/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(le){for(var e=[],u=0,N=le.length;u<N;u++)e[u]=ke[le[u]];return e};define(ke[162],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const L=new Map,R=new Map,M=new Map,w=new Map;function b(k,v){k.has(v.detail)||k.set(v.detail,-v.timestamp)}function S(k,v){const c=k.get(v.detail);c&&(c>=0||k.set(v.detail,c+v.timestamp))}let A=[];typeof le=="function"&&typeof le.getStats=="function"&&(A=le.getStats().slice(0).sort((k,v)=>k.timestamp-v.timestamp));for(const k of A)switch(k.type){case 10:b(L,k);break;case 11:case 12:S(L,k);break;case 21:b(R,k);break;case 22:S(R,k);break;case 33:b(M,k);break;case 34:S(M,k);break;case 31:b(w,k);break;case 32:S(w,k);break}let C=0;M.forEach(k=>C+=k);function $(k){const v=[];return k.forEach((c,g)=>v.push([g,c])),v}return{amdLoad:$(L),amdInvoke:$(R),nodeRequire:$(M),nodeEval:$(w),nodeRequireTotal:C}}static toMarkdownTable(L,R){let M="";const w=[];return L.forEach((b,S)=>{w[S]=b.length}),R.forEach(b=>{b.forEach((S,A)=>{typeof S>"u"&&(S=b[A]="-");const C=S.toString().length;w[A]=Math.max(C,w[A])})}),L.forEach((b,S)=>{M+=`| ${b+" ".repeat(w[S]-b.toString().length)} `}),M+=`|
`,L.forEach((b,S)=>{M+=`| ${"-".repeat(w[S])} `}),M+=`|
`,R.forEach(b=>{b.forEach((S,A)=>{typeof S<"u"&&(M+=`| ${S+" ".repeat(w[A]-S.toString().length)} `)}),M+=`|
`}),M}}e.$U=u}),define(ke[163],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=N,e.$hb=L,e.$ib=R,e.$jb=M,e.$kb=w,e.$lb=b,e.$nb=A,e.$ob=C,e.$pb=$,e.$qb=k,e.$rb=v;function u(c,g){const o=N(c,g);if(o!==-1)return c[o]}function N(c,g,o=c.length-1){for(let n=o;n>=0;n--){const i=c[n];if(g(i))return n}return-1}function L(c,g){const o=R(c,g);return o===-1?void 0:c[o]}function R(c,g,o=0,n=c.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);g(c[s])?i=s+1:r=s}return i-1}function M(c,g){const o=w(c,g);return o===c.length?void 0:c[o]}function w(c,g,o=0,n=c.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);g(c[s])?r=s:i=s+1}return i}function b(c,g,o=0,n=c.length){const i=w(c,g,o,n);return i===c.length?-1:i}class S{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(S.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!g(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const o=R(this.e,g,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=S;function A(c,g){if(c.length===0)return;let o=c[0];for(let n=1;n<c.length;n++){const i=c[n];g(i,o)>0&&(o=i)}return o}function C(c,g){if(c.length===0)return;let o=c[0];for(let n=1;n<c.length;n++){const i=c[n];g(i,o)>=0&&(o=i)}return o}function $(c,g){return A(c,(o,n)=>-g(o,n))}function k(c,g){if(c.length===0)return-1;let o=0;for(let n=1;n<c.length;n++){const i=c[n];g(i,c[o])>0&&(o=n)}return o}function v(c,g){for(const o of c){const n=g(o);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=N,e.$M=L,e.$N=R;function u(M,w){const b=Object.create(null);for(const S of M){const A=w(S);let C=b[A];C||(C=b[A]=[]),C.push(S)}return b}function N(M,w){const b=[],S=[];for(const A of M)w.has(A)||b.push(A);for(const A of w)M.has(A)||S.push(A);return{removed:b,added:S}}function L(M,w){const b=[],S=[];for(const[A,C]of M)w.has(A)||b.push(C);for(const[A,C]of w)M.has(A)||S.push(C);return{removed:b,added:S}}function R(M,w){const b=new Set;for(const S of w)M.has(S)&&b.add(S);return b}}),define(ke[55],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=L,e.$Wh=R;function u(M){return(w,b,S)=>{let A=null,C=null;if(typeof S.value=="function"?(A="value",C=S.value):typeof S.get=="function"&&(A="get",C=S.get),!C)throw new Error("not supported");S[A]=M(C,b)}}function N(M,w,b){let S=null,A=null;if(typeof b.value=="function"?(S="value",A=b.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(S="get",A=b.get),!A)throw new Error("not supported");const C=`$memoize$${w}`;b[S]=function(...$){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[C]}}function L(M,w,b){return u((S,A)=>{const C=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...k){this[$]||(this[$]=b?b():void 0),clearTimeout(this[C]),w&&(this[$]=w(this[$],...k),k=[this[$]]),this[C]=setTimeout(()=>{S.apply(this,k),this[$]=b?b():void 0},M)}})}function R(M,w,b){return u((S,A)=>{const C=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,k=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...c){if(this[$]||(this[$]=b?b():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),w&&(this[$]=w(this[$],...c)),this[v])return;const g=this[k]+M;g<=Date.now()?(this[k]=Date.now(),S.apply(this,[this[$]]),this[$]=b?b():void 0):(this[v]=!0,this[C]=setTimeout(()=>{this[v]=!1,this[k]=Date.now(),S.apply(this,[this[$]]),this[$]=b?b():void 0},g-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=R,e.$2=M,e.$3=w,e.$4=S,e.$6=C,e.$7=$,e.$8=k,e.$0=c;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function N(s){e.$X.setUnexpectedErrorHandler(s)}function L(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(s){S(s)||e.$X.onUnexpectedError(s)}function M(s){S(s)||e.$X.onUnexpectedExternalError(s)}function w(s){if(s instanceof Error){const{name:t,message:f}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:d,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const b="Canceled";function S(s){return s instanceof A?!0:s instanceof Error&&s.name===b&&s.message===b}class A extends Error{constructor(){super(b),this.name=this.message}}e.$5=A;function C(){const s=new Error(b);return s.name=s.message,s}function $(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function k(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function c(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Ee([1,0,13,163]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=M,e.$vb=w,e.$wb=b,e.$xb=S,e.$yb=A,e.$zb=C,e.$Ab=$,e.$Bb=k,e.$Cb=v,e.$Db=c,e.$Eb=g,e.top=o,e.$Gb=n,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=f,e.$Lb=d,e.$Mb=l,e.$Nb=a,e.$Ob=h,e.$Pb=m,e.$Qb=D,e.$Rb=p,e.$Sb=E,e.$Tb=y,e.$Ub=P,e.$Vb=I,e.$Wb=j,e.$Xb=F,e.$Yb=z,e.$Zb=O,e.$1b=T,e.$2b=B,e.$3b=W,e.$4b=X,e.$5b=x,e.$6b=Z,e.$7b=ne,e.$8b=$e,e.$$b=U;function L(oe,ae=0){return oe[oe.length-(1+ae)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function M(oe,ae,re=(G,te)=>G===te){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let G=0,te=oe.length;G<te;G++)if(!re(oe[G],ae[G]))return!1;return!0}function w(oe,ae){const re=oe.length-1;ae<re&&(oe[ae]=oe[re]),oe.pop()}function b(oe,ae,re){return S(oe.length,G=>re(oe[G],ae))}function S(oe,ae){let re=0,G=oe-1;for(;re<=G;){const te=(re+G)/2|0,ge=ae(te);if(ge<0)re=te+1;else if(ge>0)G=te-1;else return te}return-(re+1)}function A(oe,ae,re){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const G=ae[Math.floor(ae.length*Math.random())],te=[],ge=[],we=[];for(const Re of ae){const fe=re(Re,G);fe<0?te.push(Re):fe>0?ge.push(Re):we.push(Re)}return oe<te.length?A(oe,te,re):oe<te.length+we.length?we[0]:A(oe-(te.length+we.length),ge,re)}function C(oe,ae){const re=[];let G;for(const te of oe.slice(0).sort(ae))!G||ae(G[0],te)!==0?(G=[te],re.push(G)):G.push(te);return re}function*$(oe,ae){let re,G;for(const te of oe)G!==void 0&&ae(G,te)?re.push(te):(re&&(yield re),re=[te]),G=te;re&&(yield re)}function k(oe,ae){for(let re=0;re<=oe.length;re++)ae(re===0?void 0:oe[re-1],re===oe.length?void 0:oe[re])}function v(oe,ae){for(let re=0;re<oe.length;re++)ae(re===0?void 0:oe[re-1],oe[re],re+1===oe.length?void 0:oe[re+1])}function c(oe,ae,re){const G=[];function te(Re,fe,Se){if(fe===0&&Se.length===0)return;const Ae=G[G.length-1];Ae&&Ae.start+Ae.deleteCount===Re?(Ae.deleteCount+=fe,Ae.toInsert.push(...Se)):G.push({start:Re,deleteCount:fe,toInsert:Se})}let ge=0,we=0;for(;;){if(ge===oe.length){te(ge,0,ae.slice(we));break}if(we===ae.length){te(ge,oe.length-ge,[]);break}const Re=oe[ge],fe=ae[we],Se=re(Re,fe);Se===0?(ge+=1,we+=1):Se<0?(te(ge,1,[]),ge+=1):Se>0&&(te(ge,0,[fe]),we+=1)}return G}function g(oe,ae,re){const G=c(oe,ae,re),te=[],ge=[];for(const we of G)te.push(...oe.slice(we.start,we.start+we.deleteCount)),ge.push(...we.toInsert);return{removed:te,added:ge}}function o(oe,ae,re){if(re===0)return[];const G=oe.slice(0,re).sort(ae);return i(oe,ae,G,re,oe.length),G}function n(oe,ae,re,G,te){return re===0?Promise.resolve([]):new Promise((ge,we)=>{(async()=>{const Re=oe.length,fe=oe.slice(0,re).sort(ae);for(let Se=re,Ae=Math.min(re+G,Re);Se<Re;Se=Ae,Ae=Math.min(Ae+G,Re)){if(Se>re&&await new Promise(je=>setTimeout(je)),te&&te.isCancellationRequested)throw new u.$5;i(oe,ae,fe,Se,Ae)}return fe})().then(ge,we)})}function i(oe,ae,re,G,te){for(const ge=re.length;G<te;G++){const we=oe[G];if(ae(we,re[ge-1])<0){re.pop();const Re=(0,N.$kb)(re,fe=>ae(we,fe)<0);re.splice(Re,0,we)}}}function r(oe){return oe.filter(ae=>!!ae)}function s(oe){let ae=0;for(let re=0;re<oe.length;re++)oe[re]&&(oe[ae]=oe[re],ae+=1);oe.length=ae}function t(oe,ae,re){oe.splice(re,0,oe.splice(ae,1)[0])}function f(oe){return!Array.isArray(oe)||oe.length===0}function d(oe){return Array.isArray(oe)&&oe.length>0}function l(oe,ae=re=>re){const re=new Set;return oe.filter(G=>{const te=ae(G);return re.has(te)?!1:(re.add(te),!0)})}function a(oe){const ae=new Set;return re=>{const G=oe(re);return ae.has(G)?!1:(ae.add(G),!0)}}function h(oe,ae){return oe.length>0?oe[0]:ae}function m(oe,ae){return oe.length>0?oe[oe.length-1]:ae}function D(oe,ae,re=(G,te)=>G===te){let G=0;for(let te=0,ge=Math.min(oe.length,ae.length);te<ge&&re(oe[te],ae[te]);te++)G++;return G}function p(oe){return[].concat(...oe)}function E(oe,ae){let re=typeof ae=="number"?oe:0;typeof ae=="number"?re=oe:(re=0,ae=oe);const G=[];if(re<=ae)for(let te=re;te<ae;te++)G.push(te);else for(let te=re;te>ae;te--)G.push(te);return G}function y(oe,ae,re){return oe.reduce((G,te)=>(G[ae(te)]=re?re(te):te,G),Object.create(null))}function P(oe,ae){return oe.push(ae),()=>I(oe,ae)}function I(oe,ae){const re=oe.indexOf(ae);if(re>-1)return oe.splice(re,1),ae}function j(oe,ae,re){const G=oe.slice(0,ae),te=oe.slice(ae);return G.concat(re,te)}function F(oe,ae){let re;if(typeof ae=="number"){let G=ae;re=()=>{const te=Math.sin(G++)*179426549;return te-Math.floor(te)}}else re=Math.random;for(let G=oe.length-1;G>0;G-=1){const te=Math.floor(re()*(G+1)),ge=oe[G];oe[G]=oe[te],oe[te]=ge}}function z(oe,ae){const re=oe.indexOf(ae);re>-1&&(oe.splice(re,1),oe.unshift(ae))}function O(oe,ae){const re=oe.indexOf(ae);re>-1&&(oe.splice(re,1),oe.push(ae))}function T(oe,ae){for(const re of ae)oe.push(re)}function B(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}function W(oe){return Array.isArray(oe)?oe:[oe]}function X(oe){return oe[Math.floor(Math.random()*oe.length)]}function x(oe,ae,re){const G=Y(oe,ae),te=oe.length,ge=re.length;oe.length=te+ge;for(let we=te-1;we>=G;we--)oe[we+ge]=oe[we];for(let we=0;we<ge;we++)oe[we+G]=re[we]}function Z(oe,ae,re,G){const te=Y(oe,ae);let ge=oe.splice(te,re);return ge===void 0&&(ge=[]),x(oe,te,G),ge}function Y(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var ce;(function(oe){function ae(ge){return ge<0}oe.isLessThan=ae;function re(ge){return ge<=0}oe.isLessThanOrEqual=re;function G(ge){return ge>0}oe.isGreaterThan=G;function te(ge){return ge===0}oe.isNeitherLessOrGreaterThan=te,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function ne(oe,ae){return(re,G)=>ae(oe(re),oe(G))}function $e(...oe){return(ae,re)=>{for(const G of oe){const te=G(ae,re);if(!ce.isNeitherLessOrGreaterThan(te))return te}return ce.neitherLessOrGreaterThan}}const Pe=(oe,ae)=>oe-ae;e.$9b=Pe;const _=(oe,ae)=>(0,e.$9b)(oe?1:0,ae?1:0);e.$0b=_;function U(oe){return(ae,re)=>-oe(ae,re)}class ie{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let re=this.c;for(;re<this.g.length&&ae(this.g[re]);)re++;const G=re===this.c?null:this.g.slice(this.c,re);return this.c=re,G}takeFromEndWhile(ae){let re=this.d;for(;re>=0&&ae(this.g[re]);)re--;const G=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const re=this.g.slice(this.c,this.c+ae);return this.c+=ae,re}}e.$_b=ie;class be{static{this.empty=new be(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(re=>(ae(re),!0))}toArray(){const ae=[];return this.iterate(re=>(ae.push(re),!0)),ae}filter(ae){return new be(re=>this.iterate(G=>ae(G)?re(G):!0))}map(ae){return new be(re=>this.iterate(G=>re(ae(G))))}some(ae){let re=!1;return this.iterate(G=>(re=ae(G),!re)),re}findFirst(ae){let re;return this.iterate(G=>ae(G)?(re=G,!1):!0),re}findLast(ae){let re;return this.iterate(G=>(ae(G)&&(re=G),!0)),re}findLastMaxBy(ae){let re,G=!0;return this.iterate(te=>((G||ce.isGreaterThan(ae(te,re)))&&(G=!1,re=te),!0)),re}}e.$ac=be;class Ce{constructor(ae){this.c=ae}static createSortPermutation(ae,re){const G=Array.from(ae.keys()).sort((te,ge)=>re(ae[te],ae[ge]));return new Ce(G)}apply(ae){return ae.map((re,G)=>ae[this.c[G]])}inverse(){const ae=this.c.slice();for(let re=0;re<this.c.length;re++)ae[this.c[re]]=re;return new Ce(ae)}}e.$bc=Ce}),define(ke[62],Ee([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=L,e.$dd=R,e.$ed=M,e.$fd=w,e.$gd=b;function N(S,A){if(!S)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(S,A="Unreachable"){throw new Error(A)}function R(S){if(!S)throw new u.$cb("Assertion Failed")}function M(S){S||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function w(S){if(!S()){debugger;S(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function b(S,A){let C=0;for(;C<S.length-1;){const $=S[C],k=S[C+1];if(!A($,k))return!1;C++}return!0}}),define(ke[74],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(N,L){const R=this;let M=!1,w;return function(){if(M)return w;if(M=!0,L)try{w=N.apply(R,arguments)}finally{L()}else w=N.apply(R,arguments);return w}}}),define(ke[124],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0;class u{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$fP=u,e.$gP=new u("id#")}),define(ke[45],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const R=Object.freeze([]);function M(){return R}N.empty=M;function*w(t){yield t}N.single=w;function b(t){return L(t)?t:w(t)}N.wrap=b;function S(t){return t||R}N.from=S;function*A(t){for(let f=t.length-1;f>=0;f--)yield t[f]}N.reverse=A;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function $(t){return t[Symbol.iterator]().next().value}N.first=$;function k(t,f){for(const d of t)if(f(d))return!0;return!1}N.some=k;function v(t,f){for(const d of t)if(f(d))return d}N.find=v;function*c(t,f){for(const d of t)f(d)&&(yield d)}N.filter=c;function*g(t,f){let d=0;for(const l of t)yield f(l,d++)}N.map=g;function*o(...t){for(const f of t)yield*f}N.concat=o;function n(t,f,d){let l=d;for(const a of t)l=f(l,a);return l}N.reduce=n;function*i(t,f,d=t.length){for(f<0&&(f+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);f<d;f++)yield t[f]}N.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,t];const l=t[Symbol.iterator]();for(let a=0;a<f;a++){const h=l.next();if(h.done)return[d,N.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return l}}]}N.consume=r;async function s(t){const f=[];for await(const d of t)f.push(d);return Promise.resolve(f)}N.asyncToArray=s})(u||(e.Iterable=u={}))}),define(ke[164],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=C,e.$Dn=$,e.$En=k,e.$Fn=v,e.$Gn=c,e.$Hn=g,e.$In=o,e.$Jn=n,e.$Kn=i,e.$Ln=r,e.$Mn=s;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,f=!1){let d=0;const l=t.length;let a="",h=0,m=16,D=0;function p(z){let O=0,T=0;for(;O<z;){const B=t.charCodeAt(d);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;d++,O++}return O<z&&(T=-1),T}function E(z){d=z,a="",h=0,m=16,D=0}function y(){const z=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&S(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&S(t.charCodeAt(d)))for(d++;d<t.length&&S(t.charCodeAt(d));)d++;else return D=3,t.substring(z,d);let O=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&S(t.charCodeAt(d))){for(d++;d<t.length&&S(t.charCodeAt(d));)d++;O=d}else D=3;return t.substring(z,O)}function P(){let z="",O=d;for(;;){if(d>=l){z+=t.substring(O,d),D=2;break}const T=t.charCodeAt(d);if(T===34){z+=t.substring(O,d),d++;break}if(T===92){if(z+=t.substring(O,d),d++,d>=l){D=2;break}switch(t.charCodeAt(d++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=p(4);W>=0?z+=String.fromCharCode(W):D=4;break}default:D=5}O=d;continue}if(T>=0&&T<=31)if(b(T)){z+=t.substring(O,d),D=2;break}else D=6;d++}return z}function I(){if(a="",D=0,h=d,d>=l)return h=l,m=17;let z=t.charCodeAt(d);if(w(z)){do d++,a+=String.fromCharCode(z),z=t.charCodeAt(d);while(w(z));return m=15}if(b(z))return d++,a+=String.fromCharCode(z),z===13&&t.charCodeAt(d)===10&&(d++,a+=`
`),m=14;switch(z){case 123:return d++,m=1;case 125:return d++,m=2;case 91:return d++,m=3;case 93:return d++,m=4;case 58:return d++,m=6;case 44:return d++,m=5;case 34:return d++,a=P(),m=10;case 47:{const O=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!b(t.charCodeAt(d));)d++;return a=t.substring(O,d),m=12}if(t.charCodeAt(d+1)===42){d+=2;const T=l-1;let B=!1;for(;d<T;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,B=!0;break}d++}return B||(d++,D=1),a=t.substring(O,d),m=13}return a+=String.fromCharCode(z),d++,m=16}case 45:if(a+=String.fromCharCode(z),d++,d===l||!S(t.charCodeAt(d)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=y(),m=11;default:for(;d<l&&j(z);)d++,z=t.charCodeAt(d);if(h!==d){switch(a=t.substring(h,d),a){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return a+=String.fromCharCode(z),d++,m=16}}function j(z){if(w(z)||b(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>d,scan:f?F:I,getToken:()=>m,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,f){const d=[],l=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(p,E,y,P){h.value=p,h.offset=E,h.length=y,h.type=P,h.colonOffset=void 0,a=h}try{i(t,{onObjectBegin:(p,E)=>{if(f<=p)throw l;a=void 0,m=f>p,d.push("")},onObjectProperty:(p,E,y)=>{if(f<E||(D(p,E,y,"property"),d[d.length-1]=p,f<=E+y))throw l},onObjectEnd:(p,E)=>{if(f<=p)throw l;a=void 0,d.pop()},onArrayBegin:(p,E)=>{if(f<=p)throw l;a=void 0,d.push(0)},onArrayEnd:(p,E)=>{if(f<=p)throw l;a=void 0,d.pop()},onLiteralValue:(p,E,y)=>{if(f<E||(D(p,E,y,s(p)),f<=E+y))throw l},onSeparator:(p,E,y)=>{if(f<=E)throw l;if(p===":"&&a&&a.type==="property")a.colonOffset=E,m=!1,a=void 0;else if(p===","){const P=d[d.length-1];typeof P=="number"?d[d.length-1]=P+1:(m=!0,d[d.length-1]=""),a=void 0}}})}catch(p){if(p!==l)throw p}return{path:d,previousNode:a,isAtPropertyKey:m,matches:p=>{let E=0;for(let y=0;E<p.length&&y<d.length;y++)if(p[E]===d[y]||p[E]==="*")E++;else if(p[E]!=="**")return!1;return E===p.length}}}function $(t,f=[],d=R.DEFAULT){let l=null,a=[];const h=[];function m(p){Array.isArray(a)?a.push(p):l!==null&&(a[l]=p)}return i(t,{onObjectBegin:()=>{const p={};m(p),h.push(a),a=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const p=[];m(p),h.push(a),a=p,l=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:m,onError:(p,E,y)=>{f.push({error:p,offset:E,length:y})}},d),a[0]}function k(t,f=[],d=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){l.type==="property"&&(l.length=p-l.offset,l=l.parent)}function h(p){return l.children.push(p),p}i(t,{onObjectBegin:p=>{l=h({type:"object",offset:p,length:-1,parent:l,children:[]})},onObjectProperty:(p,E,y)=>{l=h({type:"property",offset:E,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:p,offset:E,length:y,parent:l})},onObjectEnd:(p,E)=>{l.length=p+E-l.offset,l=l.parent,a(p+E)},onArrayBegin:(p,E)=>{l=h({type:"array",offset:p,length:-1,parent:l,children:[]})},onArrayEnd:(p,E)=>{l.length=p+E-l.offset,l=l.parent,a(p+E)},onLiteralValue:(p,E,y)=>{h({type:s(p),offset:E,length:y,parent:l,value:p}),a(E+y)},onSeparator:(p,E,y)=>{l.type==="property"&&(p===":"?l.colonOffset=E:p===","&&a(E))},onError:(p,E,y)=>{f.push({error:p,offset:E,length:y})}},d);const D=l.children[0];return D&&delete D.parent,D}function v(t,f){if(!t)return;let d=t;for(const l of f)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let a=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],a=!0;break}if(!a)return}else{const a=l;if(d.type!=="array"||a<0||!Array.isArray(d.children)||a>=d.children.length)return;d=d.children[a]}return d}function c(t){if(!t.parent||!t.parent.children)return[];const f=c(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;f.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&f.push(d)}return f}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const f=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(f[d.children[0].value]=g(l))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,d=!1){return f>=t.offset&&f<t.offset+t.length||d&&f===t.offset+t.length}function n(t,f,d=!1){if(o(t,f,d)){const l=t.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=f;a++){const h=n(l[a],f,d);if(h)return h}return t}}function i(t,f,d=R.DEFAULT){const l=M(t,!1);function a(ne){return ne?()=>ne(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(ne){return ne?$e=>ne($e,l.getTokenOffset(),l.getTokenLength()):()=>!0}const m=a(f.onObjectBegin),D=h(f.onObjectProperty),p=a(f.onObjectEnd),E=a(f.onArrayBegin),y=a(f.onArrayEnd),P=h(f.onLiteralValue),I=h(f.onSeparator),j=a(f.onComment),F=h(f.onError),z=d&&d.disallowComments,O=d&&d.allowTrailingComma;function T(){for(;;){const ne=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ne){case 12:case 13:z?B(10):j();break;case 16:B(1);break;case 15:case 14:break;default:return ne}}}function B(ne,$e=[],Pe=[]){if(F(ne),$e.length+Pe.length>0){let _=l.getToken();for(;_!==17;){if($e.indexOf(_)!==-1){T();break}else if(Pe.indexOf(_)!==-1)break;_=T()}}}function W(ne){const $e=l.getTokenValue();return ne?P($e):D($e),T(),!0}function X(){switch(l.getToken()){case 11:{let ne=0;try{ne=JSON.parse(l.getTokenValue()),typeof ne!="number"&&(B(2),ne=0)}catch{B(2)}P(ne);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function x(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),l.getToken()===6?(I(":"),T(),ce()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Z(){m(),T();let ne=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ne||B(4,[],[]),I(","),T(),l.getToken()===2&&O)break}else ne&&B(6,[],[]);x()||B(4,[],[2,5]),ne=!0}return p(),l.getToken()!==2?B(7,[2],[]):T(),!0}function Y(){E(),T();let ne=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ne||B(4,[],[]),I(","),T(),l.getToken()===4&&O)break}else ne&&B(6,[],[]);ce()||B(4,[],[4,5]),ne=!0}return y(),l.getToken()!==4?B(8,[4],[]):T(),!0}function ce(){switch(l.getToken()){case 3:return Y();case 1:return Z();case 10:return W(!0);default:return X()}}return T(),l.getToken()===17?d.allowEmptyContent?!0:(B(4,[],[]),!1):ce()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,f){const d=M(t),l=[];let a,h=0,m;do switch(m=d.getPosition(),a=d.scan(),a){case 12:case 13:case 17:h!==m&&l.push(t.substring(h,m)),f!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,f)),h=d.getPosition();break}while(a!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(R){this.element=R,this.next=u.Undefined,this.prev=u.Undefined}}class N{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let R=this.a;for(;R!==u.Undefined;){const M=R.next;R.prev=u.Undefined,R.next=u.Undefined,R=M}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const w=new u(R);if(this.a===u.Undefined)this.a=w,this.b=w;else if(M){const S=this.b;this.b=w,w.prev=S,S.next=w}else{const S=this.a;this.a=w,w.next=S,S.prev=w}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(w))}}shift(){if(this.a!==u.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==u.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==u.Undefined&&R.next!==u.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===u.Undefined&&R.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):R.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):R.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==u.Undefined;)yield R.element,R=R.next}}e.$5c=N}),define(ke[27],Ee([1,0]),function(le,e){"use strict";var u,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=M,e.$Ac=w,e.$Ic=n;function R(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function M(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function w(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class b{constructor(r,s){this.uri=r,this.value=s}}function S(i){return Array.isArray(i)}class A{static{this.c=r=>r.toString()}constructor(r,s){if(this[u]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=s??A.c;else if(S(r)){this.d=new Map,this.e=s??A.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??A.c}set(r,s){return this.d.set(this.e(r),new b(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A;class C{constructor(r,s){this[N]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=C;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class k{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let f=this.c.get(r);if(f)f.value=s,t!==0&&this.l(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let f=this.d;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=k;class v extends k{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class c{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=c;class g{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class o{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=o;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,45]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=C,e.$Mc=$,e.$Nc=c,e.$Oc=g,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=p;const w=!1;let b=null;class S{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:S.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const j=this.c(P);j.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const j=I.get(P);if(j)return j;const F=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,F),F}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,P).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(P=10,I){let j;if(I)j=I;else{const B=new Map,W=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,B).isSingleton);if(W.length===0)return;const X=new Set(W.map(x=>x.value));if(j=W.filter(x=>!(x.parent&&X.has(x.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function F(B){function W(x,Z){for(;x.length>0&&Z.some(Y=>typeof Y=="string"?Y===x[0]:x[0].match(Y));)x.shift()}const X=B.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return W(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const z=new L.$Hc;for(const B of j){const W=F(B);for(let X=0;X<=W.length;X++)z.add(W.slice(0,X).join(`
`),B)}j.sort((0,u.$7b)(B=>B.idx,u.$9b));let O="",T=0;for(const B of j.slice(0,P)){T++;const W=F(B),X=[];for(let x=0;x<W.length;x++){let Z=W[x];Z=`(shared with ${z.get(W.slice(0,x+1).join(`
`)).size}/${j.length} leaks) at ${Z}`;const ce=z.get(W.slice(0,x).join(`
`)),ne=(0,N.$K)([...ce].map($e=>F($e)[x]),$e=>$e);delete ne[W[x]];for(const[$e,Pe]of Object.entries(ne))X.unshift(`    - stacktraces of ${Pe.length} other leaks continue with ${$e}`);X.unshift(Z)}O+=`


==================== Leaking disposable ${T}/${j.length}: ${B.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return j.length>P&&(O+=`


... and ${j.length-P} more leaking disposables

`),{leaks:j,details:O}}}e.$Jc=S;function A(y){b=y}if(w){const y="__is_disposable_tracked__";A(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function C(y){return b?.trackDisposable(y),y}function $(y){b?.markAsDisposed(y)}function k(y,P){b?.setParent(y,P)}function v(y,P){if(b)for(const I of y)b.setParent(I,P)}function c(y){return b?.markAsSingleton(y),y}function g(y){return typeof y=="object"&&y!==null&&typeof y.dispose=="function"&&y.dispose.length===0}function o(y){if(M.Iterable.is(y)){const P=[];for(const I of y)if(I)try{I.dispose()}catch(j){P.push(j)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const P of y)g(P)&&P.dispose();return[]}function i(...y){const P=r(()=>o(y));return v(y,P),P}function r(y){const P=C({dispose:(0,R.$db)(()=>{$(P),y()})});return P}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return k(P,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),k(P,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,C(this),k(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class f{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&k(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&k(P,null),P}}e.$Vc=f;class d{constructor(P){this.a=new f,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,$(this))},this}}e.$Yc=a;class h{constructor(){this.a=new Map}acquire(P,...I){let j=this.a.get(P);j||(j={counter:0,object:this.b(P,...I)},this.a.set(P,j));const{object:F}=j,z=(0,R.$db)(()=>{--j.counter===0&&(this.c(P,j.object),this.a.delete(P))});return j.counter++,{object:F,dispose:z}}}e.$Zc=h;class m{constructor(P){this.a=P}async acquire(P,...I){const j=this.a.acquire(P,...I);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(F){throw j.dispose(),F}}}e.$1c=m;class D{constructor(P){this.object=P}dispose(){}}e.$2c=D;function p(y){const P=new s;try{y(P)}finally{P.dispose()}}class E{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=E}),function(le,e){typeof define=="function"&&define.amd?define(ke[165],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(oe,ae){for(var re=0;re<ae.length;re++){var G=ae[re];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(oe,G.key,G)}}function u(oe,ae,re){return ae&&e(oe.prototype,ae),re&&e(oe,re),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function N(oe,ae){if(oe){if(typeof oe=="string")return L(oe,ae);var re=Object.prototype.toString.call(oe).slice(8,-1);if(re==="Object"&&oe.constructor&&(re=oe.constructor.name),re==="Map"||re==="Set")return Array.from(oe);if(re==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(re))return L(oe,ae)}}function L(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var re=0,G=new Array(ae);re<ae;re++)G[re]=oe[re];return G}function R(oe,ae){var re=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(re)return(re=re.call(oe)).next.bind(re);if(Array.isArray(oe)||(re=N(oe))||ae&&oe&&typeof oe.length=="number"){re&&(oe=re);var G=0;return function(){return G>=oe.length?{done:!0}:{done:!1,value:oe[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=M();function w(oe){le.defaults=oe}var b=/[&<>"']/,S=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ae){return $[ae]};function v(oe,ae){if(ae){if(b.test(oe))return oe.replace(S,k)}else if(A.test(oe))return oe.replace(C,k);return oe}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(oe){return oe.replace(c,function(ae,re){return re=re.toLowerCase(),re==="colon"?":":re.charAt(0)==="#"?re.charAt(1)==="x"?String.fromCharCode(parseInt(re.substring(2),16)):String.fromCharCode(+re.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var re={replace:function(te,ge){return ge=ge.source||ge,ge=ge.replace(o,"$1"),oe=oe.replace(te,ge),re},getRegex:function(){return new RegExp(oe,ae)}};return re}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(oe,ae,re){if(oe){var G;try{G=decodeURIComponent(g(re)).replace(i,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}ae&&!r.test(re)&&(re=a(ae,re));try{re=encodeURI(re).replace(/%25/g,"%")}catch{return null}return re}var t={},f=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(oe,ae){t[" "+oe]||(f.test(oe)?t[" "+oe]=oe+"/":t[" "+oe]=p(oe,"/",!0)),oe=t[" "+oe];var re=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?re?ae:oe.replace(d,"$1")+ae:ae.charAt(0)==="/"?re?ae:oe.replace(l,"$1")+ae:oe+ae}var h={exec:function(){}};function m(oe){for(var ae=1,re,G;ae<arguments.length;ae++){re=arguments[ae];for(G in re)Object.prototype.hasOwnProperty.call(re,G)&&(oe[G]=re[G])}return oe}function D(oe,ae){var re=oe.replace(/\|/g,function(ge,we,Re){for(var fe=!1,Se=we;--Se>=0&&Re[Se]==="\\";)fe=!fe;return fe?"|":" |"}),G=re.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>ae)G.splice(ae);else for(;G.length<ae;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function p(oe,ae,re){var G=oe.length;if(G===0)return"";for(var te=0;te<G;){var ge=oe.charAt(G-te-1);if(ge===ae&&!re)te++;else if(ge!==ae&&re)te++;else break}return oe.slice(0,G-te)}function E(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var re=oe.length,G=0,te=0;te<re;te++)if(oe[te]==="\\")te++;else if(oe[te]===ae[0])G++;else if(oe[te]===ae[1]&&(G--,G<0))return te;return-1}function y(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(oe,ae){if(ae<1)return"";for(var re="";ae>1;)ae&1&&(re+=oe),ae>>=1,oe+=oe;return re+oe}function I(oe,ae,re,G){var te=ae.href,ge=ae.title?v(ae.title):null,we=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){G.state.inLink=!0;var Re={type:"link",raw:re,href:te,title:ge,text:we,tokens:G.inlineTokens(we)};return G.state.inLink=!1,Re}return{type:"image",raw:re,href:te,title:ge,text:v(we)}}function j(oe,ae){var re=oe.match(/^(\s+)(?:```)/);if(re===null)return ae;var G=re[1];return ae.split(`
`).map(function(te){var ge=te.match(/^\s+/);if(ge===null)return te;var we=ge[0];return we.length>=G.length?te.slice(G.length):te}).join(`
`)}var F=function(){function oe(re){this.options=re||le.defaults}var ae=oe.prototype;return ae.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ae.code=function(G){var te=this.rules.block.code.exec(G);if(te){var ge=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:p(ge,`
`)}}},ae.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var ge=te[0],we=j(ge,te[3]||"");return{type:"code",raw:ge,lang:te[2]?te[2].trim():te[2],text:we}}},ae.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var ge=te[2].trim();if(/#$/.test(ge)){var we=p(ge,"#");(this.options.pedantic||!we||/ $/.test(we))&&(ge=we.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:ge,tokens:this.lexer.inline(ge)}}},ae.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},ae.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var ge=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ae.list=function(G){var te=this.rules.block.list.exec(G);if(te){var ge,we,Re,fe,Se,Ae,je,q,V,Q,J,he,pe=te[1].trim(),ze=pe.length>1,Ve={type:"list",raw:"",ordered:ze,start:ze?+pe.slice(0,-1):"",loose:!1,items:[]};pe=ze?"\\d{1,9}\\"+pe.slice(-1):"\\"+pe,this.options.pedantic&&(pe=ze?pe:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(he=!1,!(!(te=Xe.exec(G))||this.rules.block.hr.test(G)));){if(ge=te[0],G=G.substring(ge.length),q=te[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(fe=2,J=q.trimLeft()):(fe=te[2].search(/[^ ]/),fe=fe>4?1:fe,J=q.slice(fe),fe+=te[1].length),Ae=!1,!q&&/^ *$/.test(V)&&(ge+=V+`
`,G=G.substring(V.length+1),he=!0),!he)for(var tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");G&&(Q=G.split(`
`,1)[0],q=Q,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(q)||st.test(q)||tt.test(q)||ot.test(G)));){if(q.search(/[^ ]/)>=fe||!q.trim())J+=`
`+q.slice(fe);else if(!Ae)J+=`
`+q;else break;!Ae&&!q.trim()&&(Ae=!0),ge+=Q+`
`,G=G.substring(Q.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test(ge)&&(je=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(J),we&&(Re=we[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ge,task:!!we,checked:Re,loose:!1,text:J}),Ve.raw+=ge}Ve.items[Ve.items.length-1].raw=ge.trimRight(),Ve.items[Ve.items.length-1].text=J.trimRight(),Ve.raw=Ve.raw.trimRight();var De=Ve.items.length;for(Se=0;Se<De;Se++){this.lexer.state.top=!1,Ve.items[Se].tokens=this.lexer.blockTokens(Ve.items[Se].text,[]);var Be=Ve.items[Se].tokens.filter(function(Le){return Le.type==="space"}),He=Be.every(function(Le){for(var Ze=Le.raw.split(""),se=0,ue=R(Ze),Ie;!(Ie=ue()).done;){var Ge=Ie.value;if(Ge===`
`&&(se+=1),se>1)return!0}return!1});!Ve.loose&&Be.length&&He&&(Ve.loose=!0,Ve.items[Se].loose=!0)}return Ve}},ae.html=function(G){var te=this.rules.block.html.exec(G);if(te){var ge={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]);ge.type="paragraph",ge.text=we,ge.tokens=this.lexer.inline(we)}return ge}},ae.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var ge=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:te[0],href:te[2],title:te[3]}}},ae.table=function(G){var te=this.rules.block.table.exec(G);if(te){var ge={type:"table",header:D(te[1]).map(function(je){return{text:je}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=te[0];var we=ge.align.length,Re,fe,Se,Ae;for(Re=0;Re<we;Re++)/^ *-+: *$/.test(ge.align[Re])?ge.align[Re]="right":/^ *:-+: *$/.test(ge.align[Re])?ge.align[Re]="center":/^ *:-+ *$/.test(ge.align[Re])?ge.align[Re]="left":ge.align[Re]=null;for(we=ge.rows.length,Re=0;Re<we;Re++)ge.rows[Re]=D(ge.rows[Re],ge.header.length).map(function(je){return{text:je}});for(we=ge.header.length,fe=0;fe<we;fe++)ge.header[fe].tokens=this.lexer.inline(ge.header[fe].text);for(we=ge.rows.length,fe=0;fe<we;fe++)for(Ae=ge.rows[fe],Se=0;Se<Ae.length;Se++)Ae[Se].tokens=this.lexer.inline(Ae[Se].text);return ge}}},ae.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ae.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var ge=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:ge,tokens:this.lexer.inline(ge)}}},ae.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ae.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:v(te[1])}},ae.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]}},ae.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var ge=te[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var we=p(ge.slice(0,-1),"\\");if((ge.length-we.length)%2===0)return}else{var Re=E(te[2],"()");if(Re>-1){var fe=te[0].indexOf("!")===0?5:4,Se=fe+te[1].length+Re;te[2]=te[2].substring(0,Re),te[0]=te[0].substring(0,Se).trim(),te[3]=""}}var Ae=te[2],je="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);q&&(Ae=q[1],je=q[3])}else je=te[3]?te[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ge)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),I(te,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ae.reflink=function(G,te){var ge;if((ge=this.rules.inline.reflink.exec(G))||(ge=this.rules.inline.nolink.exec(G))){var we=(ge[2]||ge[1]).replace(/\s+/g," ");if(we=te[we.toLowerCase()],!we||!we.href){var Re=ge[0].charAt(0);return{type:"text",raw:Re,text:Re}}return I(ge,we,ge[0],this.lexer)}},ae.emStrong=function(G,te,ge){ge===void 0&&(ge="");var we=this.rules.inline.emStrong.lDelim.exec(G);if(we&&!(we[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=we[1]||we[2]||"";if(!Re||Re&&(ge===""||this.rules.inline.punctuation.exec(ge))){var fe=we[0].length-1,Se,Ae,je=fe,q=0,V=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*G.length+fe);(we=V.exec(te))!=null;)if(Se=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Se){if(Ae=Se.length,we[3]||we[4]){je+=Ae;continue}else if((we[5]||we[6])&&fe%3&&!((fe+Ae)%3)){q+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+q),Math.min(fe,Ae)%2){var Q=G.slice(1,fe+we.index+Ae);return{type:"em",raw:G.slice(0,fe+we.index+Ae+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var J=G.slice(2,fe+we.index+Ae-1);return{type:"strong",raw:G.slice(0,fe+we.index+Ae+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ae.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var ge=te[2].replace(/\n/g," "),we=/[^ ]/.test(ge),Re=/^ /.test(ge)&&/ $/.test(ge);return we&&Re&&(ge=ge.substring(1,ge.length-1)),ge=v(ge,!0),{type:"codespan",raw:te[0],text:ge}}},ae.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},ae.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ae.autolink=function(G,te){var ge=this.rules.inline.autolink.exec(G);if(ge){var we,Re;return ge[2]==="@"?(we=v(this.options.mangle?te(ge[1]):ge[1]),Re="mailto:"+we):(we=v(ge[1]),Re=we),{type:"link",raw:ge[0],text:we,href:Re,tokens:[{type:"text",raw:we,text:we}]}}},ae.url=function(G,te){var ge;if(ge=this.rules.inline.url.exec(G)){var we,Re;if(ge[2]==="@")we=v(this.options.mangle?te(ge[0]):ge[0]),Re="mailto:"+we;else{var fe;do fe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(fe!==ge[0]);we=v(ge[0]),ge[1]==="www."?Re="http://"+we:Re=we}return{type:"link",raw:ge[0],text:we,href:Re,tokens:[{type:"text",raw:we,text:we}]}}},ae.inlineText=function(G,te){var ge=this.rules.inline.text.exec(G);if(ge){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):v(ge[0]):ge[0]:we=v(this.options.smartypants?te(ge[0]):ge[0]),{type:"text",raw:ge[0],text:we}}},oe}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=m({},z),z.gfm=m({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=m({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=n(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=n(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=n(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=n(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=n(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=n(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=n(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=n(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=n(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=n(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=m({},O),O.pedantic=m({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=m({},O.normal,{escape:n(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=n(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=m({},O.gfm,{br:n(O.br).replace("{2,}","*").getRegex(),text:n(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var ae="",re,G,te=oe.length;for(re=0;re<te;re++)G=oe.charCodeAt(re),Math.random()>.5&&(G="x"+G.toString(16)),ae+="&#"+G+";";return ae}var W=function(){function oe(re){this.tokens=[],this.tokens.links=Object.create(null),this.options=re||le.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:z.normal,inline:O.normal};this.options.pedantic?(G.block=z.pedantic,G.inline=O.pedantic):this.options.gfm&&(G.block=z.gfm,this.options.breaks?G.inline=O.breaks:G.inline=O.gfm),this.tokenizer.rules=G}oe.lex=function(G,te){var ge=new oe(te);return ge.lex(G)},oe.lexInline=function(G,te){var ge=new oe(te);return ge.inlineTokens(G)};var ae=oe.prototype;return ae.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ae.blockTokens=function(G,te){var ge=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(je,q,V){return q+"    ".repeat(V.length)});for(var we,Re,fe,Se;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(we=je.call({lexer:ge},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.space(G)){G=G.substring(we.raw.length),we.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(we);continue}if(we=this.tokenizer.code(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(we);continue}if(we=this.tokenizer.fences(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.heading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.hr(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.blockquote(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.list(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.html(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.def(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.lheading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(fe=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,q=G.slice(1),V=void 0;ge.options.extensions.startBlock.forEach(function(Q){V=Q.call({lexer:this},q),typeof V=="number"&&V>=0&&(je=Math.min(je,V))}),je<1/0&&je>=0&&(fe=G.substring(0,je+1))}(),this.state.top&&(we=this.tokenizer.paragraph(fe))){Re=te[te.length-1],Se&&Re.type==="paragraph"?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(we),Se=fe.length!==G.length,G=G.substring(we.raw.length);continue}if(we=this.tokenizer.text(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(we);continue}if(G){var Ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,te},ae.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},ae.inlineTokens=function(G,te){var ge=this;te===void 0&&(te=[]);var we,Re,fe,Se=G,Ae,je,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)V.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(je||(q=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(we=J.call({lexer:ge},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.escape(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.tag(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&we.type==="text"&&Re.type==="text"?(Re.raw+=we.raw,Re.text+=we.text):te.push(we);continue}if(we=this.tokenizer.link(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&we.type==="text"&&Re.type==="text"?(Re.raw+=we.raw,Re.text+=we.text):te.push(we);continue}if(we=this.tokenizer.emStrong(G,Se,q)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.codespan(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.br(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.del(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.autolink(G,B)){G=G.substring(we.raw.length),te.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(G,B))){G=G.substring(we.raw.length),te.push(we);continue}if(fe=G,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,he=G.slice(1),pe=void 0;ge.options.extensions.startInline.forEach(function(ze){pe=ze.call({lexer:this},he),typeof pe=="number"&&pe>=0&&(J=Math.min(J,pe))}),J<1/0&&J>=0&&(fe=G.substring(0,J+1))}(),we=this.tokenizer.inlineText(fe,T)){G=G.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(q=we.raw.slice(-1)),je=!0,Re=te[te.length-1],Re&&Re.type==="text"?(Re.raw+=we.raw,Re.text+=we.text):te.push(we);continue}if(G){var Q="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return te},u(oe,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),oe}(),X=function(){function oe(re){this.options=re||le.defaults}var ae=oe.prototype;return ae.code=function(G,te,ge){var we=(te||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(G,we);Re!=null&&Re!==G&&(ge=!0,G=Re)}return G=G.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+v(we,!0)+'">'+(ge?G:v(G,!0))+`</code></pre>
`:"<pre><code>"+(ge?G:v(G,!0))+`</code></pre>
`},ae.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},ae.html=function(G){return G},ae.heading=function(G,te,ge,we){if(this.options.headerIds){var Re=this.options.headerPrefix+we.slug(ge);return"<h"+te+' id="'+Re+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(G,te,ge){var we=te?"ol":"ul",Re=te&&ge!==1?' start="'+ge+'"':"";return"<"+we+Re+`>
`+G+"</"+we+`>
`},ae.listitem=function(G){return"<li>"+G+`</li>
`},ae.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(G){return"<p>"+G+`</p>
`},ae.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},ae.tablerow=function(G){return`<tr>
`+G+`</tr>
`},ae.tablecell=function(G,te){var ge=te.header?"th":"td",we=te.align?"<"+ge+' align="'+te.align+'">':"<"+ge+">";return we+G+("</"+ge+`>
`)},ae.strong=function(G){return"<strong>"+G+"</strong>"},ae.em=function(G){return"<em>"+G+"</em>"},ae.codespan=function(G){return"<code>"+G+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(G){return"<del>"+G+"</del>"},ae.link=function(G,te,ge){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return ge;var we='<a href="'+v(G)+'"';return te&&(we+=' title="'+te+'"'),we+=">"+ge+"</a>",we},ae.image=function(G,te,ge){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return ge;var we='<img src="'+G+'" alt="'+ge+'"';return te&&(we+=' title="'+te+'"'),we+=this.options.xhtml?"/>":">",we},ae.text=function(G){return G},oe}(),x=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(G){return G},ae.em=function(G){return G},ae.codespan=function(G){return G},ae.del=function(G){return G},ae.html=function(G){return G},ae.text=function(G){return G},ae.link=function(G,te,ge){return""+ge},ae.image=function(G,te,ge){return""+ge},ae.br=function(){return""},oe}(),Z=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(G,te){var ge=G,we=0;if(this.seen.hasOwnProperty(ge)){we=this.seen[G];do we++,ge=G+"-"+we;while(this.seen.hasOwnProperty(ge))}return te||(this.seen[G]=we,this.seen[ge]=0),ge},ae.slug=function(G,te){te===void 0&&(te={});var ge=this.serialize(G);return this.getNextSafeSlug(ge,te.dryrun)},oe}(),Y=function(){function oe(re){this.options=re||le.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Z}oe.parse=function(G,te){var ge=new oe(te);return ge.parse(G)},oe.parseInline=function(G,te){var ge=new oe(te);return ge.parseInline(G)};var ae=oe.prototype;return ae.parse=function(G,te){te===void 0&&(te=!0);var ge="",we,Re,fe,Se,Ae,je,q,V,Q,J,he,pe,ze,Ve,Xe,tt,ot,it,st,De=G.length;for(we=0;we<De;we++){if(J=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(st=this.options.extensions.renderers[J.type].call({parser:this},J),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){ge+=st||"";continue}switch(J.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(J.tokens),J.depth,g(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(V="",q="",Se=J.header.length,Re=0;Re<Se;Re++)q+=this.renderer.tablecell(this.parseInline(J.header[Re].tokens),{header:!0,align:J.align[Re]});for(V+=this.renderer.tablerow(q),Q="",Se=J.rows.length,Re=0;Re<Se;Re++){for(je=J.rows[Re],q="",Ae=je.length,fe=0;fe<Ae;fe++)q+=this.renderer.tablecell(this.parseInline(je[fe].tokens),{header:!1,align:J.align[fe]});Q+=this.renderer.tablerow(q)}ge+=this.renderer.table(V,Q);continue}case"blockquote":{Q=this.parse(J.tokens),ge+=this.renderer.blockquote(Q);continue}case"list":{for(he=J.ordered,pe=J.start,ze=J.loose,Se=J.items.length,Q="",Re=0;Re<Se;Re++)Xe=J.items[Re],tt=Xe.checked,ot=Xe.task,Ve="",Xe.task&&(it=this.renderer.checkbox(tt),ze?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=it+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=it+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:it}):Ve+=it),Ve+=this.parse(Xe.tokens,ze),Q+=this.renderer.listitem(Ve,ot,tt);ge+=this.renderer.list(Q,he,pe);continue}case"html":{ge+=this.renderer.html(J.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Q=J.tokens?this.parseInline(J.tokens):J.text;we+1<De&&G[we+1].type==="text";)J=G[++we],Q+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);ge+=te?this.renderer.paragraph(Q):Q;continue}default:{var Be='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return ge},ae.parseInline=function(G,te){te=te||this.renderer;var ge="",we,Re,fe,Se=G.length;for(we=0;we<Se;we++){if(Re=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(fe=this.options.extensions.renderers[Re.type].call({parser:this},Re),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){ge+=fe||"";continue}switch(Re.type){case"escape":{ge+=te.text(Re.text);break}case"html":{ge+=te.html(Re.text);break}case"link":{ge+=te.link(Re.href,Re.title,this.parseInline(Re.tokens,te));break}case"image":{ge+=te.image(Re.href,Re.title,Re.text);break}case"strong":{ge+=te.strong(this.parseInline(Re.tokens,te));break}case"em":{ge+=te.em(this.parseInline(Re.tokens,te));break}case"codespan":{ge+=te.codespan(Re.text);break}case"br":{ge+=te.br();break}case"del":{ge+=te.del(this.parseInline(Re.tokens,te));break}case"text":{ge+=te.text(Re.text);break}default:{var Ae='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ge},oe}();function ce(oe,ae,re){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(re=ae,ae=null),ae=m({},ce.defaults,ae||{}),y(ae),re){var G=ae.highlight,te;try{te=W.lex(oe,ae)}catch(Se){return re(Se)}var ge=function(Ae){var je;if(!Ae)try{ae.walkTokens&&ce.walkTokens(te,ae.walkTokens),je=Y.parse(te,ae)}catch(q){Ae=q}return ae.highlight=G,Ae?re(Ae):re(null,je)};if(!G||G.length<3||(delete ae.highlight,!te.length))return ge();var we=0;ce.walkTokens(te,function(Se){Se.type==="code"&&(we++,setTimeout(function(){G(Se.text,Se.lang,function(Ae,je){if(Ae)return ge(Ae);je!=null&&je!==Se.text&&(Se.text=je,Se.escaped=!0),we--,we===0&&ge()})},0))}),we===0&&ge();return}function Re(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(Se.message+"",!0)+"</pre>";throw Se}try{var fe=W.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(ce.walkTokens(fe,ae.walkTokens)).then(function(){return Y.parse(fe,ae)}).catch(Re);ce.walkTokens(fe,ae.walkTokens)}return Y.parse(fe,ae)}catch(Se){Re(Se)}}ce.options=ce.setOptions=function(oe){return m(ce.defaults,oe),w(ce.defaults),ce},ce.getDefaults=M,ce.defaults=le.defaults,ce.use=function(){for(var oe=arguments.length,ae=new Array(oe),re=0;re<oe;re++)ae[re]=arguments[re];var G=m.apply(void 0,[{}].concat(ae)),te=ce.defaults.extensions||{renderers:{},childTokens:{}},ge;ae.forEach(function(we){if(we.extensions&&(ge=!0,we.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var Se=te.renderers?te.renderers[fe.name]:null;Se?te.renderers[fe.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),q=0;q<Ae;q++)je[q]=arguments[q];var V=fe.renderer.apply(this,je);return V===!1&&(V=Se.apply(this,je)),V}:te.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[fe.level]?te[fe.level].unshift(fe.tokenizer):te[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?te.startBlock?te.startBlock.push(fe.start):te.startBlock=[fe.start]:fe.level==="inline"&&(te.startInline?te.startInline.push(fe.start):te.startInline=[fe.start]))}fe.childTokens&&(te.childTokens[fe.name]=fe.childTokens)})),we.renderer&&function(){var fe=ce.defaults.renderer||new X,Se=function(q){var V=fe[q];fe[q]=function(){for(var Q=arguments.length,J=new Array(Q),he=0;he<Q;he++)J[he]=arguments[he];var pe=we.renderer[q].apply(fe,J);return pe===!1&&(pe=V.apply(fe,J)),pe}};for(var Ae in we.renderer)Se(Ae);G.renderer=fe}(),we.tokenizer&&function(){var fe=ce.defaults.tokenizer||new F,Se=function(q){var V=fe[q];fe[q]=function(){for(var Q=arguments.length,J=new Array(Q),he=0;he<Q;he++)J[he]=arguments[he];var pe=we.tokenizer[q].apply(fe,J);return pe===!1&&(pe=V.apply(fe,J)),pe}};for(var Ae in we.tokenizer)Se(Ae);G.tokenizer=fe}(),we.walkTokens){var Re=ce.defaults.walkTokens;G.walkTokens=function(fe){var Se=[];return Se.push(we.walkTokens.call(this,fe)),Re&&(Se=Se.concat(Re.call(this,fe))),Se}}ge&&(G.extensions=te),ce.setOptions(G)})},ce.walkTokens=function(oe,ae){for(var re=[],G=function(){var Re=ge.value;switch(re=re.concat(ae.call(ce,Re)),Re.type){case"table":{for(var fe=R(Re.header),Se;!(Se=fe()).done;){var Ae=Se.value;re=re.concat(ce.walkTokens(Ae.tokens,ae))}for(var je=R(Re.rows),q;!(q=je()).done;)for(var V=q.value,Q=R(V),J;!(J=Q()).done;){var he=J.value;re=re.concat(ce.walkTokens(he.tokens,ae))}break}case"list":{re=re.concat(ce.walkTokens(Re.items,ae));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Re.type]?ce.defaults.extensions.childTokens[Re.type].forEach(function(pe){re=re.concat(ce.walkTokens(Re[pe],ae))}):Re.tokens&&(re=re.concat(ce.walkTokens(Re.tokens,ae)))}},te=R(oe),ge;!(ge=te()).done;)G();return re},ce.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=m({},ce.defaults,ae||{}),y(ae);try{var re=W.lexInline(oe,ae);return ae.walkTokens&&ce.walkTokens(re,ae.walkTokens),Y.parseInline(re,ae)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(G.message+"",!0)+"</pre>";throw G}},ce.Parser=Y,ce.parser=Y.parse,ce.Renderer=X,ce.TextRenderer=x,ce.Lexer=W,ce.lexer=W.lex,ce.Tokenizer=F,ce.Slugger=Z,ce.parse=ce;var ne=ce.options,$e=ce.setOptions,Pe=ce.use,_=ce.walkTokens,U=ce.parseInline,ie=ce,be=Y.parse,Ce=W.lex;le.Lexer=W,le.Parser=Y,le.Renderer=X,le.Slugger=Z,le.TextRenderer=x,le.Tokenizer=F,le.getDefaults=M,le.lexer=Ce,le.marked=ce,le.options=ne,le.parse=ie,le.parseInline=U,le.parser=be,le.setOptions=$e,le.use=Pe,le.walkTokens=_,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[166],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=u;function u(c){const g=R(c);if(g&&g.length>0)return new Uint32Array(g)}let N=0;const L=new Uint32Array(10);function R(c){if(N=0,M(c,C,4352),N>0||(M(c,$,4449),N>0)||(M(c,k,4520),N>0)||(M(c,v,12593),N))return L.subarray(0,N);if(c>=44032&&c<=55203){const g=c-44032,o=g%588,n=Math.floor(g/588),i=Math.floor(o/28),r=o%28-1;if(n<C.length?M(n,C,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<$.length?M(i,$,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),r>=0&&(r<k.length?M(r,k,0):4520+r-12593<v.length&&M(4520+r-12593,v,12593)),N>0)return L.subarray(0,N)}}function M(c,g,o){c>=o&&c<o+g.length&&w(g[c-o])}function w(c){c!==0&&(L[N++]=c&255,c>>8&&(L[N++]=c>>8&255),c>>16&&(L[N++]=c>>16&255))}var b;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var S;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(S||(S={}));var A;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(A||(A={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),$=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),k=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0,e.$8l=L,e.$9l=M;const N=new u.$Ec(1e4);function L(S){return b(S,"NFC",N)}const R=new u.$Ec(1e4);function M(S){return b(S,"NFD",R)}const w=/[^\u0000-\u0080]/;function b(S,A,C){if(!S)return S;const $=C.get(S);if($)return $;let k;return w.test(S)?k=S.normalize(A):k=S,C.set(S,k),k}e.$0l=function(){const S=/[\u0300-\u036f]/g;return function(A){return M(A).replace(S,"")}}()}),define(ke[125],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=u,e.rot=N;function u(w,b,S){return Math.min(Math.max(w,b),S)}function N(w,b){return(b+w%b)%b}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=L;class R{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=R;class M{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const S=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function le(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function M(b){R.push(b,Date.now())}function w(){const b=[];for(let S=0;S<R.length;S+=2)b.push({name:R[S],startTime:R[S+1]});return b}return{mark:M,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(L+M.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function u(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=u(N))}(),define(ke[167],Ee([1,0,45]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=void 0;const N=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert(b,S,A){this.d(b,C=>C._value=S,A)}mutate(b,S){this.d(b,A=>A._value=S(A._value===N?void 0:A._value))}delete(b){const S=this.c(b);if(!S)return;let A=S.length-1;const C=S[A].node._value;if(C!==N){for(this.b--,S[A].node._value=N;A>0;A--){const{node:$,part:k}=S[A];if($.children?.size||$._value!==N)break;S[A-1].node.children.delete(k)}return C}}*deleteRecursive(b){const S=this.c(b);if(!S)return;const A=S[S.length-1].node;for(let C=S.length-1;C>0;C--){const $=S[C-1];if($.node.children.delete(S[C].part),$.node.children.size>0||$.node._value!==N)break}for(const C of R(A))C._value!==N&&(this.b--,yield C._value)}find(b){let S=this.a;for(const A of b){const C=S.children?.get(A);if(!C)return;S=C}return S._value===N?void 0:S._value}hasKeyOrParent(b){let S=this.a;for(const A of b){const C=S.children?.get(A);if(!C)return!1;if(C._value!==N)return!0;S=C}return!1}hasKeyOrChildren(b){let S=this.a;for(const A of b){const C=S.children?.get(A);if(!C)return!1;S=C}return!0}hasKey(b){let S=this.a;for(const A of b){const C=S.children?.get(A);if(!C)return!1;S=C}return S._value!==N}c(b){const S=[{part:"",node:this.a}];let A=0;for(const C of b){const $=S[A].node.children?.get(C);if(!$)return;S.push({part:C,node:$}),A++}return S}d(b,S,A){let C=this.a;for(const v of b){if(C.children)if(C.children.has(v))C=C.children.get(v);else{const c=new M;C.children.set(v,c),C=c}else{const c=new M;C.children=new Map([[v,c]]),C=c}A?.(C)}const $=C._value===N?0:1;S(C);const k=C._value===N?0:1;this.b+=k-$}*values(){for(const{_value:b}of R(this.a))b!==N&&(yield b)}}e.$2O=L;function*R(w){const b=[w];for(;b.length>0;){const S=b.pop();if(yield S,S.children)for(const A of S.children.values())b.push(A)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(b){this._value=b===void 0?N:b}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var N in u)(typeof exports=="object"?exports:le)[N]=u[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function u(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return le[N].call(L.exports,L,L.exports,u),L.l=!0,L.exports}return u.m=le,u.c=e,u.d=function(N,L,R){u.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:R})},u.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},u.t=function(N,L){if(1&L&&(N=u(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(u.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var M in N)u.d(R,M,function(w){return N[w]}.bind(null,M));return R},u.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return u.d(L,"a",L),L},u.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},u.p="",u(u.s=0)}([function(le,e,u){(function(N){var L;e=le.exports=Pe,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],b=e.src=[],S=0,A=S++;b[A]="0|[1-9]\\d*";var C=S++;b[C]="[0-9]+";var $=S++;b[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=S++;b[k]="("+b[A]+")\\.("+b[A]+")\\.("+b[A]+")";var v=S++;b[v]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var c=S++;b[c]="(?:"+b[A]+"|"+b[$]+")";var g=S++;b[g]="(?:"+b[C]+"|"+b[$]+")";var o=S++;b[o]="(?:-("+b[c]+"(?:\\."+b[c]+")*))";var n=S++;b[n]="(?:-?("+b[g]+"(?:\\."+b[g]+")*))";var i=S++;b[i]="[0-9A-Za-z-]+";var r=S++;b[r]="(?:\\+("+b[i]+"(?:\\."+b[i]+")*))";var s=S++,t="v?"+b[k]+b[o]+"?"+b[r]+"?";b[s]="^"+t+"$";var f="[v=\\s]*"+b[v]+b[n]+"?"+b[r]+"?",d=S++;b[d]="^"+f+"$";var l=S++;b[l]="((?:<|>)?=?)";var a=S++;b[a]=b[C]+"|x|X|\\*";var h=S++;b[h]=b[A]+"|x|X|\\*";var m=S++;b[m]="[v=\\s]*("+b[h]+")(?:\\.("+b[h]+")(?:\\.("+b[h]+")(?:"+b[o]+")?"+b[r]+"?)?)?";var D=S++;b[D]="[v=\\s]*("+b[a]+")(?:\\.("+b[a]+")(?:\\.("+b[a]+")(?:"+b[n]+")?"+b[r]+"?)?)?";var p=S++;b[p]="^"+b[l]+"\\s*"+b[m]+"$";var E=S++;b[E]="^"+b[l]+"\\s*"+b[D]+"$";var y=S++;b[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=S++;b[P]="(?:~>?)";var I=S++;b[I]="(\\s*)"+b[P]+"\\s+",w[I]=new RegExp(b[I],"g");var j=S++;b[j]="^"+b[P]+b[m]+"$";var F=S++;b[F]="^"+b[P]+b[D]+"$";var z=S++;b[z]="(?:\\^)";var O=S++;b[O]="(\\s*)"+b[z]+"\\s+",w[O]=new RegExp(b[O],"g");var T=S++;b[T]="^"+b[z]+b[m]+"$";var B=S++;b[B]="^"+b[z]+b[D]+"$";var W=S++;b[W]="^"+b[l]+"\\s*("+f+")$|^$";var X=S++;b[X]="^"+b[l]+"\\s*("+t+")$|^$";var x=S++;b[x]="(\\s*)"+b[l]+"\\s*("+f+"|"+b[m]+")",w[x]=new RegExp(b[x],"g");var Z=S++;b[Z]="^\\s*("+b[m]+")\\s+-\\s+("+b[m]+")\\s*$";var Y=S++;b[Y]="^\\s*("+b[D]+")\\s+-\\s+("+b[D]+")\\s*$";var ce=S++;b[ce]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)L(ne,b[ne]),w[ne]||(w[ne]=new RegExp(b[ne]));function $e(V,Q){if(V instanceof Pe)return V;if(typeof V!="string"||V.length>R||!(Q?w[d]:w[s]).test(V))return null;try{return new Pe(V,Q)}catch{return null}}function Pe(V,Q){if(V instanceof Pe){if(V.loose===Q)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Pe))return new Pe(V,Q);L("SemVer",V,Q),this.loose=Q;var J=V.trim().match(Q?w[d]:w[s]);if(!J)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<M)return pe}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=$e,e.valid=function(V,Q){var J=$e(V,Q);return J?J.version:null},e.clean=function(V,Q){var J=$e(V.trim().replace(/^[=v]+/,""),Q);return J?J.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(V){return L("SemVer.compare",this.version,this.loose,V),V instanceof Pe||(V=new Pe(V,this.loose)),this.compareMain(V)||this.comparePre(V)},Pe.prototype.compareMain=function(V){return V instanceof Pe||(V=new Pe(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},Pe.prototype.comparePre=function(V){if(V instanceof Pe||(V=new Pe(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Q=0;do{var J=this.prerelease[Q],he=V.prerelease[Q];if(L("prerelease compare",Q,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return U(J,he)}while(++Q)},Pe.prototype.inc=function(V,Q){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Q,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new Pe(V,J).inc(Q,he).version}catch{return null}},e.diff=function(V,Q){if(oe(V,Q))return null;var J=$e(V),he=$e(Q);if(J.prerelease.length||he.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return pe},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(V,Q){var J=_.test(V),he=_.test(Q);return J&&he&&(V=+V,Q=+Q),J&&!he?-1:he&&!J?1:V<Q?-1:V>Q?1:0}function ie(V,Q,J){return new Pe(V,J).compare(new Pe(Q,J))}function be(V,Q,J){return ie(V,Q,J)>0}function Ce(V,Q,J){return ie(V,Q,J)<0}function oe(V,Q,J){return ie(V,Q,J)===0}function ae(V,Q,J){return ie(V,Q,J)!==0}function re(V,Q,J){return ie(V,Q,J)>=0}function G(V,Q,J){return ie(V,Q,J)<=0}function te(V,Q,J,he){var pe;switch(Q){case"===":typeof V=="object"&&(V=V.version),typeof J=="object"&&(J=J.version),pe=V===J;break;case"!==":typeof V=="object"&&(V=V.version),typeof J=="object"&&(J=J.version),pe=V!==J;break;case"":case"=":case"==":pe=oe(V,J,he);break;case"!=":pe=ae(V,J,he);break;case">":pe=be(V,J,he);break;case">=":pe=re(V,J,he);break;case"<":pe=Ce(V,J,he);break;case"<=":pe=G(V,J,he);break;default:throw new TypeError("Invalid operator: "+Q)}return pe}function ge(V,Q){if(V instanceof ge){if(V.loose===Q)return V;V=V.value}if(!(this instanceof ge))return new ge(V,Q);L("comparator",V,Q),this.loose=Q,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(V,Q){return U(Q,V)},e.major=function(V,Q){return new Pe(V,Q).major},e.minor=function(V,Q){return new Pe(V,Q).minor},e.patch=function(V,Q){return new Pe(V,Q).patch},e.compare=ie,e.compareLoose=function(V,Q){return ie(V,Q,!0)},e.rcompare=function(V,Q,J){return ie(Q,V,J)},e.sort=function(V,Q){return V.sort(function(J,he){return e.compare(J,he,Q)})},e.rsort=function(V,Q){return V.sort(function(J,he){return e.rcompare(J,he,Q)})},e.gt=be,e.lt=Ce,e.eq=oe,e.neq=ae,e.gte=re,e.lte=G,e.cmp=te,e.Comparator=ge;var we={};function Re(V,Q){if(V instanceof Re)return V.loose===Q?V:new Re(V.raw,Q);if(V instanceof ge)return new Re(V.value,Q);if(!(this instanceof Re))return new Re(V,Q);if(this.loose=Q,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function fe(V){return!V||V.toLowerCase()==="x"||V==="*"}function Se(V,Q,J,he,pe,ze,Ve,Xe,tt,ot,it,st,De){return((Q=fe(J)?"":fe(he)?">="+J+".0.0":fe(pe)?">="+J+"."+he+".0":">="+Q)+" "+(Xe=fe(tt)?"":fe(ot)?"<"+(+tt+1)+".0.0":fe(it)?"<"+tt+"."+(+ot+1)+".0":st?"<="+tt+"."+ot+"."+it+"-"+st:"<="+Xe)).trim()}function Ae(V,Q){for(var J=0;J<V.length;J++)if(!V[J].test(Q))return!1;if(Q.prerelease.length){for(J=0;J<V.length;J++)if(L(V[J].semver),V[J].semver!==we&&V[J].semver.prerelease.length>0){var he=V[J].semver;if(he.major===Q.major&&he.minor===Q.minor&&he.patch===Q.patch)return!0}return!1}return!0}function je(V,Q,J){try{Q=new Re(Q,J)}catch{return!1}return Q.test(V)}function q(V,Q,J,he){var pe,ze,Ve,Xe,tt;switch(V=new Pe(V,he),Q=new Re(Q,he),J){case">":pe=be,ze=G,Ve=Ce,Xe=">",tt=">=";break;case"<":pe=Ce,ze=re,Ve=be,Xe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(V,Q,he))return!1;for(var ot=0;ot<Q.set.length;++ot){var it=Q.set[ot],st=null,De=null;if(it.forEach(function(Be){Be.semver===we&&(Be=new ge(">=0.0.0")),st=st||Be,De=De||Be,pe(Be.semver,st.semver,he)?st=Be:Ve(Be.semver,De.semver,he)&&(De=Be)}),st.operator===Xe||st.operator===tt||(!De.operator||De.operator===Xe)&&ze(V,De.semver)||De.operator===tt&&Ve(V,De.semver))return!1}return!0}ge.prototype.parse=function(V){var Q=this.loose?w[W]:w[X],J=V.match(Q);if(!J)throw new TypeError("Invalid comparator: "+V);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Pe(J[2],this.loose):this.semver=we},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(V){return L("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new Pe(V,this.loose)),te(V,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(V,Q){if(!(V instanceof ge))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Re(V.value,Q),je(this.value,J,Q);if(V.operator==="")return J=new Re(this.value,Q),je(V.semver,J,Q);var he=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),ze=this.semver.version===V.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Xe=te(this.semver,"<",V.semver,Q)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),tt=te(this.semver,">",V.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return he||pe||ze&&Ve||Xe||tt},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(V){var Q=this.loose;V=V.trim(),L("range",V,Q);var J=Q?w[Y]:w[Z];V=V.replace(J,Se),L("hyphen replace",V),V=V.replace(w[x],"$1$2$3"),L("comparator trim",V,w[x]),V=(V=(V=V.replace(w[I],"$1~")).replace(w[O],"$1^")).split(/\s+/).join(" ");var he=Q?w[W]:w[X],pe=V.split(" ").map(function(ze){return function(Ve,Xe){return L("comp",Ve),Ve=function(tt,ot){return tt.trim().split(/\s+/).map(function(it){return function(st,De){L("caret",st,De);var Be=De?w[B]:w[T];return st.replace(Be,function(He,Le,Ze,se,ue){var Ie;return L("caret",st,He,Le,Ze,se,ue),fe(Le)?Ie="":fe(Ze)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":fe(se)?Ie=Le==="0"?">="+Le+"."+Ze+".0 <"+Le+"."+(+Ze+1)+".0":">="+Le+"."+Ze+".0 <"+(+Le+1)+".0.0":ue?(L("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=Le==="0"?Ze==="0"?">="+Le+"."+Ze+"."+se+ue+" <"+Le+"."+Ze+"."+(+se+1):">="+Le+"."+Ze+"."+se+ue+" <"+Le+"."+(+Ze+1)+".0":">="+Le+"."+Ze+"."+se+ue+" <"+(+Le+1)+".0.0"):(L("no pr"),Ie=Le==="0"?Ze==="0"?">="+Le+"."+Ze+"."+se+" <"+Le+"."+Ze+"."+(+se+1):">="+Le+"."+Ze+"."+se+" <"+Le+"."+(+Ze+1)+".0":">="+Le+"."+Ze+"."+se+" <"+(+Le+1)+".0.0"),L("caret return",Ie),Ie})}(it,ot)}).join(" ")}(Ve,Xe),L("caret",Ve),Ve=function(tt,ot){return tt.trim().split(/\s+/).map(function(it){return function(st,De){var Be=De?w[F]:w[j];return st.replace(Be,function(He,Le,Ze,se,ue){var Ie;return L("tilde",st,He,Le,Ze,se,ue),fe(Le)?Ie="":fe(Ze)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":fe(se)?Ie=">="+Le+"."+Ze+".0 <"+Le+"."+(+Ze+1)+".0":ue?(L("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=">="+Le+"."+Ze+"."+se+ue+" <"+Le+"."+(+Ze+1)+".0"):Ie=">="+Le+"."+Ze+"."+se+" <"+Le+"."+(+Ze+1)+".0",L("tilde return",Ie),Ie})}(it,ot)}).join(" ")}(Ve,Xe),L("tildes",Ve),Ve=function(tt,ot){return L("replaceXRanges",tt,ot),tt.split(/\s+/).map(function(it){return function(st,De){st=st.trim();var Be=De?w[E]:w[p];return st.replace(Be,function(He,Le,Ze,se,ue,Ie){L("xRange",st,He,Le,Ze,se,ue,Ie);var Ge=fe(Ze),Me=Ge||fe(se),nt=Me||fe(ue);return Le==="="&&nt&&(Le=""),Ge?He=Le===">"||Le==="<"?"<0.0.0":"*":Le&&nt?(Me&&(se=0),nt&&(ue=0),Le===">"?(Le=">=",Me?(Ze=+Ze+1,se=0,ue=0):nt&&(se=+se+1,ue=0)):Le==="<="&&(Le="<",Me?Ze=+Ze+1:se=+se+1),He=Le+Ze+"."+se+"."+ue):Me?He=">="+Ze+".0.0 <"+(+Ze+1)+".0.0":nt&&(He=">="+Ze+"."+se+".0 <"+Ze+"."+(+se+1)+".0"),L("xRange return",He),He})}(it,ot)}).join(" ")}(Ve,Xe),L("xrange",Ve),Ve=function(tt,ot){return L("replaceStars",tt,ot),tt.trim().replace(w[ce],"")}(Ve,Xe),L("stars",Ve),Ve}(ze,Q)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(ze){return!!ze.match(he)})),pe=pe.map(function(ze){return new ge(ze,Q)})},Re.prototype.intersects=function(V,Q){if(!(V instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return V.set.some(function(pe){return pe.every(function(ze){return he.intersects(ze,Q)})})})})},e.toComparators=function(V,Q){return new Re(V,Q).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new Pe(V,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ae(this.set[Q],V))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(V,Q,J){var he=null,pe=null;try{var ze=new Re(Q,J)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&pe.compare(Ve)!==-1||(pe=new Pe(he=Ve,J)))}),he},e.minSatisfying=function(V,Q,J){var he=null,pe=null;try{var ze=new Re(Q,J)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&pe.compare(Ve)!==1||(pe=new Pe(he=Ve,J)))}),he},e.validRange=function(V,Q){try{return new Re(V,Q).range||"*"}catch{return null}},e.ltr=function(V,Q,J){return q(V,Q,"<",J)},e.gtr=function(V,Q,J){return q(V,Q,">",J)},e.outside=q,e.prerelease=function(V,Q){var J=$e(V,Q);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(V,Q,J){return V=new Re(V,J),Q=new Re(Q,J),V.intersects(Q)},e.coerce=function(V){if(V instanceof Pe)return V;if(typeof V!="string")return null;var Q=V.match(w[y]);return Q==null?null:$e((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,u(1))},function(le,e){var u,N,L=le.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function w(g){if(u===setTimeout)return setTimeout(g,0);if((u===R||!u)&&setTimeout)return u=setTimeout,setTimeout(g,0);try{return u(g,0)}catch{try{return u.call(null,g,0)}catch{return u.call(this,g,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:R}catch{u=R}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var b,S=[],A=!1,C=-1;function $(){A&&b&&(A=!1,b.length?S=b.concat(S):C=-1,S.length&&k())}function k(){if(!A){var g=w($);A=!0;for(var o=S.length;o;){for(b=S,S=[];++C<o;)b&&b[C].run();C=-1,o=S.length}b=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(g)}}function v(g,o){this.fun=g,this.array=o}function c(){}L.nextTick=function(g){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];S.push(new v(g,o)),S.length!==1||A||w(k)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=c,L.addListener=c,L.once=c,L.off=c,L.removeListener=c,L.removeAllListeners=c,L.emit=c,L.prependListener=c,L.prependOnceListener=c,L.listeners=function(g){return[]},L.binding=function(g){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(g){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[39],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=u&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=N}),define(ke[4],Ee([1,0,13,74,3,75,39]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=k;const w=!1,b=!1,S=!1;var A;(function(I){I.None=()=>L.$Uc.None;function j(Re){if(S){const{onDidAddListener:fe}=Re,Se=c.create();let Ae=0;Re.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),fe?.()}}}function F(Re,fe){return ce(Re,()=>{},0,void 0,!0,void 0,fe)}I.defer=F;function z(Re){return(fe,Se=null,Ae)=>{let je=!1,q;return q=Re(V=>{if(!je)return q?q.dispose():je=!0,fe.call(Se,V)},null,Ae),je&&q.dispose(),q}}I.once=z;function O(Re,fe,Se){return Z((Ae,je=null,q)=>Re(V=>Ae.call(je,fe(V)),null,q),Se)}I.map=O;function T(Re,fe,Se){return Z((Ae,je=null,q)=>Re(V=>{fe(V),Ae.call(je,V)},null,q),Se)}I.forEach=T;function B(Re,fe,Se){return Z((Ae,je=null,q)=>Re(V=>fe(V)&&Ae.call(je,V),null,q),Se)}I.filter=B;function W(Re){return Re}I.signal=W;function X(...Re){return(fe,Se=null,Ae)=>{const je=(0,L.$Rc)(...Re.map(q=>q(V=>fe.call(Se,V))));return Y(je,Ae)}}I.any=X;function x(Re,fe,Se,Ae){let je=Se;return O(Re,q=>(je=fe(je,q),je),Ae)}I.reduce=x;function Z(Re,fe){let Se;const Ae={onWillAddFirstListener(){Se=Re(je.fire,je)},onDidRemoveLastListener(){Se?.dispose()}};fe||j(Ae);const je=new s(Ae);return fe?.add(je),je.event}function Y(Re,fe){return fe instanceof Array?fe.push(Re):fe&&fe.add(Re),Re}function ce(Re,fe,Se=100,Ae=!1,je=!1,q,V){let Q,J,he,pe=0,ze;const Ve={leakWarningThreshold:q,onWillAddFirstListener(){Q=Re(tt=>{pe++,J=fe(J,tt),Ae&&!he&&(Xe.fire(J),J=void 0),ze=()=>{const ot=J;J=void 0,he=void 0,(!Ae||pe>1)&&Xe.fire(ot),pe=0},typeof Se=="number"?(clearTimeout(he),he=setTimeout(ze,Se)):he===void 0&&(he=0,queueMicrotask(ze))})},onWillRemoveListener(){je&&pe>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,Q.dispose()}};V||j(Ve);const Xe=new s(Ve);return V?.add(Xe),Xe.event}I.debounce=ce;function ne(Re,fe=0,Se){return I.debounce(Re,(Ae,je)=>Ae?(Ae.push(je),Ae):[je],fe,void 0,!0,void 0,Se)}I.accumulate=ne;function $e(Re,fe=(Ae,je)=>Ae===je,Se){let Ae=!0,je;return B(Re,q=>{const V=Ae||!fe(q,je);return Ae=!1,je=q,V},Se)}I.latch=$e;function Pe(Re,fe,Se){return[I.filter(Re,fe,Se),I.filter(Re,Ae=>!fe(Ae),Se)]}I.split=Pe;function _(Re,fe=!1,Se=[],Ae){let je=Se.slice(),q=Re(J=>{je?je.push(J):Q.fire(J)});Ae&&Ae.add(q);const V=()=>{je?.forEach(J=>Q.fire(J)),je=null},Q=new s({onWillAddFirstListener(){q||(q=Re(J=>Q.fire(J)),Ae&&Ae.add(q))},onDidAddFirstListener(){je&&(fe?setTimeout(V):V())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return Ae&&Ae.add(Q),Q.event}I.buffer=_;function U(Re,fe){return(Ae,je,q)=>{const V=fe(new be);return Re(function(Q){const J=V.evaluate(Q);J!==ie&&Ae.call(je,J)},void 0,q)}}I.chain=U;const ie=Symbol("HaltChainable");class be{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(Se=>(fe(Se),Se)),this}filter(fe){return this.f.push(Se=>fe(Se)?Se:ie),this}reduce(fe,Se){let Ae=Se;return this.f.push(je=>(Ae=fe(Ae,je),Ae)),this}latch(fe=(Se,Ae)=>Se===Ae){let Se=!0,Ae;return this.f.push(je=>{const q=Se||!fe(je,Ae);return Se=!1,Ae=je,q?je:ie}),this}evaluate(fe){for(const Se of this.f)if(fe=Se(fe),fe===ie)break;return fe}}function Ce(Re,fe,Se=Ae=>Ae){const Ae=(...Q)=>V.fire(Se(...Q)),je=()=>Re.on(fe,Ae),q=()=>Re.removeListener(fe,Ae),V=new s({onWillAddFirstListener:je,onDidRemoveLastListener:q});return V.event}I.fromNodeEventEmitter=Ce;function oe(Re,fe,Se=Ae=>Ae){const Ae=(...Q)=>V.fire(Se(...Q)),je=()=>Re.addEventListener(fe,Ae),q=()=>Re.removeEventListener(fe,Ae),V=new s({onWillAddFirstListener:je,onDidRemoveLastListener:q});return V.event}I.fromDOMEventEmitter=oe;function ae(Re){return new Promise(fe=>z(Re)(fe))}I.toPromise=ae;function re(Re){const fe=new s;return Re.then(Se=>{fe.fire(Se)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=re;function G(Re,fe,Se){return fe(Se),Re(Ae=>fe(Ae))}I.runAndSubscribe=G;class te{constructor(fe,Se){this._observable=fe,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};Se||j(Ae),this.emitter=new s(Ae),Se&&Se.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,Se){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ge(Re,fe){return new te(Re,fe).emitter.event}I.fromObservable=ge;function we(Re){return(fe,Se,Ae)=>{let je=0,q=!1;const V={beginUpdate(){je++},endUpdate(){je--,je===0&&(Re.reportChanges(),q&&(q=!1,fe.call(Se)))},handlePossibleChange(){},handleChange(){q=!0}};Re.addObserver(V),Re.reportChanges();const Q={dispose(){Re.removeObserver(V)}};return Ae instanceof L.$Tc?Ae.add(Q):Array.isArray(Ae)&&Ae.push(Q),Q}}I.fromObservableLight=we})(A||(e.Event=A={}));class C{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${C.f++}`,C.all.add(this)}start(j){this.g=new M.$0d,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$_d=C;let $=-1;function k(I){const j=$;return $=I,{dispose(){$=j}}}class v{constructor(j,F=Math.random().toString(18).slice(2,5)){this.threshold=j,this.name=F,this.g=0}dispose(){this.f?.clear()}check(j,F){const z=this.threshold;if(z<=0||F<z)return;this.f||(this.f=new Map);const O=this.f.get(j.value)||0;if(this.f.set(j.value,O+1),this.g-=1,this.g<=0){this.g=z*.5;let T,B=0;for(const[W,X]of this.f)(!T||B<X)&&(T=W,B=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${B}):`),console.warn(T)}return()=>{const T=this.f.get(j.value)||0;this.f.set(j.value,T-1)}}}class c{static create(){return new c(new Error().stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class o{constructor(j){this.value=j,this.id=g++}}const n=2,i=(I,j)=>{if(I instanceof o)j(I);else for(let F=0;F<I.length;F++){const z=I[F];z&&j(z)}},r=w?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class s{constructor(j){this.w=0,this.f=j,this.g=$>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const j=this.t;queueMicrotask(()=>{i(j,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,F,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;F&&(j=j.bind(F));const O=new o(j);let T,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=c.create(),T=this.g.check(O.stack,this.w+1)),b&&(O.stack=B??c.create()),this.t?this.t instanceof o?(this.u??=new f,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Sc)(()=>{r?.unregister(W),T?.(),this.x(O)});if(z instanceof L.$Tc?z.add(W):Array.isArray(z)&&z.push(W),r){const X=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(W,X,W)}return W},this.q}x(j){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,z=F.indexOf(j);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[z]=void 0;const O=this.u.current===this;if(this.w*n<=F.length){let T=0;for(let B=0;B<F.length;B++)F[B]?F[T++]=F[B]:O&&(this.u.end--,T<this.u.i&&this.u.i--);F.length=T}}y(j,F){if(!j)return;const z=this.f?.onListenerError||u.$1;if(!z){j.value(F);return}try{j.value(F)}catch(O){z(O)}}z(j){const F=j.current.t;for(;j.i<j.end;)this.y(F[j.i++],j.value);j.reset()}fire(j){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,j);else{const F=this.u;F.enqueue(this,j,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=s;const t=()=>new f;e.$ce=t;class f{constructor(){this.i=-1,this.end=0}enqueue(j,F,z){this.i=0,this.end=z,this.current=j,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(j,F,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,O=>this.h.push([O.value,j]));this.h.size>0&&!F.isCancellationRequested;){const[O,T]=this.h.shift(),B=[],W={...T,token:F,waitUntil:X=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(X=z(X,O)),B.push(X)}};try{O(W)}catch(X){(0,u.$1)(X);continue}Object.freeze(B),await Promise.allSettled(B).then(X=>{for(const x of X)x.status==="rejected"&&(0,u.$1)(x.reason)})}}}e.$de=d;class l extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$5c,this.A=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.A(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.w&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$ee=l;class a extends l{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$fe=a;class h extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$ge=h;class m{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const F={event:j,listener:null};this.h.push(F),this.g&&this.m(F);const z=()=>{this.g&&this.o(F);const O=this.h.indexOf(F);this.h.splice(O,1)};return(0,L.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(F=>this.f.fire(F))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$he=m;class D{constructor(j,F,z,O){this.f=new L.$Tc;const T=this.f.add(new m),B=this.f.add(new L.$4c);function W(X){B.set(X,T.add(O(X)))}for(const X of j)W(X);this.f.add(F(X=>{W(X)})),this.f.add(z(X=>{B.deleteAndDispose(X)})),this.event=T.event}dispose(){this.f.dispose()}}e.$ie=D;class p{constructor(){this.f=[]}wrapEvent(j){return(F,z,O)=>j(T=>{const B=this.f[this.f.length-1];B?B.push(()=>F.call(z,T)):F.call(z,T)},void 0,O)}bufferEvents(j){const F=[];this.f.push(F);const z=j();return this.f.pop(),F.forEach(O=>O()),z}}e.$je=p;class E{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=E;class y{static const(j){return new P(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$le=y;class P{constructor(j){this.value=j,this.onDidChange=A.None}}}),define(ke[22],Ee([1,0,4]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const N=Object.freeze(function(w,b){const S=setTimeout(w.bind(b),0);return{dispose(){clearTimeout(S)}}});var L;(function(w){function b(S){return S===w.None||S===w.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}w.isCancellationToken=b,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new u.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$me=M}),define(ke[168],Ee([1,0,22]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ze=e.$Ye=e.$Xe=void 0;class N{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new u.$me,b=this.b(w.token);return this.a={promise:b,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$Xe=N;class L{constructor(w,b=JSON.stringify){this.c=w,this.d=b,this.a=void 0,this.b=void 0}get(w){const b=this.d(w);return this.b!==b&&(this.b=b,this.a=this.c(w)),this.a}}e.$Ye=L;class R{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const b=this.b(w);return this.a.set(w,b),b}}e.$Ze=R}),define(ke[98],Ee([1,0,13,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=L,e.$oe=R,e.$pe=M,e.$qe=w,e.$re=S,e.$se=A,e.$te=C,e.$ue=$,e.$ve=k,e.$we=v,e.$xe=c,e.$ye=g,e.$ze=o,e.$Ae=n,e.$Be=i;function L(r){const s=r;return s?typeof s.read=="function":!1}function R(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function M(r){const s=r;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function w(r,s){return new b(r,s)}class b{constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,u.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let f;switch(s){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const d=f.indexOf(t);d>=0&&f.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function A(r,s,t){const f=[];let d;for(;(d=r.read())!==null&&f.length<t;)f.push(d);return d===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}function C(r,s){return new Promise((t,f)=>{const d=[];$(r,{onData:l=>{s&&d.push(l)},onError:l=>{s?f(l):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function $(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function k(r,s){return new Promise((t,f)=>{const d=new N.$Tc,l=[],a=D=>{if(l.push(D),l.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=D=>(d.dispose(),f(D)),m=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,N.$Sc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,N.$Sc)(()=>r.removeListener("end",m))),r.on("end",m),d.add((0,N.$Sc)(()=>r.removeListener("data",a))),r.on("data",a)})}function v(r,s){const t=w(s);return t.end(r),t}function c(){const r=w(()=>{throw new Error("not supported")});return r.end(),r}function g(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function o(r,s,t){const f=w(t);return $(r,{onData:d=>f.write(s.data(d)),onError:d=>f.error(s.error?s.error(d):d),onEnd:()=>f.end()}),f}function n(r,s,t){let f=!1;return{read:()=>{const d=s.read();return f?d:(f=!0,d!==null?t([r,d]):r)}}}function i(r,s,t){let f=!1;const d=w(t);return $(s,{onData:l=>f?d.write(l):(f=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{f||(f=!0,d.write(r)),d.end()}}),d}}),define(ke[21],Ee([1,0,46,98]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=S,e.$Ee=A,e.$Fe=C,e.$Ge=$,e.$He=k,e.$Ie=v,e.$Je=c,e.$Ke=g,e.$Le=o,e.$Me=n,e.$Ne=i,e.$Oe=r,e.$Pe=s,e.$Qe=t,e.$Re=f,e.$Se=d,e.$Te=l,e.$Ue=a,e.$Ve=h,e.$We=p;const L=typeof Buffer<"u",R=new u.$V(()=>new Uint8Array(256));let M,w;class b{static alloc(y){return L?new b(Buffer.allocUnsafe(y)):new b(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new b(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&L?new b(Buffer.from(y)):(M||(M=new TextEncoder),new b(M.encode(y)))}static fromByteArray(y){const P=b.alloc(y.length);for(let I=0,j=y.length;I<j;I++)P.buffer[I]=y[I];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let F=0,z=y.length;F<z;F++)P+=y[F].byteLength}const I=b.alloc(P);let j=0;for(let F=0,z=y.length;F<z;F++){const O=y[F];I.set(O,j),j+=O.byteLength}return I}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=b.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(y,P){return new b(this.buffer.subarray(y,P))}set(y,P){if(y instanceof b)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return $(this.buffer,y)}writeUInt32BE(y,P){k(this.buffer,y,P)}readUInt32LE(y){return v(this.buffer,y)}writeUInt32LE(y,P){c(this.buffer,y,P)}readUInt8(y){return g(this.buffer,y)}writeUInt8(y,P){o(this.buffer,y,P)}indexOf(y,P=0){return S(this.buffer,y instanceof b?y.buffer:y,P)}}e.$Ce=b;function S(E,y,P=0){const I=y.byteLength,j=E.byteLength;if(I===0)return 0;if(I===1)return E.indexOf(y[0]);if(I>j-P)return-1;const F=R.value;F.fill(y.length);for(let B=0;B<y.length;B++)F[y[B]]=y.length-B-1;let z=P+y.length-1,O=z,T=-1;for(;z<j;)if(E[z]===y[O]){if(O===0){T=z;break}z--,O--}else z+=Math.max(y.length-O,F[E[z]]),O=y.length-1;return T}function A(E,y){return E[y+0]<<0>>>0|E[y+1]<<8>>>0}function C(E,y,P){E[P+0]=y&255,y=y>>>8,E[P+1]=y&255}function $(E,y){return E[y]*2**24+E[y+1]*2**16+E[y+2]*2**8+E[y+3]}function k(E,y,P){E[P+3]=y,y=y>>>8,E[P+2]=y,y=y>>>8,E[P+1]=y,y=y>>>8,E[P]=y}function v(E,y){return E[y+0]<<0>>>0|E[y+1]<<8>>>0|E[y+2]<<16>>>0|E[y+3]<<24>>>0}function c(E,y,P){E[P+0]=y&255,y=y>>>8,E[P+1]=y&255,y=y>>>8,E[P+2]=y&255,y=y>>>8,E[P+3]=y&255}function g(E,y){return E[y]}function o(E,y,P){E[P]=y}function n(E){return N.$re(E,y=>b.concat(y))}function i(E){return N.$ye(E)}function r(E){return N.$te(E,y=>b.concat(y))}async function s(E){return E.ended?b.concat(E.buffer):b.concat([...E.buffer,await r(E.stream)])}function t(E){return N.$we(E,y=>b.concat(y))}function f(E){return N.$ze(E,{data:y=>typeof y=="string"?b.fromString(y):b.wrap(y)},y=>b.concat(y))}function d(E){return N.$qe(y=>b.concat(y),E)}function l(E,y){return N.$Ae(E,y,P=>b.concat(P))}function a(E,y){return N.$Be(E,y,P=>b.concat(P))}function h(E){let y=0,P=0,I=0;const j=new Uint8Array(Math.floor(E.length/4*3)),F=O=>{switch(P){case 3:j[I++]=y|O,P=0;break;case 2:j[I++]=y|O>>>2,y=O<<6,P=3;break;case 1:j[I++]=y|O>>>4,y=O<<4,P=2;break;default:y=O<<2,P=1}};for(let O=0;O<E.length;O++){const T=E.charCodeAt(O);if(T>=65&&T<=90)F(T-65);else if(T>=97&&T<=122)F(T-97+26);else if(T>=48&&T<=57)F(T-48+52);else if(T===43||T===45)F(62);else if(T===47||T===95)F(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${E[O]}`)}}const z=I;for(;P>0;)F(0);return b.wrap(j).slice(0,z)}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:E},y=!0,P=!1){const I=P?D:m;let j="";const F=E.byteLength%3;let z=0;for(;z<E.byteLength-F;z+=3){const O=E[z+0],T=E[z+1],B=E[z+2];j+=I[O>>>2],j+=I[(O<<4|T>>>4)&63],j+=I[(T<<2|B>>>6)&63],j+=I[B&63]}if(F===1){const O=E[z+0];j+=I[O>>>2],j+=I[O<<4&63],y&&(j+="==")}else if(F===2){const O=E[z+0],T=E[z+1];j+=I[O>>>2],j+=I[(O<<4|T>>>4)&63],j+=I[T<<2&63],y&&(j+="=")}return j}}),define(ke[14],Ee([1,0,168,46]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=e.$1f=e.GraphemeBreakType=e.$Qf=e.$Jf=e.$Cf=e.$Bf=void 0,e.$3e=L,e.$4e=M,e.$5e=b,e.$6e=S,e.$7e=A,e.$8e=C,e.$9e=$,e.$0e=k,e.$$e=v,e.$_e=c,e.$af=g,e.$bf=o,e.$cf=n,e.$df=i,e.$ef=r,e.$ff=s,e.$gf=t,e.$hf=f,e.$if=d,e.$jf=l,e.$kf=a,e.$lf=h,e.$mf=m,e.$nf=D,e.$of=p,e.$pf=E,e.$qf=y,e.$rf=P,e.$sf=I,e.$tf=j,e.$uf=F,e.$vf=z,e.$wf=O,e.$xf=T,e.$yf=B,e.$zf=W,e.$Af=X,e.$Df=ce,e.$Ef=ne,e.$Ff=$e,e.$Gf=Pe,e.$Hf=ie,e.$If=Ce,e.$Kf=oe,e.$Lf=ae,e.$Mf=re,e.$Nf=G,e.$Of=ge,e.$Pf=we,e.$Rf=Re,e.$Sf=fe,e.$Tf=Se,e.$Uf=Ae,e.$Vf=je,e.$Wf=q,e.$Xf=V,e.$Yf=Q,e.$Zf=Ve;function L(De){return!De||typeof De!="string"?!0:De.trim().length===0}const R=/{(\d+)}/g;function M(De,...Be){return Be.length===0?De:De.replace(R,function(He,Le){const Ze=parseInt(Le,10);return isNaN(Ze)||Ze<0||Ze>=Be.length?He:Be[Ze]})}const w=/{([^}]+)}/g;function b(De,Be){return Object.keys(Be).length===0?De:De.replace(w,(He,Le)=>Be[Le]??He)}function S(De){return De.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(De){return De.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function C(De){return De.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function $(De,Be){let He=0;const Le=Be.charCodeAt(0);for(let Ze=De.length-1;Ze>=0;Ze--)De.charCodeAt(Ze)===Le&&He++;return He}function k(De,Be,He="\u2026"){return De.length<=Be?De:`${De.substr(0,Be)}${He}`}function v(De,Be,He="\u2026"){if(De.length<=Be)return De;const Le=Math.ceil(Be/2)-He.length/2,Ze=Math.floor(Be/2)-He.length/2;return`${De.substr(0,Le)}${He}${De.substr(De.length-Ze)}`}function c(De,Be=" "){const He=g(De,Be);return o(He,Be)}function g(De,Be){if(!De||!Be)return De;const He=Be.length;if(He===0||De.length===0)return De;let Le=0;for(;De.indexOf(Be,Le)===Le;)Le=Le+He;return De.substring(Le)}function o(De,Be){if(!De||!Be)return De;const He=Be.length,Le=De.length;if(He===0||Le===0)return De;let Ze=Le,se=-1;for(;se=De.lastIndexOf(Be,Ze-1),!(se===-1||se+He!==Ze);){if(se===0)return"";Ze=se}return De.substring(0,Ze)}function n(De){return De.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(De){return De.replace(/\*/g,"")}function r(De,Be,He={}){if(!De)throw new Error("Cannot create regex from empty string");Be||(De=C(De)),He.wholeWord&&(/\B/.test(De.charAt(0))||(De="\\b"+De),/\B/.test(De.charAt(De.length-1))||(De=De+"\\b"));let Le="";return He.global&&(Le+="g"),He.matchCase||(Le+="i"),He.multiline&&(Le+="m"),He.unicode&&(Le+="u"),new RegExp(De,Le)}function s(De){return De.source==="^"||De.source==="^$"||De.source==="$"||De.source==="^\\s*$"?!1:!!(De.exec("")&&De.lastIndex===0)}function t(De){return De.split(/\r\n|\r|\n/)}function f(De){const Be=[],He=De.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(He.length/2);Le++)Be.push(He[2*Le]+(He[2*Le+1]??""));return Be}function d(De){for(let Be=0,He=De.length;Be<He;Be++){const Le=De.charCodeAt(Be);if(Le!==32&&Le!==9)return Be}return-1}function l(De,Be=0,He=De.length){for(let Le=Be;Le<He;Le++){const Ze=De.charCodeAt(Le);if(Ze!==32&&Ze!==9)return De.substring(Be,Le)}return De.substring(Be,He)}function a(De,Be=De.length-1){for(let He=Be;He>=0;He--){const Le=De.charCodeAt(He);if(Le!==32&&Le!==9)return He}return-1}function h(De,Be,He){const Le=[];let Ze=0;for(const se of De.matchAll(Be)){if(Le.push(De.slice(Ze,se.index)),se.index===void 0)throw new Error("match.index should be defined");Ze=se.index+se[0].length,Le.push(He(se[0],...se.slice(1),se.index,De,se.groups))}return Le.push(De.slice(Ze)),Promise.all(Le).then(se=>se.join(""))}function m(De,Be){return De<Be?-1:De>Be?1:0}function D(De,Be,He=0,Le=De.length,Ze=0,se=Be.length){for(;He<Le&&Ze<se;He++,Ze++){const Ge=De.charCodeAt(He),Me=Be.charCodeAt(Ze);if(Ge<Me)return-1;if(Ge>Me)return 1}const ue=Le-He,Ie=se-Ze;return ue<Ie?-1:ue>Ie?1:0}function p(De,Be){return E(De,Be,0,De.length,0,Be.length)}function E(De,Be,He=0,Le=De.length,Ze=0,se=Be.length){for(;He<Le&&Ze<se;He++,Ze++){let Ge=De.charCodeAt(He),Me=Be.charCodeAt(Ze);if(Ge===Me)continue;if(Ge>=128||Me>=128)return D(De.toLowerCase(),Be.toLowerCase(),He,Le,Ze,se);P(Ge)&&(Ge-=32),P(Me)&&(Me-=32);const nt=Ge-Me;if(nt!==0)return nt}const ue=Le-He,Ie=se-Ze;return ue<Ie?-1:ue>Ie?1:0}function y(De){return De>=48&&De<=57}function P(De){return De>=97&&De<=122}function I(De){return De>=65&&De<=90}function j(De,Be){return De.length===Be.length&&E(De,Be)===0}function F(De,Be){const He=Be.length;return Be.length>De.length?!1:E(De,Be,0,He)===0}function z(De,Be){const He=Math.min(De.length,Be.length);let Le;for(Le=0;Le<He;Le++)if(De.charCodeAt(Le)!==Be.charCodeAt(Le))return Le;return He}function O(De,Be){const He=Math.min(De.length,Be.length);let Le;const Ze=De.length-1,se=Be.length-1;for(Le=0;Le<He;Le++)if(De.charCodeAt(Ze-Le)!==Be.charCodeAt(se-Le))return Le;return He}function T(De){return 55296<=De&&De<=56319}function B(De){return 56320<=De&&De<=57343}function W(De,Be){return(De-55296<<10)+(Be-56320)+65536}function X(De,Be,He){const Le=De.charCodeAt(He);if(T(Le)&&He+1<Be){const Ze=De.charCodeAt(He+1);if(B(Ze))return W(Le,Ze)}return Le}function x(De,Be){const He=De.charCodeAt(Be-1);if(B(He)&&Be>1){const Le=De.charCodeAt(Be-2);if(T(Le))return W(Le,He)}return He}class Z{get offset(){return this.e}constructor(Be,He=0){this.c=Be,this.d=Be.length,this.e=He}setOffset(Be){this.e=Be}prevCodePoint(){const Be=x(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=X(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Bf=Z;class Y{get offset(){return this.c.offset}constructor(Be,He=0){this.c=new Z(Be,He)}nextGraphemeLength(){const Be=pe.getInstance(),He=this.c,Le=He.offset;let Ze=Be.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const se=He.offset,ue=Be.getGraphemeBreakType(He.nextCodePoint());if(J(Ze,ue)){He.setOffset(se);break}Ze=ue}return He.offset-Le}prevGraphemeLength(){const Be=pe.getInstance(),He=this.c,Le=He.offset;let Ze=Be.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const se=He.offset,ue=Be.getGraphemeBreakType(He.prevCodePoint());if(J(ue,Ze)){He.setOffset(se);break}Ze=ue}return Le-He.offset}eol(){return this.c.eol()}}e.$Cf=Y;function ce(De,Be){return new Y(De,Be).nextGraphemeLength()}function ne(De,Be){return new Y(De,Be).prevGraphemeLength()}function $e(De,Be){Be>0&&B(De.charCodeAt(Be))&&Be--;const He=Be+ce(De,Be);return[He-ne(De,He),He]}function Pe(De){const Be=new Y(De);let He=0;for(;!Be.eol();)He++,Be.nextGraphemeLength();return He}let _;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(De){return _||(_=U()),_.test(De)}const be=/^[\t\n\r\x20-\x7E]*$/;function Ce(De){return be.test(De)}e.$Jf=/[\u2028\u2029]/;function oe(De){return e.$Jf.test(De)}function ae(De){return De>=11904&&De<=55215||De>=63744&&De<=64255||De>=65281&&De<=65374}function re(De){return De>=127462&&De<=127487||De===8986||De===8987||De===9200||De===9203||De>=9728&&De<=10175||De===11088||De===11093||De>=127744&&De<=128591||De>=128640&&De<=128764||De>=128992&&De<=129008||De>=129280&&De<=129535||De>=129648&&De<=129782}function G(De,Be,He=""){const Le=De.trimStart();if(Le.length<Be)return Le;const Ze=/\b/g;let se=0;for(;Ze.test(Le)&&!(Le.length-Ze.lastIndex<Be);)se=Ze.lastIndex,Ze.lastIndex+=1;return se===0?Le:He+Le.substring(se).trimStart()}const te=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ge(De){let Be=0;for(const He of De.matchAll(te))Be!==He.index&&(yield{isCode:!1,str:De.substring(Be,He.index)}),yield{isCode:!0,str:He[0]},Be=He.index+He[0].length;Be!==De.length&&(yield{isCode:!1,str:De.substring(Be)})}function we(De){return De&&(De=De.replace(te,"")),De}e.$Qf="\uFEFF";function Re(De){return!!(De&&De.length>0&&De.charCodeAt(0)===65279)}function fe(De){return Re(De)?De.substr(1):De}function Se(De,Be){if(!De||!Be||De.length<Be.length)return!1;const He=Be.length,Le=De.toLowerCase();let Ze=0,se=-1;for(;Ze<He;){const ue=Le.indexOf(Be[Ze],se+1);if(ue<0)return!1;se=ue,Ze++}return!0}function Ae(De,Be=!1){return De?(Be&&(De=De.replace(/\\./g,"")),De.toLowerCase()!==De):!1}function je(De){return De.charAt(0).toUpperCase()+De.slice(1)}function q(De,Be=1){if(Be===0)return"";let He=-1;do He=De.indexOf(`
`,He+1),Be--;while(Be>0&&He>=0);return He===-1?De:(De[He-1]==="\r"&&He--,De.substr(0,He))}function V(De){return De=De%(2*26),De<26?String.fromCharCode(97+De):String.fromCharCode(65+De-26)}function Q(De){return pe.getInstance().getGraphemeBreakType(De)}function J(De,Be){return De===0?Be!==5&&Be!==7:De===2&&Be===3?!1:De===4||De===2||De===3||Be===4||Be===2||Be===3?!0:!(De===8&&(Be===8||Be===9||Be===11||Be===12)||(De===11||De===9)&&(Be===9||Be===10)||(De===12||De===10)&&Be===10||Be===5||Be===13||Be===7||De===1||De===13&&Be===14||De===6&&Be===6)}var he;(function(De){De[De.Other=0]="Other",De[De.Prepend=1]="Prepend",De[De.CR=2]="CR",De[De.LF=3]="LF",De[De.Control=4]="Control",De[De.Extend=5]="Extend",De[De.Regional_Indicator=6]="Regional_Indicator",De[De.SpacingMark=7]="SpacingMark",De[De.L=8]="L",De[De.V=9]="V",De[De.T=10]="T",De[De.LV=11]="LV",De[De.LVT=12]="LVT",De[De.ZWJ=13]="ZWJ",De[De.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class pe{static{this.c=null}static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const He=this.d,Le=He.length/3;let Ze=1;for(;Ze<=Le;)if(Be<He[3*Ze])Ze=2*Ze;else if(Be>He[3*Ze+1])Ze=2*Ze+1;else return He[3*Ze+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(De,Be){if(De===0)return 0;const He=Xe(De,Be);if(He!==void 0)return He;const Le=new Z(Be,De);return Le.prevCodePoint(),Le.offset}function Xe(De,Be){const He=new Z(Be,De);let Le=He.prevCodePoint();for(;tt(Le)||Le===65039||Le===8419;){if(He.offset===0)return;Le=He.prevCodePoint()}if(!re(Le))return;let Ze=He.offset;return Ze>0&&He.prevCodePoint()===8205&&(Ze=He.offset),Ze}function tt(De){return 127995<=De&&De<=127999}var ot;(function(De){De[De.zwj=8205]="zwj",De[De.emojiVariantSelector=65039]="emojiVariantSelector",De[De.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.$1f="\xA0";class it{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Ye(Be=>{function He(nt){const lt=new Map;for(let yt=0;yt<nt.length;yt+=2)lt.set(nt[yt],nt[yt+1]);return lt}function Le(nt,lt){const yt=new Map(nt);for(const[At,Ft]of lt)yt.set(At,Ft);return yt}function Ze(nt,lt){if(!nt)return lt;const yt=new Map;for(const[At,Ft]of nt)lt.has(At)&&yt.set(At,Ft);return yt}const se=this.c.value;let ue=Be.filter(nt=>!nt.startsWith("_")&&nt in se);ue.length===0&&(ue=["_default"]);let Ie;for(const nt of ue){const lt=He(se[nt]);Ie=Ze(Ie,lt)}const Ge=He(se._common),Me=Le(Ge,Ie);return new it(Me)})}static getInstance(Be){return it.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(it.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return it.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$2f=it;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Be){return st.e().has(Be)}static get codePoints(){return st.e()}}e.$3f=st}),define(ke[126],Ee([1,0,27,166,14]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=R,e.$tk=w,e.$uk=b,e.$vk=C,e.$wk=h,e.$xk=m,e.$yk=I,e.$zk=j,e.$Ak=F,e.$Bk=z,e.$Ck=ie,e.$Ek=ae,e.$Fk=te,e.$Gk=ge;function R(...fe){return function(Se,Ae){for(let je=0,q=fe.length;je<q;je++){const V=fe[je](Se,Ae);if(V)return V}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(fe,Se,Ae){if(!Ae||Ae.length<Se.length)return null;let je;return fe?je=L.$uf(Ae,Se):je=Ae.indexOf(Se)===0,je?Se.length>0?[{start:0,end:Se.length}]:[]:null}function w(fe,Se){const Ae=Se.toLowerCase().indexOf(fe.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+fe.length}]}function b(fe,Se){return S(fe.toLowerCase(),Se.toLowerCase(),0,0)}function S(fe,Se,Ae,je){if(Ae===fe.length)return[];if(je===Se.length)return null;if(fe[Ae]===Se[je]){let q=null;return(q=S(fe,Se,Ae+1,je+1))?r({start:je,end:je+1},q):null}return S(fe,Se,Ae,je+1)}function A(fe){return 97<=fe&&fe<=122}function C(fe){return 65<=fe&&fe<=90}function $(fe){return 48<=fe&&fe<=57}function k(fe){return fe===32||fe===9||fe===10||fe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>v.add(fe.charCodeAt(0)));function c(fe){return k(fe)||v.has(fe)}function g(fe,Se){return fe===Se||c(fe)&&c(Se)}const o=new Map;function n(fe){if(o.has(fe))return o.get(fe);let Se;const Ae=(0,N.$pk)(fe);return Ae&&(Se=Ae),o.set(fe,Se),Se}function i(fe){return A(fe)||C(fe)||$(fe)}function r(fe,Se){return Se.length===0?Se=[fe]:fe.end===Se[0].start?Se[0].start=fe.start:Se.unshift(fe),Se}function s(fe,Se){for(let Ae=Se;Ae<fe.length;Ae++){const je=fe.charCodeAt(Ae);if(C(je)||$(je)||Ae>0&&!i(fe.charCodeAt(Ae-1)))return Ae}return fe.length}function t(fe,Se,Ae,je){if(Ae===fe.length)return[];if(je===Se.length)return null;if(fe[Ae]!==Se[je].toLowerCase())return null;{let q=null,V=je+1;for(q=t(fe,Se,Ae+1,je+1);!q&&(V=s(Se,V))<Se.length;)q=t(fe,Se,Ae+1,V),V++;return q===null?null:r({start:je,end:je+1},q)}}function f(fe){let Se=0,Ae=0,je=0,q=0,V=0;for(let ze=0;ze<fe.length;ze++)V=fe.charCodeAt(ze),C(V)&&Se++,A(V)&&Ae++,i(V)&&je++,$(V)&&q++;const Q=Se/fe.length,J=Ae/fe.length,he=je/fe.length,pe=q/fe.length;return{upperPercent:Q,lowerPercent:J,alphaPercent:he,numericPercent:pe}}function d(fe){const{upperPercent:Se,lowerPercent:Ae}=fe;return Ae===0&&Se>.6}function l(fe){const{upperPercent:Se,lowerPercent:Ae,alphaPercent:je,numericPercent:q}=fe;return Ae>.2&&Se<.8&&je>.6&&q<.2}function a(fe){let Se=0,Ae=0,je=0,q=0;for(let V=0;V<fe.length;V++)je=fe.charCodeAt(V),C(je)&&Se++,A(je)&&Ae++,k(je)&&q++;return(Se===0||Ae===0)&&q===0?fe.length<=30:Se<=5}function h(fe,Se){if(!Se||(Se=Se.trim(),Se.length===0)||!a(fe))return null;Se.length>60&&(Se=Se.substring(0,60));const Ae=f(Se);if(!l(Ae)){if(!d(Ae))return null;Se=Se.toLowerCase()}let je=null,q=0;for(fe=fe.toLowerCase();q<Se.length&&(je=t(fe,Se,0,q))===null;)q=s(Se,q+1);return je}function m(fe,Se,Ae=!1){if(!Se||Se.length===0)return null;let je=null,q=0;for(fe=fe.toLowerCase(),Se=Se.toLowerCase();q<Se.length&&(je=D(fe,Se,0,q,Ae),je===null);)q=p(Se,q+1);return je}function D(fe,Se,Ae,je,q){let V=0;if(Ae===fe.length)return[];if(je===Se.length)return null;if(!g(fe.charCodeAt(Ae),Se.charCodeAt(je))){const he=n(fe.charCodeAt(Ae));if(!he)return null;for(let pe=0;pe<he.length;pe++)if(!g(he[pe],Se.charCodeAt(je+pe)))return null;V+=he.length-1}let Q=null,J=je+V+1;if(Q=D(fe,Se,Ae+1,J,q),!q)for(;!Q&&(J=p(Se,J))<Se.length;)Q=D(fe,Se,Ae+1,J,q),J++;if(!Q)return null;if(fe.charCodeAt(Ae)!==Se.charCodeAt(je)){const he=n(fe.charCodeAt(Ae));if(!he)return Q;for(let pe=0;pe<he.length;pe++)if(he[pe]!==Se.charCodeAt(je+pe))return Q}return r({start:je,end:je+V+1},Q)}function p(fe,Se){for(let Ae=Se;Ae<fe.length;Ae++)if(c(fe.charCodeAt(Ae))||Ae>0&&c(fe.charCodeAt(Ae-1)))return Ae;return fe.length}const E=R(e.$sk,h,w),y=R(e.$sk,h,b),P=new u.$Ec(1e4);function I(fe,Se,Ae=!1){if(typeof fe!="string"||typeof Se!="string")return null;let je=P.get(fe);je||(je=new RegExp(L.$cf(fe),"i"),P.set(fe,je));const q=je.exec(Se);return q?[{start:q.index,end:q.index+q[0].length}]:Ae?y(fe,Se):E(fe,Se)}function j(fe,Se){const Ae=ae(fe,fe.toLowerCase(),0,Se,Se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?z(Ae):null}function F(fe,Se,Ae,je,q,V){const Q=Math.min(13,fe.length);for(;Ae<Q;Ae++){const J=ae(fe,Se,Ae,je,q,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}function z(fe){if(typeof fe>"u")return[];const Se=[],Ae=fe[1];for(let je=fe.length-1;je>1;je--){const q=fe[je]+Ae,V=Se[Se.length-1];V&&V.end===q?V.end=q+1:Se.push({start:q,end:q+1})}return Se}const O=128;function T(){const fe=[],Se=[];for(let Ae=0;Ae<=O;Ae++)Se[Ae]=0;for(let Ae=0;Ae<=O;Ae++)fe.push(Se.slice(0));return fe}function B(fe){const Se=[];for(let Ae=0;Ae<=fe;Ae++)Se[Ae]=0;return Se}const W=B(2*O),X=B(2*O),x=T(),Z=T(),Y=T(),ce=!1;function ne(fe,Se,Ae,je,q){function V(J,he,pe=" "){for(;J.length<he;)J=pe+J;return J}let Q=` |   |${je.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=Ae;J++)J===0?Q+=" |":Q+=`${Se[J-1]}|`,Q+=fe[J].slice(0,q+1).map(he=>V(he.toString(),3)).join("|")+`
`;return Q}function $e(fe,Se,Ae,je){fe=fe.substr(Se),Ae=Ae.substr(je),console.log(ne(Z,fe,fe.length,Ae,Ae.length)),console.log(ne(Y,fe,fe.length,Ae,Ae.length)),console.log(ne(x,fe,fe.length,Ae,Ae.length))}function Pe(fe,Se){if(Se<0||Se>=fe.length)return!1;const Ae=fe.codePointAt(Se);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Mf(Ae)}}function _(fe,Se){if(Se<0||Se>=fe.length)return!1;switch(fe.charCodeAt(Se)){case 32:case 9:return!0;default:return!1}}function U(fe,Se,Ae){return Se[fe]!==Ae[fe]}function ie(fe,Se,Ae,je,q,V,Q=!1){for(;Se<Ae&&q<V;)fe[Se]===je[q]&&(Q&&(W[Se]=q),Se+=1),q+=1;return Se===Ae}var be;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(be||(be={}));var Ce;(function(fe){fe.Default=[-100,0];function Se(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}fe.isDefault=Se})(Ce||(e.FuzzyScore=Ce={}));class oe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Se,Ae){this.firstMatchCanBeWeak=Se,this.boostFullMatch=Ae}}e.$Dk=oe;function ae(fe,Se,Ae,je,q,V,Q=oe.default){const J=fe.length>O?O:fe.length,he=je.length>O?O:je.length;if(Ae>=J||V>=he||J-Ae>he-V||!ie(Se,Ae,J,q,V,he,!0))return;re(J,he,Ae,V,Se,q);let pe=1,ze=1,Ve=Ae,Xe=V;const tt=[!1];for(pe=1,Ve=Ae;Ve<J;pe++,Ve++){const Be=W[Ve],He=X[Ve],Le=Ve+1<J?X[Ve+1]:he;for(ze=Be-V+1,Xe=Be;Xe<Le;ze++,Xe++){let Ze=Number.MIN_SAFE_INTEGER,se=!1;Xe<=He&&(Ze=G(fe,Se,Ve,Ae,je,q,Xe,he,V,x[pe-1][ze-1]===0,tt));let ue=0;Ze!==Number.MAX_SAFE_INTEGER&&(se=!0,ue=Ze+Z[pe-1][ze-1]);const Ie=Xe>Be,Ge=Ie?Z[pe][ze-1]+(x[pe][ze-1]>0?-5:0):0,Me=Xe>Be+1&&x[pe][ze-1]>0,nt=Me?Z[pe][ze-2]+(x[pe][ze-2]>0?-5:0):0;if(Me&&(!Ie||nt>=Ge)&&(!se||nt>=ue))Z[pe][ze]=nt,Y[pe][ze]=3,x[pe][ze]=0;else if(Ie&&(!se||Ge>=ue))Z[pe][ze]=Ge,Y[pe][ze]=2,x[pe][ze]=0;else if(se)Z[pe][ze]=ue,Y[pe][ze]=1,x[pe][ze]=x[pe-1][ze-1]+1;else throw new Error("not possible")}}if(ce&&$e(fe,Ae,je,V),!tt[0]&&!Q.firstMatchCanBeWeak)return;pe--,ze--;const ot=[Z[pe][ze],V];let it=0,st=0;for(;pe>=1;){let Be=ze;do{const He=Y[pe][Be];if(He===3)Be=Be-2;else if(He===2)Be=Be-1;else break}while(Be>=1);it>1&&Se[Ae+pe-1]===q[V+ze-1]&&!U(Be+V-1,je,q)&&it+1>x[pe][Be]&&(Be=ze),Be===ze?it++:it=1,st||(st=Be),pe--,ze=Be-1,ot.push(ze)}he===J&&Q.boostFullMatch&&(ot[0]+=2);const De=st-J;return ot[0]-=De,ot}function re(fe,Se,Ae,je,q,V){let Q=fe-1,J=Se-1;for(;Q>=Ae&&J>=je;)q[Q]===V[J]&&(X[Q]=J,Q--),J--}function G(fe,Se,Ae,je,q,V,Q,J,he,pe,ze){if(Se[Ae]!==V[Q])return Number.MIN_SAFE_INTEGER;let Ve=1,Xe=!1;return Q===Ae-je?Ve=fe[Ae]===q[Q]?7:5:U(Q,q,V)&&(Q===0||!U(Q-1,q,V))?(Ve=fe[Ae]===q[Q]?7:5,Xe=!0):Pe(V,Q)&&(Q===0||!Pe(V,Q-1))?Ve=5:(Pe(V,Q-1)||_(V,Q-1))&&(Ve=5,Xe=!0),Ve>1&&Ae===je&&(ze[0]=!0),Xe||(Xe=U(Q,q,V)||Pe(V,Q-1)||_(V,Q-1)),Ae===je?Q>he&&(Ve-=Xe?3:5):pe?Ve+=Xe?2:0:Ve+=Xe?0:1,Q+1===J&&(Ve-=Xe?3:5),Ve}function te(fe,Se,Ae,je,q,V,Q){return we(fe,Se,Ae,je,q,V,!0,Q)}function ge(fe,Se,Ae,je,q,V,Q){return we(fe,Se,Ae,je,q,V,!1,Q)}function we(fe,Se,Ae,je,q,V,Q,J){let he=ae(fe,Se,Ae,je,q,V,J);if(he&&!Q)return he;if(fe.length>=3){const pe=Math.min(7,fe.length-1);for(let ze=Ae+1;ze<pe;ze++){const Ve=Re(fe,ze);if(Ve){const Xe=ae(Ve,Ve.toLowerCase(),Ae,je,q,V,J);Xe&&(Xe[0]-=3,(!he||Xe[0]>he[0])&&(he=Xe))}}}return he}function Re(fe,Se){if(Se+1>=fe.length)return;const Ae=fe[Se],je=fe[Se+1];if(Ae!==je)return fe.slice(0,Se)+je+Ae+fe.slice(Se+2)}}),define(ke[56],Ee([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$ij=void 0,e.$ej=N,e.$fj=L,e.$gj=R,e.$hj=w,e.$jj=c;function N(o){return L(o,0)}function L(o,n){switch(typeof o){case"object":return o===null?R(349,n):Array.isArray(o)?b(o,n):S(o,n);case"string":return w(o,n);case"boolean":return M(o,n);case"number":return R(o,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(o,n){return(n<<5)-n+o|0}function M(o,n){return R(o?433:863,n)}function w(o,n){n=R(149417,n);for(let i=0,r=o.length;i<r;i++)n=R(o.charCodeAt(i),n);return n}function b(o,n){return n=R(104579,n),o.reduce((i,r)=>L(r,i),n)}function S(o,n){return n=R(181387,n),Object.keys(o).sort().reduce((i,r)=>(i=w(r,i),L(o[r],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$ij=A;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function $(o,n,i=32){const r=i-n,s=~((1<<r)-1);return(o<<n|(s&o)>>>r)>>>0}function k(o,n=0,i=o.byteLength,r=0){for(let s=0;s<i;s++)o[n+s]=r}function v(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function c(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((o>>>0).toString(16),n/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let s=this.r,t=this.u,f,d;for(t!==0?(f=t,d=-1,t=0):(f=n.charCodeAt(0),d=0);;){let l=f;if(u.$xf(f))if(d+1<i){const a=n.charCodeAt(d+1);u.$yf(a)?(d++,l=u.$zf(f,a)):l=65533}else{t=f;break}else u.$yf(f)&&(l=65533);if(s=this.w(r,s,l),d++,d<i)f=n.charCodeAt(d);else break}this.r=s,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=g.g,i=this.q;for(let m=0;m<64;m+=4)n.setUint32(m,i.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)n.setUint32(m,$(n.getUint32(m-12,!1)^n.getUint32(m-32,!1)^n.getUint32(m-56,!1)^n.getUint32(m-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,f=this.n,d=this.o,l,a,h;for(let m=0;m<80;m++)m<20?(l=s&t|~s&f,a=1518500249):m<40?(l=s^t^f,a=1859775393):m<60?(l=s&t|s&f|t&f,a=2400959708):(l=s^t^f,a=3395469782),h=$(r,5)+l+d+a+n.getUint32(m*4,!1)&4294967295,d=f,f=t,t=$(s,30),s=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+d&4294967295}}e.$kj=g}),define(ke[40],Ee([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const R="error",M="warning",w="warn",b="info",S="ignore";function A($){return $?u.$tf(R,$)?L.Error:u.$tf(M,$)||u.$tf(w,$)?L.Warning:u.$tf(b,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function C($){switch($){case L.Error:return R;case L.Warning:return M;case L.Info:return b;default:return S}}L.toString=C}(N||(N={})),e.default=N}),define(ke[169],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class L{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const v=k.charCodeAt(0),c=this.b.charCodeAt(this.c);return v-c}value(){return this.b[this.c]}}e.$si=L;class R{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,N.$nf)(k,this.b,0,k.length,this.c,this.d):(0,N.$pf)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=R;class M{constructor(k=!0,v=!0){this.f=k,this.g=v}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let v=k.length-1;v>=0;v--,this.c--){const c=this.b.charCodeAt(v);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,N.$nf)(k,this.b,0,k.length,this.d,this.e):(0,N.$pf)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var w;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(w||(w={}));class b{constructor(k,v){this.f=k,this.g=v,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,N.$of)(k,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,N.$mf)(k,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=b;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class C{static forUris(k=()=>!1,v=()=>!1){return new C(new b(k,v))}static forPaths(k=!1){return new C(new M(void 0,!k))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new R)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,v){if(v){const c=v.slice(0);(0,u.$Xb)(c);for(const g of c)this.set(g,k)}else{const c=k.slice(0);(0,u.$Xb)(c);for(const g of c)this.set(g[0],g[1])}}set(k,v){const c=this.b.reset(k);let g;this.c||(this.c=new S,this.c.segment=c.value());const o=[];for(g=this.c;;){const i=c.cmp(g.segment);if(i>0)g.left||(g.left=new S,g.left.segment=c.value()),o.push([-1,g]),g=g.left;else if(i<0)g.right||(g.right=new S,g.right.segment=c.value()),o.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new S,g.mid.segment=c.value()),o.push([0,g]),g=g.mid;else break}const n=g.value;g.value=v,g.key=k;for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=o[i][0],f=o[i+1][0];if(t===1&&f===1)o[i][1]=r.rotateLeft();else if(t===-1&&f===-1)o[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(k){return this.d(k)?.value}d(k){const v=this.b.reset(k);let c=this.c;for(;c;){const g=v.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(v.hasNext())v.next(),c=c.mid;else break}return c}has(k){const v=this.d(k);return!(v?.value===void 0&&v?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,v){const c=this.b.reset(k),g=[];let o=this.c;for(;o;){const n=c.cmp(o.segment);if(n>0)g.push([-1,o]),o=o.left;else if(n<0)g.push([1,o]),o=o.right;else if(c.hasNext())c.next(),g.push([0,o]),o=o.mid;else break}if(o){if(v?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:r,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=r,o.segment=s}}else{const n=o.left??o.right;if(g.length>0){const[i,r]=g[g.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=g.length-1;n>=0;n--){const i=g[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),g[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),g[n][1]=i.rotateRight()),n>0)switch(g[n-1][0]){case-1:g[n-1][1].left=g[n][1];break;case 1:g[n-1][1].right=g[n][1];break;case 0:g[n-1][1].mid=g[n][1];break}else this.c=g[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const v=this.b.reset(k);let c=this.c,g;for(;c;){const o=v.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(v.hasNext())v.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(k){return this.g(k,!1)}g(k,v){const c=this.b.reset(k);let g=this.c;for(;g;){const o=c.cmp(g.segment);if(o>0)g=g.left;else if(o<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):v?g.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[v,c]of this)k(c,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const v=[];return this.j(k,v),v[Symbol.iterator]()}j(k,v){k&&(k.left&&this.j(k.left,v),k.value&&v.push([k.key,k.value]),k.mid&&this.j(k.mid,v),k.right&&this.j(k.right,v))}_isBalanced(){const k=v=>{if(!v)return!0;const c=v.balanceFactor();return c<-1||c>1?!1:k(v.left)&&k(v.right)};return k(this.c)}}e.$wi=C}),define(ke[18],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=u,e.$5f=N,e.$6f=L,e.$7f=R,e.$8f=M,e.$9f=w,e.$0f=b,e.$$f=S,e.$_f=A,e.$ag=C,e.$bg=$,e.$cg=k,e.$dg=v,e.$eg=g,e.$fg=o,e.$gg=n,e.$hg=i,e.$ig=r;function u(s){return typeof s=="string"}function N(s){return Array.isArray(s)&&s.every(t=>u(t))}function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function R(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function M(s){return typeof s=="number"&&!isNaN(s)}function w(s){return!!s&&typeof s[Symbol.iterator]=="function"}function b(s){return s===!0||s===!1}function S(s){return typeof s>"u"}function A(s){return!C(s)}function C(s){return S(s)||s===null}function $(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function k(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let f=0;f<s.length;f++){const d=s[f];if(C(d))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(d)}return t}const c=Object.prototype.hasOwnProperty;function g(s){if(!L(s))return!1;for(const t in s)if(c.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const f=Math.min(s.length,t.length);for(let d=0;d<f;d++)r(s[d],t[d])}function r(s,t){if(u(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!C(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=L,e.$Lj=R;const N=Object.create(null);function L(M,w){if((0,u.$4f)(w)){const b=N[w];if(b===void 0)throw new Error(`${M} references an unknown codicon: ${w}`);w=b}return N[M]=w,{id:M}}function R(){return N}}),define(ke[170],Ee([1,0,99]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=void 0,e.$Mj={add:(0,u.$Kj)("add",6e4),plus:(0,u.$Kj)("plus",6e4),gistNew:(0,u.$Kj)("gist-new",6e4),repoCreate:(0,u.$Kj)("repo-create",6e4),lightbulb:(0,u.$Kj)("lightbulb",60001),lightBulb:(0,u.$Kj)("light-bulb",60001),repo:(0,u.$Kj)("repo",60002),repoDelete:(0,u.$Kj)("repo-delete",60002),gistFork:(0,u.$Kj)("gist-fork",60003),repoForked:(0,u.$Kj)("repo-forked",60003),gitPullRequest:(0,u.$Kj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Kj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Kj)("record-keys",60005),keyboard:(0,u.$Kj)("keyboard",60005),tag:(0,u.$Kj)("tag",60006),gitPullRequestLabel:(0,u.$Kj)("git-pull-request-label",60006),tagAdd:(0,u.$Kj)("tag-add",60006),tagRemove:(0,u.$Kj)("tag-remove",60006),person:(0,u.$Kj)("person",60007),personFollow:(0,u.$Kj)("person-follow",60007),personOutline:(0,u.$Kj)("person-outline",60007),personFilled:(0,u.$Kj)("person-filled",60007),gitBranch:(0,u.$Kj)("git-branch",60008),gitBranchCreate:(0,u.$Kj)("git-branch-create",60008),gitBranchDelete:(0,u.$Kj)("git-branch-delete",60008),sourceControl:(0,u.$Kj)("source-control",60008),mirror:(0,u.$Kj)("mirror",60009),mirrorPublic:(0,u.$Kj)("mirror-public",60009),star:(0,u.$Kj)("star",60010),starAdd:(0,u.$Kj)("star-add",60010),starDelete:(0,u.$Kj)("star-delete",60010),starEmpty:(0,u.$Kj)("star-empty",60010),comment:(0,u.$Kj)("comment",60011),commentAdd:(0,u.$Kj)("comment-add",60011),alert:(0,u.$Kj)("alert",60012),warning:(0,u.$Kj)("warning",60012),search:(0,u.$Kj)("search",60013),searchSave:(0,u.$Kj)("search-save",60013),logOut:(0,u.$Kj)("log-out",60014),signOut:(0,u.$Kj)("sign-out",60014),logIn:(0,u.$Kj)("log-in",60015),signIn:(0,u.$Kj)("sign-in",60015),eye:(0,u.$Kj)("eye",60016),eyeUnwatch:(0,u.$Kj)("eye-unwatch",60016),eyeWatch:(0,u.$Kj)("eye-watch",60016),circleFilled:(0,u.$Kj)("circle-filled",60017),primitiveDot:(0,u.$Kj)("primitive-dot",60017),closeDirty:(0,u.$Kj)("close-dirty",60017),debugBreakpoint:(0,u.$Kj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Kj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Kj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Kj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Kj)("primitive-square",60018),edit:(0,u.$Kj)("edit",60019),pencil:(0,u.$Kj)("pencil",60019),info:(0,u.$Kj)("info",60020),issueOpened:(0,u.$Kj)("issue-opened",60020),gistPrivate:(0,u.$Kj)("gist-private",60021),gitForkPrivate:(0,u.$Kj)("git-fork-private",60021),lock:(0,u.$Kj)("lock",60021),mirrorPrivate:(0,u.$Kj)("mirror-private",60021),close:(0,u.$Kj)("close",60022),removeClose:(0,u.$Kj)("remove-close",60022),x:(0,u.$Kj)("x",60022),repoSync:(0,u.$Kj)("repo-sync",60023),sync:(0,u.$Kj)("sync",60023),clone:(0,u.$Kj)("clone",60024),desktopDownload:(0,u.$Kj)("desktop-download",60024),beaker:(0,u.$Kj)("beaker",60025),microscope:(0,u.$Kj)("microscope",60025),vm:(0,u.$Kj)("vm",60026),deviceDesktop:(0,u.$Kj)("device-desktop",60026),file:(0,u.$Kj)("file",60027),fileText:(0,u.$Kj)("file-text",60027),more:(0,u.$Kj)("more",60028),ellipsis:(0,u.$Kj)("ellipsis",60028),kebabHorizontal:(0,u.$Kj)("kebab-horizontal",60028),mailReply:(0,u.$Kj)("mail-reply",60029),reply:(0,u.$Kj)("reply",60029),organization:(0,u.$Kj)("organization",60030),organizationFilled:(0,u.$Kj)("organization-filled",60030),organizationOutline:(0,u.$Kj)("organization-outline",60030),newFile:(0,u.$Kj)("new-file",60031),fileAdd:(0,u.$Kj)("file-add",60031),newFolder:(0,u.$Kj)("new-folder",60032),fileDirectoryCreate:(0,u.$Kj)("file-directory-create",60032),trash:(0,u.$Kj)("trash",60033),trashcan:(0,u.$Kj)("trashcan",60033),history:(0,u.$Kj)("history",60034),clock:(0,u.$Kj)("clock",60034),folder:(0,u.$Kj)("folder",60035),fileDirectory:(0,u.$Kj)("file-directory",60035),symbolFolder:(0,u.$Kj)("symbol-folder",60035),logoGithub:(0,u.$Kj)("logo-github",60036),markGithub:(0,u.$Kj)("mark-github",60036),github:(0,u.$Kj)("github",60036),terminal:(0,u.$Kj)("terminal",60037),console:(0,u.$Kj)("console",60037),repl:(0,u.$Kj)("repl",60037),zap:(0,u.$Kj)("zap",60038),symbolEvent:(0,u.$Kj)("symbol-event",60038),error:(0,u.$Kj)("error",60039),stop:(0,u.$Kj)("stop",60039),variable:(0,u.$Kj)("variable",60040),symbolVariable:(0,u.$Kj)("symbol-variable",60040),array:(0,u.$Kj)("array",60042),symbolArray:(0,u.$Kj)("symbol-array",60042),symbolModule:(0,u.$Kj)("symbol-module",60043),symbolPackage:(0,u.$Kj)("symbol-package",60043),symbolNamespace:(0,u.$Kj)("symbol-namespace",60043),symbolObject:(0,u.$Kj)("symbol-object",60043),symbolMethod:(0,u.$Kj)("symbol-method",60044),symbolFunction:(0,u.$Kj)("symbol-function",60044),symbolConstructor:(0,u.$Kj)("symbol-constructor",60044),symbolBoolean:(0,u.$Kj)("symbol-boolean",60047),symbolNull:(0,u.$Kj)("symbol-null",60047),symbolNumeric:(0,u.$Kj)("symbol-numeric",60048),symbolNumber:(0,u.$Kj)("symbol-number",60048),symbolStructure:(0,u.$Kj)("symbol-structure",60049),symbolStruct:(0,u.$Kj)("symbol-struct",60049),symbolParameter:(0,u.$Kj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Kj)("symbol-type-parameter",60050),symbolKey:(0,u.$Kj)("symbol-key",60051),symbolText:(0,u.$Kj)("symbol-text",60051),symbolReference:(0,u.$Kj)("symbol-reference",60052),goToFile:(0,u.$Kj)("go-to-file",60052),symbolEnum:(0,u.$Kj)("symbol-enum",60053),symbolValue:(0,u.$Kj)("symbol-value",60053),symbolRuler:(0,u.$Kj)("symbol-ruler",60054),symbolUnit:(0,u.$Kj)("symbol-unit",60054),activateBreakpoints:(0,u.$Kj)("activate-breakpoints",60055),archive:(0,u.$Kj)("archive",60056),arrowBoth:(0,u.$Kj)("arrow-both",60057),arrowDown:(0,u.$Kj)("arrow-down",60058),arrowLeft:(0,u.$Kj)("arrow-left",60059),arrowRight:(0,u.$Kj)("arrow-right",60060),arrowSmallDown:(0,u.$Kj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Kj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Kj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Kj)("arrow-small-up",60064),arrowUp:(0,u.$Kj)("arrow-up",60065),bell:(0,u.$Kj)("bell",60066),bold:(0,u.$Kj)("bold",60067),book:(0,u.$Kj)("book",60068),bookmark:(0,u.$Kj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Kj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Kj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Kj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Kj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Kj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Kj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Kj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Kj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Kj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Kj)("briefcase",60076),broadcast:(0,u.$Kj)("broadcast",60077),browser:(0,u.$Kj)("browser",60078),bug:(0,u.$Kj)("bug",60079),calendar:(0,u.$Kj)("calendar",60080),caseSensitive:(0,u.$Kj)("case-sensitive",60081),check:(0,u.$Kj)("check",60082),checklist:(0,u.$Kj)("checklist",60083),chevronDown:(0,u.$Kj)("chevron-down",60084),chevronLeft:(0,u.$Kj)("chevron-left",60085),chevronRight:(0,u.$Kj)("chevron-right",60086),chevronUp:(0,u.$Kj)("chevron-up",60087),chromeClose:(0,u.$Kj)("chrome-close",60088),chromeMaximize:(0,u.$Kj)("chrome-maximize",60089),chromeMinimize:(0,u.$Kj)("chrome-minimize",60090),chromeRestore:(0,u.$Kj)("chrome-restore",60091),circleOutline:(0,u.$Kj)("circle-outline",60092),circle:(0,u.$Kj)("circle",60092),debugBreakpointUnverified:(0,u.$Kj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Kj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Kj)("circle-slash",60093),circuitBoard:(0,u.$Kj)("circuit-board",60094),clearAll:(0,u.$Kj)("clear-all",60095),clippy:(0,u.$Kj)("clippy",60096),closeAll:(0,u.$Kj)("close-all",60097),cloudDownload:(0,u.$Kj)("cloud-download",60098),cloudUpload:(0,u.$Kj)("cloud-upload",60099),code:(0,u.$Kj)("code",60100),collapseAll:(0,u.$Kj)("collapse-all",60101),colorMode:(0,u.$Kj)("color-mode",60102),commentDiscussion:(0,u.$Kj)("comment-discussion",60103),creditCard:(0,u.$Kj)("credit-card",60105),dash:(0,u.$Kj)("dash",60108),dashboard:(0,u.$Kj)("dashboard",60109),database:(0,u.$Kj)("database",60110),debugContinue:(0,u.$Kj)("debug-continue",60111),debugDisconnect:(0,u.$Kj)("debug-disconnect",60112),debugPause:(0,u.$Kj)("debug-pause",60113),debugRestart:(0,u.$Kj)("debug-restart",60114),debugStart:(0,u.$Kj)("debug-start",60115),debugStepInto:(0,u.$Kj)("debug-step-into",60116),debugStepOut:(0,u.$Kj)("debug-step-out",60117),debugStepOver:(0,u.$Kj)("debug-step-over",60118),debugStop:(0,u.$Kj)("debug-stop",60119),debug:(0,u.$Kj)("debug",60120),deviceCameraVideo:(0,u.$Kj)("device-camera-video",60121),deviceCamera:(0,u.$Kj)("device-camera",60122),deviceMobile:(0,u.$Kj)("device-mobile",60123),diffAdded:(0,u.$Kj)("diff-added",60124),diffIgnored:(0,u.$Kj)("diff-ignored",60125),diffModified:(0,u.$Kj)("diff-modified",60126),diffRemoved:(0,u.$Kj)("diff-removed",60127),diffRenamed:(0,u.$Kj)("diff-renamed",60128),diff:(0,u.$Kj)("diff",60129),diffSidebyside:(0,u.$Kj)("diff-sidebyside",60129),discard:(0,u.$Kj)("discard",60130),editorLayout:(0,u.$Kj)("editor-layout",60131),emptyWindow:(0,u.$Kj)("empty-window",60132),exclude:(0,u.$Kj)("exclude",60133),extensions:(0,u.$Kj)("extensions",60134),eyeClosed:(0,u.$Kj)("eye-closed",60135),fileBinary:(0,u.$Kj)("file-binary",60136),fileCode:(0,u.$Kj)("file-code",60137),fileMedia:(0,u.$Kj)("file-media",60138),filePdf:(0,u.$Kj)("file-pdf",60139),fileSubmodule:(0,u.$Kj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Kj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Kj)("file-symlink-file",60142),fileZip:(0,u.$Kj)("file-zip",60143),files:(0,u.$Kj)("files",60144),filter:(0,u.$Kj)("filter",60145),flame:(0,u.$Kj)("flame",60146),foldDown:(0,u.$Kj)("fold-down",60147),foldUp:(0,u.$Kj)("fold-up",60148),fold:(0,u.$Kj)("fold",60149),folderActive:(0,u.$Kj)("folder-active",60150),folderOpened:(0,u.$Kj)("folder-opened",60151),gear:(0,u.$Kj)("gear",60152),gift:(0,u.$Kj)("gift",60153),gistSecret:(0,u.$Kj)("gist-secret",60154),gist:(0,u.$Kj)("gist",60155),gitCommit:(0,u.$Kj)("git-commit",60156),gitCompare:(0,u.$Kj)("git-compare",60157),compareChanges:(0,u.$Kj)("compare-changes",60157),gitMerge:(0,u.$Kj)("git-merge",60158),githubAction:(0,u.$Kj)("github-action",60159),githubAlt:(0,u.$Kj)("github-alt",60160),globe:(0,u.$Kj)("globe",60161),grabber:(0,u.$Kj)("grabber",60162),graph:(0,u.$Kj)("graph",60163),gripper:(0,u.$Kj)("gripper",60164),heart:(0,u.$Kj)("heart",60165),home:(0,u.$Kj)("home",60166),horizontalRule:(0,u.$Kj)("horizontal-rule",60167),hubot:(0,u.$Kj)("hubot",60168),inbox:(0,u.$Kj)("inbox",60169),issueReopened:(0,u.$Kj)("issue-reopened",60171),issues:(0,u.$Kj)("issues",60172),italic:(0,u.$Kj)("italic",60173),jersey:(0,u.$Kj)("jersey",60174),json:(0,u.$Kj)("json",60175),kebabVertical:(0,u.$Kj)("kebab-vertical",60176),key:(0,u.$Kj)("key",60177),law:(0,u.$Kj)("law",60178),lightbulbAutofix:(0,u.$Kj)("lightbulb-autofix",60179),linkExternal:(0,u.$Kj)("link-external",60180),link:(0,u.$Kj)("link",60181),listOrdered:(0,u.$Kj)("list-ordered",60182),listUnordered:(0,u.$Kj)("list-unordered",60183),liveShare:(0,u.$Kj)("live-share",60184),loading:(0,u.$Kj)("loading",60185),location:(0,u.$Kj)("location",60186),mailRead:(0,u.$Kj)("mail-read",60187),mail:(0,u.$Kj)("mail",60188),markdown:(0,u.$Kj)("markdown",60189),megaphone:(0,u.$Kj)("megaphone",60190),mention:(0,u.$Kj)("mention",60191),milestone:(0,u.$Kj)("milestone",60192),gitPullRequestMilestone:(0,u.$Kj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Kj)("mortar-board",60193),move:(0,u.$Kj)("move",60194),multipleWindows:(0,u.$Kj)("multiple-windows",60195),mute:(0,u.$Kj)("mute",60196),noNewline:(0,u.$Kj)("no-newline",60197),note:(0,u.$Kj)("note",60198),octoface:(0,u.$Kj)("octoface",60199),openPreview:(0,u.$Kj)("open-preview",60200),package:(0,u.$Kj)("package",60201),paintcan:(0,u.$Kj)("paintcan",60202),pin:(0,u.$Kj)("pin",60203),play:(0,u.$Kj)("play",60204),run:(0,u.$Kj)("run",60204),plug:(0,u.$Kj)("plug",60205),preserveCase:(0,u.$Kj)("preserve-case",60206),preview:(0,u.$Kj)("preview",60207),project:(0,u.$Kj)("project",60208),pulse:(0,u.$Kj)("pulse",60209),question:(0,u.$Kj)("question",60210),quote:(0,u.$Kj)("quote",60211),radioTower:(0,u.$Kj)("radio-tower",60212),reactions:(0,u.$Kj)("reactions",60213),references:(0,u.$Kj)("references",60214),refresh:(0,u.$Kj)("refresh",60215),regex:(0,u.$Kj)("regex",60216),remoteExplorer:(0,u.$Kj)("remote-explorer",60217),remote:(0,u.$Kj)("remote",60218),remove:(0,u.$Kj)("remove",60219),replaceAll:(0,u.$Kj)("replace-all",60220),replace:(0,u.$Kj)("replace",60221),repoClone:(0,u.$Kj)("repo-clone",60222),repoForcePush:(0,u.$Kj)("repo-force-push",60223),repoPull:(0,u.$Kj)("repo-pull",60224),repoPush:(0,u.$Kj)("repo-push",60225),report:(0,u.$Kj)("report",60226),requestChanges:(0,u.$Kj)("request-changes",60227),rocket:(0,u.$Kj)("rocket",60228),rootFolderOpened:(0,u.$Kj)("root-folder-opened",60229),rootFolder:(0,u.$Kj)("root-folder",60230),rss:(0,u.$Kj)("rss",60231),ruby:(0,u.$Kj)("ruby",60232),saveAll:(0,u.$Kj)("save-all",60233),saveAs:(0,u.$Kj)("save-as",60234),save:(0,u.$Kj)("save",60235),screenFull:(0,u.$Kj)("screen-full",60236),screenNormal:(0,u.$Kj)("screen-normal",60237),searchStop:(0,u.$Kj)("search-stop",60238),server:(0,u.$Kj)("server",60240),settingsGear:(0,u.$Kj)("settings-gear",60241),settings:(0,u.$Kj)("settings",60242),shield:(0,u.$Kj)("shield",60243),smiley:(0,u.$Kj)("smiley",60244),sortPrecedence:(0,u.$Kj)("sort-precedence",60245),splitHorizontal:(0,u.$Kj)("split-horizontal",60246),splitVertical:(0,u.$Kj)("split-vertical",60247),squirrel:(0,u.$Kj)("squirrel",60248),starFull:(0,u.$Kj)("star-full",60249),starHalf:(0,u.$Kj)("star-half",60250),symbolClass:(0,u.$Kj)("symbol-class",60251),symbolColor:(0,u.$Kj)("symbol-color",60252),symbolConstant:(0,u.$Kj)("symbol-constant",60253),symbolEnumMember:(0,u.$Kj)("symbol-enum-member",60254),symbolField:(0,u.$Kj)("symbol-field",60255),symbolFile:(0,u.$Kj)("symbol-file",60256),symbolInterface:(0,u.$Kj)("symbol-interface",60257),symbolKeyword:(0,u.$Kj)("symbol-keyword",60258),symbolMisc:(0,u.$Kj)("symbol-misc",60259),symbolOperator:(0,u.$Kj)("symbol-operator",60260),symbolProperty:(0,u.$Kj)("symbol-property",60261),wrench:(0,u.$Kj)("wrench",60261),wrenchSubaction:(0,u.$Kj)("wrench-subaction",60261),symbolSnippet:(0,u.$Kj)("symbol-snippet",60262),tasklist:(0,u.$Kj)("tasklist",60263),telescope:(0,u.$Kj)("telescope",60264),textSize:(0,u.$Kj)("text-size",60265),threeBars:(0,u.$Kj)("three-bars",60266),thumbsdown:(0,u.$Kj)("thumbsdown",60267),thumbsup:(0,u.$Kj)("thumbsup",60268),tools:(0,u.$Kj)("tools",60269),triangleDown:(0,u.$Kj)("triangle-down",60270),triangleLeft:(0,u.$Kj)("triangle-left",60271),triangleRight:(0,u.$Kj)("triangle-right",60272),triangleUp:(0,u.$Kj)("triangle-up",60273),twitter:(0,u.$Kj)("twitter",60274),unfold:(0,u.$Kj)("unfold",60275),unlock:(0,u.$Kj)("unlock",60276),unmute:(0,u.$Kj)("unmute",60277),unverified:(0,u.$Kj)("unverified",60278),verified:(0,u.$Kj)("verified",60279),versions:(0,u.$Kj)("versions",60280),vmActive:(0,u.$Kj)("vm-active",60281),vmOutline:(0,u.$Kj)("vm-outline",60282),vmRunning:(0,u.$Kj)("vm-running",60283),watch:(0,u.$Kj)("watch",60284),whitespace:(0,u.$Kj)("whitespace",60285),wholeWord:(0,u.$Kj)("whole-word",60286),window:(0,u.$Kj)("window",60287),wordWrap:(0,u.$Kj)("word-wrap",60288),zoomIn:(0,u.$Kj)("zoom-in",60289),zoomOut:(0,u.$Kj)("zoom-out",60290),listFilter:(0,u.$Kj)("list-filter",60291),listFlat:(0,u.$Kj)("list-flat",60292),listSelection:(0,u.$Kj)("list-selection",60293),selection:(0,u.$Kj)("selection",60293),listTree:(0,u.$Kj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Kj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Kj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Kj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Kj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Kj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Kj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Kj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Kj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Kj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Kj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Kj)("symbol-string",60301),debugReverseContinue:(0,u.$Kj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Kj)("debug-step-back",60303),debugRestartFrame:(0,u.$Kj)("debug-restart-frame",60304),debugAlt:(0,u.$Kj)("debug-alt",60305),callIncoming:(0,u.$Kj)("call-incoming",60306),callOutgoing:(0,u.$Kj)("call-outgoing",60307),menu:(0,u.$Kj)("menu",60308),expandAll:(0,u.$Kj)("expand-all",60309),feedback:(0,u.$Kj)("feedback",60310),gitPullRequestReviewer:(0,u.$Kj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Kj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Kj)("ungroup-by-ref-type",60312),account:(0,u.$Kj)("account",60313),gitPullRequestAssignee:(0,u.$Kj)("git-pull-request-assignee",60313),bellDot:(0,u.$Kj)("bell-dot",60314),debugConsole:(0,u.$Kj)("debug-console",60315),library:(0,u.$Kj)("library",60316),output:(0,u.$Kj)("output",60317),runAll:(0,u.$Kj)("run-all",60318),syncIgnored:(0,u.$Kj)("sync-ignored",60319),pinned:(0,u.$Kj)("pinned",60320),githubInverted:(0,u.$Kj)("github-inverted",60321),serverProcess:(0,u.$Kj)("server-process",60322),serverEnvironment:(0,u.$Kj)("server-environment",60323),pass:(0,u.$Kj)("pass",60324),issueClosed:(0,u.$Kj)("issue-closed",60324),stopCircle:(0,u.$Kj)("stop-circle",60325),playCircle:(0,u.$Kj)("play-circle",60326),record:(0,u.$Kj)("record",60327),debugAltSmall:(0,u.$Kj)("debug-alt-small",60328),vmConnect:(0,u.$Kj)("vm-connect",60329),cloud:(0,u.$Kj)("cloud",60330),merge:(0,u.$Kj)("merge",60331),export:(0,u.$Kj)("export",60332),graphLeft:(0,u.$Kj)("graph-left",60333),magnet:(0,u.$Kj)("magnet",60334),notebook:(0,u.$Kj)("notebook",60335),redo:(0,u.$Kj)("redo",60336),checkAll:(0,u.$Kj)("check-all",60337),pinnedDirty:(0,u.$Kj)("pinned-dirty",60338),passFilled:(0,u.$Kj)("pass-filled",60339),circleLargeFilled:(0,u.$Kj)("circle-large-filled",60340),circleLarge:(0,u.$Kj)("circle-large",60341),circleLargeOutline:(0,u.$Kj)("circle-large-outline",60341),combine:(0,u.$Kj)("combine",60342),gather:(0,u.$Kj)("gather",60342),table:(0,u.$Kj)("table",60343),variableGroup:(0,u.$Kj)("variable-group",60344),typeHierarchy:(0,u.$Kj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Kj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Kj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Kj)("git-pull-request-create",60348),runAbove:(0,u.$Kj)("run-above",60349),runBelow:(0,u.$Kj)("run-below",60350),notebookTemplate:(0,u.$Kj)("notebook-template",60351),debugRerun:(0,u.$Kj)("debug-rerun",60352),workspaceTrusted:(0,u.$Kj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Kj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Kj)("workspace-unknown",60355),terminalCmd:(0,u.$Kj)("terminal-cmd",60356),terminalDebian:(0,u.$Kj)("terminal-debian",60357),terminalLinux:(0,u.$Kj)("terminal-linux",60358),terminalPowershell:(0,u.$Kj)("terminal-powershell",60359),terminalTmux:(0,u.$Kj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Kj)("terminal-ubuntu",60361),terminalBash:(0,u.$Kj)("terminal-bash",60362),arrowSwap:(0,u.$Kj)("arrow-swap",60363),copy:(0,u.$Kj)("copy",60364),personAdd:(0,u.$Kj)("person-add",60365),filterFilled:(0,u.$Kj)("filter-filled",60366),wand:(0,u.$Kj)("wand",60367),debugLineByLine:(0,u.$Kj)("debug-line-by-line",60368),inspect:(0,u.$Kj)("inspect",60369),layers:(0,u.$Kj)("layers",60370),layersDot:(0,u.$Kj)("layers-dot",60371),layersActive:(0,u.$Kj)("layers-active",60372),compass:(0,u.$Kj)("compass",60373),compassDot:(0,u.$Kj)("compass-dot",60374),compassActive:(0,u.$Kj)("compass-active",60375),azure:(0,u.$Kj)("azure",60376),issueDraft:(0,u.$Kj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Kj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Kj)("git-pull-request-draft",60379),debugAll:(0,u.$Kj)("debug-all",60380),debugCoverage:(0,u.$Kj)("debug-coverage",60381),runErrors:(0,u.$Kj)("run-errors",60382),folderLibrary:(0,u.$Kj)("folder-library",60383),debugContinueSmall:(0,u.$Kj)("debug-continue-small",60384),beakerStop:(0,u.$Kj)("beaker-stop",60385),graphLine:(0,u.$Kj)("graph-line",60386),graphScatter:(0,u.$Kj)("graph-scatter",60387),pieChart:(0,u.$Kj)("pie-chart",60388),bracket:(0,u.$Kj)("bracket",60175),bracketDot:(0,u.$Kj)("bracket-dot",60389),bracketError:(0,u.$Kj)("bracket-error",60390),lockSmall:(0,u.$Kj)("lock-small",60391),azureDevops:(0,u.$Kj)("azure-devops",60392),verifiedFilled:(0,u.$Kj)("verified-filled",60393),newline:(0,u.$Kj)("newline",60394),layout:(0,u.$Kj)("layout",60395),layoutActivitybarLeft:(0,u.$Kj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Kj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Kj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Kj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Kj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Kj)("layout-panel-right",60401),layoutPanel:(0,u.$Kj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Kj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Kj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Kj)("layout-statusbar",60405),layoutMenubar:(0,u.$Kj)("layout-menubar",60406),layoutCentered:(0,u.$Kj)("layout-centered",60407),target:(0,u.$Kj)("target",60408),indent:(0,u.$Kj)("indent",60409),recordSmall:(0,u.$Kj)("record-small",60410),errorSmall:(0,u.$Kj)("error-small",60411),terminalDecorationError:(0,u.$Kj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Kj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Kj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Kj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Kj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Kj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Kj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Kj)("layout-sidebar-left-off",60418),blank:(0,u.$Kj)("blank",60419),heartFilled:(0,u.$Kj)("heart-filled",60420),map:(0,u.$Kj)("map",60421),mapHorizontal:(0,u.$Kj)("map-horizontal",60421),foldHorizontal:(0,u.$Kj)("fold-horizontal",60421),mapFilled:(0,u.$Kj)("map-filled",60422),mapHorizontalFilled:(0,u.$Kj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,u.$Kj)("fold-horizontal-filled",60422),circleSmall:(0,u.$Kj)("circle-small",60423),bellSlash:(0,u.$Kj)("bell-slash",60424),bellSlashDot:(0,u.$Kj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Kj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Kj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Kj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Kj)("search-fuzzy",60429),commentDraft:(0,u.$Kj)("comment-draft",60430),send:(0,u.$Kj)("send",60431),sparkle:(0,u.$Kj)("sparkle",60432),insert:(0,u.$Kj)("insert",60433),mic:(0,u.$Kj)("mic",60434),thumbsdownFilled:(0,u.$Kj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Kj)("thumbsup-filled",60436),coffee:(0,u.$Kj)("coffee",60437),snake:(0,u.$Kj)("snake",60438),game:(0,u.$Kj)("game",60439),vr:(0,u.$Kj)("vr",60440),chip:(0,u.$Kj)("chip",60441),piano:(0,u.$Kj)("piano",60442),music:(0,u.$Kj)("music",60443),micFilled:(0,u.$Kj)("mic-filled",60444),repoFetch:(0,u.$Kj)("repo-fetch",60445),copilot:(0,u.$Kj)("copilot",60446),lightbulbSparkle:(0,u.$Kj)("lightbulb-sparkle",60447),robot:(0,u.$Kj)("robot",60448),sparkleFilled:(0,u.$Kj)("sparkle-filled",60449),diffSingle:(0,u.$Kj)("diff-single",60450),diffMultiple:(0,u.$Kj)("diff-multiple",60451),surroundWith:(0,u.$Kj)("surround-with",60452),share:(0,u.$Kj)("share",60453),gitStash:(0,u.$Kj)("git-stash",60454),gitStashApply:(0,u.$Kj)("git-stash-apply",60455),gitStashPop:(0,u.$Kj)("git-stash-pop",60456),vscode:(0,u.$Kj)("vscode",60457),vscodeInsiders:(0,u.$Kj)("vscode-insiders",60458),codeOss:(0,u.$Kj)("code-oss",60459),runCoverage:(0,u.$Kj)("run-coverage",60460),runAllCoverage:(0,u.$Kj)("run-all-coverage",60461),coverage:(0,u.$Kj)("coverage",60462),githubProject:(0,u.$Kj)("github-project",60463),mapVertical:(0,u.$Kj)("map-vertical",60464),foldVertical:(0,u.$Kj)("fold-vertical",60464),mapVerticalFilled:(0,u.$Kj)("map-vertical-filled",60465),foldVerticalFilled:(0,u.$Kj)("fold-vertical-filled",60465),goToSearch:(0,u.$Kj)("go-to-search",60466),percentage:(0,u.$Kj)("percentage",60467),sortPercentage:(0,u.$Kj)("sort-percentage",60467)}}),define(ke[78],Ee([1,0,99,170]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Nj=L;function L(){return Object.values(e.$Pj)}e.$Oj={dialogError:(0,u.$Kj)("dialog-error","error"),dialogWarning:(0,u.$Kj)("dialog-warning","warning"),dialogInfo:(0,u.$Kj)("dialog-info","info"),dialogClose:(0,u.$Kj)("dialog-close","close"),treeItemExpanded:(0,u.$Kj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Kj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Kj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Kj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Kj)("tree-item-loading","loading"),menuSelection:(0,u.$Kj)("menu-selection","check"),menuSubmenu:(0,u.$Kj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Kj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Kj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Kj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Kj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Kj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Kj)("toolbar-more","more"),quickInputBack:(0,u.$Kj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Kj)("drop-down-button",60084),symbolCustomColor:(0,u.$Kj)("symbol-customcolor",60252),exportIcon:(0,u.$Kj)("export",60332),workspaceUnspecified:(0,u.$Kj)("workspace-unspecified",60355),newLine:(0,u.$Kj)("newline",60394),thumbsDownFilled:(0,u.$Kj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Kj)("thumbsup-filled",60436),gitFetch:(0,u.$Kj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Kj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Kj)("debug-breakpoint-pending",60377)},e.$Pj={...N.$Mj,...e.$Oj}}),define(ke[24],Ee([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=N,e.$Xn=L,e.$Yn=M,e.$Zn=b,e.$1n=S,e.$2n=A,e.$3n=C,e.$4n=$,e.$5n=k,e.$6n=v,e.$7n=c,e.$8n=g;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?N(r):r}),n}function L(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(R.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,u.$7f)(s)&&n.push(s)}}return o}const R=Object.prototype.hasOwnProperty;function M(o,n){return w(o,n,new Set)}function w(o,n,i){if((0,u.$ag)(o))return o;const r=n(o);if(typeof r<"u")return r;if(Array.isArray(o)){const s=[];for(const t of o)s.push(w(t,n,i));return s}if((0,u.$6f)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)R.call(o,t)&&(s[t]=w(o[t],n,i));return i.delete(o),s}return o}function b(o,n,i=!0){return(0,u.$6f)(o)?((0,u.$6f)(n)&&Object.keys(n).forEach(r=>{r in o?i&&((0,u.$6f)(o[r])&&(0,u.$6f)(n[r])?b(o[r],n[r],i):o[r]=n[r]):o[r]=n[r]}),o):n}function S(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!S(o[i],n[i]))return!1}else{const s=[];for(r in o)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!S(s,t))return!1;for(i=0;i<s.length;i++)if(!S(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,r)=>{if((0,u.$6f)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function C(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],f=n[s];S(t,f)||(i[s]=f)}),i}function $(o,n){const i=n.toLowerCase(),r=Object.keys(o).find(s=>s.toLowerCase()===i);return r?o[r]:o[n]}function k(o,n){const i=Object.create(null);for(const[r,s]of Object.entries(o))n(r,s)&&(i[r]=s);return i}function v(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function c(o){const n=[];for(const i of v(o))typeof o[i]=="function"&&n.push(i);return n}function g(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of o)r[s]=i(s);return r}}),define(ke[57],Ee([1,0,78]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=L;var N;(function(M){function w(b){return b&&typeof b=="object"&&typeof b.id=="string"}M.isThemeColor=w})(N||(e.ThemeColor=N={}));function L(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function b(n){const i=w.exec(n.id);if(!i)return b(u.$Pj.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}M.asClassNameArray=b;function S(n){return b(n).join(" ")}M.asClassName=S;function A(n){return"."+b(n).join(".")}M.asCSSSelector=A;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=C;const $=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function k(n){const i=$.exec(n);if(!i)return;const[,r]=i;return{id:r}}M.fromString=k;function v(n){return{id:n}}M.fromId=v;function c(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}M.modify=c;function g(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=g;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(ke[171],Ee([1,0,126,14,57]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=b,e.$Ik=A,e.$Jk=$,e.$Kk=k,e.$Lk=c,e.$Mk=g;const R="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${M.source}`,"g");function b(o){return o.replace(w,(n,i)=>i?n:`\\${n}`)}const S=new RegExp(`\\\\${M.source}`,"g");function A(o){return o.replace(S,n=>`\\${n}`)}const C=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function $(o){return o.indexOf(R)===-1?o:o.replace(C,(n,i,r,s)=>r?n:i||s||"")}function k(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(o){v.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=v.lastIndex,t=v.exec(o),f=o.substring(s,t?.index);if(f.length>0){n+=f;for(let d=0;d<f.length;d++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function g(o,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,u.$yk)(o,r,i);const t=(0,N.$af)(r," "),f=r.length-t.length,d=(0,u.$yk)(o,t,i);if(d)for(const l of d){const a=s[l.start+f]+f;l.start+=a,l.end+=a}return d}}),define(ke[127],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$1e=N,e.$2e=L;var u;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function N(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return u.test(L)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};const R=new Uint8Array(16),M=[];for(let w=0;w<256;w++)M.push(w.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let b=0,S="";return S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S}}()}),define(ke[172],Ee([1,0,19,45,30]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=R,e.$Ht=M,e.$Jt=S;function R(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}function M(C,$,k){const v={id:(0,L.$Mg)(),name:C,uri:$,data:k};return{asString:async()=>"",asFile:()=>v,value:void 0}}class w{constructor(){this.a=new Map}get size(){let $=0;for(const k of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const k=[...this.a.keys()];return N.Iterable.some(this,([v,c])=>c.asFile())&&k.push("files"),A(b($),k)}get($){return this.a.get(this.b($))?.[0]}append($,k){const v=this.a.get($);v?v.push(k):this.a.set(this.b($),[k])}replace($,k){this.a.set(this.b($),[k])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,k]of this.a)for(const v of k)yield[$,v]}b($){return b($)}}e.$It=w;function b(C){return C.toLowerCase()}function S(C,$){return A(b(C),$.map(b))}function A(C,$){if(C==="*/*")return $.length>0;if($.includes(C))return!0;const k=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[v,c,g]=k;return g==="*"?$.some(o=>o.startsWith(c+"/")):!1}e.$Kt=Object.freeze({create:C=>(0,u.$Mb)(C.map($=>$.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Kt.split(C).filter($=>!$.startsWith("#"))})}),define(ke[173],Ee([1,0,63]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=N,e.$Qg=R;function N(w,b,S,A=1){let C=!1;return new Promise($=>{const k=setTimeout(()=>{if(!C)return C=!0,$(0)},S);L(w,b,A,v=>{if(!C)return C=!0,clearTimeout(k),$(v)})})}function L(w,b,S,A){if(b===0)return A(0);const C=new u.Socket;C.once("connect",()=>(M(C),L(w+S,b-1,S,A))),C.once("data",()=>{}),C.once("error",$=>(M(C),$.code!=="ECONNREFUSED"?L(w+S,b-1,S,A):A(w))),C.connect(w,"127.0.0.1")}e.$Pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(w,b,S,A="127.0.0.1"){let C=!1,$,k=1;const v=u.createServer({pauseOnConnect:!0});function c(g,o){C||(C=!0,v.removeAllListeners(),v.close(),$&&clearTimeout($),o(g))}return new Promise(g=>{$=setTimeout(()=>{c(0,g)},S),v.on("listening",()=>{c(w,g)}),v.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&k<b?(w++,k++,v.listen(w,A)):c(0,g)}),v.on("close",()=>{c(0,g)}),v.listen(w,A)})}function M(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(b){console.error(b)}}}),define(ke[128],Ee([1,0,127]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.$yt=void 0;class N{constructor(w){const b=(0,u.$1e)(w);this.c=b,this.a=N.d(b),this.b=new Map}static d(w){const b=new Uint8Array(256);return b.fill(w),b}set(w,b){const S=(0,u.$1e)(b);w>=0&&w<256?this.a[w]=S:this.b.set(w,S)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$yt=N;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new N(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$zt=R}),define(ke[174],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=N;var u;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function N(L){let R=0,M=0,w=0,b=0;for(let S=0,A=L.length;S<A;S++){const C=L.charCodeAt(S);C===13?(R===0&&(M=S),R++,S+1<A&&L.charCodeAt(S+1)===10?(b|=2,S++):b|=3,w=S+1):C===10&&(b|=1,R===0&&(M=S),R++,w=S+1)}return R===0&&(M=L.length),[R,M,L.length-w,b]}}),define(ke[50],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0;class u{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new u(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return u.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return u.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return u.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const M=L.lineNumber|0,w=R.lineNumber|0;if(M===w){const b=L.column|0,S=R.column|0;return b-S}return M-w}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new u(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$jt=u}),define(ke[29],Ee([1,0,50]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0;class N{constructor(R,M,w,b){R>w||R===w&&M>b?(this.startLineNumber=w,this.startColumn=b,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=w,this.endColumn=b)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,M){let w,b,S,A;return M.startLineNumber<R.startLineNumber?(w=M.startLineNumber,b=M.startColumn):M.startLineNumber===R.startLineNumber?(w=M.startLineNumber,b=Math.min(M.startColumn,R.startColumn)):(w=R.startLineNumber,b=R.startColumn),M.endLineNumber>R.endLineNumber?(S=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(S=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(S=R.endLineNumber,A=R.endColumn),new N(w,b,S,A)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,M){let w=R.startLineNumber,b=R.startColumn,S=R.endLineNumber,A=R.endColumn;const C=M.startLineNumber,$=M.startColumn,k=M.endLineNumber,v=M.endColumn;return w<C?(w=C,b=$):w===C&&(b=Math.max(b,$)),S>k?(S=k,A=v):S===k&&(A=Math.min(A,v)),w>S||w===S&&b>A?null:new N(w,b,S,A)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new u.$jt(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new u.$jt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new N(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new N(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new N(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const S=R.startLineNumber|0,A=M.startLineNumber|0;if(S===A){const C=R.startColumn|0,$=M.startColumn|0;if(C===$){const k=R.endLineNumber|0,v=M.endLineNumber|0;if(k===v){const c=R.endColumn|0,g=M.endColumn|0;return c-g}return k-v}return C-$}return S-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$kt=N}),define(ke[175],Ee([1,0,29]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0;class N{static insert(R,M){return{range:new u.$kt(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$lt=N}),define(ke[176],Ee([1,0,50,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends N.$kt{constructor(w,b,S,A){super(w,b,S,A),this.selectionStartLineNumber=w,this.selectionStartColumn=b,this.positionLineNumber=S,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return R.selectionsEqual(this,w)}static selectionsEqual(w,b){return w.selectionStartLineNumber===b.selectionStartLineNumber&&w.selectionStartColumn===b.selectionStartColumn&&w.positionLineNumber===b.positionLineNumber&&w.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,b){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,w,b):new R(w,b,this.startLineNumber,this.startColumn)}getPosition(){return new u.$jt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$jt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,b){return this.getDirection()===0?new R(w,b,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,w,b)}static fromPositions(w,b=w){return new R(w.lineNumber,w.column,b.lineNumber,b.column)}static fromRange(w,b){return b===0?new R(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new R(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new R(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,b){if(w&&!b||!w&&b)return!1;if(!w&&!b)return!0;if(w.length!==b.length)return!1;for(let S=0,A=w.length;S<A;S++)if(!this.selectionsEqual(w[S],b[S]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,b,S,A,C){return C===0?new R(w,b,S,A):new R(S,A,w,b)}}e.$mt=R}),define(ke[177],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Ee([1,0,27,128]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.WordCharacterClass=void 0,e.$Bt=w;var L;(function(b){b[b.Regular=0]="Regular",b[b.Whitespace=1]="Whitespace",b[b.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends N.$yt{constructor(S,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let C=0,$=S.length;C<$;C++)this.set(S.charCodeAt(C),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(S,A){let C=null;for(const $ of this.h(S)){if($.index>A)break;C=$}return C}findNextIntlWordAtOrAfterOffset(S,A){for(const C of this.h(S))if(!(C.index<A))return C;return null}h(S){return this.e?this.f===S?this.g:(this.f=S,this.g=this.j(this.e.segment(S)),this.g):[]}j(S){const A=[];for(const C of S)this.k(C)&&A.push(C);return A}k(S){return!!S.isWordLike}}e.$At=R;const M=new u.$Ec(10);function w(b,S){const A=`${b}/${S.join(",")}`;let C=M.get(A);return C||(C=new R(b,S),M.set(A,C)),C}}),define(ke[129],Ee([1,0,45,3,75]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=void 0,e.$Xs=M,e.$Ys=b,e.$Zs=S,e.$Vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(C=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$Vs)C.indexOf(k)>=0||($+="\\"+k);return $+="\\s]+)",new RegExp($,"g")}e.$Ws=R();function M(C){let $=e.$Ws;if(C&&C instanceof RegExp)if(C.global)$=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),$=new RegExp(C.source,k)}return $.lastIndex=0,$}const w=new L.$5c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(C){const $=w.unshift(C);return(0,N.$Sc)($)}function S(C,$,k,v,c){if($=M($),c||(c=u.Iterable.first(w)),k.length>c.maxLen){let r=C-c.maxLen/2;return r<0?r=0:v+=r,k=k.substring(r,C+c.maxLen/2),S(C,$,k,v,c)}const g=Date.now(),o=C-1-v;let n=-1,i=null;for(let r=1;!(Date.now()-g>=c.timeBudget);r++){const s=o-c.windowSize*r;$.lastIndex=Math.max(0,s);const t=A($,k,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return $.lastIndex=0,r}return null}function A(C,$,k,v){let c;for(;c=C.exec($);){const g=c.index||0;if(g<=k&&C.lastIndex>=k)return c;if(v>0&&g>v)return null}return null}}),define(ke[179],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var u;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class N{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let b=0,S=w.notIn.length;b<S;b++)switch(w.notIn[b]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,b){if(w.getTokenCount()===0)return!0;const S=w.findTokenIndexAtOffset(b-2),A=w.getStandardTokenType(S);return this.isOK(A)}g(w,b){for(let S=w;S<=b;S++){const A=String.fromCharCode(S);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=N;class L{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of w)R(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),R(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),R(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),R(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&R(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.$bu=L;function R(M,w,b){M.has(w)?M.get(w).push(b):M.set(w,[b])}}),define(ke[180],Ee([1,0,128]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22=e.$12=e.State=void 0,e.$32=$;var N;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class L{constructor(v,c,g){const o=new Uint8Array(v*c);for(let n=0,i=v*c;n<i;n++)o[n]=g;this.a=o,this.rows=v,this.cols=c}get(v,c){return this.a[v*this.cols+c]}set(v,c,g){this.a[v*this.cols+c]=g}}class R{constructor(v){let c=0,g=0;for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];s>c&&(c=s),r>g&&(g=r),t>g&&(g=t)}c++,g++;const o=new L(g,c,0);for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];o.set(r,s,t)}this.a=o,this.b=c}nextState(v,c){return c<0||c>=this.b?0:this.a.get(v,c)}}e.$12=R;let M=null;function w(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var b;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let S=null;function A(){if(S===null){S=new u.$yt(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<k.length;c++)S.set(k.charCodeAt(c),1);const v=".,;:";for(let c=0;c<v.length;c++)S.set(v.charCodeAt(c),2)}return S}class C{static a(v,c,g,o,n){let i=n-1;do{const r=c.charCodeAt(i);if(v.get(r)!==2)break;i--}while(i>o);if(o>0){const r=c.charCodeAt(o-1),s=c.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:g,startColumn:o+1,endLineNumber:g,endColumn:i+2},url:c.substring(o,i+1)}}static computeLinks(v,c=w()){const g=A(),o=[];for(let n=1,i=v.getLineCount();n<=i;n++){const r=v.getLineContent(n),s=r.length;let t=0,f=0,d=0,l=1,a=!1,h=!1,m=!1,D=!1;for(;t<s;){let p=!1;const E=r.charCodeAt(t);if(l===13){let y;switch(E){case 40:a=!0,y=0;break;case 41:y=a?0:1;break;case 91:m=!0,h=!0,y=0;break;case 93:m=!1,y=h?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:d===E?y=1:d===39||d===34||d===96?y=0:y=1;break;case 42:y=d===42?1:0;break;case 124:y=d===124?1:0;break;case 32:y=m?0:1;break;default:y=g.get(E)}y===1&&(o.push(C.a(g,r,n,f,t)),p=!0)}else if(l===12){let y;E===91?(h=!0,y=0):y=g.get(E),y===1?p=!0:l=13}else l=c.nextState(l,E),l===0&&(p=!0);p&&(l=1,a=!1,h=!1,D=!1,f=t+1,d=E),t++}l===13&&o.push(C.a(g,r,n,f,s))}return o}}e.$22=C;function $(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:C.computeLinks(k)}}),define(ke[79],Ee([1,0,24]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$vv=e.$uv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$wv=v,e.$Av=r;var N;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var w;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(w||(e.InjectedTextCursorStops=w={}));var b;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var S;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$1n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$uv=C;class ${constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$vv=$;var k;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k||(e.TrackedRangeStickiness=k={}));function v(s){return s&&typeof s.read=="function"}var c;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var g;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class o{constructor(t,f,d,l,a,h){this.identifier=t,this.range=f,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=a,this._isTracked=h}}e.$xv=o;class n{constructor(t,f,d){this.regex=t,this.wordSeparators=f,this.simpleSearch=d}}e.$yv=n;class i{constructor(t,f,d){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=d}}e.$zv=i;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[181],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.NodeColor=e.$qC=void 0,e.$sC=L,e.$tC=R,e.$uC=S,e.$vC=A,e.$wC=C,e.$xC=$,e.$yC=k,e.$zC=v;class u{constructor(g,o){this.piece=g,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rC)return L(this.right);let g=this;for(;g.parent!==e.$rC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$rC?e.$rC:g.parent}prev(){if(this.left!==e.$rC)return R(this.left);let g=this;for(;g.parent!==e.$rC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$rC?e.$rC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qC=u;var N;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$rC=new u(null,0),e.$rC.parent=e.$rC,e.$rC.left=e.$rC,e.$rC.right=e.$rC,e.$rC.color=0;function L(c){for(;c.left!==e.$rC;)c=c.left;return c}function R(c){for(;c.right!==e.$rC;)c=c.right;return c}function M(c){return c===e.$rC?0:c.size_left+c.piece.length+M(c.right)}function w(c){return c===e.$rC?0:c.lf_left+c.piece.lineFeedCnt+w(c.right)}function b(){e.$rC.parent=e.$rC}function S(c,g){const o=g.right;o.size_left+=g.size_left+(g.piece?g.piece.length:0),o.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=o.left,o.left!==e.$rC&&(o.left.parent=g),o.parent=g.parent,g.parent===e.$rC?c.root=o:g.parent.left===g?g.parent.left=o:g.parent.right=o,o.left=g,g.parent=o}function A(c,g){const o=g.left;g.left=o.right,o.right!==e.$rC&&(o.right.parent=g),o.parent=g.parent,g.size_left-=o.size_left+(o.piece?o.piece.length:0),g.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),g.parent===e.$rC?c.root=o:g===g.parent.right?g.parent.right=o:g.parent.left=o,o.right=g,g.parent=o}function C(c,g){let o,n;if(g.left===e.$rC?(n=g,o=n.right):g.right===e.$rC?(n=g,o=n.left):(n=L(g.right),o=n.right),n===c.root){c.root=o,o.color=0,g.detach(),b(),c.root.parent=e.$rC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===g?(o.parent=n.parent,v(c,o)):(n.parent===g?o.parent=n:o.parent=n.parent,v(c,o),n.left=g.left,n.right=g.right,n.parent=g.parent,n.color=g.color,g===c.root?c.root=n:g===g.parent.left?g.parent.left=n:g.parent.right=n,n.left!==e.$rC&&(n.left.parent=n),n.right!==e.$rC&&(n.right.parent=n),n.size_left=g.size_left,n.lf_left=g.lf_left,v(c,n)),g.detach(),o.parent.left===o){const s=M(o),t=w(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const f=s-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,k(c,o.parent,f,d)}}if(v(c,o.parent),i){b();return}let r;for(;o!==c.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,S(c,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(c,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,S(c,o.parent),o=c.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(c,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,S(c,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(c,o.parent),o=c.root));o.color=0,b()}function $(c,g){for(v(c,g);g!==c.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const o=g.parent.parent.right;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,S(c,g)),g.parent.color=0,g.parent.parent.color=1,A(c,g.parent.parent))}else{const o=g.parent.parent.left;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,A(c,g)),g.parent.color=0,g.parent.parent.color=1,S(c,g.parent.parent))}c.root.color=0}function k(c,g,o,n){for(;g!==c.root&&g!==e.$rC;)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=n),g=g.parent}function v(c,g){let o=0,n=0;if(g!==c.root){for(;g!==c.root&&g===g.parent.right;)g=g.parent;if(g!==c.root)for(g=g.parent,o=M(g.left)-g.size_left,n=w(g.left)-g.lf_left,g.size_left+=o,g.lf_left+=n;g!==c.root&&(o!==0||n!==0);)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=n),g=g.parent}}}),define(ke[182],Ee([1,0,19,127]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=void 0;class L{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,S){b=(0,N.$2e)(b);const A=this.a,C=this.b,$=S.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,b),0),this.a.set(A.subarray(b),b+$),this.a.set(S,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(b,S){return b=(0,N.$2e)(b),S=(0,N.$2e)(S),this.a[b]===S?!1:(this.a[b]=S,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,S){b=(0,N.$2e)(b),S=(0,N.$2e)(S);const A=this.a,C=this.b;if(b>=A.length)return!1;const $=A.length-b;return S>=$&&(S=$),S===0?!1:(this.a=new Uint32Array(A.length-S),this.a.set(A.subarray(0,b),0),this.a.set(A.subarray(b+S),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,N.$2e)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),b>=this.a.length&&(b=this.a.length-1);for(let A=S;A<=b;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let S=0,A=this.a.length-1,C=0,$=0,k=0;for(;S<=A;)if(C=S+(A-S)/2|0,$=this.b[C],k=$-this.a[C],b<k)A=C-1;else if(b>=$)S=C+1;else break;return new M(C,b-k)}}e.$Mv=L;class R{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const S=this.e[b],A=S>0?this.d[S-1]:0;return new M(S,b-A)}removeValues(b,S){this.a.splice(b,S),this.f(b)}insertValues(b,S){this.a=(0,u.$Wb)(this.a,b,S),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,S=this.a.length;b<S;b++){const A=this.a[b],C=b>0?this.d[b-1]:0;this.d[b]=C+A;for(let $=0;$<A;$++)this.e[C+$]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,S){this.a[b]!==S&&(this.a[b]=S,this.f(b))}}e.$Nv=R;class M{constructor(b,S){this.index=b,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=S}}e.$Ov=M}),define(ke[183],Ee([1,0,14,50,182]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=void 0;class R{constructor(w,b,S,A){this.d=w,this.f=b,this.g=S,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const b=w.changes;for(const S of b)this.o(S.range),this.p(new N.$jt(S.range.startLineNumber,S.range.startColumn),S.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,b=this.f.length,S=new Uint32Array(b);for(let A=0;A<b;A++)S[A]=this.f[A].length+w;this.j=new L.$Mv(S)}}n(w,b){this.f[w]=b,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,b){if(b.length===0)return;const S=(0,u.$gf)(b);if(S.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+S[0]+this.f[w.lineNumber-1].substring(w.column-1));return}S[S.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+S[0]);const A=new Uint32Array(S.length-1);for(let C=1;C<S.length;C++)this.f.splice(w.lineNumber+C-1,0,S[C]),A[C-1]=S[C].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,A)}}e.$Pv=R}),define(ke[100],Ee([1,0,14,178,50,29,79]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=e.$DC=e.$AC=void 0,e.$BC=S,e.$CC=A,e.$EC=c;const w=999;class b{constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=S(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$ef(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new M.$yv(i,this.wordSeparators?(0,N.$Bt)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$AC=b;function S(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const r=o.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new M.$vv(o,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new M.$vv(o,r)}class C{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class ${static findMatches(n,i,r,s,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this.b(n,r,new g(f.wordSeparators,f.regex),s,t):this.c(n,r,f,s,t):[]}static a(n,i,r,s,t,f){let d,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let a;if(s){const p=s.findLineFeedCountBeforeOffset(t+f.length)-l;a=d+f.length+p}else a=d+f.length;const h=n.getPositionAt(d),m=n.getPositionAt(a);return new R.$kt(h.lineNumber,h.column,m.lineNumber,m.column)}static b(n,i,r,s,t){const f=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new C(d):null,a=[];let h=0,m;for(r.reset(0);m=r.next(d);)if(a[h++]=A(this.a(n,f,d,l,m.index,m[0]),m,s),h>=t)return a;return a}static c(n,i,r,s,t){const f=[];let d=0;if(i.startLineNumber===i.endLineNumber){const a=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(r,a,i.startLineNumber,i.startColumn-1,d,f,s,t),f}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(r,l,i.startLineNumber,i.startColumn-1,d,f,s,t);for(let a=i.startLineNumber+1;a<i.endLineNumber&&d<t;a++)d=this.d(r,n.getLineContent(a),a,0,d,f,s,t);if(d<t){const a=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(r,a,i.endLineNumber,0,d,f,s,t)}return f}static d(n,i,r,s,t,f,d,l){const a=n.wordSeparators;if(!d&&n.simpleSearch){const D=n.simpleSearch,p=D.length,E=i.length;let y=-p;for(;(y=i.indexOf(D,y+p))!==-1;)if((!a||c(a,i,E,y,p))&&(f[t++]=new M.$vv(new R.$kt(r,y+1+s,r,y+1+p+s),null),t>=l))return t;return t}const h=new g(n.wordSeparators,n.regex);let m;h.reset(0);do if(m=h.next(i),m&&(f[t++]=A(new R.$kt(r,m.index+1+s,r,m.index+1+m[0].length+s),m,d),t>=l))return t;while(m);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,f,s):this.f(n,r,f,s)}static e(n,i,r,s){const t=new L.$jt(i.lineNumber,1),f=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new R.$kt(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),a=n.getEOL()===`\r
`?new C(l):null;r.reset(i.column-1);const h=r.next(l);return h?A(this.a(n,f,l,a,h.index,h[0]),h,s):i.lineNumber!==1||i.column!==1?this.e(n,new L.$jt(1,1),r,s):null}static f(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f),l=this.g(r,d,f,i.column,s);if(l)return l;for(let a=1;a<=t;a++){const h=(f+a-1)%t,m=n.getLineContent(h+1),D=this.g(r,m,h+1,1,s);if(D)return D}return null}static g(n,i,r,s,t){n.reset(s-1);const f=n.next(i);return f?A(new R.$kt(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,f,s):this.j(n,r,f,s)}static h(n,i,r,s){const t=this.b(n,new R.$kt(1,1,i.lineNumber,i.column),r,s,10*w);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this.h(n,new L.$jt(f,n.getLineMaxColumn(f)),r,s):null}static j(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f).substring(0,i.column-1),l=this.k(r,d,f,s);if(l)return l;for(let a=1;a<=t;a++){const h=(t+f-a-1)%t,m=n.getLineContent(h+1),D=this.k(r,m,h+1,s);if(D)return D}return null}static k(n,i,r,s){let t=null,f;for(n.reset(0);f=n.next(i);)t=A(new R.$kt(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.$DC=$;function k(o,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function v(o,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r+s-1);if(o.get(f)!==0)return!0}return!1}function c(o,n,i,r,s){return k(o,n,i,r,s)&&v(o,n,i,r,s)}class g{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){u.$Af(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||c(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.$FC=g}),define(ke[130],Ee([1,0,50,29,79,181,100]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=void 0,e.$GC=A,e.$HC=C;const w=65535;function b(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class S{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let r=1;for(let s=0,t=o.length;s<t;s++){const f=o.charCodeAt(s);f===13?s+1<t&&o.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:f===10&&(i[r++]=s+1)}return n?b(i):i}function C(o,n){o.length=0,o[0]=0;let i=1,r=0,s=0,t=0,f=!0;for(let l=0,a=n.length;l<a;l++){const h=n.charCodeAt(l);h===13?l+1<a&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(r++,o[i++]=l+1):h===10?(s++,o[i++]=l+1):f&&h!==9&&(h<32||h>126)&&(f=!1)}const d=new S(b(o),r,s,t,f);return o.length=0,d}class ${constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$IC=$;class k{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$JC=k;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$rC&&n.iterate(n.root,r=>(r!==R.$rC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class g{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new k("",[0])],this.g={line:0,column:0},this.root=R.$rC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let s=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const d=new $(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,d)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=w,r=i-Math.floor(i/3),s=r*2;let t="",f=0;const d=[];if(this.iterate(this.root,l=>{const a=this.R(l),h=a.length;if(f<=r||f+h<s)return t+=a,f+=h,!0;const m=t.replace(/\r\n|\r|\n/g,n);return d.push(new k(m,A(m))),t=a,f=h,!0}),f>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new k(l,A(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===R.$rC)return!0;const t=this.R(s),f=t.length,d=n.G(i),l=n.G(i+f),a=n.getValueInRange2(d,l);return i+=f,t===a})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==R.$rC;)if(s.left!==R.$rC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.B(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==R.$rC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),d=s-f;return new u.$jt(r+1,d+1)}return new u.$jt(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$rC){const t=this.getOffsetAt(r+1,1),f=s-n-t;return new u.$jt(r+1,f+1)}else i=i.right;return new u.$jt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,a=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(a+n.remainder,a+i.remainder)}let r=n.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==R.$rC;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=d.substring(l,l+i.remainder);break}else f+=d.substr(l,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===R.$rC)return!0;const f=t.piece;let d=f.length;if(d===0)return!0;const l=this.a[f.bufferIndex].buffer,a=this.a[f.bufferIndex].lineStarts,h=f.start.line,m=f.end.line;let D=a[h]+f.start.column;if(s&&(l.charCodeAt(D)===10&&(D++,d--),n[i++]=r,r="",s=!1,d===0))return!0;if(h===m)return!this.f&&l.charCodeAt(D+d-1)===13?(s=!0,r+=l.substr(D,d-1)):r+=l.substr(D,d),!0;r+=this.f?l.substring(D,Math.max(D,a[h+1]-this.e)):l.substring(D,a[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let p=h+1;p<m;p++)r=this.f?l.substring(a[p],a[p+1]-this.e):l.substring(a[p],a[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&l.charCodeAt(a[m]+f.end.column-1)===13?(s=!0,f.end.column===0?i--:r=l.substr(a[m],f.end.column-1)):r=l.substr(a[m],f.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,s,t,f,d,l,a,h,m){const D=this.a[n.piece.bufferIndex],p=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,f);let P;const I={line:0,column:0};let j,F;i._wordSeparators?(j=D.buffer.substring(E,y),F=z=>z+E,i.reset(0)):(j=D.buffer,F=z=>z,i.reset(E));do if(P=i.next(j),P){if(F(P.index)>=y)return h;this.s(n,F(P.index)-p,I);const z=this.t(n.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+s:I.column+1,T=O+P[0].length;if(m[h++]=(0,M.$CC)(new N.$kt(r+z,O,r+z,T),P,l),F(P.index)+P[0].length>=y||h>=a)return h}while(P);return h}findMatchesLineByLine(n,i,r,s){const t=[];let f=0;const d=new M.$FC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const a=this.H(n.endLineNumber,n.endColumn);if(a===null)return[];let h=this.s(l.node,l.remainder);const m=this.s(a.node,a.remainder);if(l.node===a.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,h,m,i,r,s,f,t),t;let D=n.startLineNumber,p=l.node;for(;p!==a.node;){const y=this.t(p.piece.bufferIndex,h,p.piece.end);if(y>=1){const I=this.a[p.piece.bufferIndex].lineStarts,j=this.u(p.piece.bufferIndex,p.piece.start),F=I[h.line+y],z=D===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(p,d,D,z,h,this.s(p,F-j),i,r,s,f,t),f>=s)return t;D+=y}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(P,n.endColumn-1);return f=this.n(i,d,I,n.endLineNumber,P,f,t,r,s),t}if(f=this.n(i,d,this.getLineContent(D).substr(P),D,P,f,t,r,s),f>=s)return t;D++,l=this.H(D,1),p=l.node,h=this.s(l.node,l.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(y,n.endColumn-1);return f=this.n(i,d,P,n.endLineNumber,y,f,t,r,s),t}const E=D===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(a.node,d,D,E,h,m,i,r,s,f,t),t}n(n,i,r,s,t,f,d,l,a){const h=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,p=D.length,E=r.length;let y=-p;for(;(y=r.indexOf(D,y+p))!==-1;)if((!h||(0,M.$EC)(h,r,E,y,p))&&(d[f++]=new L.$vv(new N.$kt(s,y+1+t,s,y+1+p+t),null),f>=a))return f;return f}let m;i.reset(0);do if(m=i.next(r),m&&(d[f++]=(0,M.$CC)(new N.$kt(s,m.index+1+t,s,m.index+1+m[0].length+t),m,l),f>=a))return f;while(m);return f}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$rC){const{node:s,remainder:t,nodeStartOffset:f}=this.G(n),d=s.piece,l=d.bufferIndex,a=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&f+d.length===n&&i.length<w){this.F(s,i),this.y();return}if(f===n)this.o(i,s),this.h.validate(n);else if(f+s.piece.length>n){const h=[];let m=new $(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),this.u(l,d.end)-this.u(l,a));if(this.K()&&this.M(i)&&this.I(s,t)===10){const y={line:m.start.line+1,column:0};m=new $(m.bufferIndex,y,m.end,this.t(m.bufferIndex,y,m.end),m.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const y=this.s(s,t-1);this.C(s,y),i="\r"+i,s.piece.length===0&&h.push(s)}else this.C(s,a);else this.C(s,a);const D=this.w(i);m.length>0&&this.S(s,m);let p=s;for(let E=0;E<D.length;E++)p=this.S(p,D[E]);this.v(h)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let f=1;f<s.length;f++)t=this.S(t,s[f])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$rC)return;const r=this.G(n),s=this.G(n+i),t=r.node,f=s.node;if(t===f){const D=this.s(t,r.remainder),p=this.s(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const E=t.next();(0,R.$wC)(this,t),this.N(E),this.y();return}this.D(t,p),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,p),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const a=this.s(f,s.remainder);this.D(f,a),f.piece.length===0&&d.push(f);const h=t.next();for(let D=h;D!==R.$rC&&D!==f;D=D.next())d.push(D);const m=t.piece.length===0?t.prev():t;this.v(d),this.O(m),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const f=i.piece,d={line:f.start.line+1,column:0},l=new $(f.bufferIndex,d,f.end,this.t(f.bufferIndex,d,f.end),f.length-1);i.piece=l,n+=`
`,(0,R.$yC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.T(t,s[f]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),s=this.S(i,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(s)}s(n,i,r){const s=n.piece,t=n.piece.bufferIndex,f=this.a[t].lineStarts,l=f[s.start.line]+s.start.column+i;let a=s.start.line,h=s.end.line,m=0,D=0,p=0;for(;a<=h&&(m=a+(h-a)/2|0,p=f[m],m!==h);)if(D=f[m+1],l<p)h=m-1;else if(l>=D)a=m+1;else break;return r?(r.line=m,r.column=l-p,null):{line:m,column:l-p}}t(n,i,r){if(r.column===0)return r.line-i.line;const s=this.a[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-i.line;const d=f-1;return this.a[n].buffer.charCodeAt(d)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$wC)(this,n[i])}w(n){if(n.length>w){const h=[];for(;n.length>w;){const D=n.charCodeAt(w-1);let p;D===13||D>=55296&&D<=56319?(p=n.substring(0,w-1),n=n.substring(w-1)):(p=n.substring(0,w),n=n.substring(w));const E=A(p);h.push(new $(this.a.length,{line:0,column:0},{line:E.length-1,column:p.length-E[E.length-1]},E.length-1,p.length)),this.a.push(new k(p,E))}const m=A(n);return h.push(new $(this.a.length,{line:0,column:0},{line:m.length-1,column:n.length-m[m.length-1]},m.length-1,n.length)),this.a.push(new k(n,m)),h}let i=this.a[0].buffer.length;const r=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let h=0;h<r.length;h++)r[h]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let h=0;h<r.length;h++)r[h]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[f],l={line:f,column:d},a=new $(0,s,l,this.t(0,s,l),t-i);return this.g=l,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this.h.get2(n);if(t){r=t.node;const f=this.B(r,n-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=d.substring(l+f,l+r.piece.length);else{const a=this.B(r,n-t.nodeStartLineNumber);return d.substring(l+f,l+a-i)}}else{let f=0;const d=n;for(;r!==R.$rC;)if(r.left!==R.$rC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.B(r,n-r.lf_left-2),a=this.B(r,n-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,m=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:d-(n-1-r.lf_left)}),h.substring(m+l,m+a-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.B(r,n-r.lf_left-2),a=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);s=a.substring(h+l,h+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$rC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return s+=f.substring(l,l+d-i),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=f.substr(d,r.piece.length)}r=r.next()}return s}y(){let n=this.root,i=1,r=0;for(;n!==R.$rC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,s=this.s(n,i),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const f=this.t(n.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const r=n.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=i,d=this.u(r.bufferIndex,f),l=this.t(r.bufferIndex,r.start,f),a=l-s,h=d-t,m=r.length+h;n.piece=new $(r.bufferIndex,r.start,f,l,m),(0,R.$yC)(this,n,h,a)}D(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=i,d=this.t(r.bufferIndex,f,r.end),l=this.u(r.bufferIndex,f),a=d-s,h=t-l,m=r.length+h;n.piece=new $(r.bufferIndex,f,r.end,d,m),(0,R.$yC)(this,n,h,a)}E(n,i,r){const s=n.piece,t=s.start,f=s.end,d=s.length,l=s.lineFeedCnt,a=i,h=this.t(s.bufferIndex,s.start,a),m=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new $(s.bufferIndex,s.start,a,h,m),(0,R.$yC)(this,n,m-d,h-l);const D=new $(s.bufferIndex,r,f,this.t(s.bufferIndex,r,f),this.u(s.bufferIndex,f)-this.u(s.bufferIndex,r)),p=this.S(n,D);this.N(p)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let p=0;p<t.length;p++)t[p]+=s;if(r){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[f],l={line:f,column:d},a=n.piece.length+i.length,h=n.piece.lineFeedCnt,m=this.t(0,n.piece.start,l),D=m-h;n.piece=new $(n.piece.bufferIndex,n.piece.start,l,m,a),this.g=l,(0,R.$yC)(this,n,i.length,D)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==R.$rC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,s=0;for(;r!==R.$rC;)if(r.left!==R.$rC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),f=this.B(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$rC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$rC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$rC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new $(n.piece.bufferIndex,n.piece.start,t,d,f),(0,R.$yC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},a=i.piece.length-1,h=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new $(i.piece.bufferIndex,l,i.piece.end,h,a),(0,R.$yC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const m=this.w(`\r
`);this.S(n,m[0]);for(let D=0;D<r.length;D++)(0,R.$wC)(this,r[D])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,R.$wC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new $(s.bufferIndex,t,s.end,d,f),(0,R.$yC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$rC)return i(R.$rC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$rC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,s)}S(n,i){const r=new R.$qC(i,1);if(r.left=R.$rC,r.right=R.$rC,r.parent=R.$rC,r.size_left=0,r.lf_left=0,this.root===R.$rC)this.root=r,r.color=0;else if(n.right===R.$rC)n.right=r,r.parent=n;else{const t=(0,R.$sC)(n.right);t.left=r,r.parent=t}return(0,R.$xC)(this,r),r}T(n,i){const r=new R.$qC(i,1);if(r.left=R.$rC,r.right=R.$rC,r.parent=R.$rC,r.size_left=0,r.lf_left=0,this.root===R.$rC)this.root=r,r.color=0;else if(n.left===R.$rC)n.left=r,r.parent=n;else{const s=(0,R.$tC)(n.left);s.right=r,r.parent=s}return(0,R.$xC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$KC=g}),define(ke[184],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0=e.$M0=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$M0=u;class N{constructor(R){this.identifier=R}}e.$N0=N}),define(ke[185],Ee([1,0,4,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$be,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,b){return this.a.set(w,b),this.handleChange([w]),(0,N.$Sc)(()=>{this.a.get(w)===b&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,b){this.b.get(w)?.dispose();const S=new R(this,w,b);return this.b.set(w,S),(0,N.$Sc)(()=>{const A=this.b.get(w);!A||A!==S||(this.b.delete(w),A.dispose())})}async getOrCreate(w){const b=this.get(w);if(b)return b;const S=this.b.get(w);return!S||S.isResolved?null:(await S.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const S=this.b.get(w);return!!(!S||S.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Mt=L;class R extends N.$Uc{get isResolved(){return this.c}constructor(w,b,S){super(),this.f=w,this.g=b,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(ke[186],Ee([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[187],Ee([1,0,4,3,186]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=A;class R extends N.$Uc{constructor($,k="",v="",c=!0,g){super(),this.h=this.B(new u.$be),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=k,this.u=v,this.w=c,this.C=g}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,k){this.C&&await this.C($)}}e.$8i=R;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$be),this.onWillRun=this.f.event,this.m=this.B(new u.$be),this.onDidRun=this.m.event}async run($,k){if(!$.enabled)return;this.f.fire({action:$});let v;try{await this.u($,k)}catch(c){v=c}this.m.fire({action:$,error:v})}async u($,k){await $.run(k)}}e.$9i=M;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let k=[];for(const v of $)v.length&&(k.length?k=[...k,new w,...v]:k=v);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=w;class b{get actions(){return this.a}constructor($,k,v,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=k,this.class=c,this.a=v}async run(){}}e.$$i=b;class S extends R{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,L.localize(0,null),void 0,!1)}}e.$_i=S;function A(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...$)=>C.run(...$),tooltip:C.label}}}),define(ke[188],Ee([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[189],Ee([1,0,188]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=S,e.$Wm=A,e.$Xm=C;const N=60,L=N*60,R=L*24,M=R*7,w=R*30,b=R*365;function S($,k,v,c){typeof $!="number"&&($=$.getTime());const g=Math.round((new Date().getTime()-$)/1e3);if(g<-30)return(0,u.localize)(0,null,S(new Date().getTime()+g*1e3,!1));if(!c&&g<30)return(0,u.localize)(1,null);let o;return g<N?(o=g,k?o===1?v?(0,u.localize)(2,null,o):(0,u.localize)(3,null,o):v?(0,u.localize)(4,null,o):(0,u.localize)(5,null,o):o===1?v?(0,u.localize)(6,null,o):(0,u.localize)(7,null,o):v?(0,u.localize)(8,null,o):(0,u.localize)(9,null,o)):g<L?(o=Math.floor(g/N),k?o===1?v?(0,u.localize)(10,null,o):(0,u.localize)(11,null,o):v?(0,u.localize)(12,null,o):(0,u.localize)(13,null,o):o===1?v?(0,u.localize)(14,null,o):(0,u.localize)(15,null,o):v?(0,u.localize)(16,null,o):(0,u.localize)(17,null,o)):g<R?(o=Math.floor(g/L),k?o===1?v?(0,u.localize)(18,null,o):(0,u.localize)(19,null,o):v?(0,u.localize)(20,null,o):(0,u.localize)(21,null,o):o===1?v?(0,u.localize)(22,null,o):(0,u.localize)(23,null,o):v?(0,u.localize)(24,null,o):(0,u.localize)(25,null,o)):g<M?(o=Math.floor(g/R),k?o===1?(0,u.localize)(26,null,o):(0,u.localize)(27,null,o):o===1?(0,u.localize)(28,null,o):(0,u.localize)(29,null,o)):g<w?(o=Math.floor(g/M),k?o===1?v?(0,u.localize)(30,null,o):(0,u.localize)(31,null,o):v?(0,u.localize)(32,null,o):(0,u.localize)(33,null,o):o===1?v?(0,u.localize)(34,null,o):(0,u.localize)(35,null,o):v?(0,u.localize)(36,null,o):(0,u.localize)(37,null,o)):g<b?(o=Math.floor(g/w),k?o===1?v?(0,u.localize)(38,null,o):(0,u.localize)(39,null,o):v?(0,u.localize)(40,null,o):(0,u.localize)(41,null,o):o===1?v?(0,u.localize)(42,null,o):(0,u.localize)(43,null,o):v?(0,u.localize)(44,null,o):(0,u.localize)(45,null,o)):(o=Math.floor(g/b),k?o===1?v?(0,u.localize)(46,null,o):(0,u.localize)(47,null,o):v?(0,u.localize)(48,null,o):(0,u.localize)(49,null,o):o===1?v?(0,u.localize)(50,null,o):(0,u.localize)(51,null,o):v?(0,u.localize)(52,null,o):(0,u.localize)(53,null,o))}function A($,k){const v=Math.abs($/1e3);return v<1?k?(0,u.localize)(54,null,$):(0,u.localize)(55,null,$):v<N?k?(0,u.localize)(56,null,Math.round($)/1e3):(0,u.localize)(57,null,Math.round($)/1e3):v<L?k?(0,u.localize)(58,null,Math.round($/(1e3*N))):(0,u.localize)(59,null,Math.round($/(1e3*N))):v<R?k?(0,u.localize)(60,null,Math.round($/(1e3*L))):(0,u.localize)(61,null,Math.round($/(1e3*L))):(0,u.localize)(62,null,Math.round($/(1e3*R)))}function C($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Ee([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Ee([1,0,19,18,190]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=b,e.$cj=S,e.$dj=A;function R(C,$){return $&&(C.stack||C.stacktrace)?L.localize(0,null,w(C),M(C.stack)||M(C.stacktrace)):w(C)}function M(C){return Array.isArray(C)?C.join(`
`):C}function w(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function b(C=null,$=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const k=u.$Hb(C),v=b(k[0],$);return k.length>1?L.localize(4,null,v,k.length):v}if(N.$4f(C))return C;if(C.detail){const k=C.detail;if(k.error)return R(k.error,$);if(k.exception)return R(k.exception,$)}return C.stack?R(C,$):C.message?C.message:L.localize(5,null)}function S(C){const $=C;return $ instanceof Error&&Array.isArray($.actions)}function A(C,$){let k;return typeof C=="string"?k=new Error(C):k=C,k.actions=$,k}}),define(ke[191],Ee([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,191]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=D,e.$J=p,e.$g="en";let N=!1,L=!1,R=!1,M=!1,w=!1,b=!1,S=!1,A=!1,C=!1,$=!1,k,v=e.$g,c=e.$g,g,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,S=r,C=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,v=e.$g;const E=i.env.VSCODE_NLS_CONFIG;if(E)try{const y=JSON.parse(E),P=y.availableLanguages["*"];k=y.locale,c=y.osLocale,v=P||e.$g,g=y._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,N=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,b=!0,k=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=k,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let d=0;L?d=1:N?d=3:R&&(d=2),e.$i=N,e.$j=L,e.$k=R,e.$l=M,e.$m=w,e.$n=S,e.$o=b,e.$p=b&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=$,e.$t=C,e.$u=d,e.$v=o,e.$w=v;var l;(function(E){function y(){return e.$w}E.value=y;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=P;function I(){return e.$w==="en"}E.isDefault=I})(l||(e.Language=l={})),e.$x=k,e.$y=c,e.$z=g,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const E=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,j=E.length;I<j;I++){const F=E[I];if(F.id===P.data.vscodeScheduleAsyncWork){E.splice(I,1),F.callback();return}}});let y=0;return P=>{const I=++y;E.push({id:I,callback:P}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return E=>setTimeout(E)})();var a;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=L||A?2:N?1:3;let h=!0,m=!1;function D(){if(!m){m=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,h=new Uint16Array(E.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function p(E){return parseFloat(E)>=20}}),define(ke[51],Ee([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Ee([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,R=90,M=122,w=46,b=47,S=92,A=58,C=63;class $ extends Error{constructor(f,d,l){let a;typeof d=="string"&&d.indexOf("not ")===0?(a="must not be",d=d.replace(/^not /,"")):a="must be";const h=f.indexOf(".")!==-1?"property":"argument";let m=`The "${f}" ${h} ${a} of type ${d}`;m+=`. Received type ${typeof l}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,f){if(t===null||typeof t!="object")throw new $(f,"Object",t)}function v(t,f){if(typeof t!="string")throw new $(f,"string",t)}const c=u.$ec==="win32";function g(t){return t===b||t===S}function o(t){return t===b}function n(t){return t>=N&&t<=R||t>=L&&t<=M}function i(t,f,d,l){let a="",h=0,m=-1,D=0,p=0;for(let E=0;E<=t.length;++E){if(E<t.length)p=t.charCodeAt(E);else{if(l(p))break;p=b}if(l(p)){if(!(m===E-1||D===1))if(D===2){if(a.length<2||h!==2||a.charCodeAt(a.length-1)!==w||a.charCodeAt(a.length-2)!==w){if(a.length>2){const y=a.lastIndexOf(d);y===-1?(a="",h=0):(a=a.slice(0,y),h=a.length-1-a.lastIndexOf(d)),m=E,D=0;continue}else if(a.length!==0){a="",h=0,m=E,D=0;continue}}f&&(a+=a.length>0?`${d}..`:"..",h=2)}else a.length>0?a+=`${d}${t.slice(m+1,E)}`:a=t.slice(m+1,E),h=E-m-1;m=E,D=0}else p===w&&D!==-1?++D:D=-1}return a}function r(t,f){k(f,"pathObject");const d=f.dir||f.root,l=f.base||`${f.name||""}${f.ext||""}`;return d?d===f.root?`${d}${l}`:`${d}${t}${l}`:l}e.$gc={resolve(...t){let f="",d="",l=!1;for(let a=t.length-1;a>=-1;a--){let h;if(a>=0){if(h=t[a],v(h,"path"),h.length===0)continue}else f.length===0?h=u.cwd():(h=u.env[`=${f}`]||u.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==f.toLowerCase()&&h.charCodeAt(2)===S)&&(h=`${f}\\`));const m=h.length;let D=0,p="",E=!1;const y=h.charCodeAt(0);if(m===1)g(y)&&(D=1,E=!0);else if(g(y))if(E=!0,g(h.charCodeAt(1))){let P=2,I=P;for(;P<m&&!g(h.charCodeAt(P));)P++;if(P<m&&P!==I){const j=h.slice(I,P);for(I=P;P<m&&g(h.charCodeAt(P));)P++;if(P<m&&P!==I){for(I=P;P<m&&!g(h.charCodeAt(P));)P++;(P===m||P!==I)&&(p=`\\\\${j}\\${h.slice(I,P)}`,D=P)}}}else D=1;else n(y)&&h.charCodeAt(1)===A&&(p=h.slice(0,2),D=2,m>2&&g(h.charCodeAt(2))&&(E=!0,D=3));if(p.length>0)if(f.length>0){if(p.toLowerCase()!==f.toLowerCase())continue}else f=p;if(l){if(f.length>0)break}else if(d=`${h.slice(D)}\\${d}`,l=E,E&&f.length>0)break}return d=i(d,!l,"\\",g),l?`${f}\\${d}`:`${f}${d}`||"."},normalize(t){v(t,"path");const f=t.length;if(f===0)return".";let d=0,l,a=!1;const h=t.charCodeAt(0);if(f===1)return o(h)?"\\":t;if(g(h))if(a=!0,g(t.charCodeAt(1))){let D=2,p=D;for(;D<f&&!g(t.charCodeAt(D));)D++;if(D<f&&D!==p){const E=t.slice(p,D);for(p=D;D<f&&g(t.charCodeAt(D));)D++;if(D<f&&D!==p){for(p=D;D<f&&!g(t.charCodeAt(D));)D++;if(D===f)return`\\\\${E}\\${t.slice(p)}\\`;D!==p&&(l=`\\\\${E}\\${t.slice(p,D)}`,d=D)}}}else d=1;else n(h)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),d=2,f>2&&g(t.charCodeAt(2))&&(a=!0,d=3));let m=d<f?i(t.slice(d),!a,"\\",g):"";return m.length===0&&!a&&(m="."),m.length>0&&g(t.charCodeAt(f-1))&&(m+="\\"),l===void 0?a?`\\${m}`:m:a?`${l}\\${m}`:`${l}${m}`},isAbsolute(t){v(t,"path");const f=t.length;if(f===0)return!1;const d=t.charCodeAt(0);return g(d)||f>2&&n(d)&&t.charCodeAt(1)===A&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,d;for(let h=0;h<t.length;++h){const m=t[h];v(m,"path"),m.length>0&&(f===void 0?f=d=m:f+=`\\${m}`)}if(f===void 0)return".";let l=!0,a=0;if(typeof d=="string"&&g(d.charCodeAt(0))){++a;const h=d.length;h>1&&g(d.charCodeAt(1))&&(++a,h>2&&(g(d.charCodeAt(2))?++a:l=!1))}if(l){for(;a<f.length&&g(f.charCodeAt(a));)a++;a>=2&&(f=`\\${f.slice(a)}`)}return e.$gc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f)return"";const d=e.$gc.resolve(t),l=e.$gc.resolve(f);if(d===l||(t=d.toLowerCase(),f=l.toLowerCase(),t===f))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===S;)a++;let h=t.length;for(;h-1>a&&t.charCodeAt(h-1)===S;)h--;const m=h-a;let D=0;for(;D<f.length&&f.charCodeAt(D)===S;)D++;let p=f.length;for(;p-1>D&&f.charCodeAt(p-1)===S;)p--;const E=p-D,y=m<E?m:E;let P=-1,I=0;for(;I<y;I++){const F=t.charCodeAt(a+I);if(F!==f.charCodeAt(D+I))break;F===S&&(P=I)}if(I!==y){if(P===-1)return l}else{if(E>y){if(f.charCodeAt(D+I)===S)return l.slice(D+I+1);if(I===2)return l.slice(D+I)}m>y&&(t.charCodeAt(a+I)===S?P=I:I===2&&(P=3)),P===-1&&(P=0)}let j="";for(I=a+P+1;I<=h;++I)(I===h||t.charCodeAt(I)===S)&&(j+=j.length===0?"..":"\\..");return D+=P,j.length>0?`${j}${l.slice(D,p)}`:(l.charCodeAt(D)===S&&++D,l.slice(D,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$gc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===S){if(f.charCodeAt(1)===S){const d=f.charCodeAt(2);if(d!==C&&d!==w)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===A&&f.charCodeAt(2)===S)return`\\\\?\\${f}`;return t},dirname(t){v(t,"path");const f=t.length;if(f===0)return".";let d=-1,l=0;const a=t.charCodeAt(0);if(f===1)return g(a)?t:".";if(g(a)){if(d=l=1,g(t.charCodeAt(1))){let D=2,p=D;for(;D<f&&!g(t.charCodeAt(D));)D++;if(D<f&&D!==p){for(p=D;D<f&&g(t.charCodeAt(D));)D++;if(D<f&&D!==p){for(p=D;D<f&&!g(t.charCodeAt(D));)D++;if(D===f)return t;D!==p&&(d=l=D+1)}}}}else n(a)&&t.charCodeAt(1)===A&&(d=f>2&&g(t.charCodeAt(2))?3:2,l=d);let h=-1,m=!0;for(let D=f-1;D>=l;--D)if(g(t.charCodeAt(D))){if(!m){h=D;break}}else m=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,a=!0,h;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let m=f.length-1,D=-1;for(h=t.length-1;h>=d;--h){const p=t.charCodeAt(h);if(g(p)){if(!a){d=h+1;break}}else D===-1&&(a=!1,D=h+1),m>=0&&(p===f.charCodeAt(m)?--m===-1&&(l=h):(m=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(g(t.charCodeAt(h))){if(!a){d=h+1;break}}else l===-1&&(a=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=0,d=-1,l=0,a=-1,h=!0,m=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(f=l=2);for(let D=t.length-1;D>=f;--D){const p=t.charCodeAt(D);if(g(p)){if(!h){l=D+1;break}continue}a===-1&&(h=!1,a=D+1),p===w?d===-1?d=D:m!==1&&(m=1):d!==-1&&(m=-1)}return d===-1||a===-1||m===0||m===1&&d===a-1&&d===l+1?"":t.slice(d,a)},format:r.bind(null,"\\"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.length;let l=0,a=t.charCodeAt(0);if(d===1)return g(a)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(g(a)){if(l=1,g(t.charCodeAt(1))){let P=2,I=P;for(;P<d&&!g(t.charCodeAt(P));)P++;if(P<d&&P!==I){for(I=P;P<d&&g(t.charCodeAt(P));)P++;if(P<d&&P!==I){for(I=P;P<d&&!g(t.charCodeAt(P));)P++;P===d?l=P:P!==I&&(l=P+1)}}}}else if(n(a)&&t.charCodeAt(1)===A){if(d<=2)return f.root=f.dir=t,f;if(l=2,g(t.charCodeAt(2))){if(d===3)return f.root=f.dir=t,f;l=3}}l>0&&(f.root=t.slice(0,l));let h=-1,m=l,D=-1,p=!0,E=t.length-1,y=0;for(;E>=l;--E){if(a=t.charCodeAt(E),g(a)){if(!p){m=E+1;break}continue}D===-1&&(p=!1,D=E+1),a===w?h===-1?h=E:y!==1&&(y=1):h!==-1&&(y=-1)}return D!==-1&&(h===-1||y===0||y===1&&h===D-1&&h===m+1?f.base=f.name=t.slice(m,D):(f.name=t.slice(m,h),f.base=t.slice(m,D),f.ext=t.slice(h,D))),m>0&&m!==l?f.dir=t.slice(0,m-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(c){const t=/\\/g;return()=>{const f=u.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let f="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const a=l>=0?t[l]:s();v(a,"path"),a.length!==0&&(f=`${a}/${f}`,d=a.charCodeAt(0)===b)}return f=i(f,!d,"/",o),d?`/${f}`:f.length>0?f:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===b,d=t.charCodeAt(t.length-1)===b;return t=i(t,!f,"/",o),t.length===0?f?"/":d?"./":".":(d&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let f;for(let d=0;d<t.length;++d){const l=t[d];v(l,"path"),l.length>0&&(f===void 0?f=l:f+=`/${l}`)}return f===void 0?".":e.$hc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f||(t=e.$hc.resolve(t),f=e.$hc.resolve(f),t===f))return"";const d=1,l=t.length,a=l-d,h=1,m=f.length-h,D=a<m?a:m;let p=-1,E=0;for(;E<D;E++){const P=t.charCodeAt(d+E);if(P!==f.charCodeAt(h+E))break;P===b&&(p=E)}if(E===D)if(m>D){if(f.charCodeAt(h+E)===b)return f.slice(h+E+1);if(E===0)return f.slice(h+E)}else a>D&&(t.charCodeAt(d+E)===b?p=E:E===0&&(p=0));let y="";for(E=d+p+1;E<=l;++E)(E===l||t.charCodeAt(E)===b)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(h+p)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===b;let d=-1,l=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===b){if(!l){d=a;break}}else l=!1;return d===-1?f?"/":".":f&&d===1?"//":t.slice(0,d)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,a=!0,h;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let m=f.length-1,D=-1;for(h=t.length-1;h>=0;--h){const p=t.charCodeAt(h);if(p===b){if(!a){d=h+1;break}}else D===-1&&(a=!1,D=h+1),m>=0&&(p===f.charCodeAt(m)?--m===-1&&(l=h):(m=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===b){if(!a){d=h+1;break}}else l===-1&&(a=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=-1,d=0,l=-1,a=!0,h=0;for(let m=t.length-1;m>=0;--m){const D=t.charCodeAt(m);if(D===b){if(!a){d=m+1;break}continue}l===-1&&(a=!1,l=m+1),D===w?f===-1?f=m:h!==1&&(h=1):f!==-1&&(h=-1)}return f===-1||l===-1||h===0||h===1&&f===l-1&&f===d+1?"":t.slice(f,l)},format:r.bind(null,"/"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.charCodeAt(0)===b;let l;d?(f.root="/",l=1):l=0;let a=-1,h=0,m=-1,D=!0,p=t.length-1,E=0;for(;p>=l;--p){const y=t.charCodeAt(p);if(y===b){if(!D){h=p+1;break}continue}m===-1&&(D=!1,m=p+1),y===w?a===-1?a=p:E!==1&&(E=1):a!==-1&&(E=-1)}if(m!==-1){const y=h===0&&d?1:h;a===-1||E===0||E===1&&a===m-1&&a===h+1?f.base=f.name=t.slice(y,m):(f.name=t.slice(y,a),f.base=t.slice(y,m),f.ext=t.slice(a,m))}return h>0?f.dir=t.slice(0,h-1):d&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,46,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=w,e.$_q=b,e.$ar=S,e.$br=A,e.$cr=C,e.$dr=$,e.$er=k,e.$fr=v,e.$gr=c,e.$hr=g,e.$ir=a,e.$jr=h,e.$kr=m;const L=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(D,p,E=!1){const y=D||"",P=p||"",I=L.value.collator.compare(y,P);return L.value.collatorIsNumeric&&I===0&&y!==P?y<P?-1:1:I}function b(D,p){const E=R.value.collator;return D=D||"",p=p||"",r(E,D,p)}function S(D,p){const E=R.value.collator;return D=D||"",p=p||"",d(D,p)||r(E,D,p)}function A(D,p){const E=R.value.collator;return D=D||"",p=p||"",f(D,p)||r(E,D,p)}function C(D,p){return D=D||"",p=p||"",D===p?0:D<p?-1:1}function $(D,p){const[E,y]=n(D),[P,I]=n(p);let j=L.value.collator.compare(y,I);if(j===0){if(L.value.collatorIsNumeric&&y!==I)return y<I?-1:1;if(j=L.value.collator.compare(E,P),L.value.collatorIsNumeric&&j===0&&E!==P)return E<P?-1:1}return j}function k(D,p){D=D||"",p=p||"";const E=i(D),y=i(p),P=R.value.collator,I=M.value.collator;return r(I,E,y)||r(P,D,p)}function v(D,p){D=D||"",p=p||"";const E=i(D),y=i(p),P=R.value.collator,I=M.value.collator;return r(I,E,y)||d(D,p)||r(P,D,p)}function c(D,p){D=D||"",p=p||"";const E=i(D),y=i(p),P=R.value.collator,I=M.value.collator;return r(I,E,y)||f(D,p)||r(P,D,p)}function g(D,p){D=D||"",p=p||"";const E=i(D).toLowerCase(),y=i(p).toLowerCase();return E!==y?E<y?-1:1:D!==p?D<p?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(D,p=!1){const E=D?o.exec(D):[];let y=[E&&E[1]||"",E&&E[3]||""];return p&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const p=D?o.exec(D):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function r(D,p,E){const y=D.compare(p,E);return y!==0?y:p.length!==E.length?p.length<E.length?-1:1:0}function s(D){const p=D.charAt(0);return p.toLocaleUpperCase()!==p}function t(D){const p=D.charAt(0);return p.toLocaleLowerCase()!==p}function f(D,p){return s(D)&&t(p)?-1:t(D)&&s(p)?1:0}function d(D,p){return t(D)&&s(p)?-1:s(D)&&t(p)?1:0}function l(D,p,E=!1){return E||(D=D&&D.toLowerCase(),p=p&&p.toLowerCase()),D===p?0:D<p?-1:1}function a(D,p,E=!1){const y=D.split(N.sep),P=p.split(N.sep),I=y.length-1,j=P.length-1;let F,z;for(let O=0;;O++){if(F=I===O,z=j===O,F&&z)return w(y[O],P[O],E);if(F)return-1;if(z)return 1;const T=l(y[O],P[O],E);if(T!==0)return T}}function h(D,p,E){const y=D.toLowerCase(),P=p.toLowerCase(),I=m(D,p,E);if(I)return I;const j=y.endsWith(E),F=P.endsWith(E);if(j!==F)return j?-1:1;const z=w(y,P);return z!==0?z:y.localeCompare(P)}function m(D,p,E){const y=D.toLowerCase(),P=p.toLowerCase(),I=y.startsWith(E),j=P.startsWith(E);if(I!==j)return I?-1:1;if(I&&j){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=w,e.$lg=b,e.$mg=S,e.$ng=A,e.$og=v,e.$pg=c,e.$qg=g,e.$rg=o,e.$sg=n,e.$tg=i,e.$ug=r,e.$vg=s,e.$wg=t,e.$xg=f,e.$yg=a;function M(h){return h===47||h===92}function w(h){return h.replace(/[\\/]/g,u.$hc.sep)}function b(h){return h.indexOf("/")===-1&&(h=w(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function S(h,m=u.$hc.sep){if(!h)return"";const D=h.length,p=h.charCodeAt(0);if(M(p)){if(M(h.charCodeAt(1))&&!M(h.charCodeAt(2))){let y=3;const P=y;for(;y<D&&!M(h.charCodeAt(y));y++);if(P!==y&&!M(h.charCodeAt(y+1))){for(y+=1;y<D;y++)if(M(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,m)}}return m}else if(o(p)&&h.charCodeAt(1)===58)return M(h.charCodeAt(2))?h.slice(0,2)+m:h.slice(0,2);let E=h.indexOf("://");if(E!==-1){for(E+=3;E<D;E++)if(M(h.charCodeAt(E)))return h.slice(0,E+1)}return""}function A(h){if(!N.$i||!h||h.length<5)return!1;let m=h.charCodeAt(0);if(m!==92||(m=h.charCodeAt(1),m!==92))return!1;let D=2;const p=D;for(;D<h.length&&(m=h.charCodeAt(D),m!==92);D++);return!(p===D||(m=h.charCodeAt(D+1),isNaN(m)||m===92))}const C=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(h,m=N.$i){const D=m?C:$;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||m&&k.test(h)||h==="."||h===".."||m&&h[h.length-1]==="."||m&&h.length!==h.trim().length||h.length>255)}function c(h,m,D){const p=h===m;return!D||p?p:!h||!m?!1:(0,L.$tf)(h,m)}function g(h,m,D,p=u.sep){if(h===m)return!0;if(!h||!m||m.length>h.length)return!1;if(D){if(!(0,L.$uf)(h,m))return!1;if(m.length===h.length)return!0;let y=m.length;return m.charAt(m.length-1)===p&&y--,h.charAt(y)===p}return m.charAt(m.length-1)!==p&&(m+=p),h.indexOf(m)===0}function o(h){return h>=65&&h<=90||h>=97&&h<=122}function n(h,m){return N.$i&&h.endsWith(":")&&(h+=u.sep),(0,u.$jc)(h)||(h=(0,u.$kc)(m,h)),h=(0,u.$ic)(h),N.$i?(h=(0,L.$bf)(h,u.sep),h.endsWith(":")&&(h+=u.sep)):(h=(0,L.$bf)(h,u.sep),h||(h=u.sep)),h}function i(h){const m=(0,u.$ic)(h);return N.$i?h.length>3?!1:r(m)&&(h.length===2||m.charCodeAt(2)===92):m===u.$hc.sep}function r(h,m=N.$i){return m?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function s(h,m=N.$i){return r(h,m)?h[0]:void 0}function t(h,m,D){return m.length>h.length?-1:h===m?0:(D&&(h=h.toLowerCase(),m=m.toLowerCase()),h.indexOf(m))}function f(h){const m=h.split(":");let D,p,E;for(const y of m){const P=Number(y);(0,R.$8f)(P)?p===void 0?p=P:E===void 0&&(E=P):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:p!==void 0?p:void 0,column:E!==void 0?E:p!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(h,m,D=8){let p="";for(let y=0;y<D;y++){let P;y===0&&N.$i&&!m&&(D===3||D===4)?P=l:P=d,p+=P.charAt(Math.floor(Math.random()*P.length))}let E;return m?E=`${m}-${p}`:E=p,h?(0,u.$kc)(h,E):E}}),define(ke[132],Ee([1,0,131,126,56,17,11,14]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=A,e.$mr=g,e.$nr=d,e.$or=E,e.$pr=z,e.$qr=T;const b=0,S=[b,[]];function A(B,W,X,x){if(!B||!W)return S;const Z=B.length,Y=W.length;if(Z<Y)return S;const ce=B.toLowerCase();return C(W,X,Y,B,ce,Z,x)}function C(B,W,X,x,Z,Y,ce){const ne=[],$e=[];for(let ie=0;ie<X;ie++){const be=ie*Y,Ce=be-Y,oe=ie>0,ae=B[ie],re=W[ie];for(let G=0;G<Y;G++){const te=G>0,ge=be+G,we=ge-1,Re=Ce+G-1,fe=te?ne[we]:0,Se=oe&&te?ne[Re]:0,Ae=oe&&te?$e[Re]:0;let je;!Se&&oe?je=0:je=$(ae,re,x,Z,G,Ae),je&&Se+je>=fe&&(ce||oe||Z.startsWith(W,G))?($e[ge]=Ae+1,ne[ge]=Se+je):($e[ge]=b,ne[ge]=fe)}}const Pe=[];let _=X-1,U=Y-1;for(;_>=0&&U>=0;){const ie=_*Y+U;$e[ie]===b||(Pe.push(U),_--),U--}return[ne[X*Y-1],Pe.reverse()]}function $(B,W,X,x,Z,Y){let ce=0;if(!k(W,x[Z]))return ce;if(ce+=1,Y>0&&(ce+=Y*5),B===X[Z]&&(ce+=1),Z===0)ce+=8;else{const ne=v(X.charCodeAt(Z-1));ne?ce+=ne:(0,N.$vk)(X.charCodeAt(Z))&&Y===0&&(ce+=2)}return ce}function k(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function g(B,W,X=0,x=0){const Z=W;return Z.values&&Z.values.length>1?o(B,Z.values,X,x):n(B,W,X,x)}function o(B,W,X,x){let Z=0;const Y=[];for(const ce of W){const[ne,$e]=n(B,ce,X,x);if(typeof ne!="number")return c;Z+=ne,Y.push(...$e)}return[Z,D(Y)]}function n(B,W,X,x){const Z=(0,N.$Ek)(W.original,W.originalLowercase,X,B,B.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,N.$Bk)(Z)]:c}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(B,W,X,x){const Z=x.values?x.values:[x];return(0,L.$ej)({[x.normalized]:{values:Z.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:X}})}function d(B,W,X,x,Z){if(!B||!W.normalized)return i;const Y=x.getItemLabel(B);if(!Y)return i;const ce=x.getItemDescription(B),ne=f(Y,ce,X,W),$e=Z[ne];if($e)return $e;const Pe=l(Y,ce,x.getItemPath(B),W,X);return Z[ne]=Pe,Pe}function l(B,W,X,x,Z){const Y=!X||!x.containsPathSeparator;return X&&(M.$k?x.pathNormalized===X:(0,w.$tf)(x.pathNormalized,X))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:x.values&&x.values.length>1?a(B,W,X,x.values,Y,Z):h(B,W,X,x,Y,Z)}function a(B,W,X,x,Z,Y){let ce=0;const ne=[],$e=[];for(const Pe of x){const{score:_,labelMatch:U,descriptionMatch:ie}=h(B,W,X,Pe,Z,Y);if(_===b)return i;ce+=_,U&&ne.push(...U),ie&&$e.push(...ie)}return{score:ce,labelMatch:D(ne),descriptionMatch:D($e)}}function h(B,W,X,x,Z,Y){if(Z||!W){const[ce,ne]=A(B,x.normalized,x.normalizedLowercase,Y&&!x.expectContiguousMatch);if(ce){const $e=(0,N.$sk)(x.normalized,B);let Pe;if($e){Pe=s;const _=Math.round(x.normalized.length/B.length*100);Pe+=_}else Pe=t;return{score:Pe+ce,labelMatch:$e||m(ne)}}}if(W){let ce=W;X&&(ce=`${W}${R.sep}`);const ne=ce.length,$e=`${ce}${B}`,[Pe,_]=A($e,x.normalized,x.normalizedLowercase,Y&&!x.expectContiguousMatch);if(Pe){const U=m(_),ie=[],be=[];return U.forEach(Ce=>{Ce.start<ne&&Ce.end>ne?(ie.push({start:0,end:Ce.end-ne}),be.push({start:Ce.start,end:ne})):Ce.start>=ne?ie.push({start:Ce.start-ne,end:Ce.end-ne}):be.push(Ce)}),{score:Pe,labelMatch:ie,descriptionMatch:be}}}return i}function m(B){const W=[];if(!B)return W;let X;for(const x of B)X&&X.end===x?X.end+=1:(X={start:x,end:x+1},W.push(X));return W}function D(B){const W=B.sort((Z,Y)=>Z.start-Y.start),X=[];let x;for(const Z of W)!x||!p(x,Z)?(x=Z,X.push(Z)):(x.start=Math.min(x.start,Z.start),x.end=Math.max(x.end,Z.end));return X}function p(B,W){return!(B.end<W.start||W.end<B.start)}function E(B,W,X,x,Z,Y){const ce=d(B,X,x,Z,Y),ne=d(W,X,x,Z,Y),$e=ce.score,Pe=ne.score;if(($e===r||Pe===r)&&$e!==Pe)return $e===r?-1:1;if($e>t||Pe>t){if($e!==Pe)return $e>Pe?-1:1;if($e<s&&Pe<s){const ae=P(ce.labelMatch,ne.labelMatch);if(ae!==0)return ae}const Ce=Z.getItemLabel(B)||"",oe=Z.getItemLabel(W)||"";if(Ce.length!==oe.length)return Ce.length-oe.length}if($e!==Pe)return $e>Pe?-1:1;const _=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,U=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(_&&!U)return-1;if(U&&!_)return 1;const ie=y(B,ce,Z),be=y(W,ne,Z);return ie&&be&&ie!==be?be>ie?-1:1:I(B,W,X,Z)}function y(B,W,X){let x=-1,Z=-1;if(W.descriptionMatch&&W.descriptionMatch.length?x=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(x=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(Z=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Y=X.getItemDescription(B);Y&&(Z+=Y.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(Z=W.descriptionMatch[W.descriptionMatch.length-1].end);return Z-x}function P(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const X=B[0].start,Z=B[B.length-1].end-X,Y=W[0].start,ne=W[W.length-1].end-Y;return Z===ne?0:ne<Z?1:-1}function I(B,W,X,x){const Z=x.getItemLabel(B)||"",Y=x.getItemLabel(W)||"",ce=x.getItemDescription(B),ne=x.getItemDescription(W),$e=Z.length+(ce?ce.length:0),Pe=Y.length+(ne?ne.length:0);if($e!==Pe)return $e-Pe;const _=x.getItemPath(B),U=x.getItemPath(W);return _&&U&&_.length!==U.length?_.length-U.length:Z!==Y?(0,u.$jr)(Z,Y,X.normalized):ce&&ne&&ce!==ne?(0,u.$jr)(ce,ne,X.normalized):_&&U&&_!==U?(0,u.$jr)(_,U,X.normalized):0}function j(B){return B.startsWith('"')&&B.endsWith('"')}const F=" ";function z(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:X,normalized:x,normalizedLowercase:Z}=O(B),Y=X.indexOf(R.sep)>=0,ce=j(B);let ne;const $e=B.split(F);if($e.length>1)for(const Pe of $e){const _=j(Pe),{pathNormalized:U,normalized:ie,normalizedLowercase:be}=O(Pe);ie&&(ne||(ne=[]),ne.push({original:Pe,originalLowercase:Pe.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:be,expectContiguousMatch:_}))}return{original:B,originalLowercase:W,pathNormalized:X,normalized:x,normalizedLowercase:Z,values:ne,containsPathSeparator:Y,expectContiguousMatch:ce}}function O(B){let W;M.$i?W=B.replace(/\//g,R.sep):W=B.replace(/\\/g,R.sep);const X=(0,w.$df)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:X,normalizedLowercase:X.toLowerCase()}}function T(B){return Array.isArray(B)?z(B.map(W=>W.original).join(F)):z(B.original)}}),define(ke[101],Ee([1,0,17]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=R,e.$Js=M,e.$Ks=w,e.$Ls=S,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const C=(0,u.$pc)(A),$=N[C.toLowerCase()];return $!==void 0?$:M(A)}function M(A){const C=(0,u.$pc)(A);return L[C.toLowerCase()]}function w(A){for(const C in L)if(L[C]===A)return C}const b=/^(.+)\/(.+?)(;.+)?$/;function S(A,C){const $=b.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:C?void 0:A}}),define(ke[102],Ee([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$gm=R,e.$hm=M;var N;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(w,...b){const S=b.reduce(($,k)=>($[k]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter($=>!S[$]).forEach($=>{for(let k=0;k<A.length;k++)if($.search(A[k])!==-1){delete w[$];break}})}function M(w){w&&(delete w.DEBUG,u.$j&&delete w.DYLD_LIBRARY_PATH,u.$k&&delete w.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=r;const L=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function w(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!L.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!R.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(l,a){return!l&&!a?"file":l}function S(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const A="",C="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(a){return a instanceof k?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,h,m,D,p,E=!1){typeof a=="object"?(this.scheme=a.scheme||A,this.authority=a.authority||A,this.path=a.path||A,this.query=a.query||A,this.fragment=a.fragment||A):(this.scheme=b(a,E),this.authority=h||A,this.path=S(this.scheme,m||A),this.query=D||A,this.fragment=p||A,w(this,E))}get fsPath(){return r(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:m,path:D,query:p,fragment:E}=a;return h===void 0?h=this.scheme:h===null&&(h=A),m===void 0?m=this.authority:m===null&&(m=A),D===void 0?D=this.path:D===null&&(D=A),p===void 0?p=this.query:p===null&&(p=A),E===void 0?E=this.fragment:E===null&&(E=A),h===this.scheme&&m===this.authority&&D===this.path&&p===this.query&&E===this.fragment?this:new g(h,m,D,p,E)}static parse(a,h=!1){const m=$.exec(a);return m?new g(m[2]||A,d(m[4]||A),d(m[5]||A),d(m[7]||A),d(m[9]||A),h):new g(A,A,A,A,A)}static file(a){let h=A;if(N.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const m=a.indexOf(C,2);m===-1?(h=a.substring(2),a=C):(h=a.substring(2,m),a=a.substring(m)||C)}return new g("file",h,a,A,A)}static from(a,h){return new g(a.scheme,a.authority,a.path,a.query,a.fragment,h)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return N.$i&&a.scheme==="file"?m=k.file(u.$gc.join(r(a,!0),...h)).path:m=u.$hc.join(a.path,...h),a.with({path:m})}toString(a=!1){return s(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof k)return a;{const h=new g(a);return h._formatted=a.external??null,h._fsPath=a._sep===c?a.fsPath??null:null,h}}else return a}}e.URI=k;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const c=N.$i?1:void 0;class g extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(a=!1){return a?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=c),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,a,h){let m,D=-1;for(let p=0;p<l.length;p++){const E=l.charCodeAt(p);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||a&&E===47||h&&E===91||h&&E===93||h&&E===58)D!==-1&&(m+=encodeURIComponent(l.substring(D,p)),D=-1),m!==void 0&&(m+=l.charAt(p));else{m===void 0&&(m=l.substr(0,p));const y=o[E];y!==void 0?(D!==-1&&(m+=encodeURIComponent(l.substring(D,p)),D=-1),m+=y):D===-1&&(D=p)}}return D!==-1&&(m+=encodeURIComponent(l.substring(D))),m!==void 0?m:l}function i(l){let a;for(let h=0;h<l.length;h++){const m=l.charCodeAt(h);m===35||m===63?(a===void 0&&(a=l.substr(0,h)),a+=o[m]):a!==void 0&&(a+=l[h])}return a!==void 0?a:l}function r(l,a){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,N.$i&&(h=h.replace(/\//g,"\\")),h}function s(l,a){const h=a?i:n;let m="",{scheme:D,authority:p,path:E,query:y,fragment:P}=l;if(D&&(m+=D,m+=":"),(p||D==="file")&&(m+=C,m+=C),p){let I=p.indexOf("@");if(I!==-1){const j=p.substr(0,I);p=p.substr(I+1),I=j.lastIndexOf(":"),I===-1?m+=h(j,!1,!1):(m+=h(j.substr(0,I),!1,!1),m+=":",m+=h(j.substr(I+1),!1,!0)),m+="@"}p=p.toLowerCase(),I=p.lastIndexOf(":"),I===-1?m+=h(p,!1,!0):(m+=h(p.substr(0,I),!1,!0),m+=p.substr(I))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const I=E.charCodeAt(1);I>=65&&I<=90&&(E=`/${String.fromCharCode(I+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const I=E.charCodeAt(0);I>=65&&I<=90&&(E=`${String.fromCharCode(I+32)}:${E.substr(2)}`)}m+=h(E,!0,!1)}return y&&(m+="?",m+=h(y,!1,!1)),P&&(m+="#",m+=a?P:n(P,!1,!1)),m}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(f)?l.replace(f,a=>t(a)):l}}),define(ke[192],Ee([1,0,2]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=N,e.$Oq=L,e.$Pq=R,e.log=w;function N(S){const A=S;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(S){const A=[];let C;try{const $=JSON.parse(S.arguments),k=$[$.length-1];k&&k.__$stack&&($.pop(),C=k.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",S.arguments)}return{args:A,stack:C}}function R(S){if(typeof S!="string")return R(L(S).stack);const A=S;if(A){const C=M(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if($&&$.length===4)return{uri:u.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function M(S){if(!S)return S;const A=S.indexOf(`
`);return A===-1?S:S.substring(0,A)}function w(S,A){const{args:C,stack:$}=L(S),k=typeof C[0]=="string"&&C.length===1;let v=M($);v&&(v=`(${v.trim()})`);let c=[];if(typeof C[0]=="string"?v&&k?c=[`%c[${A}] %c${C[0]} %c${v}`,b("blue"),b(""),b("grey")]:c=[`%c[${A}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:c=[`%c[${A}]%`,b("blue"),...C],v&&!k&&c.push(v),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,c)}function b(S){return`color: ${S}`}}),define(ke[58],Ee([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=L,e.$Yh=R,e.$Zh=w;function L(b){return JSON.stringify(b,M)}function R(b){let S=JSON.parse(b);return S=w(S),S}function M(b,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function w(b,S=0){if(!b||S>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return N.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof u.$Ce||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let A=0;A<b.length;++A)b[A]=w(b[A],S+1);else for(const A in b)Object.hasOwnProperty.call(b,A)&&(b[A]=w(b[A],S+1))}return b}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=b,e.$Ag=S,e.$Eg=C;var w;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(w||(e.Schemas=w={}));function b(v,c){return R.URI.isUri(v)?(0,L.$tf)(v.scheme,c):(0,L.$uf)(v,c+":")}function S(v,...c){return c.some(g=>b(v,g))}e.$Bg="vscode-tkn",e.$Cg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,g){this.f=C(c,g)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,w.vscodeRemoteResource)}set(c,g,o){this.a[c]=g,this.b[c]=o}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(s){return u.$1(s),c}const g=c.authority;let o=this.a[g];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[g],i=this.c[g];let r=`path=${encodeURIComponent(c.path)}`;return typeof i=="string"&&(r+=`&${e.$Cg}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$o?this.d:w.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:r})}}e.$Dg=new A;function C(v,c){return M.$hc.join(c??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class ${static{this.a=e.$Jg}asBrowserUri(c){const g=this.b(c,le);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===w.vscodeRemote?e.$Dg.rewrite(c):c.scheme===w.file&&(N.$m||N.$q===`${w.vscodeFileResource}://${$.a}`)?c.with({scheme:w.vscodeFileResource,authority:c.authority||$.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,le);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===w.vscodeFileResource?c.with({scheme:w.file,authority:c.authority!==$.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return R.URI.isUri(c)?c:R.URI.parse(g.toUrl(c))}}e.$Kg=new $;var k;(function(v){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:R.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(g);if(s)return c.get(s)}v.getHeadersFromQuery=o;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(g,t):i[g]=t}v.addSearchParam=n})(k||(e.COI=k={}))}),define(ke[193],Ee([1,0,162,15,11,2]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=A;class M{constructor($,k,v){this.id=$,this.dependencies=k,this.callback=v}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,k,v)=>{typeof $!="string"&&(v=k,k=$,$=null),(typeof k!="object"||!Array.isArray(k))&&(v=k,k=null),this.c.push(new M($,k,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const k=await(this.a?this.i($):this.b?this.h($):this.j($));if(!k)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h($){return new Promise((k,v)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",o),c.removeEventListener("error",n)},o=i=>{g(),k(this.c.pop())},n=i=>{g(),v(i)};c.addEventListener("load",o),c.addEventListener("error",n),this.f&&($=this.f.createScriptURL($)),c.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(c)})}i($){return new Promise((k,v)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),k(this.c.pop())}catch(c){v(c)}})}async j($){try{const k=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse($).fsPath,o=k.readFileSync(g).toString(),n=c.wrap(o.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const b=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function A(C,$,k){if(u.$T){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[C]&&(C=S[C]);const v=`${C}/${$}`;if(b.has(v))return b.get(v);let c;if(/^\w[\w\d+.-]*:\/\//.test(v))c=v;else{const i=`${k&&!L.$o?N.$Hg:N.$Gg}/${v}`;c=N.$Kg.asBrowserUri(i).toString(!0)}const g=w.INSTANCE.load(c);return b.set(v,g),g}else return await new Promise((v,c)=>{le([C],v,c)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=b,e.$ah=A,e.$bh=$;function b(k){return(0,w.$xc)(k,!0)}class S{constructor(v){this.a=v}compare(v,c,g=!1){return v===c?0:(0,M.$mf)(this.getComparisonKey(v,g),this.getComparisonKey(c,g))}isEqual(v,c,g=!1){return v===c?!0:!v||!c?!1:this.getComparisonKey(v,g)===this.getComparisonKey(c,g)}getComparisonKey(v,c=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,c,g=!1){if(v.scheme===c.scheme){if(v.scheme===N.Schemas.file)return u.$qg(b(v),b(c),this.a(v))&&v.query===c.query&&(g||v.fragment===c.fragment);if((0,e.$9g)(v.authority,c.authority))return u.$qg(v.path,c.path,this.a(v),"/")&&v.query===c.query&&(g||v.fragment===c.fragment)}return!1}joinPath(v,...c){return w.URI.joinPath(v,...c)}basenameOrAuthority(v){return(0,e.$1g)(v)||v.authority}basename(v){return L.$hc.basename(v.path)}extname(v){return L.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let c;return v.scheme===N.Schemas.file?c=w.URI.file(L.$nc(b(v))).path:(c=L.$hc.dirname(v.path),v.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),c="/")),v.with({path:c})}normalizePath(v){if(!v.path.length)return v;let c;return v.scheme===N.Schemas.file?c=w.URI.file(L.$ic(b(v))).path:c=L.$hc.normalize(v.path),v.with({path:c})}relativePath(v,c){if(v.scheme!==c.scheme||!(0,e.$9g)(v.authority,c.authority))return;if(v.scheme===N.Schemas.file){const n=L.$mc(b(v),b(c));return R.$i?u.$kg(n):n}let g=v.path||"/";const o=c.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(g.length,o.length);n<i&&!(g.charCodeAt(n)!==o.charCodeAt(n)&&g.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);g=o.substr(0,n)+g.substr(n)}return L.$hc.relative(g,o)}resolvePath(v,c){if(v.scheme===N.Schemas.file){const g=w.URI.file(L.$lc(b(v),c));return v.with({authority:g.authority,path:g.path})}return c=u.$lg(c),v.with({path:L.$hc.resolve(v.path,c)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,c){return v===c||v!==void 0&&c!==void 0&&(0,M.$tf)(v,c)}hasTrailingPathSeparator(v,c=L.sep){if(v.scheme===N.Schemas.file){const g=b(v);return g.length>u.$mg(g).length&&g[g.length-1]===c}else{const g=v.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,c=L.sep){return(0,e.$0g)(v,c)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,c=L.sep){let g=!1;if(v.scheme===N.Schemas.file){const o=b(v);g=o!==void 0&&o.length===u.$mg(o).length&&o[o.length-1]===c}else{c="/";const o=v.path;g=o.length===1&&o.charCodeAt(o.length-1)===47}return!g&&!(0,e.$0g)(v,c)?v.with({path:v.path+"/"}):v}}e.$Sg=S,e.$Tg=new S(()=>!1),e.$Ug=new S(k=>k.scheme===N.Schemas.file?!R.$k:!0),e.$Vg=new S(k=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function A(k,v){const c=[];for(let g=0;g<k.length;g++){const o=v(k[g]);k.some((n,i)=>i===g?!1:(0,e.$Xg)(o,v(n)))||c.push(k[g])}return c}var C;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function v(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&g.set(r,s)});const n=c.path.substring(0,c.path.indexOf(";"));return n&&g.set(k.META_DATA_MIME,n),g}k.parseMetaData=v})(C||(e.DataUri=C={}));function $(k,v,c){if(v){let g=k.path;return g&&g[0]!==L.$hc.sep&&(g=L.$hc.sep+g),k.with({scheme:c,authority:v,path:g})}return k.with({scheme:c})}}),define(ke[8],Ee([1,0,22,13,4,3,23,11,169,46]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=A,e.$dh=C,e.$eh=$,e.$fh=k,e.$gh=v,e.$hh=c,e.$ih=g,e.$jh=o,e.$rh=h,e.$sh=m,e.$th=D,e.$uh=p,e.$vh=E,e.$Kh=Z,e.$Sh=oe;function A(re){return!!re&&typeof re.then=="function"}function C(re){const G=new u.$me,te=re(G.token),ge=new Promise((we,Re)=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),Re(new N.$5)});Promise.resolve(te).then(Se=>{fe.dispose(),G.dispose(),we(Se)},Se=>{fe.dispose(),G.dispose(),Re(Se)})});return new class{cancel(){G.cancel(),G.dispose()}then(we,Re){return ge.then(we,Re)}catch(we){return this.then(void 0,we)}finally(we){return ge.finally(we)}}}function $(re,G,te){return new Promise((ge,we)=>{const Re=G.onCancellationRequested(()=>{Re.dispose(),ge(te)});re.then(ge,we).finally(()=>Re.dispose())})}function k(re,G){return new Promise((te,ge)=>{const we=G.onCancellationRequested(()=>{we.dispose(),ge(new N.$5)});re.then(te,ge).finally(()=>we.dispose())})}async function v(re){let G=-1;const te=re.map((ge,we)=>ge.then(Re=>(G=we,Re)));try{return await Promise.race(te)}finally{re.forEach((ge,we)=>{we!==G&&ge.cancel()})}}function c(re,G,te){let ge;const we=setTimeout(()=>{ge?.(void 0),te?.()},G);return Promise.race([re.finally(()=>clearTimeout(we)),new Promise(Re=>ge=Re)])}function g(re){return new Promise((G,te)=>{const ge=re();A(ge)?ge.then(G,te):G(ge)})}function o(){let re,G;return{promise:new Promise((ge,we)=>{re=ge,G=we}),resolve:re,reject:G}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const te=()=>{if(this.b=null,this.f)return;const ge=this.queue(this.d);return this.d=null,ge};this.b=new Promise(ge=>{this.a.then(te,te).then(ge)})}return new Promise((te,ge)=>{this.b.then(te,ge)})}return this.a=G(),new Promise((te,ge)=>{this.a.then(we=>{this.a=null,te(we)},we=>{this.a=null,ge(we)})})}dispose(){this.f=!0}}e.$kh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$lh=i;class r{constructor(){this.a=new Map}queue(G,te){const we=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(G)===we&&this.a.delete(G)});return this.a.set(G,we),we}}e.$mh=r;const s=(re,G)=>{let te=!0;const ge=setTimeout(()=>{te=!1,G()},re);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ge),te=!1}}},t=re=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,re())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class f{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,te=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((we,Re)=>{this.d=we,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const ge=()=>{this.a=null,this.d?.(null)};return this.a=te===b.$$d?t(ge):s(te,ge),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=f;class d{constructor(G){this.a=new f(G),this.b=new n}trigger(G,te){return this.a.trigger(()=>this.b.queue(G),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=d;class l{constructor(){this.a=!1,this.b=new Promise((G,te)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=l;class a extends l{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$qh=a;function h(re,G){return G?new Promise((te,ge)=>{const we=setTimeout(()=>{Re.dispose(),te()},re),Re=G.onCancellationRequested(()=>{clearTimeout(we),Re.dispose(),ge(new N.$5)})}):C(te=>h(re,te))}function m(re,G=0,te){const ge=setTimeout(()=>{re(),te&&we.dispose()},G),we=(0,R.$Sc)(()=>{clearTimeout(ge),te?.deleteAndLeak(we)});return te?.add(we),we}function D(re){const G=[];let te=0;const ge=re.length;function we(){return te<ge?re[te++]():null}function Re(fe){fe!=null&&G.push(fe);const Se=we();return Se?Se.then(Re):Promise.resolve(G)}return Promise.resolve(null).then(Re)}function p(re,G=ge=>!!ge,te=null){let ge=0;const we=re.length,Re=()=>{if(ge>=we)return Promise.resolve(te);const fe=re[ge++];return Promise.resolve(fe()).then(Ae=>G(Ae)?Promise.resolve(Ae):Re())};return Re()}function E(re,G=ge=>!!ge,te=null){if(re.length===0)return Promise.resolve(te);let ge=re.length;const we=()=>{ge=-1;for(const Re of re)Re.cancel?.()};return new Promise((Re,fe)=>{for(const Se of re)Se.then(Ae=>{--ge>=0&&G(Ae)?(we(),Re(Ae)):ge===0&&Re(te)}).catch(Ae=>{--ge>=0&&(we(),fe(Ae))})})}class y{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new L.$be}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ge)=>{this.g.push({factory:G,c:te,e:ge}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const te=G.factory();te.then(G.c,G.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=y;class P extends y{constructor(){super(1)}}e.$xh=P;class I{constructor(){this.a=new Y,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$yh=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new $e;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,te=M.$Tg){const ge=te.getComparisonKey(G);return this.a.get(ge)?.size??0}queueFor(G,te,ge=M.$Tg){const we=ge.getComparisonKey(G);let Re=this.a.get(we);if(!Re){Re=new P;const fe=this.f++,Se=L.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(fe,Se),this.a.set(we,Re)}return Re.queue(te)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=j;class F{constructor(G,te){this.a=-1,typeof G=="function"&&typeof te=="number"&&this.setIfNotSet(G,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},te)}setIfNotSet(G,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},te))}}e.$Ah=F;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,te,ge=globalThis){this.cancel();const we=ge.setInterval(()=>{G()},te);this.d=(0,R.$Sc)(()=>{ge.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=z;class O{constructor(G,te){this.b=-1,this.a=G,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=O;class T{constructor(G,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=G,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=T;class B extends O{constructor(G,te){super(G,te),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$Eh=B;class W extends R.$Uc{constructor(G,te){super(),this.g=G,this.h=te,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of G)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(re,G)=>{(0,w.$B)(()=>{if(te)return;const ge=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Hh=(re,G,te)=>{const ge=re.requestIdleCallback(G,typeof te=="number"?{timeout:te}:void 0);let we=!1;return{dispose(){we||(we=!0,re.cancelIdleCallback(ge))}}},e.$Gh=re=>(0,e.$Hh)(globalThis,re)}();class X{constructor(G,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ge){this.l=ge}finally{this.g=!0}},this.f=(0,e.$Hh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=X;class x extends X{constructor(G){super(globalThis,G)}}e.$Jh=x;async function Z(re,G,te){let ge;for(let we=0;we<te;we++)try{return await re()}catch(Re){ge=Re,await h(G)}throw ge}class Y{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,te,ge){return this.a={taskId:G,cancel:()=>ge?.(),promise:te},te.then(()=>this.d(G),()=>this.d(G)),te}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:te,resolve:ge,reject:we}=o();this.b={run:G,promise:te,promiseResolve:ge,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=Y;class ce{constructor(G,te=()=>Date.now()){this.d=G,this.f=te,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Mh=ce;var ne;(function(re){re[re.Resolved=0]="Resolved",re[re.Rejected=1]="Rejected"})(ne||(ne={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,te)=>{this.a=G,this.b=te})}complete(G){return new Promise(te=>{this.a(G),this.d={outcome:0,value:G},te()})}error(G){return new Promise(te=>{this.b(G),this.d={outcome:1,value:G},te()})}cancel(){return this.error(new N.$5)}}e.$Nh=$e;var Pe;(function(re){async function G(ge){let we;const Re=await Promise.all(ge.map(fe=>fe.then(Se=>Se,Se=>{we||(we=Se)})));if(typeof we<"u")throw we;return Re}re.settled=G;function te(ge){return new Promise(async(we,Re)=>{try{await ge(we,Re)}catch(fe){Re(fe)}})}re.withAsyncBody=te})(Pe||(e.Promises=Pe={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=_;class U{constructor(G){this.b=G,this.a=new S.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=U;var ie;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(ie||(ie={}));class be{static fromArray(G){return new be(te=>{te.emitMany(G)})}static fromPromise(G){return new be(async te=>{te.emitMany(await G)})}static fromPromises(G){return new be(async te=>{await Promise.all(G.map(async ge=>te.emitOne(await ge)))})}static merge(G){return new be(async te=>{await Promise.all(G.map(async ge=>{for await(const we of ge)te.emitOne(we)}))})}static{this.EMPTY=be.fromArray([])}constructor(G,te){this.a=0,this.b=[],this.d=null,this.f=te,this.g=new L.$be,queueMicrotask(async()=>{const ge={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(G(ge)),this.k()}catch(we){this.l(we)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(G,te){return new be(async ge=>{for await(const we of G)ge.emitOne(te(we))})}map(G){return be.map(this,G)}static filter(G,te){return new be(async ge=>{for await(const we of G)te(we)&&ge.emitOne(we)})}filter(G){return be.filter(this,G)}static coalesce(G){return be.filter(G,te=>!!te)}coalesce(){return be.coalesce(this)}static async toPromise(G){const te=[];for await(const ge of G)te.push(ge);return te}toPromise(){return be.toPromise(this)}h(G){this.a===0&&(this.b.push(G),this.g.fire())}j(G){this.a===0&&(this.b=this.b.concat(G),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(G){this.a===0&&(this.a=2,this.d=G,this.g.fire())}}e.$Qh=be;class Ce extends be{constructor(G,te){super(te),this.m=G}cancel(){this.m.cancel()}}e.$Rh=Ce;function oe(re){const G=new u.$me,te=re(G.token);return new Ce(G,async ge=>{const we=G.token.onCancellationRequested(()=>{we.dispose(),G.dispose(),ge.reject(new N.$5)});try{for await(const Re of te){if(G.token.isCancellationRequested)return;ge.emitOne(Re)}we.dispose(),G.dispose()}catch(Re){we.dispose(),G.dispose(),ge.reject(Re)}})}class ae{constructor(G){this.a=new $e,this.b=new be(we=>{if(te){we.reject(te);return}return ge&&we.emitMany(ge),this.d=Re=>we.reject(Re),this.f=Re=>we.emitOne(Re),this.a.p},G);let te,ge;this.f=we=>{ge||(ge=[]),ge.push(we)},this.d=we=>{te||(te=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Th=ae}),define(ke[35],Ee([1,0,19,8,34,27,17,11,14]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=S,e.$ik=v,e.$jk=P,e.$kk=I,e.$lk=j,e.$mk=F,e.$nk=z,e.$ok=W;function S(){return Object.create(null)}e.$gk="**",e.$hk="/";const A="[/\\\\]",C="[^/\\\\]",$=/\//g;function k(X,x){switch(X){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${x?`|${A}${C}+`:""})*?`}}function v(X,x){if(!X)return[];const Z=[];let Y=!1,ce=!1,ne="";for(const $e of X){switch($e){case x:if(!Y&&!ce){Z.push(ne),ne="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ne+=$e}return ne&&Z.push(ne),Z}function c(X){if(!X)return"";let x="";const Z=v(X,e.$hk);if(Z.every(Y=>Y===e.$gk))x=".*";else{let Y=!1;Z.forEach((ce,ne)=>{if(ce===e.$gk){if(Y)return;x+=k(2,ne===Z.length-1)}else{let $e=!1,Pe="",_=!1,U="";for(const ie of ce){if(ie!=="}"&&$e){Pe+=ie;continue}if(_&&(ie!=="]"||!U)){let be;ie==="-"?be=ie:(ie==="^"||ie==="!")&&!U?be="^":ie===e.$hk?be="":be=(0,b.$8e)(ie),U+=be;continue}switch(ie){case"{":$e=!0;continue;case"[":_=!0;continue;case"}":{const Ce=`(?:${v(Pe,",").map(oe=>c(oe)).join("|")})`;x+=Ce,$e=!1,Pe="";break}case"]":{x+="["+U+"]",_=!1,U="";break}case"?":x+=C;continue;case"*":x+=k(1);continue;default:x+=(0,b.$8e)(ie)}}ne<Z.length-1&&(Z[ne+1]!==e.$gk||ne+2<Z.length)&&(x+=A)}Y=ce===e.$gk})}return x}const g=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),f=function(){return!1},d=function(){return null};function l(X,x){if(!X)return d;let Z;typeof X!="string"?Z=X.pattern:Z=X,Z=Z.trim();const Y=`${Z}_${!!x.trimForExclusions}`;let ce=t.get(Y);if(ce)return a(ce,X);let ne;return g.test(Z)?ce=m(Z.substr(4),Z):(ne=o.exec(h(Z,x)))?ce=D(ne[1],Z):(x.trimForExclusions?i:n).test(Z)?ce=p(Z,x):(ne=r.exec(h(Z,x)))?ce=E(ne[1].substr(1),Z,!0):(ne=s.exec(h(Z,x)))?ce=E(ne[1],Z,!1):ce=y(Z),t.set(Y,ce),a(ce,X)}function a(X,x){if(typeof x=="string")return X;const Z=function(Y,ce){return(0,L.$qg)(Y,x.base,!w.$k)?X((0,b.$af)(Y.substr(x.base.length),M.sep),ce):null};return Z.allBasenames=X.allBasenames,Z.allPaths=X.allPaths,Z.basenames=X.basenames,Z.patterns=X.patterns,Z}function h(X,x){return x.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function m(X,x){return function(Z,Y){return typeof Z=="string"&&Z.endsWith(X)?x:null}}function D(X,x){const Z=`/${X}`,Y=`\\${X}`,ce=function($e,Pe){return typeof $e!="string"?null:Pe?Pe===X?x:null:$e===X||$e.endsWith(Z)||$e.endsWith(Y)?x:null},ne=[X];return ce.basenames=ne,ce.patterns=[x],ce.allBasenames=ne,ce}function p(X,x){const Z=B(X.slice(1,-1).split(",").map(Pe=>l(Pe,x)).filter(Pe=>Pe!==d),X),Y=Z.length;if(!Y)return d;if(Y===1)return Z[0];const ce=function(Pe,_){for(let U=0,ie=Z.length;U<ie;U++)if(Z[U](Pe,_))return X;return null},ne=Z.find(Pe=>!!Pe.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const $e=Z.reduce((Pe,_)=>_.allPaths?Pe.concat(_.allPaths):Pe,[]);return $e.length&&(ce.allPaths=$e),ce}function E(X,x,Z){const Y=M.sep===M.$hc.sep,ce=Y?X:X.replace($,M.sep),ne=M.sep+ce,$e=M.$hc.sep+X;let Pe;return Z?Pe=function(_,U){return typeof _=="string"&&(_===ce||_.endsWith(ne)||!Y&&(_===X||_.endsWith($e)))?x:null}:Pe=function(_,U){return typeof _=="string"&&(_===ce||!Y&&_===X)?x:null},Pe.allPaths=[(Z?"*/":"./")+X],Pe}function y(X){try{const x=new RegExp(`^${c(X)}$`);return function(Z){return x.lastIndex=0,typeof Z=="string"&&x.test(Z)?X:null}}catch{return d}}function P(X,x,Z){return!X||typeof x!="string"?!1:I(X)(x,void 0,Z)}function I(X,x={}){if(!X)return f;if(typeof X=="string"||j(X)){const Z=l(X,x);if(Z===d)return f;const Y=function(ce,ne){return!!Z(ce,ne)};return Z.allBasenames&&(Y.allBasenames=Z.allBasenames),Z.allPaths&&(Y.allPaths=Z.allPaths),Y}return O(X,x)}function j(X){const x=X;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}function F(X){return X.allBasenames||[]}function z(X){return X.allPaths||[]}function O(X,x){const Z=B(Object.getOwnPropertyNames(X).map(Pe=>T(Pe,X[Pe],x)).filter(Pe=>Pe!==d)),Y=Z.length;if(!Y)return d;if(!Z.some(Pe=>!!Pe.requiresSiblings)){if(Y===1)return Z[0];const Pe=function(ie,be){let Ce;for(let oe=0,ae=Z.length;oe<ae;oe++){const re=Z[oe](ie,be);if(typeof re=="string")return re;(0,N.$ch)(re)&&(Ce||(Ce=[]),Ce.push(re))}return Ce?(async()=>{for(const oe of Ce){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},_=Z.find(ie=>!!ie.allBasenames);_&&(Pe.allBasenames=_.allBasenames);const U=Z.reduce((ie,be)=>be.allPaths?ie.concat(be.allPaths):ie,[]);return U.length&&(Pe.allPaths=U),Pe}const ce=function(Pe,_,U){let ie,be;for(let Ce=0,oe=Z.length;Ce<oe;Ce++){const ae=Z[Ce];ae.requiresSiblings&&U&&(_||(_=(0,M.$oc)(Pe)),ie||(ie=_.substr(0,_.length-(0,M.$pc)(Pe).length)));const re=ae(Pe,_,ie,U);if(typeof re=="string")return re;(0,N.$ch)(re)&&(be||(be=[]),be.push(re))}return be?(async()=>{for(const Ce of be){const oe=await Ce;if(typeof oe=="string")return oe}return null})():null},ne=Z.find(Pe=>!!Pe.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const $e=Z.reduce((Pe,_)=>_.allPaths?Pe.concat(_.allPaths):Pe,[]);return $e.length&&(ce.allPaths=$e),ce}function T(X,x,Z){if(x===!1)return d;const Y=l(X,Z);if(Y===d)return d;if(typeof x=="boolean")return Y;if(x){const ce=x.when;if(typeof ce=="string"){const ne=($e,Pe,_,U)=>{if(!U||!Y($e,Pe))return null;const ie=ce.replace("$(basename)",()=>_),be=U(ie);return(0,N.$ch)(be)?be.then(Ce=>Ce?X:null):be?X:null};return ne.requiresSiblings=!0,ne}}return Y}function B(X,x){const Z=X.filter(Pe=>!!Pe.basenames);if(Z.length<2)return X;const Y=Z.reduce((Pe,_)=>{const U=_.basenames;return U?Pe.concat(U):Pe},[]);let ce;if(x){ce=[];for(let Pe=0,_=Y.length;Pe<_;Pe++)ce.push(x)}else ce=Z.reduce((Pe,_)=>{const U=_.patterns;return U?Pe.concat(U):Pe},[]);const ne=function(Pe,_){if(typeof Pe!="string")return null;if(!_){let ie;for(ie=Pe.length;ie>0;ie--){const be=Pe.charCodeAt(ie-1);if(be===47||be===92)break}_=Pe.substr(ie)}const U=Y.indexOf(_);return U!==-1?ce[U]:null};ne.basenames=Y,ne.patterns=ce,ne.allBasenames=Y;const $e=X.filter(Pe=>!Pe.basenames);return $e.push(ne),$e}function W(X,x){return(0,u.$ub)(X,x,(Z,Y)=>typeof Z=="string"&&typeof Y=="string"?Z===Y:typeof Z!="string"&&typeof Y!="string"?Z.base===Y.base&&Z.pattern===Y.pattern:!1)}}),define(ke[80],Ee([1,0,13,171,23,14,2]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=S,e.$Pk=A,e.$Qk=C,e.$Rk=$,e.$Sk=k,e.$Tk=v,e.$Uk=c,e.$Vk=g;var w;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class b{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=$(this.supportThemeIcons?(0,N.$Hk)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${k(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,R.$8e)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Nk=b;function S(o){return A(o)?!o.value:Array.isArray(o)?o.every(S):!0}function A(o){return o instanceof b?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function C(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,L.$Wg)(M.URI.from(o.baseUri),M.URI.from(n.baseUri)))}function $(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,o,`${"`".repeat(r)}`].join(`
`)}function v(o){return o.replace(/"/g,"&quot;")}function c(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",d=t?t[1]:"",l=isFinite(parseInt(d)),a=isFinite(parseInt(f));l&&n.push(`width="${d}"`),a&&n.push(`height="${f}"`)}return{href:o,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=b,e.$pw=A,e.$qw=$,e.$rw=k,e.$sw=o,e.$tw=i,e.$uw=r,e.$vw=s,e.$ww=t,e.$xw=f;function b(l,a){const{os:h,tildify:m,relative:D}=a;if(D){const y=S(l,D,h);if(typeof y=="string")return y}let p=l.fsPath;if(h===1&&!R.$i?p=p.replace(/\//g,"\\"):h!==1&&R.$i&&(p=p.replace(/\\/g,"/")),h!==1&&m?.userHome){const y=m.userHome.fsPath;let P;l.scheme!==m.userHome.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep?P=m.userHome.with({path:l.path}).fsPath:P=p,p=$(P,y,h)}return(h===1?L.$gc:L.$hc).normalize(A(p,h===1))}function S(l,a,h){const m=h===1?L.$gc:L.$hc,D=h===3?M.$Tg:M.$Vg,p=a.getWorkspace(),E=(0,u.$Ob)(p.folders);if(!E)return;l.scheme!==E.uri.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep&&(l=E.uri.with({path:l.path}));const y=a.getWorkspaceFolder(l);if(!y)return;let P;if(D.isEqual(y.uri,l)?P="":P=D.relativePath(y.uri,l)??"",P&&(P=m.normalize(P)),p.folders.length>1&&!a.noPrefix){const I=y.name?y.name:D.basenameOrAuthority(y.uri);P=P?`${I} \u2022 ${P}`:I}return P}function A(l,a=R.$i){return(0,N.$ug)(l,a)?l.charAt(0).toUpperCase()+l.slice(1):l}let C=Object.create(null);function $(l,a,h=R.OS){if(h===1||!l||!a)return l;let m=C.original===a?C.normalized:void 0;m||(m=a,R.$i&&(m=(0,N.$kg)(m)),m=`${(0,w.$bf)(m,L.$hc.sep)}${L.$hc.sep}`,C={original:a,normalized:m});let D=l;return R.$i&&(D=(0,N.$kg)(D)),(h===3?D.startsWith(m):(0,w.$uf)(D,m))?`~/${D.substr(m.length)}`:l}function k(l,a){return l.replace(/^~($|\/|\\)/,`${a}$1`)}const v="\u2026",c="\\\\",g="~";function o(l,a=L.sep){const h=new Array(l.length);let m=!1;for(let D=0;D<l.length;D++){const p=l[D];if(p===""){h[D]=`.${a}`;continue}if(!p){h[D]=p;continue}m=!0;let E="",y=p;y.indexOf(c)===0?(E=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(a)===0?(E=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(g)===0&&(E=y.substr(0,y.indexOf(g)+g.length),y=y.substr(y.indexOf(g)+g.length));const P=y.split(a);for(let I=1;m&&I<=P.length;I++)for(let j=P.length-I;m&&j>=0;j--){m=!1;let F=P.slice(j,j+I).join(a);for(let z=0;!m&&z<l.length;z++)if(z!==D&&l[z]&&l[z].indexOf(F)>-1){const O=j+I===P.length,T=j>0&&l[z].indexOf(a)>-1?a+F:F,B=l[z].endsWith(T);m=!O||B}if(!m){let z="";(P[0].endsWith(":")||E!=="")&&(j===1&&(j=0,I++,F=P[0]+a+F),j>0&&(z=P[0]+a),z=E+z),j>0&&(z=z+v+a),z=z+F,j+I<P.length&&(z=z+a+v),h[D]=z}}m&&(h[D]=p)}return h}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,a=Object.create(null)){const h=[];let m=!1,D="";for(const p of l)if(p==="$"||m&&p==="{")D&&h.push({value:D,type:n.TEXT}),D="",m=!0;else if(p==="}"&&m){const E=a[D];if(typeof E=="string")E.length&&h.push({value:E,type:n.VARIABLE});else if(E){const y=h[h.length-1];(!y||y.type!==n.SEPARATOR)&&h.push({value:E.label,type:n.SEPARATOR})}D="",m=!1}else D+=p;return D&&!m&&h.push({value:D,type:n.TEXT}),h.filter((p,E)=>{if(p.type===n.SEPARATOR){const y=h[E-1],P=h[E+1];return[y,P].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(p=>p.value).join("")}function r(l,a){return R.$j||a?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(l,a){return R.$j||a?l.replace(/\(&&\w\)|&&/g,""):R.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function f(l){if(l.endsWith("]")){const a=l.lastIndexOf(" [",l.length-2);if(a!==-1){const h=d(l.substring(0,a)),m=l.substring(a);return{name:h.name+m,parentPath:h.parentPath}}}return d(l)}function d(l){const a=l.indexOf("/")!==-1?L.$hc:L.$gc,h=a.basename(l),m=a.dirname(l);return h.length?{name:h,parentPath:m}:{name:m,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=w,e.$vn=S,e.$wn=A;function L(C){return C.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const k=this.a.transformIncoming($);return k===$?$:L(N.URI.from(k))}transformOutgoing($){const k=this.a.transformOutgoing($);return k===$?$:L(N.URI.from(k))}transformOutgoingURI($){const k=this.a.transformOutgoing($);return k===$?$:N.URI.from(k)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$sn=R,e.$tn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function M(C,$,k){if(!C||k>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return $.transformOutgoing(C);for(const v in C)if(Object.hasOwnProperty.call(C,v)){const c=M(C[v],$,k+1);c!==null&&(C[v]=c)}}return null}function w(C,$){const k=M(C,$,0);return k===null?C:k}function b(C,$,k,v){if(!C||v>200)return null;if(typeof C=="object"){if(C.$mid===1)return k?N.URI.revive($.transformIncoming(C)):$.transformIncoming(C);if(C instanceof u.$Ce)return null;for(const c in C)if(Object.hasOwnProperty.call(C,c)){const g=b(C[c],$,k,v+1);g!==null&&(C[c]=g)}}return null}function S(C,$){const k=b(C,$,!1,0);return k===null?C:k}function A(C,$){const k=b(C,$,!0,0);return k===null?C:k}}),define(ke[31],Ee([1,0,52,64,396,8,34,76,17,11,23,2]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=h,e.writeFileSync=D;var $;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function k(T,B=$.UNLINK,W){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===$.UNLINK?c(T):v(T,W)}async function v(T,B=(0,M.$yg)((0,N.tmpdir)())){try{try{await u.promises.rename(T,B)}catch(W){return W.code==="ENOENT"?void 0:c(T)}c(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function c(T){return(0,L.promisify)(u.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function g(T){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function o(T,B){return r(await(B?n(T):(0,L.promisify)(u.readdir)(T)))}async function n(T){try{return await(0,L.promisify)(u.readdir)(T,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const B=[],W=await o(T);for(const X of W){let x=!1,Z=!1,Y=!1;try{const ce=await e.Promises.lstat((0,b.$kc)(T,X));x=ce.isFile(),Z=ce.isDirectory(),Y=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}B.push({name:X,isFile:()=>x,isDirectory:()=>Z,isSymbolicLink:()=>Y})}return B}function i(T){return r(u.readdirSync(T))}function r(T){return T.map(B=>typeof B=="string"?S.$j?(0,w.$8l)(B):B:(B.name=S.$j?(0,w.$8l)(B.name):B.name,B))}async function s(T){const B=await o(T),W=[];for(const X of B)await f.existsDirectory((0,b.$kc)(T,X))&&W.push(X);return W}function t(T,B=1e3){return new Promise(W=>{let X=!1;const x=setInterval(()=>{X||(X=!0,u.access(T,Z=>{X=!1,Z&&(clearInterval(x),W(void 0))}))},B)})}var f;(function(T){async function B(x){let Z;try{if(Z=await e.Promises.lstat(x),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(S.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw ce}throw Y}}T.stat=B;async function W(x){try{const{stat:Z,symbolicLink:Y}=await T.stat(x);return Z.isFile()&&Y?.dangling!==!0}catch{}return!1}T.existsFile=W;async function X(x){try{const{stat:Z,symbolicLink:Y}=await T.stat(x);return Z.isDirectory()&&Y?.dangling!==!0}catch{}return!1}T.existsDirectory=X})(f||(e.SymlinkSupport=f={}));const d=new R.$zh;function l(T,B,W){return d.queueFor(C.URI.file(T),()=>{const X=p(W);return new Promise((x,Z)=>m(T,B,X,Y=>Y?Z(Y):x()))},A.$Ug)}let a=!0;function h(T){a=T}function m(T,B,W,X){if(!a)return u.writeFile(T,B,{mode:W.mode,flag:W.flag},X);u.open(T,W.flag,W.mode,(x,Z)=>{if(x)return X(x);u.writeFile(Z,B,Y=>{if(Y)return u.close(Z,()=>X(Y));u.fdatasync(Z,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),h(!1)),u.close(Z,ne=>X(ne))))})})}function D(T,B,W){const X=p(W);if(!a)return u.writeFileSync(T,B,{mode:X.mode,flag:X.flag});const x=u.openSync(T,X.flag,X.mode);try{u.writeFileSync(x,B);try{u.fdatasyncSync(x)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),h(!1)}}finally{u.closeSync(x)}}function p(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function E(T,B,W=6e4){if(T!==B)try{S.$i&&typeof W=="number"?await y(T,B,Date.now(),W):await(0,L.promisify)(u.rename)(T,B)}catch(X){if(T.toLowerCase()!==B.toLowerCase()&&X.code==="EXDEV"||T.endsWith("."))await P(T,B,{preserveSymlinks:!1}),await k(T,$.MOVE);else throw X}}async function y(T,B,W,X,x=0){try{return await(0,L.promisify)(u.rename)(T,B)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-W>=X)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Z}`),Z;if(x===0){let Y=!1;try{const{stat:ce}=await f.stat(B);ce.isFile()||(Y=!0)}catch{}if(Y)throw Z}return await(0,R.$rh)(Math.min(100,x*10)),y(T,B,W,X,x+1)}}async function P(T,B,W){return j(T,B,{root:{source:T,target:B},options:W,handledSourcePaths:new Set})}const I=511;async function j(T,B,W){if(W.handledSourcePaths.has(T))return;W.handledSourcePaths.add(T);const{stat:X,symbolicLink:x}=await f.stat(T);if(x){if(W.options.preserveSymlinks)try{return await O(T,B,W)}catch{}if(x.dangling)return}return X.isDirectory()?F(T,B,X.mode&I,W):z(T,B,X.mode&I)}async function F(T,B,W,X){await e.Promises.mkdir(B,{recursive:!0,mode:W});const x=await o(T);for(const Z of x)await j((0,b.$kc)(T,Z),(0,b.$kc)(B,Z),X)}async function z(T,B,W){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,W)}async function O(T,B,W){let X=await e.Promises.readlink(T);(0,M.$qg)(X,W.root.source,!S.$k)&&(X=(0,b.$kc)(W.root.target,X.substr(W.root.source.length+1))),await e.Promises.symlink(X,B)}e.Promises=new class{get access(){return(0,L.promisify)(u.access)}get stat(){return(0,L.promisify)(u.stat)}get lstat(){return(0,L.promisify)(u.lstat)}get utimes(){return(0,L.promisify)(u.utimes)}get read(){return(T,B,W,X,x)=>new Promise((Z,Y)=>{u.read(T,B,W,X,x,(ce,ne,$e)=>ce?Y(ce):Z({bytesRead:ne,buffer:$e}))})}get readFile(){return(0,L.promisify)(u.readFile)}get write(){return(T,B,W,X,x)=>new Promise((Z,Y)=>{u.write(T,B,W,X,x,(ce,ne,$e)=>ce?Y(ce):Z({bytesWritten:ne,buffer:$e}))})}get appendFile(){return(0,L.promisify)(u.appendFile)}get fdatasync(){return(0,L.promisify)(u.fdatasync)}get truncate(){return(0,L.promisify)(u.truncate)}get copyFile(){return(0,L.promisify)(u.copyFile)}get open(){return(0,L.promisify)(u.open)}get close(){return(0,L.promisify)(u.close)}get symlink(){return(0,L.promisify)(u.symlink)}get readlink(){return(0,L.promisify)(u.readlink)}get chmod(){return(0,L.promisify)(u.chmod)}get mkdir(){return(0,L.promisify)(u.mkdir)}get unlink(){return(0,L.promisify)(u.unlink)}get rmdir(){return(0,L.promisify)(u.rmdir)}get realpath(){return(0,L.promisify)(u.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return k}get rename(){return E}get copy(){return P}}}),define(ke[104],Ee([1,0,52,17,11,14,31]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=w,e.$Wq=b,e.$Xq=S,e.$Yq=A;function w($){if(L.$k)return $;const k=(0,N.$nc)($);if($===k)return $;const v=((0,N.$oc)($)||$).toLowerCase();try{const g=(0,M.readdirSync)(k).filter(o=>o.toLowerCase()===v);if(g.length===1){const o=w(k);if(o)return(0,N.$kc)(o,g[0])}else if(g.length>1){const o=g.indexOf(v);if(o>=0){const n=w(k);if(n)return(0,N.$kc)(n,g[o])}}}catch{}return null}async function b($,k){if(L.$k)return $;const v=(0,N.$nc)($);if($===v)return $;const c=((0,N.$oc)($)||$).toLowerCase();try{if(k?.isCancellationRequested)return null;const o=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===c);if(o.length===1){const n=await b(v,k);if(n)return(0,N.$kc)(n,o[0])}else if(o.length>1){const n=o.indexOf(c);if(n>=0){const i=await b(v,k);if(i)return(0,N.$kc)(i,o[n])}}}catch{}return null}async function S($){try{return await M.Promises.realpath($)}catch{const v=C($);return await M.Promises.access(v,u.constants.R_OK),v}}function A($){try{return u.realpathSync($)}catch{const v=C($);return u.accessSync(v,u.constants.R_OK),v}}function C($){return(0,R.$bf)((0,N.$ic)($),N.sep)}}),define(ke[105],Ee([1,0,17,11,51,102,18,31]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$im=b,e.$jm=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function b(C=L.env){return C.comspec||"cmd.exe"}function S(C){let $=[],k=!1;const v=function(c){if(k){$.push(c);return}(!C.send(c,o=>{if(o&&console.error(o),k=!1,$.length>0){const n=$.slice(0);$=[],n.forEach(i=>v(i))}})||N.$i)&&(k=!0)};return{send:v}}var A;(function(C){async function $(k,v,c){if(u.$jc(k))return k;if(v===void 0&&(v=L.cwd()),u.$nc(k)!=="."||(c===void 0&&M.$4f(L.env.PATH)&&(c=L.env.PATH.split(u.$uc)),c===void 0||c.length===0))return u.$kc(v,k);async function o(n){if(await w.Promises.exists(n)){let i;try{i=await w.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await w.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of c){let i;if(u.$jc(n)?i=u.$kc(n,k):i=u.$kc(v,n,k),await o(i))return i;let r=i+".com";if(await o(r)||(r=i+".exe",await o(r)))return r}return u.$kc(v,k)}C.findExecutable=$})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(le,e,u,N){var L=arguments.length,R=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,u):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(le,e,u,N);else for(var w=le.length-1;w>=0;w--)(M=le[w])&&(R=(L<3?M(R):L>3?M(e,u,R):M(e,u))||R);return L>3&&R&&Object.defineProperty(e,u,R),R};define(ke[81],Ee([1,0,19,8,21,22,55,13,4,3,58,14,18]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.ProxyChannel=e.$$h=e.$8h=e.$7h=e.$6h=e.RequestInitiator=e.$5h=e.$2h=e.$1h=void 0,e.$3h=h,e.$4h=m,e.$9h=I,e.$0h=j;var k;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(k||(k={}));function v(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(c||(c={}));function g(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(o||(o={}));function n(x){let Z=0;for(let Y=0;;Y+=7){const ce=x.read(1);if(Z|=(ce.buffer[0]&127)<<Y,!(ce.buffer[0]&128))return Z}}const i=d(0);function r(x,Z){if(Z===0){x.write(i);return}let Y=0;for(let ne=Z;ne!==0;ne=ne>>>7)Y++;const ce=L.$Ce.alloc(Y);for(let ne=0;Z!==0;ne++)ce.buffer[ne]=Z&127,Z=Z>>>7,Z>0&&(ce.buffer[ne]|=128);x.write(ce)}class s{constructor(Z){this.b=Z,this.a=0}read(Z){const Y=this.b.slice(this.a,this.a+Z);return this.a+=Y.byteLength,Y}}e.$1h=s;class t{constructor(){this.a=[]}get buffer(){return L.$Ce.concat(this.a)}write(Z){this.a.push(Z)}}e.$2h=t;var f;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(f||(f={}));function d(x){const Z=L.$Ce.alloc(1);return Z.writeUInt8(x,0),Z}const l={Undefined:d(f.Undefined),String:d(f.String),Buffer:d(f.Buffer),VSBuffer:d(f.VSBuffer),Array:d(f.Array),Object:d(f.Object),Uint:d(f.Int)},a=typeof Buffer<"u";function h(x,Z){if(typeof Z>"u")x.write(l.Undefined);else if(typeof Z=="string"){const Y=L.$Ce.fromString(Z);x.write(l.String),r(x,Y.byteLength),x.write(Y)}else if(a&&Buffer.isBuffer(Z)){const Y=L.$Ce.wrap(Z);x.write(l.Buffer),r(x,Y.byteLength),x.write(Y)}else if(Z instanceof L.$Ce)x.write(l.VSBuffer),r(x,Z.byteLength),x.write(Z);else if(Array.isArray(Z)){x.write(l.Array),r(x,Z.length);for(const Y of Z)h(x,Y)}else if(typeof Z=="number"&&(Z|0)===Z)x.write(l.Uint),r(x,Z);else{const Y=L.$Ce.fromString(JSON.stringify(Z));x.write(l.Object),r(x,Y.byteLength),x.write(Y)}}function m(x){switch(x.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return x.read(n(x)).toString();case f.Buffer:return x.read(n(x)).buffer;case f.VSBuffer:return x.read(n(x));case f.Array:{const Y=n(x),ce=[];for(let ne=0;ne<Y;ne++)ce.push(m(x));return ce}case f.Object:return JSON.parse(x.read(n(x)).toString());case f.Int:return n(x)}}class D{constructor(Z,Y,ce=null,ne=1e3){this.h=Z,this.j=Y,this.k=ce,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(Z,Y){this.b.set(Z,Y),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const Y=this.o([Z.type]);this.k?.logOutgoing(Y,0,1,g(Z.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(Y,Z.id,1,g(Z.type),Z.data);return}}}o(Z,Y=void 0){const ce=new t;return h(ce,Z),h(ce,Y),this.p(ce.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const Y=new s(Z),ce=m(Y),ne=m(Y),$e=ce[0];switch($e){case 100:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${v($e)}: ${ce[2]}.${ce[3]}`,ne),this.s({type:$e,id:ce[1],channelName:ce[2],name:ce[3],arg:ne});case 102:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${v($e)}: ${ce[2]}.${ce[3]}`,ne),this.t({type:$e,id:ce[1],channelName:ce[2],name:ce[3],arg:ne});case 101:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${v($e)}`),this.u({type:$e,id:ce[1]});case 103:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${v($e)}`),this.u({type:$e,id:ce[1]})}}s(Z){const Y=this.b.get(Z.channelName);if(!Y){this.v(Z);return}const ce=new R.$me;let ne;try{ne=Y.call(this.j,Z.name,Z.arg,ce.token)}catch(_){ne=Promise.reject(_)}const $e=Z.id;ne.then(_=>{this.m({id:$e,data:_,type:201})},_=>{_ instanceof Error?this.m({id:$e,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:$e,data:_,type:203})}).finally(()=>{Pe.dispose(),this.d.delete(Z.id)});const Pe=(0,S.$Sc)(()=>ce.cancel());this.d.set(Z.id,Pe)}t(Z){const Y=this.b.get(Z.channelName);if(!Y){this.v(Z);return}const ce=Z.id,$e=Y.listen(this.j,Z.name,Z.arg)(Pe=>this.m({id:ce,data:Pe,type:204}));this.d.set(Z.id,$e)}u(Z){const Y=this.d.get(Z.id);Y&&(Y.dispose(),this.d.delete(Z.id))}v(Z){let Y=this.g.get(Z.channelName);Y||(Y=[],this.g.set(Z.channelName,Y));const ce=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:Z,timeoutTimer:ce})}w(Z){const Y=this.g.get(Z);if(Y){for(const ce of Y)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$5h=D;var p;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class E{constructor(Z,Y=null){this.l=Z,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=Y}getChannel(Z){const Y=this;return{call(ce,ne,$e){return Y.a?Promise.reject(new w.$5):Y.m(Z,ce,ne,$e)},listen(ce,ne){return Y.a?b.Event.None:Y.o(Z,ce,ne)}}}m(Z,Y,ce,ne=R.CancellationToken.None){const $e=this.g++,_={id:$e,type:100,channelName:Z,name:Y,arg:ce};if(ne.isCancellationRequested)return Promise.reject(new w.$5);let U;return new Promise((be,Ce)=>{if(ne.isCancellationRequested)return Ce(new w.$5);const oe=()=>{const te=ge=>{switch(ge.type){case 201:this.f.delete($e),be(ge.data);break;case 202:{this.f.delete($e);const we=new Error(ge.data.message);we.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,we.name=ge.data.name,Ce(we);break}case 203:this.f.delete($e),Ce(ge.data);break}};this.f.set($e,te),this.p(_)};let ae=null;this.b===o.Idle?oe():(ae=(0,N.$dh)(te=>this.u()),ae.then(()=>{ae=null,oe()}));const re=()=>{ae?(ae.cancel(),ae=null):this.p({id:$e,type:101}),Ce(new w.$5)},G=ne.onCancellationRequested(re);U=(0,S.$Rc)((0,S.$Sc)(re),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Z,Y,ce){const ne=this.g++,Pe={id:ne,type:102,channelName:Z,name:Y,arg:ce};let _=null;const U=new b.$be({onWillAddFirstListener:()=>{_=(0,N.$dh)(be=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(Pe)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:ne,type:103}))}}),ie=be=>U.fire(be.data);return this.f.set(ne,ie),U.event}p(Z){switch(Z.type){case 100:case 102:{const Y=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(Y,Z.id,0,`${v(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const Y=this.q([Z.type,Z.id]);this.j?.logOutgoing(Y,Z.id,0,v(Z.type));return}}}q(Z,Y=void 0){const ce=new t;return h(ce,Z),h(ce,Y),this.r(ce.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const Y=new s(Z),ce=m(Y),ne=m(Y),$e=ce[0];switch($e){case 200:return this.j?.logIncoming(Z.byteLength,0,0,g($e)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,ce[1],0,g($e),ne),this.t({type:ce[0],id:ce[1],data:ne})}}t(Z){if(Z.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$6h=E,Je([M.$Uh],E.prototype,"onDidInitializePromise",null);class y{get connections(){const Z=[];return this.f.forEach(Y=>Z.push(Y)),Z}constructor(Z,Y,ce){this.a=new Map,this.f=new Set,this.g=new b.$be,this.onDidAddConnection=this.g.event,this.h=new b.$be,this.onDidRemoveConnection=this.h.event,this.j=new S.$Tc,this.j.add(Z(({protocol:ne,onDidClientDisconnect:$e})=>{const Pe=b.Event.once(ne.onMessage);this.j.add(Pe(_=>{const U=new s(_),ie=m(U),be=new D(ne,ie,Y,ce),Ce=new E(ne,Y);this.a.forEach((ae,re)=>be.registerChannel(re,ae));const oe={channelServer:be,channelClient:Ce,ctx:ie};this.f.add(oe),this.g.fire(oe),this.j.add($e(()=>{be.dispose(),Ce.dispose(),this.f.delete(oe),this.h.fire(oe)}))}))}))}getChannel(Z,Y){const ce=this;return{call(ne,$e,Pe){let _;if((0,$.$fg)(Y)){const ie=(0,u.$4b)(ce.connections.filter(Y));_=ie?Promise.resolve(ie):b.Event.toPromise(b.Event.filter(ce.onDidAddConnection,Y))}else _=Y.routeCall(ce,ne,$e);const U=_.then(ie=>ie.channelClient.getChannel(Z));return I(U).call(ne,$e,Pe)},listen(ne,$e){if((0,$.$fg)(Y))return ce.k(Z,Y,ne,$e);const Pe=Y.routeEvent(ce,ne,$e).then(_=>_.channelClient.getChannel(Z));return I(Pe).listen(ne,$e)}}}k(Z,Y,ce,ne){const $e=this;let Pe;const _=new b.$be({onWillAddFirstListener:()=>{Pe=new S.$Tc;const U=new b.$he,ie=new Map,be=oe=>{const re=oe.channelClient.getChannel(Z).listen(ce,ne),G=U.add(re);ie.set(oe,G)},Ce=oe=>{const ae=ie.get(oe);ae&&(ae.dispose(),ie.delete(oe))};$e.connections.filter(Y).forEach(be),b.Event.filter($e.onDidAddConnection,Y)(be,void 0,Pe),$e.onDidRemoveConnection(Ce,void 0,Pe),U.event(_.fire,_,Pe),Pe.add(U)},onDidRemoveLastListener:()=>{Pe?.dispose(),Pe=void 0}});return _.event}registerChannel(Z,Y){this.a.set(Z,Y);for(const ce of this.f)ce.channelServer.registerChannel(Z,Y)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$7h=y;class P{constructor(Z,Y,ce=null){const ne=new t;h(ne,Y),Z.send(ne.buffer),this.a=new E(Z,ce),this.d=new D(Z,Y,ce)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,Y){this.d.registerChannel(Z,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$8h=P;function I(x){return{call(Z,Y,ce){return x.then(ne=>ne.call(Z,Y,ce))},listen(Z,Y){const ce=new b.$ke;return x.then(ne=>ce.input=ne.listen(Z,Y)),ce.event}}}function j(x){let Z=!1;return{call(Y,ce,ne){return Z?x.call(Y,ce,ne):(0,N.$rh)(0).then(()=>Z=!0).then(()=>x.call(Y,ce,ne))},listen(Y,ce){if(Z)return x.listen(Y,ce);const ne=new b.$ke;return(0,N.$rh)(0).then(()=>Z=!0).then(()=>ne.input=x.listen(Y,ce)),ne.event}}}class F{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const Y of Z.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await b.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$$h=F;var z;(function(x){function Z($e,Pe,_){const U=$e,ie=_&&_.disableMarshalling,be=new Map;for(const Ce in U)ce(Ce)&&be.set(Ce,b.Event.buffer(U[Ce],!0,void 0,Pe));return new class{listen(Ce,oe,ae){const re=be.get(oe);if(re)return re;const G=U[oe];if(typeof G=="function"){if(ne(oe))return G.call(U,ae);if(ce(oe))return be.set(oe,b.Event.buffer(U[oe],!0,void 0,Pe)),be.get(oe)}throw new w.$bb(`Event not found: ${oe}`)}call(Ce,oe,ae){const re=U[oe];if(typeof re=="function"){if(!ie&&Array.isArray(ae))for(let te=0;te<ae.length;te++)ae[te]=(0,A.$Zh)(ae[te]);let G=re.apply(U,ae);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new w.$bb(`Method not found: ${oe}`)}}}x.fromService=Z;function Y($e,Pe){const _=Pe&&Pe.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return Pe?.properties?.has(ie)?Pe.properties.get(ie):ne(ie)?function(be){return $e.listen(ie,be)}:ce(ie)?$e.listen(ie):async function(...be){let Ce;Pe&&!(0,$.$ag)(Pe.context)?Ce=[Pe.context,...be]:Ce=be;const oe=await $e.call(ie,Ce);return _?oe:(0,A.$Zh)(oe)};throw new w.$bb(`Property not found: ${String(ie)}`)}})}x.toService=Y;function ce($e){return $e[0]==="o"&&$e[1]==="n"&&C.$sf($e.charCodeAt(2))}function ne($e){return/^onDynamic/.test($e)&&C.$sf($e.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Z=x.toString();if(Z!=="[object Object]")return Z}return x}function B(x){return Array.isArray(x)?x.map(T):T(x)}function W(x,Z,Y,ce,ne,$e,Pe){Pe=B(Pe);const _=O[ne],U=_[ce%_.length];let ie=[`%c[${x}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test($e)?(ie=ie.concat(Pe),ie.push(")")):ie.push(Pe),console.log.apply(console,ie)}class X{constructor(Z,Y){this.d=Z,this.f=Y,this.a=0,this.b=0}logOutgoing(Z,Y,ce,ne,$e){this.b+=Z,W(this.d,this.b,Z,Y,ce,ne,$e)}logIncoming(Z,Y,ce,ne,$e){this.a+=Z,W(this.f,this.a,Z,Y,ce,ne,$e)}}e.$_h=X}),define(ke[82],Ee([1,0,21,4,3,81]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.ProtocolConstants=e.$ai=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var w;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let h=0;function m(p,E){if(!a.has(p)){const y=String(++h);a.set(p,y)}return a.get(p)}function D(p,E,y,P){if(!l.enableDiagnostics)return;const I=m(p,E);if(P instanceof u.$Ce||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const j=u.$Ce.alloc(P.byteLength);j.set(P),l.records.push({timestamp:Date.now(),id:I,label:E,type:y,buff:j})}else l.records.push({timestamp:Date.now(),id:I,label:E,type:y,data:P})}l.traceSocketEvent=D})(w||(e.SocketDiagnostics=w={}));var b;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let S=null;function A(){return S||(S=u.$Ce.alloc(0)),S}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,h){if(a===0)return A();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const E=this.a[0];return h&&(this.a.shift(),this.b-=a),E}if(this.a[0].byteLength>a){const E=this.a[0].slice(0,a);return h&&(this.a[0]=this.a[0].slice(a),this.b-=a),E}const m=u.$Ce.alloc(a);let D=0,p=0;for(;a>0;){const E=this.a[p];if(E.byteLength>a){const y=E.slice(0,a);m.set(y,D),D+=a,h&&(this.a[p]=E.slice(a),this.b-=a),a-=a}else m.set(E,D),D+=E.byteLength,h?(this.a.shift(),this.b-=E.byteLength):p++,a-=E.byteLength}return m}}e.$ai=C;var $;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})($||($={}));function k(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class c{constructor(a,h,m,D){this.type=a,this.id=h,this.ack=m,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.$Uc{constructor(a){super(),this.f=this.B(new N.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,D=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new c(m,D,p,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=u.$Ce.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(h,a.data)}g(a,h){const m=this.f===0;return this.d.push(a,h),this.f+=a.byteLength+h.byteLength,m}h(){const a=u.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,h){this.g(a,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class n extends L.$Uc{constructor(a){super(),this.f=new N.$be,this.onMessage=this.f.event,this.g=new N.$be,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new c(1,0,0,a))}}e.$bi=n;class i extends R.$8h{static fromSocket(a,h){return new i(new n(a),h)}get onDidDispose(){return this.b.onDidDispose}constructor(a,h,m=null){super(a,h,m),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$ci=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$di=r;class s{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,h=this.a;for(;h;)h=h.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let h=0,m=this.a;for(;m;)a[h++]=m.data,m=m.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const h=new s(a);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const a=Date.now();for(let h=0;h<f.a;h++)this.c[h]=a-1e3*h;setInterval(()=>{for(let h=f.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),h=(1+f.a)*1e3;let m=0;for(let D=0;D<f.a;D++)a-this.c[D]<=h&&m++;return 1-m/f.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??f.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new c(5,0,0,A());this.p.write(a),this.p.flush()}sendPause(){const a=new c(7,0,0,A());this.p.write(a)}sendResume(){const a=new c(8,0,0,A());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,h){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new c(3,0,this.h,A());this.p.write(a);const h=this.b.toArray();for(let m=0,D=h.length;m<D;m++)this.p.write(h[m]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const h=this.b.peek();if(h&&h.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new c(6,0,0,A())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let m=0,D=h.length;m<D;m++)this.p.write(h[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const h=++this.c;this.h=this.g;const m=new c(1,h,this.h,a);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(a){const h=new c(2,0,0,a);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),h=Date.now()-a.writtenTime,m=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&m>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:m});return}const p=Math.max(2e4-h,2e4-m,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new c(3,0,this.h,A());this.p.write(a)}D(){this.h=this.g;const a=new c(9,0,this.h,A());this.p.write(a)}}e.$ei=d}),define(ke[194],Ee([1,0,53,8,21,22,192,13,4,3,24,105,102,81]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class v extends k.$5h{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",n=>L.$Ce.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Rq=v;class c{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new b.$be,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$nh(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,r,s){return n.k(o,i,r,s)},listen(i,r){return n.l(o,i,r)}}}k(o,n,i,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(w.$6());this.b.cancel();const s=this.n(o),t=(0,N.$dh)(l=>s.call(n,i,l)),f=r.onCancellationRequested(()=>t.cancel()),d=(0,S.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{f.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return b.Event.None;this.b.cancel();let r;const s=new b.$be({onWillAddFirstListener:()=>{r=this.n(o).listen(n,i)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$Wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$hm)(n.env),this.d=(0,u.fork)(this.i,o,n);const i=new b.$be,s=b.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,M.$Nq)(h)){(0,M.log)(h,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$Ce.wrap(Buffer.from(h,"base64")))}),t=this.j.useQueue?(0,C.$jm)(this.d):this.d,f=h=>this.d&&this.d.connected&&t.send(h.buffer.toString("base64")),d=i.event,l={send:f,onMessage:d};this.f=new k.$6h(l);const a=()=>this.o();process.once("exit",a),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,m)=>{process.removeListener("exit",a),s.dispose(),this.c.forEach(D=>(0,S.$Pc)(D)),this.c.clear(),h!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+m),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:m})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sq=c}),define(ke[195],Ee([1,0,8,4,3,58,18]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.StorageState=e.StorageHint=void 0,e.$Pp=b;var w;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function b($){const k=$;return k?.changed instanceof Map||k?.deleted instanceof Set}var S;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(S||(e.StorageState=S={}));class A extends L.$Uc{static{this.a=100}constructor(k,v=Object.create(null)){super(),this.r=k,this.s=v,this.b=this.B(new N.$ee),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new u.$oh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((v,c)=>this.w(c,v)),k.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(k,v){if(this.c===S.Closed)return;let c=!1;(0,M.$ag)(v)?c=this.f.delete(k):this.f.get(k)!==v&&(this.f.set(k,v),c=!0),c&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,v){const c=this.f.get(k);return(0,M.$ag)(c)?v:c}getBoolean(k,v){const c=this.get(k);return(0,M.$ag)(c)?v:c==="true"}getNumber(k,v){const c=this.get(k);return(0,M.$ag)(c)?v:parseInt(c,10)}getObject(k,v){const c=this.get(k);return(0,M.$ag)(c)?v:(0,R.$Yh)(c)}async set(k,v,c=!1){if(this.c===S.Closed)return;if((0,M.$ag)(v))return this.delete(k,c);const g=(0,M.$6f)(v)||Array.isArray(v)?(0,R.$Xh)(v):String(v);if(this.f.get(k)!==g)return this.f.set(k,g),this.j.set(k,g),this.h.delete(k),this.b.fire({key:k,external:c}),this.D()}async delete(k,v=!1){if(!(this.c===S.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:v}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(this.z)return this.D(k)}async D(k){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$Qp=A;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((v,c)=>this.a.set(c,v)),k.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Rp=C}),define(ke[196],Ee([1,0,14,11,21]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=A,e.$ut=C;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let w;function b(){return w||(w=new TextDecoder("UTF-16BE")),w}let S;function A(){return S||(S=N.$D()?M():b()),S}function C(v,c,g){const o=new Uint16Array(v.buffer,c,g);return g>0&&(o[0]===65279||o[0]===65534)?$(v,c,g):M().decode(o)}function $(v,c,g){const o=[];let n=0;for(let i=0;i<g;i++){const r=L.$Ee(v,c);c+=2,o[n++]=String.fromCharCode(r)}return o.join("")}class k{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return A().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const g=this.a-this.d;g<=1&&(g===0||u.$xf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const g=c.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=c;return}for(let o=0;o<g;o++)this.b[this.d++]=c.charCodeAt(o)}}e.$vt=k}),define(ke[197],Ee([1,0,21,196]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function L(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,A,C,$){this.oldPosition=S,this.oldText=A,this.newPosition=C,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,A,C){const $=A.length;u.$He(S,$,C),C+=4;for(let k=0;k<$;k++)u.$Fe(S,A.charCodeAt(k),C),C+=2;return C}static d(S,A){const C=u.$Ge(S,A);return A+=4,(0,N.$ut)(S,A,C)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(S,A){return u.$He(S,this.oldPosition,A),A+=4,u.$He(S,this.newPosition,A),A+=4,A=R.c(S,this.oldText,A),A=R.c(S,this.newText,A),A}static read(S,A,C){const $=u.$Ge(S,A);A+=4;const k=u.$Ge(S,A);A+=4;const v=R.d(S,A);A+=R.a(v);const c=R.d(S,A);return A+=R.a(c),C.push(new R($,v,k,c)),A}}e.$wt=R;function M(b,S){return b===null||b.length===0?S:new w(b,S).compress()}class w{constructor(S,A){this.a=S,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,A=0,C=this.n(S),$=this.l(A);for(;S<this.f||A<this.h;){if(C===null){this.k($),$=this.l(++A);continue}if($===null){this.m(C),C=this.n(++S);continue}if($.oldEnd<=C.newPosition){this.k($),$=this.l(++A);continue}if(C.newEnd<=$.oldPosition){this.m(C),C=this.n(++S);continue}if($.oldPosition<C.newPosition){const[o,n]=w.r($,C.newPosition-$.oldPosition);this.k(o),$=n;continue}if(C.newPosition<$.oldPosition){const[o,n]=w.q(C,$.oldPosition-C.newPosition);this.m(o),C=n;continue}let c,g;if($.oldEnd===C.newEnd)c=C,g=$,C=this.n(++S),$=this.l(++A);else if($.oldEnd<C.newEnd){const[o,n]=w.q(C,$.oldLength);c=o,g=$,C=n,$=this.l(++A)}else{const[o,n]=w.r($,C.newLength);c=C,g=o,C=this.n(++S),$=n}this.d[this.e++]=new R(c.oldPosition,c.oldText,g.newPosition,g.newText),this.g+=c.newLength-c.oldLength,this.j+=g.newLength-g.oldLength}const k=w.s(this.d);return w.t(k)}k(S){this.d[this.e++]=w.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=w.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,A){return new R(A.oldPosition-S,A.oldText,A.newPosition,A.newText)}static p(S,A){return new R(A.oldPosition,A.oldText,A.newPosition+S,A.newText)}static q(S,A){const C=S.newText.substr(0,A),$=S.newText.substr(A);return[new R(S.oldPosition,S.oldText,S.newPosition,C),new R(S.oldEnd,"",S.newPosition+A,$)]}static r(S,A){const C=S.oldText.substr(0,A),$=S.oldText.substr(A);return[new R(S.oldPosition,C,S.newPosition,S.newText),new R(S.oldPosition+A,$,S.newEnd,"")]}static s(S){if(S.length===0)return S;const A=[];let C=0,$=S[0];for(let k=1;k<S.length;k++){const v=S[k];$.oldEnd===v.oldPosition?$=new R($.oldPosition,$.oldText+v.oldText,$.newPosition,$.newText+v.newText):(A[C++]=$,$=v)}return A[C++]=$,A}static t(S){if(S.length===0)return S;const A=[];let C=0;for(let $=0;$<S.length;$++){const k=S[$];k.oldText!==k.newText&&(A[C++]=k)}return A}}}),define(ke[198],Ee([1,0,35,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=L,e.$Vt=R;function L(M,w,b,S,A,C){if(Array.isArray(M)){let $=0;for(const k of M){const v=L(k,w,b,S,A,C);if(v===10)return v;v>$&&($=v)}return $}else{if(typeof M=="string")return S?M==="*"?5:M===b?10:0:0;if(M){const{language:$,pattern:k,scheme:v,hasAccessToAllModels:c,notebookType:g}=M;if(!S&&!c)return 0;g&&A&&(w=A);let o=0;if(v)if(v===w.scheme)o=10;else if(v==="*")o=5;else return 0;if($)if($===b)o=10;else if($==="*")o=Math.max(o,5);else return 0;if(g)if(g===C)o=10;else if(g==="*"&&C!==void 0)o=Math.max(o,5);else return 0;if(k){let n;if(typeof k=="string"?n=k:n={...k,base:(0,N.$ic)(k.base)},n===w.fsPath||(0,u.$jk)(n,w.fsPath))o=10;else return 0}return o}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(ke[199],Ee([1,0,4,14,29,79,130,174,197,3]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class A extends S.$Uc{constructor($,k,v,c,g,o,n){super(),this.m=this.B(new u.$be),this.onDidChangeContent=this.m.event,this.f=k,this.j=!o,this.g=c,this.h=g,this.c=new M.$KC($,v,n)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,k){return this.c.getOffsetAt($,k)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,k){const v=$+k,c=this.getPositionAt($),g=this.getPositionAt(v);return new L.$kt(c.lineNumber,c.column,g.lineNumber,g.column)}getValueInRange($,k=0){if($.isEmpty())return"";const v=this.n(k);return this.c.getValueInRange($,v)}getValueLengthInRange($,k=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const v=this.getOffsetAt($.startLineNumber,$.startColumn),c=this.getOffsetAt($.endLineNumber,$.endColumn);let g=0;const o=this.n(k),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,r=$.endLineNumber-$.startLineNumber;g=i*r}return c-v+g}getCharacterCountInRange($,k=0){if(this.j){let v=0;const c=$.startLineNumber,g=$.endLineNumber;for(let o=c;o<=g;o++){const n=this.getLineContent(o),i=o===c?$.startColumn-1:0,r=o===g?$.endColumn-1:n.length;for(let s=i;s<r;s++)N.$xf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(k).length*(g-c),v}return this.getValueLengthInRange($,k)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,k){return this.c.getLineCharCode($,k)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const k=N.$if(this.getLineContent($));return k===-1?0:k+1}getLineLastNonWhitespaceColumn($){const k=N.$kf(this.getLineContent($));return k===-1?0:k+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,k,v){let c=this.g,g=this.h,o=this.j,n=!0,i=[];for(let a=0;a<$.length;a++){const h=$[a];n&&h._isTracked&&(n=!1);const m=h.range;if(h.text){let P=!0;o||(P=!N.$If(h.text),o=P),!c&&P&&(c=N.$Hf(h.text)),!g&&P&&(g=N.$Kf(h.text))}let D="",p=0,E=0,y=0;if(h.text){let P;[p,E,y,P]=(0,w.$Nt)(h.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,I)}i[a]={sortIndex:a,identifier:h.identifier||null,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m),text:D,eolCount:p,firstLineLength:E,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}i.sort(A.u);let r=!1;for(let a=0,h=i.length-1;a<h;a++){const m=i[a].range.getEndPosition(),D=i[a+1].range.getStartPosition();if(D.isBeforeOrEqual(m)){if(D.isBefore(m))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const s=v||k?A._getInverseEditRanges(i):[],t=[];if(k)for(let a=0;a<i.length;a++){const h=i[a],m=s[a];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=m.startLineNumber;D<=m.endLineNumber;D++){let p="";D===m.startLineNumber&&(p=this.getLineContent(h.range.startLineNumber),N.$if(p)!==-1)||t.push({lineNumber:D,oldContent:p})}}let f=null;if(v){let a=0;f=[];for(let h=0;h<i.length;h++){const m=i[h],D=s[h],p=this.getValueInRange(m.range),E=m.rangeOffset+a;a+=m.text.length-p.length,f[h]={sortIndex:m.sortIndex,identifier:m.identifier,range:D,text:p,textChange:new b.$wt(m.rangeOffset,p,E,m.text)}}r||f.sort((h,m)=>h.sortIndex-m.sortIndex)}this.g=c,this.h=g,this.j=o;const d=this.t(i);let l=null;if(k&&t.length>0){t.sort((a,h)=>h.lineNumber-a.lineNumber),l=[];for(let a=0,h=t.length;a<h;a++){const m=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===m)continue;const D=t[a].oldContent,p=this.getLineContent(m);p.length===0||p===D||N.$if(p)!==-1||l.push(m)}}return this.m.fire(),new R.$zv(f,d,l)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let k=!1;const v=$[0].range,c=$[$.length-1].range,g=new L.$kt(v.startLineNumber,v.startColumn,c.endLineNumber,c.endColumn);let o=v.startLineNumber,n=v.startColumn;const i=[];for(let d=0,l=$.length;d<l;d++){const a=$[d],h=a.range;k=k||a.forceMoveMarkers,i.push(this.getValueInRange(new L.$kt(o,n,h.startLineNumber,h.startColumn))),a.text.length>0&&i.push(a.text),o=h.endLineNumber,n=h.endColumn}const r=i.join(""),[s,t,f]=(0,w.$Nt)(r);return{sortIndex:0,identifier:$[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const k=[];for(let v=0;v<$.length;v++){const c=$[v],g=c.range.startLineNumber,o=c.range.startColumn,n=c.range.endLineNumber,i=c.range.endColumn;if(g===n&&o===i&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const r=new L.$kt(g,o,n,i);k.push({range:r,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return k}findMatchesLineByLine($,k,v,c){return this.c.findMatchesLineByLine($,k,v,c)}getPieceTree(){return this.c}static _getInverseEditRange($,k){const v=$.startLineNumber,c=$.startColumn,[g,o,n]=(0,w.$Nt)(k);let i;if(k.length>0){const r=g+1;r===1?i=new L.$kt(v,c,v,c+o):i=new L.$kt(v,c,v+r-1,n+1)}else i=new L.$kt(v,c,v,c);return i}static _getInverseEditRanges($){const k=[];let v=0,c=0,g=null;for(let o=0,n=$.length;o<n;o++){const i=$[o];let r,s;g?g.range.endLineNumber===i.range.startLineNumber?(r=v,s=c+(i.range.startColumn-g.range.endColumn)):(r=v+(i.range.startLineNumber-g.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new L.$kt(r,s,r,s+i.firstLineLength):t=new L.$kt(r,s,r+f-1,i.lastLineLength+1)}else t=new L.$kt(r,s,r,s);v=t.endLineNumber,c=t.endColumn,k.push(t),g=i}return k}static u($,k){const v=L.$kt.compareRangesUsingEnds($.range,k.range);return v===0?$.sortIndex-k.sortIndex:v}static w($,k){const v=L.$kt.compareRangesUsingEnds($.range,k.range);return v===0?k.sortIndex-$.sortIndex:-v}}e.$LC=A}),define(ke[200],Ee([1,0,14,130,199]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=void 0;class R{constructor(b,S,A,C,$,k,v,c,g){this.a=b,this.b=S,this.c=A,this.d=C,this.e=$,this.f=k,this.g=v,this.h=c,this.j=g}k(b){const S=this.c+this.d+this.e,A=this.c+this.e;return S===0?b===1?`
`:`\r
`:A>S/2?`\r
`:`
`}create(b){const S=this.k(b),A=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let $=0,k=A.length;$<k;$++){const v=A[$].buffer.replace(/\r\n|\r|\n/g,S),c=(0,N.$GC)(v);A[$]=new N.$JC(v,c)}const C=new L.$LC(A,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(b){return this.a[0].buffer.substr(0,b).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(b){if(b.length===0)return;this.a.length===0&&u.$Rf(b)&&(this.b=u.$Qf,b=b.substr(1));const S=b.charCodeAt(b.length-1);S===13||S>=55296&&S<=56319?(this.m(b.substr(0,b.length-1),!1),this.c=!0,this.d=S):(this.m(b,!1),this.c=!1,this.d=S)}m(b,S){!S&&b.length===0||(this.c?this.n(String.fromCharCode(this.d)+b):this.n(b))}n(b){const S=(0,N.$HC)(this.e,b);this.a.push(new N.$JC(b,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=u.$Hf(b)),this.k||(this.k=u.$Kf(b)))}finish(b=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,b)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const b=this.a[this.a.length-1];b.buffer+=String.fromCharCode(this.d);const S=(0,N.$GC)(b.buffer);b.lineStarts=S,this.d===13&&this.f++}}}e.$MC=M}),define(ke[134],Ee([1,0,21,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbb=b,e.$ibb=A;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function R(C){for(let $=0,k=C.length;$<k;$+=4){const v=C[$+0],c=C[$+1],g=C[$+2],o=C[$+3];C[$+0]=o,C[$+1]=g,C[$+2]=c,C[$+3]=v}}function M(C){const $=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||R($),u.$Ce.wrap($)}function w(C){const $=C.buffer;if(N.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const k=new Uint8Array($.byteLength);return k.set($),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function b(C){const $=new Uint32Array(S(C));let k=0;if($[k++]=C.id,C.type==="full")$[k++]=1,$[k++]=C.data.length,$.set(C.data,k),k+=C.data.length;else{$[k++]=2,$[k++]=C.deltas.length;for(const v of C.deltas)$[k++]=v.start,$[k++]=v.deleteCount,v.data?($[k++]=v.data.length,$.set(v.data,k),k+=v.data.length):$[k++]=0}return M($)}function S(C){let $=0;if($+=2,C.type==="full")$+=1+C.data.length;else{$+=1,$+=3*C.deltas.length;for(const k of C.deltas)k.data&&($+=k.data.length)}return $}function A(C){const $=w(C);let k=0;const v=$[k++];if($[k++]===1){const n=$[k++],i=$.subarray(k,k+n);return k+=n,{id:v,type:"full",data:i}}const g=$[k++],o=[];for(let n=0;n<g;n++){const i=$[k++],r=$[k++],s=$[k++];let t;s>0&&(t=$.subarray(k,k+s),k+=s),o[n]={start:i,deleteCount:r,data:t}}return{id:v,type:"delta",deltas:o}}}),define(ke[201],Ee([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,177,129,201]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=we;var b;(function(se){se[se.None=0]="None",se[se.Keep=1]="Keep",se[se.Brackets=2]="Brackets",se[se.Advanced=3]="Advanced",se[se.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=S;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(ue,Ie,Ge,Me){this.id=ue,this.name=Ie,this.defaultValue=Ge,this.schema=Me}applyUpdate(ue,Ie){return k(ue,Ie)}compute(ue,Ie,Ge){return Ge}}class ${constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=$;function k(se,ue){if(typeof se!="object"||typeof ue!="object"||!se||!ue)return new $(ue,se!==ue);if(Array.isArray(se)||Array.isArray(ue)){const Ge=Array.isArray(se)&&Array.isArray(ue)&&u.$ub(se,ue);return new $(ue,!Ge)}let Ie=!1;for(const Ge in ue)if(ue.hasOwnProperty(Ge)){const Me=k(se[Ge],ue[Ge]);Me.didChange&&(se[Ge]=Me.newValue,Ie=!0)}return new $(se,Ie)}class v{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return k(ue,Ie)}validate(ue){return this.defaultValue}}class c{constructor(ue,Ie,Ge,Me){this.id=ue,this.name=Ie,this.defaultValue=Ge,this.schema=Me}applyUpdate(ue,Ie){return k(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ge){return Ge}}function g(se,ue){return typeof se>"u"?ue:se==="false"?!1:!!se}class o extends c{constructor(ue,Ie,Ge,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ge),super(ue,Ie,Ge,Me)}validate(ue){return g(ue,this.defaultValue)}}function n(se,ue,Ie,Ge){if(typeof se>"u")return ue;let Me=parseInt(se,10);return isNaN(Me)?ue:(Me=Math.max(Ie,Me),Me=Math.min(Ge,Me),Me|0)}class i extends c{static clampedInt(ue,Ie,Ge,Me){return n(ue,Ie,Ge,Me)}constructor(ue,Ie,Ge,Me,nt,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Ge,lt.minimum=Me,lt.maximum=nt),super(ue,Ie,Ge,lt),this.minimum=Me,this.maximum=nt}validate(ue){return i.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(se,ue,Ie,Ge){if(typeof se>"u")return ue;const Me=s.float(se,ue);return s.clamp(Me,Ie,Ge)}class s extends c{static clamp(ue,Ie,Ge){return ue<Ie?Ie:ue>Ge?Ge:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ge=parseFloat(ue);return isNaN(Ge)?Ie:Ge}constructor(ue,Ie,Ge,Me,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ge),super(ue,Ie,Ge,nt),this.validationFn=Me}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends c{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ge,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ge),super(ue,Ie,Ge,Me)}validate(ue){return t.string(ue,this.defaultValue)}}function f(se,ue,Ie,Ge){return typeof se!="string"?ue:Ge&&se in Ge?Ge[se]:Ie.indexOf(se)===-1?ue:se}class d extends c{constructor(ue,Ie,Ge,Me,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Me,nt.default=Ge),super(ue,Ie,Ge,nt),this.c=Me}validate(ue){return f(ue,this.defaultValue,this.c)}}class l extends C{constructor(ue,Ie,Ge,Me,nt,lt,yt=void 0){typeof yt<"u"&&(yt.type="string",yt.enum=nt,yt.default=Me),super(ue,Ie,Ge,yt),this.c=nt,this.d=lt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function a(se){switch(se){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ge){return Ge===0?ue.accessibilitySupport:Ge}}class m extends C{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:g(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(se){se[se.Hidden=0]="Hidden",se[se.Blink=1]="Blink",se[se.Smooth=2]="Smooth",se[se.Phase=3]="Phase",se[se.Expand=4]="Expand",se[se.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function p(se){switch(se){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(se){se[se.Line=1]="Line",se[se.Block=2]="Block",se[se.Underline=3]="Underline",se[se.LineThin=4]="LineThin",se[se.BlockOutline=5]="BlockOutline",se[se.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function y(se){switch(se){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function P(se){switch(se){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class I extends v{constructor(){super(142)}compute(ue,Ie,Ge){const Me=["monaco-editor"];return Ie.get(39)&&Me.push(Ie.get(39)),ue.extraEditorClassName&&Me.push(ue.extraEditorClassName),Ie.get(74)==="default"?Me.push("mouse-default"):Ie.get(74)==="copy"&&Me.push("mouse-copy"),Ie.get(111)&&Me.push("showUnused"),Ie.get(140)&&Me.push("showDeprecated"),Me.join(" ")}}class j extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ue,Ie,Ge){return Ge&&ue.emptySelectionClipboard}}class F extends C{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:w.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:w.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:g(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":f(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":f(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ie.loop,this.defaultValue.loop)}}}class z extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?z.OFF:ue==="true"?z.ON:ue:ue?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?O.OFF:ue==="true"?O.TRANSLATE:ue:ue?O.TRANSLATE:O.OFF}compute(ue,Ie,Ge){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class T extends v{constructor(){super(50)}compute(ue,Ie,Ge){return ue.fontInfo}}class B extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(ue){const Ie=s.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Ie,6,100)}compute(ue,Ie,Ge){return ue.fontInfo.fontSize}}class W extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(i.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class X extends C{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ge,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ge,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ge,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ge,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ge,description:w.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:f(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??f(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??f(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??f(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??f(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??f(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:w.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:g(Ie.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ie.above,this.defaultValue.above)}}}var Z;(function(se){se[se.None=0]="None",se[se.Text=1]="Text",se[se.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class Y extends v{constructor(){super(145)}compute(ue,Ie,Ge){return Y.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ge=Math.floor(ue.paddingTop/ue.lineHeight);let Me=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Me=Math.max(Me,Ie-1));const nt=(Ge+ue.viewLineCount+Me)/(ue.pixelRatio*ue.height),lt=Math.floor(ue.viewLineCount/nt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Me,desiredRatio:nt,minimapLineCount:lt}}static c(ue,Ie){const Ge=ue.outerWidth,Me=ue.outerHeight,nt=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const lt=Ie.stableMinimapLayoutInput,yt=lt&&ue.outerHeight===lt.outerHeight&&ue.lineHeight===lt.lineHeight&&ue.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===lt.pixelRatio&&ue.scrollBeyondLastLine===lt.scrollBeyondLastLine&&ue.paddingTop===lt.paddingTop&&ue.paddingBottom===lt.paddingBottom&&ue.minimap.enabled===lt.minimap.enabled&&ue.minimap.side===lt.minimap.side&&ue.minimap.size===lt.minimap.size&&ue.minimap.showSlider===lt.minimap.showSlider&&ue.minimap.renderCharacters===lt.minimap.renderCharacters&&ue.minimap.maxColumn===lt.minimap.maxColumn&&ue.minimap.scale===lt.minimap.scale&&ue.verticalScrollbarWidth===lt.verticalScrollbarWidth&&ue.isViewportWrapping===lt.isViewportWrapping,At=ue.lineHeight,Ft=ue.typicalHalfwidthCharacterWidth,Qt=ue.scrollBeyondLastLine,xt=ue.minimap.renderCharacters;let Dt=nt>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const qt=ue.minimap.maxColumn,Xt=ue.minimap.size,et=ue.minimap.side,ri=ue.verticalScrollbarWidth,_t=ue.viewLineCount,ft=ue.remainingWidth,$t=ue.isViewportWrapping,ei=xt?2:3;let Zt=Math.floor(nt*Me);const zt=Zt/nt;let gt=!1,Ut=!1,Yt=ei*Dt,Bt=Dt/nt,xe=1;if(Xt==="fill"||Xt==="fit"){const{typicalViewportLineCount:Nt,extraLinesBeforeFirstLine:ti,extraLinesBeyondLastLine:Ht,desiredRatio:si,minimapLineCount:Mt}=Y.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:Qt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Me,lineHeight:At,pixelRatio:nt});if(_t/Mt>1)gt=!0,Ut=!0,Dt=1,Yt=1,Bt=Dt/nt;else{let Pt=!1,It=Dt+1;if(Xt==="fit"){const bt=Math.ceil((ti+_t+Ht)*Yt);$t&&yt&&ft<=Ie.stableFitRemainingWidth?(Pt=!0,It=Ie.stableFitMaxMinimapScale):Pt=bt>Zt}if(Xt==="fill"||Pt){gt=!0;const bt=Dt;Yt=Math.min(At*nt,Math.max(1,Math.floor(1/si))),$t&&yt&&ft<=Ie.stableFitRemainingWidth&&(It=Ie.stableFitMaxMinimapScale),Dt=Math.min(It,Math.max(1,Math.floor(Yt/ei))),Dt>bt&&(xe=Math.min(2,Dt/bt)),Bt=Dt/nt/xe,Zt=Math.ceil(Math.max(Nt,ti+_t+Ht)*Yt),$t?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=ft,Ie.stableFitMaxMinimapScale=Dt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const oi=Math.floor(qt*Bt),Vt=Math.min(oi,Math.max(0,Math.floor((ft-ri-2)*Bt/(Ft+Bt)))+e.MINIMAP_GUTTER_WIDTH);let Kt=Math.floor(nt*Vt);const mt=Kt/nt;Kt=Math.floor(Kt*xe);const Rt=xt?1:2,Ot=et==="left"?0:Ge-Vt-ri;return{renderMinimap:Rt,minimapLeft:Ot,minimapWidth:Vt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Ut,minimapScale:Dt,minimapLineHeight:Yt,minimapCanvasInnerWidth:Kt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:zt}}static computeLayout(ue,Ie){const Ge=Ie.outerWidth|0,Me=Ie.outerHeight|0,nt=Ie.lineHeight|0,lt=Ie.lineNumbersDigitCount|0,yt=Ie.typicalHalfwidthCharacterWidth,At=Ie.maxDigitWidth,Ft=Ie.pixelRatio,Qt=Ie.viewLineCount,xt=ue.get(137),Dt=xt==="inherit"?ue.get(136):xt,qt=Dt==="inherit"?ue.get(132):Dt,Xt=ue.get(135),et=Ie.isDominatedByLongLines,ri=ue.get(57),_t=ue.get(68).renderType!==0,ft=ue.get(69),$t=ue.get(105),ei=ue.get(84),Zt=ue.get(73),zt=ue.get(103),gt=zt.verticalScrollbarSize,Ut=zt.verticalHasArrows,Yt=zt.arrowSize,Bt=zt.horizontalScrollbarSize,xe=ue.get(43),oi=ue.get(110)!=="never";let Vt=ue.get(66);xe&&oi&&(Vt+=16);let Kt=0;if(_t){const li=Math.max(lt,ft);Kt=Math.round(li*At)}let mt=0;ri&&(mt=nt*Ie.glyphMarginDecorationLaneCount);let Rt=0,Ot=Rt+mt,Nt=Ot+Kt,ti=Nt+Vt;const Ht=Ge-mt-Kt-Vt;let si=!1,Mt=!1,Tt=-1;Dt==="inherit"&&et?(si=!0,Mt=!0):qt==="on"||qt==="bounded"?Mt=!0:qt==="wordWrapColumn"&&(Tt=Xt);const Pt=Y.c({outerWidth:Ge,outerHeight:Me,lineHeight:nt,typicalHalfwidthCharacterWidth:yt,pixelRatio:Ft,scrollBeyondLastLine:$t,paddingTop:ei.top,paddingBottom:ei.bottom,minimap:Zt,verticalScrollbarWidth:gt,viewLineCount:Qt,remainingWidth:Ht,isViewportWrapping:Mt},Ie.memory||new A);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(Rt+=Pt.minimapWidth,Ot+=Pt.minimapWidth,Nt+=Pt.minimapWidth,ti+=Pt.minimapWidth);const It=Ht-Pt.minimapWidth,bt=Math.max(1,Math.floor((It-gt-2)/yt)),Ct=Ut?Yt:0;return Mt&&(Tt=Math.max(1,bt),qt==="bounded"&&(Tt=Math.min(Tt,Xt))),{width:Ge,height:Me,glyphMarginLeft:Rt,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ot,lineNumbersWidth:Kt,decorationsLeft:Nt,decorationsWidth:Vt,contentLeft:ti,contentWidth:It,minimap:Pt,viewportColumn:bt,isWordWrapMinified:si,isViewportWrapping:Mt,wrappingColumn:Tt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Bt,overviewRuler:{top:Ct,width:gt,height:Me-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=Y;class ce extends C{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(ue){return f(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ge){return Ie.get(2)===2?"advanced":Ge}}var ne;(function(se){se.Off="off",se.OnCode="onCode",se.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class $e extends C{constructor(){const ue={enabled:ne.On};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:ue.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:f(ue.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class Pe extends C{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:w.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends C{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:w.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:f(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:g(Ie.padding,this.defaultValue.padding)}}}class U extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):i.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ge){return Ge<0?i.clampedInt(-Ge*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ie extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:w.localize(66,null)})}compute(ue,Ie,Ge){return ue.fontInfo.lineHeight}}class be extends C{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:ue.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:w.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:w.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:w.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:w.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),autohide:g(Ie.autohide,this.defaultValue.autohide),size:f(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ie.side,this.defaultValue.side,["right","left"]),showSlider:f(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ie.scale,1,1,3),maxColumn:i.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:g(Ie.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:g(Ie.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Ie.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ce(se){return se==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class oe extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:i.clampedInt(Ie.top,0,0,1e3),bottom:i.clampedInt(Ie.bottom,0,0,1e3)}}}class ae extends C{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:w.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:w.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),cycle:g(Ie.cycle,this.defaultValue.cycle)}}}class re extends v{constructor(){super(143)}compute(ue,Ie,Ge){return ue.pixelRatio}}class G extends C{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(85,null),w.localize(86,null),w.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:w.localize(88,null)},comments:{anyOf:Ie,default:ue.comments,description:w.localize(89,null)},other:{anyOf:Ie,default:ue.other,description:w.localize(90,null)}},default:ue,markdownDescription:w.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Ft=ue?"on":"off";return{comments:Ft,strings:Ft,other:Ft}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ge,strings:Me}=ue,nt=["on","inline","off"];let lt,yt,At;return typeof Ie=="boolean"?lt=Ie?"on":"off":lt=f(Ie,this.defaultValue.other,nt),typeof Ge=="boolean"?yt=Ge?"on":"off":yt=f(Ge,this.defaultValue.comments,nt),typeof Me=="boolean"?At=Me?"on":"off":At=f(Me,this.defaultValue.strings,nt),{other:lt,comments:yt,strings:At}}}var te;(function(se){se[se.Off=0]="Off",se[se.On=1]="On",se[se.Relative=2]="Relative",se[se.Interval=3]="Interval",se[se.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class ge extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(92,null),w.localize(93,null),w.localize(94,null),w.localize(95,null)],default:"on",description:w.localize(96,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ge=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ge}}}function we(se){const ue=se.get(98);return ue==="editable"?se.get(91):ue!=="on"}class Re extends C{constructor(){const ue=[],Ie={type:"number",description:w.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:w.localize(98,null),format:"color-hex"}}}]},default:ue,description:w.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ge of ue)if(typeof Ge=="number")Ie.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Me=Ge;Ie.push({column:i.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Ie.sort((Ge,Me)=>Ge.column-Me.column),Ie}return this.defaultValue}}class fe extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Se(se,ue){if(typeof se!="string")return ue;switch(se){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends C{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(100,null),w.localize(101,null),w.localize(102,null)],default:"auto",description:w.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(104,null),w.localize(105,null),w.localize(106,null)],default:"auto",description:w.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:w.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:w.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:w.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:w.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ge=i.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=i.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(Ie.vertical,this.defaultValue.vertical),horizontal:Se(Ie.horizontal,this.defaultValue.horizontal),useShadows:g(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Ie.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:i.clampedInt(Ie.verticalSliderSize,Me,0,1e3),scrollByPage:g(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends C{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:w.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:w.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:w.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:w.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:w.localize(118,null)}})}applyUpdate(ue,Ie){let Ge=!1;Ie.allowedCharacters&&ue&&(N.$1n(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ge=!0)),Ie.allowedLocales&&ue&&(N.$1n(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ge=!0));const Me=super.applyUpdate(ue,Ie);return Ge?new $(Me.newValue,!0):Me}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:he(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ge={};for(const[Me,nt]of Object.entries(ue))nt===!0&&(Ge[Me]=!0);return Ge}}class q extends C{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:w.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(120,null),w.localize(121,null),w.localize(122,null)],description:w.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:w.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:w.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),mode:f(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class V extends C{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:w.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(127,null),w.localize(128,null),w.localize(129,null)],description:w.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:w.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:w.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Ie.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:g(Ie.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Q extends C{constructor(){const ue={enabled:R.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:w.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:w.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends C{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null)],default:ue.bracketPairs,description:w.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(139,null),w.localize(140,null),w.localize(141,null)],default:ue.bracketPairsHorizontal,description:w.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:w.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:w.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(145,null),w.localize(146,null),w.localize(147,null)],default:ue.highlightActiveIndentation,description:w.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:he(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(se,ue,Ie){const Ge=Ie.indexOf(se);return Ge===-1?ue:Ie[Ge]}class pe extends C{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(149,null),w.localize(150,null)],default:ue.insertMode,description:w.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:w.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:w.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:w.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(155,null),w.localize(156,null),w.localize(157,null),w.localize(158,null)],default:ue.selectionMode,markdownDescription:w.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:w.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:w.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:w.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:w.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:w.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:f(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ie.preview,this.defaultValue.preview),previewMode:f(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ie.showMethods,this.defaultValue.showMethods),showFunctions:g(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ie.showFields,this.defaultValue.showFields),showVariables:g(Ie.showVariables,this.defaultValue.showVariables),showClasses:g(Ie.showClasses,this.defaultValue.showClasses),showStructs:g(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ie.showModules,this.defaultValue.showModules),showProperties:g(Ie.showProperties,this.defaultValue.showProperties),showEvents:g(Ie.showEvents,this.defaultValue.showEvents),showOperators:g(Ie.showOperators,this.defaultValue.showOperators),showUnits:g(Ie.showUnits,this.defaultValue.showUnits),showValues:g(Ie.showValues,this.defaultValue.showValues),showConstants:g(Ie.showConstants,this.defaultValue.showConstants),showEnums:g(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ie.showKeywords,this.defaultValue.showKeywords),showWords:g(Ie.showWords,this.defaultValue.showWords),showColors:g(Ie.showColors,this.defaultValue.showColors),showFiles:g(Ie.showFiles,this.defaultValue.showFiles),showReferences:g(Ie.showReferences,this.defaultValue.showReferences),showFolders:g(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ie.showUsers,this.defaultValue.showUsers),showIssues:g(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends C{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:w.localize(199,null),type:"string"},{description:w.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const Ie=[];for(const Ge of ue)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Ie.push(Ge)}catch{}return Ie}return this.defaultValue}}var Xe;(function(se){se[se.None=0]="None",se[se.Same=1]="Same",se[se.Indent=2]="Indent",se[se.DeepIndent=3]="DeepIndent"})(Xe||(e.WrappingIndent=Xe={}));class tt extends C{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(201,null),w.localize(202,null),w.localize(203,null),w.localize(204,null)],description:w.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ge){return Ie.get(2)===2?0:Ge}}class ot extends v{constructor(){super(146)}compute(ue,Ie,Ge){const Me=Ie.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class it extends C{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:w.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(208,null),w.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showDropSelector:f(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:w.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(212,null),w.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:g(Ie.enabled,this.defaultValue.enabled),showPasteSelector:f(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const De="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?He:De,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(se){return e.editorOptionsRegistry[se.id]=se,se}var Ze;(function(se){se[se.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",se[se.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",se[se.accessibilitySupport=2]="accessibilitySupport",se[se.accessibilityPageSize=3]="accessibilityPageSize",se[se.ariaLabel=4]="ariaLabel",se[se.ariaRequired=5]="ariaRequired",se[se.autoClosingBrackets=6]="autoClosingBrackets",se[se.autoClosingComments=7]="autoClosingComments",se[se.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",se[se.autoClosingDelete=9]="autoClosingDelete",se[se.autoClosingOvertype=10]="autoClosingOvertype",se[se.autoClosingQuotes=11]="autoClosingQuotes",se[se.autoIndent=12]="autoIndent",se[se.automaticLayout=13]="automaticLayout",se[se.autoSurround=14]="autoSurround",se[se.bracketPairColorization=15]="bracketPairColorization",se[se.guides=16]="guides",se[se.codeLens=17]="codeLens",se[se.codeLensFontFamily=18]="codeLensFontFamily",se[se.codeLensFontSize=19]="codeLensFontSize",se[se.colorDecorators=20]="colorDecorators",se[se.colorDecoratorsLimit=21]="colorDecoratorsLimit",se[se.columnSelection=22]="columnSelection",se[se.comments=23]="comments",se[se.contextmenu=24]="contextmenu",se[se.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",se[se.cursorBlinking=26]="cursorBlinking",se[se.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",se[se.cursorStyle=28]="cursorStyle",se[se.cursorSurroundingLines=29]="cursorSurroundingLines",se[se.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",se[se.cursorWidth=31]="cursorWidth",se[se.disableLayerHinting=32]="disableLayerHinting",se[se.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",se[se.domReadOnly=34]="domReadOnly",se[se.dragAndDrop=35]="dragAndDrop",se[se.dropIntoEditor=36]="dropIntoEditor",se[se.emptySelectionClipboard=37]="emptySelectionClipboard",se[se.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",se[se.extraEditorClassName=39]="extraEditorClassName",se[se.fastScrollSensitivity=40]="fastScrollSensitivity",se[se.find=41]="find",se[se.fixedOverflowWidgets=42]="fixedOverflowWidgets",se[se.folding=43]="folding",se[se.foldingStrategy=44]="foldingStrategy",se[se.foldingHighlight=45]="foldingHighlight",se[se.foldingImportsByDefault=46]="foldingImportsByDefault",se[se.foldingMaximumRegions=47]="foldingMaximumRegions",se[se.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",se[se.fontFamily=49]="fontFamily",se[se.fontInfo=50]="fontInfo",se[se.fontLigatures=51]="fontLigatures",se[se.fontSize=52]="fontSize",se[se.fontWeight=53]="fontWeight",se[se.fontVariations=54]="fontVariations",se[se.formatOnPaste=55]="formatOnPaste",se[se.formatOnType=56]="formatOnType",se[se.glyphMargin=57]="glyphMargin",se[se.gotoLocation=58]="gotoLocation",se[se.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",se[se.hover=60]="hover",se[se.inDiffEditor=61]="inDiffEditor",se[se.inlineSuggest=62]="inlineSuggest",se[se.inlineEdit=63]="inlineEdit",se[se.letterSpacing=64]="letterSpacing",se[se.lightbulb=65]="lightbulb",se[se.lineDecorationsWidth=66]="lineDecorationsWidth",se[se.lineHeight=67]="lineHeight",se[se.lineNumbers=68]="lineNumbers",se[se.lineNumbersMinChars=69]="lineNumbersMinChars",se[se.linkedEditing=70]="linkedEditing",se[se.links=71]="links",se[se.matchBrackets=72]="matchBrackets",se[se.minimap=73]="minimap",se[se.mouseStyle=74]="mouseStyle",se[se.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",se[se.mouseWheelZoom=76]="mouseWheelZoom",se[se.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",se[se.multiCursorModifier=78]="multiCursorModifier",se[se.multiCursorPaste=79]="multiCursorPaste",se[se.multiCursorLimit=80]="multiCursorLimit",se[se.occurrencesHighlight=81]="occurrencesHighlight",se[se.overviewRulerBorder=82]="overviewRulerBorder",se[se.overviewRulerLanes=83]="overviewRulerLanes",se[se.padding=84]="padding",se[se.pasteAs=85]="pasteAs",se[se.parameterHints=86]="parameterHints",se[se.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",se[se.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",se[se.quickSuggestions=89]="quickSuggestions",se[se.quickSuggestionsDelay=90]="quickSuggestionsDelay",se[se.readOnly=91]="readOnly",se[se.readOnlyMessage=92]="readOnlyMessage",se[se.renameOnType=93]="renameOnType",se[se.renderControlCharacters=94]="renderControlCharacters",se[se.renderFinalNewline=95]="renderFinalNewline",se[se.renderLineHighlight=96]="renderLineHighlight",se[se.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",se[se.renderValidationDecorations=98]="renderValidationDecorations",se[se.renderWhitespace=99]="renderWhitespace",se[se.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",se[se.roundedSelection=101]="roundedSelection",se[se.rulers=102]="rulers",se[se.scrollbar=103]="scrollbar",se[se.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",se[se.scrollBeyondLastLine=105]="scrollBeyondLastLine",se[se.scrollPredominantAxis=106]="scrollPredominantAxis",se[se.selectionClipboard=107]="selectionClipboard",se[se.selectionHighlight=108]="selectionHighlight",se[se.selectOnLineNumbers=109]="selectOnLineNumbers",se[se.showFoldingControls=110]="showFoldingControls",se[se.showUnused=111]="showUnused",se[se.snippetSuggestions=112]="snippetSuggestions",se[se.smartSelect=113]="smartSelect",se[se.smoothScrolling=114]="smoothScrolling",se[se.stickyScroll=115]="stickyScroll",se[se.stickyTabStops=116]="stickyTabStops",se[se.stopRenderingLineAfter=117]="stopRenderingLineAfter",se[se.suggest=118]="suggest",se[se.suggestFontSize=119]="suggestFontSize",se[se.suggestLineHeight=120]="suggestLineHeight",se[se.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",se[se.suggestSelection=122]="suggestSelection",se[se.tabCompletion=123]="tabCompletion",se[se.tabIndex=124]="tabIndex",se[se.unicodeHighlighting=125]="unicodeHighlighting",se[se.unusualLineTerminators=126]="unusualLineTerminators",se[se.useShadowDOM=127]="useShadowDOM",se[se.useTabStops=128]="useTabStops",se[se.wordBreak=129]="wordBreak",se[se.wordSegmenterLocales=130]="wordSegmenterLocales",se[se.wordSeparators=131]="wordSeparators",se[se.wordWrap=132]="wordWrap",se[se.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",se[se.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",se[se.wordWrapColumn=135]="wordWrapColumn",se[se.wordWrapOverride1=136]="wordWrapOverride1",se[se.wordWrapOverride2=137]="wordWrapOverride2",se[se.wrappingIndent=138]="wrappingIndent",se[se.wrappingStrategy=139]="wrappingStrategy",se[se.showDeprecated=140]="showDeprecated",se[se.inlayHints=141]="inlayHints",se[se.editorClassName=142]="editorClassName",se[se.pixelRatio=143]="pixelRatio",se[se.tabFocusMode=144]="tabFocusMode",se[se.layoutInfo=145]="layoutInfo",se[se.wrappingInfo=146]="wrappingInfo",se[se.defaultColorDecorators=147]="defaultColorDecorators",se[se.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",se[se.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(214,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(215,null),""],markdownDescription:w.localize(216,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new i(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(217,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",w.localize(218,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(220,null),w.localize(221,null),""],description:w.localize(222,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(223,null),w.localize(224,null),""],description:w.localize(225,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(226,null),""],description:w.localize(227,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(228,null),""],description:w.localize(229,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(230,null),w.localize(231,null),""],description:w.localize(232,null)})),autoIndent:Le(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[w.localize(233,null),w.localize(234,null),w.localize(235,null),w.localize(236,null),w.localize(237,null)],description:w.localize(238,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(239,null),w.localize(240,null),w.localize(241,null),""],description:w.localize(242,null)})),bracketPairColorization:Le(new Q),bracketPairGuides:Le(new J),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:w.localize(243,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:w.localize(244,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:w.localize(245,null)})),codeLensFontSize:Le(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(246,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:w.localize(247,null)})),colorDecoratorActivatedOn:Le(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(248,null),w.localize(249,null),w.localize(250,null)],description:w.localize(251,null)})),colorDecoratorsLimit:Le(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(252,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:w.localize(253,null)})),comments:Le(new m),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(254,null)})),cursorBlinking:Le(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:w.localize(255,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(256,null),w.localize(257,null),w.localize(258,null)],description:w.localize(259,null)})),cursorStyle:Le(new l(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:w.localize(260,null)})),cursorSurroundingLines:Le(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(261,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(262,null),w.localize(263,null)],markdownDescription:w.localize(264,null)})),cursorWidth:Le(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(265,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:w.localize(266,null)})),emptySelectionClipboard:Le(new j),dropIntoEditor:Le(new it),stickyScroll:Le(new Pe),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(267,null),w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new s(40,"fastScrollSensitivity",5,se=>se<=0?5:se,{markdownDescription:w.localize(271,null)})),find:Le(new F),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:w.localize(272,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(273,null),w.localize(274,null)],description:w.localize(275,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:w.localize(276,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:w.localize(277,null)})),foldingMaximumRegions:Le(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(278,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(279,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(280,null)})),fontInfo:Le(new T),fontLigatures2:Le(new z),fontSize:Le(new B),fontWeight:Le(new W),fontVariations:Le(new O),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:w.localize(281,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:w.localize(282,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:w.localize(283,null)})),gotoLocation:Le(new X),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:w.localize(284,null)})),hover:Le(new x),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,se=>s.clamp(se,-5,20),{description:w.localize(285,null)})),lightbulb:Le(new $e),lineDecorationsWidth:Le(new U),lineHeight:Le(new ie),lineNumbers:Le(new ge),lineNumbersMinChars:Le(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(70,"linkedEditing",!1,{description:w.localize(286,null)})),links:Le(new o(71,"links",!0,{description:w.localize(287,null)})),matchBrackets:Le(new d(72,"matchBrackets","always",["always","near","never"],{description:w.localize(288,null)})),minimap:Le(new be),mouseStyle:Le(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new s(75,"mouseWheelScrollSensitivity",1,se=>se===0?1:se,{markdownDescription:w.localize(289,null)})),mouseWheelZoom:Le(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?w.localize(290,null):w.localize(291,null)})),multiCursorMergeOverlapping:Le(new o(77,"multiCursorMergeOverlapping",!0,{description:w.localize(292,null)})),multiCursorModifier:Le(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ce,{markdownEnumDescriptions:[w.localize(293,null),w.localize(294,null)],markdownDescription:w.localize(295,null)})),multiCursorPaste:Le(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),multiCursorLimit:Le(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(299,null)})),occurrencesHighlight:Le(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(300,null),w.localize(301,null),w.localize(302,null)],markdownDescription:w.localize(303,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:w.localize(304,null)})),overviewRulerLanes:Le(new i(83,"overviewRulerLanes",3,0,3)),padding:Le(new oe),pasteAs:Le(new st),parameterHints:Le(new ae),peekWidgetDefaultFocus:Le(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(305,null),w.localize(306,null)],description:w.localize(307,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:w.localize(308,null)})),quickSuggestions:Le(new G),quickSuggestionsDelay:Le(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(309,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new fe),renameOnType:Le(new o(93,"renameOnType",!1,{description:w.localize(310,null),markdownDeprecationMessage:w.localize(311,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:w.localize(312,null),restricted:!0})),renderFinalNewline:Le(new d(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(313,null)})),renderLineHighlight:Le(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(314,null)],description:w.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(316,null)})),renderValidationDecorations:Le(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(317,null),w.localize(318,null),w.localize(319,null),""],description:w.localize(320,null)})),revealHorizontalRightPadding:Le(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:w.localize(321,null)})),rulers:Le(new Re),scrollbar:Le(new Ae),scrollBeyondLastColumn:Le(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(322,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:w.localize(323,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:w.localize(324,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:w.localize(325,null),included:L.$k})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:w.localize(326,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(327,null),w.localize(328,null),w.localize(329,null)],description:w.localize(330,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:w.localize(331,null)})),showDeprecated:Le(new o(140,"showDeprecated",!0,{description:w.localize(332,null)})),inlayHints:Le(new _),snippetSuggestions:Le(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(333,null),w.localize(334,null),w.localize(335,null),w.localize(336,null)],description:w.localize(337,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:w.localize(338,null)})),stopRenderingLineAfter:Le(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new pe),inlineSuggest:Le(new q),inlineEdit:Le(new V),inlineCompletionsAccessibilityVerbose:Le(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(339,null)})),suggestFontSize:Le(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:w.localize(342,null)})),suggestSelection:Le(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(343,null),w.localize(344,null),w.localize(345,null)],description:w.localize(346,null)})),tabCompletion:Le(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(347,null),w.localize(348,null),w.localize(349,null)],description:w.localize(350,null)})),tabIndex:Le(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new je),unusualLineTerminators:Le(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(351,null),w.localize(352,null),w.localize(353,null)],description:w.localize(354,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:w.localize(355,null)})),wordBreak:Le(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(356,null),w.localize(357,null)],description:w.localize(358,null)})),wordSegmenterLocales:Le(new Ve),wordSeparators:Le(new t(131,"wordSeparators",M.$Vs,{description:w.localize(359,null)})),wordWrap:Le(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(360,null),w.localize(361,null),w.localize(362,null),w.localize(363,null)],description:w.localize(364,null)})),wordWrapBreakAfterCharacters:Le(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(365,null)})),wordWrapOverride1:Le(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new I),defaultColorDecorators:Le(new o(147,"defaultColorDecorators",!1,{markdownDescription:w.localize(366,null)})),pixelRatio:Le(new re),tabFocusMode:Le(new o(144,"tabFocusMode",!1,{markdownDescription:w.localize(367,null)})),layoutInfo:Le(new Y),wrappingInfo:Le(new ot),wrappingIndent:Le(new tt),wrappingStrategy:Le(new ce)}}),define(ke[202],Ee([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,175,29,185,202]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$8t=e.$7t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$6t=e.$5t=e.SymbolKinds=e.SymbolTag=e.$3t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$1t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Zt=e.$Yt=e.$Xt=void 0,e.$2t=f,e.$4t=l;class b{constructor(X,x,Z){this.offset=X,this.type=x,this.language=Z,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Xt=b;class S{constructor(X,x){this.tokens=X,this.endState=x,this._tokenizationResultBrand=void 0}}e.$Yt=S;class A{constructor(X,x){this.tokens=X,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$Zt=A;var C;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var $;(function(W){const X=new Map;X.set(0,u.$Pj.symbolMethod),X.set(1,u.$Pj.symbolFunction),X.set(2,u.$Pj.symbolConstructor),X.set(3,u.$Pj.symbolField),X.set(4,u.$Pj.symbolVariable),X.set(5,u.$Pj.symbolClass),X.set(6,u.$Pj.symbolStruct),X.set(7,u.$Pj.symbolInterface),X.set(8,u.$Pj.symbolModule),X.set(9,u.$Pj.symbolProperty),X.set(10,u.$Pj.symbolEvent),X.set(11,u.$Pj.symbolOperator),X.set(12,u.$Pj.symbolUnit),X.set(13,u.$Pj.symbolValue),X.set(15,u.$Pj.symbolEnum),X.set(14,u.$Pj.symbolConstant),X.set(15,u.$Pj.symbolEnum),X.set(16,u.$Pj.symbolEnumMember),X.set(17,u.$Pj.symbolKeyword),X.set(27,u.$Pj.symbolSnippet),X.set(18,u.$Pj.symbolText),X.set(19,u.$Pj.symbolColor),X.set(20,u.$Pj.symbolFile),X.set(21,u.$Pj.symbolReference),X.set(22,u.$Pj.symbolCustomColor),X.set(23,u.$Pj.symbolFolder),X.set(24,u.$Pj.symbolTypeParameter),X.set(25,u.$Pj.account),X.set(26,u.$Pj.issues);function x(ce){let ne=X.get(ce);return ne||(console.info("No codicon found for CompletionItemKind "+ce),ne=u.$Pj.symbolProperty),ne}W.toIcon=x;const Z=new Map;Z.set("method",0),Z.set("function",1),Z.set("constructor",2),Z.set("field",3),Z.set("variable",4),Z.set("class",5),Z.set("struct",6),Z.set("interface",7),Z.set("module",8),Z.set("property",9),Z.set("event",10),Z.set("operator",11),Z.set("unit",12),Z.set("value",13),Z.set("constant",14),Z.set("enum",15),Z.set("enum-member",16),Z.set("enumMember",16),Z.set("keyword",17),Z.set("snippet",27),Z.set("text",18),Z.set("color",19),Z.set("file",20),Z.set("reference",21),Z.set("customcolor",22),Z.set("folder",23),Z.set("type-parameter",24),Z.set("typeParameter",24),Z.set("account",25),Z.set("issue",26);function Y(ce,ne){let $e=Z.get(ce);return typeof $e>"u"&&!ne&&($e=9),$e}W.fromString=Y})($||(e.CompletionItemKinds=$={}));var k;(function(W){W[W.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var v;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var c;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(c||(e.PartialAcceptTriggerKind=c={}));var g;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var o;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class n{constructor(X,x,Z,Y){this.range=X,this.text=x,this.completionKind=Z,this.isSnippetText=Y}equals(X){return R.$kt.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}e.$1t=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(W){return W&&N.URI.isUri(W.uri)&&R.$kt.isIRange(W.range)&&(R.$kt.isIRange(W.originSelectionRange)||R.$kt.isIRange(W.targetSelectionRange))}var d;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$3t={17:(0,w.localize)(0,null),16:(0,w.localize)(1,null),4:(0,w.localize)(2,null),13:(0,w.localize)(3,null),8:(0,w.localize)(4,null),9:(0,w.localize)(5,null),21:(0,w.localize)(6,null),23:(0,w.localize)(7,null),7:(0,w.localize)(8,null),0:(0,w.localize)(9,null),11:(0,w.localize)(10,null),10:(0,w.localize)(11,null),19:(0,w.localize)(12,null),5:(0,w.localize)(13,null),1:(0,w.localize)(14,null),2:(0,w.localize)(15,null),20:(0,w.localize)(16,null),15:(0,w.localize)(17,null),18:(0,w.localize)(18,null),24:(0,w.localize)(19,null),3:(0,w.localize)(20,null),6:(0,w.localize)(21,null),14:(0,w.localize)(22,null),22:(0,w.localize)(23,null),25:(0,w.localize)(24,null),12:(0,w.localize)(25,null)};function l(W,X){return(0,w.localize)(26,null,W,e.$3t[X])}var a;(function(W){W[W.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var h;(function(W){const X=new Map;X.set(0,u.$Pj.symbolFile),X.set(1,u.$Pj.symbolModule),X.set(2,u.$Pj.symbolNamespace),X.set(3,u.$Pj.symbolPackage),X.set(4,u.$Pj.symbolClass),X.set(5,u.$Pj.symbolMethod),X.set(6,u.$Pj.symbolProperty),X.set(7,u.$Pj.symbolField),X.set(8,u.$Pj.symbolConstructor),X.set(9,u.$Pj.symbolEnum),X.set(10,u.$Pj.symbolInterface),X.set(11,u.$Pj.symbolFunction),X.set(12,u.$Pj.symbolVariable),X.set(13,u.$Pj.symbolConstant),X.set(14,u.$Pj.symbolString),X.set(15,u.$Pj.symbolNumber),X.set(16,u.$Pj.symbolBoolean),X.set(17,u.$Pj.symbolArray),X.set(18,u.$Pj.symbolObject),X.set(19,u.$Pj.symbolKey),X.set(20,u.$Pj.symbolNull),X.set(21,u.$Pj.symbolEnumMember),X.set(22,u.$Pj.symbolStruct),X.set(23,u.$Pj.symbolEvent),X.set(24,u.$Pj.symbolOperator),X.set(25,u.$Pj.symbolTypeParameter);function x(Z){let Y=X.get(Z);return Y||(console.info("No codicon found for SymbolKind "+Z),Y=u.$Pj.symbolProperty),Y}W.toIcon=x})(h||(e.SymbolKinds=h={}));class m{static asEditOperation(X){return L.$lt.replace(R.$kt.lift(X.range),X.text)}}e.$5t=m;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(X){switch(X){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(X)}constructor(X){this.value=X}}e.$6t=D;var p;(function(W){W[W.AIGenerated=1]="AIGenerated"})(p||(e.NewSymbolNameTag=p={}));var E;(function(W){function X(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}W.is=X})(E||(e.Command=E={}));var y;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var P;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(P||(e.CommentThreadState=P={}));var I;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var j;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var F;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(F||(e.CommentState=F={}));var z;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class O{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$7t=O,e.$8t=new M.$Mt;var T;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Ee([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Ee([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Ee([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Ee([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Ee([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[211],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[212],Ee([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Ee([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[214],Ee([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[215],Ee([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Ee([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Ee([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[219],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[220],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[221],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[222],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[223],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[224],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[225],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[226],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[227],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[228],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[229],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[230],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[231],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[232],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[233],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[234],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[235],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[236],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[237],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[238],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[239],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[240],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[241],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[242],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[243],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[244],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[245],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[246],Ee([1,0,13,205]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const M=(0,N.localize)(3,null),w=(0,N.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,$=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:$};this.g.push({offset:C,lexeme:$,additionalInfo:A}),this.f.push(k)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),$=b.b.get(C);$?this.k($):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(w);return}const v=this.c.charCodeAt(A);if(C)C=!1;else if(v===47&&!$){A++;break}else v===91?$=!0:v===92?C=!0:v===93&&($=!1);A++}for(;A<this.c.length&&b.a.has(this.c.charCodeAt(A));)A++;this.e=A;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=b}),define(ke[247],Ee([1,0,23,40,208,397]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=b,e.$Bp=S,e.$Cp=A,e.$Dp=C,e.$Ep=$,e.$Fp=k,e.$Gp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function b(o){return o=o.trim(),o==="*"||M.test(o)}function S(o){if(!b(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),f=!1);let d=0;if(o.preRelease){const l=w.exec(o.preRelease);if(l){const[,a,h,m]=l;d=Date.UTC(Number(a),Number(h)-1,Number(m))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:d}}function C(o,n,i){let r;typeof o=="string"?r=A(S(o)):r=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(S(i)):t=i,!r||!t)return!1;const f=r.majorBase,d=r.minorBase,l=r.patchBase;let a=t.majorBase,h=t.minorBase,m=t.patchBase;const D=t.notBefore;let p=t.majorMustEqual,E=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>a?!0:f<a?!1:d>h?!0:d<h||s&&s<D?!1:l>=m:(f===1&&a===0&&(!p||!E||!y)&&(a=1,h=0,m=0,p=!0,E=!1,y=!1),f<a?!1:f>a?!p:d<h?!1:d>h?!E:l<m?!1:l>m?!y:!(s&&s<D))}function $(o,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof r.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!r.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!g(r.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!g(r.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const l=(0,u.$4g)(i,r.main);(0,u.$Xg)(l,i)||t.push([N.default.Warning,L.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const l=(0,u.$4g)(i,r.browser);(0,u.$Xg)(l,i)||t.push([N.default.Warning,L.localize(12,null,l.path,i.path)])}}if(!R.valid(r.version))return t.push([N.default.Error,L.localize(13,null)]),t;const f=[];if(!k(o,n,r,s,f))for(const l of f)t.push([N.default.Error,l]);return t}function k(o,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:c(o,n,i.engines.vscode,s)}function v(o,n,i){return o==="*"||c(n,i,o)}function c(o,n,i,r=[]){const s=A(S(i));if(!s)return r.push(L.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(L.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(L.localize(16,null,i)),!1;return C(o,n,s)?!0:(r.push(L.localize(17,null,o,i)),!1)}function g(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class u{constructor(L,R=[],M=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$ni=u}),define(ke[84],Ee([1,0,106]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=R,e.$ps=M;const N=[];var L;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(w,b,S){b instanceof u.$ni||(b=new u.$ni(b,[],!!S)),N.push([w,b])}function M(){return N}}),define(ke[248],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class u{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=u;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const w=this.lookupOrInsertNode(R),b=this.lookupOrInsertNode(M);w.outgoing.set(b.key,b),b.incoming.set(w.key,w)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const w of this.a.values())w.outgoing.delete(M),w.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let w=this.a.get(M);return w||(w=new u(M,R),this.a.set(M,w)),w}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,w]of this.a)R.push(`${M}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const w=new Set([R]),b=this.c(M,w);if(b)return b}}c(R,M){for(const[w,b]of R.outgoing){if(M.has(w))return[...M,w].join(" -> ");M.add(w);const S=this.c(b,M);if(S)return S;M.delete(w)}}}e.$6q=N}),define(ke[5],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=L,e.$ri=R;var u;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function w(b){return b[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=w})(u||(e._util=u={})),e.$pi=L("instantiationService");function N(M,w,b){w[u.DI_TARGET]===w?w[u.DI_DEPENDENCIES].push({id:M,index:b}):(w[u.DI_DEPENDENCIES]=[{id:M,index:b}],w[u.DI_TARGET]=w)}function L(M){if(u.serviceIds.has(M))return u.serviceIds.get(M);const w=function(b,S,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(w,b,A)};return w.toString=()=>M,u.serviceIds.set(M,w),w}function R(M){return M}}),define(ke[54],Ee([1,0,18,2,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=R,e.$Yi=M,e.$Zi=b,e.$1i=S,e.$2i=A,e.$3i=C,e.$4i=$,e.$5i=v,e.$6i=c,e.$7i=g,e.$Wi=(0,L.$qi)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}var w;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function b(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function S(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const r in o)C(i,r,o[r],n);return i}function C(o,n,i,r){const s=n.split("."),t=s.pop();let f=o;for(let d=0;d<s.length;d++){const l=s[d];let a=f[l];switch(typeof a){case"undefined":a=f[l]=Object.create(null);break;case"object":if(a===null){r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is null`);return}break;default:r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(a)}`);return}f=a}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}function $(o,n){const i=n.split(".");k(o,i)}function k(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(k(r,n),Object.keys(r).length===0&&delete o[i])}}function v(o,n,i){function r(f,d){let l=f;for(const a of d){if(typeof l!="object"||l===null)return;l=l[a]}return l}const s=n.split("."),t=r(o,s);return typeof t>"u"?i:t}function c(o,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in o?u.$6f(o[r])&&u.$6f(n[r])?c(o[r],n[r],i):i&&(o[r]=n[r]):o[r]=n[r])})}function g(o){return o.replace(/[\[\]]/g,"")}}),define(ke[37],Ee([1,0,11,14,246,5,204,13]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=S,e.$pj=f,e.$qj=d,e.$Jj=ne;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",u.$j),b.set("isLinux",u.$k),b.set("isWindows",u.$i),b.set("isWeb",u.$o),b.set("isMacNative",u.$j&&!u.$o),b.set("isEdge",u.$H),b.set("isFirefox",u.$F),b.set("isChrome",u.$E),b.set("isSafari",u.$G);function S(_,U){if(b.get(_)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(_,U)}const A=Object.prototype.hasOwnProperty;var C;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const $={regexParsingWithErrorRecovery:!0},k=(0,M.localize)(0,null),v=(0,M.localize)(1,null),c=(0,M.localize)(2,null),g=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new L.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const be=this.D(),Ce=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:L.$lj.getLexeme(be),additionalInfo:Ce}),s.c}return ie}catch(ie){if(ie!==s.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,g),ie?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,g),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const Ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ce.type!==10)throw this.B("REGEX",Ce);const oe=Ce.lexeme,ae=oe.lastIndexOf("/"),re=ae===oe.length-1?void 0:this.w(oe.substring(ae+1));let G;try{G=new RegExp(oe.substring(1,ae),re)}catch{throw this.B("REGEX",Ce)}return T.create(ie,G)}switch(Ce.type){case 10:case 19:{const oe=[Ce.lexeme];this.z();let ae=this.D(),re=0;for(let Re=0;Re<Ce.lexeme.length;Re++)Ce.lexeme.charCodeAt(Re)===40?re++:Ce.lexeme.charCodeAt(Re)===41&&re--;for(;!this.E()&&ae.type!==15&&ae.type!==16;){switch(ae.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let Re=0;Re<ae.lexeme.length;Re++)ae.lexeme.charCodeAt(Re)===40?re++:Ce.lexeme.charCodeAt(Re)===41&&re--}if(re<0)break;oe.push(L.$lj.getLexeme(ae)),this.z(),ae=this.D()}const G=oe.join(""),te=G.lastIndexOf("/"),ge=te===G.length-1?void 0:this.w(G.substring(te+1));let we;try{we=new RegExp(G.substring(1,te),ge)}catch{throw this.B("REGEX",Ce)}return t.regex(ie,we)}case 18:{const oe=Ce.lexeme;this.z();let ae=null;if(!(0,N.$3e)(oe)){const re=oe.indexOf("/"),G=oe.lastIndexOf("/");if(re!==G&&re>=0){const te=oe.slice(re+1,G),ge=oe[G+1]==="i"?"i":"";try{ae=new RegExp(te,ge)}catch{throw this.B("REGEX",Ce)}}}if(ae===null)throw this.B("REGEX",Ce);return T.create(ie,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const Ce=this.u();return t.notIn(ie,Ce)}switch(this.D().type){case 3:{this.z();const Ce=this.u();if(this.x().type===18)return t.equals(ie,Ce);switch(Ce){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Ce)}}case 4:{this.z();const Ce=this.u();if(this.x().type===18)return t.notEquals(ie,Ce);switch(Ce){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Ce)}}case 5:return this.z(),z.create(ie,this.u());case 6:return this.z(),O.create(ie,this.u());case 7:return this.z(),j.create(ie,this.u());case 8:return this.z(),F.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,be){const Ce=(0,M.localize)(8,null,U,L.$lj.getLexeme(ie)),oe=ie.offset,ae=L.$lj.getLexeme(ie);return this.h.push({message:Ce,offset:oe,lexeme:ae,additionalInfo:be}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=s;class t{static false(){return a.INSTANCE}static true(){return h.INSTANCE}static has(U){return m.create(U)}static equals(U,ie){return D.create(U,ie)}static notEquals(U,ie){return y.create(U,ie)}static regex(U,ie){return T.create(U,ie)}static in(U,ie){return p.create(U,ie)}static notIn(U,ie){return E.create(U,ie)}static not(U){return P.create(U)}static and(...U){return X.create(U,null,!0)}static or(...U){return x.create(U,null,!0)}static greater(U,ie){return j.create(U,ie)}static greaterEquals(U,ie){return F.create(U,ie)}static smaller(U,ie){return z.create(U,ie)}static smallerEquals(U,ie){return O.create(U,ie)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$oj=t;function f(_){const U=new s({regexParsingWithErrorRecovery:!1});return _.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function d(_,U){const ie=_?_.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ie&&!be?!0:!ie||!be?!1:ie.equals(be)}function l(_,U){return _.cmp(U)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$rj=a;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return a.INSTANCE}}e.$sj=h;class m{static create(U,ie=null){const be=b.get(U);return typeof be=="boolean"?be?h.INSTANCE:a.INSTANCE:new m(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=b.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:a.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$tj=m;class D{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?m.create(U,be):P.create(U,be);const Ce=b.get(U);return typeof Ce=="boolean"?ie===(Ce?"true":"false")?h.INSTANCE:a.INSTANCE:new D(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=b.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?h.INSTANCE:a.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$uj=D;class p{static create(U,ie){return new p(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ie)?ie.includes(be):typeof be=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$vj=p;class E{static create(U,ie){return new E(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=p.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=E;class y{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?P.create(U,be):m.create(U,be);const Ce=b.get(U);return typeof Ce=="boolean"?ie===(Ce?"true":"false")?a.INSTANCE:h.INSTANCE:new y(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=b.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?a.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$xj=y;class P{static create(U,ie=null){const be=b.get(U);return typeof be=="boolean"?be?a.INSTANCE:h.INSTANCE:new P(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=b.get(this.c);return typeof U=="boolean"?U?a.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$yj=P;function I(_,U){if(typeof _=="string"){const ie=parseFloat(_);isNaN(ie)||(_=ie)}return typeof _=="string"||typeof _=="number"?U(_):a.INSTANCE}class j{static create(U,ie,be=null){return I(ie,Ce=>new j(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$zj=j;class F{static create(U,ie,be=null){return I(ie,Ce=>new F(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Aj=F;class z{static create(U,ie,be=null){return I(ie,Ce=>new z(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Bj=z;class O{static create(U,ie,be=null){return I(ie,Ce=>new O(U,Ce,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Cj=O;class T{static create(U,ie){return new T(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return ie<be?-1:ie>be?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ie===be}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Dj=T;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Ej=B;function W(_){let U=null;for(let ie=0,be=_.length;ie<be;ie++){const Ce=_[ie].substituteConstants();if(_[ie]!==Ce&&U===null){U=[];for(let oe=0;oe<ie;oe++)U[oe]=_[oe]}U!==null&&(U[ie]=Ce)}return U===null?_:U}class X{static create(U,ie,be){return X.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Ce=l(this.expr[ie],U.expr[ie]);if(Ce!==0)return Ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,be){const Ce=[];let oe=!1;for(const ae of U)if(ae){if(ae.type===1){oe=!0;continue}if(ae.type===0)return a.INSTANCE;if(ae.type===6){Ce.push(...ae.expr);continue}Ce.push(ae)}if(Ce.length===0&&oe)return h.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(l);for(let ae=1;ae<Ce.length;ae++)Ce[ae-1].equals(Ce[ae])&&(Ce.splice(ae,1),ae--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const ae=Ce[Ce.length-1];if(ae.type!==9)break;Ce.pop();const re=Ce.pop(),G=Ce.length===0,te=x.create(ae.expr.map(ge=>X.create([ge,re],null,be)),null,G);te&&(Ce.push(te),Ce.sort(l))}if(Ce.length===1)return Ce[0];if(be){for(let ae=0;ae<Ce.length;ae++)for(let re=ae+1;re<Ce.length;re++)if(Ce[ae].negate().equals(Ce[re]))return a.INSTANCE;if(Ce.length===1)return Ce[0]}return new X(Ce,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new X(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=x.create(U,this,!0)}return this.c}}e.$Fj=X;class x{static create(U,ie,be){return x.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Ce=l(this.expr[ie],U.expr[ie]);if(Ce!==0)return Ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:x.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,be){let Ce=[],oe=!1;if(U){for(let ae=0,re=U.length;ae<re;ae++){const G=U[ae];if(G){if(G.type===0){oe=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){Ce=Ce.concat(G.expr);continue}Ce.push(G)}}if(Ce.length===0&&oe)return a.INSTANCE;Ce.sort(l)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let ae=1;ae<Ce.length;ae++)Ce[ae-1].equals(Ce[ae])&&(Ce.splice(ae,1),ae--);if(Ce.length===1)return Ce[0];if(be){for(let ae=0;ae<Ce.length;ae++)for(let re=ae+1;re<Ce.length;re++)if(Ce[ae].negate().equals(Ce[re]))return h.INSTANCE;if(Ce.length===1)return Ce[0]}return new x(Ce,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new x(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),be=U.shift(),Ce=[];for(const oe of Pe(ie))for(const ae of Pe(be))Ce.push(X.create([oe,ae],null,!1));U.unshift(x.create(Ce,null,!1))}this.c=x.create(U,this,!0)}return this.c}}e.$Gj=x;class Z extends m{static{this.d=[]}static all(){return Z.d.values()}constructor(U,ie,be){super(U,null),this.f=ie,typeof be=="object"?Z.d.push({...be,key:U}):be!==!0&&Z.d.push({key:U,description:be,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Hj=Z,e.$Ij=(0,R.$qi)("contextKeyService");function Y(_,U){return _<U?-1:_>U?1:0}function ce(_,U,ie,be){return _<ie?-1:_>ie?1:U<be?-1:U>be?1:0}function ne(_,U){if(_.type===0||U.type===1)return!0;if(_.type===9)return U.type===9?$e(_.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(ne(_,ie))return!0;return!1}if(_.type===6){if(U.type===6)return $e(U.expr,_.expr);for(const ie of _.expr)if(ne(ie,U))return!0;return!1}return _.equals(U)}function $e(_,U){let ie=0,be=0;for(;ie<_.length&&be<U.length;){const Ce=_[ie].cmp(U[be]);if(Ce<0)return!1;Ce===0&&ie++,be++}return ie===_.length}function Pe(_){return _.type===9?_.expr:[_]}}),define(ke[249],Ee([1,0,23,40,206,5,103,11,24]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Aw=e.$zw=e.$yw=void 0,e.$Bw=k,e.$Cw=v,e.$yw=(0,R.$qi)("dialogService");var S;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(S||(S={}));class A{a(g){return this.d(g,S.Confirmation)}b(g){return this.d(g,S.Prompt)}c(g){return this.d(g,S.Input)}d(g,o){const n=[];switch(o){case S.Confirmation:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case S.Prompt:{const i=g;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case S.Input:{const i=g;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===N.default.Info?"info":g===N.default.Error?"error":g===N.default.Warning?"warning":"none"}f(g,o,n){const i=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&i.push(g.cancelButton);let r=i[o]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$zw=A,e.$Aw=(0,R.$qi)("fileDialogService");var C;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const $=10;function k(c){const g=[];return g.push(...c.slice(0,$).map(o=>typeof o=="string"?o:(0,u.$1g)(o))),c.length>$&&(c.length-$===1?g.push((0,L.localize)(7,null)):g.push((0,L.localize)(8,null,c.length-$))),g.push(""),g.join(`
`)}function v(c,g){const o=(0,b.$Wn)(c);let n=(o.buttons??[]).map(t=>(0,M.$vw)(t)),i=(c.buttons||[]).map((t,f)=>f),r=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(w.$k||w.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const f=i[s];i.splice(s,1),i.splice(1,0,f),s=1}w.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(w.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const f=i[s];i.splice(s,1),i.push(f),s=n.length-1}}return o.buttons=n,o.defaultId=r,o.cancelId=s,o.noLink=!0,o.title=o.title||g.nameLong,{options:o,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,u.$qi)("environmentService"),e.$yi=(0,u.$ri)(e.$xi)}),define(ke[137],Ee([1,0,207,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=L,e.$Uo=R,e.$Vo=M,e.$Wo=w,e.$Xo=b,e.$Yo=S,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function w(i,r){return r==="web"&&!i.includes("web")}function b(i,r,s){return w(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var $;(function(i){i.Install="install",i.Uninstall="uninstall"})($||(e.StatisticType=$={}));var k;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var c;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class g extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$1o=g;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$2o=n,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,u.localize2)(0,"Extensions"),e.$9o=(0,u.localize2)(1,"Preferences")}),define(ke[250],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=void 0,e.$b6b=(0,u.$qi)("externalTerminal"),e.$c6b="Terminal.app"}),define(ke[251],Ee([1,0,53,55,15,17,11,102,31,105,209,250]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=e.$kbc=e.$jbc=void 0;const $=A.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends k{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(u,s,S.$im(),t)}spawnTerminal(s,t,f,d){const l=t.windowsExec||v.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const a=R.$oc(l,".exe").toLowerCase();if(a==="cmder")return s.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return l.indexOf(" ")>=0&&h.push('""'),h.push(l),a==="wt"&&h.push("-d ."),new Promise((m,D)=>{const p=o(process),E=s.spawn(f,h,{cwd:d,env:p,detached:!0});E.on("error",D),E.on("exit",()=>m())})}async runInTerminal(s,t,f,d,l){const a="windowsExec"in l&&l.windowsExec?l.windowsExec:v.getDefaultTerminalWindows(),h=await v.f();return new Promise((m,D)=>{const p=`"${t} - ${$}"`,E=`"${f.join('" "')}" & pause`,y=Object.assign({},o(process),d);Object.keys(y).filter(z=>y[z]===null).forEach(z=>delete y[z]);const P={cwd:t,env:y,windowsVerbatimArguments:!0};let I,j;R.$oc(a,".exe")==="wt"?(I=a,j=["-d",".",v.b,"/c",E]):h?(I=h,j=["-d",".",a,"/c",E]):(I=v.b,j=["/c","start",p,"/wait",a,"/c",`"${E}"`]),u.spawn(I,j,P).on("error",z=>{D(n(z))}),m(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await S.win32.findExecutable("wt");return await b.Promises.exists(s)?s:void 0}catch{return}}}e.$jbc=v,Je([N.$Uh],v,"f",null);class c extends k{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const a=l.osxExec||C.$c6b;return new Promise((h,m)=>{if(a===C.$c6b||a==="iTerm.app"){const D=a===C.$c6b?"TerminalHelper":"iTermHelper",E=[L.$Kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",s||$,"-w",t];for(const I of f)E.push("-a"),E.push(I);if(d){const I=Object.assign({},o(process),d);for(const j in I){const F=I[j];F===null?(E.push("-u"),E.push(j)):(E.push("-e"),E.push(`${j}=${F}`))}}let y="";const P=u.spawn(c.b,E);P.on("error",I=>{m(n(I))}),P.stderr.on("data",I=>{y+=I.toString()}),P.on("exit",I=>{if(I===0)h(void 0);else if(y){const j=y.split(`
`,1);m(new Error(j[0]))}else m(new Error(A.localize(1,null,D,I)))})}else m(new Error(A.localize(2,null,a)))})}spawnTerminal(s,t,f){const d=t.osxExec||C.$c6b;return new Promise((l,a)=>{const h=["-a",d];f&&h.push(f);const m=o(process),D=s.spawn("/usr/bin/open",h,{cwd:f,env:m});D.on("error",a),D.on("exit",()=>l())})}}e.$kbc=c;class g extends k{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const a=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((h,m)=>{const D=[];a.then(p=>{p.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const E=`${i(f)}; echo; read -p "${g.b}" -n1;`;D.push(`''${E}''`);const y=Object.assign({},o(process),d);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const P={cwd:t,env:y};let I="";const j=u.spawn(p,D,P);j.on("error",F=>{m(n(F))}),j.stderr.on("data",F=>{I+=F.toString()}),j.on("exit",F=>{if(F===0)h(void 0);else if(I){const z=I.split(`
`,1);m(new Error(z[0]))}else m(new Error(A.localize(4,null,p,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!M.$k)g.d=Promise.resolve("xterm");else{const s=await b.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(s,t,f){const d=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,a)=>{d.then(h=>{const m=o(process),D=s.spawn(h,[],{cwd:f,env:m});D.on("error",a),D.on("exit",()=>l())})})}}e.$lbc=g;function o(r){const s={...r.env};return(0,w.$gm)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[32],Ee([1,0,77,17,14,18,2,210,5,11,15,46]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=$,e.$Yk=c,e.$Zk=o,e.$1k=n,e.$2k=i,e.$3k=r,e.$4k=s,e.$5k=t,e.$6k=f,e.$7k=d,e.$8k=l,e.$0k=m,e.$$k=D,e.$_k=p,e.$al=E,e.$bl=y,e.$el=z,e.$ql=x,e.$rl=Z,e.$tl=ce,e.$Wk=(0,b.$qi)("fileService");function $(ne){return ne.create===!0}var k;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var v;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function c(ne){const $e=ne;return!!$e&&typeof $e.onDidChange=="function"}var g;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function o(ne){return!!(ne.capabilities&2)}function n(ne){return!!(ne.capabilities&8)}function i(ne){return!!(ne.capabilities&131072)}function r(ne){return!!(ne.capabilities&4)}function s(ne){return!!(ne.capabilities&16)}function t(ne){return o(ne)?!!(ne.capabilities&16384):!1}function f(ne){return o(ne)?!!(ne.capabilities&32768):!1}function d(ne){return!!(ne.capabilities&65536)}function l(ne){return!!(ne.capabilities&2048)}var a;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class h extends Error{static create($e,Pe){const _=new h($e.toString(),Pe);return p(_,Pe),_}constructor($e,Pe){super($e),this.code=Pe}}e.$9k=h;function m(ne,$e){return h.create(ne,$e)}function D(ne){return ne||m((0,w.localize)(0,null),a.Unknown)}function p(ne,$e){return ne.name=$e?`${$e} (FileSystemError)`:"FileSystemError",ne}function E(ne){if(!ne)return a.Unknown;if(ne instanceof h)return ne.code;const $e=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!$e)return a.Unknown;switch($e[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}function y(ne){if(ne instanceof O)return ne.fileOperationResult;switch(E(ne)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}var P;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class I{constructor($e,Pe,_){this.resource=$e,this.operation=Pe,this.target=_}isOperation($e){return this.operation===$e}}e.$cl=I;var j;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{static{this.a=null}constructor($e,Pe){this.c=Pe,this.b=void 0,this.d=new C.$V(()=>{const _=u.$wi.forUris(()=>this.c);return _.fill(this.rawAdded.map(U=>[U,!0])),_}),this.f=new C.$V(()=>{const _=u.$wi.forUris(()=>this.c);return _.fill(this.rawUpdated.map(U=>[U,!0])),_}),this.g=new C.$V(()=>{const _=u.$wi.forUris(()=>this.c);return _.fill(this.rawDeleted.map(U=>[U,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of $e){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==F.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains($e,...Pe){return this.h($e,{includeChildren:!1},...Pe)}affects($e,...Pe){return this.h($e,{includeChildren:!0},...Pe)}h($e,Pe,..._){if(!$e)return!1;const U=_.length>0;return!!((!U||_.includes(1))&&(this.d.value.get($e)||Pe.includeChildren&&this.d.value.findSuperstr($e))||(!U||_.includes(0))&&(this.f.value.get($e)||Pe.includeChildren&&this.f.value.findSuperstr($e))||(!U||_.includes(2))&&(this.g.value.findSubstr($e)||Pe.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$dl=F;function z(ne,$e,Pe){return!ne||!$e||ne===$e||$e.length>ne.length?!1:($e.charAt($e.length-1)!==N.sep&&($e+=N.sep),Pe?(0,L.$uf)(ne,$e):ne.indexOf($e)===0)}class O extends Error{constructor($e,Pe,_){super($e),this.fileOperationResult=Pe,this.options=_}}e.$fl=O;class T extends O{constructor($e,Pe,_,U){super($e,Pe,U),this.fileOperationResult=Pe,this.size=_}}e.$gl=T;class B extends O{constructor($e,Pe,_){super($e,2,_),this.stat=Pe}}e.$hl=B;var W;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var X;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$pl="";function x(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function Z(ne,$e){if(!$e.hasProvider(M.URI.from({scheme:ne.scheme})))return new Promise(Pe=>{const _=$e.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ne.scheme&&U.added&&(_.dispose(),Pe())})})}class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize($e){return(0,R.$8f)($e)||($e=0),$e<Y.KB?(0,w.localize)(1,null,$e.toFixed(0)):$e<Y.MB?(0,w.localize)(2,null,($e/Y.KB).toFixed(2)):$e<Y.GB?(0,w.localize)(3,null,($e/Y.MB).toFixed(2)):$e<Y.TB?(0,w.localize)(4,null,($e/Y.GB).toFixed(2)):(0,w.localize)(5,null,($e/Y.TB).toFixed(2))}}e.$sl=Y;function ce(ne){const $e=typeof ne=="string"||ne?.scheme===A.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===A.Schemas.file?1024*Y.MB:$e?10*Y.MB:S.$o?50*Y.MB:1024*Y.MB}}),define(ke[252],Ee([1,0,21,13,211,32]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=M;async function M(A,C,$,k,v,c){let g;try{await w(A,C,$,k,v,c)}catch(o){g=o}finally{g&&v.errorTransformer&&(g=v.errorTransformer(g)),typeof g<"u"&&$.error(g),$.end()}}async function w(A,C,$,k,v,c){b(c);const g=await A.open(C,{create:!1});try{b(c);let o=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,r=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(g,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await $.write(k(r)),r=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&b(c)&&S(o,v));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),$.write(k(r.slice(0,f)))}}catch(o){throw(0,R.$$k)(o)}finally{await A.close(g)}}function b(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function S(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,R.$0k)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Ee([1,0,35,3,17,11,2,32]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0,e.$Dq=b,e.$Eq=S,e.$Iq=k,e.$Jq=v,e.$Kq=c,e.$Lq=g;function b(n){return typeof n.correlationId=="number"}function S(n){return n.recursive===!0}class A extends N.$Uc{static{this.a=5}constructor(i,r,s,t){super(),this.h=i,this.j=r,this.m=s,this.n=t,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const i=new N.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fq=A;class C extends A{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.$Gq=C;class $ extends A{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.$Hq=$;function k(n){return n.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new o;for(const r of n)i.processEvent(r);return i.coalesce()}function c(n,i){return typeof i=="string"&&!i.startsWith(u.$gk)&&!(0,L.$jc)(i)?{base:n,pattern:i}:i}function g(n,i){const r=[];for(const s of i)r.push((0,u.$kk)(c(n,s)));return r}class o{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let s=!1;if(r){const t=r.type,f=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&f===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,w.$el)(s.resource.fsPath,t,!R.$k))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(ke[253],Ee([1,0,52,3,65,4,2,8]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class b extends N.$Uc{constructor(){super(),this.a=this.B(new R.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new w.$Nh,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Dq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new w.$Nh;try{this.h.clear(),this.g.clear();for(const C of A)this.t(C)?this.h.set(C.correlationId,C):this.g.add(C);for(const[C]of this.j)this.h.has(C)||(this.j.deleteAndDispose(C),this.m.delete(C));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const C=new N.$Tc;this.j.set(A.correlationId,C),await this.r.p,!C.isDisposed&&(this.z(A,C),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,C){this.C(A,C)?(this.M(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,C),this.m.add(A.correlationId))}C(A,C){const $=this.L?.subscribe(A.path,(k,v)=>{C.isDisposed||(k?this.z(A,C):v?.type===1&&this.F(A))});return $?(C.add($),!0):!1}D(A,C){let $=!1;const k=(v,c)=>{if(C.isDisposed)return;const g=this.G(v),o=this.G(c),n=$;$=g,!g&&(o||n)&&this.F(A)};this.M(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.watchFile)(A.path,{persistent:!1,interval:this.n},k)}catch(v){this.N(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}C.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.unwatchFile)(A.path,k)}catch(v){this.N(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.M(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const C={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([C]),this.H(C,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,C){const $=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.M(typeof C.correlationId=="number"?`${$} (correlationId: ${C.correlationId})`:$)}I(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}}e.$Uq=b}),define(ke[254],Ee([1,0,52,8,22,34,3,76,17,11,23,2,104,31,65]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0,e.$1q=g;class c extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(n,i,r,s,t,f){super(),this.r=n,this.s=i,this.t=r,this.u=s,this.w=t,this.y=f,this.c=this.B(new N.$Fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.t(d))),this.f=this.B(new N.$Eh(d=>this.L(d),c.b)),this.g=(0,v.$Lq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,v.$Lq)(this.r.path,this.r.includes):void 0,this.j=new L.$me,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const n=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const i=await k.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.F(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.N(n):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${n})`),this.C()}}C(){this.n=!0,this.u?.()}async D(n){let i=n.path;try{i=await k.Promises.realpath(n.path),n.path===i&&(i=await(0,$.$Wq)(n.path,this.j.token)??n.path),n.path!==i&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async F(n,i){const r=new M.$Tc;return this.G(n,i,r)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(n,i,r)),r}G(n,i,r){if(i)return!1;const s=C.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(f,d)=>{if(!r.isDisposed)if(f){const l=await this.F(n,i);r.isDisposed?l.dispose():r.add(l)}else d&&(typeof d.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:s,type:d.type,cId:this.r.correlationId}])});return t?(r.add(t),!0):!1}async H(n,i,r){if(S.$j&&(0,R.$qg)(n,"/Volumes/",!0)){this.N(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new L.$me(this.j.token);r.add((0,M.$Sc)(()=>s.dispose(!0)));const t=new M.$Tc;r.add(t);try{const f=C.URI.file(this.r.path),d=(0,b.$oc)(n),l=(0,u.watch)(n);t.add((0,M.$Sc)(()=>{l.removeAllListeners(),l.close()})),this.P(`Started watching: '${n}'`);const a=new Set;if(i)try{for(const m of await k.Promises.readdir(n))a.add(m)}catch(m){this.N(m)}if(s.token.isCancellationRequested)return;const h=new Map;t.add((0,M.$Sc)(()=>{for(const[,m]of h)m.dispose();h.clear()})),l.on("error",(m,D)=>{s.token.isCancellationRequested||(this.N(`Failed to watch ${n} for changes using fs.watch() (${m}, ${D})`),this.C())}),l.on("change",(m,D)=>{if(s.token.isCancellationRequested)return;this.P(`[raw] ["${m}"] ${D}`);let p="";if(D&&(p=D.toString(),S.$j&&(p=(0,w.$8l)(p))),!(!p||m!=="change"&&m!=="rename"))if(i)if(m==="rename"){h.get(p)?.dispose();const E=setTimeout(async()=>{if(h.delete(p),p===d&&!await k.Promises.exists(n)){this.I(f);return}if(s.token.isCancellationRequested)return;const y=await this.M((0,b.$kc)(n,p));if(s.token.isCancellationRequested)return;let P;y?a.has(p)?P=0:(P=1,a.add(p)):(a.delete(p),P=2),this.J({resource:(0,A.$4g)(f,p),type:P,cId:this.r.correlationId})},c.a);h.set(p,(0,M.$Sc)(()=>clearTimeout(E)))}else{let E;a.has(p)?E=0:(E=1,a.add(p)),this.J({resource:(0,A.$4g)(f,p),type:E,cId:this.r.correlationId})}else if(m==="rename"||p!==d){const E=setTimeout(async()=>{const y=await k.Promises.exists(n);s.token.isCancellationRequested||(y?(this.J({resource:f,type:0,cId:this.r.correlationId},!0),t.add(await this.F(n,!1))):this.I(f))},c.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(E)))}else this.J({resource:f,type:0,cId:this.r.correlationId},!0)})}catch(f){s.token.isCancellationRequested||this.N(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.C()}}I(n){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:n,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(n,i=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}L(n){const i=(0,v.$Jq)(n);if(i.length>0){if(this.y)for(const s of i)this.P(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(n){if(S.$k)return k.Promises.exists(n);try{const i=(0,b.$oc)(n);return(await k.Promises.readdir((0,b.$nc)(n))).some(s=>s===i)}catch(i){return this.P(i),!1}}setVerboseLogging(n){this.y=n}N(n){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}O(n){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}P(n){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Zq=c;async function g(o,n,i,r,s=512){const t=await k.Promises.open(o,"r"),f=Buffer.allocUnsafe(s),d=new L.$me(r);let l,a=!1;const h={path:o,excludes:[],recursive:!1},m=new c(h,void 0,D=>{(async()=>{for(const{type:p}of D)if(p===0){if(a)return;a=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:E}=await k.Promises.read(t,f,0,s,null);if(!E||d.token.isCancellationRequested)break;n(f.slice(0,E))}}catch(E){l=new Error(E),d.dispose(!0)}finally{a=!1}}})()});return await m.ready,i(),new Promise((D,p)=>{d.token.onCancellationRequested(async()=>{m.dispose();try{await k.Promises.close(t)}catch(E){l=new Error(E)}l?p(l):D()})})}}),define(ke[255],Ee([1,0,4,35,253,11,254,34]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class b extends L.$Uq{constructor(A){super(),this.L=A,this.onDidError=u.Event.None,this.watchers=new Set,this.O=!1}async J(A){A=this.W(A);const C=[],$=new Set(Array.from(this.watchers));for(const k of A){const v=this.R(k);v&&(0,N.$ok)(v.request.excludes,k.excludes)&&(0,N.$ok)(v.request.includes,k.includes)?$.delete(v):C.push(k)}C.length&&this.M(`Request to start watching: ${C.map(k=>this.I(k)).join(",")}`),$.size&&this.M(`Request to stop watching: ${Array.from($).map(k=>this.I(k.request)).join(",")}`);for(const k of $)this.U(k);for(const k of C)this.S(k)}R(A){for(const C of this.watchers)if(typeof A.correlationId=="number"||typeof C.request.correlationId=="number"){if(C.request.correlationId===A.correlationId)return C}else if((0,w.$pg)(C.request.path,A.path,!R.$k))return C}S(A){const C=new M.$Zq(A,this.L,k=>this.a.fire(k),()=>this.c.fire(A),k=>this.b.fire(k),this.O),$={request:A,instance:C};this.watchers.add($)}async stop(){await super.stop();for(const A of this.watchers)this.U(A)}U(A){this.M("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}W(A){const C=new Map;for(const $ of A){const k=R.$k?$.path:$.path.toLowerCase();let v=C.get($.correlationId);v||(v=new Map,C.set($.correlationId,v)),v.has(k)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I($)}`),v.set(k,$)}return Array.from(C.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(A){this.O=A;for(const C of this.watchers)C.instance.setVerboseLogging(A)}M(A,C){this.O&&this.b.fire({type:"trace",message:this.Z(A,C)})}N(A){this.b.fire({type:"warn",message:this.Z(A)})}Z(A,C){return C?`[File Watcher (node.js)] ${A} (${this.I(C.request)})`:`[File Watcher (node.js)] ${A}`}}e.$2q=b}),define(ke[256],Ee([1,0,65,255]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class L extends u.$Gq{constructor(M,w,b){super(M,w,b),this.s()}r(M){return M.add(new N.$2q(void 0))}}e.$3q=L}),define(ke[257],Ee([1,0,15,81,194,65]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class M extends R.$Hq{constructor(b,S,A){super(b,S,A),this.s()}r(b){const S=b.add(new L.$Sq(u.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(S.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$0h)(S.getChannel("watcher")))}}e.$Tq=M}),define(ke[107],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class u{constructor(...L){this.a=new Map;for(const[R,M]of L)this.set(R,M)}set(L,R){const M=this.a.get(L);return this.a.set(L,R),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$oi=u}),define(ke[258],Ee([1,0,8,13,3,106,248,5,107,75]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const A=!1;class C extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class ${constructor(g=new b.$oi,o=!1,n,i=A){this.i=g,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(w.$pi,this),this._globalGraph=i?n?._globalGraph??new M.$6q(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const g of this.g)(0,L.$Oc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const o=new class extends ${dispose(){this.h.delete(o),super.dispose()}}(g,this.j,this,this.l);return this.h.add(o),o}invokeFunction(g,...o){this.m();const n=v.traceInvocation(this.l,g);let i=!1;try{return g({get:s=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(g,...o){this.m();let n,i;return g instanceof R.$ni?(n=v.traceCreation(this.l,g.ctor),i=this.o(g.ctor,g.staticArguments.concat(o),n)):(n=v.traceCreation(this.l,g),i=this.o(g,o,n)),n.stop(),i}o(g,o=[],n){const i=w._util.getServiceDependencies(g).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this.s(t.id,n);f||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${g.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(g,o.concat(r))}q(g,o){if(this.i.get(g)instanceof R.$ni)this.i.set(g,o);else if(this.k)this.k.q(g,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const o=this.i.get(g);return!o&&this.k?this.k.r(g):o}s(g,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const n=this.r(g);return n instanceof R.$ni?this.u(g,n,o.branch(g,!0)):(o.branch(g,!1),n)}u(g,o,n){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,o,n)}finally{this.t.delete(g)}}v(g,o,n){const i=new M.$6q(t=>t.id.toString());let r=0;const s=[{id:g,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new C(i);for(const f of w._util.getServiceDependencies(t.desc.ctor)){const d=this.r(f.id);if(d||this.y(`[createInstance] ${g} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),d instanceof R.$ni){const l={id:f.id,desc:d,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new C(i);break}for(const{data:f}of t){if(this.r(f.id)instanceof R.$ni){const l=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,l)}i.removeNode(f)}}return this.r(g)}w(g,o,n=[],i,r){if(this.i.get(g)instanceof R.$ni)return this.x(g,o,n,i,r,this.g);if(this.k)return this.k.w(g,o,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(g,o,n=[],i,r,s){if(i){const t=new $(void 0,this.j,this,this.l);t.c=String(g);const f=new Map,d=new u.$Jh(()=>{const l=t.o(o,n,r);for(const[a,h]of f){const m=l[a];if(typeof m=="function")for(const D of h)D.disposable=m.apply(l,D.listener)}return f.clear(),s.add(l),l});return new Proxy(Object.create(null),{get(l,a){if(!d.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let D=f.get(a);return D||(D=new S.$5c,f.set(a,D)),(E,y,P)=>{if(d.isInitialized)return d.value[a](E,y,P);{const I={listener:[E,y,P],disposable:void 0},j=D.push(I);return(0,L.$Sc)(()=>{j(),I.disposable?.dispose()})}}}if(a in l)return l[a];const h=d.value;let m=h[a];return typeof m!="function"||(m=m.bind(h),l[a]=m),m},set(l,a,h){return d.value[a]=h,!0},getPrototypeOf(l){return o.prototype}})}else{const t=this.o(o,n,r);return s.add(t),t}}y(g,o){if(o&&console.warn(g),this.j)throw new Error(g)}}e.$7q=$;var k;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(k||(k={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,o){return g?new v(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,o){return g?new v(1,o.name):v.c}static{this.f=0}constructor(g,o){this.type=g,this.name=o,this.g=Date.now(),this.h=[]}branch(g,o){const n=new v(3,g.toString());return this.h.push([g,o,n]),n}stop(){const g=Date.now()-this.g;v.f+=g;let o=!1;function n(r,s){const t=[],f=new Array(r+1).join("	");for(const[d,l,a]of s.h)if(l&&a){o=!0,t.push(`${f}CREATES -> ${d}`);const h=n(r+1,a);h&&t.push(h)}else t.push(`${f}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||o)&&v.all.add(i.join(`
`))}}e.$8q=v}),define(ke[12],Ee([1,0,213,47,4,56,3,27,11,23,18,2,37,5]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=c,e.log=o,e.$$j=m,e.$_j=D,e.$ak=p,e.$bk=E,e.$Wj=(0,k.$qi)("logService"),e.$Xj=(0,k.$qi)("loggerService");function v(){return new Date().toISOString()}function c(y){return(0,A.$8f)(y)}var g;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$Zj=g.Info;function o(y,P,I){switch(P){case g.Trace:y.trace(I);break;case g.Debug:y.debug(I);break;case g.Info:y.info(I);break;case g.Warning:y.warn(I);break;case g.Error:y.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(y,P=!1){let I="";for(let j=0;j<y.length;j++){let F=y[j];if(F instanceof Error&&(F=(0,N.$bj)(F,P)),typeof F=="object")try{F=JSON.stringify(F)}catch{}I+=(j>0?" ":"")+F}return I}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new L.$be),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==g.Off&&this.b<=P}}e.$2j=i;class r extends i{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(g.Trace)&&this.g(g.Trace,n([P,...I],!0))}debug(P,...I){this.f(g.Debug)&&this.g(g.Debug,n([P,...I]))}info(P,...I){this.f(g.Info)&&this.g(g.Info,n([P,...I]))}warn(P,...I){this.f(g.Warning)&&this.g(g.Warning,n([P,...I]))}error(P,...I){if(this.f(g.Error))if(P instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=P.stack,this.g(g.Error,n(j))}else this.g(g.Error,n([P,...I]))}flush(){}}e.$3j=r;class s extends i{constructor(P=e.$Zj){super(),this.setLevel(P),this.g=!b.$i}trace(P,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,P,...I):console.log(`[main ${v()}]`,P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,P,...I):console.warn(`[main ${v()}]`,P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,P,...I):console.error(`[main ${v()}]`,P,...I))}flush(){}}e.$4j=s;class t extends i{constructor(P=e.$Zj,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$5j=t;class f extends i{constructor(P,I=e.$Zj){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(P),...I])}debug(P,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(P),...I])}info(P,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(P),...I])}warn(P,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(P),...I])}error(P,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,N.$bj)(P,this.f(g.Trace))}flush(){}}e.$6j=f;class d extends i{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const j of this.g)j.trace(P,...I)}debug(P,...I){for(const j of this.g)j.debug(P,...I)}info(P,...I){for(const j of this.g)j.info(P,...I)}warn(P,...I){for(const j of this.g)j.warn(P,...I)}error(P,...I){for(const j of this.g)j.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$7j=d;class l extends M.$Uc{constructor(P,I,j){if(super(),this.h=P,this.j=I,this.b=new w.$Bc,this.c=this.B(new L.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$be),this.onDidChangeVisibility=this.g.event,j)for(const F of j)this.b.set(F.resource,{logger:void 0,info:F})}m(P){return(0,A.$4f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const j=this.n(P),F=(0,A.$4f)(P)?P:I?.id??(0,R.$ej)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const O=I?.logLevel==="always"?g.Trace:I?.logLevel;z||(z=this.s(j,O??this.getLogLevel(j)??this.h,{...I,id:F}));const T={logger:z,info:{resource:j,id:F,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(j,T),z}n(P){return(0,A.$4f)(P)?(0,S.$4g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(C.URI.isUri(P)){const j=P,F=I,z=this.b.get(j);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([j,F]))}else{this.h=P;for(const[j,F]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const j=this.m(P);j&&I!==!j.info.hidden&&(j.info.hidden=!I,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=l;class a{constructor(){this.onDidChangeLogLevel=new L.$be().event}setLevel(P){}getLevel(){return g.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$9j=a;class h extends a{}e.$0j=h;function m(y){if(y.verbose)return g.Trace;if(typeof y.logLevel=="string"){const P=E(y.logLevel.toLowerCase());if(P!==void 0)return P}return e.$Zj}function D(y){switch(y){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function p(y){switch(y){case g.Trace:return{original:"Trace",value:u.localize(0,null)};case g.Debug:return{original:"Debug",value:u.localize(1,null)};case g.Info:return{original:"Info",value:u.localize(2,null)};case g.Warning:return{original:"Warning",value:u.localize(3,null)};case g.Error:return{original:"Error",value:u.localize(4,null)};case g.Off:return{original:"Off",value:u.localize(5,null)}}}function E(y){switch(y){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ck=new $.$Hj("logLevel",D(g.Info))}),define(ke[259],Ee([1,0,19,8,13,4,3,17,65,12]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class A extends M.$Uc{constructor($,k){super(),this.a=$,this.b=k,this.c=this.B(new R.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$oh(0)),this.w=[],this.y=this.B(new N.$oh(0))}watch($,k){return k.recursive||this.b?.watcher?.forceUniversal?this.n($,k):this.z($,k)}n($,k){const v={path:this.I($),excludes:k.excludes,includes:k.includes,recursive:k.recursive,correlationId:k.correlationId},c=(0,u.$Ub)(this.j,v);return this.r(),(0,M.$Sc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,L.$1)($))}s(){this.h||(this.h=this.B(this.t(k=>this.c.fire((0,b.$Iq)(k)),k=>this.G(k),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const k of this.j)(0,b.$Eq)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const k of this.j)(0,b.$Eq)(k)&&$.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,k){const v={path:this.I($),excludes:k.excludes,includes:k.includes,recursive:!1,correlationId:k.correlationId},c=(0,u.$Ub)(this.w,v);return this.C(),(0,M.$Sc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,L.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,b.$Iq)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,w.$ic)($.fsPath)}}e.$Mq=A}),define(ke[260],Ee([1,0,52,398,8,27,21,4,34,3,17,11,23,98,31,212,32,252,259,47,257,256]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0,(()=>{try{(0,N.gracefulify)(u)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.$bj)(f)}`)}})();class t extends n.$Mq{static{this.J=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=w.Event.None,this.O=new R.$Bc(a=>$.$Ug.getComparisonKey(a)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,C.$k&&(this.L|=1024)),this.L}async stat(d){try{const{stat:l,symbolicLink:a}=await v.SymlinkSupport.stat(this.I(d));return{type:this.N(l,a),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:g.FilePermission.Locked}}catch(l){throw this.gb(l)}}async M(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await v.Promises.readdir(this.I(d),{withFileTypes:!0}),a=[];return await Promise.all(l.map(async h=>{try{let m;h.isSymbolicLink()?m=(await this.stat((0,$.$4g)(d,h.name))).type:m=this.N(h),a.push([h.name,m])}catch(m){this.a.trace(m)}})),a}catch(l){throw this.gb(l)}}N(d,l){let a;return l?.dangling?a=g.FileType.Unknown:d.isFile()?a=g.FileType.File:d.isDirectory()?a=g.FileType.Directory:a=g.FileType.Unknown,l&&(a|=g.FileType.SymbolicLink),a}async P(d){const l=this.I(d);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let a;for(;a=this.O.get(d);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await a.wait();const h=new L.$ph;return this.O.set(d,h),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,S.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.O.get(d)===h&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.O.delete(d)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let a;try{l?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(d)})`),a=await this.P(d));const h=this.I(d);return await v.Promises.readFile(h)}catch(h){throw this.gb(h)}finally{a?.dispose()}}Q(d){t.J&&this.a.trace(d)}readFileStream(d,l,a){const h=(0,k.$qe)(m=>M.$Ce.concat(m.map(D=>M.$Ce.wrap(D))).buffer);return(0,o.$Bq)(this,d,h,m=>m.buffer,{...l,bufferSize:256*1024},a),h}async writeFile(d,l,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.R(d)?this.S(d,(0,$.$4g)((0,$.$3g)(d),`${(0,$.$1g)(d)}${a.atomic.postfix}`),l,a):this.U(d,l,a)}async R(d){try{const l=this.I(d),{symbolicLink:a}=await v.SymlinkSupport.stat(l);if(a)return!1}catch{}return!0}async S(d,l,a,h){const m=new S.$Tc;try{m.add(await this.P(d)),m.add(await this.P(l)),await this.U(l,a,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(D){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{m.dispose()}}async U(d,l,a,h){let m;try{const D=this.I(d);if(!a.create||!a.overwrite){if(await v.Promises.exists(D)){if(!a.overwrite)throw(0,g.$0k)((0,c.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,g.$0k)((0,c.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(d,{create:!0,unlock:a.unlock},h),await this.write(m,0,l,0,l.byteLength)}catch(D){throw await this.hb(d,D)}finally{typeof m=="number"&&await this.close(m)}}static{this.Z=!0}static configureFlushOnWrite(d){t.Z=d}async open(d,l,a){const h=this.I(d);let m;(0,g.$Xk)(l)&&!a&&(m=await this.P(d));let D;try{if((0,g.$Xk)(l)&&l.unlock)try{const{stat:E}=await v.SymlinkSupport.stat(h);E.mode&128||await v.Promises.chmod(h,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let p;if((0,g.$Xk)(l)){if(C.$i)try{await v.Promises.truncate(h,0),p="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}p||(p="w")}else p="r";D=await v.Promises.open(h,p)}catch(p){throw m?.dispose(),(0,g.$Xk)(l)?await this.hb(d,p):this.gb(p)}if(this.W.set(D,0),(0,g.$Xk)(l)&&this.Y.set(D,d),m){const p=this.X.get(D);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.X.set(D,m),p&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),p.dispose())}return D}async close(d){const l=this.X.get(d);try{if(this.W.delete(d),this.Y.delete(d)&&t.Z)try{await v.Promises.fdatasync(d)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await v.Promises.close(d)}catch(a){throw this.gb(a)}finally{l&&(this.X.get(d)===l&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.X.delete(d)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,a,h,m){const D=this.$(d,l);let p=null;try{p=(await v.Promises.read(d,a,h,m,D)).bytesRead}catch(E){throw this.gb(E)}finally{this.ab(d,D,p)}return p}$(d,l){return l===this.W.get(d)?null:l}ab(d,l,a){const h=this.W.get(d);typeof h=="number"&&(typeof l=="number"||(typeof a=="number"?this.W.set(d,h+a):this.W.delete(d)))}async write(d,l,a,h,m){return(0,L.$Kh)(()=>this.bb(d,l,a,h,m),100,3)}async bb(d,l,a,h,m){const D=this.$(d,l);let p=null;try{p=(await v.Promises.write(d,a,h,m,D)).bytesWritten}catch(E){throw await this.hb(this.Y.get(d),E)}finally{this.ab(d,D,p)}return p}async mkdir(d){try{await v.Promises.mkdir(this.I(d))}catch(l){throw this.gb(l)}}async delete(d,l){try{const a=this.I(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,A.$kc)((0,A.$nc)(a),`${(0,A.$oc)(a)}${l.atomic.postfix}`)),await v.Promises.rm(a,v.RimRafMode.MOVE,h)}else try{await v.Promises.unlink(a)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let m=!1;try{const{stat:D,symbolicLink:p}=await v.SymlinkSupport.stat(a);m=D.isDirectory()&&!p}catch{}if(m)await v.Promises.rmdir(a);else throw h}else throw h}}catch(a){throw this.gb(a)}}async rename(d,l,a){const h=this.I(d),m=this.I(l);if(h!==m)try{await this.cb(d,l,"move",a.overwrite),await v.Promises.rename(h,m)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,c.localize)(2,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(m)),D.toString()))),this.gb(D)}}async copy(d,l,a){const h=this.I(d),m=this.I(l);if(h!==m)try{await this.cb(d,l,"copy",a.overwrite),await v.Promises.copy(h,m,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,c.localize)(3,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(m)),D.toString()))),this.gb(D)}}async cb(d,l,a,h){const m=this.I(d),D=this.I(l);let p=!1;if(!!(this.capabilities&1024)||(p=(0,b.$pg)(m,D,!0)),p){if(a==="copy")throw(0,g.$0k)((0,c.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const y=await this.M(d);if(!y)throw(0,g.$0k)((0,c.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const P=await this.M(l);if(P){if(!h)throw(0,g.$0k)((0,c.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);y.type&g.FileType.File&&P.type&g.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.db(d,l,!1)}async db(d,l,a){const h=this.I(d),m=this.I(l),D=!!(this.capabilities&1024);if((0,b.$pg)(h,m,!D))return;const p=new S.$Tc;try{p.add(await this.P(d)),p.add(await this.P(l)),a&&await v.Promises.mkdir((0,A.$nc)(m),{recursive:!0}),await v.Promises.copyFile(h,m)}catch(E){if(E.code==="ENOENT"&&!a)return this.db(d,l,!0);throw this.gb(E)}finally{p.dispose()}}t(d,l,a){return new r.$Tq(h=>d(h),h=>l(h),a)}F(d,l,a){return new s.$3q(h=>d(h),h=>l(h),a)}gb(d){if(d instanceof g.$9k)return d;let l=d,a;switch(d.code){case"ENOENT":a=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=g.FileSystemProviderErrorCode.Unknown;break;default:a=g.FileSystemProviderErrorCode.Unknown}return(0,g.$0k)(l,a)}async hb(d,l){let a=this.gb(l);if(d&&a.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await v.SymlinkSupport.stat(this.I(d));h.mode&128||(a=(0,g.$0k)(l,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return a}}e.$4q=t}),define(ke[261],Ee([1,0,3,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0;class L extends u.$Uc{constructor(M,w=[]){super(),this.a=new N.$7j([M,...w]),this.B(M.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...w){this.a.trace(M,...w)}debug(M,...w){this.a.debug(M,...w)}info(M,...w){this.a.info(M,...w)}warn(M,...w){this.a.warn(M,...w)}error(M,...w){this.a.error(M,...w)}flush(){this.a.flush()}}e.$yQ=L}),define(ke[262],Ee([1,0,32,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=void 0;var L;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(L||(L={}));async function R(S,A,C,$,k){try{const v=await new Promise((g,o)=>{le(["@vscode/spdlog"],g,o)});v.setFlushOn(L.Trace);const c=await v.createAsyncRotatingLogger(S,A,C,$);return k?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(v){console.error(v)}return null}function M(S,A,C){switch(A){case N.LogLevel.Trace:S.trace(C);break;case N.LogLevel.Debug:S.debug(C);break;case N.LogLevel.Info:S.info(C);break;case N.LogLevel.Warning:S.warn(C);break;case N.LogLevel.Error:S.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function w(S,A){switch(A){case N.LogLevel.Trace:S.setLevel(L.Trace);break;case N.LogLevel.Debug:S.setLevel(L.Debug);break;case N.LogLevel.Info:S.setLevel(L.Info);break;case N.LogLevel.Warning:S.setLevel(L.Warning);break;case N.LogLevel.Error:S.setLevel(L.Error);break;case N.LogLevel.Off:S.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class b extends N.$3j{constructor(A,C,$,k,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,C,$,k),this.B(this.onDidChangeLogLevel(c=>{this.r&&w(this.r,c)}))}async s(A,C,$,k){const v=$?6:1,c=30/v*u.$sl.MB,g=await R(A,C,c,v,k);if(g){this.r=g,w(this.r,this.getLevel());for(const{level:o,message:n}of this.m)M(this.r,o,n);this.m=[]}}g(A,C){this.r?M(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nQ=b}),define(ke[138],Ee([1,0,40,214,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(b){function S(v,c){return c-v}b.compare=S;const A=Object.create(null);A[b.Error]=(0,N.localize)(0,null),A[b.Warning]=(0,N.localize)(1,null),A[b.Info]=(0,N.localize)(2,null);function C(v){return A[v]||""}b.toString=C;function $(v){switch(v){case u.default.Error:return b.Error;case u.default.Warning:return b.Warning;case u.default.Info:return b.Info;case u.default.Ignore:return b.Hint}}b.fromSeverity=$;function k(v){switch(v){case b.Error:return u.default.Error;case b.Warning:return u.default.Warning;case b.Info:return u.default.Info;case b.Hint:return u.default.Ignore}}b.toSeverity=k}(M||(e.MarkerSeverity=M={}));var w;(function(b){const S="";function A($){return C($,!0)}b.makeKey=A;function C($,k){const v=[S];return $.source?v.push($.source.replace("\xA6","\\\xA6")):v.push(S),$.code?typeof $.code=="string"?v.push($.code.replace("\xA6","\\\xA6")):v.push($.code.value.replace("\xA6","\\\xA6")):v.push(S),$.severity!==void 0&&$.severity!==null?v.push(M.toString($.severity)):v.push(S),$.message&&k?v.push($.message.replace("\xA6","\\\xA6")):v.push(S),$.startLineNumber!==void 0&&$.startLineNumber!==null?v.push($.startLineNumber.toString()):v.push(S),$.startColumn!==void 0&&$.startColumn!==null?v.push($.startColumn.toString()):v.push(S),$.endLineNumber!==void 0&&$.endLineNumber!==null?v.push($.endLineNumber.toString()):v.push(S),$.endColumn!==void 0&&$.endColumn!==null?v.push($.endColumn.toString()):v.push(S),v.push(S),v.join("\xA6")}b.makeKeyOptionalMessage=C})(w||(e.IMarkerData=w={})),e.$Tt=(0,L.$qi)("markerService")}),define(ke[263],Ee([1,0,4,40,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=w,e.Severity=N.default,e.$Tv=(0,L.$qi)("notificationService");var R;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function w(C){if(C){const $=C;return typeof $.id=="string"&&typeof $.label=="string"}return!1}var b;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class S{constructor(){this.progress=new A,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity($){}updateMessage($){}updateActions($){}close(){}}e.$Vv=S;class A{infinite(){}done(){}total($){}worked($){}}e.$Wv=A}),define(ke[264],Ee([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[139],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,u.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(le,e){return function(u,N){e(u,N,le)}};define(ke[108],Ee([1,0,8,22,3,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,R.$qi)("progressService");var M;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$Zv=w;class b{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const k=this.d;this.d=()=>{k?.(),$()}}):Promise.resolve()}}e.$1v=b;let S=class extends L.$Uc{constructor($,k){super(),this.a=new u.$Nh,k.withProgress($,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$2v=S,e.$2v=S=Je([qe(1,e.$Xv)],S);class A extends L.$Uc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new L.$Tc)}start($){this.stop();const k=++this.a,v=new N.$me;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:k,token:v.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$3v=A,e.$4v=(0,R.$qi)("editorProgressService")}),define(ke[38],Ee([1,0,62,18]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class L{constructor(){this.a=new Map}add(M,w){u.ok(N.$4f(M)),u.ok(N.$6f(w)),u.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,w)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new L}),define(ke[109],Ee([1,0,4,38]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function L(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class R{constructor(){this.b=new u.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,S){this.a[L(b)]=S,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;N.$9n.add(e.$0n.JSONContribution,M)}),define(ke[85],Ee([1,0,19,4,18,203,54,109,38]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=c,e.$no=g,e.$oo=o,e.$po=i,e.$qo=r;var S;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$bo={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const C=b.$9n.as(w.$0n.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$io,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const d=new Set;this.n(t,f,d),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const f=new Set;this.o(t,f),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const d=new Set;this.o(f,d),this.n(t,!1,d),C.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const d=[];for(const{overrides:l,source:a}of t)for(const h in l)if(f.add(h),e.$lo.test(h)){const m=this.a.get(h),D=m?.valuesSources??new Map;if(a)for(const P of Object.keys(l[h]))D.set(P,a);const p={...m?.value||{},...l[h]};this.a.set(h,{source:a,value:p,valuesSources:D});const E=(0,M.$7i)(h),y={type:"object",default:p,description:R.localize(1,null,E),$ref:e.$io,defaultDefaultValue:p,source:L.$4f(a)?void 0:a,defaultValueSource:a};d.push(...c(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:l[h],source:a});const m=this.d[h];m&&(this.w(h,m),this.r(h,m))}this.m(d)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:d,source:l}of t)for(const a in d){const h=this.a.get(a),m=L.$4f(l)?l:l?.id,D=L.$4f(h?.source)?h?.source:h?.source?.id;if(m===D)if(f.add(a),this.a.delete(a),e.$lo.test(a))delete this.d[a],delete this.b.properties[a];else{const p=this.d[a];p&&(this.w(a,p),this.r(a,p))}}this.u()}deltaConfiguration(t){let f=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,d){t.forEach(l=>{this.p(l,f,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,f){const d=l=>{if(l.properties)for(const a in l.properties){f.add(a);const h=this.d[a];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[a],this.s(a,l.properties[a])}l.allOf?.forEach(a=>d(a))};for(const l of t){d(l);const a=this.c.indexOf(l);a!==-1&&this.c.splice(a,1)}}p(t,f=!0,d,l,a=3,h){a=L.$ag(t.scope)?a:t.scope;const m=t.properties;if(m)for(const p in m){const E=m[p];if(f&&i(p,E)){delete m[p];continue}if(E.source=d,E.defaultDefaultValue=m[p].default,this.w(p,E),e.$lo.test(p)?E.scope=void 0:(E.scope=L.$ag(E.scope)?a:E.scope,E.restricted=L.$ag(E.restricted)?!!l?.includes(p):E.restricted),m[p].hasOwnProperty("included")&&!m[p].included){this.f[p]=m[p],delete m[p];continue}else this.d[p]=m[p],m[p].policy?.name&&this.e.set(m[p].policy.name,p);!m[p].deprecationMessage&&m[p].markdownDeprecationMessage&&(m[p].deprecationMessage=m[p].markdownDeprecationMessage),h.add(p)}const D=t.allOf;if(D)for(const p of D)this.p(p,f,d,l,a,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$co.properties[t]=f,f.scope){case 1:e.$do.properties[t]=f;break;case 2:e.$eo.properties[t]=f;break;case 6:e.$fo.properties[t]=f;break;case 3:e.$go.properties[t]=f;break;case 4:e.$ho.properties[t]=f;break;case 5:e.$ho.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$co.properties[t],f.scope){case 1:delete e.$do.properties[t];break;case 2:delete e.$eo.properties[t];break;case 6:delete e.$fo.properties[t];break;case 3:delete e.$go.properties[t];break;case 4:case 5:delete e.$ho.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$io};this.w(f,d),e.$co.properties[f]=d,e.$do.properties[f]=d,e.$eo.properties[f]=d,e.$fo.properties[f]=d,e.$go.properties[f]=d,e.$ho.properties[f]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=t,e.$do.patternProperties[e.$ko]=t,e.$eo.patternProperties[e.$ko]=t,e.$fo.patternProperties[e.$ko]=t,e.$go.patternProperties[e.$ko]=t,e.$ho.patternProperties[e.$ko]=t,this.i.fire()}w(t,f){const d=this.a.get(t);let l=d?.value,a=d?.source;L.$$f(l)&&(l=f.defaultDefaultValue,a=void 0),L.$$f(l)&&(l=o(f.type)),f.default=l,f.defaultValueSource=a}}const k="\\[([^\\]]+)\\]",v=new RegExp(k,"g");e.$ko=`^(${k})+$`,e.$lo=new RegExp(e.$ko);function c(s){const t=[];if(e.$lo.test(s)){let f=v.exec(s);for(;f?.length;){const d=f[1].trim();d&&t.push(d),f=v.exec(s)}}return(0,u.$Mb)(t)}function g(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new $;b.$9n.add(e.$bo.Configuration,n);function i(s,t){return s.trim()?e.$lo.test(s)?R.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ke[265],Ee([1,0,19,4,164,3,27,24,18,2,54,85,38]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=i;function k(f){return Object.isFrozen(f)?f:w.$Xn(f)}class v{static createEmptyModel(d){return new v({},[],[],void 0,d)}constructor(d,l,a,h,m){this.b=d,this.c=l,this.d=a,this.raw=h,this.f=m,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof v)return l;const a=new c("",this.f);return a.parseRaw(l),a.configurationModel});this.g=d.reduce((l,a)=>a===l?a:l.merge(a),d[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$5i)(this.contents,d):this.contents}inspect(d,l){const a=this;return{get value(){return k(a.rawConfiguration.getValue(d))},get override(){return l?k(a.rawConfiguration.getOverrideValue(d,l)):void 0},get merged(){return k(l?a.rawConfiguration.override(l).getValue(d):a.rawConfiguration.getValue(d))},get overrides(){const h=[];for(const{contents:m,identifiers:D,keys:p}of a.rawConfiguration.overrides){const E=new v(m,p,[],void 0,a.f).getValue(d);E!==void 0&&h.push({identifiers:D,value:E})}return h.length?k(h):void 0}}}getOverrideValue(d,l){const a=this.j(l);return a?d?(0,A.$5i)(a,d):a:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const a of this.overrides)a.identifiers.includes(d)&&l.push(...a.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return u.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.h(d),this.a.set(d,l)),l}merge(...d){const l=w.$Wn(this.contents),a=w.$Wn(this.overrides),h=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const D of d)if(m.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(l,D.contents);for(const p of D.overrides){const[E]=a.filter(y=>u.$ub(y.identifiers,p.identifiers));E?(this.i(E.contents,p.contents),E.keys.push(...p.keys),E.keys=u.$Mb(E.keys)):a.push(w.$Wn(p))}for(const p of D.keys)h.indexOf(p)===-1&&h.push(p)}return new v(l,h,a,m.every(D=>D instanceof v)?void 0:m,this.f)}h(d){const l=this.j(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const a={};for(const h of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let m=this.contents[h];const D=l[h];D&&(typeof m=="object"&&typeof D=="object"?(m=w.$Wn(m),this.i(m,D)):m=D),a[h]=m}return new v(a,this.keys,this.overrides,void 0,this.f)}i(d,l){for(const a of Object.keys(l)){if(a in d&&b.$6f(d[a])&&b.$6f(l[a])){this.i(d[a],l[a]);continue}d[a]=w.$Wn(l[a])}}j(d){let l=null,a=null;const h=m=>{m&&(a?this.i(a,m):a=w.$Wn(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===d?l=m.contents:m.identifiers.includes(d)&&h(m.contents);return h(l),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.k(d,l,!0)}setValue(d,l){this.k(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,A.$4i)(this.contents,d),C.$lo.test(d)&&this.overrides.splice(this.overrides.findIndex(a=>u.$ub(a.identifiers,(0,C.$mo)(d))),1))}k(d,l,a){(0,A.$3i)(this.contents,d,l,h=>this.f.error(h)),a=a||this.keys.indexOf(d)===-1,a&&this.keys.push(d),C.$lo.test(d)&&this.overrides.push({identifiers:(0,C.$mo)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$2i)(this.contents[d],h=>this.f.error(h))})}}e.$ro=v;class c{constructor(d,l){this.f=d,this.g=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!b.$ag(d)){const a=this.h(d);this.parseRaw(a,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:a,keys:h,overrides:m,restricted:D,hasExcludedProperties:p}=this.i(d,l);this.b=new v(a,h,m,p?[d]:void 0,this.g),this.c=D||[]}h(d){let l={},a=null,h=[];const m=[],D=[];function p(y){Array.isArray(h)?h.push(y):a!==null&&(h[a]=y)}const E={onObjectBegin:()=>{const y={};p(y),m.push(h),h=y,a=null},onObjectProperty:y=>{a=y},onObjectEnd:()=>{h=m.pop()},onArrayBegin:()=>{const y=[];p(y),m.push(h),h=y,a=null},onArrayEnd:()=>{h=m.pop()},onLiteralValue:p,onError:(y,P,I)=>{D.push({error:y,offset:P,length:I})}};if(d)try{L.$Kn(d,E),l=h[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return l}i(d,l){const a=$.$9n.as(C.$bo.Configuration).getConfigurationProperties(),h=this.j(d,a,!0,l);d=h.raw;const m=(0,A.$2i)(d,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),D=Object.keys(d),p=this.l(d,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:m,keys:D,overrides:p,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}j(d,l,a,h){let m=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:m};const D={},p=[];for(const E in d)if(C.$lo.test(E)&&a){const y=this.j(d[E],l,!1,h);D[E]=y.raw,m=m||y.hasExcludedProperties,p.push(...y.restricted)}else{const y=l[E],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&p.push(E),!h.exclude?.includes(E)&&(h.include?.includes(E)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&y?.restricted))?D[E]=d[E]:m=!0}return{raw:D,restricted:p,hasExcludedProperties:m}}l(d,l){const a=[];for(const h of Object.keys(d))if(C.$lo.test(h)){const m={};for(const D in d[h])m[D]=d[h][D];a.push({identifiers:(0,C.$mo)(h),keys:Object.keys(m),contents:(0,A.$2i)(m,l)})}return a}}e.$so=c;class g extends R.$Uc{constructor(d,l,a,h,m){super(),this.c=d,this.f=l,this.g=h,this.h=m,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new c(this.c.toString(),m),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&a.isEqual(D.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=g;class o{constructor(d,l,a,h,m,D,p,E,y,P,I,j,F){this.a=d,this.b=l,this.c=a,this.overrideIdentifiers=h,this.d=m,this.f=D,this.g=p,this.h=E,this.i=y,this.j=P,this.k=I,this.l=j,this.m=F}get value(){return k(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(d,l,a,h,m,D,p,E,y,P){this.j=d,this.l=l,this.m=a,this.n=h,this.p=m,this.q=D,this.r=p,this.s=E,this.t=y,this.u=P,this.h=null,this.i=new M.$Bc,this.v=null}getValue(d,l,a){return this.w(d,l,a).getValue(d)}updateValue(d,l,a={}){let h;a.resource?(h=this.t.get(a.resource),h||(h=v.createEmptyModel(this.u),this.t.set(a.resource,h))):h=this.s,l===void 0?h.removeValue(d):h.setValue(d,l),a.resource||(this.h=null)}inspect(d,l,a){const h=this.w(d,l,a),m=this.A(l.resource,a),D=l.resource?this.t.get(l.resource)||this.s:this.s,p=new Set;for(const E of h.overrides)for(const y of E.identifiers)h.getOverrideValue(d,y)!==void 0&&p.add(y);return new o(d,l,h.getValue(d),p.size?[...p]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.q:void 0,m||void 0,D)}keys(d){const l=this.A(void 0,d);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.j=d,this.h=null,this.i.clear()}updatePolicyConfiguration(d){this.l=d}updateApplicationConfiguration(d){this.m=d,this.h=null,this.i.clear()}updateLocalUserConfiguration(d){this.n=d,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(d){this.p=d,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(d){this.q=d,this.h=null,this.i.clear()}updateFolderConfiguration(d,l){this.r.set(d,l),this.i.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.i.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const a=[];if(!l){const{added:h,updated:m,removed:D}=s(this.j,d);l=[...h,...m,...D]}for(const h of l)for(const m of(0,C.$mo)(h)){const D=this.j.getKeysForOverrideIdentifier(m),p=d.getKeysForOverrideIdentifier(m),E=[...p.filter(y=>D.indexOf(y)===-1),...D.filter(y=>p.indexOf(y)===-1),...D.filter(y=>!w.$1n(this.j.override(m).getValue(y),d.override(m).getValue(y)))];a.push([m,E])}return this.updateDefaultConfiguration(d),{keys:l,overrides:a}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:a,removed:h}=s(this.l,d),m=[...l,...a,...h];return m.length&&this.updatePolicyConfiguration(d),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:a,removed:h,overrides:m}=s(this.applicationConfiguration,d),D=[...l,...a,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:m}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:a,removed:h,overrides:m}=s(this.localUserConfiguration,d),D=[...l,...a,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:m}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:a,removed:h,overrides:m}=s(this.remoteUserConfiguration,d),D=[...l,...a,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:m}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:a,removed:h,overrides:m}=s(this.workspaceConfiguration,d),D=[...l,...a,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:m}}compareAndUpdateFolderConfiguration(d,l){const a=this.folderConfigurations.get(d),{added:h,updated:m,removed:D,overrides:p}=s(a,l),E=[...h,...m,...D];return(E.length||!a)&&this.updateFolderConfiguration(d,l),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:a,updated:h,removed:m,overrides:D}=s(l,void 0);return{keys:[...a,...h,...m],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(d,l,a){let h=this.x(l,a);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(d)!==void 0&&(h=h.merge(this.l)),h}x({resource:d},l){let a=this.y();if(l&&d){const h=l.getFolder(d);h&&(a=this.z(h.uri)||a);const m=this.t.get(d);m&&(a=a.merge(m))}return a}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(d){let l=this.i.get(d);if(!l){const a=this.y(),h=this.r.get(d);h?(l=a.merge(h),this.i.set(d,l)):l=a}return l}A(d,l){if(l&&d){const a=l.getFolder(d);if(a)return this.r.get(a.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((d,l)=>{const{contents:a,overrides:h,keys:m}=this.r.get(l);return d.push([l,{contents:a,overrides:h,keys:m}]),d},[])}}allKeys(){const d=new Set;return this.j.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.q.keys.forEach(l=>d.add(l)),this.r.forEach(l=>l.keys.forEach(a=>d.add(a))),[...d.values()]}B(){const d=new Set;return this.j.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.q.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.r.forEach(l=>l.getAllOverrideIdentifiers().forEach(a=>d.add(a))),[...d.values()]}D(d){const l=new Set;return this.j.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.q.getKeysForOverrideIdentifier(d).forEach(a=>l.add(a)),this.r.forEach(a=>a.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d,l){const a=this.E(d.defaults,l),h=this.E(d.policy,l),m=this.E(d.application,l),D=this.E(d.user,l),p=this.E(d.workspace,l),E=d.folders.reduce((y,P)=>(y.set(S.URI.revive(P[0]),this.E(P[1],l)),y),new M.$Bc);return new n(a,h,m,D,v.createEmptyModel(l),p,E,v.createEmptyModel(l),new M.$Bc,l)}static E(d,l){return new v(d.contents,d.keys,d.overrides,void 0,l)}}e.$uo=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const d=new Set,l=new Map;for(const h of f)h.keys.forEach(m=>d.add(m)),h.overrides.forEach(([m,D])=>{const p=(0,M.$yc)(l,m,new Set);D.forEach(E=>p.add(E))});const a=[];return l.forEach((h,m)=>a.push([m,[...h.values()]])),{keys:[...d.values()],overrides:a}}class r{constructor(d,l,a,h,m){this.change=d,this.f=l,this.g=a,this.h=h,this.i=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of d.keys)this.affectedKeys.add(D);for(const[,D]of d.overrides)for(const p of D)this.affectedKeys.add(p);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(d,l){const a=this.a+d,h=this.d.indexOf(a);if(h<0)return!1;const m=h+a.length;if(m>=this.d.length)return!1;const D=this.d.charCodeAt(m);if(D!==this.b&&D!==this.c)return!1;if(l){const p=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,E=this.g.getValue(d,l,this.h);return!w.$1n(p,E)}return!0}}e.$wo=r;function s(f,d){const{added:l,removed:a,updated:h}=t(d?.rawConfiguration,f?.rawConfiguration),m=[],D=f?.getAllOverrideIdentifiers()||[],p=d?.getAllOverrideIdentifiers()||[];if(d){const E=p.filter(y=>!D.includes(y));for(const y of E)m.push([y,d.getKeysForOverrideIdentifier(y)])}if(f){const E=D.filter(y=>!p.includes(y));for(const y of E)m.push([y,f.getKeysForOverrideIdentifier(y)])}if(d&&f){for(const E of D)if(p.includes(E)){const y=t({contents:f.getOverrideValue(void 0,E)||{},keys:f.getKeysForOverrideIdentifier(E)},{contents:d.getOverrideValue(void 0,E)||{},keys:d.getKeysForOverrideIdentifier(E)});m.push([E,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:a,updated:h,overrides:m}}function t(f,d){const l=f?d?f.keys.filter(m=>d.keys.indexOf(m)===-1):[...f.keys]:[],a=d?f?d.keys.filter(m=>f.keys.indexOf(m)===-1):[...d.keys]:[],h=[];if(f&&d){for(const m of d.keys)if(f.keys.indexOf(m)!==-1){const D=(0,A.$5i)(d.contents,m),p=(0,A.$5i)(f.contents,m);w.$1n(D,p)||h.push(m)}}return{added:l,removed:a,updated:h}}}),define(ke[266],Ee([1,0,21,4,3,82]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsb=e.$lsb=e.$ksb=void 0,e.$msb=w;const M=(S,A,C)=>{const $=new Uint8Array(16);for(let c=0;c<16;c++)$[c]=Math.round(Math.random()*256);const k=(0,u.$We)(u.$Ce.wrap($));return[`GET ws://localhost${S}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$ksb=M,e.$lsb=u.$Ce.fromString(`\r
\r
`);async function w(S,A,C,$,k){S.write(u.$Ce.fromString((0,e.$ksb)(A,C,$)));const v=new L.$Tc;try{return await new Promise((c,g)=>{let o;v.add(S.onData(n=>{o?o=u.$Ce.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$lsb);if(i===-1)return;c(S),S.pauseData();const r=o.slice(i+e.$lsb.byteLength);r.byteLength&&k.onData.fire(r)})),v.add(S.onClose(n=>g(n??new Error("socket closed")))),v.add(S.onEnd(()=>g(new Error("socket ended"))))})}catch(c){throw S.dispose(),c}finally{v.dispose()}}class b extends L.$Uc{constructor(A,C){super(),this.g=A,this.a=this.B(new N.$ee),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$be),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event($=>this.a.fire($))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$nsb=b}),define(ke[66],Ee([1,0,13,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=S,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=R;class M{constructor(C,$){this.host=C,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var w;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class b extends u.$bb{static isNotAvailable(C){return C instanceof b&&C._code===w.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof b&&C._code===w.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof b&&C._code===w.NoResolverFound}static isInvalidAuthority(C){return C instanceof b&&C._code===w.InvalidAuthority}static isHandled(C){return C instanceof b&&C.isHandled}constructor(C,$=w.Unknown,k){super(C),this._message=C,this._code=$,this._detail=k,this.isHandled=$===w.NotAvailable&&k===!0,Object.setPrototypeOf(this,b.prototype)}}e.$El=b;function S(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}}),define(ke[267],Ee([1,0,8,21,22,13,4,3,15,59,39,30,82,66]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Kl=D,e.$Ll=p,e.$Ml=y;const v=30*1e3;var c;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function g(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(_){const U=new L.$me;return setTimeout(()=>U.cancel(),_),U.token}function n(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ie=new L.$me;return _.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new w.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$jh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(_,U){const ie=new i(U);return ie.registerDisposable(_.onControlMessage(be=>{const Ce=JSON.parse(be.toString()),oe=Z(Ce);oe?ie.reject(oe):ie.resolve(Ce)})),ie.promise}function s(_,U,ie,be,Ce,oe,ae,re){const G=new i(re),te=A.$0d.create(!1);return _.info(`Creating a socket (${ae})...`),S.mark(`code/willCreateSocket/${oe}`),U.connect(ie,be,Ce,ae).then(ge=>{G.didTimeout?(S.mark(`code/didCreateSocketError/${oe}`),_.info(`Creating a socket (${ae}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(S.mark(`code/didCreateSocketOK/${oe}`),_.info(`Creating a socket (${ae}) was successful after ${te.elapsed()} ms.`),G.resolve(ge))},ge=>{S.mark(`code/didCreateSocketError/${oe}`),_.info(`Creating a socket (${ae}) returned an error after ${te.elapsed()} ms.`),_.error(ge),G.reject(ge)}),G.promise}function t(_,U){const ie=new i(U);return _.then(be=>{ie.didTimeout||ie.resolve(be)},be=>{ie.didTimeout||ie.reject(be)}),ie.promise}async function f(_,U,ie,be){const Ce=$e(_,U);_.logService.trace(`${Ce} 1/6. invoking socketFactory.connect().`);let oe;try{oe=await s(_.logService,_.remoteSocketFactoryService,_.connectTo,b.$Dg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,g(U),`renderer-${g(U)}-${_.reconnectionToken}`,be)}catch(ge){throw _.logService.error(`${Ce} socketFactory.connect() failed or timed out. Error:`),_.logService.error(ge),ge}_.logService.trace(`${Ce} 2/6. socketFactory.connect() was successful.`);let ae,re;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(oe,null),ae=_.reconnectionProtocol,re=!1):(ae=new $.$ei({socket:oe}),re=!0),_.logService.trace(`${Ce} 3/6. sending AuthRequest control message.`);const G=await t(_.signService.createNewMessage((0,C.$Mg)()),be),te={type:"auth",auth:_.connectionToken||"00000000000000000000",data:G.data};ae.sendControl(N.$Ce.fromString(JSON.stringify(te)));try{const ge=await r(ae,n(be,o(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(_.logService.trace(`${Ce} 4/6. received SignRequest control message.`),!await t(_.signService.validate(G,ge.signedData),be)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const Re=await t(_.signService.sign(ge.data),be),fe={type:"connectionType",commit:_.commit,signedData:Re,desiredConnectionType:U};return ie&&(fe.args=ie),_.logService.trace(`${Ce} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(N.$Ce.fromString(JSON.stringify(fe))),{protocol:ae,ownsProtocol:re}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(_.logService.error(`${Ce} the handshake timed out. Error:`),_.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${Ce} received error control message when negotiating connection. Error:`),_.logService.error(ge)),re&&x(ae),ge}}async function d(_,U,ie,be){const Ce=Date.now(),oe=$e(_,U),{protocol:ae,ownsProtocol:re}=await f(_,U,ie,be),G=new i(be);return G.registerDisposable(ae.onControlMessage(te=>{const ge=JSON.parse(te.toString()),we=Z(ge);we?(_.logService.error(`${oe} received error control message when negotiating connection. Error:`),_.logService.error(we),re&&x(ae),G.reject(we)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${Pe(Ce)}!`),G.resolve({protocol:ae,firstMessage:ge}))})),G.promise}async function l(_,U){const{protocol:ie}=await d(_,1,void 0,U);return{protocol:ie}}async function a(_,U,ie){const{protocol:be,firstMessage:Ce}=await d(_,2,U,ie),oe=Ce&&Ce.debugPort;return{protocol:be,debugPort:oe}}async function h(_,U,ie){const be=Date.now(),Ce=$e(_,3),{protocol:oe}=await f(_,3,U,ie);return _.logService.trace(`${Ce} 6/6. handshake finished, connection is up and running after ${Pe(be)}!`),oe}async function m(_,U,ie){const{connectTo:be,connectionToken:Ce}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:be,connectionToken:Ce,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function D(_,U,ie){return E(_,async be=>{const{protocol:Ce}=await l(be,L.CancellationToken.None);return new W(_,U,ie,be.reconnectionToken,Ce)})}async function p(_,U){return E(_,async ie=>{const{protocol:be,debugPort:Ce}=await a(ie,U,L.CancellationToken.None);return new X(_,U,ie.reconnectionToken,be,Ce)})}async function E(_,U){for(let be=1;;be++)try{const Ce=(0,C.$Mg)(),oe=await m(_,Ce,null);return await U(oe)}catch(Ce){if(be<5)_.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(Ce);else throw _.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(Ce),B.triggerPermanentFailure(0,0,k.$El.isHandled(Ce)),Ce}}async function y(_,U,ie){const be=await m(_,(0,C.$Mg)(),null);return await h(be,{host:U,port:ie},L.CancellationToken.None)}function P(_){return(0,u.$dh)(U=>new Promise((ie,be)=>{const Ce=setTimeout(ie,_*1e3);U.onCancellationRequested(()=>{clearTimeout(Ce),ie()})}))}var I;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class j{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$Nl=j;class F{constructor(U,ie,be,Ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=be,this.c=Ce,this.type=1}skipWait(){this.c.cancel()}}e.$Ol=F;class z{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=2}}e.$Pl=z;class O{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=4}}e.$Ql=O;class T{constructor(U,ie,be,Ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.handled=Ce,this.type=3}}e.$Rl=T;class B extends w.$Uc{static triggerPermanentFailure(U,ie,be){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=be,this.j.forEach(Ce=>Ce.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ie,be,Ce,oe){super(),this.t=U,this.u=ie,this.reconnectionToken=be,this.protocol=Ce,this.w=oe,this.m=this.B(new M.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(Ce.onSocketClose(ae=>{const re=ne(this.t,this.reconnectionToken,!0);ae?ae.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(Ce.onSocketTimeout(ae=>{const re=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,w.$Sc)(()=>{const ae=B.j.indexOf(this);ae>=0&&B.j.splice(ae,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const Ce=be<ie.length?ie[be]:ie[ie.length-1];try{if(Ce>0){const ae=P(Ce);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ce,ae)),this.u.logService.info(`${U} waiting for ${Ce} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const oe=await m(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${oe.connectTo}...`),await this.G(oe,o(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(oe){if(oe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(k.$El.isTemporarilyNotAvailable(oe)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((oe.code==="ETIMEDOUT"||oe.code==="ENETUNREACH"||oe.code==="ECONNREFUSED"||oe.code==="ECONNRESET")&&oe.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((0,R.$4)(oe)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if(oe instanceof k.$El){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,k.$El.isHandled(oe));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,be){this.w?B.triggerPermanentFailure(U,ie,be):this.D(U,ie,be)}D(U,ie,be){this.m.fire(new T(this.reconnectionToken,U,ie,be)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Sl=B;class W extends B{constructor(U,ie,be,Ce,oe){super(1,U,Ce,oe,!0),this.client=this.B(new $.$ci(oe,{remoteAuthority:ie,clientId:be},U.ipcLogger))}async G(U,ie){await l(U,ie)}}e.$Tl=W;class X extends B{constructor(U,ie,be,Ce,oe){super(2,U,be,Ce,!1),this.H=ie,this.debugPort=oe}async G(U,ie){await a(U,this.H,ie)}}e.$Ul=X;function x(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function Z(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Y(_,U){for(;_.length<U;)_+=" ";return _}function ce(_,U){return`[remote-connection][${Y(g(_),13)}][${U.substr(0,5)}\u2026]`}function ne(_,U,ie){return`${ce(_,U)}[${ie?"reconnect":"initial"}]`}function $e(_,U){return`${ne(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function Pe(_){return`${Date.now()-_} ms`}}),define(ke[86],Ee([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=L,e.$Dm=R,e.$Em=M;function N(b){return b.scheme===u.Schemas.vscodeRemote?b.authority:void 0}function L(b){if(!b)return;const S=b.indexOf("+");return S<0?b:b.substr(0,S)}function R(b){const{host:S,port:A}=w(b);if(typeof A>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:S,port:A}}function M(b,S){let{host:A,port:C}=w(b);return typeof C>"u"&&(C=S),{host:A,port:C}}function w(b){const S=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const A=b.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const C=b.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:b,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=R,e.$Om=C,e.$Pm=$,e.$Qm=k,e.$Rm=v,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function R(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(M||(e.ExtensionType=M={}));var w;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class b{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,o){if(typeof g>"u"||g===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof g=="string"||typeof o=="string"){const n=typeof g=="string"?g:g.value,i=typeof o=="string"?o:o.value;return u.$tf(n,i)}return g._lower===o._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Lm=b;class S{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const o of g)this.add(o)}add(g){this.c.add(b.toKey(g))}delete(g){return this.c.delete(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}}e.$Mm=S;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(b.toKey(g))}get(g){return this.c.get(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}set(g,o){this.c.set(b.toKey(g),o)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=A;function C(c){return $(c)}function $(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function k(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function v(c,g){if(g){const o=`onResolveRemoteAuthority:${(0,L.$Cm)(g)}`;return!!c.activationEvents?.includes(o)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,w){this.a.set(M,w)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const w=Object.create(null);for(const b of M){const S=this.readActivationEvents(b);S.length>0&&(w[N.$Lm.toKey(b.identifier)]=S)}return w}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const w=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let b=0;b<w.length;b++)w[b]==="onUri"&&(w[b]=`onUri:${N.$Lm.toKey(M.identifier)}`);if(!M.contributes)return w;for(const b in M.contributes){const S=this.a.get(b);if(!S)continue;const A=M.contributes[b],C=Array.isArray(A)?A:[A];try{S(C,w)}catch($){(0,u.$1)($)}}return w}}e.$cG=L,e.$dG=new L}),define(ke[268],Ee([1,0,3,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=void 0,e.$Gl=(0,N.$qi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,w){return this.a[M]??=[],this.a[M].push(w),(0,u.$Sc)(()=>{const b=this.a[M]?.indexOf(w);typeof b=="number"&&b>=0&&this.a[M]?.splice(b,1)})}b(M){return(this.a[M.type]||[]).find(b=>b.supports(M))}connect(M,w,b,S){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,w,b,S)}}e.$Hl=L}),define(ke[269],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const M=String(u.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$C0b=u}),define(ke[110],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=void 0,e.$Il="signService",e.$Jl=(0,u.$qi)(e.$Il)}),define(ke[141],Ee([1,0,269]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class N extends u.$C0b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>le(["vsda"],R,M))}}e.$ycc=N}),define(ke[270],Ee([1,0,11,51,30]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=w;function R(b){if(u.$u===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function M(b,S,A,C,$,k,v,c,g){const o=Object.create(null);o["common.machineId"]=k,o["common.sqmId"]=v,o.sessionID=(0,L.$Mg)()+Date.now(),o.commitHash=C,o.version=$,o["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,u.$h)(u.$u),o["common.nodePlatform"]=N.$ec,o["common.nodeArch"]=A,o["common.product"]=g||"desktop",c&&(o["common.msftInternal"]=c);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(o["common.snap"]="true");const r=R(S);return r&&(o["common.platformDetail"]=r),o}function w(b){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const A=S.toLowerCase();return b.some(C=>A===C)}}),define(ke[271],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,u.$qi)("telemetryService"),e.$Wl=(0,u.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Ee([1,0,24,18,86,270,271]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=A,e.$hp=C,e.$ip=$,e.$jp=k,e.$kp=c,e.$lp=o,e.$mp=n,e.$np=s;class w{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$_o=w;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=b,e.$bp=new b;class S{async publicLog(f,d,l){}async publicLogError(f,d,l){}}e.$cp=S,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function C(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const f=t.getValue(M.$4l),d=t.getValue(M.$5l);if(t.getValue(M.$6l)===!1||d===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function k(t){const f={},d={},l={};g(t,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const h=l[a];typeof h=="number"?d[a]=h:typeof h=="boolean"?d[a]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${h.length}`),f[a]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(f[a]=h)}return{properties:f,measurements:d}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const f=(0,L.$Cm)(t);return v.has(f)?f:"other"}function g(t,f,d=0,l){if(t)for(const a of Object.getOwnPropertyNames(t)){const h=t[a],m=l?l+a:a;Array.isArray(h)?f[m]=(0,u.$2n)(h):h instanceof Date?f[m]=h.toISOString():(0,N.$6f)(h)?d<2?g(h,f,d+1,m+"."):f[m]=(0,u.$2n)(h):f[m]=h}}function o(t,f){const d=t.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,R.$$o)(d)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const l=[];for(const D of f)for(;;){const p=D.exec(t);if(!p)break;l.push([p.index,D.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(d="";;){const D=h.exec(t);if(!D)break;const p=l.some(([E,y])=>D.index<y&&E<h.lastIndex);!a.test(D[0])&&!p&&(d+=t.substring(m,D.index)+"<REDACTED: user-file-path>",m=h.lastIndex)}return m<t.length&&(d+=t.substr(m)),d}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,f){return(0,u.$Yn)(t,d=>{if(d instanceof w||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,f);for(const a of f)l=l.replace(a,"");return l=r(l),l}})}}),define(ke[272],Ee([1,0,14,137,25,11,2,13,51,87]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=A,e.$qp=v,e.$rp=c,e.$sp=g,e.$tp=o,e.$up=n,e.$vp=i,e.$wp=r,e.$yp=s,e.$zp=f;function A(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,u.$of)(d.id,l.id)===0}const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(l){const a=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new $(l.identifier,a,h)}static parse(l){const a=C.exec(l);return a&&a[1]&&a[2]?new $({id:a[1]},a[2],a[4]||void 0):null}constructor(l,a,h="undefined"){this.version=a,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof $?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$pp=$;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(d){const l=k.exec(d);return l&&l[1]?[g(l[1]),l[2]]:[g(d),void 0]}function c(d,l){return`${d}.${l}`}function g(d){return d.toLowerCase()}function o(d,l){return g(c(d??L.$Hm,l))}function n(d,l){const a=[],h=m=>{for(const D of a)if(D.some(p=>A(l(p),l(m))))return D;return null};for(const m of d){const D=h(m);D?D.push(m):a.push([m])}return a}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new S.$_o(d.identifier.id),name:new S.$_o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$xp=new L.$Lm("pprice.better-merge");function s(d,l){const a=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const m=h.shift();if(m&&a.every(D=>!A(D.identifier,{id:m}))){const D=d.filter(p=>A(p.identifier,{id:m}));D.length===1&&(a.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function t(d,l){if(!R.$k)return!1;let a;try{a=(await d.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await d.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){l.debug("Error while getting the os-release file.",(0,w.$0)(m))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(d,l){const a=await t(d,l),h=(0,N.$Vo)(a?"alpine":R.$u,b.$fc);return l.debug("ComputeTargetPlatform:",h),h}}),define(ke[273],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=u,e.$ds=N,e.$es=L,e.$fs=R,e.$gs=M,e.$hs=w;function u(b){return[...b.entries()]}function N(b){return b?[...b.entries()]:[]}function L(b){return new Map(b)}function R(b){return new Map(b??[])}function M(b){return Array.from(b.entries()).map(S=>[S[0],u(S[1].map),N(S[1].descriptionMap)])}function w(b){return new Map(b.map(S=>[S[0],{map:L(S[1]),descriptionMap:R(S[2])}]))}}),define(ke[274],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsb=void 0;class u{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,M=5){const w=R(b=>{const S=typeof b=="string"?b:b.data;let A=this.a.get(L);if(A){A.data.push(S);return}const C=setTimeout(()=>this.flushBuffer(L),M);A={data:[S],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),w.dispose()}},this.a.set(L,A)});return w}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$Fsb=u}),define(ke[275],Ee([1,0,8,78,99,57,4,18,2,215,109,38]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0w=e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.IconFontDefinition=e.IconContribution=e.$2w=void 0,e.$3w=g,e.$4w=o,e.$2w={IconContribution:"base.contributions.icons"};var $;(function(s){function t(f,d){let l=f.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const a=c.getIcon(l.id);if(!a)return;l=a.defaults}return l}s.getDefinition=t})($||(e.IconContribution=$={}));var k;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function f(d){const l=a=>(0,w.$4f)(a)?a:void 0;if(d&&Array.isArray(d.src)&&d.src.every(a=>(0,w.$4f)(a.format)&&(0,w.$4f)(a.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(a=>({format:a.format,location:b.URI.parse(a.location)}))}}s.fromJSONObject=f})(k||(e.IconFontDefinition=k={}));class v{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,d,l){const a=this.b[t];if(a){if(d&&!a.description){a.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=d),this.a.fire()}return a}const h={id:t,description:d,defaults:f,deprecationMessage:l};this.b[t]=h;const m={$ref:"#/definitions/icons"};return l&&(m.deprecationMessage=l),d&&(m.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=m,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const d=this.f[t];return d||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(a,h)=>a.id.localeCompare(h.id),f=a=>{for(;R.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(a=>this.b[a]);for(const a of l.filter(h=>!!h.description).sort(t))d.push(`|<i class="${f(a)}"></i>|${a.id}|${R.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const a of l.filter(h=>!R.ThemeIcon.isThemeIcon(h.defaults)).sort(t))d.push(`|<i class="${f(a)}"></i>|${a.id}|`);return d.join(`
`)}}const c=new v;C.$9n.add(e.$2w.IconContribution,c);function g(s,t,f,d){return c.registerIcon(s,t,f,d)}function o(){return c}function n(){const s=(0,L.$Lj)();for(const t in s){const f="\\"+s[t].toString(16);c.registerIcon(t,{fontCharacter:f})}}n(),e.$5w="vscode://schemas/icons";const i=C.$9n.as(A.$0n.JSONContribution);i.registerSchema(e.$5w,c.getIconSchema());const r=new u.$Ch(()=>i.notifySchemaChanged(e.$5w),200);c.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$6w=g("widget-close",N.$Pj.close,(0,S.localize)(2,null)),e.$7w=g("goto-previous-location",N.$Pj.arrowUp,(0,S.localize)(3,null)),e.$8w=g("goto-next-location",N.$Pj.arrowDown,(0,S.localize)(4,null)),e.$9w=R.ThemeIcon.modify(N.$Pj.sync,"spin"),e.$0w=R.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,54,5,12]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=S,e.$8v=C,e.$9v=$,e.$$v=k,e.$aw=v,e.$bw=c,e.$5v=(0,R.$qi)("tunnelService"),e.$6v=(0,R.$qi)("sharedTunnelsService");var w;(function(n){n.Http="http",n.Https="https"})(w||(e.TunnelProtocol=w={}));var b;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(b||(e.TunnelPrivacyId=b={}));function S(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function C(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=C(N.URI.parse(s));if(t)return t}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(n){return e.$0v.indexOf(n)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$_v.indexOf(n)>=0}function c(n,i,r,s){if(r===1)return!1;if(r===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class g{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this.b=s,this.a=new u.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=g;let o=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$be,this.onTunnelOpened=this.a.event,this.b=new u.$be,this.onTunnelClosed=this.b.event,this.c=new u.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const d=await f.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,s,t,f){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(v(i)||k(i))&&(i=e.$0v[0]);const s=this.s(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,f,d=!1,l,a){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(h,r,s,t,f,d,l,a);return m?m.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.o(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&D.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this.e.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:s})}async r(i,r){const s=this.e.get(i);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this.e.delete(i)}}s(i,r){const s=[i];k(i)?(s.push(...e.$0v),s.push(...e.$_v)):v(i)&&s.push(...e.$_v);const t=s.map(f=>this.e.get(f));for(const f of t){const d=f?.get(r);if(d)return d}}canTunnel(i){return!!C(i)}u(i,r,s,t,f,d,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const a=s;this.j.add(a);const h=t===void 0?s:t,m={elevationRequired:f?this.isPortPrivileged(h):!1},D={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==b.Private:void 0,protocol:l},p=i.forwardPort(D,m);return p?(this.q(r,s,p),p.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(a)})):this.j.delete(a),p}};e.$dw=o,e.$dw=o=Je([qe(0,M.$Wj),qe(1,L.$Wi)],o)}),define(ke[276],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0,e.$ul=(0,u.$qi)("IUriIdentityService")}),define(ke[277],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,u.$qi)("editSessionIdentityService");var N;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[278],Ee([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=N,e.$nM=L,e.$oM=R,e.$pM=M,e.$qM=w;function N(b){return b.scheme!==u.Schemas.file&&b.scheme!==u.Schemas.vscodeRemote}function L(b){if(b.folders.length)return b.folders.every(S=>N(S.uri))?b.folders[0].uri:void 0;if(b.configuration&&N(b.configuration))return b.configuration}function R(b){return L(b)?.scheme}function M(b){return L(b)?.authority}function w(b){return L(b)!==void 0}}),define(ke[41],Ee([1,0,217,17,77,23,2,5,15]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=S,e.$Bi=A,e.$Ei=C,e.$Fi=$,e.$Gi=k,e.$Hi=c,e.$Ii=g,e.$Li=i,e.$Qi=r,e.$Ri=s,e.$Ti=t,e.$Ui=f,e.$Vi=d,e.$zi=(0,w.$qi)("contextService");function S(l){const a=l;return typeof a?.id=="string"&&M.URI.isUri(a.uri)}function A(l){return typeof l?.id=="string"&&!S(l)&&!$(l)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function C(l,a){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,N.$oc)(l)}:a?e.$Ci:e.$Di;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function $(l){const a=l;return typeof a?.id=="string"&&M.URI.isUri(a.configPath)}function k(l){const a=l;if(a?.uri)return{id:a.id,uri:M.URI.revive(a.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}var v;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function c(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function g(l){const a=l;return!!(a&&typeof a=="object"&&M.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class o{constructor(a,h,m,D,p){this.h=a,this.j=m,this.k=D,this.l=p,this.c=L.$wi.forUris(this.l,()=>!0),this.folders=h}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=L.$wi.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=o;class n{constructor(a,h){this.raw=h,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.$4g)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=n;function i(l){return new n({uri:l,index:0,name:(0,R.$Zg)(l)},{uri:l.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,u.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function r(l,a){return R.$Ug.isEqualOrParent(l,a.untitledWorkspacesHome)}function s(l){let a;return M.URI.isUri(l)?a=l:a=l.configuration,a?.scheme===b.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Si}function f(l,a){return!r(l,a)&&!s(l)}function d(l){return(typeof l=="string"?(0,N.$pc)(l):(0,R.$2g)(l))===e.$Ni}}),define(ke[279],Ee([1,0,56,4,3,23,2,216,136,32,5,12,41,27,276,8,30,14,18]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$wl=e.ProfileResourceType=void 0,e.$vl=r,e.$xl=s,e.$yl=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&M.URI.isUri(a.location)&&M.URI.isUri(a.globalStorageHome)&&M.URI.isUri(a.settingsResource)&&M.URI.isUri(a.keybindingsResource)&&M.URI.isUri(a.tasksResource)&&M.URI.isUri(a.snippetsHome)&&M.URI.isUri(a.extensionsResource))}e.$wl=(0,A.$qi)("IUserDataProfilesService");function s(l,a){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:M.URI.revive(l.location).with({scheme:a}),globalStorageHome:M.URI.revive(l.globalStorageHome).with({scheme:a}),settingsResource:M.URI.revive(l.settingsResource).with({scheme:a}),keybindingsResource:M.URI.revive(l.keybindingsResource).with({scheme:a}),tasksResource:M.URI.revive(l.tasksResource).with({scheme:a}),snippetsHome:M.URI.revive(l.snippetsHome).with({scheme:a}),extensionsResource:M.URI.revive(l.extensionsResource).with({scheme:a}),cacheHome:M.URI.revive(l.cacheHome).with({scheme:a}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,a,h,m,D,p){return{id:l,name:a,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:p&&D?.useDefaultFlags?.globalState?p.globalStorageHome:(0,R.$4g)(h,"globalStorage"),settingsResource:p&&D?.useDefaultFlags?.settings?p.settingsResource:(0,R.$4g)(h,"settings.json"),keybindingsResource:p&&D?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,R.$4g)(h,"keybindings.json"),tasksResource:p&&D?.useDefaultFlags?.tasks?p.tasksResource:(0,R.$4g)(h,"tasks.json"),snippetsHome:p&&D?.useDefaultFlags?.snippets?p.snippetsHome:(0,R.$4g)(h,"snippets"),extensionsResource:p&&D?.useDefaultFlags?.extensions?p.extensionsResource:(0,R.$4g)(h,"extensions.json"),cacheHome:(0,R.$4g)(m,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let f=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,h,m,D){super(),this.t=a,this.u=h,this.w=m,this.y=D,this.f=!0,this.h=this.B(new N.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$4g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$4g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),h=[a];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,n.$4f)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}h.push(t((0,R.$1g)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},a))}}catch(p){this.y.error(p)}const m=new k.$Bc,D=new Map;if(h.length)try{const p=this.Q();if(p.workspaces)for(const[E,y]of Object.entries(p.workspaces)){const P=M.URI.parse(E),I=h.find(j=>j.id===y);I&&m.set(P,I)}if(p.emptyWindows)for(const[E,y]of Object.entries(p.emptyWindows)){const P=h.find(I=>I.id===y);P&&D.set(E,P)}}catch(p){this.y.error(p)}this.z={profiles:h,workspaces:m,emptyWindows:D}}return this.z}D(){const a=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const h="Temp",m=new RegExp(`${(0,o.$8e)(h)}\\s(\\d+)`);let D=0;for(const E of this.profiles){const y=m.exec(E.name),P=y?parseInt(y[1]):0;D=P>D?P:D}const p=`${h} ${D+1}`;return this.createProfile((0,u.$ej)((0,g.$Mg)()).toString(16),p,{transient:!0},a)}async createNamedProfile(a,h,m){return this.createProfile((0,u.$ej)((0,g.$Mg)()).toString(16),a,h,m)}async createProfile(a,h,m,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(a,h,m);return D&&await this.setProfileForWorkspace(D,p),p}async F(a,h,m){if(!(0,n.$4f)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{if(this.profiles.find(P=>P.name===h||P.id===a))throw new Error(`Profile with ${h} name already exists`);const E=t(a,h,(0,R.$4g)(this.profilesHome,a),this.g,m,this.defaultProfile);await this.u.createFolder(E.location);const y=[];return this.j.fire({profile:E,join(P){y.push(P)}}),await c.Promises.settled(y),this.I([E],[],[]),E}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(D=>D.id===a.id);if(!m)throw new Error(`Profile '${a.name}' does not exist`);return m=t(m.id,h.name??m.name,m.location,this.g,{shortName:h.shortName??m.shortName,icon:h.icon===null?void 0:h.icon??m.icon,transient:h.transient??m.isTransient,useDefaultFlags:h.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.I([],[],[m]),m}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===a.id);if(!h)throw new Error(`Profile '${a.name}' does not exist`);const m=[];this.m.fire({profile:h,join(D){m.push(D)}});try{await Promise.allSettled(m)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,S.$bl)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(D=>D.id===h.id);if(!m)throw new Error(`Profile '${h.name}' does not exist`);this.L(a,m)}unsetWorkspace(a,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(h=>h.isDirectory&&this.profiles.every(m=>!this.w.extUri.isEqual(m.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(a.map(h=>this.removeProfile(h)))}getProfileForWorkspace(a){const h=this.G(a);return M.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(a){return(0,$.$Ai)(a)?a.uri:(0,$.$Fi)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,a.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,a.location)))}I(a,h,m){const D=[...this.profiles,...a],p=[];this.s.profiles=[];for(let E of D)E.isDefault||h.some(y=>E.id===y.id)||(E=m.find(y=>E.id===y.id)??E,E.isTransient?this.s.profiles.push(E):p.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(p),this.z=void 0,this.J(a,h,m)}J(a,h,m){this.h.fire({added:a,removed:h,updated:m,all:this.profiles})}L(a,h,m){m=h?.isTransient?!0:m,m||this.L(a,void 0,!0);const D=this.G(a),p=m?this.s:this.C;M.URI.isUri(D)?(p.workspaces.delete(D),h&&p.workspaces.set(D,h)):(p.emptyWindows.delete(D),h&&p.emptyWindows.set(D,h)),m||this.M()}M(){const a={};for(const[m,D]of this.C.workspaces.entries())a[m.toString()]=D.id;const h={};for(const[m,D]of this.C.emptyWindows.entries())h[m.toString()]=D.id;this.R({workspaces:a,emptyWindows:h}),this.z=void 0}N(a){const h={},m=this.D();if(a.workspaces)for(const[p,E]of Object.entries(a.workspaces)){const y=M.URI.parse(E);h[p]=this.w.extUri.isEqual(y,m.location)?m.id:this.w.extUri.basename(y)}const D={};if(a.emptyWindows)for(const[p,E]of Object.entries(a.emptyWindows)){const y=M.URI.parse(E);D[p]=this.w.extUri.isEqual(y,m.location)?m.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$zl=f,e.$zl=f=Je([qe(0,b.$xi),qe(1,S.$Wk),qe(2,v.$ul),qe(3,C.$Wj)],f);class d extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Al=d}),define(ke[280],Ee([1,0,8,4,3,59,18,195,5,279]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Up=e.$Tp=e.$Sp=void 0,e.$Vp=k,e.$Xp=c,e.$Zp=o,e.$Sp="__$__isNewStorageMarker",e.$Tp="__$__targetStorageMarker",e.$Up=(0,b.$qi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var $;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function k(n){const i=n.get(e.$Tp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new N.$ee),this.c=this.B(new N.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$be),this.onWillSaveState=this.f.event,this.h=this.B(new u.$Ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,s){return N.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,u.$Gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:s,external:t}=r;if(s===e.$Tp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,r,s){return this.P(r)?.get(i,s)}getBoolean(i,r,s){return this.P(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.P(r)?.getNumber(i,s)}getObject(i,r,s){return this.P(r)?.getObject(i,s)}storeAll(i,r){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,f=!1){if((0,M.$ag)(r)){this.remove(i,s,f);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,r,f)})}remove(i,r,s=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const s=[],t=this.J(i);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}z(i,r,s,t=!1){const f=this.J(r);typeof s=="number"?f[i]!==s&&(f[i]=s,this.P(r)?.set(e.$Tp,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.P(r)?.set(e.$Tp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?k(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Sp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(A.NONE),(0,S.$vl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||c(r)&&c(i))}N(i,r,s){this.y(()=>{const t=new Set;for(const[f,d]of i)t.add(f),r.get(f)!==d&&this.u(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(s,{key:f,external:!0})})}}e.$Wp=v;function c(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class g extends v{constructor(){super(),this.U=this.B(new w.$Qp(new w.$Rp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$Qp(new w.$Rp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$Qp(new w.$Rp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Yp=g;async function o(n,i,r,s,t,f){const d=P=>{try{return JSON.parse(P)}catch{return P}},l=new Map,a=new Map;n.forEach((P,I)=>{l.set(I,P),a.set(I,d(P))});const h=new Map,m=new Map;i.forEach((P,I)=>{h.set(I,P),m.set(I,d(P))});const D=new Map,p=new Map;r.forEach((P,I)=>{D.set(I,P),p.set(I,d(P))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const E=[];if(l.forEach((P,I)=>{E.push({key:I,value:P})}),console.table(E),console.groupEnd(),console.log(a),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];h.forEach((I,j)=>{P.push({key:j,value:I})}),console.table(P),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${f})`);const y=[];D.forEach((P,I)=>{y.push({key:I,value:P})}),console.table(y),console.groupEnd(),console.log(p)}}),define(ke[111],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;class u{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1jc=u}),define(ke[60],Ee([1,0,15,23,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0;class R{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new N.$Sg(w=>{const b=this.b.get(w.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(w,b){b===null?this.b.delete(w.scheme):this.b.set(w.scheme,b)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$6jc=R,e.$7jc=(0,L.$qi)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0,e.$qP=(0,u.$qi)("IExtHostInitDataService")}),define(ke[281],Ee([1,0,223,12,261,28]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;let M=class extends L.$yQ{constructor(b,S,A){const C=A.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",$=A.remote.isRemote?(0,u.localize)(0,null):b?(0,u.localize)(1,null):(0,u.localize)(2,null);super(S.createLogger(C,{name:$}))}};e.$amc=M,e.$amc=M=Je([qe(1,N.$Xj),qe(2,R.$qP)],M)}),define(ke[282],Ee([1,0,8]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=e.$Lkc=void 0;class N{constructor(M,w,b){this.h=new Map,this.a=M,this.b=w,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new u.$Ch(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of S.values())A.complete()}catch(A){for(const C of S.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,w){let b=this.f[M];return typeof b>"u"&&(b=w),b}update(M,w){this.f[M]=w;const b=this.h.get(M);if(b!==void 0)return b.p;const S=new u.$Nh;return this.h.set(M,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$Lkc=N;class L extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,w){super(M.identifier.value,!0,w),this.j=M}}e.$Mkc=L}),define(ke[283],Ee([1,0,4,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class L{constructor(M){this.c=M,this.a=new u.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,w,b,S){const C=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(w.value,b,S);this.b.fire(C)}$acceptDirtyStateChanged(M,w){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(w)}$acceptModelSaved(M){const w=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(w.apiNotebook)}}e.$Alc=L}),define(ke[20],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0,e.$aP=(0,u.$qi)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$bP=N}),define(ke[284],Ee([1,0,25,4]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class L{#e;constructor(M,w){this.b=new N.$be,this.onDidChange=this.b.event,this.a=u.$Lm.toKey(M.identifier),this.#e=w,this.#e.onDidChangePassword(b=>{b.extensionId===this.a&&this.b.fire({key:b.key})})}get(M){return this.#e.get(this.a,M)}store(M,w){return this.#e.store(this.a,M,w)}delete(M){return this.#e.delete(this.a,M)}}e.$Vkc=L}),define(ke[67],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=void 0,e.$jkc=(0,u.$qi)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$kkc=N}),define(ke[285],Ee([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnb=L,e.$Ynb=M;class N{constructor(){this.buffers=[]}add(b){let S=this.buffers.indexOf(b);return S<0&&(S=this.buffers.length,this.buffers.push(b)),S}}function L(w,b){if(b.serializeBuffersForPostMessage){const S=new N,C=JSON.stringify(w,(k,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v)};if(ArrayBuffer.isView(v)){const c=R(v);if(c)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v.buffer),view:{type:c,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),$=S.buffers.map(k=>{const v=new Uint8Array(k);return u.$Ce.wrap(v)});return{message:C,buffers:$}}else return{message:JSON.stringify(w),buffers:[]}}function R(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(w,b){const S=b.map($=>{const k=new ArrayBuffer($.byteLength);return new Uint8Array(k).set($.buffer),k}),A=b.length?($,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const v=k,{index:c}=v,g=S[c];if(v.view)switch(v.view.type){case 1:return new Int8Array(g,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return k}:void 0;return{message:JSON.parse(w,A),arrayBuffers:S}}}),define(ke[286],Ee([1,0,287,399,400,63,2,12,401]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=A;const S=!1;function A(i,r,s,t,f,d){const l=d.environment.useHostProxy,a=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:p=>i.resolveProxy(p),lookupProxyAuthorization:g.bind(void 0,t,f,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(r),addCertificatesV2:()=>k(r),log:t,getLogLevel:()=>{const p=t.getLevel();switch(p){case w.LogLevel.Trace:return b.LogLevel.Trace;case w.LogLevel.Debug:return b.LogLevel.Debug;case w.LogLevel.Info:return b.LogLevel.Info;case w.LogLevel.Warning:return b.LogLevel.Warning;case w.LogLevel.Error:return b.LogLevel.Error;case w.LogLevel.Off:return b.LogLevel.Off;default:return E(p)}function E(y){return t.error("Unknown log level",y),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const p=[];if(d.remote.isRemote&&p.push((0,b.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const E=i.loadCertificates();E.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),p.push(E)}return(await Promise.all(p)).flat()},env:process.env},m=(0,b.createProxyResolver)(h),D=C(h,m);return c(s,D)}function C(i,r){return{http:Object.assign(u,(0,b.createHttpPatch)(i,u,r)),https:Object.assign(N,(0,b.createHttpPatch)(i,N,r)),net:Object.assign(R,(0,b.createNetPatch)(i,R)),tls:Object.assign(L,(0,b.createTlsPatch)(i,L))}}function $(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}function k(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}const v=new Map;function c(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(l,a,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return f.apply(this,arguments);const m=s.findSubstr(M.URI.file(a.filename));let D=v.get(m);if(D||v.set(m,D={}),!D[l]){const p=r[l];D[l]={...p}}return D[l]}})}async function g(i,r,s,t,f,d,l,a){const h=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const m=l||h,D=Array.isArray(m)?m:typeof m=="string"?[m]:[];if(n(r,D,f),D.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const p=await new Promise((j,F)=>{le(["kerberos"],j,F)}),E=new URL(d),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${E.hostname}`:`HTTP@${E.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${y}`),"Negotiate "+await(await p.initializeClient(y)).step("")}catch(p){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let o=!1;function n(i,r,s){o||!r.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[288],Ee([1,0,133]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=L;function N(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(R){return new u.$sn(N(R))}}),define(ke[142],Ee([1,0,233,18,2,3,5,38,32,15,47,187,40]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$BF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$sF=e.EditorInputCapabilities=e.$rF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0,e.$iF=c,e.$jF=g,e.$kF=o,e.$lF=n,e.$mF=i,e.$nF=r,e.$oF=s,e.$pF=t,e.$qF=f,e.$tF=D,e.$uF=E,e.$vF=y,e.$wF=P,e.$xF=I,e.$yF=j,e.$zF=F,e.$AF=X,e.$CF=Y,e.$DF=ne,e.$EF=$e,e.$FF=Pe,e.$dF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$eF={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$fF="workbench.editor.sidebysideEditor",e.$gF="workbench.editors.textDiffEditor",e.$hF="workbench.editors.binaryResourceDiffEditor";var k;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var v;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function c(_){const U=_;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function g(_){const U=_;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function o(_,U,ie){for(const be of ie.visibleEditorPanes)if(be.group.id===U&&_.matches(be.input))return be.getViewState()}function n(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.resource)}function i(_){if(D(_))return!1;const U=_;return U?.original!==void 0&&U.modified!==void 0}function r(_){if(D(_))return!1;const U=_;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(_){if(D(_)||i(_))return!1;const U=_;return U?.primary!==void 0&&U.secondary!==void 0}function t(_){if(D(_))return!1;const U=_;return U?U.resource===void 0||U.resource.scheme===S.Schemas.untitled||U.forceUntitled===!0:!1}function f(_){if(D(_))return!1;const U=_;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var d;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class a{constructor(){this.a=new Map}registerSource(U,ie){let be=this.a.get(U);return be||(be={source:U,label:ie},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$rF=new a;var h;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class m extends R.$Uc{}e.$sF=m;function D(_){return _ instanceof m}function p(_){const U=_;return L.URI.isUri(U?.preferredResource)}function E(_){const U=_;return D(U?.primary)&&D(U?.secondary)}function y(_){const U=_;return D(U?.modified)&&D(U?.original)}function P(_,U,ie,be,Ce){return Pe(be,[(0,C.$aj)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const oe={...ie,limits:{size:Number.MAX_VALUE}};_.openEditor(U,oe)}}),(0,C.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function I(_){return D(_?.editor)}function j(_){const U=_;return I(_)&&U?.group!==void 0}function F(_){const U=_;return typeof U?.groupId=="number"&&D(U.editor)}var z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var O;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var T;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class B{getOriginalUri(U,ie){if(!U)return;if(f(U))return e.$BF.getOriginalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Ce,secondary:oe}=this.a(U);if(Ce&&oe){if(ie?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===T.ANY)return this.getOriginalUri(Ce,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(oe,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===T.PRIMARY?Ce:oe}}if(i(U)||r(U)||s(U)||f(U))return;const be=p(U)?U.preferredResource:U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}a(U){return E(U)||s(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ie){if(!U)return;if(f(U))return e.$BF.getCanonicalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Ce,secondary:oe}=this.a(U);if(Ce&&oe){if(ie?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===T.ANY)return this.getCanonicalUri(Ce,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(oe,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===T.PRIMARY?Ce:oe}}if(i(U)||r(U)||s(U)||f(U))return;const be=U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}b(U,ie){if(Array.isArray(ie)){if(ie.some(be=>U.scheme===be))return U}else if(ie===U.scheme)return U}}var W;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function X(_,U,ie,be){if(!_.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ie===W.MOUSE||ie===W.KEYBOARD;case"mouse":return ie===W.MOUSE;case"keyboard":return ie===W.KEYBOARD}return!1}e.$BF=new B;var x;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(U){const ie=this.a=U.get(M.$pi);for(const[be,Ce]of this.c)this.e(be,Ce,ie);this.c.clear()}e(U,ie,be){const Ce=be.createInstance(ie);this.d.set(U,Ce)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$cg)(this.b)}registerEditorSerializer(U,ie){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ie,this.a):this.c.set(U,ie),(0,R.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}w.$9n.add(e.$dF.EditorFactory,new Z);async function Y(_,U,ie){return!_||!_.length?[]:await Promise.all(_.map(async be=>{const Ce=L.URI.revive(be.fileUri);if(!Ce){ie.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(Ce)){ie.info("Cannot resolve the path because it cannot be handled",be);return}let ae=be.exists,re=be.type;if(typeof ae!="boolean"||typeof re!="number")try{re=(await U.stat(Ce)).isDirectory?b.FileType.Directory:b.FileType.Unknown,ae=!0}catch(te){ie.error(te),ae=!1}if(!ae&&be.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",be);return}if(re===b.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",be);return}const G={...be.options,pinned:!0};return ae?{resource:Ce,options:G}:{resource:Ce,options:G,forceUntitled:!0}}))}var ce;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function ne(_){const U=_;if(!U)return!1;const ie=U;if(ie.modified)return ne(ie.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function $e(_){return(0,A.$cj)(_)}function Pe(_,U,ie){const be=(0,A.$dj)(_,U);return be.forceMessage=ie?.forceMessage,be.forceSeverity=ie?.forceSeverity,be.allowDialog=ie?.allowDialog,be}}),define(ke[289],Ee([1,0,4,234,5,3,27,38,19,24,78,275]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$LF=e.ViewContentGroups=e.$JF=e.ViewContainerLocation=e.Extensions=e.$IF=e.$HF=e.$GF=void 0,e.$KF=v,e.$GF="views",e.$HF=(0,N.localize)(0,null),e.$IF=(0,C.$3w)("default-view-icon",A.$Pj.window,(0,N.localize)(1,null));var $;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var k;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(k||(e.ViewContainerLocation=k={})),e.$JF=[0,1,2];function v(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class c extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onDidRegister=this.c.event,this.f=this.B(new u.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,b.$Rb)([...this.g.values()])}registerViewContainer(d,l,a){const h=this.get(d.id);if(h)return h;const m=d;return m.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,M.$yc)(this.g,l,[]).push(m),a?.isDefault&&this.h.push(m),this.c.fire({viewContainer:m,viewContainerLocation:l}),m}deregisterViewContainer(d){for(const l of this.g.keys()){const a=this.g.get(l),h=a?.indexOf(d);if(h!==-1){a?.splice(h,1),a.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(a=>a?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}w.$9n.add($.ViewContainersRegistry,new c);var g;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(g||(e.ViewContentGroups=g={}));function o(f,d){const l=f.group??g.More,a=d.group??g.More;return l!==a?l.localeCompare(a):(f.order??5)-(d.order??5)}class n extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:a})=>this.r(l,a)),this.c.fire(d)}deregisterViews(d,l){const a=this.s(d,l);a.length&&this.f.fire({views:a,viewContainer:l})}moveViews(d,l){for(const a of this.m.keys())if(a!==l){const h=this.s(d,a);h.length&&(this.r(h,l),this.g.fire({views:h,from:a,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const a=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(a)return a}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,R.$Sc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const a=new Map;for(const[h,m]of l)this.n.add(d,m),a.set(h,(0,R.$Sc)(()=>{this.n.delete(d,m),this.h.fire(d)}));return this.h.fire(d),a}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,a=>l.push(a)),l.sort(o)}r(d,l){let a=this.m.get(l);a||(a=[],this.m.set(l,a),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,N.localize)(2,null,h.id));a.push(h)}}s(d,l){const a=this.m.get(l);if(!a)return[];const h=[],m=[];for(const D of a)d.includes(D)?h.push(D):m.push(D);return h.length&&(m.length?this.m.set(l,m):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}w.$9n.add($.ViewsRegistry,new n),e.$LF=(0,L.$qi)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,l){this.c=!1,this.d=!1,(0,S.$Zn)(this,d),this.d=!!l,this.resolve=async a=>{if(l&&!this.c){const h=await l(a);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$MF=s;class t extends Error{constructor(d){super((0,N.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$NF=t}),define(ke[290],Ee([1,0,235,37]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$RF=new N.$Hj("chatSessionResponseVote","",{type:"string",description:(0,u.localize)(0,null)}),e.$SF=new N.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,u.localize)(1,null)}),e.$TF=new N.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,u.localize)(2,null)}),e.$UF=new N.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,u.localize)(3,null)}),e.$VF=new N.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,u.localize)(4,null)}),e.$WF=new N.$Hj("chatResponse",!1,{type:"boolean",description:(0,u.localize)(5,null)}),e.$XF=new N.$Hj("chatRequest",!1,{type:"boolean",description:(0,u.localize)(6,null)}),e.$YF=new N.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,u.localize)(7,null)}),e.$ZF=new N.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,u.localize)(8,null)}),e.$1F=new N.$Hj("inChatInput",!1,{type:"boolean",description:(0,u.localize)(9,null)}),e.$2F=new N.$Hj("inChat",!1,{type:"boolean",description:(0,u.localize)(10,null)}),e.$3F=new N.$Hj("hasChatProvider",!1,{type:"boolean",description:(0,u.localize)(11,null)}),e.$4F=new N.$Hj("chatCursorAtTop",!1),e.$5F=new N.$Hj("chatInputHasAgent",!1),e.$6F=new N.$Hj("chatLocation",void 0)}),define(ke[291],Ee([1,0,4,45,3,37,5,290]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var b;(function(C){C.Panel="panel",C.Terminal="terminal",C.Notebook="notebook",C.Editor="editor"})(b||(e.ChatAgentLocation=b={})),function(C){function $(k){switch(k){case"panel":return C.Panel;case"terminal":return C.Terminal;case"notebook":return C.Notebook;case"editor":return C.Editor}return C.Panel}C.fromRaw=$}(b||(e.ChatAgentLocation=b={})),e.$3G=(0,M.$qi)("chatAgentService");let S=class{static{this.AGENT_LEADER="@"}constructor($){this.f=$,this.b=[],this.d=new u.$be,this.onDidChangeAgents=this.d.event,this.e=w.$3F.bindTo(this.f)}registerAgent($,k){if(this.getAgent($))throw new Error(`Agent already registered: ${JSON.stringify($)}`);const c=this,g=k.slashCommands;k={...k,get slashCommands(){return g.filter(n=>!n.when||c.f.contextMatchesRules(R.$oj.deserialize(n.when)))}};const o={data:k};return this.b.push(o),(0,L.$Sc)(()=>{this.b=this.b.filter(n=>n!==o),this.d.fire(void 0)})}registerAgentImplementation($,k){const v=this.g($);if(!v)throw new Error(`Unknown agent: ${JSON.stringify($)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify($)}`);return v.data.isDefault&&this.e.set(!0),v.impl=k,this.d.fire(new A(v.data,k)),(0,L.$Sc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent($,k){const v={data:$,impl:k};return this.b.push(v),this.d.fire(new A($,k)),(0,L.$Sc)(()=>{this.b=this.b.filter(c=>c!==v),this.d.fire(void 0)})}updateAgent($,k){const v=this.g($);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify($)} registered`);v.data.metadata={...v.data.metadata,...k},this.d.fire(new A(v.data,v.impl))}getDefaultAgent($){return this.getActivatedAgents().find(k=>!!k.isDefault&&k.locations.includes($))}getContributedDefaultAgent($){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes($))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),$=>!!$.data.metadata.isSecondary)?.data}g($){return this.b.find(k=>k.data.id===$)}getAgent($){return this.g($)?.data}getAgents(){return this.b.map($=>$.data)}getActivatedAgents(){return Array.from(this.b.values()).filter($=>!!$.impl).map($=>new A($.data,$.impl))}getAgentsByName($){return this.getAgents().filter(k=>k.name===$)}async invokeAgent($,k,v,c,g){const o=this.g($);if(!o?.impl)throw new Error(`No activated agent with id ${$}`);return await o.impl.invoke(k,v,c,g)}async getFollowups($,k,v,c,g){const o=this.g($);if(!o?.impl)throw new Error(`No activated agent with id ${$}`);return o.impl?.provideFollowups?o.impl.provideFollowups(k,v,c,g):[]}};e.$4G=S,e.$4G=S=Je([qe(0,R.$Ij)],S);class A{constructor($,k){this.b=$,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke($,k,v,c){return this.d.invoke($,k,v,c)}async provideFollowups($,k,v,c){return this.d.provideFollowups?this.d.provideFollowups($,k,v,c):[]}provideWelcomeMessage($){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage($)}provideSampleQuestions($,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions($,k)}}e.$5G=A}),define(ke[292],Ee([1,0,2,29,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$$F=R,e.$_F=M;function R(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof u.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(N.$kt.isIRange)}function M(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(R)}var w;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var b;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})(b||(e.ChatCopyKind=b={})),e.$aG=(0,L.$qi)("IChatService"),e.$bG="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,8,236]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sob=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new u.$be,this.o=new u.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(w){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=w}onEvent(w){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=w}onRequest(w){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.u("response",w)}sendRequest(w,b,S,A){const C={command:w};if(b&&Object.keys(b).length>0&&(C.arguments=b),this.u("request",C),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const k=this.f.get(C.seq);if(k){this.f.delete(C.seq);const v={type:"response",seq:0,request_seq:C.seq,success:!1,command:w,message:(0,L.localize)(0,null,A,w)};k(v)}},A)}return S&&this.f.set(C.seq,S),C.seq}acceptMessage(w){this.k?this.k(w):(this.m.push(w),this.m.length===1&&this.s())}q(w,b){return w.type!=="event"||b.type!=="event"}async s(){let w;for(;this.m.length;){if((!w||this.q(this.m[0],w))&&await(0,N.$rh)(0),w=this.m.shift(),!w)return;switch(w.type){case"event":this.j?.(w);break;case"request":this.g?.(w);break;case"response":{const b=w,S=this.f.get(b.request_seq);S&&(this.f.delete(b.request_seq),S(b));break}}}}u(w,b){b.type=w,b.seq=this.d++,this.sendMessage(b)}async w(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach((b,S)=>w.set(S,b)),await(0,N.$rh)(500),w.forEach((b,S)=>{b({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$sob=R}),define(ke[293],Ee([1,0,2,237,37,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=b,e.$hJ=A,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new L.$Hj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$dI=new L.$Hj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$eI=new L.$Hj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$fI="debugUx",e.$gI=new L.$Hj(e.$fI,"default",{type:"string",description:N.localize(3,null)}),e.$hI=new L.$Hj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$iI=new L.$Hj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$jI=new L.$Hj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$kI=new L.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$lI=new L.$Hj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$mI=new L.$Hj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$nI=new L.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$oI=new L.$Hj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$pI=new L.$Hj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$qI=new L.$Hj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$rI=new L.$Hj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$sI=new L.$Hj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$tI=new L.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$uI=new L.$Hj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$vI=new L.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$wI=new L.$Hj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$xI=new L.$Hj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$yI=new L.$Hj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$zI=new L.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$AI=new L.$Hj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$BI=new L.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$CI=new L.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$DI=new L.$Hj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$EI=new L.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$FI=new L.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$GI=new L.$Hj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$HI=new L.$Hj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$II=new L.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$JI=new L.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$KI=new L.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$LI=new L.$Hj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$MI=new L.$Hj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$NI=new L.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$OI=new L.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$PI=new L.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$QI=new L.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$RI=new L.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$SI=new L.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$TI=new L.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$UI=new L.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$VI=new L.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$WI=new L.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$XI=new L.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$YI=new L.$Hj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$ZI=new L.$Hj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$1I=new L.$Hj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$2I=new L.$Hj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$3I=new L.$Hj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$4I=new L.$Hj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$5I=new L.$Hj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$6I=new L.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$7I=new L.$Hj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$8I=new L.$Hj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$9I=new L.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$0I=new L.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$$I=new L.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$_I=new L.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var w;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(w||(e.State=w={}));function b(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var S;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$gJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var C;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(C||(e.DataBreakpointSetType=C={}));var $;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var k;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$iJ=(0,R.$qi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var c;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var g;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:u.URI.revive(r.iconPath.light),dark:u.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(n||(e.IDebugVisualization=n={}))}),define(ke[294],Ee([1,0,14,2,17,24,15,29,22,19]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=C,e.$9G=$,e.$0G=k,e.$$G=v,e.$_G=c,e.$aH=g,e.$bH=o,e.$cH=i,e.$dH=t,e.$eH=f,e.$fH=l,e.$gH=h;const A=/{([^}]+)}/g;function C(D,p,E){return D.replace(A,function(y,P){return p&&P.length>0&&P[0]!=="_"?y:E&&E.hasOwnProperty(P)?E[P]:y})}function $(D){const p={};for(const E of Object.keys(D))E.startsWith("!")||(p[E]=D[E]);return p}function k(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||k(D.parentSession))}function v(D){let p=D.configuration.type;if(p)return p==="vslsShare"&&(p=D.configuration.adapterProxy.configuration.type),(0,u.$tf)(p,"extensionhost")||(0,u.$tf)(p,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function c(D){return D.type&&(D.label||D.program||D.runtime)}function g(D,p,E){let y,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=I.exec(D);){const F=j.index+1,z=F+j[0].length;if(F<=p&&z>=E){y=j[0],P=F;break}}if(y){const F=/\w+/g;let z=null;for(;(z=F.exec(y))&&!(z.index+1+P+z[0].length>=E););z&&(y=y.substring(0,F.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}async function o(D,p,E,y){if(D.evaluatableExpressionProvider.has(p)){const P=D.evaluatableExpressionProvider.ordered(p),I=(0,S.$Hb)(await Promise.all(P.map(async j=>{try{return await j.provideEvaluatableExpression(p,E,y??b.CancellationToken.None)}catch{return}})));if(I.length>0){let j=I[0].expression;const F=I[0].range;return j||(j=p.getLineContent(E.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:j}}}else{const P=p.getLineContent(E.lineNumber),{start:I,end:j}=g(P,E.column,E.column),F=P.substring(I-1,j);return{matchingExpression:F,range:new w.$kt(E.lineNumber,I,E.lineNumber,I+F.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,L.$jc)(D.path))return N.URI.file(D.path)}return D.path}function s(D){if(typeof D.path=="object"){const p=N.URI.revive(D.path);if(p)return p.scheme===M.Schemas.file?p.fsPath:p.toString()}return D.path}function t(D,p){const E=p?r:s,y=(0,R.$Wn)(D);return d(y,(P,I)=>{P&&I&&(I.path=E(I))}),y}function f(D,p){const E=p?r:s,y=(0,R.$Wn)(D);return d(y,(P,I)=>{!P&&I&&(I.path=E(I))}),y}function d(D,p){switch(D.type){case"event":{const E=D;switch(E.event){case"output":p(!1,E.body.source);break;case"loadedSource":p(!1,E.body.source);break;case"breakpoint":p(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=D;switch(E.command){case"setBreakpoints":p(!0,E.arguments.source);break;case"breakpointLocations":p(!0,E.arguments.source);break;case"source":p(!0,E.arguments.source);break;case"gotoTargets":p(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(y=>p(!1,y));break;default:break}break}case"response":{const E=D;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(y=>p(!1,y.source));break;case"loadedSources":E.body.sources.forEach(y=>p(!1,y));break;case"scopes":E.body.scopes.forEach(y=>p(!1,y.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(y=>p(!1,y.source));break;case"setBreakpoints":E.body.breakpoints.forEach(y=>p(!1,y.source));break;case"disassemble":E.body?.instructions.forEach(P=>p(!1,P.location));break;default:break}break}}}function l(D){return D.filter(p=>!p.presentation?.hidden).sort((p,E)=>p.presentation?E.presentation?p.presentation.group?E.presentation.group?p.presentation.group!==E.presentation.group?p.presentation.group.localeCompare(E.presentation.group):a(p.presentation.order,E.presentation.order):-1:E.presentation.group?1:a(p.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function a(D,p){return typeof D!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:D-p}async function h(D,p){const E=D.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(E!=="none"&&(await p.saveAll(),E==="allEditorsInActiveGroup")){const y=p.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await p.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const m=(D,p)=>!D||!p?D===p:D.name===p.name&&D.path===p.path&&D.sourceReference===p.sourceReference;e.$hH=m}),define(ke[295],Ee([1,0,53,63,24,17,11,14,31,238,143]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=e.$jmc=e.$imc=e.$hmc=e.$gmc=void 0;class C extends A.$sob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${C.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(C.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(C.b);for(const s of r){const t=s.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+C.a.length);continue}}break}}}e.$gmc=C;class $ extends C{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$hmc=$;class k extends ${constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$imc=k;class v extends ${constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.path,o)}}e.$jmc=v;class c extends C{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(R.$jc(o)){if(!await b.Promises.exists(o))throw new Error(S.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=L.$Zn(L.$Wn(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=u.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(S.localize(2,null,n[0]));this.x=f}else throw new Error(S.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.x=u.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((o,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=R.$kc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(R.$jc(o.program)?i.program=o.program:i.program=R.$kc(n,o.program)),o.args&&(i.args=o.args);const r=o;return r.win&&(i.win=c.A(r.win,n)),r.winx86&&(i.winx86=c.A(r.winx86,n)),r.windows&&(i.windows=c.A(r.windows,n)),r.osx&&(i.osx=c.A(r.osx,n)),r.linux&&(i.linux=c.A(r.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(h=>typeof h.type=="string"&&w.$tf(h.type,n)).forEach(h=>{const m=c.A(h,l.extensionLocation.fsPath);i=L.$Zn(i,m,l.isBuiltin)})}let r;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:M.$i?r=i.win||i.windows:M.$j?r=i.osx:M.$k&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,d=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$kmc=c}),define(ke[296],Ee([1,0,53,34,11]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=M,e.$mmc=b;function R(S,A){return new Promise((C,$)=>{let k="";const v=u.spawn(S,A);v.pid&&v.stdout.on("data",c=>{k+=c.toString()}),v.on("error",c=>{$(c)}),v.on("close",c=>{C(k)})})}async function M(S){if(S)if(L.$i){const A=await new Promise((C,$)=>{le(["@vscode/windows-process-tree"],C,$)});return new Promise(C=>{A.getProcessTree(S,$=>{C(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(S)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var w;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(w||(w={}));function b(S,A,C,$){S=S.trim().toLowerCase();let k;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?k=1:S.indexOf("cmd.exe")>=0?k=0:S.indexOf("bash")>=0?k=2:L.$i?k=0:k=2;let v,c=" ";switch(k){case 1:if(v=g=>(g=g.replace(/\'/g,"''"),g.length>0&&g.charAt(g.length-1)==="\\"?`'${g}\\'`:`'${g}'`),$){const g=(0,N.$vg)($);g&&(c+=`${g}:; `),c+=`cd ${v($)}; `}if(A.length>0){const g=A.shift(),o=C?g:v(g);c+=o[0]==="'"?`& ${o} `:`${o} `;for(const n of A)c+=n==="<"||n===">"||C?n:v(n),c+=" "}break;case 0:if(v=g=>(g=g.replace(/\"/g,'""'),g=g.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>g.includes(o))||g.length===0?`"${g}"`:g),$){const g=(0,N.$vg)($);g&&(c+=`${g}: && `),c+=`cd ${v($)} && `}for(const g of A)c+=g==="<"||g===">"||C?g:v(g),c+=" ";break;case 2:{v=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),g.length===0?'""':g),$&&(c+=`cd ${v($)} ; `);for(const g of A)c+=g==="<"||g===">"||C?g:v(g),c+=" ";break}}return c}}),define(ke[297],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var N;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vK=(0,u.$qi)("INotebookExecutionService")}),define(ke[298],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mib=e.$lib=e.ProxyKernelState=e.$kib=void 0,e.$kib=100;var N;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$lib=(0,u.$qi)("INotebookKernelService"),e.$mib=(0,u.$qi)("INotebookKernelHistoryService")}),define(ke[299],Ee([1,0,3,29,200,100]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Vb=void 0;class M extends u.$Uc{constructor(b,S,A){super(),this._source=b,this.b=S,this.c=A,this.a=void 0}f(b){const S=b.getLineCount();return new N.$kt(1,1,S,this.g(b,S))}g(b,S){if(S<1||S>b.getLineCount())throw new Error("Illegal value for lineNumber");return b.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const b=new L.$MC;b.acceptChunk(this._source);const S=b.finish(!0),{textBuffer:A,disposable:C}=S.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(b=>{const S=new L.$MC;S.acceptChunk(b);const A=S.finish(!0),{textBuffer:C,disposable:$}=A.create(1);return this.B($),C})),this.a}findInInputs(b){const A=new R.$AC(b,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs(b){const A=new R.$AC(b,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const $=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if($.length!==0)return{textBuffer:C,matches:$}}).filter(C=>!!C):[]}}e.$_Vb=M}),define(ke[68],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(R){R.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class L{static fromExtHostTestItem(M,w,b=M.parent){if(M._isRoot)return new L([w]);const S=[M.id];for(let A=b;A&&A.id!==w;A=A.parent)S.push(A.id);return S.push(w),new L(S.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const w=M.indexOf("\0");return w===-1?M:M.slice(0,w)}static fromString(M){return new L(M.split("\0"))}static join(M,w){return new L([...M.path,w])}static joinToString(M,w){return M.toString()+"\0"+w}static parentId(M){const w=M.lastIndexOf("\0");return w===-1?void 0:M.slice(0,w)}static localId(M){const w=M.lastIndexOf("\0");return w===-1?M:M.slice(w+1)}static isChild(M,w){return w.startsWith(M)&&w[M.length]==="\0"}static compare(M,w){return M===w?0:L.isChild(M,w)?2:L.isChild(w,M)?3:1}constructor(M,w=M.length){if(this.path=M,this.d=w,M.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let w=0;w<M.d&&w<this.d;w++)if(M.path[w]!==this.path[w])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=L}),define(ke[89],Ee([1,0,2,50,29,68]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var w;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var b;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$DL=[2,4,8,16,32,64];const S=O=>"runId"in O;e.$EL=S;var A;(function(O){O.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({range:L.$kt.lift(B.range),uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var C;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(C||(e.TestMessageType=C={}));var $;(function(O){O.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(T,B.location)})})($||(e.ITestErrorMessage=$={}));const k=(O,T)=>`${T?"s":"e"}${O}`;e.$FL=k;var v;(function(O){O.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(T,B.location)})})(v||(e.ITestOutputMessage=v={}));var c;(function(O){O.serialize=T=>T.type===0?$.serialize(T):v.serialize(T),O.deserialize=(T,B)=>B.type===0?$.deserialize(T,B):v.deserialize(T,B)})(c||(e.ITestMessage=c={}));var g;(function(O){O.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),O.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(c.serialize)}),O.deserialize=(T,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>c.deserialize(T,W))})})(g||(e.ITestTaskState=g={}));const o="\0",n=(O,T)=>O+o+T;e.$GL=n;const i=O=>{const T=O.indexOf(o);return{ctrlId:O.slice(0,T),tagId:O.slice(T+1)}};e.$HL=i;var r;(function(O){O.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),O.deserialize=(T,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?T.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?L.$kt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(O){O.serialize=T=>({expand:T.expand,item:r.serialize(T.item)}),O.deserialize=(T,B)=>({controllerId:R.$BL.root(B.item.extId),expand:B.expand,item:r.deserialize(T,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(O){O.serialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.uri!==void 0&&(B.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(B.range=T.item.range?.toJSON()),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}},O.deserialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.range!==void 0&&(B.range=T.item.range?L.$kt.lift(T.item.range):null),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const d=(O,T)=>{T.expand!==void 0&&(O.expand=T.expand),T.item!==void 0&&(O.item=O.item?Object.assign(O.item,T.item):T.item)};e.$IL=d;var l;(function(O){O.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(g.serializeWithoutMessages)}),O.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(g.serialize)}),O.deserialize=(T,B)=>({...t.deserialize(T,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>g.deserialize(T,W)),retired:!0})})(l||(e.TestResultItem=l={}));var a;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(T,B)=>{T.covered+=B.covered,T.total+=B.total}})(a||(e.ICoverageCount=a={}));var h;(function(O){O.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(h||(e.IFileCoverage=h={}));function m(O){return{...O,location:O.location?.toJSON()}}function D(O){return O.location=O.location?N.$jt.isIPosition(O.location)?N.$jt.lift(O.location):L.$kt.lift(O.location):void 0,O}e.$JL=3;var p;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(p||(e.DetailType=p={}));var E;(function(O){O.serialize=T=>T.type===0?P.serialize(T):I.serialize(T),O.deserialize=T=>T.type===0?P.deserialize(T):I.deserialize(T)})(E||(e.CoverageDetails=E={}));var y;(function(O){O.serialize=m,O.deserialize=D})(y||(e.IBranchCoverage=y={}));var P;(function(O){O.serialize=m,O.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var I;(function(O){O.serialize=T=>({...m(T),branches:T.branches?.map(y.serialize)}),O.deserialize=T=>({...D(T),branches:T.branches?.map(y.deserialize)})})(I||(e.IStatementCoverage=I={}));var j;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(j||(e.TestDiffOpType=j={}));var F;(function(O){O.deserialize=(T,B)=>B.op===0?{op:B.op,item:t.deserialize(T,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:T.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:f.serialize(T.item)}:T})(F||(e.TestsDiffOp=F={}));class z{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const B=this.v();for(const W of T)switch(W.op){case 0:this.l(t.deserialize(this.k,W.item),B);break;case 1:this.o(f.deserialize(W.item),B);break;case 3:this.p(W.itemId,B);break;case 5:this.q(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.c.set(W.tag.id,W.tag);break;case 7:this.c.delete(W.id);break}B.complete?.()}l(T,B){const W=R.$BL.parentId(T.item.extId)?.toString();let X;if(!W)X=this.w(T),this.g.add(X),this.f.set(T.item.extId,X);else if(this.f.has(W)){const x=this.f.get(W);x.children.add(T.item.extId),X=this.w(T,x),this.f.set(T.item.extId,X)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return B.add?.(X),T.expand===2&&this.h++,X}o(T,B){const W=this.f.get(T.extId);if(W)return T.expand!==void 0&&(W.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$IL)(W,T),B.update?.(W),W}p(T,B){const W=this.f.get(T);if(!W)return;const X=R.$BL.parentId(W.item.extId)?.toString();X?this.f.get(X).children.delete(W.item.extId):this.g.delete(W);const x=[[T]];for(;x.length;)for(const Z of x.pop()){const Y=this.f.get(Z);Y&&(x.push(Y.children),this.f.delete(Z),B.remove?.(Y,Y!==W),Y.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$KL=z}),define(ke[112],Ee([1,0,8,4,3,62,89,68]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.TestItemEventOp=void 0;var b;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const S=(n,i)=>n===i,C=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:S,label:S,description:S,error:S,sortText:S,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),$=(n,i)=>{let r;for(const[s,t]of C)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class k extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,M.$IL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,M.$IL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(w.$BL.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const s of r.ops)this.w(i,s);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$cd)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const s=w.$BL.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(i)}}),this.I(i,f,r);return}if(f.actual===i){this.H(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,r);const d=this.s.getChildren(f.actual),l=f.actual,a=$(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,f.actual=i,f.resolveBarrier=void 0,f.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,s.toString()),delete a.tags),this.w(f,{op:4,update:a})),this.I(i,f,r);for(const[m,D]of d)this.s.getChildren(i).get(D.id)||this.O(w.$BL.joinToString(s,D.id));const h=f.expandLevels;h!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(s.toString(),h))}),this.y(f.actual.uri)}C(i,r,s){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(f=>(0,M.$GL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(i,r,s){this.H(i,r,s);for(const[t,f]of this.s.getChildren(i))this.z(f,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const s=[];for(const[t,f]of this.s.getChildren(i.actual)){const d=this.expand(w.$BL.joinToString(i.fullId,f.id),r);(0,u.$ch)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const f=new u.$ph;return f.open(),f}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$ph,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(f){s(f)}return(0,u.$ch)(t)?t.catch(s).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,d]of this.s.getChildren(t.actual))s.push(this.tree.get(w.$BL.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$3O=k;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$4O=v;class c extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5O=c;class g extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$6O=g;const o=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const d of s.values())t.call(f,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,d=new Set(s.keys()),l={op:5,ops:[]};for(const a of t){if(!(a instanceof r))throw new c(a.id);const h=i(a).controllerId;if(h!==n.controllerId)throw new g(a.id,h,n.controllerId);if(f.has(a.id))throw new v(a.id);f.set(a.id,a),d.delete(a.id),l.ops.push({op:0,item:a})}for(const a of d.keys())l.ops.push({op:3,id:a});n.listener?.(l),s=f},add(t){if(!(t instanceof r))throw new c(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$7O=o}),define(ke[144],Ee([1,0,112]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0;const N=new WeakMap,L=(M,w)=>{const b={controllerId:w};return N.set(M,b),b};e.$8O=L;const R=M=>{const w=N.get(M);if(!w)throw new u.$5O(M?.id||"<unknown>");return w};e.$9O=R}),define(ke[113],Ee([1,0,15,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Exb=e.$Dxb=void 0,e.$Gxb=L,e.$Hxb=M,e.$Dxb="vscode-cdn.net",e.$Exb=`vscode-resource.${e.$Dxb}`,e.$Fxb=`'self' https://*.${e.$Dxb}`;function L(w,b){return w.scheme===u.Schemas.http||w.scheme===u.Schemas.https?w:(b&&b.authority&&b.isRemote&&w.scheme===u.Schemas.file&&(w=N.URI.from({scheme:u.Schemas.vscodeRemote,authority:b.authority,path:w.path})),N.URI.from({scheme:u.Schemas.https,authority:`${w.scheme}+${R(w.authority)}.${e.$Exb}`,path:w.path,fragment:w.fragment,query:w.query}))}function R(w){return w.replace(/./g,b=>{const S=b.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?b:"-"+S.toString(16).padStart(4,"0")})}function M(w){return w.replace(/-([0-9a-f]{4})/g,(b,S)=>String.fromCharCode(parseInt(S,16)))}}),define(ke[300],Ee([1,0,4,3,113]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=void 0;class R{constructor(w,b,S){this.d=w,this.e=b,this.f=S,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const A=b.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,b,S,A,C){let $;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===w){$=i;break}if(!$)throw new Error("not a visible editor");const k=this,v=this.a++,c=new u.$be,g=new u.$be,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$Gxb)(i,k.f)}get cspSource(){return L.$Fxb}set options(i){this.b=i,k.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,k.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(i){return k.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=w,this.line=b,this.height=S,this.webview=o,this.onDidDispose=g.event}dispose(){k.c.has(v)&&(k.c.delete(v),k.d.$disposeEditorInset(v),g.fire(),g.dispose(),c.dispose())}};return this.d.$createEditorInset(v,$.id,$.value.document.uri,b+1,S,A||{},C.identifier,C.extensionLocation),this.c.set(v,{editor:w,inset:n,onDidReceiveMessage:c}),n}$onDidDispose(w){const b=this.c.get(w);b&&b.inset.dispose()}$onDidReceiveMessage(w,b){this.c.get(w)?.onDidReceiveMessage.fire(b)}}e.$hkc=R}),define(ke[145],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,u.$qi)("IAuthenticationService"),e.$TL=(0,u.$qi)("IAuthenticationExtensionsService")}),define(ke[301],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.VariableKind=e.$YP=void 0,e.$YP=(0,u.$qi)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class L extends Error{constructor(M,w){super(w),this.variable=M}}e.$ZP=L}),define(ke[302],Ee([1,0,17,51,18,24,11,103,241,301,14]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,v,c,g){this.h=new Map,this.a=k,this.b=v,this.g=c,g&&(this.c=g.then(o=>this.i(o)))}i(k){if(M.$i){const v=Object.create(null);return Object.keys(k).forEach(c=>{v[c.toLowerCase()]=k[c]}),v}return k}resolveWithEnvironment(k,v,c){return this.l({env:this.i(k),userHome:void 0},v?v.uri:void 0,c)}async resolveAsync(k,v){const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,v)}async j(k,v,c,g){const o=R.$Wn(v);M.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):M.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):M.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,k?k.uri:void 0,o,c,g)}async resolveAnyAsync(k,v,c){return this.j(k,v,c)}async resolveAnyMap(k,v,c){const g=new Map;return{newConfig:await this.j(k,v,c,g),resolvedVariables:g}}resolveWithInteractionReplace(k,v,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,v,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,v){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,v)}async l(k,v,c,g,o){if(L.$4f(c))return this.m(k,v,c,g,o);if(Array.isArray(c))return Promise.all(c.map(n=>this.l(k,v,n,g,o)));if(L.$6f(c)){const n=Object.create(null),i=await Promise.all(Object.keys(c).map(async r=>[await this.m(k,v,r,g,o),await this.l(k,v,c[r],g,o)]));for(const[r,s]of i)n[r]=s;return n}return c}m(k,v,c,g,o){return(0,A.$lf)(c,C.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(C.VARIABLE_LHS))return n;let r=await this.o(k,n,i,v,g);return o?.set(i,r),r!==n&&L.$4f(r)&&r.match(C.VARIABLE_REGEXP)&&(r=await this.m(k,v,r,g,o)),r})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,v,c,g,o){let n;const i=c.split(":");i.length>1&&(c=i[0],n=i[1]);const r=f=>{const d=this.a.getFilePath();if(d)return(0,w.$pw)(d);throw new S.$ZP(f,(0,b.localize)(0,null,v))},s=f=>{const d=r(f);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,w.$pw)(l)}throw new S.$ZP(f,(0,b.localize)(1,null,v,u.$oc(d)))},t=f=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new S.$ZP(f,(0,b.localize)(2,null,v,n))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new S.$ZP(f,(0,b.localize)(3,null,v)):new S.$ZP(f,(0,b.localize)(4,null,v))};switch(c){case"env":if(n){if(k.env){const f=k.env[M.$i?n.toLowerCase():n];if(L.$4f(f))return f}return""}throw new S.$ZP(S.VariableKind.Env,(0,b.localize)(5,null,v));case"config":if(n){const f=this.a.getConfigurationValue(g,n);if(L.$ag(f))throw new S.$ZP(S.VariableKind.Config,(0,b.localize)(6,null,v,n));if(L.$6f(f))throw new S.$ZP(S.VariableKind.Config,(0,b.localize)(7,null,v,n));return f}throw new S.$ZP(S.VariableKind.Config,(0,b.localize)(8,null,v));case"command":return this.p(S.VariableKind.Command,v,n,o,"command");case"input":return this.p(S.VariableKind.Input,v,n,o,"input");case"extensionInstallFolder":if(n){const f=await this.a.getExtension(n);if(!f)throw new S.$ZP(S.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,v,n));return this.n(f.extensionLocation)}throw new S.$ZP(S.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,v));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,w.$pw)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return g||n?(0,w.$pw)(this.n(t(S.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$pw)(u.$oc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new S.$ZP(S.VariableKind.UserHome,(0,b.localize)(11,null,v))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new S.$ZP(S.VariableKind.LineNumber,(0,b.localize)(12,null,v))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new S.$ZP(S.VariableKind.SelectedText,(0,b.localize)(13,null,v))}case"file":return r(S.VariableKind.File);case"fileWorkspaceFolder":return s(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(s(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||n?u.$mc(this.n(t(S.VariableKind.RelativeFile)),r(S.VariableKind.RelativeFile)):r(S.VariableKind.RelativeFile);case"relativeFileDirname":{const f=u.$nc(r(S.VariableKind.RelativeFileDirname));if(g||n){const d=u.$mc(this.n(t(S.VariableKind.RelativeFileDirname)),f);return d.length===0?".":d}return f}case"fileDirname":return u.$nc(r(S.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(S.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=u.$oc(r(S.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-u.$pc(f).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(S.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||v}case"execInstallFolder":{const f=this.a.getAppRoot();return f||v}case"pathSeparator":case"/":return u.sep;default:try{const f=n?`${c}:${n}`:c;return this.p(S.VariableKind.Unknown,v,f,o,void 0)}catch{return v}}}}p(k,v,c,g,o){if(c&&g){const n=o===void 0?g[c]:g[o+":"+c];if(typeof n=="string")return n;throw new S.$ZP(k,(0,b.localize)(14,null,v))}return v}}e.$cQ=C}),define(ke[146],Ee([1,0,5,142]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ID=void 0,e.$JD=S,e.$KD=$,e.$LD=k,e.$ID=(0,u.$qi)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var w;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var b;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function S(v){const c=v;return(0,N.$tF)(c?.editor)&&(0,N.$tF)(c?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function $(v){const c=v;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function k(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[303],Ee([1,0,5,146]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$QD=L,e.$MD=(0,u.$qi)("editorService"),e.$ND=-1,e.$OD=-2,e.$PD=-3;function L(R){const M=R;return typeof R=="number"||(0,N.$KD)(M)}}),define(ke[147],Ee([1,0,5,136]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,u.$ri)(N.$xi)}),define(ke[148],Ee([1,0,25,4,17,3,8]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=e.$E$b=e.$D$b=e.$C$b=e.$B$b=void 0;class w{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$B$b=w;class b{static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(c),this.f=new u.$Nm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=g(this.e,i),this.e=this.e.concat(n);const r=b.l(this.e);return this.e=g(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const a=i.getArcs(d);for(let h=0;h<a.length;h++)if(!l.has(a[h]))return!1;return!0}getNodes(){return this.e}},r=new u.$Nm;for(const d of n)if(r.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(u.$Lm.toKey(d.identifier),u.$Lm.toKey(l));const s=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>s.add(d));const t=i.getNodes().filter(d=>!s.has(d));let f;do{f=!1;for(let d=0;d<t.length;d++){const l=t[d];i.hasOnlyGoodArcs(l,s)&&(t.splice(d,1),d--,s.add(l),f=!0)}}while(f);return t.map(d=>r.get(d))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$C$b=b;class S{constructor(n,i){this.versionId=n,this.extensions=i}}e.$D$b=S;class A{constructor(n){this.d=new k,this.c=new b(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new C(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$E$b=A;class C extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$F$b=C;class ${constructor(n){this.name=n;const i=(0,M.$jh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class k{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new $(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(s))}}var v;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(v||(v={}));function c(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=L.$hc.basename(o.extensionLocation.path),t=L.$hc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function g(o,n){const i=new u.$Mm(n);return o.filter(r=>!i.has(r.identifier))}}),define(ke[304],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.ExtHostConnectionType=void 0,e.$hn=w,e.$in=b;var u;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$en=N;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$fn=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[R.ENV_KEY]="1"}}e.$gn=R;function M(A){delete A[N.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function w(A,C){M(C),A.serialize(C)}function b(A){if(A[N.ENV_KEY])return S(A,new N(A[N.ENV_KEY]));if(A[L.ENV_KEY])return S(A,new L);if(A[R.ENV_KEY])return S(A,new R);throw new Error("No connection information defined in environment!")}function S(A,C){return M(A),C}}),define(ke[114],Ee([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=w;var N;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(N||(e.UIKind=N={}));var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(S){const A=u.$Ce.alloc(1);switch(S){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function w(S,A){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var b;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,226]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$sP=e.$rP=void 0,e.$tP=c;let k=class extends C.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:b.$ep,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$Yj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const r=this.getTelemetryDetails(),s=new v(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,w.$Cm)((0,b.$kp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$rP=k,e.$rP=k=Je([qe(0,R.$qP),qe(1,L.$Xj)],k);class v{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,r,s,t,f){this.g=i,this.h=r,this.i=s,this.j=t,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,b.$np)(n,[]),this.c&&(n=(0,S.$Zn)(n,this.c)),this.b||(n=(0,S.$Zn)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,b.$np)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$sP=v;function c(g){const o=Date.now()-new Date(g).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$uP=(0,u.$qi)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,272,140,25,5]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.ActivationKind=e.$AG=e.$zG=e.$wG=e.ExtensionHostStartup=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$xG=$,e.$yG=k,e.$BG=o,e.$CG=n,e.$sG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tG="extensions.webWorker",e.$uG=(0,w.$qi)("extensionService");class b{constructor(s){this.dependency=s}}e.$vG=b;var S;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,f){this.c=s,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$dG.createActivationEventsMap(this.d)}}set(s,t,f){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],l=[],a=[],h=[],m=C(this.d),D=C(t),p=(j,F)=>j.extensionLocation.toString()===F.extensionLocation.toString()||j.isBuiltin===F.isBuiltin||j.isUserBuiltin===F.isUserBuiltin||j.isUnderDevelopment===F.isUnderDevelopment;for(const j of this.d){const F=D.get(j.identifier);if(!F){d.push(j.identifier),m.delete(j.identifier);continue}if(!p(j,F)){d.push(j.identifier),m.delete(j.identifier);continue}}for(const j of t){const F=m.get(j.identifier);if(!F){l.push(j);continue}if(!p(F,j)){d.push(F.identifier),m.delete(F.identifier);continue}}const E=new M.$Mm(this.e),y=new M.$Mm(f);for(const j of this.e)y.has(j)||a.push(j);for(const j of f)E.has(j)||h.push(j);const P=R.$dG.createActivationEventsMap(l),I={versionId:s,toRemove:d,toAdd:l,addActivationEvents:P,myToRemove:a,myToAdd:h};return this.delta(I),I}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:d,myToAdd:l}=s,a=new M.$Mm(t),h=new M.$Mm(d);for(let m=0;m<this.d.length;m++)a.has(this.d[m].identifier)&&(this.d.splice(m,1),m--);for(let m=0;m<this.e.length;m++)h.has(this.e[m])&&(this.e.splice(m,1),m--);for(const m of f)this.d.push(m);for(const m of l)this.e.push(m);return this.f=null,s}containsExtension(s){for(const t of this.e)if(M.$Lm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=R.$dG.readActivationEvents(t);for(const d of f)s.add(d)}return s}}e.$wG=A;function C(r){const s=new M.$Nm;for(const t of r)s.set(t.identifier,t);return s}function $(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function k(r,s){if(!$(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class v{constructor(s,t,f,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=d}}e.$zG=v;class c{constructor(s,t){this.description=s,this.value=t}}e.$AG=c;var g;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,L.$tp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new M.$Lm((0,L.$rp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DG=i}),define(ke[305],Ee([1,0,13,148,25,26,12,8]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=void 0;class b{static{this.NONE=new b(!1,-1,-1,-1)}constructor(o,n,i,r){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$Dkc=b;class S{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new b(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ekc=S;class A{constructor(o,n,i,r,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.$Fkc=A;class C extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gkc=C;class $ extends A{constructor(){super(!1,null,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hkc=$;class k extends A{constructor(o){super(!0,o,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,n,i,r){this.g=r,this.a=o,this.b=n,this.c=i,this.d=new L.$Nm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new k(s));return this.c.onExtensionActivationError(o.id,s,new R.$vG(o.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;i.push(this.j({id:f.identifier,reason:o.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),a=this.k(o,n.displayName,[],new k(l));return this.c.onExtensionActivationError(n.identifier,l,new R.$vG(s)),a}return this.k(o,n.displayName,i,null)}k(o,n,i,r){const s=new c(o.id,n,o.reason,i,r,this.c,this.g);return this.d.set(o.id,s),s}l(o){return N.$C$b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$Ikc=v,e.$Ikc=v=Je([qe(3,M.$Wj)],v);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,r,s,t,f){this.c=o,this.d=n,this.f=i,this.g=r,this.h=s,this.j=t,this.k=f,this.a=new w.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new k(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new k(n),this.b&&u.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};c=Je([qe(6,M.$Wj)],c)}),define(ke[306],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[307],Ee([1,0,243,13,40,137,109,38,25,306,139,140]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0;const $=w.$9n.as(M.$0n.JSONContribution);class k{constructor(s,t,f){this.a=s,this.b=t,this.c=f}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(L.default.Error,s)}warn(s){this.d(L.default.Warning,s)}info(s){this.d(L.default.Info,s)}}e.$mG=k;class v{static a(s){const t=new b.$Mm;for(let f=0,d=s.length;f<d;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const f=this.a(s),d=this.a(t),l=t.filter(h=>!f.has(h.description.identifier)),a=s.filter(h=>!d.has(h.description.identifier));return new v(l,a)}constructor(s,t){this.added=s,this.removed=t}}e.$nG=v;class c{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,N.$1)(s)}}}e.$oG=c;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$pG={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$Km},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionKind:{description:u.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new c(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&C.$dG.register(s.extensionPoint,s.activationEventsGenerator),e.$pG.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,$.registerSchema(o,e.$pG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$qG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};w.$9n.add(i.ExtensionsRegistry,new n),e.$rG=w.$9n.as(i.ExtensionsRegistry),$.registerSchema(o,e.$pG),$.registerSchema(A.$ek,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ke[308],Ee([1,0,239,18,24,307,37,4]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var S;(function($){function k(v,c,g){if(!v)return;const o=N.$4f(v.type)?v.type:void 0;if(!o||o.length===0){g.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)N.$4f(i)&&n.push(i);return{extensionId:c.value,taskType:o,required:n,properties:v.properties?L.$Wn(v.properties):{},when:v.when?M.$oj.deserialize(v.when):void 0}}$.from=k})(S||(S={}));const A=R.$rG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,k)=>{for(const v of $)v.type&&k.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:b}});class C{constructor(){this.d=new w.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,v)=>{A.setHandler((c,g)=>{this.c=void 0;try{for(const o of g.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of g.added){const n=o.value;for(const i of n){const r=S.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const v of this.all()){const c={type:"object",additionalProperties:!1};v.required.length>0&&(c.required=v.required.slice(0)),v.properties!==void 0?c.properties=L.$Wn(v.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[v.taskType]},k.push(c)}this.c={oneOf:k}}return this.c}}e.$UH=new C}),define(ke[309],Ee([1,0,240,18,23,24,37,308]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,u.localize(0,null)),e.$XH=u.localize2(2,"Tasks");var b;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(b||(e.ShellQuoting=b={})),e.$YH="$customized",function(O){function T(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=T}(b||(e.ShellQuoting=b={}));var S;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A||(e.RevealKind=A={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=T}(A||(e.RevealKind=A={}));var C;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=T}(C||(e.RevealProblemKind=C={}));var $;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})($||(e.PanelKind=$={})),function(O){function T(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=T}($||(e.PanelKind=$={}));var k;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(O){function T(W){switch(W.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=T;function B(W){switch(W){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(v||(e.RuntimeType=v={}));var c;(function(O){function T(B){return N.$4f(B)?B:B.value}O.value=T})(c||(e.CommandString=c={}));var g;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function T(W){return W===O.Clean._id||W===O.Build._id||W===O.Rebuild._id||W===O.Test._id}O.is=T;function B(W){if(W!==void 0)return N.$4f(W)?T(W)?{_id:W,isDefault:!1}:void 0:W}O.from=B})(g||(e.TaskGroup=g={}));var o;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function T(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(O){O.parallel="parallel",O.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(T,B,W,X,x,Z){this._label="",this._id=T,B&&(this._label=B),W&&(this.type=W),this.runOptions=X,this.configurationProperties=x,this._source=Z}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,B=!1){if(T===void 0)return!1;if(N.$4f(T))return T===this._label||T===this.configurationProperties.identifier||B&&T===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$ZH=t;class f extends t{constructor(T,B,W,X,x,Z,Y,ce){super(T,W,void 0,Y,ce,B),this.command={},this._source=B,this.hasDefinedMatchers=Z,x&&(this.command=x)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(T){return T instanceof f}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new f(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$1H=f;class d extends t{constructor(T,B,W,X,x,Z,Y){super(T,W,X,Z,Y,B),this._source=B,this.configures=x}static is(T){return T instanceof d}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}}e.$2H=d;class l extends t{constructor(T,B,W,X,x,Z,Y,ce,ne){super(T,W,X,ce,ne,B),this.defines=x,this.hasDefinedMatchers=Y,this.command=Z,this.icon=ne.icon,this.hide=ne.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof l}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new l(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$3H=l;class a extends t{constructor(T,B,W,X,x,Z){super(T,W,X,x,Z,B),this._source=B}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new a(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$4H=a;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(O){O._default=O.Terminal}(h||(e.ExecutionEngine=h={}));var m;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(m||(e.JsonSchemaVersion=m={}));class D{constructor(T){this.c=new Map;for(let B=0;B<T.length;B++)this.c.set(T[B].uri.toString(),B)}compare(T,B){const W=T.getWorkspaceFolder(),X=B.getWorkspaceFolder();if(W&&X){let x=this.c.get(W.uri.toString());x=x===void 0?0:x+1;let Z=this.c.get(X.uri.toString());return Z=Z===void 0?0:Z+1,x===Z?T._label.localeCompare(B._label):x-Z}else return!W&&X?-1:W&&!X?1:0}}e.$5H=D;var p;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(p||(e.TaskEventKind=p={}));var E;(function(O){O.SingleRun="singleRun",O.Background="background"})(E||(e.TaskRunType=E={}));var y;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(O){function T(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function B(ce,ne,$e){return{...T(ce),kind:"start",terminalId:ne,resolvedVariables:$e}}O.start=B;function W(ce,ne,$e){return{...T(ce),kind:"processStarted",terminalId:ne,processId:$e}}O.processStarted=W;function X(ce,ne,$e){return{...T(ce),kind:"processEnded",terminalId:ne,exitCode:$e}}O.processEnded=X;function x(ce,ne,$e){return{...T(ce),kind:"terminated",exitReason:$e,terminalId:ne}}O.terminated=x;function Z(ce,ne,$e){return{...T(ne),kind:ce,terminalId:$e}}O.general=Z;function Y(){return{kind:"changed"}}O.changed=Y})(P||(e.TaskEvent=P={}));var I;(function(O){function T(W){const X=Object.keys(W).sort();let x="";for(const Z of X){let Y=W[Z];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),x+=Z+","+Y+","}return x}function B(W){const x={_key:T(W),type:W.taskType};return Object.assign(x,W),x}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var j;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var F;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var z;(function(O){function T(B,W){const X=w.$UH.get(B.type);if(X===void 0){const ce=R.$Wn(B);return delete ce._key,I.create(ce)}const x=Object.create(null);x.type=X.taskType;const Z=new Set;X.required.forEach(ce=>Z.add(ce));const Y=X.properties;for(const ce of Object.keys(Y)){const ne=B[ce];if(ne!=null)x[ce]=ne;else if(Z.has(ce)){const $e=Y[ce];if($e.default!==void 0)x[ce]=R.$Wn($e.default);else switch($e.type){case"boolean":x[ce]=!1;break;case"number":case"integer":x[ce]=0;break;case"string":x[ce]="";break;default:W.error(u.localize(1,null,JSON.stringify(B,void 0,0),ce));return}}}return I.create(x)}O.createTaskIdentifier=T})(z||(e.TaskDefinition=z={}))}),define(ke[310],Ee([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=e.$G$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,w)=>{this.b=M,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,u.$1)(M))}then(M,w){return this.j().then(M,w)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$G$b=N;class L extends N{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$H$b=L}),define(ke[48],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$jw=void 0,e.$kw=L,e.$lw=R;class u{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++u.count}}e.$jw=u;const N=[];function L(w){const b=new u(w);return N[b.nid]=b,b}function R(w){return N[w].sid}class M{constructor(b){this.value=b}}e.$mw=M}),define(ke[6],Ee([1,0,48]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var L;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var w;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var b;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var S;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var A;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(g){return g._id=C.a++,g}}e.$OM=C;var $;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var k;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var v;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$PM={MainThreadAuthentication:(0,u.$kw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$kw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$kw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$kw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$kw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$kw)("MainThreadClipboard"),MainThreadCommands:(0,u.$kw)("MainThreadCommands"),MainThreadComments:(0,u.$kw)("MainThreadComments"),MainThreadConfiguration:(0,u.$kw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$kw)("MainThreadConsole"),MainThreadDebugService:(0,u.$kw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$kw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$kw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$kw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$kw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$kw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$kw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$kw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$kw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$kw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$kw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$kw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$kw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$kw)("MainThreadLanguages"),MainThreadLogger:(0,u.$kw)("MainThreadLogger"),MainThreadMessageService:(0,u.$kw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$kw)("MainThreadOutputService"),MainThreadProgress:(0,u.$kw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$kw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$kw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$kw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$kw)("MainThreadSecretState"),MainThreadStorage:(0,u.$kw)("MainThreadStorage"),MainThreadSpeech:(0,u.$kw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$kw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$kw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,u.$kw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,u.$kw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$kw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$kw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$kw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$kw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$kw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$kw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$kw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$kw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$kw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$kw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$kw)("MainThreadSCM"),MainThreadSearch:(0,u.$kw)("MainThreadSearch"),MainThreadShare:(0,u.$kw)("MainThreadShare"),MainThreadTask:(0,u.$kw)("MainThreadTask"),MainThreadWindow:(0,u.$kw)("MainThreadWindow"),MainThreadLabelService:(0,u.$kw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$kw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$kw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$kw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$kw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$kw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$kw)("MainThreadInteractive"),MainThreadInlineChat:(0,u.$kw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$kw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$kw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$kw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$kw)("MainThreadTimeline"),MainThreadTesting:(0,u.$kw)("MainThreadTesting"),MainThreadLocalization:(0,u.$kw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$kw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$kw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,u.$kw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$kw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$kw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$kw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$kw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$kw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$kw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$kw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$kw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$kw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$kw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$kw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$kw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$kw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$kw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$kw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$kw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$kw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$kw)("ExtHostStatusBar"),ExtHostShare:(0,u.$kw)("ExtHostShare"),ExtHostExtensionService:(0,u.$kw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$kw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$kw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,u.$kw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,u.$kw)("ExtHostSCM"),ExtHostSearch:(0,u.$kw)("ExtHostSearch"),ExtHostTask:(0,u.$kw)("ExtHostTask"),ExtHostWorkspace:(0,u.$kw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$kw)("ExtHostWindow"),ExtHostWebviews:(0,u.$kw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$kw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$kw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$kw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$kw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$kw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$kw)("ExtHostProgress"),ExtHostComments:(0,u.$kw)("ExtHostComments"),ExtHostSecretState:(0,u.$kw)("ExtHostSecretState"),ExtHostStorage:(0,u.$kw)("ExtHostStorage"),ExtHostUrls:(0,u.$kw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$kw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$kw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$kw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$kw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$kw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$kw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$kw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$kw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$kw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$kw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$kw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$kw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,u.$kw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$kw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$kw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$kw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$kw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$kw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$kw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$kw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$kw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$kw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$kw)("ExtHostTimeline"),ExtHostTesting:(0,u.$kw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$kw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$kw)("ExtHostLocalization")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=e.$3jc=void 0,e.$3jc=(0,u.$qi)("IExtHostApiDeprecationService");let M=class{constructor(b,S){this.c=S,this.a=new Set,this.b=b.getProxy(L.$PM.MainThreadTelemetry)}report(b,S,A){const C=this.d(b,S);this.a.has(C)||(this.a.add(C),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:b}))}d(b,S){return`${b}-${S.identifier.value}`}};e.$4jc=M,e.$4jc=M=Je([qe(0,R.$aP),qe(1,N.$Wj)],M),e.$5jc=Object.freeze(new class{report(w,b,S){}})}),define(ke[311],Ee([1,0,6]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class N{constructor(R){const M=R.getProxy(u.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(w){return M.$writeText(w)}})}}e.$fkc=N}),define(ke[312],Ee([1,0,24,6,28,20]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;let M=class{constructor(A,C){this.a=A.getProxy(N.$PM.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,C){const $=this,k=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,C,k,arguments)}})}e(A,C,$,k){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:b(k,this.b)}),this.c&&this.f(A,$,k)}};e.$_lc=M,e.$_lc=M=Je([qe(0,R.$aP),qe(1,L.$qP)],M);const w=1e5;function b(S,A){const C=[];if(S.length)for(let $=0;$<S.length;$++){let k=S[$];if(typeof k>"u")k="undefined";else if(k instanceof Error){const v=k;v.stack?k=v.stack:k=v.toString()}C.push(k)}if(A){const $=new Error().stack;$&&C.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,u.$2n)(C);return $.length>w?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[313],Ee([1,0,2,6,26]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class R{constructor(w){this.a=w.getProxy(N.$PM.MainThreadDialogs)}showOpenDialog(w,b){return b?.allowUIResources&&(0,L.$yG)(w,"showLocal"),this.a.$showOpenDialog(b).then(S=>S?S.map(A=>u.URI.revive(A)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then(b=>b?u.URI.revive(b):void 0)}}e.$clc=R}),define(ke[314],Ee([1,0,3,6]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(N.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,M),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$wlc=L}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0;let A=class{constructor($,k,v){this.f=v,this.d=new Map,this.a=k.getProxy(w.$PM.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===u.$g}getMessage($,k){const{message:v,args:c,comment:g}=k;if(this.c)return(0,N.$5e)(v,c??{});let o=v;g&&g.length>0&&(o+=`/${Array.isArray(g)?g.join(""):g}`);const n=this.d.get($)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,N.$5e)(n??v,c??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let k;const v=await this.g($);if(!v){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(v),g=JSON.parse(c);k=$.isBuiltin?g.contents?.bundle:g}catch(c){this.f.error(`Failed to load translations for ${$.identifier.value} from ${v}: ${c.message}`);return}k&&this.d.set($.identifier.value,{contents:k,uri:v})}async g($){if($.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return L.URI.revive(k)}return $.l10n?L.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wkc=A,e.$Wkc=A=Je([qe(0,b.$qP),qe(1,S.$aP),qe(2,M.$Wj)],A),e.$Xkc=(0,R.$qi)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,58]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let b=class extends u.$8j{constructor(C,$){super($.logLevel,$.logsLocation,$.loggers.map(k=>(0,w.$Zh)(k))),this.r=C.getProxy(N.$PM.MainThreadLogger)}$setLogLevel(C,$){$?this.setLogLevel(M.URI.revive($),C):this.setLogLevel(C)}setVisibility(C,$){super.setVisibility(C,$),this.r.$setVisibility(C,$)}s(C,$,k){return new S(this.r,C,$,k)}};e.$$lc=b,e.$$lc=b=Je([qe(0,R.$aP),qe(1,L.$qP)],b);class S extends u.$3j{constructor(C,$,k,v){super(v?.logLevel==="always"),this.r=C,this.s=$,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger($,v).then(()=>{this.u(this.n),this.m=!0})}g(C,$){const k=[[C,$]];this.m?this.u(k):this.n.push(...k)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=void 0,e.$Ykc=(0,N.$qi)("IExtHostManagedSockets");let w=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(u.$PM.MainThreadManagedSockets)}setFactory(C,$){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(C,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const $=++this.b,k=await this.c.makeConnection(),v=new L.$Tc;return this.d.set($,new S($,k,v)),v.add((0,L.$Sc)(()=>this.d.delete($))),v.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),v.dispose()})),v.add(k.onDidClose(c=>{this.a.$onDidManagedSocketClose($,c?.stack??c?.message),v.dispose()})),v.add(k.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData($,M.$Ce.wrap(c)))),$}$remoteSocketWrite(C,$){this.d.get(C)?.actual.send($.buffer)}$remoteSocketEnd(C){const $=this.d.get(C);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Zkc=w,e.$Zkc=w=Je([qe(0,R.$aP)],w);class b{constructor(C,$){this.socketFactoryId=C,this.makeConnection=$}}class S extends L.$Uc{constructor(C,$,k){super(),this.socketId=C,this.actual=$,this.B(k)}}}),define(ke[315],Ee([1,0,6,12,26]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;function R(w){return w&&w.title}let M=class{constructor(b,S){this.b=S,this.a=b.getProxy(u.$PM.MainThreadMessageService)}showMessage(b,S,A,C,$){const k={source:{identifier:b.identifier,label:b.displayName||b.name}};let v;typeof C=="string"||R(C)?v=[C,...$]:(k.modal=C?.modal,k.useCustom=C?.useCustom,k.detail=C?.detail,v=$),k.useCustom&&(0,L.$yG)(b,"resolvers");const c=[];let g=!1;for(let o=0;o<v.length;o++){const n=v[o];if(typeof n=="string")c.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;c.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(g?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,n):g=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,n)}return this.a.$showMessage(S,A,k,c).then(o=>{if(typeof o=="number")return v[o]})}};e.$ylc=M,e.$ylc=M=Je([qe(1,N.$Wj)],M)}),define(ke[316],Ee([1,0,3,18,2,26,6]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class w{constructor(S){this.b=new Map,this.a=S.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,A,C){if((0,R.$yG)(S,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,S.identifier.value),(0,u.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(S,A,C,$){const k=this.b.get(S);if(!k)throw new Error(`Unknown handler with id: ${S}`);return k.saveProfile(A,C,$)}async $readProfile(S,A,C){const $=this.b.get(S);if(!$)throw new Error(`Unknown handler with id: ${S}`);return $.readProfile((0,N.$4f)(A)?A:L.URI.revive(A),C)}}e.$Hlc=w}),define(ke[117],Ee([1,0,6,4,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=void 0;class R{constructor(w){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=w.getProxy(u.$PM.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,b){return this.a.$getPassword(w,b)}store(w,b,S){return this.a.$setPassword(w,b,S)}delete(w,b){return this.a.$deletePassword(w,b)}}e.$Tkc=R,e.$Ukc=(0,L.$qi)("IExtHostSecretState")}),define(ke[317],Ee([1,0,22,3,6]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class R{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(L.$PM.MainThreadSpeech)}async $createSpeechToTextSession(w,b,S){const A=this.c.get(w);if(!A)return;const C=new N.$Tc,$=new u.$me;this.d.set(b,$);const k=C.add(A.provideSpeechToTextSession($.token,S?{language:S}:void 0));C.add(k.onDidChange(v=>{$.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,v)})),C.add($.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createKeywordRecognitionSession(w,b){const S=this.c.get(w);if(!S)return;const A=new N.$Tc,C=new u.$me;this.d.set(b,C);const $=A.add(S.provideKeywordRecognitionSession(C.token));A.add($.onDidChange(k=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,k)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,b,S){const A=R.a++;return this.c.set(A,S),this.b.$registerProvider(A,b,{extension:w,displayName:w.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Olc=R}),define(ke[118],Ee([1,0,6,4,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=void 0;class R{constructor(w,b){this.c=b,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(u.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(w,b){this.a.$registerExtensionStorageKeysToSync(w,b)}async initializeExtensionStorage(w,b,S){const A=await this.a.$initializeExtensionStorage(w,b);let C;return A&&(C=this.d(w,b,A)),C||S}setValue(w,b,S){return this.a.$setValue(w,b,S)}$acceptValue(w,b,S){const A=this.d(w,b,S);A&&this.b.fire({shared:w,key:b,value:A})}d(w,b,S){try{return JSON.parse(S)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${w}): ${A}`)}}}e.$Jkc=R,e.$Kkc=(0,L.$qi)("IExtHostStorage")}),define(ke[318],Ee([1,0,3,15,2,6]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(R.$PM.MainThreadUriOpeners)}registerExternalUriOpener(b,S,A,C){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const $=C.schemes.find(k=>!M.a.has(k));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(S,A),this.b.$registerUriOpener(S,C.schemes,b,C.label),(0,u.$Sc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri(b,S,A){const C=this.c.get(b);if(!C)throw new Error(`Unknown opener with id: ${b}`);const $=L.URI.revive(S);return C.canOpenExternalUri($,A)}async $openUri(b,S,A){const C=this.c.get(b);if(!C)throw new Error(`Unknown opener id: '${b}'`);return C.openExternalUri(L.URI.revive(S.resolvedUri),{sourceUri:L.URI.revive(S.sourceUri)},A)}}e.$5lc=M}),define(ke[319],Ee([1,0,6,2,3,13,25]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class w{static{this.a=0}constructor(S){this.c=new M.$Mm,this.d=new Map,this.b=S.getProxy(u.$PM.MainThreadUrls)}registerUriHandler(S,A){const C=S.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const $=w.a++;return this.c.add(C),this.d.set($,A),this.b.$registerUriHandler($,C,S.displayName||S.name),(0,L.$Sc)(()=>{this.c.delete(C),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(S,A){const C=this.d.get(S);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(A))}catch($){(0,R.$1)($)}return Promise.resolve(void 0)}async createAppUri(S){return N.URI.revive(await this.b.$createAppUri(S))}}e.$6lc=w}),define(ke[92],Ee([1,0,4,3,15,24,2,247,285,113,6]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=e.$ukc=void 0,e.$vkc=$,e.$xkc=c,e.$ykc=g;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,f,d,l,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$be,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=f,this.#s=d,this.#r=l,this.#l=$(l),this.#d=k(l),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,S.$Gxb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===L.Schemas.https||r.scheme===L.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+S.$Fxb}return S.$Fxb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),R.$1n(this.#o,r)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,b.$Xnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,a,h,m)=>{const D=M.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),p=(0,S.$Gxb)(D,{isRemote:s,authority:t}).toString();return`${d}${p}${m}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,a,h,m)=>{const D=M.URI.from({scheme:a||"file",path:decodeURIComponent(h)}),p=(0,S.$Gxb)(D,{isRemote:s,authority:t}).toString();return`${d}${p}${m}`})}}e.$ukc=C;function $(i){try{const r=(0,w.$Cp)((0,w.$Bp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function k(i){try{const r=(0,w.$Cp)((0,w.$Bp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class v extends N.$Uc{constructor(r,s,t,f,d){super(),this.c=s,this.f=t,this.g=f,this.h=d,this.b=new Map,this.a=r.getProxy(A.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const f=this.j(r);if(f){const{message:d}=(0,b.$Ynb)(s,t.value);f._onMessageEmitter.fire(d)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const f=new C(r,this.a,o(s),this.c,this.f,t,this.h);this.b.set(r,f);const d=f._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$wkc=v;function c(i){return{id:i.identifier,location:i.extensionLocation}}function g(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>M.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(le,e,u,N,L,R,M,w,b,S){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0;let C=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(k){const v=this.d;return{get focused(){return v.focused},get active(){return(0,S.$yG)(k,"windowActivity"),v.active}}}constructor(k){this.c=new u.$be,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=k.getProxy(N.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:c})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,v){v!==this.d[k]&&(this.d={...this.d,[k]:v},this.c.fire(this.d))}openUri(k,v){let c;if(typeof k=="string"){c=k;try{k=L.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,M.$3e)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,c,v)}async asExternalUri(k,v){if((0,M.$3e)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(k,v);return L.URI.from(c)}};e.$8lc=C,e.$8lc=C=A=Je([qe(0,b.$aP)],C),e.$9lc=(0,w.$qi)("IExtHostWindow")}),define(ke[320],Ee([1,0,312,28,20]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;const R=1024*1024;let M=class extends u.$_lc{constructor(b,S){super(b,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(b,S,A){const C=b==="error"||b==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),S.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(b,S){const A=process[b],C=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(k,v,c)=>{if(!this.g){$+=k.toString(v);const g=$.length>R?$.length:$.lastIndexOf(`
`);g!==-1&&(console[S]($.slice(0,g)),$=$.slice(g+1))}C.call(A,k,v,c)}})}};e.$Kmc=M,e.$Kmc=M=Je([qe(0,L.$aP),qe(1,N.$qP)],M)}),define(ke[321],Ee([1,0,149,15,262,30]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;class M extends u.$$lc{s(b,S,A){return b.scheme===N.Schemas.file?new L.$nQ(A?.name||(0,R.$Mg)(),b.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,S):super.s(b,S,A)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$Wmc=M}),define(ke[322],Ee([1,0,8,21,22,13,4,3,133,310,48]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$I$b=g,e.$J$b=o;function $(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const k="$$ref$$",v={[k]:-1};class c{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function g(y,P=null,I=!1){const j=[];return{jsonString:(I?$:JSON.stringify)(y,(z,O)=>{if(typeof O>"u")return v;if(typeof O=="object"){if(O instanceof N.$Ce){const T=j.push(O)-1;return{[k]:T}}if(P)return P(z,O)}return O}),referencedBuffers:j}}function o(y,P,I){return JSON.parse(y,(j,F)=>{if(F){const z=F[k];if(typeof z=="number")return P[z];if(I&&F.$mid===1)return I.transformIncoming(F)}return F})}function n(y,P){return JSON.stringify(y,P)}function i(y){return y?(P,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends w.$Uc{static{C=f}static{this.a=3*1e3}constructor(P,I=null,j=null){super(),this[C]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,z=A.$jw.count;F<z;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$Ch(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,b.$vn)(P,this.g):P}getProxy(P){const{nid:I,sid:j}=P;return this.s[I]||(this.s[I]=this.J(I,j)),this.s[I]}J(P,I){const j={get:(F,z)=>(typeof z=="string"&&!F[z]&&z.charCodeAt(0)===36&&(F[z]=(...O)=>this.U(P,z,O)),z===d?I:F[z])};return new Proxy(Object.create(null),j)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,j=P.length;I<j;I++){const F=P[I];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,j=h.read(P,0),F=j.readUInt8(),z=j.readUInt32();switch(F){case 1:case 2:{let{rpcId:O,method:T,args:B}=D.deserializeRequestJSONArgs(j);this.g&&(B=(0,b.$vn)(B,this.g)),this.M(I,z,O,T,B,F===2);break}case 3:case 4:{let{rpcId:O,method:T,args:B}=D.deserializeRequestMixedArgs(j);this.g&&(B=(0,b.$vn)(B,this.g)),this.M(I,z,O,T,B,F===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let O=D.deserializeReplyOKJSON(j);this.g&&(O=(0,b.$vn)(O,this.g)),this.O(I,z,O);break}case 10:{const O=D.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(I,z,O);break}case 8:{const O=D.deserializeReplyOKVSBuffer(j);this.O(I,z,O);break}case 11:{let O=D.deserializeReplyErrError(j);this.g&&(O=(0,b.$vn)(O,this.g)),this.P(I,z,O);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,j,F,z,O){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,A.$lw)(j)}.${F}(`,z);const T=String(I);let B,W;if(O){const x=new L.$me;z.push(x.token),B=this.Q(j,F,z),W=()=>x.cancel()}else B=this.Q(j,F,z),W=t;this.u[T]=W;const X=D.serializeAcknowledged(I);this.f?.logOutgoing(X.byteLength,I,1,"ack"),this.c.send(X),B.then(x=>{delete this.u[T];const Z=D.serializeReplyOK(I,x,this.h);this.f?.logOutgoing(Z.byteLength,I,1,"reply:",x),this.c.send(Z)},x=>{delete this.u[T];const Z=D.serializeReplyErr(I,x);this.f?.logOutgoing(Z.byteLength,I,1,"replyErr:",x),this.c.send(Z)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const j=String(I);this.u[j]?.()}O(P,I,j){this.f?.logIncoming(P,I,0,"receiveReply:",j);const F=String(I);if(!this.w.hasOwnProperty(F))return;const z=this.w[F];delete this.w[F],z.resolveOk(j)}P(P,I,j){this.f?.logIncoming(P,I,0,"receiveReplyErr:",j);const F=String(I);if(!this.w.hasOwnProperty(F))return;const z=this.w[F];delete this.w[F];let O;j&&(j.$isError?(O=new Error,O.name=j.name,O.message=j.message,O.stack=j.stack):O=j),z.resolveErr(O)}Q(P,I,j){try{return Promise.resolve(this.S(P,I,j))}catch(F){return Promise.reject(F)}}S(P,I,j){const F=this.m[P];if(!F)throw new Error("Unknown actor "+(0,A.$lw)(P));const z=F[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$lw)(P));return z.apply(F,j)}U(P,I,j){if(this.j)return new S.$H$b;let F=null;if(j.length>0&&L.CancellationToken.isCancellationToken(j[j.length-1])&&(F=j.pop()),F&&F.isCancellationRequested)return Promise.reject(R.$6());const z=D.serializeRequestArguments(j,this.h),O=++this.t,T=String(O),B=new S.$G$b,W=new w.$Tc;F&&W.add(F.onCancellationRequested(()=>{const x=D.serializeCancel(O);this.f?.logOutgoing(x.byteLength,O,0,"cancel"),this.c.send(D.serializeCancel(O))})),this.w[T]=new a(B,W),this.F(O);const X=D.serializeRequest(O,P,I,z,!!F);return this.f?.logOutgoing(X.byteLength,O,0,`request: ${(0,A.$lw)(P)}.${I}(`,j),this.c.send(X),B}}e.$K$b=l;class a{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,I,j){const F=new h(N.$Ce.alloc(j+1+4),0);return F.writeUInt8(P),F.writeUInt32(I),F}static read(P,I){return new h(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let j=0,F=P.length;j<F;j++){const z=P[j];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)I+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,j=P.length;I<j;I++){const F=P[I];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let z=0;z<F.buffers.length;++z)this.writeBuffer(F.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let j=0;j<P;j++)switch(this.readUInt8()){case 1:I[j]=this.readLongString();break;case 2:I[j]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),T=[];for(let B=0;B<z;++B)T.push(this.readVSBuffer());I[j]=new A.$mw(o(O,T,null));break}case 4:I[j]=void 0;break}return I}}var m;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(m||(m={}));class D{static a(P){for(let I=0,j=P.length;I<j;I++)if(P[I]instanceof N.$Ce||P[I]instanceof A.$mw||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const j=[];for(let F=0,z=P.length;F<z;F++){const O=P[F];if(O instanceof N.$Ce)j[F]={type:2,value:O};else if(typeof O>"u")j[F]={type:4};else if(O instanceof A.$mw){const{jsonString:T,referencedBuffers:B}=g(O.value,I);j[F]={type:3,value:N.$Ce.fromString(T),buffers:B}}else j[F]={type:1,value:N.$Ce.fromString(n(O,I))}}return{type:1,args:j}}return{type:0,args:n(P,I)}}static serializeRequest(P,I,j,F,z){switch(F.type){case 0:return this.b(P,I,j,F.args,z);case 1:return this.c(P,I,j,F.args,z)}}static b(P,I,j,F,z){const O=N.$Ce.fromString(j),T=N.$Ce.fromString(F);let B=0;B+=h.sizeUInt8(),B+=h.sizeShortString(O),B+=h.sizeLongString(T);const W=h.alloc(z?2:1,P,B);return W.writeUInt8(I),W.writeShortString(O),W.writeLongString(T),W.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),j=P.readShortString(),F=P.readLongString();return{rpcId:I,method:j,args:JSON.parse(F)}}static c(P,I,j,F,z){const O=N.$Ce.fromString(j);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(O),T+=h.sizeMixedArray(F);const B=h.alloc(z?4:3,P,T);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(F),B.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),j=P.readShortString(),F=P.readMixedArray(),z=new Array(F.length);for(let O=0,T=F.length;O<T;O++){const B=F[O];typeof B=="string"?z[O]=JSON.parse(B):z[O]=B}return{rpcId:I,method:j,args:z}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,I,j){if(typeof I>"u")return this.d(P);if(I instanceof N.$Ce)return this.e(P,I);if(I instanceof A.$mw){const{jsonString:F,referencedBuffers:z}=g(I.value,j,!0);return this.g(P,F,z)}else return this.f(P,$(I,j))}static d(P){return h.alloc(7,P,0).buffer}static e(P,I){let j=0;j+=h.sizeVSBuffer(I);const F=h.alloc(8,P,j);return F.writeVSBuffer(I),F.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const j=N.$Ce.fromString(I);let F=0;F+=h.sizeLongString(j);const z=h.alloc(9,P,F);return z.writeLongString(j),z.buffer}static g(P,I,j){const F=N.$Ce.fromString(I);let z=0;z+=h.sizeUInt32,z+=h.sizeLongString(F);for(const T of j)z+=h.sizeVSBuffer(T);const O=h.alloc(10,P,z);O.writeUInt32(j.length),O.writeLongString(F);for(const T of j)O.writeBuffer(T);return O.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const j=P.readUInt32(),F=P.readLongString(),z=[];for(let O=0;O<j;++O)z.push(P.readVSBuffer());return new A.$mw(o(F,z,I))}static serializeReplyErr(P,I){const j=I?$(R.$3(I),null):void 0;if(typeof j!="string")return this.h(P);const F=N.$Ce.fromString(j);let z=0;z+=h.sizeLongString(F);const O=h.alloc(11,P,z);return O.writeLongString(F),O.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return h.alloc(12,P,0).buffer}}var p;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var E;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(E||(E={}))}),define(ke[323],Ee([1,0,21,27,15,84,5]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=A,e.$tK=C,e.$rK=(0,M.$qi)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${w.join("")}]+`),S=7;function A(k){if(k.scheme!==L.Schemas.vscodeNotebookCell)return;const v=k.fragment.indexOf("s");if(v<0)return;const c=parseInt(k.fragment.substring(0,v).replace(b,""),S),g=(0,u.$Ve)(k.fragment.substring(v+1)).toString();if(!isNaN(c))return{handle:c,notebook:k.with({scheme:g,fragment:null})}}function C(k,v){const c=v.toString(S),o=`${c.length<w.length?w[c.length-1]:"z"}${c}s${(0,u.$We)(u.$Ce.fromString(k.scheme),!0,!0)}`;return k.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}class ${constructor(){this.a=new N.$Bc}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const c=A(v);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$uK=$,(0,R.$os)(e.$rK,$,1)}),define(ke[119],Ee([1,0,21,35,45,101,15,17,11,37,323]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=f,e.$IK=l,e.$JK=a,e.$MK=D,e.$NK=E,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var C;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(C||(e.CellKind=C={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",R.$Hs.latex,R.$Hs.markdown,"image/png","image/jpeg",R.$Hs.text],e.$BK=[R.$Hs.latex,R.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var $;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var k;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function W(ne,$e){return(0,A.$tK)(ne,$e)}B.generate=W;function X(ne){return(0,A.$sK)(ne)}B.parse=X;function x(ne,$e){return ne.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${ne.scheme!==M.Schemas.file?ne.scheme:""}`})}B.generateCellOutputUri=x;function Z(ne){if(ne.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!$e)return;const Pe=$e[1]&&$e[1]!==""?$e[1]:void 0,_=$e[2];return{outputId:Pe,notebook:ne.with({scheme:_||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=Z;function Y(ne,$e,Pe){return B.generate(ne,$e).with({scheme:Pe})}B.generateCellPropertyUri=Y;function ce(ne,$e){if(ne.scheme===$e)return B.parse(ne.with({scheme:B.scheme}))}B.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const s=B=>b.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],X=e.$AK){this.e=X,this.d=[...new Set(W)].map(x=>({pattern:x,matches:N.$kk(s(x))}))}sort(W){const X=new Map(L.Iterable.map(W,Z=>[Z,s(Z)]));let x=[];for(const{matches:Z}of this.d)for(const[Y,ce]of X)if(Z(ce)){x.push(Y),X.delete(Y);break}return X.size&&(x=x.concat([...X.keys()].sort((Z,Y)=>this.e.indexOf(Z)-this.e.indexOf(Y)))),x}prioritize(W,X){const x=this.f(W);if(x===-1){this.d.unshift({pattern:W,matches:N.$kk(s(W))});return}const Z=new Set(X.map(ce=>this.f(ce,x)));Z.delete(-1);const Y=Array.from(Z).sort();this.d.splice(x+1,0,...Y.map(ce=>this.d[ce]));for(let ce=Y.length-1;ce>=0;ce--)this.d.splice(Y[ce],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,X=this.d.length){const x=s(W);for(let Z=0;Z<X;Z++)if(this.d[Z].matches(x))return Z;return-1}}e.$EK=t;function f(B,W,X,x=(Z,Y)=>Z===Y){const Z=[];function Y($e,Pe,_){if(Pe===0&&_.length===0)return;const U=Z[Z.length-1];U&&U.start+U.deleteCount===$e?(U.deleteCount+=Pe,U.toInsert.push(..._)):Z.push({start:$e,deleteCount:Pe,toInsert:_})}let ce=0,ne=0;for(;;){if(ce===B.length){Y(ce,0,W.slice(ne));break}if(ne===W.length){Y(ce,B.length-ce,[]);break}const $e=B[ce],Pe=W[ne];if(x($e,Pe)){ce+=1,ne+=1;continue}X(Pe)?(Y(ce,1,[]),ce+=1):(Y(ce,0,[Pe]),ne+=1)}return Z}e.$GK=new S.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new S.$Hj("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(B){const W=B;return!!((typeof W.include=="string"||N.$lk(W.include))&&(typeof W.exclude=="string"||N.$lk(W.exclude)))}function a(B,W,X){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const x=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,Z=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(N.$jk(x,(0,w.$oc)(X.fsPath).toLowerCase()))return!(Z&&N.$jk(Z,(0,w.$oc)(X.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class m{static{this.d="notebook/"}static create(W){return`${m.d}${W}`}static parse(W){if(W.startsWith(m.d))return W.substring(m.d.length)}}e.$LK=m;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const p=new TextDecoder;function E(B){const W=[];let X=!1;for(const ce of B)(W.length===0||X)&&(W.push(ce),X=!0);let x=I(W);const Z=u.$Ce.concat(W.map(ce=>u.$Ce.wrap(ce))),Y=T(Z);return x=x||Y.byteLength!==Z.byteLength,{data:Y,didCompression:x}}e.$OK="\x1B[A";const y=e.$OK.split("").map(B=>B.charCodeAt(0)),P=10;function I(B){let W=!1;return B.forEach((X,x)=>{if(x===0||X.length<e.$OK.length)return;const Z=B[x-1],Y=X.subarray(0,e.$OK.length);if(Y[0]===y[0]&&Y[1]===y[1]&&Y[2]===y[2]){const ce=Z.lastIndexOf(P);if(ce===-1)return;W=!0,B[x-1]=Z.subarray(0,ce),B[x]=X.subarray(e.$OK.length)}}),W}function j(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function F(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let X=B.match(/\r+(.*)$/m)[1];X=X+W.slice(X.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return B}const z=8,O=13;function T(B){return!B.buffer.includes(z)&&!B.buffer.includes(O)?B:u.$Ce.fromString(F(j(p.decode(B.buffer))))}}),define(ke[7],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,66,119]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v){"use strict";var c,g,o,n,i,r,s,t,f,d,l,a,h,m,D,p,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$1O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$ZO=e.$YO=e.$XO=e.$WO=e.ChatLocation=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=lt,e.$QN=ee,e.$vO=Lt;function y(H){return Object.assign(H,{apply:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const Te=me.length===1?[]:me[1];return Reflect.construct(H,Te,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const[Te,...Ye]=me;return Reflect.construct(H,Ye,Te.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let j=c=class{static from(...K){let me=K;return new c(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}#e;constructor(K){this.#e=K}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=j,e.$RM=j=c=Je([y],j);let F=g=class{static Min(...K){if(K.length===0)throw new TypeError;let me=K[0];for(let Te=1;Te<K.length;Te++){const Ye=K[Te];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...K){if(K.length===0)throw new TypeError;let me=K[0];for(let Te=1;Te<K.length;Te++){const Ye=K[Te];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(K){if(!K)return!1;if(K instanceof g)return!0;const{line:me,character:Te}=K;return typeof me=="number"&&typeof Te=="number"}static of(K){if(K instanceof g)return K;if(this.isPosition(K))return new g(K.line,K.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(K,me){if(K<0)throw(0,N.$7)("line must be non-negative");if(me<0)throw(0,N.$7)("character must be non-negative");this.c=K,this.e=me}isBefore(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<K.e}isBeforeOrEqual(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<=K.e}isAfter(K){return!this.isBeforeOrEqual(K)}isAfterOrEqual(K){return!this.isBefore(K)}isEqual(K){return this.c===K.c&&this.e===K.e}compareTo(K){return this.c<K.c?-1:this.c>K.line?1:this.e<K.e?-1:this.e>K.e?1:0}translate(K,me=0){if(K===null||me===null)throw(0,N.$7)();let Te;return typeof K>"u"?Te=0:typeof K=="number"?Te=K:(Te=typeof K.lineDelta=="number"?K.lineDelta:0,me=typeof K.characterDelta=="number"?K.characterDelta:0),Te===0&&me===0?this:new g(this.line+Te,this.character+me)}with(K,me=this.character){if(K===null||me===null)throw(0,N.$7)();let Te;return typeof K>"u"?Te=this.line:typeof K=="number"?Te=K:(Te=typeof K.line=="number"?K.line:this.line,me=typeof K.character=="number"?K.character:this.character),Te===this.line&&me===this.character?this:new g(Te,me)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=F,e.$SM=F=g=Je([y],F);let z=o=class{static isRange(K){return K instanceof o?!0:K?F.isPosition(K.start)&&F.isPosition(K.end):!1}static of(K){if(K instanceof o)return K;if(this.isRange(K))return new o(K.start,K.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(K,me,Te,Ye){let rt,dt;if(typeof K=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new F(K,me),dt=new F(Te,Ye)):F.isPosition(K)&&F.isPosition(me)&&(rt=F.of(K),dt=F.of(me)),!rt||!dt)throw new Error("Invalid arguments");rt.isBefore(dt)?(this.c=rt,this.e=dt):(this.c=dt,this.e=rt)}contains(K){return o.isRange(K)?this.contains(K.start)&&this.contains(K.end):F.isPosition(K)?!(F.of(K).isBefore(this.c)||this.e.isBefore(K)):!1}isEqual(K){return this.c.isEqual(K.c)&&this.e.isEqual(K.e)}intersection(K){const me=F.Max(K.start,this.c),Te=F.Min(K.end,this.e);if(!me.isAfter(Te))return new o(me,Te)}union(K){if(this.contains(K))return this;if(K.contains(this))return K;const me=F.Min(K.start,this.c),Te=F.Max(K.end,this.end);return new o(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(K,me=this.end){if(K===null||me===null)throw(0,N.$7)();let Te;return K?F.isPosition(K)?Te=K:(Te=K.start||this.start,me=K.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new o(Te,me)}toJSON(){return[this.start,this.end]}};e.$TM=z,e.$TM=z=o=Je([y],z);let O=n=class extends z{static isSelection(K){return K instanceof n?!0:K?z.isRange(K)&&F.isPosition(K.anchor)&&F.isPosition(K.active)&&typeof K.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(K,me,Te,Ye){let rt,dt;if(typeof K=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new F(K,me),dt=new F(Te,Ye)):F.isPosition(K)&&F.isPosition(me)&&(rt=F.of(K),dt=F.of(me)),!rt||!dt)throw new Error("Invalid arguments");super(rt,dt),this.f=rt,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=O,e.$UM=O=n=Je([y],O);const T=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$7)("connectionToken")};class B{static isResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.host=="string"&&typeof K.port=="number"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,me,Te){if(typeof K!="string"||K.length===0)throw(0,N.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,N.$7)("port");typeof Te<"u"&&T(Te),this.host=K,this.port=Math.round(me),this.connectionToken=Te}}e.$VM=B;class W{static isManagedResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.makeConnection=="function"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,me){this.makeConnection=K,this.connectionToken=me,typeof me<"u"&&T(me)}}e.$WM=W;class X extends Error{static NotAvailable(K,me){return new X(K,k.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(K){return new X(K,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(K,me=k.RemoteAuthorityResolverErrorCode.Unknown,Te){super(K),this._message=K,this._code=me,this._detail=Te,Object.setPrototypeOf(this,X.prototype)}}e.$XM=X;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var Z;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let Y=i=class{static isTextEdit(K){return K instanceof i?!0:K?z.isRange(K)&&typeof K.newText=="string":!1}static replace(K,me){return new i(K,me)}static insert(K,me){return i.replace(new z(K,K),me)}static delete(K){return i.replace(K,"")}static setEndOfLine(K){const me=new i(new z(new F(0,0),new F(0,0)),"");return me.newEol=K,me}get range(){return this.c}set range(K){if(K&&!z.isRange(K))throw(0,N.$7)("range");this.c=K}get newText(){return this.e||""}set newText(K){if(K&&typeof K!="string")throw(0,N.$7)("newText");this.e=K}get newEol(){return this.f}set newEol(K){if(K&&typeof K!="number")throw(0,N.$7)("newEol");this.f=K}constructor(K,me){this.c=K,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=Y,e.$YM=Y=i=Je([y],Y);let ce=r=class{static isNotebookCellEdit(K){return K instanceof r?!0:K?at.isNotebookRange(K)&&Array.isArray(K.newCells):!1}static replaceCells(K,me){return new r(K,me)}static insertCells(K,me){return new r(new at(K,K),me)}static deleteCells(K){return new r(K,[])}static updateCellMetadata(K,me){const Te=new r(new at(K,K),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(K){const me=new r(new at(0,0),[]);return me.newNotebookMetadata=K,me}constructor(K,me){this.range=K,this.newCells=me}};e.$ZM=ce,e.$ZM=ce=r=Je([y],ce);class ne{static isSnippetTextEdit(K){return K instanceof ne?!0:K?z.isRange(K.range)&&_.isSnippetString(K.snippet):!1}static replace(K,me){return new ne(K,me)}static insert(K,me){return ne.replace(new z(K,K),me)}constructor(K,me){this.range=K,this.snippet=me}}e.$1M=ne;var $e;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(K,me,Te,Ye){this.c.push({_type:1,from:K,to:me,options:Te,metadata:Ye})}createFile(K,me,Te){this.c.push({_type:1,from:void 0,to:K,options:me,metadata:Te})}deleteFile(K,me,Te){this.c.push({_type:1,from:K,to:void 0,options:me,metadata:Te})}e(K,me,Te){this.c.push({_type:3,metadata:Te,uri:K,edit:{editType:5,metadata:me},notebookMetadata:me})}f(K,me,Te,Ye){const rt=me.start,dt=me.end;(rt!==dt||Te.length>0)&&this.c.push({_type:5,uri:K,index:rt,count:dt-rt,cells:Te,metadata:Ye})}g(K,me,Te,Ye){this.c.push({_type:3,metadata:Ye,uri:K,edit:{editType:3,index:me,metadata:Te}})}replace(K,me,Te,Ye){this.c.push({_type:2,uri:K,edit:new Y(me,Te),metadata:Ye})}insert(K,me,Te,Ye){this.replace(K,new z(me,me),Te,Ye)}delete(K,me,Te){this.replace(K,me,"",Te)}has(K){return this.c.some(me=>me._type===2&&me.uri.toString()===K.toString())}set(K,me){if(me)for(const Te of me){if(!Te)continue;let Ye,rt;Array.isArray(Te)?(Ye=Te[0],rt=Te[1]):Ye=Te,ce.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(K,Ye.range.start,Ye.newCellMetadata,rt):Ye.newNotebookMetadata?this.e(K,Ye.newNotebookMetadata,rt):this.f(K,Ye.range,Ye.newCells,rt):ne.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:K,range:Ye.range,edit:Ye.snippet,metadata:rt}):this.c.push({_type:2,uri:K,edit:Ye,metadata:rt})}else{for(let Te=0;Te<this.c.length;Te++){const Ye=this.c[Te];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===K.toString()&&(this.c[Te]=void 0);break}}(0,u.$Ib)(this.c)}}get(K){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===K.toString()&&me.push(Te.edit);return me}entries(){const K=new R.$Bc;for(const me of this.c)if(me._type===2){let Te=K.get(me.uri);Te||(Te=[me.uri,[]],K.set(me.uri,Te)),Te[1].push(me.edit)}return[...K.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Pe,e.$2M=Pe=Je([y],Pe);let _=s=class{static isSnippetString(K){return K instanceof s?!0:K?typeof K.value=="string":!1}static c(K){return K.replace(/\$|}|\\/g,"\\$&")}constructor(K){this.e=1,this.value=K||""}appendText(K){return this.value+=s.c(K),this}appendTabstop(K=this.e++){return this.value+="$",this.value+=K,this}appendPlaceholder(K,me=this.e++){if(typeof K=="function"){const Te=new s;Te.e=this.e,K(Te),this.e=Te.e,K=Te.value}else K=s.c(K);return this.value+="${",this.value+=me,this.value+=":",this.value+=K,this.value+="}",this}appendChoice(K,me=this.e++){const Te=K.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(K,me){if(typeof me=="function"){const Te=new s;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=K,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$3M=_,e.$3M=_=s=Je([y],_);var U;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ie;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let be=t=class{static isLocation(K){return K instanceof t?!0:K?z.isRange(K.range)&&S.URI.isUri(K.uri):!1}constructor(K,me){if(this.uri=K,me)if(z.isRange(me))this.range=z.of(me);else if(F.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=be,e.$4M=be=t=Je([y],be);let Ce=class{static is(K){return K?typeof K.message=="string"&&K.location&&z.isRange(K.location.range)&&S.URI.isUri(K.location.uri):!1}constructor(K,me){this.location=K,this.message=me}static isEqual(K,me){return K===me?!0:!K||!me?!1:K.message===me.message&&K.location.range.isEqual(me.location.range)&&K.location.uri.toString()===me.location.uri.toString()}};e.$5M=Ce,e.$5M=Ce=Je([y],Ce);let oe=class{constructor(K,me,Te=ie.Error){if(!z.isRange(K))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=K,this.message=me,this.severity=Te}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(K,me){return K===me?!0:!K||!me?!1:K.message===me.message&&K.severity===me.severity&&K.code===me.code&&K.severity===me.severity&&K.source===me.source&&K.range.isEqual(me.range)&&(0,u.$ub)(K.tags,me.tags)&&(0,u.$ub)(K.relatedInformation,me.relatedInformation,Ce.isEqual)}};e.$6M=oe,e.$6M=oe=Je([y],oe);let ae=class{constructor(K,me){if(!K)throw new Error("Illegal argument, contents must be defined");Array.isArray(K)?this.contents=K:this.contents=[K],this.range=me}};e.$7M=ae,e.$7M=ae=Je([y],ae);var re;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let G=class{constructor(K,me=re.Text){this.range=K,this.kind=me}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$8M=G,e.$8M=G=Je([y],G);let te=class{constructor(K,me){this.uri=K,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(K=>K.toJSON())}}};e.$9M=te,e.$9M=te=Je([y],te);var ge;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(ge||(e.SymbolKind=ge={}));var we;(function(H){H[H.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Re=f=class{static validate(K){if(!K.name)throw new Error("name must not be falsy")}constructor(K,me,Te,Ye,rt){this.name=K,this.kind=me,this.containerName=rt,typeof Te=="string"&&(this.containerName=Te),Ye instanceof be?this.location=Ye:Te instanceof z&&(this.location=new be(Ye,Te)),f.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Re,e.$0M=Re=f=Je([y],Re);let fe=d=class{static validate(K){if(!K.name)throw new Error("name must not be falsy");if(!K.range.contains(K.selectionRange))throw new Error("selectionRange must be contained in fullRange");K.children?.forEach(d.validate)}constructor(K,me,Te,Ye,rt){this.name=K,this.detail=me,this.kind=Te,this.range=Ye,this.selectionRange=rt,this.children=[],d.validate(this)}};e.$$M=fe,e.$$M=fe=d=Je([y],fe);var Se;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Se||(e.CodeActionTriggerKind=Se={}));let Ae=class{constructor(K,me){this.title=K,this.kind=me}};e.$_M=Ae,e.$_M=Ae=Je([y],Ae);let je=class{static{l=this}static{this.c="."}constructor(K){this.value=K}append(K){return new l(this.value?this.value+l.c+K:K)}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+l.c)}};e.$aN=je,e.$aN=je=l=Je([y],je),je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorMove=je.Refactor.append("move"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll"),je.Notebook=je.Empty.append("notebook");let q=class{constructor(K,me){if(this.range=K,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=q,e.$bN=q=Je([y],q);class V{constructor(K,me,Te,Ye,rt,dt){this.kind=K,this.name=me,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=dt}}e.$cN=V;class Q{constructor(K,me){this.fromRanges=me,this.from=K}}e.$dN=Q;class J{constructor(K,me){this.fromRanges=me,this.to=K}}e.$eN=J;var he;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(he||(e.LanguageStatusSeverity=he={}));let pe=class{constructor(K,me){this.range=K,this.command=me}get isResolved(){return!!this.command}};e.$fN=pe,e.$fN=pe=Je([y],pe);let ze=a=class{#e;static isMarkdownString(K){return K instanceof a?!0:K&&K.appendCodeblock&&K.appendMarkdown&&K.appendText&&K.value!==void 0}constructor(K,me=!1){this.#e=new L.$Nk(K,{supportThemeIcons:me})}get value(){return this.#e.value}set value(K){this.#e.value=K}get isTrusted(){return this.#e.isTrusted}set isTrusted(K){this.#e.isTrusted=K}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(K){this.#e.supportThemeIcons=K}get supportHtml(){return this.#e.supportHtml}set supportHtml(K){this.#e.supportHtml=K}get baseUri(){return this.#e.baseUri}set baseUri(K){this.#e.baseUri=K}appendText(K){return this.#e.appendText(K),this}appendMarkdown(K){return this.#e.appendMarkdown(K),this}appendCodeblock(K,me){return this.#e.appendCodeblock(me??"",K),this}};e.$gN=ze,e.$gN=ze=a=Je([y],ze);let Ve=class{constructor(K,me){this.label=K,this.documentation=me}};e.$hN=Ve,e.$hN=Ve=Je([y],Ve);let Xe=class{constructor(K,me){this.label=K,this.documentation=me,this.parameters=[]}};e.$iN=Xe,e.$iN=Xe=Je([y],Xe);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=tt,e.$jN=tt=Je([y],tt);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var it;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let st=class{constructor(K){this.value=K}};e.$kN=st,e.$kN=st=Je([y],st);let De=class{constructor(K,me,Te){this.position=K,this.label=me,this.kind=Te}};e.$lN=De,e.$lN=De=Je([y],De);var Be;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var He;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var Le;(function(H){H[H.Deprecated=1]="Deprecated"})(Le||(e.CompletionItemTag=Le={}));let Ze=class{constructor(K,me){this.label=K,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=Ze,e.$mN=Ze=Je([y],Ze);let se=class{constructor(K=[],me=!1){this.items=K,this.isIncomplete=me}};e.$nN=se,e.$nN=se=Je([y],se);let ue=class{constructor(K,me,Te){this.insertText=K,this.range=me,this.command=Te}};e.$oN=ue,e.$oN=ue=Je([y],ue);let Ie=class{constructor(K){this.commands=void 0,this.suppressSuggestions=void 0,this.items=K}};e.$pN=Ie,e.$pN=Ie=Je([y],Ie);var Ge;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(Ge||(e.PartialAcceptTriggerKind=Ge={}));var Me;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(Me||(e.ViewColumn=Me={}));var nt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function lt(H,K){return`${C.$Lm.toKey(H)}.${K}`}var yt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var At;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var Ft;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var Qt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var xt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var Dt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(H){function K(me){switch(me){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=K}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var qt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(qt||(e.SyntaxTokenType=qt={})),function(H){function K(me){switch(me){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=K}(qt||(e.SyntaxTokenType=qt={}));let Xt=class{constructor(K,me){if(me&&!S.URI.isUri(me))throw(0,N.$7)("target");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.target=me}};e.$rN=Xt,e.$rN=Xt=Je([y],Xt);let et=class{constructor(K,me,Te,Ye){this.red=K,this.green=me,this.blue=Te,this.alpha=Ye}};e.$sN=et,e.$sN=et=Je([y],et);let ri=class{constructor(K,me){if(me&&!(me instanceof et))throw(0,N.$7)("color");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.color=me}};e.$tN=ri,e.$tN=ri=Je([y],ri);let _t=class{constructor(K){if(!K||typeof K!="string")throw(0,N.$7)("label");this.label=K}};e.$uN=_t,e.$uN=_t=Je([y],_t);var ft;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(ft||(e.ColorFormat=ft={}));var $t;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var ei;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ei||(e.TerminalExitReason=ei={}));var Zt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(Zt||(e.TerminalShellExecutionCommandLineConfidence=Zt={}));class zt{constructor(K,me,Te){if(this.startIndex=K,this.length=me,this.tooltip=Te,typeof K!="number"||K<0)throw(0,N.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,N.$7)("length");if(Te!==void 0&&typeof Te!="string")throw(0,N.$7)("tooltip")}}e.$vN=zt;class gt{constructor(K){this.uri=K}}e.$wN=gt;class Ut{constructor(K){this.terminalCommand=K}}e.$xN=Ut;var Yt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Yt||(e.TerminalLocation=Yt={}));class Bt{constructor(K){if(this.options=K,typeof K!="object")throw(0,N.$7)("options")}}e.$yN=Bt;var xe;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(xe||(e.TaskRevealKind=xe={}));var oi;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Vt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(K){switch(K){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(K,me){if(this.label=me,typeof K!="string"||typeof me!="string")throw(0,N.$7)("name");this.c=K}get id(){return this.c}};e.$zN=Vt,e.$zN=Vt=h=Je([y],Vt);function Kt(H){let K="";for(let me=0;me<H.length;me++)K+=H[me].replace(/,/g,",,")+",";return K}let mt=class{constructor(K,me,Te){if(typeof K!="string")throw(0,N.$7)("process");this.e=[],this.c=K,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(K){if(typeof K!="string")throw(0,N.$7)("process");this.c=K}get args(){return this.e}set args(K){Array.isArray(K)||(K=[]),this.e=K}get options(){return this.f}set options(K){this.f=K}computeId(){const K=[];if(K.push("process"),this.c!==void 0&&K.push(this.c),this.e&&this.e.length>0)for(const me of this.e)K.push(me);return Kt(K)}};e.$AN=mt,e.$AN=mt=Je([y],mt);let Rt=class{constructor(K,me,Te){if(this.f=[],Array.isArray(me)){if(!K)throw(0,N.$7)("command can't be undefined or null");if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K,this.f=me,this.g=Te}else{if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K,this.g=me}}get commandLine(){return this.c}set commandLine(K){if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K}get command(){return this.e?this.e:""}set command(K){if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K}get args(){return this.f}set args(K){this.f=K||[]}get options(){return this.g}set options(K){this.g=K}computeId(){const K=[];if(K.push("shell"),this.c!==void 0&&K.push(this.c),this.e!==void 0&&K.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)K.push(typeof me=="string"?me:me.value);return Kt(K)}};e.$BN=Rt,e.$BN=Rt=Je([y],Rt);var Ot;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Ot||(e.ShellQuoting=Ot={}));var Nt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Nt||(e.TaskScope=Nt={}));class ti{constructor(K){this.c=K}computeId(){return"customExecution"+(0,A.$Mg)()}set callback(K){this.c=K}get callback(){return this.c}}e.$CN=ti;let Ht=class{static{m=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(K,me,Te,Ye,rt,dt){this.k=!1,this.l=this.definition=K;let pt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Te,this.execution=Ye,pt=rt,this.k=!0):me===Nt.Global||me===Nt.Workspace?(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=rt,pt=dt):(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=rt,pt=dt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(K){this.j=K}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof mt?this.l={type:m.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:m.f,id:this.q.computeId()}:this.q instanceof ti?this.l={type:m.c,id:this.q.computeId()}:this.l={type:m.g,id:(0,A.$Mg)()}}get definition(){return this.l}set definition(K){if(K==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=K}get scope(){return this.m}set target(K){this.B(),this.m=K}get name(){return this.o}set name(K){if(typeof K!="string")throw(0,N.$7)("name");this.B(),this.o=K}get execution(){return this.q}set execution(K){K===null&&(K=void 0),this.B(),this.q=K;const me=this.l.type;(m.g===me||m.e===me||m.f===me||m.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(K){if(Array.isArray(K))this.B(),this.r=K,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(K){K!==!0&&K!==!1&&(K=!1),this.B(),this.u=K}get source(){return this.w}set source(K){if(typeof K!="string"||K.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=K}get group(){return this.x}set group(K){K===null&&(K=void 0),this.B(),this.x=K}get detail(){return this.A}set detail(K){K===null&&(K=void 0),this.A=K}get presentationOptions(){return this.y}set presentationOptions(K){K==null&&(K=Object.create(null)),this.B(),this.y=K}get runOptions(){return this.z}set runOptions(K){K==null&&(K=Object.create(null)),this.B(),this.z=K}};e.$DN=Ht,e.$DN=Ht=m=Je([y],Ht);var si;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(si||(e.ProgressLocation=si={}));var Mt;(function(H){function K(me){const Te=me;return(0,b.$8f)(Te.value)?Te.tooltip&&!(0,b.$4f)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}H.isViewBadge=K})(Mt||(e.ViewBadge=Mt={}));let Tt=D=class{static isTreeItem(K,me){const Te=K;if(Te.checkboxState!==void 0){const Ye=(0,b.$8f)(Te.checkboxState)?Te.checkboxState:(0,b.$6f)(Te.checkboxState)&&(0,b.$8f)(Te.checkboxState.state)?Te.checkboxState.state:void 0,rt=!(0,b.$8f)(Te.checkboxState)&&(0,b.$6f)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==It.Checked&&Ye!==It.Unchecked||rt!==void 0&&!(0,b.$4f)(rt))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(K instanceof D)return!0;if(Te.label!==void 0&&!(0,b.$4f)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,b.$4f)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,b.$4f)(Te.iconPath)&&!S.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,b.$4f)(Te.iconPath.id))){const Ye=Te.iconPath;if(!Ye||!(0,b.$4f)(Ye.light)&&!S.URI.isUri(Ye.light)&&!(0,b.$4f)(Ye.dark)&&!S.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,b.$4f)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!S.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,b.$4f)(Te.tooltip)&&!(Te.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<Pt.None&&Te.collapsibleState>Pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,b.$4f)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(K,me=Pt.None){this.collapsibleState=me,S.URI.isUri(K)?this.resourceUri=K:this.label=K}};e.$EN=Tt,e.$EN=Tt=D=Je([y],Tt);var Pt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Pt||(e.TreeItemCollapsibleState=Pt={}));var It;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(K){this.value=K}};e.$FN=bt,e.$FN=bt=Je([y],bt);class Ct extends bt{}e.$GN=Ct;class li extends Ct{#e;constructor(K){super(""),this.#e=K}asFile(){return this.#e}}e.$HN=li;class St{constructor(K,me,Te,Ye){this.name=K,this.uri=me,this._itemId=Te,this.c=Ye}data(){return this.c()}}e.$IN=St;let hi=class{#e=new Map;constructor(K){for(const[me,Te]of K??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Te):this.#e.set(this.#t(me),[Te])}}get(K){return this.#e.get(this.#t(K))?.[0]}set(K,me){this.#e.set(this.#t(K),[me])}forEach(K,me){for(const[Te,Ye]of this.#e)for(const rt of Ye)K.call(me,rt,Te,this)}*[Symbol.iterator](){for(const[K,me]of this.#e)for(const Te of me)yield[K,Te]}#t(K){return K.toLowerCase()}};e.$JN=hi,e.$JN=hi=Je([y],hi);let Gt=class{constructor(K,me,Te){this.insertText=K,this.title=me,this.kind=Te}};e.$KN=Gt,e.$KN=Gt=Je([y],Gt);var wi;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class ii{static{this.c="."}constructor(K){this.value=K}append(...K){return new ii((this.value?[this.value,...K]:K).join(ii.c))}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+ii.c)}}e.$LN=ii,ii.Empty=new ii("");class vi{constructor(K,me,Te){this.title=me,this.insertText=K,this.kind=Te}}e.$MN=vi;let kt=class{constructor(K,me){this.id=K,this.color=me}static isThemeIcon(K){return typeof K.id!="string"?(console.log("INVALID ThemeIcon, invalid id",K.id),!1):!0}};e.$NN=kt,e.$NN=kt=Je([y],kt),kt.File=new kt("file"),kt.Folder=new kt("folder");let $i=class{constructor(K){this.id=K}};e.$ON=$i,e.$ON=$i=Je([y],$i);var Ne;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Ne||(e.ConfigurationTarget=Ne={}));let Fe=class{get base(){return this.c}set base(K){this.c=K,this.e=S.URI.file(K)}get baseUri(){return this.e}set baseUri(K){this.e=K,this.c=K.fsPath}constructor(K,me){if(typeof K!="string"&&(!K||!S.URI.isUri(K)&&!S.URI.isUri(K.uri)))throw(0,N.$7)("base");if(typeof me!="string")throw(0,N.$7)("pattern");typeof K=="string"?this.baseUri=S.URI.file(K):S.URI.isUri(K)?this.baseUri=K:this.baseUri=K.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=Fe,e.$PN=Fe=Je([y],Fe);const ye=new WeakMap;function ee(H,K){ye.set(H,K)}let Oe=class{constructor(K,me,Te,Ye,rt){this.enabled=typeof K=="boolean"?K:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ye=="string"&&(this.logMessage=Ye),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=ye.get(this)??(0,A.$Mg)()),this.c}};e.$RN=Oe,e.$RN=Oe=Je([y],Oe);let Ke=class extends Oe{constructor(K,me,Te,Ye,rt,dt){if(super(me,Te,Ye,rt,dt),K===null)throw(0,N.$7)("location");this.location=K}};e.$SN=Ke,e.$SN=Ke=Je([y],Ke);let _e=class extends Oe{constructor(K,me,Te,Ye,rt,dt){super(me,Te,Ye,rt,dt),this.functionName=K}};e.$TN=_e,e.$TN=_e=Je([y],_e);let Qe=class extends Oe{constructor(K,me,Te,Ye,rt,dt,pt,Jt){if(super(Ye,rt,dt,pt,Jt),!me)throw(0,N.$7)("dataId");this.label=K,this.dataId=me,this.canPersist=Te}};e.$UN=Qe,e.$UN=Qe=Je([y],Qe);let ht=class{constructor(K,me,Te){this.command=K,this.args=me||[],this.options=Te}};e.$VN=ht,e.$VN=ht=Je([y],ht);let Et=class{constructor(K,me){this.port=K,this.host=me}};e.$WN=Et,e.$WN=Et=Je([y],Et);let jt=class{constructor(K){this.path=K}};e.$XN=jt,e.$XN=jt=Je([y],jt);let Wt=class{constructor(K){this.implementation=K}};e.$YN=Wt,e.$YN=Wt=Je([y],Wt);class ut{constructor(K,me,Te){this.session=K,this.threadId=me,this.frameId=Te}}e.$ZN=ut;class ni{constructor(K,me){this.session=K,this.threadId=me}}e.$1N=ni;let di=class{constructor(K,me){this.range=K,this.expression=me}};e.$2N=di,e.$2N=di=Je([y],di);var bi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(bi||(e.InlineCompletionTriggerKind=bi={}));let Di=class{constructor(K,me){this.range=K,this.text=me}};e.$3N=Di,e.$3N=Di=Je([y],Di);let Ri=class{constructor(K,me,Te=!0){this.range=K,this.variableName=me,this.caseSensitiveLookup=Te}};e.$4N=Ri,e.$4N=Ri=Je([y],Ri);let Mi=class{constructor(K,me){this.range=K,this.expression=me}};e.$5N=Mi,e.$5N=Mi=Je([y],Mi);let Li=class{constructor(K,me){this.frameId=K,this.stoppedLocation=me}};e.$6N=Li,e.$6N=Li=Je([y],Li);var Ni;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Ni||(e.NewSymbolNameTag=Ni={}));class cn{constructor(K,me){this.newSymbolName=K,this.tags=me}}e.$7N=cn;var Oi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Ti=p=class extends Error{static FileExists(K){return new p(K,$.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(K){return new p(K,$.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(K){return new p(K,$.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(K){return new p(K,$.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(K){return new p(K,$.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(K){return new p(K,$.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(K,me=$.FileSystemProviderErrorCode.Unknown,Te){super(S.URI.isUri(K)?K.toString(!0):K),this.code=Te?.name??"Unknown",(0,$.$_k)(this,me),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$8N=Ti,e.$8N=Ti=p=Je([y],Ti);let yi=class{constructor(K,me,Te){this.start=K,this.end=me,this.kind=Te}};e.$9N=yi,e.$9N=yi=Je([y],yi);var Ci;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var Hi;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Gi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var pi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(pi||(e.CommentState=pi={}));var Ji;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(K,me=[]){this.tokenTypes=K,this.tokenModifiers=me}}e.$0N=un;function ji(H){return typeof H>"u"||(0,b.$5f)(H)}class Fi{constructor(K){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,K){this.m=!0;for(let me=0,Te=K.tokenTypes.length;me<Te;me++)this.k.set(K.tokenTypes[me],me);for(let me=0,Te=K.tokenModifiers.length;me<Te;me++)this.l.set(K.tokenModifiers[me],me)}}push(K,me,Te,Ye,rt){if(typeof K=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(K,me,Te,Ye,rt);if(z.isRange(K)&&typeof me=="string"&&ji(Te))return this.o(K,me,Te);throw(0,N.$7)()}o(K,me,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(K.start.line!==K.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=K.start.line,rt=K.start.character,dt=K.end.character-K.start.character,pt=this.k.get(me);let Jt=0;if(Te)for(const ui of Te){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ui);Jt|=1<<fi>>>0}this.q(Ye,rt,dt,pt,Jt)}q(K,me,Te,Ye,rt){if(this.f&&(K<this.c||K===this.c&&me<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ui=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],Vi=this.g[5*gi+1];mi===0?(mi=ui,Vi+=fi):mi+=ui,this.g[5*gi]=mi,this.g[5*gi+1]=Vi,ui=mi,fi=Vi}}let dt=K,pt=me;this.f&&this.j>0&&(dt-=this.c,dt===0&&(pt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=pt,this.g[this.j++]=Te,this.g[this.j++]=Ye,this.g[this.j++]=rt,this.c=K,this.e=me}static r(K){const me=[],Te=K.length/5|0;for(let pt=0;pt<Te;pt++)me[pt]=pt;me.sort((pt,Jt)=>{const ui=K[5*pt],fi=K[5*Jt];if(ui===fi){const gi=K[5*pt+1],mi=K[5*Jt+1];return gi-mi}return ui-fi});const Ye=new Uint32Array(K.length);let rt=0,dt=0;for(let pt=0;pt<Te;pt++){const Jt=5*me[pt],ui=K[Jt+0],fi=K[Jt+1],gi=K[Jt+2],mi=K[Jt+3],Vi=K[Jt+4],Mn=ui-rt,ar=Mn===0?fi-dt:fi,Ki=5*pt;Ye[Ki+0]=Mn,Ye[Ki+1]=ar,Ye[Ki+2]=gi,Ye[Ki+3]=mi,Ye[Ki+4]=Vi,rt=ui,dt=fi}return Ye}build(K){return this.f?new Pi(new Uint32Array(this.g),K):new Pi(Fi.r(this.g),K)}}e.$$N=Fi;class Pi{constructor(K,me){this.resultId=me,this.data=K}}e.$_N=Pi;class ln{constructor(K,me,Te){this.start=K,this.deleteCount=me,this.data=Te}}e.$aO=ln;class Xi{constructor(K,me){this.resultId=me,this.edits=K}}e.$bO=Xi;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class hn{constructor(K){this.name=K}}e.$cO=hn;let zi=class{static{this.Back={iconPath:new kt("arrow-left")}}constructor(){}};e.$dO=zi,e.$dO=zi=Je([y],zi);var Yi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Ii;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Ii||(e.InputBoxValidationSeverity=Ii={}));var Bi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Bi||(e.ExtensionKind=Bi={}));class We{static validate(K){if(typeof K.badge=="string"){let me=(0,w.$Df)(K.badge,0);if(me<K.badge.length&&(me+=(0,w.$Df)(K.badge,me)),K.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(K.badge&&!kt.isThemeIcon(K.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!K.color&&!K.badge&&!K.tooltip)throw new Error("The decoration is empty");return!0}constructor(K,me,Te){this.badge=K,this.tooltip=me,this.color=Te}}e.$eO=We;let ai=class{constructor(K){this.kind=K}};e.$fO=ai,e.$fO=ai=Je([y],ai);var Ui;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class at{static isNotebookRange(K){return K instanceof at?!0:K?typeof K.start=="number"&&typeof K.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(K,me){if(K<0)throw(0,N.$7)("start must be positive");if(me<0)throw(0,N.$7)("end must be positive");K<=me?(this.c=K,this.e=me):(this.c=me,this.e=K)}with(K){let me=this.c,Te=this.e;return K.start!==void 0&&(me=K.start),K.end!==void 0&&(Te=K.end),me===this.c&&Te===this.e?this:new at(me,Te)}}e.$gO=at;class wt{static validate(K){if(typeof K.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof K.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof K.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(K){return Array.isArray(K)&&K.every(me=>wt.isNotebookCellData(me))}static isNotebookCellData(K){return!0}constructor(K,me,Te,Ye,rt,dt,pt){this.kind=K,this.value=me,this.languageId=Te,this.mime=Ye,this.outputs=rt??[],this.metadata=dt,this.executionSummary=pt,wt.validate(this)}}e.$hO=wt;class dn{constructor(K){this.cells=K}}e.$iO=dn;class ci{static isNotebookCellOutputItem(K){return K instanceof ci?!0:K?typeof K.mime=="string"&&K.data instanceof Uint8Array:!1}static error(K){const me={name:K.name,message:K.message,stack:K.stack};return ci.json(me,"application/vnd.code.notebook.error")}static stdout(K){return ci.text(K,"application/vnd.code.notebook.stdout")}static stderr(K){return ci.text(K,"application/vnd.code.notebook.stderr")}static bytes(K,me="application/octet-stream"){return new ci(K,me)}static#e=new TextEncoder;static text(K,me=M.$Hs.text){const Te=ci.#e.encode(String(K));return new ci(Te,me)}static json(K,me="text/x-json"){const Te=JSON.stringify(K,void 0,"	");return ci.text(Te,me)}constructor(K,me){this.data=K,this.mime=me;const Te=(0,M.$Ls)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$jO=ci;class ki{static isNotebookCellOutput(K){return K instanceof ki?!0:!K||typeof K!="object"?!1:typeof K.id=="string"&&Array.isArray(K.items)}static ensureUniqueMimeTypes(K,me=!1){const Te=new Set,Ye=new Set;for(let rt=0;rt<K.length;rt++){const dt=K[rt],pt=(0,M.$Ls)(dt.mime);if(!Te.has(pt)||(0,v.$MK)(pt)){Te.add(pt);continue}Ye.add(rt),me&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ye.size===0?K:K.filter((rt,dt)=>!Ye.has(dt))}constructor(K,me,Te){this.items=ki.ensureUniqueMimeTypes(K,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,A.$Mg)(),this.metadata=me??Te)}}e.$kO=ki;var xi;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Ei;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var _i;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(K,me){this.text=K,this.alignment=me}}e.$lO=fn;var Wi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(K,me=[]){this.uri=K,this.provides=(0,u.$3b)(me)}}e.$mO=gn;class mn{constructor(K){this.label=K}}e.$nO=mn;var nn;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let qi=class{constructor(K,me){this.label=K,this.timestamp=me}};e.$oO=qi,e.$oO=qi=Je([y],qi);var rn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(K,me){this.ranges=K,this.wordPattern=me}}e.$pO=$n;class bn{constructor(K){this.c=K}get autoForwardAction(){return this.c}}e.$qO=bn;var an;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var de;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(de||(e.TestRunProfileKind=de={}));let ve=class{constructor(K=void 0,me=void 0,Te=void 0,Ye=!1){this.include=K,this.exclude=me,this.profile=Te,this.continuous=Ye}};e.$rO=ve,e.$rO=ve=Je([y],ve);let Ue=E=class{static diff(K,me,Te){const Ye=new E(K);return Ye.expectedOutput=me,Ye.actualOutput=Te,Ye}constructor(K){this.message=K}};e.$sO=Ue,e.$sO=Ue=E=Je([y],Ue);let ct=class{constructor(K){this.id=K}};e.$tO=ct,e.$tO=ct=Je([y],ct);class vt{constructor(K,me){this.covered=K,this.total=me,Lt(this)}}e.$uO=vt;function Lt(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class Si{static fromDetails(K,me){const Te=new vt(0,0),Ye=new vt(0,0),rt=new vt(0,0);for(const pt of me)if("branches"in pt){Te.total+=1,Te.covered+=pt.executed?1:0;for(const Jt of pt.branches)Ye.total+=1,Ye.covered+=Jt.executed?1:0}else rt.total+=1,rt.covered+=pt.executed?1:0;const dt=new Si(K,Te,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return dt.detailedCoverage=me,dt}constructor(K,me,Te,Ye){this.uri=K,this.statementCoverage=me,this.branchCoverage=Te,this.declarationCoverage=Ye}}e.$wO=Si;class Ln{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Te=[]){this.executed=K,this.location=me,this.branches=Te}}e.$xO=Ln;class Nn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Te){this.executed=K,this.location=me,this.label=Te}}e.$yO=Nn;class On{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Te){this.name=K,this.executed=me,this.location=Te}}e.$zO=On;var pn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var wn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class Tn{constructor(K,me,Te,Ye,rt,dt){this.kind=K,this.name=me,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=dt}}e.$AO=Tn;class jn{constructor(K){this.uri=K}}e.$BO=jn;class Fn{constructor(K,me){this.original=K,this.modified=me}}e.$CO=Fn;class zn{constructor(K,me,Te,Ye){this.base=K,this.input1=me,this.input2=Te,this.result=Ye}}e.$DO=zn;class Bn{constructor(K,me){this.uri=K,this.viewType=me}}e.$EO=Bn;class Un{constructor(K){this.viewType=K}}e.$FO=Un;class Wn{constructor(K,me){this.uri=K,this.notebookType=me}}e.$GO=Wn;class qn{constructor(K,me,Te){this.original=K,this.modified=me,this.notebookType=Te}}e.$HO=qn;class Vn{constructor(){}}e.$IO=Vn;class Kn{constructor(K,me){this.uri=K,this.inputBoxUri=me}}e.$JO=Kn;class Hn{constructor(){}}e.$KO=Hn;class Gn{constructor(K){this.textDiffs=K}}e.$LO=Gn;var yn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Jn{constructor(K,me){this.label=K,this.values=me}}e.$MO=Jn;var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var Dn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Qn{constructor(K){this.value=typeof K=="string"?new ze(K):K}}e.$NO=Qn;class Xn{constructor(K,me){this.value=K,this.baseUri=me}}e.$OO=Xn;class Zn{constructor(K,me){this.value=K,this.title=me}}e.$PO=Zn;class Yn{constructor(K){this.value=K}}e.$QO=Yn;class xn{constructor(K){this.value=K}}e.$RO=xn;class _n{constructor(K){this.value=K}}e.$SO=_n;class er{constructor(K,me){this.uri=K,this.edits=Array.isArray(me)?me:[me]}}e.$TO=er;class tr{constructor(K,me,Te,Ye){this.prompt=K,this.command=me,this.variables=Te,this.participant=Ye}}e.$UO=tr;class ir{constructor(K,me,Te,Ye){this.response=K,this.result=me,this.participant=Te,this.command=Ye}}e.$VO=ir;var Cn;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Cn||(e.ChatLocation=Cn={}));class nr{constructor(K){this.content=K}}e.$WO=nr;class rr{constructor(K,me){this.content=K,this.name=me}}e.$XO=rr;class sr{constructor(K,me){this.content=K,this.name=me}}e.$YO=sr;class Ai extends Error{static NotFound(K){return new Ai(K,Ai.NotFound.name)}static NoPermissions(K){return new Ai(K,Ai.NoPermissions.name)}constructor(K,me,Te){super(K,{cause:Te}),this.name="LanguageModelError",this.code=me??""}}e.$ZO=Ai;var Pn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var In;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(In||(e.SpeechToTextStatus=In={}));var An;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class or{constructor(K,me){this.text=K,this.range=me}}e.$1O=or;var Rn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(ke[324],Ee([1,0,6,7]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,w,b){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(M);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(w,b)??[]}getRelatedInformation(M,w,b){return this.c.$getAiRelatedInformation(w,b)}registerRelatedInformationProvider(M,w,b){const S=this.b;return this.b++,this.a.set(S,b),this.c.$registerAiRelatedInformationProvider(S,w),new N.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$2jc=L}),define(ke[120],Ee([1,0,4,6,7,25,145,5,20]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=e.$akc=void 0,e.$akc=(0,w.$qi)("IExtHostAuthentication");let S=class{constructor($){this.b=new Map,this.c=new u.$be,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=$.getProxy(N.$PM.MainThreadAuthentication)}async getSession($,k,v,c={}){const g=R.$Lm.toKey($.identifier),o=[...v].sort().join(" ");return await this.d.getOrCreate(`${g} ${k} ${o}`,async()=>{await this.a.$ensureProvider(k);const n=$.displayName||$.name;return this.a.$getSession(k,v,g,n,c)})}async getSessions($,k,v){const c=R.$Lm.toKey($.identifier),g=[...v].sort().join(" ");return await this.f.getOrCreate(`${c} ${g}`,async()=>{await this.a.$ensureProvider(k);const o=$.displayName||$.name;return this.a.$getSessions(k,v,c,o)})}async removeSession($,k){const v=this.b.get($);return v?v.provider.removeSession(k):this.a.$removeSession($,k)}registerAuthenticationProvider($,k,v,c){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:k,provider:v,options:c??{supportsMultipleAccounts:!1}});const g=v.onDidChangeSessions(o=>this.a.$sendDidChangeSessions($,o));return this.a.$registerAuthenticationProvider($,k,c?.supportsMultipleAccounts??!1),new L.$RM(()=>{g.dispose(),this.b.delete($),this.a.$unregisterAuthenticationProvider($)})}$createSession($,k,v){const c=this.b.get($);if(c)return Promise.resolve(c.provider.createSession(k,v));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,k){const v=this.b.get($);if(v)return Promise.resolve(v.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,k){const v=this.b.get($);if(v)return Promise.resolve(v.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,k){return $.startsWith(M.$RL)||this.c.fire({provider:{id:$,label:k}}),Promise.resolve()}};e.$bkc=S,e.$bkc=S=Je([qe(0,b.$aP)],S);class A{constructor(){this.a=new Map}getOrCreate($,k){const v=this.a.get($);if(v)return v;const c=k().finally(()=>this.a.delete($));return this.a.set($,c),c}}}),define(ke[151],Ee([1,0,2,6,7,5,20,12,19,14,17,26]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=void 0;let k=class{static{$=this}static{this.c=0}static{this.d=250}constructor(c,g){this.h=g,this.f=new Map,this.g=c.getProxy(N.$PM.MainThreadDecorations)}registerFileDecorationProvider(c,g){const o=$.c++;this.f.set(o,{provider:c,extensionDescription:g}),this.g.$registerDecorationProvider(o,g.identifier.value);const n=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,b.$3b)(i);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,S.$9e)(d.path,"/")})),t=(0,b.$zb)(s,(d,l)=>d.rank-l.rank||(0,S.$mf)(d.uri.path,l.uri.path)),f=[];e:for(const d of t){let l;for(const a of d){const h=(0,A.$nc)(a.uri.path);if(l!==h&&(l=h,f.push(a.uri)>=$.d))break e}}this.g.$onDidChange(o,f)});return new L.$RM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(c,g,o){if(!this.f.has(c))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(c);return await Promise.all(g.map(async s=>{try{const{uri:t,id:f}=s,d=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),o));if(!d)return;try{L.$eO.validate(d),d.badge&&typeof d.badge!="string"&&(0,C.$yG)(r,"codiconDecoration"),n[f]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$alc=k,e.$alc=k=$=Je([qe(0,M.$aP),qe(1,w.$Wj)],k),e.$blc=(0,R.$qi)("IExtHostDecorations")}),define(ke[325],Ee([1,0,13,2,7,6,15,22,14]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class S{static{this.a=0}constructor(C,$,k){this.d=$,this.e=k,this.b=new Map,this.c=C.getProxy(R.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,$){if(Object.keys(M.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const k=S.a++;this.b.set(k,$),this.c.$registerTextContentProvider(k,C);let v;if(typeof $.onDidChange=="function"){let c;v=$.onDidChange(async g=>{if(g.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;c&&await c;const o=this.$provideTextDocumentContent(k,g).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(g);if(!i)return;const r=(0,b.$gf)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(g,n)}).catch(u.$1).finally(()=>{c===o&&(c=void 0)});c=o})}return new L.$RM(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(C,$){const k=this.b.get(C);return k?Promise.resolve(k.provideTextDocumentContent(N.URI.revive($),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$dlc=S}),define(ke[152],Ee([1,0,62,15,14,183,129,7,19]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0,e.$cP=A;const S=new Map;function A(v,c){c?S.set(v,c):S.delete(v)}function C(v){return S.get(v)}class $ extends R.$Pv{constructor(c,g,o,n,i,r,s){super(g,o,n,i),this.c=c,this.m=r,this.q=s,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,b.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===N.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(g){return g?c.s(g):c.getText()},get eol(){return c.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(g){return c.t(g)},offsetAt(g){return c.u(g)},positionAt(g){return c.v(g)},validateRange(g){return c.w(g)},validatePosition(g){return c.x(g)},getWordRangeAtPosition(g,o){return c.y(g,o)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,u.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,u.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const g=this.w(c);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const o=this.g,n=g.start.line,i=g.end.line,r=[];r.push(this.f[n].substring(g.start.character));for(let s=n+1;s<i;s++)r.push(this.f[s]);return r.push(this.f[i].substring(0,g.end.character)),r.join(o)}t(c){let g;if(c instanceof w.$SM?g=c.line:typeof c=="number"&&(g=c),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new k(g,this.f[g],g===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const g=this.j.getIndexOf(c),o=this.f[g.index].length;return new w.$SM(g.index,Math.min(g.remainder,o))}w(c){if(!(c instanceof w.$TM))throw new Error("Invalid argument");const g=this.x(c.start),o=this.x(c.end);return g===c.start&&o===c.end?c:new w.$TM(g.line,g.character,o.line,o.character)}x(c){if(!(c instanceof w.$SM))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:g,character:o}=c,n=!1;if(g<0)g=0,o=0,n=!0;else if(g>=this.f.length)g=this.f.length-1,o=this.f[g].length,n=!0;else{const i=this.f[g].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new w.$SM(g,o):c}y(c,g){const o=this.x(c);if(!g)g=C(this.m);else if((0,L.$ff)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const n=(0,M.$Zs)(o.character+1,(0,M.$Xs)(g),this.f[o.line],0);if(n)return new w.$TM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$dP=$;class k{constructor(c,g,o){this.a=c,this.b=g,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eP=k}),define(ke[326],Ee([1,0,6,7]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,w,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(M);if(!S)throw new Error("Embedding vector provider not found");const A=await S.provideEmbeddingVector(w,b);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,w,b){const S=this.b;return this.b++,this.a.set(S,b),this.c.$registerAiEmbeddingVectorProvider(w,S),new N.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$flc=L}),define(ke[69],Ee([1,0,6,32,7,21,5,20,60,3,8,23,15]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=void 0;let v=k=class{constructor(g,o){this.b=new Map,this.c=new A.$zh,this.a=g.getProxy(u.$PM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===N.FilePermission.Readonly?1:void 0}}catch(r){k.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return k.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return k.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return k.e(r)}},async writeFile(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Ce.wrap(r))}catch(s){return k.e(s)}},async delete(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return k.e(s)}},async rename(i,r,s){try{return await n.a.$rename(i,r,{overwrite:!1,...s})}catch(t){return k.e(t)}},async copy(i,r,s){try{return await n.a.$copy(i,r,{overwrite:!1,...s})}catch(t){return k.e(t)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(g,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await g.stat(n)).type&N.FileType.Directory))throw L.$8N.FileExists(`Unable to create folder '${n.scheme===$.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(N.$al(r)!==N.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(n)),n=o.dirname(n)}for(let r=i.length-1;r>=0;r--){n=o.joinPath(n,i[r]);try{await g.createDirectory(n)}catch(s){if(N.$al(s)!==N.FileSystemProviderErrorCode.FileExists)throw s}}}static e(g){if(g instanceof L.$8N)throw g;if(g instanceof N.$9k)switch(g.code){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(g.message);default:throw new L.$8N(g.message,g.name)}if(!(g instanceof Error))throw new L.$8N(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw L.$8N.Unavailable(g.message);switch(g.name){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(g.message);default:throw new L.$8N(g.message,g.name)}}addFileSystemProvider(g,o,n){return this.b.set(g,{impl:o,extUri:n?.isCaseSensitive?C.$Tg:C.$Vg,isReadonly:!!n?.isReadonly}),(0,S.$Sc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??C.$Tg}};e.$qkc=v,e.$qkc=v=k=Je([qe(0,w.$aP),qe(1,b.$7jc)],v),e.$rkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=e.$skc=void 0,e.$skc=(0,u.$qi)("IExtensionStoragePaths");let w=class{constructor(S,A,C){this.d=A,this.f=C,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then($=>this.c=$)}async g(S){return M.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,A=await this.g(S);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(S){if(this.c)return M.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return M.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$tkc=w,e.$tkc=w=Je([qe(0,N.$qP),qe(1,L.$Wj),qe(2,R.$rkc)],w)}),define(ke[327],Ee([1,0,7,20,4]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;let R=class{constructor(w){this.a=new u.$fO(u.ColorThemeKind.Dark),this.b=new L.$be}get activeColorTheme(){return this.a}$onColorThemeChange(w){let b;switch(w){case"light":b=u.ColorThemeKind.Light;break;case"hcDark":b=u.ColorThemeKind.HighContrast;break;case"hcLight":b=u.ColorThemeKind.HighContrastLight;break;default:b=u.ColorThemeKind.Dark}this.a=new u.$fO(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1lc=R,e.$1lc=R=Je([qe(0,N.$aP)],R)}),define(ke[70],Ee([1,0,22,4,3,229,5,12,88,6,28,20,7]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pCb=e.$oCb=e.TunnelDtoConverter=void 0;class k extends b.$cw{}var v;(function(g){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:i.protocol}}g.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==b.TunnelPrivacyId.ConstantPrivate&&i.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}g.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$oCb=(0,M.$qi)("IExtHostTunnelService");let c=class extends L.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(S.$PM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const r=new k(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new $.$RM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,r,s){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async a=>{let h;try{h=await l.provider.providePortAttributes({port:a,pid:i,commandLine:r},s)}catch{h=await l.provider.providePortAttributes(a,i,r,s)}return{providedAttributes:h,port:a}})))}const f=t.filter(d=>!!d.providedAttributes);return f.length>0?f.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await o.provideTunnel(r,s,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:s}),v.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$pCb=c,e.$pCb=c=Je([qe(0,C.$aP),qe(1,A.$qP),qe(2,w.$Wj)],c)}),define(ke[16],Ee([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,291,119,68,89,303,26,7]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f,d,l,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$0O=B,e.$$O=X,e.$_O=x;var m;(function(Ne){function Fe(ee){const{selectionStartLineNumber:Oe,selectionStartColumn:Ke,positionLineNumber:_e,positionColumn:Qe}=ee,ht=new h.$SM(Oe-1,Ke-1),Et=new h.$SM(_e-1,Qe-1);return new h.$UM(ht,Et)}Ne.to=Fe;function ye(ee){const{anchor:Oe,active:Ke}=ee;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Ne.from=ye})(m||(e.Selection=m={}));var D;(function(Ne){function Fe(ee){if(!ee)return;const{start:Oe,end:Ke}=ee;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Ne.from=Fe;function ye(ee){if(!ee)return;const{startLineNumber:Oe,startColumn:Ke,endLineNumber:_e,endColumn:Qe}=ee;return new h.$TM(Oe-1,Ke-1,_e-1,Qe-1)}Ne.to=ye})(D||(e.Range=D={}));var p;(function(Ne){function Fe(ee){return{uri:ee.uri,range:D.from(ee.range)}}Ne.from=Fe;function ye(ee){return new h.$4M(c.URI.revive(ee.uri),D.to(ee.range))}Ne.to=ye})(p||(e.Location=p={}));var E;(function(Ne){function Fe(ye){switch(ye){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Ne.to=Fe})(E||(e.TokenType=E={}));var y;(function(Ne){function Fe(ee){return new h.$SM(ee.lineNumber-1,ee.column-1)}Ne.to=Fe;function ye(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Ne.from=ye})(y||(e.Position=y={}));var P;(function(Ne){function Fe(Oe,Ke,_e){return(0,u.$Hb)((0,u.$3b)(Oe).map(Qe=>ye(Qe,Ke,_e)))}Ne.from=Fe;function ye(Oe,Ke,_e){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:_e?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ee(Oe.scheme,Ke),pattern:Ie.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Oe,Ke){return Ke&&typeof Oe=="string"?Ke.transformOutgoingScheme(Oe):Oe}})(P||(e.DocumentSelector=P={}));var I;(function(Ne){function Fe(ee){switch(ee){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Ne.from=Fe;function ye(ee){switch(ee){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Ne.to=ye})(I||(e.DiagnosticTag=I={}));var j;(function(Ne){function Fe(ee){let Oe;return ee.code&&((0,v.$4f)(ee.code)||(0,v.$8f)(ee.code)?Oe=String(ee.code):Oe={value:String(ee.code.value),target:ee.code.target}),{...D.from(ee.range),message:ee.message,source:ee.source,code:Oe,severity:z.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(F.from),tags:Array.isArray(ee.tags)?(0,u.$Hb)(ee.tags.map(I.from)):void 0}}Ne.from=Fe;function ye(ee){const Oe=new h.$6M(D.to(ee),ee.message,z.to(ee.severity));return Oe.source=ee.source,Oe.code=(0,v.$4f)(ee.code)?ee.code:ee.code?.value,Oe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(F.to),Oe.tags=ee.tags&&(0,u.$Hb)(ee.tags.map(I.to)),Oe}Ne.to=ye})(j||(e.Diagnostic=j={}));var F;(function(Ne){function Fe(ee){return{...D.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Ne.from=Fe;function ye(ee){return new h.$5M(new h.$4M(ee.resource,D.to(ee)),ee.message)}Ne.to=ye})(F||(e.DiagnosticRelatedInformation=F={}));var z;(function(Ne){function Fe(ee){switch(ee){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Ne.from=Fe;function ye(ee){switch(ee){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Ne.to=ye})(z||(e.DiagnosticSeverity=z={}));var O;(function(Ne){function Fe(ee){return typeof ee=="number"&&ee>=h.ViewColumn.One?ee-1:ee===h.ViewColumn.Beside?l.$OD:l.$ND}Ne.from=Fe;function ye(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Ne.to=ye})(O||(e.ViewColumn=O={}));function T(Ne){return typeof Ne.range<"u"}function B(Ne){return Ne.length===0?!0:!!T(Ne[0])}var W;(function(Ne){function Fe(Qe){return Qe.map(Ne.from)}Ne.fromMany=Fe;function ye(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ee(Qe){let ht;if(ye(Qe)){const{language:ut,value:ni}=Qe;ht={value:"```"+ut+`
`+ni+"\n```\n"}}else h.$gN.isMarkdownString(Qe)?ht={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ht={value:Qe}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const jt=ut=>{try{let ni=c.URI.parse(ut,!0);ni=ni.with({query:Oe(ni.query,Et)}),Et[ut]=ni}catch{}return""},Wt=new b.marked.Renderer;return Wt.link=jt,Wt.image=ut=>typeof ut=="string"?jt(M.$Vk(ut).href):"",(0,b.marked)(ht.value,{renderer:Wt}),ht}Ne.from=ee;function Oe(Qe,ht){if(!Qe)return Qe;let Et;try{Et=(0,S.$Yh)(Qe)}catch{}if(!Et)return Qe;let jt=!1;return Et=(0,C.$Yn)(Et,Wt=>{if(c.URI.isUri(Wt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[ut]=Wt,jt=!0,ut}else return}),jt?JSON.stringify(Et):Qe}function Ke(Qe){const ht=new h.$gN(Qe.value,Qe.supportThemeIcons);return ht.isTrusted=Qe.isTrusted,ht.supportHtml=Qe.supportHtml,ht.baseUri=Qe.baseUri?c.URI.from(Qe.baseUri):void 0,ht}Ne.to=Ke;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Ne.from(Qe)}Ne.fromStrict=_e})(W||(e.MarkdownString=W={}));function X(Ne){return B(Ne)?Ne.map(Fe=>({range:D.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?W.fromMany(Fe.hoverMessage):Fe.hoverMessage?W.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ne.map(Fe=>({range:D.from(Fe)}))}function x(Ne){return typeof Ne>"u"?Ne:typeof Ne=="string"?c.URI.file(Ne):Ne}var Z;(function(Ne){function Fe(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?x(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Ne.from=Fe})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var Y;(function(Ne){function Fe(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?x(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?Z.from(ye.before):void 0,after:ye.after?Z.from(ye.after):void 0}}Ne.from=Fe})(Y||(e.ThemableDecorationRenderOptions=Y={}));var ce;(function(Ne){function Fe(ye){if(typeof ye>"u")return ye;switch(ye){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Ne.from=Fe})(ce||(e.DecorationRangeBehavior=ce={}));var ne;(function(Ne){function Fe(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ce.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?Y.from(ye.light):void 0,dark:ye.dark?Y.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?x(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?Z.from(ye.before):void 0,after:ye.after?Z.from(ye.after):void 0}}Ne.from=Fe})(ne||(e.DecorationRenderOptions=ne={}));var $e;(function(Ne){function Fe(ee){return{text:ee.newText,eol:ee.newEol&&He.from(ee.newEol),range:D.from(ee.range)}}Ne.from=Fe;function ye(ee){const Oe=new h.$YM(D.to(ee.range),ee.text);return Oe.newEol=typeof ee.eol>"u"?void 0:He.to(ee.eol),Oe}Ne.to=ye})($e||(e.TextEdit=$e={}));var Pe;(function(Ne){function Fe(ee,Oe){const Ke={edits:[]};if(ee instanceof h.$2M){const _e=new w.$Cc;for(const Qe of ee._allEntries())Qe._type===1&&c.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of ee._allEntries())if(Qe._type===1){let ht;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ht={type:"base64",value:(0,N.$We)(N.$Ce.wrap(Qe.options.contents))}:ht={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ke.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ht},metadata:Qe.metadata})}else Qe._type===2?Ke.edits.push({resource:Qe.uri,textEdit:$e.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ke.edits.push({resource:Qe.uri,textEdit:{range:D.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Qt.from)}})}return Ke}Ne.from=Fe;function ye(ee){const Oe=new h.$2M,Ke=new w.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Qe=_e,ht=c.URI.revive(Qe.resource),Et=D.to(Qe.textEdit.range),jt=Qe.textEdit.text,Wt=Qe.textEdit.insertAsSnippet;let ut;Wt?ut=h.$1M.replace(Et,new h.$3M(jt)):ut=h.$YM.replace(Et,jt);const ni=Ke.get(ht);ni?ni.push(ut):Ke.set(ht,[ut])}else Oe.renameFile(c.URI.revive(_e.oldResource),c.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of Ke)Oe.set(_e,Qe);return Oe}Ne.to=ye})(Pe||(e.WorkspaceEdit=Pe={}));var _;(function(Ne){const Fe=Object.create(null);Fe[h.SymbolKind.File]=0,Fe[h.SymbolKind.Module]=1,Fe[h.SymbolKind.Namespace]=2,Fe[h.SymbolKind.Package]=3,Fe[h.SymbolKind.Class]=4,Fe[h.SymbolKind.Method]=5,Fe[h.SymbolKind.Property]=6,Fe[h.SymbolKind.Field]=7,Fe[h.SymbolKind.Constructor]=8,Fe[h.SymbolKind.Enum]=9,Fe[h.SymbolKind.Interface]=10,Fe[h.SymbolKind.Function]=11,Fe[h.SymbolKind.Variable]=12,Fe[h.SymbolKind.Constant]=13,Fe[h.SymbolKind.String]=14,Fe[h.SymbolKind.Number]=15,Fe[h.SymbolKind.Boolean]=16,Fe[h.SymbolKind.Array]=17,Fe[h.SymbolKind.Object]=18,Fe[h.SymbolKind.Key]=19,Fe[h.SymbolKind.Null]=20,Fe[h.SymbolKind.EnumMember]=21,Fe[h.SymbolKind.Struct]=22,Fe[h.SymbolKind.Event]=23,Fe[h.SymbolKind.Operator]=24,Fe[h.SymbolKind.TypeParameter]=25;function ye(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Ne.from=ye;function ee(Oe){for(const Ke in Fe)if(Fe[Ke]===Oe)return Number(Ke);return h.SymbolKind.Property}Ne.to=ee})(_||(e.SymbolKind=_={}));var U;(function(Ne){function Fe(ee){switch(ee){case h.SymbolTag.Deprecated:return 1}}Ne.from=Fe;function ye(ee){switch(ee){case 1:return h.SymbolTag.Deprecated}}Ne.to=ye})(U||(e.SymbolTag=U={}));var ie;(function(Ne){function Fe(ee){return{name:ee.name,kind:_.from(ee.kind),tags:ee.tags&&ee.tags.map(U.from),containerName:ee.containerName,location:re.from(ee.location)}}Ne.from=Fe;function ye(ee){const Oe=new h.$0M(ee.name,_.to(ee.kind),ee.containerName,re.to(ee.location));return Oe.tags=ee.tags&&ee.tags.map(U.to),Oe}Ne.to=ye})(ie||(e.WorkspaceSymbol=ie={}));var be;(function(Ne){function Fe(ee){const Oe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),kind:_.from(ee.kind),tags:ee.tags?.map(U.from)??[]};return ee.children&&(Oe.children=ee.children.map(Fe)),Oe}Ne.from=Fe;function ye(ee){const Oe=new h.$$M(ee.name,ee.detail,_.to(ee.kind),D.to(ee.range),D.to(ee.selectionRange));return(0,u.$Lb)(ee.tags)&&(Oe.tags=ee.tags.map(U.to)),ee.children&&(Oe.children=ee.children.map(ye)),Oe}Ne.to=ye})(be||(e.DocumentSymbol=be={}));var Ce;(function(Ne){function Fe(ee){const Oe=new h.$cN(_.to(ee.kind),ee.name,ee.detail||"",c.URI.revive(ee.uri),D.to(ee.range),D.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Ne.to=Fe;function ye(ee,Oe,Ke){if(Oe=Oe??ee._sessionId,Ke=Ke??ee._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,name:ee.name,detail:ee.detail,kind:_.from(ee.kind),uri:ee.uri,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Ne.from=ye})(Ce||(e.CallHierarchyItem=Ce={}));var oe;(function(Ne){function Fe(ye){return new h.$dN(Ce.to(ye.from),ye.fromRanges.map(ee=>D.to(ee)))}Ne.to=Fe})(oe||(e.CallHierarchyIncomingCall=oe={}));var ae;(function(Ne){function Fe(ye){return new h.$eN(Ce.to(ye.to),ye.fromRanges.map(ee=>D.to(ee)))}Ne.to=Fe})(ae||(e.CallHierarchyOutgoingCall=ae={}));var re;(function(Ne){function Fe(ee){return{range:ee.range&&D.from(ee.range),uri:ee.uri}}Ne.from=Fe;function ye(ee){return new h.$4M(c.URI.revive(ee.uri),D.to(ee.range))}Ne.to=ye})(re||(e.location=re={}));var G;(function(Ne){function Fe(ee){const Oe=ee,Ke=ee;return{originSelectionRange:Oe.originSelectionRange?D.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ke.uri,range:D.from(Oe.targetRange?Oe.targetRange:Ke.range),targetSelectionRange:Oe.targetSelectionRange?D.from(Oe.targetSelectionRange):void 0}}Ne.from=Fe;function ye(ee){return{targetUri:c.URI.revive(ee.uri),targetRange:D.to(ee.range),targetSelectionRange:ee.targetSelectionRange?D.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?D.to(ee.originSelectionRange):void 0}}Ne.to=ye})(G||(e.DefinitionLink=G={}));var te;(function(Ne){function Fe(ee){return{range:D.from(ee.range),contents:W.fromMany(ee.contents)}}Ne.from=Fe;function ye(ee){return new h.$7M(ee.contents.map(W.to),D.to(ee.range))}Ne.to=ye})(te||(e.Hover=te={}));var ge;(function(Ne){function Fe(ee){return{range:D.from(ee.range),expression:ee.expression}}Ne.from=Fe;function ye(ee){return new h.$2N(D.to(ee.range),ee.expression)}Ne.to=ye})(ge||(e.EvaluatableExpression=ge={}));var we;(function(Ne){function Fe(ee){if(ee instanceof h.$3N)return{type:"text",range:D.from(ee.range),text:ee.text};if(ee instanceof h.$4N)return{type:"variable",range:D.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof h.$5N)return{type:"expression",range:D.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Ne.from=Fe;function ye(ee){switch(ee.type){case"text":return{range:D.to(ee.range),text:ee.text};case"variable":return{range:D.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:D.to(ee.range),expression:ee.expression}}}Ne.to=ye})(we||(e.InlineValue=we={}));var Re;(function(Ne){function Fe(ee){return{frameId:ee.frameId,stoppedLocation:D.from(ee.stoppedLocation)}}Ne.from=Fe;function ye(ee){return new h.$6N(ee.frameId,D.to(ee.stoppedLocation))}Ne.to=ye})(Re||(e.InlineValueContext=Re={}));var fe;(function(Ne){function Fe(ee){return{range:D.from(ee.range),kind:ee.kind}}Ne.from=Fe;function ye(ee){return new h.$8M(D.to(ee.range),ee.kind)}Ne.to=ye})(fe||(e.DocumentHighlight=fe={}));var Se;(function(Ne){function Fe(ee){return{uri:ee.uri,highlights:ee.highlights.map(fe.from)}}Ne.from=Fe;function ye(ee){return new h.$9M(c.URI.revive(ee.uri),ee.highlights.map(fe.to))}Ne.to=ye})(Se||(e.MultiDocumentHighlight=Se={}));var Ae;(function(Ne){function Fe(ye){switch(ye){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Ne.to=Fe})(Ae||(e.CompletionTriggerKind=Ae={}));var je;(function(Ne){function Fe(ye){return{triggerKind:Ae.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Ne.to=Fe})(je||(e.CompletionContext=je={}));var q;(function(Ne){function Fe(ee){switch(ee){case h.CompletionItemTag.Deprecated:return 1}}Ne.from=Fe;function ye(ee){switch(ee){case 1:return h.CompletionItemTag.Deprecated}}Ne.to=ye})(q||(e.CompletionItemTag=q={}));var V;(function(Ne){const Fe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ye(Ke){return Fe.get(Ke)??9}Ne.from=ye;const ee=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Oe(Ke){return ee.get(Ke)??h.CompletionItemKind.Property}Ne.to=Oe})(V||(e.CompletionItemKind=V={}));var Q;(function(Ne){function Fe(ye,ee){const Oe=new h.$mN(ye.label);return Oe.insertText=ye.insertText,Oe.kind=V.to(ye.kind),Oe.tags=ye.tags?.map(q.to),Oe.detail=ye.detail,Oe.documentation=M.$Pk(ye.documentation)?W.to(ye.documentation):ye.documentation,Oe.sortText=ye.sortText,Oe.filterText=ye.filterText,Oe.preselect=ye.preselect,Oe.commitCharacters=ye.commitCharacters,g.$kt.isIRange(ye.range)?Oe.range=D.to(ye.range):typeof ye.range=="object"&&(Oe.range={inserting:D.to(ye.range.insert),replacing:D.to(ye.range.replace)}),Oe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Oe.insertText=new h.$3M(ye.insertText):(Oe.insertText=ye.insertText,Oe.textEdit=Oe.range instanceof h.$TM?new h.$YM(Oe.range,Oe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ye.additionalTextEdits.map(Ke=>$e.to(Ke))),Oe.command=ee&&ye.command?ee.fromInternal(ye.command):void 0,Oe}Ne.to=Fe})(Q||(e.CompletionItem=Q={}));var J;(function(Ne){function Fe(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:W.fromStrict(ee.documentation)}}Ne.from=Fe;function ye(ee){return{label:ee.label,documentation:M.$Pk(ee.documentation)?W.to(ee.documentation):ee.documentation}}Ne.to=ye})(J||(e.ParameterInformation=J={}));var he;(function(Ne){function Fe(ee){return{label:ee.label,documentation:W.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.from):[],activeParameter:ee.activeParameter}}Ne.from=Fe;function ye(ee){return{label:ee.label,documentation:M.$Pk(ee.documentation)?W.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(J.to):[],activeParameter:ee.activeParameter}}Ne.to=ye})(he||(e.SignatureInformation=he={}));var pe;(function(Ne){function Fe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.from):[]}}Ne.from=Fe;function ye(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.to):[]}}Ne.to=ye})(pe||(e.SignatureHelp=pe={}));var ze;(function(Ne){function Fe(ye,ee){const Oe=new h.$lN(y.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(Ve.to.bind(void 0,ye)),ee.kind&&Xe.to(ee.kind));return Oe.textEdits=ee.textEdits&&ee.textEdits.map($e.to),Oe.tooltip=M.$Pk(ee.tooltip)?W.to(ee.tooltip):ee.tooltip,Oe.paddingLeft=ee.paddingLeft,Oe.paddingRight=ee.paddingRight,Oe}Ne.to=Fe})(ze||(e.InlayHint=ze={}));var Ve;(function(Ne){function Fe(ye,ee){const Oe=new h.$kN(ee.label);return Oe.tooltip=M.$Pk(ee.tooltip)?W.to(ee.tooltip):ee.tooltip,o.Command.is(ee.command)&&(Oe.command=ye.fromInternal(ee.command)),ee.location&&(Oe.location=re.to(ee.location)),Oe}Ne.to=Fe})(Ve||(e.InlayHintLabelPart=Ve={}));var Xe;(function(Ne){function Fe(ee){return ee}Ne.from=Fe;function ye(ee){return ee}Ne.to=ye})(Xe||(e.InlayHintKind=Xe={}));var tt;(function(Ne){function Fe(ee){return{range:D.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Ne.from=Fe;function ye(ee){let Oe;if(ee.url)try{Oe=typeof ee.url=="string"?c.URI.parse(ee.url,!0):c.URI.revive(ee.url)}catch{}return new h.$rN(D.to(ee.range),Oe)}Ne.to=ye})(tt||(e.DocumentLink=tt={}));var ot;(function(Ne){function Fe(ee){const Oe=new h.$uN(ee.label);return ee.textEdit&&(Oe.textEdit=$e.to(ee.textEdit)),ee.additionalTextEdits&&(Oe.additionalTextEdits=ee.additionalTextEdits.map(Ke=>$e.to(Ke))),Oe}Ne.to=Fe;function ye(ee){return{label:ee.label,textEdit:ee.textEdit?$e.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Oe=>$e.from(Oe)):void 0}}Ne.from=ye})(ot||(e.ColorPresentation=ot={}));var it;(function(Ne){function Fe(ee){return new h.$sN(ee[0],ee[1],ee[2],ee[3])}Ne.to=Fe;function ye(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Ne.from=ye})(it||(e.Color=it={}));var st;(function(Ne){function Fe(ee){return{range:D.from(ee.range)}}Ne.from=Fe;function ye(ee){return new h.$bN(D.to(ee.range))}Ne.to=ye})(st||(e.SelectionRange=st={}));var De;(function(Ne){function Fe(ye){switch(ye){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Ne.to=Fe})(De||(e.TextDocumentSaveReason=De={}));var Be;(function(Ne){function Fe(ee){switch(ee){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}Ne.from=Fe;function ye(ee){switch(ee){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}Ne.to=ye})(Be||(e.TextEditorLineNumbersStyle=Be={}));var He;(function(Ne){function Fe(ee){if(ee===h.EndOfLine.CRLF)return 1;if(ee===h.EndOfLine.LF)return 0}Ne.from=Fe;function ye(ee){if(ee===1)return h.EndOfLine.CRLF;if(ee===0)return h.EndOfLine.LF}Ne.to=ye})(He||(e.EndOfLine=He={}));var Le;(function(Ne){function Fe(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ne.from=Fe})(Le||(e.ProgressLocation=Le={}));var Ze;(function(Ne){function Fe(ee){const Oe={start:ee.start+1,end:ee.end+1};return ee.kind&&(Oe.kind=se.from(ee.kind)),Oe}Ne.from=Fe;function ye(ee){const Oe={start:ee.start-1,end:ee.end-1};return ee.kind&&(Oe.kind=se.to(ee.kind)),Oe}Ne.to=ye})(Ze||(e.FoldingRange=Ze={}));var se;(function(Ne){function Fe(ee){if(ee)switch(ee){case h.FoldingRangeKind.Comment:return o.$6t.Comment;case h.FoldingRangeKind.Imports:return o.$6t.Imports;case h.FoldingRangeKind.Region:return o.$6t.Region}}Ne.from=Fe;function ye(ee){if(ee)switch(ee.value){case o.$6t.Comment.value:return h.FoldingRangeKind.Comment;case o.$6t.Imports.value:return h.FoldingRangeKind.Imports;case o.$6t.Region.value:return h.FoldingRangeKind.Region}}Ne.to=ye})(se||(e.FoldingRangeKind=se={}));var ue;(function(Ne){function Fe(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?D.from(ye.selection):void 0,override:typeof ye.override=="boolean"?r.$eF.id:void 0}}Ne.from=Fe})(ue||(e.TextEditorOpenOptions=ue={}));var Ie;(function(Ne){function Fe(Ke){return Ke instanceof h.$PN?Ke.toJSON():typeof Ke=="string"?Ke:ye(Ke)||ee(Ke)?new h.$PN(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Ne.from=Fe;function ye(Ke){const _e=Ke;return _e?c.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(Ke){const _e=Ke;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Oe(Ke){return typeof Ke=="string"?Ke:new h.$PN(c.URI.revive(Ke.baseUri),Ke.pattern)}Ne.to=Oe})(Ie||(e.GlobPattern=Ie={}));var Ge;(function(Ne){function Fe(ye){if(ye){if(Array.isArray(ye))return ye.map(Fe);if(typeof ye=="string")return ye;{const ee=ye;return{language:ee.language,scheme:ee.scheme,pattern:Ie.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Ne.from=Fe})(Ge||(e.LanguageSelector=Ge={}));var Me;(function(Ne){function Fe(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&c.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(_e=>_e instanceof h.$TM)))}Ne.is=Fe;function ye(ee){return{documents:ee.documents.map(Oe=>Oe.map(Ke=>({uri:c.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(_e=>D.from(_e))})))}}Ne.from=ye})(Me||(e.MappedEditsContext=Me={}));var nt;(function(Ne){function Fe(ee){return{start:ee.start,end:ee.end}}Ne.from=Fe;function ye(ee){return new h.$gO(ee.start,ee.end)}Ne.to=ye})(nt||(e.NotebookRange=nt={}));var lt;(function(Ne){function Fe(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Ne.to=Fe;function ye(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Ne.from=ye})(lt||(e.NotebookCellExecutionSummary=lt={}));var yt;(function(Ne){function Fe(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Ne.to=Fe})(yt||(e.NotebookCellExecutionState=yt={}));var At;(function(Ne){function Fe(ee){switch(ee){case h.NotebookCellKind.Markup:return t.CellKind.Markup;case h.NotebookCellKind.Code:default:return t.CellKind.Code}}Ne.from=Fe;function ye(ee){switch(ee){case t.CellKind.Markup:return h.NotebookCellKind.Markup;case t.CellKind.Code:default:return h.NotebookCellKind.Code}}Ne.to=ye})(At||(e.NotebookCellKind=At={}));var Ft;(function(Ne){function Fe(ee){const Oe={metadata:ee.metadata??Object.create(null),cells:[]};for(const Ke of ee.cells)h.$hO.validate(Ke),Oe.cells.push(Qt.from(Ke));return Oe}Ne.from=Fe;function ye(ee){const Oe=new h.$iO(ee.cells.map(Qt.to));return(0,v.$eg)(ee.metadata)||(Oe.metadata=ee.metadata),Oe}Ne.to=ye})(Ft||(e.NotebookData=Ft={}));var Qt;(function(Ne){function Fe(ee){return{cellKind:At.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:lt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(Dt.from):[]}}Ne.from=Fe;function ye(ee){return new h.$hO(At.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(Dt.to):void 0,ee.metadata,ee.internalMetadata?lt.to(ee.internalMetadata):void 0)}Ne.to=ye})(Qt||(e.NotebookCellData=Qt={}));var xt;(function(Ne){function Fe(ee){return{mime:ee.mime,valueBytes:N.$Ce.wrap(ee.data)}}Ne.from=Fe;function ye(ee){return new h.$jO(ee.valueBytes.buffer,ee.mime)}Ne.to=ye})(xt||(e.NotebookCellOutputItem=xt={}));var Dt;(function(Ne){function Fe(ee){return{outputId:ee.id,items:ee.items.map(xt.from),metadata:ee.metadata}}Ne.from=Fe;function ye(ee){const Oe=ee.items.map(xt.to);return new h.$kO(Oe,ee.outputId,ee.metadata)}Ne.to=ye})(Dt||(e.NotebookCellOutput=Dt={}));var qt;(function(Ne){function Fe(Oe){return ee(Oe)?{include:Ie.from(Oe.include)??void 0,exclude:Ie.from(Oe.exclude)??void 0}:Ie.from(Oe)??void 0}Ne.from=Fe;function ye(Oe){return ee(Oe)?{include:Ie.to(Oe.include),exclude:Ie.to(Oe.exclude)}:Ie.to(Oe)}Ne.to=ye;function ee(Oe){const Ke=Oe;return Ke?!(0,v.$ag)(Ke.include)&&!(0,v.$ag)(Ke.exclude):!1}})(qt||(e.NotebookExclusiveDocumentPattern=qt={}));var Xt;(function(Ne){function Fe(ye,ee,Oe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Ke,Oe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Ne.from=Fe})(Xt||(e.NotebookStatusBarItem=Xt={}));var et;(function(Ne){function Fe(ye,ee,Oe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ee.toInternal(Ke,Oe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Ne.from=Fe})(et||(e.NotebookKernelSourceAction=et={}));var ri;(function(Ne){function Fe(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Ne.from=Fe})(ri||(e.NotebookDocumentContentOptions=ri={}));var _t;(function(Ne){function Fe(ee){return{uri:ee.uri,provides:ee.provides}}Ne.from=Fe;function ye(ee){return new h.$mO(c.URI.revive(ee.uri),ee.provides)}Ne.to=ye})(_t||(e.NotebookRendererScript=_t={}));var ft;(function(Ne){function Fe(ee){return{message:W.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:D.from(ee.location.range),uri:ee.location.uri}}}Ne.from=Fe;function ye(ee){const Oe=new h.$sO(typeof ee.message=="string"?ee.message:W.to(ee.message));return Oe.actualOutput=ee.actual,Oe.expectedOutput=ee.expected,Oe.contextValue=ee.contextValue,Oe.location=ee.location?re.to(ee.location):void 0,Oe}Ne.to=ye})(ft||(e.TestMessage=ft={}));var $t;(function(Ne){Ne.namespace=d.$GL,Ne.denamespace=d.$HL})($t||(e.TestTag=$t={}));var ei;(function(Ne){function Fe(ee){const Oe=(0,i.$9O)(ee).controllerId;return{extId:f.$BL.fromExtHostTestItem(ee,Oe).toString(),label:ee.label,uri:c.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Ke=>$t.namespace(Oe,Ke.id)),range:g.$kt.lift(D.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&W.fromStrict(ee.error)||null}}Ne.from=Fe;function ye(ee){return{parent:void 0,error:void 0,id:f.$BL.fromString(ee.extId).localId,label:ee.label,uri:c.URI.revive(ee.uri),tags:(ee.tags||[]).map(Oe=>{const{tagId:Ke}=$t.denamespace(Oe);return new h.$tO(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Ne.toPlain=ye})(ei||(e.TestItem=ei={})),function(Ne){function Fe(ee){return{id:ee.id}}Ne.from=Fe;function ye(ee){return new h.$tO(ee.id)}Ne.to=ye}($t||(e.TestTag=$t={}));var Zt;(function(Ne){const Fe=(ee,Oe)=>{const Ke=ee.value;if(!Ke)return;const _e={...ei.toPlain(Ke.item),parent:Oe,taskStates:Ke.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(ee.children)for(const Qe of ee.children.values()){const ht=Fe(Qe,_e);ht&&_e.children.push(ht)}return _e};function ye(ee){const Oe=new $.$2O;for(const Qe of ee.items)Oe.insert(f.$BL.fromString(Qe.item.extId).path,Qe);const Ke=[Oe.nodes],_e=[];for(;Ke.length;)for(const Qe of Ke.pop())Qe.value?_e.push(Qe):Qe.children&&Ke.push(Qe.children.values());return{completedAt:ee.completedAt,results:_e.map(Qe=>Fe(Qe)).filter(v.$_f)}}Ne.to=ye})(Zt||(e.TestResults=Zt={}));var zt;(function(Ne){function Fe(Ke){return{covered:Ke.covered,total:Ke.total}}function ye(Ke){return"line"in Ke?y.from(Ke):D.from(Ke)}function ee(Ke){if(typeof Ke.executed=="number"&&Ke.executed<0)throw new Error(`Invalid coverage count ${Ke.executed}`);return"branches"in Ke?{count:Ke.executed,location:ye(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(_e=>({count:_e.executed,location:_e.location&&ye(_e.location),label:_e.label})):void 0}:{type:0,name:Ke.name,count:Ke.executed,location:ye(Ke.location)}}Ne.fromDetails=ee;function Oe(Ke,_e){return h.$vO(_e.statementCoverage),h.$vO(_e.branchCoverage),h.$vO(_e.declarationCoverage),{id:Ke,uri:_e.uri,statement:Fe(_e.statementCoverage),branch:_e.branchCoverage&&Fe(_e.branchCoverage),declaration:_e.declarationCoverage&&Fe(_e.declarationCoverage)}}Ne.fromFile=Oe})(zt||(e.TestCoverage=zt={}));var gt;(function(Ne){function Fe(ye){switch(ye){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Ne.to=Fe})(gt||(e.CodeActionTriggerKind=gt={}));var Ut;(function(Ne){function Fe(ee){const Oe=new h.$AO(_.to(ee.kind),ee.name,ee.detail||"",c.URI.revive(ee.uri),D.to(ee.range),D.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Ne.to=Fe;function ye(ee,Oe,Ke){if(Oe=Oe??ee._sessionId,Ke=Ke??ee._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,kind:_.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Ne.from=ye})(Ut||(e.TypeHierarchyItem=Ut={}));var Yt;(function(Ne){function Fe(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Ne.from=Fe})(Yt||(e.ViewBadge=Yt={}));var Bt;(function(Ne){function Fe(Ke,_e,Qe){const ht=_e.fileData;return ht?new h.$HN(new h.$IN(ht.name,c.URI.revive(ht.uri),ht.id,(0,R.$db)(()=>Qe(ht.id)))):Ke===A.$Hs.uriList&&_e.uriListData?new h.$GN(Oe(_e.uriListData)):new h.$GN(_e.asString)}Ne.to=Fe;async function ye(Ke,_e){const Qe=await _e.asString();if(Ke===A.$Hs.uriList)return{asString:Qe,fileData:void 0,uriListData:ee(Qe)};const ht=_e.asFile();return{asString:Qe,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Ne.from=ye;function ee(Ke){return L.$Kt.split(Ke).map(_e=>{if(_e.startsWith("#"))return _e;try{return c.URI.parse(_e)}catch{}return _e})}function Oe(Ke){return L.$Kt.create(Ke.map(_e=>typeof _e=="string"?_e:c.URI.revive(_e)))}})(Bt||(e.DataTransferItem=Bt={}));var xe;(function(Ne){function Fe(ee,Oe){const Ke=ee.items.map(([_e,Qe])=>[_e,Bt.to(_e,Qe,Oe)]);return new h.$JN(Ke)}Ne.toDataTransfer=Fe;async function ye(ee){const Oe={items:[]},Ke=[];for(const[_e,Qe]of ee)Ke.push((async()=>{Oe.items.push([_e,await Bt.from(_e,Qe)])})());return await Promise.all(Ke),Oe}Ne.from=ye})(xe||(e.DataTransfer=xe={}));var oi;(function(Ne){function Fe(ee,Oe){return{kind:"reply",agentId:ee.participant??Oe?.agentId??"",subCommand:ee.command??Oe?.command,message:ee.prompt,title:ee.label}}Ne.from=Fe;function ye(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Ne.to=ye})(oi||(e.ChatFollowup=oi={}));var Vt;(function(Ne){function Fe(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Ne.from=Fe})(Vt||(e.ChatInlineFollowup=Vt={}));var Kt;(function(Ne){function Fe(ee){switch(ee.role){case 0:return new h.$WO(ee.content);case 1:return new h.$XO(ee.content);case 2:return new h.$YO(ee.content)}}Ne.to=Fe;function ye(ee){if(ee instanceof h.$WO)return{role:0,content:ee.content};if(ee instanceof h.$XO)return{role:1,content:ee.content};if(ee instanceof h.$YO)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Ne.from=ye})(Kt||(e.LanguageModelMessage=Kt={}));var mt;(function(Ne){function Fe(Oe){const Ke={};for(const _e of Object.keys(Oe))Ke[_e]=Oe[_e].map(Ne.to);return Ke}Ne.objectTo=Fe;function ye(Oe){return{level:Rt.to(Oe.level),kind:Oe.kind,value:(0,c.$wc)(Oe.value)?c.URI.revive(Oe.value):Oe.value,description:Oe.description}}Ne.to=ye;function ee(Oe){return{level:Rt.from(Oe.level),kind:Oe.kind,value:Oe.value,description:Oe.description}}Ne.from=ee})(mt||(e.ChatVariable=mt={}));var Rt;(function(Ne){function Fe(ee){switch(ee){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}Ne.to=Fe;function ye(ee){switch(ee){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}Ne.from=ye})(Rt||(e.ChatVariableLevel=Rt={}));var Ot;(function(Ne){function Fe(ye){switch(ye){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}Ne.to=Fe})(Ot||(e.InteractiveEditorResponseFeedbackKind=Ot={}));var Nt;(function(Ne){function Fe(ee){return{kind:"markdownContent",content:W.from(ee.value)}}Ne.from=Fe;function ye(ee){return new h.$NO(W.to(ee.content))}Ne.to=ye})(Nt||(e.ChatResponseMarkdownPart=Nt={}));var ti;(function(Ne){function Fe(ee){const{value:Oe,baseUri:Ke}=ee;function _e(Qe,ht){return Qe.map(Et=>{const jt=c.URI.joinPath(ht,Et.name);return{label:Et.name,uri:jt,children:Et.children&&_e(Et.children,jt)}})}return{kind:"treeData",treeData:{label:(0,k.$1g)(Ke),uri:Ke,children:_e(Oe,Ke)}}}Ne.from=Fe;function ye(ee){const Oe=(0,S.$Zh)(ee.treeData);function Ke(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&Ke(Et.children)}))}const _e=Oe.uri,Qe=Oe.children?Ke(Oe.children):[];return new h.$OO(Qe,_e)}Ne.to=ye})(ti||(e.ChatResponseFilesPart=ti={}));var Ht;(function(Ne){function Fe(ee){return{kind:"inlineReference",name:ee.title,inlineReference:c.URI.isUri(ee.value)?ee.value:p.from(ee.value)}}Ne.from=Fe;function ye(ee){const Oe=(0,S.$Zh)(ee);return new h.$PO(c.URI.isUri(Oe.inlineReference)?Oe.inlineReference:p.to(Oe.inlineReference),ee.name)}Ne.to=ye})(Ht||(e.ChatResponseAnchorPart=Ht={}));var si;(function(Ne){function Fe(ee){return{kind:"progressMessage",content:W.from(ee.value)}}Ne.from=Fe;function ye(ee){return new h.$QO(ee.content.value)}Ne.to=ye})(si||(e.ChatResponseProgressPart=si={}));var Mt;(function(Ne){function Fe(ee,Oe,Ke){return{kind:"command",command:Oe.toInternal(ee.value,Ke)??{command:ee.value.command,title:ee.value.title}}}Ne.from=Fe;function ye(ee,Oe){return new h.$RO(Oe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Ne.to=ye})(Mt||(e.ChatResponseCommandButtonPart=Mt={}));var Tt;(function(Ne){function Fe(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(Oe=>$e.from(Oe))}}Ne.from=Fe;function ye(ee){return new h.$TO(c.URI.revive(ee.uri),ee.edits.map(Oe=>$e.to(Oe)))}Ne.to=ye})(Tt||(e.ChatResponseTextEditPart=Tt={}));var Pt;(function(Ne){function Fe(ee){return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:c.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:p.from(ee.value.value)}}:{kind:"reference",reference:c.URI.isUri(ee.value)?ee.value:p.from(ee.value)}}Ne.from=Fe;function ye(ee){const Oe=(0,S.$Zh)(ee),Ke=_e=>c.URI.isUri(_e)?_e:p.to(_e);return new h.$SO("variableName"in Oe.reference?{variableName:Oe.reference.variableName,value:Oe.reference.value&&Ke(Oe.reference.value)}:Ke(Oe.reference))}Ne.to=ye})(Pt||(e.ChatResponseReferencePart=Pt={}));var It;(function(Ne){function Fe(Oe,Ke,_e){return Oe instanceof h.$NO?Nt.from(Oe):Oe instanceof h.$PO?Ht.from(Oe):Oe instanceof h.$SO?Pt.from(Oe):Oe instanceof h.$QO?si.from(Oe):Oe instanceof h.$OO?ti.from(Oe):Oe instanceof h.$RO?Mt.from(Oe,Ke,_e):Oe instanceof h.$TO?Tt.from(Oe):{kind:"content",content:""}}Ne.from=Fe;function ye(Oe,Ke){switch(Oe.kind){case"reference":return Pt.to(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Oe,Ke)}}Ne.to=ye;function ee(Oe,Ke){switch(Oe.kind){case"markdownContent":return Nt.to(Oe);case"inlineReference":return Ht.to(Oe);case"progressMessage":return;case"treeData":return ti.to(Oe);case"command":return Mt.to(Oe,Ke)}}Ne.toContent=ee})(It||(e.ChatResponsePart=It={}));var bt;(function(Ne){function Fe(ee,Oe){return"markdownContent"in Oe?((0,a.$yG)(ee,"chatParticipantAdditions"),{content:W.from(Oe.markdownContent),kind:"markdownContent"}):"content"in Oe?"vulnerabilities"in Oe&&Oe.vulnerabilities?((0,a.$yG)(ee,"chatParticipantAdditions"),{content:Oe.content,vulnerabilities:Oe.vulnerabilities,kind:"vulnerability"}):typeof Oe.content=="string"?{content:Oe.content,kind:"content"}:((0,a.$yG)(ee,"chatParticipantAdditions"),{content:W.from(Oe.content),kind:"markdownContent"}):"documents"in Oe?{documents:Oe.documents.map(Ke=>({uri:Ke.uri,version:Ke.version,ranges:Ke.ranges.map(_e=>D.from(_e))})),kind:"usedContext"}:"reference"in Oe?{reference:"uri"in Oe.reference?{uri:Oe.reference.uri,range:D.from(Oe.reference.range)}:Oe.reference,kind:"reference"}:"inlineReference"in Oe?{inlineReference:"uri"in Oe.inlineReference?{uri:Oe.inlineReference.uri,range:D.from(Oe.inlineReference.range)}:Oe.inlineReference,name:Oe.title,kind:"inlineReference"}:"participant"in Oe?((0,a.$yG)(ee,"chatParticipantAdditions"),{agentId:Oe.participant,command:Oe.command,kind:"agentDetection"}):"message"in Oe?{content:W.from(Oe.message),kind:"progressMessage"}:void 0}Ne.from=Fe;function ye(ee,Oe){switch(ee.kind){case"markdownContent":return{content:ee.content.value};case"inlineReference":return{inlineReference:(0,c.$wc)(ee.inlineReference)?c.URI.revive(ee.inlineReference):p.to(ee.inlineReference),title:ee.name};case"command":return{command:Oe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title}};default:return}}Ne.toProgressContent=ye})(bt||(e.ChatResponseProgress=bt={}));var Ct;(function(Ne){function Fe(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(St.to),location:li.to(ye.location)}}Ne.to=Fe})(Ct||(e.ChatAgentRequest=Ct={}));var li;(function(Ne){function Fe(ye){switch(ye){case s.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return h.ChatLocation.Panel;case s.ChatAgentLocation.Editor:return h.ChatLocation.Editor}}Ne.to=Fe})(li||(e.ChatLocation=li={}));var St;(function(Ne){function Fe(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(mt.to)}}Ne.to=Fe})(St||(e.ChatAgentResolvedVariable=St={}));var hi;(function(Ne){function Fe(ye){return{label:ye.label,values:ye.values.map(mt.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation}}Ne.from=Fe})(hi||(e.ChatAgentCompletionItem=hi={}));var Gt;(function(Ne){function Fe(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Ne.to=Fe})(Gt||(e.ChatAgentResult=Gt={}));var wi;(function(Ne){function Fe(ye,ee,Oe){if(ee.action.kind==="vote")return;const Ke=Gt.to(ye);return ee.action.kind==="command"?{action:{kind:"command",commandButton:bt.toProgressContent(ee.action.commandButton,Oe)},result:Ke}:ee.action.kind==="followUp"?{action:{kind:"followUp",followup:oi.to(ee.action.followup)},result:Ke}:{action:ee.action,result:Ke}}Ne.to=Fe})(wi||(e.ChatAgentUserActionEvent=wi={}));var ii;(function(Ne){function Fe(ye,ee,Oe){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:ee.toInternal(ye,Oe)}Ne.from=Fe})(ii||(e.TerminalQuickFix=ii={}));var vi;(function(Ne){function Fe(ye){return{kind:kt.to(ye.kind)}}Ne.to=Fe})(vi||(e.PartialAcceptInfo=vi={}));var kt;(function(Ne){function Fe(ye){switch(ye){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}Ne.to=Fe})(kt||(e.PartialAcceptTriggerKind=kt={}));var $i;(function(Ne){function Fe(ye,ee){return{id:ee,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Ne.from=Fe})($i||(e.DebugTreeItem=$i={}))}),define(ke[328],Ee([1,0,6,20,16,48]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;let M=class{constructor(b,S){this.a=b.getProxy(u.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>S.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,S,A){const C=new R.$mw(L.WorkspaceEdit.from(b,this.b));return this.a.$tryApplyWorkspaceEdit(C,void 0,A?.isRefactoring??!1)}};e.$ckc=M,e.$ckc=M=Je([qe(0,N.$aP)],M)}),define(ke[329],Ee([1,0,19,8,47,4,45,3,39,18,2,218,25,6,16,7,292,26]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class n{constructor(t,f,d,l,a,h){this.i=t,this.j=f,this.k=d,this.l=l,this.m=a,this.n=h,this.b=b.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(l){if(t.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,l),a}};const t=this;this.b.reset();const d=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){f(this.markdown);const a=new c.$NO(l),h=v.ChatResponseMarkdownPart.from(a);return d(h),this},filetree(l,a){f(this.filetree);const h=new c.$OO(l,a),m=v.ChatResponseFilesPart.from(h);return d(m),this},anchor(l,a){f(this.anchor);const h=new c.$PO(l,a),m=v.ChatResponseAnchorPart.from(h);return d(m),this},button(l){f(this.anchor);const a=new c.$RO(l),h=v.ChatResponseCommandButtonPart.from(a,t.m,t.n);return d(h),this},progress(l){f(this.progress);const a=new c.$QO(l),h=v.ChatResponseProgressPart.from(a);return d(h),this},reference(l){if(f(this.reference),"variableName"in l&&!l.value){const a=t.j.variables.variables.find(h=>h.name===l.variableName);if(a){let h;if(a.references?.length)h=a.references.map(m=>({kind:"reference",reference:{variableName:l.variableName,value:m.reference}}));else{const m=new c.$SO(l);h=[v.ChatResponseReferencePart.from(m)]}return h.forEach(m=>d(m)),this}}else{const a=new c.$SO(l),h=v.ChatResponseReferencePart.from(a);d(h)}return this},textEdit(l,a){f(this.textEdit),(0,o.$yG)(t.i,"chatParticipantAdditions");const h=new c.$TO(l,a),m=v.ChatResponseTextEditPart.from(h);return d(m),this},push(l){if(f(this.push),l instanceof c.$TO&&(0,o.$yG)(t.i,"chatParticipantAdditions"),l instanceof c.$SO)this.reference(l.value);else{const a=v.ChatResponsePart.from(l,t.m,t.n);d(a)}return this},report(l){if(f(this.report),"placeholder"in l&&"resolvedContent"in l)return;const a=v.ChatResponseProgress.from(t.i,l);if(!a){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return d(a),this}}}return this.g}}class i{static{this.b=0}constructor(t,f,d){this.i=f,this.j=d,this.c=new Map,this.g=new w.$4c,this.d=t.getProxy(k.$PM.MainThreadChatAgents2)}transferActiveChat(t){this.d.$transferActiveChatSession(t)}createChatAgent(t,f,d){const l=i.b++,a=new r(t,f,this.d,l,d);return this.c.set(l,a),this.d.$registerAgent(l,t.identifier,f,{},void 0),a.apiAgent}createDynamicChatAgent(t,f,d,l,a){const h=i.b++,m=new r(t,f,this.d,h,a);return this.c.set(h,m),this.d.$registerAgent(h,t.identifier,f,{isSticky:!0},{name:d,description:l}),m.apiAgent}async $invokeAgent(t,f,d,l){const a=this.c.get(t);if(!a)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.g.get(f.sessionId);h||(h=new w.$Tc,this.g.set(f.sessionId,h));const m=new n(a.extension,f,this.d,this.i,this.j.converter,h);try{const D=await this.k(f.agentId,d),p=a.invoke(v.ChatAgentRequest.to(f),{history:D},m.apiObject,l);return await(0,N.$eh)(Promise.resolve(p).then(E=>{if(E?.metadata)try{JSON.stringify(E.metadata)}catch(y){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${a.extension.identifier.value}] [@${a.id}] ${P}`,a.extension),{errorDetails:{message:P},timings:m.timings}}return{errorDetails:E?.errorDetails,timings:m.timings,metadata:E?.metadata}}),l)}catch(D){return this.i.error(D,a.extension),{errorDetails:{message:(0,C.localize)(0,null,(0,L.$bj)(D)),responseIsIncomplete:!0}}}finally{m.close()}}async k(t,f){const d=[];for(const l of f.history){const a=v.ChatAgentResult.to(l.result),h=t===l.request.agentId?a:{...a,metadata:void 0};d.push(new c.$UO(l.request.message,l.request.command,l.request.variables.variables.map(v.ChatAgentResolvedVariable.to),l.request.agentId));const m=(0,u.$Hb)(l.response.map(D=>v.ChatResponsePart.toContent(D,this.j.converter)));d.push(new c.$VO(m,h,l.request.agentId,l.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,d,l,a){const h=this.c.get(f);if(!h)return Promise.resolve([]);const m=await this.k(h.id,l),D=v.ChatAgentResult.to(d);return(await h.provideFollowups(D,{history:m},a)).filter(p=>{const E=!p.participant||M.Iterable.some(this.c.values(),y=>y.id===p.participant&&$.$Lm.equals(y.extension.identifier,h.extension.identifier));return E||this.i.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),E}).map(p=>v.ChatFollowup.from(p,t))}$acceptFeedback(t,f,d,l){const a=this.c.get(t);if(!a)return;const h=v.ChatAgentResult.to(f);let m;switch(d){case g.InteractiveSessionVoteDirection.Down:m=c.ChatResultFeedbackKind.Unhelpful;break;case g.InteractiveSessionVoteDirection.Up:m=c.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(l?{result:h,kind:m,reportIssue:l}:{result:h,kind:m}))}$acceptAction(t,f,d){const l=this.c.get(t);if(!l||d.action.kind==="vote")return;const a=v.ChatAgentUserActionEvent.to(f,d,this.j.converter);a&&l.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(t,f,d){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(f,d)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f,d){const l=this.c.get(t);if(l)return(await l.provideSampleQuestions(v.ChatLocation.to(f),d)).map(a=>v.ChatFollowup.from(a,void 0))}}e.$dkc=i;class r{constructor(t,f,d,l,a){this.extension=t,this.id=f,this.u=d,this.w=l,this.x=a,this.n=new R.$be,this.o=new R.$be}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,f){return this.q?await this.q.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,d){if(!this.b)return[];const l=await this.b.provideFollowups(t,f,d);return l?l.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(t);return f?f.map(d=>typeof d=="string"?d:v.MarkdownString.from(d)):[]}async provideSampleQuestions(t,f){if(!this.s||!this.s.provideSampleQuestions)return[];const d=await this.s.provideSampleQuestions(t,f);return d||[]}get apiAgent(){let t=!1,f=!1;const d=()=>{t||f||(f=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof c.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:v.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),f=!1}))},l=this;return{get id(){return l.id},get fullName(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.c??l.extension.displayName??l.extension.name},set fullName(a){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.c=a,d()},get iconPath(){return l.d},set iconPath(a){l.d=a,d()},get requestHandler(){return l.x},set requestHandler(a){(0,S.$bg)(typeof a=="function","Invalid request handler"),l.x=a},get followupProvider(){return l.b},set followupProvider(a){l.b=a,d()},get isDefault(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.g},set isDefault(a){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.g=a,d()},get helpTextPrefix(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.i},set helpTextPrefix(a){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.i=a,d()},get helpTextVariablesPrefix(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.j},set helpTextVariablesPrefix(a){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.j=a,d()},get helpTextPostfix(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.k},set helpTextPostfix(a){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.k=a,d()},get isSecondary(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.m},set isSecondary(a){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.m=a,d()},get sampleRequest(){return l.l},set sampleRequest(a){l.l=a,d()},get supportIssueReporting(){return(0,o.$yG)(l.extension,"chatParticipantAdditions"),l.p},set supportIssueReporting(a){(0,o.$yG)(l.extension,"chatParticipantAdditions"),l.p=a,d()},get onDidReceiveFeedback(){return l.n.event},set participantVariableProvider(a){if((0,o.$yG)(l.extension,"chatParticipantAdditions"),l.q=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");l.u.$registerAgentCompletionsProvider(l.w,a.triggerCharacters)}else l.u.$unregisterAgentCompletionsProvider(l.w)},get participantVariableProvider(){return(0,o.$yG)(l.extension,"chatParticipantAdditions"),l.q},set welcomeMessageProvider(a){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.s=a,d()},get welcomeMessageProvider(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.s},onDidPerformAction:(0,o.$xG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(a){l.t=a,d()},get requester(){return l.t},dispose(){t=!0,l.b=void 0,l.n.dispose(),l.u.$unregisterAgent(l.w)}}}invoke(t,f,d,l){return this.x(t,f,d,l)}}}),define(ke[330],Ee([1,0,13,3,6,16,7,26]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class b{static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$PM.MainThreadChatVariables)}async $resolveVariable(C,$,k,v){const c=this.b.get(C);if(c)try{if(c.resolver.resolve2){(0,w.$yG)(c.extension,"chatParticipantAdditions");const g=new S($,this.c),o=await c.resolver.resolve2(c.data.name,{prompt:k},g.apiObject,v);if(o)return o.map(R.ChatVariable.from)}else{const g=await c.resolver.resolve(c.data.name,{prompt:k},v);if(g)return g.map(R.ChatVariable.from)}}catch(g){(0,u.$2)(g)}}registerVariableResolver(C,$,k,v){const c=b.a++;return this.b.set(c,{extension:C,data:{name:$,description:k},resolver:v}),this.c.$registerVariable(c,{name:$,description:k}),(0,N.$Sc)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$ekc=b;class S{constructor(C,$){this.c=C,this.d=$,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let $=function(v){if(C.a){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,v),c}};const C=this,k=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){$(this.progress);const c=new M.$QO(v),g=R.ChatResponseProgressPart.from(c);return k(g),this},reference(v){$(this.reference);const c=new M.$SO(v),g=R.ChatResponseReferencePart.from(c);return k(g),this},push(v){return $(this.push),v instanceof M.$SO?k(R.ChatResponseReferencePart.from(v)):v instanceof M.$QO&&k(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[331],Ee([1,0,8,55,4,3,2,83,25,16,7,6,26]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=k;function k(v,c,g){const o=v.getProxy(C.$PM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new b.$Nm,c.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const D=this.b.get(m.handle);return D?D.value:m}else if(m&&m.$mid===7){const D=m,p=this.b.get(D.commentControlHandle);if(!p)return D;const E=p.getCommentThread(D.commentThreadHandle);return E?E.value:D}else if(m&&(m.$mid===9||m.$mid===8)){const D=this.b.get(m.thread.commentControlHandle);if(!D)return m;const p=D.getCommentThread(m.thread.commentThreadHandle);return p?m.$mid===8?p.value:{thread:p.value,text:m.text}:m}else if(m&&m.$mid===10){const D=this.b.get(m.thread.commentControlHandle);if(!D)return m;const p=D.getCommentThread(m.thread.commentThreadHandle);if(!p)return m;const E=m.commentUniqueId,y=p.getCommentByUniqueId(E);return y||m}else if(m&&m.$mid===11){const D=this.b.get(m.thread.commentControlHandle);if(!D)return m;const p=D.getCommentThread(m.thread.commentThreadHandle);if(!p)return m;const E=m.text,y=m.commentUniqueId,P=p.getCommentByUniqueId(y);return P?(typeof P.body=="string"?P.body=E:P.body=new A.$gN(E),P):m}return m}})}createCommentController(m,D,p){const E=n.a++,y=new r(m,E,D,p);this.b.set(y.handle,y);const P=this.c.get(m.identifier)||[];return P.push(y),this.c.set(m.identifier,P),y.value}async $createCommentThreadTemplate(m,D,p){const E=this.b.get(m);E&&E.$createCommentThreadTemplate(D,p)}async $setActiveComment(m,D){const p=this.b.get(m);p&&p.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(m,D,p){const E=this.b.get(m);E&&E.$updateCommentThreadTemplate(D,p)}$deleteCommentThread(m,D){this.b.get(m)?.$deleteCommentThread(D)}async $provideCommentingRanges(m,D,p){const E=this.b.get(m);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const y=await g.ensureDocumentData(M.URI.revive(D));return(0,u.$ih)(async()=>{const P=await E.commentingRangeProvider.provideCommentingRanges(y.document,p);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(j=>S.Range.from(j)),fileComments:P.fileComments}),I})}$toggleReaction(m,D,p,E,y){const P=this.b.get(m);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,u.$ih)(()=>{const I=P.getCommentThread(D);if(I){const j=I.getCommentByUniqueId(E.uniqueIdInThread);if(P!==void 0&&j&&P.reactionHandler)return P.reactionHandler(j,f(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,typeof m=="object"?((0,$.$yG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=m.resolved,this.b.applicability=m.applicability):this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,D,p,E,y,P,I,j){this.m=D,this.n=p,this.o=E,this.p=y,this.q=P,this.extensionDescription=I,this.r=j,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${m}.${this.handle}`),o.$createCommentThread(D,this.handle,this.n,this.o,S.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{o.$deleteCommentThread(D,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(z){F.range=z},get comments(){return F.comments},set comments(z){F.comments=z},get collapsibleState(){return F.collapsibleState},set collapsibleState(z){F.collapsibleState=z},get canReply(){return F.canReply},set canReply(z){F.canReply=z},get contextValue(){return F.contextValue},set contextValue(z){F.contextValue=z},get label(){return F.label},set label(z){F.label=z},get state(){return F.state},set state(z){F.state=z},dispose:()=>{F.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const m=p=>Object.prototype.hasOwnProperty.call(this.b,p),D={};m("range")&&(D.range=S.Range.from(this.p)),m("label")&&(D.label=this.label),m("contextValue")&&(D.contextValue=this.contextValue??null),m("comments")&&(D.comments=this.q.map(p=>s(this,p,this.k,this.extensionDescription))),m("collapsibleState")&&(D.collapseState=d(this.g)),m("canReply")&&(D.canReply=this.canReply),m("state")&&(D.state=l(this.h)),m("applicability")&&(D.applicability=a(this.h)),m("isTemplate")&&(D.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(m){for(const D of this.k){const p=D[0],E=D[1];if(m===E)return p}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Je([(0,N.$Vh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,m?.resourceHints&&(0,$.$yG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,m?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,$.$yG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,$.$yG)(this.h,"activeComment"),this.f}constructor(m,D,p,E){this.h=m,this.i=D,this.j=p,this.k=E,this.a=new Map,o.$registerCommentController(this.handle,p,E,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(P){y.options=P},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(P){y.commentingRangeProvider=P},get reactionHandler(){return y.reactionHandler},set reactionHandler(P){y.reactionHandler=P},get activeCommentThread(){return y.activeCommentThread},createCommentThread(P,I,j){return y.createCommentThread(P,I,j).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(m,D,p){D===void 0&&(0,$.$yG)(this.h,"fileComments");const E=new i(this.id,this.handle,void 0,m,D,p,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(m){if(!m){this.e=void 0,this.f=void 0;return}const D=this.a.get(m.commentThreadHandle);D&&(this.e=m.uniqueIdInThread?D.getCommentByUniqueId(m.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(m,D){const p=new i(this.id,this.handle,void 0,M.URI.revive(m),S.Range.to(D),[],this.h,!0);return p.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(m,D){const p=this.a.get(m);p&&(p.range=S.Range.to(D))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.g.forEach(m=>m.dispose())}}function s(h,m,D,p){let E=D.get(m);return E||(E=++h.commentHandle,D.set(m,E)),m.state!==void 0&&(0,$.$yG)(p,"commentsDraftState"),m.reactions?.some(y=>y.reactors!==void 0)&&(0,$.$yG)(p,"commentReactor"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:E,body:typeof m.body=="string"?m.body:S.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(y=>t(y)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?S.$_O(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted,reactors:h.reactors&&h.reactors.length>0&&typeof h.reactors[0]!="string"?h.reactors.map(m=>m.name):h.reactors}}function f(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?M.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1,reactors:h.reactors?.map(m=>({name:m}))}}function d(h){if(h!==void 0)switch(h){case A.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function l(h){let m;if(typeof h=="object"?m=h.resolved:m=h,m!==void 0)switch(m){case A.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}function a(h){let m;if(typeof h=="object"&&(m=h.applicability),m!==void 0)switch(m){case A.CommentThreadApplicability.Current:return w.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return w.CommentThreadApplicability.Outdated}return w.CommentThreadApplicability.Current}return new n}}),define(ke[332],Ee([1,0,22,56,3,15,23,2,16,92,111,6,7]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;class k{constructor(f,d){this.document=f,this.b=d,this.a=1,this.c=new A.$1jc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,d){await this.f(f).undo(),d||this.disposeBackup()}async redo(f,d){await this.f(f).redo(),d||this.disposeBackup()}disposeEdits(f){for(const d of f)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this.a++;return(0,M.$4g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const d=this.c.get(f,0);if(!d)throw new Error("No edit found");return d}}class v{constructor(){this.a=new Map}get(f,d){return this.a.get(this.b(f,d))}add(f,d,l){const a=this.b(f,d.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${f} resource:${d.uri}`);const h=new k(d,l);return this.a.set(a,h),h}delete(f,d){const l=this.b(f,d.uri);this.a.delete(l)}b(f,d){return`${f}@@@${d}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class g{constructor(){this.a=new Map}addTextProvider(f,d,l){return this.b(0,f,d,l)}addCustomProvider(f,d,l){return this.b(1,f,d,l)}get(f){return this.a.get(f)}b(f,d,l,a){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:f,extension:l,provider:a}),new $.$RM(()=>this.a.delete(d))}}class o{constructor(f,d,l,a,h){this.d=d,this.f=l,this.g=a,this.h=h,this.b=new g,this.c=new v,this.a=f.getProxy(C.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(f,d,l,a){const h=new L.$Tc;return i(l)?(h.add(this.b.addTextProvider(d,f,l)),this.a.$registerTextEditorProvider((0,S.$xkc)(f),d,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,S.$vkc)(f))):(h.add(this.b.addCustomProvider(d,f,l)),n(l)&&h.add(l.onDidChangeCustomDocument(m=>{const D=this.i(d,m.document.uri);if(r(m)){const p=D.addEdit(m);this.a.$onDidEdit(m.document.uri,d,p,m.label)}else this.a.$onContentChange(m.document.uri,d)})),this.a.$registerCustomEditorProvider((0,S.$xkc)(f),d,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,S.$vkc)(f))),$.$RM.from(h,new $.$RM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(f,d,l,a,h){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=w.URI.revive(f),p=await m.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:a?.buffer},h);let E;return n(m.provider)&&this.f&&(E=this.f.workspaceValue(m.extension)??this.f.globalValue(m.extension)),this.c.add(d,p,E),{editable:n(m.provider)}}async $disposeCustomDocument(f,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const a=w.URI.revive(f),{document:h}=this.i(d,a);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(f,d,l,a,h,m){const D=this.b.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const p=b.ViewColumn.to(h),E=this.g.createNewWebview(d,a.contentOptions,D.extension),y=this.h.createNewWebviewPanel(d,l,a.title,p,a.options,E,a.active),P=w.URI.revive(f);switch(D.type){case 1:{const{document:I}=this.i(l,P);return D.provider.resolveCustomEditor(I,y,m)}case 0:{const I=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(I,y,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,d,l){this.i(d,f).disposeEdits(l)}async $onMoveCustomEditor(f,d,l){const a=this.b.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(f);if(!h)throw new Error("No webview found");const m=w.URI.revive(d),D=this.d.getDocument(m);await a.provider.moveCustomTextEditor(D,h,u.CancellationToken.None)}async $undo(f,d,l,a){return this.i(d,f).undo(l,a)}async $redo(f,d,l,a){return this.i(d,f).redo(l,a)}async $revert(f,d,l){const a=this.i(d,f);await this.j(d).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(f,d,l){const a=this.i(d,f);await this.j(d).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(f,d,l,a){const h=this.i(d,f);return this.j(d).saveCustomDocumentAs(h.document,w.URI.revive(l),a)}async $backup(f,d,l){const a=this.i(d,f),m=await this.j(d).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(m),m.id}i(f,d){const l=this.c.get(f,w.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(f){const l=this.b.get(f)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$Akc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$ej)(f)+""}}),define(ke[333],Ee([1,0,219,138,2,6,7,16,4,12,27,60]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=e.$8jc=void 0;class k{#e;#t;#i;constructor(g,o,n,i,r,s,t,f){this.d=g,this.e=o,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new A.$Bc(d=>s.getComparisonKey(d)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,o){if(!g){this.clear();return}this.j();let n=[];if(L.URI.isUri(g)){if(!o){this.delete(g);return}this.#i.set(g,o.slice()),n=[g]}else if(Array.isArray(g)){n=[];let s;g=[...g].sort(k.k);for(const t of g){const[f,d]=t;if((!s||f.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=f,n.push(f),this.#i.set(f,[])),d)this.#i.get(f)?.push(...d);else{const l=this.#i.get(f);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const f=this.#i.get(s);if(f)if(f.length>this.g){t=[];const d=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const a of f)if(a.severity===d[l]&&t.push({...w.Diagnostic.from(a),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,u.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(d=>({...w.Diagnostic.from(d),modelVersionId:this.h(s)}));if(i.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,o){this.j();for(const[n,i]of this)g.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const o=this.#i.get(g);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,o){return g[0].toString()<o[0].toString()?-1:g[0].toString()>o[0].toString()?1:0}}e.$8jc=k;let v=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(g){const o=new A.$Bc;for(const n of g)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(g,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new b.$fe({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,$._mapper),this.f=g.getProxy(R.$PM.MainThreadDiagnostics)}createDiagnosticCollection(g,o){const{g:n,f:i,h:r,j:s,k:t,l:f}=this,d=new class{$changeMany(h,m){i.$changeMany(h,m),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,h,m.length===0?"CLEARING":m)}$clear(h){i.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,h)}dispose(){i.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,l=o;else if(!n.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+$.c++;while(n.has(l))}return new class extends k{constructor(){super(o,l,$.e,$.d,h=>f.getDocument(h)?.version,t.extUri,d,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(g){if(g)return this.m(g);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((r,s)=>{let t=o.get(r.toString());typeof t>"u"&&(t=n.length,o.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(g){let o=[];for(const n of this.g.values())n.has(g)&&(o=o.concat(n.get(g)));return o}$acceptMarkersChange(g){if(!this.n){const o="_generated_mirror",n=new k(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of g)this.n.set(L.URI.revive(o),n.map(w.Diagnostic.to))}};e.$9jc=v,e.$9jc=v=$=Je([qe(1,S.$Wj),qe(2,C.$7jc)],v)}),define(ke[334],Ee([1,0,2,13,7,16,75,48]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class b{constructor(A,C,$,k={timeout:1500,errors:3}){this.c=A,this.d=C,this.f=$,this.g=k,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(C,$,k)=>{const c={dispose:this.a.push([C,$,A])};return Array.isArray(k)&&k.push(c),c}}async $participateInSave(A,C){const $=u.URI.revive(A);let k=!1;const v=setTimeout(()=>k=!0,this.g.timeout),c=[];try{for(const g of[...this.a]){if(k)break;const o=this.d.getDocument($),n=await this.h(g,{document:o,reason:R.TextDocumentSaveReason.to(C)});c.push(n)}}finally{clearTimeout(v)}return c}h([A,C,$],k){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i($,A,C,k).then(()=>!0,c=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' threw ERROR`),this.c.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const g=this.b.get(A);this.b.set(A,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,C,$,k){const v=[],c=Date.now(),{document:g,reason:o}=k,{version:n}=g,i=Object.freeze({document:g,reason:o,waitUntil(r){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{C.apply($,[i])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,s)=>{const t=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(t),r(f)}).catch(f=>{clearTimeout(t),s(f)})}).then(r=>{const s={edits:[]};for(const t of r)if(Array.isArray(t)&&t.every(f=>f instanceof L.$YM))for(const{newText:f,newEol:d,range:l}of t)s.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:f,eol:d&&R.EndOfLine.from(d)}});if(s.edits.length!==0)return n===g.version?this.f.$tryApplyWorkspaceEdit(new w.$mw(s)):Promise.reject(new Error("concurrent_edits"))})}}e.$elc=b}),define(ke[335],Ee([1,0,4,3,2,6,152,16,18,24,7]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class C{constructor(k,v){this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=k.getProxy(R.$PM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(c=>{for(const g of c)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const g of c)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const v=this.g.getDocument(k);if(v)return v}getDocument(k){const v=this.getDocumentData(k);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return v.document}ensureDocumentData(k){const v=this.g.getDocument(k);if(v)return Promise.resolve(v);let c=this.h.get(k.toString());return c||(c=this.f.$tryOpenDocument(k).then(g=>{this.h.delete(k.toString());const o=L.URI.revive(g);return(0,b.$cg)(this.g.getDocument(o))},g=>(this.h.delete(k.toString()),Promise.reject(g))),this.h.set(k.toString(),c)),c}createDocumentData(k){return this.f.$tryCreateDocument(k).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(k,v){const c=L.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(v),this.a.fire(g.document)}$acceptModelSaved(k){const v=L.URI.revive(k),c=this.g.getDocument(v);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(k,v){const c=L.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");g._acceptIsDirty(v),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,v,c){const g=L.URI.revive(k),o=this.g.getDocument(g);if(!o)throw new Error("unknown document");o._acceptIsDirty(c),o.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,S.$Xn)({document:o.document,contentChanges:v.changes.map(i=>({range:w.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(k,v){(0,M.$cP)(k,v)}}e.$0jc=C}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,7]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=e.$Bkc=void 0,e.$Bkc=(0,M.$qi)("IExtHostEditorTabs");class C{constructor(g,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$BO(R.URI.revive(this.b.input.uri));case 2:return new A.$CO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$DO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$EO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$FO(this.b.input.viewType);case 4:return new A.$GO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$HO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$IO;case 9:return new A.$JO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$KO;case 11:return new A.$LO(this.b.input.diffEditors.map(g=>new A.$CO(R.URI.revive(g.original),R.URI.revive(g.modified))));default:return}}}class ${constructor(g,o){this.c=[],this.d="",this.b=g,this.e=o;for(const n of g.tabs)n.isActive&&(this.d=n.id),this.c.push(new C(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return S.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(n=>n.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const n=new C(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,n),g.tabDto.isActive&&(this.d=n.tabId),n}else if(g.kind===1){const n=this.c.splice(g.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(g.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,n),n}const o=this.c.find(n=>n.tabId===g.tabDto.id);if(!o)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(g.tabDto),o}activeTabId(){return this.d}}let k=class{constructor(g){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=g.getProxy(w.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,o={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(n=>n.apiObject))},get activeTabGroup(){const n=g.d;return(0,L.$cg)(g.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?v(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(g){const o=new Set(this.e.map(d=>d.groupId)),n=new Set(g.map(d=>d.groupId)),i=(0,u.$L)(o,n),r=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=g.map(d=>{const l=new $(d,()=>this.d);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const f=(0,L.$cg)(g.find(d=>d.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(g){const o=this.e.find(n=>n.groupId===g.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const o=this.e.find(i=>i.groupId===g.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(g){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===g)return n}h(g){return this.e.find(o=>o.apiObject===g)}async i(g,o){const n=[];for(const i of g){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,o)}async j(g,o){const n=[];for(const i of g){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,o)}};e.$Ckc=k,e.$Ckc=k=Je([qe(0,b.$aP)],k);function v(c){return c.tabs!==void 0}}),define(ke[336],Ee([1,0,2,6,3,7,16,180,14,21,26,80]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class ${constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const g=this.a.indexOf(c);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),g=[];let o,n,i=14,r=14;for(const s of c){let t=o?(0,b.$vf)(o,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,g.push([n,s.toUpperCase().charCodeAt(t),r]),g.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;o=s,r=i}g.push([9,58,10]),g.push([10,47,12]),this.b=new w.$12(g)}}provideDocumentLinks(c){this.c();const g=[],o=w.$22.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of o){const i=M.DocumentLink.to(n);i.target&&g.push(i)}return g}}class k{constructor(c,g){this.i=g,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(N.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,g,o,n={}){if(k.j(o),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const i=this.h++;this.b.add(g),this.d.add(g),this.c.set(i,o);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$yG)(c,"fsChunks"),r+=4);let s;n.isReadonly&&(0,C.$Pk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,g,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${g}`),console.error(f)});const t=o.onDidChangeFile(f=>{const d=[];for(const l of f){const{uri:a,type:h}=l;if(a.scheme!==g)continue;let m;switch(h){case R.FileChangeType.Changed:m=0;break;case R.FileChangeType.Created:m=1;break;case R.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:a,type:m})}this.a.$onFileSystemChange(i,d)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:g,ctime:o,mtime:n,size:i,permissions:r}=c;return{type:g,ctime:o,mtime:n,size:i,permissions:r}}$stat(c,g){return Promise.resolve(this.l(c).stat(u.URI.revive(g))).then(o=>k.k(o))}$readdir(c,g){return Promise.resolve(this.l(c).readDirectory(u.URI.revive(g)))}$readFile(c,g){return Promise.resolve(this.l(c).readFile(u.URI.revive(g))).then(o=>S.$Ce.wrap(o))}$writeFile(c,g,o,n){return Promise.resolve(this.l(c).writeFile(u.URI.revive(g),o.buffer,n))}$delete(c,g,o){return Promise.resolve(this.l(c).delete(u.URI.revive(g),o))}$rename(c,g,o,n){return Promise.resolve(this.l(c).rename(u.URI.revive(g),u.URI.revive(o),n))}$copy(c,g,o,n){const i=this.l(c);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(g),u.URI.revive(o),n))}$mkdir(c,g){return Promise.resolve(this.l(c).createDirectory(u.URI.revive(g)))}$watch(c,g,o,n){const i=this.l(c).watch(u.URI.revive(o),n);this.f.set(g,i)}$unwatch(c,g){const o=this.f.get(g);o&&(o.dispose(),this.f.delete(g))}$open(c,g,o){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(g),o))}$close(c,g){const o=this.l(c);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(g))}$read(c,g,o,n){const i=this.l(c);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=S.$Ce.alloc(n);return Promise.resolve(i.read(g,o,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(c,g,o,n){const i=this.l(c);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(g,o,n.buffer,0,n.byteLength))}l(c){const g=this.c.get(c);if(!g){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return g}}e.$glc=k}),define(ke[337],Ee([1,0,4,35,2,6,16,7,46]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(k,v,c,g,o,n){this.a=Math.random(),this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$kk)(o),r=typeof o=="string",s=n?.correlate,t=g(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(s&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const d of f.created){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of f.changed){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of f.deleted){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=w.$RM.from(this.i(k,c,o,n,n?.correlate),this.b,this.c,this.d,t)}i(k,v,c,g,o){const n=w.$RM.from();if(typeof c=="string")return n;const i=k.getProxy(R.$PM.MainThreadFileSystemEventService);let r=!1;return(c.pattern.includes(N.$gk)||c.pattern.includes(N.$hk))&&(r=!0),i.$watch(v.identifier.value,this.a,c.baseUri,{recursive:r,excludes:g?.excludes??[]},!!o),w.$RM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(k){this.a=k,this.session=this.a.session,this.b=new b.$V(()=>this.a.created.map(L.URI.revive)),this.c=new b.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new b.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(k,v,c){this.j=k,this.k=v,this.l=c,this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.g=new u.$de,this.h=new u.$de,this.i=new u.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,v,c,g){return new S(this.j,k,v,this.a.event,M.GlobPattern.from(c),g)}$onFileEvent(k){this.a.fire(new A(k))}$onDidRunFileOperation(k,v){switch(k){case 2:this.b.fire(Object.freeze({files:v.map(c=>({oldUri:L.URI.revive(c.source),newUri:L.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(c=>L.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(c=>L.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,v){return(c,g,o)=>{const n=function(r){c.call(g,r)};return n.extension=k,v.event(n,void 0,o)}}async $onWillRunFileOperation(k,v,c,g){switch(k){case 2:return await this.n(this.g,{files:v.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},c,g);case 1:return await this.n(this.i,{files:v.map(o=>L.URI.revive(o.target))},c,g);case 0:case 3:return await this.n(this.h,{files:v.map(o=>L.URI.revive(o.target))},c,g)}}async n(k,v,c,g){const o=new Set,n=[];if(await k.fireAsync(v,g,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof w.$2M&&(n.push([s.extension,f]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",s.extension.identifier)}),g.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=M.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$hlc=C}),define(ke[338],Ee([1,0,19,8,22,13,124,3,24,39,14,18,2,29,176,83,134,221,25,16,7,26,111,6]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class d{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const Q=this.d.getDocument(q),J=await this.e.provideDocumentSymbols(Q,V);if(!(0,u.$Kb)(J))return J[0]instanceof r.$$M?J.map(i.DocumentSymbol.from):d.f(J)}static f(q){q=q.slice(0).sort((J,he)=>{let pe=J.location.range.start.compareTo(he.location.range.start);return pe===0&&(pe=he.location.range.end.compareTo(J.location.range.end)),pe});const V=[],Q=[];for(const J of q){const he={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push(he),V.push(he);break}const pe=Q[Q.length-1];if(k.$kt.containsRange(pe.range,he.range)&&!k.$kt.equalsRange(pe.range,he.range)){pe.children?.push(he),Q.push(he);break}Q.pop()}}return V}}class l{constructor(q,V,Q,J,he,pe){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=he,this.l=pe,this.d=new t.$1jc("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const Q=this.f.getDocument(q),J=await this.h.provideCodeLenses(Q,V);if(!J||V.isCancellationRequested)return;const he=this.d.add(J),pe=new w.$Tc;this.e.set(he,pe);const ze={cacheId:he,lenses:[]};for(let Ve=0;Ve<J.length;Ve++)ze.lenses.push({cacheId:[he,Ve],range:i.Range.from(J[Ve].range),command:this.g.toInternal(J[Ve].command,pe)});return ze}async resolveCodeLens(q,V){const Q=q.cacheId&&this.d.get(...q.cacheId);if(!Q)return;let J;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.h.resolveCodeLens(Q,V),J||(J=Q),V.isCancellationRequested)return;const he=q.cacheId&&this.e.get(q.cacheId[0]);if(he){if(!J.command){const pe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,pe),this.l.error(pe);return}return q.command=this.g.toInternal(J.command,he),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function a(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class h{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDefinition(J,he,Q);return a(pe)}}class m{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDeclaration(J,he,Q);return a(pe)}}class D{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideImplementation(J,he,Q);return a(pe)}}class p{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideTypeDefinition(J,he,Q);return a(pe)}}class E{constructor(q,V){this.d=q,this.e=V}async provideHover(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideHover(J,he,Q);if(!(!pe||(0,u.$Kb)(pe.contents)))return pe.range||(pe.range=J.getWordRangeAtPosition(he)),pe.range||(pe.range=new r.$TM(he,he)),i.Hover.from(pe)}}class y{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideEvaluatableExpression(J,he,Q);if(pe)return i.EvaluatableExpression.from(pe)}}class P{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,Q,J){const he=this.d.getDocument(q),pe=await this.e.provideInlineValues(he,i.Range.to(V),i.InlineValueContext.to(Q),J);if(Array.isArray(pe))return pe.map(ze=>i.InlineValue.from(ze))}}class I{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDocumentHighlights(J,he,Q);if(Array.isArray(pe))return pe.map(i.DocumentHighlight.from)}}class j{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,Q,J){const he=this.d.getDocument(q),pe=Q.map(Xe=>this.d.getDocument(Xe)),ze=i.Position.to(V),Ve=await this.e.provideMultiDocumentHighlights(he,ze,pe,J);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class F{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideLinkedEditingRanges(J,he,Q);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,u.$Hb)(pe.ranges.map(i.Range.from)),wordPattern:pe.wordPattern}}}class z{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,Q,J){const he=this.d.getDocument(q),pe=i.Position.to(V),ze=await this.e.provideReferences(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.location.from)}}class O{static{this.d=1e3}constructor(q,V,Q,J,he,pe,ze){this.g=q,this.h=V,this.j=Q,this.k=J,this.l=he,this.m=pe,this.n=ze,this.e=new t.$1jc("CodeAction"),this.f=new Map}async provideCodeActions(q,V,Q,J){const he=this.g.getDocument(q),pe=v.$mt.isISelection(V)?i.Selection.to(V):i.Range.to(V),ze=[];for(const st of this.j.getDiagnostics(q))if(pe.intersection(st.range)&&ze.push(st)>O.d)break;const Ve={diagnostics:ze,only:Q.only?new r.$aN(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},Xe=await this.k.provideCodeActions(he,pe,Ve,J);if(!(0,u.$Lb)(Xe)||J.isCancellationRequested)return;const tt=this.e.add(Xe),ot=new w.$Tc;this.f.set(tt,ot);const it=[];for(let st=0;st<Xe.length;st++){const De=Xe[st];if(De)if(O.o(De))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:De.title,command:this.h.toInternal(De,ot)});else{Ve.only&&(De.kind?Ve.only.contains(De.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${De.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=De.ranges??[];it.push({cacheId:[tt,st],title:De.title,command:De.command&&this.h.toInternal(De.command,ot),diagnostics:De.diagnostics&&De.diagnostics.map(i.Diagnostic.from),edit:De.edit&&i.WorkspaceEdit.from(De.edit,void 0),kind:De.kind&&De.kind.value,isPreferred:De.isPreferred,isAI:(0,s.$xG)(this.m,"codeActionAI")?De.isAI:!1,ranges:(0,s.$xG)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:De.disabled?.reason})}}return{cacheId:tt,actions:it}}async resolveCodeAction(q,V){const[Q,J]=q,he=this.e.get(Q,J);if(!he||O.o(he))return{};if(!this.k.resolveCodeAction)return{};const pe=await this.k.resolveCodeAction(he,V)??he;let ze;pe.edit&&(ze=i.WorkspaceEdit.from(pe.edit,void 0));let Ve;if(pe.command){const Xe=this.f.get(Q);Xe&&(Ve=this.h.toInternal(pe.command,Xe))}return{edit:ze,command:Ve}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class T{constructor(q,V,Q,J,he){this.e=q,this.f=V,this.g=Q,this.h=J,this.j=he,this.d=new t.$1jc("DocumentPasteEdit")}async prepareDocumentPaste(q,V,Q,J){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(q),pe=V.map(Xe=>i.Range.to(Xe)),ze=i.DataTransfer.toDataTransfer(Q,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(he,pe,ze,J),J.isCancellationRequested)return;const Ve=Array.from(ze).filter(([,Xe])=>!(Xe instanceof r.$GN));return i.DataTransfer.from(Ve)}async providePasteEdits(q,V,Q,J,he,pe){if(!this.g.provideDocumentPasteEdits)return[];const ze=this.f.getDocument(V),Ve=Q.map(it=>i.Range.to(it)),Xe=i.DataTransfer.toDataTransfer(J,async it=>(await this.e.$resolvePasteFileData(this.h,q,it)).buffer),tt=await this.g.provideDocumentPasteEdits(ze,Ve,Xe,{only:he.only?new r.$LN(he.only):void 0,triggerKind:he.triggerKind},pe);if(!tt||pe.isCancellationRequested)return[];const ot=this.d.add(tt);return tt.map((it,st)=>({_cacheId:[ot,st],title:it.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:it.kind,yieldTo:it.yieldTo?.map(De=>De.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[Q,J]=q,he=this.d.get(Q,J);if(!he||!this.g.resolveDocumentPasteEdit)return{};const pe=await this.g.resolveDocumentPasteEdit(he,V)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,Q){const J=this.d.getDocument(q),he=await this.e.provideDocumentFormattingEdits(J,V,Q);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class W{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,Q,J){const he=this.d.getDocument(q),pe=i.Range.to(V),ze=await this.e.provideDocumentRangeFormattingEdits(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,Q,J){(0,C.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(q),pe=V.map(i.Range.to),ze=await this.e.provideDocumentRangesFormattingEdits(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class X{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,Q,J,he){const pe=this.d.getDocument(q),ze=i.Position.to(V),Ve=await this.e.provideOnTypeFormattingEdits(pe,ze,Q,J,he);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class x{constructor(q,V){this.e=q,this.f=V,this.d=new t.$1jc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const Q=await this.e.provideWorkspaceSymbols(q,V);if(!(0,u.$Lb)(Q))return{symbols:[]};const J=this.d.add(Q),he={cacheId:J,symbols:[]};for(let pe=0;pe<Q.length;pe++){const ze=Q[pe];if(!ze||!ze.name){this.f.warn("INVALID SymbolInformation",ze);continue}he.symbols.push({...i.WorkspaceSymbol.from(ze),cacheId:[J,pe]})}return he}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const Q=this.d.get(...q.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,V);return J&&(0,b.$Zn)(q,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class Z{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideRenameEdits(q,V,Q,J){const he=this.d.getDocument(q),pe=i.Position.to(V);try{const ze=await this.e.provideRenameEdits(he,pe,Q,J);return ze?i.WorkspaceEdit.from(ze):void 0}catch(ze){const Ve=Z.g(ze);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(q,V,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(q),he=i.Position.to(V);try{const pe=await this.e.prepareRename(J,he,Q);let ze,Ve;if(r.$TM.isRange(pe)?(ze=pe,Ve=J.getText(pe)):(0,C.$6f)(pe)&&(ze=pe.range,Ve=pe.placeholder),!ze||!Ve)return;if(ze.start.line>he.line||ze.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ze),text:Ve}}catch(pe){const ze=Z.g(pe);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(pe)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Y{constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideNewSymbolNames(q,V,Q){const J=this.d.getDocument(q),he=i.Range.to(V);try{const pe=await this.e.provideNewSymbolNames(J,he,Q);return pe?pe.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(pe){this.f.error(Y.g(pe)??JSON.stringify(pe,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ce{constructor(q,V){this.resultId=q,this.tokens=V}}class ne{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,Q){const J=this.f.getDocument(q),he=V!==0?this.d.get(V):null;let pe=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,he.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return he&&this.d.delete(V),pe?(pe=ne.h(pe),this.o(ne.n(he,pe),pe)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return ne.j(q)?ne.k(q)?q:new r.$_N(new Uint32Array(q.data),q.resultId):ne.l(q)?ne.m(q)?q:new r.$bO(q.edits.map(V=>new r.$aO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!ne.j(V)||!q||!q.tokens)return V;const Q=q.tokens,J=Q.length,he=V.data,pe=he.length;let ze=0;const Ve=Math.min(J,pe);for(;ze<Ve&&Q[ze]===he[ze];)ze++;if(ze===J&&ze===pe)return new r.$bO([],V.resultId);let Xe=0;const tt=Ve-ze;for(;Xe<tt&&Q[J-Xe-1]===he[pe-Xe-1];)Xe++;return new r.$bO([{start:ze,deleteCount:J-ze-Xe,data:he.subarray(ze,pe-Xe)}],V.resultId)}o(q,V){if(ne.j(q)){const Q=this.e++;return this.d.set(Q,new ce(q.resultId,q.data)),(0,g.$hbb)({id:Q,type:"full",data:q.data})}if(ne.l(q)){const Q=this.e++;return ne.j(V)?this.d.set(Q,new ce(V.resultId,V.data)):this.d.set(Q,new ce(q.resultId)),(0,g.$hbb)({id:Q,type:"delta",deltas:(q.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class $e{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,Q){const J=this.d.getDocument(q),he=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(V),Q);return he?this.f(he):null}f(q){return(0,g.$hbb)({id:0,type:"full",data:q.data})}}class Pe{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,Q,J,he){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=he,this.d=new t.$1jc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,Q,J){const he=this.f.getDocument(q),pe=i.Position.to(V),ze=he.getWordRangeAtPosition(pe)||new r.$TM(pe,pe),Ve=ze.with({end:pe}),Xe=new S.$0d,tt=await this.h.provideCompletionItems(he,pe,J,i.CompletionContext.to(Q));if(!tt||J.isCancellationRequested)return;const ot=Array.isArray(tt)?new r.$nN(tt):tt,it=Pe.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),st=new w.$Tc;this.e.set(it,st);const De=[],Be={x:it,b:De,a:{replace:i.Range.from(ze),insert:i.Range.from(Ve)},c:ot.isIncomplete||void 0,d:Xe.elapsed()};for(let He=0;He<ot.items.length;He++){const Le=ot.items[He],Ze=this.l(Le,[it,He],Ve,ze);De.push(Ze)}return Be}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=this.l(Q,q),he=await this.h.resolveCompletionItem(Q,V);if(!he)return;const pe=this.l(he,q);return(J.h!==pe.h||J.i!==pe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==pe.n||J.o!==pe.o||!(0,b.$1n)(J.p,pe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:pe.d,c:pe.c,l:pe.l,h:pe.h,i:pe.i,n:pe.n,o:pe.o,p:pe.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,Q,J){const he=this.e.get(V[0]);if(!he)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(q.command,he),ze={x:V,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=q.textEdit.newText):typeof q.insertText=="string"?ze.h=q.insertText:q.insertText instanceof r.$3M&&(ze.h=q.insertText.value,ze.i|=4);let Ve;return q.textEdit?Ve=q.textEdit.range:q.range&&(Ve=q.range),r.$TM.isRange(Ve)?ze.j=i.Range.from(Ve):Ve&&(!Q?.isEqual(Ve.inserting)||!J?.isEqual(Ve.replacing))&&(ze.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),ze}}class _{async provideInlineCompletions(q,V,Q,J){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,Q){}handlePartialAccept(q,V,Q,J){}}class U extends _{constructor(q,V,Q,J){super(),this.f=q,this.g=V,this.h=Q,this.j=J,this.d=new be,this.e=(0,s.$xG)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$xG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,Q,J){const he=this.g.getDocument(q),pe=i.Position.to(V),ze=await this.h.provideInlineCompletionItems(he,pe,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!ze||J.isCancellationRequested)return;const Ve=Array.isArray(ze)?ze:ze.items,Xe=this.e?Array.isArray(ze)?[]:ze.commands||[]:[],tt=this.e&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((st,De)=>{let Be;st.command&&(ot||(ot=new w.$Tc),Be=this.j.toInternal(st.command,ot));const He=st.insertText;return{insertText:typeof He=="string"?He:{snippet:He.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:Be,idx:De,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Xe.map(st=>(ot||(ot=new w.$Tc),this.j.toInternal(st,ot))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,Q){const J=this.d.get(q)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Q)}handlePartialAccept(q,V,Q,J){const he=this.d.get(q)?.items[V];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,Q),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(J)))}}class ie{async provideInlineEdits(q,V,Q){const J=this.f.getDocument(q),he=await this.g.provideInlineEdit(J,{triggerKind:this.e[V.triggerKind]},Q);if(!he||Q.isCancellationRequested)return;let pe;const ze=this.d.createReferenceId({dispose(){pe?.dispose()},item:he});let Ve;he.accepted&&(pe||(pe=new w.$Tc),Ve=this.h.toInternal(he.accepted,pe));let Xe;return he.rejected&&(pe||(pe=new w.$Tc),Xe=this.h.toInternal(he.rejected,pe)),{pid:ze,text:he.text,range:i.Range.from(he.range),accepted:Ve,rejected:Xe}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,Q,J){this.f=V,this.g=Q,this.h=J,this.d=new be,this.e={[c.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class Ce{constructor(q,V){this.e=q,this.f=V,this.d=new t.$1jc("SignatureHelp")}async provideSignatureHelp(q,V,Q,J){const he=this.e.getDocument(q),pe=i.Position.to(V),ze=this.g(Q),Ve=await this.f.provideSignatureHelp(he,pe,J,ze);if(Ve){const Xe=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Xe}}}g(q){let V;if(q.activeSignatureHelp){const Q=i.SignatureHelp.to(q.activeSignatureHelp),J=this.d.get(q.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=Q.activeSignature,V.activeParameter=Q.activeParameter):V=Q}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class oe{constructor(q,V,Q,J,he){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=he,this.d=new t.$1jc("InlayHints"),this.e=new Map}async provideInlayHints(q,V,Q){const J=this.f.getDocument(q),he=i.Range.to(V),pe=await this.h.provideInlayHints(J,he,Q);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(Q.isCancellationRequested)return;const ze=this.d.add(pe);this.e.set(ze,new w.$Tc);const Ve={hints:[],cacheId:ze};for(let Xe=0;Xe<pe.length;Xe++)this.l(pe[Xe],he)&&Ve.hints.push(this.m(pe[Xe],[ze,Xe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ve}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.h.resolveInlayHint(Q,V);if(J&&this.l(J))return this.m(J,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const Q=this.e.get(V[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")J.label=q.label;else{const he=[];J.label=he;for(const pe of q.label){if(!pe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ze={label:pe.value,tooltip:i.MarkdownString.fromStrict(pe.tooltip)};r.$4M.isLocation(pe.location)&&(ze.location=i.location.from(pe.location)),pe.command&&(ze.command=this.g.toInternal(pe.command,Q)),he.push(ze)}}return J}}class ae{constructor(q,V){this.e=q,this.f=V,this.d=new t.$1jc("DocumentLink")}async provideLinks(q,V){const Q=this.e.getDocument(q),J=await this.f.provideDocumentLinks(Q,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ae.g).map(i.DocumentLink.from)};{const he=this.d.add(J),pe={links:[],cacheId:he};for(let ze=0;ze<J.length;ze++){if(!ae.g(J[ze]))continue;const Ve=i.DocumentLink.from(J[ze]);Ve.cacheId=[he,ze],pe.links.push(Ve)}return pe}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,V);if(!(!J||!ae.g(J)))return i.DocumentLink.from(J)}releaseLinks(q){this.d.delete(q)}}class re{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const Q=this.d.getDocument(q),J=await this.e.provideDocumentColors(Q,V);return Array.isArray(J)?J.map(pe=>({color:i.Color.from(pe.color),range:i.Range.from(pe.range)})):[]}async provideColorPresentations(q,V,Q){const J=this.d.getDocument(q),he=i.Range.to(V.range),pe=i.Color.to(V.color),ze=await this.e.provideColorPresentations(pe,{document:J,range:he},Q);if(Array.isArray(ze))return ze.map(i.ColorPresentation.from)}}class G{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,Q){const J=this.d.getDocument(q),he=await this.e.provideFoldingRanges(J,V,Q);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class te{constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideSelectionRanges(q,V,Q){const J=this.d.getDocument(q),he=V.map(i.Position.to),pe=await this.e.provideSelectionRanges(J,he,Q);if(!(0,u.$Lb)(pe))return[];if(pe.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let Ve=0;Ve<he.length;Ve++){const Xe=[];ze.push(Xe);let tt=he[Ve],ot=pe[Ve];for(;;){if(!ot.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(i.SelectionRange.from(ot)),!ot.parent)break;tt=ot.range,ot=ot.parent}}return ze}}class ge{constructor(q,V){this.f=q,this.g=V,this.d=new M.$fP(""),this.e=new Map}async prepareSession(q,V,Q){const J=this.f.getDocument(q),he=i.Position.to(V),pe=await this.g.prepareCallHierarchy(J,he,Q);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(Ve=>this.h(ze,Ve)):[this.h(ze,pe)]}async provideCallsTo(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(J,Q);if(he)return he.map(pe=>({from:this.h(q,pe.from),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}async provideCallsFrom(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if(he)return he.map(pe=>({to:this.h(q,pe.to),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}releaseSession(q){this.e.delete(q)}h(q,V){const Q=this.e.get(q),J=i.CallHierarchyItem.from(V,q,Q.size.toString(36));return Q.set(J._itemId,V),J}j(q,V){return this.e.get(q)?.get(V)}}class we{constructor(q,V){this.f=q,this.g=V,this.d=new M.$fP(""),this.e=new Map}async prepareSession(q,V,Q){const J=this.f.getDocument(q),he=i.Position.to(V),pe=await this.g.prepareTypeHierarchy(J,he,Q);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(Ve=>this.h(ze,Ve)):[this.h(ze,pe)]}async provideSupertypes(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(J,Q);if(he)return he.map(pe=>this.h(q,pe))}async provideSubtypes(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(J,Q);if(he)return he.map(pe=>this.h(q,pe))}releaseSession(q){this.e.delete(q)}h(q,V){const Q=this.e.get(q),J=i.TypeHierarchyItem.from(V,q,Q.size.toString(36));return Q.set(J._itemId,V),J}j(q,V){return this.e.get(q)?.get(V)}}class Re{constructor(q,V,Q,J,he){this.e=q,this.f=V,this.g=Q,this.h=J,this.j=he,this.d=new t.$1jc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,V,Q,J,he){const pe=this.f.getDocument(V),ze=i.Position.to(Q),Ve=i.DataTransfer.toDataTransfer(J,async it=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,it)).buffer),Xe=await this.g.provideDocumentDropEdits(pe,ze,Ve,he);if(!Xe)return;const tt=(0,u.$3b)(Xe),ot=this.d.add(tt);return tt.map((it,st)=>({_cacheId:[ot,st],title:it.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(De=>De.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,V){const[Q,J]=q,he=this.d.get(Q,J);if(!he||!this.g.resolveDocumentDropEdit)return{};const pe=await this.g.resolveDocumentDropEdit(he,V)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class fe{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,Q,J){const he=$.URI.revive(q),pe=this.d.getDocument(he),ze=Q.documents.map(tt=>tt.map(ot=>({uri:$.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(it=>i.Range.to(it))}))),Ve={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(pe,V,Ve,J);return Xe?i.WorkspaceEdit.from(Xe):null}}class Se{constructor(q,V){this.adapter=q,this.extension=V}}class Ae{static{this.d=0}constructor(q,V,Q,J,he,pe,ze,Ve){this.g=V,this.h=Q,this.j=J,this.k=he,this.l=pe,this.m=ze,this.n=Ve,this.f=new Map,this.e=q.getProxy(f.$PM.MainThreadLanguageFeatures)}o(q,V){return i.DocumentSelector.from(q,this.g,V)}p(q){return new r.$RM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ae.d++}async s(q,V,Q,J,he,pe=!1){const ze=this.f.get(q);if(!ze||!(ze.adapter instanceof V))return J;const Ve=Date.now();pe||this.l.trace(`[${ze.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Xe=Q(ze.adapter,ze.extension);return Promise.resolve(Xe).catch(tt=>{(0,R.$4)(tt)||(this.l.error(`[${ze.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(ze.extension.identifier,tt))}).finally(()=>{pe||this.l.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(he)?(0,N.$fh)(Xe,he):Xe}t(q,V){const Q=this.q();return this.f.set(Q,new Se(q,V)),Q}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,V,Q,J){const he=this.t(new d(this.h,Q),q),pe=J&&J.label||Ae.u(q);return this.e.$registerDocumentSymbolProvider(he,this.o(V,q),pe),this.p(he)}$provideDocumentSymbols(q,V,Q){return this.s(q,d,J=>J.provideDocumentSymbols($.URI.revive(V),Q),void 0,Q)}registerCodeLensProvider(q,V,Q){const J=this.q(),he=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Se(new l(this.h,this.j.converter,Q,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(J,this.o(V,q),he);let pe=this.p(J);if(he!==void 0){const ze=Q.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(he));pe=r.$RM.from(pe,ze)}return pe}$provideCodeLenses(q,V,Q){return this.s(q,l,J=>J.provideCodeLenses($.URI.revive(V),Q),void 0,Q)}$resolveCodeLens(q,V,Q){return this.s(q,l,J=>J.resolveCodeLens(V,Q),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,l,Q=>Promise.resolve(Q.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,Q){const J=this.t(new h(this.h,Q),q);return this.e.$registerDefinitionSupport(J,this.o(V,q)),this.p(J)}$provideDefinition(q,V,Q,J){return this.s(q,h,he=>he.provideDefinition($.URI.revive(V),Q,J),[],J)}registerDeclarationProvider(q,V,Q){const J=this.t(new m(this.h,Q),q);return this.e.$registerDeclarationSupport(J,this.o(V,q)),this.p(J)}$provideDeclaration(q,V,Q,J){return this.s(q,m,he=>he.provideDeclaration($.URI.revive(V),Q,J),[],J)}registerImplementationProvider(q,V,Q){const J=this.t(new D(this.h,Q),q);return this.e.$registerImplementationSupport(J,this.o(V,q)),this.p(J)}$provideImplementation(q,V,Q,J){return this.s(q,D,he=>he.provideImplementation($.URI.revive(V),Q,J),[],J)}registerTypeDefinitionProvider(q,V,Q){const J=this.t(new p(this.h,Q),q);return this.e.$registerTypeDefinitionSupport(J,this.o(V,q)),this.p(J)}$provideTypeDefinition(q,V,Q,J){return this.s(q,p,he=>he.provideTypeDefinition($.URI.revive(V),Q,J),[],J)}registerHoverProvider(q,V,Q,J){const he=this.t(new E(this.h,Q),q);return this.e.$registerHoverProvider(he,this.o(V,q)),this.p(he)}$provideHover(q,V,Q,J){return this.s(q,E,he=>he.provideHover($.URI.revive(V),Q,J),void 0,J)}registerEvaluatableExpressionProvider(q,V,Q,J){const he=this.t(new y(this.h,Q),q);return this.e.$registerEvaluatableExpressionProvider(he,this.o(V,q)),this.p(he)}$provideEvaluatableExpression(q,V,Q,J){return this.s(q,y,he=>he.provideEvaluatableExpression($.URI.revive(V),Q,J),void 0,J)}registerInlineValuesProvider(q,V,Q,J){const he=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new P(this.h,Q),q);this.e.$registerInlineValuesProvider(pe,this.o(V,q),he);let ze=this.p(pe);if(he!==void 0){const Ve=Q.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(he));ze=r.$RM.from(ze,Ve)}return ze}$provideInlineValues(q,V,Q,J,he){return this.s(q,P,pe=>pe.provideInlineValues($.URI.revive(V),Q,J,he),void 0,he)}registerDocumentHighlightProvider(q,V,Q){const J=this.t(new I(this.h,Q),q);return this.e.$registerDocumentHighlightProvider(J,this.o(V,q)),this.p(J)}registerMultiDocumentHighlightProvider(q,V,Q){const J=this.t(new j(this.h,Q),q);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(V,q)),this.p(J)}$provideDocumentHighlights(q,V,Q,J){return this.s(q,I,he=>he.provideDocumentHighlights($.URI.revive(V),Q,J),void 0,J)}$provideMultiDocumentHighlights(q,V,Q,J,he){return this.s(q,j,pe=>pe.provideMultiDocumentHighlights($.URI.revive(V),Q,J.map(ze=>$.URI.revive(ze)),he),void 0,he)}registerLinkedEditingRangeProvider(q,V,Q){const J=this.t(new F(this.h,Q),q);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,q)),this.p(J)}$provideLinkedEditingRanges(q,V,Q,J){return this.s(q,F,async he=>{const pe=await he.provideLinkedEditingRanges($.URI.revive(V),Q,J);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?Ae.w(pe.wordPattern):void 0}},void 0,J)}registerReferenceProvider(q,V,Q){const J=this.t(new z(this.h,Q),q);return this.e.$registerReferenceSupport(J,this.o(V,q)),this.p(J)}$provideReferences(q,V,Q,J,he){return this.s(q,z,pe=>pe.provideReferences($.URI.revive(V),Q,J,he),void 0,he)}registerCodeActionProvider(q,V,Q,J){const he=new w.$Tc,pe=this.t(new O(this.h,this.j.converter,this.k,Q,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(pe,this.o(V,q),{providedKinds:J?.providedCodeActionKinds?.map(ze=>ze.value),documentation:J?.documentation?.map(ze=>({kind:ze.kind.value,command:this.j.converter.toInternal(ze.command,he)}))},Ae.u(q),!!Q.resolveCodeAction),he.add(this.p(pe)),he}$provideCodeActions(q,V,Q,J,he){return this.s(q,O,pe=>pe.provideCodeActions($.URI.revive(V),Q,J,he),void 0,he)}$resolveCodeAction(q,V,Q){return this.s(q,O,J=>J.resolveCodeAction(V,Q),{},void 0)}$releaseCodeActions(q,V){this.s(q,O,Q=>Promise.resolve(Q.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,Q){const J=this.t(new B(this.h,Q),q);return this.e.$registerDocumentFormattingSupport(J,this.o(V,q),q.identifier,q.displayName||q.name),this.p(J)}$provideDocumentFormattingEdits(q,V,Q,J){return this.s(q,B,he=>he.provideDocumentFormattingEdits($.URI.revive(V),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(q,V,Q){const J=typeof Q.provideDocumentRangesFormattingEdits=="function",he=this.t(new W(this.h,Q),q);return this.e.$registerRangeFormattingSupport(he,this.o(V,q),q.identifier,q.displayName||q.name,J),this.p(he)}$provideDocumentRangeFormattingEdits(q,V,Q,J,he){return this.s(q,W,pe=>pe.provideDocumentRangeFormattingEdits($.URI.revive(V),Q,J,he),void 0,he)}$provideDocumentRangesFormattingEdits(q,V,Q,J,he){return this.s(q,W,pe=>pe.provideDocumentRangesFormattingEdits($.URI.revive(V),Q,J,he),void 0,he)}registerOnTypeFormattingEditProvider(q,V,Q,J){const he=this.t(new X(this.h,Q),q);return this.e.$registerOnTypeFormattingSupport(he,this.o(V,q),J,q.identifier),this.p(he)}$provideOnTypeFormattingEdits(q,V,Q,J,he,pe){return this.s(q,X,ze=>ze.provideOnTypeFormattingEdits($.URI.revive(V),Q,J,he,pe),void 0,pe)}registerWorkspaceSymbolProvider(q,V){const Q=this.t(new x(V,this.l),q);return this.e.$registerNavigateTypeSupport(Q,typeof V.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(q,V,Q){return this.s(q,x,J=>J.provideWorkspaceSymbols(V,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(q,V,Q){return this.s(q,x,J=>J.resolveWorkspaceSymbol(V,Q),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,x,Q=>Q.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,Q){const J=this.t(new Z(this.h,Q,this.l),q);return this.e.$registerRenameSupport(J,this.o(V,q),Z.supportsResolving(Q)),this.p(J)}$provideRenameEdits(q,V,Q,J,he){return this.s(q,Z,pe=>pe.provideRenameEdits($.URI.revive(V),Q,J,he),void 0,he)}$resolveRenameLocation(q,V,Q,J){return this.s(q,Z,he=>he.resolveRenameLocation($.URI.revive(V),Q,J),void 0,J)}registerNewSymbolNamesProvider(q,V,Q){const J=this.t(new Y(this.h,Q,this.l),q);return this.e.$registerNewSymbolNamesProvider(J,this.o(V,q)),this.p(J)}$provideNewSymbolNames(q,V,Q,J){return this.s(q,Y,he=>he.provideNewSymbolNames($.URI.revive(V),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(q,V,Q,J){const he=this.t(new ne(this.h,Q),q),pe=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(V,q),J,pe);let ze=this.p(he);if(pe){const Ve=Q.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(pe));ze=r.$RM.from(ze,Ve)}return ze}$provideDocumentSemanticTokens(q,V,Q,J){return this.s(q,ne,he=>he.provideDocumentSemanticTokens($.URI.revive(V),Q,J),null,J)}$releaseDocumentSemanticTokens(q,V){this.s(q,ne,Q=>Q.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,Q,J){const he=this.t(new $e(this.h,Q),q);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(V,q),J),this.p(he)}$provideDocumentRangeSemanticTokens(q,V,Q,J){return this.s(q,$e,he=>he.provideDocumentRangeSemanticTokens($.URI.revive(V),Q,J),null,J)}registerCompletionItemProvider(q,V,Q,J){const he=this.t(new Pe(this.h,this.j.converter,Q,this.m,q),q);return this.e.$registerCompletionsProvider(he,this.o(V,q),J,Pe.supportsResolving(Q),q.identifier),this.p(he)}$provideCompletionItems(q,V,Q,J,he){return this.s(q,Pe,pe=>pe.provideCompletionItems($.URI.revive(V),Q,J,he),void 0,he)}$resolveCompletionItem(q,V,Q){return this.s(q,Pe,J=>J.resolveCompletionItem(V,Q),void 0,Q)}$releaseCompletionItems(q,V){this.s(q,Pe,Q=>Q.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,Q,J){const he=new U(q,this.h,Q,this.j.converter),pe=this.t(he,q);return this.e.$registerInlineCompletionsSupport(pe,this.o(V,q),he.supportsHandleEvents,n.$Lm.toKey(q.identifier.value),J?.yieldTo?.map(ze=>n.$Lm.toKey(ze))||[]),this.p(pe)}$provideInlineCompletions(q,V,Q,J,he){return this.s(q,_,pe=>pe.provideInlineCompletions($.URI.revive(V),Q,J,he),void 0,he)}$handleInlineCompletionDidShow(q,V,Q,J){this.s(q,_,async he=>{he.handleDidShowCompletionItem(V,Q,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,Q,J,he){this.s(q,_,async pe=>{pe.handlePartialAccept(V,Q,J,he)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,_,async Q=>{Q.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,Q){const J=new ie(q,this.h,Q,this.j.converter),he=this.t(J,q);return this.e.$registerInlineEditProvider(he,this.o(V,q),q.identifier),this.p(he)}$provideInlineEdit(q,V,Q,J){return this.s(q,ie,he=>he.provideInlineEdits($.URI.revive(V),Q,J),void 0,J)}$freeInlineEdit(q,V){this.s(q,ie,async Q=>{Q.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,Q,J){const he=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,pe=this.t(new Ce(this.h,Q),q);return this.e.$registerSignatureHelpProvider(pe,this.o(V,q),he),this.p(pe)}$provideSignatureHelp(q,V,Q,J,he){return this.s(q,Ce,pe=>pe.provideSignatureHelp($.URI.revive(V),Q,J,he),void 0,he)}$releaseSignatureHelp(q,V){this.s(q,Ce,Q=>Q.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new oe(this.h,this.j.converter,Q,this.l,q),q);this.e.$registerInlayHintsProvider(he,this.o(V,q),typeof Q.resolveInlayHint=="function",J,Ae.u(q));let pe=this.p(he);if(J!==void 0){const ze=Q.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(J));pe=r.$RM.from(pe,ze)}return pe}$provideInlayHints(q,V,Q,J){return this.s(q,oe,he=>he.provideInlayHints($.URI.revive(V),Q,J),void 0,J)}$resolveInlayHint(q,V,Q){return this.s(q,oe,J=>J.resolveInlayHint(V,Q),void 0,Q)}$releaseInlayHints(q,V){this.s(q,oe,Q=>Q.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,Q){const J=this.t(new ae(this.h,Q),q);return this.e.$registerDocumentLinkProvider(J,this.o(V,q),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(q,V,Q){return this.s(q,ae,J=>J.provideLinks($.URI.revive(V),Q),void 0,Q,V.scheme==="output")}$resolveDocumentLink(q,V,Q){return this.s(q,ae,J=>J.resolveLink(V,Q),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,ae,Q=>Q.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,Q){const J=this.t(new re(this.h,Q),q);return this.e.$registerDocumentColorProvider(J,this.o(V,q)),this.p(J)}$provideDocumentColors(q,V,Q){return this.s(q,re,J=>J.provideColors($.URI.revive(V),Q),[],Q)}$provideColorPresentations(q,V,Q,J){return this.s(q,re,he=>he.provideColorPresentations($.URI.revive(V),Q,J),void 0,J)}registerFoldingRangeProvider(q,V,Q){const J=this.q(),he=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Se(new G(this.h,Q),q)),this.e.$registerFoldingRangeProvider(J,this.o(V,q),q.identifier,he);let pe=this.p(J);if(he!==void 0){const ze=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));pe=r.$RM.from(pe,ze)}return pe}$provideFoldingRanges(q,V,Q,J){return this.s(q,G,he=>he.provideFoldingRanges($.URI.revive(V),Q,J),void 0,J)}registerSelectionRangeProvider(q,V,Q){const J=this.t(new te(this.h,Q,this.l),q);return this.e.$registerSelectionRangeProvider(J,this.o(V,q)),this.p(J)}$provideSelectionRanges(q,V,Q,J){return this.s(q,te,he=>he.provideSelectionRanges($.URI.revive(V),Q,J),[],J)}registerCallHierarchyProvider(q,V,Q){const J=this.t(new ge(this.h,Q),q);return this.e.$registerCallHierarchyProvider(J,this.o(V,q)),this.p(J)}$prepareCallHierarchy(q,V,Q,J){return this.s(q,ge,he=>Promise.resolve(he.prepareSession($.URI.revive(V),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(q,V,Q,J){return this.s(q,ge,he=>he.provideCallsTo(V,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(q,V,Q,J){return this.s(q,ge,he=>he.provideCallsFrom(V,Q,J),void 0,J)}$releaseCallHierarchy(q,V){this.s(q,ge,Q=>Promise.resolve(Q.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,Q){const J=this.t(new we(this.h,Q),q);return this.e.$registerTypeHierarchyProvider(J,this.o(V,q)),this.p(J)}$prepareTypeHierarchy(q,V,Q,J){return this.s(q,we,he=>Promise.resolve(he.prepareSession($.URI.revive(V),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(q,V,Q,J){return this.s(q,we,he=>he.provideSupertypes(V,Q,J),void 0,J)}$provideTypeHierarchySubtypes(q,V,Q,J){return this.s(q,we,he=>he.provideSubtypes(V,Q,J),void 0,J)}$releaseTypeHierarchy(q,V){this.s(q,we,Q=>Promise.resolve(Q.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,Q,J){const he=this.q();return this.f.set(he,new Se(new Re(this.e,this.h,Q,he,q),q)),this.e.$registerDocumentOnDropEditProvider(he,this.o(V,q),(0,s.$xG)(q,"documentPaste")&&J?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(q,V,Q,J,he,pe){return this.s(q,Re,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(V,$.URI.revive(Q),J,he,pe)),void 0,void 0)}$resolveDropEdit(q,V,Q){return this.s(q,Re,J=>J.resolveDropEdit(V,Q),{},void 0)}$releaseDropEdits(q,V){this.s(q,Re,Q=>Promise.resolve(Q.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(q,V,Q){const J=this.t(new fe(this.h,Q),q);return this.e.$registerMappedEditsProvider(J,this.o(V,q)),this.p(J)}$provideMappedEdits(q,V,Q,J,he){return this.s(q,fe,pe=>Promise.resolve(pe.provideMappedEdits(V,Q,J,he)),null,he)}registerDocumentPasteEditProvider(q,V,Q,J){const he=this.q();return this.f.set(he,new Se(new T(this.e,this.h,Q,he,q),q)),this.e.$registerPasteEditProvider(he,this.o(V,q),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(pe=>pe.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(q,V,Q,J,he){return this.s(q,T,pe=>pe.prepareDocumentPaste($.URI.revive(V),Q,J,he),void 0,he)}$providePasteEdits(q,V,Q,J,he,pe,ze){return this.s(q,T,Ve=>Ve.providePasteEdits(V,$.URI.revive(Q),J,he,pe,ze),void 0,ze)}$resolvePasteEdit(q,V,Q){return this.s(q,T,J=>J.resolvePasteEdit(V,Q),{},void 0)}$releasePasteEdits(q,V){this.s(q,T,Q=>Promise.resolve(Q.releasePasteEdits(V)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Ae.w(q.decreaseIndentPattern),increaseIndentPattern:Ae.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ae.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ae.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Ae.w(q.beforeText),afterText:q.afterText?Ae.w(q.afterText):void 0,previousLineText:q.previousLineText?Ae.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Ae.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>r.SyntaxTokenType.toString(V)):void 0}}static D(q){return q.map(Ae.C)}setLanguageConfiguration(q,V,Q){const{wordPattern:J}=Q;if(J&&(0,A.$ff)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const he=this.q(),pe={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Ae.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Ae.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Ae.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Ae.D(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,V,pe),this.p(he)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$$jc=Ae}),define(ke[121],Ee([1,0,3,6,16,7,108,25,8,4,222,145,13,5,20,120,12]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=e.$Rkc=void 0,e.$Rkc=(0,k.$qi)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new b.$Th,this.stream=f??new b.$Th}}class i{constructor(){this.a=new Map,this.b=new b.$Th,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new n(t.index,this.b):f=new n(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{o=this}static{this.a=1}constructor(t,f,d){this.j=f,this.k=d,this.c=new S.$be,this.d=new S.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new w.$Nm,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,d,l){const a=o.a++;this.f.set(a,{extension:t.identifier,provider:d,languageModelId:f});let h;return l.auth&&(h={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(a,f,{extension:t.identifier,identifier:f,model:l.name??"",auth:h}),(0,u.$Sc)(()=>{this.f.delete(a),this.b.$unregisterProvider(a)})}async $provideLanguageModelResponse(t,f,d,l,a,h){const m=this.f.get(t);if(!m)return;const D=new M.$Zv(async p=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:p.index,part:p.part})});return m.provider.provideLanguageModelResponse2(l.map(L.LanguageModelMessage.to),a,w.$Lm.toKey(d),D,h)}$updateLanguageModels(t){const f=[],d=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),f.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),d.push(l);for(const[a,h]of this.i)h.languageModelId===l&&(h.res.reject(new $.$5),this.i.delete(a))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:d,to:l,enabled:a}of t){const h=this.h.get(d)??new w.$Mm;if(h.has(l)!==a){a?h.add(l):h.delete(l),this.h.set(d,h);const D={from:d,to:l};f.push(D),this.c.fire(D)}}}async sendChatRequest(t,f,d,l,a){const h=t.identifier,m=await this.b.$prepareChatAccess(h,f,l.justification);if(!m||!this.g.has(f))throw R.$ZO.NotFound(`Language model '${f}' is unknown.`);if(this.m(h,m)&&(!await this.l(t,{identifier:m.extension,displayName:m.auth.providerLabel},l.justification,l.silent)||!this.h.get(h)?.has(m.extension)))throw R.$ZO.NoPermissions(`Language model '${f}' cannot be used by '${h.value}'.`);const D=Math.random()*1e6|0,p=this.b.$fetchResponse(h,f,D,d.map(L.LanguageModelMessage.from),l.modelOptions??{},a),E=new b.$ph,y=new i;this.i.set(D,{languageModelId:f,res:y});let P;if(p.catch(I=>{E.isOpen()?y.reject(I):P=I}).finally(()=>{this.i.delete(D),y.resolve(),E.open()}),await E.wait(),P)throw new R.$ZO(`Language model '${f}' errored, check cause for more details`,"Unknown",P);return y.apiObject}async $handleResponseFragment(t,f){const d=this.i.get(t);d&&d.res.handleFragment(f)}async l(t,f,d,l){const a=C.$RL+f.identifier.value;if(await this.k.getSession(t,a,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(l)return!1;try{const m=d?(0,A.localize)(0,null,f.displayName,d):(0,A.localize)(1,null,f.displayName);return await this.k.getSession(t,a,[],{forceNewSession:{detail:m}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!w.$Lm.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,d=S.Event.signal(S.Event.filter(this.c.event,a=>w.$Lm.equals(a.from,t.identifier))),l=S.Event.signal(this.d.event);return{get onDidChange(){return S.Event.any(d,l)},canSendRequest(a){const h=f.g.get(a);if(!h)return;if(!f.m(t.identifier,h))return!0;const m=f.h.get(t.identifier);if(m)return m.has(h.extension)}}}};e.$Skc=r,e.$Skc=r=o=Je([qe(0,v.$aP),qe(1,g.$Wj),qe(2,c.$akc)],r)}),define(ke[339],Ee([1,0,6,16,7,40,8,3,26]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class S{constructor(C,$,k,v){this.c=$,this.d=k,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(u.$PM.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,$){await this.a.$changeLanguage(C,$);const k=this.c.getDocumentData(C);if(!k)throw new Error(`document '${C.toString()}' NOT found`);return k.document}async tokenAtPosition(C,$){const k=C.version,v=N.Position.from($),c=await this.a.$tokensAtPosition(C.uri,v),g={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition($)??new L.$TM($.line,$.character,$.line,$.character)};if(!c)return g;const o={range:N.Range.to(c.range),type:N.TokenType.to(c.type)};return!o.range.contains($)||k!==C.version?g:o}createLanguageStatusItem(C,$,k){const v=this.f++,c=this.a,g=this.g,o=`${C.identifier.value}/${$}`;if(g.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);g.add(o);const n={selector:k,id:$,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new w.$Tc,s=()=>{if(i?.dispose(),!g.has(o)){console.warn(`LanguageStatusItem (${$}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$sh)(()=>{r.clear(),this.a.$setLanguageStatus(v,{id:o,name:n.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),c.$removeLanguageStatus(v),g.delete(o)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,s()},get selector(){return n.selector},set selector(f){n.selector=f,s()},get text(){return n.text},set text(f){n.text=f,s()},set text2(f){(0,b.$yG)(C,"languageStatusText"),n.text=f,s()},get text2(){return(0,b.$yG)(C,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,s()},get severity(){return n.severity},set severity(f){n.severity=f,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,s()},get command(){return n.command},set command(f){n.command=f,s()},get busy(){return n.busy},set busy(f){n.busy=f,s()}};return s(),t}}e.$xlc=S}),define(ke[340],Ee([1,0,15,2,16,7,119]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0;class w{constructor(C,$,k,v){this.start=C,this.deletedCount=$,this.deletedItems=k,this.items=v}asApiEvent(){return{range:new R.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,$,k){this.notebook=C,this.h=$,this.j=k,this.handle=k.handle,this.uri=N.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(L.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return C.g},set mime(v){C.g=v},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(k)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,$,k){const v=k.map(L.NotebookCellOutputItem.to),c=this.a.find(g=>g.id===C);if(c&&($||(c.items.length=0),c.items.push(...v),c.items.length>1&&c.items.every(g=>M.$MK(g.mime)))){const g=new Map,o=[];c.items.forEach(n=>{let i;g.has(n.mime)?i=g.get(n.mime):(i=[],g.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),c.items.length=0,o.forEach(n=>{const i=M.$NK(g.get(n));c.items.push({mime:n,data:i.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$jlc=b;class S{static{this.a=0}constructor(C,$,k,v,c){this.k=C,this.l=$,this.m=k,this.uri=v,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,$={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===u.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(k){return k=C.n(k),C.b[k].apiCell},getCells(k){return(k?C.p(k):C.b).map(c=>c.apiCell)},save(){return C.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,$,k){this.g=C.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:k});const v={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},c=[];for(const o of C.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,v.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,v.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),c.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),c.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const g=new Map;for(let o=0;o<c.length;o++){const n=c[o],i=g.get(n.cell);if(i===void 0){const r=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});g.set(n.cell,r-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let $=C.start|0,k=C.end|0;return $<0&&($=0),k>this.b.length&&(k=this.b.length),C.with({start:$,end:k})}p(C){C=this.o(C);const $=[];for(let k=C.start;k<C.end;k++)$.push(this.b[k]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,$,k){if(this.j)return;const v=[],c=[],g=[];if(C.reverse().forEach(o=>{const i=o[2].map(t=>{const f=new b(this,this.l,t);return $||c.push(b.asModelAddData(t)),f}),r=new w(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)g.push(t.uri),r.deletedItems.push(t.apiCell);v.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:g}),k)for(const o of v)k.push(o.asApiEvent())}s(C,$,k,v){const c=this.b.splice(C,$);this.b.splice(k,0,...c);const g=[new w(C,$,c.map(o=>o.apiCell),[]),new w(k,0,[],c)];for(const o of g)v.push(o.asApiEvent())}t(C,$){this.b[C].setOutputs($)}u(C,$,k,v){this.b[C].setOutputItems($,k,v)}v(C,$){const k=this.b[C];k.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(k.uri,$)}w(C,$){const k=this.b[C];k.apiCell.mime=$}x(C,$){this.b[C].setMetadata($)}y(C,$){this.b[C].setInternalMetadata($)}getCellFromApiCell(C){return this.b.find($=>$.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find($=>$.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$klc=S}),define(ke[341],Ee([1,0,4,2,16,7,48]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class w{constructor(S,A,C,$={timeout:1500,errors:3}){this.b=S,this.c=A,this.d=C,this.f=$,this.a=new u.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(A,C,$)=>{const k=function(c){A.call(C,c)};return k.extension=S,this.a.event(k,void 0,$)}}async $participateInSave(S,A,C){const $=N.URI.revive(S),k=this.c.getNotebookDocument($);if(!k)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},C,async(g,o)=>{const n=Date.now(),i=await await Promise.resolve(g);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!C.isCancellationRequested&&i&&(i instanceof R.$2M?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(v.length===0)return!0;const c={edits:[]};for(const g of v){const{edits:o}=L.WorkspaceEdit.from(g);c.edits=c.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new M.$mw(c))}}e.$zlc=w}),define(ke[153],Ee([1,0,13,16,7]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,b,S,A,C,$){this.id=w,this.f=b,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=$}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection(b){this.selections=[b]},get selections(){return w.a},set selections(b){if(!Array.isArray(b)||!b.every(L.$gO.isNotebookRange))throw(0,u.$7)("selections");w.a=b,w.g(b)},get visibleRanges(){return w.b},revealRange(b,S){w.f.$tryRevealRange(w.id,N.NotebookRange.from(b),S??L.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(N.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$llc=R}),define(ke[342],Ee([1,0,4,12,16]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;let R=class{constructor(w,b){this.c=w,this.d=b,this.a=new u.$be,this.b=new u.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,b);const S=this.d.getEditorById(w);b.visibleRanges&&S._acceptVisibleRanges(b.visibleRanges.ranges.map(L.NotebookRange.to)),b.selections&&S._acceptSelections(b.selections.selections.map(L.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const b in w)this.d.getEditorById(b)._acceptViewColumn(L.ViewColumn.to(w[b]))}};e.$Blc=R,e.$Blc=R=Je([qe(0,N.$Wj)],R)}),define(ke[343],Ee([1,0,4,6,153]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class R{constructor(w,b){this.c=b,this.a=new Map,this.b=w.getProxy(N.$PM.MainThreadNotebookRenderers)}$postRendererMessage(w,b,S){const A=this.c.getEditorById(w);this.a.get(b)?.fire({editor:A.apiEditor,message:S})}createRendererMessaging(w,b){if(!w.contributes?.notebookRenderer?.some(A=>A.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(A,C,$)=>this.d(b).event(A,C,$),postMessage:(A,C)=>{L.$llc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const $=C&&L.$llc.apiEditorsToExtHost.get(C);return this.b.$postMessage($?.id,b,A)}}}d(w){let b=this.a.get(w);return b||(b=new u.$be({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(w)}}),this.a.set(w,b),b)}}e.$Elc=R}),define(ke[344],Ee([1,0,16,108,22,55,13]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class w{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,$,k){const v=this.b++,{title:c,location:g,cancellable:o}=$,n={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(g),title:c,source:n,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(M.$2),this.d(v,k,!!o)}d(C,$,k){let v;k&&(v=new L.$me,this.c.set(C,v));const c=o=>{this.a.$progressEnd(o),this.c.delete(o),v?.dispose()};let g;try{g=$(new S(this.a,C),k&&v?v.token:L.CancellationToken.None)}catch(o){throw c(C),o}return g.then(o=>c(C),o=>c(C)),g}$acceptProgressCanceled(C){const $=this.c.get(C);$&&($.cancel(),this.c.delete(C))}}e.$Ilc=w;function b(A,C){return A.message=C.message,typeof C.increment=="number"&&(typeof A.increment=="number"?A.increment+=C.increment:A.increment=C.increment),A}class S extends N.$Zv{constructor(C,$){super(k=>this.throttledReport(k)),this.c=C,this.d=$}throttledReport(C){this.c.$progressReport(this.d,C)}}Je([(0,R.$Wh)(100,(A,C)=>b(A,C),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(ke[345],Ee([1,0,2,6,8,16]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class M{static{this.a=0}constructor(b,S){this.d=S,this.c=new Map,this.b=b.getProxy(N.$PM.MainThreadQuickDiff)}$provideOriginalResource(b,S,A){const C=u.URI.revive(S),$=this.c.get(b);return $?(0,L.$ih)(()=>$.provideOriginalResource(C,A)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(b,S,A,C){const $=M.a++;return this.c.set($,S),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(b,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Jlc=M}),define(ke[346],Ee([1,0,22,4,3,6,2,7,13,19,40,57,26,16]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=v;function v(c,g,o){const n=c.getProxy(R.$PM.MainThreadQuickOpen);class i{constructor(m,D){this.e=new Map,this.f=0,this.a=m,this.b=D}showQuickPick(m,D,p,E=u.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),P=++this.f,I=n.$show(P,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},E),j={},F=I.then(()=>j);return Promise.race([F,y]).then(z=>{if(z===j)return;const O=(0,$.$xG)(m,"quickPickItemTooltip");return y.then(T=>{const B=[];for(let W=0;W<T.length;W++){const X=T[W];if(typeof X=="string")B.push({label:X,handle:W});else if(X.kind===w.QuickPickItemKind.Separator)B.push({type:"separator",label:X.label});else{X.tooltip&&!O&&console.warn(`Extension '${m.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`);const x=X.iconPath?d(X.iconPath):void 0;B.push({label:X.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:X.description,detail:X.detail,picked:X.picked,alwaysShow:X.alwaysShow,tooltip:O?k.MarkdownString.fromStrict(X.tooltip):void 0,handle:W})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=W=>{p.onDidSelectItem(T[W])}),n.$setItems(P,B),I.then(W=>{if(typeof W=="number")return T[W];if(Array.isArray(W))return W.map(X=>T[X])})})}).then(void 0,z=>{if(!(0,b.$4)(z))return n.$setError(P,z),Promise.reject(z)})}$onItemSelected(m){this.c?.(m)}showInput(m,D=u.CancellationToken.None){return this.d=m?.validateInput,n.$input(m,typeof this.d=="function",D).then(void 0,p=>{if(!(0,b.$4)(p))return Promise.reject(p)})}async $validateInput(m){if(!this.d)return;const D=await this.d(m);if(!D||typeof D=="string")return D;let p;switch(D.severity){case w.InputBoxValidationSeverity.Info:p=A.default.Info;break;case w.InputBoxValidationSeverity.Warning:p=A.default.Warning;break;case w.InputBoxValidationSeverity.Error:p=A.default.Error;break;default:p=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:p}}async showWorkspaceFolderPick(m,D=u.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!p)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(y=>y.uri.toString()===p.uri.toString())}createQuickPick(m){const D=new l(m,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(m){const D=new a(m,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(m,D){this.e.get(m)?._fireDidChangeValue(D)}$onDidAccept(m){this.e.get(m)?._fireDidAccept()}$onDidChangeActive(m,D){const p=this.e.get(m);p instanceof l&&p._fireDidChangeActive(D)}$onDidChangeSelection(m,D){const p=this.e.get(m);p instanceof l&&p._fireDidChangeSelection(D)}$onDidTriggerButton(m,D){this.e.get(m)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(m,D,p){const E=this.e.get(m);E instanceof l&&E._fireDidTriggerItemButton(D,p)}$onDidHide(m){this.e.get(m)?._fireDidHide()}}class r{static{this.a=1}constructor(m,D){this.x=m,this.y=D,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(m){this.b=m,this.z({title:m})}get step(){return this.c}set step(m){this.c=m,this.z({step:m})}get totalSteps(){return this.d}set totalSteps(m){this.d=m,this.z({totalSteps:m})}get enabled(){return this.g}set enabled(m){this.g=m,this.z({enabled:m})}get busy(){return this.j}set busy(m){this.j=m,this.z({busy:m})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(m){this.k=m,this.z({ignoreFocusOut:m})}get value(){return this.l}set value(m){this.l=m,this.z({value:m})}get placeholder(){return this.m}set placeholder(m){this.m=m,this.z({placeholder:m})}get buttons(){return this.n}set buttons(m){this.n=m.slice(),this.o.clear(),m.forEach((D,p)=>{const E=D===w.$dO.Back?-1:p;this.o.set(E,D)}),this.z({buttons:m.map((D,p)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===w.$dO.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(m){this.l=m,this.q.fire(m)}_fireDidTriggerButton(m){const D=this.o.get(m);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(m){if(!this.v){for(const D of Object.keys(m)){const p=m[D];this.u[D]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(h){if(h instanceof w.$NN)return{id:h.id};const m=f(h),D=t(h);return{dark:typeof m=="string"?M.URI.file(m):m,light:typeof D=="string"?M.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function f(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const m=s(h);let D,p;return"id"in m?p=C.ThemeIcon.asClassName(m):D=m,{iconPath:D,iconClass:p}}class l extends r{constructor(m,D){super(m.identifier,D),this.O=m,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(m){this.B=m.slice(),this.C.clear(),this.D.clear(),m.forEach((E,y)=>{this.C.set(y,E),this.D.set(E,y)});const D=(0,$.$xG)(this.O,"quickPickItemTooltip"),p=[];for(let E=0;E<m.length;E++){const y=m[E];if(y.kind===w.QuickPickItemKind.Separator)p.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?d(y.iconPath):void 0;p.push({handle:E,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?k.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((I,j)=>({...d(I.iconPath),tooltip:I.tooltip,handle:j}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(m){this.E=m,this.z({canSelectMany:m})}get matchOnDescription(){return this.F}set matchOnDescription(m){this.F=m,this.z({matchOnDescription:m})}get matchOnDetail(){return this.G}set matchOnDetail(m){this.G=m,this.z({matchOnDetail:m})}get sortByLabel(){return this.H}set sortByLabel(m){this.H=m,this.z({sortByLabel:m})}get keepScrollPosition(){return this.I}set keepScrollPosition(m){this.I=m,this.z({keepScrollPosition:m})}get activeItems(){return this.J}set activeItems(m){this.J=m.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(m){this.L=m.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(m){const D=(0,S.$Hb)(m.map(p=>this.C.get(p)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(m){const D=(0,S.$Hb)(m.map(p=>this.C.get(p)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(m,D){const p=this.C.get(m);if(!p||!p.buttons||!p.buttons.length)return;const E=p.buttons[D];E&&this.N.fire({button:E,item:p})}}class a extends r{constructor(m,D){super(m.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(m){this.B=m,this.z({password:m})}get prompt(){return this.C}set prompt(m){this.C=m,this.z({prompt:m})}get valueSelection(){return this.D}set valueSelection(m){this.D=m,this.z({valueSelection:m})}get validationMessage(){return this.E}set validationMessage(m){this.E=m,m?typeof m=="string"?this.z({validationMessage:m,severity:A.default.Error}):this.z({validationMessage:m.message,severity:m.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(g,o)}}),define(ke[347],Ee([1,0,2,4,55,3,8,6,19,131,12,25,57,16,26,15,11]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;function n(P){return P instanceof u.URI}function i(P,I){return P.scheme===c.Schemas.file&&I.scheme===c.Schemas.file&&g.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function r(P){if(P)return typeof P.iconPath=="string"?u.URI.file(P.iconPath):u.URI.isUri(P.iconPath)||$.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function s(P){if(P.icon){if(u.URI.isUri(P.icon))return P.icon;if($.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function t(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const j=typeof P.iconPath=="string"?P.iconPath:u.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,F=typeof I.iconPath=="string"?I.iconPath:u.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,S.$ir)(j,F)}function f(P,I){let j=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(j=t(P,I),j!==0)return j;if(P.light&&I.light)j=t(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(j!==0)return j;if(P.dark&&I.dark)j=t(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return j}function d(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let j=0;j<P.arguments.length;j++){const F=P.arguments[j],z=I.arguments[j];if(F!==z&&!(n(F)&&n(z)&&i(F,z)))return F<z?-1:1}return 0}function l(P,I){let j=(0,S.$ir)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(j!==0)return j;if(P.command&&I.command)j=d(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(j!==0)return j;if(P.decorations&&I.decorations)j=f(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)j=(0,S.$ir)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)j=(0,S.$ir)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return j}function a(P,I){for(let j=0;j<P.length;j++)if(P[j]!==I[j])return!1;return!0}function h(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?a(P.arguments,I.arguments):P.arguments===I.arguments)}function m(P,I){return(0,b.$ub)(P,I,h)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$yG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$yG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$yG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,j,F,z,O){this.k=I,this.l=z,this.m=O,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=F}showValidationMessage(I,j){(0,v.$yG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,j)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$Llc=D;class p{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,j,F,z,O,T,B){this.q=I,this.s=j,this.t=F,this.u=z,this.v=O,this.multiDiffEditorEnableViewChanges=T,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=p.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,j){const F=this.h.get(I);return F?(0,M.$ih)(()=>this.s.executeCommand(F.command,...F.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(l),F=(0,b.$Db)(this.o,I,l).map(T=>{const B=T.toInsert.map(W=>{const X=this.e++;this.g.set(X,W);const x=W.resourceUri;let Z;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const re=new R.$Tc;Z=this.s.converter.toInternal(W.command,re),this.j.set(X,re)}else this.h.set(X,W.command);const Y=(0,v.$xG)(this.w,"scmMultiDiffEditor"),ce=Y?W.multiDiffEditorOriginalUri:void 0,ne=Y?W.multiFileDiffEditorModifiedUri:void 0,$e=r(W.decorations),Pe=W.decorations&&r(W.decorations.light)||$e,_=W.decorations&&r(W.decorations.dark)||$e,U=[Pe,_],ie=W.decorations&&W.decorations.tooltip||"",be=W.decorations&&!!W.decorations.strikeThrough,Ce=W.decorations&&!!W.decorations.faded,oe=W.contextValue||"";return{rawResource:[X,x,U,ie,be,Ce,oe,Z,ce,ne],handle:X}});return{start:T.start,deleteCount:T.deleteCount,toInsert:B}}),z=F.map(({start:T,deleteCount:B,toInsert:W})=>[T,B,W.map(X=>X.rawResource)]),O=F.reverse();for(const{start:T,deleteCount:B,toInsert:W}of O){const X=W.map(Z=>Z.handle),x=this.n.splice(T,B,...X);for(const Z of x)this.g.delete(Z),this.h.delete(Z),this.j.get(Z)?.dispose(),this.j.delete(Z)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let j;(0,v.$xG)(this.x,"quickDiffProvider")&&(j=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:j})}get historyProvider(){return(0,v.$yG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$yG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const j=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:j})}get actionButton(){return(0,v.$yG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$yG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const j=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(F=>F.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:j??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&m(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const j=(I||[]).map(F=>this.y.converter.toInternal(F,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:j})}get selected(){return this.u}constructor(I,j,F,z,O,T,B){this.x=I,this.y=z,this.z=O,this.A=T,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=F;const W=u.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,j,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,O,T,B,W)}createResourceGroup(I,j,F){const z=(0,v.$xG)(this.x,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,O=new p(this.#e,this.y,this.w,I,j,z,this.x),T=N.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,T),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],j=[];for(const[F,z]of this.C){z.dispose();const O=F.onDidUpdateResourceStates(()=>{this.D.add(F),this.eventuallyUpdateResourceStates()});N.Event.once(F.onDidDispose)(()=>{this.D.delete(F),O.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.w,F.handle)}),I.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const T=F._takeResourceStateSnapshot();T.length>0&&j.push([F.handle,T]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.w,I,j),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(j=>{const F=j._takeResourceStateSnapshot();F.length!==0&&I.push([j.handle,F])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$Vh)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$Vh)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,j,F,z){this.l=j,this.m=F,this.n=z,this.g=new Map,this.h=new C.$Nm,this.j=new N.$be,this.e=I.getProxy(w.$PM.MainThreadSCM),this.f=I.getProxy(w.$PM.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const T=this.g.get(O.sourceControlHandle);if(!T)return O;const B=T.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const T=this.g.get(O.sourceControlHandle);return T?T.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const T=this.g.get(O.handle);return T||O}return O}})}createSourceControl(I,j,F,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,j,F,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=o.d++,T=new E(I,this.m,this.e,this.l,j,F,z);this.g.set(O,T);const B=this.h.get(I.identifier)||[];return B.push(T),this.h.set(I.identifier,B),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const j=this.h.get(I.identifier),F=j&&j[j.length-1];return F&&F.inputBox}$provideOriginalResource(I,j,F){const z=u.URI.revive(j);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>O.quickDiffProvider.provideOriginalResource(z,F)).then(T=>T||null)}$onInputBoxValueChange(I,j){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const F=this.g.get(I);return F&&F.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(I,j,F,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,j,F);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const T=O.getResourceGroup(j);return T?T.$executeResourceCommand(F,z):Promise.resolve(void 0)}$validateInput(I,j,F){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>z.inputBox.validateInput(j,F)).then(O=>{if(!O)return Promise.resolve(void 0);const T=k.MarkdownString.fromStrict(O.message);return T?Promise.resolve([T,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,j,F,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,F,z)??void 0}async $provideHistoryItems(I,j,F,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(j,F,z))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(I,j,F,z){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const T=await O.provideHistoryItemSummary(j,F,z);return T?{...T,icon:s(T)}:void 0}async $provideHistoryItemChanges(I,j,F,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(j,F,z)??void 0}};e.$Mlc=y,e.$Mlc=y=o=Je([qe(3,A.$Wj)],y)}),define(ke[348],Ee([1,0,6,16,2]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class R{static{this.a=0}constructor(w,b){this.d=b,this.c=new Map,this.b=w.getProxy(u.$PM.MainThreadShare)}async $provideShare(w,b,S){return await this.c.get(w)?.provideShare({selection:N.Range.to(b.selection),resourceUri:L.URI.revive(b.resourceUri)},S)??void 0}registerShareProvider(w,b){const S=R.a++;return this.c.set(S,b),this.b.$registerShareProvider(S,N.DocumentSelector.from(w,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$Nlc=R}),define(ke[349],Ee([1,0,7,6,225,3,16,18]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor($,k,v,c,g,o=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=$,this.#t=k,g&&c){this.c=(0,u.$qN)(c.identifier,g);const i=v.get(this.c);i&&(o=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(b.a++);this.e=c,this.f=g,this.g=o,this.h=this.u(n)}u($){if((0,w.$8f)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!b.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let k;this.m?k=this.m:k=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=b.b.get(this.o.id));const c=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,k,this.k,c,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Plc=b;class S{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const k={message:$};return this.b.unshift(k),this.c(),new u.$RM(()=>{const v=this.b.indexOf(k);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,k){this.e=new Map,this.a=$.getProxy(N.$PM.MainThreadStatusBar),this.b=k,this.c=new S(this)}$acceptStaticEntries($){for(const k of $)this.e.set(k.entryId,k)}createStatusBarEntry($,k,v,c){return new b(this.a,this.b,this.e,$,k,v,c)}setStatusBarMessage($,k){const v=this.c.setMessage($);let c;return typeof k=="number"?c=setTimeout(()=>v.dispose(),k):typeof k<"u"&&k.then(()=>v.dispose(),()=>v.dispose()),new u.$RM(()=>{v.dispose(),clearTimeout(c)})}}e.$Qlc=A}),define(ke[154],Ee([1,0,29,144,68,112,89,16,2]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=e.$nP=e.$mP=void 0;const S=(i,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(d){if(!s(f,d)){const l=f;f=d,i.listener?.(t(d,l))}}}},A=(i,r)=>i===r,C={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},$=i=>r=>({op:4,update:i(r)}),k=(i,r)=>({range:(()=>{let s;const t=$(f=>({range:u.$kt.lift(w.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){i.listener?.({op:6}),C.range(s,f)||(s=f,i.listener?.(t(f)))}}})(),label:S(i,r,C.label,$(s=>({label:s}))),description:S(i,void 0,C.description,$(s=>({description:s}))),sortText:S(i,void 0,C.sortText,$(s=>({sortText:s}))),canResolveChildren:S(i,!1,C.canResolveChildren,s=>({op:2,state:s})),busy:S(i,!1,C.busy,$(s=>({busy:s}))),error:S(i,void 0,C.error,$(s=>({error:w.MarkdownString.fromStrict(s)||null}))),tags:S(i,[],C.tags,(s,t)=>({op:1,new:s.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),v=i=>{const r=L.$BL.fromString(i.extId),s=new g(r.controllerId,r.localId,i.label,b.URI.revive(i.uri)||void 0);return s.range=w.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>w.TestTag.to({id:(0,M.$HL)(t).tagId})),s},c=i=>{let r;for(const s of i.tests){const t=v(s.item);(0,N.$9O)(t).parent=r,r=t}return r};e.$mP=c;class g{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,N.$8O)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,R.$7O)(d,N.$9O,g),enumerable:!0,writable:!1},...k(d,t)})}}e.$nP=g;class o extends g{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$oP=o;class n extends R.$3O{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:N.$9O,getChildren:f=>f.children,root:new o(r,s),toITestItem:w.TestItem.from})}}e.$pP=n}),define(ke[33],Ee([1,0,18,7,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,39,87,90,30]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=void 0;let d=class{#e;#t;#i;constructor(p,E,y){this.b=new Map,this.c=new Map,this.#e=p.getProxy(M.$PM.MainThreadCommands),this.d=E,this.#i=y,this.#t=p.getProxy(M.$PM.MainThreadTelemetry),this.converter=new l(this,P=>{const I=this.c.get(P);return I?.result===h.Void?I:void 0},E),this.f=[{processArgument(P){return(0,S.$Zh)(P)}},{processArgument(P){return(0,R.$Yn)(P,function(I){if(A.$kt.isIRange(I))return L.Range.to(I);if(C.$jt.isIPosition(I))return L.Position.to(I);if(A.$kt.isIRange(I.range)&&$.URI.isUri(I.uri))return L.location.to(I);if(I instanceof o.$Ce)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const E=this.registerCommand(!1,p.id,async(...y)=>{const P=p.args.map((j,F)=>{if(!j.validate(y[F]))throw new Error(`Invalid argument '${j.name}' when running '${p.id}', received: ${typeof y[F]=="object"?JSON.stringify(y[F],null,"	"):y[F]} `);return j.convert(y[F])}),I=await this.executeCommand(p.internalId,...P);return p.result.convert(I,y,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new N.$RM(()=>{E.dispose(),this.c.delete(p.id)})}registerCommand(p,E,y,P,I,j){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:y,thisArg:P,metadata:I,extension:j}),p&&this.#e.$registerCommand(E),new N.$RM(()=>{this.b.delete(E)&&p&&this.#e.$unregisterCommand(E)})}executeCommand(p,...E){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,E,!0)}async g(p,E,y){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,E,!1);{let P=!1;const I=(0,R.$Yn)(E,function(j){if(j instanceof N.$SM)return L.Position.from(j);if(j instanceof N.$TM)return L.Range.from(j);if(j instanceof N.$4M)return L.location.from(j);if(N.$gO.isNotebookRange(j))return L.NotebookRange.from(j);if(j instanceof ArrayBuffer)return P=!0,o.$Ce.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return P=!0,o.$Ce.wrap(j);if(j instanceof o.$Ce)return P=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(p,P?new n.$mw(I):I,y);return(0,S.$Zh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(p,E,!1);throw j}}}async h(p,E,y){const P=this.b.get(p);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:j,metadata:F}=P;if(F?.args)for(let O=0;O<F.args.length;O++)try{(0,u.$ig)(E[O],F.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${F.args[O].name}' - ${F.args[O].description}`)}const z=r.$0d.create();try{return await I.apply(j,E)}catch(O){if(p===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...E);T&&(p=T.command)}if(this.d.error(O,p,P.extension?.identifier),!y)throw O;if(P.extension?.identifier){const T=this.#i.onExtensionError(P.extension.identifier,O);this.d.trace("forwarded error to extension?",T,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$bj)(O)),this.id=p,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,p,z.elapsed())}}j(p,E,y){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new s.$_o(E),duration:y})}$executeContributedCommand(p,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const y=this.b.get(p);return y?(E=E.map(P=>this.f.reduce((I,j)=>j.processArgument(I,y.extension?.identifier),P)),this.h(p,E,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(E=>(p&&(E=E.filter(y=>y[0]!=="_")),E))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[E,y]of this.b){const{metadata:P}=y;P&&(p[E]=P)}return Promise.resolve(p)}};e.$vP=d,e.$vP=d=Je([qe(0,c.$aP),qe(1,b.$Wj),qe(2,t.$uP)],d),e.$wP=(0,v.$qi)("IExtHostCommands");class l{constructor(p,E,y){this.d=p,this.f=E,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,E){if(!p)return;const y={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return y;const P=this.f(p.command);if(P)y.id=P.internalId,y.arguments=P.args.map((I,j)=>I.convert(p.arguments&&p.arguments[j]));else if((0,w.$Lb)(p.arguments)){const I=`${p.command} /${++this.c}`;this.b.set(I,p),E.add((0,k.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),y.$ident=I,y.id=this.delegatingCommandId,y.arguments=[I],this.g.trace("CommandsConverter#CREATE",p.command,I)}return y}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const E=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$xP=l;class a{static{this.Uri=new a("uri","Uri of a text document",p=>$.URI.isUri(p),p=>p)}static{this.Position=new a("position","A position in a text document",p=>N.$SM.isPosition(p),L.Position.from)}static{this.Range=new a("range","A range in a text document",p=>N.$TM.isRange(p),L.Range.from)}static{this.Selection=new a("selection","A selection in a text document",p=>N.$UM.isSelection(p),L.Selection.from)}static{this.Number=new a("number","",p=>typeof p=="number",p=>p)}static{this.String=new a("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=a.Arr(a.String)}static Arr(p){return new a(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,E=>Array.isArray(E)&&E.every(y=>p.validate(y)),E=>E.map(y=>p.convert(y)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",p=>p instanceof N.$cN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",p=>p instanceof N.$AO,L.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",p=>p instanceof g.$nP,L.TestItem.from)}constructor(p,E,y,P){this.name=p,this.description=E,this.validate=y,this.convert=P}optional(){return new a(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,E){return new a(p??this.name,E??this.description,this.validate,this.convert)}}e.$yP=a;class h{static{this.Void=new h("no result",p=>p)}constructor(p,E){this.description=p,this.convert=E}}e.$zP=h;class m{constructor(p,E,y,P,I){this.id=p,this.internalId=E,this.description=y,this.args=P,this.result=I}}e.$AP=m}),define(ke[350],Ee([1,0,19,15,2,83,134,37,33,16,7]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;const C=[new b.$AP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of DocumentHighlight-instances.",k(S.DocumentHighlight.to))),new b.$AP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$yP.Uri],new b.$zP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,g)=>{if((0,u.$Kb)(c))return;class o extends A.$0M{static to(i){const r=new o(i.name,S.SymbolKind.to(i.kind),i.containerName||"",new A.$4M(g[0],S.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=S.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return c.map(o.to)})),new b.$AP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$yP.Uri,new b.$yP("options","Formatting options",c=>!0,c=>c)],new b.$zP("A promise that resolves to an array of TextEdits.",k(S.TextEdit.to))),new b.$AP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$yP.Uri,b.$yP.Range,new b.$yP("options","Formatting options",c=>!0,c=>c)],new b.$zP("A promise that resolves to an array of TextEdits.",k(S.TextEdit.to))),new b.$AP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$yP.Uri,b.$yP.Position,new b.$yP("ch","Trigger character",c=>typeof c=="string",c=>c),new b.$yP("options","Formatting options",c=>!0,c=>c)],new b.$zP("A promise that resolves to an array of TextEdits.",k(S.TextEdit.to))),new b.$AP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location-instances.",k(S.location.to))),new b.$AP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Hover-instances.",k(S.Hover.to))),new b.$AP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$yP.Uri,new b.$yP("position","A position in a text document",c=>Array.isArray(c)&&c.every(g=>A.$SM.isPosition(g)),c=>c.map(S.Position.from))],new b.$zP("A promise that resolves to an array of ranges.",c=>c.map(g=>{let o;for(const n of g.reverse())o=new A.$bN(S.Range.to(n),o);return o}))),new b.$AP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$yP.String.with("query","Search string")],new b.$zP("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(S.WorkspaceSymbol.to))),new b.$AP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(S.CallHierarchyItem.to))),new b.$AP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$yP.CallHierarchyItem],new b.$zP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(S.CallHierarchyIncomingCall.to))),new b.$AP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$yP.CallHierarchyItem],new b.$zP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(S.CallHierarchyOutgoingCall.to))),new b.$AP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:S.Range.to(c.range),placeholder:c.text}})),new b.$AP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$yP.Uri,b.$yP.Position,b.$yP.String.with("newName","The new symbol name")],new b.$zP("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return S.WorkspaceEdit.to(c)}})),new b.$AP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$yP.Uri,b.$yP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$zP("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(S.DocumentLink.to))),new b.$AP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$yP.Uri],new b.$zP("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new A.$0N(c.tokenTypes,c.tokenModifiers)})),new b.$AP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$yP.Uri],new b.$zP("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,M.$ibb)(c);if(g.type==="full")return new A.$_N(g.data,void 0)})),new b.$AP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$yP.Uri,b.$yP.Range.optional()],new b.$zP("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new A.$0N(c.tokenTypes,c.tokenModifiers)})),new b.$AP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$yP.Uri,b.$yP.Range],new b.$zP("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,M.$ibb)(c);if(g.type==="full")return new A.$_N(g.data,void 0)})),new b.$AP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$yP.Uri,b.$yP.Position,b.$yP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$yP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$zP("A promise that resolves to a CompletionList-instance.",(c,g,o)=>{if(!c)return new A.$nN([]);const n=c.suggestions.map(i=>S.CompletionItem.to(i,o));return new A.$nN(n,c.incomplete)})),new b.$AP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$yP.Uri,b.$yP.Position,b.$yP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$zP("A promise that resolves to SignatureHelp.",c=>{if(c)return S.SignatureHelp.to(c)})),new b.$AP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$yP.Uri,b.$yP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$zP("A promise that resolves to an array of CodeLens-instances.",(c,g,o)=>k(n=>new A.$fN(S.Range.to(n.range),n.command&&o.fromInternal(n.command)))(c))),new b.$AP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$yP.Uri,new b.$yP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>A.$TM.isRange(c),c=>A.$UM.isSelection(c)?S.Selection.from(c):S.Range.from(c)),b.$yP.String.with("kind","Code action kind to return code actions for").optional(),b.$yP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$zP("A promise that resolves to an array of Command-instances.",(c,g,o)=>k(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.$_M(n.title,n.kind?new A.$aN(n.kind):void 0);return n.edit&&(i.edit=S.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(c))),new b.$AP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$yP.Uri],new b.$zP("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(g=>new A.$tN(S.Range.to(g.range),S.Color.to(g.color))):[])),new b.$AP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$yP("color","The color to show and insert",c=>c instanceof A.$sN,S.Color.from),new b.$yP("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:S.Range.from(c.range)}))],new b.$zP("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(S.ColorPresentation.to):[])),new b.$AP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$yP.Uri,b.$yP.Range],new b.$zP("A promise that resolves to an array of Inlay objects",(c,g,o)=>c.map(S.InlayHint.to.bind(void 0,o)))),new b.$AP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$yP.Uri],new b.$zP("A promise that resolves to an array of FoldingRange objects",(c,g)=>{if(c)return c.map(S.FoldingRange.to)})),new b.$AP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$zP("A promise that resolves to an array of NotebookContentProvider static info objects.",k(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(g=>S.NotebookExclusiveDocumentPattern.to(g))})))),new b.$AP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$yP.Uri,b.$yP.Range,new b.$yP("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof A.$TM,c=>S.InlineValueContext.from(c))],new b.$zP("A promise that resolves to an array of InlineValue objects",c=>c.map(S.InlineValue.to))),new b.$AP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$yP("uriOrString","Uri-instance or string (only http/https)",c=>L.URI.isUri(c)||typeof c=="string"&&(0,N.$Ag)(c,N.Schemas.http,N.Schemas.https),c=>c),new b.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[S.ViewColumn.from(c),void 0]:[S.ViewColumn.from(c.viewColumn),S.TextEditorOpenOptions.from(c)])).optional(),b.$yP.String.with("label","").optional()],b.$zP.Void),new b.$AP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$yP.Uri.with("resource","Resource to open"),b.$yP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[S.ViewColumn.from(c),void 0]:[S.ViewColumn.from(c.viewColumn),S.TextEditorOpenOptions.from(c)])).optional()],b.$zP.Void),new b.$AP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$yP.Uri.with("left","Left-hand side resource of the diff editor"),b.$yP.Uri.with("right","Right-hand side resource of the diff editor"),b.$yP.String.with("title","Human readable title for the diff editor").optional(),new b.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[S.ViewColumn.from(c.viewColumn),S.TextEditorOpenOptions.from(c)]).optional()],b.$zP.Void),new b.$AP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$yP.String.with("title","Human readable title for the changes editor"),new b.$yP("resourceList","List of resources to compare",c=>{for(const g of c){if(g.length!==3)return!1;const[o,n,i]=g;if(!L.URI.isUri(o)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},c=>c)],b.$zP.Void),new b.$AP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(S.TypeHierarchyItem.to))),new b.$AP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$yP.TypeHierarchyItem],new b.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(S.TypeHierarchyItem.to))),new b.$AP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$yP.TypeHierarchyItem],new b.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(S.TypeHierarchyItem.to))),new b.$AP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$yP.TestItem],b.$zP.Void),new b.$AP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$yP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$zP.Void),new b.$AP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$yP.String.with("name","The context key name"),new b.$yP("value","The context key value",()=>!0,c=>c)],b.$zP.Void),new b.$AP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$yP.Uri,b.$yP.StringArray,new b.$yP("MappedEditsContext","Mapped Edits Context",c=>S.MappedEditsContext.is(c),c=>S.MappedEditsContext.from(c))],new b.$zP("A promise that resolves to a workspace edit or null",c=>c?S.WorkspaceEdit.to(c):null))];class ${static register(g){C.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",w.$pj)}}e.$_jc=$;function k(c){return g=>{if(Array.isArray(g))return g.map(c)}}function v(c){if(!Array.isArray(c))return;const g=[];for(const o of c)R.$2t(o)?g.push(S.DefinitionLink.to(o)):g.push(S.location.to(o));return g}}),define(ke[351],Ee([1,0,8,3,2,6,33,16,7]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class S{static{this.a=0}constructor(k,v){this.extension=k,this.provider=v,this.handle=S.a++}}class A{constructor(k){this.session=k,this.responses=[]}}class C{static{this.a=0}constructor(k,v,c,g){this.f=c,this.g=g,this.b=new Map,this.d=new Map,this.e=k.getProxy(R.$PM.MainThreadInlineChat),v.registerApiCommand(new M.$AP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$yP("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?w.Range.from(o.initialRange):void 0,initialSelection:b.$UM.isSelection(o.initialSelection)?w.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?w.Position.from(o.position):void 0}})],M.$zP.Void))}registerProvider(k,v,c){const g=new S(k,v);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,c?.label??k.displayName??k.name,k.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",c?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(k,v,c,g){const o=this.b.get(k);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(v)),i=w.Selection.to(c),r=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},g);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=C.a++;return this.d.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:w.Range.from(r.wholeRange),message:r.message}}async $provideResponse(k,v,c,g){const o=this.b.get(k);if(!o)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:c.prompt,selection:w.Selection.to(c.selection),wholeRange:w.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,previewDocument:this.f.getDocument(L.URI.revive(c.previewDocument)),withIntentDetection:c.withIntentDetection};let r=!1;const s={report:async D=>{if(!c.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||g.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:D.message,edits:D.edits?.map(w.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:b.$gN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,g));let f;try{f=await(0,u.$eh)(t,g)}finally{r=!0}if(!f)return;const d=n.responses.push(f)-1,l={wholeRange:w.Range.from(f.wholeRange),placeholder:f.placeholder};if(!C.h(f))return{...l,id:d,type:"editorEdit",message:w.MarkdownString.from(f.contents),edits:[]};const{edits:a,contents:h}=f,m=h!==void 0?w.MarkdownString.from(h):void 0;return a instanceof b.$2M?{...l,id:d,type:"bulkEdit",edits:w.WorkspaceEdit.from(a),message:m}:{...l,id:d,type:"editorEdit",edits:a.map(w.TextEdit.from),message:m}}async $provideFollowups(k,v,c,g){const o=this.b.get(k),n=this.d.get(v),i=n?.responses[c];if(o&&i&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(n.session,i,g));return(await(0,u.$eh)(r,g))?.map(w.ChatInlineFollowup.from)}}$handleFeedback(k,v,c,g){const o=this.b.get(k),n=this.d.get(v),i=n?.responses[c];if(o&&i){const r=w.InteractiveEditorResponseFeedbackKind.to(g);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(k,v){}static h(k){return typeof k=="object"&&typeof k.edits=="object"}}e.$ilc=C}),define(ke[352],Ee([1,0,2,33]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class L{constructor(M,w,b,S,A){this.a=w,this.b=b,this.c=S;const C=new N.$AP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$yP("showOptions","Show Options",$=>!0,$=>$),new N.$yP("resource","Interactive resource Uri",$=>!0,$=>$),new N.$yP("controllerId","Notebook controller Id",$=>!0,$=>$),new N.$yP("title","Interactive editor title",$=>!0,$=>$)],new N.$zP("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const k=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri),notebookEditor:k.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(M,w,b,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:b,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$vlc=L}),define(ke[353],Ee([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,113,297,26,48,298]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0,e.$Dlc=a;let r=class{constructor(m,D,p,E,y){this.m=D,this.n=p,this.o=E,this.q=y,this.b=new w.$Bc,this.c=new w.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=m.getProxy(C.$PM.MainThreadNotebookKernels);const P=new $.$AP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$yP("options","Select kernel options",j=>!0,j=>{if(j&&"notebookEditor"in j&&"id"in j){const F=this.n.getIdByEditor(j.notebookEditor);return{id:j.id,extension:j.extension,notebookEditorId:F}}else if(j&&"notebookEditor"in j){const F=this.n.getIdByEditor(j.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${j.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return j})],$.$zP.Void),I=new $.$AP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[$.$yP.Uri],new $.$zP("A promise that resolves to an array of variables",(j,F)=>j.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(m,D,p,E,y,P){for(const $e of this.j.values())if($e.controller.id===D&&S.$Lm.equals(m.identifier,$e.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,j=this;this.q.trace(`NotebookController[${I}], CREATED by ${m.identifier.value}, ${D}`);const F=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${m.identifier}'`);let z=!1;const O=new R.$be,T=new R.$be,B={id:a(m.identifier,D),notebookType:p,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:E||m.identifier.value,preloads:P?P.map(k.NotebookRendererScript.from):[]};let W=y??F,X,x;this.a.$addKernel(I,B).catch($e=>{console.log($e),z=!0});let Z=0;const Y=()=>{if(z)return;const $e=++Z;Promise.resolve().then(()=>{$e===Z&&this.a.$updateKernel(I,B)})},ce=new w.$Bc,ne={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label($e){B.label=$e??m.displayName??m.name,Y()},get detail(){return B.detail??""},set detail($e){B.detail=$e,Y()},get description(){return B.description??""},set description($e){B.description=$e,Y()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages($e){B.supportedLanguages=$e,Y()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder($e){B.supportsExecutionOrder=$e,Y()},get rendererScripts(){return B.preloads?B.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler($e){W=$e??F},get interruptHandler(){return X},set interruptHandler($e){X=$e,B.supportsInterrupt=!!$e,Y()},set variableProvider($e){(0,o.$yG)(m,"notebookVariableProvider"),x=$e,B.hasVariableProvider=!!$e,$e?.onDidChangeVariables(Pe=>j.a.$variablesUpdated(Pe.uri)),Y()},get variableProvider(){return x},createNotebookCellExecution($e){if(z)throw new Error("notebook controller is DISPOSED");if(!ce.has($e.notebook.uri))throw j.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return j._createNotebookCellExecution($e,a(m.identifier,this.id))},createNotebookExecution($e){if((0,o.$yG)(m,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ce.has($e.uri))throw j.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return j._createNotebookExecution($e,a(m.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),O.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity($e,Pe){Pe===v.NotebookControllerAffinity2.Hidden&&(0,o.$yG)(m,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(I,$e.uri,Pe)},onDidReceiveMessage:T.event,postMessage($e,Pe){return(0,o.$yG)(m,"notebookMessaging"),j.a.$postMessage(I,Pe&&j.n.getIdByEditor(Pe),$e)},asWebviewUri($e){return(0,o.$yG)(m,"notebookMessaging"),(0,c.$Gxb)($e,j.m.remote)}};return this.j.set(I,{extensionId:m.identifier,controller:ne,onDidReceiveMessage:T,onDidChangeSelection:O,associatedNotebooks:ce}),ne}getIdByController(m){for(const[D,p]of this.j)if(p.controller===m)return a(p.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,D){const p=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(p,D);const y={dispose:()=>{this.f.delete(p),E.a.$removeKernelDetectionTask(p)}};return this.f.set(p,y),y}registerKernelSourceActionProvider(m,D,p){const E=this.i++,y=typeof p.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,P=this;this.h.set(E,p),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,D);let I;return y!==void 0&&(I=p.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(E),P.a.$removeKernelSourceActionProvider(E,E),I?.dispose()}}}async $provideKernelSourceActions(m,D){const p=this.h.get(m);if(p){const E=new M.$Tc;return(await p.provideNotebookKernelSourceActions(D)??[]).map(P=>k.NotebookKernelSourceAction.from(P,this.o.converter,E))}return[]}$acceptNotebookAssociation(m,D,p){const E=this.j.get(m);if(E){const y=this.n.getNotebookDocument(b.URI.revive(D));p?E.associatedNotebooks.set(y.uri,!0):E.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${m}] ASSOCIATE notebook`,y.uri.toString(),p),E.onDidChangeSelection.fire({selected:p,notebook:y.apiNotebook})}}async $executeCells(m,D,p){const E=this.j.get(m);if(!E)return;const y=this.n.getNotebookDocument(b.URI.revive(D)),P=[];for(const I of p){const j=y.getCell(I);j&&P.push(j.apiCell)}try{this.q.trace(`NotebookController[${m}] EXECUTE cells`,y.uri.toString(),P.length),await E.controller.executeHandler.call(E.controller,P,y.apiNotebook,E.controller)}catch(I){this.q.error(`NotebookController[${m}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(m,D,p){const E=this.j.get(m);if(!E)return;const y=this.n.getNotebookDocument(b.URI.revive(D));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,y.apiNotebook);else for(const P of p){const I=y.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(E.controller.interruptHandler){const P=this.c.get(y.uri);p.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(m,D,p,E,y,P,I){const j=this.j.get(m);if(!j)return;const F=this.n.getNotebookDocument(b.URI.revive(p)),z=j.controller.variableProvider;if(!z)return;let O;if(E!==void 0){if(O=this.s[E],!O)return}else this.s={};const T=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(F.apiNotebook,O,T,P,I);let W=0;for await(const X of B){if(I.isCancellationRequested)return;const x={id:this.r++,name:X.variable.name,value:X.variable.value,type:X.variable.type,interfaces:X.variable.interfaces,language:X.variable.language,expression:X.variable.expression,hasNamedChildren:X.hasNamedChildren,indexedChildrenCount:X.indexedChildrenCount,extensionId:j.extensionId.value};if(this.s[x.id]=X.variable,this.a.$receiveVariable(D,x),W++>=i.$kib)return}}$acceptKernelMessageFromRenderer(m,D,p){const E=this.j.get(m);if(!E)return;const y=this.n.getEditorById(D);E.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:p}))}$cellExecutionChanged(m,D,p){const y=this.n.getNotebookDocument(b.URI.revive(m)).getCell(D);if(y){const P=p?k.NotebookCellExecutionState.to(p):v.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution(m,D){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const y=new t(D,E,this.a);this.b.set(E.uri,y);const P=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),P.dispose(),this.b.delete(E.uri))});return y.asApiObject()}_createNotebookExecution(m,D){const p=this.n.getNotebookDocument(m.uri),E=m.getCells().find(I=>{const j=p.getCellFromApiCell(I);return j&&this.b.has(j.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const y=new d(D,p,this.a),P=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),P.dispose(),this.c.delete(p.uri))});return this.c.set(p.uri,[y,P]),y.asApiObject()}};e.$Clc=r,e.$Clc=r=Je([qe(4,A.$Wj)],r);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(m,D,p){super(),this.m=D,this.n=p,this.b=t.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new L.$me),this.h=new l(10,E=>this.s(E)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const D=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$mw(D))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let D=this.m;if(m&&(D=this.m.notebook.getCellFromApiCell(m)),!D)throw new Error("INVALID cell");return D.handle}y(m){return m.map(D=>{const p=v.$kO.ensureUniqueMimeTypes(D.items,!0);return p===D.items?k.NotebookCellOutput.from(D):k.NotebookCellOutput.from({items:p,id:D.id,metadata:D.metadata})})}async z(m,D,p){const E=this.w(D),y=this.y((0,u.$3b)(m));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:E,append:p,outputs:y})}async C(m,D,p){return m=v.$kO.ensureUniqueMimeTypes((0,u.$3b)(m),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:m.map(k.NotebookCellOutputItem.from),outputId:D.id,append:p})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(p){m.j=p,m.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(p){if(m.f===s.Resolved||m.f===s.Started)throw new Error("Cannot call start again");m.f=s.Started,m.c.fire(),m.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,E,y){if(m.f===s.Resolved)throw new Error("Cannot call resolve twice");m.f=s.Resolved,m.c.fire(),m.h.flush();const P=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;m.n.$completeExecution(m.b,new n.$mw({runEndTime:E,lastRunSuccess:p,error:P}))},clearOutput(p){return m.t(),m.z([],p,!1)},appendOutput(p,E){return m.t(),m.z(p,E,!0)},replaceOutput(p,E){return m.t(),m.z(p,E,!1)},appendOutputItems(p,E){return m.t(),m.C(p,E,!0)},replaceOutputItems(p,E){return m.t(),m.C(p,E,!1)}})}}var f;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(f||(f={}));class d extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(m,D,p){super(),this.h=D,this.j=p,this.b=d.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new L.$me),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(m,D){this.f=m,this.g=D,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new N.$Nh,this.b=Date.now(),(0,N.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>m.complete())}}function a(h,m){return`${h.value}/${m}`}}),define(ke[42],Ee([1,0,4,6,5,2,20,3,7,227,13,273,22,30,274,57,8,16,33]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=e.$Pkc=e.$Okc=e.$Nkc=void 0,e.$Nkc=(0,L.$qi)("IExtHostTerminalService");class i extends w.$Uc{constructor(p,E,y,P){super(),this.u=p,this._id=E,this.w=y,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new u.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(j,F=!0){I.C(),I.u.$sendText(I._id,j,F)},show(j){I.C(),I.u.$show(I._id,j)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??E?.cwd??void 0,env:p.env??void 0,icon:a(p.iconPath)??void 0,color:c.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(p.location,E?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,E,y,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:c.ThemeColor.isThemeColor(I)?I.id:void 0,location:E?.location||this.z(p,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,E){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in p?{viewColumn:o.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,E){this.j=Object.freeze({code:p,reason:E})}setDimensions(p,E){return p===this.f&&E===this.h||p===0||E===0?!1:(this.f=p,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(E=>{E!==p&&(this.b=Promise.resolve(p))})}}e.$Okc=i;class r{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new u.$be,this.onProcessData=this.a.event,this.b=new u.$be,this.d=new u.$be,this.onDidChangeProperty=this.d.event,this.f=new u.$be,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,E){this.g.setDimensions?.({columns:p,rows:E})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends w.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,E,y){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$be,this.onDidCloseTerminal=this.H.event,this.I=new u.$be,this.onDidOpenTerminal=this.I.event,this.J=new u.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$be,this.onDidChangeTerminalState=this.M.event,this.N=new u.$be,this.onDidChangeShell=this.N.event,this.O=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$PM.MainThreadTerminalService),this.y=new v.$Fsb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:P=>{const I=j=>{const F=j;return this.getTerminalById(F.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let j=0;j<P.length&&P[j].$mid===15;j++)P[j]=I(P[j]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,E){const y=new i(this.a,(0,k.$Mg)(),p,p.name),P=new r(p.pty);return y.createExtensionTerminal(p.location,E,this.R(p,E).resolvedExtHostIdentifier,a(p.iconPath),h(p.color)).then(I=>{const j=this.S(I,P);this.h[I]=j}),this.f.push(y),y.value}R(p,E){if(E=E||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const y=p.location.parentTerminal;if(y){const P=this.f.find(I=>I.value===y);P&&(E.resolvedExtHostIdentifier=P._id)}}else p.location&&typeof p.location!="object"?E.location=p.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(p,E){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const P=new r(E),I=this.S(p,P);this.h[p]=I}async $acceptActiveTerminalChanged(p){const E=this.b;if(p===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(p);y&&(this.b=y,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,E){const y=this.getTerminalById(p);y&&this.O.fire({terminal:y.value,data:E})}async $acceptTerminalDimensions(p,E,y){const P=this.getTerminalById(p);P&&P.setDimensions(E,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(p,E){const y=this.getTerminalById(p);y&&this.P.fire({terminal:y.value,...E})}async $acceptTerminalMaximumDimensions(p,E,y){this.g.get(p)?.resize(E,y)}async $acceptTerminalTitleChange(p,E){const y=this.getTerminalById(p);y&&(y.name=E)}async $acceptTerminalClosed(p,E,y){const P=this.X(this.f,p);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(E,y),this.H.fire(I.value)}}$acceptTerminalOpened(p,E,y,P){if(E){const F=this.X(this.f,E);if(F!==null){this.f[F]._id=p,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new i(this.a,p,I,y);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,E){this.getTerminalById(p)?._setProcessId(E)}async $startExtensionTerminal(p,E){const y=this.getTerminalById(p);if(!y)return{message:(0,S.localize)(0,null,p)};y.isOpen||await new Promise(I=>{const j=this.onDidOpenTerminal(async F=>{F===y.value&&(j.dispose(),I())})});const P=this.g.get(p);P?P.startSendingEvents(E):this.j[p]={initialDimensions:E}}S(p,E){const y=new w.$Tc;y.add(E.onProcessReady(I=>this.a.$sendProcessReady(p,I.pid,I.cwd,I.windowsPty))),y.add(E.onDidChangeProperty(I=>this.a.$sendProcessProperty(p,I))),this.y.startBuffering(p,E.onProcessData),y.add(E.onProcessExit(I=>this.U(p,I))),this.g.set(p,E);const P=this.j[p];return P&&E instanceof r&&(E.startSendingEvents(P.initialDimensions),delete this.j[p]),y}$acceptProcessAckDataEvent(p,E){this.g.get(p)?.acknowledgeDataEvent(E)}$acceptProcessInput(p,E){this.g.get(p)?.input(E)}$acceptTerminalInteraction(p){const E=this.getTerminalById(p);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(p,E){this.getTerminalById(p)?.setSelection(E)}$acceptProcessResize(p,E,y){try{this.g.get(p)?.resize(E,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(p,E){this.g.get(p)?.shutdown(E)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(E=>this.a.$sendProcessProperty(p,{type:"cwd",value:E}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new b.$RM(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,E,y){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,y),this.a.$registerProfileProvider(E,p.identifier.value),new b.$RM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(p,E,y){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,y),this.a.$registerQuickFixProvider(p,E),new b.$RM(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,E){const y=new $.$me().token;if(y.isCancellationRequested)return;const P=this.D.get(p);if(!P)return;const I=await P.provideTerminalQuickFixes(E,y);if(I===null||Array.isArray(I)&&I.length===0)return;const j=new w.$Tc;if(this.w.value=j,!Array.isArray(I))return I?o.TerminalQuickFix.from(I,this.Q.converter,j):void 0;const F=[];for(const z of I){const O=o.TerminalQuickFix.from(z,this.Q.converter,j);O&&F.push(O)}return F}async $createContributedProfileTerminal(p,E){const y=new $.$me().token;let P=await this.C.get(p)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,E);return}this.createTerminalFromOptions(P.options,E)}}async $provideLinks(p,E){const y=this.getTerminalById(p);if(!y)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const I=new $.$me;this.G.set(p,I);const j=[],F={terminal:y.value,line:E},z=[];for(const B of this.z)z.push(g.Promises.withAsyncBody(async W=>{I.token.onCancellationRequested(()=>W({provider:B,links:[]}));const X=await B.provideTerminalLinks(F,I.token)||[];I.token.isCancellationRequested||W({provider:B,links:X})}));const O=await Promise.all(z);if(I.token.isCancellationRequested)return[];const T=new Map;for(const B of O)B&&B.links.length>0&&j.push(...B.links.map(W=>{const X={id:s++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return T.set(X.id,{provider:B.provider,link:W}),X}));return this.F.set(p,T),j}$activateLink(p,E){const y=this.F.get(p)?.get(E);y&&y.provider.handleTerminalLink(y.link)}U(p,E){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const y=this.h[p];y&&(y.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,E)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const E=this.f.findIndex(y=>y.value===p);return E>=0?E:null}W(p,E){const y=this.X(p,E);return y!==null?p[y]:null}X(p,E){const y=p.findIndex(P=>P._id===E);return y>=0?y:null}getEnvironmentVariableCollection(p){let E=this.n.get(p.identifier.value);return E||(E=new f,this.Z(p.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(p,E){const y=(0,C.$cs)(E.map),P=(0,C.$ds)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(p,E.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(p){p.forEach(E=>{const y=E[0],P=new f(E[1]);this.Z(y,P)})}$acceptDefaultProfile(p,E){const y=this.s;this.s=p,this.u=E,y?.path!==p.path&&this.N.fire(p.path)}Z(p,E){this.n.set(p,E),E.onDidChangeCollection(()=>{this.Y(p,E)})}};e.$Pkc=t,e.$Pkc=t=Je([qe(1,n.$wP),qe(2,M.$aP)],t);class f{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$be,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const E=this.h(p);let y=this.a.get(E);return y||(y=new d(this,p),this.a.set(E,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(p,E,y,P){this.f(p,{value:E,type:b.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(p,E,y,P){this.f(p,{value:E,type:b.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(p,E,y,P){this.f(p,{value:E,type:b.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(p,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(p,E.scope),P=this.map.get(y),I=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==E.value||P.type!==E.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const j=this.g(p,E.scope),F={variable:p,...E,options:I};this.map.set(j,F),this.d.fire()}}get(p,E){const y=this.g(p,E),P=this.map.get(y);return P?m(P):void 0}g(p,E){const y=this.h(E);return y.length?`${p}:::${y}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const E=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(p)&&E.set(P.variable,m(P));return E}delete(p,E){const y=this.g(p,E);this.map.delete(y),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[E,y]of this.map)y.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(E);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,E){const y=this.h(E),P=this.descriptionMap.get(y);if(!P||P.description!==p){let I;typeof p=="string"?I=p:I=p?.value.split(`

`)[0];const j={description:I,scope:E};this.descriptionMap.set(y,j),this.d.fire()}}getDescription(p){const E=this.h(p);return this.descriptionMap.get(E)?.description}k(p){const E=this.h(p);this.descriptionMap.delete(E)}}class d{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,E){this.b=p,this.d=E,this.a=new u.$be}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,E,y){this.b.replace(p,E,y,this.d)}append(p,E,y){this.b.append(p,E,y,this.d)}prepend(p,E,y){this.b.prepend(p,E,y,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,E){this.b.getVariableMap(this.d).forEach((y,P)=>p.call(E,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(p,E){super(!1,p,E)}createTerminal(p,E,y){throw new A.$_}createTerminalFromOptions(p,E){throw new A.$_}};e.$Qkc=l,e.$Qkc=l=Je([qe(0,n.$wP),qe(1,M.$aP)],l);function a(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return c.ThemeColor.isThemeColor(D)?D:void 0}function m(D){const p={...D};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[155],Ee([1,0,7,3,5,6,20,42,4,2,8]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0,e.$Ulc=(0,L.$qi)("IExtHostTerminalShellIntegration");let C=class extends N.$Uc{constructor(g,o){super(),this.h=o,this.b=new Map,this.c=new b.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(R.$PM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(g){const o=this.h.getTerminalById(g);if(!o)return;const n=o.value;let i=this.b.get(g);i||(i=new $(o.value,this.f),this.b.set(g,i),i.store.add(o.onWillDispose(()=>this.b.get(g)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(g,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),o.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(g,o,n,i,r){this.b.has(g)||this.$shellIntegrationChange(g);const s={value:o,confidence:n,isTrusted:i};this.b.get(g)?.startShellExecution(s,r)}$shellExecutionEnd(g,o,n,i,r){const s={value:o,confidence:n,isTrusted:i};this.b.get(g)?.endShellExecution(s,r)}$shellExecutionData(g,o){this.b.get(g)?.emitData(o)}$cwdChange(g,o){this.b.get(g)?.setCwd(o)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$Vlc=C,e.$Vlc=C=Je([qe(0,M.$aP),qe(1,w.$Nkc)],C);class $ extends N.$Uc{get currentExecution(){return this.a}constructor(g,o){super(),this.j=g,this.m=o,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new b.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$be),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,r){let s=i;r&&(s+=` "${r.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(s);const t={value:s,confidence:u.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=n.startShellExecution(t,n.c,!0).value;return n.b=!0,f}}}startShellExecution(g,o,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new k(g,o);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,o){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(g){let o=!1;S.URI.isUri(this.c)?o=!S.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(o=!0),o&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(g,o){this.c=g,this.cwd=o,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Qh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const g=this.a=new A.$ph;return new A.$Qh(async n=>{this.b.push(n),await g.wait()})}emitData(g){for(const o of this.b)o.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[354],Ee([1,0,8,21,22,4,74,56,3,18,30,12,6,20,154,16,7,68,112,89]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=e.$Xlc=e.$Wlc=void 0;let r=class extends b.$Uc{constructor(I,j,F,z){super(),this.w=z,this.f=this.B(new R.$be),this.g=new Map,this.s=this.B(new R.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy($.$PM.MainThreadTesting),this.m=new D(this.h),this.j=new d(this.h,j),F.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const T=O,B=T.tests[T.tests.length-1].item.extId;return this.g.get(o.$BL.root(B))?.collection.tree.get(B)?.actual??(0,v.$mP)(O)}case 18:{const{test:T,message:B}=O,W=T.item.extId;return{test:this.g.get(o.$BL.root(W))?.collection.tree.get(W)?.actual??(0,v.$mP)({$mid:16,tests:[T]}),message:c.TestMessage.to(B)}}default:return O}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await F.executeCommand("_testing.getExplorerSelection"),T=B=>{const W=this.g.get(o.$BL.root(B));if(W)return o.$BL.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:O?.include.map(T).filter(S.$_f)||[],exclude:O?.exclude.map(T).filter(S.$_f)||[]}})}createTestController(I,j,F,z){if(this.g.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const O=new b.$Tc,T=O.add(new v.$pP(j,F,this.w));T.root.label=F;const B=new Map,W=new Set,X=this.h,x={items:T.root.children,get label(){return F},set label(Y){F=Y,T.root.label=Y,X.$updateController(j,{label:F})},get refreshHandler(){return z},set refreshHandler(Y){z=Y,X.$updateController(j,{canRefresh:!!Y})},get id(){return j},createRunProfile:(Y,ce,ne,$e,Pe,_)=>{let U=(0,w.$ej)(Y);for(;B.has(U);)U++;return new E(this.h,B,W,this.s.event,j,U,Y,ce,ne,$e,Pe,_)},createTestItem(Y,ce,ne){return new v.$nP(j,Y,ce,ne)},createTestRun:(Y,ce,ne=!0)=>this.j.createTestRun(j,T,Y,ce,ne),invalidateTestResults:Y=>{if(Y===void 0)this.h.$markTestRetired(void 0);else{const ce=Y instanceof Array?Y:[Y];this.h.$markTestRetired(ce.map(ne=>o.$BL.fromExtHostTestItem(ne,j).toString()))}},set resolveHandler(Y){T.resolveHandler=Y},get resolveHandler(){return T.resolveHandler},dispose:()=>{O.dispose()}};X.$registerTestController(j,F,!!z),O.add((0,b.$Sc)(()=>X.$unregisterTestController(j)));const Z={controller:x,collection:T,profiles:B,extension:I,activeProfiles:W};return this.g.set(j,Z),O.add((0,b.$Sc)(()=>this.g.delete(j))),O.add(T.onDidGenerateDiff(Y=>X.$publishDiff(j,Y.map(i.TestsDiffOp.serialize)))),x}createTestObserver(){return this.m.checkout()}async runTests(I,j=L.CancellationToken.None){const F=l(I);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(F.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(O=>o.$BL.fromExtHostTestItem(O,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:y[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:I.exclude?.map(O=>O.id)},j)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,j){return(await this.j.getCoverageDetails(I,j))?.map(c.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,j){this.g.get(I)?.profiles.get(j)?.configureHandler?.()}$setDefaultRunProfiles(I){const j=new Map;for(const[F,z]of Object.entries(I)){const O=this.g.get(F);if(!O)continue;const T=new Map,B=z.filter(X=>!O.activeProfiles.has(X)),W=[...O.activeProfiles].filter(X=>!z.includes(X));for(const X of B)T.set(X,!0),O.activeProfiles.add(X);for(const X of W)T.set(X,!1),O.activeProfiles.delete(X);T.size&&j.set(F,T)}this.s.fire(j)}async $refreshTests(I,j){await this.g.get(I)?.controller.refreshHandler?.(j)}$publishTestResults(I){this.results=Object.freeze(I.map(c.TestResults.to).concat(this.results).sort((j,F)=>F.completedAt-j.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,j){const F=this.g.get(o.$BL.fromString(I).controllerId)?.collection;F&&(await F.expand(I,j<0?1/0:j),F.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(j=>i.TestsDiffOp.deserialize({asCanonicalUri:F=>F},j)))}async $runControllerTests(I,j){return Promise.all(I.map(F=>this.y(F,!1,j)))}async $startContinuousRun(I,j){const F=new L.$me(j),z=await Promise.all(I.map(O=>this.y(O,!0,F.token)));return!j.isCancellationRequested&&!z.some(O=>O.error)&&await new Promise(O=>j.onCancellationRequested(O)),F.dispose(!0),z}async y(I,j,F){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:O,profiles:T}=z,B=T.get(I.profileId);if(!B)return{};const W=I.testIds.map(Y=>O.tree.get(Y)).filter(S.$_f),X=I.excludeExtIds.map(Y=>z.collection.tree.get(Y)).filter(S.$_f).filter(Y=>W.some(ce=>ce.fullId.compare(Y.fullId)===2));if(!W.length)return{};const x=new g.$rO(W.some(Y=>Y.actual instanceof v.$oP)?void 0:W.map(Y=>Y.actual),X.map(Y=>Y.actual),B,j),Z=(0,i.$EL)(I)&&this.j.prepareForMainThreadTestRun(x,a.fromInternal(I,z.collection),B,F);try{return await B.runHandler(x,F),{}}catch(Y){return{error:String(Y)}}finally{Z&&Z.hasRunningTasks&&!F.isCancellationRequested&&await R.Event.toPromise(Z.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$Wlc=r,e.$Wlc=r=Je([qe(0,k.$aP),qe(1,C.$Wj)],r);const s=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class f extends b.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,j,F,z,O){super(),this.y=I,this.z=j,this.C=F,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$me(O));const T=this.B(new u.$Ch(()=>this.F(),s));this.B(this.j.token.onCancellationRequested(()=>T.schedule()));const B=new R.$be;this.s=B.event,this.B((0,b.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,j){const[,F,z]=o.$BL.fromString(I).path,O=this.w.get(z);if(!O)return[];const T=this.g.get(F);if(!T)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(T.run,O,j)??[]}createRun(I){const j=this.y.id,F=this.y.controllerId,z=(0,A.$Mg)(),O=X=>(x,...Z)=>{if(B){this.C.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.y.isIncluded(x)&&(this.H(x),X(x,...Z))},T=(X,x)=>{const Z=x instanceof Array?x.map(c.TestMessage.from):[c.TestMessage.from(x)];if(X.uri&&X.range){const Y={range:c.Range.from(X.range),uri:X.uri};for(const ce of Z)ce.location=ce.location||Y}this.z.$appendTestMessagesInRun(j,z,o.$BL.fromExtHostTestItem(X,F).toString(),Z)};let B=!1;const W={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:X=>{const x=X.uri.toString(),Z=new o.$BL([j,z,x]).toString();this.w.set(x,X),this.z.$appendCoverage(j,z,c.TestCoverage.fromFile(Z,X))},enqueued:O(X=>{this.z.$updateTestStateInRun(j,z,o.$BL.fromExtHostTestItem(X,F).toString(),1)}),skipped:O(X=>{this.z.$updateTestStateInRun(j,z,o.$BL.fromExtHostTestItem(X,F).toString(),5)}),started:O(X=>{this.z.$updateTestStateInRun(j,z,o.$BL.fromExtHostTestItem(X,F).toString(),2)}),errored:O((X,x,Z)=>{T(X,x),this.z.$updateTestStateInRun(j,z,o.$BL.fromExtHostTestItem(X,F).toString(),6,Z)}),failed:O((X,x,Z)=>{T(X,x),this.z.$updateTestStateInRun(j,z,o.$BL.fromExtHostTestItem(X,F).toString(),4,Z)}),passed:O((X,x)=>{this.z.$updateTestStateInRun(j,z,o.$BL.fromExtHostTestItem(X,this.y.controllerId).toString(),3,x)}),appendOutput:(X,x,Z)=>{B||(Z&&(this.y.isIncluded(Z)?this.H(Z):Z=void 0),this.z.$appendOutputToRun(j,z,N.$Ce.fromString(X),x&&c.location.from(x),Z&&o.$BL.fromExtHostTestItem(Z,F).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(j,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:W}),this.z.$startedTestRunTask(j,{id:z,name:I,running:!0}),W}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof v.$nP))throw new n.$5O(I.id);if(this.h.has(o.$BL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const j=[],F=this.y.colllection.root;for(;;){const z=c.TestItem.from(I);if(j.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===F))break;I=I.parent||F}this.z.$addTestsToRun(this.y.controllerId,this.y.id,j)}dispose(){this.G(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(I,j){this.g=I,this.h=j,this.c=new Map,this.f=new Map}getCoverageDetails(I,j){const F=o.$BL.root(I);return this.f.get(F)?.getCoverageDetails(I,j)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[j,{id:F}]of this.c)F===I&&this.c.delete(j)}prepareForMainThreadTestRun(I,j,F,z){return this.j(I,j,F,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,j,F,z,O){const T=this.c.get(F);if(T)return T.createRun(z);const B=a.fromPublic(I,j,F,O),W=l(F);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!F.continuous,profile:W&&{group:y[W.kind],id:W.profileId},exclude:F.exclude?.map(x=>o.$BL.fromExtHostTestItem(x,j.root.id).toString())??[],id:B.id,include:F.include?.map(x=>o.$BL.fromExtHostTestItem(x,j.root.id).toString())??[j.root.id],persist:O});const X=this.j(F,B,F.profile);return R.Event.once(X.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),X.createRun(z)}j(I,j,F,z){const O=new f(j,this.g,this.h,F,z);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$Xlc=d;const l=P=>{if(P.profile){if(!(P.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class a{static fromPublic(I,j,F,z){return new a(I,(0,A.$Mg)(),F.include?.map(O=>o.$BL.fromExtHostTestItem(O,I).toString())??[I],F.exclude?.map(O=>o.$BL.fromExtHostTestItem(O,I).toString())??[],z,j)}static fromInternal(I,j){return new a(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,j)}constructor(I,j,F,z,O,T){this.controllerId=I,this.id=j,this.isPersisted=O,this.colllection=T,this.c=F.map(B=>B+"\0"),this.f=z.map(B=>B+"\0")}isIncluded(I){const j=o.$BL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const F of this.f)if(j===F||j.startsWith(F))return!1;for(const F of this.c)if(j===F||j.startsWith(F))return!0;return!1}}e.$Ylc=a;class h{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,c.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const j=o.$BL.parentId(I.item.extId);if(j&&this.h.has(j.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:j,g:F}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...j].map(z=>z.revived)},get removed(){return[...F].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends i.$KL{constructor(){super(...arguments),this.s=new R.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,j){return{...I,revived:c.TestItem.toPlain(I.item),depth:j?j.depth+1:0,children:new Set}}v(){return new h(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(j=>j.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new m({asCanonicalUri:j=>j});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const p=(P,I,j,F)=>{j?Object.assign(j,F):I.$updateTestRunConfig(P.controllerId,P.profileId,F)};class E{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,p(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,p(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),p(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,p(this,this.#e,this.#n,{tag:I?c.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,p(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#i,I=>I.map(j=>j.get(this.controllerId)?.get(this.profileId)).filter(S.$_f))}constructor(I,j,F,z,O,T,B,W,X,x=!1,Z=void 0,Y=!1){this.controllerId=O,this.profileId=T,this.f=B,this.kind=W,this.runHandler=X,this._tag=Z,this.g=Y,this.#e=I,this.#s=j,this.#t=F,this.#i=z,j.set(T,this);const ce=y[W];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);x&&F.add(T),this.#n={profileId:T,controllerId:O,tag:Z?c.TestTag.namespace(this.controllerId,Z.id):null,label:B,group:ce,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:Y},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Zlc=E;const y={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(ke[156],Ee([1,0,62,13,124,16,7]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=e.$hP=void 0;class w{static{this.c=new L.$fP("TextEditorDecorationType")}constructor($,k,v){const c=w.c.nextId();$.$registerTextEditorDecorationType(k.identifier,c,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:c,dispose(){$.$removeTextEditorDecorationType(c)}})}}e.$hP=w;class b{constructor($,k){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,k){this.k();let v=null;if($ instanceof M.$SM)v=new M.$TM($,$);else if($ instanceof M.$TM)v=$;else throw new Error("Unrecognized location");this.l(v,k,!1)}insert($,k){this.k(),this.l(new M.$TM($,$),k,!0)}delete($){this.k();let k=null;if($ instanceof M.$TM)k=$;else throw new Error("Unrecognized location");this.l(k,null,!0)}l($,k,v){const c=this.c.validateRange($);this.g.push({range:c,text:k,forceMoveMarkers:v})}setEndOfLine($){if(this.k(),$!==M.EndOfLine.LF&&$!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=$}}class S{constructor($,k,v,c){this.c=$,this.d=k,this._accept(v),this.e=c;const g=this;this.value={get tabSize(){return g.f},set tabSize(o){g.n(o)},get indentSize(){return g.g},set indentSize(o){g.p(o)},get insertSpaces(){return g.j},set insertSpaces(o){g.s(o)},get cursorStyle(){return g.k},set cursorStyle(o){g.t(o)},get lineNumbers(){return g.l},set lineNumbers(o){g.u(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.originalIndentSize,this.j=$.insertSpaces,this.k=$.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to($.lineNumbers)}m($){if($==="auto")return"auto";if(typeof $=="number"){const k=Math.floor($);return k>0?k:null}if(typeof $=="string"){const k=parseInt($,10);return isNaN(k)?null:k>0?k:null}return null}n($){const k=this.m($);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const k=Math.floor($);return k>0?k:null}if(typeof $=="string"){const k=parseInt($,10);return isNaN(k)?null:k>0?k:null}return null}p($){const k=this.o($);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q($){return $==="auto"?"auto":$==="false"?!1:!!$}s($){const k=this.q($);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t($){this.k!==$&&(this.k=$,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}u($){this.l!==$&&(this.l=$,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const k={};let v=!1;if(typeof $.tabSize<"u"){const c=this.m($.tabSize);c==="auto"?(v=!0,k.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,v=!0,k.tabSize=c)}if(typeof $.indentSize<"u"){const c=this.o($.indentSize);c==="tabSize"?(v=!0,k.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,v=!0,k.indentSize=c)}if(typeof $.insertSpaces<"u"){const c=this.q($.insertSpaces);c==="auto"?(v=!0,k.insertSpaces=c):this.j!==c&&(this.j=c,v=!0,k.insertSpaces=c)}typeof $.cursorStyle<"u"&&this.k!==$.cursorStyle&&(this.k=$.cursorStyle,v=!0,k.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.l!==$.lineNumbers&&(this.l=$.lineNumbers,v=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v($,k){k.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(v)})}}e.$iP=S;class A{constructor($,k,v,c,g,o,n,i){this.id=$,this.j=k,this.k=v,this.g=!1,this.h=new Set,this.c=g,this.d=new S(this.j,this.id,o,v),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return c.value},set document(s){throw new N.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof M.$UM))throw(0,N.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof M.$UM)))throw(0,N.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new N.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new N.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new b(c.value,t);return s(f),r.m(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>R.Range.from(l));else if(t instanceof M.$SM){const{lineNumber:l,column:a}=R.Position.from(t);d=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(t instanceof M.$TM)d=[R.Range.from(t)];else{d=[];for(const l of t)if(l instanceof M.$TM)d.push(R.Range.from(l));else{const{lineNumber:a,column:h}=R.Position.from(l);d.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return k.$tryInsertSnippet($,c.value.version,s.value,d,f)},setDecorations(s,t){const f=t.length===0;f&&!r.h.has(s.key)||(f?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(R.$0O(t))return k.$trySetDecorations($,s.key,R.$$O(t));{const d=new Array(4*t.length);for(let l=0,a=t.length;l<a;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return k.$trySetDecorationsFast($,s.key,d)}}))},revealRange(s,t){r.n(()=>k.$tryRevealRange($,R.Range.from(s),t||M.TextEditorRevealType.Default))},show(s){k.$tryShowEditor($,R.ViewColumn.from(s))},hide(){k.$tryHideEditor($)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions($){(0,u.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,u.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,u.ok)(!this.g),this.f=$}_acceptSelections($){(0,u.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const k=$.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const v=k.edits.map(g=>g.range);v.sort((g,o)=>g.end.line===o.end.line?g.end.character===o.end.character?g.start.line===o.start.line?g.start.character-o.start.character:g.start.line-o.start.line:g.end.character-o.end.character:g.end.line-o.end.line);for(let g=0,o=v.length-1;g<o;g++){const n=v[g].end;if(v[g+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=k.edits.map(g=>({range:R.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,c,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$jP=A}),define(ke[72],Ee([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,45,46]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new k.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=R.URI.revive(d),a=this.c.get(l);a?.unref()&&(this.c.delete(l),s.push(a.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=R.URI.revive(d.uri);let a=this.c.get(l);if(a&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new o(new b.$dP(this.h.getProxy(w.$PM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,a),t.push(a.value)),a.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&f.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=R.URI.revive(d.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const a=this.c.get(l).value,h=new A.$jP(d.id,this.h.getProxy(w.$PM.MainThreadTextEditors),this.i,new g.$V(()=>a.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(m=>C.Range.to(m)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,L.$Pc)(s),(0,L.$Pc)(f),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return c.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$kP=n,e.$kP=n=Je([qe(0,S.$aP),qe(1,$.$Wj)],n),e.$lP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(ke[355],Ee([1,0,19,4,6,156,16,7]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class b{constructor(A,C){this.i=C,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const C=this.i.allEditors();return A?C:C.map($=>$.value)}async showTextDocument(A,C,$){let k;typeof C=="number"?k={position:M.ViewColumn.from(C),preserveFocus:$}:typeof C=="object"?k={position:M.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?M.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:k={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,k),c=v&&this.i.getEditor(v);if(c)return c.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,C){return new R.$hP(this.h,A,C).value}$acceptEditorPropertiesChanged(A,C){const $=this.i.getEditor(A);if(!$)throw new Error("unknown text editor");if(C.options&&$._acceptOptions(C.options),C.selections){const k=C.selections.selections.map(M.Selection.to);$._acceptSelections(k)}if(C.visibleRanges){const k=u.$Hb(C.visibleRanges.map(M.Range.to));$._acceptVisibleRanges(k)}if(C.options&&this.b.fire({textEditor:$.value,options:{...C.options,lineNumbers:M.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const k=w.TextEditorSelectionChangeKind.fromValue(C.selections.source),v=C.selections.selections.map(M.Selection.to);this.a.fire({textEditor:$.value,selections:v,kind:k})}if(C.visibleRanges){const k=u.$Hb(C.visibleRanges.map(M.Range.to));this.c.fire({textEditor:$.value,visibleRanges:k})}}$acceptEditorPositionData(A){for(const C in A){const $=this.i.getEditor(C);if(!$)throw new Error("Unknown text editor");const k=M.ViewColumn.to(A[C]);$.value.viewColumn!==k&&($._acceptViewColumn(k),this.d.fire({textEditor:$.value,viewColumn:k}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$gkc=b}),define(ke[356],Ee([1,0,2,5,6,3,7,16,25,18]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=e.$2lc=void 0,e.$2lc=(0,N.$qi)("IExtHostTimeline");class A{constructor(k,v){this.b=new Map,this.c=new Map,this.a=k.getProxy(L.$PM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(c,g)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&b.$Lm.equals(g,this.b.get(c.source)?.extension)){const o=c.uri===void 0?void 0:u.URI.revive(c.uri);return this.c.get(c.source)?.get(C(o))?.get(c.handle)}else return;return c}})}async $getTimeline(k,v,c,g){return this.b.get(k)?.provider.provideTimeline(u.URI.revive(v),c,g)}registerTimelineProvider(k,v,c,g){const o=new R.$Tc,n=this.d(v.id,g,o).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const r=this.c;return this.f({...v,scheme:k,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(o.clear(),r.get(v.id)?.clear());const d=await v.provideTimeline(s,t,f);if(d==null)return;const l=n(s,t);return{...d,source:v.id,items:d.items.map(l)}},dispose(){for(const s of r.values())s.get(v.id)?.clear();i?.dispose(),o.dispose()}},c)}d(k,v,c){return(g,o)=>{let n;if(o?.cacheResults){let i=this.c.get(k);i===void 0&&(i=new Map,this.c.set(k,i));const r=C(g);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${k}|${i.id??i.timestamp}`;n?.set(t,i);let f,d,l;i.iconPath&&(r instanceof M.$NN?l={id:r.id,color:r.color}:u.URI.isUri(r)?(f=r,d=r):{light:f,dark:d}=r);let a;return M.$gN.isMarkdownString(s.tooltip)?a=w.MarkdownString.from(s.tooltip):(0,S.$4f)(s.tooltip)?a=s.tooltip:M.$gN.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=w.MarkdownString.from(s.detail)):(0,S.$4f)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=s.detail),{...s,id:s.id??void 0,handle:t,source:k,command:i.command?v.toInternal(i.command,c):void 0,icon:f,iconDark:d,themeIcon:l,tooltip:a,accessibilityInformation:i.accessibilityInformation}}}}f(k,v){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:v}),(0,R.$Sc)(()=>{for(const g of this.c.values())g.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$3lc=A;function C($){return $?.toString()}}),define(ke[357],Ee([1,0,228,23,2,4,3,289,8,7,18,19,16,80,22,184,26]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;function o(r,s){if((0,A.$4f)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends M.$Uc{constructor(s,t,f){super(),this.f=s,this.g=t,this.h=f,this.a=new Map,this.b=new c.$M0;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(a=>d(a)?this.r(a):a):l})}registerTreeDataProvider(s,t,f){const d=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>d.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,m=this.m(s,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:a,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(s,D),E={get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get activeItem(){return(0,g.$yG)(f,"treeViewActiveItem"),m.focusedElement},get onDidChangeActiveItem(){return(0,g.$yG)(f,"treeViewActiveItem"),m.onDidChangeActiveItem},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get onDidChangeCheckboxState(){return m.onDidChangeCheckboxState},get message(){return m.message},set message(y){(0,k.$Pk)(y)&&(0,g.$yG)(f,"treeViewMarkdownMessage"),m.message=y},get title(){return m.title},set title(y){m.title=y},get description(){return m.description},set description(y){m.description=y},get badge(){return m.badge},set badge(y){y!==void 0&&S.ViewBadge.isViewBadge(y)?m.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(m.badge=void 0)},reveal:(y,P)=>m.reveal(y,P),dispose:async()=>{await p,this.a.delete(s),m.dispose()}};return this.B(E),E}$getChildren(s,t){const f=this.a.get(s);return f?f.getChildren(t):Promise.reject(new w.$NF(s))}async $handleDrop(s,t,f,d,l,a,h,m){const D=this.a.get(s);if(!D)return Promise.reject(new w.$NF(s));const p=$.DataTransfer.toDataTransfer(f,async E=>(await this.f.$resolveDropFileData(s,t,E)).buffer);return h===s&&m&&await this.j(p,D,m,l,a),D.onDrop(p,d,l)}async j(s,t,f,d,l){const a=this.b.removeDragOperationTransfer(l);if(a)(await a)?.forEach((h,m)=>{h&&s.set(m,h)});else if(l&&t.handleDrag){const h=t.handleDrag(f,s,d);this.b.addDragOperationTransfer(l,h),await h}return s}async $handleDrag(s,t,f,d){const l=this.a.get(s);if(!l)return Promise.reject(new w.$NF(s));const a=await this.j(new S.$JN,l,t,d,f);if(!(!a||d.isCancellationRequested))return $.DataTransfer.from(a)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new w.$NF(s);return t.hasResolve}$resolve(s,t,f){const d=this.a.get(s);if(!d)throw new w.$NF(s);return d.resolveTreeItem(t,f)}$setExpanded(s,t,f){const d=this.a.get(s);if(!d)throw new w.$NF(s);d.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const d=this.a.get(s);if(!d)throw new w.$NF(s);d.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.a.get(s);if(!f){if(!t)return;throw new w.$NF(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.a.get(s);if(!f)throw new w.$NF(s);f.setCheckboxState(t)}m(s,t,f){const d=this.B(new i(s,t,this.f,this.g.converter,this.h,f));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$4lc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$ag)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,f,d,l,a){if(super(),this.I=s,this.J=f,this.L=d,this.M=l,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$me,a.contributes&&a.contributes.views)for(const p in a.contributes.views)for(const E of a.contributes.views[p])E.id===s&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let h,m;const D=R.Event.debounce(this.F.event,(p,E)=>(p||(p={message:!1,elements:[]}),E.element!==!1&&(h||(h=new Promise(y=>m=y),this.G=this.G.then(()=>h)),Array.isArray(E.element)?p.elements.push(...E.element):p.elements.push(E.element)),E.message&&(p.message=!0),p),200,!0);this.B(D(({message:p,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const y=m;return h=null,this.$(E).then(()=>y())})),p&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.X(s);return f||(f=await this.Y(t)),f?f.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,A.$ag)(t.select)?!0:t.select,d=(0,A.$ag)(t.focus)?!1:t.focus,l=(0,A.$ag)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(a=>this.W(s,a[a.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:a.map(m=>m.item)},{select:f,focus:d,expand:l})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:f,focus:d,expand:l})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=$.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,C.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const d=this.getExtensionElement(f.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:f.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const d=[];for(const l of s){const a=this.getExtensionElement(l);a&&d.push(a)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,f){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,b.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(s);if(f){const d=this.m.get(f);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,f,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(d=>(f.push(d),f))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,b.$ih)(()=>this.f.getParent(s))}W(s,t){const f=this.m.get(s);return f?Promise.resolve(f):(0,b.$ih)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const a=this.m.get(l);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.m.get(f):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$me(this.Z.token);try{const f=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,C.$Hb)(d||[]),a=await Promise.all((0,C.$Hb)(l).map(m=>this.f.getTreeItem(m)));if(t.token.isCancellationRequested)return;const h=a.map((m,D)=>m?this.db(l[D],m,f):null);return(0,C.$Hb)(h)}finally{t.dispose()}}$(s){if(s.some(f=>!f))return this.Z.dispose(!0),this.Z=new v.$me,this.tb(),this.J.$refresh(this.I);{const f=this.ab(s);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(s){const t=new Set,f=s.map(l=>this.m.get(l));for(const l of f)if(l&&!t.has(l.item.handle)){let a=l;for(;a&&a.parent&&f.findIndex(h=>a&&a.parent&&h&&h.item.handle===a.parent.item.handle)===-1;){const h=this.j.get(a.parent.item.handle);a=h?this.m.get(h):void 0}a&&!a.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const a=this.j.get(l);if(a){const h=this.m.get(a);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(s){const t={};return Promise.all(s.map(f=>this.cb(f).then(d=>{d&&(t[f]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,b.$ih)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,f.parent);return this.pb(t,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}db(s,t,f){const d=this.ib(s,t,f);if(t.id&&this.j.has(d.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,f),d}eb(s){return S.$gN.isMarkdownString(s)?$.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,f,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:d}}hb(s){if(!S.$EN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,f){this.hb(t);const d=this.B(new M.$Tc),l=this.kb(s,t,f),a=this.lb(t);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,A.$ag)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof S.$NN?s.iconPath:void 0}kb(s,{id:t,label:f,resourceUri:d},l,a){if(t)return`${i.b}/${t}`;const h=o(f,this.N),m=l?l.item.handle:i.a;let D=h?h.label:d?(0,N.$1g)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const p=this.m.has(s)?this.m.get(s).item.handle:void 0,E=this.X(l)||[];let y,P=0;do{if(y=`${m}/${P}:${D}`,a||!this.j.has(y)||p===y)break;P++}while(P<=E.length);return y}lb(s){if(s.iconPath&&!(s.iconPath instanceof S.$NN))return typeof s.iconPath=="string"||L.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof S.$NN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return L.URI.isUri(s)?s:L.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,f,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(s,t);const l=this.X(d)||[],a=l.filter(h=>h.item.handle===f.item.handle)[0];a&&l.splice(l.indexOf(a),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[358],Ee([1,0,4,3,2,30,16,92,6,7]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class A extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,c,g,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$be),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=c,this.#n=g,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!c})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Uc{static c(){return(0,R.$Mg)()}constructor(v,c,g){super(),this.j=c,this.m=g,this.g=new Map,this.h=new Map,this.f=v.getProxy(b.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,c,g,o,n={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,w.$vkc)(v),t=C.c();this.f.$createWebviewPanel((0,w.$xkc)(v),t,c,{title:g,panelOptions:$(n),webviewOptions:(0,w.$ykc)(v,this.m,n),serializeBuffersForPostMessage:s},r);const f=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,c,g,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(v){const c=Object.keys(v);c.sort((g,o)=>{const n=v[g],i=v[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const g of c){const o=this.getWebviewPanel(g);if(!o)continue;const n=v[g];o._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,c,g){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:g,extension:v}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,w.$vkc)(v)}),new S.$RM(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(v,c,g,o){const n=this.h.get(c);if(!n)throw new Error(`No serializer found for '${c}'`);const{serializer:i,extension:r}=n,s=this.j.createNewWebview(v,g.webviewOptions,r),t=this.createNewWebviewPanel(v,c,g.title,o,g.panelOptions,s,g.active);await i.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(v,c,g,o,n,i,r){const s=new A(v,this.f,i,{viewType:c,title:g,viewColumn:o,panelOptions:n,active:r});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$zkc=C;function $(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(ke[359],Ee([1,0,4,3,92,16,6,7]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class b extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,$,k,v,c,g){super(),this.#s=!1,this.#u=this.B(new u.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$be),this.onDidDispose=this.#l.event,this.#i=k,this.#a=v,this.#e=C,this.#t=$,this.#n=c,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(C,$){this.d=$,this.b=new Map,this.c=new Map,this.a=C.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(C,$,k,v){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:k,extension:C}),this.a.$registerWebviewViewProvider((0,L.$xkc)(C),$,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$vkc)(C)}),new w.$RM(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(C,$,k,v,c){const g=this.b.get($);if(!g)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:n}=g,i=this.d.createNewWebview(C,{},n),r=new b(C,this.a,$,k,i,!0);this.c.set(C,r),await o.resolveWebviewView(r,{state:v},c)}async $onDidChangeWebviewViewVisibility(C,$){this.e(C)._setVisible($)}async $disposeWebviewView(C){const $=this.e(C);this.c.delete(C),$.dispose(),this.d.deleteWebview(C)}e(C){const $=this.c.get(C);if(!$)throw new Error("No webview found");return $}}e.$7lc=S}),define(ke[360],Ee([1,0,69,15,12,260,32,11]),function(le,e,u,N,L,R,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;let b=class{constructor(C,$){C.addFileSystemProvider(N.Schemas.file,new S($),{isCaseSensitive:w.$k})}};e.$Lmc=b,e.$Lmc=b=Je([qe(0,u.$rkc),qe(1,L.$Wj)],b);class S{constructor(C){this.b=C,this.a=new R.$4q(this.b)}async stat(C){const $=await this.a.stat(C);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,$,k){return this.a.writeFile(C,$,{...k,unlock:!1,atomic:!1})}delete(C,$){return this.a.delete(C,{...$,useTrash:!1,atomic:!1})}rename(C,$,k){return this.a.rename(C,$,k)}copy(C,$,k){return this.a.copy(C,$,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,$){throw new Error("Method not implemented.")}}}),define(ke[361],Ee([1,0,17,64,30,33,3,6,2,20]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;let A=class extends M.$Uc{constructor($,k){super();const v=$.getProxy(w.$PM.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async c=>{const g=b.URI.file((0,u.$kc)((0,N.tmpdir)(),(0,L.$Mg)()));return await v.$download(c,g),g})}};e.$Jmc=A,e.$Jmc=A=Je([qe(0,S.$aP),qe(1,R.$wP)],A)}),define(ke[362],Ee([1,0,52,17,2,93,3,15,8,31]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class A extends R.$tkc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==w.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const d=f.fsPath;let l=0;do{let a;l===0?a=d:a=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await C(a);const h=N.$kc(a,"vscode.lock"),m=await c(this.d,h,!1);if(m)return this.i=m,process.on("exit",()=>{m.dispose()}),L.URI.file(a);l++}while(l<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Vmc=A;async function C(s){try{await S.Promises.stat(s);return}catch{}try{await S.Promises.mkdir(s,{recursive:!0})}catch{}}const $=1e3,k=10*60*1e3;class v extends M.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new b.$Bh),this.a.cancelAndSet(async()=>{const d=await g(t,f);(!d||d.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(f,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${f}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function c(s,t,f){try{const l={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const d=await g(s,t);return!d||d.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function g(s,t){let f;try{f=await S.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(f))}catch(d){return s.error(d),null}}async function o(s,t){let f;try{f=await S.Promises.stat(t)}catch(d){return s.error(d),0}return f.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const f=await g(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let m=f.willReleaseAt-Date.now();if(m<5e3){for(m>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${m} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);m>0;){if(await(0,b.$rh)(Math.min(100,m)),await o(s,t)===0)return r(s,t);m=f.willReleaseAt-Date.now()}return r(s,t)}}if(!n(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const d=await o(s,t),l=Date.now()-d;if(l<=k)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,b.$rh)(2e3);const a=await o(s,t),h=Date.now()-a;return h<=k?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return c(s,t,!0)}}),define(ke[363],Ee([1,0,30,20,42,33]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;let M=class extends L.$Pkc{constructor(b,S){super(!0,b,S)}createTerminal(b,S,A){return this.createTerminalFromOptions({name:b,shellPath:S,shellArgs:A})}createTerminalFromOptions(b,S){const A=new L.$Okc(this.a,(0,u.$Mg)(),b,b.name);return this.f.push(A),A.create(b,this.R(b,S)),A.value}};e.$emc=M,e.$emc=M=Je([qe(0,R.$wP),qe(1,N.$aP)],M)}),define(ke[364],Ee([1,0,4,38,37,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new L.$Hj("inOutput",!1),e.$5L=new L.$Hj("activeLogOutput",!1),e.$6L=new L.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new L.$Hj("activeLogOutput.level",""),e.$8L=new L.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new L.$Hj("outputView.scrollLock",!1),e.$0L=(0,R.$qi)("outputService");var M;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new u.$be,this.onDidRegisterChannel=this.b.event,this.c=new u.$be,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(A=>S.push(A)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}N.$9n.add(e.$$L.OutputChannels,new w),e.$_L=new L.$Hj("activeOutputChannel","")}),define(ke[157],Ee([1,0,6,5,20,25,12,364,69,28,60,189,21,18,32,4,3]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=void 0;class o extends M.$3j{get disposed(){return this.n}constructor(s,t,f,d,l){super(),this.id=s,this.name=t,this.r=f,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=$.$Ce.fromString(t).byteLength,(0,M.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,f,d,l,a){this.i=t,this.j=f,this.k=d,this.l=l,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(u.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,k.$4f)(t)?t:void 0;if((0,k.$4f)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const h=this.i.environment.extensionLogLevel?.find(([D])=>R.$Lm.equals(f.identifier,D))?.[1];h&&(a=(0,M.$bk)(h));const m=d?this.o(s,a,f):this.n(s,l,f);return m.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(s,a??this.m.getLevel(),m):this.q(s,m)}async n(s,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(s,l,t,f.identifier.value);return new o(h,s,a,this.a,f)}async o(s,t,f){const d=await this.p(f),l=s.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(d,`${l}.log`),h=`${f.identifier.value}.${l}`,m=this.l.createLogger(a,{id:h,name:s,logLevel:t,extensionId:f.identifier.value});return new n(h,s,m,this.a,f)}p(s){let t=this.d.get(s.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(d){if((0,v.$al)(d)!==v.FileSystemProviderErrorCode.FileExists)throw d}return f})())}return t}q(s,t){let f=!1;const d=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),t.then(a=>a.append(l))},appendLine(l){d(),t.then(a=>a.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(a=>a.replace(l))},show(l,a){d(),t.then(h=>h.show(l,a))},hide(){d(),t.then(l=>l.hide())},dispose(){f=!0,t.then(l=>l.dispose())}}}r(s,t,f){const d=new g.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},a=d.add(new c.$be);function h(m){t=m,a.fire(m)}return f.then(m=>{d.add(m),m.logLevel!==t&&h(m.logLevel),d.add(m.onDidChangeLogLevel(D=>h(D)))}),{...this.q(s,f),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(m,...D){l(),f.then(p=>p.trace(m,...D))},debug(m,...D){l(),f.then(p=>p.debug(m,...D))},info(m,...D){l(),f.then(p=>p.info(m,...D))},warn(m,...D){l(),f.then(p=>p.warn(m,...D))},error(m,...D){l(),f.then(p=>p.error(m,...D))},dispose(){d.dispose()}}}};e.$Flc=i,e.$Flc=i=Je([qe(0,L.$aP),qe(1,S.$qP),qe(2,b.$rkc),qe(3,A.$7jc),qe(4,M.$Xj),qe(5,M.$Wj)],i),e.$Glc=(0,N.$qi)("IExtHostOutputService")}),define(ke[158],Ee([1,0,5,8]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,u.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let w=0;w<this.maxSampleCount;w++){const b=await L.getRoundTripTime();if(b===void 0)return;R=Math.min(R,b/2),await(0,N.$rh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((w,b)=>w+b,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((w,b)=>w+b,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[365],Ee([1,0,232,85,38,41,54,3,4,158,11,24,8]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class k{constructor(){this.migrations=[],this.a=new b.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new k;L.$9n.add(e.$uJ.ConfigurationMigration,v);let c=class extends w.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const d=r[t];if(!d)continue;const l=[];if(d.value!==void 0){const a=await this.h(n,t,d.value,i,void 0);for(const h of a??[])l.push([h,[]])}for(const{identifiers:a,value:h}of d.overrides??[])if(h!==void 0){const m=await this.h(n,t,h,i,a);for(const D of m??[])l.push([D,a])}l.length&&await Promise.allSettled(l.map(async([[a,h],m])=>this.a.updateValue(a,h.value,{resource:i,overrideIdentifiers:m},f)))}}async h(n,i,r,s,t){const f=l=>{const h=this.a.inspect(l,{resource:s})[i];if(h)return t?h.overrides?.find(({identifiers:m})=>(0,C.$1n)(m,t))?.value:h.value},d=await n.migrateFn(r,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$vJ=c,e.$vJ=c=Je([qe(0,M.$Wi),qe(1,R.$zi)],c);let g=class extends w.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new $.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$9n.as(N.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$wJ=g,e.$wJ=g=Je([qe(0,S.$an)],g)}),define(ke[366],Ee([1,0,35,15,17,23,242,365,85,5,38]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kgb=e.$jgb=void 0,e.$lgb=c,e.$mgb=g,e.$jgb=(0,S.$qi)("editorResolverService"),e.$kgb="workbench.editorAssociations";const C=A.$9n.as(b.$bo.Configuration),$={...w.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration($);var k;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(k||(e.RegisteredEditorPriority=k={}));var v;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function c(o){switch(o){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function g(o,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(L.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$1g)(n);return u.$jk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(ke[367],Ee([1,0,34,15,17,11,23,2,5,278,41,147,158]),function(le,e,u,N,L,R,M,w,b,S,A,C,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,b.$qi)("pathService");let v=k=class{constructor(g,o,n,i){this.d=g,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??g})()}hasValidBasename(g,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(g,i,o)):this.h(g,o,n)}h(g,o,n){return g.scheme===N.Schemas.file||g.scheme===N.Schemas.vscodeRemote?(0,u.$og)(n??(0,M.$1g)(g),o===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,o){if(g.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,S.$oM)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:N.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?L.$gc:L.$hc)}async fileURI(g){let o="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const i=g.indexOf("/",2);i===-1?(o=g.substring(2),g="/"):(o=g.substring(2,i),g=g.substring(i)||"/")}return w.URI.from({scheme:N.Schemas.file,authority:o,path:g,query:"",fragment:""})}};e.$sM=v,e.$sM=v=k=Je([qe(1,$.$an),qe(2,C.$aM),qe(3,A.$zi)],v)}),define(ke[368],Ee([1,0,244,19,55,4,56,3,2,54,249,12,66,280,88,41,147,26,22,18,24,37]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.OnPortForward=e.$fM=e.$eM=e.TunnelSource=e.TunnelCloseReason=e.$cM=e.$bM=void 0,e.$dM=a,e.$gM=D,e.$hM=p,e.$iM=E,e.$jM=P;const t=10*1e3,f="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$bM="onTunnel",e.$cM=new s.$Hj("forwardedPortsViewEnabled",!1,u.localize(0,null));function a(F){const z=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var h;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var m;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(m||(e.TunnelSource=m={})),e.$eM={source:m.User,description:u.localize(1,null)},e.$fM={source:m.Auto,description:u.localize(2,null)};function D(F,z,O){const T=F.get(E(z,O));if(T)return T;if((0,v.$$v)(z))for(const B of v.$0v){const W=E(B,O);if(F.has(W))return F.get(W)}else if((0,v.$aw)(z))for(const B of v.$_v){const W=E(B,O);if(F.has(W))return F.get(W)}}function p(F,z,O){const T=D(F,z,O);if(T)return T;const B=(0,v.$aw)(z)?"localhost":(0,v.$$v)(z)?"0.0.0.0":void 0;if(B)return D(F,B,O)}function E(F,z){return F+":"+z}var y;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(y||(e.OnPortForward=y={}));function P(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class I extends w.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$be,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,T){let B=this.w(z,O,T,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const X=this.j[B];X.key===z?(W.onAutoForward=X.onAutoForward??W.onAutoForward,W.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:W.elevateIfNeeded,W.label=X.label??W.label,W.requireLocalPort=X.requireLocalPort,W.protocol=X.protocol):(W.onAutoForward=W.onAutoForward??X.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:X.elevateIfNeeded,W.label=W.label??X.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??X.protocol),B=this.w(z,O,T,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$4f)(z.host)&&(0,i.$8f)(z.port)}w(z,O,T,B,W){if(W>=B.length)return-1;const X=!(0,v.$$v)(O)&&!(0,v.$aw)(O),Z=B.slice(W).findIndex(Y=>(0,i.$8f)(Y.key)?X?!1:Y.key===z:this.t(Y.key)?X?!1:z>=Y.key.start&&z<=Y.key.end:this.u(Y.key)?z===Y.key.port&&O===Y.key.host:T?Y.key.test(T):!1);return Z>=0?Z+W:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,i.$6f)(z))return[];const O=[];for(const B in z){if(B===void 0)continue;const W=z[B];let X;if(Number(B))X=Number(B);else if((0,i.$4f)(B))if(I.g.test(B)){const x=B.match(I.g);X={start:Number(x[1]),end:Number(x[2])}}else if(I.h.test(B)){const x=B.match(I.h);X={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(B)}catch{}x&&(X=x)}X&&O.push({key:X,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(O)}z(z){function O(T,B){return(0,i.$8f)(T.key)?T.key:B.t(T.key)?T.key.start:B.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,B)=>O(T,this)-O(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case v.ProvidedOnAutoForward.Notify:return y.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case v.ProvidedOnAutoForward.Silent:return y.Silent;case v.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(z,O,T){const W=this.r.inspect(I.c).userRemoteValue;let X;!W||!(0,i.$6f)(W)?X={}:X=(0,r.$Wn)(W),X[`${z}`]||(X[`${z}`]={});for(const x in O)X[`${z}`][x]=O[x];return this.r.updateValue(I.c,X,T)}}e.$kM=I;let j=class extends w.$Uc{constructor(z,O,T,B,W,X,x,Z,Y,ce){super(),this.H=z,this.I=O,this.J=T,this.L=B,this.M=W,this.N=X,this.O=x,this.P=Z,this.Q=Y,this.R=ce,this.c=new Map,this.g=new R.$be,this.onForwardPort=this.g.event,this.h=new R.$be,this.onClosePort=this.h.event,this.j=new R.$be,this.onPortName=this.j.event,this.n=new R.$be,this.onCandidatesChanged=this.n.event,this.t=new R.$be,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$be,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const $e=await this.getAttributes(ne.map(Pe=>({port:Pe.tunnelRemotePort,host:Pe.tunnelRemoteHost})));for(const Pe of ne)if(Pe.localAddress){const _=E(Pe.tunnelRemoteHost,Pe.tunnelRemotePort),U=p(this.m??new Map,Pe.tunnelRemoteHost,Pe.tunnelRemotePort);this.forwarded.set(_,{remotePort:Pe.tunnelRemotePort,remoteHost:Pe.tunnelRemoteHost,localAddress:Pe.localAddress,protocol:$e?.get(Pe.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Pe.localAddress,$e?.get(Pe.tunnelRemotePort)),localPort:Pe.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:Pe.privacy,source:e.$eM}),this.f.set(_,Pe)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const $e=E(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!p(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!p(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!p(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const Pe=p(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),_=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set($e,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:_?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,_),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:Pe?.detail,hasRunningProcess:!!Pe,pid:Pe?.pid,privacy:ne.privacy,source:e.$eM})}await this.cb(),this.f.set($e,ne),this.g.fire(this.forwarded.get($e))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,h.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$bM))?(this.R.createKey(e.$cM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const T=E(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return b.URI.parse(z);const T=O?.protocol??"http";return b.URI.parse(`${T}://${z}`)}async Y(z){const O=this.N.getWorkspace(),T=O.configuration?(0,M.$ej)(O.configuration.path):O.folders.length>0?(0,M.$ej)(O.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(f)}async $(){return this.Y(d)}async ab(){const z=this.I.get(f,1);if(z)return this.I.remove(f,1),await this.cb(),z;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(T=>T.remotePort).join(", ")}`);for(const T of O){const B=p(this.detected,T.remoteHost,T.remotePort);T.source.source!==m.Extension&&!B||T.source.source===m.Extension&&B?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===m.Extension&&!B&&this.D.set(E(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new w.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(O=>O.startsWith(d));for(const O of z){const T=this.I.getNumber(O,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(d,f);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),O=z.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let T;z.length>0&&(T=JSON.stringify(O));const B=await this.Z(),W=await this.$();!T&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):T!==this.y&&B&&W&&(this.I.store(B,T,0,0),this.I.store(W,Date.now()+l,0,0)),this.y=T}}async eb(z,O,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=u.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(W)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(z,O)}async fb(z,O){await this.Q.activateByEvent(e.$bM);const T=p(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let W;if(T)return this.hb(T,z,O);{const X=this.L.remoteAuthority,x=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,Z=E(z.remote.host,z.remote.port);this.c.set(Z,!0),z=this.gb(Z,z);const Y=await this.H.openTunnel(x,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof Y=="string")W=Y;else if(Y&&Y.localAddress){const ce=p(this.m??new Map,z.remote.host,z.remote.port),ne=Y.protocol?Y.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:O?.protocol??v.TunnelProtocol.Http,$e={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:Y.localAddress,protocol:ne,localUri:await this.X(Y.localAddress,O),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:z.source??e.$eM,privacy:Y.privacy};return this.forwarded.set(Z,$e),this.f.set(Z,Y),this.c.delete(Z),await this.cb(),await this.eb(Y,B,O),this.g.fire($e),Y}this.c.delete(Z)}return W}gb(z,O){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const B=T.get(z);T.delete(z),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(z,O,T){const B=T?.label??O.name;let W;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(W||(W={}));let X=W.None;switch(B!==z.name&&(z.name=B,X=W.Fire),(T?.protocol||z.protocol!==v.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(O.source=z.source,X=W.Reopen),O.privacy&&z.privacy!==O.privacy&&(X=W.Reopen),X){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(z.remoteHost,z.remotePort,h.User),await this.fb(O,T)}return p(this.f,O.remote.host,O.remote.port)}async name(z,O,T){const B=p(this.forwarded,z,O),W=E(z,O);if(B){B.name=T,await this.cb(),this.j.fire({host:z,port:O});return}else this.detected.has(W)&&(this.detected.get(W).name=T,this.j.fire({host:z,port:O}))}async close(z,O,T){const B=E(z,O),W=this.forwarded.get(B);return T===h.AutoForwardEnd&&W&&W.source.source===m.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},T)}address(z,O){const T=E(z,O);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const T=p(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:E(O.localAddress.host,O.localAddress.port);this.detected.set(E(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:m.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const T=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(B=>B.port).join(", ")}`),this.n.fire(T)}ib(z){const O=this.m??new Map,T=new Map;return this.m=T,z.forEach(B=>{const W=E(B.host,B.port);T.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(W)&&O.delete(W);const X=p(this.forwarded,B.host,B.port);X&&(X.runningProcess=B.detail,X.hasRunningProcess=!0,X.pid=B.pid)}),O.forEach((B,W)=>{const X=a(W);if(!X)return;const x=p(this.forwarded,X.host,X.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const Z=p(this.detected,X.host,X.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(O)for(const T of z){const B=O.get(T.remotePort);(B?.protocol||T.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},B),B&&B.label&&B.label!==T.name&&await this.name(T.remoteHost,T.remotePort,B.label)}}async getAttributes(z,O=!0){const T=new Map,B=new Map;z.forEach(Y=>{const ce=p(this.m??new Map,v.$0v[0],Y.port)??Y;if(ce){T.set(Y.port,ce);const ne=P(ce)?ce.pid:void 0;B.has(ne)||B.set(ne,[]),B.get(ne)?.push(Y.port)}});const W=new Map;if(z.forEach(Y=>{const ce=this.configPortsAttributes.getAttributes(Y.port,Y.host,T.get(Y.port)?.detail);ce&&W.set(Y.port,ce)}),this.G.length===0||!O)return W.size>0?W:void 0;const X=await Promise.all((0,N.$Rb)(this.G.map(Y=>Array.from(B.entries()).map(ce=>{const ne=ce[1],$e=T.get(ne[0]);return Y.providePortAttributes(ne,$e?.pid,$e?.detail,n.CancellationToken.None)})))),x=new Map;if(X.forEach(Y=>Y.forEach(ce=>{ce&&x.set(ce.port,ce)})),!W&&!x)return;const Z=new Map;return z.forEach(Y=>{const ce=W.get(Y.port),ne=x.get(Y.port);Z.set(Y.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??I.providedActionToAction(ne?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),Z}addAttributesProvider(z){this.G.push(z)}};e.$lM=j,Je([(0,L.$Vh)(1e3)],j.prototype,"cb",null),e.$lM=j=Je([qe(0,v.$5v),qe(1,k.$Up),qe(2,S.$Wi),qe(3,g.$aM),qe(4,$.$Bl),qe(5,c.$zi),qe(6,C.$Wj),qe(7,A.$yw),qe(8,o.$uG),qe(9,s.$Ij)],j)}),define(ke[94],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class u{constructor(M,w){this.line=M,this.character=w}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,w){return new u(0,0)}with(M){return new u(0,0)}}e.$WK=u;class N{constructor(M,w,b,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(M,w),this.end=new u(b,S)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$XK=N;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,8]),function(le,e,u,N,L,R,M,w,b,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=o,e.$6K=n,e.$7K=i,e.$_K=m,e.$aL=D,e.$cL=y,e.$dL=P,e.$eL=I,e.$fL=j,e.$gL=F,e.$hL=z,e.$jL=T,e.$lL=X,e.$mL=x,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const $="\u27EA ",k=" characters skipped \u27EB",v=($.length+k.length+5)*2;e.$4K=(0,w.$qi)("searchService");var c;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var g;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})(g||(e.QueryType=g={}));function o(Y){return!!Y.preview}function n(Y){return!!Y.resource}function i(Y){return!!Y.message}var r;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(ce){this.resource=ce,this.results=[]}}e.$8K=s;class t{constructor(ce,ne,$e,Pe){this.ranges=ne,this.webviewIndex=Pe;const _=Array.isArray(ne)?ne:[ne];if($e&&$e.matchLines===1&&f(_)){ce=(0,M.$Wf)(ce,$e.matchLines);let U="",ie=0,be=0;const Ce=Math.floor($e.charsPerLine/5),oe=[];for(const ae of _){const re=Math.max(ae.startColumn-Ce,0),G=ae.startColumn+$e.charsPerLine;if(re>be+Ce+v){const te=$+(re-be)+k;U+=te+ce.slice(re,G),ie+=re-(be+te.length)}else U+=ce.slice(be,G);oe.push(new l(0,ae.startColumn-ie,ae.endColumn-ie)),be=G}this.preview={text:U,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const U=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:ce,matches:(0,u.$2b)(ne,ie=>new d(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$9K=t;function f(Y){const ce=Y[0].startLineNumber;for(const ne of Y)if(ne.startLineNumber!==ce||ne.endLineNumber!==ce)return!1;return!0}class d{constructor(ce,ne,$e,Pe){this.startLineNumber=ce,this.startColumn=ne,this.endLineNumber=$e,this.endColumn=Pe}}e.$0K=d;class l extends d{constructor(ce,ne,$e){super(ce,ne,ce,$e)}}e.$$K=l;var a;(function(Y){Y.List="list",Y.Tree="tree"})(a||(e.ViewMode=a={}));var h;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function m(Y,ce=!0){const ne=Y&&Y.files&&Y.files.exclude,$e=ce&&Y&&Y.search&&Y.search.exclude;if(!ne&&!$e)return;if(!ne||!$e)return ne||$e;let Pe=Object.create(null);return Pe=L.$Zn(Pe,L.$Wn(ne)),Pe=L.$Zn(Pe,L.$Wn($e),!0),Pe}function D(Y,ce){return Y.excludePattern&&N.$jk(Y.excludePattern,ce)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&N.$jk(Y.includePattern,ce)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ne=>{const $e=ne.folder.fsPath;if(R.$qg(ce,$e)){const Pe=b.$mc($e,ce);return!ne.includePattern||!!N.$jk(ne.includePattern,Pe)}else return!1}):!1:!0}var p;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class E extends Error{constructor(ce,ne){super(ce),this.code=ne}}e.$bL=E;function y(Y){const ce=Y.message;if((0,S.$4)(Y))return new E(ce,p.canceled);try{const ne=JSON.parse(ce);return new E(ne.message,ne.code)}catch{return new E(ce,p.other)}}function P(Y){const ce={message:Y.message,code:Y.code};return new Error(JSON.stringify(ce))}function I(Y){return Y.type==="error"?!0:Y.type==="success"}function j(Y){return Y.type==="success"}function F(Y){return!!Y.path}function z(Y,ce,ne=!0){const $e=Y.searchPath?Y.searchPath:Y.relativePath;return ne?(0,M.$Tf)($e,ce):N.$jk(ce,$e)}class O{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=O;function T(Y,ce){const ne={...Y||{},...ce||{}};return Object.keys(ne).filter($e=>{const Pe=ne[$e];return typeof Pe=="boolean"&&Pe})}class B{constructor(ce,ne){this.c=null,this.a={...ce.excludePattern||{},...ne.excludePattern||{}},this.b=N.$kk(this.a);let $e=ce.includePattern;ne.includePattern&&($e?$e={...$e,...ne.includePattern}:$e=ne.includePattern),$e&&(this.c=N.$kk($e))}matchesExcludesSync(ce,ne,$e){return!!(this.b&&this.b(ce,ne,$e))}includedInQuerySync(ce,ne,$e){return!(this.b&&this.b(ce,ne,$e)||this.c&&!this.c(ce,ne,$e))}includedInQuery(ce,ne,$e){const Pe=this.b(ce,ne,$e),_=()=>this.c?!!this.c(ce,ne,$e):!0;return(0,C.$ch)(Pe)?Pe.then(U=>U?!1:_()):_()}hasSiblingExcludeClauses(){return W(this.a)}}e.$kL=B;function W(Y){for(const ce in Y)if(typeof Y[ce]!="boolean")return!0;return!1}function X(Y){if(!Y)return;let ce;return ne=>(ce||(ce=(Y()||Promise.resolve([])).then($e=>$e?Z($e):{})),ce.then($e=>!!$e[ne]))}function x(Y){if(!Y)return;let ce;return ne=>{if(!ce){const $e=Y();ce=$e?Z($e):{}}return!!ce[ne]}}function Z(Y){const ce={};for(const ne of Y)ce[ne]=!0;return ce}}),define(ke[43],Ee([1,0,19,8,22,4,3,77,15,125,23,14,2,230,5,12,263,41,60,28,20,16,7,67,36,6,58]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f,d,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=e.$lkc=void 0;function h(j,F,z){return new A.$Sg(O=>E(O,z)).isEqual(j,F)}function m(j,F,z){return h(j.uri,F.uri,z)?0:(0,C.$mf)(j.uri.toString(),F.uri.toString())}function D(j,F,z){return j.index!==F.index?j.index<F.index?-1:1:h(j.uri,F.uri,z)?(0,C.$mf)(j.name,F.name):(0,C.$mf)(j.uri.toString(),F.uri.toString())}function p(j,F,z,O){const T=j.slice(0).sort((W,X)=>z(W,X,O)),B=F.slice(0).sort((W,X)=>z(W,X,O));return(0,u.$Eb)(T,B,(W,X)=>z(W,X,O))}function E(j,F){const z=F.getCapabilities(j.scheme);return!(z&&z&1024)}class y extends o.$Ji{static toExtHostWorkspace(F,z,O,T){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:X,configuration:x,transient:Z,isUntitled:Y}=F,ce=[],ne=z;z?X.forEach((U,ie)=>{const be=$.URI.revive(U.uri),Ce=y.o(O||z,be,T);Ce?(Ce.name=U.name,Ce.index=U.index,ce.push(Ce)):ce.push({uri:be,name:U.name,index:ie})}):ce.push(...X.map(({uri:U,name:ie,index:be})=>({uri:$.URI.revive(U),name:ie,index:be}))),ce.sort((U,ie)=>U.index<ie.index?-1:1);const $e=new y(B,W,ce,!!Z,x?$.URI.revive(x):null,!!Y,U=>E(U,T)),{added:Pe,removed:_}=p(ne?ne.workspaceFolders:[],$e.workspaceFolders,m,T);return{workspace:$e,added:Pe,removed:_}}static o(F,z,O){for(let T=0;T<F.folders.length;T++){const B=F.workspaceFolders[T];if(h(B.uri,z,O))return B}}constructor(F,z,O,T,B,W,X){super(F,O.map(x=>new o.$Ki(x)),T,B,X),this.t=z,this.u=W,this.q=[],this.s=w.$wi.forUris(X),O.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,z){return z&&this.s.get(F)&&(F=(0,A.$3g)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let P=class{constructor(F,z,O,T,B){this.c=new R.$be,this.onDidChangeWorkspace=this.c.event,this.g=new R.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$de,this.C=new Map,this.h=T,this.s=O,this.t=B,this.j=new S.$xm,this.k=new N.$ph,this.o=F.getProxy(l.$PM.MainThreadWorkspace),this.q=F.getProxy(l.$PM.MainThreadMessageService);const W=z.workspace;this.l=W?new y(W.id,W.name,[],!!W.transient,W.configuration?$.URI.revive(W.configuration):null,!!W.isUntitled,X=>E(X,O)):void 0}$initializeWorkspace(F,z){this.v=z,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:b.Schemas.untitled,path:(0,A.$1g)((0,A.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,z,O,...T){const B=[];if(Array.isArray(T)&&T.forEach(Y=>{$.URI.isUri(Y.uri)&&!B.some(ce=>h(ce.uri,Y.uri,this.s))&&B.push({uri:Y.uri,name:Y.name||(0,A.$Zg)(Y.uri)})}),this.n||[z,O].some(Y=>typeof Y!="number"||Y<0)||O===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(z+O>W.length)return!1;const X=W.slice(0);X.splice(z,O,...B.map(Y=>({uri:Y.uri,name:Y.name||(0,A.$Zg)(Y.uri),index:void 0})));for(let Y=0;Y<X.length;Y++){const ce=X[Y];if(X.some((ne,$e)=>$e!==Y&&h(ce.uri,ne.uri,this.s)))return!1}X.forEach((Y,ce)=>Y.index=ce);const{added:x,removed:Z}=p(W,X,D,this.s);if(x.length===0&&Z.length===0)return!1;if(this.o){const Y=F.displayName||F.name;this.o.$updateWorkspaceFolders(Y,z,O,B).then(void 0,ce=>{this.n=void 0;const ne={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(g.Severity.Error,(0,k.localize)(0,null,Y,ce.toString()),ne,[])})}return this.y(X),!0}getWorkspaceFolder(F,z){if(this.x)return this.x.getWorkspaceFolder(F,z)}async getWorkspaceFolder2(F,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,z)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,z){let O,T="";if(typeof F=="string"?(O=$.URI.file(F),T=F):typeof F<"u"&&(O=F,T=F.fsPath),!O)return T;const B=this.getWorkspaceFolder(O,!0);if(!B)return T;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let W=(0,A.$6g)(B.uri,O);return z&&B.name&&(W=`${B.name}/${W}`),W}y(F){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:z,added:O,removed:T}=y.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:T}))}findFiles(F,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let W="",X=!0;return z===null?X=!1:z!==void 0&&(typeof z=="string"?W=z:W=z.pattern),this.z(F,void 0,{exclude:W,maxResults:O,useDefaultExcludes:X,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(F,z={},O,T=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,F,z,T)}async z(F,z,O,T=L.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,W={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let X;if(F){const{includePattern:x,folder:Z}=I(s.GlobPattern.from(F));X=Z,W.includePattern=x}else{const{includePattern:x,folder:Z}=I(s.GlobPattern.from(z));X=Z,W.filePattern=x}return this.o.$startFileSearch(X??null,W,T).then(x=>Array.isArray(x)?x.map(Z=>$.URI.revive(Z)):[])}async findTextInFiles(F,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),X=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:x,folder:Z}=I(s.GlobPattern.from(z.include)),Y=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ce={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:X,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:x,excludePattern:Y},ne=!1;if(this.u[W]=$e=>{if(ne)return;const Pe=$.URI.revive($e.resource);$e.results.forEach(_=>{const U=(0,a.$Zh)(_);(0,d.$5K)(U)?O({uri:Pe,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ie=>new t.$TM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,u.$2b)(U.ranges,ie=>new t.$TM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):O({uri:Pe,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(F,Z??null,ce,W,B);return delete this.u[W],$e||{}}catch($e){throw delete this.u[W],$e}}$handleTextSearchResult(F,z){this.u[z]?.(F)}async save(F){const z=await this.o.$save(F,{saveAs:!1});return $.URI.revive(z)}async saveAs(F){const z=await this.o.$save(F,{saveAs:!0});return $.URI.revive(z)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,z){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,z);const O=this.t.transformOutgoingScheme(F),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,O),(0,M.$Sc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(F,z){this.h.info("Getting edit session identifier for workspaceFolder",F);const O=await this.resolveWorkspaceFolder($.URI.revive(F));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const T=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!T),!T)return;const B=await T.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(F,z,O,T){this.h.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder($.URI.revive(F));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const X=await W.provideEditSessionIdentityMatch?.(z,O,T);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(F){return(z,O,T)=>{const B=function(X){z.call(O,X)};return B.extension=F,this.B.event(B,void 0,T)}}async $onWillCreateEditSessionIdentity(F,z,O){const T=await this.resolveWorkspaceFolder($.URI.revive(F));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},z,async(B,W)=>{const X=Date.now();await Promise.resolve(B),Date.now()-X>O&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(F,z){if(this.C.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.C.set(F,z);const O=this.t.transformOutgoingScheme(F),T=this.A++;return this.o.$registerCanonicalUriProvider(T,O),(0,M.$Sc)(()=>{this.C.delete(F),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(F,z,O){const T=this.C.get(F.scheme);if(!T)return;const B=await T.provideCanonicalUri?.($.URI.revive(F),z,O);if(B)return B}async $provideCanonicalUri(F,z,O){return this.provideCanonicalUri($.URI.revive(F),{targetScheme:z},O)}};e.$lkc=P,e.$lkc=P=Je([qe(0,r.$aP),qe(1,i.$qP),qe(2,n.$7jc),qe(3,c.$Wj),qe(4,f.$jkc)],P),e.$mkc=(0,v.$qi)("IExtHostWorkspace");function I(j){let F,z;return j&&(typeof j=="string"?F=j:(F=j.pattern,z=$.URI.revive(j.baseUri))),{includePattern:F,folder:z}}}),define(ke[44],Ee([1,0,24,4,43,6,7,265,85,18,8,5,20,12,2]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=e.$okc=e.$nkc=void 0;function c(f,d){if(d){const l=d.split(".");let a=f;for(let h=0;a&&h<l.length;h++)a=a[l[h]];return a}}function g(f){return f instanceof v.URI}function o(f){return f&&f.uri instanceof v.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof v.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(g(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(d,l,a){this.a=d.getProxy(R.$PM.MainThreadConfiguration),this.c=l,this.b=a,this.d=new A.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(d,l))}};e.$nkc=s,e.$nkc=s=Je([qe(0,$.$aP),qe(1,L.$mkc),qe(2,k.$Wj)],s);class t{constructor(d,l,a,h){this.a=new N.$be,this.b=d,this.f=h,this.c=l,this.e=w.$uo.parse(a,h),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$uo.parse(d,this.f),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,a))}getConfiguration(d,l,a){const h=r(l)||{},m=this.g(d?c(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,a?.identifier);function D(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(E){return typeof c(m,E)<"u"},get:(E,y)=>{this.h(d?`${d}.${E}`:E,h,a?.identifier);let P=c(m,E);if(typeof P>"u")P=y;else{let I;const j=(F,z)=>{if((0,S.$6f)(F)){let O;const T=()=>{I=I||(0,u.$Wn)(m),O=O||c(I,z)};return new Proxy(F,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return T(),()=>O;if(I)return O=O||c(I,z),O[W];const X=B[W];return typeof W=="string"?j(X,`${z}.${W}`):X},set:(B,W,X)=>(T(),O&&(O[W]=X),!0),deleteProperty:(B,W)=>(T(),O&&delete O[W],!0),defineProperty:(B,W,X)=>(T(),O&&Object.defineProperty(O,W,X),!0)})}return Array.isArray(F)?(0,u.$Wn)(F):F};P=j(P,E)}return P},update:(E,y,P,I)=>{E=d?`${d}.${E}`:E;const j=D(P);return y!==void 0?this.b.$updateConfigurationOption(j,E,y,h,I):this.b.$removeConfigurationOption(j,E,h,I)},inspect:E=>{E=d?`${d}.${E}`:E;const y=this.e.inspect(E,h,this.c.workspace);if(y)return{key:E,defaultValue:(0,u.$Wn)(y.policy?.value??y.default?.value),globalValue:(0,u.$Wn)(y.user?.value??y.application?.value),workspaceValue:(0,u.$Wn)(y.workspace?.value),workspaceFolderValue:(0,u.$Wn)(y.workspaceFolder?.value),defaultLanguageValue:(0,u.$Wn)(y.default?.override),globalLanguageValue:(0,u.$Wn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,u.$Wn)(y.workspace?.override),workspaceFolderLanguageValue:(0,u.$Wn)(y.workspaceFolder?.override),languageIds:(0,u.$Wn)(y.overrideIdentifiers)}}};return typeof m=="object"&&(0,u.$Zn)(p,m,!1),Object.freeze(p)}g(d){const l=a=>(0,S.$6f)(a)?new Proxy(a,{get:(h,m)=>l(h[m]),set:(h,m,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(h,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(h,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(d)}h(d,l,a){const h=b.$lo.test(d)?4:this.d.get(d),m=a?`[${a.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const a=new w.$wo(d,l,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(h,m)=>a.affectsConfiguration(h,r(m))})}k(d){return d.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.$okc=t,e.$pkc=(0,C.$qi)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,8,4,6,7,43,72,44,22,42,20,28,5,15,11,12,91,309,13]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=e.$Slc=e.$Rlc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(s||(s={}));var t;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(t||(t={}));var f;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(f||(f={}));var d;(function(j){function F(T){if(T){const B=T;return B&&!!B.process}else return!1}j.is=F;function z(T){if(T==null)return;const B={process:T.process,args:T.args};return T.options&&(B.options=f.from(T.options)),B}j.from=z;function O(T){if(T!=null)return new M.$AN(T.process,T.args,T.options)}j.to=O})(d||(d={}));var l;(function(j){function F(O){if(O!=null)return O}j.from=F;function z(O){if(O!=null)return O}j.to=z})(l||(l={}));var a;(function(j){function F(T){if(T){const B=T;return B&&(!!B.commandLine||!!B.command)}else return!1}j.is=F;function z(T){if(T==null)return;const B={};return T.commandLine!==void 0?B.commandLine=T.commandLine:(B.command=T.command,B.args=T.args),T.options&&(B.options=l.from(T.options)),B}j.from=z;function O(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$BN(T.commandLine,T.options):new M.$BN(T.command,T.args?T.args:[],T.options)}j.to=O})(a||(a={}));var h;(function(j){function F(T){if(T){const B=T;return B&&B.customExecution==="customExecution"}else return!1}j.is=F;function z(T){return{customExecution:"customExecution"}}j.from=z;function O(T,B){return B.get(T)}j.to=O})(h||(e.CustomExecutionDTO=h={}));var m;(function(j){function F(z,O){let T;return z.scope!==void 0&&typeof z.scope!="number"?T=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===M.TaskScope.Workspace&&O&&O.workspaceFile?T=O.workspaceFile:T=i.$VH),{id:z._id,workspaceFolder:T}}j.from=F})(m||(e.TaskHandleDTO=m={}));var D;(function(j){function F(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}j.from=F})(D||(D={}));var p;(function(j){function F(T,B){if(T==null)return[];const W=[];for(const X of T){const x=z(X,B);x&&W.push(x)}return W}j.fromMany=F;function z(T,B){if(T==null)return;let W;T.execution instanceof M.$AN?W=d.from(T.execution):T.execution instanceof M.$BN?W=a.from(T.execution):T.execution&&T.execution instanceof M.$CN&&(W=h.from(T.execution));const X=s.from(T.definition);let x;return T.scope?typeof T.scope=="number"?x=T.scope:x=T.scope.uri:x=M.TaskScope.Workspace,!X||!x?void 0:{_id:T._id,definition:X,name:T.name,source:{extensionId:B.identifier.value,label:T.source,scope:x},execution:W,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}j.from=z;async function O(T,B,W){if(T==null)return;let X;d.is(T.execution)?X=d.to(T.execution):a.is(T.execution)?X=a.to(T.execution):h.is(T.execution)&&(X=h.to(T._id,W));const x=s.to(T.definition);let Z;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Z=T.source.scope:Z=await B.resolveWorkspaceFolder(u.URI.revive(T.source.scope)):Z=M.TaskScope.Workspace),!x||!Z)return;const Y=new M.$DN(x,Z,T.name,T.source.label,X,T.problemMatchers);return T.isBackground!==void 0&&(Y.isBackground=T.isBackground),T.group!==void 0&&(Y.group=M.$zN.from(T.group._id),Y.group&&T.group.isDefault&&(Y.group=new M.$zN(Y.group.id,Y.group.label),T.group.isDefault===!0&&(Y.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Y.presentationOptions=t.to(T.presentationOptions)),T._id&&(Y._id=T._id),T.detail&&(Y.detail=T.detail),Y}j.to=O})(p||(e.TaskDTO=p={}));var E;(function(j){function F(O){return O}j.from=F;function z(O){if(O)return Object.assign(Object.create(null),O)}j.to=z})(E||(E={}));class y{#e;constructor(F,z,O){this._id=z,this.a=O,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let P=class{constructor(F,z,O,T,B,W,X,x){this.q=new L.$be,this.r=new L.$be,this.s=new L.$be,this.u=new L.$be,this.a=F.getProxy(R.$PM.MainThreadTask),this.b=O,this.c=T,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=X,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,z,O){if(!O)return new M.$RM(()=>{});const T=this.x();return this.j.set(T,{type:z,provider:O,extension:F}),this.a.$registerTaskProvider(T,z),new M.$RM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(F,z){this.a.$registerTaskSystem(F,z)}fetchTasks(F){return this.a.$fetchTasks(E.from(F)).then(async z=>{const O=[];for(const T of z){const B=await p.to(T,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const F=[];return this.k.forEach(z=>F.push(z)),F}terminateTask(F){if(!(F instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,z,O){const T=this.m.get(F.id);T&&(this.o.set(F.id,T),this.e.attachPtyToTerminal(z,await T.callback(O))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const z=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const z=await this.z(F.id);this.s.fire({execution:z,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const z=await this.z(F.id);this.u.fire({execution:z,exitCode:F.exitCode})}$provideTasks(F,z){const O=this.j.get(F);if(!O)return Promise.reject(new Error("no handler found"));const T=[],B=(0,N.$ih)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(W=>this.v(z,T,O,W));return new Promise(W=>{B.then(X=>{Promise.all(T).then(()=>{W(X)})})})}async $resolveTask(F,z){const O=this.j.get(F);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const T=await p.to(z,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(T,A.CancellationToken.None);if(!B)return;this.A(B,O);const W=p.from(B,O.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(F,z,O){const T=await this.a.$createTaskId(F);!O&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,z.execution)),this.m.set(T,z.execution)}async z(F,z){if(typeof F=="string"){const B=this.l.get(F);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(F.id);if(O)return O;let T;return z?T=Promise.resolve(new y(this,F.id,z)):T=p.to(F.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,F.id,B)}),this.l.set(F.id,T),T.then(B=>(this.k.set(F.id,B),B))}A(F,z){F._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const O=this.n.values();let T=O.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=O.next()}};e.$Rlc=P,e.$Rlc=P=Je([qe(0,$.$aP),qe(1,k.$qP),qe(2,w.$mkc),qe(3,b.$lP),qe(4,S.$pkc),qe(5,C.$Nkc),qe(6,o.$Wj),qe(7,n.$3jc)],P);let I=class extends P{constructor(F,z,O,T,B,W,X,x){super(F,z,O,T,B,W,X,x),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:g.$h(0)})}async executeTask(F,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=p.from(z,F);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.y(O,z,!1);else throw new r.$_;const T=await this.z(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),T}v(F,z,O,T){const B=[];if(T)for(const W of T){if(this.A(W,O),!W.definition||!F[W.definition.type]){const x=W.source?W.source:"No task source";this.f.warn(`The task [${x}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const X=p.from(W,O.extension);X&&h.is(X.execution)?(B.push(X),z.push(this.y(X,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(F){if(h.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,z,O){}};e.$Slc=I,e.$Slc=I=Je([qe(0,$.$aP),qe(1,k.$qP),qe(2,w.$mkc),qe(3,b.$lP),qe(4,S.$pkc),qe(5,C.$Nkc),qe(6,o.$Wj),qe(7,n.$3jc)],I),e.$Tlc=(0,v.$qi)("IExtHostTask")}),define(ke[369],Ee([1,0,36,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=L,e.$uL=R;function L(M){return"cellResults"in M}e.$tL="rawCell#";function R(M,w){let b=-1;const S=[];let A=[];return M.forEach($=>{$.range.startLineNumber!==b&&A.length>0&&(S.push([...A]),A=[]),A.push($),b=$.range.endLineNumber}),A.length>0&&S.push([...A]),S.map($=>{const k=[],v=$[0].range.startLineNumber,c=$[$.length-1].range.endLineNumber;for(let g=v;g<=c;g++)k.push(w.getLineContent(g));return new u.$9K(k.join(`
`)+`
`,$.map(g=>new N.$kt(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(ke[370],Ee([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,7,48,340,153,24,15,299,369,366]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,h,m,D,p,E){this.q=m,this.r=D,this.s=p,this.t=E,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new L.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$1jc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy($.$PM.MainThreadNotebook),this.c=a.getProxy($.$PM.MainThreadNotebookDocuments),this.d=a.getProxy($.$PM.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,I=y.cell.handle,F=this.g.get(P)?.getCell(I);if(F)return F.apiCell}if(y&&y.$mid===14){const P=y.uri,I=this.g.get(P);if(I)return I.apiNotebook}return y}}),d.B(h)}getEditorById(a){const h=this.h.get(a);if(!h)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(a){for(const[h,m]of this.h)if(m.apiEditor===a)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,h){const m=this.g.get(a);if(!m&&!h)throw new Error(`NO notebook document for '${a}'`);return m}static u(a,h){if(!h)return;const m=h.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(h.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:h.displayName,filenamePattern:m,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,h,m){const D=d.a++,p=typeof m.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(D,m),this.b.$registerNotebookCellStatusBarItemProvider(D,p,h);let E;return p!==void 0&&(E=m.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(p))),new c.$RM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,p),E?.dispose()})}async createNotebookDocument(a){const h=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&v.NotebookData.from(a.content)});return S.URI.revive(h)}async openNotebookDocument(a){const h=this.g.get(a);if(h)return h.apiNotebook;const m=await this.c.$tryOpenNotebook(a),D=this.g.get(S.URI.revive(m));return(0,b.$cg)(D?.apiNotebook)}async showNotebookDocument(a,h){S.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let m;typeof h=="object"?m={position:v.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(v.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:m={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,m),p=D&&this.h.get(D)?.apiEditor;if(p)return p;throw D?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,h,m,D){const p=this.f.get(a),E=S.URI.revive(h),y=this.g.get(E);if(!y||!p)return;const P=y.getCellFromIndex(m);if(!P)return;const I=await p.provideCellStatusBarItems(P.apiCell,D);if(!I)return;const j=new R.$Tc,F=this.p.add([j]),O=(Array.isArray(I)?I:[I]).map(T=>v.NotebookStatusBarItem.from(T,this.i,j));return{cacheId:F,items:O}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,h,m,D,p){if((0,w.$3e)(h))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:h,serializer:m,options:D}),this.b.$registerNotebookSerializer(E,{id:a.identifier,location:a.extensionLocation},h,v.NotebookDocumentContentOptions.from(D),d.u(a,p)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(a,h,m){const D=this.x.get(a);if(!D)throw new Error("NO serializer found");const p=await D.serializer.deserializeNotebook(h.buffer,m);return new g.$mw(v.NotebookData.from(p))}async $notebookToData(a,h,m){const D=this.x.get(a);if(!D)throw new Error("NO serializer found");const p=await D.serializer.serializeNotebook(v.NotebookData.to(h.value),m);return N.$Ce.wrap(p)}async $saveNotebook(a,h,m,D,p){const E=S.URI.revive(h),y=this.x.get(a);if(!y)throw new Error("NO serializer found");const P=this.g.get(E);if(!P)throw new Error("Document NOT found");if(P.versionId!==m)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new A.$fl((0,u.localize)(0,null,this.z(E)),6);await this.y(E,D);const I={metadata:(0,i.$5n)(P.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of P.apiNotebook.getCells()){const B=new c.$hO(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);B.metadata=(0,i.$5n)(T.metadata,W=>!(y.options?.transientCellMetadata??{})[W]),I.cells.push(B)}const j=await y.serializer.serializeNotebook(I,p);await this.s.value.writeFile(E,j);const F=this.s.getFileSystemProviderExtUri(E.scheme),z=await this.s.value.stat(E);return{name:F.basename(E),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$ql({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(a,h,m,D,p){const E=this.x.get(a)?.serializer;if(!E)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(z,O,T)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const X={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(X,O,x=>{x.forEach(Z=>{y.has(Z)||D.some(ce=>B.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(ne=>(0,f.$mgb)(ne,Z)))||y.add(Z)})}).catch(x=>{if(x.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw x})}))))})(m,p,h);const I=new M.$Bc;let j=!1;const F=Array.from(y).map(async z=>{const O=[];try{if(p.isCancellationRequested)return;if(h.maxResults&&[...I.values()].reduce((X,x)=>X+x.cellResults.length,0)>h.maxResults){j=!0;return}const T=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(x=>T.push({input:x.document.getText(),outputs:x.outputs.flatMap(Z=>Z.items.map(Y=>Y.data.toString()))}));else{const X=await this.s.value.readFile(z),x=N.$Ce.fromString(X.toString()),Z=await E.deserializeNotebook(x.buffer,p);if(p.isCancellationRequested)return;v.NotebookData.from(Z).cells.forEach(ce=>T.push({input:ce.source,outputs:ce.outputs.flatMap(ne=>ne.items.map($e=>$e.valueBytes.toString()))}))}if(p.isCancellationRequested)return;T.forEach((X,x)=>{const Z=h.contentPattern.pattern,Y=new s.$_Vb(X.input,void 0,X.outputs),ce=Y.findInInputs(Z),ne=Y.findInOutputs(Z),$e=ne.flatMap(Pe=>(0,t.$uL)(Pe.matches,Pe.textBuffer)).map((Pe,_)=>(Pe.webviewIndex=_,Pe));if(ce.length>0||ne.length>0){const Pe={index:x,contentResults:(0,t.$uL)(ce,Y.inputTextBuffer),webviewResults:$e};O.push(Pe)}});const W={resource:z,cellResults:O};I.set(z,W);return}catch{return}});return await Promise.all(F),{limitHit:j,results:[...I.values()]}}async y(a,h){const m=await this.s.value.stat(a);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$pl&&typeof m.mtime=="number"&&typeof m.size=="number"&&h.mtime<m.mtime&&h.etag!==A.$ql({mtime:h.mtime,size:m.size}))throw new A.$fl((0,u.localize)(1,null),3,h)}z(a){return a.scheme===r.Schemas.file?a.fsPath:a.toString()}A(a,h,m){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const D=new n.$llc(h,this.d,a,m.visibleRanges.map(v.NotebookRange.to),m.selections.map(v.NotebookRange.to),typeof m.viewColumn=="number"?v.ViewColumn.to(m.viewColumn):void 0);this.h.set(h,D)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const m of a.value.removedDocuments){const D=S.URI.revive(m),p=this.g.get(D);p&&(p.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(p.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===D.toString()&&this.h.delete(E.id)}if(a.value.addedDocuments){const m=[];for(const D of a.value.addedDocuments){const p=S.URI.revive(D.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const E=new o.$klc(this.c,this.q,this.r,p,D);m.push(...D.cells.map(y=>o.$jlc.asModelAddData(y))),this.g.get(p)?.dispose(),this.g.set(p,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this.m.fire(E.apiNotebook)}}if(a.value.addedEditors)for(const m of a.value.addedEditors){if(this.h.has(m.id))return;const D=S.URI.revive(m.documentUri),p=this.g.get(D);p&&this.A(p,m.id,m)}const h=[];if(a.value.removedEditors)for(const m of a.value.removedEditors){const D=this.h.get(m);D&&(this.h.delete(m),this.k?.id===D.id&&(this.k=void 0),h.push(D))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const m=new Set;this.l.forEach(D=>m.add(D.id));for(const D of this.h.values()){const p=m.has(D.id);D._acceptVisibility(p)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const h=k.$yP.String.with("notebookType","A notebook type"),m=new k.$AP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new k.$yP("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>N.$Ce.wrap(p))],new k.$zP("Notebook Data",p=>v.NotebookData.to(p.value))),D=new k.$AP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new k.$yP("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new g.$mw(v.NotebookData.from(p)))],new k.$zP("Bytes",p=>p.buffer));a.registerApiCommand(m),a.registerApiCommand(D)}}e.$ulc=d}),define(ke[371],Ee([1,0,17,22,47,35,23,39,36]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;class S{constructor($,k,v){this.k=$,this.l=k,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$kk($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$kk($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const k=this.k.folderQueries||[];return new Promise((v,c)=>{const g=o=>{this.f++,$(o)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(g,{base:o,basename:i})}),Promise.all(k.map(o=>this.p(o,g))).then(o=>{v({limitHit:this.e,stats:o[0]||void 0})},o=>{c(new Error((0,L.$bj)(o)))})})}async p($,k){const v=new N.$me,c=this.q($),g=this.r(),o=new b.$kL(this.k,$),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=w.$0d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,v.token),s=i.elapsed(),t=w.$0d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const d=u.$hc.relative($.folder.path,f.path);if(n){const l=u.$oc(f.path);this.v(k,{base:$.folder,relativePath:d,basename:l});return}this.s(g,$.folder,d,k)}),this.g&&!this.e)?null:(this.u(g,o,k),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q($){const k=(0,b.$jL)(this.k.includePattern,$.includePattern),v=(0,b.$jL)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:v,includes:k,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},k,v,c){if(v===this.a){const o=u.$oc(this.a);this.v(c,{base:k,relativePath:this.a,basename:o})}function g(o){const n=u.$oc(o),i=u.$nc(o);let r=$[i];r||(r=$[i]=[],g(i)),r.push({base:k,relativePath:o,basename:n})}g(v)}u({rootEntries:$,pathToEntries:k},v,c){const g=this,o=this.a;function n(i){const r=(0,b.$mL)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const f=i[s],{relativePath:d,basename:l}=f;if(v.matchesExcludesSync(d,l,o!==l?r:void 0))continue;const a=k[d];if(a)n(a);else{if(d===o)continue;g.v(c,f)}if(g.e)break}}n($)}v($,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(k))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,k,v,c){const g=this.c($.cacheKey),o=new S($,k,g&&g.token);let n=0;const i=r=>{n+=r.length,v(r.map(s=>this.d(s)))};return this.e(o,A.a,i,c).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new N.$me),this.b.get($)}d($){return $.relativePath?{resource:M.$4g($.base,$.relativePath)}:{resource:$.base}}e($,k,v,c){const g=c.onCancellationRequested(()=>{$.cancel()}),o=i=>{i&&(n.push(i),k>0&&n.length>=k&&(v(n),n=[]))};let n=[];return $.search(o).then(i=>(n.length&&v(n),g.dispose(),i),i=>(n.length&&v(n),g.dispose(),Promise.reject(i)))}}e.$mlc=A}),define(ke[372],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,245,54,12,41,146,367,36]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=D;let s=class{constructor(E,y,P,I,j){this.a=E,this.b=y,this.c=P,this.d=I,this.e=j}text(E,y,P={}){E=this.f(E,P);const I=this.a.getValue(),j=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(o.$Li),P),type:2,contentPattern:E,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||j||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(E,y){const P=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const I={...E,wordSeparators:P.editor.wordSeparators};return this.j(E,y)&&(I.isCaseSensitive=!0),this.k(E)&&(I.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),I}file(E,y={}){return{...this.h(E,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(E,y){return E?(E=Array.isArray(E)?E.map(a):a(E),y?this.parseSearchPaths(E):{pattern:f(...Array.isArray(E)?E:[E])}):{}}h(E=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),I=this.g(y.excludePattern,y.expandPatterns),j=E.length>1,F=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,y,I)):E.map(T=>this.r(T,y,I,j))).filter(T=>!!T),z={_reason:y._reason,folderQueries:F,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=u.$Hb(u.$Rb(this.c.groups.map(X=>X.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const B=T.filter(X=>(0,r.$aL)(z,X.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const O=y.extraFileResources&&y.extraFileResources.filter(T=>(0,r.$aL)(z,T.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(E){const y=[],P=new M.$Bc,I={};let j=!1;return E.forEach(F=>{if(F.scheme===w.Schemas.walkThrough)return;if((0,S.$8g)(F)){const O=this.b.getWorkspaceFolder(F)?.uri??F.with({path:b.$nc(F.fsPath)});let T=P.get(O);T||(j=!0,T={folder:O,includePattern:{}},y.push(T),P.set(O,T));const B=b.$mc(O.fsPath,F.fsPath);(0,C.$cg)(T.includePattern)[B.replace(/\\/g,"/")]=!0}else F.fsPath&&(j=!0,I[F.fsPath]=!0)}),{folderQueries:y,includePattern:I,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(E,y){if(y.isSmartCase){if(E.isRegExp){if(A.$Uf(E.pattern,!0))return!0}else if(A.$Uf(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,k.$BC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const y=W=>b.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),I=(Array.isArray(E)?E:d(E)).map(W=>{const X=this.e.resolvedUserHome;return X?(0,R.$rw)(W,X.scheme===w.Schemas.file?X.fsPath:X.path):W}),j=N.$K(I,W=>y(W)?"searchPaths":"exprSegments"),F=(j.exprSegments||[]).map(W=>A.$bf(W,"/")).map(W=>A.$bf(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),l(W))),z={},O=this.m(j.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const T=u.$Rb(F),B=f(...T);return B&&(z.pattern=B),z}l(E,y){return y.disregardExcludeSettings?void 0:(0,r.$_K)(E,!y.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const y=E.flatMap(I=>{let{pathPortion:j,globPortion:F}=t(I);return F&&(F=h(F)),this.n(j).flatMap(O=>this.o(O,F))}),P=new Map;return y.forEach(I=>{const j=I.searchPath.toString(),F=P.get(j);F?I.pattern&&(F.pattern=F.pattern||{},F.pattern[I.pattern]=!0):P.set(j,{searchPath:I.searchPath,pattern:I.pattern?f(I.pattern):void 0})}),Array.from(P.values())}n(E){if(b.$jc(E)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==w.Schemas.file?[{searchPath:y[0].uri.with({path:E})}]:[{searchPath:$.URI.file(b.$ic(E))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(E=a(E),E.startsWith("../")||E===".."){const I=b.$hc.resolve(y.path,E);return[{searchPath:y.with({path:I})}]}const P=h(E);return[{searchPath:y,pattern:P}]}else{if(E==="./"||E===".\\")return[];{const y=E.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(j=>{const F=y.match(new RegExp(`^${A.$8e(j.name)}(?:/(.*)|$)`));return F?{match:F,folder:j}:null}).filter(C.$_f);if(I.length)return I.map(j=>{const F=j.match[1];return{searchPath:j.folder.uri,pattern:F&&h(F)}});{const j=E.match(/\.[\/\\](.+)[\/\\]?/),F=j?j[1]:E,z=v.localize(0,null,F);throw new Error(z)}}}}o(E,y){const P=E.pattern&&y?`${E.pattern}/${y}`:E.pattern||y,I=[{searchPath:E.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:E.searchPath,pattern:P+"/**"}),I}q(E,y,P){const I=this.r((0,o.$Li)(E.searchPath),y,P,!1);return I?{...I,includePattern:E.pattern}:null}r(E,y,P,I){let j;const F=$.URI.isUri(E)?E:E.uri;if(P.searchPaths){const W=P.searchPaths.filter(X=>(0,S.$Wg)(X.searchPath,F))[0];if(W&&!W.pattern)return null;W&&(j=W.pattern)}const z=this.a.getValue({resource:F}),T={...this.l(z,y)||{},...j||{}},B=$.URI.isUri(E)?(0,S.$1g)(E):E.name;return{folder:F,folderName:I?B:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$tM=s,e.$tM=s=Je([qe(0,c.$Wi),qe(1,o.$zi),qe(2,n.$ID),qe(3,g.$Wj),qe(4,i.$rM)],s);function t(p){const E=p.match(/[\*\{\}\(\)\[\]\?]/);if(E){const y=E.index,P=p.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let I=p.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:p.substr((P.index||0)+1)}}}return{pathPortion:p}}function f(...p){return p.length?p.reduce((E,y)=>(E[y]=!0,E),Object.create(null)):void 0}function d(p){return L.$ik(p,",").map(E=>E.trim()).filter(E=>!!E.length)}function l(p){return[`**/${p}/**`,`**/${p}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function a(p){return p.replace(/\\/g,"/")}function h(p){return a(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(p){return p.replace(/([?*[\]])/g,"[$1]")}function D(p,E){p=u.$Mb(p,I=>I.toString());const y=[],P=E.getWorkspace();return p&&p.forEach(I=>{let j;if(E.getWorkbenchState()===2)j=(0,S.$6g)(P.folders[0].uri,I),j&&j!=="."&&(j="./"+j);else{const F=E.getWorkspaceFolder(I);if(F){const z=F.name;if(P.folders.filter(T=>T.name===z).length===1){const T=(0,S.$6g)(F.uri,I);T===""?j=`./${F.name}`:j=`./${F.name}/${T}`}else j=I.fsPath}}j&&y.push(m(j))}),y}}),define(ke[373],Ee([1,0,23,2,22,13,5,372,36,41,8]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mtb=$,e.$ntb=c;const C=7e3;function $(g,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const a of n)if(/^workspaceContains:/.test(a)){const h=a.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||g.forceUsingSearch?r.push(h):i.push(h)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$jh)(),f=a=>t({activationEvent:a}),d=Promise.all(i.map(a=>k(g,a,f))).then(()=>{}),l=v(g,o.identifier,r,f);return Promise.all([d,l]).then(()=>{t(void 0)}),s}async function k(g,o,n){for(const i of g.folders)if(await g.exists(u.$4g(N.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function v(g,o,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new L.$me,s=g.checkExists(g.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),g.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},C);let f=!1;try{f=await s}catch(d){R.$4(d)||R.$1(d)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function c(g,o,n,i){const r=g.get(M.$pi),s=g.get(b.$4K),f=r.createInstance(w.$tM).file(o.map(d=>(0,S.$Li)(N.URI.revive(d))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(f,i).then(d=>!!d.limitHit,d=>R.$4(d)?!1:Promise.reject(d))}}),define(ke[49],Ee([1,0,220,17,59,23,8,3,77,2,12,6,44,305,118,43,26,148,13,25,21,282,7,66,5,28,93,20,107,70,42,121,4,373,117,284,15,115,39,11,116]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f,d,l,a,h,m,D,p,E,y,P,I,j,F,z,O,T,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=e.$3kc=e.$2kc=e.$1kc=void 0,e.$1kc=(0,d.$qi)("IHostUtils");let X=W=class extends w.$Uc{constructor(U,ie,be,Ce,oe,ae,re,G,te,ge,we,Re,fe){super(),this.Y=Re,this.Z=fe,this.a=this.B(new y.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ie,this.g=be,this.f=re,this.j=Ce,this.m=oe,this.s=ae,this.t=te,this.u=ge,this.w=we,this.y=this.g.getProxy(C.$PM.MainThreadWorkspace),this.z=this.g.getProxy(C.$PM.MainThreadTelemetry),this.C=this.g.getProxy(C.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Pe(this.f.extensions.activationEvents),this.L=new o.$C$b(this.I,this.f.extensions.allExtensions);const Se=new i.$Mm(this.f.extensions.myExtensions);this.J=new o.$C$b(this.I,ne(this.L,Se)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new v.$Jkc(this.g,this.s),this.N=new I.$Tkc(this.g),this.O=G,this.h=U.createChild(new m.$oi([v.$Kkc,this.M],[I.$Ukc,this.N])),this.P=this.B(new k.$Ikc(this.J,this.L,{onExtensionActivationError:(Ae,je,q)=>{this.C.$onExtensionActivationError(Ae,n.$3(je),q)},actualActivateExtension:async(Ae,je)=>{if(o.$C$b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,je),new k.$Hkc;const q=this.J.getExtensionDescription(Ae);return this.fb(q,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this.eb(oe))}catch{}await Promise.all(U)}terminate(U,ie=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ce=>{this.s.error(Ce)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$rh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ie=await this.C.$getExtension(U);return ie&&{...ie,identifier:new i.$Lm(ie.identifier.value),extensionLocation:S.URI.revive(ie.extensionLocation)}}ab(U,ie){return this.P.activateByEvent(U,ie)}bb(U,ie){return this.P.activateById(U,ie)}activateByIdWithErrors(U,ie){return this.bb(U,ie).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===F.Schemas.file&&this.c.fsRealpath){const ie=U.fsPath;this.R.has(ie)||this.R.set(ie,this.c.fsRealpath(ie));const be=await this.R.get(ie);return S.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new $e(U))),this.Q}async db(U){const ie=b.$wi.forUris(be=>R.$Ug.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const Ce=await this.cb(be.extensionLocation);ie.set(Ce,be)}})),ie}eb(U){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ie;const be=this.P.getActivatedExtension(U);if(!be)return ie;try{typeof be.module.deactivate=="function"&&(ie=Promise.resolve(be.module.deactivate()).then(void 0,Ce=>(this.s.error(Ce),Promise.resolve(void 0))))}catch(Ce){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Ce)}try{(0,w.$Pc)(be.subscriptions)}catch(Ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Ce)}return ie}async fb(U,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ie).then(be=>{const Ce=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,ie),this.gb(U,ie,"success",Ce),be},be=>{throw this.gb(U,ie,"failure"),be})}gb(U,ie,be,Ce){const oe=Z(U,ie);this.z.$publicLog2("extensionActivationTimes",{...oe,...Ce||{},outcome:be})}hb(U,ie){const be=Z(U,ie);this.z.$publicLog2("activatePlugin",be);const Ce=this.wb(U);if(!Ce)return Promise.resolve(new k.$Gkc(k.$Dkc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${U.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const oe=new k.$Ekc(ie.startup);return Promise.all([this.xb(U,(0,R.$4g)(U.extensionLocation,Ce),oe),this.ib(U)]).then(ae=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,ae[0],ae[1],oe))).then(ae=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ae))}ib(U){const ie=this.Z.createLanguageModelAccessInformation(U),be=new s.$Mkc(U,this.M),Ce=new s.$Lkc(U.identifier.value,!1,this.M),oe=new j.$Vkc(U,this.N),ae=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,Ce.whenReady,this.O.whenReady]).then(()=>{const G=this;let te,ge;const we=(0,g.$xG)(U,"ipc")?this.f.messagePorts?.get(i.$Lm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Ce,secrets:oe,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Re){return N.$kc(U.extensionLocation.fsPath,Re)},get storagePath(){return G.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return G.O.globalValue(U).fsPath},get logPath(){return N.$kc(G.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return S.URI.joinPath(G.f.logsLocation,U.identifier.value)},get storageUri(){return G.O.workspaceValue(U)},get globalStorageUri(){return G.O.globalValue(U)},get extensionMode(){return ae},get extension(){return te===void 0&&(te=new ce(G,U.identifier,U,re,!1)),te},get extensionRuntime(){return(0,g.$yG)(U,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!ge){if(!we)return;const Re=y.Event.buffer(y.Event.fromDOMEventEmitter(we,"message",fe=>fe.data));we.start(),ge={onDidReceiveMessage:Re,postMessage:we.postMessage.bind(we)}}return ge}})})}static jb(U,ie,be,Ce,oe){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,ie,be,Ce,oe).then(ae=>new k.$Fkc(!1,null,oe.build(),be,ae,Ce.subscriptions))}static kb(U,ie,be,Ce,oe){if(typeof be.activate=="function")try{oe.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ae=typeof global=="object"?global:self,re=be.activate.apply(ae,[Ce]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(re).then(G=>(oe.activateResolveStop(),G))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(be)}lb(U,ie){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ie}).then(void 0,be=>{this.s.error(be)})}mb(U,ie=0){const Ce=Date.now();(0,T.$B)(()=>{for(let oe=ie;oe<U.length;oe+=1){const ae=U[oe];for(const re of ae.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-Ce>50){this.mb(U,oe);break}else this.lb(ae,re)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ie=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ie)this.mb(be);else for(const Ce of be)if(Ce.activationEvents)for(const oe of Ce.activationEvents)oe==="onStartupFinished"&&this.lb(Ce,oe)})}ob(){const U=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const ie=this.j.workspace?this.j.workspace.folders:[],be=this.pb(ie),Ce=this.rb(),oe=Promise.all([Ce,U,be]).then(()=>{});return Promise.race([oe,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),oe}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.qb(U,ie))).then(()=>{})}async qb(U,ie){if(this.isActivated(ie.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Ce={logService:this.s,folders:U.map(ae=>ae.uri),forceUsingSearch:be||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,re,G)=>this.y.$checkExists(ae,re,G)},oe=await(0,P.$mtb)(Ce,ie);if(oe)return this.bb(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:oe.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ie}=this.f.environment;if(!U||!ie)throw new Error(u.localize(0,null));const be=await this.xb(null,ie,new k.$Ekc(!1));if(!be||typeof be.run!="function")throw new Error(u.localize(1,null,ie.toString()));return new Promise((Ce,oe)=>{const ae=(te,ge)=>{te?(T.$t&&this.s.error("Test runner called back with error",te),oe(te)):(T.$t&&(ge?this.s.info(`Test runner called back with ${ge} failures.`):this.s.info("Test runner called back with successful outcome.")),Ce(typeof ge=="number"&&ge>0?1:0))},re=(0,R.$Rg)(ie),G=be.run(re,ae);G&&G.then&&G.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),Ce(0)}).catch(te=>{T.$t&&this.s.error("Test runner finished with error",te),oe(te instanceof Error&&te.stack?te.stack:String(te))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ie){return this.S[U]=ie,(0,w.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ie}=await this.ub(U);return ie?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ie=U.indexOf("+");if(ie===-1)throw new t.$XM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,ie);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,ie){const be=O.$0d.create(!1),Ce=()=>`[resolveAuthority(${(0,f.$Fl)(U)},${ie})][${be.elapsed()}ms] `,oe=V=>this.s.info(`${Ce()}${V}`),ae=V=>this.s.warn(`${Ce()}${V}`),re=(V,Q=void 0)=>this.s.error(`${Ce()}${V}`,Q),G=V=>{if(V instanceof t.$XM)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},te=async V=>{oe(`activating resolver for ${V}...`);const{resolver:Q,authorityPrefix:J}=await this.ub(V);if(!Q)throw re(`no resolver for ${J}`),new t.$XM(`No remote extension installed to resolve ${J}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:J,remoteAuthority:V}},ge=U.split(/@|%40/g).reverse();oe(`activating remote resolvers ${ge.join(" -> ")}`);let we;try{we=await Promise.all(ge.map(te)).catch(async V=>{if(!(V instanceof t.$XM)||V._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return ae(`resolving nested authorities failed: ${V.message}`),[await te(U)]})}catch(V){return G(V)}const Re=new M.$Bh;Re.cancelAndSet(()=>oe("waiting..."),1e3);let fe,Se;for(const[V,{authorityPrefix:Q,resolver:J,remoteAuthority:he}]of we.entries())try{if(V===we.length-1)oe("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${Q}`),fe=await J.resolve(he,{resolveAttempt:ie,execServer:Se}),L.mark(`code/extHost/didResolveAuthorityOK/${Q}`),oe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$WM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(oe(`invoking resolveExecServer() for ${he}`),L.mark(`code/extHost/willResolveExecServer/${Q}`),Se=await J.resolveExecServer?.(he,{resolveAttempt:ie,execServer:Se}),!Se)throw new t.$XM(`Exec server was not available for ${he}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(pe){return L.mark(`code/extHost/didResolveAuthorityError/${Q}`),re("returned an error",pe),Re.dispose(),G(pe)}Re.dispose();const Ae={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};oe(`returned ${t.$WM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let q;if(t.$WM.isManagedResolvedAuthority(fe)){const V=ie;this.Y.setFactory(V,fe.makeConnection),q={authority:U,connectTo:new f.$Cl(V),connectionToken:fe.connectionToken}}else q={authority:U,connectTo:new f.$Dl(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:q,options:je,tunnelInformation:Ae}}}async $getCanonicalURI(U,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Fl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const Ce=S.URI.revive(ie);if(typeof be.getCanonicalURI>"u")return Ce;const oe=await(0,M.$ih)(()=>be.getCanonicalURI(Ce));return oe||Ce}async $startExtensionHost(U){U.toAdd.forEach(ae=>ae.extensionLocation=S.URI.revive(ae.extensionLocation));const{globalRegistry:ie,myExtensions:be}=x(this.I,this.L,this.J,U),Ce=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(U,ie){return ie===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,ie){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ie),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ae=>ae.extensionLocation=S.URI.revive(ae.extensionLocation));const{globalRegistry:ie,myExtensions:be}=x(this.I,this.L,this.J,U),Ce=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ie=r.$Ce.alloc(U),be=Math.random()%256;for(let Ce=0;Ce<U;Ce++)ie.writeUInt8(be,Ce);return ie}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$2kc=X,e.$2kc=X=W=Je([qe(0,d.$pi),qe(1,e.$1kc),qe(2,h.$aP),qe(3,c.$mkc),qe(4,$.$pkc),qe(5,A.$Wj),qe(6,l.$qP),qe(7,a.$skc),qe(8,D.$oCb),qe(9,p.$Nkc),qe(10,z.$Xkc),qe(11,B.$Ykc),qe(12,E.$Rkc)],X);function x(_,U,ie,be){_.addActivationEvents(be.addActivationEvents);const Ce=new o.$C$b(_,U.getAllExtensionDescriptions());Ce.deltaExtensions(be.toAdd,be.toRemove);const oe=new i.$Mm(ie.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of be.myToRemove)oe.delete(re);for(const re of be.myToAdd)oe.add(re);const ae=ne(Ce,oe);return{globalRegistry:Ce,myExtensions:ae}}function Z(_,U){return{id:_.identifier.value,name:_.name,extensionVersion:_.version,publisherDisplayName:_.publisher,activationEvents:_.activationEvents?_.activationEvents.join(","):null,isBuiltin:_.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Y(_){return _.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$3kc=(0,d.$qi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(U,ie,be,Ce,oe){this.#e=U,this.#t=ie,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=N.$ic((0,R.$Rg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Ce,this.isFromDifferentExtensionHost=oe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4kc=ce;function ne(_,U){return _.getAllExtensionDescriptions().filter(ie=>U.has(ie.identifier))}class $e{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$5kc=$e;class Pe{constructor(U){this.a=new i.$Nm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ie of Object.keys(U))this.a.set(ie,U[ie])}}}),define(ke[374],Ee([1,0,59,2,6,44,26,25,20,28,5,49,12,14]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0;let c=class{constructor(r,s,t,f,d,l,a){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.h=l,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$bmc=c,e.$bmc=c=Je([qe(2,A.$pi),qe(3,R.$pkc),qe(4,C.$3kc),qe(5,S.$qP),qe(6,$.$Wj)],c);let g=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&v.a.size){const s=(0,k.$8e)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,f,d]=s,l=v.a.get(f);if(l!==void 0)return console.warn(`${f} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};g=v=Je([qe(0,S.$qP)],g);class o{constructor(r,s,t,f,d){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.nodeModuleName="vscode",this.a=new w.$Nm}load(r,s){const t=this.d.findSubstr(s);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((d,l)=>f+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this.b=this.c(M.$sG,this.e,this.f)}return this.b}}let n=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$PM.MainThreadTelemetry);const f=t.getProxy(L.$PM.MainThreadWindow);this.c=(d,l)=>{const a=N.URI.parse(d);return l?this.g(d,l):a.scheme==="http"||a.scheme==="https"?f.$openUri(a,d,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?f.$openUri(a,d,{}):this.g(d,l)}}load(r,s,t){const f=this.e.findSubstr(s);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,b.$aP)],n)}),define(ke[61],Ee([1,0,46,3,17,51,5,72,71,49,7,43,302,44]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=e.$6kc=void 0,e.$6kc=(0,M.$qi)("IExtHostVariableResolverProvider");class v extends $.$cQ{constructor(o,n,i,r,s,t,f){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const a=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof A.$CO||a.input instanceof A.$HO)return a.input.modified;if(a.input instanceof A.$BO||a.input instanceof A.$GO||a.input instanceof A.$EO)return a.input.uri}}}super({getFolderUri:l=>{const a=t.folders.filter(h=>h.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,a)=>s.getConfiguration(void 0,l).get(a),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return L.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const a=n.getWorkspaceFolder(l);if(a)return L.$ic(a.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(R.env))}}let c=class extends N.$Uc{constructor(o,n,i,r,s){super(),this.b=o,this.c=n,this.g=i,this.h=r,this.j=s,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$7kc=c,e.$7kc=c=Je([qe(0,S.$3kc),qe(1,C.$mkc),qe(2,w.$lP),qe(3,k.$pkc),qe(4,b.$Bkc)],c)}),define(ke[96],Ee([1,0,8,4,2,25,5,6,71,49,20,7,43,143,294,44,61,3,57,33,16]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=e.$$kc=e.$0kc=e.$9kc=e.$8kc=void 0,e.$8kc=(0,M.$qi)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(m,D,p,E,y,P,I){this.N=D,this.O=p,this.P=E,this.Q=y,this.R=P,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=m.getProxy(w.$PM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(j=>{j.onDidChange(F=>{this.V(j)}),this.V(j)})}async $getVisualizerTreeItem(m,D){const p=this.W(D);if(!p)return;const E=await this.H.get(m)?.getTreeItem?.(p);return E?this.U(m,E):void 0}registerDebugVisualizationTree(m,D,p){const E=R.$Lm.toKey(m.identifier),y=this.jb(E,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,p),this.l.$registerDebugVisualizerTree(y,!!p.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(m,D){const p=this.J.get(D)?.item;return p?(await this.H.get(m)?.getChildren?.(p))?.map(y=>this.U(m,y))||[]:[]}async $editVisualizerTreeItem(m,D){const p=this.J.get(m);if(!p)return;const E=await this.H.get(p.provider)?.editItem?.(p.item,D);return this.U(p.provider,E||p.item)}$disposeVisualizedTree(m){const D=this.J.get(m);if(!D)return;const p=[D.children];for(const E of p)if(E)for(const y of E)p.push(this.J.get(y)?.children),this.J.delete(y)}U(m,D){let p=this.I.get(D);return p||(p=this.F++,this.I.set(D,p),this.J.set(p,{provider:m,item:D})),r.DebugTreeItem.from(D,p)}asDebugSourceUri(m,D){const p=m;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let E=`debug:${encodeURIComponent(p.path||"")}`,y="?";return D&&(E+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),E+=`${y}ref=${p.sourceReference}`,L.URI.parse(E)}else{if(p.path)return L.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(m){const D=[];for(const p of m.getAllExtensionDescriptions())if(p.contributes){const E=p.contributes.debuggers;if(E&&E.length>0)for(const y of E)(0,v.$_G)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const m=[];return this.z.forEach(D=>m.push(D)),m}async $resolveDebugVisualizer(m,D){const p=this.L.get(m);if(!p)throw new Error(`No debug visualizer found with id '${m}'`);let{v:E,provider:y,extensionId:P}=p;if(E.visualization||(E=await y.resolveDebugVisualization?.(E,D)||E,p.v=E),!E.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,E.visualization)}async $executeDebugVisualizerCommand(m){const D=this.L.get(m);if(!D)throw new Error(`No debug visualizer found with id '${m}'`);const p=D.v.visualization;p&&"command"in p&&this.S.executeCommand(p.command,...p.arguments||[])}W(m){const D=this.m.get(m.sessionId);return D&&{session:D.api,variable:m.variable,containerId:m.containerId,frameId:m.frameId,threadId:m.threadId}}async $provideDebugVisualizers(m,D,p,E){const y=this.W(p),P=this.jb(m,D),I=this.G.get(P);if(!y||!I)return[];const j=await I.provideDebugVisualization(y,E);return j?j.map(F=>{const z=++this.M;this.L.set(z,{v:F,provider:I,extensionId:m});const O=F.iconPath?this.lb(F.iconPath):void 0;return{id:z,name:F.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(m,F.visualization)}}):[]}$disposeDebugVisualizers(m){for(const D of m)this.L.delete(D)}registerDebugVisualizationProvider(m,D,p){if(!m.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const E=R.$Lm.toKey(m.identifier),y=this.jb(E,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,p),this.l.$registerDebugVisualizer(E,D),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(E,D),this.G.delete(D)})}addBreakpoints(m){const D=m.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(D,[],[]);const p=[],E=new Map;for(const y of D)if(y instanceof C.$SN){let P=E.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},E.set(y.location.uri.toString(),P),p.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof C.$TN&&p.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(p)}removeBreakpoints(m){const D=m.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const p=D.filter(P=>P instanceof C.$SN).map(P=>P.id),E=D.filter(P=>P instanceof C.$TN).map(P=>P.id),y=D.filter(P=>P instanceof C.$UN).map(P=>P.id);return this.l.$unregisterBreakpoints(p,E,y)}startDebugging(m,D,p){return this.l.$startDebugging(m?m.uri:void 0,D,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,suppressSaveBeforeStart:p.suppressSaveBeforeStart,suppressDebugStatusbar:p.suppressDebugStatusbar??p.debugUI?.simple,suppressDebugToolbar:p.suppressDebugToolbar??p.debugUI?.simple,suppressDebugView:p.suppressDebugView??p.debugUI?.simple})}stopDebugging(m){return this.l.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,D,p){if(!D)return new C.$RM(()=>{});const E=this.d++;return this.f.push({type:m,handle:E,provider:D}),this.l.$registerDebugConfigurationProvider(m,p,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,E),new C.$RM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(m,D,p){if(!p)return new C.$RM(()=>{});if(!this.cb(m,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this.g++;return this.h.push({type:D,handle:E,factory:p}),this.l.$registerDebugAdapterDescriptorFactory(D,E),new C.$RM(()=>{this.h=this.h.filter(y=>y.factory!==p),this.l.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(m,D){if(!D)return new C.$RM(()=>{});const p=this.j++;return this.k.push({type:m,handle:p,factory:D}),new C.$RM(()=>{this.k=this.k.filter(E=>E.factory!==D)})}async $runInTerminal(m,D){return Promise.resolve(void 0)}async $substituteVariables(m,D){let p;const E=await this.ib(m);return E&&(p={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(p,D)}X(m,D){if(m.type==="implementation")return new l(m.implementation)}Y(){}async $startDASession(m,D){const p=this,E=await this.hb(D);return this.eb(this.$(E.type),E).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const P=this.Z(y),I=this.X(P,E);if(!I)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const j=I;return this.D.set(m,j),this.db(E).then(F=>(F&&this.E.set(m,F),j.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,T={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);T.body={signature:B},j.sendResponse(T)}else throw new Error("no signer")}catch(B){T.success=!1,T.message=B.message,j.sendResponse(T)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(z),z=(0,v.$eH)(z,!0),p.l.$acceptDAMessage(m,z)}),j.onError(z=>{F&&F.onError&&F.onError(z),this.l.$acceptDAError(m,z.name,z.message,z.stack)}),j.onExit(z=>{F&&F.onExit&&F.onExit(z??void 0,void 0),this.l.$acceptDAExit(m,z??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),j.startSession()))})}$sendDAMessage(m,D){D=(0,v.$dH)(D,!1);const p=this.E.get(m);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(D),this.D.get(m)?.sendMessage(D)}$stopDASession(m){const D=this.E.get(m);this.E.delete(m),D&&D.onWillStopSession&&D.onWillStopSession();const p=this.D.get(m);return this.D.delete(m),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const D=[],p=[],E=[];if(m.added)for(const y of m.added){const P=y.id;if(P&&!this.z.has(P)){let I;if(y.type==="function")I=new C.$TN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")I=new C.$UN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const j=L.URI.revive(y.uri);I=new C.$SN(new C.$4M(j,new C.$SM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,C.$QN)(I,P),this.z.set(P,I),D.push(I)}}if(m.removed)for(const y of m.removed){const P=this.z.get(y);P&&(this.z.delete(y),p.push(P))}if(m.changed){for(const y of m.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof C.$TN&&y.type==="function"){const I=P;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.functionName=y.functionName}else if(P instanceof C.$SN&&y.type==="source"){const I=P;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.location=new C.$4M(L.URI.revive(y.uri),new C.$SM(y.line,y.character))}E.push(P)}}}this.gb(D,p,E)}async $acceptStackFrameFocus(m){let D;if(m){const p=await this.hb(m.sessionId);m.kind==="thread"?D=new C.$1N(p.api,m.threadId):D=new C.$ZN(p.api,m.threadId,m.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(m,D,p){return(0,u.$ih)(async()=>{const E=this.bb(m);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return E.provideDebugConfigurations(y,p)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(m,D,p,E){return(0,u.$ih)(async()=>{const y=this.bb(m);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return y.resolveDebugConfiguration(P,p,E)})}$resolveDebugConfigurationWithSubstitutedVariables(m,D,p,E){return(0,u.$ih)(async()=>{const y=this.bb(m);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(P,p,E)})}async $provideDebugAdapter(m,D){const p=this.ab(m);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.hb(D);return this.eb(p,E).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(m){const D=await this.hb(m);this.n.fire(D.api)}async $acceptDebugSessionTerminated(m){const D=await this.hb(m);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(m){this.u=m?await this.hb(m):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(m,D){(await this.hb(m))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(m,D){const E={session:(await this.hb(m)).api,event:D.event,body:D.body};this.w.fire(E)}Z(m){if(m instanceof C.$VN)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof C.$WN)return{type:"server",port:m.port,host:m.host};if(m instanceof C.$XN)return{type:"pipeServer",path:m.path};if(m instanceof C.$YN)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}$(m){const D=this.h.filter(p=>p.type===m);if(D.length>0)return D[0].factory}ab(m){const D=this.h.filter(p=>p.handle===m);if(D.length>0)return D[0].factory}bb(m){const D=this.f.filter(p=>p.handle===m);if(D.length>0)return D[0].provider}cb(m,D){if(m.contributes){const p=m.contributes.debuggers;if(p&&p.length>0){for(const E of p)if(E.label&&E.type&&E.type===D)return!0}}return!1}db(m){const p=m.configuration.type,E=this.k.filter(y=>y.type===p||y.type==="*").map(y=>(0,u.$ih)(()=>y.factory.createDebugAdapterTracker(m.api)).then(P=>P,P=>null));return Promise.race([Promise.all(E).then(y=>{const P=y.filter(I=>!!I);if(P.length>0)return new d(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(m,D){const p=D.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new C.$WN(p));if(m){const y=await this.O.getExtensionRegistry();return(0,u.$ih)(()=>m.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(P=>{if(P)return P})}const E=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,E))}fb(m,D){}gb(m,D,p){(m.length>0||D.length>0||p.length>0)&&this.A.fire(Object.freeze({added:m,removed:D,changed:p}))}async hb(m){if(m)if(typeof m=="string"){const D=this.m.get(m);if(D)return D}else{let D=this.m.get(m.id);if(!D){const p=await this.ib(m.folderUri),E=m.parent?this.m.get(m.parent):void 0;D=new t(this.l,m.id,m.type,m.name,p,m.configuration,E?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(m){if(m){const D=L.URI.revive(m);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(m,D){return`${m}\0${D}`}kb(m,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${m}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(m){const D=this.mb(m);let p,E;return"id"in D?E=n.ThemeIcon.asClassName(D):p=D,{iconPath:p,iconClass:E}}mb(m){if(m instanceof C.$NN)return{id:m.id};const D=typeof m=="object"&&"dark"in m?m.dark:m,p=typeof m=="object"&&"light"in m?m.light:m;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof p=="string"?L.URI.file(p):p}}};e.$9kc=s,e.$9kc=s=Je([qe(0,A.$aP),qe(1,$.$mkc),qe(2,S.$3kc),qe(3,c.$pkc),qe(4,b.$Bkc),qe(5,g.$6kc),qe(6,i.$wP)],s);class t{constructor(m,D,p,E,y,P,I){this.f=m,this.g=D,this.h=p,this.j=E,this.k=y,this.l=P,this.m=I}get api(){const m=this;return this.d??=Object.freeze({id:m.g,type:m.h,get name(){return m.j},set name(D){m.j=D,m.f.$setDebugSessionName(m.g,D)},parentSession:m.m,workspaceFolder:m.k,configuration:m.l,customRequest(D,p){return m.f.$customDebugAdapterRequest(m.g,D,p)},getDebugProtocolBreakpoint(D){return m.f.$getDebugProtocolBreakpoint(m.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(m){this.j=m}get configuration(){return this.l}}e.$0kc=t;class f{constructor(m){this.value=Object.freeze({append(D){m.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$$kc=f;class d{constructor(m){this.d=m}onWillStartSession(){this.d.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(m):void 0)}onWillStopSession(){this.d.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.d.forEach(D=>D.onError?D.onError(m):void 0)}onExit(m,D){this.d.forEach(p=>p.onExit?p.onExit(m,D):void 0)}}class l extends k.$sob{constructor(m){super(),this.h=m,m.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.h.handleMessage(m)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends s{constructor(m,D,p,E,y,P,I){super(m,D,p,E,y,P,I)}};e.$_kc=a,e.$_kc=a=Je([qe(0,A.$aP),qe(1,$.$mkc),qe(2,S.$3kc),qe(3,c.$pkc),qe(4,b.$Bkc),qe(5,g.$6kc),qe(6,i.$wP)],a)}),define(ke[375],Ee([1,0,13,59,2,6,322,12,84,107,28,258,20,67,49,90]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=e.$cmc=void 0;class g{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(w.$Wj),t=i.get($.$aP).getProxy(R.$PM.MainThreadErrors);u.setUnexpectedErrorHandler(f=>{r.error(f);const d=u.$3(f);t.$onUnexpectedError(d)})}static async installFullHandler(i){const r=i.get(w.$Wj),s=i.get($.$aP),t=i.get(v.$3kc),f=i.get(c.$uP),d=s.getProxy(R.$PM.MainThreadExtensionService),l=s.getProxy(R.$PM.MainThreadErrors),a=await t.getExtensionPathIndex(),h=new WeakMap;function m(E,y){if(h.has(E))return h.get(E).stack;let P="",I,j;for(const z of y)P+=`
	at ${z.toString()}`,j=z.getFileName(),!I&&j&&(I=a.findSubstr(L.URI.file(j)));const F=`${E.name||"Error"}: ${E.message||""}${P}`;return h.set(E,{extensionIdentifier:I?.identifier,stack:F}),F}const D=Symbol("prepareStackTrace wrapped");let p=m;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(E){if(E===m||!E||E[D]){p=E||m;return}p=function(y,P){return m(y,P),E.call(Error,y,P)},Object.assign(p,{[D]:!0})}}),u.setUnexpectedErrorHandler(E=>{r.error(E);const y=u.$3(E),P=h.get(E);if(!P?.extensionIdentifier){l.$onUnexpectedError(y);return}d.$onExtensionRuntimeError(P.extensionIdentifier,y);const I=f.onExtensionError(P.extensionIdentifier,E);r.trace("forwarded error to extension?",I,P)})}}e.$cmc=g;class o{constructor(i,r,s,t,f){this.a=s,this.b=new M.$K$b(i,null,t),r=o.e(r,this.b);const d=new S.$oi(...(0,b.$ps)());d.set(A.$qP,{_serviceBrand:void 0,...r,messagePorts:f}),d.set($.$aP,new $.$bP(this.b)),d.set(k.$jkc,new k.$kkc(t)),d.set(v.$1kc,s);const l=new C.$7q(d,!0);l.invokeFunction(g.installEarlyHandler),this.d=l.invokeFunction(a=>a.get(w.$Wj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(a=>a.get(v.$3kc)),this.c.initialize(),l.invokeFunction(g.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(R.$PM.MainThreadExtensionService);return L.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>L.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$dmc=o}),define(ke[376],Ee([1,0,8,11,231,251,141,96,71,49,20,42,7,61,43,295,296,44,33,377]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;let r=class extends w.$9kc{constructor(a,h,m,D,p,E,y,P){super(a,h,m,D,E,y,P),this.pb=p,this.nb=new d}X(a,h){switch(a.type){case"server":return new c.$imc(a);case"pipeServer":return new c.$jmc(a);case"executable":return new c.$kmc(a,h.type)}return super.X(a,h)}fb(a,h){const m=c.$kmc.platformAdapterExecutable(h.getAllExtensionDescriptions(),a.type);if(m)return new $.$VN(m.command,m.args,m.options)}Y(){return new M.$ycc}async $runInTerminal(a,h){if(a.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(T=>{this.nb.onTerminalClosed(T)}));const m=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),p=this.pb.getDefaultShellArgs(!0),E=a.title||L.localize(0,null),y=s(D,p,a);let P=await this.nb.checkout(y,E,!0),I,j=!1;if(P)I=a.cwd;else{const T={shellPath:D,shellArgs:p,cwd:a.cwd,name:E,iconPath:new $.$NN("debug"),env:a.env};j=!0,P=this.pb.createTerminalFromOptions(T,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(P,y)}P.show(!0);const F=await P.processId;j?await new Promise(T=>setTimeout(T,1e3)):(P.state.isInteractedWith&&P.sendText(""),m.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?P.sendText("cls"):D.indexOf("bash")>=0?P.sendText("clear"):N.$i?P.sendText("cls"):P.sendText("clear")));const z=(0,g.$mmc)(D,a.args,!!a.argsCanBeInterpretedByShell,I);P.sendText(z);const O=this.onDidTerminateDebugSession(T=>{T.id===h&&(this.nb.free(P),O.dispose())});return F}else if(a.kind==="external")return f(a,await this.P.getConfigProvider());return super.$runInTerminal(a,h)}};e.$nmc=r,e.$nmc=r=Je([qe(0,A.$aP),qe(1,v.$mkc),qe(2,S.$3kc),qe(3,o.$pkc),qe(4,C.$Nkc),qe(5,b.$Bkc),qe(6,k.$6kc),qe(7,n.$wP)],r);function s(l,a,h){const m=(0,i.createHash)("sha256");return m.update(JSON.stringify({shell:l,shellArgs:a})),m.update(JSON.stringify(Object.entries(h.env||{}).sort(([D],[p])=>D.localeCompare(p)))),m.digest("base64")}let t;function f(l,a){if(!t)if(N.$i)t=new R.$jbc;else if(N.$j)t=new R.$kbc;else if(N.$k)t=new R.$lbc;else throw new Error("external terminals not supported on this platform");const h=a.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,h,m=!1){const p=[...this.b.entries()].map(([E,y])=>(0,u.$dh)(async P=>{if(E.name!==h||y.lastUsedAt!==-1&&await(0,g.$lmc)(await E.processId))return null;const I=Date.now();return y.lastUsedAt+d.a>I||P.isCancellationRequested?null:y.config!==a?(m&&E.dispose(),null):(y.lastUsedAt=I,E)}));return await(0,u.$vh)(p,E=>!!E)}insert(a,h){this.b.set(a,{lastUsedAt:Date.now(),config:h})}free(a){const h=this.b.get(a);h&&(h.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(ke[378],Ee([1,0,17,2,105,43,72,44,41,42,20,28,95,15,12,91,23,64,61]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;let i=class extends $.$Rlc{constructor(s,t,f,d,l,a,h,m,D){super(s,t,f,d,l,a,h,m),this.C=f,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const d=$.TaskHandleDTO.from(f,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(l,t);return this.a.$executeTask(d).catch(()=>{}),a}else{const d=$.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const l=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}v(s,t,f,d){const l=[];if(d)for(const a of d){this.A(a,f),(!a.definition||!s[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(a,f.extension);h&&(l.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,a,!0)))}return{tasks:l,extension:f.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=N.URI.file((0,o.homedir)());t=new b.$Ki({uri:f,name:g.$1g(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=N.URI.revive(s),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(f),a=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),m=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const D of t.variables)d.variables[D]=await h.resolveAsync(m,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let p=0;p<D.length;p++)D[p]=await h.resolveAsync(m,D[p])}d.process=await L.win32.findExecutable(await h.resolveAsync(m,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(m,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return L.win32.findExecutable(s,t,f)}};e.$fmc=i,e.$fmc=i=Je([qe(0,A.$aP),qe(1,C.$qP),qe(2,R.$mkc),qe(3,M.$lP),qe(4,w.$pkc),qe(5,S.$Nkc),qe(6,v.$Wj),qe(7,c.$3jc),qe(8,n.$6kc)],i)}),define(ke[379],Ee([1,0,64,61]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class L extends N.$7kc{m(){return(0,u.homedir)()}}e.$Xmc=L}),define(ke[159],Ee([1,0,19,8,22,47,15,17,23,2,36]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$olc=e.$nlc=void 0,e.$plc=c;class C{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],s=new L.$me(i);return new Promise((t,f)=>{this.a=new k(n);let d=!1;const l=(a,h)=>{if(!d&&!this.b){const m=this.h(a);c(a)&&typeof this.g.maxResults=="number"&&this.c+m>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),a=this.j(a,this.g.maxResults-this.c));const D=this.h(a);this.c+=D,(D>0||!c(a))&&this.a.add(a,h)}};Promise.all(r.map((a,h)=>this.k(a,m=>l(m,h),s.token))).then(a=>{s.dispose(),this.a.flush();const h=a.some(m=>!!m&&!!m.limitHit);t({limitHit:this.b||h,messages:(0,u.$Rb)(a.map(m=>m?.message?Array.isArray(m.message)?m.message:[m.message]:[])),stats:{type:this.f}})},a=>{s.dispose();const h=(0,R.$bj)(a);f(new Error(h))})})}h(n){return c(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const s=new A.$kL(this.g,n),t=[],f={report:a=>{if(!this.l(a))return;const h=n.folder.scheme===M.Schemas.file?(0,A.$lL)(()=>this.e.readdir(b.$3g(a.uri))):void 0,m=b.$6g(n.folder,a.uri);if(m){const D=s.includedInQuery(m,w.$oc(m),h);(0,N.$ch)(D)?t.push(D.then(p=>{p&&i(a)})):D&&i(a)}}},d=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,f,r):l=await this.d.provider.provideTextSearchResults($(this.d.query.contentPattern),d,f,r),t.length&&await Promise.all(t),l}l(n){if(c(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$jL)(this.g.includePattern,n.includePattern),r=(0,A.$jL)(this.g.excludePattern,n.excludePattern),s={folder:S.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$nlc=C;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class k{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new g(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!b.$Wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$olc=k;function v(o){return c(o)?{preview:{matches:(0,u.$2b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,u.$2b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function c(o){return!!o.preview}class g{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qlc=g}),define(ke[97],Ee([1,0,3,6,5,371,20,67,12,2,159]),function(le,e,u,N,L,R,M,w,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=void 0,e.$tlc=$,e.$rlc=(0,L.$qi)("IExtHostSearch");let C=class{constructor(c,g,o){this.n=c,this.o=g,this.q=o,this.c=this.n.getProxy(N.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$mlc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,g){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const o=this.d++;return this.e.set(o,g),this.c.$registerTextSearchProvider(o,this.s(c)),(0,u.$Sc)(()=>{this.g.delete(c),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(c,g){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const o=this.d++;return this.h.set(o,g),this.c.$registerAITextSearchProvider(o,this.s(c)),(0,u.$Sc)(()=>{this.i.delete(c),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(c,g){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const o=this.d++;return this.j.set(o,g),this.c.$registerFileSearchProvider(o,this.s(c)),(0,u.$Sc)(()=>{this.k.delete(c),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(c,g,o,n){const i=$(o),r=this.j.get(c);if(r)return this.l.fileSearch(i,r,s=>{this.c.$handleFileMatch(c,g,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,g,o){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,g,o,n){const i=this.e.get(c);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${c}`);const r=$(o);return this.t(r,i).search(t=>this.c.$handleTextMatch(c,g,t),n)}$provideAITextSearchResults(c,g,o,n){const i=this.h.get(c);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${c}`);const r=$(o);return this.v(r,i).search(t=>this.c.$handleTextMatch(c,g,t),n)}$enableExtensionHostSearch(){}t(c,g){return new A.$nlc({query:c,provider:g},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(c,g){return new A.$nlc({query:c,provider:g},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$slc=C,e.$slc=C=Je([qe(0,M.$aP),qe(1,w.$jkc),qe(2,b.$Wj)],C);function $(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(k),extraFileResources:v.extraFileResources&&v.extraFileResources.map(c=>S.URI.revive(c))}}function k(v){return{...v,folder:S.URI.revive(v.folder)}}}),define(ke[380],Ee([1,0,22,13,4,3,15,40,2,135,198,179,79,25,32,12,86,87,277,6,324,350,91,120,328,329,330,311,300,33,331,44,332,96,151,333,313,325,334,335,72,71,326,49,336,69,337,60,28,351,352,314,338,121,339,115,116,315,370,341,283,342,353,343,157,316,344,345,346,20,347,97,117,348,317,349,118,93,95,90,42,155,354,355,327,356,357,70,16,7,318,67,319,92,358,359,150,43,293,114,26,94]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f,d,l,a,h,m,D,p,E,y,P,I,j,F,z,O,T,B,W,X,x,Z,Y,ce,ne,$e,Pe,_,U,ie,be,Ce,oe,ae,re,G,te,ge,we,Re,fe,Se,Ae,je,q,V,Q,J,he,pe,ze,Ve,Xe,tt,ot,it,st,De,Be,He,Le,Ze,se,ue,Ie,Ge,Me,nt,lt,yt,At,Ft,Qt,xt,Dt,qt,Xt,et,ri){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=_t;function _t(ft){const $t=ft.get($e.$qP),ei=ft.get(ne.$7jc),Zt=ft.get(Y.$rkc),zt=ft.get(x.$3kc),gt=ft.get(Dt.$mkc),Ut=ft.get(st.$uP),Yt=ft.get(E.$pkc),Bt=ft.get(lt.$jkc),xe=ft.get(Q.$aP),oi=ft.get(tt.$Kkc),Vt=ft.get(ot.$skc),Kt=ft.get(c.$Xj),mt=ft.get(c.$Wj),Rt=ft.get(Ie.$oCb),Ot=ft.get(t.$3jc),Nt=ft.get(xt.$9lc),ti=ft.get(pe.$Ukc),Ht=ft.get(W.$Bkc),si=ft.get(ae.$Ykc),Mt=ft.get(f.$akc),Tt=ft.get(be.$Rkc);xe.set(i.$QM.ExtHostFileSystemInfo,ei),xe.set(i.$QM.ExtHostLogLevelServiceShape,Kt),xe.set(i.$QM.ExtHostWorkspace,gt),xe.set(i.$QM.ExtHostConfiguration,Yt),xe.set(i.$QM.ExtHostExtensionService,zt),xe.set(i.$QM.ExtHostStorage,oi),xe.set(i.$QM.ExtHostTunnelService,Rt),xe.set(i.$QM.ExtHostWindow,Nt),xe.set(i.$QM.ExtHostSecretState,ti),xe.set(i.$QM.ExtHostTelemetry,Ut),xe.set(i.$QM.ExtHostEditorTabs,Ht),xe.set(i.$QM.ExtHostManagedSockets,si),xe.set(i.$QM.ExtHostAuthentication,Mt),xe.set(i.$QM.ExtHostChatProvider,Tt);const Pt=xe.set(i.$QM.ExtHostDecorations,ft.get(I.$blc)),It=xe.set(i.$QM.ExtHostDocumentsAndEditors,ft.get(B.$lP)),bt=xe.set(i.$QM.ExtHostCommands,ft.get(D.$wP)),Ct=xe.set(i.$QM.ExtHostTerminalService,ft.get(De.$Nkc)),li=xe.set(i.$QM.ExtHostTerminalShellIntegration,ft.get(Be.$Ulc)),St=xe.set(i.$QM.ExtHostDebugService,ft.get(P.$8kc)),hi=xe.set(i.$QM.ExtHostSearch,ft.get(he.$rlc)),Gt=xe.set(i.$QM.ExtHostTask,ft.get(it.$Tlc)),wi=xe.set(i.$QM.ExtHostOutputService,ft.get(Se.$Glc)),ii=xe.set(i.$QM.ExtHostLocalization,ft.get(oe.$Xkc)),vi=xe.set(i.$QM.ExtHostUrls,new yt.$6lc(xe)),kt=xe.set(i.$QM.ExtHostDocuments,new T.$0jc(xe,It)),$i=xe.set(i.$QM.ExtHostDocumentContentProviders,new z.$dlc(xe,It,mt)),Ne=xe.set(i.$QM.ExtHostDocumentSaveParticipant,new O.$elc(mt,kt,xe.getProxy(i.$PM.MainThreadBulkEdits))),Fe=xe.set(i.$QM.ExtHostNotebook,new G.$ulc(xe,bt,It,kt,Zt,hi)),ye=xe.set(i.$QM.ExtHostNotebookDocuments,new ge.$Alc(Fe)),ee=xe.set(i.$QM.ExtHostNotebookEditors,new we.$Blc(mt,Fe)),Oe=xe.set(i.$QM.ExtHostNotebookKernels,new Re.$Clc(xe,$t,Fe,bt,mt)),Ke=xe.set(i.$QM.ExtHostNotebookRenderers,new fe.$Elc(xe,Fe)),_e=xe.set(i.$QM.ExtHostNotebookDocumentSaveParticipant,new te.$zlc(mt,Fe,xe.getProxy(i.$PM.MainThreadBulkEdits))),Qe=xe.set(i.$QM.ExtHostEditors,new Le.$gkc(xe,It)),ht=xe.set(i.$QM.ExtHostTreeViews,new ue.$4lc(xe.getProxy(i.$PM.MainThreadTreeViews),bt,mt)),Et=xe.set(i.$QM.ExtHostEditorInsets,new m.$hkc(xe.getProxy(i.$PM.MainThreadEditorInsets),Qe,$t.remote)),jt=xe.set(i.$QM.ExtHostDiagnostics,new j.$9jc(xe,mt,ei,It)),Wt=xe.set(i.$QM.ExtHostLanguages,new Ce.$xlc(xe,kt,bt.converter,Bt)),ut=xe.set(i.$QM.ExtHostLanguageFeatures,new ie.$$jc(xe,Bt,kt,bt,jt,mt,Ot,Ut)),ni=xe.set(i.$QM.ExtHostFileSystem,new Z.$glc(xe,ut)),di=xe.set(i.$QM.ExtHostFileSystemEventService,new ce.$hlc(xe,mt,It)),bi=xe.set(i.$QM.ExtHostQuickOpen,(0,V.$Klc)(xe,gt,bt)),Di=xe.set(i.$QM.ExtHostSCM,new J.$Mlc(xe,bt,kt,mt)),Ri=xe.set(i.$QM.ExtHostQuickDiff,new q.$Jlc(xe,Bt)),Mi=xe.set(i.$QM.ExtHostShare,new ze.$Nlc(xe,Bt)),Li=xe.set(i.$QM.ExtHostComments,(0,p.$ikc)(xe,bt,kt)),Ni=xe.set(i.$QM.ExtHostProgress,new je.$Ilc(xe.getProxy(i.$PM.MainThreadProgress))),cn=xe.set(i.$QM.ExtHostLabelService,new U.$wlc(xe)),Oi=xe.set(i.$QM.ExtHostTheming,new Ze.$1lc(xe)),Ti=xe.set(i.$QM.ExtHostTimeline,new se.$3lc(xe,bt)),yi=xe.set(i.$QM.ExtHostWebviews,new At.$wkc(xe,$t.remote,gt,mt,Ot)),Ci=xe.set(i.$QM.ExtHostWebviewPanels,new Ft.$zkc(xe,yi,gt)),Hi=xe.set(i.$QM.ExtHostCustomEditors,new y.$Akc(xe,kt,Vt,yi,Ci)),Gi=xe.set(i.$QM.ExtHostWebviewViews,new Qt.$7lc(xe,yi)),pi=xe.set(i.$QM.ExtHostTesting,new He.$Wlc(xe,mt,bt,It)),Ji=xe.set(i.$QM.ExtHostUriOpeners,new nt.$5lc(xe)),Qi=xe.set(i.$QM.ExtHostProfileContentHandlers,new Ae.$Hlc(xe));xe.set(i.$QM.ExtHostInteractive,new _.$vlc(xe,Fe,It,bt,mt));const un=xe.set(i.$QM.ExtHostInlineChat,new Pe.$ilc(xe,bt,kt,mt)),ji=xe.set(i.$QM.ExtHostChatAgents2,new l.$dkc(xe,mt,bt)),Fi=xe.set(i.$QM.ExtHostChatVariables,new a.$ekc(xe)),Pi=xe.set(i.$QM.ExtHostAiRelatedInformation,new r.$2jc(xe)),ln=xe.set(i.$QM.ExtHostAiEmbeddingVector,new X.$flc(xe)),Xi=xe.set(i.$QM.ExtHostStatusBar,new Xe.$Qlc(xe,bt.converter)),Zi=xe.set(i.$QM.ExtHostSpeech,new Ve.$Olc(xe)),hn=Object.values(i.$QM);xe.assertRegistered(hn);const zi=new d.$ckc(xe,It),Yi=new h.$fkc(xe),Ii=new re.$ylc(xe,mt),Bi=new F.$clc(xe);return s.$_jc.register(bt),function(We,ai,Ui){function at(de){return(ve,Ue,ct)=>{const vt=de(Lt=>{try{ve.call(Ue,Lt)}catch(Si){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Ut.onExtensionError(We.identifier,Si)}});return ct?.push(vt),vt}}const wt=function(){let de=!We.isUnderDevelopment;function ve(){de||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ve();else{const vt=ct;typeof vt.scheme>"u"&&ve(),typeof vt.exclusive=="boolean"&&(0,et.$yG)(We,"documentFiltersExclusive")}return ct}}(),dn={getSession(de,ve,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$yG)(We,"authLearnMore"),Mt.getSession(We,de,ve,Ue)},getSessions(de,ve){return(0,et.$yG)(We,"authGetSessions"),Mt.getSessions(We,de,ve)},async hasSession(de,ve){return(0,et.$yG)(We,"authSession"),!!await Mt.getSession(We,de,ve,{silent:!0})},get onDidChangeSessions(){return at(Mt.onDidChangeSessions)},registerAuthenticationProvider(de,ve,Ue,ct){return Mt.registerAuthenticationProvider(de,ve,Ue,ct)}},ci={registerCommand(de,ve,Ue){return bt.registerCommand(!0,de,ve,Ue,void 0,We)},registerTextEditorCommand(de,ve,Ue){return bt.registerCommand(!0,de,(...ct)=>{const vt=Qe.getActiveTextEditor();if(!vt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}return vt.edit(Lt=>{ve.apply(Ue,[vt,Lt,...ct])}).then(Lt=>{Lt||mt.warn("Edits from command "+de+" were not applied.")},Lt=>{mt.warn("An error occurred while running command "+de,Lt)})},void 0,void 0,We)},registerDiffInformationCommand:(de,ve,Ue)=>((0,et.$yG)(We,"diffCommand"),bt.registerCommand(!0,de,async(...ct)=>{const vt=It.activeEditor(!0);if(!vt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}const Lt=await Qe.getDiffInformation(vt.id);ve.apply(Ue,[Lt,...ct])},void 0,void 0,We)),executeCommand(de,...ve){return bt.executeCommand(de,...ve)},getCommands(de=!1){return bt.getCommands(de)}},ki={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return at(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Ut.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Ut.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$yG)(We,"telemetry"),Ut.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$yG)(We,"telemetry"),at(Ut.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$tP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ve){return st.$sP.validateSender(de),Ut.instantiateLogger(We,de,ve)},openExternal(de,ve){return Nt.openUri(de,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===$t.environment.appUriScheme)return vi.createAppUri(de);try{return await Nt.asExternalUri(de,{allowTunneling:!!$t.remote.authority})}catch(ve){if((0,M.$zg)(de,M.Schemas.http)||(0,M.$zg)(de,M.Schemas.https))return de;throw ve}},get remoteName(){return(0,g.$Cm)($t.remote.authority)},get remoteAuthority(){return(0,et.$yG)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$yG)(We,"resolvers"),$t.quality},get appCommit(){return(0,et.$yG)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(de,ve,Ue){return pi.createTestController(We,de,ve,Ue)},createTestObserver(){return(0,et.$yG)(We,"testObserver"),pi.createTestObserver()},runTests(de){return(0,et.$yG)(We,"testObserver"),pi.runTests(de)},get onDidChangeTestResults(){return(0,et.$yG)(We,"testObserver"),at(pi.onResultsChanged)},get testResults(){return(0,et.$yG)(We,"testObserver"),pi.results}},Ei=$t.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,_i={getExtension(de,ve){(0,et.$xG)(We,"extensionsAny")||(ve=!1);const Ue=ai.mine.getExtensionDescription(de);if(Ue)return new x.$4kc(zt,We.identifier,Ue,Ei,!1);if(ve){const ct=ai.all.getExtensionDescription(de);if(ct)return new x.$4kc(zt,We.identifier,ct,Ei,!0)}},get all(){const de=[];for(const ve of ai.mine.getAllExtensionDescriptions())de.push(new x.$4kc(zt,We.identifier,ve,Ei,!1));return de},get allAcrossExtensionHosts(){(0,et.$yG)(We,"extensionsAny");const de=new k.$Mm(ai.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ve=[];for(const Ue of ai.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ve.push(new x.$4kc(zt,We.identifier,Ue,Ei,ct))}return ve},get onDidChange(){return(0,et.$xG)(We,"extensionsAny")?at(L.Event.any(ai.mine.onDidChange,ai.all.onDidChange)):at(ai.mine.onDidChange)}},en={createDiagnosticCollection(de){return jt.createDiagnosticCollection(We.identifier,de)},get onDidChangeDiagnostics(){return at(jt.onDidChangeDiagnostics)},getDiagnostics:de=>jt.getDiagnostics(de),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(de,ve){return Wt.changeLanguage(de.uri,ve)},match(de,ve){const Ue=Ge.LanguageSelector.from(de);let ct;return(0,A.$Vt)(Ue)&&(ct=Fe.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Lt=>Lt.document===ve))?.apiNotebook),(0,A.$Ut)(Ue,ve.uri,ve.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ve,Ue){return ut.registerCodeActionProvider(We,wt(de),ve,Ue)},registerDocumentPasteEditProvider(de,ve,Ue){return(0,et.$yG)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,wt(de),ve,Ue)},registerCodeLensProvider(de,ve){return ut.registerCodeLensProvider(We,wt(de),ve)},registerDefinitionProvider(de,ve){return ut.registerDefinitionProvider(We,wt(de),ve)},registerDeclarationProvider(de,ve){return ut.registerDeclarationProvider(We,wt(de),ve)},registerImplementationProvider(de,ve){return ut.registerImplementationProvider(We,wt(de),ve)},registerTypeDefinitionProvider(de,ve){return ut.registerTypeDefinitionProvider(We,wt(de),ve)},registerHoverProvider(de,ve){return ut.registerHoverProvider(We,wt(de),ve,We.identifier)},registerEvaluatableExpressionProvider(de,ve){return ut.registerEvaluatableExpressionProvider(We,wt(de),ve,We.identifier)},registerInlineValuesProvider(de,ve){return ut.registerInlineValuesProvider(We,wt(de),ve,We.identifier)},registerDocumentHighlightProvider(de,ve){return ut.registerDocumentHighlightProvider(We,wt(de),ve)},registerMultiDocumentHighlightProvider(de,ve){return ut.registerMultiDocumentHighlightProvider(We,wt(de),ve)},registerLinkedEditingRangeProvider(de,ve){return ut.registerLinkedEditingRangeProvider(We,wt(de),ve)},registerReferenceProvider(de,ve){return ut.registerReferenceProvider(We,wt(de),ve)},registerRenameProvider(de,ve){return ut.registerRenameProvider(We,wt(de),ve)},registerNewSymbolNamesProvider(de,ve){return(0,et.$yG)(We,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(We,wt(de),ve)},registerDocumentSymbolProvider(de,ve,Ue){return ut.registerDocumentSymbolProvider(We,wt(de),ve,Ue)},registerWorkspaceSymbolProvider(de){return ut.registerWorkspaceSymbolProvider(We,de)},registerDocumentFormattingEditProvider(de,ve){return ut.registerDocumentFormattingEditProvider(We,wt(de),ve)},registerDocumentRangeFormattingEditProvider(de,ve){return ut.registerDocumentRangeFormattingEditProvider(We,wt(de),ve)},registerOnTypeFormattingEditProvider(de,ve,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(We,wt(de),ve,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentSemanticTokensProvider(We,wt(de),ve,Ue)},registerDocumentRangeSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,wt(de),ve,Ue)},registerSignatureHelpProvider(de,ve,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,wt(de),ve,Ue):ut.registerSignatureHelpProvider(We,wt(de),ve,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ve,...Ue){return ut.registerCompletionItemProvider(We,wt(de),ve,Ue)},registerInlineCompletionItemProvider(de,ve,Ue){return ve.handleDidShowCompletionItem&&(0,et.$yG)(We,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,et.$yG)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$yG)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,wt(de),ve,Ue)},registerInlineEditProvider(de,ve){return(0,et.$yG)(We,"inlineEdit"),ut.registerInlineEditProvider(We,wt(de),ve)},registerDocumentLinkProvider(de,ve){return ut.registerDocumentLinkProvider(We,wt(de),ve)},registerColorProvider(de,ve){return ut.registerColorProvider(We,wt(de),ve)},registerFoldingRangeProvider(de,ve){return ut.registerFoldingRangeProvider(We,wt(de),ve)},registerSelectionRangeProvider(de,ve){return ut.registerSelectionRangeProvider(We,de,ve)},registerCallHierarchyProvider(de,ve){return ut.registerCallHierarchyProvider(We,de,ve)},registerTypeHierarchyProvider(de,ve){return ut.registerTypeHierarchyProvider(We,de,ve)},setLanguageConfiguration:(de,ve)=>ut.setLanguageConfiguration(We,de,ve),getTokenInformationAtPosition(de,ve){return(0,et.$yG)(We,"tokenInformation"),Wt.tokenAtPosition(de,ve)},registerInlayHintsProvider(de,ve){return ut.registerInlayHintsProvider(We,de,ve)},createLanguageStatusItem(de,ve){return Wt.createLanguageStatusItem(We,de,ve)},registerDocumentDropEditProvider(de,ve,Ue){return ut.registerDocumentOnDropEditProvider(We,de,ve,(0,et.$xG)(We,"documentPaste")?Ue:void 0)}},fn={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(de,ve,Ue){b.URI.isUri(de)&&de.scheme===M.Schemas.vscodeRemote&&!de.authority&&Ot.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(b.URI.isUri(de)?Promise.resolve(Wi.openTextDocument(de)):Promise.resolve(de));return Qe.showTextDocument(ct,ve,Ue)},createTextEditorDecorationType(de){return Qe.createTextEditorDecorationType(We,de)},onDidChangeActiveTextEditor(de,ve,Ue){return at(Qe.onDidChangeActiveTextEditor)(de,ve,Ue)},onDidChangeVisibleTextEditors(de,ve,Ue){return at(Qe.onDidChangeVisibleTextEditors)(de,ve,Ue)},onDidChangeTextEditorSelection(de,ve,Ue){return at(Qe.onDidChangeTextEditorSelection)(de,ve,Ue)},onDidChangeTextEditorOptions(de,ve,Ue){return at(Qe.onDidChangeTextEditorOptions)(de,ve,Ue)},onDidChangeTextEditorVisibleRanges(de,ve,Ue){return at(Qe.onDidChangeTextEditorVisibleRanges)(de,ve,Ue)},onDidChangeTextEditorViewColumn(de,ve,Ue){return at(Qe.onDidChangeTextEditorViewColumn)(de,ve,Ue)},onDidCloseTerminal(de,ve,Ue){return at(Ct.onDidCloseTerminal)(de,ve,Ue)},onDidOpenTerminal(de,ve,Ue){return at(Ct.onDidOpenTerminal)(de,ve,Ue)},onDidChangeActiveTerminal(de,ve,Ue){return at(Ct.onDidChangeActiveTerminal)(de,ve,Ue)},onDidChangeTerminalDimensions(de,ve,Ue){return(0,et.$yG)(We,"terminalDimensions"),at(Ct.onDidChangeTerminalDimensions)(de,ve,Ue)},onDidChangeTerminalState(de,ve,Ue){return at(Ct.onDidChangeTerminalState)(de,ve,Ue)},onDidWriteTerminalData(de,ve,Ue){return(0,et.$yG)(We,"terminalDataWriteEvent"),at(Ct.onDidWriteTerminalData)(de,ve,Ue)},onDidExecuteTerminalCommand(de,ve,Ue){return(0,et.$yG)(We,"terminalExecuteCommandEvent"),at(Ct.onDidExecuteTerminalCommand)(de,ve,Ue)},onDidChangeTerminalShellIntegration(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidChangeTerminalShellIntegration)(de,ve,Ue)},onDidStartTerminalShellExecution(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidStartTerminalShellExecution)(de,ve,Ue)},onDidEndTerminalShellExecution(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidEndTerminalShellExecution)(de,ve,Ue)},get state(){return Nt.getState(We)},onDidChangeWindowState(de,ve,Ue){return at(Nt.onDidChangeWindowState)(de,ve,Ue)},showInformationMessage(de,...ve){return Ii.showMessage(We,w.default.Info,de,ve[0],ve.slice(1))},showWarningMessage(de,...ve){return Ii.showMessage(We,w.default.Warning,de,ve[0],ve.slice(1))},showErrorMessage(de,...ve){return Ii.showMessage(We,w.default.Error,de,ve[0],ve.slice(1))},showQuickPick(de,ve,Ue){return bi.showQuickPick(We,de,ve,Ue)},showWorkspaceFolderPick(de){return bi.showWorkspaceFolderPick(de)},showInputBox(de,ve){return bi.showInput(de,ve)},showOpenDialog(de){return Bi.showOpenDialog(We,de)},showSaveDialog(de){return Bi.showSaveDialog(de)},createStatusBarItem(de,ve,Ue){let ct,vt,Lt;return typeof de=="string"?(ct=de,vt=ve,Lt=Ue):(vt=de,Lt=ve),Xi.createStatusBarEntry(We,ct,vt,Lt)},setStatusBarMessage(de,ve){return Xi.setStatusBarMessage(de,ve)},withScmProgress(de){return Ot.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ni.withProgress(We,{location:Me.ProgressLocation.SourceControl},(ve,Ue)=>de({report(ct){}}))},withProgress(de,ve){return Ni.withProgress(We,de,ve)},createOutputChannel(de,ve){return wi.createOutputChannel(de,ve,We)},createWebviewPanel(de,ve,Ue,ct){return Ci.createWebviewPanel(We,de,ve,Ue,ct)},createWebviewTextEditorInset(de,ve,Ue,ct){return(0,et.$yG)(We,"editorInsets"),Et.createWebviewEditorInset(de,ve,Ue,ct,We)},createTerminal(de,ve,Ue){return typeof de=="object"?"pty"in de?Ct.createExtensionTerminal(de):Ct.createTerminalFromOptions(de):Ct.createTerminal(de,ve,Ue)},registerTerminalLinkProvider(de){return Ct.registerLinkProvider(de)},registerTerminalProfileProvider(de,ve){return Ct.registerProfileProvider(We,de,ve)},registerTerminalQuickFixProvider(de,ve){return(0,et.$yG)(We,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(de,We.identifier.value,ve)},registerTreeDataProvider(de,ve){return ht.registerTreeDataProvider(de,ve,We)},createTreeView(de,ve){return ht.createTreeView(de,ve,We)},registerWebviewPanelSerializer:(de,ve)=>Ci.registerWebviewPanelSerializer(We,de,ve),registerCustomEditorProvider:(de,ve,Ue={})=>Hi.registerCustomEditorProvider(We,de,ve,Ue),registerFileDecorationProvider(de){return Pt.registerFileDecorationProvider(de,We)},registerUriHandler(de){return vi.registerUriHandler(We,de)},createQuickPick(){return bi.createQuickPick(We)},createInputBox(){return bi.createInputBox(We)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(de,ve,Ue){return at(Oi.onDidChangeActiveColorTheme)(de,ve,Ue)},registerWebviewViewProvider(de,ve,Ue){return Gi.registerWebviewViewProvider(We,de,ve,Ue?.webviewOptions)},get activeNotebookEditor(){return Fe.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ve,Ue){return at(Fe.onDidChangeActiveNotebookEditor)(de,ve,Ue)},get visibleNotebookEditors(){return Fe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Fe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ve,Ue){return at(ee.onDidChangeNotebookEditorSelection)(de,ve,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ve,Ue){return at(ee.onDidChangeNotebookEditorVisibleRanges)(de,ve,Ue)},showNotebookDocument(de,ve){return Fe.showNotebookDocument(de,ve)},registerExternalUriOpener(de,ve,Ue){return(0,et.$yG)(We,"externalUriOpener"),Ji.registerExternalUriOpener(We.identifier,de,ve,Ue)},registerProfileContentHandler(de,ve){return(0,et.$yG)(We,"profileContentHandlers"),Qi.registerProfileContentHandler(We,de,ve)},registerQuickDiffProvider(de,ve,Ue,ct){return(0,et.$yG)(We,"quickDiffProvider"),Ri.registerQuickDiffProvider(wt(de),ve,Ue,ct)},get tabGroups(){return Ht.tabGroups},registerShareProvider(de,ve){return(0,et.$yG)(We,"shareProvider"),Mi.registerShareProvider(wt(de),ve)}},Wi={get rootPath(){return Ot.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new N.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(de,ve,...Ue)=>gt.updateWorkspaceFolders(We,de,ve||0,...Ue),onDidChangeWorkspaceFolders:function(de,ve,Ue){return at(gt.onDidChangeWorkspace)(de,ve,Ue)},asRelativePath:(de,ve)=>gt.getRelativePath(de,ve),findFiles:(de,ve,Ue,ct)=>gt.findFiles(de,ve,Ue,We.identifier,ct),findFiles2:(de,ve,Ue)=>((0,et.$yG)(We,"findFiles2"),gt.findFiles2(de,ve,We.identifier,Ue)),findTextInFiles:(de,ve,Ue,ct)=>{(0,et.$yG)(We,"findTextInFiles");let vt,Lt;return typeof ve=="object"?(vt=ve,Lt=Ue):(vt={},Lt=ve,ct=Ue),gt.findTextInFiles(de,vt||{},Lt,We.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,ve){return zi.applyWorkspaceEdit(de,We,ve)},createFileSystemWatcher:(de,ve,Ue,ct)=>{let vt;return typeof ve=="boolean"?vt={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ve&&((0,et.$yG)(We,"createFileSystemWatcher"),vt={...ve,correlate:!0}),di.createFileSystemWatcher(gt,We,de,vt)},get textDocuments(){return kt.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new N.$9("textDocuments")},openTextDocument(de){let ve;const Ue=de;if(typeof de=="string")ve=Promise.resolve(b.URI.file(de));else if(b.URI.isUri(de))ve=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ve=kt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ct=>(ct.scheme===M.Schemas.vscodeRemote&&!ct.authority&&Ot.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),kt.ensureDocumentData(ct).then(vt=>vt.document)))},onDidOpenTextDocument:(de,ve,Ue)=>at(kt.onDidAddDocument)(de,ve,Ue),onDidCloseTextDocument:(de,ve,Ue)=>at(kt.onDidRemoveDocument)(de,ve,Ue),onDidChangeTextDocument:(de,ve,Ue)=>at(kt.onDidChangeDocument)(de,ve,Ue),onDidSaveTextDocument:(de,ve,Ue)=>at(kt.onDidSaveDocument)(de,ve,Ue),onWillSaveTextDocument:(de,ve,Ue)=>at(Ne.getOnWillSaveTextDocumentEvent(We))(de,ve,Ue),get notebookDocuments(){return Fe.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ve){let Ue;if(b.URI.isUri(de))Ue=de,await Fe.openNotebookDocument(de);else if(typeof de=="string")Ue=b.URI.revive(await Fe.createNotebookDocument({viewType:de,content:ve}));else throw new Error("Invalid arguments");return Fe.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ve,Ue){return at(ye.onDidSaveNotebookDocument)(de,ve,Ue)},onDidChangeNotebookDocument(de,ve,Ue){return at(ye.onDidChangeNotebookDocument)(de,ve,Ue)},onWillSaveNotebookDocument(de,ve,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(We))(de,ve,Ue)},get onDidOpenNotebookDocument(){return at(Fe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Fe.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ve,Ue,ct){return Fe.registerNotebookSerializer(We,de,ve,Ue,(0,et.$xG)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ve,Ue)=>at(Ui.onDidChangeConfiguration)(de,ve,Ue),getConfiguration(de,ve){return ve=arguments.length===1?void 0:ve,Ui.getConfiguration(de,ve,We)},registerTextDocumentContentProvider(de,ve){return $i.registerTextDocumentContentProvider(de,ve)},registerTaskProvider:(de,ve)=>(Ot.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(We,de,ve)),registerFileSystemProvider(de,ve,Ue){return(0,R.$Rc)(ni.registerFileSystemProvider(We,de,ve,Ue),Zt.addFileSystemProvider(de,ve,Ue))},get fs(){return Zt.value},registerFileSearchProvider:(de,ve)=>((0,et.$yG)(We,"fileSearchProvider"),hi.registerFileSearchProvider(de,ve)),registerTextSearchProvider:(de,ve)=>((0,et.$yG)(We,"textSearchProvider"),hi.registerTextSearchProvider(de,ve)),registerAITextSearchProvider:(de,ve)=>((0,et.$yG)(We,"aiTextSearchProvider"),(0,et.$yG)(We,"textSearchProvider"),hi.registerAITextSearchProvider(de,ve)),registerRemoteAuthorityResolver:(de,ve)=>((0,et.$yG)(We,"resolvers"),zt.registerRemoteAuthorityResolver(de,ve)),registerResourceLabelFormatter:de=>((0,et.$yG)(We,"resolvers"),cn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$yG)(We,"resolvers"),zt.getRemoteExecServer(de)),onDidCreateFiles:(de,ve,Ue)=>at(di.onDidCreateFile)(de,ve,Ue),onDidDeleteFiles:(de,ve,Ue)=>at(di.onDidDeleteFile)(de,ve,Ue),onDidRenameFiles:(de,ve,Ue)=>at(di.onDidRenameFile)(de,ve,Ue),onWillCreateFiles:(de,ve,Ue)=>at(di.getOnWillCreateFileEvent(We))(de,ve,Ue),onWillDeleteFiles:(de,ve,Ue)=>at(di.getOnWillDeleteFileEvent(We))(de,ve,Ue),onWillRenameFiles:(de,ve,Ue)=>at(di.getOnWillRenameFileEvent(We))(de,ve,Ue),openTunnel:de=>((0,et.$yG)(We,"tunnels"),Rt.openTunnel(We,de).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,et.$yG)(We,"tunnels"),Rt.getTunnels()},onDidChangeTunnels:(de,ve,Ue)=>((0,et.$yG)(We,"tunnels"),at(Rt.onDidChangeTunnels)(de,ve,Ue)),registerPortAttributesProvider:(de,ve)=>((0,et.$yG)(We,"portsAttributes"),Rt.registerPortsAttributesProvider(de,ve)),registerTunnelProvider:(de,ve)=>((0,et.$yG)(We,"tunnelFactory"),Rt.registerTunnelProvider(de,ve)),registerTimelineProvider:(de,ve)=>((0,et.$yG)(We,"timeline"),Ti.registerTimelineProvider(de,ve,We.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$yG)(We,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ve,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,ve,Ue),registerEditSessionIdentityProvider:(de,ve)=>((0,et.$yG)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,ve)),onWillCreateEditSessionIdentity:(de,ve,Ue)=>((0,et.$yG)(We,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(We))(de,ve,Ue)),registerCanonicalUriProvider:(de,ve)=>((0,et.$yG)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,ve)),getCanonicalUri:(de,ve,Ue)=>((0,et.$yG)(We,"canonicalUriProvider"),gt.provideCanonicalUri(de,ve,Ue))},tn={get inputBox(){return Ot.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(We)},createSourceControl(de,ve,Ue){return Di.createSourceControl(We,de,ve,Ue)}},gn={createCommentController(de,ve){return Li.createCommentController(We,de,ve)}},mn={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){if((0,et.$xG)(We,"debugFocus"))return St.activeStackItem},registerDebugVisualizationProvider(de,ve){return(0,et.$yG)(We,"debugVisualization"),St.registerDebugVisualizationProvider(We,de,ve)},registerDebugVisualizationTreeProvider(de,ve){return(0,et.$yG)(We,"debugVisualization"),St.registerDebugVisualizationTree(We,de,ve)},onDidStartDebugSession(de,ve,Ue){return at(St.onDidStartDebugSession)(de,ve,Ue)},onDidTerminateDebugSession(de,ve,Ue){return at(St.onDidTerminateDebugSession)(de,ve,Ue)},onDidChangeActiveDebugSession(de,ve,Ue){return at(St.onDidChangeActiveDebugSession)(de,ve,Ue)},onDidReceiveDebugSessionCustomEvent(de,ve,Ue){return at(St.onDidReceiveDebugSessionCustomEvent)(de,ve,Ue)},onDidChangeBreakpoints(de,ve,Ue){return at(St.onDidChangeBreakpoints)(de,ve,Ue)},onDidChangeActiveStackItem(de,ve,Ue){return(0,et.$yG)(We,"debugFocus"),at(St.onDidChangeActiveStackItem)(de,ve,Ue)},registerDebugConfigurationProvider(de,ve,Ue){return St.registerDebugConfigurationProvider(de,ve,Ue||qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ve){return St.registerDebugAdapterDescriptorFactory(We,de,ve)},registerDebugAdapterTrackerFactory(de,ve){return St.registerDebugAdapterTrackerFactory(de,ve)},startDebugging(de,ve,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?St.startDebugging(de,ve,{parentSession:Ue}):St.startDebugging(de,ve,Ue||{})},stopDebugging(de){return St.stopDebugging(de)},addBreakpoints(de){return St.addBreakpoints(de)},removeBreakpoints(de){return St.removeBreakpoints(de)},asDebugSourceUri(de,ve){return St.asDebugSourceUri(de,ve)}},nn={registerTaskProvider:(de,ve)=>Gt.registerTaskProvider(We,de,ve),fetchTasks:de=>Gt.fetchTasks(de),executeTask:de=>Gt.executeTask(We,de),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(de,ve,Ue)=>at(Gt.onDidStartTask)(de,ve,Ue),onDidEndTask:(de,ve,Ue)=>at(Gt.onDidEndTask)(de,ve,Ue),onDidStartTaskProcess:(de,ve,Ue)=>at(Gt.onDidStartTaskProcess)(de,ve,Ue),onDidEndTaskProcess:(de,ve,Ue)=>at(Gt.onDidEndTaskProcess)(de,ve,Ue)},qi={createNotebookController(de,ve,Ue,ct,vt){return Oe.createNotebookController(We,de,ve,Ue,ct,(0,et.$xG)(We,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ve)=>Fe.registerNotebookCellStatusBarItemProvider(We,de,ve),createRendererMessaging(de){return Ke.createRendererMessaging(We,de)},createNotebookControllerDetectionTask(de){return(0,et.$yG)(We,"notebookKernelSource"),Oe.createNotebookControllerDetectionTask(We,de)},registerKernelSourceActionProvider(de,ve){return(0,et.$yG)(We,"notebookKernelSource"),Oe.registerKernelSourceActionProvider(We,de,ve)},onDidChangeNotebookCellExecutionState(de,ve,Ue){return(0,et.$yG)(We,"notebookCellExecutionState"),at(Oe.onDidChangeNotebookCellExecutionState)(de,ve,Ue)}},rn={t(...de){if(typeof de[0]=="string"){const ve=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return ii.getMessage(We.identifier.value,{message:ve,args:Ue})}return ii.getMessage(We.identifier.value,de[0])},get bundle(){return ii.getBundle(We.identifier.value)},get uri(){return ii.getBundleUri(We.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(de,ve){return(0,et.$yG)(We,"interactive"),un.registerProvider(We,de,ve)},transferActiveChat(de){return(0,et.$yG)(We,"interactive"),ji.transferActiveChat(de)}},on={getRelatedInformation(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),Pi.getRelatedInformation(We,de,ve)},registerRelatedInformationProvider(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(We,de,ve)},registerEmbeddingVectorProvider(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(We,de,ve)}},$n={registerChatResponseProvider(de,ve,Ue){return(0,et.$yG)(We,"chatProvider"),Tt.registerLanguageModel(We,de,ve,Ue)},registerChatVariableResolver(de,ve,Ue){return(0,et.$yG)(We,"chatVariableResolver"),Fi.registerVariableResolver(We,de,ve,Ue)},registerMappedEditsProvider(de,ve){return(0,et.$yG)(We,"mappedEditsProvider"),ut.registerMappedEditsProvider(We,de,ve)},createChatParticipant(de,ve){return(0,et.$yG)(We,"chatParticipant"),ji.createChatAgent(We,de,ve)},createDynamicChatParticipant(de,ve,Ue,ct){return(0,et.$yG)(We,"chatParticipantAdditions"),ji.createDynamicChatAgent(We,de,ve,Ue,ct)}},bn={get languageModels(){return(0,et.$yG)(We,"languageModels"),Tt.getLanguageModelIds()},onDidChangeLanguageModels:(de,ve,Ue)=>((0,et.$yG)(We,"languageModels"),Tt.onDidChangeProviders(de,ve,Ue)),sendChatRequest(de,ve,Ue,ct){return(0,et.$yG)(We,"languageModels"),Tt.sendChatRequest(We,de,ve,Ue,ct)}},an={registerSpeechProvider(de,ve){return(0,et.$yG)(We,"speech"),Zi.registerProvider(We.identifier,de,ve)}};return{version:$t.version,ai:on,authentication:dn,commands:ci,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:bn,notebooks:qi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:Me.$RN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$MO,CallHierarchyIncomingCall:Me.$dN,CallHierarchyItem:Me.$cN,CallHierarchyOutgoingCall:Me.$eN,CancellationError:N.$5,CancellationTokenSource:u.$me,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$_M,CodeActionKind:Me.$aN,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$fN,Color:Me.$sN,ColorInformation:Me.$tN,ColorPresentation:Me.$uN,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$mN,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$nN,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$CN,DebugAdapterExecutable:Me.$VN,DebugAdapterInlineImplementation:Me.$YN,DebugAdapterNamedPipeServer:Me.$XN,DebugAdapterServer:Me.$WN,DebugConfigurationProviderTriggerKind:qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$cO,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$6M,DiagnosticRelatedInformation:Me.$5M,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$RM,DocumentHighlight:Me.$8M,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$9M,DocumentLink:Me.$rN,DocumentSymbol:Me.$$M,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$2N,InlineValueText:Me.$3N,InlineValueVariableLookup:Me.$4N,InlineValueEvaluatableExpression:Me.$5N,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:L.$be,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$eO,FileDecoration2:Me.$eO,FileSystemError:Me.$8N,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Me.$9N,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$TN,InlineCompletionItem:Me.$oN,InlineCompletionList:Me.$pN,Hover:Me.$7M,IndentAction:C.IndentAction,Location:Me.$4M,MarkdownString:Me.$gN,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Me.$hN,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$SM,ProcessExecution:Me.$AN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$dO,Range:Me.$TM,RelativePattern:Me.$PN,Selection:Me.$UM,SelectionRange:Me.$bN,SemanticTokens:Me.$_N,SemanticTokensBuilder:Me.$$N,SemanticTokensEdit:Me.$aO,SemanticTokensEdits:Me.$bO,SemanticTokensLegend:Me.$0N,ShellExecution:Me.$BN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$jN,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$iN,SnippetString:Me.$3M,SourceBreakpoint:Me.$SN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$0M,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$DN,TaskGroup:Me.$zN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$vN,TerminalQuickFixTerminalCommand:Me.$xN,TerminalQuickFixOpener:Me.$wN,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$yN,TerminalExitReason:Me.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Me.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$YM,SnippetTextEdit:Me.$1M,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$ON,ThemeIcon:Me.$NN,TreeItem:Me.$EN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$AO,UIKind:Xt.UIKind,Uri:b.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$2M,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$KN,DocumentDropOrPasteEditKind:Me.$LN,DocumentPasteEdit:Me.$MN,InlayHint:Me.$lN,InlayHintLabelPart:Me.$kN,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$XM,ResolvedAuthority:Me.$VM,ManagedResolvedAuthority:Me.$WM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$oO,NotebookRange:Me.$gO,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$hO,NotebookData:Me.$iO,NotebookRendererScript:Me.$mO,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$kO,NotebookCellOutputItem:Me.$jO,NotebookCellStatusBarItem:Me.$lO,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$ZM,NotebookKernelSourceAction:Me.$nO,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$qO,LinkedEditingRanges:Me.$pO,TestResultState:Me.TestResultState,TestRunRequest:Me.$rO,TestMessage:Me.$sO,TestTag:Me.$tO,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:ri.TextSearchCompleteMessageType,DataTransfer:Me.$JN,DataTransferItem:Me.$FN,TestCoverageCount:Me.$uO,FileCoverage:Me.$wO,StatementCoverage:Me.$xO,BranchCoverage:Me.$yO,DeclarationCoverage:Me.$zO,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$BO,TabInputTextDiff:Me.$CO,TabInputTextMerge:Me.$DO,TabInputCustom:Me.$EO,TabInputNotebook:Me.$GO,TabInputNotebookDiff:Me.$HO,TabInputWebview:Me.$FO,TabInputTerminal:Me.$IO,TabInputInteractiveWindow:Me.$JO,TabInputChat:Me.$KO,TabInputTextMultiDiff:Me.$LO,TelemetryTrustedValue:o.$_o,LogLevel:c.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$ZN,Thread:Me.$1N,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$NO,ChatResponseFileTreePart:Me.$OO,ChatResponseAnchorPart:Me.$PO,ChatResponseProgressPart:Me.$QO,ChatResponseReferencePart:Me.$SO,ChatResponseTextEditPart:Me.$TO,ChatResponseCommandButtonPart:Me.$RO,ChatRequestTurn:Me.$UO,ChatResponseTurn:Me.$VO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$WO,LanguageModelChatUserMessage:Me.$XO,LanguageModelChatAssistantMessage:Me.$YO,LanguageModelSystemMessage:Me.$WO,LanguageModelUserMessage:Me.$XO,LanguageModelAssistantMessage:Me.$YO,LanguageModelError:Me.$ZO,NewSymbolName:Me.$7N,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$1O,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ke[381],Ee([1,0,84,157,43,151,44,33,72,42,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f,d,l,a,h,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$os)(l.$Xkc,l.$Wkc,1),(0,u.$os)(f.$Xj,t.$$lc,1),(0,u.$os)(c.$3jc,c.$4jc,1),(0,u.$os)(w.$wP,w.$vP,0),(0,u.$os)(h.$akc,h.$bkc,0),(0,u.$os)(m.$Rkc,m.$Skc,0),(0,u.$os)(M.$pkc,M.$nkc,0),(0,u.$os)(o.$rkc,o.$qkc,0),(0,u.$os)(C.$8kc,C.$_kc,0),(0,u.$os)(R.$blc,R.$alc,0),(0,u.$os)(b.$lP,b.$kP,0),(0,u.$os)(a.$Ykc,a.$Zkc,0),(0,u.$os)(n.$7jc,n.$6jc,0),(0,u.$os)(N.$Glc,N.$Flc,1),(0,u.$os)($.$rlc,$.$slc,0),(0,u.$os)(k.$Kkc,k.$Jkc,0),(0,u.$os)(A.$Tlc,A.$Slc,0),(0,u.$os)(S.$Nkc,S.$Qkc,0),(0,u.$os)(D.$Ulc,D.$Vlc,0),(0,u.$os)(v.$oCb,v.$pCb,0),(0,u.$os)(g.$9lc,g.$8lc,0),(0,u.$os)(L.$mkc,L.$lkc,0),(0,u.$os)(i.$Ukc,i.$Tkc,0),(0,u.$os)(r.$uP,r.$rP,0),(0,u.$os)(s.$Bkc,s.$Ckc,0),(0,u.$os)(d.$6kc,d.$7kc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0,e.$omc=M,e.$pmc=w;function M(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}function w(C,$,k,v){const c=(0,u.$2b)(k,b),g=new L.$9K($,c,v),o=g.preview.matches;return{ranges:(0,u.$2b)(c,S),uri:C,preview:{text:g.preview.text,matches:(0,u.$2b)(o,S)}}}function b(C){return new L.$0K(C.start.line,C.start.character,C.end.line,C.end.character)}function S(C){return new R.$XK(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor($,k){this.a=$,this.b=k}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$qmc=A,e.$qmc=A=Je([qe(1,N.$Wj)],A)}),define(ke[382],Ee([1,0,53,17,76,34,11,14,122,383]),function(le,e,u,N,L,R,M,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=C,e.$smc=g,e.$tmc=n;const A=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(i,r,s,t){const f=$(i,r,s,t),d=r.folder.fsPath;return{cmd:u.spawn(A,f.args,{cwd:d}),rgDiskPath:A,siblingClauses:f.siblingClauses,rgArgs:f,cwd:d}}function $(i,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];v([r],s,!1).forEach(l=>{const a=(0,b.$omc)(l);if(f.push("-g",a),M.$j){const h=(0,L.$9l)(a);h!==a&&f.push("-g",h)}});const d=k([r],t,void 0,!1);return d.globArgs.forEach(l=>{const a=`!${(0,b.$omc)(l)}`;if(f.push("-g",a),M.$j){const h=(0,L.$9l)(a);h!==a&&f.push("-g",h)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:d.siblingClauses}}function k(i,r,s,t=!0){const f=[];let d={};return i.forEach(l=>{const a=Object.assign({},l.excludePattern||{},r||{}),h=c(a,t?l.folder.fsPath:void 0,s);f.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:f,siblingClauses:d}}function v(i,r,s=!0){const t=[];return i.forEach(f=>{const d=Object.assign({},r||{},f.includePattern||{}),l=c(d,s?f.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function c(i,r,s){const t=[],f={};return Object.keys(i).forEach(d=>{if(s&&s.has(d)||!d)return;const l=i[d];d=o(r?g(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(f[d]=l)}),{globArgs:t,siblingClauses:f}}function g(i,r){return N.$jc(r)?r:N.$kc(i,r)}function o(i){return i=w.$bf(i,"\\"),w.$bf(i,"/")}function n(i){return R.$mg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[384],Ee([1,0,53,52,17,385,19,47,35,76,34,11,39,14,18,31,36,382,132]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=e.$umc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&b.$kk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$pr)(this.b).normalizedLowercase),this.u=l.excludePattern&&b.$kk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),m=a.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==m).forEach(D=>{(0,A.$qg)(D,m)&&(h[L.$mc(m,D)]=!0)}),this.t.set(m,new t(h,m))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,a,h,m,D){if(this.m=$.$0d.create(!1),this.l)return D(null,this.j);a.forEach(p=>{const E=L.$oc(p.fsPath);this.u&&this.u(p.fsPath,E)||this.J(h,{relativePath:p.fsPath,searchPath:void 0})}),this.r=$.$0d.create(!1),this.w(l,(p,E)=>{this.x(this.y,this,p,h,m,y=>{if(y){const P=(0,w.$bj)(y);console.error(P),this.q.push(P),E(y,void 0)}else E(null,void 0)})},(p,E)=>{this.m.stop();const y=p?M.$Hb(p)[0]:null;D(y,this.j)})}w(l,a,h){const m=new Array(l.length),D=new Array(l.length);let p=!1,E=0;if(l.length===0)return h(null,[]);l.forEach((y,P)=>{a(y,(I,j)=>{if(I?(p=!0,m[P]=null,D[P]=I):(m[P]=j,D[P]=null),++E===l.length)return h(p?D:null,m)})})}x(l,a,...h){try{l.apply(a,h)}catch(m){h[h.length-1](m)}}y(l,a,h,m){const D=l.folder.fsPath,p=C.$j,E=()=>F&&F.kill();i.add(E);let y=B=>{i.delete(E),y=()=>{},m(B)},P="";const I=this.D(),j=(0,o.$rmc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),F=j.cmd,z=!Object.keys(j.siblingClauses).length,O=j.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let T=`${j.rgDiskPath} ${O}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(F,"utf8",h,(B,W,X)=>{if(B){y(B);return}if(this.j){y();return}const Z=(P+(p?S.$8l(W||""):W)).split(`
`);if(X){const Y=Z.length;Z[Y-1]=Z[Y-1].trim(),Z[Y-1]||Z.pop()}else P=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Z.length,z){for(const Y of Z)if(this.J(a,{base:D,relativePath:Y,searchPath:this.N(l,Y)}),this.j){E();break}(X||this.j)&&y();return}this.G(l,I,D,Z,a),X&&(this.H(I,D,a),y())})}spawnFindCmd(l){const a=this.t.get(l.folder.fsPath),h=a.getBasenameTerms(),m=a.getPathTerms(),D=["-L","."];if(h.length||m.length){D.push("-not","(","(");for(const p of h)D.push("-name",p),D.push("-o");for(const p of m)D.push("-path",p),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,a,h){let m="";this.z(l,a,()=>{},(D,p,E)=>{if(D){h(D);return}m+=p,E&&h(null,m)})}z(l,a,h,m){let D=(y,P,I)=>{(y||I)&&(D=()=>{},this.r?.stop()),m(y,P,I)},p=!1;l.stdout?(this.A(l.stdout,a,D),l.stdout.once("data",()=>p=!0)):h({message:"stdout is null"});let E;l.stderr?E=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",y=>{D(y)}),l.on("close",y=>{let P;!p&&(P=this.C(E,a))&&f(P)?D(new Error(`command failed with error code ${y}: ${this.C(E,a)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(l,a,h){const m=new R.StringDecoder(a);return l.on("data",D=>{h(null,m.write(D))}),m}B(l){const a=[];return l.on("data",h=>{a.push(h)}),a}C(l,a){const h=new R.StringDecoder(a);return l.map(m=>h.write(m)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:a},h,m,D){m.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const p=E=>{const y=L.$oc(E),P=L.$nc(E);let I=a[P];I||(I=a[P]=[],p(P)),I.push({base:h,relativePath:E,basename:y,searchPath:this.N(l,E)})};m.forEach(p)}H({rootEntries:l,pathToEntries:a},h,m){const D=this,p=this.t.get(h),E=this.b;function y(P){D.o++;const I=(0,g.$mL)(()=>P.map(j=>j.basename));for(let j=0,F=P.length;j<F;j++){const z=P[j],{relativePath:O,basename:T}=z;if(p.test(O,T,E!==T?I:void 0))continue;const B=a[O];if(B)y(B);else{if(D.p++,O===E)continue;D.J(m,z)}if(D.j)break}}y(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,a,h,m,D){const p=l.folder,E=(0,g.$mL)(()=>h);this.w(h,(y,P)=>{if(this.l||this.j)return P(null);const I=a?[a,y].join(L.sep):y;if(this.t.get(l.folder.fsPath).test(I,y,this.a.filePattern!==y?E:void 0))return P(null);const j=[p.fsPath,I].join(L.sep);N.lstat(j,(F,z)=>{if(F||this.l||this.j)return P(null);this.L(j,z,(O,T)=>O||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(j,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?P(null):(this.v[W]=!0,c.Promises.readdir(j).then(X=>{if(this.l||this.j)return P(null);this.I(l,I,X,m,x=>P(x||null))},X=>{P(null)})))):(this.p++,I===this.b||this.h&&v.$8f(T.size)&&T.size>this.h||this.J(m,{base:p.fsPath,relativePath:I,searchPath:this.N(l,I)}),P(null,void 0)))})},y=>{const P=y&&M.$Hb(y);return D(P&&P.length>0?P[0]:void 0)})}J(l,a){this.K(a)&&(!this.d||this.d(a.relativePath,L.$oc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(a))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$hL)(l,this.c);if(this.b)return(0,g.$hL)(l,this.b,!1)}return!0}L(l,a,h){return a.isSymbolicLink()?N.stat(l,h):h(null,a)}M(l,a,h){return a.isSymbolicLink()?N.realpath(l,(m,D)=>m?h(m):h(null,D)):h(null,l)}N(l,a){return l.folderName?L.$kc(l.folderName,a):a}}e.$umc=r;class s{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,a,h){this.c.walk(this.a,this.b,l,a,(m,D)=>{h(m,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$vmc=s;class t{constructor(l,a){this.expression=l,this.c=a,this.d(l)}d(l){let a,h;Object.keys(l).filter(m=>l[m]).forEach(m=>{L.$jc(m)?(a=a||b.$fk(),a[m]=l[m]):(h=h||b.$fk(),h[m]=l[m])}),this.a=a&&b.$kk(a,{trimForExclusions:!0}),this.b=h&&b.$kk(h,{trimForExclusions:!0})}test(l,a,h){return this.b&&this.b(l,a,h)||this.a&&this.a(L.$kc(this.c,l),a,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...b.$mk(this.a)),this.b&&l.push(...b.$mk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...b.$nk(this.a)),this.b&&l.push(...b.$nk(this.b)),l}}function f(d){const l=d.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return k.$Vf(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(ke[386],Ee([1,0,98,21,193,22]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$1D=e.DecodeStreamErrorKind=e.$ZD=e.$YD=e.$XD=e.$VD=e.$UD=e.$TD=e.$SD=void 0,e.$WD=M,e.$2D=v,e.$3D=c,e.$4D=g,e.$5D=o,e.$6D=n,e.$7D=d,e.$8D=l,e.$SD="utf8",e.$TD="utf8bom",e.$UD="utf16be",e.$VD="utf16le";function M(a){return[e.$SD,e.$TD,e.$UD,e.$VD].some(h=>h===a)}e.$XD=[254,255],e.$YD=[255,254],e.$ZD=[239,187,191];const w=512,b=512,S=512*8,A=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class $ extends Error{constructor(h,m){super(h),this.decodeStreamErrorKind=m}}e.$1D=$;class k{static async create(h){let m;if(h!==e.$SD)m=(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const D=new TextDecoder;m={write(p){return D.decode(p,{stream:!0})},end(){return D.decode()}}}return new k(m)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function v(a,h){const m=h.minBytesRequiredForDetection??h.guessEncoding?S:b;return new Promise((D,p)=>{const E=(0,u.$qe)(z=>z.join("")),y=[];let P=0,I;const j=new R.$me,F=async()=>{try{const z=await l({buffer:N.$Ce.concat(y),bytesRead:P},h.guessEncoding);if(z.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);z.encoding=await h.overwriteEncoding(z.encoding),I=await k.create(z.encoding);const O=I.write(N.$Ce.concat(y).buffer);E.write(O),y.length=0,P=0,D({stream:E,detected:z})}catch(z){j.cancel(),E.destroy(),p(z)}};(0,u.$ue)(a,{onData:async z=>{I?E.write(I.write(z.buffer)):(y.push(z),P+=z.byteLength,P>=m&&(a.pause(),await F(),setTimeout(()=>a.resume())))},onError:z=>E.error(z),onEnd:async()=>{I||await F(),E.end(I?.end())}},j.token)})}async function c(a,h,m){const p=(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),m);let E=!1,y=!1;return{read(){if(y)return null;const P=a.read();if(typeof P!="string"){if(y=!0,!E&&m?.addBOM)switch(h){case e.$SD:case e.$TD:return N.$Ce.wrap(Uint8Array.from(e.$ZD));case e.$UD:return N.$Ce.wrap(Uint8Array.from(e.$XD));case e.$VD:return N.$Ce.wrap(Uint8Array.from(e.$YD))}const I=p.end();return I&&I.length>0?(E=!0,N.$Ce.wrap(I)):null}return E=!0,N.$Ce.wrap(p.write(P))}}}async function g(a){return(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}function o(a){return a===e.$TD||a===null?e.$SD:a}function n(a,h){if(!a||h<e.$XD.length)return null;const m=a.readUInt8(0),D=a.readUInt8(1);if(m===e.$XD[0]&&D===e.$XD[1])return e.$UD;if(m===e.$YD[0]&&D===e.$YD[1])return e.$VD;if(h<e.$ZD.length)return null;const p=a.readUInt8(2);return m===e.$ZD[0]&&D===e.$ZD[1]&&p===e.$ZD[2]?e.$TD:null}const i=["ascii","utf-16","utf-32"];async function r(a){const h=await(0,L.$RD)("jschardet","dist/jschardet.min.js"),m=a.slice(0,A),D=f(m.buffer),p=h.detect(D);if(!p||!p.encoding)return null;const E=p.encoding.toLowerCase();return 0<=i.indexOf(E)?null:t(p.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(a){const h=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[h]||h}function f(a){let h="";for(let m=0;m<a.length;m++)h+=String.fromCharCode(a[m]);return h}function d(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=a.match(/windows(\d+)/);return h?"windows-"+h[1]:a}}}function l({buffer:a,bytesRead:h},m){let D=n(a,h),p=!1;if(D!==e.$UD&&D!==e.$VD&&a){let E=!0,y=!0,P=!1;for(let I=0;I<h&&I<w;I++){const j=I%2===1,F=a.readUInt8(I)===0;if(F&&(P=!0),E&&(j&&!F||!j&&F)&&(E=!1),y&&(j&&F||!j&&!F)&&(y=!1),F&&!E&&!y)break}P&&(E?D=e.$VD:y?D=e.$UD:p=!0)}return m&&!p&&!D&&a?r(a.slice(0,h)).then(E=>({seemsBinary:!1,encoding:E})):{seemsBinary:p,encoding:D}}e.$9D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Ee([1,0,386,31,159]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class R extends L.$nlc{constructor(w,b,S=N,A="searchProcess"){super({query:w,provider:b},{readdir:C=>S.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,u.$7D)(C)},A)}}e.$Dmc=R}),define(ke[161],Ee([1,0,53,402,385,19,73,35,14,2,36,94,403,383,122]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=e.$wmc=void 0,e.$ymc=t,e.$zmc=d,e.$Amc=a,e.$Bmc=h,e.$Cmc=D;const c=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(E){this.a=E}provideTextSearchResults(E,y,P,I){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((j,F)=>{I.onCancellationRequested(()=>Z());const z=t(E,y),O=y.folder.fsPath,T=z.map(Pe=>Pe.match(/^-/)?Pe:`'${Pe}'`).join(" ");this.a.appendLine(`${c} ${T}
 - cwd: ${O}`);let B=u.spawn(c,z,{cwd:O});B.on("error",Pe=>{console.error(Pe),this.a.appendLine("Error: "+(Pe&&Pe.message)),F((0,A.$dL)(new A.$bL(Pe&&Pe.message,A.SearchErrorCode.rgProcessError)))});let W=!1;const X=new i(y.maxResults,y.folder,y.previewOptions);X.on("result",Pe=>{W=!0,ce="",P.report(Pe)});let x=!1;const Z=()=>{x=!0,B?.kill(),X?.cancel()};let Y=!1;X.on("hitLimit",()=>{Y=!0,Z()});let ce="";B.stdout.on("data",Pe=>{X.handleData(Pe),W||(ce+=Pe)});let ne=!1;B.stdout.once("data",()=>ne=!0);let $e="";B.stderr.on("data",Pe=>{const _=Pe.toString();this.a.appendLine(_),$e.length+_.length<1e6&&($e+=_)}),B.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),x)j({limitHit:Y});else{X.flush(),B=null;let Pe;$e&&!ne&&(Pe=o($e))?F((0,A.$dL)(new A.$bL(Pe.message,Pe.code))):j({limitHit:Y})}})})}}e.$wmc=g;function o(p){const E=p.split(`
`),y=E[0].trim();if(E.some(I=>I.startsWith("regex parse error")))return new A.$bL(n(E),A.SearchErrorCode.regexParseError);const P=y.match(/grep config error: unknown encoding: (.*)/);if(P)return new A.$bL(`Unknown encoding: ${P[1]}`,A.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new A.$bL(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new A.$bL(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new A.$bL(y,A.SearchErrorCode.regexParseError)}function n(p){const E=["Regex parse error"],y=p.filter(P=>P.startsWith("PCRE2:"));if(y.length>=1){const P=y[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const I=P.split(":")[1];E.push(":"+I)}}return E.join("")}class i extends N.EventEmitter{constructor(E,y,P){super(),this.g=E,this.h=y,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,y){return super.on(E,y),this}handleData(E){if(this.b)return;const y=typeof E=="string"?E:this.d.write(E);this.k(y)}k(E){let y=E.indexOf(`
`);const P=this.a+E;if(y>=0)y+=this.a.length;else{this.a=P;return}let I=0;for(;y>=0;)this.m(P.substring(I,y).trim()),I=y+1,y=P.indexOf(`
`,I);this.a=P.substring(I)}m(E){if(this.b||!E)return;let y;try{y=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(y.type==="match"){const P=r(y.data.path),I=S.URI.joinPath(this.h,P),j=this.n(y.data,I);this.p(j),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const P=r(y.data.path),I=S.URI.joinPath(this.h,P);this.o(y.data,I).forEach(F=>this.p(F))}}n(E,y){const P=E.line_number-1,I=r(E.lines),j=Buffer.from(I);let F=0,z=0,O=P;E.submatches.length===0&&E.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(E.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=r(B.match),x=j.slice(F,B.start).toString(),Z=s(x),Y=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+z,ce=s(X),ne=Z.numLines+O,$e=ce.numLines+ne,Pe=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+Y;return F=B.end,z=Pe,O=$e,new C.$XK(ne,Y,$e,Pe)}));return(0,v.$pmc)(y,I,T,this.j)}o(E,y){const P=r(E.lines),I=E.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((j,F)=>({text:j,uri:y,lineNumber:I+F}))}p(E){this.emit("result",E)}}e.$xmc=i;function r(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function s(p){const E=/\n/g;let y=0,P=-1,I;for(;I=E.exec(p);)y++,P=I.index;const j=P>=0?p.length-P-1:p.length;return{numLines:y,lastLineLength:j}}function t(p,E){const y=["--hidden","--no-require-git"];y.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:I}=(0,M.$K)(E.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const F=new Set;I.forEach(z=>{F.add(z)}),y.push("-g","!*"),F.forEach(z=>{f(z).map(v.$omc).forEach(O=>{y.push("-g",O)})})}P&&P.length&&P.forEach(F=>{y.push("-g",F)}),E.excludes.map(v.$omc).forEach(F=>y.push("-g",`!${F}`)),E.maxFileSize&&y.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),E.followSymlinks&&y.push("--follow"),E.encoding&&E.encoding!=="utf8"&&y.push("--encoding",E.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,b.$8e)(p.pattern),p.isRegExp=!0),E.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),p.isRegExp&&(p.pattern=d(p.pattern),y.push("--engine","auto"));let j;if(p.isWordMatch){const z=(0,b.$ef)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",z)}else if(p.isRegExp){let F=a(p.pattern);F=h(F),y.push("--regexp",F)}else j=p.pattern,y.push("--fixed-strings");return y.push("--no-config"),E.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),p.isMultiline&&y.push("--multiline"),E.beforeContext&&y.push("--before-context",E.beforeContext+""),E.afterContext&&y.push("--after-context",E.afterContext+""),y.push("--"),j&&y.push(j),y.push("."),y}function f(p){return D(p).flatMap(y=>{const P=(0,w.$ik)(y,"/");return P.map((I,j)=>P.slice(0,j+1).join("/"))})}function d(p){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(y);)p=p.replace(y,"$1\\x{$2}");return p}const l=p=>p.type==="Assertion"&&p.kind==="lookbehind";function a(p){let E;try{E=new $.RegExpParser().parsePattern(p)}catch{return p}let y="",P=0;const I=(z,O,T)=>{y+=p.slice(P,z)+T,P=O},j=[];return new $.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const O=j[0];if(!O)I(z.start,z.end,"\\r?\\n");else if(!j.some(l))if(O.type==="CharacterClass")if(O.negate){const T=p.slice(O.start+2,z.start)+p.slice(z.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,T?`[^${T}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=p.slice(O.start+1,z.start)+p.slice(z.end,O.end-1);I(O.start,O.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){j.unshift(z)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(z){j.unshift(z)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(z){j.unshift(z)},onCharacterClassLeave(){j.shift()},onAssertionEnter(z){l(z)&&j.push(z)},onAssertionLeave(z){j[0]===z&&j.shift()}}).visit(E),y+=p.slice(P),y}function h(p){return p.replace(/\n/g,"\\r?\\n")}function m(p){let E=!1,y=!1,P="",I="";for(let j=0;j<p.length;j++){const F=p[j];switch(F){case"\\":y?(E?I+="\\"+F:P+="\\"+F,y=!1):y=!0;break;case"{":if(y)E?I+=F:P+=F,y=!1;else{if(E)return{strInBraces:P+"{"+I+"{"+p.substring(j+1)};E=!0}break;case"}":if(y)E?I+=F:P+=F,y=!1;else{if(E)return{fixedStart:P,strInBraces:I,fixedEnd:p.substring(j+1)};P+=F}break;default:E?I+=(y?"\\":"")+F:P+=(y?"\\":"")+F,y=!1;break}}return{strInBraces:P+(E?"{"+I:"")}}function D(p){const{fixedStart:E,strInBraces:y,fixedEnd:P}=m(p);if(E===void 0||P===void 0)return[y];let I=(0,w.$ik)(y,",");I.length||(I=[""]);const j=D(P);return I.flatMap(F=>{const z=E+F;return j.map(O=>z+O)})}}),define(ke[387],Ee([1,0,22,161,108,15]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;class M{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,A,C,$){const k=new N.$wmc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},c=new L.$Zv(g=>C.report({...g,uri:g.uri.with({scheme:A.folder.scheme})}));return this.c($,g=>k.provideTextSearchResults(S,v,c,g))}else return this.c($,v=>k.provideTextSearchResults(S,A,C,v))}async c(S,A){const C=w(S);this.a.add(C);const $=await A(C.token);return this.a.delete(C),$}d(){this.a.forEach(S=>S.cancel())}}e.$Gmc=M;function w(b){const S=new u.$me;return b.onCancellationRequested(()=>S.cancel()),S}}),define(ke[388],Ee([1,0,31,161,160]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class R{constructor(b){this.a=b}search(b,S,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(k){A({message:k})}},$=new L.$Dmc(this.a,new N.$wmc(C),u);return new Promise((k,v)=>$.search(c=>{S(c.map(M))},b).then(c=>k({limitHit:c.limitHit,type:"success",stats:c.stats}),v))}}e.$Emc=R;function M(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce((b,S)=>{if(S.ranges){const A=S;return b+(Array.isArray(A.ranges)?A.ranges.length:1)}else return b+1},0)}}}),define(ke[389],Ee([1,0,19,8,13,4,132,17,39,2,32,36,384,388]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class v{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=o(r),f=new R.$be({onDidAddFirstListener:()=>{s=(0,N.$dh)(d=>this.doFileSearchWithEngine($.$vmc,t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=o(r),f=new R.$be({onDidAddFirstListener:()=>{s=(0,N.$dh)(d=>this.f(t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new k.$Emc(r).search(t,s,s)}g(){return{maxFileSize:16*A.$sl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine($.$vmc,r,s,t)}doFileSearchWithEngine(r,s,t,f,d=v.a){let l=0;const a=m=>{Array.isArray(m)?(l+=m.length,t(m.map(D=>this.h(D)))):m.relativePath?(l++,t(this.h(m))):t(m)};if(s.sortByScore){let m=this.l(s,a,f);if(!m){const D=s.maxResults?Object.assign({},s,{maxResults:null}):s,p=new r(D);m=this.j(p,s,t,a,f)}return new Promise((D,p)=>{m.then(([E,y])=>{const P=y.map(I=>this.h(I));this.o(P,t,d),D(E)},p)})}const h=new r(s);return this.r(h,a,d,f).then(m=>({limitHit:m.limitHit,type:"success",stats:{detailStats:m.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,w.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,f,d){const l=new R.$be;let a=(0,N.$dh)(m=>{let D=[];const p=E=>{Array.isArray(E)?D=E:(f(E),l.fire(E))};return this.r(r,p,-1,m).then(E=>[E,D])}),h;if(s.cacheKey){h=this.k(s.cacheKey);const m={promise:a,event:l.event,resolved:!1};h.resultsToSearchCache[s.filePattern||""]=m,a.then(()=>{m.resolved=!0},D=>{delete h.resultsToSearchCache[s.filePattern||""]}),a=this.s(a)}return a.then(([m,D])=>{const p=h?h.scorerCache:Object.create(null),E=(typeof s.maxResults!="number"||s.maxResults>0)&&b.$0d.create(!1);return this.n(s,D,p,d).then(y=>{const P=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:m.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:m.messages,limitHit:m.limitHit||typeof s.maxResults=="number"&&D.length>s.maxResults},y]})})}k(r){const s=this.b[r];return s||(this.b[r]=new c)}l(r,s,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const d=this.q(f,r.filePattern||"",s,t);if(d)return d.then(([l,a,h])=>{const m=b.$0d.create(!1);return this.n(r,a,f.scorerCache,t).then(D=>{const p=m.elapsed(),E={fromCache:!0,detailStats:h,type:this.d,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&a.length>r.maxResults,stats:E},D]})})}n(r,s,t,f){const d=(0,M.$pr)(r.filePattern||""),l=(h,m)=>(0,M.$or)(h,m,d,!0,g,t),a=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(s,l,a,1e4,f)}o(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}q(r,s,t,f){const d=b.$0d.create(!1),l=s.indexOf(w.sep)>=0;let a;for(const p in r.resultsToSearchCache)if(s.startsWith(p)){if(l&&p.indexOf(w.sep)<0&&p!=="")continue;const E=r.resultsToSearchCache[p];a={promise:this.s(E.promise),event:E.event,resolved:E.resolved};break}if(!a)return null;const h=d.elapsed(),m=b.$0d.create(!1),D=a.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),a.promise.then(([p,E])=>{if(f&&f.isCancellationRequested)throw(0,L.$6)();const y=[],P=(0,M.$pr)(s).normalizedLowercase;for(const I of E)(0,C.$hL)(I,P)&&y.push(I);return[p,y,{cacheWasResolved:a.resolved,cacheLookupTime:h,cacheFilterTime:m.elapsed(),cacheEntryCount:E.length}]})}r(r,s,t,f){return new Promise((d,l)=>{let a=[];f?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(a.push(h),t>0&&a.length>=t&&(s(a),a=[])):s(h))},h=>{s(h)},(h,m)=>{a.length&&s(a),h?(s({message:"Search finished. Error: "+h.message}),l(h)):(s({message:"Search finished. Stats: "+JSON.stringify(m.stats)}),d(m))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$Fmc=v;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(i){return(0,w.$oc)(i.relativePath)}getItemDescription(i){return(0,w.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>S.URI.revive(r))}}function n(i){return{...i,folder:S.URI.revive(i.folder)}}}),define(ke[390],Ee([1,0,3,15,2,31,12,28,20,97,67,36,389,387,122,160]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;let g=class extends S.$slc{constructor(n,i,r,s){super(n,r,s),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$qmc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new k.$Gmc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$qmc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new k.$Gmc(n))),this.A.add(this.C(N.Schemas.file,new $.$Fmc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,S.$tlc)(r);if(n===this.x){const f=Date.now();return this.D(n,i,t,s).then(d=>{const l=Date.now()-f;return this.q.debug(`Ext host file search time: ${l}ms`),d})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,C.$gL)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>L.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new c.$Dmc(n,i,void 0,"textSearchProvider")}};e.$Hmc=g,e.$Hmc=g=Je([qe(0,b.$aP),qe(1,w.$qP),qe(2,A.$jkc),qe(3,M.$Wj)],g)}),define(ke[123],Ee([1,0,377,63,64,404,21,13,4,3,17,11,30,81,82]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$hi=e.$gi=e.$fi=void 0,e.$ii=d,e.$ji=l,e.$li=m,e.$mi=D;class c{traceSocketEvent(E,y){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,y)}constructor(E,y=""){this.f=!0,this.debugLabel=y,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,w.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const y=P=>{this.traceSocketEvent("read",P),E(M.$Ce.wrap(P))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(E){const y=P=>{E({type:0,hadError:P,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(E){const y=()=>{E()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,w.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,w.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$fi=c;var g;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var o;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(o||(o={}));class n extends S.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,y){this.socket.traceSocketEvent(E,y)}constructor(E,y,P,I){super(),this.f=this.B(new b.$be),this.g=this.B(new b.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:P?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,y,P,I,this.f,(j,F)=>this.m(j,F))),this.B(this.a.onError(j=>{console.error(j),(0,w.$1)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new v.$ai,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let y=0;for(;y<E.byteLength;)this.a.writeMessage(E.slice(y,Math.min(y+262144,E.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(E,{compressed:y,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let I=2;E.byteLength<126?I+=0:E.byteLength<2**16?I+=2:I+=8;const j=M.$Ce.alloc(I),F=y?64:0,z=P&15;if(j.writeUInt8(128|F|z,0),E.byteLength<126)j.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){j.writeUInt8(126,1);let O=1;j.writeUInt8(E.byteLength>>>8&255,++O),j.writeUInt8(E.byteLength>>>0&255,++O)}else{j.writeUInt8(127,1);let O=1;j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(0,++O),j.writeUInt8(E.byteLength>>>24&255,++O),j.writeUInt8(E.byteLength>>>16&255,++O),j.writeUInt8(E.byteLength>>>8&255,++O),j.writeUInt8(E.byteLength>>>0&255,++O)}this.socket.write(M.$Ce.concat([j,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),P=y.readUInt8(0),I=(P&128)>>>7,j=(P&64)>>>6,F=P&15,z=y.readUInt8(1),O=(z&128)>>>7,T=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),P=y.readUInt8(1),I=(P&128)>>>7;let j=P&127,F=1;j===126?j=y.readUInt8(++F)*2**8+y.readUInt8(++F):j===127&&(j=y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F));let z=0;I&&(z=y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F)),this.j.state=3,this.j.readLen=j,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$gi=n;class i extends S.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$Ce.alloc(0)}constructor(E,y,P,I,j,F){super(),this.n=E,this.r=j,this.s=F,this.a=this.B(new b.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,I,P,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(E,y){this.g.push({data:E,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:y}=this.g.shift();if(this.f&&y.compressed){const P=await this.w(this.f,E);this.s(P,y)}else this.s(E,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,y){return new Promise((P,I)=>{E.write(y),E.flush(j=>P(j))})}acceptFrame(E,y,P){this.h.push({data:E,isCompressed:y,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const y=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,y,P){return new Promise((I,j)=>{E.write(y),P&&E.write(M.$Ce.fromByteArray([0,0,255,255])),E.flush(F=>I(F))})}}class r extends S.$Uc{get recordedInflateBytes(){return this.j?M.$Ce.concat(this.f):M.$Ce.alloc(0)}constructor(E,y,P,I){super(),this.h=E,this.j=y,this.a=this.B(new b.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(M.$Ce.wrap(j))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=M.$Ce.concat(this.g);this.g.length=0,E(y)})}}class s extends S.$Uc{constructor(E,y){super(),this.g=E,this.a=this.B(new b.$be),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(M.$Ce.wrap(P))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=M.$Ce.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),E(y)})}}function t(p,E){if(E===0)return;const y=p.byteLength>>>2;for(let O=0;O<y;O++){const T=p.readUInt32BE(O*4);p.writeUInt32BE(T^E,O*4)}const P=y*4,I=p.byteLength-P,j=E>>>24&255,F=E>>>16&255,z=E>>>8&255;I>=1&&p.writeUInt8(p.readUInt8(P)^j,P),I>=2&&p.writeUInt8(p.readUInt8(P+1)^F,P+1),I>=3&&p.writeUInt8(p.readUInt8(P+2)^z,P+2)}e.$hi=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function d(){const p=(0,$.$Mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const E=process.platform!=="darwin"&&e.$hi?e.$hi:(0,L.tmpdir)(),y=(0,A.$kc)(E,`vscode-ipc-${p}.sock`);return a(y),y}function l(p,E,y){const I=(0,u.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${y}-${E}-sock`;const j=y.substr(0,4),F=E.substr(0,6);let z;return process.platform!=="darwin"&&e.$hi&&!process.env.VSCODE_PORTABLE?z=(0,A.$kc)(e.$hi,`vscode-${I}-${j}-${F}.sock`):z=(0,A.$kc)(p,`${j}-${F}.sock`),a(z),z}function a(p){const E=f[C.$u];typeof E=="number"&&p.length>=E&&console.warn(`WARNING: IPC handle "${p}" is longer than ${E} chars, try a shorter --user-data-dir`)}class h extends k.$7h{static b(E){const y=b.Event.fromNodeEventEmitter(E,"connection");return b.Event.map(y,P=>({protocol:new v.$bi(new c(P,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(P,"close"))}))}constructor(E){super(h.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ki=h;function m(p){return new Promise((E,y)=>{const P=(0,N.createServer)();P.on("error",y),P.listen(p,()=>{P.removeListener("error",y),E(new h(P))})})}function D(p,E){return new Promise((y,P)=>{const I=(0,N.createConnection)(p,()=>{I.removeListener("error",P),y(v.$ci.fromSocket(new c(I,`ipc-client${E}`),E))});I.once("error",P)})}}),define(ke[391],Ee([1,0,63,64,173,123,8,3,11,54,12,139,267,268,110,88,21]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0;async function o(t,f,d,l,a){let h;for(let m=3;m&&(h?.dispose(),h=await new n(t,f,d,l,a).waitForReady(),!(a&&L.$Pg[a]||!L.$Pg[h.tunnelLocalPort]));m--);return h}class n extends w.$Uc{constructor(f,d,l,a,h){super(),this.m=d,this.n=h,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=u.createServer(),this.c=new M.$ph,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.r(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,d=(0,c.$aw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,L.$Qg)(f,2,1e3,d),a=null;return this.b.listen(l,this.m),await this.c.wait(),a=this.b.address(),a||(l=0,this.b.listen(l,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(f){f.pause();const d=(0,c.$$v)(this.tunnelRemoteHost)||(0,c.$aw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$Ml)(this.a,d,this.tunnelRemotePort),a=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&f.write(h.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),a.end()}),f.on("close",()=>a.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),a instanceof R.$fi?a.socket.destroy():a.end()}),a instanceof R.$fi?this.t(f,a):this.s(f,a),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),a.end()})}s(f,d){d.onClose(()=>f.destroy()),d.onEnd(()=>f.end()),d.onData(l=>f.write(l.buffer)),f.on("data",l=>d.write(g.$Ce.wrap(l))),f.resume()}t(f,d){const l=d.socket;l.on("end",()=>f.end()),l.on("close",()=>f.end()),l.on("error",()=>{f.destroy()}),l.pipe(f),f.pipe(l)}}e.$tcc=n;let i=class extends c.$dw{constructor(f,d,l,a,h){super(d,h),this.v=f,this.w=l,this.y=a}isPortPrivileged(f){return(0,c.$bw)(f,this.m,b.OS,N.release())}t(f,d,l,a,h,m,D,p){const E=this.s(d,l);if(E)return++E.refcount,E.value;if((0,c.$7v)(f))return this.u(f,d,l,h,m,D,p);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(y,a,d,l,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,l,P),P}}};e.$ucc=i,e.$ucc=i=Je([qe(0,k.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,C.$dk),qe(4,S.$Wi)],i);let r=class extends i{constructor(f,d,l,a,h){super(f,d,l,a,h)}};e.$vcc=r,e.$vcc=r=Je([qe(0,k.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,C.$dk),qe(4,S.$Wi)],r);let s=class extends w.$Uc{constructor(f,d,l,a,h){super(),this.b=f,this.c=d,this.f=l,this.g=a,this.h=h,this.a=new Map}async openTunnel(f,d,l,a,h,m,D,p,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${a} on local port ${m}.`),!this.a.has(f)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(d,l,a,h,m,D,p,E)}};e.$wcc=s,e.$wcc=s=Je([qe(0,k.$Gl),qe(1,A.$Wj),qe(2,C.$dk),qe(3,v.$Jl),qe(4,S.$Wi)],s)}),define(ke[392],Ee([1,0,123,287,52,33,2,12,41]),function(le,e,u,N,L,R,M,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.$BP=void 0;class S{constructor($,k,v){this.b=$,this.c=k,this.f=v,this.a=N.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(k.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,k){const v=(g,o)=>{k.writeHead(g,{"content-type":"application/json"}),k.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},c=[];$.setEncoding("utf8"),$.on("data",g=>c.push(g)),$.on("end",async()=>{try{const g=JSON.parse(c.join(""));let o;switch(g.type){case"open":o=await this.i(g);break;case"openExternal":o=await this.j(g);break;case"status":o=await this.l(g);break;case"extensionManagement":o=await this.k(g);break;default:v(404,`Unknown message type: ${g.type}`);break}v(200,o)}catch(g){const o=g instanceof Error?g.message:JSON.stringify(g);v(500,o),this.c.error("Error while processing pipe request",g)}})}async i($){const{fileURIs:k,folderURIs:v,forceNewWindow:c,diffMode:g,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=$,f=[];if(Array.isArray(v))for(const h of v)try{f.push({folderUri:M.URI.parse(h)})}catch{}if(Array.isArray(k))for(const h of k)try{(0,b.$Vi)(h)?f.push({workspaceUri:M.URI.parse(h)}):f.push({fileUri:M.URI.parse(h)})}catch{}const d=s?M.URI.file(s):void 0,a={forceNewWindow:c,diffMode:g,mergeMode:o,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,a)}async j($){for(const k of $.uris){const v=M.URI.parse(k),c=v.scheme==="file"?v:k;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k($){const k=c=>c?.map(g=>/\.vsix$/i.test(g)?M.URI.parse(g):g),v={list:$.list,install:k($.install),uninstall:k($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$BP=S;let A=class extends S{constructor($,k){super($,k,(0,u.$ii)())}};e.$CP=A,e.$CP=A=Je([qe(0,R.$wP),qe(1,w.$Wj)],A)}),define(ke[393],Ee([1,0,59,380,374,286,49,361,2,15,7,392,104,320,360]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class c extends L.$bmc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(d,l,a){return d=t(d),n.a.has(d)?n.a.get(d).load(d,b.URI.file((0,$.$Yq)(l.filename)),h=>r.apply(this,[h,l,a])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(f,d)=>s.call(this,t(f),d);const t=f=>{for(const d of n.b){const l=d(f);if(l){f=l;break}}return f}}}class g extends M.$2kc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(k.$Kmc);const n=this.h.invokeFunction(N.$0lc);if(this.h.createInstance(w.$Jmc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(C.$CP);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$Lmc),await this.h.createInstance(c,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$Imc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,r){if(i.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),s=le.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$Mmc=g}),define(ke[394],Ee([1,0,53,21,4,3,125,11,23,2,31,12,266,66,110,88,391,28,20,70,368]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0,e.$Nmc=s,e.$Omc=t,e.$Pmc=f,e.$Qmc=d,e.$Rmc=a,e.$Smc=h,e.$Tmc=m;function s(E){const y=E.trim().split(`
`),P=[];return y.forEach(j=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);F&&F.length>=3&&P.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),P.reduce((j,F)=>(j[F.socket]=F,j),{})}function t(...E){const y=[].concat(...E.map(d));return[...new Map(y.filter(P=>P.st==="0A").map(P=>{const I=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:f(I[0]),port:parseInt(I[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function f(E){let y="";if(E.length===8)for(let P=E.length-2;P>=0;P-=2)y+=parseInt(E.substr(P,2),16),P!==0&&(y+=".");else for(let P=0;P<E.length;P+=8){const I=E.substring(P,P+8);let j="";for(let F=8;F>=2;F-=2)j+=I.substring(F-2,F),(F===6||F===2)&&(j=parseInt(j,16).toString(16),y+=`${j}`,j="",P+F!==E.length-6&&(y+=":"))}return y}function d(E){const y=E.trim().split(`
`),P=y.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return y.map(j=>j.trim().split(/\s+/).reduce((F,z,O)=>(F[P[O]||O]=z,F),{}))}function l(E){return!!E.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||E.indexOf("out/server-main.js")!==-1||E.indexOf("_productName=VSCode")!==-1}function a(E){const y=E.trim().split(`
`),P=[];return y.forEach(I=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);j&&j.length>=4&&P.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),P}async function h(E,y,P){const I=P.reduce((F,z)=>(F[z.pid]=z,F),{}),j=[];return E.forEach(({socket:F,ip:z,port:O})=>{const T=y[F]?y[F].pid:void 0,B=T?I[T]?.cmd:void 0;T&&B&&!l(B)&&j.push({host:z,port:O,detail:B,pid:T})}),j}function m(E,y,P){const I=new Map,j=a(y);for(const F of E){const z=P.get(F.port);if(z){I.set(F.port,z);continue}const O=j.find(T=>T.cmd.includes(`${F.port}`));if(O){let T=O,B;do B=j.find(W=>W.ppid===T.pid),B&&(T=B);while(B);I.set(F.port,{host:F.ip,port:F.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$pCb{constructor(y,P,I,j){super(y,P,I),this.D=P,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,w.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new M.$ym;let j=0;for(;this.C;){const F=new Date().getTime(),z=(await this.I()).filter(B=>(0,c.$$v)(B.host)||(0,c.$aw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),j++>3&&I.update(O),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(B=>setTimeout(()=>B(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",P="";try{y=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(y,P),j=await new Promise(x=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,Y,ce)=>{x(Y)})}),F=s(j),z=await A.Promises.readdir("/proc"),O=[];for(const x of z)try{const Z=Number(x),Y=b.$4g(S.URI.file("/proc"),x);if((await A.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(Z)){const ne=await A.Promises.readlink(b.$4g(Y,"cwd").fsPath),$e=await A.Promises.readFile(b.$4g(Y,"cmdline").fsPath,"utf8");O.push({pid:Z,cwd:ne,cmd:$e})}}catch{}const T=[],B=I.filter(x=>{const Z=F[x.socket];return Z||T.push(x),Z}),W=h(B,F,O);let X;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const x=await new Promise(Z=>{(0,u.exec)("ps -F -A -l | grep root",(Y,ce,ne)=>{Z(ce)})});this.z=m(T,x,this.z),X=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${X.map(Z=>Z.port).join(", ")}`)}return W.then(x=>X?x.concat(X):x)}w(y){return async P=>{const I=new g.$tcc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,z,O,T){const B=await y.makeConnection();return p.connect(B,z,O,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$Cl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await I.waitForReady();const j=new L.$be;return{localAddress:(0,r.$dM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{I.dispose(),j.fire(),j.dispose()}}}}};e.$Umc=D,e.$Umc=D=Je([qe(0,n.$aP),qe(1,o.$qP),qe(2,C.$Wj),qe(3,v.$Jl)],D);class p extends $.$nsb{static connect(y,P,I,j){const F=new R.$Tc,z={onClose:F.add(new L.$be),onData:F.add(new L.$be),onEnd:F.add(new L.$be)};F.add(y.onDidReceiveMessage(T=>z.onData.fire(N.$Ce.wrap(T)))),F.add(y.onDidEnd(()=>z.onEnd.fire())),F.add(y.onDidClose(T=>z.onClose.fire({type:0,error:T,hadError:!!T})));const O=new p(y,j,z);return O.B(F),(0,$.$msb)(O,P,I,j,z)}constructor(y,P,I){super(P,I),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[395],Ee([1,0,84,363,378,376,390,393,394,96,49,97,95,42,70,93,362,321,12,379,61,281,106,110,141]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o,n,i,r,s,t,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$os)(A.$3kc,w.$Mmc,0),(0,u.$os)(n.$Xj,o.$Wmc,1),(0,u.$os)(n.$Wj,new t.$ni(s.$amc,[!1],!0)),(0,u.$os)(f.$Jl,d.$ycc,1),(0,u.$os)(c.$skc,g.$Vmc,0),(0,u.$os)(S.$8kc,R.$nmc,0),(0,u.$os)(C.$rlc,M.$Hmc,0),(0,u.$os)($.$Tlc,L.$fmc,0),(0,u.$os)(k.$Nkc,N.$emc,0),(0,u.$os)(v.$oCb,b.$Umc,0),(0,u.$os)(r.$6kc,i.$Xmc,0)}),define(ke[405],Ee([1,0,63,406,59,13,82,123,264,114,375,21,31,104,8,135,288,304,381,395]),function(le,e,u,N,L,R,M,w,b,S,A,C,$,k,v,c,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,m=h._load;h._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(h){process.exit=function(m){if(h)i(m);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(m,D){m==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(m,D)}}let t=function(h){i()};function f(){const h=(0,o.$in)(process.env);if(h.type===3)return new Promise((m,D)=>{const p=E=>{const y=E[0],P=new M.$di;y.on("message",I=>P.fire(C.$Ce.wrap(I.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),m({onMessage:P.event,send:I=>y.postMessage(I.buffer)})};process.parentPort.on("message",E=>p(E.ports))});if(h.type===2)return new Promise((m,D)=>{let p=null;const E=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,P=3e5,I=new v.$Dh(()=>t("renderer disconnected for too long (1)"),y),j=new v.$Dh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const T=C.$Ce.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new w.$fi(O,"extHost-socket");else{const W=C.$Ce.wrap(Buffer.from(z.inflateBytes,"base64"));B=new w.$gi(new w.$fi(O,"extHost-socket"),z.permessageDeflate,W,!1)}p?(I.cancel(),j.cancel(),p.beginAcceptReconnection(B,T),p.endAcceptReconnection(),p.sendResume()):(clearTimeout(E),p=new M.$ei({socket:B,initialChunk:T}),p.sendResume(),p.onDidDispose(()=>t("renderer disconnected")),m(p),p.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;I.isScheduled()&&j.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const m=h.pipeName;return new Promise((D,p)=>{const E=u.createConnection(m,()=>{E.removeListener("error",p);const y=new M.$ei({socket:new w.$fi(E,"extHost-renderer")});y.sendResume(),D(y)});E.once("error",p),E.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await f();return new class{constructor(){this.a=new M.$di,this.onMessage=this.a.event,this.b=!1,h.onMessage(m=>{(0,S.$Um)(m,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||h.send(m)}async drain(){if(h.drain)return h.drain()}}}function l(h){return new Promise(m=>{const D=h.onMessage(p=>{D.dispose();const E=JSON.parse(p.toString()),y=E.commit,P=b.default.commit;if(y&&P&&y!==P&&i(55),E.parentPid){let I=0;setInterval(function(){try{process.kill(E.parentPid,0),I=0}catch(F){F&&F.code==="EPERM"?(I++,I>=3&&t(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${E.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(E.parentPid)}catch(F){(0,R.$1)(F)}}h.send((0,S.$Tm)(0)),m({protocol:h,initData:E})});h.send((0,S.$Tm)(1))})}async function a(){const h=[];process.on("unhandledRejection",(I,j)=>{h.push(j),setTimeout(()=>{const F=h.indexOf(j);F>=0&&j.catch(z=>{h.splice(F,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const j=h.indexOf(I);j>=0&&h.splice(j,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const m=await d();L.mark("code/extHost/didConnectToRenderer");const D=await l(m);L.mark("code/extHost/didWaitForInitData");const{initData:p}=D;s(!!p.environment.extensionTestsLocationURI),p.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,p.environment.skipWorkspaceStorageLock=(0,c.boolean)(n.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(j){i(j)}fsExists(j){return $.Promises.exists(j)}fsRealpath(j){return(0,k.$Xq)(j)}};let y=null;p.remote.authority&&n.transformURIs&&(y=(0,g.$ss)(p.remote.authority));const P=new A.$dmc(D.protocol,p,E,y);t=I=>P.terminate(I)}a().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7eba2d200076e9ca04ef1d0874fb49aae426f895/core/vs/workbench/api/node/extensionHostProcess.js.map
