/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ge){for(var e=[],I=0,N=ge.length;I<N;I++)e[I]=Re[ge[I]];return e};define(Re[68],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=R,e.$Wh=F;function I(M){return(p,g,D)=>{let T=null,k=null;if(typeof D.value=="function"?(T="value",k=D.value):typeof D.get=="function"&&(T="get",k=D.get),!k)throw new Error("not supported");D[T]=M(k,g)}}function N(M,p,g){let D=null,T=null;if(typeof g.value=="function"?(D="value",T=g.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(D="get",T=g.get),!T)throw new Error("not supported");const k=`$memoize$${p}`;g[D]=function(...u){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,u)}),this[k]}}function R(M,p,g){return I((D,T)=>{const k=`$debounce$${T}`,u=`$debounce$result$${T}`;return function(...w){this[u]||(this[u]=g?g():void 0),clearTimeout(this[k]),p&&(this[u]=p(this[u],...w),w=[this[u]]),this[k]=setTimeout(()=>{D.apply(this,w),this[u]=g?g():void 0},M)}})}function F(M,p,g){return I((D,T)=>{const k=`$throttle$timer$${T}`,u=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,d=`$throttle$pending$${T}`;return function(...s){if(this[u]||(this[u]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),p&&(this[u]=p(this[u],...s)),this[d])return;const o=this[w]+M;o<=Date.now()?(this[w]=Date.now(),D.apply(this,[this[u]]),this[u]=g?g():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[w]=Date.now(),D.apply(this,[this[u]]),this[u]=g?g():void 0},o-Date.now()))}})}}),define(Re[90],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$fP=I,e.$gP=new I("id#")}),define(Re[123],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=k,e.$Dn=u,e.$En=w,e.$Fn=d,e.$Gn=s,e.$Hn=o,e.$In=n,e.$Jn=r,e.$Kn=i,e.$Ln=a,e.$Mn=l;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function M(t,b=!1){let c=0;const m=t.length;let v="",$=0,h=16,E=0;function f(q){let A=0,j=0;for(;A<q;){const K=t.charCodeAt(c);if(K>=48&&K<=57)j=j*16+K-48;else if(K>=65&&K<=70)j=j*16+K-65+10;else if(K>=97&&K<=102)j=j*16+K-97+10;else break;c++,A++}return A<q&&(j=-1),j}function S(q){c=q,v="",$=0,h=16,E=0}function y(){const q=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&D(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&D(t.charCodeAt(c)))for(c++;c<t.length&&D(t.charCodeAt(c));)c++;else return E=3,t.substring(q,c);let A=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&D(t.charCodeAt(c))){for(c++;c<t.length&&D(t.charCodeAt(c));)c++;A=c}else E=3;return t.substring(q,A)}function C(){let q="",A=c;for(;;){if(c>=m){q+=t.substring(A,c),E=2;break}const j=t.charCodeAt(c);if(j===34){q+=t.substring(A,c),c++;break}if(j===92){if(q+=t.substring(A,c),c++,c>=m){E=2;break}switch(t.charCodeAt(c++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=f(4);ie>=0?q+=String.fromCharCode(ie):E=4;break}default:E=5}A=c;continue}if(j>=0&&j<=31)if(g(j)){q+=t.substring(A,c),E=2;break}else E=6;c++}return q}function P(){if(v="",E=0,$=c,c>=m)return $=m,h=17;let q=t.charCodeAt(c);if(p(q)){do c++,v+=String.fromCharCode(q),q=t.charCodeAt(c);while(p(q));return h=15}if(g(q))return c++,v+=String.fromCharCode(q),q===13&&t.charCodeAt(c)===10&&(c++,v+=`
`),h=14;switch(q){case 123:return c++,h=1;case 125:return c++,h=2;case 91:return c++,h=3;case 93:return c++,h=4;case 58:return c++,h=6;case 44:return c++,h=5;case 34:return c++,v=C(),h=10;case 47:{const A=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<m&&!g(t.charCodeAt(c));)c++;return v=t.substring(A,c),h=12}if(t.charCodeAt(c+1)===42){c+=2;const j=m-1;let K=!1;for(;c<j;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,E=1),v=t.substring(A,c),h=13}return v+=String.fromCharCode(q),c++,h=16}case 45:if(v+=String.fromCharCode(q),c++,c===m||!D(t.charCodeAt(c)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=y(),h=11;default:for(;c<m&&V(q);)c++,q=t.charCodeAt(c);if($!==c){switch(v=t.substring($,c),v){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return v+=String.fromCharCode(q),c++,h=16}}function V(q){if(p(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>c,scan:b?W:P,getToken:()=>h,getTokenValue:()=>v,getTokenOffset:()=>$,getTokenLength:()=>c-$,getTokenError:()=>E}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function D(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,b){const c=[],m=new Object;let v;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function E(f,S,y,C){$.value=f,$.offset=S,$.length=y,$.type=C,$.colonOffset=void 0,v=$}try{i(t,{onObjectBegin:(f,S)=>{if(b<=f)throw m;v=void 0,h=b>f,c.push("")},onObjectProperty:(f,S,y)=>{if(b<S||(E(f,S,y,"property"),c[c.length-1]=f,b<=S+y))throw m},onObjectEnd:(f,S)=>{if(b<=f)throw m;v=void 0,c.pop()},onArrayBegin:(f,S)=>{if(b<=f)throw m;v=void 0,c.push(0)},onArrayEnd:(f,S)=>{if(b<=f)throw m;v=void 0,c.pop()},onLiteralValue:(f,S,y)=>{if(b<S||(E(f,S,y,l(f)),b<=S+y))throw m},onSeparator:(f,S,y)=>{if(b<=S)throw m;if(f===":"&&v&&v.type==="property")v.colonOffset=S,h=!1,v=void 0;else if(f===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(h=!0,c[c.length-1]=""),v=void 0}}})}catch(f){if(f!==m)throw f}return{path:c,previousNode:v,isAtPropertyKey:h,matches:f=>{let S=0;for(let y=0;S<f.length&&y<c.length;y++)if(f[S]===c[y]||f[S]==="*")S++;else if(f[S]!=="**")return!1;return S===f.length}}}function u(t,b=[],c=F.DEFAULT){let m=null,v=[];const $=[];function h(f){Array.isArray(v)?v.push(f):m!==null&&(v[m]=f)}return i(t,{onObjectBegin:()=>{const f={};h(f),$.push(v),v=f,m=null},onObjectProperty:f=>{m=f},onObjectEnd:()=>{v=$.pop()},onArrayBegin:()=>{const f=[];h(f),$.push(v),v=f,m=null},onArrayEnd:()=>{v=$.pop()},onLiteralValue:h,onError:(f,S,y)=>{b.push({error:f,offset:S,length:y})}},c),v[0]}function w(t,b=[],c=F.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(f){m.type==="property"&&(m.length=f-m.offset,m=m.parent)}function $(f){return m.children.push(f),f}i(t,{onObjectBegin:f=>{m=$({type:"object",offset:f,length:-1,parent:m,children:[]})},onObjectProperty:(f,S,y)=>{m=$({type:"property",offset:S,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:f,offset:S,length:y,parent:m})},onObjectEnd:(f,S)=>{m.length=f+S-m.offset,m=m.parent,v(f+S)},onArrayBegin:(f,S)=>{m=$({type:"array",offset:f,length:-1,parent:m,children:[]})},onArrayEnd:(f,S)=>{m.length=f+S-m.offset,m=m.parent,v(f+S)},onLiteralValue:(f,S,y)=>{$({type:l(f),offset:S,length:y,parent:m,value:f}),v(S+y)},onSeparator:(f,S,y)=>{m.type==="property"&&(f===":"?m.colonOffset=S:f===","&&v(S))},onError:(f,S,y)=>{b.push({error:f,offset:S,length:y})}},c);const E=m.children[0];return E&&delete E.parent,E}function d(t,b){if(!t)return;let c=t;for(const m of b)if(typeof m=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let v=!1;for(const $ of c.children)if(Array.isArray($.children)&&$.children[0].value===m){c=$.children[1],v=!0;break}if(!v)return}else{const v=m;if(c.type!=="array"||v<0||!Array.isArray(c.children)||v>=c.children.length)return;c=c.children[v]}return c}function s(t){if(!t.parent||!t.parent.children)return[];const b=s(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;b.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&b.push(c)}return b}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const b=Object.create(null);for(const c of t.children){const m=c.children[1];m&&(b[c.children[0].value]=o(m))}return b}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function n(t,b,c=!1){return b>=t.offset&&b<t.offset+t.length||c&&b===t.offset+t.length}function r(t,b,c=!1){if(n(t,b,c)){const m=t.children;if(Array.isArray(m))for(let v=0;v<m.length&&m[v].offset<=b;v++){const $=r(m[v],b,c);if($)return $}return t}}function i(t,b,c=F.DEFAULT){const m=M(t,!1);function v(re){return re?()=>re(m.getTokenOffset(),m.getTokenLength()):()=>!0}function $(re){return re?Se=>re(Se,m.getTokenOffset(),m.getTokenLength()):()=>!0}const h=v(b.onObjectBegin),E=$(b.onObjectProperty),f=v(b.onObjectEnd),S=v(b.onArrayBegin),y=v(b.onArrayEnd),C=$(b.onLiteralValue),P=$(b.onSeparator),V=v(b.onComment),W=$(b.onError),q=c&&c.disallowComments,A=c&&c.allowTrailingComma;function j(){for(;;){const re=m.scan();switch(m.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(re){case 12:case 13:q?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return re}}}function K(re,Se=[],Le=[]){if(W(re),Se.length+Le.length>0){let ne=m.getToken();for(;ne!==17;){if(Se.indexOf(ne)!==-1){j();break}else if(Le.indexOf(ne)!==-1)break;ne=j()}}}function ie(re){const Se=m.getTokenValue();return re?C(Se):E(Se),j(),!0}function ce(){switch(m.getToken()){case 11:{let re=0;try{re=JSON.parse(m.getTokenValue()),typeof re!="number"&&(K(2),re=0)}catch{K(2)}C(re);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return j(),!0}function ve(){return m.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),m.getToken()===6?(P(":"),j(),pe()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){h(),j();let re=!1;for(;m.getToken()!==2&&m.getToken()!==17;){if(m.getToken()===5){if(re||K(4,[],[]),P(","),j(),m.getToken()===2&&A)break}else re&&K(6,[],[]);ve()||K(4,[],[2,5]),re=!0}return f(),m.getToken()!==2?K(7,[2],[]):j(),!0}function ue(){S(),j();let re=!1;for(;m.getToken()!==4&&m.getToken()!==17;){if(m.getToken()===5){if(re||K(4,[],[]),P(","),j(),m.getToken()===4&&A)break}else re&&K(6,[],[]);pe()||K(4,[],[4,5]),re=!0}return y(),m.getToken()!==4?K(8,[4],[]):j(),!0}function pe(){switch(m.getToken()){case 3:return ue();case 1:return Ie();case 10:return ie(!0);default:return ce()}}return j(),m.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):pe()?(m.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function a(t,b){const c=M(t),m=[];let v,$=0,h;do switch(h=c.getPosition(),v=c.scan(),v){case 12:case 13:case 17:$!==h&&m.push(t.substring($,h)),b!==void 0&&m.push(c.getTokenValue().replace(/[^\r\n]/g,b)),$=c.getPosition();break}while(v!==17);return m.join("")}function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Re[124],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ee,$e){for(var fe=0;fe<$e.length;fe++){var Q=$e[fe];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ee,Q.key,Q)}}function I(Ee,$e,fe){return $e&&e(Ee.prototype,$e),fe&&e(Ee,fe),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function N(Ee,$e){if(Ee){if(typeof Ee=="string")return R(Ee,$e);var fe=Object.prototype.toString.call(Ee).slice(8,-1);if(fe==="Object"&&Ee.constructor&&(fe=Ee.constructor.name),fe==="Map"||fe==="Set")return Array.from(Ee);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return R(Ee,$e)}}function R(Ee,$e){($e==null||$e>Ee.length)&&($e=Ee.length);for(var fe=0,Q=new Array($e);fe<$e;fe++)Q[fe]=Ee[fe];return Q}function F(Ee,$e){var fe=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(fe)return(fe=fe.call(Ee)).next.bind(fe);if(Array.isArray(Ee)||(fe=N(Ee))||$e&&Ee&&typeof Ee.length=="number"){fe&&(Ee=fe);var Q=0;return function(){return Q>=Ee.length?{done:!0}:{done:!1,value:Ee[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function p(Ee){ge.defaults=Ee}var g=/[&<>"']/,D=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function($e){return u[$e]};function d(Ee,$e){if($e){if(g.test(Ee))return Ee.replace(D,w)}else if(T.test(Ee))return Ee.replace(k,w);return Ee}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ee){return Ee.replace(s,function($e,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var n=/(^|[^\[])\^/g;function r(Ee,$e){Ee=typeof Ee=="string"?Ee:Ee.source,$e=$e||"";var fe={replace:function(Y,he){return he=he.source||he,he=he.replace(n,"$1"),Ee=Ee.replace(Y,he),fe},getRegex:function(){return new RegExp(Ee,$e)}};return fe}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Ee,$e,fe){if(Ee){var Q;try{Q=decodeURIComponent(o(fe)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}$e&&!a.test(fe)&&(fe=v($e,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var t={},b=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ee,$e){t[" "+Ee]||(b.test(Ee)?t[" "+Ee]=Ee+"/":t[" "+Ee]=f(Ee,"/",!0)),Ee=t[" "+Ee];var fe=Ee.indexOf(":")===-1;return $e.substring(0,2)==="//"?fe?$e:Ee.replace(c,"$1")+$e:$e.charAt(0)==="/"?fe?$e:Ee.replace(m,"$1")+$e:Ee+$e}var $={exec:function(){}};function h(Ee){for(var $e=1,fe,Q;$e<arguments.length;$e++){fe=arguments[$e];for(Q in fe)Object.prototype.hasOwnProperty.call(fe,Q)&&(Ee[Q]=fe[Q])}return Ee}function E(Ee,$e){var fe=Ee.replace(/\|/g,function(he,le,Ne){for(var de=!1,Ce=le;--Ce>=0&&Ne[Ce]==="\\";)de=!de;return de?"|":" |"}),Q=fe.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>$e)Q.splice($e);else for(;Q.length<$e;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function f(Ee,$e,fe){var Q=Ee.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=Ee.charAt(Q-Y-1);if(he===$e&&!fe)Y++;else if(he!==$e&&fe)Y++;else break}return Ee.slice(0,Q-Y)}function S(Ee,$e){if(Ee.indexOf($e[1])===-1)return-1;for(var fe=Ee.length,Q=0,Y=0;Y<fe;Y++)if(Ee[Y]==="\\")Y++;else if(Ee[Y]===$e[0])Q++;else if(Ee[Y]===$e[1]&&(Q--,Q<0))return Y;return-1}function y(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Ee,$e){if($e<1)return"";for(var fe="";$e>1;)$e&1&&(fe+=Ee),$e>>=1,Ee+=Ee;return fe+Ee}function P(Ee,$e,fe,Q){var Y=$e.href,he=$e.title?d($e.title):null,le=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ne={type:"link",raw:fe,href:Y,title:he,text:le,tokens:Q.inlineTokens(le)};return Q.state.inLink=!1,Ne}return{type:"image",raw:fe,href:Y,title:he,text:d(le)}}function V(Ee,$e){var fe=Ee.match(/^(\s+)(?:```)/);if(fe===null)return $e;var Q=fe[1];return $e.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var le=he[0];return le.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var W=function(){function Ee(fe){this.options=fe||ge.defaults}var $e=Ee.prototype;return $e.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},$e.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:f(he,`
`)}}},$e.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],le=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:le}}},$e.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var le=f(he,"#");(this.options.pedantic||!le||/ $/.test(le))&&(he=le.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},$e.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},$e.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},$e.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,le,Ne,de,Ce,Me,ze,z,L,G,H,_,se=Y[1].trim(),Fe=se.length>1,Be={type:"list",raw:"",ordered:Fe,start:Fe?+se.slice(0,-1):"",loose:!1,items:[]};se=Fe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Fe?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(_=!1,!(!(Y=Qe.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),z=Y[2].split(`
`,1)[0],L=Q.split(`
`,1)[0],this.options.pedantic?(de=2,H=z.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=z.slice(de),de+=Y[1].length),Me=!1,!z&&/^ *$/.test(L)&&(he+=L+`
`,Q=Q.substring(L.length+1),_=!0),!_)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(G=Q.split(`
`,1)[0],z=G,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(z)||it.test(z)||_e.test(z)||et.test(Q)));){if(z.search(/[^ ]/)>=de||!z.trim())H+=`
`+z.slice(de);else if(!Me)H+=`
`+z;else break;!Me&&!z.trim()&&(Me=!0),he+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(H),le&&(Ne=le[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!le,checked:Ne,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Ce=0;Ce<nt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var ct=Be.items[Ce].tokens.filter(function(je){return je.type==="space"}),ft=ct.every(function(je){for(var st=je.raw.split(""),X=0,Z=F(st),me;!(me=Z()).done;){var He=me.value;if(He===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&ct.length&&ft&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},$e.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]);he.type="paragraph",he.text=le,he.tokens=this.lexer.inline(le)}return he}},$e.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},$e.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:E(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var le=he.align.length,Ne,de,Ce,Me;for(Ne=0;Ne<le;Ne++)/^ *-+: *$/.test(he.align[Ne])?he.align[Ne]="right":/^ *:-+: *$/.test(he.align[Ne])?he.align[Ne]="center":/^ *:-+ *$/.test(he.align[Ne])?he.align[Ne]="left":he.align[Ne]=null;for(le=he.rows.length,Ne=0;Ne<le;Ne++)he.rows[Ne]=E(he.rows[Ne],he.header.length).map(function(ze){return{text:ze}});for(le=he.header.length,de=0;de<le;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(le=he.rows.length,de=0;de<le;de++)for(Me=he.rows[de],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return he}}},$e.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},$e.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},$e.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},$e.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:d(Y[1])}},$e.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]):Y[0]}},$e.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var le=f(he.slice(0,-1),"\\");if((he.length-le.length)%2===0)return}else{var Ne=S(Y[2],"()");if(Ne>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Me=Y[2],ze="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);z&&(Me=z[1],ze=z[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),P(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},$e.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var le=(he[2]||he[1]).replace(/\s+/g," ");if(le=Y[le.toLowerCase()],!le||!le.href){var Ne=he[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return P(he,le,he[0],this.lexer)}},$e.emStrong=function(Q,Y,he){he===void 0&&(he="");var le=this.rules.inline.emStrong.lDelim.exec(Q);if(le&&!(le[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=le[1]||le[2]||"";if(!Ne||Ne&&(he===""||this.rules.inline.punctuation.exec(he))){var de=le[0].length-1,Ce,Me,ze=de,z=0,L=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*Q.length+de);(le=L.exec(Y))!=null;)if(Ce=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!Ce){if(Me=Ce.length,le[3]||le[4]){ze+=Me;continue}else if((le[5]||le[6])&&de%3&&!((de+Me)%3)){z+=Me;continue}if(ze-=Me,!(ze>0)){if(Me=Math.min(Me,Me+ze+z),Math.min(de,Me)%2){var G=Q.slice(1,de+le.index+Me);return{type:"em",raw:Q.slice(0,de+le.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,de+le.index+Me-1);return{type:"strong",raw:Q.slice(0,de+le.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),le=/[^ ]/.test(he),Ne=/^ /.test(he)&&/ $/.test(he);return le&&Ne&&(he=he.substring(1,he.length-1)),he=d(he,!0),{type:"codespan",raw:Y[0],text:he}}},$e.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},$e.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},$e.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var le,Ne;return he[2]==="@"?(le=d(this.options.mangle?Y(he[1]):he[1]),Ne="mailto:"+le):(le=d(he[1]),Ne=le),{type:"link",raw:he[0],text:le,href:Ne,tokens:[{type:"text",raw:le,text:le}]}}},$e.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var le,Ne;if(he[2]==="@")le=d(this.options.mangle?Y(he[0]):he[0]),Ne="mailto:"+le;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);le=d(he[0]),he[1]==="www."?Ne="http://"+le:Ne=le}return{type:"link",raw:he[0],text:le,href:Ne,tokens:[{type:"text",raw:le,text:le}]}}},$e.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):d(he[0]):he[0]:le=d(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:le}}},Ee}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=r(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=r(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=r(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=r(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=r(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=h({},q),q.gfm=h({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=r(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=h({},q.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:r(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=r(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=r(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=r(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=r(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=r(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=r(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=r(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=r(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=r(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=r(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=r(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=h({},A),A.pedantic=h({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=h({},A.normal,{escape:r(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=r(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=h({},A.gfm,{br:r(A.br).replace("{2,}","*").getRegex(),text:r(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ee){var $e="",fe,Q,Y=Ee.length;for(fe=0;fe<Y;fe++)Q=Ee.charCodeAt(fe),Math.random()>.5&&(Q="x"+Q.toString(16)),$e+="&#"+Q+";";return $e}var ie=function(){function Ee(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}Ee.lex=function(Q,Y){var he=new Ee(Y);return he.lex(Q)},Ee.lexInline=function(Q,Y){var he=new Ee(Y);return he.inlineTokens(Q)};var $e=Ee.prototype;return $e.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},$e.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(ze,z,L){return z+"    ".repeat(L.length)});for(var le,Ne,de,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(le=ze.call({lexer:he},Q,Y))?(Q=Q.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.space(Q)){Q=Q.substring(le.raw.length),le.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(le);continue}if(le=this.tokenizer.code(Q)){Q=Q.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(le);continue}if(le=this.tokenizer.fences(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.heading(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.hr(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.blockquote(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.list(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.html(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.def(Q)){Q=Q.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.lheading(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,z=Q.slice(1),L=void 0;he.options.extensions.startBlock.forEach(function(G){L=G.call({lexer:this},z),typeof L=="number"&&L>=0&&(ze=Math.min(ze,L))}),ze<1/0&&ze>=0&&(de=Q.substring(0,ze+1))}(),this.state.top&&(le=this.tokenizer.paragraph(de))){Ne=Y[Y.length-1],Ce&&Ne.type==="paragraph"?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(le),Ce=de.length!==Q.length,Q=Q.substring(le.raw.length);continue}if(le=this.tokenizer.text(Q)){Q=Q.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+le.raw,Ne.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(le);continue}if(Q){var Me="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},$e.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},$e.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var le,Ne,de,Ce=Q,Me,ze,z;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(ze||(z=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(le=H.call({lexer:he},Q,Y))?(Q=Q.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.escape(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.tag(Q)){Q=Q.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&le.type==="text"&&Ne.type==="text"?(Ne.raw+=le.raw,Ne.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.link(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(le.raw.length),Ne=Y[Y.length-1],Ne&&le.type==="text"&&Ne.type==="text"?(Ne.raw+=le.raw,Ne.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.emStrong(Q,Ce,z)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.codespan(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.br(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.del(Q)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.autolink(Q,K)){Q=Q.substring(le.raw.length),Y.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(Q,K))){Q=Q.substring(le.raw.length),Y.push(le);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,_=Q.slice(1),se=void 0;he.options.extensions.startInline.forEach(function(Fe){se=Fe.call({lexer:this},_),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(de=Q.substring(0,H+1))}(),le=this.tokenizer.inlineText(de,j)){Q=Q.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(z=le.raw.slice(-1)),ze=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=le.raw,Ne.text+=le.text):Y.push(le);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(Ee,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),Ee}(),ce=function(){function Ee(fe){this.options=fe||ge.defaults}var $e=Ee.prototype;return $e.code=function(Q,Y,he){var le=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Q,le);Ne!=null&&Ne!==Q&&(he=!0,Q=Ne)}return Q=Q.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+d(le,!0)+'">'+(he?Q:d(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:d(Q,!0))+`</code></pre>
`},$e.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},$e.html=function(Q){return Q},$e.heading=function(Q,Y,he,le){if(this.options.headerIds){var Ne=this.options.headerPrefix+le.slug(he);return"<h"+Y+' id="'+Ne+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(Q,Y,he){var le=Y?"ol":"ul",Ne=Y&&he!==1?' start="'+he+'"':"";return"<"+le+Ne+`>
`+Q+"</"+le+`>
`},$e.listitem=function(Q){return"<li>"+Q+`</li>
`},$e.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(Q){return"<p>"+Q+`</p>
`},$e.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},$e.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},$e.tablecell=function(Q,Y){var he=Y.header?"th":"td",le=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return le+Q+("</"+he+`>
`)},$e.strong=function(Q){return"<strong>"+Q+"</strong>"},$e.em=function(Q){return"<em>"+Q+"</em>"},$e.codespan=function(Q){return"<code>"+Q+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(Q){return"<del>"+Q+"</del>"},$e.link=function(Q,Y,he){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var le='<a href="'+d(Q)+'"';return Y&&(le+=' title="'+Y+'"'),le+=">"+he+"</a>",le},$e.image=function(Q,Y,he){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var le='<img src="'+Q+'" alt="'+he+'"';return Y&&(le+=' title="'+Y+'"'),le+=this.options.xhtml?"/>":">",le},$e.text=function(Q){return Q},Ee}(),ve=function(){function Ee(){}var $e=Ee.prototype;return $e.strong=function(Q){return Q},$e.em=function(Q){return Q},$e.codespan=function(Q){return Q},$e.del=function(Q){return Q},$e.html=function(Q){return Q},$e.text=function(Q){return Q},$e.link=function(Q,Y,he){return""+he},$e.image=function(Q,Y,he){return""+he},$e.br=function(){return""},Ee}(),Ie=function(){function Ee(){this.seen={}}var $e=Ee.prototype;return $e.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(Q,Y){var he=Q,le=0;if(this.seen.hasOwnProperty(he)){le=this.seen[Q];do le++,he=Q+"-"+le;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=le,this.seen[he]=0),he},$e.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},Ee}(),ue=function(){function Ee(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Ie}Ee.parse=function(Q,Y){var he=new Ee(Y);return he.parse(Q)},Ee.parseInline=function(Q,Y){var he=new Ee(Y);return he.parseInline(Q)};var $e=Ee.prototype;return $e.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",le,Ne,de,Ce,Me,ze,z,L,G,H,_,se,Fe,Be,Qe,_e,et,tt,it,nt=Q.length;for(le=0;le<nt;le++){if(H=Q[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=it||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",z="",Ce=H.header.length,Ne=0;Ne<Ce;Ne++)z+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(L+=this.renderer.tablerow(z),G="",Ce=H.rows.length,Ne=0;Ne<Ce;Ne++){for(ze=H.rows[Ne],z="",Me=ze.length,de=0;de<Me;de++)z+=this.renderer.tablecell(this.parseInline(ze[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(z)}he+=this.renderer.table(L,G);continue}case"blockquote":{G=this.parse(H.tokens),he+=this.renderer.blockquote(G);continue}case"list":{for(_=H.ordered,se=H.start,Fe=H.loose,Ce=H.items.length,G="",Ne=0;Ne<Ce;Ne++)Qe=H.items[Ne],_e=Qe.checked,et=Qe.task,Be="",Qe.task&&(tt=this.renderer.checkbox(_e),Fe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=tt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=tt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Qe.tokens,Fe),G+=this.renderer.listitem(Be,et,_e);he+=this.renderer.list(G,_,se);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;le+1<nt&&Q[le+1].type==="text";)H=Q[++le],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(G):G;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return he},$e.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",le,Ne,de,Ce=Q.length;for(le=0;le<Ce;le++){if(Ne=Q[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(de=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){he+=de||"";continue}switch(Ne.type){case"escape":{he+=Y.text(Ne.text);break}case"html":{he+=Y.html(Ne.text);break}case"link":{he+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{he+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{he+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{he+=Y.codespan(Ne.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{he+=Y.text(Ne.text);break}default:{var Me='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},Ee}();function pe(Ee,$e,fe){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof $e=="function"&&(fe=$e,$e=null),$e=h({},pe.defaults,$e||{}),y($e),fe){var Q=$e.highlight,Y;try{Y=ie.lex(Ee,$e)}catch(Ce){return fe(Ce)}var he=function(Me){var ze;if(!Me)try{$e.walkTokens&&pe.walkTokens(Y,$e.walkTokens),ze=ue.parse(Y,$e)}catch(z){Me=z}return $e.highlight=Q,Me?fe(Me):fe(null,ze)};if(!Q||Q.length<3||(delete $e.highlight,!Y.length))return he();var le=0;pe.walkTokens(Y,function(Ce){Ce.type==="code"&&(le++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Me,ze){if(Me)return he(Me);ze!=null&&ze!==Ce.text&&(Ce.text=ze,Ce.escaped=!0),le--,le===0&&he()})},0))}),le===0&&he();return}function Ne(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+d(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ie.lex(Ee,$e);if($e.walkTokens){if($e.async)return Promise.all(pe.walkTokens(de,$e.walkTokens)).then(function(){return ue.parse(de,$e)}).catch(Ne);pe.walkTokens(de,$e.walkTokens)}return ue.parse(de,$e)}catch(Ce){Ne(Ce)}}pe.options=pe.setOptions=function(Ee){return h(pe.defaults,Ee),p(pe.defaults),pe},pe.getDefaults=M,pe.defaults=ge.defaults,pe.use=function(){for(var Ee=arguments.length,$e=new Array(Ee),fe=0;fe<Ee;fe++)$e[fe]=arguments[fe];var Q=h.apply(void 0,[{}].concat($e)),Y=pe.defaults.extensions||{renderers:{},childTokens:{}},he;$e.forEach(function(le){if(le.extensions&&(he=!0,le.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Me=arguments.length,ze=new Array(Me),z=0;z<Me;z++)ze[z]=arguments[z];var L=de.renderer.apply(this,ze);return L===!1&&(L=Ce.apply(this,ze)),L}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),le.renderer&&function(){var de=pe.defaults.renderer||new ce,Ce=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),_=0;_<G;_++)H[_]=arguments[_];var se=le.renderer[z].apply(de,H);return se===!1&&(se=L.apply(de,H)),se}};for(var Me in le.renderer)Ce(Me);Q.renderer=de}(),le.tokenizer&&function(){var de=pe.defaults.tokenizer||new W,Ce=function(z){var L=de[z];de[z]=function(){for(var G=arguments.length,H=new Array(G),_=0;_<G;_++)H[_]=arguments[_];var se=le.tokenizer[z].apply(de,H);return se===!1&&(se=L.apply(de,H)),se}};for(var Me in le.tokenizer)Ce(Me);Q.tokenizer=de}(),le.walkTokens){var Ne=pe.defaults.walkTokens;Q.walkTokens=function(de){var Ce=[];return Ce.push(le.walkTokens.call(this,de)),Ne&&(Ce=Ce.concat(Ne.call(this,de))),Ce}}he&&(Q.extensions=Y),pe.setOptions(Q)})},pe.walkTokens=function(Ee,$e){for(var fe=[],Q=function(){var Ne=he.value;switch(fe=fe.concat($e.call(pe,Ne)),Ne.type){case"table":{for(var de=F(Ne.header),Ce;!(Ce=de()).done;){var Me=Ce.value;fe=fe.concat(pe.walkTokens(Me.tokens,$e))}for(var ze=F(Ne.rows),z;!(z=ze()).done;)for(var L=z.value,G=F(L),H;!(H=G()).done;){var _=H.value;fe=fe.concat(pe.walkTokens(_.tokens,$e))}break}case"list":{fe=fe.concat(pe.walkTokens(Ne.items,$e));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Ne.type]?pe.defaults.extensions.childTokens[Ne.type].forEach(function(se){fe=fe.concat(pe.walkTokens(Ne[se],$e))}):Ne.tokens&&(fe=fe.concat(pe.walkTokens(Ne.tokens,$e)))}},Y=F(Ee),he;!(he=Y()).done;)Q();return fe},pe.parseInline=function(Ee,$e){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");$e=h({},pe.defaults,$e||{}),y($e);try{var fe=ie.lexInline(Ee,$e);return $e.walkTokens&&pe.walkTokens(fe,$e.walkTokens),ue.parseInline(fe,$e)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+d(Q.message+"",!0)+"</pre>";throw Q}},pe.Parser=ue,pe.parser=ue.parse,pe.Renderer=ce,pe.TextRenderer=ve,pe.Lexer=ie,pe.lexer=ie.lex,pe.Tokenizer=W,pe.Slugger=Ie,pe.parse=pe;var re=pe.options,Se=pe.setOptions,Le=pe.use,ne=pe.walkTokens,U=pe.parseInline,x=pe,be=ue.parse,Te=ie.lex;ge.Lexer=ie,ge.Parser=ue,ge.Renderer=ce,ge.Slugger=Ie,ge.TextRenderer=ve,ge.Tokenizer=W,ge.getDefaults=M,ge.lexer=Te,ge.marked=pe,ge.options=re,ge.parse=x,ge.parseInline=U,ge.parser=be,ge.setOptions=Se,ge.use=Le,ge.walkTokens=ne,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Re[125],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=I;function I(s){const o=F(s);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const R=new Uint32Array(10);function F(s){if(N=0,M(s,k,4352),N>0||(M(s,u,4449),N>0)||(M(s,w,4520),N>0)||(M(s,d,12593),N))return R.subarray(0,N);if(s>=44032&&s<=55203){const o=s-44032,n=o%588,r=Math.floor(o/588),i=Math.floor(n/28),a=n%28-1;if(r<k.length?M(r,k,0):4352+r-12593<d.length&&M(4352+r,d,12593),i<u.length?M(i,u,0):4449+i-12593<d.length&&M(4449+i-12593,d,12593),a>=0&&(a<w.length?M(a,w,0):4520+a-12593<d.length&&M(4520+a-12593,d,12593)),N>0)return R.subarray(0,N)}}function M(s,o,n){s>=n&&s<n+o.length&&p(o[s-n])}function p(s){s!==0&&(R[N++]=s&255,s>>8&&(R[N++]=s>>8&255),s>>16&&(R[N++]=s>>16&255))}var g;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var D;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(D||(D={}));var T;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(T||(T={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),d=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[126],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=I,e.rot=N;function I(p,g,D){return Math.min(Math.max(p,g),D)}function N(p,g){return(g+p%g)%g}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=R;class F{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=F;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const D=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function ge(R){const F=[];typeof R=="number"&&F.push("code/timeOrigin",R);function M(g){F.push(g,Date.now())}function p(){const g=[];for(let D=0;D<F.length;D+=2)g.push({name:F[D],startTime:F[D+1]});return g}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))F.push({name:M.name,startTime:Math.round(R+M.startTime)});return F}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),define(Re[127],Ae([1,0,46]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=void 0;const N=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(g,D,T){this.d(g,k=>k._value=D,T)}mutate(g,D){this.d(g,T=>T._value=D(T._value===N?void 0:T._value))}delete(g){const D=this.c(g);if(!D)return;let T=D.length-1;const k=D[T].node._value;if(k!==N){for(this.b--,D[T].node._value=N;T>0;T--){const{node:u,part:w}=D[T];if(u.children?.size||u._value!==N)break;D[T-1].node.children.delete(w)}return k}}*deleteRecursive(g){const D=this.c(g);if(!D)return;const T=D[D.length-1].node;for(let k=D.length-1;k>0;k--){const u=D[k-1];if(u.node.children.delete(D[k].part),u.node.children.size>0||u.node._value!==N)break}for(const k of F(T))k._value!==N&&(this.b--,yield k._value)}find(g){let D=this.a;for(const T of g){const k=D.children?.get(T);if(!k)return;D=k}return D._value===N?void 0:D._value}hasKeyOrParent(g){let D=this.a;for(const T of g){const k=D.children?.get(T);if(!k)return!1;if(k._value!==N)return!0;D=k}return!1}hasKeyOrChildren(g){let D=this.a;for(const T of g){const k=D.children?.get(T);if(!k)return!1;D=k}return!0}hasKey(g){let D=this.a;for(const T of g){const k=D.children?.get(T);if(!k)return!1;D=k}return D._value!==N}c(g){const D=[{part:"",node:this.a}];let T=0;for(const k of g){const u=D[T].node.children?.get(k);if(!u)return;D.push({part:k,node:u}),T++}return D}d(g,D,T){let k=this.a;for(const d of g){if(k.children)if(k.children.has(d))k=k.children.get(d);else{const s=new M;k.children.set(d,s),k=s}else{const s=new M;k.children=new Map([[d,s]]),k=s}T?.(k)}const u=k._value===N?0:1;D(k);const w=k._value===N?0:1;this.b+=w-u}*values(){for(const{_value:g}of F(this.a))g!==N&&(yield g)}}e.$2O=R;function*F(p){const g=[p];for(;g.length>0;){const D=g.pop();if(yield D,D.children)for(const T of D.children.values())g.push(T)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(g){this._value=g===void 0?N:g}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:ge)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(N){if(e[N])return e[N].exports;var R=e[N]={i:N,l:!1,exports:{}};return ge[N].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=ge,I.c=e,I.d=function(N,R,F){I.o(N,R)||Object.defineProperty(N,R,{enumerable:!0,get:F})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,R){if(1&R&&(N=I(N)),8&R||4&R&&typeof N=="object"&&N&&N.__esModule)return N;var F=Object.create(null);if(I.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:N}),2&R&&typeof N!="string")for(var M in N)I.d(F,M,function(p){return N[p]}.bind(null,M));return F},I.n=function(N){var R=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(R,"a",R),R},I.o=function(N,R){return Object.prototype.hasOwnProperty.call(N,R)},I.p="",I(I.s=0)}([function(ge,e,I){(function(N){var R;e=ge.exports=Le,R=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],g=e.src=[],D=0,T=D++;g[T]="0|[1-9]\\d*";var k=D++;g[k]="[0-9]+";var u=D++;g[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=D++;g[w]="("+g[T]+")\\.("+g[T]+")\\.("+g[T]+")";var d=D++;g[d]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var s=D++;g[s]="(?:"+g[T]+"|"+g[u]+")";var o=D++;g[o]="(?:"+g[k]+"|"+g[u]+")";var n=D++;g[n]="(?:-("+g[s]+"(?:\\."+g[s]+")*))";var r=D++;g[r]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var i=D++;g[i]="[0-9A-Za-z-]+";var a=D++;g[a]="(?:\\+("+g[i]+"(?:\\."+g[i]+")*))";var l=D++,t="v?"+g[w]+g[n]+"?"+g[a]+"?";g[l]="^"+t+"$";var b="[v=\\s]*"+g[d]+g[r]+"?"+g[a]+"?",c=D++;g[c]="^"+b+"$";var m=D++;g[m]="((?:<|>)?=?)";var v=D++;g[v]=g[k]+"|x|X|\\*";var $=D++;g[$]=g[T]+"|x|X|\\*";var h=D++;g[h]="[v=\\s]*("+g[$]+")(?:\\.("+g[$]+")(?:\\.("+g[$]+")(?:"+g[n]+")?"+g[a]+"?)?)?";var E=D++;g[E]="[v=\\s]*("+g[v]+")(?:\\.("+g[v]+")(?:\\.("+g[v]+")(?:"+g[r]+")?"+g[a]+"?)?)?";var f=D++;g[f]="^"+g[m]+"\\s*"+g[h]+"$";var S=D++;g[S]="^"+g[m]+"\\s*"+g[E]+"$";var y=D++;g[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=D++;g[C]="(?:~>?)";var P=D++;g[P]="(\\s*)"+g[C]+"\\s+",p[P]=new RegExp(g[P],"g");var V=D++;g[V]="^"+g[C]+g[h]+"$";var W=D++;g[W]="^"+g[C]+g[E]+"$";var q=D++;g[q]="(?:\\^)";var A=D++;g[A]="(\\s*)"+g[q]+"\\s+",p[A]=new RegExp(g[A],"g");var j=D++;g[j]="^"+g[q]+g[h]+"$";var K=D++;g[K]="^"+g[q]+g[E]+"$";var ie=D++;g[ie]="^"+g[m]+"\\s*("+b+")$|^$";var ce=D++;g[ce]="^"+g[m]+"\\s*("+t+")$|^$";var ve=D++;g[ve]="(\\s*)"+g[m]+"\\s*("+b+"|"+g[h]+")",p[ve]=new RegExp(g[ve],"g");var Ie=D++;g[Ie]="^\\s*("+g[h]+")\\s+-\\s+("+g[h]+")\\s*$";var ue=D++;g[ue]="^\\s*("+g[E]+")\\s+-\\s+("+g[E]+")\\s*$";var pe=D++;g[pe]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)R(re,g[re]),p[re]||(p[re]=new RegExp(g[re]));function Se(L,G){if(L instanceof Le)return L;if(typeof L!="string"||L.length>F||!(G?p[c]:p[l]).test(L))return null;try{return new Le(L,G)}catch{return null}}function Le(L,G){if(L instanceof Le){if(L.loose===G)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof Le))return new Le(L,G);R("SemVer",L,G),this.loose=G;var H=L.trim().match(G?p[c]:p[l]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(_){if(/^[0-9]+$/.test(_)){var se=+_;if(se>=0&&se<M)return se}return _}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Se,e.valid=function(L,G){var H=Se(L,G);return H?H.version:null},e.clean=function(L,G){var H=Se(L.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Le,Le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Le.prototype.toString=function(){return this.version},Le.prototype.compare=function(L){return R("SemVer.compare",this.version,this.loose,L),L instanceof Le||(L=new Le(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Le.prototype.compareMain=function(L){return L instanceof Le||(L=new Le(L,this.loose)),U(this.major,L.major)||U(this.minor,L.minor)||U(this.patch,L.patch)},Le.prototype.comparePre=function(L){if(L instanceof Le||(L=new Le(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],_=L.prerelease[G];if(R("prerelease compare",G,H,_),H===void 0&&_===void 0)return 0;if(_===void 0)return 1;if(H===void 0)return-1;if(H!==_)return U(H,_)}while(++G)},Le.prototype.inc=function(L,G){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,G,H,_){typeof H=="string"&&(_=H,H=void 0);try{return new Le(L,H).inc(G,_).version}catch{return null}},e.diff=function(L,G){if(Ee(L,G))return null;var H=Se(L),_=Se(G);if(H.prerelease.length||_.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==_[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==_[se])return se},e.compareIdentifiers=U;var ne=/^[0-9]+$/;function U(L,G){var H=ne.test(L),_=ne.test(G);return H&&_&&(L=+L,G=+G),H&&!_?-1:_&&!H?1:L<G?-1:L>G?1:0}function x(L,G,H){return new Le(L,H).compare(new Le(G,H))}function be(L,G,H){return x(L,G,H)>0}function Te(L,G,H){return x(L,G,H)<0}function Ee(L,G,H){return x(L,G,H)===0}function $e(L,G,H){return x(L,G,H)!==0}function fe(L,G,H){return x(L,G,H)>=0}function Q(L,G,H){return x(L,G,H)<=0}function Y(L,G,H,_){var se;switch(G){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),se=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),se=L!==H;break;case"":case"=":case"==":se=Ee(L,H,_);break;case"!=":se=$e(L,H,_);break;case">":se=be(L,H,_);break;case">=":se=fe(L,H,_);break;case"<":se=Te(L,H,_);break;case"<=":se=Q(L,H,_);break;default:throw new TypeError("Invalid operator: "+G)}return se}function he(L,G){if(L instanceof he){if(L.loose===G)return L;L=L.value}if(!(this instanceof he))return new he(L,G);R("comparator",L,G),this.loose=G,this.parse(L),this.semver===le?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(L,G){return U(G,L)},e.major=function(L,G){return new Le(L,G).major},e.minor=function(L,G){return new Le(L,G).minor},e.patch=function(L,G){return new Le(L,G).patch},e.compare=x,e.compareLoose=function(L,G){return x(L,G,!0)},e.rcompare=function(L,G,H){return x(G,L,H)},e.sort=function(L,G){return L.sort(function(H,_){return e.compare(H,_,G)})},e.rsort=function(L,G){return L.sort(function(H,_){return e.rcompare(H,_,G)})},e.gt=be,e.lt=Te,e.eq=Ee,e.neq=$e,e.gte=fe,e.lte=Q,e.cmp=Y,e.Comparator=he;var le={};function Ne(L,G){if(L instanceof Ne)return L.loose===G?L:new Ne(L.raw,G);if(L instanceof he)return new Ne(L.value,G);if(!(this instanceof Ne))return new Ne(L,G);if(this.loose=G,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function de(L){return!L||L.toLowerCase()==="x"||L==="*"}function Ce(L,G,H,_,se,Fe,Be,Qe,_e,et,tt,it,nt){return((G=de(H)?"":de(_)?">="+H+".0.0":de(se)?">="+H+"."+_+".0":">="+G)+" "+(Qe=de(_e)?"":de(et)?"<"+(+_e+1)+".0.0":de(tt)?"<"+_e+"."+(+et+1)+".0":it?"<="+_e+"."+et+"."+tt+"-"+it:"<="+Qe)).trim()}function Me(L,G){for(var H=0;H<L.length;H++)if(!L[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<L.length;H++)if(R(L[H].semver),L[H].semver!==le&&L[H].semver.prerelease.length>0){var _=L[H].semver;if(_.major===G.major&&_.minor===G.minor&&_.patch===G.patch)return!0}return!1}return!0}function ze(L,G,H){try{G=new Ne(G,H)}catch{return!1}return G.test(L)}function z(L,G,H,_){var se,Fe,Be,Qe,_e;switch(L=new Le(L,_),G=new Ne(G,_),H){case">":se=be,Fe=Q,Be=Te,Qe=">",_e=">=";break;case"<":se=Te,Fe=fe,Be=be,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(L,G,_))return!1;for(var et=0;et<G.set.length;++et){var tt=G.set[et],it=null,nt=null;if(tt.forEach(function(ct){ct.semver===le&&(ct=new he(">=0.0.0")),it=it||ct,nt=nt||ct,se(ct.semver,it.semver,_)?it=ct:Be(ct.semver,nt.semver,_)&&(nt=ct)}),it.operator===Qe||it.operator===_e||(!nt.operator||nt.operator===Qe)&&Fe(L,nt.semver)||nt.operator===_e&&Be(L,nt.semver))return!1}return!0}he.prototype.parse=function(L){var G=this.loose?p[ie]:p[ce],H=L.match(G);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Le(H[2],this.loose):this.semver=le},he.prototype.toString=function(){return this.value},he.prototype.test=function(L){return R("Comparator.test",L,this.loose),this.semver===le||(typeof L=="string"&&(L=new Le(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},he.prototype.intersects=function(L,G){if(!(L instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(L.value,G),ze(this.value,H,G);if(L.operator==="")return H=new Ne(this.value,G),ze(L.semver,H,G);var _=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Fe=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),Qe=Y(this.semver,"<",L.semver,G)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),_e=Y(this.semver,">",L.semver,G)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return _||se||Fe&&Be||Qe||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(L){var G=this.loose;L=L.trim(),R("range",L,G);var H=G?p[ue]:p[Ie];L=L.replace(H,Ce),R("hyphen replace",L),L=L.replace(p[ve],"$1$2$3"),R("comparator trim",L,p[ve]),L=(L=(L=L.replace(p[P],"$1~")).replace(p[A],"$1^")).split(/\s+/).join(" ");var _=G?p[ie]:p[ce],se=L.split(" ").map(function(Fe){return function(Be,Qe){return R("comp",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){R("caret",it,nt);var ct=nt?p[K]:p[j];return it.replace(ct,function(ft,je,st,X,Z){var me;return R("caret",it,ft,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Z?(R("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+Z+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+Z+" <"+(+je+1)+".0.0"):(R("no pr"),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+" <"+(+je+1)+".0.0"),R("caret return",me),me})}(tt,et)}).join(" ")}(Be,Qe),R("caret",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){var ct=nt?p[W]:p[V];return it.replace(ct,function(ft,je,st,X,Z){var me;return R("tilde",it,ft,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Z?(R("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0"):me=">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0",R("tilde return",me),me})}(tt,et)}).join(" ")}(Be,Qe),R("tildes",Be),Be=function(_e,et){return R("replaceXRanges",_e,et),_e.split(/\s+/).map(function(tt){return function(it,nt){it=it.trim();var ct=nt?p[S]:p[f];return it.replace(ct,function(ft,je,st,X,Z,me){R("xRange",it,ft,je,st,X,Z,me);var He=de(st),we=He||de(X),ot=we||de(Z);return je==="="&&ot&&(je=""),He?ft=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(we&&(X=0),ot&&(Z=0),je===">"?(je=">=",we?(st=+st+1,X=0,Z=0):ot&&(X=+X+1,Z=0)):je==="<="&&(je="<",we?st=+st+1:X=+X+1),ft=je+st+"."+X+"."+Z):we?ft=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(ft=">="+st+"."+X+".0 <"+st+"."+(+X+1)+".0"),R("xRange return",ft),ft})}(tt,et)}).join(" ")}(Be,Qe),R("xrange",Be),Be=function(_e,et){return R("replaceStars",_e,et),_e.trim().replace(p[pe],"")}(Be,Qe),R("stars",Be),Be}(Fe,G)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Fe){return!!Fe.match(_)})),se=se.map(function(Fe){return new he(Fe,G)})},Ne.prototype.intersects=function(L,G){if(!(L instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(_){return L.set.some(function(se){return se.every(function(Fe){return _.intersects(Fe,G)})})})})},e.toComparators=function(L,G){return new Ne(L,G).set.map(function(H){return H.map(function(_){return _.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Le(L,this.loose));for(var G=0;G<this.set.length;G++)if(Me(this.set[G],L))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(L,G,H){var _=null,se=null;try{var Fe=new Ne(G,H)}catch{return null}return L.forEach(function(Be){Fe.test(Be)&&(_&&se.compare(Be)!==-1||(se=new Le(_=Be,H)))}),_},e.minSatisfying=function(L,G,H){var _=null,se=null;try{var Fe=new Ne(G,H)}catch{return null}return L.forEach(function(Be){Fe.test(Be)&&(_&&se.compare(Be)!==1||(se=new Le(_=Be,H)))}),_},e.validRange=function(L,G){try{return new Ne(L,G).range||"*"}catch{return null}},e.ltr=function(L,G,H){return z(L,G,"<",H)},e.gtr=function(L,G,H){return z(L,G,">",H)},e.outside=z,e.prerelease=function(L,G){var H=Se(L,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,G,H){return L=new Ne(L,H),G=new Ne(G,H),L.intersects(G)},e.coerce=function(L){if(L instanceof Le)return L;if(typeof L!="string")return null;var G=L.match(p[y]);return G==null?null:Se((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,N,R=ge.exports={};function F(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(o){if(I===setTimeout)return setTimeout(o,0);if((I===F||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:F}catch{I=F}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var g,D=[],T=!1,k=-1;function u(){T&&g&&(T=!1,g.length?D=g.concat(D):k=-1,D.length&&w())}function w(){if(!T){var o=p(u);T=!0;for(var n=D.length;n;){for(g=D,D=[];++k<n;)g&&g[k].run();k=-1,n=D.length}g=null,T=!1,function(r){if(N===clearTimeout)return clearTimeout(r);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(r);try{N(r)}catch{try{return N.call(null,r)}catch{return N.call(this,r)}}}(o)}}function d(o,n){this.fun=o,this.array=n}function s(){}R.nextTick=function(o){var n=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)n[r-1]=arguments[r];D.push(new d(o,n)),D.length!==1||T||p(w)},d.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=s,R.addListener=s,R.once=s,R.off=s,R.removeListener=s,R.removeAllListeners=s,R.emit=s,R.prependListener=s,R.prependOnceListener=s,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Re[128],Ae([1,0,14,6]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=R,e.$oe=F,e.$pe=M,e.$qe=p,e.$re=D,e.$se=T,e.$te=k,e.$ue=u,e.$ve=w,e.$we=d,e.$xe=s,e.$ye=o,e.$ze=n,e.$Ae=r,e.$Be=i;function R(a){const l=a;return l?typeof l.read=="function":!1}function F(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}function M(a){const l=a;return l?F(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function p(a,l){return new g(a,l)}class g{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,I.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let b;switch(l){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const c=b.indexOf(t);c>=0&&b.splice(c,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(a,l){const t=[];let b;for(;(b=a.read())!==null;)t.push(b);return l(t)}function T(a,l,t){const b=[];let c;for(;(c=a.read())!==null&&b.length<t;)b.push(c);return c===null&&b.length>0?l(b):{read:()=>{if(b.length>0)return b.shift();if(typeof c<"u"){const m=c;return c=void 0,m}return a.read()}}}function k(a,l){return new Promise((t,b)=>{const c=[];u(a,{onData:m=>{l&&c.push(m)},onError:m=>{l?b(m):t(void 0)},onEnd:()=>{t(l?l(c):void 0)}})})}function u(a,l,t){a.on("error",b=>{t?.isCancellationRequested||l.onError(b)}),a.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),a.on("data",b=>{t?.isCancellationRequested||l.onData(b)})}function w(a,l){return new Promise((t,b)=>{const c=new N.$Tc,m=[],v=E=>{if(m.push(E),m.length>l)return c.dispose(),a.pause(),t({stream:a,buffer:m,ended:!1})},$=E=>(c.dispose(),b(E)),h=()=>(c.dispose(),t({stream:a,buffer:m,ended:!0}));c.add((0,N.$Sc)(()=>a.removeListener("error",$))),a.on("error",$),c.add((0,N.$Sc)(()=>a.removeListener("end",h))),a.on("end",h),c.add((0,N.$Sc)(()=>a.removeListener("data",v))),a.on("data",v)})}function d(a,l){const t=p(l);return t.end(a),t}function s(){const a=p(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}function n(a,l,t){const b=p(t);return u(a,{onData:c=>b.write(l.data(c)),onError:c=>b.error(l.error?l.error(c):c),onEnd:()=>b.end()}),b}function r(a,l,t){let b=!1;return{read:()=>{const c=l.read();return b?c:(b=!0,c!==null?t([a,c]):a)}}}function i(a,l,t){let b=!1;const c=p(t);return u(l,{onData:m=>b?c.write(m):(b=!0,c.write(t([a,m]))),onError:m=>c.error(m),onEnd:()=>{b||(b=!0,c.write(a)),c.end()}}),c}}),define(Re[22],Ae([1,0,40,128]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=D,e.$Ee=T,e.$Fe=k,e.$Ge=u,e.$He=w,e.$Ie=d,e.$Je=s,e.$Ke=o,e.$Le=n,e.$Me=r,e.$Ne=i,e.$Oe=a,e.$Pe=l,e.$Qe=t,e.$Re=b,e.$Se=c,e.$Te=m,e.$Ue=v,e.$Ve=$,e.$We=f;const R=typeof Buffer<"u",F=new I.$V(()=>new Uint8Array(256));let M,p;class g{static alloc(y){return R?new g(Buffer.allocUnsafe(y)):new g(new Uint8Array(y))}static wrap(y){return R&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new g(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&R?new g(Buffer.from(y)):(M||(M=new TextEncoder),new g(M.encode(y)))}static fromByteArray(y){const C=g.alloc(y.length);for(let P=0,V=y.length;P<V;P++)C.buffer[P]=y[P];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let W=0,q=y.length;W<q;W++)C+=y[W].byteLength}const P=g.alloc(C);let V=0;for(let W=0,q=y.length;W<q;W++){const A=y[W];P.set(A,V),V+=A.byteLength}return P}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=g.alloc(this.byteLength);return y.set(this),y}toString(){return R?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(y,C){return new g(this.buffer.subarray(y,C))}set(y,C){if(y instanceof g)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,C){w(this.buffer,y,C)}readUInt32LE(y){return d(this.buffer,y)}writeUInt32LE(y,C){s(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){n(this.buffer,y,C)}indexOf(y,C=0){return D(this.buffer,y instanceof g?y.buffer:y,C)}}e.$Ce=g;function D(S,y,C=0){const P=y.byteLength,V=S.byteLength;if(P===0)return 0;if(P===1)return S.indexOf(y[0]);if(P>V-C)return-1;const W=F.value;W.fill(y.length);for(let K=0;K<y.length;K++)W[y[K]]=y.length-K-1;let q=C+y.length-1,A=q,j=-1;for(;q<V;)if(S[q]===y[A]){if(A===0){j=q;break}q--,A--}else q+=Math.max(y.length-A,W[S[q]]),A=y.length-1;return j}function T(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0}function k(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255}function u(S,y){return S[y]*2**24+S[y+1]*2**16+S[y+2]*2**8+S[y+3]}function w(S,y,C){S[C+3]=y,y=y>>>8,S[C+2]=y,y=y>>>8,S[C+1]=y,y=y>>>8,S[C]=y}function d(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0|S[y+2]<<16>>>0|S[y+3]<<24>>>0}function s(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255,y=y>>>8,S[C+2]=y&255,y=y>>>8,S[C+3]=y&255}function o(S,y){return S[y]}function n(S,y,C){S[C]=y}function r(S){return N.$re(S,y=>g.concat(y))}function i(S){return N.$ye(S)}function a(S){return N.$te(S,y=>g.concat(y))}async function l(S){return S.ended?g.concat(S.buffer):g.concat([...S.buffer,await a(S.stream)])}function t(S){return N.$we(S,y=>g.concat(y))}function b(S){return N.$ze(S,{data:y=>typeof y=="string"?g.fromString(y):g.wrap(y)},y=>g.concat(y))}function c(S){return N.$qe(y=>g.concat(y),S)}function m(S,y){return N.$Ae(S,y,C=>g.concat(C))}function v(S,y){return N.$Be(S,y,C=>g.concat(C))}function $(S){let y=0,C=0,P=0;const V=new Uint8Array(Math.floor(S.length/4*3)),W=A=>{switch(C){case 3:V[P++]=y|A,C=0;break;case 2:V[P++]=y|A>>>2,y=A<<6,C=3;break;case 1:V[P++]=y|A>>>4,y=A<<4,C=2;break;default:y=A<<2,C=1}};for(let A=0;A<S.length;A++){const j=S.charCodeAt(A);if(j>=65&&j<=90)W(j-65);else if(j>=97&&j<=122)W(j-97+26);else if(j>=48&&j<=57)W(j-48+52);else if(j===43||j===45)W(62);else if(j===47||j===95)W(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${S[A]}`)}}const q=P;for(;C>0;)W(0);return g.wrap(V).slice(0,q)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:S},y=!0,C=!1){const P=C?E:h;let V="";const W=S.byteLength%3;let q=0;for(;q<S.byteLength-W;q+=3){const A=S[q+0],j=S[q+1],K=S[q+2];V+=P[A>>>2],V+=P[(A<<4|j>>>4)&63],V+=P[(j<<2|K>>>6)&63],V+=P[K&63]}if(W===1){const A=S[q+0];V+=P[A>>>2],V+=P[A<<4&63],y&&(V+="==")}else if(W===2){const A=S[q+0],j=S[q+1];V+=P[A>>>2],V+=P[(A<<4|j>>>4)&63],V+=P[j<<2&63],y&&(V+="=")}return V}}),define(Re[129],Ae([1,0,28,125,15]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=F,e.$tk=p,e.$uk=g,e.$vk=k,e.$wk=$,e.$xk=h,e.$yk=P,e.$zk=V,e.$Ak=W,e.$Bk=q,e.$Ck=x,e.$Ek=$e,e.$Fk=Y,e.$Gk=he;function F(...de){return function(Ce,Me){for(let ze=0,z=de.length;ze<z;ze++){const L=de[ze](Ce,Me);if(L)return L}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(de,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return de?ze=R.$uf(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function p(de,Ce){const Me=Ce.toLowerCase().indexOf(de.toLowerCase());return Me===-1?null:[{start:Me,end:Me+de.length}]}function g(de,Ce){return D(de.toLowerCase(),Ce.toLowerCase(),0,0)}function D(de,Ce,Me,ze){if(Me===de.length)return[];if(ze===Ce.length)return null;if(de[Me]===Ce[ze]){let z=null;return(z=D(de,Ce,Me+1,ze+1))?a({start:ze,end:ze+1},z):null}return D(de,Ce,Me,ze+1)}function T(de){return 97<=de&&de<=122}function k(de){return 65<=de&&de<=90}function u(de){return 48<=de&&de<=57}function w(de){return de===32||de===9||de===10||de===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>d.add(de.charCodeAt(0)));function s(de){return w(de)||d.has(de)}function o(de,Ce){return de===Ce||s(de)&&s(Ce)}const n=new Map;function r(de){if(n.has(de))return n.get(de);let Ce;const Me=(0,N.$pk)(de);return Me&&(Ce=Me),n.set(de,Ce),Ce}function i(de){return T(de)||k(de)||u(de)}function a(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function l(de,Ce){for(let Me=Ce;Me<de.length;Me++){const ze=de.charCodeAt(Me);if(k(ze)||u(ze)||Me>0&&!i(de.charCodeAt(Me-1)))return Me}return de.length}function t(de,Ce,Me,ze){if(Me===de.length)return[];if(ze===Ce.length)return null;if(de[Me]!==Ce[ze].toLowerCase())return null;{let z=null,L=ze+1;for(z=t(de,Ce,Me+1,ze+1);!z&&(L=l(Ce,L))<Ce.length;)z=t(de,Ce,Me+1,L),L++;return z===null?null:a({start:ze,end:ze+1},z)}}function b(de){let Ce=0,Me=0,ze=0,z=0,L=0;for(let Fe=0;Fe<de.length;Fe++)L=de.charCodeAt(Fe),k(L)&&Ce++,T(L)&&Me++,i(L)&&ze++,u(L)&&z++;const G=Ce/de.length,H=Me/de.length,_=ze/de.length,se=z/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:_,numericPercent:se}}function c(de){const{upperPercent:Ce,lowerPercent:Me}=de;return Me===0&&Ce>.6}function m(de){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:z}=de;return Me>.2&&Ce<.8&&ze>.6&&z<.2}function v(de){let Ce=0,Me=0,ze=0,z=0;for(let L=0;L<de.length;L++)ze=de.charCodeAt(L),k(ze)&&Ce++,T(ze)&&Me++,w(ze)&&z++;return(Ce===0||Me===0)&&z===0?de.length<=30:Ce<=5}function $(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!v(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=b(Ce);if(!m(Me)){if(!c(Me))return null;Ce=Ce.toLowerCase()}let ze=null,z=0;for(de=de.toLowerCase();z<Ce.length&&(ze=t(de,Ce,0,z))===null;)z=l(Ce,z+1);return ze}function h(de,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,z=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(ze=E(de,Ce,0,z,Me),ze===null);)z=f(Ce,z+1);return ze}function E(de,Ce,Me,ze,z){let L=0;if(Me===de.length)return[];if(ze===Ce.length)return null;if(!o(de.charCodeAt(Me),Ce.charCodeAt(ze))){const _=r(de.charCodeAt(Me));if(!_)return null;for(let se=0;se<_.length;se++)if(!o(_[se],Ce.charCodeAt(ze+se)))return null;L+=_.length-1}let G=null,H=ze+L+1;if(G=E(de,Ce,Me+1,H,z),!z)for(;!G&&(H=f(Ce,H))<Ce.length;)G=E(de,Ce,Me+1,H,z),H++;if(!G)return null;if(de.charCodeAt(Me)!==Ce.charCodeAt(ze)){const _=r(de.charCodeAt(Me));if(!_)return G;for(let se=0;se<_.length;se++)if(_[se]!==Ce.charCodeAt(ze+se))return G}return a({start:ze,end:ze+L+1},G)}function f(de,Ce){for(let Me=Ce;Me<de.length;Me++)if(s(de.charCodeAt(Me))||Me>0&&s(de.charCodeAt(Me-1)))return Me;return de.length}const S=F(e.$sk,$,p),y=F(e.$sk,$,g),C=new I.$Ec(1e4);function P(de,Ce,Me=!1){if(typeof de!="string"||typeof Ce!="string")return null;let ze=C.get(de);ze||(ze=new RegExp(R.$cf(de),"i"),C.set(de,ze));const z=ze.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Me?y(de,Ce):S(de,Ce)}function V(de,Ce){const Me=$e(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function W(de,Ce,Me,ze,z,L){const G=Math.min(13,de.length);for(;Me<G;Me++){const H=$e(de,Ce,Me,ze,z,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(de){if(typeof de>"u")return[];const Ce=[],Me=de[1];for(let ze=de.length-1;ze>1;ze--){const z=de[ze]+Me,L=Ce[Ce.length-1];L&&L.end===z?L.end=z+1:Ce.push({start:z,end:z+1})}return Ce}const A=128;function j(){const de=[],Ce=[];for(let Me=0;Me<=A;Me++)Ce[Me]=0;for(let Me=0;Me<=A;Me++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Me=0;Me<=de;Me++)Ce[Me]=0;return Ce}const ie=K(2*A),ce=K(2*A),ve=j(),Ie=j(),ue=j(),pe=!1;function re(de,Ce,Me,ze,z){function L(H,_,se=" "){for(;H.length<_;)H=se+H;return H}let G=` |   |${ze.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=de[H].slice(0,z+1).map(_=>L(_.toString(),3)).join("|")+`
`;return G}function Se(de,Ce,Me,ze){de=de.substr(Ce),Me=Me.substr(ze),console.log(re(Ie,de,de.length,Me,Me.length)),console.log(re(ue,de,de.length,Me,Me.length)),console.log(re(ve,de,de.length,Me,Me.length))}function Le(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Me=de.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Mf(Me)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function U(de,Ce,Me){return Ce[de]!==Me[de]}function x(de,Ce,Me,ze,z,L,G=!1){for(;Ce<Me&&z<L;)de[Ce]===ze[z]&&(G&&(ie[Ce]=z),Ce+=1),z+=1;return Ce===Me}var be;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(be||(be={}));var Te;(function(de){de.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}de.isDefault=Ce})(Te||(e.FuzzyScore=Te={}));class Ee{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$Dk=Ee;function $e(de,Ce,Me,ze,z,L,G=Ee.default){const H=de.length>A?A:de.length,_=ze.length>A?A:ze.length;if(Me>=H||L>=_||H-Me>_-L||!x(Ce,Me,H,z,L,_,!0))return;fe(H,_,Me,L,Ce,z);let se=1,Fe=1,Be=Me,Qe=L;const _e=[!1];for(se=1,Be=Me;Be<H;se++,Be++){const ct=ie[Be],ft=ce[Be],je=Be+1<H?ce[Be+1]:_;for(Fe=ct-L+1,Qe=ct;Qe<je;Fe++,Qe++){let st=Number.MIN_SAFE_INTEGER,X=!1;Qe<=ft&&(st=Q(de,Ce,Be,Me,ze,z,Qe,_,L,ve[se-1][Fe-1]===0,_e));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+Ie[se-1][Fe-1]);const me=Qe>ct,He=me?Ie[se][Fe-1]+(ve[se][Fe-1]>0?-5:0):0,we=Qe>ct+1&&ve[se][Fe-1]>0,ot=we?Ie[se][Fe-2]+(ve[se][Fe-2]>0?-5:0):0;if(we&&(!me||ot>=He)&&(!X||ot>=Z))Ie[se][Fe]=ot,ue[se][Fe]=3,ve[se][Fe]=0;else if(me&&(!X||He>=Z))Ie[se][Fe]=He,ue[se][Fe]=2,ve[se][Fe]=0;else if(X)Ie[se][Fe]=Z,ue[se][Fe]=1,ve[se][Fe]=ve[se-1][Fe-1]+1;else throw new Error("not possible")}}if(pe&&Se(de,Me,ze,L),!_e[0]&&!G.firstMatchCanBeWeak)return;se--,Fe--;const et=[Ie[se][Fe],L];let tt=0,it=0;for(;se>=1;){let ct=Fe;do{const ft=ue[se][ct];if(ft===3)ct=ct-2;else if(ft===2)ct=ct-1;else break}while(ct>=1);tt>1&&Ce[Me+se-1]===z[L+Fe-1]&&!U(ct+L-1,ze,z)&&tt+1>ve[se][ct]&&(ct=Fe),ct===Fe?tt++:tt=1,it||(it=ct),se--,Fe=ct-1,et.push(Fe)}_===H&&G.boostFullMatch&&(et[0]+=2);const nt=it-H;return et[0]-=nt,et}function fe(de,Ce,Me,ze,z,L){let G=de-1,H=Ce-1;for(;G>=Me&&H>=ze;)z[G]===L[H]&&(ce[G]=H,G--),H--}function Q(de,Ce,Me,ze,z,L,G,H,_,se,Fe){if(Ce[Me]!==L[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Me-ze?Be=de[Me]===z[G]?7:5:U(G,z,L)&&(G===0||!U(G-1,z,L))?(Be=de[Me]===z[G]?7:5,Qe=!0):Le(L,G)&&(G===0||!Le(L,G-1))?Be=5:(Le(L,G-1)||ne(L,G-1))&&(Be=5,Qe=!0),Be>1&&Me===ze&&(Fe[0]=!0),Qe||(Qe=U(G,z,L)||Le(L,G-1)||ne(L,G-1)),Me===ze?G>_&&(Be-=Qe?3:5):se?Be+=Qe?2:0:Be+=Qe?0:1,G+1===H&&(Be-=Qe?3:5),Be}function Y(de,Ce,Me,ze,z,L,G){return le(de,Ce,Me,ze,z,L,!0,G)}function he(de,Ce,Me,ze,z,L,G){return le(de,Ce,Me,ze,z,L,!1,G)}function le(de,Ce,Me,ze,z,L,G,H){let _=$e(de,Ce,Me,ze,z,L,H);if(_&&!G)return _;if(de.length>=3){const se=Math.min(7,de.length-1);for(let Fe=Me+1;Fe<se;Fe++){const Be=Ne(de,Fe);if(Be){const Qe=$e(Be,Be.toLowerCase(),Me,ze,z,L,H);Qe&&(Qe[0]-=3,(!_||Qe[0]>_[0])&&(_=Qe))}}}return _}function Ne(de,Ce){if(Ce+1>=de.length)return;const Me=de[Ce],ze=de[Ce+1];if(Me!==ze)return de.slice(0,Ce)+ze+Me+de.slice(Ce+2)}}),define(Re[33],Ae([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(N||(N={})),function(R){const F="error",M="warning",p="warn",g="info",D="ignore";function T(u){return u?I.$tf(F,u)?R.Error:I.$tf(M,u)||I.$tf(p,u)?R.Warning:I.$tf(g,u)?R.Info:R.Ignore:R.Ignore}R.fromValue=T;function k(u){switch(u){case R.Error:return F;case R.Warning:return M;case R.Info:return g;default:return D}}R.toString=k}(N||(N={})),e.default=N}),define(Re[130],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(Re[52],Ae([1,0,18,15]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const d=w.charCodeAt(0),s=this.b.charCodeAt(this.c);return d-s}value(){return this.b[this.c]}}e.$si=R;class F{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,N.$nf)(w,this.b,0,w.length,this.c,this.d):(0,N.$pf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=F;class M{constructor(w=!0,d=!0){this.f=w,this.g=d}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let d=w.length-1;d>=0;d--,this.c--){const s=this.b.charCodeAt(d);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,N.$nf)(w,this.b,0,w.length,this.d,this.e):(0,N.$pf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var p;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(w,d){this.f=w,this.g=d,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,N.$of)(w,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,N.$mf)(w,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=g;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(T||(T={}));class k{static forUris(w=()=>!1,d=()=>!1){return new k(new g(w,d))}static forPaths(w=!1){return new k(new M(void 0,!w))}static forStrings(){return new k(new R)}static forConfigKeys(){return new k(new F)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,d){if(d){const s=d.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o,w)}else{const s=w.slice(0);(0,I.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(w,d){const s=this.b.reset(w);let o;this.c||(this.c=new D,this.c.segment=s.value());const n=[];for(o=this.c;;){const i=s.cmp(o.segment);if(i>0)o.left||(o.left=new D,o.left.segment=s.value()),n.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new D,o.right.segment=s.value()),n.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new D,o.mid.segment=s.value()),n.push([0,o]),o=o.mid;else break}const r=o.value;o.value=d,o.key=w;for(let i=n.length-1;i>=0;i--){const a=n[i][1];a.updateHeight();const l=a.balanceFactor();if(l<-1||l>1){const t=n[i][0],b=n[i+1][0];if(t===1&&b===1)n[i][1]=a.rotateLeft();else if(t===-1&&b===-1)n[i][1]=a.rotateRight();else if(t===1&&b===-1)a.right=n[i+1][1]=n[i+1][1].rotateRight(),n[i][1]=a.rotateLeft();else if(t===-1&&b===1)a.left=n[i+1][1]=n[i+1][1].rotateLeft(),n[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(n[i-1][0]){case-1:n[i-1][1].left=n[i][1];break;case 1:n[i-1][1].right=n[i][1];break;case 0:n[i-1][1].mid=n[i][1];break}else this.c=n[0][1]}}return r}get(w){return this.d(w)?.value}d(w){const d=this.b.reset(w);let s=this.c;for(;s;){const o=d.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(d.hasNext())d.next(),s=s.mid;else break}return s}has(w){const d=this.d(w);return!(d?.value===void 0&&d?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,d){const s=this.b.reset(w),o=[];let n=this.c;for(;n;){const r=s.cmp(n.segment);if(r>0)o.push([-1,n]),n=n.left;else if(r<0)o.push([1,n]),n=n.right;else if(s.hasNext())s.next(),o.push([0,n]),n=n.mid;else break}if(n){if(d?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const r=this.f(n.right);if(r.key){const{key:i,value:a,segment:l}=r;this.e(r.key,!1),n.key=i,n.value=a,n.segment=l}}else{const r=n.left??n.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=r;break;case 0:a.mid=r;break;case 1:a.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const i=o[r][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[r][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[r][1]=i.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const d=this.b.reset(w);let s=this.c,o;for(;s;){const n=d.cmp(s.segment);if(n>0)s=s.left;else if(n<0)s=s.right;else if(d.hasNext())d.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(w){return this.g(w,!1)}g(w,d){const s=this.b.reset(w);let o=this.c;for(;o;){const n=s.cmp(o.segment);if(n>0)o=o.left;else if(n<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):d?o.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[d,s]of this)w(s,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const d=[];return this.j(w,d),d[Symbol.iterator]()}j(w,d){w&&(w.left&&this.j(w.left,d),w.value&&d.push([w.key,w.value]),w.mid&&this.j(w.mid,d),w.right&&this.j(w.right,d))}_isBalanced(){const w=d=>{if(!d)return!0;const s=d.balanceFactor();return s<-1||s>1?!1:w(d.left)&&w(d.right)};return w(this.c)}}e.$wi=k}),define(Re[41],Ae([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=R;var N;(function(M){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=p})(N||(e.ThemeColor=N={}));function R(M){return{id:M}}var F;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(r){const i=p.exec(r.id);if(!i)return g(I.$Pj.error);const[,a,l]=i,t=["codicon","codicon-"+a];return l&&t.push("codicon-modifier-"+l.substring(1)),t}M.asClassNameArray=g;function D(r){return g(r).join(" ")}M.asClassName=D;function T(r){return"."+g(r).join(".")}M.asCSSSelector=T;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||N.isThemeColor(r.color))}M.isThemeIcon=k;const u=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function w(r){const i=u.exec(r);if(!i)return;const[,a]=i;return{id:a}}M.fromString=w;function d(r){return{id:r}}M.fromId=d;function s(r,i){let a=r.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),i&&(a=`${a}~${i}`),{id:a}}M.modify=s;function o(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}M.getModifier=o;function n(r,i){return r.id===i.id&&r.color?.id===i.color?.id}M.isEqual=n})(F||(e.ThemeIcon=F={}))}),define(Re[131],Ae([1,0,129,15,41]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=g,e.$Ik=T,e.$Jk=u,e.$Kk=w,e.$Lk=s,e.$Mk=o;const F="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function g(n){return n.replace(p,(r,i)=>i?r:`\\${r}`)}const D=new RegExp(`\\\\${M.source}`,"g");function T(n){return n.replace(D,r=>`\\${r}`)}const k=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(n){return n.indexOf(F)===-1?n:n.replace(k,(r,i,a,l)=>a?r:i||l||"")}function w(n){return n?n.replace(/\$\((.*?)\)/g,(r,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(n){d.lastIndex=0;let r="";const i=[];let a=0;for(;;){const l=d.lastIndex,t=d.exec(n),b=n.substring(l,t?.index);if(b.length>0){r+=b;for(let c=0;c<b.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:r,iconOffsets:i}}function o(n,r,i=!1){const{text:a,iconOffsets:l}=r;if(!l||l.length===0)return(0,I.$yk)(n,a,i);const t=(0,N.$af)(a," "),b=a.length-t.length,c=(0,I.$yk)(n,t,i);if(c)for(const m of c){const v=l[m.start+b]+b;m.start+=v,m.end+=v}return c}}),define(Re[35],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(R){return I.test(R)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(p){for(let g=0;g<p.length;g++)p[g]=Math.floor(Math.random()*256);return p};const F=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){R(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let g=0,D="";return D+=M[F[g++]],D+=M[F[g++]],D+=M[F[g++]],D+=M[F[g++]],D+="-",D+=M[F[g++]],D+=M[F[g++]],D+="-",D+=M[F[g++]],D+=M[F[g++]],D+="-",D+=M[F[g++]],D+=M[F[g++]],D+="-",D+=M[F[g++]],D+=M[F[g++]],D+=M[F[g++]],D+=M[F[g++]],D+=M[F[g++]],D+=M[F[g++]],D}}()}),define(Re[132],Ae([1,0,18,46,35]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=F,e.$Ht=M,e.$Jt=D;function F(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}function M(k,u,w){const d={id:(0,R.$Mg)(),name:k,uri:u,data:w};return{asString:async()=>"",asFile:()=>d,value:void 0}}class p{constructor(){this.a=new Map}get size(){let u=0;for(const w of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const w=[...this.a.keys()];return N.Iterable.some(this,([d,s])=>s.asFile())&&w.push("files"),T(g(u),w)}get(u){return this.a.get(this.b(u))?.[0]}append(u,w){const d=this.a.get(u);d?d.push(w):this.a.set(this.b(u),[w])}replace(u,w){this.a.set(this.b(u),[w])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,w]of this.a)for(const d of w)yield[u,d]}b(u){return g(u)}}e.$It=p;function g(k){return k.toLowerCase()}function D(k,u){return T(g(k),u.map(g))}function T(k,u){if(k==="*/*")return u.length>0;if(u.includes(k))return!0;const w=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[d,s,o]=w;return o==="*"?u.some(n=>n.startsWith(s+"/")):!1}e.$Kt=Object.freeze({create:k=>(0,I.$Mb)(k.map(u=>u.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Kt.split(k).filter(u=>!u.startsWith("#"))})}),define(Re[133],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=N;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function N(R){let F=0,M=0,p=0,g=0;for(let D=0,T=R.length;D<T;D++){const k=R.charCodeAt(D);k===13?(F===0&&(M=D),F++,D+1<T&&R.charCodeAt(D+1)===10?(g|=2,D++):g|=3,p=D+1):k===10&&(g|=1,F===0&&(M=D),F++,p=D+1)}return F===0&&(M=R.length),[F,M,R.length-p,g]}}),define(Re[134],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[135],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let g=0,D=p.notIn.length;g<D;g++)switch(p.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,g){if(p.getTokenCount()===0)return!0;const D=p.findTokenIndexAtOffset(g-2),T=p.getStandardTokenType(D);return this.isOK(T)}g(p,g){for(let D=p;D<=g;D++){const T=String.fromCharCode(D);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=N;class R{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of p)F(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),F(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),F(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),F(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&F(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$bu=R;function F(M,p,g){M.has(p)?M.get(p).push(g):M.set(p,[g])}}),define(Re[136],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.NodeColor=e.$qC=void 0,e.$sC=R,e.$tC=F,e.$uC=D,e.$vC=T,e.$wC=k,e.$xC=u,e.$yC=w,e.$zC=d;class I{constructor(o,n){this.piece=o,this.color=n,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rC)return R(this.right);let o=this;for(;o.parent!==e.$rC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}prev(){if(this.left!==e.$rC)return F(this.left);let o=this;for(;o.parent!==e.$rC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qC=I;var N;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$rC=new I(null,0),e.$rC.parent=e.$rC,e.$rC.left=e.$rC,e.$rC.right=e.$rC,e.$rC.color=0;function R(s){for(;s.left!==e.$rC;)s=s.left;return s}function F(s){for(;s.right!==e.$rC;)s=s.right;return s}function M(s){return s===e.$rC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$rC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function g(){e.$rC.parent=e.$rC}function D(s,o){const n=o.right;n.size_left+=o.size_left+(o.piece?o.piece.length:0),n.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=n.left,n.left!==e.$rC&&(n.left.parent=o),n.parent=o.parent,o.parent===e.$rC?s.root=n:o.parent.left===o?o.parent.left=n:o.parent.right=n,n.left=o,o.parent=n}function T(s,o){const n=o.left;o.left=n.right,n.right!==e.$rC&&(n.right.parent=o),n.parent=o.parent,o.size_left-=n.size_left+(n.piece?n.piece.length:0),o.lf_left-=n.lf_left+(n.piece?n.piece.lineFeedCnt:0),o.parent===e.$rC?s.root=n:o===o.parent.right?o.parent.right=n:o.parent.left=n,n.right=o,o.parent=n}function k(s,o){let n,r;if(o.left===e.$rC?(r=o,n=r.right):o.right===e.$rC?(r=o,n=r.left):(r=R(o.right),n=r.right),r===s.root){s.root=n,n.color=0,o.detach(),g(),s.root.parent=e.$rC;return}const i=r.color===1;if(r===r.parent.left?r.parent.left=n:r.parent.right=n,r===o?(n.parent=r.parent,d(s,n)):(r.parent===o?n.parent=r:n.parent=r.parent,d(s,n),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===s.root?s.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$rC&&(r.left.parent=r),r.right!==e.$rC&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,d(s,r)),o.detach(),n.parent.left===n){const l=M(n),t=p(n);if(l!==n.parent.size_left||t!==n.parent.lf_left){const b=l-n.parent.size_left,c=t-n.parent.lf_left;n.parent.size_left=l,n.parent.lf_left=t,w(s,n.parent,b,c)}}if(d(s,n.parent),i){g();return}let a;for(;n!==s.root&&n.color===0;)n===n.parent.left?(a=n.parent.right,a.color===1&&(a.color=0,n.parent.color=1,D(s,n.parent),a=n.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,n=n.parent):(a.right.color===0&&(a.left.color=0,a.color=1,T(s,a),a=n.parent.right),a.color=n.parent.color,n.parent.color=0,a.right.color=0,D(s,n.parent),n=s.root)):(a=n.parent.left,a.color===1&&(a.color=0,n.parent.color=1,T(s,n.parent),a=n.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,n=n.parent):(a.left.color===0&&(a.right.color=0,a.color=1,D(s,a),a=n.parent.left),a.color=n.parent.color,n.parent.color=0,a.left.color=0,T(s,n.parent),n=s.root));n.color=0,g()}function u(s,o){for(d(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const n=o.parent.parent.right;n.color===1?(o.parent.color=0,n.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,D(s,o)),o.parent.color=0,o.parent.parent.color=1,T(s,o.parent.parent))}else{const n=o.parent.parent.left;n.color===1?(o.parent.color=0,n.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(s,o)),o.parent.color=0,o.parent.parent.color=1,D(s,o.parent.parent))}s.root.color=0}function w(s,o,n,r){for(;o!==s.root&&o!==e.$rC;)o.parent.left===o&&(o.parent.size_left+=n,o.parent.lf_left+=r),o=o.parent}function d(s,o){let n=0,r=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,n=M(o.left)-o.size_left,r=p(o.left)-o.lf_left,o.size_left+=n,o.lf_left+=r;o!==s.root&&(n!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=n,o.parent.lf_left+=r),o=o.parent}}}),define(Re[92],Ae([1,0,93,29,94,136,95]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=void 0,e.$GC=T,e.$HC=k;const p=65535;function g(n){let r;return n[n.length-1]<65536?r=new Uint16Array(n.length):r=new Uint32Array(n.length),r.set(n,0),r}class D{constructor(r,i,a,l,t){this.lineStarts=r,this.cr=i,this.lf=a,this.crlf=l,this.isBasicASCII=t}}function T(n,r=!0){const i=[0];let a=1;for(let l=0,t=n.length;l<t;l++){const b=n.charCodeAt(l);b===13?l+1<t&&n.charCodeAt(l+1)===10?(i[a++]=l+2,l++):i[a++]=l+1:b===10&&(i[a++]=l+1)}return r?g(i):i}function k(n,r){n.length=0,n[0]=0;let i=1,a=0,l=0,t=0,b=!0;for(let m=0,v=r.length;m<v;m++){const $=r.charCodeAt(m);$===13?m+1<v&&r.charCodeAt(m+1)===10?(t++,n[i++]=m+2,m++):(a++,n[i++]=m+1):$===10?(l++,n[i++]=m+1):b&&$!==9&&($<32||$>126)&&(b=!1)}const c=new D(g(n),a,l,t,b);return n.length=0,c}class u{constructor(r,i,a,l,t){this.bufferIndex=r,this.start=i,this.end=a,this.lineFeedCnt=l,this.length=t}}e.$IC=u;class w{constructor(r,i){this.buffer=r,this.lineStarts=i}}e.$JC=w;class d{constructor(r,i){this.a=[],this.c=r,this.d=i,this.b=0,r.root!==F.$rC&&r.iterate(r.root,a=>(a!==F.$rC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(r){this.a=r,this.b=[]}get(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=r&&a.nodeStartOffset+a.node.piece.length>=r)return a}return null}get2(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<r&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=r)return a}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let i=!1;const a=this.b;for(let l=0;l<a.length;l++){const t=a[l];if(t.node.parent===null||t.nodeStartOffset>=r){a[l]=null,i=!0;continue}}if(i){const l=[];for(const t of a)t!==null&&l.push(t);this.b=l}}}class o{constructor(r,i,a){this.create(r,i,a)}create(r,i,a){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=F.$rC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let l=null;for(let t=0,b=r.length;t<b;t++)if(r[t].buffer.length>0){r[t].lineStarts||(r[t].lineStarts=T(r[t].buffer));const c=new u(t+1,{line:0,column:0},{line:r[t].lineStarts.length-1,column:r[t].buffer.length-r[t].lineStarts[r[t].lineStarts.length-1]},r[t].lineStarts.length-1,r[t].buffer.length);this.a.push(r[t]),l=this.S(l,c)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const i=p,a=i-Math.floor(i/3),l=a*2;let t="",b=0;const c=[];if(this.iterate(this.root,m=>{const v=this.R(m),$=v.length;if(b<=a||b+$<l)return t+=v,b+=$,!0;const h=t.replace(/\r\n|\r|\n/g,r);return c.push(new w(h,T(h))),t=v,b=$,!0}),b>0){const m=t.replace(/\r\n|\r|\n/g,r);c.push(new w(m,T(m)))}this.create(c,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new d(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let i=0;return this.iterate(this.root,l=>{if(l===F.$rC)return!0;const t=this.R(l),b=t.length,c=r.G(i),m=r.G(i+b),v=r.getValueInRange2(c,m);return i+=b,t===v})}getOffsetAt(r,i){let a=0,l=this.root;for(;l!==F.$rC;)if(l.left!==F.$rC&&l.lf_left+1>=r)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=r){a+=l.size_left;const t=this.B(l,r-l.lf_left-2);return a+=t+i-1}else r-=l.lf_left+l.piece.lineFeedCnt,a+=l.size_left+l.piece.length,l=l.right;return a}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let i=this.root,a=0;const l=r;for(;i!==F.$rC;)if(i.size_left!==0&&i.size_left>=r)i=i.left;else if(i.size_left+i.piece.length>=r){const t=this.A(i,r-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const b=this.getOffsetAt(a+1,1),c=l-b;return new I.$jt(a+1,c+1)}return new I.$jt(a+1,t.remainder+1)}else if(r-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===F.$rC){const t=this.getOffsetAt(a+1,1),b=l-r-t;return new I.$jt(a+1,b+1)}else i=i.right;return new I.$jt(1,1)}getValueInRange(r,i){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const a=this.H(r.startLineNumber,r.startColumn),l=this.H(r.endLineNumber,r.endColumn),t=this.getValueInRange2(a,l);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(r,i){if(r.node===i.node){const c=r.node,m=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return m.substring(v+r.remainder,v+i.remainder)}let a=r.node;const l=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let b=l.substring(t+r.remainder,t+a.piece.length);for(a=a.next();a!==F.$rC;){const c=this.a[a.piece.bufferIndex].buffer,m=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){b+=c.substring(m,m+i.remainder);break}else b+=c.substr(m,a.piece.length);a=a.next()}return b}getLinesContent(){const r=[];let i=0,a="",l=!1;return this.iterate(this.root,t=>{if(t===F.$rC)return!0;const b=t.piece;let c=b.length;if(c===0)return!0;const m=this.a[b.bufferIndex].buffer,v=this.a[b.bufferIndex].lineStarts,$=b.start.line,h=b.end.line;let E=v[$]+b.start.column;if(l&&(m.charCodeAt(E)===10&&(E++,c--),r[i++]=a,a="",l=!1,c===0))return!0;if($===h)return!this.f&&m.charCodeAt(E+c-1)===13?(l=!0,a+=m.substr(E,c-1)):a+=m.substr(E,c),!0;a+=this.f?m.substring(E,Math.max(E,v[$+1]-this.e)):m.substring(E,v[$+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;for(let f=$+1;f<h;f++)a=this.f?m.substring(v[f],v[f+1]-this.e):m.substring(v[f],v[f+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;return!this.f&&m.charCodeAt(v[h]+b.end.column-1)===13?(l=!0,b.end.column===0?i--:a=m.substr(v[h],b.end.column-1)):a=m.substr(v[h],b.end.column),!0}),l&&(r[i++]=a,a=""),r[i++]=a,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const i=r.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],l=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(l)}else{const i=this.a[r.node.piece.bufferIndex],l=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return i.buffer.charCodeAt(l)}}getLineCharCode(r,i){const a=this.H(r,i+1);return this.l(a)}getLineLength(r){if(r===this.getLineCount()){const i=this.getOffsetAt(r,1);return this.getLength()-i}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const i=this.G(r);return this.l(i)}findMatchesInNode(r,i,a,l,t,b,c,m,v,$,h){const E=this.a[r.piece.bufferIndex],f=this.u(r.piece.bufferIndex,r.piece.start),S=this.u(r.piece.bufferIndex,t),y=this.u(r.piece.bufferIndex,b);let C;const P={line:0,column:0};let V,W;i._wordSeparators?(V=E.buffer.substring(S,y),W=q=>q+S,i.reset(0)):(V=E.buffer,W=q=>q,i.reset(S));do if(C=i.next(V),C){if(W(C.index)>=y)return $;this.s(r,W(C.index)-f,P);const q=this.t(r.piece.bufferIndex,t,P),A=P.line===t.line?P.column-t.column+l:P.column+1,j=A+C[0].length;if(h[$++]=(0,M.$CC)(new N.$kt(a+q,A,a+q,j),C,m),W(C.index)+C[0].length>=y||$>=v)return $}while(C);return $}findMatchesLineByLine(r,i,a,l){const t=[];let b=0;const c=new M.$FC(i.wordSeparators,i.regex);let m=this.H(r.startLineNumber,r.startColumn);if(m===null)return[];const v=this.H(r.endLineNumber,r.endColumn);if(v===null)return[];let $=this.s(m.node,m.remainder);const h=this.s(v.node,v.remainder);if(m.node===v.node)return this.findMatchesInNode(m.node,c,r.startLineNumber,r.startColumn,$,h,i,a,l,b,t),t;let E=r.startLineNumber,f=m.node;for(;f!==v.node;){const y=this.t(f.piece.bufferIndex,$,f.piece.end);if(y>=1){const P=this.a[f.piece.bufferIndex].lineStarts,V=this.u(f.piece.bufferIndex,f.piece.start),W=P[$.line+y],q=E===r.startLineNumber?r.startColumn:1;if(b=this.findMatchesInNode(f,c,E,q,$,this.s(f,W-V),i,a,l,b,t),b>=l)return t;E+=y}const C=E===r.startLineNumber?r.startColumn-1:0;if(E===r.endLineNumber){const P=this.getLineContent(E).substring(C,r.endColumn-1);return b=this.n(i,c,P,r.endLineNumber,C,b,t,a,l),t}if(b=this.n(i,c,this.getLineContent(E).substr(C),E,C,b,t,a,l),b>=l)return t;E++,m=this.H(E,1),f=m.node,$=this.s(m.node,m.remainder)}if(E===r.endLineNumber){const y=E===r.startLineNumber?r.startColumn-1:0,C=this.getLineContent(E).substring(y,r.endColumn-1);return b=this.n(i,c,C,r.endLineNumber,y,b,t,a,l),t}const S=E===r.startLineNumber?r.startColumn:1;return b=this.findMatchesInNode(v.node,c,E,S,$,h,i,a,l,b,t),t}n(r,i,a,l,t,b,c,m,v){const $=r.wordSeparators;if(!m&&r.simpleSearch){const E=r.simpleSearch,f=E.length,S=a.length;let y=-f;for(;(y=a.indexOf(E,y+f))!==-1;)if((!$||(0,M.$EC)($,a,S,y,f))&&(c[b++]=new R.$vv(new N.$kt(l,y+1+t,l,y+1+f+t),null),b>=v))return b;return b}let h;i.reset(0);do if(h=i.next(a),h&&(c[b++]=(0,M.$CC)(new N.$kt(l,h.index+1+t,l,h.index+1+h[0].length+t),h,m),b>=v))return b;while(h);return b}insert(r,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==F.$rC){const{node:l,remainder:t,nodeStartOffset:b}=this.G(r),c=l.piece,m=c.bufferIndex,v=this.s(l,t);if(l.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&b+c.length===r&&i.length<p){this.F(l,i),this.y();return}if(b===r)this.o(i,l),this.h.validate(r);else if(b+l.piece.length>r){const $=[];let h=new u(c.bufferIndex,v,c.end,this.t(c.bufferIndex,v,c.end),this.u(m,c.end)-this.u(m,v));if(this.K()&&this.M(i)&&this.I(l,t)===10){const y={line:h.start.line+1,column:0};h=new u(h.bufferIndex,y,h.end,this.t(h.bufferIndex,y,h.end),h.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(l,t-1)===13){const y=this.s(l,t-1);this.C(l,y),i="\r"+i,l.piece.length===0&&$.push(l)}else this.C(l,v);else this.C(l,v);const E=this.w(i);h.length>0&&this.S(l,h);let f=l;for(let S=0;S<E.length;S++)f=this.S(f,E[S]);this.v($)}else this.q(i,l)}else{const l=this.w(i);let t=this.T(null,l[0]);for(let b=1;b<l.length;b++)t=this.S(t,l[b])}this.y()}delete(r,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===F.$rC)return;const a=this.G(r),l=this.G(r+i),t=a.node,b=l.node;if(t===b){const E=this.s(t,a.remainder),f=this.s(t,l.remainder);if(a.nodeStartOffset===r){if(i===t.piece.length){const S=t.next();(0,F.$wC)(this,t),this.N(S),this.y();return}this.D(t,f),this.h.validate(r),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===r+i){this.C(t,E),this.O(t),this.y();return}this.E(t,E,f),this.y();return}const c=[],m=this.s(t,a.remainder);this.C(t,m),this.h.validate(r),t.piece.length===0&&c.push(t);const v=this.s(b,l.remainder);this.D(b,v),b.piece.length===0&&c.push(b);const $=t.next();for(let E=$;E!==F.$rC&&E!==b;E=E.next())c.push(E);const h=t.piece.length===0?t.prev():t;this.v(c),this.O(h),this.y()}o(r,i){const a=[];if(this.K()&&this.M(r)&&this.L(i)){const b=i.piece,c={line:b.start.line+1,column:0},m=new u(b.bufferIndex,c,b.end,this.t(b.bufferIndex,c,b.end),b.length-1);i.piece=m,r+=`
`,(0,F.$yC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const l=this.w(r);let t=this.T(i,l[l.length-1]);for(let b=l.length-2;b>=0;b--)t=this.T(t,l[b]);this.N(t),this.v(a)}q(r,i){this.Q(r,i)&&(r+=`
`);const a=this.w(r),l=this.S(i,a[0]);let t=l;for(let b=1;b<a.length;b++)t=this.S(t,a[b]);this.N(l)}s(r,i,a){const l=r.piece,t=r.piece.bufferIndex,b=this.a[t].lineStarts,m=b[l.start.line]+l.start.column+i;let v=l.start.line,$=l.end.line,h=0,E=0,f=0;for(;v<=$&&(h=v+($-v)/2|0,f=b[h],h!==$);)if(E=b[h+1],m<f)$=h-1;else if(m>=E)v=h+1;else break;return a?(a.line=h,a.column=m-f,null):{line:h,column:m-f}}t(r,i,a){if(a.column===0)return a.line-i.line;const l=this.a[r].lineStarts;if(a.line===l.length-1)return a.line-i.line;const t=l[a.line+1],b=l[a.line]+a.column;if(t>b+1)return a.line-i.line;const c=b-1;return this.a[r].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(r,i){return this.a[r].lineStarts[i.line]+i.column}v(r){for(let i=0;i<r.length;i++)(0,F.$wC)(this,r[i])}w(r){if(r.length>p){const $=[];for(;r.length>p;){const E=r.charCodeAt(p-1);let f;E===13||E>=55296&&E<=56319?(f=r.substring(0,p-1),r=r.substring(p-1)):(f=r.substring(0,p),r=r.substring(p));const S=T(f);$.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:f.length-S[S.length-1]},S.length-1,f.length)),this.a.push(new w(f,S))}const h=T(r);return $.push(new u(this.a.length,{line:0,column:0},{line:h.length-1,column:r.length-h[h.length-1]},h.length-1,r.length)),this.a.push(new w(r,h)),$}let i=this.a[0].buffer.length;const a=T(r,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let $=0;$<a.length;$++)a[$]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+r,i+=1}else{if(i!==0)for(let $=0;$<a.length;$++)a[$]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=r}const t=this.a[0].buffer.length,b=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[b],m={line:b,column:c},v=new u(0,l,m,this.t(0,l,m),t-i);return this.g=m,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,i=0){let a=this.root,l="";const t=this.h.get2(r);if(t){a=t.node;const b=this.B(a,r-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,m=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===r)l=c.substring(m+b,m+a.piece.length);else{const v=this.B(a,r-t.nodeStartLineNumber);return c.substring(m+b,m+v-i)}}else{let b=0;const c=r;for(;a!==F.$rC;)if(a.left!==F.$rC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const m=this.B(a,r-a.lf_left-2),v=this.B(a,r-a.lf_left-1),$=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);return b+=a.size_left,this.h.set({node:a,nodeStartOffset:b,nodeStartLineNumber:c-(r-1-a.lf_left)}),$.substring(h+m,h+v-i)}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const m=this.B(a,r-a.lf_left-2),v=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);l=v.substring($+m,$+a.piece.length);break}else r-=a.lf_left+a.piece.lineFeedCnt,b+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==F.$rC;){const b=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),m=this.u(a.piece.bufferIndex,a.piece.start);return l+=b.substring(m,m+c-i),l}else{const c=this.u(a.piece.bufferIndex,a.piece.start);l+=b.substr(c,a.piece.length)}a=a.next()}return l}y(){let r=this.root,i=1,a=0;for(;r!==F.$rC;)i+=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;this.b=i,this.c=a,this.h.validate(this.c)}A(r,i){const a=r.piece,l=this.s(r,i),t=l.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const b=this.t(r.piece.bufferIndex,a.start,l);if(b!==t)return{index:b,remainder:0}}return{index:t,remainder:l.column}}B(r,i){if(i<0)return 0;const a=r.piece,l=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?l[a.end.line]+a.end.column-l[a.start.line]-a.start.column:l[t]-l[a.start.line]-a.start.column}C(r,i){const a=r.piece,l=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),b=i,c=this.u(a.bufferIndex,b),m=this.t(a.bufferIndex,a.start,b),v=m-l,$=c-t,h=a.length+$;r.piece=new u(a.bufferIndex,a.start,b,m,h),(0,F.$yC)(this,r,$,v)}D(r,i){const a=r.piece,l=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),b=i,c=this.t(a.bufferIndex,b,a.end),m=this.u(a.bufferIndex,b),v=c-l,$=t-m,h=a.length+$;r.piece=new u(a.bufferIndex,b,a.end,c,h),(0,F.$yC)(this,r,$,v)}E(r,i,a){const l=r.piece,t=l.start,b=l.end,c=l.length,m=l.lineFeedCnt,v=i,$=this.t(l.bufferIndex,l.start,v),h=this.u(l.bufferIndex,i)-this.u(l.bufferIndex,t);r.piece=new u(l.bufferIndex,l.start,v,$,h),(0,F.$yC)(this,r,h-c,$-m);const E=new u(l.bufferIndex,a,b,this.t(l.bufferIndex,a,b),this.u(l.bufferIndex,b)-this.u(l.bufferIndex,a)),f=this.S(r,E);this.N(f)}F(r,i){this.Q(i,r)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(r),l=this.a[0].buffer.length;this.a[0].buffer+=i;const t=T(i,!1);for(let f=0;f<t.length;f++)t[f]+=l;if(a){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const b=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[b],m={line:b,column:c},v=r.piece.length+i.length,$=r.piece.lineFeedCnt,h=this.t(0,r.piece.start,m),E=h-$;r.piece=new u(r.piece.bufferIndex,r.piece.start,m,h,v),this.g=m,(0,F.$yC)(this,r,i.length,E)}G(r){let i=this.root;const a=this.h.get(r);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:r-a.nodeStartOffset};let l=0;for(;i!==F.$rC;)if(i.size_left>r)i=i.left;else if(i.size_left+i.piece.length>=r){l+=i.size_left;const t={node:i,remainder:r-i.size_left,nodeStartOffset:l};return this.h.set(t),t}else r-=i.size_left+i.piece.length,l+=i.size_left+i.piece.length,i=i.right;return null}H(r,i){let a=this.root,l=0;for(;a!==F.$rC;)if(a.left!==F.$rC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const t=this.B(a,r-a.lf_left-2),b=this.B(a,r-a.lf_left-1);return l+=a.size_left,{node:a,remainder:Math.min(t+i-1,b),nodeStartOffset:l}}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const t=this.B(a,r-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:l};i-=a.piece.length-t;break}else r-=a.lf_left+a.piece.lineFeedCnt,l+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==F.$rC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),b=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:b}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(r,i){if(r.piece.lineFeedCnt<1)return-1;const a=this.a[r.piece.bufferIndex],l=this.u(r.piece.bufferIndex,r.piece.start)+i;return a.buffer.charCodeAt(l)}J(r){if(!r)return 0;let i=r.size_left;for(;r!==this.root;)r.parent.right===r&&(i+=r.parent.size_left+r.parent.piece.length),r=r.parent;return i}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===F.$rC||r.piece.lineFeedCnt===0)return!1;const i=r.piece,a=this.a[i.bufferIndex].lineStarts,l=i.start.line,t=a[l]+i.start.column;return l===a.length-1||a[l+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===F.$rC||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const i=r.prev();this.M(i)&&this.P(i,r)}}O(r){if(this.K()&&this.M(r)){const i=r.next();this.L(i)&&this.P(r,i)}}P(r,i){const a=[],l=this.a[r.piece.bufferIndex].lineStarts;let t;r.piece.end.column===0?t={line:r.piece.end.line-1,column:l[r.piece.end.line]-l[r.piece.end.line-1]-1}:t={line:r.piece.end.line,column:r.piece.end.column-1};const b=r.piece.length-1,c=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,t,c,b),(0,F.$yC)(this,r,-1,-1),r.piece.length===0&&a.push(r);const m={line:i.piece.start.line+1,column:0},v=i.piece.length-1,$=this.t(i.piece.bufferIndex,m,i.piece.end);i.piece=new u(i.piece.bufferIndex,m,i.piece.end,$,v),(0,F.$yC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const h=this.w(`\r
`);this.S(r,h[0]);for(let E=0;E<a.length;E++)(0,F.$wC)(this,a[E])}Q(r,i){if(this.K()&&this.M(r)){const a=i.next();if(this.L(a)){if(r+=`
`,a.piece.length===1)(0,F.$wC)(this,a);else{const l=a.piece,t={line:l.start.line+1,column:0},b=l.length-1,c=this.t(l.bufferIndex,t,l.end);a.piece=new u(l.bufferIndex,t,l.end,c,b),(0,F.$yC)(this,a,-1,-1)}return!0}}return!1}iterate(r,i){if(r===F.$rC)return i(F.$rC);const a=this.iterate(r.left,i);return a&&i(r)&&this.iterate(r.right,i)}R(r){if(r===F.$rC)return"";const i=this.a[r.piece.bufferIndex],a=r.piece,l=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(l,t)}getPieceContent(r){const i=this.a[r.bufferIndex],a=this.u(r.bufferIndex,r.start),l=this.u(r.bufferIndex,r.end);return i.buffer.substring(a,l)}S(r,i){const a=new F.$qC(i,1);if(a.left=F.$rC,a.right=F.$rC,a.parent=F.$rC,a.size_left=0,a.lf_left=0,this.root===F.$rC)this.root=a,a.color=0;else if(r.right===F.$rC)r.right=a,a.parent=r;else{const t=(0,F.$sC)(r.right);t.left=a,a.parent=t}return(0,F.$xC)(this,a),a}T(r,i){const a=new F.$qC(i,1);if(a.left=F.$rC,a.right=F.$rC,a.parent=F.$rC,a.size_left=0,a.lf_left=0,this.root===F.$rC)this.root=a,a.color=0;else if(r.left===F.$rC)r.left=a,a.parent=r;else{const l=(0,F.$tC)(r.left);l.right=a,a.parent=l}return(0,F.$xC)(this,a),a}U(r){let i="";return this.iterate(r,a=>(i+=this.R(a),!0)),i}}e.$KC=o}),define(Re[137],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0=e.$M0=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const M=this.a.get(F);return this.a.delete(F),M}}addDragOperationTransfer(F,M){this.a.set(F,M)}}e.$M0=I;class N{constructor(F){this.identifier=F}}e.$N0=N}),define(Re[138],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Re[139],Ae([1,0,5,6,138]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=T;class F extends N.$Uc{constructor(u,w="",d="",s=!0,o){super(),this.h=this.B(new I.$be),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=w,this.u=d,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,w){this.C&&await this.C(u)}}e.$8i=F;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$be),this.onWillRun=this.f.event,this.m=this.B(new I.$be),this.onDidRun=this.m.event}async run(u,w){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,w)}catch(s){d=s}this.m.fire({action:u,error:d})}async u(u,w){await u.run(w)}}e.$9i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let w=[];for(const d of u)d.length&&(w.length?w=[...w,new p,...d]:w=d);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=p;class g{get actions(){return this.a}constructor(u,w,d,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=w,this.class=s,this.a=d}async run(){}}e.$$i=g;class D extends F{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,R.localize(0,null),void 0,!1)}}e.$_i=D;function T(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...u)=>k.run(...u),tooltip:k.label}}}),define(Re[140],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Re[141],Ae([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=D,e.$Wm=T,e.$Xm=k;const N=60,R=N*60,F=R*24,M=F*7,p=F*30,g=F*365;function D(u,w,d,s){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,D(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,I.localize)(1,null);let n;return o<N?(n=o,w?n===1?d?(0,I.localize)(2,null,n):(0,I.localize)(3,null,n):d?(0,I.localize)(4,null,n):(0,I.localize)(5,null,n):n===1?d?(0,I.localize)(6,null,n):(0,I.localize)(7,null,n):d?(0,I.localize)(8,null,n):(0,I.localize)(9,null,n)):o<R?(n=Math.floor(o/N),w?n===1?d?(0,I.localize)(10,null,n):(0,I.localize)(11,null,n):d?(0,I.localize)(12,null,n):(0,I.localize)(13,null,n):n===1?d?(0,I.localize)(14,null,n):(0,I.localize)(15,null,n):d?(0,I.localize)(16,null,n):(0,I.localize)(17,null,n)):o<F?(n=Math.floor(o/R),w?n===1?d?(0,I.localize)(18,null,n):(0,I.localize)(19,null,n):d?(0,I.localize)(20,null,n):(0,I.localize)(21,null,n):n===1?d?(0,I.localize)(22,null,n):(0,I.localize)(23,null,n):d?(0,I.localize)(24,null,n):(0,I.localize)(25,null,n)):o<M?(n=Math.floor(o/F),w?n===1?(0,I.localize)(26,null,n):(0,I.localize)(27,null,n):n===1?(0,I.localize)(28,null,n):(0,I.localize)(29,null,n)):o<p?(n=Math.floor(o/M),w?n===1?d?(0,I.localize)(30,null,n):(0,I.localize)(31,null,n):d?(0,I.localize)(32,null,n):(0,I.localize)(33,null,n):n===1?d?(0,I.localize)(34,null,n):(0,I.localize)(35,null,n):d?(0,I.localize)(36,null,n):(0,I.localize)(37,null,n)):o<g?(n=Math.floor(o/p),w?n===1?d?(0,I.localize)(38,null,n):(0,I.localize)(39,null,n):d?(0,I.localize)(40,null,n):(0,I.localize)(41,null,n):n===1?d?(0,I.localize)(42,null,n):(0,I.localize)(43,null,n):d?(0,I.localize)(44,null,n):(0,I.localize)(45,null,n)):(n=Math.floor(o/g),w?n===1?d?(0,I.localize)(46,null,n):(0,I.localize)(47,null,n):d?(0,I.localize)(48,null,n):(0,I.localize)(49,null,n):n===1?d?(0,I.localize)(50,null,n):(0,I.localize)(51,null,n):d?(0,I.localize)(52,null,n):(0,I.localize)(53,null,n))}function T(u,w){const d=Math.abs(u/1e3);return d<1?w?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):d<N?w?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):d<R?w?(0,I.localize)(58,null,Math.round(u/(1e3*N))):(0,I.localize)(59,null,Math.round(u/(1e3*N))):d<F?w?(0,I.localize)(60,null,Math.round(u/(1e3*R))):(0,I.localize)(61,null,Math.round(u/(1e3*R))):(0,I.localize)(62,null,Math.round(u/(1e3*F)))}function k(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[142],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Re[42],Ae([1,0,18,17,142]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=g,e.$cj=D,e.$dj=T;function F(k,u){return u&&(k.stack||k.stacktrace)?R.localize(0,null,p(k),M(k.stack)||M(k.stacktrace)):p(k)}function M(k){return Array.isArray(k)?k.join(`
`):k}function p(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function g(k=null,u=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const w=I.$Hb(k),d=g(w[0],u);return w.length>1?R.localize(4,null,d,w.length):d}if(N.$4f(k))return k;if(k.detail){const w=k.detail;if(w.error)return F(w.error,u);if(w.exception)return F(w.exception,u)}return k.stack?F(k,u):k.message?k.message:R.localize(5,null)}function D(k){const u=k;return u instanceof Error&&Array.isArray(u.actions)}function T(k,u){let w;return typeof k=="string"?w=new Error(k):w=k,w.actions=u,w}}),define(Re[143],Ae([1,0,40,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=p,e.$_q=g,e.$ar=D,e.$br=T,e.$cr=k,e.$dr=u,e.$er=w,e.$fr=d,e.$gr=s,e.$hr=o,e.$ir=v,e.$jr=$,e.$kr=h;const R=new I.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),F=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(E,f,S=!1){const y=E||"",C=f||"",P=R.value.collator.compare(y,C);return R.value.collatorIsNumeric&&P===0&&y!==C?y<C?-1:1:P}function g(E,f){const S=F.value.collator;return E=E||"",f=f||"",a(S,E,f)}function D(E,f){const S=F.value.collator;return E=E||"",f=f||"",c(E,f)||a(S,E,f)}function T(E,f){const S=F.value.collator;return E=E||"",f=f||"",b(E,f)||a(S,E,f)}function k(E,f){return E=E||"",f=f||"",E===f?0:E<f?-1:1}function u(E,f){const[S,y]=r(E),[C,P]=r(f);let V=R.value.collator.compare(y,P);if(V===0){if(R.value.collatorIsNumeric&&y!==P)return y<P?-1:1;if(V=R.value.collator.compare(S,C),R.value.collatorIsNumeric&&V===0&&S!==C)return S<C?-1:1}return V}function w(E,f){E=E||"",f=f||"";const S=i(E),y=i(f),C=F.value.collator,P=M.value.collator;return a(P,S,y)||a(C,E,f)}function d(E,f){E=E||"",f=f||"";const S=i(E),y=i(f),C=F.value.collator,P=M.value.collator;return a(P,S,y)||c(E,f)||a(C,E,f)}function s(E,f){E=E||"",f=f||"";const S=i(E),y=i(f),C=F.value.collator,P=M.value.collator;return a(P,S,y)||b(E,f)||a(C,E,f)}function o(E,f){E=E||"",f=f||"";const S=i(E).toLowerCase(),y=i(f).toLowerCase();return S!==y?S<y?-1:1:E!==f?E<f?-1:1:0}const n=/^(.*?)(\.([^.]*))?$/;function r(E,f=!1){const S=E?n.exec(E):[];let y=[S&&S[1]||"",S&&S[3]||""];return f&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(E){const f=E?n.exec(E):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function a(E,f,S){const y=E.compare(f,S);return y!==0?y:f.length!==S.length?f.length<S.length?-1:1:0}function l(E){const f=E.charAt(0);return f.toLocaleUpperCase()!==f}function t(E){const f=E.charAt(0);return f.toLocaleLowerCase()!==f}function b(E,f){return l(E)&&t(f)?-1:t(E)&&l(f)?1:0}function c(E,f){return t(E)&&l(f)?-1:l(E)&&t(f)?1:0}function m(E,f,S=!1){return S||(E=E&&E.toLowerCase(),f=f&&f.toLowerCase()),E===f?0:E<f?-1:1}function v(E,f,S=!1){const y=E.split(N.sep),C=f.split(N.sep),P=y.length-1,V=C.length-1;let W,q;for(let A=0;;A++){if(W=P===A,q=V===A,W&&q)return p(y[A],C[A],S);if(W)return-1;if(q)return 1;const j=m(y[A],C[A],S);if(j!==0)return j}}function $(E,f,S){const y=E.toLowerCase(),C=f.toLowerCase(),P=h(E,f,S);if(P)return P;const V=y.endsWith(S),W=C.endsWith(S);if(V!==W)return V?-1:1;const q=p(y,C);return q!==0?q:y.localeCompare(C)}function h(E,f,S){const y=E.toLowerCase(),C=f.toLowerCase(),P=y.startsWith(S),V=C.startsWith(S);if(P!==V)return P?-1:1;if(P&&V){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Re[47],Ae([1,0,19,21,15,17]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=p,e.$lg=g,e.$mg=D,e.$ng=T,e.$og=d,e.$pg=s,e.$qg=o,e.$rg=n,e.$sg=r,e.$tg=i,e.$ug=a,e.$vg=l,e.$wg=t,e.$xg=b,e.$yg=v;function M($){return $===47||$===92}function p($){return $.replace(/[\\/]/g,I.$hc.sep)}function g($){return $.indexOf("/")===-1&&($=p($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}function D($,h=I.$hc.sep){if(!$)return"";const E=$.length,f=$.charCodeAt(0);if(M(f)){if(M($.charCodeAt(1))&&!M($.charCodeAt(2))){let y=3;const C=y;for(;y<E&&!M($.charCodeAt(y));y++);if(C!==y&&!M($.charCodeAt(y+1))){for(y+=1;y<E;y++)if(M($.charCodeAt(y)))return $.slice(0,y+1).replace(/[\\/]/g,h)}}return h}else if(n(f)&&$.charCodeAt(1)===58)return M($.charCodeAt(2))?$.slice(0,2)+h:$.slice(0,2);let S=$.indexOf("://");if(S!==-1){for(S+=3;S<E;S++)if(M($.charCodeAt(S)))return $.slice(0,S+1)}return""}function T($){if(!N.$i||!$||$.length<5)return!1;let h=$.charCodeAt(0);if(h!==92||(h=$.charCodeAt(1),h!==92))return!1;let E=2;const f=E;for(;E<$.length&&(h=$.charCodeAt(E),h!==92);E++);return!(f===E||(h=$.charCodeAt(E+1),isNaN(h)||h===92))}const k=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d($,h=N.$i){const E=h?k:u;return!(!$||$.length===0||/^\s+$/.test($)||(E.lastIndex=0,E.test($))||h&&w.test($)||$==="."||$===".."||h&&$[$.length-1]==="."||h&&$.length!==$.trim().length||$.length>255)}function s($,h,E){const f=$===h;return!E||f?f:!$||!h?!1:(0,R.$tf)($,h)}function o($,h,E,f=I.sep){if($===h)return!0;if(!$||!h||h.length>$.length)return!1;if(E){if(!(0,R.$uf)($,h))return!1;if(h.length===$.length)return!0;let y=h.length;return h.charAt(h.length-1)===f&&y--,$.charAt(y)===f}return h.charAt(h.length-1)!==f&&(h+=f),$.indexOf(h)===0}function n($){return $>=65&&$<=90||$>=97&&$<=122}function r($,h){return N.$i&&$.endsWith(":")&&($+=I.sep),(0,I.$jc)($)||($=(0,I.$kc)(h,$)),$=(0,I.$ic)($),N.$i?($=(0,R.$bf)($,I.sep),$.endsWith(":")&&($+=I.sep)):($=(0,R.$bf)($,I.sep),$||($=I.sep)),$}function i($){const h=(0,I.$ic)($);return N.$i?$.length>3?!1:a(h)&&($.length===2||h.charCodeAt(2)===92):h===I.$hc.sep}function a($,h=N.$i){return h?n($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}function l($,h=N.$i){return a($,h)?$[0]:void 0}function t($,h,E){return h.length>$.length?-1:$===h?0:(E&&($=$.toLowerCase(),h=h.toLowerCase()),$.indexOf(h))}function b($){const h=$.split(":");let E,f,S;for(const y of h){const C=Number(y);(0,F.$8f)(C)?f===void 0?f=C:S===void 0&&(S=C):E=E?[E,y].join(":"):y}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:f!==void 0?f:void 0,column:S!==void 0?S:f!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",m="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v($,h,E=8){let f="";for(let y=0;y<E;y++){let C;y===0&&N.$i&&!h&&(E===3||E===4)?C=m:C=c,f+=C.charAt(Math.floor(Math.random()*C.length))}let S;return h?S=`${h}-${f}`:S=f,$?(0,I.$kc)($,S):S}}),define(Re[69],Ae([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=F,e.$Js=M,e.$Ks=p,e.$Ls=D,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(T){const k=(0,I.$pc)(T),u=N[k.toLowerCase()];return u!==void 0?u:M(T)}function M(T){const k=(0,I.$pc)(T);return R[k.toLowerCase()]}function p(T){for(const k in R)if(R[k]===T)return k}const g=/^(.+)\/(.+?)(;.+)?$/;function D(T,k){const u=g.exec(T);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:k?void 0:T}}),define(Re[53],Ae([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=R,e.$Yh=F,e.$Zh=p;function R(g){return JSON.stringify(g,M)}function F(g){let D=JSON.parse(g);return D=p(D),D}function M(g,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function p(g,D=0){if(!g||D>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return N.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof I.$Ce||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let T=0;T<g.length;++T)g[T]=p(g[T],D+1);else for(const T in g)Object.hasOwnProperty.call(g,T)&&(g[T]=p(g[T],D+1))}return g}}),define(Re[12],Ae([1,0,14,21,15,2,19]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=g,e.$Ag=D,e.$Eg=k;var p;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(p||(e.Schemas=p={}));function g(d,s){return F.URI.isUri(d)?(0,R.$tf)(d.scheme,s):(0,R.$uf)(d,s+":")}function D(d,...s){return s.some(o=>g(d,o))}e.$Bg="vscode-tkn",e.$Cg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=k(s,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(s,o,n){this.a[s]=o,this.b[s]=n}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(l){return I.$1(l),s}const o=s.authority;let n=this.a[o];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(s.path)}`;return typeof i=="string"&&(a+=`&${e.$Cg}=${encodeURIComponent(i)}`),F.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${n}:${r}`,path:this.g,query:a})}}e.$Dg=new T;function k(d,s){return M.$hc.join(s??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class u{static{this.a=e.$Jg}asBrowserUri(s){const o=this.b(s,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Dg.rewrite(s):s.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${u.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||u.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ge);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==u.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return F.URI.isUri(s)?s:F.URI.parse(o.toUrl(s))}}e.$Kg=new u;var w;(function(d){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function n(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:F.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const l=a?.get(o);if(l)return s.get(l)}d.getHeadersFromQuery=n;function r(i,a,l){if(!globalThis.crossOriginIsolated)return;const t=a&&l?"3":l?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}d.addSearchParam=r})(w||(e.COI=w={}))}),define(Re[23],Ae([1,0,47,12,19,21,15,2]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=g,e.$ah=T,e.$bh=u;function g(w){return(0,p.$xc)(w,!0)}class D{constructor(d){this.a=d}compare(d,s,o=!1){return d===s?0:(0,M.$mf)(this.getComparisonKey(d,o),this.getComparisonKey(s,o))}isEqual(d,s,o=!1){return d===s?!0:!d||!s?!1:this.getComparisonKey(d,o)===this.getComparisonKey(s,o)}getComparisonKey(d,s=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,s,o=!1){if(d.scheme===s.scheme){if(d.scheme===N.Schemas.file)return I.$qg(g(d),g(s),this.a(d))&&d.query===s.query&&(o||d.fragment===s.fragment);if((0,e.$9g)(d.authority,s.authority))return I.$qg(d.path,s.path,this.a(d),"/")&&d.query===s.query&&(o||d.fragment===s.fragment)}return!1}joinPath(d,...s){return p.URI.joinPath(d,...s)}basenameOrAuthority(d){return(0,e.$1g)(d)||d.authority}basename(d){return R.$hc.basename(d.path)}extname(d){return R.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let s;return d.scheme===N.Schemas.file?s=p.URI.file(R.$nc(g(d))).path:(s=R.$hc.dirname(d.path),d.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),s="/")),d.with({path:s})}normalizePath(d){if(!d.path.length)return d;let s;return d.scheme===N.Schemas.file?s=p.URI.file(R.$ic(g(d))).path:s=R.$hc.normalize(d.path),d.with({path:s})}relativePath(d,s){if(d.scheme!==s.scheme||!(0,e.$9g)(d.authority,s.authority))return;if(d.scheme===N.Schemas.file){const r=R.$mc(g(d),g(s));return F.$i?I.$kg(r):r}let o=d.path||"/";const n=s.path||"/";if(this.a(d)){let r=0;for(const i=Math.min(o.length,n.length);r<i&&!(o.charCodeAt(r)!==n.charCodeAt(r)&&o.charAt(r).toLowerCase()!==n.charAt(r).toLowerCase());r++);o=n.substr(0,r)+o.substr(r)}return R.$hc.relative(o,n)}resolvePath(d,s){if(d.scheme===N.Schemas.file){const o=p.URI.file(R.$lc(g(d),s));return d.with({authority:o.authority,path:o.path})}return s=I.$lg(s),d.with({path:R.$hc.resolve(d.path,s)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,s){return d===s||d!==void 0&&s!==void 0&&(0,M.$tf)(d,s)}hasTrailingPathSeparator(d,s=R.sep){if(d.scheme===N.Schemas.file){const o=g(d);return o.length>I.$mg(o).length&&o[o.length-1]===s}else{const o=d.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,s=R.sep){return(0,e.$0g)(d,s)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,s=R.sep){let o=!1;if(d.scheme===N.Schemas.file){const n=g(d);o=n!==void 0&&n.length===I.$mg(n).length&&n[n.length-1]===s}else{s="/";const n=d.path;o=n.length===1&&n.charCodeAt(n.length-1)===47}return!o&&!(0,e.$0g)(d,s)?d.with({path:d.path+"/"}):d}}e.$Sg=D,e.$Tg=new D(()=>!1),e.$Ug=new D(w=>w.scheme===N.Schemas.file?!F.$k:!0),e.$Vg=new D(w=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function T(w,d){const s=[];for(let o=0;o<w.length;o++){const n=d(w[o]);w.some((r,i)=>i===o?!1:(0,e.$Xg)(n,d(r)))||s.push(w[o])}return s}var k;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function d(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,l]=i.split(":");a&&l&&o.set(a,l)});const r=s.path.substring(0,s.path.indexOf(";"));return r&&o.set(w.META_DATA_MIME,r),o}w.parseMetaData=d})(k||(e.DataUri=k={}));function u(w,d,s){if(d){let o=w.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),w.with({scheme:s,authority:d,path:o})}return w.with({scheme:s})}}),define(Re[11],Ae([1,0,24,14,5,6,23,21,130,40]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=T,e.$dh=k,e.$eh=u,e.$fh=w,e.$gh=d,e.$hh=s,e.$ih=o,e.$jh=n,e.$rh=$,e.$sh=h,e.$th=E,e.$uh=f,e.$vh=S,e.$Kh=Ie,e.$Sh=Ee;function T(fe){return!!fe&&typeof fe.then=="function"}function k(fe){const Q=new I.$me,Y=fe(Q.token),he=new Promise((le,Ne)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Ne(new N.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),Q.dispose(),le(Ce)},Ce=>{de.dispose(),Q.dispose(),Ne(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(le,Ne){return he.then(le,Ne)}catch(le){return this.then(void 0,le)}finally(le){return he.finally(le)}}}function u(fe,Q,Y){return new Promise((he,le)=>{const Ne=Q.onCancellationRequested(()=>{Ne.dispose(),he(Y)});fe.then(he,le).finally(()=>Ne.dispose())})}function w(fe,Q){return new Promise((Y,he)=>{const le=Q.onCancellationRequested(()=>{le.dispose(),he(new N.$5)});fe.then(Y,he).finally(()=>le.dispose())})}async function d(fe){let Q=-1;const Y=fe.map((he,le)=>he.then(Ne=>(Q=le,Ne)));try{return await Promise.race(Y)}finally{fe.forEach((he,le)=>{le!==Q&&he.cancel()})}}function s(fe,Q,Y){let he;const le=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(le)),new Promise(Ne=>he=Ne)])}function o(fe){return new Promise((Q,Y)=>{const he=fe();T(he)?he.then(Q,Y):Q(he)})}function n(){let fe,Q;return{promise:new Promise((he,le)=>{fe=he,Q=le}),resolve:fe,reject:Q}}class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(le=>{this.a=null,Y(le)},le=>{this.a=null,he(le)})})}dispose(){this.f=!0}}e.$kh=r;class i{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$lh=i;class a{constructor(){this.a=new Map}queue(Q,Y){const le=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===le&&this.a.delete(Q)});return this.a.set(Q,le),le}}e.$mh=a;const l=(fe,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},fe);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class b{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((le,Ne)=>{this.d=le,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===g.$$d?t(he):l(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=b;class c{constructor(Q){this.a=new b(Q),this.b=new r}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=c;class m{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=m;class v extends m{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$qh=v;function $(fe,Q){return Q?new Promise((Y,he)=>{const le=setTimeout(()=>{Ne.dispose(),Y()},fe),Ne=Q.onCancellationRequested(()=>{clearTimeout(le),Ne.dispose(),he(new N.$5)})}):k(Y=>$(fe,Y))}function h(fe,Q=0,Y){const he=setTimeout(()=>{fe(),Y&&le.dispose()},Q),le=(0,F.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(le)});return Y?.add(le),le}function E(fe){const Q=[];let Y=0;const he=fe.length;function le(){return Y<he?fe[Y++]():null}function Ne(de){de!=null&&Q.push(de);const Ce=le();return Ce?Ce.then(Ne):Promise.resolve(Q)}return Promise.resolve(null).then(Ne)}function f(fe,Q=he=>!!he,Y=null){let he=0;const le=fe.length,Ne=()=>{if(he>=le)return Promise.resolve(Y);const de=fe[he++];return Promise.resolve(de()).then(Me=>Q(Me)?Promise.resolve(Me):Ne())};return Ne()}function S(fe,Q=he=>!!he,Y=null){if(fe.length===0)return Promise.resolve(Y);let he=fe.length;const le=()=>{he=-1;for(const Ne of fe)Ne.cancel?.()};return new Promise((Ne,de)=>{for(const Ce of fe)Ce.then(Me=>{--he>=0&&Q(Me)?(le(),Ne(Me)):he===0&&Ne(Y)}).catch(Me=>{--he>=0&&(le(),de(Me))})})}class y{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$be}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=y;class C extends y{constructor(){super(1)}}e.$xh=C;class P{constructor(){this.a=new ue,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$yh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new Se;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=M.$Tg){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=M.$Tg){const le=he.getComparisonKey(Q);let Ne=this.a.get(le);if(!Ne){Ne=new C;const de=this.f++,Ce=R.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$4c),this.d.set(de,Ce),this.a.set(le,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=V;class W{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Ah=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const le=he.setInterval(()=>{Q()},Y);this.d=(0,F.$Sc)(()=>{he.clearInterval(le),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=q;class A{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=A;class j{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=j;class K extends A{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Eh=K;class ie extends F.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new F.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(fe,Q)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Hh=(fe,Q,Y)=>{const he=fe.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let le=!1;return{dispose(){le||(le=!0,fe.cancelIdleCallback(he))}}},e.$Gh=fe=>(0,e.$Hh)(globalThis,fe)}();class ce{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Hh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=ce;class ve extends ce{constructor(Q){super(globalThis,Q)}}e.$Jh=ve;async function Ie(fe,Q,Y){let he;for(let le=0;le<Y;le++)try{return await fe()}catch(Ne){he=Ne,await $(Q)}throw he}class ue{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:le}=n();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=ue;class pe{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Mh=pe;var re;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(re||(re={}));class Se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new N.$5)}}e.$Nh=Se;var Le;(function(fe){async function Q(he){let le;const Ne=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{le||(le=Ce)})));if(typeof le<"u")throw le;return Ne}fe.settled=Q;function Y(he){return new Promise(async(le,Ne)=>{try{await he(le,Ne)}catch(de){Ne(de)}})}fe.withAsyncBody=Y})(Le||(e.Promises=Le={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=ne;class U{constructor(Q){this.b=Q,this.a=new D.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=U;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class be{static fromArray(Q){return new be(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new be(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new be(async Y=>{await Promise.all(Q.map(async he=>{for await(const le of he)Y.emitOne(le)}))})}static{this.EMPTY=be.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new R.$be,queueMicrotask(async()=>{const he={emitOne:le=>this.h(le),emitMany:le=>this.j(le),reject:le=>this.l(le)};try{await Promise.resolve(Q(he)),this.k()}catch(le){this.l(le)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new be(async he=>{for await(const le of Q)he.emitOne(Y(le))})}map(Q){return be.map(this,Q)}static filter(Q,Y){return new be(async he=>{for await(const le of Q)Y(le)&&he.emitOne(le)})}filter(Q){return be.filter(this,Q)}static coalesce(Q){return be.filter(Q,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return be.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Qh=be;class Te extends be{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Rh=Te;function Ee(fe){const Q=new I.$me,Y=fe(Q.token);return new Te(Q,async he=>{const le=Q.token.onCancellationRequested(()=>{le.dispose(),Q.dispose(),he.reject(new N.$5)});try{for await(const Ne of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Ne)}le.dispose(),Q.dispose()}catch(Ne){le.dispose(),Q.dispose(),he.reject(Ne)}})}class $e{constructor(Q){this.a=new Se,this.b=new be(le=>{if(Y){le.reject(Y);return}return he&&le.emitMany(he),this.d=Ne=>le.reject(Ne),this.f=Ne=>le.emitOne(Ne),this.a.p},Q);let Y,he;this.f=le=>{he||(he=[]),he.push(le)},this.d=le=>{Y||(Y=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Th=$e}),define(Re[36],Ae([1,0,18,11,47,28,19,21,15]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=D,e.$ik=d,e.$jk=C,e.$kk=P,e.$lk=V,e.$mk=W,e.$nk=q,e.$ok=ie;function D(){return Object.create(null)}e.$gk="**",e.$hk="/";const T="[/\\\\]",k="[^/\\\\]",u=/\//g;function w(ce,ve){switch(ce){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}${ve?`|${T}${k}+`:""})*?`}}function d(ce,ve){if(!ce)return[];const Ie=[];let ue=!1,pe=!1,re="";for(const Se of ce){switch(Se){case ve:if(!ue&&!pe){Ie.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}re+=Se}return re&&Ie.push(re),Ie}function s(ce){if(!ce)return"";let ve="";const Ie=d(ce,e.$hk);if(Ie.every(ue=>ue===e.$gk))ve=".*";else{let ue=!1;Ie.forEach((pe,re)=>{if(pe===e.$gk){if(ue)return;ve+=w(2,re===Ie.length-1)}else{let Se=!1,Le="",ne=!1,U="";for(const x of pe){if(x!=="}"&&Se){Le+=x;continue}if(ne&&(x!=="]"||!U)){let be;x==="-"?be=x:(x==="^"||x==="!")&&!U?be="^":x===e.$hk?be="":be=(0,g.$8e)(x),U+=be;continue}switch(x){case"{":Se=!0;continue;case"[":ne=!0;continue;case"}":{const Te=`(?:${d(Le,",").map(Ee=>s(Ee)).join("|")})`;ve+=Te,Se=!1,Le="";break}case"]":{ve+="["+U+"]",ne=!1,U="";break}case"?":ve+=k;continue;case"*":ve+=w(1);continue;default:ve+=(0,g.$8e)(x)}}re<Ie.length-1&&(Ie[re+1]!==e.$gk||re+2<Ie.length)&&(ve+=T)}ue=pe===e.$gk})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,n=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.$Ec(1e4),b=function(){return!1},c=function(){return null};function m(ce,ve){if(!ce)return c;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!ve.trimForExclusions}`;let pe=t.get(ue);if(pe)return v(pe,ce);let re;return o.test(Ie)?pe=h(Ie.substr(4),Ie):(re=n.exec($(Ie,ve)))?pe=E(re[1],Ie):(ve.trimForExclusions?i:r).test(Ie)?pe=f(Ie,ve):(re=a.exec($(Ie,ve)))?pe=S(re[1].substr(1),Ie,!0):(re=l.exec($(Ie,ve)))?pe=S(re[1],Ie,!1):pe=y(Ie),t.set(ue,pe),v(pe,ce)}function v(ce,ve){if(typeof ve=="string")return ce;const Ie=function(ue,pe){return(0,R.$qg)(ue,ve.base,!p.$k)?ce((0,g.$af)(ue.substr(ve.base.length),M.sep),pe):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function $(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function h(ce,ve){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?ve:null}}function E(ce,ve){const Ie=`/${ce}`,ue=`\\${ce}`,pe=function(Se,Le){return typeof Se!="string"?null:Le?Le===ce?ve:null:Se===ce||Se.endsWith(Ie)||Se.endsWith(ue)?ve:null},re=[ce];return pe.basenames=re,pe.patterns=[ve],pe.allBasenames=re,pe}function f(ce,ve){const Ie=K(ce.slice(1,-1).split(",").map(Le=>m(Le,ve)).filter(Le=>Le!==c),ce),ue=Ie.length;if(!ue)return c;if(ue===1)return Ie[0];const pe=function(Le,ne){for(let U=0,x=Ie.length;U<x;U++)if(Ie[U](Le,ne))return ce;return null},re=Ie.find(Le=>!!Le.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Se=Ie.reduce((Le,ne)=>ne.allPaths?Le.concat(ne.allPaths):Le,[]);return Se.length&&(pe.allPaths=Se),pe}function S(ce,ve,Ie){const ue=M.sep===M.$hc.sep,pe=ue?ce:ce.replace(u,M.sep),re=M.sep+pe,Se=M.$hc.sep+ce;let Le;return Ie?Le=function(ne,U){return typeof ne=="string"&&(ne===pe||ne.endsWith(re)||!ue&&(ne===ce||ne.endsWith(Se)))?ve:null}:Le=function(ne,U){return typeof ne=="string"&&(ne===pe||!ue&&ne===ce)?ve:null},Le.allPaths=[(Ie?"*/":"./")+ce],Le}function y(ce){try{const ve=new RegExp(`^${s(ce)}$`);return function(Ie){return ve.lastIndex=0,typeof Ie=="string"&&ve.test(Ie)?ce:null}}catch{return c}}function C(ce,ve,Ie){return!ce||typeof ve!="string"?!1:P(ce)(ve,void 0,Ie)}function P(ce,ve={}){if(!ce)return b;if(typeof ce=="string"||V(ce)){const Ie=m(ce,ve);if(Ie===c)return b;const ue=function(pe,re){return!!Ie(pe,re)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return A(ce,ve)}function V(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function W(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function A(ce,ve){const Ie=K(Object.getOwnPropertyNames(ce).map(Le=>j(Le,ce[Le],ve)).filter(Le=>Le!==c)),ue=Ie.length;if(!ue)return c;if(!Ie.some(Le=>!!Le.requiresSiblings)){if(ue===1)return Ie[0];const Le=function(x,be){let Te;for(let Ee=0,$e=Ie.length;Ee<$e;Ee++){const fe=Ie[Ee](x,be);if(typeof fe=="string")return fe;(0,N.$ch)(fe)&&(Te||(Te=[]),Te.push(fe))}return Te?(async()=>{for(const Ee of Te){const $e=await Ee;if(typeof $e=="string")return $e}return null})():null},ne=Ie.find(x=>!!x.allBasenames);ne&&(Le.allBasenames=ne.allBasenames);const U=Ie.reduce((x,be)=>be.allPaths?x.concat(be.allPaths):x,[]);return U.length&&(Le.allPaths=U),Le}const pe=function(Le,ne,U){let x,be;for(let Te=0,Ee=Ie.length;Te<Ee;Te++){const $e=Ie[Te];$e.requiresSiblings&&U&&(ne||(ne=(0,M.$oc)(Le)),x||(x=ne.substr(0,ne.length-(0,M.$pc)(Le).length)));const fe=$e(Le,ne,x,U);if(typeof fe=="string")return fe;(0,N.$ch)(fe)&&(be||(be=[]),be.push(fe))}return be?(async()=>{for(const Te of be){const Ee=await Te;if(typeof Ee=="string")return Ee}return null})():null},re=Ie.find(Le=>!!Le.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Se=Ie.reduce((Le,ne)=>ne.allPaths?Le.concat(ne.allPaths):Le,[]);return Se.length&&(pe.allPaths=Se),pe}function j(ce,ve,Ie){if(ve===!1)return c;const ue=m(ce,Ie);if(ue===c)return c;if(typeof ve=="boolean")return ue;if(ve){const pe=ve.when;if(typeof pe=="string"){const re=(Se,Le,ne,U)=>{if(!U||!ue(Se,Le))return null;const x=pe.replace("$(basename)",()=>ne),be=U(x);return(0,N.$ch)(be)?be.then(Te=>Te?ce:null):be?ce:null};return re.requiresSiblings=!0,re}}return ue}function K(ce,ve){const Ie=ce.filter(Le=>!!Le.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((Le,ne)=>{const U=ne.basenames;return U?Le.concat(U):Le},[]);let pe;if(ve){pe=[];for(let Le=0,ne=ue.length;Le<ne;Le++)pe.push(ve)}else pe=Ie.reduce((Le,ne)=>{const U=ne.patterns;return U?Le.concat(U):Le},[]);const re=function(Le,ne){if(typeof Le!="string")return null;if(!ne){let x;for(x=Le.length;x>0;x--){const be=Le.charCodeAt(x-1);if(be===47||be===92)break}ne=Le.substr(x)}const U=ue.indexOf(ne);return U!==-1?pe[U]:null};re.basenames=ue,re.patterns=pe,re.allBasenames=ue;const Se=ce.filter(Le=>!Le.basenames);return Se.push(re),Se}function ie(ce,ve){return(0,I.$ub)(ce,ve,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}}),define(Re[54],Ae([1,0,14,131,23,15,2]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=D,e.$Pk=T,e.$Qk=k,e.$Rk=u,e.$Sk=w,e.$Tk=d,e.$Uk=s,e.$Vk=o;var p;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class g{constructor(r="",i=!1){if(this.value=r,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(r,i=0){return this.value+=u(this.supportThemeIcons?(0,N.$Hk)(r):r).replace(/([ \t]+)/g,(a,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,i){return this.value+=`
${w(i,r)}
`,this}appendLink(r,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(r),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(r,i){const a=new RegExp((0,F.$8e)(i),"g");return r.replace(a,(l,t)=>r.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$Nk=g;function D(n){return T(n)?!n.value:Array.isArray(n)?n.every(D):!0}function T(n){return n instanceof g?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}function k(n,r){return n===r?!0:!n||!r?!1:n.value===r.value&&n.isTrusted===r.isTrusted&&n.supportThemeIcons===r.supportThemeIcons&&n.supportHtml===r.supportHtml&&(n.baseUri===r.baseUri||!!n.baseUri&&!!r.baseUri&&(0,R.$Wg)(M.URI.from(n.baseUri),M.URI.from(r.baseUri)))}function u(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(n,r){const i=n.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${r}`,n,`${"`".repeat(a)}`].join(`
`)}function d(n){return n.replace(/"/g,"&quot;")}function s(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(n){const r=[],i=n.split("|").map(l=>l.trim());n=i[0];const a=i[1];if(a){const l=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),b=l?l[1]:"",c=t?t[1]:"",m=isFinite(parseInt(c)),v=isFinite(parseInt(b));m&&r.push(`width="${c}"`),v&&r.push(`height="${b}"`)}return{href:n,dimensions:r}}}),define(Re[96],Ae([1,0,18,47,19,21,23,15]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=g,e.$pw=T,e.$qw=u,e.$rw=w,e.$sw=n,e.$tw=i,e.$uw=a,e.$vw=l,e.$ww=t,e.$xw=b;function g(m,v){const{os:$,tildify:h,relative:E}=v;if(E){const y=D(m,E,$);if(typeof y=="string")return y}let f=m.fsPath;if($===1&&!F.$i?f=f.replace(/\//g,"\\"):$!==1&&F.$i&&(f=f.replace(/\\/g,"/")),$!==1&&h?.userHome){const y=h.userHome.fsPath;let C;m.scheme!==h.userHome.scheme&&m.path[0]===R.$hc.sep&&m.path[1]!==R.$hc.sep?C=h.userHome.with({path:m.path}).fsPath:C=f,f=u(C,y,$)}return($===1?R.$gc:R.$hc).normalize(T(f,$===1))}function D(m,v,$){const h=$===1?R.$gc:R.$hc,E=$===3?M.$Tg:M.$Vg,f=v.getWorkspace(),S=(0,I.$Ob)(f.folders);if(!S)return;m.scheme!==S.uri.scheme&&m.path[0]===R.$hc.sep&&m.path[1]!==R.$hc.sep&&(m=S.uri.with({path:m.path}));const y=v.getWorkspaceFolder(m);if(!y)return;let C;if(E.isEqual(y.uri,m)?C="":C=E.relativePath(y.uri,m)??"",C&&(C=h.normalize(C)),f.folders.length>1&&!v.noPrefix){const P=y.name?y.name:E.basenameOrAuthority(y.uri);C=C?`${P} \u2022 ${C}`:P}return C}function T(m,v=F.$i){return(0,N.$ug)(m,v)?m.charAt(0).toUpperCase()+m.slice(1):m}let k=Object.create(null);function u(m,v,$=F.OS){if($===1||!m||!v)return m;let h=k.original===v?k.normalized:void 0;h||(h=v,F.$i&&(h=(0,N.$kg)(h)),h=`${(0,p.$bf)(h,R.$hc.sep)}${R.$hc.sep}`,k={original:v,normalized:h});let E=m;return F.$i&&(E=(0,N.$kg)(E)),($===3?E.startsWith(h):(0,p.$uf)(E,h))?`~/${E.substr(h.length)}`:m}function w(m,v){return m.replace(/^~($|\/|\\)/,`${v}$1`)}const d="\u2026",s="\\\\",o="~";function n(m,v=R.sep){const $=new Array(m.length);let h=!1;for(let E=0;E<m.length;E++){const f=m[E];if(f===""){$[E]=`.${v}`;continue}if(!f){$[E]=f;continue}h=!0;let S="",y=f;y.indexOf(s)===0?(S=y.substr(0,y.indexOf(s)+s.length),y=y.substr(y.indexOf(s)+s.length)):y.indexOf(v)===0?(S=y.substr(0,y.indexOf(v)+v.length),y=y.substr(y.indexOf(v)+v.length)):y.indexOf(o)===0&&(S=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(v);for(let P=1;h&&P<=C.length;P++)for(let V=C.length-P;h&&V>=0;V--){h=!1;let W=C.slice(V,V+P).join(v);for(let q=0;!h&&q<m.length;q++)if(q!==E&&m[q]&&m[q].indexOf(W)>-1){const A=V+P===C.length,j=V>0&&m[q].indexOf(v)>-1?v+W:W,K=m[q].endsWith(j);h=!A||K}if(!h){let q="";(C[0].endsWith(":")||S!=="")&&(V===1&&(V=0,P++,W=C[0]+v+W),V>0&&(q=C[0]+v),q=S+q),V>0&&(q=q+d+v),q=q+W,V+P<C.length&&(q=q+v+d),$[E]=q}}h&&($[E]=f)}return $}var r;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function i(m,v=Object.create(null)){const $=[];let h=!1,E="";for(const f of m)if(f==="$"||h&&f==="{")E&&$.push({value:E,type:r.TEXT}),E="",h=!0;else if(f==="}"&&h){const S=v[E];if(typeof S=="string")S.length&&$.push({value:S,type:r.VARIABLE});else if(S){const y=$[$.length-1];(!y||y.type!==r.SEPARATOR)&&$.push({value:S.label,type:r.SEPARATOR})}E="",h=!1}else E+=f;return E&&!h&&$.push({value:E,type:r.TEXT}),$.filter((f,S)=>{if(f.type===r.SEPARATOR){const y=$[S-1],C=$[S+1];return[y,C].every(P=>P&&(P.type===r.VARIABLE||P.type===r.TEXT)&&P.value.length>0)}return!0}).map(f=>f.value).join("")}function a(m,v){return F.$j||v?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):m.replace(/&&|&/g,$=>$==="&"?"&&":"&")}function l(m,v){return F.$j||v?m.replace(/\(&&\w\)|&&/g,""):F.$i?m.replace(/&&|&/g,$=>$==="&"?"&&":"&"):m.replace(/&&/g,"_")}function t(m){return m.replace(/&/g,"&&")}function b(m){if(m.endsWith("]")){const v=m.lastIndexOf(" [",m.length-2);if(v!==-1){const $=c(m.substring(0,v)),h=m.substring(v);return{name:$.name+h,parentPath:$.parentPath}}}return c(m)}function c(m){const v=m.indexOf("/")!==-1?R.$hc:R.$gc,$=v.basename(m),h=v.dirname(m);return $.length?{name:$,parentPath:h}:{name:h,parentPath:""}}}),define(Re[144],Ae([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=p,e.$vn=D,e.$wn=T;function R(k){return k.toJSON()}class F{constructor(u){this.a=u}transformIncoming(u){const w=this.a.transformIncoming(u);return w===u?u:R(N.URI.from(w))}transformOutgoing(u){const w=this.a.transformOutgoing(u);return w===u?u:R(N.URI.from(w))}transformOutgoingURI(u){const w=this.a.transformOutgoing(u);return w===u?u:N.URI.from(w)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$sn=F,e.$tn=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function M(k,u,w){if(!k||w>200)return null;if(typeof k=="object"){if(k instanceof N.URI)return u.transformOutgoing(k);for(const d in k)if(Object.hasOwnProperty.call(k,d)){const s=M(k[d],u,w+1);s!==null&&(k[d]=s)}}return null}function p(k,u){const w=M(k,u,0);return w===null?k:w}function g(k,u,w,d){if(!k||d>200)return null;if(typeof k=="object"){if(k.$mid===1)return w?N.URI.revive(u.transformIncoming(k)):u.transformIncoming(k);if(k instanceof I.$Ce)return null;for(const s in k)if(Object.hasOwnProperty.call(k,s)){const o=g(k[s],u,w,d+1);o!==null&&(k[s]=o)}}return null}function D(k,u){const w=g(k,u,!1,0);return w===null?k:w}function T(k,u){const w=g(k,u,!0,0);return w===null?k:w}}),define(Re[145],Ae([1,0,15,21,22]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=T,e.$ut=k;let F;function M(){return F||(F=new TextDecoder("UTF-16LE")),F}let p;function g(){return p||(p=new TextDecoder("UTF-16BE")),p}let D;function T(){return D||(D=N.$D()?M():g()),D}function k(d,s,o){const n=new Uint16Array(d.buffer,s,o);return o>0&&(n[0]===65279||n[0]===65534)?u(d,s,o):M().decode(n)}function u(d,s,o){const n=[];let r=0;for(let i=0;i<o;i++){const a=R.$Ee(d,s);s+=2,n[r++]=String.fromCharCode(a)}return n.join("")}class w{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return T().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||I.$xf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let n=0;n<o;n++)this.b[this.d++]=s.charCodeAt(n)}}e.$vt=w}),define(Re[146],Ae([1,0,22,145]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function R(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,T,k,u){this.oldPosition=D,this.oldText=T,this.newPosition=k,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,T,k){const u=T.length;I.$He(D,u,k),k+=4;for(let w=0;w<u;w++)I.$Fe(D,T.charCodeAt(w),k),k+=2;return k}static d(D,T){const k=I.$Ge(D,T);return T+=4,(0,N.$ut)(D,T,k)}writeSize(){return 8+F.a(this.oldText)+F.a(this.newText)}write(D,T){return I.$He(D,this.oldPosition,T),T+=4,I.$He(D,this.newPosition,T),T+=4,T=F.c(D,this.oldText,T),T=F.c(D,this.newText,T),T}static read(D,T,k){const u=I.$Ge(D,T);T+=4;const w=I.$Ge(D,T);T+=4;const d=F.d(D,T);T+=F.a(d);const s=F.d(D,T);return T+=F.a(s),k.push(new F(u,d,w,s)),T}}e.$wt=F;function M(g,D){return g===null||g.length===0?D:new p(g,D).compress()}class p{constructor(D,T){this.a=D,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,T=0,k=this.n(D),u=this.l(T);for(;D<this.f||T<this.h;){if(k===null){this.k(u),u=this.l(++T);continue}if(u===null){this.m(k),k=this.n(++D);continue}if(u.oldEnd<=k.newPosition){this.k(u),u=this.l(++T);continue}if(k.newEnd<=u.oldPosition){this.m(k),k=this.n(++D);continue}if(u.oldPosition<k.newPosition){const[n,r]=p.r(u,k.newPosition-u.oldPosition);this.k(n),u=r;continue}if(k.newPosition<u.oldPosition){const[n,r]=p.q(k,u.oldPosition-k.newPosition);this.m(n),k=r;continue}let s,o;if(u.oldEnd===k.newEnd)s=k,o=u,k=this.n(++D),u=this.l(++T);else if(u.oldEnd<k.newEnd){const[n,r]=p.q(k,u.oldLength);s=n,o=u,k=r,u=this.l(++T)}else{const[n,r]=p.r(u,k.newLength);s=k,o=n,k=this.n(++D),u=r}this.d[this.e++]=new F(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const w=p.s(this.d);return p.t(w)}k(D){this.d[this.e++]=p.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=p.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,T){return new F(T.oldPosition-D,T.oldText,T.newPosition,T.newText)}static p(D,T){return new F(T.oldPosition,T.oldText,T.newPosition+D,T.newText)}static q(D,T){const k=D.newText.substr(0,T),u=D.newText.substr(T);return[new F(D.oldPosition,D.oldText,D.newPosition,k),new F(D.oldEnd,"",D.newPosition+T,u)]}static r(D,T){const k=D.oldText.substr(0,T),u=D.oldText.substr(T);return[new F(D.oldPosition,k,D.newPosition,D.newText),new F(D.oldPosition+T,u,D.newEnd,"")]}static s(D){if(D.length===0)return D;const T=[];let k=0,u=D[0];for(let w=1;w<D.length;w++){const d=D[w];u.oldEnd===d.oldPosition?u=new F(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(T[k++]=u,u=d)}return T[k++]=u,T}static t(D){if(D.length===0)return D;const T=[];let k=0;for(let u=0;u<D.length;u++){const w=D[u];w.oldText!==w.newText&&(T[k++]=w)}return T}}}),define(Re[147],Ae([1,0,36,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=R,e.$Vt=F;function R(M,p,g,D,T,k){if(Array.isArray(M)){let u=0;for(const w of M){const d=R(w,p,g,D,T,k);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof M=="string")return D?M==="*"?5:M===g?10:0:0;if(M){const{language:u,pattern:w,scheme:d,hasAccessToAllModels:s,notebookType:o}=M;if(!D&&!s)return 0;o&&T&&(p=T);let n=0;if(d)if(d===p.scheme)n=10;else if(d==="*")n=5;else return 0;if(u)if(u===g)n=10;else if(u==="*")n=Math.max(n,5);else return 0;if(o)if(o===k)n=10;else if(o==="*"&&k!==void 0)n=Math.max(n,5);else return 0;if(w){let r;if(typeof w=="string"?r=w:r={...w,base:(0,N.$ic)(w.base)},r===p.fsPath||(0,I.$jk)(r,p.fsPath))n=10;else return 0}return n}else return 0}}function F(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(F):!!M.notebookType}}),define(Re[148],Ae([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class T extends D.$Uc{constructor(u,w,d,s,o,n,r){super(),this.m=this.B(new I.$be),this.onDidChangeContent=this.m.event,this.f=w,this.j=!n,this.g=s,this.h=o,this.c=new M.$KC(u,d,r)}equals(u){return!(u instanceof T)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,w){return this.c.getOffsetAt(u,w)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,w){const d=u+w,s=this.getPositionAt(u),o=this.getPositionAt(d);return new R.$kt(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(u,w=0){if(u.isEmpty())return"";const d=this.n(w);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,w=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),s=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const n=this.n(w),r=this.getEOL();if(n.length!==r.length){const i=n.length-r.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return s-d+o}getCharacterCountInRange(u,w=0){if(this.j){let d=0;const s=u.startLineNumber,o=u.endLineNumber;for(let n=s;n<=o;n++){const r=this.getLineContent(n),i=n===s?u.startColumn-1:0,a=n===o?u.endColumn-1:r.length;for(let l=i;l<a;l++)N.$xf(r.charCodeAt(l))?(d=d+1,l=l+1):d=d+1}return d+=this.n(w).length*(o-s),d}return this.getValueLengthInRange(u,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,w){return this.c.getLineCharCode(u,w)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const w=N.$if(this.getLineContent(u));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(u){const w=N.$kf(this.getLineContent(u));return w===-1?0:w+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,w,d){let s=this.g,o=this.h,n=this.j,r=!0,i=[];for(let v=0;v<u.length;v++){const $=u[v];r&&$._isTracked&&(r=!1);const h=$.range;if($.text){let C=!0;n||(C=!N.$If($.text),n=C),!s&&C&&(s=N.$Hf($.text)),!o&&C&&(o=N.$Kf($.text))}let E="",f=0,S=0,y=0;if($.text){let C;[f,S,y,C]=(0,p.$Nt)($.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?E=$.text:E=$.text.replace(/\r\n|\r|\n/g,P)}i[v]={sortIndex:v,identifier:$.identifier||null,range:h,rangeOffset:this.getOffsetAt(h.startLineNumber,h.startColumn),rangeLength:this.getValueLengthInRange(h),text:E,eolCount:f,firstLineLength:S,lastLineLength:y,forceMoveMarkers:!!$.forceMoveMarkers,isAutoWhitespaceEdit:$.isAutoWhitespaceEdit||!1}}i.sort(T.u);let a=!1;for(let v=0,$=i.length-1;v<$;v++){const h=i[v].range.getEndPosition(),E=i[v+1].range.getStartPosition();if(E.isBeforeOrEqual(h)){if(E.isBefore(h))throw new Error("Overlapping ranges are not allowed!");a=!0}}r&&(i=this.s(i));const l=d||w?T._getInverseEditRanges(i):[],t=[];if(w)for(let v=0;v<i.length;v++){const $=i[v],h=l[v];if($.isAutoWhitespaceEdit&&$.range.isEmpty())for(let E=h.startLineNumber;E<=h.endLineNumber;E++){let f="";E===h.startLineNumber&&(f=this.getLineContent($.range.startLineNumber),N.$if(f)!==-1)||t.push({lineNumber:E,oldContent:f})}}let b=null;if(d){let v=0;b=[];for(let $=0;$<i.length;$++){const h=i[$],E=l[$],f=this.getValueInRange(h.range),S=h.rangeOffset+v;v+=h.text.length-f.length,b[$]={sortIndex:h.sortIndex,identifier:h.identifier,range:E,text:f,textChange:new g.$wt(h.rangeOffset,f,S,h.text)}}a||b.sort(($,h)=>$.sortIndex-h.sortIndex)}this.g=s,this.h=o,this.j=n;const c=this.t(i);let m=null;if(w&&t.length>0){t.sort((v,$)=>$.lineNumber-v.lineNumber),m=[];for(let v=0,$=t.length;v<$;v++){const h=t[v].lineNumber;if(v>0&&t[v-1].lineNumber===h)continue;const E=t[v].oldContent,f=this.getLineContent(h);f.length===0||f===E||N.$if(f)!==-1||m.push(h)}}return this.m.fire(),new F.$zv(b,c,m)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let w=!1;const d=u[0].range,s=u[u.length-1].range,o=new R.$kt(d.startLineNumber,d.startColumn,s.endLineNumber,s.endColumn);let n=d.startLineNumber,r=d.startColumn;const i=[];for(let c=0,m=u.length;c<m;c++){const v=u[c],$=v.range;w=w||v.forceMoveMarkers,i.push(this.getValueInRange(new R.$kt(n,r,$.startLineNumber,$.startColumn))),v.text.length>0&&i.push(v.text),n=$.endLineNumber,r=$.endColumn}const a=i.join(""),[l,t,b]=(0,p.$Nt)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:l,firstLineLength:t,lastLineLength:b,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(u){u.sort(T.w);const w=[];for(let d=0;d<u.length;d++){const s=u[d],o=s.range.startLineNumber,n=s.range.startColumn,r=s.range.endLineNumber,i=s.range.endColumn;if(o===r&&n===i&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const a=new R.$kt(o,n,r,i);w.push({range:a,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return w}findMatchesLineByLine(u,w,d,s){return this.c.findMatchesLineByLine(u,w,d,s)}getPieceTree(){return this.c}static _getInverseEditRange(u,w){const d=u.startLineNumber,s=u.startColumn,[o,n,r]=(0,p.$Nt)(w);let i;if(w.length>0){const a=o+1;a===1?i=new R.$kt(d,s,d,s+n):i=new R.$kt(d,s,d+a-1,r+1)}else i=new R.$kt(d,s,d,s);return i}static _getInverseEditRanges(u){const w=[];let d=0,s=0,o=null;for(let n=0,r=u.length;n<r;n++){const i=u[n];let a,l;o?o.range.endLineNumber===i.range.startLineNumber?(a=d,l=s+(i.range.startColumn-o.range.endColumn)):(a=d+(i.range.startLineNumber-o.range.endLineNumber),l=i.range.startColumn):(a=i.range.startLineNumber,l=i.range.startColumn);let t;if(i.text.length>0){const b=i.eolCount+1;b===1?t=new R.$kt(a,l,a,l+i.firstLineLength):t=new R.$kt(a,l,a+b-1,i.lastLineLength+1)}else t=new R.$kt(a,l,a,l);d=t.endLineNumber,s=t.endColumn,w.push(t),o=i}return w}static u(u,w){const d=R.$kt.compareRangesUsingEnds(u.range,w.range);return d===0?u.sortIndex-w.sortIndex:d}static w(u,w){const d=R.$kt.compareRangesUsingEnds(u.range,w.range);return d===0?w.sortIndex-u.sortIndex:-d}}e.$LC=T}),define(Re[149],Ae([1,0,15,92,148]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=void 0;class F{constructor(g,D,T,k,u,w,d,s,o){this.a=g,this.b=D,this.c=T,this.d=k,this.e=u,this.f=w,this.g=d,this.h=s,this.j=o}k(g){const D=this.c+this.d+this.e,T=this.c+this.e;return D===0?g===1?`
`:`\r
`:T>D/2?`\r
`:`
`}create(g){const D=this.k(g),T=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let u=0,w=T.length;u<w;u++){const d=T[u].buffer.replace(/\r\n|\r|\n/g,D),s=(0,N.$GC)(d);T[u]=new N.$JC(d,s)}const k=new R.$LC(T,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&I.$Rf(g)&&(this.b=I.$Qf,g=g.substr(1));const D=g.charCodeAt(g.length-1);D===13||D>=55296&&D<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=D):(this.m(g,!1),this.c=!1,this.d=D)}m(g,D){!D&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const D=(0,N.$HC)(this.e,g);this.a.push(new N.$JC(g,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Hf(g)),this.k||(this.k=I.$Kf(g)))}finish(g=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const D=(0,N.$GC)(g.buffer);g.lineStarts=D,this.d===13&&this.f++}}}e.$MC=M}),define(Re[97],Ae([1,0,22,21]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbb=g,e.$ibb=T;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function F(k){for(let u=0,w=k.length;u<w;u+=4){const d=k[u+0],s=k[u+1],o=k[u+2],n=k[u+3];k[u+0]=n,k[u+1]=o,k[u+2]=s,k[u+3]=d}}function M(k){const u=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return N.$D()||F(u),I.$Ce.wrap(u)}function p(k){const u=k.buffer;if(N.$D()||F(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const w=new Uint8Array(u.byteLength);return w.set(u),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function g(k){const u=new Uint32Array(D(k));let w=0;if(u[w++]=k.id,k.type==="full")u[w++]=1,u[w++]=k.data.length,u.set(k.data,w),w+=k.data.length;else{u[w++]=2,u[w++]=k.deltas.length;for(const d of k.deltas)u[w++]=d.start,u[w++]=d.deleteCount,d.data?(u[w++]=d.data.length,u.set(d.data,w),w+=d.data.length):u[w++]=0}return M(u)}function D(k){let u=0;if(u+=2,k.type==="full")u+=1+k.data.length;else{u+=1,u+=3*k.deltas.length;for(const w of k.deltas)w.data&&(u+=w.data.length)}return u}function T(k){const u=p(k);let w=0;const d=u[w++];if(u[w++]===1){const r=u[w++],i=u.subarray(w,w+r);return w+=r,{id:d,type:"full",data:i}}const o=u[w++],n=[];for(let r=0;r<o;r++){const i=u[w++],a=u[w++],l=u[w++];let t;l>0&&(t=u.subarray(w,w+l),w+=l),n[r]={start:i,deleteCount:a,data:t}}return{id:d,type:"delta",deltas:n}}}),define(Re[150],Ae([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Re[151],Ae([1,0,18,26,21,134,152,150]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=r,e.clampedFloat=a,e.stringSet=b,e.cursorStyleToString=y,e.filterValidationDecorations=le;var g;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=D;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class k{constructor(Z,me,He,we){this.id=Z,this.name=me,this.defaultValue=He,this.schema=we}applyUpdate(Z,me){return w(Z,me)}compute(Z,me,He){return He}}class u{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=u;function w(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new u(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const He=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new u(Z,!He)}let me=!1;for(const He in Z)if(Z.hasOwnProperty(He)){const we=w(X[He],Z[He]);we.didChange&&(X[He]=we.newValue,me=!0)}return new u(X,me)}class d{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return w(Z,me)}validate(Z){return this.defaultValue}}class s{constructor(Z,me,He,we){this.id=Z,this.name=me,this.defaultValue=He,this.schema=we}applyUpdate(Z,me){return w(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,He){return He}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class n extends s{constructor(Z,me,He,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=He),super(Z,me,He,we)}validate(Z){return o(Z,this.defaultValue)}}function r(X,Z,me,He){if(typeof X>"u")return Z;let we=parseInt(X,10);return isNaN(we)?Z:(we=Math.max(me,we),we=Math.min(He,we),we|0)}class i extends s{static clampedInt(Z,me,He,we){return r(Z,me,He,we)}constructor(Z,me,He,we,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=we,dt.maximum=ot),super(Z,me,He,dt),this.minimum=we,this.maximum=ot}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function a(X,Z,me,He){if(typeof X>"u")return Z;const we=l.float(X,Z);return l.clamp(we,me,He)}class l extends s{static clamp(Z,me,He){return Z<me?me:Z>He?He:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const He=parseFloat(Z);return isNaN(He)?me:He}constructor(Z,me,He,we,ot){typeof ot<"u"&&(ot.type="number",ot.default=He),super(Z,me,He,ot),this.validationFn=we}validate(Z){return this.validationFn(l.float(Z,this.defaultValue))}}class t extends s{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,He,we=void 0){typeof we<"u"&&(we.type="string",we.default=He),super(Z,me,He,we)}validate(Z){return t.string(Z,this.defaultValue)}}function b(X,Z,me,He){return typeof X!="string"?Z:He&&X in He?He[X]:me.indexOf(X)===-1?Z:X}class c extends s{constructor(Z,me,He,we,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=we,ot.default=He),super(Z,me,He,ot),this.c=we}validate(Z){return b(Z,this.defaultValue,this.c)}}class m extends k{constructor(Z,me,He,we,ot,dt,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=ot,Ct.default=we),super(Z,me,He,Ct),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function v(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,He){return He===0?Z.accessibilitySupport:He}}class h extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function f(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function y(X){switch(X){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function C(X){switch(X){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class P extends d{constructor(){super(142)}compute(Z,me,He){const we=["monaco-editor"];return me.get(39)&&we.push(me.get(39)),Z.extraEditorClassName&&we.push(Z.extraEditorClassName),me.get(74)==="default"?we.push("mouse-default"):me.get(74)==="copy"&&we.push("mouse-copy"),me.get(111)&&we.push("showUnused"),me.get(140)&&we.push("showDeprecated"),we.join(" ")}}class V extends n{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Z,me,He){return He&&Z.emptySelectionClipboard}}class W extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:p.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:p.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?A.OFF:Z==="true"?A.TRANSLATE:Z:Z?A.TRANSLATE:A.OFF}compute(Z,me,He){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class j extends d{constructor(){super(50)}compute(Z,me,He){return Z.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Z){const me=l.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(me,6,100)}compute(Z,me,He){return Z.fontInfo.fontSize}}class ie extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends k{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:p.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends d{constructor(){super(145)}compute(Z,me,He){return ue.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,He=Math.floor(Z.paddingTop/Z.lineHeight);let we=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(we=Math.max(we,me-1));const ot=(He+Z.viewLineCount+we)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:we,desiredRatio:ot,minimapLineCount:dt}}static c(Z,me){const He=Z.outerWidth,we=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=me.stableMinimapLayoutInput,Ct=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Ut=Z.lineHeight,Yt=Z.typicalHalfwidthCharacterWidth,Jt=Z.scrollBeyondLastLine,xt=Z.minimap.renderCharacters;let Dt=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Wt=Z.minimap.maxColumn,Qt=Z.minimap.size,Xe=Z.minimap.side,ri=Z.verticalScrollbarWidth,_t=Z.viewLineCount,ht=Z.remainingWidth,$t=Z.isViewportWrapping,ei=xt?2:3;let Zt=Math.floor(ot*we);const Lt=Zt/ot;let gt=!1,jt=!1,Xt=ei*Dt,zt=Dt/ot,Ke=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:Nt,extraLinesBeforeFirstLine:ti,extraLinesBeyondLastLine:Ht,desiredRatio:si,minimapLineCount:At}=ue.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:Jt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:we,lineHeight:Ut,pixelRatio:ot});if(_t/At>1)gt=!0,jt=!0,Dt=1,Xt=1,zt=Dt/ot;else{let It=!1,Pt=Dt+1;if(Qt==="fit"){const pt=Math.ceil((ti+_t+Ht)*Xt);$t&&Ct&&ht<=me.stableFitRemainingWidth?(It=!0,Pt=me.stableFitMaxMinimapScale):It=pt>Zt}if(Qt==="fill"||It){gt=!0;const pt=Dt;Xt=Math.min(Ut*ot,Math.max(1,Math.floor(1/si))),$t&&Ct&&ht<=me.stableFitRemainingWidth&&(Pt=me.stableFitMaxMinimapScale),Dt=Math.min(Pt,Math.max(1,Math.floor(Xt/ei))),Dt>pt&&(Ke=Math.min(2,Dt/pt)),zt=Dt/ot/Ke,Zt=Math.ceil(Math.max(Nt,ti+_t+Ht)*Xt),$t?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Dt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const oi=Math.floor(Wt*zt),Vt=Math.min(oi,Math.max(0,Math.floor((ht-ri-2)*zt/(Yt+zt)))+e.MINIMAP_GUTTER_WIDTH);let qt=Math.floor(ot*Vt);const mt=qt/ot;qt=Math.floor(qt*Ke);const Rt=xt?1:2,Tt=Xe==="left"?0:He-Vt-ri;return{renderMinimap:Rt,minimapLeft:Tt,minimapWidth:Vt,minimapHeightIsEditorHeight:gt,minimapIsSampling:jt,minimapScale:Dt,minimapLineHeight:Xt,minimapCanvasInnerWidth:qt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Lt}}static computeLayout(Z,me){const He=me.outerWidth|0,we=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Ct=me.typicalHalfwidthCharacterWidth,Ut=me.maxDigitWidth,Yt=me.pixelRatio,Jt=me.viewLineCount,xt=Z.get(137),Dt=xt==="inherit"?Z.get(136):xt,Wt=Dt==="inherit"?Z.get(132):Dt,Qt=Z.get(135),Xe=me.isDominatedByLongLines,ri=Z.get(57),_t=Z.get(68).renderType!==0,ht=Z.get(69),$t=Z.get(105),ei=Z.get(84),Zt=Z.get(73),Lt=Z.get(103),gt=Lt.verticalScrollbarSize,jt=Lt.verticalHasArrows,Xt=Lt.arrowSize,zt=Lt.horizontalScrollbarSize,Ke=Z.get(43),oi=Z.get(110)!=="never";let Vt=Z.get(66);Ke&&oi&&(Vt+=16);let qt=0;if(_t){const li=Math.max(dt,ht);qt=Math.round(li*Ut)}let mt=0;ri&&(mt=ot*me.glyphMarginDecorationLaneCount);let Rt=0,Tt=Rt+mt,Nt=Tt+qt,ti=Nt+Vt;const Ht=He-mt-qt-Vt;let si=!1,At=!1,Ft=-1;Dt==="inherit"&&Xe?(si=!0,At=!0):Wt==="on"||Wt==="bounded"?At=!0:Wt==="wordWrapColumn"&&(Ft=Qt);const It=ue.c({outerWidth:He,outerHeight:we,lineHeight:ot,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Yt,scrollBeyondLastLine:$t,paddingTop:ei.top,paddingBottom:ei.bottom,minimap:Zt,verticalScrollbarWidth:gt,viewLineCount:Jt,remainingWidth:Ht,isViewportWrapping:At},me.memory||new T);It.renderMinimap!==0&&It.minimapLeft===0&&(Rt+=It.minimapWidth,Tt+=It.minimapWidth,Nt+=It.minimapWidth,ti+=It.minimapWidth);const Pt=Ht-It.minimapWidth,pt=Math.max(1,Math.floor((Pt-gt-2)/Ct)),St=jt?Xt:0;return At&&(Ft=Math.max(1,pt),Wt==="bounded"&&(Ft=Math.min(Ft,Qt))),{width:He,height:we,glyphMarginLeft:Rt,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Tt,lineNumbersWidth:qt,decorationsLeft:Nt,decorationsWidth:Vt,contentLeft:ti,contentWidth:Pt,minimap:It,viewportColumn:pt,isWordWrapMinified:si,isViewportWrapping:At,wrappingColumn:Ft,verticalScrollbarWidth:gt,horizontalScrollbarHeight:zt,overviewRuler:{top:St,width:gt,height:we-2*St,right:0}}}}e.EditorLayoutInfoComputer=ue;class pe extends k{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Z){return b(Z,"simple",["simple","advanced"])}compute(Z,me,He){return me.get(2)===2?"advanced":He}}var re;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class Se extends k{constructor(){const Z={enabled:re.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[re.Off,re.OnCode,re.On],default:Z.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:b(Z.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class Le extends k{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:p.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends k{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:p.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:b(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class U extends k{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):i.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,He){return He<0?i.clampedInt(-He*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends l{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>l.clamp(Z,0,150),{markdownDescription:p.localize(66,null)})}compute(Z,me,He){return Z.fontInfo.lineHeight}}class be extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Z.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:l.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Te(X){return X==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends k{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class $e extends k{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:p.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class fe extends d{constructor(){super(143)}compute(Z,me,He){return Z.pixelRatio}}class Q extends k{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:p.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:p.localize(89,null)},other:{anyOf:me,default:Z.other,description:p.localize(90,null)}},default:Z,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Yt=Z?"on":"off";return{comments:Yt,strings:Yt,other:Yt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:He,strings:we}=Z,ot=["on","inline","off"];let dt,Ct,Ut;return typeof me=="boolean"?dt=me?"on":"off":dt=b(me,this.defaultValue.other,ot),typeof He=="boolean"?Ct=He?"on":"off":Ct=b(He,this.defaultValue.comments,ot),typeof we=="boolean"?Ut=we?"on":"off":Ut=b(we,this.defaultValue.strings,ot),{other:dt,comments:Ct,strings:Ut}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends k{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,He=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function le(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Ne extends k{constructor(){const Z=[],me={type:"number",description:p.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Z,description:p.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="number")me.push({column:i.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const we=He;me.push({column:i.clampedInt(we.column,0,0,1e4),color:we.color})}return me.sort((He,we)=>He.column-we.column),me}return this.defaultValue}}class de extends k{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,He=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:we,verticalSliderSize:i.clampedInt(me.verticalSliderSize,we,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends k{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Z,me){let He=!1;me.allowedCharacters&&Z&&(N.$1n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},He=!0)),me.allowedLocales&&Z&&(N.$1n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},He=!0));const we=super.applyUpdate(Z,me);return He?new u(we.newValue,!0):we}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:_(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const He={};for(const[we,ot]of Object.entries(Z))ot===!0&&(He[we]=!0);return He}}class z extends k{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class L extends k{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:p.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends k{constructor(){const Z={enabled:F.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Z.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Z.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Z.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:_(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(X,Z,me){const He=me.indexOf(X);return He===-1?Z:me[He]}class se extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Z.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Z.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Fe extends k{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends k{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&me.push(He)}catch{}return me}return this.defaultValue}}var Qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class _e extends k{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,He){return me.get(2)===2?0:He}}class et extends d{constructor(){super(146)}compute(Z,me,He){const we=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class tt extends k{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:b(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends k{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:b(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?ct:R.$k?ft:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new n(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:je(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:je(new $),accessibilityPageSize:je(new i(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:je(new n(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new n(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:je(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:je(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:je(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:je(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:je(new m(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:je(new n(13,"automaticLayout",!1)),autoSurround:je(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:je(new G),bracketPairGuides:je(new H),stickyTabStops:je(new n(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:je(new n(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:je(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:je(new n(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:je(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:je(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:je(new n(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:je(new h),contextmenu:je(new n(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new n(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:je(new m(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:je(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:je(new m(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(260,null)})),cursorSurroundingLines:je(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:je(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:je(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:je(new n(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new n(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new n(34,"domReadOnly",!1)),dragAndDrop:je(new n(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:je(new V),dropIntoEditor:je(new tt),stickyScroll:je(new Le),experimentalWhitespaceRendering:je(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new l(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:p.localize(271,null)})),find:je(new W),fixedOverflowWidgets:je(new n(42,"fixedOverflowWidgets",!1)),folding:je(new n(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:je(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:je(new n(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:je(new n(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:je(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new n(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:je(new j),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new ie),fontVariations:je(new A),formatOnPaste:je(new n(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:je(new n(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:je(new n(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:je(new ce),hideCursorInOverviewRuler:je(new n(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:je(new ve),inDiffEditor:je(new n(61,"inDiffEditor",!1)),letterSpacing:je(new l(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>l.clamp(X,-5,20),{description:p.localize(285,null)})),lightbulb:je(new Se),lineDecorationsWidth:je(new U),lineHeight:je(new x),lineNumbers:je(new he),lineNumbersMinChars:je(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new n(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:je(new n(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:je(new c(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:je(new be),mouseStyle:je(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new l(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:je(new n(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:je(new n(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:je(new m(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:je(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:je(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:je(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:je(new n(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:je(new i(83,"overviewRulerLanes",3,0,3)),padding:je(new Ee),pasteAs:je(new it),parameterHints:je(new $e),peekWidgetDefaultFocus:je(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:je(new n(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:je(new n(91,"readOnly",!1)),readOnlyMessage:je(new de),renameOnType:je(new n(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:je(new n(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:je(new c(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:je(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new n(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:je(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:je(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new n(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:je(new Ne),scrollbar:je(new Me),scrollBeyondLastColumn:je(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:je(new n(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:je(new n(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:je(new n(107,"selectionClipboard",!0,{description:p.localize(325,null),included:R.$k})),selectionHighlight:je(new n(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:je(new n(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:je(new n(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:je(new n(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:je(new ne),snippetSuggestions:je(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:je(new Fe),smoothScrolling:je(new n(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:je(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new se),inlineSuggest:je(new z),inlineEdit:je(new L),inlineCompletionsAccessibilityVerbose:je(new n(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:je(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new n(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:je(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:je(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:je(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new ze),unusualLineTerminators:je(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:je(new n(127,"useShadowDOM",!0)),useTabStops:je(new n(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:je(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new t(131,"wordSeparators",M.$Vs,{description:p.localize(359,null)})),wordWrap:je(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:je(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new n(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:je(new fe),tabFocusMode:je(new n(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:je(new ue),wrappingInfo:je(new et),wrappingIndent:je(new _e),wrappingStrategy:je(new pe)}}),define(Re[153],Ae([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[154],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[155],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Re[156],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[157],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[158],Ae([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Re[159],Ae([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Re[160],Ae([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Re[161],Ae([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[162],Ae([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Re[163],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[164],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[165],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[166],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[167],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Re[168],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[169],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[170],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[171],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[172],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[173],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[174],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[175],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[176],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Re[177],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Re[178],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Re[179],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Re[180],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[181],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[182],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[183],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[184],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[185],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[186],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[187],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[188],Ae([1,0,14,155]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var R;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(R||(e.TokenType=R={}));function F(...D){switch(D.length){case 1:return(0,N.localize)(0,null,D[0]);case 2:return(0,N.localize)(1,null,D[0],D[1]);case 3:return(0,N.localize)(2,null,D[0],D[1],D[2]);default:return}}const M=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const k=this.d,u=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:u};this.g.push({offset:k,lexeme:u,additionalInfo:T}),this.f.push(w)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const k=this.c.substring(this.d,this.e),u=g.b.get(k);u?this.k(u):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,k=!1,u=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(p);return}const d=this.c.charCodeAt(T);if(k)k=!1;else if(d===47&&!u){T++;break}else d===91?u=!0:d===92?k=!0:d===93&&(u=!1);T++}for(;T<this.c.length&&g.a.has(this.c.charCodeAt(T));)T++;this.e=T;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=g}),define(Re[189],Ae([1,0,23,33,157,301]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=g,e.$Bp=D,e.$Cp=T,e.$Dp=k,e.$Ep=u,e.$Fp=w,e.$Gp=d;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function g(n){return n=n.trim(),n==="*"||M.test(n)}function D(n){if(!g(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=n.match(M);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}function T(n){if(!n)return null;const r=n.majorBase,i=n.majorMustEqual,a=n.minorBase;let l=n.minorMustEqual;const t=n.patchBase;let b=n.patchMustEqual;n.hasCaret&&(r===0||(l=!1),b=!1);let c=0;if(n.preRelease){const m=p.exec(n.preRelease);if(m){const[,v,$,h]=m;c=Date.UTC(Number(v),Number($)-1,Number(h))}}return{majorBase:r,majorMustEqual:i,minorBase:a,minorMustEqual:l,patchBase:t,patchMustEqual:b,isMinimum:n.hasGreaterEquals,notBefore:c}}function k(n,r,i){let a;typeof n=="string"?a=T(D(n)):a=n;let l;r instanceof Date?l=r.getTime():typeof r=="string"&&(l=new Date(r).getTime());let t;if(typeof i=="string"?t=T(D(i)):t=i,!a||!t)return!1;const b=a.majorBase,c=a.minorBase,m=a.patchBase;let v=t.majorBase,$=t.minorBase,h=t.patchBase;const E=t.notBefore;let f=t.majorMustEqual,S=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?b>v?!0:b<v?!1:c>$?!0:c<$||l&&l<E?!1:m>=h:(b===1&&v===0&&(!f||!S||!y)&&(v=1,$=0,h=0,f=!0,S=!1,y=!1),b<v?!1:b>v?!f:c<$?!1:c>$?!S:m<h?!1:m>h?!y:!(l&&l<E))}function u(n,r,i,a,l){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([N.default.Error,R.localize(0,null)]),t;if(typeof a.name!="string")return t.push([N.default.Error,R.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([N.default.Error,R.localize(2,null,"version")]),t;if(!a.engines)return t.push([N.default.Error,R.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([N.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([N.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([N.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([N.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([N.default.Warning,R.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([N.default.Error,R.localize(9,null,"main")]),t;{const m=(0,I.$4g)(i,a.main);(0,I.$Xg)(m,i)||t.push([N.default.Warning,R.localize(10,null,m.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([N.default.Error,R.localize(11,null,"browser")]),t;{const m=(0,I.$4g)(i,a.browser);(0,I.$Xg)(m,i)||t.push([N.default.Warning,R.localize(12,null,m.path,i.path)])}}if(!F.valid(a.version))return t.push([N.default.Error,R.localize(13,null)]),t;const b=[];if(!w(n,r,a,l,b))for(const m of b)t.push([N.default.Error,m]);return t}function w(n,r,i,a,l){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:s(n,r,i.engines.vscode,l)}function d(n,r,i){return n==="*"||s(r,i,n)}function s(n,r,i,a=[]){const l=T(D(i));if(!l)return a.push(R.localize(14,null,i)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return a.push(R.localize(15,null,i)),!1}else if(!l.majorMustEqual)return a.push(R.localize(16,null,i)),!1;return k(n,r,l)?!0:(a.push(R.localize(17,null,n,i)),!1)}function o(n){if(!Array.isArray(n))return!1;for(let r=0,i=n.length;r<i;r++)if(typeof n[r]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class I{constructor(R,F=[],M=!1){this.ctor=R,this.staticArguments=F,this.supportsDelayedInstantiation=M}}e.$ni=I}),define(Re[55],Ae([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=F,e.$ps=M;const N=[];var R;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function F(p,g,D){g instanceof I.$ni||(g=new I.$ni(g,[],!!D)),N.push([p,g])}function M(){return N}}),define(Re[190],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class I{constructor(F,M){this.key=F,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=I;class N{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const M of this.a.values())M.outgoing.size===0&&F.push(M);return F}insertEdge(F,M){const p=this.lookupOrInsertNode(F),g=this.lookupOrInsertNode(M);p.outgoing.set(g.key,g),g.incoming.set(p.key,p)}removeNode(F){const M=this.b(F);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(F){const M=this.b(F);let p=this.a.get(M);return p||(p=new I(M,F),this.a.set(M,p)),p}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[M,p]of this.a)F.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,M]of this.a){const p=new Set([F]),g=this.c(M,p);if(g)return g}}c(F,M){for(const[p,g]of F.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const D=this.c(g,M);if(D)return D;M.delete(p)}}}e.$6q=N}),define(Re[3],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=R,e.$ri=F;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(I||(e._util=I={})),e.$pi=R("instantiationService");function N(M,p,g){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:M,index:g}):(p[I.DI_DEPENDENCIES]=[{id:M,index:g}],p[I.DI_TARGET]=p)}function R(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const p=function(g,D,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,g,T)};return p.toString=()=>M,I.serviceIds.set(M,p),p}function F(M){return M}}),define(Re[48],Ae([1,0,17,2,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=F,e.$Yi=M,e.$Zi=g,e.$1i=D,e.$2i=T,e.$3i=k,e.$4i=u,e.$5i=d,e.$6i=s,e.$7i=o,e.$Wi=(0,R.$qi)("configurationService");function F(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof N.URI)}function M(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof N.URI)}var p;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function g(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function D(n){return n.applicationValue!==void 0||n.userValue!==void 0||n.userLocalValue!==void 0||n.userRemoteValue!==void 0||n.workspaceValue!==void 0||n.workspaceFolderValue!==void 0}function T(n,r){const i=Object.create(null);for(const a in n)k(i,a,n[a],r);return i}function k(n,r,i,a){const l=r.split("."),t=l.pop();let b=n;for(let c=0;c<l.length;c++){const m=l[c];let v=b[m];switch(typeof v){case"undefined":v=b[m]=Object.create(null);break;case"object":if(v===null){a(`Ignoring ${r} as ${l.slice(0,c+1).join(".")} is null`);return}break;default:a(`Ignoring ${r} as ${l.slice(0,c+1).join(".")} is ${JSON.stringify(v)}`);return}b=v}if(typeof b=="object"&&b!==null)try{b[t]=i}catch{a(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(b)}`)}else a(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(b)}`)}function u(n,r){const i=r.split(".");w(n,i)}function w(n,r){const i=r.shift();if(r.length===0){delete n[i];return}if(Object.keys(n).indexOf(i)!==-1){const a=n[i];typeof a=="object"&&!Array.isArray(a)&&(w(a,r),Object.keys(a).length===0&&delete n[i])}}function d(n,r,i){function a(b,c){let m=b;for(const v of c){if(typeof m!="object"||m===null)return;m=m[v]}return m}const l=r.split("."),t=a(n,l);return typeof t>"u"?i:t}function s(n,r,i){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in n?I.$6f(n[a])&&I.$6f(r[a])?s(n[a],r[a],i):i&&(n[a]=r[a]):n[a]=r[a])})}function o(n){return n.replace(/[\[\]]/g,"")}}),define(Re[31],Ae([1,0,21,15,188,3,154,14]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=D,e.$pj=b,e.$qj=c,e.$Jj=re;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",I.$j),g.set("isLinux",I.$k),g.set("isWindows",I.$i),g.set("isWeb",I.$o),g.set("isMacNative",I.$j&&!I.$o),g.set("isEdge",I.$H),g.set("isFirefox",I.$F),g.set("isChrome",I.$E),g.set("isSafari",I.$G);function D(ne,U){if(g.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(ne,U)}const T=Object.prototype.hasOwnProperty;var k;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const u={regexParsingWithErrorRecovery:!0},w=(0,M.localize)(0,null),d=(0,M.localize)(1,null),s=(0,M.localize)(2,null),o=(0,M.localize)(3,null),n=(0,M.localize)(4,null),r=(0,M.localize)(5,null),i=(0,M.localize)(6,null),a=(0,M.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=u){this.k=U,this.d=new R.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const be=this.D(),Te=be.type===17?r:void 0;throw this.h.push({message:n,offset:be.offset,lexeme:R.$lj.getLexeme(be),additionalInfo:Te}),l.c}return x}catch(x){if(x!==l.c)throw x;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const x=this.o();U.push(x)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const x=this.s();U.push(x)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=U.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Ee=Te.lexeme,$e=Ee.lastIndexOf("/"),fe=$e===Ee.length-1?void 0:this.w(Ee.substring($e+1));let Q;try{Q=new RegExp(Ee.substring(1,$e),fe)}catch{throw this.B("REGEX",Te)}return j.create(x,Q)}switch(Te.type){case 10:case 19:{const Ee=[Te.lexeme];this.z();let $e=this.D(),fe=0;for(let Ne=0;Ne<Te.lexeme.length;Ne++)Te.lexeme.charCodeAt(Ne)===40?fe++:Te.lexeme.charCodeAt(Ne)===41&&fe--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Ne=0;Ne<$e.lexeme.length;Ne++)$e.lexeme.charCodeAt(Ne)===40?fe++:Te.lexeme.charCodeAt(Ne)===41&&fe--}if(fe<0)break;Ee.push(R.$lj.getLexeme($e)),this.z(),$e=this.D()}const Q=Ee.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let le;try{le=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Te)}return t.regex(x,le)}case 18:{const Ee=Te.lexeme;this.z();let $e=null;if(!(0,N.$3e)(Ee)){const fe=Ee.indexOf("/"),Q=Ee.lastIndexOf("/");if(fe!==Q&&fe>=0){const Y=Ee.slice(fe+1,Q),he=Ee[Q+1]==="i"?"i":"";try{$e=new RegExp(Y,he)}catch{throw this.B("REGEX",Te)}}}if($e===null)throw this.B("REGEX",Te);return j.create(x,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Te=this.u();return t.notIn(x,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(x,Te);switch(Te){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(x,Te);switch(Te){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Te)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:a}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,x){if(this.C(U))return this.z();throw this.B(x,this.D())}B(U,x,be){const Te=(0,M.localize)(8,null,U,R.$lj.getLexeme(x)),Ee=x.offset,$e=R.$lj.getLexeme(x);return this.h.push({message:Te,offset:Ee,lexeme:$e,additionalInfo:be}),l.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=l;class t{static false(){return v.INSTANCE}static true(){return $.INSTANCE}static has(U){return h.create(U)}static equals(U,x){return E.create(U,x)}static notEquals(U,x){return y.create(U,x)}static regex(U,x){return j.create(U,x)}static in(U,x){return f.create(U,x)}static notIn(U,x){return S.create(U,x)}static not(U){return C.create(U)}static and(...U){return ce.create(U,null,!0)}static or(...U){return ve.create(U,null,!0)}static greater(U,x){return V.create(U,x)}static greaterEquals(U,x){return W.create(U,x)}static smaller(U,x){return q.create(U,x)}static smallerEquals(U,x){return A.create(U,x)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$oj=t;function b(ne){const U=new l({regexParsingWithErrorRecovery:!1});return ne.map(x=>(U.parse(x),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function c(ne,U){const x=ne?ne.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!x&&!be?!0:!x||!be?!1:x.equals(be)}function m(ne,U){return ne.cmp(U)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return $.INSTANCE}}e.$rj=v;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return v.INSTANCE}}e.$sj=$;class h{static create(U,x=null){const be=g.get(U);return typeof be=="boolean"?be?$.INSTANCE:v.INSTANCE:new h(U,x)}constructor(U,x){this.key=U,this.c=x,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=g.get(this.key);return typeof U=="boolean"?U?$.INSTANCE:v.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$tj=h;class E{static create(U,x,be=null){if(typeof x=="boolean")return x?h.create(U,be):C.create(U,be);const Te=g.get(U);return typeof Te=="boolean"?x===(Te?"true":"false")?$.INSTANCE:v.INSTANCE:new E(U,x,be)}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=g.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?$.INSTANCE:v.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$uj=E;class f{static create(U,x){return new f(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(x)?x.includes(be):typeof be=="string"&&typeof x=="object"&&x!==null?T.call(x,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$vj=f;class S{static create(U,x){return new S(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=11,this.c=f.create(U,x)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=S;class y{static create(U,x,be=null){if(typeof x=="boolean")return x?C.create(U,be):h.create(U,be);const Te=g.get(U);return typeof Te=="boolean"?x===(Te?"true":"false")?v.INSTANCE:$.INSTANCE:new y(U,x,be)}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=g.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?v.INSTANCE:$.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$xj=y;class C{static create(U,x=null){const be=g.get(U);return typeof be=="boolean"?be?v.INSTANCE:$.INSTANCE:new C(U,x)}constructor(U,x){this.c=U,this.d=x,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=g.get(this.c);return typeof U=="boolean"?U?v.INSTANCE:$.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$yj=C;function P(ne,U){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?U(ne):v.INSTANCE}class V{static create(U,x,be=null){return P(x,Te=>new V(U,Te,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$zj=V;class W{static create(U,x,be=null){return P(x,Te=>new W(U,Te,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Aj=W;class q{static create(U,x,be=null){return P(x,Te=>new q(U,Te,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Bj=q;class A{static create(U,x,be=null){return P(x,Te=>new A(U,Te,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Cj=A;class j{static create(U,x){return new j(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const x=this.f?this.f.source:"",be=U.f?U.f.source:"";return x<be?-1:x>be?1:0}equals(U){if(U.type===this.type){const x=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&x===be}return!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Dj=j;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Ej=K;function ie(ne){let U=null;for(let x=0,be=ne.length;x<be;x++){const Te=ne[x].substituteConstants();if(ne[x]!==Te&&U===null){U=[];for(let Ee=0;Ee<x;Ee++)U[Ee]=ne[Ee]}U!==null&&(U[x]=Te)}return U===null?ne:U}class ce{static create(U,x,be){return ce.d(U,x,be)}constructor(U,x){this.expr=U,this.c=x,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Te=m(this.expr[x],U.expr[x]);if(Te!==0)return Te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:ce.create(U,this.c,!1)}evaluate(U){for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].evaluate(U))return!1;return!0}static d(U,x,be){const Te=[];let Ee=!1;for(const $e of U)if($e){if($e.type===1){Ee=!0;continue}if($e.type===0)return v.INSTANCE;if($e.type===6){Te.push(...$e.expr);continue}Te.push($e)}if(Te.length===0&&Ee)return $.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(m);for(let $e=1;$e<Te.length;$e++)Te[$e-1].equals(Te[$e])&&(Te.splice($e,1),$e--);if(Te.length===1)return Te[0];for(;Te.length>1;){const $e=Te[Te.length-1];if($e.type!==9)break;Te.pop();const fe=Te.pop(),Q=Te.length===0,Y=ve.create($e.expr.map(he=>ce.create([he,fe],null,be)),null,Q);Y&&(Te.push(Y),Te.sort(m))}if(Te.length===1)return Te[0];if(be){for(let $e=0;$e<Te.length;$e++)for(let fe=$e+1;fe<Te.length;fe++)if(Te[$e].negate().equals(Te[fe]))return v.INSTANCE;if(Te.length===1)return Te[0]}return new ce(Te,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ce(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());this.c=ve.create(U,this,!0)}return this.c}}e.$Fj=ce;class ve{static create(U,x,be){return ve.d(U,x,be)}constructor(U,x){this.expr=U,this.c=x,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Te=m(this.expr[x],U.expr[x]);if(Te!==0)return Te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:ve.create(U,this.c,!1)}evaluate(U){for(let x=0,be=this.expr.length;x<be;x++)if(this.expr[x].evaluate(U))return!0;return!1}static d(U,x,be){let Te=[],Ee=!1;if(U){for(let $e=0,fe=U.length;$e<fe;$e++){const Q=U[$e];if(Q){if(Q.type===0){Ee=!0;continue}if(Q.type===1)return $.INSTANCE;if(Q.type===9){Te=Te.concat(Q.expr);continue}Te.push(Q)}}if(Te.length===0&&Ee)return v.INSTANCE;Te.sort(m)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let $e=1;$e<Te.length;$e++)Te[$e-1].equals(Te[$e])&&(Te.splice($e,1),$e--);if(Te.length===1)return Te[0];if(be){for(let $e=0;$e<Te.length;$e++)for(let fe=$e+1;fe<Te.length;fe++)if(Te[$e].negate().equals(Te[fe]))return $.INSTANCE;if(Te.length===1)return Te[0]}return new ve(Te,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ve(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());for(;U.length>1;){const x=U.shift(),be=U.shift(),Te=[];for(const Ee of Le(x))for(const $e of Le(be))Te.push(ce.create([Ee,$e],null,!1));U.unshift(ve.create(Te,null,!1))}this.c=ve.create(U,this,!0)}return this.c}}e.$Gj=ve;class Ie extends h{static{this.d=[]}static all(){return Ie.d.values()}constructor(U,x,be){super(U,null),this.f=x,typeof be=="object"?Ie.d.push({...be,key:U}):be!==!0&&Ie.d.push({key:U,description:be,type:x!=null?typeof x:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return E.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Hj=Ie,e.$Ij=(0,F.$qi)("contextKeyService");function ue(ne,U){return ne<U?-1:ne>U?1:0}function pe(ne,U,x,be){return ne<x?-1:ne>x?1:U<be?-1:U>be?1:0}function re(ne,U){if(ne.type===0||U.type===1)return!0;if(ne.type===9)return U.type===9?Se(ne.expr,U.expr):!1;if(U.type===9){for(const x of U.expr)if(re(ne,x))return!0;return!1}if(ne.type===6){if(U.type===6)return Se(U.expr,ne.expr);for(const x of ne.expr)if(re(x,U))return!0;return!1}return ne.equals(U)}function Se(ne,U){let x=0,be=0;for(;x<ne.length&&be<U.length;){const Te=ne[x].cmp(U[be]);if(Te<0)return!1;Te===0&&x++,be++}return x===ne.length}function Le(ne){return ne.type===9?ne.expr:[ne]}}),define(Re[191],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,I.$qi)("environmentService"),e.$yi=(0,I.$ri)(e.$xi)}),define(Re[98],Ae([1,0,156,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=R,e.$Uo=F,e.$Vo=M,e.$Wo=p,e.$Xo=g,e.$Yo=D,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function F(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(i,a){return a==="web"&&!i.includes("web")}function g(i,a,l){return p(a,l)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===l}function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var k;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var d;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var s;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(a,l){super(a),this.code=l,this.name=l}}e.$1o=o;var n;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(n||(e.ExtensionGalleryErrorCode=n={}));class r extends Error{constructor(a,l){super(a),this.code=l,this.name=l}}e.$2o=r,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,I.localize2)(0,"Extensions"),e.$9o=(0,I.localize2)(1,"Preferences")}),define(Re[43],Ae([1,0,52,19,15,17,2,158,3,21,12,40]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=u,e.$Yk=s,e.$Zk=n,e.$1k=r,e.$2k=i,e.$3k=a,e.$4k=l,e.$5k=t,e.$6k=b,e.$7k=c,e.$8k=m,e.$0k=h,e.$$k=E,e.$_k=f,e.$al=S,e.$bl=y,e.$el=q,e.$ql=ve,e.$rl=Ie,e.$tl=pe,e.$Wk=(0,g.$qi)("fileService");function u(re){return re.create===!0}var w;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function s(re){const Se=re;return!!Se&&typeof Se.onDidChange=="function"}var o;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(re){return!!(re.capabilities&2)}function r(re){return!!(re.capabilities&8)}function i(re){return!!(re.capabilities&131072)}function a(re){return!!(re.capabilities&4)}function l(re){return!!(re.capabilities&16)}function t(re){return n(re)?!!(re.capabilities&16384):!1}function b(re){return n(re)?!!(re.capabilities&32768):!1}function c(re){return!!(re.capabilities&65536)}function m(re){return!!(re.capabilities&2048)}var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class $ extends Error{static create(Se,Le){const ne=new $(Se.toString(),Le);return f(ne,Le),ne}constructor(Se,Le){super(Se),this.code=Le}}e.$9k=$;function h(re,Se){return $.create(re,Se)}function E(re){return re||h((0,p.localize)(0,null),v.Unknown)}function f(re,Se){return re.name=Se?`${Se} (FileSystemError)`:"FileSystemError",re}function S(re){if(!re)return v.Unknown;if(re instanceof $)return re.code;const Se=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Se)return v.Unknown;switch(Se[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function y(re){if(re instanceof A)return re.fileOperationResult;switch(S(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var C;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class P{constructor(Se,Le,ne){this.resource=Se,this.operation=Le,this.target=ne}isOperation(Se){return this.operation===Se}}e.$cl=P;var V;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class W{static{this.a=null}constructor(Se,Le){this.c=Le,this.b=void 0,this.d=new k.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawAdded.map(U=>[U,!0])),ne}),this.f=new k.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawUpdated.map(U=>[U,!0])),ne}),this.g=new k.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawDeleted.map(U=>[U,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of Se){switch(ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}this.b!==W.a&&(typeof ne.cId=="number"?this.b===void 0?this.b=ne.cId:this.b!==ne.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Se,...Le){return this.h(Se,{includeChildren:!1},...Le)}affects(Se,...Le){return this.h(Se,{includeChildren:!0},...Le)}h(Se,Le,...ne){if(!Se)return!1;const U=ne.length>0;return!!((!U||ne.includes(1))&&(this.d.value.get(Se)||Le.includeChildren&&this.d.value.findSuperstr(Se))||(!U||ne.includes(0))&&(this.f.value.get(Se)||Le.includeChildren&&this.f.value.findSuperstr(Se))||(!U||ne.includes(2))&&(this.g.value.findSubstr(Se)||Le.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$dl=W;function q(re,Se,Le){return!re||!Se||re===Se||Se.length>re.length?!1:(Se.charAt(Se.length-1)!==N.sep&&(Se+=N.sep),Le?(0,R.$uf)(re,Se):re.indexOf(Se)===0)}class A extends Error{constructor(Se,Le,ne){super(Se),this.fileOperationResult=Le,this.options=ne}}e.$fl=A;class j extends A{constructor(Se,Le,ne,U){super(Se,Le,U),this.fileOperationResult=Le,this.size=ne}}e.$gl=j;class K extends A{constructor(Se,Le,ne){super(Se,2,ne),this.stat=Le}}e.$hl=K;var ie;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var ce;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$pl="";function ve(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function Ie(re,Se){if(!Se.hasProvider(M.URI.from({scheme:re.scheme})))return new Promise(Le=>{const ne=Se.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===re.scheme&&U.added&&(ne.dispose(),Le())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Se){return(0,F.$8f)(Se)||(Se=0),Se<ue.KB?(0,p.localize)(1,null,Se.toFixed(0)):Se<ue.MB?(0,p.localize)(2,null,(Se/ue.KB).toFixed(2)):Se<ue.GB?(0,p.localize)(3,null,(Se/ue.MB).toFixed(2)):Se<ue.TB?(0,p.localize)(4,null,(Se/ue.GB).toFixed(2)):(0,p.localize)(5,null,(Se/ue.TB).toFixed(2))}}e.$sl=ue;function pe(re){const Se=typeof re=="string"||re?.scheme===T.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===T.Schemas.file?1024*ue.MB:Se?10*ue.MB:D.$o?50*ue.MB:1024*ue.MB}}),define(Re[71],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class I{constructor(...R){this.a=new Map;for(const[F,M]of R)this.set(F,M)}set(R,F){const M=this.a.get(R);return this.a.set(R,F),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$oi=I}),define(Re[192],Ae([1,0,11,14,6,70,190,3,71,193]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const T=!1;class k extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new g.$oi,n=!1,r,i=T){this.i=o,this.j=n,this.k=r,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$pi,this),this._globalGraph=i?r?._globalGraph??new M.$6q(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const n=new class extends u{dispose(){this.h.delete(n),super.dispose()}}(o,this.j,this,this.l);return this.h.add(n),n}invokeFunction(o,...n){this.m();const r=d.traceInvocation(this.l,o);let i=!1;try{return o({get:l=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(l,r);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...n)}finally{i=!0,r.stop()}}createInstance(o,...n){this.m();let r,i;return o instanceof F.$ni?(r=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(n),r)):(r=d.traceCreation(this.l,o),i=this.o(o,n,r)),r.stop(),i}o(o,n=[],r){const i=p._util.getServiceDependencies(o).sort((t,b)=>t.index-b.index),a=[];for(const t of i){const b=this.s(t.id,r);b||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(b)}const l=i.length>0?i[0].index:n.length;if(n.length!==l){console.trace(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${n.length} static arguments`);const t=l-n.length;t>0?n=n.concat(new Array(t)):n=n.slice(0,l)}return Reflect.construct(o,n.concat(a))}q(o,n){if(this.i.get(o)instanceof F.$ni)this.i.set(o,n);else if(this.k)this.k.q(o,n);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const n=this.i.get(o);return!n&&this.k?this.k.r(o):n}s(o,n){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.r(o);return r instanceof F.$ni?this.u(o,r,n.branch(o,!0)):(n.branch(o,!1),r)}u(o,n,r){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,n,r)}finally{this.t.delete(o)}}v(o,n,r){const i=new M.$6q(t=>t.id.toString());let a=0;const l=[{id:o,desc:n,_trace:r}];for(;l.length;){const t=l.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new k(i);for(const b of p._util.getServiceDependencies(t.desc.ctor)){const c=this.r(b.id);if(c||this.y(`[createInstance] ${o} depends on ${b.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(b.id)),c instanceof F.$ni){const m={id:b.id,desc:c,_trace:t._trace.branch(b.id,!0)};i.insertEdge(t,m),l.push(m)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new k(i);break}for(const{data:b}of t){if(this.r(b.id)instanceof F.$ni){const m=this.w(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this.q(b.id,m)}i.removeNode(b)}}return this.r(o)}w(o,n,r=[],i,a){if(this.i.get(o)instanceof F.$ni)return this.x(o,n,r,i,a,this.g);if(this.k)return this.k.w(o,n,r,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}x(o,n,r=[],i,a,l){if(i){const t=new u(void 0,this.j,this,this.l);t.c=String(o);const b=new Map,c=new I.$Jh(()=>{const m=t.o(n,r,a);for(const[v,$]of b){const h=m[v];if(typeof h=="function")for(const E of $)E.disposable=h.apply(m,E.listener)}return b.clear(),l.add(m),m});return new Proxy(Object.create(null),{get(m,v){if(!c.isInitialized&&typeof v=="string"&&(v.startsWith("onDid")||v.startsWith("onWill"))){let E=b.get(v);return E||(E=new D.$5c,b.set(v,E)),(S,y,C)=>{if(c.isInitialized)return c.value[v](S,y,C);{const P={listener:[S,y,C],disposable:void 0},V=E.push(P);return(0,R.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if(v in m)return m[v];const $=c.value;let h=$[v];return typeof h!="function"||(h=h.bind($),m[v]=h),h},set(m,v,$){return c.value[v]=$,!0},getPrototypeOf(m){return n.prototype}})}else{const t=this.o(n,r,a);return l.add(t),t}}y(o,n){if(n&&console.warn(o),this.j)throw new Error(o)}}e.$7q=u;var w;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(w||(w={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,n){return o?new d(2,n.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,n){return o?new d(1,n.name):d.c}static{this.f=0}constructor(o,n){this.type=o,this.name=n,this.g=Date.now(),this.h=[]}branch(o,n){const r=new d(3,o.toString());return this.h.push([o,n,r]),r}stop(){const o=Date.now()-this.g;d.f+=o;let n=!1;function r(a,l){const t=[],b=new Array(a+1).join("	");for(const[c,m,v]of l.h)if(m&&v){n=!0,t.push(`${b}CREATES -> ${c}`);const $=r(a+1,v);$&&t.push($)}else t.push(`${b}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||n)&&d.all.add(i.join(`
`))}}e.$8q=d}),define(Re[13],Ae([1,0,159,42,5,99,6,28,21,23,17,2,31,3]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=s,e.log=n,e.$$j=h,e.$_j=E,e.$ak=f,e.$bk=S,e.$Wj=(0,w.$qi)("logService"),e.$Xj=(0,w.$qi)("loggerService");function d(){return new Date().toISOString()}function s(y){return(0,T.$8f)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Zj=o.Info;function n(y,C,P){switch(C){case o.Trace:y.trace(P);break;case o.Debug:y.debug(P);break;case o.Info:y.info(P);break;case o.Warning:y.warn(P);break;case o.Error:y.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function r(y,C=!1){let P="";for(let V=0;V<y.length;V++){let W=y[V];if(W instanceof Error&&(W=(0,N.$bj)(W,C)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new R.$be),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$2j=i;class a extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,r([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,r([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,r([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,r([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=C.stack,this.g(o.Error,r(V))}else this.g(o.Error,r([C,...P]))}flush(){}}e.$3j=a;class l extends i{constructor(C=e.$Zj){super(),this.setLevel(C),this.g=!g.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,C,...P):console.warn(`[main ${d()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,C,...P):console.error(`[main ${d()}]`,C,...P))}flush(){}}e.$4j=l;class t extends i{constructor(C=e.$Zj,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$5j=t;class b extends i{constructor(C,P=e.$Zj){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,N.$bj)(C,this.f(o.Trace))}flush(){}}e.$6j=b;class c extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const V of this.g)V.trace(C,...P)}debug(C,...P){for(const V of this.g)V.debug(C,...P)}info(C,...P){for(const V of this.g)V.info(C,...P)}warn(C,...P){for(const V of this.g)V.warn(C,...P)}error(C,...P){for(const V of this.g)V.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$7j=c;class m extends M.$Uc{constructor(C,P,V){if(super(),this.h=C,this.j=P,this.b=new p.$Bc,this.c=this.B(new R.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$be),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(C){return(0,T.$4f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const V=this.n(C),W=(0,T.$4f)(C)?C:P?.id??(0,F.$ej)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const A=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(V,A??this.getLogLevel(V)??this.h,{...P,id:W}));const j={logger:q,info:{resource:V,id:W,logLevel:A,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(j.info),this.b.set(V,j),q}n(C){return(0,T.$4f)(C)?(0,D.$4g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(k.URI.isUri(C)){const V=C,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=C;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const V=this.m(C);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=m;class v{constructor(){this.onDidChangeLogLevel=new R.$be().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$9j=v;class $ extends v{}e.$0j=$;function h(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=S(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Zj}function E(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ck=new u.$Hj("logLevel",E(o.Info))}),define(Re[194],Ae([1,0,6,13]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0;class R extends I.$Uc{constructor(M,p=[]){super(),this.a=new N.$7j([M,...p]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$yQ=R}),define(Re[100],Ae([1,0,33,160,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function D(d,s){return s-d}g.compare=D;const T=Object.create(null);T[g.Error]=(0,N.localize)(0,null),T[g.Warning]=(0,N.localize)(1,null),T[g.Info]=(0,N.localize)(2,null);function k(d){return T[d]||""}g.toString=k;function u(d){switch(d){case I.default.Error:return g.Error;case I.default.Warning:return g.Warning;case I.default.Info:return g.Info;case I.default.Ignore:return g.Hint}}g.fromSeverity=u;function w(d){switch(d){case g.Error:return I.default.Error;case g.Warning:return I.default.Warning;case g.Info:return I.default.Info;case g.Hint:return I.default.Ignore}}g.toSeverity=w}(M||(e.MarkerSeverity=M={}));var p;(function(g){const D="";function T(u){return k(u,!0)}g.makeKey=T;function k(u,w){const d=[D];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(D),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(D),u.severity!==void 0&&u.severity!==null?d.push(M.toString(u.severity)):d.push(D),u.message&&w?d.push(u.message.replace("\xA6","\\\xA6")):d.push(D),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(D),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(D),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(D),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(D),d.push(D),d.join("\xA6")}g.makeKeyOptionalMessage=k})(p||(e.IMarkerData=p={})),e.$Tt=(0,R.$qi)("markerService")}),define(Re[195],Ae([1,0,5,33,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=p,e.Severity=N.default,e.$Tv=(0,R.$qi)("notificationService");var F;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(k){if(k){const u=k;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var g;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class D{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Vv=D;class T{infinite(){}done(){}total(u){}worked(u){}}e.$Wv=T}),define(Re[196],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,I.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,N){var R=arguments.length,F=R<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ge,e,I,N);else for(var p=ge.length-1;p>=0;p--)(M=ge[p])&&(F=(R<3?M(F):R>3?M(e,I,F):M(e,I))||F);return R>3&&F&&Object.defineProperty(e,I,F),F},Ve=this&&this.__param||function(ge,e){return function(I,N){e(I,N,ge)}};define(Re[101],Ae([1,0,11,24,6,3]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,F.$qi)("progressService");var M;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Zv=p;class g{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const w=this.d;this.d=()=>{w?.(),u()}}):Promise.resolve()}}e.$1v=g;let D=class extends R.$Uc{constructor(u,w){super(),this.a=new I.$Nh,w.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$2v=D,e.$2v=D=Je([Ve(1,e.$Xv)],D);class T extends R.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new R.$Tc)}start(u){this.stop();const w=++this.a,d=new N.$me;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>d.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:d.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$3v=T,e.$4v=(0,F.$qi)("editorProgressService")}),define(Re[30],Ae([1,0,56,17]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class R{constructor(){this.a=new Map}add(M,p){I.ok(N.$4f(M)),I.ok(N.$6f(p)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new R}),define(Re[72],Ae([1,0,5,30]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class F{constructor(){this.b=new I.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,D){this.a[R(g)]=D,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new F;N.$9n.add(e.$0n.JSONContribution,M)}),define(Re[57],Ae([1,0,18,5,17,153,48,72,30]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=s,e.$no=o,e.$oo=n,e.$po=i,e.$qo=a;var D;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$bo={Configuration:"base.contributions.configuration"};var T;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const k=g.$9n.as(p.$0n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$io,this.g),this.v()}registerConfiguration(t,b=!0){this.registerConfigurations([t],b)}registerConfigurations(t,b=!0){const c=new Set;this.n(t,b,c),k.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const b=new Set;this.o(t,b),k.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:b})}updateConfigurations({add:t,remove:b}){const c=new Set;this.o(b,c),this.n(t,!1,c),k.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const b=new Set;this.k(t,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}k(t,b){const c=[];for(const{overrides:m,source:v}of t)for(const $ in m)if(b.add($),e.$lo.test($)){const h=this.a.get($),E=h?.valuesSources??new Map;if(v)for(const C of Object.keys(m[$]))E.set(C,v);const f={...h?.value||{},...m[$]};this.a.set($,{source:v,value:f,valuesSources:E});const S=(0,M.$7i)($),y={type:"object",default:f,description:F.localize(1,null,S),$ref:e.$io,defaultDefaultValue:f,source:R.$4f(v)?void 0:v,defaultValueSource:v};c.push(...s($)),this.d[$]=y,this.b.properties[$]=y}else{this.a.set($,{value:m[$],source:v});const h=this.d[$];h&&(this.w($,h),this.r($,h))}this.m(c)}deregisterDefaultConfigurations(t){const b=new Set;this.l(t,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}l(t,b){for(const{overrides:c,source:m}of t)for(const v in c){const $=this.a.get(v),h=R.$4f(m)?m:m?.id,E=R.$4f($?.source)?$?.source:$?.source?.id;if(h===E)if(b.add(v),this.a.delete(v),e.$lo.test(v))delete this.d[v],delete this.b.properties[v];else{const f=this.d[v];f&&(this.w(v,f),this.r(v,f))}}this.u()}deltaConfiguration(t){let b=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),b=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),b=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:b})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const b of t)this.h.add(b);this.u()}n(t,b,c){t.forEach(m=>{this.p(m,b,m.extensionInfo,m.restrictedProperties,void 0,c),this.c.push(m),this.q(m)})}o(t,b){const c=m=>{if(m.properties)for(const v in m.properties){b.add(v);const $=this.d[v];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[v],this.s(v,m.properties[v])}m.allOf?.forEach(v=>c(v))};for(const m of t){c(m);const v=this.c.indexOf(m);v!==-1&&this.c.splice(v,1)}}p(t,b=!0,c,m,v=3,$){v=R.$ag(t.scope)?v:t.scope;const h=t.properties;if(h)for(const f in h){const S=h[f];if(b&&i(f,S)){delete h[f];continue}if(S.source=c,S.defaultDefaultValue=h[f].default,this.w(f,S),e.$lo.test(f)?S.scope=void 0:(S.scope=R.$ag(S.scope)?v:S.scope,S.restricted=R.$ag(S.restricted)?!!m?.includes(f):S.restricted),h[f].hasOwnProperty("included")&&!h[f].included){this.f[f]=h[f],delete h[f];continue}else this.d[f]=h[f],h[f].policy?.name&&this.e.set(h[f].policy.name,f);!h[f].deprecationMessage&&h[f].markdownDeprecationMessage&&(h[f].deprecationMessage=h[f].markdownDeprecationMessage),$.add(f)}const E=t.allOf;if(E)for(const f of E)this.p(f,b,c,m,v,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const b=c=>{const m=c.properties;if(m)for(const $ in m)this.r($,m[$]);c.allOf?.forEach(b)};b(t)}r(t,b){switch(e.$co.properties[t]=b,b.scope){case 1:e.$do.properties[t]=b;break;case 2:e.$eo.properties[t]=b;break;case 6:e.$fo.properties[t]=b;break;case 3:e.$go.properties[t]=b;break;case 4:e.$ho.properties[t]=b;break;case 5:e.$ho.properties[t]=b,this.g.properties[t]=b;break}}s(t,b){switch(delete e.$co.properties[t],b.scope){case 1:delete e.$do.properties[t];break;case 2:delete e.$eo.properties[t];break;case 6:delete e.$fo.properties[t];break;case 3:delete e.$go.properties[t];break;case 4:case 5:delete e.$ho.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const b=`[${t}]`,c={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$io};this.w(b,c),e.$co.properties[b]=c,e.$do.properties[b]=c,e.$eo.properties[b]=c,e.$fo.properties[b]=c,e.$go.properties[b]=c,e.$ho.properties[b]=c}}v(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=t,e.$do.patternProperties[e.$ko]=t,e.$eo.patternProperties[e.$ko]=t,e.$fo.patternProperties[e.$ko]=t,e.$go.patternProperties[e.$ko]=t,e.$ho.patternProperties[e.$ko]=t,this.i.fire()}w(t,b){const c=this.a.get(t);let m=c?.value,v=c?.source;R.$$f(m)&&(m=b.defaultDefaultValue,v=void 0),R.$$f(m)&&(m=n(b.type)),b.default=m,b.defaultValueSource=v}}const w="\\[([^\\]]+)\\]",d=new RegExp(w,"g");e.$ko=`^(${w})+$`,e.$lo=new RegExp(e.$ko);function s(l){const t=[];if(e.$lo.test(l)){let b=d.exec(l);for(;b?.length;){const c=b[1].trim();c&&t.push(c),b=d.exec(l)}}return(0,I.$Mb)(t)}function o(l){return l.reduce((t,b)=>`${t}[${b}]`,"")}function n(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const r=new u;g.$9n.add(e.$bo.Configuration,r);function i(l,t){return l.trim()?e.$lo.test(l)?F.localize(7,null,l):r.getConfigurationProperties()[l]!==void 0?F.localize(8,null,l):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,l,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}function a(){const l=[],t=r.getConfigurationProperties();for(const b of Object.keys(t))l.push([b,t[b].scope]);return l.push(["launch",4]),l.push(["task",4]),l}}),define(Re[197],Ae([1,0,18,5,123,6,28,26,17,2,48,57,30]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=i;function w(b){return Object.isFrozen(b)?b:p.$Xn(b)}class d{static createEmptyModel(c){return new d({},[],[],void 0,c)}constructor(c,m,v,$,h){this.b=c,this.c=m,this.d=v,this.raw=$,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const c=this.raw.map(m=>{if(m instanceof d)return m;const v=new s("",this.f);return v.parseRaw(m),v.configurationModel});this.g=c.reduce((m,v)=>v===m?v:m.merge(v),c[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,T.$5i)(this.contents,c):this.contents}inspect(c,m){const v=this;return{get value(){return w(v.rawConfiguration.getValue(c))},get override(){return m?w(v.rawConfiguration.getOverrideValue(c,m)):void 0},get merged(){return w(m?v.rawConfiguration.override(m).getValue(c):v.rawConfiguration.getValue(c))},get overrides(){const $=[];for(const{contents:h,identifiers:E,keys:f}of v.rawConfiguration.overrides){const S=new d(h,f,[],void 0,v.f).getValue(c);S!==void 0&&$.push({identifiers:E,value:S})}return $.length?w($):void 0}}}getOverrideValue(c,m){const v=this.j(m);return v?c?(0,T.$5i)(v,c):v:void 0}getKeysForOverrideIdentifier(c){const m=[];for(const v of this.overrides)v.identifiers.includes(c)&&m.push(...v.keys);return I.$Mb(m)}getAllOverrideIdentifiers(){const c=[];for(const m of this.overrides)c.push(...m.identifiers);return I.$Mb(c)}override(c){let m=this.a.get(c);return m||(m=this.h(c),this.a.set(c,m)),m}merge(...c){const m=p.$Wn(this.contents),v=p.$Wn(this.overrides),$=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const E of c)if(h.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.i(m,E.contents);for(const f of E.overrides){const[S]=v.filter(y=>I.$ub(y.identifiers,f.identifiers));S?(this.i(S.contents,f.contents),S.keys.push(...f.keys),S.keys=I.$Mb(S.keys)):v.push(p.$Wn(f))}for(const f of E.keys)$.indexOf(f)===-1&&$.push(f)}return new d(m,$,v,h.every(E=>E instanceof d)?void 0:h,this.f)}h(c){const m=this.j(c);if(!m||typeof m!="object"||!Object.keys(m).length)return this;const v={};for(const $ of I.$Mb([...Object.keys(this.contents),...Object.keys(m)])){let h=this.contents[$];const E=m[$];E&&(typeof h=="object"&&typeof E=="object"?(h=p.$Wn(h),this.i(h,E)):h=E),v[$]=h}return new d(v,this.keys,this.overrides,void 0,this.f)}i(c,m){for(const v of Object.keys(m)){if(v in c&&g.$6f(c[v])&&g.$6f(m[v])){this.i(c[v],m[v]);continue}c[v]=p.$Wn(m[v])}}j(c){let m=null,v=null;const $=h=>{h&&(v?this.i(v,h):v=p.$Wn(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===c?m=h.contents:h.identifiers.includes(c)&&$(h.contents);return $(m),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,m){this.k(c,m,!0)}setValue(c,m){this.k(c,m,!1)}removeValue(c){const m=this.keys.indexOf(c);m!==-1&&(this.keys.splice(m,1),(0,T.$4i)(this.contents,c),k.$lo.test(c)&&this.overrides.splice(this.overrides.findIndex(v=>I.$ub(v.identifiers,(0,k.$mo)(c))),1))}k(c,m,v){(0,T.$3i)(this.contents,c,m,$=>this.f.error($)),v=v||this.keys.indexOf(c)===-1,v&&this.keys.push(c),k.$lo.test(c)&&this.overrides.push({identifiers:(0,k.$mo)(c),keys:Object.keys(this.contents[c]),contents:(0,T.$2i)(this.contents[c],$=>this.f.error($))})}}e.$ro=d;class s{constructor(c,m){this.f=c,this.g=m,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,m){if(!g.$ag(c)){const v=this.h(c);this.parseRaw(v,m)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,m){this.a=c;const{contents:v,keys:$,overrides:h,restricted:E,hasExcludedProperties:f}=this.i(c,m);this.b=new d(v,$,h,f?[c]:void 0,this.g),this.c=E||[]}h(c){let m={},v=null,$=[];const h=[],E=[];function f(y){Array.isArray($)?$.push(y):v!==null&&($[v]=y)}const S={onObjectBegin:()=>{const y={};f(y),h.push($),$=y,v=null},onObjectProperty:y=>{v=y},onObjectEnd:()=>{$=h.pop()},onArrayBegin:()=>{const y=[];f(y),h.push($),$=y,v=null},onArrayEnd:()=>{$=h.pop()},onLiteralValue:f,onError:(y,C,P)=>{E.push({error:y,offset:C,length:P})}};if(c)try{R.$Kn(c,S),m=$[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return m}i(c,m){const v=u.$9n.as(k.$bo.Configuration).getConfigurationProperties(),$=this.j(c,v,!0,m);c=$.raw;const h=(0,T.$2i)(c,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`)),E=Object.keys(c),f=this.l(c,S=>this.g.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:h,keys:E,overrides:f,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}j(c,m,v,$){let h=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:h};const E={},f=[];for(const S in c)if(k.$lo.test(S)&&v){const y=this.j(c[S],m,!1,$);E[S]=y.raw,h=h||y.hasExcludedProperties,f.push(...y.restricted)}else{const y=m[S],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&f.push(S),!$.exclude?.includes(S)&&($.include?.includes(S)||(C===void 0||$.scopes===void 0||$.scopes.includes(C))&&!($.skipRestricted&&y?.restricted))?E[S]=c[S]:h=!0}return{raw:E,restricted:f,hasExcludedProperties:h}}l(c,m){const v=[];for(const $ of Object.keys(c))if(k.$lo.test($)){const h={};for(const E in c[$])h[E]=c[$][E];v.push({identifiers:(0,k.$mo)($),keys:Object.keys(h),contents:(0,T.$2i)(h,m)})}return v}}e.$so=s;class o extends F.$Uc{constructor(c,m,v,$,h){super(),this.c=c,this.f=m,this.g=$,this.h=h,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),h),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&v.isEqual(E.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=o;class n{constructor(c,m,v,$,h,E,f,S,y,C,P,V,W){this.a=c,this.b=m,this.c=v,this.overrideIdentifiers=$,this.d=h,this.f=E,this.g=f,this.h=S,this.i=y,this.j=C,this.k=P,this.l=V,this.m=W}get value(){return w(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class r{constructor(c,m,v,$,h,E,f,S,y,C){this.j=c,this.l=m,this.m=v,this.n=$,this.p=h,this.q=E,this.r=f,this.s=S,this.t=y,this.u=C,this.h=null,this.i=new M.$Bc,this.v=null}getValue(c,m,v){return this.w(c,m,v).getValue(c)}updateValue(c,m,v={}){let $;v.resource?($=this.t.get(v.resource),$||($=d.createEmptyModel(this.u),this.t.set(v.resource,$))):$=this.s,m===void 0?$.removeValue(c):$.setValue(c,m),v.resource||(this.h=null)}inspect(c,m,v){const $=this.w(c,m,v),h=this.A(m.resource,v),E=m.resource?this.t.get(m.resource)||this.s:this.s,f=new Set;for(const S of $.overrides)for(const y of S.identifiers)$.getOverrideValue(c,y)!==void 0&&f.add(y);return new n(c,m,$.getValue(c),f.size?[...f]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.q:void 0,h||void 0,E)}keys(c){const m=this.A(void 0,c);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:m?m.keys.slice(0):[]}}updateDefaultConfiguration(c){this.j=c,this.h=null,this.i.clear()}updatePolicyConfiguration(c){this.l=c}updateApplicationConfiguration(c){this.m=c,this.h=null,this.i.clear()}updateLocalUserConfiguration(c){this.n=c,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(c){this.p=c,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(c){this.q=c,this.h=null,this.i.clear()}updateFolderConfiguration(c,m){this.r.set(c,m),this.i.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.i.delete(c)}compareAndUpdateDefaultConfiguration(c,m){const v=[];if(!m){const{added:$,updated:h,removed:E}=l(this.j,c);m=[...$,...h,...E]}for(const $ of m)for(const h of(0,k.$mo)($)){const E=this.j.getKeysForOverrideIdentifier(h),f=c.getKeysForOverrideIdentifier(h),S=[...f.filter(y=>E.indexOf(y)===-1),...E.filter(y=>f.indexOf(y)===-1),...E.filter(y=>!p.$1n(this.j.override(h).getValue(y),c.override(h).getValue(y)))];v.push([h,S])}return this.updateDefaultConfiguration(c),{keys:m,overrides:v}}compareAndUpdatePolicyConfiguration(c){const{added:m,updated:v,removed:$}=l(this.l,c),h=[...m,...v,...$];return h.length&&this.updatePolicyConfiguration(c),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:m,updated:v,removed:$,overrides:h}=l(this.applicationConfiguration,c),E=[...m,...v,...$];return E.length&&this.updateApplicationConfiguration(c),{keys:E,overrides:h}}compareAndUpdateLocalUserConfiguration(c){const{added:m,updated:v,removed:$,overrides:h}=l(this.localUserConfiguration,c),E=[...m,...v,...$];return E.length&&this.updateLocalUserConfiguration(c),{keys:E,overrides:h}}compareAndUpdateRemoteUserConfiguration(c){const{added:m,updated:v,removed:$,overrides:h}=l(this.remoteUserConfiguration,c),E=[...m,...v,...$];return E.length&&this.updateRemoteUserConfiguration(c),{keys:E,overrides:h}}compareAndUpdateWorkspaceConfiguration(c){const{added:m,updated:v,removed:$,overrides:h}=l(this.workspaceConfiguration,c),E=[...m,...v,...$];return E.length&&this.updateWorkspaceConfiguration(c),{keys:E,overrides:h}}compareAndUpdateFolderConfiguration(c,m){const v=this.folderConfigurations.get(c),{added:$,updated:h,removed:E,overrides:f}=l(v,m),S=[...$,...h,...E];return(S.length||!v)&&this.updateFolderConfiguration(c,m),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(c){const m=this.folderConfigurations.get(c);if(!m)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:v,updated:$,removed:h,overrides:E}=l(m,void 0);return{keys:[...v,...$,...h],overrides:E}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(c,m,v){let $=this.x(m,v);return m.overrideIdentifier&&($=$.override(m.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(c)!==void 0&&($=$.merge(this.l)),$}x({resource:c},m){let v=this.y();if(m&&c){const $=m.getFolder(c);$&&(v=this.z($.uri)||v);const h=this.t.get(c);h&&(v=v.merge(h))}return v}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(c){let m=this.i.get(c);if(!m){const v=this.y(),$=this.r.get(c);$?(m=v.merge($),this.i.set(c,m)):m=v}return m}A(c,m){if(m&&c){const v=m.getFolder(c);if(v)return this.r.get(v.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((c,m)=>{const{contents:v,overrides:$,keys:h}=this.r.get(m);return c.push([m,{contents:v,overrides:$,keys:h}]),c},[])}}allKeys(){const c=new Set;return this.j.keys.forEach(m=>c.add(m)),this.userConfiguration.keys.forEach(m=>c.add(m)),this.q.keys.forEach(m=>c.add(m)),this.r.forEach(m=>m.keys.forEach(v=>c.add(v))),[...c.values()]}B(){const c=new Set;return this.j.getAllOverrideIdentifiers().forEach(m=>c.add(m)),this.userConfiguration.getAllOverrideIdentifiers().forEach(m=>c.add(m)),this.q.getAllOverrideIdentifiers().forEach(m=>c.add(m)),this.r.forEach(m=>m.getAllOverrideIdentifiers().forEach(v=>c.add(v))),[...c.values()]}D(c){const m=new Set;return this.j.getKeysForOverrideIdentifier(c).forEach(v=>m.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(v=>m.add(v)),this.q.getKeysForOverrideIdentifier(c).forEach(v=>m.add(v)),this.r.forEach(v=>v.getKeysForOverrideIdentifier(c).forEach($=>m.add($))),[...m.values()]}static parse(c,m){const v=this.E(c.defaults,m),$=this.E(c.policy,m),h=this.E(c.application,m),E=this.E(c.user,m),f=this.E(c.workspace,m),S=c.folders.reduce((y,C)=>(y.set(D.URI.revive(C[0]),this.E(C[1],m)),y),new M.$Bc);return new r(v,$,h,E,d.createEmptyModel(m),f,S,d.createEmptyModel(m),new M.$Bc,m)}static E(c,m){return new d(c.contents,c.keys,c.overrides,void 0,m)}}e.$uo=r;function i(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const c=new Set,m=new Map;for(const $ of b)$.keys.forEach(h=>c.add(h)),$.overrides.forEach(([h,E])=>{const f=(0,M.$yc)(m,h,new Set);E.forEach(S=>f.add(S))});const v=[];return m.forEach(($,h)=>v.push([h,[...$.values()]])),{keys:[...c.values()],overrides:v}}class a{constructor(c,m,v,$,h){this.change=c,this.f=m,this.g=v,this.h=$,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const E of c.keys)this.affectedKeys.add(E);for(const[,E]of c.overrides)for(const f of E)this.affectedKeys.add(f);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=r.parse(this.f.data,this.i)),this.j}affectsConfiguration(c,m){const v=this.a+c,$=this.d.indexOf(v);if($<0)return!1;const h=$+v.length;if(h>=this.d.length)return!1;const E=this.d.charCodeAt(h);if(E!==this.b&&E!==this.c)return!1;if(m){const f=this.previousConfiguration?this.previousConfiguration.getValue(c,m,this.f?.workspace):void 0,S=this.g.getValue(c,m,this.h);return!p.$1n(f,S)}return!0}}e.$wo=a;function l(b,c){const{added:m,removed:v,updated:$}=t(c?.rawConfiguration,b?.rawConfiguration),h=[],E=b?.getAllOverrideIdentifiers()||[],f=c?.getAllOverrideIdentifiers()||[];if(c){const S=f.filter(y=>!E.includes(y));for(const y of S)h.push([y,c.getKeysForOverrideIdentifier(y)])}if(b){const S=E.filter(y=>!f.includes(y));for(const y of S)h.push([y,b.getKeysForOverrideIdentifier(y)])}if(c&&b){for(const S of E)if(f.includes(S)){const y=t({contents:b.getOverrideValue(void 0,S)||{},keys:b.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});h.push([S,[...y.added,...y.removed,...y.updated]])}}return{added:m,removed:v,updated:$,overrides:h}}function t(b,c){const m=b?c?b.keys.filter(h=>c.keys.indexOf(h)===-1):[...b.keys]:[],v=c?b?c.keys.filter(h=>b.keys.indexOf(h)===-1):[...c.keys]:[],$=[];if(b&&c){for(const h of c.keys)if(b.keys.indexOf(h)!==-1){const E=(0,T.$5i)(c.contents,h),f=(0,T.$5i)(b.contents,h);p.$1n(E,f)||$.push(h)}}return{added:m,removed:v,updated:$}}}),define(Re[102],Ae([1,0,14,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=D,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var R;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class F{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=F;class M{constructor(k,u){this.host=k,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class g extends I.$bb{static isNotAvailable(k){return k instanceof g&&k._code===p.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===p.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===p.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===p.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,u=p.Unknown,w){super(k),this._message=k,this._code=u,this._detail=w,this.isHandled=u===p.NotAvailable&&w===!0,Object.setPrototypeOf(this,g.prototype)}}e.$El=g;function D(T){const k=T.indexOf("+");return k===-1?T:T.substring(0,k)}}),define(Re[58],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=R,e.$Dm=F,e.$Em=M;function N(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}function R(g){if(!g)return;const D=g.indexOf("+");return D<0?g:g.substr(0,D)}function F(g){const{host:D,port:T}=p(g);if(typeof T>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:D,port:T}}function M(g,D){let{host:T,port:k}=p(g);return typeof k>"u"&&(k=D),{host:T,port:k}}function p(g){const D=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const T=g.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const k=g.match(/(.*):(\d+)$/);return k?{host:k[1],port:parseInt(k[2],10)}:{host:g,port:void 0}}}),define(Re[20],Ae([1,0,15,3,58]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=F,e.$Om=k,e.$Pm=u,e.$Qm=w,e.$Rm=d,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function F(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,n){if(typeof o>"u"||o===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof o=="string"||typeof n=="string"){const r=typeof o=="string"?o:o.value,i=typeof n=="string"?n:n.value;return I.$tf(r,i)}return o._lower===n._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Lm=g;class D{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const n of o)this.add(n)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$Mm=D;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,n){this.c.set(g.toKey(o),n)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=T;function k(s){return u(s)}function u(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function w(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function d(s,o){if(o){const n=`onResolveRemoteAuthority:${(0,R.$Cm)(o)}`;return!!s.activationEvents?.includes(n)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(Re[103],Ae([1,0,14,20]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const g of M){const D=this.readActivationEvents(g);D.length>0&&(p[N.$Lm.toKey(g.identifier)]=D)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<p.length;g++)p[g]==="onUri"&&(p[g]=`onUri:${N.$Lm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const g in M.contributes){const D=this.a.get(g);if(!D)continue;const T=M.contributes[g],k=Array.isArray(T)?T:[T];try{D(k,p)}catch(u){(0,I.$1)(u)}}return p}}e.$cG=R,e.$dG=new R}),define(Re[198],Ae([1,0,21,73,35]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=p;function F(g){if(I.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,D,T,k,u,w,d,s,o){const n=Object.create(null);n["common.machineId"]=w,n["common.sqmId"]=d,n.sessionID=(0,R.$Mg)()+Date.now(),n.commitHash=k,n.version=u,n["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,I.$h)(I.$u),n["common.nodePlatform"]=N.$ec,n["common.nodeArch"]=T,n["common.product"]=o||"desktop",s&&(n["common.msftInternal"]=s);let r=0;const i=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),I.$l&&(n["common.snap"]="true");const a=F(D);return a&&(n["common.platformDetail"]=a),n}function p(g){const D=N.env.USERDNSDOMAIN;if(!D)return!1;const T=D.toLowerCase();return g.some(k=>T===k)}}),define(Re[199],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,I.$qi)("telemetryService"),e.$Wl=(0,I.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var R;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Re[59],Ae([1,0,26,17,58,198,199]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=T,e.$hp=k,e.$ip=u,e.$jp=w,e.$kp=s,e.$lp=n,e.$mp=r,e.$np=l;class p{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$_o=p;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=g,e.$bp=new g;class D{async publicLog(b,c,m){}async publicLogError(b,c,m){}}e.$cp=D,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!t.enableTelemetry)}function k(t,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const b=t.getValue(M.$4l),c=t.getValue(M.$5l);if(t.getValue(M.$6l)===!1||c===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const b={},c={},m={};o(t,m);for(let v in m){v=v.length>150?v.substr(v.length-149):v;const $=m[v];typeof $=="number"?c[v]=$:typeof $=="boolean"?c[v]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${$.length}`),b[v]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(b[v]=$)}return{properties:b,measurements:c}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const b=(0,R.$Cm)(t);return d.has(b)?b:"other"}function o(t,b,c=0,m){if(t)for(const v of Object.getOwnPropertyNames(t)){const $=t[v],h=m?m+v:v;Array.isArray($)?b[h]=(0,I.$2n)($):$ instanceof Date?b[h]=$.toISOString():(0,N.$6f)($)?c<2?o($,b,c+1,h+"."):b[h]=(0,I.$2n)($):b[h]=$}}function n(t,b){const c=t.msftInternalDomains||[],m=b.getValue("telemetry.internalTesting");return(0,F.$$o)(c)||m}function r(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,b){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const m=[];for(const E of b)for(;;){const f=E.exec(t);if(!f)break;m.push([f.index,E.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(c="";;){const E=$.exec(t);if(!E)break;const f=m.some(([S,y])=>E.index<y&&S<$.lastIndex);!v.test(E[0])&&!f&&(c+=t.substring(h,E.index)+"<REDACTED: user-file-path>",h=$.lastIndex)}return h<t.length&&(c+=t.substr(h)),c}function a(t){if(!t)return t;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of b)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function l(t,b){return(0,I.$Yn)(t,c=>{if(c instanceof p||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let m=c.replaceAll("%20"," ");m=i(m,b);for(const v of b)m=m.replace(v,"");return m=a(m),m}})}}),define(Re[200],Ae([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=T,e.$qp=d,e.$rp=s,e.$sp=o,e.$tp=n,e.$up=r,e.$vp=i,e.$wp=a,e.$yp=l,e.$zp=b;function T(c,m){return c.uuid&&m.uuid?c.uuid===m.uuid:c.id===m.id?!0:(0,I.$of)(c.id,m.id)===0}const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(m){const v=m.manifest?m.manifest.version:m.version,$=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new u(m.identifier,v,$)}static parse(m){const v=k.exec(m);return v&&v[1]&&v[2]?new u({id:v[1]},v[2],v[4]||void 0):null}constructor(m,v,$="undefined"){this.version=v,this.targetPlatform=$,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof u?T(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$pp=u;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(c){const m=w.exec(c);return m&&m[1]?[o(m[1]),m[2]]:[o(c),void 0]}function s(c,m){return`${c}.${m}`}function o(c){return c.toLowerCase()}function n(c,m){return o(s(c??R.$Hm,m))}function r(c,m){const v=[],$=h=>{for(const E of v)if(E.some(f=>T(m(f),m(h))))return E;return null};for(const h of c){const E=$(h);E?E.push(h):v.push([h])}return v}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new D.$_o(c.identifier.id),name:new D.$_o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$xp=new R.$Lm("pprice.better-merge");function l(c,m){const v=[],$=m.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const h=$.shift();if(h&&v.every(E=>!T(E.identifier,{id:h}))){const E=c.filter(f=>T(f.identifier,{id:h}));E.length===1&&(v.push(E[0]),$.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}async function t(c,m){if(!F.$k)return!1;let v;try{v=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){m.debug("Error while getting the os-release file.",(0,p.$0)(h))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function b(c,m){const v=await t(c,m),$=(0,N.$Vo)(v?"alpine":F.$u,g.$fc);return m.debug("ComputeTargetPlatform:",$),$}}),define(Re[201],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=I,e.$ds=N,e.$es=R,e.$fs=F,e.$gs=M,e.$hs=p;function I(g){return[...g.entries()]}function N(g){return g?[...g.entries()]:[]}function R(g){return new Map(g)}function F(g){return new Map(g??[])}function M(g){return Array.from(g.entries()).map(D=>[D[0],I(D[1].map),N(D[1].descriptionMap)])}function p(g){return new Map(g.map(D=>[D[0],{map:R(D[1]),descriptionMap:F(D[2])}]))}}),define(Re[202],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsb=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,F,M=5){const p=F(g=>{const D=typeof g=="string"?g:g.data;let T=this.a.get(R);if(T){T.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(R),M);T={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(R),p.dispose()}},this.a.set(R,T)});return p}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const F=this.a.get(R);F&&(this.a.delete(R),this.b(R,F.data.join("")))}}e.$Fsb=I}),define(Re[203],Ae([1,0,11,91,302,41,5,17,2,161,72,30]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0w=e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.IconFontDefinition=e.IconContribution=e.$2w=void 0,e.$3w=o,e.$4w=n,e.$2w={IconContribution:"base.contributions.icons"};var u;(function(l){function t(b,c){let m=b.defaults;for(;F.ThemeIcon.isThemeIcon(m);){const v=s.getIcon(m.id);if(!v)return;m=v.defaults}return m}l.getDefinition=t})(u||(e.IconContribution=u={}));var w;(function(l){function t(c){return{weight:c.weight,style:c.style,src:c.src.map(m=>({format:m.format,location:m.location.toString()}))}}l.toJSONObject=t;function b(c){const m=v=>(0,p.$4f)(v)?v:void 0;if(c&&Array.isArray(c.src)&&c.src.every(v=>(0,p.$4f)(v.format)&&(0,p.$4f)(v.location)))return{weight:m(c.weight),style:m(c.style),src:c.src.map(v=>({format:v.format,location:g.URI.parse(v.location)}))}}l.fromJSONObject=b})(w||(e.IconFontDefinition=w={}));class d{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,b,c,m){const v=this.b[t];if(v){if(c&&!v.description){v.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const E=this.e.enum.indexOf(t);E!==-1&&(this.e.enumDescriptions[E]=c),this.a.fire()}return v}const $={id:t,description:c,defaults:b,deprecationMessage:m};this.b[t]=$;const h={$ref:"#/definitions/icons"};return m&&(h.deprecationMessage=m),c&&(h.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=h,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const b=this.e.enum.indexOf(t);b!==-1&&(this.e.enum.splice(b,1),this.e.enumDescriptions.splice(b,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,b){const c=this.f[t];return c||(this.f[t]=b,this.a.fire(),b)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(v,$)=>v.id.localeCompare($.id),b=v=>{for(;F.ThemeIcon.isThemeIcon(v.defaults);)v=this.b[v.defaults.id];return`codicon codicon-${v?v.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map(v=>this.b[v]);for(const v of m.filter($=>!!$.description).sort(t))c.push(`|<i class="${b(v)}"></i>|${v.id}|${F.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const v of m.filter($=>!F.ThemeIcon.isThemeIcon($.defaults)).sort(t))c.push(`|<i class="${b(v)}"></i>|${v.id}|`);return c.join(`
`)}}const s=new d;k.$9n.add(e.$2w.IconContribution,s);function o(l,t,b,c){return s.registerIcon(l,t,b,c)}function n(){return s}function r(){const l=(0,R.$Lj)();for(const t in l){const b="\\"+l[t].toString(16);s.registerIcon(t,{fontCharacter:b})}}r(),e.$5w="vscode://schemas/icons";const i=k.$9n.as(T.$0n.JSONContribution);i.registerSchema(e.$5w,s.getIconSchema());const a=new I.$Ch(()=>i.notifySchemaChanged(e.$5w),200);s.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$6w=o("widget-close",N.$Pj.close,(0,D.localize)(2,null)),e.$7w=o("goto-previous-location",N.$Pj.arrowUp,(0,D.localize)(3,null)),e.$8w=o("goto-next-location",N.$Pj.arrowDown,(0,D.localize)(4,null)),e.$9w=F.ThemeIcon.modify(N.$Pj.sync,"spin"),e.$0w=F.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(Re[204],Ae([1,0,5,2,48,3,13]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=D,e.$8v=k,e.$9v=u,e.$$v=w,e.$aw=d,e.$bw=s,e.$5v=(0,F.$qi)("tunnelService"),e.$6v=(0,F.$qi)("sharedTunnelsService");var p;(function(r){r.Http="http",r.Https="https"})(p||(e.TunnelProtocol=p={}));var g;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(g||(e.TunnelPrivacyId=g={}));function D(r){return!!r.forwardPort}var T;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function k(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}function u(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const i=r.query.split("&");for(const a of i){const l=a.split("=")[1];if(/^https?:/.exec(l)){const t=k(N.URI.parse(l));if(t)return t}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(r){return e.$0v.indexOf(r)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(r){return e.$_v.indexOf(r)>=0}function s(r,i,a,l){if(a===1)return!1;if(a===2&&d(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(t?.length===4&&parseInt(t[1])>=18)return!1}return r<1024}class o{constructor(i,a,l){this.remoteAddress=i,this.localAddress=a,this.b=l,this.a=new I.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=o;let n=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$be,this.onTunnelOpened=this.a.event,this.b=new I.$be,this.onTunnelClosed=this.b.event,this.c=new I.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const l of a){const t=Array.from(l.values());for(const b of t){const c=await b.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(l=>typeof l!="string"?l?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,l,t,b){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:l,privacy:t,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(d(i)||w(i))&&(i=e.$0v[0]);const l=this.s(i,a);if(l)return++l.refcount,l.value}openTunnel(i,a,l,t,b,c=!1,m,v){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${l} on local port ${b}.`);const $=this.f??i;if(!$)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(l)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.t($,a,l,t,b,c,m,v);return h?h.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,l),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,l);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(E);return(E.tunnelRemoteHost!==a||E.tunnelRemotePort!==l)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),m&&E.privacy!==m&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const l=a.get(i.tunnelRemotePort);l&&(l.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,l))}}}}async p(i,a,l){if(l.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=l.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const l=this.e.get(i);if(l&&l.has(a)){const t=l.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,l){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:l})}async r(i,a){const l=this.e.get(i);if(l){const t=l.get(a),b=t?await t.value:void 0;(!b||typeof b=="string")&&l.delete(a),l.size===0&&this.e.delete(i)}}s(i,a){const l=[i];w(i)?(l.push(...e.$0v),l.push(...e.$_v)):d(i)&&l.push(...e.$_v);const t=l.map(b=>this.e.get(b));for(const b of t){const c=b?.get(a);if(c)return c}}canTunnel(i){return!!k(i)}u(i,a,l,t,b,c,m){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${l} on local port ${t}.`);const v=l;this.j.add(v);const $=t===void 0?l:t,h={elevationRequired:b?this.isPortPrivileged($):!1},E={remoteAddress:{host:a,port:l},localAddressPort:t,privacy:c,public:c?c!==g.Private:void 0,protocol:m},f=i.forwardPort(E,h);return f?(this.q(a,l,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(v)})):this.j.delete(v),f}};e.$dw=n,e.$dw=n=Je([Ve(0,M.$Wj),Ve(1,R.$Wi)],n)}),define(Re[205],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,I.$qi)("editSessionIdentityService");var N;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Re[206],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=N,e.$nM=R,e.$oM=F,e.$pM=M,e.$qM=p;function N(g){return g.scheme!==I.Schemas.file&&g.scheme!==I.Schemas.vscodeRemote}function R(g){if(g.folders.length)return g.folders.every(D=>N(D.uri))?g.folders[0].uri:void 0;if(g.configuration&&N(g.configuration))return g.configuration}function F(g){return R(g)?.scheme}function M(g){return R(g)?.authority}function p(g){return R(g)!==void 0}}),define(Re[49],Ae([1,0,162,19,52,23,2,3,12]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=D,e.$Bi=T,e.$Ei=k,e.$Fi=u,e.$Gi=w,e.$Hi=s,e.$Ii=o,e.$Li=i,e.$Qi=a,e.$Ri=l,e.$Ti=t,e.$Ui=b,e.$Vi=c,e.$zi=(0,p.$qi)("contextService");function D(m){const v=m;return typeof v?.id=="string"&&M.URI.isUri(v.uri)}function T(m){return typeof m?.id=="string"&&!D(m)&&!u(m)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function k(m,v){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,N.$oc)(m)}:v?e.$Ci:e.$Di;const $=m;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}function u(m){const v=m;return typeof v?.id=="string"&&M.URI.isUri(v.configPath)}function w(m){const v=m;if(v?.uri)return{id:v.id,uri:M.URI.revive(v.uri)};const $=m;if($?.configPath)return{id:$.id,configPath:M.URI.revive($.configPath)};if(m?.id)return{id:m.id}}var d;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function s(m){const v=m;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}function o(m){const v=m;return!!(v&&typeof v=="object"&&M.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}class n{constructor(v,$,h,E,f){this.h=v,this.j=h,this.k=E,this.l=f,this.c=R.$wi.forUris(this.l,()=>!0),this.folders=$}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=R.$wi.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=n;class r{constructor(v,$){this.raw=$,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,F.$4g)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=r;function i(m){return new r({uri:m,index:0,name:(0,F.$Zg)(m)},{uri:m.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,I.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function a(m,v){return F.$Ug.isEqualOrParent(m,v.untitledWorkspacesHome)}function l(m){let v;return M.URI.isUri(m)?v=m:v=m.configuration,v?.scheme===g.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(m){return m.id===e.$Si}function b(m,v){return!a(m,v)&&!l(m)}function c(m){return(typeof m=="string"?(0,N.$pc)(m):(0,F.$2g)(m))===e.$Ni}}),define(Re[74],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const F=this.c++;return this.b.set(F,R),this.e(),F}get(R,F){return this.b.has(R)?this.b.get(R)[F]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1jc=I}),define(Re[44],Ae([1,0,12,23,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=e.$6jc=void 0;class F{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new N.$Sg(p=>{const g=this.b.get(p.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(p,g){g===null?this.b.delete(p.scheme):this.b.set(p.scheme,g)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$6jc=F,e.$7jc=(0,R.$qi)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0,e.$qP=(0,I.$qi)("IExtHostInitDataService")}),define(Re[207],Ae([1,0,168,13,194,27]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;let M=class extends R.$yQ{constructor(g,D,T){const k=T.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",u=T.remote.isRemote?(0,I.localize)(0,null):g?(0,I.localize)(1,null):(0,I.localize)(2,null);super(D.createLogger(k,{name:u}))}};e.$amc=M,e.$amc=M=Je([Ve(1,N.$Xj),Ve(2,F.$qP)],M)}),define(Re[208],Ae([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=e.$Lkc=void 0;class N{constructor(M,p,g){this.h=new Map,this.a=M,this.b=p,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new I.$Ch(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of D.values())T.complete()}catch(T){for(const k of D.values())k.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let g=this.f[M];return typeof g>"u"&&(g=p),g}update(M,p){this.f[M]=p;const g=this.h.get(M);if(g!==void 0)return g.p;const D=new I.$Nh;return this.h.set(M,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$Lkc=N;class R extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$Mkc=R}),define(Re[209],Ae([1,0,5,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;class R{constructor(M){this.c=M,this.a=new I.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,g,D){const k=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(p.value,g,D);this.b.fire(k)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$Alc=R}),define(Re[16],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0,e.$aP=(0,I.$qi)("IExtHostRpcService");class N{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$bP=N}),define(Re[210],Ae([1,0,20,5]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class R{#e;constructor(M,p){this.b=new N.$be,this.onDidChange=this.b.event,this.a=I.$Lm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$Vkc=R}),define(Re[60],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=void 0,e.$jkc=(0,I.$qi)("IURITransformerService");class N{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$kkc=N}),define(Re[211],Ae([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnb=R,e.$Ynb=M;class N{constructor(){this.buffers=[]}add(g){let D=this.buffers.indexOf(g);return D<0&&(D=this.buffers.length,this.buffers.push(g)),D}}function R(p,g){if(g.serializeBuffersForPostMessage){const D=new N,k=JSON.stringify(p,(w,d)=>{if(d instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add(d)};if(ArrayBuffer.isView(d)){const s=F(d);if(s)return{$$vscode_array_buffer_reference$$:!0,index:D.add(d.buffer),view:{type:s,byteLength:d.byteLength,byteOffset:d.byteOffset}}}return d}),u=D.buffers.map(w=>{const d=new Uint8Array(w);return I.$Ce.wrap(d)});return{message:k,buffers:u}}else return{message:JSON.stringify(p),buffers:[]}}function F(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,g){const D=g.map(u=>{const w=new ArrayBuffer(u.byteLength);return new Uint8Array(w).set(u.buffer),w}),T=g.length?(u,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const d=w,{index:s}=d,o=D[s];if(d.view)switch(d.view.type){case 1:return new Int8Array(o,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(p,T),arrayBuffers:D}}}),define(Re[104],Ae([1,0,177,17,2,6,3,30,43,12,42,139,33]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$BF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$sF=e.EditorInputCapabilities=e.$rF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0,e.$iF=s,e.$jF=o,e.$kF=n,e.$lF=r,e.$mF=i,e.$nF=a,e.$oF=l,e.$pF=t,e.$qF=b,e.$tF=E,e.$uF=S,e.$vF=y,e.$wF=C,e.$xF=P,e.$yF=V,e.$zF=W,e.$AF=ce,e.$CF=ue,e.$DF=re,e.$EF=Se,e.$FF=Le,e.$dF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$eF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$fF="workbench.editor.sidebysideEditor",e.$gF="workbench.editors.textDiffEditor",e.$hF="workbench.editors.binaryResourceDiffEditor";var w;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var d;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function s(ne){const U=ne;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function o(ne){const U=ne;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function n(ne,U,x){for(const be of x.visibleEditorPanes)if(be.group.id===U&&ne.matches(be.input))return be.getViewState()}function r(ne){if(E(ne))return!1;const U=ne;return R.URI.isUri(U?.resource)}function i(ne){if(E(ne))return!1;const U=ne;return U?.original!==void 0&&U.modified!==void 0}function a(ne){if(E(ne))return!1;const U=ne;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function l(ne){if(E(ne)||i(ne))return!1;const U=ne;return U?.primary!==void 0&&U.secondary!==void 0}function t(ne){if(E(ne))return!1;const U=ne;return U?U.resource===void 0||U.resource.scheme===D.Schemas.untitled||U.forceUntitled===!0:!1}function b(ne){if(E(ne))return!1;const U=ne;return R.URI.isUri(U?.base?.resource)&&R.URI.isUri(U?.input1?.resource)&&R.URI.isUri(U?.input2?.resource)&&R.URI.isUri(U?.result?.resource)}var c;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var m;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class v{constructor(){this.a=new Map}registerSource(U,x){let be=this.a.get(U);return be||(be={source:U,label:x},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$rF=new v;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})($||(e.EditorInputCapabilities=$={}));class h extends F.$Uc{}e.$sF=h;function E(ne){return ne instanceof h}function f(ne){const U=ne;return R.URI.isUri(U?.preferredResource)}function S(ne){const U=ne;return E(U?.primary)&&E(U?.secondary)}function y(ne){const U=ne;return E(U?.modified)&&E(U?.original)}function C(ne,U,x,be,Te){return Le(be,[(0,k.$aj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Ee={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(U,Ee)}}),(0,k.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function P(ne){return E(ne?.editor)}function V(ne){const U=ne;return P(ne)&&U?.group!==void 0}function W(ne){const U=ne;return typeof U?.groupId=="number"&&E(U.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var j;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class K{getOriginalUri(U,x){if(!U)return;if(b(U))return e.$BF.getOriginalUri(U.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:Ee}=this.a(U);if(Te&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getOriginalUri(Te,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===j.PRIMARY?Te:Ee}}if(i(U)||a(U)||l(U)||b(U))return;const be=f(U)?U.preferredResource:U.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}a(U){return S(U)||l(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,x){if(!U)return;if(b(U))return e.$BF.getCanonicalUri(U.result,x);if(x?.supportSideBySide){const{primary:Te,secondary:Ee}=this.a(U);if(Te&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getCanonicalUri(Te,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===j.PRIMARY?Te:Ee}}if(i(U)||a(U)||l(U)||b(U))return;const be=U.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}b(U,x){if(Array.isArray(x)){if(x.some(be=>U.scheme===be))return U}else if(x===U.scheme)return U}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,U,x,be){if(!ne.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$BF=new K;var ve;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(U){const x=this.a=U.get(M.$pi);for(const[be,Te]of this.c)this.e(be,Te,x);this.c.clear()}e(U,x,be){const Te=be.createInstance(x);this.d.set(U,Te)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$cg)(this.b)}registerEditorSerializer(U,x){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,x,this.a):this.c.set(U,x),(0,F.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$9n.add(e.$dF.EditorFactory,new Ie);async function ue(ne,U,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async be=>{const Te=R.URI.revive(be.fileUri);if(!Te){x.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(Te)){x.info("Cannot resolve the path because it cannot be handled",be);return}let $e=be.exists,fe=be.type;if(typeof $e!="boolean"||typeof fe!="number")try{fe=(await U.stat(Te)).isDirectory?g.FileType.Directory:g.FileType.Unknown,$e=!0}catch(Y){x.error(Y),$e=!1}if(!$e&&be.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",be);return}if(fe===g.FileType.Directory){x.info("Cannot resolve the path because it is a directory",be);return}const Q={...be.options,pinned:!0};return $e?{resource:Te,options:Q}:{resource:Te,options:Q,forceUntitled:!0}}))}var pe;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function re(ne){const U=ne;if(!U)return!1;const x=U;if(x.modified)return re(x.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function Se(ne){return(0,T.$cj)(ne)}function Le(ne,U,x){const be=(0,T.$dj)(ne,U);return be.forceMessage=x?.forceMessage,be.forceSeverity=x?.forceSeverity,be.allowDialog=x?.allowDialog,be}}),define(Re[212],Ae([1,0,5,178,3,6,28,30,18,26,91,203]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$LF=e.ViewContentGroups=e.$JF=e.ViewContainerLocation=e.Extensions=e.$IF=e.$HF=e.$GF=void 0,e.$KF=d,e.$GF="views",e.$HF=(0,N.localize)(0,null),e.$IF=(0,k.$3w)("default-view-icon",T.$Pj.window,(0,N.localize)(1,null));var u;(function(b){b.ViewContainersRegistry="workbench.registry.view.containers",b.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var w;(function(b){b[b.Sidebar=0]="Sidebar",b[b.Panel=1]="Panel",b[b.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$JF=[0,1,2];function d(b){switch(b){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onDidRegister=this.c.event,this.f=this.B(new I.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(c,m,v){const $=this.get(c.id);if($)return $;const h=c;return h.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:h.openCommandActionDescriptor??{id:h.id},(0,M.$yc)(this.g,m,[]).push(h),v?.isDefault&&this.h.push(h),this.c.fire({viewContainer:h,viewContainerLocation:m}),h}deregisterViewContainer(c){for(const m of this.g.keys()){const v=this.g.get(m),$=v?.indexOf(c);if($!==-1){v?.splice($,1),v.length===0&&this.g.delete(m),this.f.fire({viewContainer:c,viewContainerLocation:m});return}}}get(c){return this.all.filter(m=>m.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(v=>v?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(m=>this.getViewContainerLocation(m)===c)}}p.$9n.add(u.ViewContainersRegistry,new s);var o;(function(b){b.Open="2_open",b.Debug="4_debug",b.SCM="5_scm",b.More="9_more"})(o||(e.ViewContentGroups=o={}));function n(b,c){const m=b.group??o.More,v=c.group??o.More;return m!==v?m.localeCompare(v):(b.order??5)-(c.order??5)}class r extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(c,m){this.registerViews2([{views:c,viewContainer:m}])}registerViews2(c){c.forEach(({views:m,viewContainer:v})=>this.r(m,v)),this.c.fire(c)}deregisterViews(c,m){const v=this.s(c,m);v.length&&this.f.fire({views:v,viewContainer:m})}moveViews(c,m){for(const v of this.m.keys())if(v!==m){const $=this.s(c,v);$.length&&(this.r($,m),this.g.fire({views:$,from:v,to:m}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const m of this.j){const v=(this.m.get(m)||[]).filter($=>$.id===c)[0];if(v)return v}return null}getViewContainer(c){for(const m of this.j)if((this.m.get(m)||[]).filter($=>$.id===c)[0])return m;return null}registerViewWelcomeContent(c,m){return this.n.add(c,m),this.h.fire(c),(0,F.$Sc)(()=>{this.n.delete(c,m),this.h.fire(c)})}registerViewWelcomeContent2(c,m){const v=new Map;for(const[$,h]of m)this.n.add(c,h),v.set($,(0,F.$Sc)(()=>{this.n.delete(c,h),this.h.fire(c)}));return this.h.fire(c),v}getViewWelcomeContent(c){const m=[];return this.n.forEach(c,v=>m.push(v)),m.sort(n)}r(c,m){let v=this.m.get(m);v||(v=[],this.m.set(m,v),this.j.push(m));for(const $ of c){if(this.getView($.id)!==null)throw new Error((0,N.localize)(2,null,$.id));v.push($)}}s(c,m){const v=this.m.get(m);if(!v)return[];const $=[],h=[];for(const E of v)c.includes(E)?$.push(E):h.push(E);return $.length&&(h.length?this.m.set(m,h):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),$}}p.$9n.add(u.ViewsRegistry,new r),e.$LF=(0,R.$qi)("viewDescriptorService");var i;(function(b){b[b.Default=0]="Default",b[b.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(b){b[b.None=0]="None",b[b.Collapsed=1]="Collapsed",b[b.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class l{constructor(c,m){this.c=!1,this.d=!1,(0,D.$Zn)(this,c),this.d=!!m,this.resolve=async v=>{if(m&&!this.c){const $=await m(v);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$MF=l;class t extends Error{constructor(c){super((0,N.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$NF=t}),define(Re[213],Ae([1,0,179,31]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$RF=new N.$Hj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$SF=new N.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$TF=new N.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$UF=new N.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$VF=new N.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$WF=new N.$Hj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$XF=new N.$Hj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$YF=new N.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$ZF=new N.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$1F=new N.$Hj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$2F=new N.$Hj("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$3F=new N.$Hj("hasChatProvider",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$4F=new N.$Hj("chatCursorAtTop",!1),e.$5F=new N.$Hj("chatInputHasAgent",!1),e.$6F=new N.$Hj("chatLocation",void 0)}),define(Re[214],Ae([1,0,5,46,6,31,3,213]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var g;(function(k){k.Panel="panel",k.Terminal="terminal",k.Notebook="notebook",k.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(k){function u(w){switch(w){case"panel":return k.Panel;case"terminal":return k.Terminal;case"notebook":return k.Notebook;case"editor":return k.Editor}return k.Panel}k.fromRaw=u}(g||(e.ChatAgentLocation=g={})),e.$3G=(0,M.$qi)("chatAgentService");let D=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=[],this.d=new I.$be,this.onDidChangeAgents=this.d.event,this.e=p.$3F.bindTo(this.f)}registerAgent(u,w){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const s=this,o=w.slashCommands;w={...w,get slashCommands(){return o.filter(r=>!r.when||s.f.contextMatchesRules(F.$oj.deserialize(r.when)))}};const n={data:w};return this.b.push(n),(0,R.$Sc)(()=>{this.b=this.b.filter(r=>r!==n),this.d.fire(void 0)})}registerAgentImplementation(u,w){const d=this.g(u);if(!d)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(d.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return d.data.isDefault&&this.e.set(!0),d.impl=w,this.d.fire(new T(d.data,w)),(0,R.$Sc)(()=>{d.impl=void 0,this.d.fire(void 0),d.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,w){const d={data:u,impl:w};return this.b.push(d),this.d.fire(new T(u,w)),(0,R.$Sc)(()=>{this.b=this.b.filter(s=>s!==d),this.d.fire(void 0)})}updateAgent(u,w){const d=this.g(u);if(!d?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);d.data.metadata={...d.data.metadata,...w},this.d.fire(new T(d.data,d.impl))}getDefaultAgent(u){return this.getActivatedAgents().find(w=>!!w.isDefault&&w.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(w=>!!w.isDefault&&w.locations.includes(u))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}g(u){return this.b.find(w=>w.data.id===u)}getAgent(u){return this.g(u)?.data}getAgents(){return this.b.map(u=>u.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).map(u=>new T(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(w=>w.name===u)}async invokeAgent(u,w,d,s,o){const n=this.g(u);if(!n?.impl)throw new Error(`No activated agent with id ${u}`);return await n.impl.invoke(w,d,s,o)}async getFollowups(u,w,d,s,o){const n=this.g(u);if(!n?.impl)throw new Error(`No activated agent with id ${u}`);return n.impl?.provideFollowups?n.impl.provideFollowups(w,d,s,o):[]}};e.$4G=D,e.$4G=D=Je([Ve(0,F.$Ij)],D);class T{constructor(u,w){this.b=u,this.d=w}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,w,d,s){return this.d.invoke(u,w,d,s)}async provideFollowups(u,w,d,s){return this.d.provideFollowups?this.d.provideFollowups(u,w,d,s):[]}provideWelcomeMessage(u){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u)}provideSampleQuestions(u,w){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,w)}}e.$5G=T}),define(Re[215],Ae([1,0,2,29,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$$F=F,e.$_F=M;function F(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof I.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(N.$kt.isIRange)}function M(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(F)}var p;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var g;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(g||(e.ChatCopyKind=g={})),e.$aG=(0,R.$qi)("IChatService"),e.$bG="accessibility.voice.keywordActivation"}),define(Re[216],Ae([1,0,5,11,180]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sob=void 0;class F{constructor(){this.f=new Map,this.m=[],this.n=new I.$be,this.o=new I.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,g,D,T){const k={command:p};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.u("request",k),typeof T=="number"){const u=setTimeout(()=>{clearTimeout(u);const w=this.f.get(k.seq);if(w){this.f.delete(k.seq);const d={type:"response",seq:0,request_seq:k.seq,success:!1,command:p,message:(0,R.localize)(0,null,T,p)};w(d)}},T)}return D&&this.f.set(k.seq,D),k.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,g){return p.type!=="event"||g.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,N.$rh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const g=p,D=this.f.get(g.request_seq);D&&(this.f.delete(g.request_seq),D(g));break}}}}u(p,g){g.type=p,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((g,D)=>p.set(D,g)),await(0,N.$rh)(500),p.forEach((g,D)=>{g({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$sob=F}),define(Re[217],Ae([1,0,2,181,31,3]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=g,e.$hJ=T,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new R.$Hj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$dI=new R.$Hj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$eI=new R.$Hj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$fI="debugUx",e.$gI=new R.$Hj(e.$fI,"default",{type:"string",description:N.localize(3,null)}),e.$hI=new R.$Hj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$iI=new R.$Hj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$jI=new R.$Hj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$kI=new R.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$lI=new R.$Hj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$mI=new R.$Hj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$nI=new R.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$oI=new R.$Hj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$pI=new R.$Hj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$qI=new R.$Hj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$rI=new R.$Hj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$sI=new R.$Hj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$tI=new R.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$uI=new R.$Hj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$vI=new R.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$wI=new R.$Hj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$xI=new R.$Hj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$yI=new R.$Hj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$zI=new R.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$AI=new R.$Hj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$BI=new R.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$CI=new R.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$DI=new R.$Hj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$EI=new R.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$FI=new R.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$GI=new R.$Hj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$HI=new R.$Hj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$II=new R.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$JI=new R.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$KI=new R.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$LI=new R.$Hj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$MI=new R.$Hj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$NI=new R.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$OI=new R.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$PI=new R.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$QI=new R.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$RI=new R.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$SI=new R.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$TI=new R.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$UI=new R.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$VI=new R.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$WI=new R.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$XI=new R.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$YI=new R.$Hj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$ZI=new R.$Hj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$1I=new R.$Hj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$2I=new R.$Hj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$3I=new R.$Hj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$4I=new R.$Hj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$5I=new R.$Hj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$6I=new R.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$7I=new R.$Hj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$8I=new R.$Hj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$9I=new R.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$0I=new R.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$$I=new R.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$_I=new R.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function g(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var D;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$gJ="vscode-debug-memory";function T(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var k;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(k||(e.DataBreakpointSetType=k={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var w;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$iJ=(0,F.$qi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var s;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var n;(function(i){i.deserialize=a=>a,i.serialize=a=>a})(n||(e.IDebugVisualizationTreeItem=n={}));var r;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:I.URI.revive(a.iconPath.light),dark:I.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(r||(e.IDebugVisualization=r={}))}),define(Re[218],Ae([1,0,15,2,19,26,12,29,24,18]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=k,e.$9G=u,e.$0G=w,e.$$G=d,e.$_G=s,e.$aH=o,e.$bH=n,e.$cH=i,e.$dH=t,e.$eH=b,e.$fH=m,e.$gH=$;const T=/{([^}]+)}/g;function k(E,f,S){return E.replace(T,function(y,C){return f&&C.length>0&&C[0]!=="_"?y:S&&S.hasOwnProperty(C)?S[C]:y})}function u(E){const f={};for(const S of Object.keys(E))S.startsWith("!")||(f[S]=E[S]);return f}function w(E){return E.configuration.request==="attach"&&!d(E)&&(!E.parentSession||w(E.parentSession))}function d(E){let f=E.configuration.type;if(f)return f==="vslsShare"&&(f=E.configuration.adapterProxy.configuration.type),(0,I.$tf)(f,"extensionhost")||(0,I.$tf)(f,"pwa-extensionhost")?E:E.parentSession?d(E.parentSession):void 0}function s(E){return E.type&&(E.label||E.program||E.runtime)}function o(E,f,S){let y,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(E);){const W=V.index+1,q=W+V[0].length;if(W<=f&&q>=S){y=V[0],C=W;break}}if(y){const W=/\w+/g;let q=null;for(;(q=W.exec(y))&&!(q.index+1+C+q[0].length>=S););q&&(y=y.substring(0,W.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function n(E,f,S,y){if(E.evaluatableExpressionProvider.has(f)){const C=E.evaluatableExpressionProvider.ordered(f),P=(0,D.$Hb)(await Promise.all(C.map(async V=>{try{return await V.provideEvaluatableExpression(f,S,y??g.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=f.getLineContent(S.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const C=f.getLineContent(S.lineNumber),{start:P,end:V}=o(C,S.column,S.column),W=C.substring(P-1,V);return{matchingExpression:W,range:new p.$kt(S.lineNumber,P,S.lineNumber,P+W.length)}}return null}const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(E){return!!(E&&E.match(r))}function a(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(i(E.path))return N.URI.parse(E.path);if((0,R.$jc)(E.path))return N.URI.file(E.path)}return E.path}function l(E){if(typeof E.path=="object"){const f=N.URI.revive(E.path);if(f)return f.scheme===M.Schemas.file?f.fsPath:f.toString()}return E.path}function t(E,f){const S=f?a:l,y=(0,F.$Wn)(E);return c(y,(C,P)=>{C&&P&&(P.path=S(P))}),y}function b(E,f){const S=f?a:l,y=(0,F.$Wn)(E);return c(y,(C,P)=>{!C&&P&&(P.path=S(P))}),y}function c(E,f){switch(E.type){case"event":{const S=E;switch(S.event){case"output":f(!1,S.body.source);break;case"loadedSource":f(!1,S.body.source);break;case"breakpoint":f(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=E;switch(S.command){case"setBreakpoints":f(!0,S.arguments.source);break;case"breakpointLocations":f(!0,S.arguments.source);break;case"source":f(!0,S.arguments.source);break;case"gotoTargets":f(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(y=>f(!1,y));break;default:break}break}case"response":{const S=E;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(y=>f(!1,y.source));break;case"loadedSources":S.body.sources.forEach(y=>f(!1,y));break;case"scopes":S.body.scopes.forEach(y=>f(!1,y.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(y=>f(!1,y.source));break;case"setBreakpoints":S.body.breakpoints.forEach(y=>f(!1,y.source));break;case"disassemble":S.body?.instructions.forEach(C=>f(!1,C.location));break;default:break}break}}}function m(E){return E.filter(f=>!f.presentation?.hidden).sort((f,S)=>f.presentation?S.presentation?f.presentation.group?S.presentation.group?f.presentation.group!==S.presentation.group?f.presentation.group.localeCompare(S.presentation.group):v(f.presentation.order,S.presentation.order):-1:S.presentation.group?1:v(f.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function v(E,f){return typeof E!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:E-f}async function $(E,f){const S=E.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(S!=="none"&&(await f.saveAll(),S==="allEditorsInActiveGroup")){const y=f.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await f.save({editor:y.input,groupId:y.group.id})}await E.reloadConfiguration()}const h=(E,f)=>!E||!f?E===f:E.name===f.name&&E.path===f.path&&E.sourceReference===f.sourceReference;e.$hH=h}),define(Re[219],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var N;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vK=(0,I.$qi)("INotebookExecutionService")}),define(Re[220],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mib=e.$lib=e.ProxyKernelState=e.$kib=void 0,e.$kib=100;var N;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$lib=(0,I.$qi)("INotebookKernelService"),e.$mib=(0,I.$qi)("INotebookKernelHistoryService")}),define(Re[221],Ae([1,0,6,29,149,95]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Vb=void 0;class M extends I.$Uc{constructor(g,D,T){super(),this._source=g,this.b=D,this.c=T,this.a=void 0}f(g){const D=g.getLineCount();return new N.$kt(1,1,D,this.g(g,D))}g(g,D){if(D<1||D>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const g=new R.$MC;g.acceptChunk(this._source);const D=g.finish(!0),{textBuffer:T,disposable:k}=D.create(1);this.b=T,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const D=new R.$MC;D.acceptChunk(g);const T=D.finish(!0),{textBuffer:k,disposable:u}=T.create(1);return this.B(u),k})),this.a}findInInputs(g){const T=new F.$AC(g,!1,!1,null).parseSearchRequest();if(!T)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,T,!0,5e3)}findInOutputs(g){const T=new F.$AC(g,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(k=>{const u=k.findMatchesLineByLine(this.f(k),T,!0,5e3);if(u.length!==0)return{textBuffer:k,matches:u}}).filter(k=>!!k):[]}}e.$_Vb=M}),define(Re[50],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(F){F.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var N;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class R{static fromExtHostTestItem(M,p,g=M.parent){if(M._isRoot)return new R([p]);const D=[M.id];for(let T=g;T&&T.id!==p;T=T.parent)D.push(T.id);return D.push(p),new R(D.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new R(M.split("\0"))}static join(M,p){return new R([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:R.isChild(M,p)?2:R.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=R}),define(Re[61],Ae([1,0,2,93,29,50]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var g;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$DL=[2,4,8,16,32,64];const D=A=>"runId"in A;e.$EL=D;var T;(function(A){A.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({range:R.$kt.lift(K.range),uri:j.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var k;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(k||(e.TestMessageType=k={}));var u;(function(A){A.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&T.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(j,K.location)})})(u||(e.ITestErrorMessage=u={}));const w=(A,j)=>`${j?"s":"e"}${A}`;e.$FL=w;var d;(function(A){A.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&T.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(j,K.location)})})(d||(e.ITestOutputMessage=d={}));var s;(function(A){A.serialize=j=>j.type===0?u.serialize(j):d.serialize(j),A.deserialize=(j,K)=>K.type===0?u.deserialize(j,K):d.deserialize(j,K)})(s||(e.ITestMessage=s={}));var o;(function(A){A.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),A.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(s.serialize)}),A.deserialize=(j,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>s.deserialize(j,ie))})})(o||(e.ITestTaskState=o={}));const n="\0",r=(A,j)=>A+n+j;e.$GL=r;const i=A=>{const j=A.indexOf(n);return{ctrlId:A.slice(0,j),tagId:A.slice(j+1)}};e.$HL=i;var a;(function(A){A.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),A.deserialize=(j,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?j.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$kt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(a||(e.ITestItem=a={}));var l;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(A){A.serialize=j=>({expand:j.expand,item:a.serialize(j.item)}),A.deserialize=(j,K)=>({controllerId:F.$BL.root(K.item.extId),expand:K.expand,item:a.deserialize(j,K.item)})})(t||(e.InternalTestItem=t={}));var b;(function(A){A.serialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.uri!==void 0&&(K.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(K.range=j.item.range?.toJSON()),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}},A.deserialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.range!==void 0&&(K.range=j.item.range?R.$kt.lift(j.item.range):null),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}}})(b||(e.ITestItemUpdate=b={}));const c=(A,j)=>{j.expand!==void 0&&(A.expand=j.expand),j.item!==void 0&&(A.item=A.item?Object.assign(A.item,j.item):j.item)};e.$IL=c;var m;(function(A){A.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serializeWithoutMessages)}),A.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serialize)}),A.deserialize=(j,K)=>({...t.deserialize(j,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>o.deserialize(j,ie)),retired:!0})})(m||(e.TestResultItem=m={}));var v;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(j,K)=>{j.covered+=K.covered,j.total+=K.total}})(v||(e.ICoverageCount=v={}));var $;(function(A){A.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:j.asCanonicalUri(I.URI.revive(K.uri))})})($||(e.IFileCoverage=$={}));function h(A){return{...A,location:A.location?.toJSON()}}function E(A){return A.location=A.location?N.$jt.isIPosition(A.location)?N.$jt.lift(A.location):R.$kt.lift(A.location):void 0,A}e.$JL=3;var f;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(f||(e.DetailType=f={}));var S;(function(A){A.serialize=j=>j.type===0?C.serialize(j):P.serialize(j),A.deserialize=j=>j.type===0?C.deserialize(j):P.deserialize(j)})(S||(e.CoverageDetails=S={}));var y;(function(A){A.serialize=h,A.deserialize=E})(y||(e.IBranchCoverage=y={}));var C;(function(A){A.serialize=h,A.deserialize=E})(C||(e.IDeclarationCoverage=C={}));var P;(function(A){A.serialize=j=>({...h(j),branches:j.branches?.map(y.serialize)}),A.deserialize=j=>({...E(j),branches:j.branches?.map(y.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(A){A.deserialize=(j,K)=>K.op===0?{op:K.op,item:t.deserialize(j,K.item)}:K.op===1?{op:K.op,item:b.deserialize(K.item)}:K.op===2?{op:K.op,uri:j.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:b.serialize(j.item)}:j})(W||(e.TestsDiffOp=W={}));class q{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const K=this.v();for(const ie of j)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(b.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(j,K){const ie=F.$BL.parentId(j.item.extId)?.toString();let ce;if(!ie)ce=this.w(j),this.g.add(ce),this.f.set(j.item.extId,ce);else if(this.f.has(ie)){const ve=this.f.get(ie);ve.children.add(j.item.extId),ce=this.w(j,ve),this.f.set(j.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return K.add?.(ce),j.expand===2&&this.h++,ce}o(j,K){const ie=this.f.get(j.extId);if(ie)return j.expand!==void 0&&(ie.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$IL)(ie,j),K.update?.(ie),ie}p(j,K){const ie=this.f.get(j);if(!ie)return;const ce=F.$BL.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ve=[[j]];for(;ve.length;)for(const Ie of ve.pop()){const ue=this.f.get(Ie);ue&&(ve.push(ue.children),this.f.delete(Ie),K.remove?.(ue,ue!==ie),ue.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$KL=q}),define(Re[75],Ae([1,0,11,5,6,56,61,50]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.TestItemEventOp=void 0;var g;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const D=(r,i)=>r===i,k=Object.entries({range:(r,i)=>r===i?!0:!r||!i?!1:r.equalsRange(i),busy:D,label:D,description:D,error:D,sortText:D,tags:(r,i)=>!(r.length!==i.length||r.some(a=>!i.includes(a)))}),u=(r,i)=>{let a;for(const[l,t]of k)t(r[l],i[l])||(a?a[l]=i[l]:a={[l]:i[l]});return a};class w extends R.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,M.$IL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,M.$IL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const l=this.tree.get(i);if(l){if((l.expandLevels===void 0||a>l.expandLevels)&&(l.expandLevels=a),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,a-1):t.wait().then(()=>this.L(l,a-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,a-1)):this.L(l,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(p.$BL.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const l of a.ops)this.w(i,l);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,F.$cd)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const l=p.$BL.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let b=this.tree.get(l.toString());if(!b){b={fullId:l,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(b.fullId.toString(),b),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:b.expand,item:this.s.toITestItem(i)}}),this.I(i,b,a);return}if(b.actual===i){this.H(i,b,a);return}if(b.actual.uri?.toString()!==i.uri?.toString())return this.O(l.toString()),this.z(i,a);const c=this.s.getChildren(b.actual),m=b.actual,v=u(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,b.actual=i,b.resolveBarrier=void 0,b.expand=0,v&&(v.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,l.toString()),delete v.tags),this.w(b,{op:4,update:v})),this.I(i,b,a);for(const[h,E]of c)this.s.getChildren(i).get(E.id)||this.O(p.$BL.joinToString(l,E.id));const $=b.expandLevels;$!==void 0&&queueMicrotask(()=>{b.expand===1&&(b.expandLevels=void 0,this.expand(l.toString(),$))}),this.y(b.actual.uri)}C(i,a,l){const t=new Set(a.map(b=>b.id));for(const b of i)t.delete(b.id)||this.D(b);this.pushDiff({op:1,item:{extId:l,item:{tags:i.map(b=>(0,M.$GL)(this.s.controllerId,b.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,l){this.G(i,l);const t=this.s.getApiFor(i);t.parent=l?.actual,t.listener=b=>this.w(a,b),this.J(a)}I(i,a,l){this.H(i,a,l);for(const[t,b]of this.s.getChildren(i))this.z(b,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const l=[];for(const[t,b]of this.s.getChildren(i.actual)){const c=this.expand(p.$BL.joinToString(i.fullId,b.id),a);(0,I.$ch)(c)&&l.push(c)}if(l.length)return Promise.all(l).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const b=new I.$ph;return b.open(),b}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$ph,l=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,b)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(b){l(b)}return(0,I.$ch)(t)?t.catch(l).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const l=[a];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const b of t.actual.tags)this.F(b.id);this.tree.delete(t.fullId.toString());for(const[b,c]of this.s.getChildren(t.actual))l.push(this.tree.get(p.$BL.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$3O=w;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$4O=d;class s extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5O=s;class o extends Error{constructor(i,a,l){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${l}".`)}}e.$6O=o;const n=(r,i,a)=>{let l=new Map;return{get size(){return l.size},forEach(t,b){for(const c of l.values())t.call(b,c,this)},[Symbol.iterator](){return l.entries()},replace(t){const b=new Map,c=new Set(l.keys()),m={op:5,ops:[]};for(const v of t){if(!(v instanceof a))throw new s(v.id);const $=i(v).controllerId;if($!==r.controllerId)throw new o(v.id,$,r.controllerId);if(b.has(v.id))throw new d(v.id);b.set(v.id,v),c.delete(v.id),m.ops.push({op:0,item:v})}for(const v of c.keys())m.ops.push({op:3,id:v});r.listener?.(m),l=b},add(t){if(!(t instanceof a))throw new s(t.id);l.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){l.delete(t)&&r.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$7O=n}),define(Re[105],Ae([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0;const N=new WeakMap,R=(M,p)=>{const g={controllerId:p};return N.set(M,g),g};e.$8O=R;const F=M=>{const p=N.get(M);if(!p)throw new I.$5O(M?.id||"<unknown>");return p};e.$9O=F}),define(Re[76],Ae([1,0,12,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Exb=e.$Dxb=void 0,e.$Gxb=R,e.$Hxb=M,e.$Dxb="vscode-cdn.net",e.$Exb=`vscode-resource.${e.$Dxb}`,e.$Fxb=`'self' https://*.${e.$Dxb}`;function R(p,g){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(g&&g.authority&&g.isRemote&&p.scheme===I.Schemas.file&&(p=N.URI.from({scheme:I.Schemas.vscodeRemote,authority:g.authority,path:p.path})),N.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${F(p.authority)}.${e.$Exb}`,path:p.path,fragment:p.fragment,query:p.query}))}function F(p){return p.replace(/./g,g=>{const D=g.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?g:"-"+D.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(g,D)=>String.fromCharCode(parseInt(D,16)))}}),define(Re[222],Ae([1,0,5,6,76]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=void 0;class F{constructor(p,g,D){this.d=p,this.e=g,this.f=D,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const T=g.getVisibleTextEditors();for(const k of this.c.values())T.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,g,D,T,k){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===p){u=i;break}if(!u)throw new Error("not a visible editor");const w=this,d=this.a++,s=new I.$be,o=new I.$be,n=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$Gxb)(i,w.f)}get cspSource(){return R.$Fxb}set options(i){this.b=i,w.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,w.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(i){return w.d.$postMessage(d,i)}},r=new class{constructor(){this.editor=p,this.line=g,this.height=D,this.webview=n,this.onDidDispose=o.event}dispose(){w.c.has(d)&&(w.c.delete(d),w.d.$disposeEditorInset(d),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,g+1,D,T||{},k.identifier,k.extensionLocation),this.c.set(d,{editor:p,inset:r,onDidReceiveMessage:s}),r}$onDidDispose(p){const g=this.c.get(p);g&&g.inset.dispose()}$onDidReceiveMessage(p,g){this.c.get(p)?.onDidReceiveMessage.fire(g)}}e.$hkc=F}),define(Re[106],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,I.$qi)("IAuthenticationService"),e.$TL=(0,I.$qi)("IAuthenticationExtensionsService")}),define(Re[223],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.VariableKind=e.$YP=void 0,e.$YP=(0,I.$qi)("configurationResolverService");var N;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class R extends Error{constructor(M,p){super(p),this.variable=M}}e.$ZP=R}),define(Re[224],Ae([1,0,19,73,17,26,21,96,184,223,15]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,d,s,o){this.h=new Map,this.a=w,this.b=d,this.g=s,o&&(this.c=o.then(n=>this.i(n)))}i(w){if(M.$i){const d=Object.create(null);return Object.keys(w).forEach(s=>{d[s.toLowerCase()]=w[s]}),d}return w}resolveWithEnvironment(w,d,s){return this.l({env:this.i(w),userHome:void 0},d?d.uri:void 0,s)}async resolveAsync(w,d){const s={env:await this.c,userHome:await this.g};return this.l(s,w?w.uri:void 0,d)}async j(w,d,s,o){const n=F.$Wn(d);M.$i&&n.windows?Object.keys(n.windows).forEach(i=>n[i]=n.windows[i]):M.$j&&n.osx?Object.keys(n.osx).forEach(i=>n[i]=n.osx[i]):M.$k&&n.linux&&Object.keys(n.linux).forEach(i=>n[i]=n.linux[i]),delete n.windows,delete n.osx,delete n.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,n,s,o)}async resolveAnyAsync(w,d,s){return this.j(w,d,s)}async resolveAnyMap(w,d,s){const o=new Map;return{newConfig:await this.j(w,d,s,o),resolvedVariables:o}}resolveWithInteractionReplace(w,d,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,d,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,d){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,d)}async l(w,d,s,o,n){if(R.$4f(s))return this.m(w,d,s,o,n);if(Array.isArray(s))return Promise.all(s.map(r=>this.l(w,d,r,o,n)));if(R.$6f(s)){const r=Object.create(null),i=await Promise.all(Object.keys(s).map(async a=>[await this.m(w,d,a,o,n),await this.l(w,d,s[a],o,n)]));for(const[a,l]of i)r[a]=l;return r}return s}m(w,d,s,o,n){return(0,T.$lf)(s,k.VARIABLE_REGEXP,async(r,i)=>{if(i.includes(k.VARIABLE_LHS))return r;let a=await this.o(w,r,i,d,o);return n?.set(i,a),a!==r&&R.$4f(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.m(w,d,a,o,n)),a})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,d,s,o,n){let r;const i=s.split(":");i.length>1&&(s=i[0],r=i[1]);const a=b=>{const c=this.a.getFilePath();if(c)return(0,p.$pw)(c);throw new D.$ZP(b,(0,g.localize)(0,null,d))},l=b=>{const c=a(b);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,p.$pw)(m)}throw new D.$ZP(b,(0,g.localize)(1,null,d,I.$oc(c)))},t=b=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new D.$ZP(b,(0,g.localize)(2,null,d,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new D.$ZP(b,(0,g.localize)(3,null,d)):new D.$ZP(b,(0,g.localize)(4,null,d))};switch(s){case"env":if(r){if(w.env){const b=w.env[M.$i?r.toLowerCase():r];if(R.$4f(b))return b}return""}throw new D.$ZP(D.VariableKind.Env,(0,g.localize)(5,null,d));case"config":if(r){const b=this.a.getConfigurationValue(o,r);if(R.$ag(b))throw new D.$ZP(D.VariableKind.Config,(0,g.localize)(6,null,d,r));if(R.$6f(b))throw new D.$ZP(D.VariableKind.Config,(0,g.localize)(7,null,d,r));return b}throw new D.$ZP(D.VariableKind.Config,(0,g.localize)(8,null,d));case"command":return this.p(D.VariableKind.Command,d,r,n,"command");case"input":return this.p(D.VariableKind.Input,d,r,n,"input");case"extensionInstallFolder":if(r){const b=await this.a.getExtension(r);if(!b)throw new D.$ZP(D.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,d,r));return this.n(b.extensionLocation)}throw new D.$ZP(D.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,d));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$pw)(this.n(t(D.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,p.$pw)(this.n(t(D.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$pw)(I.$oc(this.n(t(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new D.$ZP(D.VariableKind.UserHome,(0,g.localize)(11,null,d))}case"lineNumber":{const b=this.a.getLineNumber();if(b)return b;throw new D.$ZP(D.VariableKind.LineNumber,(0,g.localize)(12,null,d))}case"selectedText":{const b=this.a.getSelectedText();if(b)return b;throw new D.$ZP(D.VariableKind.SelectedText,(0,g.localize)(13,null,d))}case"file":return a(D.VariableKind.File);case"fileWorkspaceFolder":return l(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(l(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?I.$mc(this.n(t(D.VariableKind.RelativeFile)),a(D.VariableKind.RelativeFile)):a(D.VariableKind.RelativeFile);case"relativeFileDirname":{const b=I.$nc(a(D.VariableKind.RelativeFileDirname));if(o||r){const c=I.$mc(this.n(t(D.VariableKind.RelativeFileDirname)),b);return c.length===0?".":c}return b}case"fileDirname":return I.$nc(a(D.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(D.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const b=I.$oc(a(D.VariableKind.FileBasenameNoExtension));return b.slice(0,b.length-I.$pc(b).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(D.VariableKind.FileDirnameBasename)));case"execPath":{const b=this.a.getExecPath();return b||d}case"execInstallFolder":{const b=this.a.getAppRoot();return b||d}case"pathSeparator":case"/":return I.sep;default:try{const b=r?`${s}:${r}`:s;return this.p(D.VariableKind.Unknown,d,b,n,void 0)}catch{return d}}}}p(w,d,s,o,n){if(s&&o){const r=n===void 0?o[s]:o[n+":"+s];if(typeof r=="string")return r;throw new D.$ZP(w,(0,g.localize)(14,null,d))}return d}}e.$cQ=k}),define(Re[107],Ae([1,0,3,104]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ID=void 0,e.$JD=D,e.$KD=u,e.$LD=w,e.$ID=(0,I.$qi)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var F;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var M;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var g;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function D(d){const s=d;return(0,N.$tF)(s?.editor)&&(0,N.$tF)(s?.replacement)}var T;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var k;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function u(d){const s=d;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function w(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Re[225],Ae([1,0,3,107]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$QD=R,e.$MD=(0,I.$qi)("editorService"),e.$ND=-1,e.$OD=-2,e.$PD=-3;function R(F){const M=F;return typeof F=="number"||(0,N.$KD)(M)}}),define(Re[226],Ae([1,0,3,191]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,I.$ri)(N.$xi)}),define(Re[108],Ae([1,0,20,5,19,6,11]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=e.$E$b=e.$D$b=e.$C$b=e.$B$b=void 0;class p{constructor(r,i){this.versionId=r,this.removedDueToLooping=i}}e.$B$b=p;class g{static isHostExtension(r,i,a){if(i.getExtensionDescription(r))return!1;const l=a.getExtensionDescription(r);return l?!!((l.main||l.browser)&&l.api==="none"):!1}constructor(r,i){this.j=r,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(s),this.f=new I.$Nm,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const i=this.j.readActivationEvents(r);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,i){this.e=o(this.e,i),this.e=this.e.concat(r);const a=g.l(this.e);return this.e=o(this.e,a.map(l=>l.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,a)}static l(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,m){this.addNode(c),this.addNode(m),this.c.has(c)?this.c.get(c).push(m):this.c.set(c,[m])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,m){const v=i.getArcs(c);for(let $=0;$<v.length;$++)if(!m.has(v[$]))return!1;return!0}getNodes(){return this.e}},a=new I.$Nm;for(const c of r)if(a.set(c.identifier,c),c.extensionDependencies)for(const m of c.extensionDependencies)i.addArc(I.$Lm.toKey(c.identifier),I.$Lm.toKey(m));const l=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>l.add(c));const t=i.getNodes().filter(c=>!l.has(c));let b;do{b=!1;for(let c=0;c<t.length;c++){const m=t[c];i.hasOnlyGoodArcs(m,l)&&(t.splice(c,1),c--,l.add(m),b=!0)}}while(b);return t.map(c=>a.get(c))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.h.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const i=this.f.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.g)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$C$b=g;class D{constructor(r,i){this.versionId=r,this.extensions=i}}e.$D$b=D;class T{constructor(r){this.d=new w,this.c=new g(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new k(this,i)}deltaExtensions(r,i,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$E$b=T;class k extends F.$Uc{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$F$b=k;class u{constructor(r){this.name=r;const i=(0,M.$jh)();this.promise=i.promise,this.c=i.resolve}resolve(r){this.c(r)}}class w{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new u(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),l=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};r.resolve((0,F.$Sc)(l))}}var d;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(d||(d={}));function s(n,r){const i=n.isBuiltin?0:n.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==a)return i-a;const l=R.$hc.basename(n.extensionLocation.path),t=R.$hc.basename(r.extensionLocation.path);return l<t?-1:l>t?1:0}function o(n,r){const i=new I.$Mm(r);return n.filter(a=>!i.has(a.identifier))}}),define(Re[77],Ae([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=p;var N;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(N||(e.UIKind=N={}));var R;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var F;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function M(D){const T=I.$Ce.alloc(1);switch(D){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function p(D,T){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var g;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Re[62],Ae([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$sP=e.$rP=void 0,e.$tP=s;let w=class extends k.$Uc{constructor(n,r){super(),this.s=n,this.t=r,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:g.$ep,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(r.onDidChangeLogLevel(i=>{(0,R.$Yj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(n,r,i){const a=this.getTelemetryDetails(),l=new d(r,i,n,this.n,this.j,this.getBuiltInCommonProperties(n),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(n.identifier.value)??[];return this.r.set(n.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(n,r,i){this.f=n,this.g=r,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(n){const r=Object.create(null);switch(r["common.extname"]=`${n.publisher}.${n.name}`,r["common.extversion"]=n.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:r["common.uikind"]="web";break;case M.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,p.$Cm)((0,g.$kp)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(n){this.h=this.getTelemetryConfiguration(),this.f=n;const r=this.getTelemetryDetails();this.r.forEach((i,a)=>{const l=i.filter(t=>!t.isDisposed);l.length===0?this.r.delete(a):this.r.set(a,l)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(n,r){const a=this.r.get(n.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(n.value),!1;let l=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(r),l=!0);return l}};e.$rP=w,e.$rP=w=Je([Ve(0,F.$qP),Ve(1,R.$Xj)],w);class d{static validateSender(n){if(typeof n!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof n.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof n.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof n.flush<"u"&&typeof n.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(n,r,i,a,l,t,b){this.g=i,this.h=a,this.i=l,this.j=t,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=n,this.d={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(n,r){this.e&&(this.d={isUsageEnabled:n,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(n){let r="properties"in n?n.properties??{}:n;return r=(0,g.$np)(r,[]),this.c&&(r=(0,D.$Zn)(r,this.c)),this.b||(r=(0,D.$Zn)(r,this.j)),"properties"in n?n.properties=r:n=r,n}k(n,r){this.f&&(this.g.publisher==="vscode"?n=this.g.name+"/"+n:n=this.g.identifier.value+"/"+n,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(n,r),this.h.trace(n,r))}logUsage(n,r){this.d.isUsageEnabled&&this.k(n,r)}logError(n,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof n=="string")this.k(n,r);else{const i={name:n.name,message:n.message,stack:n.stack,cause:n.cause},a=(0,g.$np)(i,[]),l=new Error(a.message,{cause:a.cause});l.stack=a.stack,l.name=a.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(l,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const n=this,r={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n.d.isUsageEnabled},get isErrorsEnabled(){return n.d.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n.a.event.bind(n)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let n=this.f;this.f=void 0,Promise.resolve(n.flush()).then(n=void 0),this.e=void 0}else this.f=void 0}}e.$sP=d;function s(o){const n=Date.now()-new Date(o).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.$uP=(0,I.$qi)("IExtHostTelemetry")}),define(Re[25],Ae([1,0,5,2,200,103,20,3]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.ActivationKind=e.$AG=e.$zG=e.$wG=e.ExtensionHostStartup=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$xG=u,e.$yG=w,e.$BG=n,e.$CG=r,e.$sG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tG="extensions.webWorker",e.$uG=(0,p.$qi)("extensionService");class g{constructor(l){this.dependency=l}}e.$vG=g;var D;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,b){this.c=l,this.d=t.slice(0),this.e=b.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$dG.createActivationEventsMap(this.d)}}set(l,t,b){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const c=[],m=[],v=[],$=[],h=k(this.d),E=k(t),f=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=E.get(V.identifier);if(!W){c.push(V.identifier),h.delete(V.identifier);continue}if(!f(V,W)){c.push(V.identifier),h.delete(V.identifier);continue}}for(const V of t){const W=h.get(V.identifier);if(!W){m.push(V);continue}if(!f(W,V)){c.push(W.identifier),h.delete(W.identifier);continue}}const S=new M.$Mm(this.e),y=new M.$Mm(b);for(const V of this.e)y.has(V)||v.push(V);for(const V of b)S.has(V)||$.push(V);const C=F.$dG.createActivationEventsMap(m),P={versionId:l,toRemove:c,toAdd:m,addActivationEvents:C,myToRemove:v,myToAdd:$};return this.delta(P),P}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:b,myToRemove:c,myToAdd:m}=l,v=new M.$Mm(t),$=new M.$Mm(c);for(let h=0;h<this.d.length;h++)v.has(this.d[h].identifier)&&(this.d.splice(h,1),h--);for(let h=0;h<this.e.length;h++)$.has(this.e[h])&&(this.e.splice(h,1),h--);for(const h of b)this.d.push(h);for(const h of m)this.e.push(h);return this.f=null,l}containsExtension(l){for(const t of this.e)if(M.$Lm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const b=F.$dG.readActivationEvents(t);for(const c of b)l.add(c)}return l}}e.$wG=T;function k(a){const l=new M.$Nm;for(const t of a)l.set(t.identifier,t);return l}function u(a,l){return a.enabledApiProposals?a.enabledApiProposals.includes(l):!1}function w(a,l){if(!u(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class d{constructor(l,t,b,c){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=b,this.activationReason=c}}e.$zG=d;class s{constructor(l,t){this.description=l,this.value=t}}e.$AG=s;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function n(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,R.$tp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function r(a,l){return{identifier:new M.$Lm((0,R.$rp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,publisherDisplayName:a.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DG=i}),define(Re[227],Ae([1,0,14,108,20,25,13,11]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(n,r,i,a){this.startup=n,this.codeLoadingTime=r,this.activateCallTime=i,this.activateResolvedTime=a}}e.$Dkc=g;class D{constructor(n){this.a=n,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(n,r){return n===-1||r===-1?-1:r-n}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ekc=D;class T{constructor(n,r,i,a,l,t){this.activationFailed=n,this.activationFailedError=r,this.activationTimes=i,this.module=a,this.exports=l,this.subscriptions=t}}e.$Fkc=T;class k extends T{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gkc=k;class u extends T{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hkc=u;class w extends T{constructor(n){super(!0,n,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(n,r,i,a){this.g=a,this.a=n,this.b=r,this.c=i,this.d=new R.$Nm,this.f=Object.create(null)}dispose(){for(const[n,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const n=[];for(const[r,i]of this.d)n.push(i.wait());await Promise.all(n)}isActivated(n){const r=this.d.get(n);return!!(r&&r.value)}getActivatedExtension(n){const r=this.d.get(n);if(!r||!r.value)throw new Error(`Extension '${n.value}' is not known or not activated`);return r.value}async activateByEvent(n,r){if(this.f[n])return;const i=this.a.getExtensionDescriptionsForActivationEvent(n);await this.h(i.map(a=>({id:a.identifier,reason:{startup:r,extensionId:a.identifier,activationEvent:n}}))),this.f[n]=!0}activateById(n,r){const i=this.a.getExtensionDescription(n);if(!i)throw new Error(`Extension '${n.value}' is not known`);return this.h([{id:i.identifier,reason:r}])}async h(n){const r=n.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(r.map(i=>i.wait()))}j(n){if(this.d.has(n.id))return this.d.get(n.id);if(this.l(n.id))return this.k(n,null,[],null);const r=this.a.getExtensionDescription(n.id);if(!r){const l=new Error(`Cannot activate unknown extension '${n.id.value}'`),t=this.k(n,null,[],new w(l));return this.c.onExtensionActivationError(n.id,l,new F.$vG(n.id.value)),t}const i=[],a=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const l of a){if(this.m(l))continue;const t=this.d.get(l);if(t){i.push(t);continue}if(this.l(l)){i.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:n.reason}));continue}const b=this.a.getExtensionDescription(l);if(b){if(!b.main&&!b.browser)continue;i.push(this.j({id:b.identifier,reason:n.reason}));continue}const c=r.displayName||r.identifier.value,m=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${l}'`),v=this.k(n,r.displayName,[],new w(m));return this.c.onExtensionActivationError(r.identifier,m,new F.$vG(l)),v}return this.k(n,r.displayName,i,null)}k(n,r,i,a){const l=new s(n.id,r,n.reason,i,a,this.c,this.g);return this.d.set(n.id,l),l}l(n){return N.$C$b.isHostExtension(n,this.a,this.b)}m(n){const r=this.b.getExtensionDescription(n);return r?!r.main&&!r.browser:!1}};e.$Ikc=d,e.$Ikc=d=Je([Ve(3,M.$Wj)],d);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(n,r,i,a,l,t,b){this.c=n,this.d=r,this.f=i,this.g=a,this.h=l,this.j=t,this.k=b,this.a=new p.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let n=0;n<this.g.length;n++){const r=this.g[n];if(r.value&&!r.value.activationFailed){this.g.splice(n,1),n--;continue}if(r.value&&r.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);i.detail=r.value.activationFailedError,this.h=new w(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(n=>n.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(n){const r=new Error;if(n&&n.name&&(r.name=n.name),n&&n.message?r.message=`Activating extension '${this.c.value}' failed: ${n.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${n}.`,n&&n.stack&&(r.stack=n.stack),this.h=new w(r),this.b&&I.$4(n))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(n)}}};s=Je([Ve(6,M.$Wj)],s)}),define(Re[228],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[229],Ae([1,0,186,14,33,98,72,30,20,228,196,103]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0;const u=p.$9n.as(M.$0n.JSONContribution);class w{constructor(l,t,b){this.a=l,this.b=t,this.c=b}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(R.default.Error,l)}warn(l){this.d(R.default.Warning,l)}info(l){this.d(R.default.Info,l)}}e.$mG=w;class d{static a(l){const t=new g.$Mm;for(let b=0,c=l.length;b<c;b++)t.add(l[b].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new d(t,[]);if(!t||!t.length)return new d([],l);const b=this.a(l),c=this.a(t),m=t.filter($=>!b.has($.description.identifier)),v=l.filter($=>!c.has($.description.identifier));return new d(m,v)}constructor(l,t){this.added=l,this.removed=t}}e.$nG=d;class s{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=d.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,N.$1)(l)}}}e.$oG=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},n="vscode://schemas/vscode-extensions";e.$pG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$Km},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$No}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$No}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new s(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&k.$dG.register(l.extensionPoint,l.activationEventsGenerator),e.$pG.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,u.registerSchema(n,e.$pG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$qG=r;const i={ExtensionsRegistry:"ExtensionsRegistry"};p.$9n.add(i.ExtensionsRegistry,new r),e.$rG=p.$9n.as(i.ExtensionsRegistry),u.registerSchema(n,e.$pG),u.registerSchema(T.$ek,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Re[230],Ae([1,0,182,17,26,229,31,5]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var D;(function(u){function w(d,s,o){if(!d)return;const n=N.$4f(d.type)?d.type:void 0;if(!n||n.length===0){o.error(I.localize(3,null));return}const r=[];if(Array.isArray(d.required))for(const i of d.required)N.$4f(i)&&r.push(i);return{extensionId:s.value,taskType:n,required:r,properties:d.properties?R.$Wn(d.properties):{},when:d.when?M.$oj.deserialize(d.when):void 0}}u.from=w})(D||(D={}));const T=F.$rG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,w)=>{for(const d of u)d.type&&w.push(`onTaskType:${d.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new p.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,d)=>{T.setHandler((s,o)=>{this.c=void 0;try{for(const n of o.removed){const r=n.value;for(const i of r)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const n of o.added){const r=n.value;for(const i of r){const a=D.from(i,n.description.identifier,n.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const d of this.all()){const s={type:"object",additionalProperties:!1};d.required.length>0&&(s.required=d.required.slice(0)),d.properties!==void 0?s.properties=R.$Wn(d.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[d.taskType]},w.push(s)}this.c={oneOf:w}}return this.c}}e.$UH=new k}),define(Re[231],Ae([1,0,183,17,23,26,31,230]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,I.localize(0,null)),e.$XH=I.localize2(2,"Tasks");var g;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$YH="$customized",function(A){function j(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=j}(g||(e.ShellQuoting=g={}));var D;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var T;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(T||(e.RevealKind=T={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=j}(T||(e.RevealKind=T={}));var k;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=j}(k||(e.RevealProblemKind=k={}));var u;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(u||(e.PanelKind=u={})),function(A){function j(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=j}(u||(e.PanelKind=u={}));var w;(function(A){A.defaults={echo:!0,reveal:T.Always,revealProblems:k.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var d;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(d||(e.RuntimeType=d={})),function(A){function j(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=j;function K(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(d||(e.RuntimeType=d={}));var s;(function(A){function j(K){return N.$4f(K)?K:K.value}A.value=j})(s||(e.CommandString=s={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function j(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=j;function K(ie){if(ie!==void 0)return N.$4f(ie)?j(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=K})(o||(e.TaskGroup=o={}));var n;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(n||(e.TaskScope=n={}));var r;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function j(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=j})(r||(e.TaskSourceKind=r={}));var i;(function(A){A.parallel="parallel",A.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var l;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(j,K,ie,ce,ve,Ie){this._label="",this._id=j,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ve,this._source=Ie}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,K=!1){if(j===void 0)return!1;if(N.$4f(j))return j===this._label||j===this.configurationProperties.identifier||K&&j===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$ZH=t;class b extends t{constructor(j,K,ie,ce,ve,Ie,ue,pe){super(j,ie,void 0,ue,pe,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,ve&&(this.command=ve)}clone(){return new b(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case d.Shell:K="shell";break;case d.Process:K="process";break;case d.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(j){return j instanceof b}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$YH,folder:j,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new b(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$1H=b;class c extends t{constructor(j,K,ie,ce,ve,Ie,ue){super(j,ie,ce,Ie,ue,K),this._source=K,this.configures=ve}static is(j){return j instanceof c}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$YH,folder:j,id:K};return JSON.stringify(ie)}}e.$2H=c;class m extends t{constructor(j,K,ie,ce,ve,Ie,ue,pe,re){super(j,ie,ce,pe,re,K),this.defines=ve,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=re.icon,this.hide=re.hide}clone(){return new m(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof m}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new m(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$3H=m;class v extends t{constructor(j,K,ie,ce,ve,Ie){super(j,ie,ce,ve,Ie,K),this._source=K}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new v(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$4H=v;var $;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(A){A._default=A.Terminal}($||(e.ExecutionEngine=$={}));var h;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(h||(e.JsonSchemaVersion=h={}));class E{constructor(j){this.c=new Map;for(let K=0;K<j.length;K++)this.c.set(j[K].uri.toString(),K)}compare(j,K){const ie=j.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ve=this.c.get(ie.uri.toString());ve=ve===void 0?0:ve+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,ve===Ie?j._label.localeCompare(K._label):ve-Ie}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$5H=E;var f;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(f||(e.TaskEventKind=f={}));var S;(function(A){A.SingleRun="singleRun",A.Background="background"})(S||(e.TaskRunType=S={}));var y;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(A){function j(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function K(pe,re,Se){return{...j(pe),kind:"start",terminalId:re,resolvedVariables:Se}}A.start=K;function ie(pe,re,Se){return{...j(pe),kind:"processStarted",terminalId:re,processId:Se}}A.processStarted=ie;function ce(pe,re,Se){return{...j(pe),kind:"processEnded",terminalId:re,exitCode:Se}}A.processEnded=ce;function ve(pe,re,Se){return{...j(pe),kind:"terminated",exitReason:Se,terminalId:re}}A.terminated=ve;function Ie(pe,re,Se){return{...j(re),kind:pe,terminalId:Se}}A.general=Ie;function ue(){return{kind:"changed"}}A.changed=ue})(C||(e.TaskEvent=C={}));var P;(function(A){function j(ie){const ce=Object.keys(ie).sort();let ve="";for(const Ie of ce){let ue=ie[Ie];ue instanceof Object?ue=j(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ve+=Ie+","+ue+","}return ve}function K(ie){const ve={_key:j(ie),type:ie.taskType};return Object.assign(ve,ie),ve}A.create=K})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(A){function j(K,ie){const ce=p.$UH.get(K.type);if(ce===void 0){const pe=F.$Wn(K);return delete pe._key,P.create(pe)}const ve=Object.create(null);ve.type=ce.taskType;const Ie=new Set;ce.required.forEach(pe=>Ie.add(pe));const ue=ce.properties;for(const pe of Object.keys(ue)){const re=K[pe];if(re!=null)ve[pe]=re;else if(Ie.has(pe)){const Se=ue[pe];if(Se.default!==void 0)ve[pe]=F.$Wn(Se.default);else switch(Se.type){case"boolean":ve[pe]=!1;break;case"number":case"integer":ve[pe]=0;break;case"string":ve[pe]="";break;default:ie.error(I.localize(1,null,JSON.stringify(K,void 0,0),pe));return}}}return P.create(ve)}A.createTaskIdentifier=j})(q||(e.TaskDefinition=q={}))}),define(Re[232],Ae([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=e.$G$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$G$b=N;class R extends N{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$H$b=R}),define(Re[34],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$jw=void 0,e.$kw=R,e.$lw=F;class I{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++I.count}}e.$jw=I;const N=[];function R(p){const g=new I(p);return N[g.nid]=g,g}function F(p){return N[p].sid}class M{constructor(g){this.value=g}}e.$mw=M}),define(Re[4],Ae([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var R;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var F;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var g;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var D;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class k{static{this.a=0}static mixin(o){return o._id=k.a++,o}}e.$OM=k;var u;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var d;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$PM={MainThreadAuthentication:(0,I.$kw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$kw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$kw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$kw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$kw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$kw)("MainThreadClipboard"),MainThreadCommands:(0,I.$kw)("MainThreadCommands"),MainThreadComments:(0,I.$kw)("MainThreadComments"),MainThreadConfiguration:(0,I.$kw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$kw)("MainThreadConsole"),MainThreadDebugService:(0,I.$kw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$kw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$kw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$kw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$kw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$kw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$kw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$kw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$kw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$kw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$kw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$kw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$kw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$kw)("MainThreadLanguages"),MainThreadLogger:(0,I.$kw)("MainThreadLogger"),MainThreadMessageService:(0,I.$kw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$kw)("MainThreadOutputService"),MainThreadProgress:(0,I.$kw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$kw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$kw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$kw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$kw)("MainThreadSecretState"),MainThreadStorage:(0,I.$kw)("MainThreadStorage"),MainThreadSpeech:(0,I.$kw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$kw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$kw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$kw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$kw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$kw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$kw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$kw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$kw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$kw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$kw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$kw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$kw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$kw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$kw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$kw)("MainThreadSCM"),MainThreadSearch:(0,I.$kw)("MainThreadSearch"),MainThreadShare:(0,I.$kw)("MainThreadShare"),MainThreadTask:(0,I.$kw)("MainThreadTask"),MainThreadWindow:(0,I.$kw)("MainThreadWindow"),MainThreadLabelService:(0,I.$kw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$kw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$kw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$kw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$kw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$kw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$kw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$kw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$kw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$kw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$kw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$kw)("MainThreadTimeline"),MainThreadTesting:(0,I.$kw)("MainThreadTesting"),MainThreadLocalization:(0,I.$kw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$kw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$kw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,I.$kw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$kw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$kw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$kw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$kw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$kw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$kw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$kw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$kw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$kw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$kw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$kw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$kw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$kw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$kw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$kw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$kw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$kw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$kw)("ExtHostStatusBar"),ExtHostShare:(0,I.$kw)("ExtHostShare"),ExtHostExtensionService:(0,I.$kw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$kw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$kw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$kw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$kw)("ExtHostSCM"),ExtHostSearch:(0,I.$kw)("ExtHostSearch"),ExtHostTask:(0,I.$kw)("ExtHostTask"),ExtHostWorkspace:(0,I.$kw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$kw)("ExtHostWindow"),ExtHostWebviews:(0,I.$kw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$kw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$kw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$kw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$kw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$kw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$kw)("ExtHostProgress"),ExtHostComments:(0,I.$kw)("ExtHostComments"),ExtHostSecretState:(0,I.$kw)("ExtHostSecretState"),ExtHostStorage:(0,I.$kw)("ExtHostStorage"),ExtHostUrls:(0,I.$kw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$kw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$kw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$kw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$kw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$kw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$kw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$kw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$kw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$kw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$kw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$kw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$kw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$kw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$kw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$kw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$kw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$kw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$kw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$kw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$kw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$kw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$kw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$kw)("ExtHostTimeline"),ExtHostTesting:(0,I.$kw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$kw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$kw)("ExtHostLocalization")}}),define(Re[78],Ae([1,0,3,13,4,16]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=e.$3jc=void 0,e.$3jc=(0,I.$qi)("IExtHostApiDeprecationService");let M=class{constructor(g,D){this.c=D,this.a=new Set,this.b=g.getProxy(R.$PM.MainThreadTelemetry)}report(g,D,T){const k=this.d(g,D);this.a.has(k)||(this.a.add(k),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:g}))}d(g,D){return`${g}-${D.identifier.value}`}};e.$4jc=M,e.$4jc=M=Je([Ve(0,F.$aP),Ve(1,N.$Wj)],M),e.$5jc=Object.freeze(new class{report(p,g,D){}})}),define(Re[233],Ae([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class N{constructor(F){const M=F.getProxy(I.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$fkc=N}),define(Re[234],Ae([1,0,26,4,27,16]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;let M=class{constructor(T,k){this.a=T.getProxy(N.$PM.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,k){const u=this,w=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){u.e(T,k,w,arguments)}})}e(T,k,u,w){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g(w,this.b)}),this.c&&this.f(T,u,w)}};e.$_lc=M,e.$_lc=M=Je([Ve(0,F.$aP),Ve(1,R.$qP)],M);const p=1e5;function g(D,T){const k=[];if(D.length)for(let u=0;u<D.length;u++){let w=D[u];if(typeof w>"u")w="undefined";else if(w instanceof Error){const d=w;d.stack?w=d.stack:w=d.toString()}k.push(w)}if(T){const u=new Error().stack;u&&k.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$2n)(k);return u.length>p?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[235],Ae([1,0,2,4,25]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class F{constructor(p){this.a=p.getProxy(N.$PM.MainThreadDialogs)}showOpenDialog(p,g){return g?.allowUIResources&&(0,R.$yG)(p,"showLocal"),this.a.$showOpenDialog(g).then(D=>D?D.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(g=>g?I.URI.revive(g):void 0)}}e.$clc=F}),define(Re[236],Ae([1,0,6,4]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(N.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$wlc=R}),define(Re[79],Ae([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0;let T=class{constructor(u,w,d){this.f=d,this.d=new Map,this.a=w.getProxy(p.$PM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,w){const{message:d,args:s,comment:o}=w;if(this.c)return(0,N.$5e)(d,s??{});let n=d;o&&o.length>0&&(n+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(u)?.contents[n];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${n}`),(0,N.$5e)(r??d,s??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let w;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(d),o=JSON.parse(s);w=u.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${s.message}`);return}w&&this.d.set(u.identifier.value,{contents:w,uri:d})}async g(u){if(u.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return R.URI.revive(w)}return u.l10n?R.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wkc=T,e.$Wkc=T=Je([Ve(0,g.$qP),Ve(1,D.$aP),Ve(2,M.$Wj)],T),e.$Xkc=(0,F.$qi)("IExtHostLocalizationService")}),define(Re[237],Ae([1,0,13,4,27,16,2,53]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let g=class extends I.$8j{constructor(k,u){super(u.logLevel,u.logsLocation,u.loggers.map(w=>(0,p.$Zh)(w))),this.r=k.getProxy(N.$PM.MainThreadLogger)}$setLogLevel(k,u){u?this.setLogLevel(M.URI.revive(u),k):this.setLogLevel(k)}setVisibility(k,u){super.setVisibility(k,u),this.r.$setVisibility(k,u)}s(k,u,w){return new D(this.r,k,u,w)}};e.$$lc=g,e.$$lc=g=Je([Ve(0,F.$aP),Ve(1,R.$qP)],g);class D extends I.$3j{constructor(k,u,w,d){super(d?.logLevel==="always"),this.r=k,this.s=u,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(k,u){const w=[[k,u]];this.m?this.u(w):this.n.push(...w)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Re[80],Ae([1,0,4,3,6,16,22]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=void 0,e.$Ykc=(0,N.$qi)("IExtHostManagedSockets");let p=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(I.$PM.MainThreadManagedSockets)}setFactory(k,u){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const u=++this.b,w=await this.c.makeConnection(),d=new R.$Tc;return this.d.set(u,new D(u,w,d)),d.add((0,R.$Sc)(()=>this.d.delete(u))),d.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(w.onDidClose(s=>{this.a.$onDidManagedSocketClose(u,s?.stack??s?.message),d.dispose()})),d.add(w.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(u,M.$Ce.wrap(s)))),u}$remoteSocketWrite(k,u){this.d.get(k)?.actual.send(u.buffer)}$remoteSocketEnd(k){const u=this.d.get(k);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Zkc=p,e.$Zkc=p=Je([Ve(0,F.$aP)],p);class g{constructor(k,u){this.socketFactoryId=k,this.makeConnection=u}}class D extends R.$Uc{constructor(k,u,w){super(),this.socketId=k,this.actual=u,this.B(w)}}}),define(Re[238],Ae([1,0,4,13,25]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;function F(p){return p&&p.title}let M=class{constructor(g,D){this.b=D,this.a=g.getProxy(I.$PM.MainThreadMessageService)}showMessage(g,D,T,k,u){const w={source:{identifier:g.identifier,label:g.displayName||g.name}};let d;typeof k=="string"||F(k)?d=[k,...u]:(w.modal=k?.modal,w.useCustom=k?.useCustom,w.detail=k?.detail,d=u),w.useCustom&&(0,R.$yG)(g,"resolvers");const s=[];let o=!1;for(let n=0;n<d.length;n++){const r=d[n];if(typeof r=="string")s.push({title:r,handle:n,isCloseAffordance:!1});else if(typeof r=="object"){const{title:i,isCloseAffordance:a}=r;s.push({title:i,isCloseAffordance:!!a,handle:n}),a&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,r):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,r)}return this.a.$showMessage(D,T,w,s).then(n=>{if(typeof n=="number")return d[n]})}};e.$ylc=M,e.$ylc=M=Je([Ve(1,N.$Wj)],M)}),define(Re[239],Ae([1,0,6,17,2,25,4]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class p{constructor(D){this.b=new Map,this.a=D.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,T,k){if((0,F.$yG)(D,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,k),this.a.$registerProfileContentHandler(T,k.name,k.description,D.identifier.value),(0,I.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(D,T,k,u){const w=this.b.get(D);if(!w)throw new Error(`Unknown handler with id: ${D}`);return w.saveProfile(T,k,u)}async $readProfile(D,T,k){const u=this.b.get(D);if(!u)throw new Error(`Unknown handler with id: ${D}`);return u.readProfile((0,N.$4f)(T)?T:R.URI.revive(T),k)}}e.$Hlc=p}),define(Re[81],Ae([1,0,4,5,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=void 0;class F{constructor(p){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$PM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,g){return this.a.$getPassword(p,g)}store(p,g,D){return this.a.$setPassword(p,g,D)}delete(p,g){return this.a.$deletePassword(p,g)}}e.$Tkc=F,e.$Ukc=(0,R.$qi)("IExtHostSecretState")}),define(Re[240],Ae([1,0,24,6,4]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=void 0;class F{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(R.$PM.MainThreadSpeech)}async $createSpeechToTextSession(p,g,D){const T=this.c.get(p);if(!T)return;const k=new N.$Tc,u=new I.$me;this.d.set(g,u);const w=k.add(T.provideSpeechToTextSession(u.token,D?{language:D}:void 0));k.add(w.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,d)})),k.add(u.token.onCancellationRequested(()=>k.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,g){const D=this.c.get(p);if(!D)return;const T=new N.$Tc,k=new I.$me;this.d.set(g,k);const u=T.add(D.provideKeywordRecognitionSession(k.token));T.add(u.onDidChange(w=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,w)})),T.add(k.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,g,D){const T=F.a++;return this.c.set(T,D),this.b.$registerProvider(T,g,{extension:p,displayName:p.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Olc=F}),define(Re[82],Ae([1,0,4,5,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=e.$Jkc=void 0;class F{constructor(p,g){this.c=g,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,g){this.a.$registerExtensionStorageKeysToSync(p,g)}async initializeExtensionStorage(p,g,D){const T=await this.a.$initializeExtensionStorage(p,g);let k;return T&&(k=this.d(p,g,T)),k||D}setValue(p,g,D){return this.a.$setValue(p,g,D)}$acceptValue(p,g,D){const T=this.d(p,g,D);T&&this.b.fire({shared:p,key:g,value:T})}d(p,g,D){try{return JSON.parse(D)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${p}): ${T}`)}}}e.$Jkc=F,e.$Kkc=(0,R.$qi)("IExtHostStorage")}),define(Re[241],Ae([1,0,6,12,2,4]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(F.$PM.MainThreadUriOpeners)}registerExternalUriOpener(g,D,T,k){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const u=k.schemes.find(w=>!M.a.has(w));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(D,T),this.b.$registerUriOpener(D,k.schemes,g,k.label),(0,I.$Sc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(g,D,T){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const u=R.URI.revive(D);return k.canOpenExternalUri(u,T)}async $openUri(g,D,T){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(R.URI.revive(D.resolvedUri),{sourceUri:R.URI.revive(D.sourceUri)},T)}}e.$5lc=M}),define(Re[242],Ae([1,0,4,2,6,14,20]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class p{static{this.a=0}constructor(D){this.c=new M.$Mm,this.d=new Map,this.b=D.getProxy(I.$PM.MainThreadUrls)}registerUriHandler(D,T){const k=D.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const u=p.a++;return this.c.add(k),this.d.set(u,T),this.b.$registerUriHandler(u,k,D.displayName||D.name),(0,R.$Sc)(()=>{this.c.delete(k),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(D,T){const k=this.d.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(N.URI.revive(T))}catch(u){(0,F.$1)(u)}return Promise.resolve(void 0)}async createAppUri(D){return N.URI.revive(await this.b.$createAppUri(D))}}e.$6lc=p}),define(Re[63],Ae([1,0,5,6,12,26,2,189,211,76,4]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=e.$ukc=void 0,e.$vkc=u,e.$xkc=s,e.$ykc=o;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,l,t,b,c,m,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$be,this._onDidDispose=this.#h.event,this.#e=a,this.#t=l,this.#o=t,this.#n=b,this.#s=c,this.#r=m,this.#l=u(m),this.#d=w(m),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,D.$Gxb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===R.Schemas.https||a.scheme===R.Schemas.http){let l=a.toString();return l.endsWith("/")||(l+="/"),l+" "+D.$Fxb}return D.$Fxb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),F.$1n(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const l=(0,g.$Xnb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const l=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,c,m,v,$,h)=>{const E=M.URI.from({scheme:v||"file",path:decodeURIComponent($)}),f=(0,D.$Gxb)(E,{isRemote:l,authority:t}).toString();return`${c}${f}${h}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,c,m,v,$,h)=>{const E=M.URI.from({scheme:v||"file",path:decodeURIComponent($)}),f=(0,D.$Gxb)(E,{isRemote:l,authority:t}).toString();return`${c}${f}${h}`})}}e.$ukc=k;function u(i){try{const a=(0,p.$Cp)((0,p.$Bp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function w(i){try{const a=(0,p.$Cp)((0,p.$Bp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class d extends N.$Uc{constructor(a,l,t,b,c){super(),this.c=l,this.f=t,this.g=b,this.h=c,this.b=new Map,this.a=a.getProxy(T.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,l,t){const b=this.j(a);if(b){const{message:c}=(0,g.$Ynb)(l,t.value);b._onMessageEmitter.fire(c)}}$onMissingCsp(a,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,l,t){const b=new k(a,this.a,n(l),this.c,this.f,t,this.h);this.b.set(a,b);const c=b._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return b}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$wkc=d;function s(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||r(i,a)}}function n(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>M.URI.from(a))}}function r(i,a){return[...(a?.getWorkspaceFolders()||[]).map(l=>l.uri),i.extensionLocation]}}),define(Re[109],Ae([1,0,5,4,2,12,15,3,16,25]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0;let k=class{static{T=this}static{this.a={focused:!0,active:!0}}getState(w){const d=this.d;return{get focused(){return d.focused},get active(){return(0,D.$yG)(w,"windowActivity"),d.active}}}constructor(w){this.c=new I.$be,this.onDidChangeWindowState=this.c.event,this.d=T.a,this.b=w.getProxy(N.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:d,isActive:s})=>{this.onDidChangeWindowProperty("focused",d),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,d){d!==this.d[w]&&(this.d={...this.d,[w]:d},this.c.fire(this.d))}openUri(w,d){let s;if(typeof w=="string"){s=w;try{w=R.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,M.$3e)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,s,d)}async asExternalUri(w,d){if((0,M.$3e)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(w,d);return R.URI.from(s)}};e.$8lc=k,e.$8lc=k=T=Je([Ve(0,g.$aP)],k),e.$9lc=(0,p.$qi)("IExtHostWindow")}),define(Re[243],Ae([1,0,234,27,16]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;let F=class extends I.$_lc{constructor(p,g){super(p,g)}f(p,g,D){g.apply(console,D)}};e.$hoc=F,e.$hoc=F=Je([Ve(0,R.$aP),Ve(1,N.$qP)],F)}),define(Re[244],Ae([1,0,11,22,24,14,5,6,144,232,34]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$I$b=o,e.$J$b=n;function u(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const w="$$ref$$",d={[w]:-1};class s{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(y,C=null,P=!1){const V=[];return{jsonString:(P?u:JSON.stringify)(y,(q,A)=>{if(typeof A>"u")return d;if(typeof A=="object"){if(A instanceof N.$Ce){const j=V.push(A)-1;return{[w]:j}}if(C)return C(q,A)}return A}),referencedBuffers:V}}function n(y,C,P){return JSON.parse(y,(V,W)=>{if(W){const q=W[w];if(typeof q=="number")return C[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function r(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,P)=>P&&P.$mid===1?y.transformOutgoing(P):P:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},b=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class m extends p.$Uc{static{k=b}static{this.a=3*1e3}constructor(C,P=null,V=null){super(),this[k]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=V,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=T.$jw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Ch(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+m.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+m.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,g.$vn)(C,this.g):C}getProxy(C){const{nid:P,sid:V}=C;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(C,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...A)=>this.U(C,q,A)),q===c?P:W[q])};return new Proxy(Object.create(null),V)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,V=C.length;P<V;P++){const W=C[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,V=$.read(C,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:A,method:j,args:K}=E.deserializeRequestJSONArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(P,q,A,j,K,W===2);break}case 3:case 4:{let{rpcId:A,method:j,args:K}=E.deserializeRequestMixedArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(P,q,A,j,K,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let A=E.deserializeReplyOKJSON(V);this.g&&(A=(0,g.$vn)(A,this.g)),this.O(P,q,A);break}case 10:{const A=E.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,A);break}case 8:{const A=E.deserializeReplyOKVSBuffer(V);this.O(P,q,A);break}case 11:{let A=E.deserializeReplyErrError(V);this.g&&(A=(0,g.$vn)(A,this.g)),this.P(P,q,A);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,V,W,q,A){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,T.$lw)(V)}.${W}(`,q);const j=String(P);let K,ie;if(A){const ve=new R.$me;q.push(ve.token),K=this.Q(V,W,q),ie=()=>ve.cancel()}else K=this.Q(V,W,q),ie=t;this.u[j]=ie;const ce=E.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[j];const Ie=E.serializeReplyOK(P,ve,this.h);this.f?.logOutgoing(Ie.byteLength,P,1,"reply:",ve),this.c.send(Ie)},ve=>{delete this.u[j];const Ie=E.serializeReplyErr(P,ve);this.f?.logOutgoing(Ie.byteLength,P,1,"replyErr:",ve),this.c.send(Ie)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(C,P,V){this.f?.logIncoming(C,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(C,P,V){this.f?.logIncoming(C,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let A;V&&(V.$isError?(A=new Error,A.name=V.name,A.message=V.message,A.stack=V.stack):A=V),q.resolveErr(A)}Q(C,P,V){try{return Promise.resolve(this.S(C,P,V))}catch(W){return Promise.reject(W)}}S(C,P,V){const W=this.m[C];if(!W)throw new Error("Unknown actor "+(0,T.$lw)(C));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$lw)(C));return q.apply(W,V)}U(C,P,V){if(this.j)return new D.$H$b;let W=null;if(V.length>0&&R.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(F.$6());const q=E.serializeRequestArguments(V,this.h),A=++this.t,j=String(A),K=new D.$G$b,ie=new p.$Tc;W&&ie.add(W.onCancellationRequested(()=>{const ve=E.serializeCancel(A);this.f?.logOutgoing(ve.byteLength,A,0,"cancel"),this.c.send(E.serializeCancel(A))})),this.w[j]=new v(K,ie),this.F(A);const ce=E.serializeRequest(A,C,P,q,!!W);return this.f?.logOutgoing(ce.byteLength,A,0,`request: ${(0,T.$lw)(C)}.${P}(`,V),this.c.send(ce),K}}e.$K$b=m;class v{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class ${static alloc(C,P,V){const W=new $(N.$Ce.alloc(V+1+4),0);return W.writeUInt8(C),W.writeUInt32(P),W}static read(C,P){return new $(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let V=0,W=C.length;V<W;V++){const q=C[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)P+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,V=C.length;P<V;P++){const W=C[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let V=0;V<C;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),j=[];for(let K=0;K<q;++K)j.push(this.readVSBuffer());P[V]=new T.$mw(n(A,j,null));break}case 4:P[V]=void 0;break}return P}}var h;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(h||(h={}));class E{static a(C){for(let P=0,V=C.length;P<V;P++)if(C[P]instanceof N.$Ce||C[P]instanceof T.$mw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const V=[];for(let W=0,q=C.length;W<q;W++){const A=C[W];if(A instanceof N.$Ce)V[W]={type:2,value:A};else if(typeof A>"u")V[W]={type:4};else if(A instanceof T.$mw){const{jsonString:j,referencedBuffers:K}=o(A.value,P);V[W]={type:3,value:N.$Ce.fromString(j),buffers:K}}else V[W]={type:1,value:N.$Ce.fromString(r(A,P))}}return{type:1,args:V}}return{type:0,args:r(C,P)}}static serializeRequest(C,P,V,W,q){switch(W.type){case 0:return this.b(C,P,V,W.args,q);case 1:return this.c(C,P,V,W.args,q)}}static b(C,P,V,W,q){const A=N.$Ce.fromString(V),j=N.$Ce.fromString(W);let K=0;K+=$.sizeUInt8(),K+=$.sizeShortString(A),K+=$.sizeLongString(j);const ie=$.alloc(q?2:1,C,K);return ie.writeUInt8(P),ie.writeShortString(A),ie.writeLongString(j),ie.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(C,P,V,W,q){const A=N.$Ce.fromString(V);let j=0;j+=$.sizeUInt8(),j+=$.sizeShortString(A),j+=$.sizeMixedArray(W);const K=$.alloc(q?4:3,C,j);return K.writeUInt8(P),K.writeShortString(A),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readMixedArray(),q=new Array(W.length);for(let A=0,j=W.length;A<j;A++){const K=W[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(C){return $.alloc(5,C,0).buffer}static serializeCancel(C){return $.alloc(6,C,0).buffer}static serializeReplyOK(C,P,V){if(typeof P>"u")return this.d(C);if(P instanceof N.$Ce)return this.e(C,P);if(P instanceof T.$mw){const{jsonString:W,referencedBuffers:q}=o(P.value,V,!0);return this.g(C,W,q)}else return this.f(C,u(P,V))}static d(C){return $.alloc(7,C,0).buffer}static e(C,P){let V=0;V+=$.sizeVSBuffer(P);const W=$.alloc(8,C,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const V=N.$Ce.fromString(P);let W=0;W+=$.sizeLongString(V);const q=$.alloc(9,C,W);return q.writeLongString(V),q.buffer}static g(C,P,V){const W=N.$Ce.fromString(P);let q=0;q+=$.sizeUInt32,q+=$.sizeLongString(W);for(const j of V)q+=$.sizeVSBuffer(j);const A=$.alloc(10,C,q);A.writeUInt32(V.length),A.writeLongString(W);for(const j of V)A.writeBuffer(j);return A.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const V=C.readUInt32(),W=C.readLongString(),q=[];for(let A=0;A<V;++A)q.push(C.readVSBuffer());return new T.$mw(n(W,q,P))}static serializeReplyErr(C,P){const V=P?u(F.$3(P),null):void 0;if(typeof V!="string")return this.h(C);const W=N.$Ce.fromString(V);let q=0;q+=$.sizeLongString(W);const A=$.alloc(11,C,q);return A.writeLongString(W),A.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return $.alloc(12,C,0).buffer}}var f;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var S;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(S||(S={}))}),define(Re[245],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0;const I=function(F){const M=p=>{globalThis.removeEventListener("message",M);const g=p.data;Object.defineProperties(globalThis,{postMessage:{value(D,T){g.postMessage(D,T)}},onmessage:{get(){return g.onmessage},set(D){g.onmessage=D}}}),g.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",M)}.toString();class N extends EventTarget{constructor(F,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${I})('${M}'))`,D=new Blob([g],{type:"application/javascript"}),T=URL.createObjectURL(D),k=new MessageChannel,u=T,w={type:"_newWorker",id:u,port:k.port2,url:T,options:p};F(w,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{F({type:"_terminateWorker",id:u}),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(d){k.port1.onmessage=d}},onmessageerror:{get(){return k.port1.onmessageerror},set(d){k.port1.onmessageerror=d}}}),k.port1.addEventListener("messageerror",d=>{const s=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",d=>{const s=new MessageEvent("message",{data:d.data});this.dispatchEvent(s)}),k.port1.start()}}e.$joc=N}),define(Re[246],Ae([1,0,22,28,12,55,3]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=T,e.$tK=k,e.$rK=(0,M.$qi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${p.join("")}]+`),D=7;function T(w){if(w.scheme!==R.Schemas.vscodeNotebookCell)return;const d=w.fragment.indexOf("s");if(d<0)return;const s=parseInt(w.fragment.substring(0,d).replace(g,""),D),o=(0,I.$Ve)(w.fragment.substring(d+1)).toString();if(!isNaN(s))return{handle:s,notebook:w.with({scheme:o,fragment:null})}}function k(w,d){const s=d.toString(D),n=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,I.$We)(I.$Ce.fromString(w.scheme),!0,!0)}`;return w.with({scheme:R.Schemas.vscodeNotebookCell,fragment:n})}class u{constructor(){this.a=new N.$Bc}getNotebook(d){if(d.scheme===R.Schemas.vscodeNotebookCell){const s=T(d);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$uK=u,(0,F.$os)(e.$rK,u,1)}),define(Re[83],Ae([1,0,22,36,46,69,12,19,21,31,246]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=b,e.$IK=m,e.$JK=v,e.$MK=E,e.$NK=S,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var k;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(k||(e.CellKind=k={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",F.$Hs.latex,F.$Hs.markdown,"image/png","image/jpeg",F.$Hs.text],e.$BK=[F.$Hs.latex,F.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var d;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var n;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(n||(e.NotebookCellsChangeType=n={}));var r;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function ie(re,Se){return(0,T.$tK)(re,Se)}K.generate=ie;function ce(re){return(0,T.$sK)(re)}K.parse=ce;function ve(re,Se){return re.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${Se??""},${re.scheme!==M.Schemas.file?re.scheme:""}`})}K.generateCellOutputUri=ve;function Ie(re){if(re.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const Se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!Se)return;const Le=Se[1]&&Se[1]!==""?Se[1]:void 0,ne=Se[2];return{outputId:Le,notebook:re.with({scheme:ne||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function ue(re,Se,Le){return K.generate(re,Se).with({scheme:Le})}K.generateCellPropertyUri=ue;function pe(re,Se){if(re.scheme===Se)return K.parse(re.with({scheme:K.scheme}))}K.parseCellPropertyUri=pe})(a||(e.CellUri=a={}));const l=K=>g.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$AK){this.e=ce,this.d=[...new Set(ie)].map(ve=>({pattern:ve,matches:N.$kk(l(ve))}))}sort(ie){const ce=new Map(R.Iterable.map(ie,Ie=>[Ie,l(Ie)]));let ve=[];for(const{matches:Ie}of this.d)for(const[ue,pe]of ce)if(Ie(pe)){ve.push(ue),ce.delete(ue);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ve}prioritize(ie,ce){const ve=this.f(ie);if(ve===-1){this.d.unshift({pattern:ie,matches:N.$kk(l(ie))});return}const Ie=new Set(ce.map(pe=>this.f(pe,ve)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ve+1,0,...ue.map(pe=>this.d[pe]));for(let pe=ue.length-1;pe>=0;pe--)this.d.splice(ue[pe],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ve=l(ie);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(ve))return Ie;return-1}}e.$EK=t;function b(K,ie,ce,ve=(Ie,ue)=>Ie===ue){const Ie=[];function ue(Se,Le,ne){if(Le===0&&ne.length===0)return;const U=Ie[Ie.length-1];U&&U.start+U.deleteCount===Se?(U.deleteCount+=Le,U.toInsert.push(...ne)):Ie.push({start:Se,deleteCount:Le,toInsert:ne})}let pe=0,re=0;for(;;){if(pe===K.length){ue(pe,0,ie.slice(re));break}if(re===ie.length){ue(pe,K.length-pe,[]);break}const Se=K[pe],Le=ie[re];if(ve(Se,Le)){pe+=1,re+=1;continue}ce(Le)?(ue(pe,1,[]),pe+=1):(ue(pe,0,[Le]),re+=1)}return Ie}e.$GK=new D.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new D.$Hj("notebookEditorCursorAtLineBoundary","none");var c;(function(K){K.default="default",K.option="option"})(c||(e.NotebookEditorPriority=c={}));function m(K){const ie=K;return!!((typeof ie.include=="string"||N.$lk(ie.include))&&(typeof ie.exclude=="string"||N.$lk(ie.exclude)))}function v(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ve=m(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=m(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$jk(ve,(0,p.$oc)(ce.fsPath).toLowerCase()))return!(Ie&&N.$jk(Ie,(0,p.$oc)(ce.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var $;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})($||(e.CellStatusbarAlignment=$={}));class h{static{this.d="notebook/"}static create(ie){return`${h.d}${ie}`}static parse(ie){if(ie.startsWith(h.d))return ie.substring(h.d.length)}}e.$LK=h;function E(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function S(K){const ie=[];let ce=!1;for(const pe of K)(ie.length===0||ce)&&(ie.push(pe),ce=!0);let ve=P(ie);const Ie=I.$Ce.concat(ie.map(pe=>I.$Ce.wrap(pe))),ue=j(Ie);return ve=ve||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ve}}e.$OK="\x1B[A";const y=e.$OK.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let ie=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$OK.length)return;const Ie=K[ve-1],ue=ce.subarray(0,e.$OK.length);if(ue[0]===y[0]&&ue[1]===y[1]&&ue[2]===y[2]){const pe=Ie.lastIndexOf(C);if(pe===-1)return;ie=!0,K[ve-1]=Ie.subarray(0,pe),K[ve]=ce.subarray(e.$OK.length)}}),ie}function V(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,A=13;function j(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:I.$Ce.fromString(W(V(f.decode(K.buffer))))}}),define(Re[7],Ae([1,0,18,14,54,28,69,15,17,2,35,20,43,102,83]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d){"use strict";var s,o,n,r,i,a,l,t,b,c,m,v,$,h,E,f,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$1O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$ZO=e.$YO=e.$XO=e.$WO=e.ChatLocation=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=dt,e.$QN=J,e.$vO=Mt;function y(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=te;return Reflect.construct(B,Ge,De.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=s=class{static from(...O){let te=O;return new s(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(O){this.#e=O}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=V,e.$RM=V=s=Je([y],V);let W=o=class{static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let De=1;De<O.length;De++){const Ge=O[De];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let De=1;De<O.length;De++){const Ge=O[De];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(O){if(!O)return!1;if(O instanceof o)return!0;const{line:te,character:De}=O;return typeof te=="number"&&typeof De=="number"}static of(O){if(O instanceof o)return O;if(this.isPosition(O))return new o(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,te){if(O<0)throw(0,N.$7)("line must be non-negative");if(te<0)throw(0,N.$7)("character must be non-negative");this.c=O,this.e=te}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,te=0){if(O===null||te===null)throw(0,N.$7)();let De;return typeof O>"u"?De=0:typeof O=="number"?De=O:(De=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,N.$7)();let De;return typeof O>"u"?De=this.line:typeof O=="number"?De=O:(De=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=W,e.$SM=W=o=Je([y],W);let q=n=class{static isRange(O){return O instanceof n?!0:O?W.isPosition(O.start)&&W.isPosition(O.end):!1}static of(O){if(O instanceof n)return O;if(this.isRange(O))return new n(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,te,De,Ge){let Ye,lt;if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(O,te),lt=new W(De,Ge)):W.isPosition(O)&&W.isPosition(te)&&(Ye=W.of(O),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(O){return n.isRange(O)?this.contains(O.start)&&this.contains(O.end):W.isPosition(O)?!(W.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const te=W.Max(O.start,this.c),De=W.Min(O.end,this.e);if(!te.isAfter(De))return new n(te,De)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=W.Min(O.start,this.c),De=W.Max(O.end,this.end);return new n(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,te=this.end){if(O===null||te===null)throw(0,N.$7)();let De;return O?W.isPosition(O)?De=O:(De=O.start||this.start,te=O.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new n(De,te)}toJSON(){return[this.start,this.end]}};e.$TM=q,e.$TM=q=n=Je([y],q);let A=r=class extends q{static isSelection(O){return O instanceof r?!0:O?q.isRange(O)&&W.isPosition(O.anchor)&&W.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,te,De,Ge){let Ye,lt;if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(O,te),lt=new W(De,Ge)):W.isPosition(O)&&W.isPosition(te)&&(Ye=W.of(O),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=A,e.$UM=A=r=Je([y],A);const j=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.host=="string"&&typeof O.port=="number"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,te,De){if(typeof O!="string"||O.length===0)throw(0,N.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,N.$7)("port");typeof De<"u"&&j(De),this.host=O,this.port=Math.round(te),this.connectionToken=De}}e.$VM=K;class ie{static isManagedResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.makeConnection=="function"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,te){this.makeConnection=O,this.connectionToken=te,typeof te<"u"&&j(te)}}e.$WM=ie;class ce extends Error{static NotAvailable(O,te){return new ce(O,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new ce(O,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,te=w.RemoteAuthorityResolverErrorCode.Unknown,De){super(O),this._message=O,this._code=te,this._detail=De,Object.setPrototypeOf(this,ce.prototype)}}e.$XM=ce;var ve;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=i=class{static isTextEdit(O){return O instanceof i?!0:O?q.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new i(O,te)}static insert(O,te){return i.replace(new q(O,O),te)}static delete(O){return i.replace(O,"")}static setEndOfLine(O){const te=new i(new q(new W(0,0),new W(0,0)),"");return te.newEol=O,te}get range(){return this.c}set range(O){if(O&&!q.isRange(O))throw(0,N.$7)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,N.$7)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,N.$7)("newEol");this.f=O}constructor(O,te){this.c=O,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=ue,e.$YM=ue=i=Je([y],ue);let pe=a=class{static isNotebookCellEdit(O){return O instanceof a?!0:O?xe.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,te){return new a(O,te)}static insertCells(O,te){return new a(new xe(O,O),te)}static deleteCells(O){return new a(O,[])}static updateCellMetadata(O,te){const De=new a(new xe(O,O),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(O){const te=new a(new xe(0,0),[]);return te.newNotebookMetadata=O,te}constructor(O,te){this.range=O,this.newCells=te}};e.$ZM=pe,e.$ZM=pe=a=Je([y],pe);class re{static isSnippetTextEdit(O){return O instanceof re?!0:O?q.isRange(O.range)&&ne.isSnippetString(O.snippet):!1}static replace(O,te){return new re(O,te)}static insert(O,te){return re.replace(new q(O,O),te)}constructor(O,te){this.range=O,this.snippet=te}}e.$1M=re;var Se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let Le=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,te,De,Ge){this.c.push({_type:1,from:O,to:te,options:De,metadata:Ge})}createFile(O,te,De){this.c.push({_type:1,from:void 0,to:O,options:te,metadata:De})}deleteFile(O,te,De){this.c.push({_type:1,from:O,to:void 0,options:te,metadata:De})}e(O,te,De){this.c.push({_type:3,metadata:De,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}f(O,te,De,Ge){const Ye=te.start,lt=te.end;(Ye!==lt||De.length>0)&&this.c.push({_type:5,uri:O,index:Ye,count:lt-Ye,cells:De,metadata:Ge})}g(O,te,De,Ge){this.c.push({_type:3,metadata:Ge,uri:O,edit:{editType:3,index:te,metadata:De}})}replace(O,te,De,Ge){this.c.push({_type:2,uri:O,edit:new ue(te,De),metadata:Ge})}insert(O,te,De,Ge){this.replace(O,new q(te,te),De,Ge)}delete(O,te,De){this.replace(O,te,"",De)}has(O){return this.c.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const De of te){if(!De)continue;let Ge,Ye;Array.isArray(De)?(Ge=De[0],Ye=De[1]):Ge=De,pe.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(O,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(O,Ge.newNotebookMetadata,Ye):this.f(O,Ge.range,Ge.newCells,Ye):re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:O,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:O,edit:Ge,metadata:Ye})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===O.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(O){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===O.toString()&&te.push(De.edit);return te}entries(){const O=new F.$Bc;for(const te of this.c)if(te._type===2){let De=O.get(te.uri);De||(De=[te.uri,[]],O.set(te.uri,De)),De[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Le,e.$2M=Le=Je([y],Le);let ne=l=class{static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=l.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this.e++){if(typeof O=="function"){const De=new l;De.e=this.e,O(De),this.e=De.e,O=De.value}else O=l.c(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this.e++){const De=O.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const De=new l;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$3M=ne,e.$3M=ne=l=Je([y],ne);var U;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let be=t=class{static isLocation(O){return O instanceof t?!0:O?q.isRange(O.range)&&D.URI.isUri(O.uri):!1}constructor(O,te){if(this.uri=O,te)if(q.isRange(te))this.range=q.of(te);else if(W.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=be,e.$4M=be=t=Je([y],be);let Te=class{static is(O){return O?typeof O.message=="string"&&O.location&&q.isRange(O.location.range)&&D.URI.isUri(O.location.uri):!1}constructor(O,te){this.location=O,this.message=te}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};e.$5M=Te,e.$5M=Te=Je([y],Te);let Ee=class{constructor(O,te,De=x.Error){if(!q.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,I.$ub)(O.tags,te.tags)&&(0,I.$ub)(O.relatedInformation,te.relatedInformation,Te.isEqual)}};e.$6M=Ee,e.$6M=Ee=Je([y],Ee);let $e=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};e.$7M=$e,e.$7M=$e=Je([y],$e);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let Q=class{constructor(O,te=fe.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$8M=Q,e.$8M=Q=Je([y],Q);let Y=class{constructor(O,te){this.uri=O,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(O=>O.toJSON())}}};e.$9M=Y,e.$9M=Y=Je([y],Y);var he;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var le;(function(B){B[B.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let Ne=b=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,te,De,Ge,Ye){this.name=O,this.kind=te,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),Ge instanceof be?this.location=Ge:De instanceof q&&(this.location=new be(Ge,De)),b.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Ne,e.$0M=Ne=b=Je([y],Ne);let de=c=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(c.validate)}constructor(O,te,De,Ge,Ye){this.name=O,this.detail=te,this.kind=De,this.range=Ge,this.selectionRange=Ye,this.children=[],c.validate(this)}};e.$$M=de,e.$$M=de=c=Je([y],de);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Me=class{constructor(O,te){this.title=O,this.kind=te}};e.$_M=Me,e.$_M=Me=Je([y],Me);let ze=class{static{m=this}static{this.c="."}constructor(O){this.value=O}append(O){return new m(this.value?this.value+m.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+m.c)}};e.$aN=ze,e.$aN=ze=m=Je([y],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let z=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=z,e.$bN=z=Je([y],z);class L{constructor(O,te,De,Ge,Ye,lt){this.kind=O,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$cN=L;class G{constructor(O,te){this.fromRanges=te,this.from=O}}e.$dN=G;class H{constructor(O,te){this.fromRanges=te,this.to=O}}e.$eN=H;var _;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(_||(e.LanguageStatusSeverity=_={}));let se=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};e.$fN=se,e.$fN=se=Je([y],se);let Fe=v=class{#e;static isMarkdownString(O){return O instanceof v?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,te=!1){this.#e=new R.$Nk(O,{supportThemeIcons:te})}get value(){return this.#e.value}set value(O){this.#e.value=O}get isTrusted(){return this.#e.isTrusted}set isTrusted(O){this.#e.isTrusted=O}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(O){this.#e.supportThemeIcons=O}get supportHtml(){return this.#e.supportHtml}set supportHtml(O){this.#e.supportHtml=O}get baseUri(){return this.#e.baseUri}set baseUri(O){this.#e.baseUri=O}appendText(O){return this.#e.appendText(O),this}appendMarkdown(O){return this.#e.appendMarkdown(O),this}appendCodeblock(O,te){return this.#e.appendCodeblock(te??"",O),this}};e.$gN=Fe,e.$gN=Fe=v=Je([y],Fe);let Be=class{constructor(O,te){this.label=O,this.documentation=te}};e.$hN=Be,e.$hN=Be=Je([y],Be);let Qe=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};e.$iN=Qe,e.$iN=Qe=Je([y],Qe);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=_e,e.$jN=_e=Je([y],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let it=class{constructor(O){this.value=O}};e.$kN=it,e.$kN=it=Je([y],it);let nt=class{constructor(O,te,De){this.position=O,this.label=te,this.kind=De}};e.$lN=nt,e.$lN=nt=Je([y],nt);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ft;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=st,e.$mN=st=Je([y],st);let X=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};e.$nN=X,e.$nN=X=Je([y],X);let Z=class{constructor(O,te,De){this.insertText=O,this.range=te,this.command=De}};e.$oN=Z,e.$oN=Z=Je([y],Z);let me=class{constructor(O){this.commands=void 0,this.suppressSuggestions=void 0,this.items=O}};e.$pN=me,e.$pN=me=Je([y],me);var He;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(He||(e.PartialAcceptTriggerKind=He={}));var we;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(we||(e.ViewColumn=we={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,O){return`${k.$Lm.toKey(B)}.${O}`}var Ct;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Ct||(e.TextEditorLineNumbersStyle=Ct={}));var Ut;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Ut||(e.TextDocumentSaveReason=Ut={}));var Yt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Yt||(e.TextEditorRevealType=Yt={}));var Jt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var xt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var Dt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(B){function O(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function O(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=O}(Wt||(e.SyntaxTokenType=Wt={}));let Qt=class{constructor(O,te){if(te&&!D.URI.isUri(te))throw(0,N.$7)("target");if(!q.isRange(O)||O.isEmpty)throw(0,N.$7)("range");this.range=O,this.target=te}};e.$rN=Qt,e.$rN=Qt=Je([y],Qt);let Xe=class{constructor(O,te,De,Ge){this.red=O,this.green=te,this.blue=De,this.alpha=Ge}};e.$sN=Xe,e.$sN=Xe=Je([y],Xe);let ri=class{constructor(O,te){if(te&&!(te instanceof Xe))throw(0,N.$7)("color");if(!q.isRange(O)||O.isEmpty)throw(0,N.$7)("range");this.range=O,this.color=te}};e.$tN=ri,e.$tN=ri=Je([y],ri);let _t=class{constructor(O){if(!O||typeof O!="string")throw(0,N.$7)("label");this.label=O}};e.$uN=_t,e.$uN=_t=Je([y],_t);var ht;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ht||(e.ColorFormat=ht={}));var $t;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var ei;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ei||(e.TerminalExitReason=ei={}));var Zt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Zt||(e.TerminalShellExecutionCommandLineConfidence=Zt={}));class Lt{constructor(O,te,De){if(this.startIndex=O,this.length=te,this.tooltip=De,typeof O!="number"||O<0)throw(0,N.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,N.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,N.$7)("tooltip")}}e.$vN=Lt;class gt{constructor(O){this.uri=O}}e.$wN=gt;class jt{constructor(O){this.terminalCommand=O}}e.$xN=jt;var Xt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Xt||(e.TerminalLocation=Xt={}));class zt{constructor(O){if(this.options=O,typeof O!="object")throw(0,N.$7)("options")}}e.$yN=zt;var Ke;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ke||(e.TaskRevealKind=Ke={}));var oi;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Vt=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(O){switch(O){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,N.$7)("name");this.c=O}get id(){return this.c}};e.$zN=Vt,e.$zN=Vt=$=Je([y],Vt);function qt(B){let O="";for(let te=0;te<B.length;te++)O+=B[te].replace(/,/g,",,")+",";return O}let mt=class{constructor(O,te,De){if(typeof O!="string")throw(0,N.$7)("process");this.e=[],this.c=O,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,N.$7)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const te of this.e)O.push(te);return qt(O)}};e.$AN=mt,e.$AN=mt=Je([y],mt);let Rt=class{constructor(O,te,De){if(this.f=[],Array.isArray(te)){if(!O)throw(0,N.$7)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,N.$7)("command");this.e=O,this.f=te,this.g=De}else{if(typeof O!="string")throw(0,N.$7)("commandLine");this.c=O,this.g=te}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,N.$7)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,N.$7)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)O.push(typeof te=="string"?te:te.value);return qt(O)}};e.$BN=Rt,e.$BN=Rt=Je([y],Rt);var Tt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Tt||(e.ShellQuoting=Tt={}));var Nt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Nt||(e.TaskScope=Nt={}));class ti{constructor(O){this.c=O}computeId(){return"customExecution"+(0,T.$Mg)()}set callback(O){this.c=O}get callback(){return this.c}}e.$CN=ti;let Ht=class{static{h=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(O,te,De,Ge,Ye,lt){this.k=!1,this.l=this.definition=O;let bt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ge,bt=Ye,this.k=!0):te===Nt.Global||te===Nt.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,bt=lt):(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,bt=lt),typeof bt=="string"?(this.r=[bt],this.t=!0):Array.isArray(bt)?(this.r=bt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(O){this.j=O}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof mt?this.l={type:h.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:h.f,id:this.q.computeId()}:this.q instanceof ti?this.l={type:h.c,id:this.q.computeId()}:this.l={type:h.g,id:(0,T.$Mg)()}}get definition(){return this.l}set definition(O){if(O==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=O}get scope(){return this.m}set target(O){this.B(),this.m=O}get name(){return this.o}set name(O){if(typeof O!="string")throw(0,N.$7)("name");this.B(),this.o=O}get execution(){return this.q}set execution(O){O===null&&(O=void 0),this.B(),this.q=O;const te=this.l.type;(h.g===te||h.e===te||h.f===te||h.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(O){if(Array.isArray(O))this.B(),this.r=O,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.B(),this.u=O}get source(){return this.w}set source(O){if(typeof O!="string"||O.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=O}get group(){return this.x}set group(O){O===null&&(O=void 0),this.B(),this.x=O}get detail(){return this.A}set detail(O){O===null&&(O=void 0),this.A=O}get presentationOptions(){return this.y}set presentationOptions(O){O==null&&(O=Object.create(null)),this.B(),this.y=O}get runOptions(){return this.z}set runOptions(O){O==null&&(O=Object.create(null)),this.B(),this.z=O}};e.$DN=Ht,e.$DN=Ht=h=Je([y],Ht);var si;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(si||(e.ProgressLocation=si={}));var At;(function(B){function O(te){const De=te;return(0,g.$8f)(De.value)?De.tooltip&&!(0,g.$4f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=O})(At||(e.ViewBadge=At={}));let Ft=E=class{static isTreeItem(O,te){const De=O;if(De.checkboxState!==void 0){const Ge=(0,g.$8f)(De.checkboxState)?De.checkboxState:(0,g.$6f)(De.checkboxState)&&(0,g.$8f)(De.checkboxState.state)?De.checkboxState.state:void 0,Ye=!(0,g.$8f)(De.checkboxState)&&(0,g.$6f)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Pt.Checked&&Ge!==Pt.Unchecked||Ye!==void 0&&!(0,g.$4f)(Ye))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(O instanceof E)return!0;if(De.label!==void 0&&!(0,g.$4f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$4f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$4f)(De.iconPath)&&!D.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$4f)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,g.$4f)(Ge.light)&&!D.URI.isUri(Ge.light)&&!(0,g.$4f)(Ge.dark)&&!D.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$4f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!D.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$4f)(De.tooltip)&&!(De.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<It.None&&De.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$4f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(O,te=It.None){this.collapsibleState=te,D.URI.isUri(O)?this.resourceUri=O:this.label=O}};e.$EN=Ft,e.$EN=Ft=E=Je([y],Ft);var It;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var Pt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Pt||(e.TreeItemCheckboxState=Pt={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O){this.value=O}};e.$FN=pt,e.$FN=pt=Je([y],pt);class St extends pt{}e.$GN=St;class li extends St{#e;constructor(O){super(""),this.#e=O}asFile(){return this.#e}}e.$HN=li;class Et{constructor(O,te,De,Ge){this.name=O,this.uri=te,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$IN=Et;let hi=class{#e=new Map;constructor(O){for(const[te,De]of O??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(De):this.#e.set(this.#t(te),[De])}}get(O){return this.#e.get(this.#t(O))?.[0]}set(O,te){this.#e.set(this.#t(O),[te])}forEach(O,te){for(const[De,Ge]of this.#e)for(const Ye of Ge)O.call(te,Ye,De,this)}*[Symbol.iterator](){for(const[O,te]of this.#e)for(const De of te)yield[O,De]}#t(O){return O.toLowerCase()}};e.$JN=hi,e.$JN=hi=Je([y],hi);let Gt=class{constructor(O,te,De){this.insertText=O,this.title=te,this.kind=De}};e.$KN=Gt,e.$KN=Gt=Je([y],Gt);var vi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class ii{static{this.c="."}constructor(O){this.value=O}append(...O){return new ii((this.value?[this.value,...O]:O).join(ii.c))}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+ii.c)}}e.$LN=ii,ii.Empty=new ii("");class wi{constructor(O,te,De){this.title=te,this.insertText=O,this.kind=De}}e.$MN=wi;let yt=class{constructor(O,te){this.id=O,this.color=te}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};e.$NN=yt,e.$NN=yt=Je([y],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let $i=class{constructor(O){this.id=O}};e.$ON=$i,e.$ON=$i=Je([y],$i);var ye;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ye||(e.ConfigurationTarget=ye={}));let Pe=class{get base(){return this.c}set base(O){this.c=O,this.e=D.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,te){if(typeof O!="string"&&(!O||!D.URI.isUri(O)&&!D.URI.isUri(O.uri)))throw(0,N.$7)("base");if(typeof te!="string")throw(0,N.$7)("pattern");typeof O=="string"?this.baseUri=D.URI.file(O):D.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=Pe,e.$PN=Pe=Je([y],Pe);const ae=new WeakMap;function J(B,O){ae.set(B,O)}let ke=class{constructor(O,te,De,Ge,Ye){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=ae.get(this)??(0,T.$Mg)()),this.c}};e.$RN=ke,e.$RN=ke=Je([y],ke);let We=class extends ke{constructor(O,te,De,Ge,Ye,lt){if(super(te,De,Ge,Ye,lt),O===null)throw(0,N.$7)("location");this.location=O}};e.$SN=We,e.$SN=We=Je([y],We);let Ze=class extends ke{constructor(O,te,De,Ge,Ye,lt){super(te,De,Ge,Ye,lt),this.functionName=O}};e.$TN=Ze,e.$TN=Ze=Je([y],Ze);let qe=class extends ke{constructor(O,te,De,Ge,Ye,lt,bt,Kt){if(super(Ge,Ye,lt,bt,Kt),!te)throw(0,N.$7)("dataId");this.label=O,this.dataId=te,this.canPersist=De}};e.$UN=qe,e.$UN=qe=Je([y],qe);let ut=class{constructor(O,te,De){this.command=O,this.args=te||[],this.options=De}};e.$VN=ut,e.$VN=ut=Je([y],ut);let kt=class{constructor(O,te){this.port=O,this.host=te}};e.$WN=kt,e.$WN=kt=Je([y],kt);let Ot=class{constructor(O){this.path=O}};e.$XN=Ot,e.$XN=Ot=Je([y],Ot);let Bt=class{constructor(O){this.implementation=O}};e.$YN=Bt,e.$YN=Bt=Je([y],Bt);class at{constructor(O,te,De){this.session=O,this.threadId=te,this.frameId=De}}e.$ZN=at;class ni{constructor(O,te){this.session=O,this.threadId=te}}e.$1N=ni;let di=class{constructor(O,te){this.range=O,this.expression=te}};e.$2N=di,e.$2N=di=Je([y],di);var pi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Si=class{constructor(O,te){this.range=O,this.text=te}};e.$3N=Si,e.$3N=Si=Je([y],Si);let Ai=class{constructor(O,te,De=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=De}};e.$4N=Ai,e.$4N=Ai=Je([y],Ai);let Mi=class{constructor(O,te){this.range=O,this.expression=te}};e.$5N=Mi,e.$5N=Mi=Je([y],Mi);let Ni=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};e.$6N=Ni,e.$6N=Ni=Je([y],Ni);var Ti;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ti||(e.NewSymbolNameTag=Ti={}));class cn{constructor(O,te){this.newSymbolName=O,this.tags=te}}e.$7N=cn;var Fi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Oi=f=class extends Error{static FileExists(O){return new f(O,u.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(O){return new f(O,u.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(O){return new f(O,u.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(O){return new f(O,u.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(O){return new f(O,u.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(O){return new f(O,u.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(O,te=u.FileSystemProviderErrorCode.Unknown,De){super(D.URI.isUri(O)?O.toString(!0):O),this.code=De?.name??"Unknown",(0,u.$_k)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$8N=Oi,e.$8N=Oi=f=Je([y],Oi);let yi=class{constructor(O,te,De){this.start=O,this.end=te,this.kind=De}};e.$9N=yi,e.$9N=yi=Je([y],yi);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Gi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var bi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(bi||(e.CommentState=bi={}));var Ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.$0N=un;function Li(B){return typeof B>"u"||(0,g.$5f)(B)}class zi{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,O){this.m=!0;for(let te=0,De=O.tokenTypes.length;te<De;te++)this.k.set(O.tokenTypes[te],te);for(let te=0,De=O.tokenModifiers.length;te<De;te++)this.l.set(O.tokenModifiers[te],te)}}push(O,te,De,Ge,Ye){if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(O,te,De,Ge,Ye);if(q.isRange(O)&&typeof te=="string"&&Li(De))return this.o(O,te,De);throw(0,N.$7)()}o(O,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,Ye=O.start.character,lt=O.end.character-O.start.character,bt=this.k.get(te);let Kt=0;if(De)for(const ui of De){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ui);Kt|=1<<fi>>>0}this.q(Ge,Ye,lt,bt,Kt)}q(O,te,De,Ge,Ye){if(this.f&&(O<this.c||O===this.c&&te<this.e)){this.f=!1;const Kt=this.g.length/5|0;let ui=0,fi=0;for(let gi=0;gi<Kt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ui,qi+=fi):mi+=ui,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ui=mi,fi=qi}}let lt=O,bt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(bt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=bt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=Ye,this.c=O,this.e=te}static r(O){const te=[],De=O.length/5|0;for(let bt=0;bt<De;bt++)te[bt]=bt;te.sort((bt,Kt)=>{const ui=O[5*bt],fi=O[5*Kt];if(ui===fi){const gi=O[5*bt+1],mi=O[5*Kt+1];return gi-mi}return ui-fi});const Ge=new Uint32Array(O.length);let Ye=0,lt=0;for(let bt=0;bt<De;bt++){const Kt=5*te[bt],ui=O[Kt+0],fi=O[Kt+1],gi=O[Kt+2],mi=O[Kt+3],qi=O[Kt+4],Mn=ui-Ye,ar=Mn===0?fi-lt:fi,Hi=5*bt;Ge[Hi+0]=Mn,Ge[Hi+1]=ar,Ge[Hi+2]=gi,Ge[Hi+3]=mi,Ge[Hi+4]=qi,Ye=ui,lt=fi}return Ge}build(O){return this.f?new Pi(new Uint32Array(this.g),O):new Pi(zi.r(this.g),O)}}e.$$N=zi;class Pi{constructor(O,te){this.resultId=te,this.data=O}}e.$_N=Pi;class ln{constructor(O,te,De){this.start=O,this.deleteCount=te,this.data=De}}e.$aO=ln;class Zi{constructor(O,te){this.resultId=te,this.edits=O}}e.$bO=Zi;var Xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class hn{constructor(O){this.name=O}}e.$cO=hn;let Ui=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$dO=Ui,e.$dO=Ui=Je([y],Ui);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Ci;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Ci||(e.InputBoxValidationSeverity=Ci={}));var ji;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(ji||(e.ExtensionKind=ji={}));class Ue{static validate(O){if(typeof O.badge=="string"){let te=(0,p.$Df)(O.badge,0);if(te<O.badge.length&&(te+=(0,p.$Df)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!yt.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,te,De){this.badge=O,this.tooltip=te,this.color=De}}e.$eO=Ue;let ai=class{constructor(O){this.kind=O}};e.$fO=ai,e.$fO=ai=Je([y],ai);var Bi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Bi||(e.ColorThemeKind=Bi={}));class xe{static isNotebookRange(O){return O instanceof xe?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,te){if(O<0)throw(0,N.$7)("start must be positive");if(te<0)throw(0,N.$7)("end must be positive");O<=te?(this.c=O,this.e=te):(this.c=te,this.e=O)}with(O){let te=this.c,De=this.e;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(De=O.end),te===this.c&&De===this.e?this:new xe(te,De)}}e.$gO=xe;class vt{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>vt.isNotebookCellData(te))}static isNotebookCellData(O){return!0}constructor(O,te,De,Ge,Ye,lt,bt){this.kind=O,this.value=te,this.languageId=De,this.mime=Ge,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=bt,vt.validate(this)}}e.$hO=vt;class dn{constructor(O){this.cells=O}}e.$iO=dn;class ci{static isNotebookCellOutputItem(O){return O instanceof ci?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return ci.json(te,"application/vnd.code.notebook.error")}static stdout(O){return ci.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ci.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new ci(O,te)}static#e=new TextEncoder;static text(O,te=M.$Hs.text){const De=ci.#e.encode(String(O));return new ci(De,te)}static json(O,te="text/x-json"){const De=JSON.stringify(O,void 0,"	");return ci.text(De,te)}constructor(O,te){this.data=O,this.mime=te;const De=(0,M.$Ls)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$jO=ci;class ki{static isNotebookCellOutput(O){return O instanceof ki?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,te=!1){const De=new Set,Ge=new Set;for(let Ye=0;Ye<O.length;Ye++){const lt=O[Ye],bt=(0,M.$Ls)(lt.mime);if(!De.has(bt)||(0,d.$MK)(bt)){De.add(bt);continue}Ge.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?O:O.filter((Ye,lt)=>!Ge.has(lt))}constructor(O,te,De){this.items=ki.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Mg)(),this.metadata=te??De)}}e.$kO=ki;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Ei;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var _i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(O,te){this.text=O,this.alignment=te}}e.$lO=fn;var Wi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(O,te=[]){this.uri=O,this.provides=(0,I.$3b)(te)}}e.$mO=gn;class mn{constructor(O){this.label=O}}e.$nO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Vi=class{constructor(O,te){this.label=O,this.timestamp=te}};e.$oO=Vi,e.$oO=Vi=Je([y],Vi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.$pO=$n;class pn{constructor(O){this.c=O}get autoForwardAction(){return this.c}}e.$qO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var ee;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ee||(e.TestRunProfileKind=ee={}));let oe=class{constructor(O=void 0,te=void 0,De=void 0,Ge=!1){this.include=O,this.exclude=te,this.profile=De,this.continuous=Ge}};e.$rO=oe,e.$rO=oe=Je([y],oe);let Oe=S=class{static diff(O,te,De){const Ge=new S(O);return Ge.expectedOutput=te,Ge.actualOutput=De,Ge}constructor(O){this.message=O}};e.$sO=Oe,e.$sO=Oe=S=Je([y],Oe);let rt=class{constructor(O){this.id=O}};e.$tO=rt,e.$tO=rt=Je([y],rt);class wt{constructor(O,te){this.covered=O,this.total=te,Mt(this)}}e.$uO=wt;function Mt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class Di{static fromDetails(O,te){const De=new wt(0,0),Ge=new wt(0,0),Ye=new wt(0,0);for(const bt of te)if("branches"in bt){De.total+=1,De.covered+=bt.executed?1:0;for(const Kt of bt.branches)Ge.total+=1,Ge.covered+=Kt.executed?1:0}else Ye.total+=1,Ye.covered+=bt.executed?1:0;const lt=new Di(O,De,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(O,te,De,Ge){this.uri=O,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ge}}e.$wO=Di;class Nn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De=[]){this.executed=O,this.location=te,this.branches=De}}e.$xO=Nn;class Tn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De){this.executed=O,this.location=te,this.label=De}}e.$yO=Tn;class Fn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De){this.name=O,this.executed=te,this.location=De}}e.$zO=Fn;var bn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var vn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var wn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn||(e.PortAutoForwardAction=wn={}));class On{constructor(O,te,De,Ge,Ye,lt){this.kind=O,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$AO=On;class Ln{constructor(O){this.uri=O}}e.$BO=Ln;class zn{constructor(O,te){this.original=O,this.modified=te}}e.$CO=zn;class Un{constructor(O,te,De,Ge){this.base=O,this.input1=te,this.input2=De,this.result=Ge}}e.$DO=Un;class jn{constructor(O,te){this.uri=O,this.viewType=te}}e.$EO=jn;class Bn{constructor(O){this.viewType=O}}e.$FO=Bn;class Wn{constructor(O,te){this.uri=O,this.notebookType=te}}e.$GO=Wn;class Vn{constructor(O,te,De){this.original=O,this.modified=te,this.notebookType=De}}e.$HO=Vn;class qn{constructor(){}}e.$IO=qn;class Hn{constructor(O,te){this.uri=O,this.inputBoxUri=te}}e.$JO=Hn;class Gn{constructor(){}}e.$KO=Gn;class Kn{constructor(O){this.textDiffs=O}}e.$LO=Kn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Jn{constructor(O,te){this.label=O,this.values=te}}e.$MO=Jn;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Qn{constructor(O){this.value=typeof O=="string"?new Fe(O):O}}e.$NO=Qn;class Zn{constructor(O,te){this.value=O,this.baseUri=te}}e.$OO=Zn;class Xn{constructor(O,te){this.value=O,this.title=te}}e.$PO=Xn;class Yn{constructor(O){this.value=O}}e.$QO=Yn;class xn{constructor(O){this.value=O}}e.$RO=xn;class _n{constructor(O){this.value=O}}e.$SO=_n;class er{constructor(O,te){this.uri=O,this.edits=Array.isArray(te)?te:[te]}}e.$TO=er;class tr{constructor(O,te,De,Ge){this.prompt=O,this.command=te,this.variables=De,this.participant=Ge}}e.$UO=tr;class ir{constructor(O,te,De,Ge){this.response=O,this.result=te,this.participant=De,this.command=Ge}}e.$VO=ir;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class nr{constructor(O){this.content=O}}e.$WO=nr;class rr{constructor(O,te){this.content=O,this.name=te}}e.$XO=rr;class sr{constructor(O,te){this.content=O,this.name=te}}e.$YO=sr;class Ri extends Error{static NotFound(O){return new Ri(O,Ri.NotFound.name)}static NoPermissions(O){return new Ri(O,Ri.NoPermissions.name)}constructor(O,te,De){super(O,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$ZO=Ri;var Pn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var Cn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Cn||(e.SpeechToTextStatus=Cn={}));var Rn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class or{constructor(O,te){this.text=O,this.range=te}}e.$1O=or;var An;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(Re[247],Ae([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,g){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(M);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(p,g)??[]}getRelatedInformation(M,p,g){return this.c.$getAiRelatedInformation(p,g)}registerRelatedInformationProvider(M,p,g){const D=this.b;return this.b++,this.a.set(D,g),this.c.$registerAiRelatedInformationProvider(D,p),new N.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$2jc=R}),define(Re[84],Ae([1,0,5,4,7,20,106,3,16]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=e.$akc=void 0,e.$akc=(0,p.$qi)("IExtHostAuthentication");let D=class{constructor(u){this.b=new Map,this.c=new I.$be,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=u.getProxy(N.$PM.MainThreadAuthentication)}async getSession(u,w,d,s={}){const o=F.$Lm.toKey(u.identifier),n=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${w} ${n}`,async()=>{await this.a.$ensureProvider(w);const r=u.displayName||u.name;return this.a.$getSession(w,d,o,r,s)})}async getSessions(u,w,d){const s=F.$Lm.toKey(u.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${s} ${o}`,async()=>{await this.a.$ensureProvider(w);const n=u.displayName||u.name;return this.a.$getSessions(w,d,s,n)})}async removeSession(u,w){const d=this.b.get(u);return d?d.provider.removeSession(w):this.a.$removeSession(u,w)}registerAuthenticationProvider(u,w,d,s){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:w,provider:d,options:s??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(n=>this.a.$sendDidChangeSessions(u,n));return this.a.$registerAuthenticationProvider(u,w,s?.supportsMultipleAccounts??!1),new R.$RM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,w,d){const s=this.b.get(u);if(s)return Promise.resolve(s.provider.createSession(w,d));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,w){const d=this.b.get(u);if(d)return Promise.resolve(d.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,w){const d=this.b.get(u);if(d)return Promise.resolve(d.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,w){return u.startsWith(M.$RL)||this.c.fire({provider:{id:u,label:w}}),Promise.resolve()}};e.$bkc=D,e.$bkc=D=Je([Ve(0,g.$aP)],D);class T{constructor(){this.a=new Map}getOrCreate(u,w){const d=this.a.get(u);if(d)return d;const s=w().finally(()=>this.a.delete(u));return this.a.set(u,s),s}}}),define(Re[110],Ae([1,0,2,4,7,3,16,13,18,15,19,25]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=void 0;let w=class{static{u=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(N.$PM.MainThreadDecorations)}registerFileDecorationProvider(s,o){const n=u.c++;this.f.set(n,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(n,o.identifier.value);const r=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(n,null);return}const a=(0,g.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(n,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const l=a.map(c=>({uri:c,rank:(0,D.$9e)(c.path,"/")})),t=(0,g.$zb)(l,(c,m)=>c.rank-m.rank||(0,D.$mf)(c.uri.path,m.uri.path)),b=[];e:for(const c of t){let m;for(const v of c){const $=(0,T.$nc)(v.uri.path);if(m!==$&&(m=$,b.push(v.uri)>=u.d))break e}}this.g.$onDidChange(n,b)});return new R.$RM(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(s,o,n){if(!this.f.has(s))return Object.create(null);const r=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(s);return await Promise.all(o.map(async l=>{try{const{uri:t,id:b}=l,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),n));if(!c)return;try{R.$eO.validate(c),c.badge&&typeof c.badge!="string"&&(0,k.$yG)(a,"codiconDecoration"),r[b]=[c.propagate,c.tooltip,c.badge,c.color]}catch(m){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${m}`)}}catch(t){this.h.error(t)}})),r}};e.$alc=w,e.$alc=w=u=Je([Ve(0,M.$aP),Ve(1,p.$Wj)],w),e.$blc=(0,F.$qi)("IExtHostDecorations")}),define(Re[248],Ae([1,0,14,2,7,4,12,24,15]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class D{static{this.a=0}constructor(k,u,w){this.d=u,this.e=w,this.b=new Map,this.c=k.getProxy(F.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,u){if(Object.keys(M.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const w=D.a++;this.b.set(w,u),this.c.$registerTextContentProvider(w,k);let d;if(typeof u.onDidChange=="function"){let s;d=u.onDidChange(async o=>{if(o.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const n=this.$provideTextDocumentContent(w,o).then(async r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,g.$gf)(r);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,r)}).catch(I.$1).finally(()=>{s===n&&(s=void 0)});s=n})}return new R.$RM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(k,u){const w=this.b.get(k);return w?Promise.resolve(w.provideTextDocumentContent(N.URI.revive(u),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$dlc=D}),define(Re[111],Ae([1,0,56,12,15,303,152,7,18]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0,e.$cP=T;const D=new Map;function T(d,s){s?D.set(d,s):D.delete(d)}function k(d){return D.get(d)}class u extends F.$Pv{constructor(s,o,n,r,i,a,l){super(o,n,r,i),this.c=s,this.m=a,this.q=l,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,g.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===N.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,n){return s.y(o,n)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,I.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,I.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const n=this.g,r=o.start.line,i=o.end.line,a=[];a.push(this.f[r].substring(o.start.character));for(let l=r+1;l<i;l++)a.push(this.f[l]);return a.push(this.f[i].substring(0,o.end.character)),a.join(n)}t(s){let o;if(s instanceof p.$SM?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),n=this.f[o.index].length;return new p.$SM(o.index,Math.min(o.remainder,n))}w(s){if(!(s instanceof p.$TM))throw new Error("Invalid argument");const o=this.x(s.start),n=this.x(s.end);return o===s.start&&n===s.end?s:new p.$TM(o.line,o.character,n.line,n.character)}x(s){if(!(s instanceof p.$SM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:n}=s,r=!1;if(o<0)o=0,n=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,n=this.f[o].length,r=!0;else{const i=this.f[o].length;n<0?(n=0,r=!0):n>i&&(n=i,r=!0)}return r?new p.$SM(o,n):s}y(s,o){const n=this.x(s);if(!o)o=k(this.m);else if((0,R.$ff)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,M.$Zs)(n.character+1,(0,M.$Xs)(o),this.f[n.line],0);if(r)return new p.$TM(n.line,r.startColumn-1,n.line,r.endColumn-1)}}e.$dP=u;class w{constructor(s,o,n){this.a=s,this.b=o,this.c=n}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eP=w}),define(Re[249],Ae([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(M);if(!D)throw new Error("Embedding vector provider not found");const T=await D.provideEmbeddingVector(p,g);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(M,p,g){const D=this.b;return this.b++,this.a.set(D,g),this.c.$registerAiEmbeddingVectorProvider(p,D),new N.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$flc=R}),define(Re[64],Ae([1,0,4,43,7,22,3,16,44,6,11,23,12]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$qkc=void 0;let d=w=class{constructor(o,n){this.b=new Map,this.c=new T.$zh,this.a=o.getProxy(I.$PM.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(i){try{let a;const l=r.b.get(i.scheme);return l?(await r.a.$ensureActivation(i.scheme),a=await l.impl.stat(i)):a=await r.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===N.FilePermission.Readonly?1:void 0}}catch(a){w.e(a)}},async readDirectory(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await r.a.$readdir(i)}catch(a){return w.e(a)}},async createDirectory(i){try{const a=r.b.get(i.scheme);return a&&!a.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(a.impl,a.extUri,i)):await r.a.$mkdir(i)}catch(a){return w.e(a)}},async readFile(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await r.a.$readFile(i)).buffer}catch(a){return w.e(a)}},async writeFile(i,a){try{const l=r.b.get(i.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(l.impl,l.extUri,l.extUri.dirname(i)),await r.c.queueFor(i,()=>Promise.resolve(l.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await r.a.$writeFile(i,F.$Ce.wrap(a))}catch(l){return w.e(l)}},async delete(i,a){try{const l=r.b.get(i.scheme);return l&&!l.isReadonly&&!a?.useTrash?(await r.a.$ensureActivation(i.scheme),await l.impl.delete(i,{recursive:!1,...a})):await r.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(l){return w.e(l)}},async rename(i,a,l){try{return await r.a.$rename(i,a,{overwrite:!1,...l})}catch(t){return w.e(t)}},async copy(i,a,l){try{return await r.a.$copy(i,a,{overwrite:!1,...l})}catch(t){return w.e(t)}},isWritableFileSystem(i){const a=n.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,n,r){const i=[];for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&N.FileType.Directory))throw R.$8N.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(N.$al(a)!==N.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(r)),r=n.dirname(r)}for(let a=i.length-1;a>=0;a--){r=n.joinPath(r,i[a]);try{await o.createDirectory(r)}catch(l){if(N.$al(l)!==N.FileSystemProviderErrorCode.FileExists)throw l}}}static e(o){if(o instanceof R.$8N)throw o;if(o instanceof N.$9k)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw R.$8N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$8N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$8N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$8N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$8N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$8N.Unavailable(o.message);default:throw new R.$8N(o.message,o.name)}if(!(o instanceof Error))throw new R.$8N(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$8N.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw R.$8N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$8N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$8N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$8N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$8N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$8N.Unavailable(o.message);default:throw new R.$8N(o.message,o.name)}}addFileSystemProvider(o,n,r){return this.b.set(o,{impl:n,extUri:r?.isCaseSensitive?k.$Tg:k.$Vg,isReadonly:!!r?.isReadonly}),(0,D.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??k.$Tg}};e.$qkc=d,e.$qkc=d=w=Je([Ve(0,p.$aP),Ve(1,g.$7jc)],d),e.$rkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(Re[85],Ae([1,0,3,27,13,64,2]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=e.$skc=void 0,e.$skc=(0,I.$qi)("IExtensionStoragePaths");let p=class{constructor(D,T,k){this.d=T,this.f=k,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(D){return M.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,T=await this.g(D);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(M.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this.c)return M.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return M.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$tkc=p,e.$tkc=p=Je([Ve(0,N.$qP),Ve(1,R.$Wj),Ve(2,F.$rkc)],p)}),define(Re[250],Ae([1,0,7,16,5]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;let F=class{constructor(p){this.a=new I.$fO(I.ColorThemeKind.Dark),this.b=new R.$be}get activeColorTheme(){return this.a}$onColorThemeChange(p){let g;switch(p){case"light":g=I.ColorThemeKind.Light;break;case"hcDark":g=I.ColorThemeKind.HighContrast;break;case"hcLight":g=I.ColorThemeKind.HighContrastLight;break;default:g=I.ColorThemeKind.Dark}this.a=new I.$fO(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1lc=F,e.$1lc=F=Je([Ve(0,N.$aP)],F)}),define(Re[86],Ae([1,0,24,5,6,174,3,13,204,4,27,16,7]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pCb=e.$oCb=e.TunnelDtoConverter=void 0;class w extends g.$cw{}var d;(function(o){function n(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=n;function r(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==g.TunnelPrivacyId.ConstantPrivate&&i.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=r})(d||(e.TunnelDtoConverter=d={})),e.$oCb=(0,M.$qi)("IExtHostTunnelService");let s=class extends R.$Uc{constructor(n,r,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=n.getProxy(D.$PM.MainThreadTunnelService)}async openTunnel(n,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const i=await this.a.$openTunnel(r,n.displayName);if(i){const a=new w(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(n,r){n.portRange===void 0&&n.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:n,provider:r}),this.a.$registerPortsAttributesProvider(n,i),new u.$RM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(n,r,i,a,l){const t=[];for(const c of n){const m=this.r.get(c);if(!m)return[];t.push(...await Promise.all(r.map(async v=>{let $;try{$=await m.provider.providePortAttributes({port:v,pid:i,commandLine:a},l)}catch{$=await m.provider.providePortAttributes(v,i,a,l)}return{providedAttributes:$,port:v}})))}const b=t.filter(c=>!!c.providedAttributes);return b.length>0?b.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(n){}registerTunnelProvider(n,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,l)=>await n.provideTunnel(a,l,I.CancellationToken.None)??void 0;const i=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions,protocol:r.tunnelFeatures.protocol===void 0?!0:r.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(n,r){if(n){n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.f=n.showCandidatePort,this.a.$setCandidateFilter());const i=n.tunnelFactory??(r?this.w(r):void 0);if(i){this.b=i;let a=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const l=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(n){}async $closeTunnel(n,r){if(this.g.has(n.host)){const i=this.g.get(n.host);i.has(n.port)&&(r&&i.get(n.port).disposeListener.dispose(),await i.get(n.port).tunnel.dispose(),i.delete(n.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(n,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(n,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(n.remoteAddress.host)||this.g.set(n.remoteAddress.host,new Map);const l=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:a,disposeListener:l}),d.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(n){const r=await Promise.all(n.map(a=>this.f(a.host,a.port,a.detail??""))),i=n.filter((a,l)=>r[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$pCb=s,e.$pCb=s=Je([Ve(0,k.$aP),Ve(1,T.$qP),Ve(2,p.$Wj)],s)}),define(Re[8],Ae([1,0,18,22,132,251,54,28,124,53,69,26,127,23,17,2,29,87,100,105,104,214,83,50,61,225,25,7]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b,c,m,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$0O=K,e.$$O=ce,e.$_O=ve;var h;(function(ye){function Pe(J){const{selectionStartLineNumber:ke,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:qe}=J,ut=new $.$SM(ke-1,We-1),kt=new $.$SM(Ze-1,qe-1);return new $.$UM(ut,kt)}ye.to=Pe;function ae(J){const{anchor:ke,active:We}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ye.from=ae})(h||(e.Selection=h={}));var E;(function(ye){function Pe(J){if(!J)return;const{start:ke,end:We}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ye.from=Pe;function ae(J){if(!J)return;const{startLineNumber:ke,startColumn:We,endLineNumber:Ze,endColumn:qe}=J;return new $.$TM(ke-1,We-1,Ze-1,qe-1)}ye.to=ae})(E||(e.Range=E={}));var f;(function(ye){function Pe(J){return{uri:J.uri,range:E.from(J.range)}}ye.from=Pe;function ae(J){return new $.$4M(s.URI.revive(J.uri),E.to(J.range))}ye.to=ae})(f||(e.Location=f={}));var S;(function(ye){function Pe(ae){switch(ae){case 1:return $.StandardTokenType.Comment;case 0:return $.StandardTokenType.Other;case 3:return $.StandardTokenType.RegEx;case 2:return $.StandardTokenType.String}}ye.to=Pe})(S||(e.TokenType=S={}));var y;(function(ye){function Pe(J){return new $.$SM(J.lineNumber-1,J.column-1)}ye.to=Pe;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}ye.from=ae})(y||(e.Position=y={}));var C;(function(ye){function Pe(ke,We,Ze){return(0,I.$Hb)((0,I.$3b)(ke).map(qe=>ae(qe,We,Ze)))}ye.from=Pe;function ae(ke,We,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,We),pattern:me.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function J(ke,We){return We&&typeof ke=="string"?We.transformOutgoingScheme(ke):ke}})(C||(e.DocumentSelector=C={}));var P;(function(ye){function Pe(J){switch(J){case $.DiagnosticTag.Unnecessary:return 1;case $.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function ae(J){switch(J){case 1:return $.DiagnosticTag.Unnecessary;case 2:return $.DiagnosticTag.Deprecated;default:return}}ye.to=ae})(P||(e.DiagnosticTag=P={}));var V;(function(ye){function Pe(J){let ke;return J.code&&((0,d.$4f)(J.code)||(0,d.$8f)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...E.from(J.range),message:J.message,source:J.source,code:ke,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(P.from)):void 0}}ye.from=Pe;function ae(J){const ke=new $.$6M(E.to(J),J.message,q.to(J.severity));return ke.source=J.source,ke.code=(0,d.$4f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),ke.tags=J.tags&&(0,I.$Hb)(J.tags.map(P.to)),ke}ye.to=ae})(V||(e.Diagnostic=V={}));var W;(function(ye){function Pe(J){return{...E.from(J.location.range),message:J.message,resource:J.location.uri}}ye.from=Pe;function ae(J){return new $.$5M(new $.$4M(J.resource,E.to(J)),J.message)}ye.to=ae})(W||(e.DiagnosticRelatedInformation=W={}));var q;(function(ye){function Pe(J){switch(J){case $.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case $.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case $.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case $.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}ye.from=Pe;function ae(J){switch(J){case r.MarkerSeverity.Info:return $.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return $.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return $.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return $.DiagnosticSeverity.Hint;default:return $.DiagnosticSeverity.Error}}ye.to=ae})(q||(e.DiagnosticSeverity=q={}));var A;(function(ye){function Pe(J){return typeof J=="number"&&J>=$.ViewColumn.One?J-1:J===$.ViewColumn.Beside?m.$OD:m.$ND}ye.from=Pe;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=ae})(A||(e.ViewColumn=A={}));function j(ye){return typeof ye.range<"u"}function K(ye){return ye.length===0?!0:!!j(ye[0])}var ie;(function(ye){function Pe(qe){return qe.map(ye.from)}ye.fromMany=Pe;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(ae(qe)){const{language:at,value:ni}=qe;ut={value:"```"+at+`
`+ni+"\n```\n"}}else $.$gN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Ot=at=>{try{let ni=s.URI.parse(at,!0);ni=ni.with({query:ke(ni.query,kt)}),kt[at]=ni}catch{}return""},Bt=new g.marked.Renderer;return Bt.link=Ot,Bt.image=at=>typeof at=="string"?Ot(M.$Vk(at).href):"",(0,g.marked)(ut.value,{renderer:Bt}),ut}ye.from=J;function ke(qe,ut){if(!qe)return qe;let kt;try{kt=(0,D.$Yh)(qe)}catch{}if(!kt)return qe;let Ot=!1;return kt=(0,k.$Yn)(kt,Bt=>{if(s.URI.isUri(Bt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[at]=Bt,Ot=!0,at}else return}),Ot?JSON.stringify(kt):qe}function We(qe){const ut=new $.$gN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}ye.to=We;function Ze(qe){if(qe)return typeof qe=="string"?qe:ye.from(qe)}ye.fromStrict=Ze})(ie||(e.MarkdownString=ie={}));function ce(ye){return K(ye)?ye.map(Pe=>({range:E.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?ie.fromMany(Pe.hoverMessage):Pe.hoverMessage?ie.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:E.from(Pe)}))}function ve(ye){return typeof ye>"u"?ye:typeof ye=="string"?s.URI.file(ye):ye}var Ie;(function(ye){function Pe(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ve(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ye.from=Pe})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var ue;(function(ye){function Pe(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ve(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ie.from(ae.before):void 0,after:ae.after?Ie.from(ae.after):void 0}}ye.from=Pe})(ue||(e.ThemableDecorationRenderOptions=ue={}));var pe;(function(ye){function Pe(ae){if(typeof ae>"u")return ae;switch(ae){case $.DecorationRangeBehavior.OpenOpen:return 0;case $.DecorationRangeBehavior.ClosedClosed:return 1;case $.DecorationRangeBehavior.OpenClosed:return 2;case $.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(pe||(e.DecorationRangeBehavior=pe={}));var re;(function(ye){function Pe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?pe.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?ue.from(ae.light):void 0,dark:ae.dark?ue.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ve(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ie.from(ae.before):void 0,after:ae.after?Ie.from(ae.after):void 0}}ye.from=Pe})(re||(e.DecorationRenderOptions=re={}));var Se;(function(ye){function Pe(J){return{text:J.newText,eol:J.newEol&&ft.from(J.newEol),range:E.from(J.range)}}ye.from=Pe;function ae(J){const ke=new $.$YM(E.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:ft.to(J.eol),ke}ye.to=ae})(Se||(e.TextEdit=Se={}));var Le;(function(ye){function Pe(J,ke){const We={edits:[]};if(J instanceof $.$2M){const Ze=new p.$Cc;for(const qe of J._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$We)(N.$Ce.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),We.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?We.edits.push({resource:qe.uri,textEdit:Se.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?We.edits.push({resource:qe.uri,textEdit:{range:E.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?We.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&We.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Jt.from)}})}return We}ye.from=Pe;function ae(J){const ke=new $.$2M,We=new p.$Bc;for(const Ze of J.edits)if(Ze.textEdit){const qe=Ze,ut=s.URI.revive(qe.resource),kt=E.to(qe.textEdit.range),Ot=qe.textEdit.text,Bt=qe.textEdit.insertAsSnippet;let at;Bt?at=$.$1M.replace(kt,new $.$3M(Ot)):at=$.$YM.replace(kt,Ot);const ni=We.get(ut);ni?ni.push(at):We.set(ut,[at])}else ke.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of We)ke.set(Ze,qe);return ke}ye.to=ae})(Le||(e.WorkspaceEdit=Le={}));var ne;(function(ye){const Pe=Object.create(null);Pe[$.SymbolKind.File]=0,Pe[$.SymbolKind.Module]=1,Pe[$.SymbolKind.Namespace]=2,Pe[$.SymbolKind.Package]=3,Pe[$.SymbolKind.Class]=4,Pe[$.SymbolKind.Method]=5,Pe[$.SymbolKind.Property]=6,Pe[$.SymbolKind.Field]=7,Pe[$.SymbolKind.Constructor]=8,Pe[$.SymbolKind.Enum]=9,Pe[$.SymbolKind.Interface]=10,Pe[$.SymbolKind.Function]=11,Pe[$.SymbolKind.Variable]=12,Pe[$.SymbolKind.Constant]=13,Pe[$.SymbolKind.String]=14,Pe[$.SymbolKind.Number]=15,Pe[$.SymbolKind.Boolean]=16,Pe[$.SymbolKind.Array]=17,Pe[$.SymbolKind.Object]=18,Pe[$.SymbolKind.Key]=19,Pe[$.SymbolKind.Null]=20,Pe[$.SymbolKind.EnumMember]=21,Pe[$.SymbolKind.Struct]=22,Pe[$.SymbolKind.Event]=23,Pe[$.SymbolKind.Operator]=24,Pe[$.SymbolKind.TypeParameter]=25;function ae(ke){return typeof Pe[ke]=="number"?Pe[ke]:6}ye.from=ae;function J(ke){for(const We in Pe)if(Pe[We]===ke)return Number(We);return $.SymbolKind.Property}ye.to=J})(ne||(e.SymbolKind=ne={}));var U;(function(ye){function Pe(J){switch(J){case $.SymbolTag.Deprecated:return 1}}ye.from=Pe;function ae(J){switch(J){case 1:return $.SymbolTag.Deprecated}}ye.to=ae})(U||(e.SymbolTag=U={}));var x;(function(ye){function Pe(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(U.from),containerName:J.containerName,location:fe.from(J.location)}}ye.from=Pe;function ae(J){const ke=new $.$0M(J.name,ne.to(J.kind),J.containerName,fe.to(J.location));return ke.tags=J.tags&&J.tags.map(U.to),ke}ye.to=ae})(x||(e.WorkspaceSymbol=x={}));var be;(function(ye){function Pe(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:E.from(J.range),selectionRange:E.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(U.from)??[]};return J.children&&(ke.children=J.children.map(Pe)),ke}ye.from=Pe;function ae(J){const ke=new $.$$M(J.name,J.detail,ne.to(J.kind),E.to(J.range),E.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ke.tags=J.tags.map(U.to)),J.children&&(ke.children=J.children.map(ae)),ke}ye.to=ae})(be||(e.DocumentSymbol=be={}));var Te;(function(ye){function Pe(J){const ke=new $.$cN(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),E.to(J.range),E.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}ye.to=Pe;function ae(J,ke,We){if(ke=ke??J._sessionId,We=We??J._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:E.from(J.range),selectionRange:E.from(J.selectionRange),tags:J.tags?.map(U.from)}}ye.from=ae})(Te||(e.CallHierarchyItem=Te={}));var Ee;(function(ye){function Pe(ae){return new $.$dN(Te.to(ae.from),ae.fromRanges.map(J=>E.to(J)))}ye.to=Pe})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var $e;(function(ye){function Pe(ae){return new $.$eN(Te.to(ae.to),ae.fromRanges.map(J=>E.to(J)))}ye.to=Pe})($e||(e.CallHierarchyOutgoingCall=$e={}));var fe;(function(ye){function Pe(J){return{range:J.range&&E.from(J.range),uri:J.uri}}ye.from=Pe;function ae(J){return new $.$4M(s.URI.revive(J.uri),E.to(J.range))}ye.to=ae})(fe||(e.location=fe={}));var Q;(function(ye){function Pe(J){const ke=J,We=J;return{originSelectionRange:ke.originSelectionRange?E.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:We.uri,range:E.from(ke.targetRange?ke.targetRange:We.range),targetSelectionRange:ke.targetSelectionRange?E.from(ke.targetSelectionRange):void 0}}ye.from=Pe;function ae(J){return{targetUri:s.URI.revive(J.uri),targetRange:E.to(J.range),targetSelectionRange:J.targetSelectionRange?E.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?E.to(J.originSelectionRange):void 0}}ye.to=ae})(Q||(e.DefinitionLink=Q={}));var Y;(function(ye){function Pe(J){return{range:E.from(J.range),contents:ie.fromMany(J.contents)}}ye.from=Pe;function ae(J){return new $.$7M(J.contents.map(ie.to),E.to(J.range))}ye.to=ae})(Y||(e.Hover=Y={}));var he;(function(ye){function Pe(J){return{range:E.from(J.range),expression:J.expression}}ye.from=Pe;function ae(J){return new $.$2N(E.to(J.range),J.expression)}ye.to=ae})(he||(e.EvaluatableExpression=he={}));var le;(function(ye){function Pe(J){if(J instanceof $.$3N)return{type:"text",range:E.from(J.range),text:J.text};if(J instanceof $.$4N)return{type:"variable",range:E.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof $.$5N)return{type:"expression",range:E.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function ae(J){switch(J.type){case"text":return{range:E.to(J.range),text:J.text};case"variable":return{range:E.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:E.to(J.range),expression:J.expression}}}ye.to=ae})(le||(e.InlineValue=le={}));var Ne;(function(ye){function Pe(J){return{frameId:J.frameId,stoppedLocation:E.from(J.stoppedLocation)}}ye.from=Pe;function ae(J){return new $.$6N(J.frameId,E.to(J.stoppedLocation))}ye.to=ae})(Ne||(e.InlineValueContext=Ne={}));var de;(function(ye){function Pe(J){return{range:E.from(J.range),kind:J.kind}}ye.from=Pe;function ae(J){return new $.$8M(E.to(J.range),J.kind)}ye.to=ae})(de||(e.DocumentHighlight=de={}));var Ce;(function(ye){function Pe(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}ye.from=Pe;function ae(J){return new $.$9M(s.URI.revive(J.uri),J.highlights.map(de.to))}ye.to=ae})(Ce||(e.MultiDocumentHighlight=Ce={}));var Me;(function(ye){function Pe(ae){switch(ae){case 1:return $.CompletionTriggerKind.TriggerCharacter;case 2:return $.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return $.CompletionTriggerKind.Invoke}}ye.to=Pe})(Me||(e.CompletionTriggerKind=Me={}));var ze;(function(ye){function Pe(ae){return{triggerKind:Me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ye.to=Pe})(ze||(e.CompletionContext=ze={}));var z;(function(ye){function Pe(J){switch(J){case $.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function ae(J){switch(J){case 1:return $.CompletionItemTag.Deprecated}}ye.to=ae})(z||(e.CompletionItemTag=z={}));var L;(function(ye){const Pe=new Map([[$.CompletionItemKind.Method,0],[$.CompletionItemKind.Function,1],[$.CompletionItemKind.Constructor,2],[$.CompletionItemKind.Field,3],[$.CompletionItemKind.Variable,4],[$.CompletionItemKind.Class,5],[$.CompletionItemKind.Interface,7],[$.CompletionItemKind.Struct,6],[$.CompletionItemKind.Module,8],[$.CompletionItemKind.Property,9],[$.CompletionItemKind.Unit,12],[$.CompletionItemKind.Value,13],[$.CompletionItemKind.Constant,14],[$.CompletionItemKind.Enum,15],[$.CompletionItemKind.EnumMember,16],[$.CompletionItemKind.Keyword,17],[$.CompletionItemKind.Snippet,27],[$.CompletionItemKind.Text,18],[$.CompletionItemKind.Color,19],[$.CompletionItemKind.File,20],[$.CompletionItemKind.Reference,21],[$.CompletionItemKind.Folder,23],[$.CompletionItemKind.Event,10],[$.CompletionItemKind.Operator,11],[$.CompletionItemKind.TypeParameter,24],[$.CompletionItemKind.Issue,26],[$.CompletionItemKind.User,25]]);function ae(We){return Pe.get(We)??9}ye.from=ae;const J=new Map([[0,$.CompletionItemKind.Method],[1,$.CompletionItemKind.Function],[2,$.CompletionItemKind.Constructor],[3,$.CompletionItemKind.Field],[4,$.CompletionItemKind.Variable],[5,$.CompletionItemKind.Class],[7,$.CompletionItemKind.Interface],[6,$.CompletionItemKind.Struct],[8,$.CompletionItemKind.Module],[9,$.CompletionItemKind.Property],[12,$.CompletionItemKind.Unit],[13,$.CompletionItemKind.Value],[14,$.CompletionItemKind.Constant],[15,$.CompletionItemKind.Enum],[16,$.CompletionItemKind.EnumMember],[17,$.CompletionItemKind.Keyword],[27,$.CompletionItemKind.Snippet],[18,$.CompletionItemKind.Text],[19,$.CompletionItemKind.Color],[20,$.CompletionItemKind.File],[21,$.CompletionItemKind.Reference],[23,$.CompletionItemKind.Folder],[10,$.CompletionItemKind.Event],[11,$.CompletionItemKind.Operator],[24,$.CompletionItemKind.TypeParameter],[25,$.CompletionItemKind.User],[26,$.CompletionItemKind.Issue]]);function ke(We){return J.get(We)??$.CompletionItemKind.Property}ye.to=ke})(L||(e.CompletionItemKind=L={}));var G;(function(ye){function Pe(ae,J){const ke=new $.$mN(ae.label);return ke.insertText=ae.insertText,ke.kind=L.to(ae.kind),ke.tags=ae.tags?.map(z.to),ke.detail=ae.detail,ke.documentation=M.$Pk(ae.documentation)?ie.to(ae.documentation):ae.documentation,ke.sortText=ae.sortText,ke.filterText=ae.filterText,ke.preselect=ae.preselect,ke.commitCharacters=ae.commitCharacters,o.$kt.isIRange(ae.range)?ke.range=E.to(ae.range):typeof ae.range=="object"&&(ke.range={inserting:E.to(ae.range.insert),replacing:E.to(ae.range.replace)}),ke.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?ke.insertText=new $.$3M(ae.insertText):(ke.insertText=ae.insertText,ke.textEdit=ke.range instanceof $.$TM?new $.$YM(ke.range,ke.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ke.additionalTextEdits=ae.additionalTextEdits.map(We=>Se.to(We))),ke.command=J&&ae.command?J.fromInternal(ae.command):void 0,ke}ye.to=Pe})(G||(e.CompletionItem=G={}));var H;(function(ye){function Pe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}ye.from=Pe;function ae(J){return{label:J.label,documentation:M.$Pk(J.documentation)?ie.to(J.documentation):J.documentation}}ye.to=ae})(H||(e.ParameterInformation=H={}));var _;(function(ye){function Pe(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}ye.from=Pe;function ae(J){return{label:J.label,documentation:M.$Pk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}ye.to=ae})(_||(e.SignatureInformation=_={}));var se;(function(ye){function Pe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(_.from):[]}}ye.from=Pe;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(_.to):[]}}ye.to=ae})(se||(e.SignatureHelp=se={}));var Fe;(function(ye){function Pe(ae,J){const ke=new $.$lN(y.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&Qe.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(Se.to),ke.tooltip=M.$Pk(J.tooltip)?ie.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}ye.to=Pe})(Fe||(e.InlayHint=Fe={}));var Be;(function(ye){function Pe(ae,J){const ke=new $.$kN(J.label);return ke.tooltip=M.$Pk(J.tooltip)?ie.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(ke.command=ae.fromInternal(J.command)),J.location&&(ke.location=fe.to(J.location)),ke}ye.to=Pe})(Be||(e.InlayHintLabelPart=Be={}));var Qe;(function(ye){function Pe(J){return J}ye.from=Pe;function ae(J){return J}ye.to=ae})(Qe||(e.InlayHintKind=Qe={}));var _e;(function(ye){function Pe(J){return{range:E.from(J.range),url:J.target,tooltip:J.tooltip}}ye.from=Pe;function ae(J){let ke;if(J.url)try{ke=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new $.$rN(E.to(J.range),ke)}ye.to=ae})(_e||(e.DocumentLink=_e={}));var et;(function(ye){function Pe(J){const ke=new $.$uN(J.label);return J.textEdit&&(ke.textEdit=Se.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(We=>Se.to(We))),ke}ye.to=Pe;function ae(J){return{label:J.label,textEdit:J.textEdit?Se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>Se.from(ke)):void 0}}ye.from=ae})(et||(e.ColorPresentation=et={}));var tt;(function(ye){function Pe(J){return new $.$sN(J[0],J[1],J[2],J[3])}ye.to=Pe;function ae(J){return[J.red,J.green,J.blue,J.alpha]}ye.from=ae})(tt||(e.Color=tt={}));var it;(function(ye){function Pe(J){return{range:E.from(J.range)}}ye.from=Pe;function ae(J){return new $.$bN(E.to(J.range))}ye.to=ae})(it||(e.SelectionRange=it={}));var nt;(function(ye){function Pe(ae){switch(ae){case 2:return $.TextDocumentSaveReason.AfterDelay;case 1:return $.TextDocumentSaveReason.Manual;case 3:case 4:return $.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(nt||(e.TextDocumentSaveReason=nt={}));var ct;(function(ye){function Pe(J){switch(J){case $.TextEditorLineNumbersStyle.Off:return 0;case $.TextEditorLineNumbersStyle.Relative:return 2;case $.TextEditorLineNumbersStyle.Interval:return 3;case $.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function ae(J){switch(J){case 0:return $.TextEditorLineNumbersStyle.Off;case 2:return $.TextEditorLineNumbersStyle.Relative;case 3:return $.TextEditorLineNumbersStyle.Interval;case 1:default:return $.TextEditorLineNumbersStyle.On}}ye.to=ae})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ft;(function(ye){function Pe(J){if(J===$.EndOfLine.CRLF)return 1;if(J===$.EndOfLine.LF)return 0}ye.from=Pe;function ae(J){if(J===1)return $.EndOfLine.CRLF;if(J===0)return $.EndOfLine.LF}ye.to=ae})(ft||(e.EndOfLine=ft={}));var je;(function(ye){function Pe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case $.ProgressLocation.SourceControl:return 3;case $.ProgressLocation.Window:return 10;case $.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(je||(e.ProgressLocation=je={}));var st;(function(ye){function Pe(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=X.from(J.kind)),ke}ye.from=Pe;function ae(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=X.to(J.kind)),ke}ye.to=ae})(st||(e.FoldingRange=st={}));var X;(function(ye){function Pe(J){if(J)switch(J){case $.FoldingRangeKind.Comment:return n.$6t.Comment;case $.FoldingRangeKind.Imports:return n.$6t.Imports;case $.FoldingRangeKind.Region:return n.$6t.Region}}ye.from=Pe;function ae(J){if(J)switch(J.value){case n.$6t.Comment.value:return $.FoldingRangeKind.Comment;case n.$6t.Imports.value:return $.FoldingRangeKind.Imports;case n.$6t.Region.value:return $.FoldingRangeKind.Region}}ye.to=ae})(X||(e.FoldingRangeKind=X={}));var Z;(function(ye){function Pe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?E.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.$eF.id:void 0}}ye.from=Pe})(Z||(e.TextEditorOpenOptions=Z={}));var me;(function(ye){function Pe(We){return We instanceof $.$PN?We.toJSON():typeof We=="string"?We:ae(We)||J(We)?new $.$PN(We.baseUri??We.base,We.pattern).toJSON():We}ye.from=Pe;function ae(We){const Ze=We;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(We){return typeof We=="string"?We:new $.$PN(s.URI.revive(We.baseUri),We.pattern)}ye.to=ke})(me||(e.GlobPattern=me={}));var He;(function(ye){function Pe(ae){if(ae){if(Array.isArray(ae))return ae.map(Pe);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ye.from=Pe})(He||(e.LanguageSelector=He={}));var we;(function(ye){function Pe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(We=>We&&typeof We=="object"&&"uri"in We&&s.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof $.$TM)))}ye.is=Pe;function ae(J){return{documents:J.documents.map(ke=>ke.map(We=>({uri:s.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>E.from(Ze))})))}}ye.from=ae})(we||(e.MappedEditsContext=we={}));var ot;(function(ye){function Pe(J){return{start:J.start,end:J.end}}ye.from=Pe;function ae(J){return new $.$gO(J.start,J.end)}ye.to=ae})(ot||(e.NotebookRange=ot={}));var dt;(function(ye){function Pe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ye.to=Pe;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ye.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(ye){function Pe(ae){if(ae===t.NotebookCellExecutionState.Unconfirmed)return $.NotebookCellExecutionState.Pending;if(ae===t.NotebookCellExecutionState.Pending)return;if(ae===t.NotebookCellExecutionState.Executing)return $.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}ye.to=Pe})(Ct||(e.NotebookCellExecutionState=Ct={}));var Ut;(function(ye){function Pe(J){switch(J){case $.NotebookCellKind.Markup:return t.CellKind.Markup;case $.NotebookCellKind.Code:default:return t.CellKind.Code}}ye.from=Pe;function ae(J){switch(J){case t.CellKind.Markup:return $.NotebookCellKind.Markup;case t.CellKind.Code:default:return $.NotebookCellKind.Code}}ye.to=ae})(Ut||(e.NotebookCellKind=Ut={}));var Yt;(function(ye){function Pe(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const We of J.cells)$.$hO.validate(We),ke.cells.push(Jt.from(We));return ke}ye.from=Pe;function ae(J){const ke=new $.$iO(J.cells.map(Jt.to));return(0,d.$eg)(J.metadata)||(ke.metadata=J.metadata),ke}ye.to=ae})(Yt||(e.NotebookData=Yt={}));var Jt;(function(ye){function Pe(J){return{cellKind:Ut.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Dt.from):[]}}ye.from=Pe;function ae(J){return new $.$hO(Ut.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Dt.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}ye.to=ae})(Jt||(e.NotebookCellData=Jt={}));var xt;(function(ye){function Pe(J){return{mime:J.mime,valueBytes:N.$Ce.wrap(J.data)}}ye.from=Pe;function ae(J){return new $.$jO(J.valueBytes.buffer,J.mime)}ye.to=ae})(xt||(e.NotebookCellOutputItem=xt={}));var Dt;(function(ye){function Pe(J){return{outputId:J.id,items:J.items.map(xt.from),metadata:J.metadata}}ye.from=Pe;function ae(J){const ke=J.items.map(xt.to);return new $.$kO(ke,J.outputId,J.metadata)}ye.to=ae})(Dt||(e.NotebookCellOutput=Dt={}));var Wt;(function(ye){function Pe(ke){return J(ke)?{include:me.from(ke.include)??void 0,exclude:me.from(ke.exclude)??void 0}:me.from(ke)??void 0}ye.from=Pe;function ae(ke){return J(ke)?{include:me.to(ke.include),exclude:me.to(ke.exclude)}:me.to(ke)}ye.to=ae;function J(ke){const We=ke;return We?!(0,d.$ag)(We.include)&&!(0,d.$ag)(We.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var Qt;(function(ye){function Pe(ae,J,ke){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===$.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(We,ke),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ye.from=Pe})(Qt||(e.NotebookStatusBarItem=Qt={}));var Xe;(function(ye){function Pe(ae,J,ke){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(We,ke),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}ye.from=Pe})(Xe||(e.NotebookKernelSourceAction=Xe={}));var ri;(function(ye){function Pe(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}ye.from=Pe})(ri||(e.NotebookDocumentContentOptions=ri={}));var _t;(function(ye){function Pe(J){return{uri:J.uri,provides:J.provides}}ye.from=Pe;function ae(J){return new $.$mO(s.URI.revive(J.uri),J.provides)}ye.to=ae})(_t||(e.NotebookRendererScript=_t={}));var ht;(function(ye){function Pe(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:E.from(J.location.range),uri:J.location.uri}}}ye.from=Pe;function ae(J){const ke=new $.$sO(typeof J.message=="string"?J.message:ie.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?fe.to(J.location):void 0,ke}ye.to=ae})(ht||(e.TestMessage=ht={}));var $t;(function(ye){ye.namespace=c.$GL,ye.denamespace=c.$HL})($t||(e.TestTag=$t={}));var ei;(function(ye){function Pe(J){const ke=(0,i.$9O)(J).controllerId;return{extId:b.$BL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(We=>$t.namespace(ke,We.id)),range:o.$kt.lift(E.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}ye.from=Pe;function ae(J){return{parent:void 0,error:void 0,id:b.$BL.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:We}=$t.denamespace(ke);return new $.$tO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:E.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ye.toPlain=ae})(ei||(e.TestItem=ei={})),function(ye){function Pe(J){return{id:J.id}}ye.from=Pe;function ae(J){return new $.$tO(J.id)}ye.to=ae}($t||(e.TestTag=$t={}));var Zt;(function(ye){const Pe=(J,ke)=>{const We=J.value;if(!We)return;const Ze={...ei.toPlain(We.item),parent:ke,taskStates:We.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Pe(qe,Ze);ut&&Ze.children.push(ut)}return Ze};function ae(J){const ke=new u.$2O;for(const qe of J.items)ke.insert(b.$BL.fromString(qe.item.extId).path,qe);const We=[ke.nodes],Ze=[];for(;We.length;)for(const qe of We.pop())qe.value?Ze.push(qe):qe.children&&We.push(qe.children.values());return{completedAt:J.completedAt,results:Ze.map(qe=>Pe(qe)).filter(d.$_f)}}ye.to=ae})(Zt||(e.TestResults=Zt={}));var Lt;(function(ye){function Pe(We){return{covered:We.covered,total:We.total}}function ae(We){return"line"in We?y.from(We):E.from(We)}function J(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ae(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:We.name,count:We.executed,location:ae(We.location)}}ye.fromDetails=J;function ke(We,Ze){return $.$vO(Ze.statementCoverage),$.$vO(Ze.branchCoverage),$.$vO(Ze.declarationCoverage),{id:We,uri:Ze.uri,statement:Pe(Ze.statementCoverage),branch:Ze.branchCoverage&&Pe(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Pe(Ze.declarationCoverage)}}ye.fromFile=ke})(Lt||(e.TestCoverage=Lt={}));var gt;(function(ye){function Pe(ae){switch(ae){case 1:return $.CodeActionTriggerKind.Invoke;case 2:return $.CodeActionTriggerKind.Automatic}}ye.to=Pe})(gt||(e.CodeActionTriggerKind=gt={}));var jt;(function(ye){function Pe(J){const ke=new $.$AO(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),E.to(J.range),E.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}ye.to=Pe;function ae(J,ke,We){if(ke=ke??J._sessionId,We=We??J._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:E.from(J.range),selectionRange:E.from(J.selectionRange),tags:J.tags?.map(U.from)}}ye.from=ae})(jt||(e.TypeHierarchyItem=jt={}));var Xt;(function(ye){function Pe(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}ye.from=Pe})(Xt||(e.ViewBadge=Xt={}));var zt;(function(ye){function Pe(We,Ze,qe){const ut=Ze.fileData;return ut?new $.$HN(new $.$IN(ut.name,s.URI.revive(ut.uri),ut.id,(0,F.$db)(()=>qe(ut.id)))):We===T.$Hs.uriList&&Ze.uriListData?new $.$GN(ke(Ze.uriListData)):new $.$GN(Ze.asString)}ye.to=Pe;async function ae(We,Ze){const qe=await Ze.asString();if(We===T.$Hs.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Ze.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ye.from=ae;function J(We){return R.$Kt.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function ke(We){return R.$Kt.create(We.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(zt||(e.DataTransferItem=zt={}));var Ke;(function(ye){function Pe(J,ke){const We=J.items.map(([Ze,qe])=>[Ze,zt.to(Ze,qe,ke)]);return new $.$JN(We)}ye.toDataTransfer=Pe;async function ae(J){const ke={items:[]},We=[];for(const[Ze,qe]of J)We.push((async()=>{ke.items.push([Ze,await zt.from(Ze,qe)])})());return await Promise.all(We),ke}ye.from=ae})(Ke||(e.DataTransfer=Ke={}));var oi;(function(ye){function Pe(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}ye.from=Pe;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ye.to=ae})(oi||(e.ChatFollowup=oi={}));var Vt;(function(ye){function Pe(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}ye.from=Pe})(Vt||(e.ChatInlineFollowup=Vt={}));var qt;(function(ye){function Pe(J){switch(J.role){case 0:return new $.$WO(J.content);case 1:return new $.$XO(J.content);case 2:return new $.$YO(J.content)}}ye.to=Pe;function ae(J){if(J instanceof $.$WO)return{role:0,content:J.content};if(J instanceof $.$XO)return{role:1,content:J.content};if(J instanceof $.$YO)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}ye.from=ae})(qt||(e.LanguageModelMessage=qt={}));var mt;(function(ye){function Pe(ke){const We={};for(const Ze of Object.keys(ke))We[Ze]=ke[Ze].map(ye.to);return We}ye.objectTo=Pe;function ae(ke){return{level:Rt.to(ke.level),kind:ke.kind,value:(0,s.$wc)(ke.value)?s.URI.revive(ke.value):ke.value,description:ke.description}}ye.to=ae;function J(ke){return{level:Rt.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}ye.from=J})(mt||(e.ChatVariable=mt={}));var Rt;(function(ye){function Pe(J){switch(J){case"short":return $.ChatVariableLevel.Short;case"medium":return $.ChatVariableLevel.Medium;case"full":default:return $.ChatVariableLevel.Full}}ye.to=Pe;function ae(J){switch(J){case $.ChatVariableLevel.Short:return"short";case $.ChatVariableLevel.Medium:return"medium";case $.ChatVariableLevel.Full:default:return"full"}}ye.from=ae})(Rt||(e.ChatVariableLevel=Rt={}));var Tt;(function(ye){function Pe(ae){switch(ae){case 1:return $.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return $.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return $.InteractiveEditorResponseFeedbackKind.Undone;case 3:return $.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return $.InteractiveEditorResponseFeedbackKind.Bug}}ye.to=Pe})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Nt;(function(ye){function Pe(J){return{kind:"markdownContent",content:ie.from(J.value)}}ye.from=Pe;function ae(J){return new $.$NO(ie.to(J.content))}ye.to=ae})(Nt||(e.ChatResponseMarkdownPart=Nt={}));var ti;(function(ye){function Pe(J){const{value:ke,baseUri:We}=J;function Ze(qe,ut){return qe.map(kt=>{const Ot=s.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Ot,children:kt.children&&Ze(kt.children,Ot)}})}return{kind:"treeData",treeData:{label:(0,w.$1g)(We),uri:We,children:Ze(ke,We)}}}ye.from=Pe;function ae(J){const ke=(0,D.$Zh)(J.treeData);function We(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&We(kt.children)}))}const Ze=ke.uri,qe=ke.children?We(ke.children):[];return new $.$OO(qe,Ze)}ye.to=ae})(ti||(e.ChatResponseFilesPart=ti={}));var Ht;(function(ye){function Pe(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:f.from(J.value)}}ye.from=Pe;function ae(J){const ke=(0,D.$Zh)(J);return new $.$PO(s.URI.isUri(ke.inlineReference)?ke.inlineReference:f.to(ke.inlineReference),J.name)}ye.to=ae})(Ht||(e.ChatResponseAnchorPart=Ht={}));var si;(function(ye){function Pe(J){return{kind:"progressMessage",content:ie.from(J.value)}}ye.from=Pe;function ae(J){return new $.$QO(J.content.value)}ye.to=ae})(si||(e.ChatResponseProgressPart=si={}));var At;(function(ye){function Pe(J,ke,We){return{kind:"command",command:ke.toInternal(J.value,We)??{command:J.value.command,title:J.value.title}}}ye.from=Pe;function ae(J,ke){return new $.$RO(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ye.to=ae})(At||(e.ChatResponseCommandButtonPart=At={}));var Ft;(function(ye){function Pe(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>Se.from(ke))}}ye.from=Pe;function ae(J){return new $.$TO(s.URI.revive(J.uri),J.edits.map(ke=>Se.to(ke)))}ye.to=ae})(Ft||(e.ChatResponseTextEditPart=Ft={}));var It;(function(ye){function Pe(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:f.from(J.value.value)}}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:f.from(J.value)}}ye.from=Pe;function ae(J){const ke=(0,D.$Zh)(J),We=Ze=>s.URI.isUri(Ze)?Ze:f.to(Ze);return new $.$SO("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&We(ke.reference.value)}:We(ke.reference))}ye.to=ae})(It||(e.ChatResponseReferencePart=It={}));var Pt;(function(ye){function Pe(ke,We,Ze){return ke instanceof $.$NO?Nt.from(ke):ke instanceof $.$PO?Ht.from(ke):ke instanceof $.$SO?It.from(ke):ke instanceof $.$QO?si.from(ke):ke instanceof $.$OO?ti.from(ke):ke instanceof $.$RO?At.from(ke,We,Ze):ke instanceof $.$TO?Ft.from(ke):{kind:"content",content:""}}ye.from=Pe;function ae(ke,We){switch(ke.kind){case"reference":return It.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,We)}}ye.to=ae;function J(ke,We){switch(ke.kind){case"markdownContent":return Nt.to(ke);case"inlineReference":return Ht.to(ke);case"progressMessage":return;case"treeData":return ti.to(ke);case"command":return At.to(ke,We)}}ye.toContent=J})(Pt||(e.ChatResponsePart=Pt={}));var pt;(function(ye){function Pe(J,ke){return"markdownContent"in ke?((0,v.$yG)(J,"chatParticipantAdditions"),{content:ie.from(ke.markdownContent),kind:"markdownContent"}):"content"in ke?"vulnerabilities"in ke&&ke.vulnerabilities?((0,v.$yG)(J,"chatParticipantAdditions"),{content:ke.content,vulnerabilities:ke.vulnerabilities,kind:"vulnerability"}):typeof ke.content=="string"?{content:ke.content,kind:"content"}:((0,v.$yG)(J,"chatParticipantAdditions"),{content:ie.from(ke.content),kind:"markdownContent"}):"documents"in ke?{documents:ke.documents.map(We=>({uri:We.uri,version:We.version,ranges:We.ranges.map(Ze=>E.from(Ze))})),kind:"usedContext"}:"reference"in ke?{reference:"uri"in ke.reference?{uri:ke.reference.uri,range:E.from(ke.reference.range)}:ke.reference,kind:"reference"}:"inlineReference"in ke?{inlineReference:"uri"in ke.inlineReference?{uri:ke.inlineReference.uri,range:E.from(ke.inlineReference.range)}:ke.inlineReference,name:ke.title,kind:"inlineReference"}:"participant"in ke?((0,v.$yG)(J,"chatParticipantAdditions"),{agentId:ke.participant,command:ke.command,kind:"agentDetection"}):"message"in ke?{content:ie.from(ke.message),kind:"progressMessage"}:void 0}ye.from=Pe;function ae(J,ke){switch(J.kind){case"markdownContent":return{content:J.content.value};case"inlineReference":return{inlineReference:(0,s.$wc)(J.inlineReference)?s.URI.revive(J.inlineReference):f.to(J.inlineReference),title:J.name};case"command":return{command:ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title}};default:return}}ye.toProgressContent=ae})(pt||(e.ChatResponseProgress=pt={}));var St;(function(ye){function Pe(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(Et.to),location:li.to(ae.location)}}ye.to=Pe})(St||(e.ChatAgentRequest=St={}));var li;(function(ye){function Pe(ae){switch(ae){case l.ChatAgentLocation.Notebook:return $.ChatLocation.Notebook;case l.ChatAgentLocation.Terminal:return $.ChatLocation.Terminal;case l.ChatAgentLocation.Panel:return $.ChatLocation.Panel;case l.ChatAgentLocation.Editor:return $.ChatLocation.Editor}}ye.to=Pe})(li||(e.ChatLocation=li={}));var Et;(function(ye){function Pe(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(mt.to)}}ye.to=Pe})(Et||(e.ChatAgentResolvedVariable=Et={}));var hi;(function(ye){function Pe(ae){return{label:ae.label,values:ae.values.map(mt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}ye.from=Pe})(hi||(e.ChatAgentCompletionItem=hi={}));var Gt;(function(ye){function Pe(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}ye.to=Pe})(Gt||(e.ChatAgentResult=Gt={}));var vi;(function(ye){function Pe(ae,J,ke){if(J.action.kind==="vote")return;const We=Gt.to(ae);return J.action.kind==="command"?{action:{kind:"command",commandButton:pt.toProgressContent(J.action.commandButton,ke)},result:We}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:oi.to(J.action.followup)},result:We}:{action:J.action,result:We}}ye.to=Pe})(vi||(e.ChatAgentUserActionEvent=vi={}));var ii;(function(ye){function Pe(ae,J,ke){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,ke)}ye.from=Pe})(ii||(e.TerminalQuickFix=ii={}));var wi;(function(ye){function Pe(ae){return{kind:yt.to(ae.kind)}}ye.to=Pe})(wi||(e.PartialAcceptInfo=wi={}));var yt;(function(ye){function Pe(ae){switch(ae){case 0:return $.PartialAcceptTriggerKind.Word;case 1:return $.PartialAcceptTriggerKind.Line;case 2:return $.PartialAcceptTriggerKind.Suggest;default:return $.PartialAcceptTriggerKind.Unknown}}ye.to=Pe})(yt||(e.PartialAcceptTriggerKind=yt={}));var $i;(function(ye){function Pe(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}ye.from=Pe})($i||(e.DebugTreeItem=$i={}))}),define(Re[252],Ae([1,0,4,16,8,34]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;let M=class{constructor(g,D){this.a=g.getProxy(I.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>D.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,D,T){const k=new F.$mw(R.WorkspaceEdit.from(g,this.b));return this.a.$tryApplyWorkspaceEdit(k,void 0,T?.isRefactoring??!1)}};e.$ckc=M,e.$ckc=M=Je([Ve(0,N.$aP)],M)}),define(Re[253],Ae([1,0,18,11,42,5,46,6,65,17,2,163,20,4,8,7,215,25]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class r{constructor(t,b,c,m,v,$){this.i=t,this.j=b,this.k=c,this.l=m,this.m=v,this.n=$,this.b=g.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let b=function(m){if(t.c){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,m),v}};const t=this;this.b.reset();const c=m=>{typeof this.d>"u"&&"content"in m&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,m)};this.g={markdown(m){b(this.markdown);const v=new s.$NO(m),$=d.ChatResponseMarkdownPart.from(v);return c($),this},filetree(m,v){b(this.filetree);const $=new s.$OO(m,v),h=d.ChatResponseFilesPart.from($);return c(h),this},anchor(m,v){b(this.anchor);const $=new s.$PO(m,v),h=d.ChatResponseAnchorPart.from($);return c(h),this},button(m){b(this.anchor);const v=new s.$RO(m),$=d.ChatResponseCommandButtonPart.from(v,t.m,t.n);return c($),this},progress(m){b(this.progress);const v=new s.$QO(m),$=d.ChatResponseProgressPart.from(v);return c($),this},reference(m){if(b(this.reference),"variableName"in m&&!m.value){const v=t.j.variables.variables.find($=>$.name===m.variableName);if(v){let $;if(v.references?.length)$=v.references.map(h=>({kind:"reference",reference:{variableName:m.variableName,value:h.reference}}));else{const h=new s.$SO(m);$=[d.ChatResponseReferencePart.from(h)]}return $.forEach(h=>c(h)),this}}else{const v=new s.$SO(m),$=d.ChatResponseReferencePart.from(v);c($)}return this},textEdit(m,v){b(this.textEdit),(0,n.$yG)(t.i,"chatParticipantAdditions");const $=new s.$TO(m,v),h=d.ChatResponseTextEditPart.from($);return c(h),this},push(m){if(b(this.push),m instanceof s.$TO&&(0,n.$yG)(t.i,"chatParticipantAdditions"),m instanceof s.$SO)this.reference(m.value);else{const v=d.ChatResponsePart.from(m,t.m,t.n);c(v)}return this},report(m){if(b(this.report),"placeholder"in m&&"resolvedContent"in m)return;const v=d.ChatResponseProgress.from(t.i,m);if(!v){t.l.error("Unknown progress type: "+JSON.stringify(m));return}return c(v),this}}}return this.g}}class i{static{this.b=0}constructor(t,b,c){this.i=b,this.j=c,this.c=new Map,this.g=new p.$4c,this.d=t.getProxy(w.$PM.MainThreadChatAgents2)}transferActiveChat(t){this.d.$transferActiveChatSession(t)}createChatAgent(t,b,c){const m=i.b++,v=new a(t,b,this.d,m,c);return this.c.set(m,v),this.d.$registerAgent(m,t.identifier,b,{},void 0),v.apiAgent}createDynamicChatAgent(t,b,c,m,v){const $=i.b++,h=new a(t,b,this.d,$,v);return this.c.set($,h),this.d.$registerAgent($,t.identifier,b,{isSticky:!0},{name:c,description:m}),h.apiAgent}async $invokeAgent(t,b,c,m){const v=this.c.get(t);if(!v)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let $=this.g.get(b.sessionId);$||($=new p.$Tc,this.g.set(b.sessionId,$));const h=new r(v.extension,b,this.d,this.i,this.j.converter,$);try{const E=await this.k(b.agentId,c),f=v.invoke(d.ChatAgentRequest.to(b),{history:E},h.apiObject,m);return await(0,N.$eh)(Promise.resolve(f).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${v.extension.identifier.value}] [@${v.id}] ${C}`,v.extension),{errorDetails:{message:C},timings:h.timings}}return{errorDetails:S?.errorDetails,timings:h.timings,metadata:S?.metadata}}),m)}catch(E){return this.i.error(E,v.extension),{errorDetails:{message:(0,k.localize)(0,null,(0,R.$bj)(E)),responseIsIncomplete:!0}}}finally{h.close()}}async k(t,b){const c=[];for(const m of b.history){const v=d.ChatAgentResult.to(m.result),$=t===m.request.agentId?v:{...v,metadata:void 0};c.push(new s.$UO(m.request.message,m.request.command,m.request.variables.variables.map(d.ChatAgentResolvedVariable.to),m.request.agentId));const h=(0,I.$Hb)(m.response.map(E=>d.ChatResponsePart.toContent(E,this.j.converter)));c.push(new s.$VO(h,$,m.request.agentId,m.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,b,c,m,v){const $=this.c.get(b);if(!$)return Promise.resolve([]);const h=await this.k($.id,m),E=d.ChatAgentResult.to(c);return(await $.provideFollowups(E,{history:h},v)).filter(f=>{const S=!f.participant||M.Iterable.some(this.c.values(),y=>y.id===f.participant&&u.$Lm.equals(y.extension.identifier,$.extension.identifier));return S||this.i.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),S}).map(f=>d.ChatFollowup.from(f,t))}$acceptFeedback(t,b,c,m){const v=this.c.get(t);if(!v)return;const $=d.ChatAgentResult.to(b);let h;switch(c){case o.InteractiveSessionVoteDirection.Down:h=s.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:h=s.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(m?{result:$,kind:h,reportIssue:m}:{result:$,kind:h}))}$acceptAction(t,b,c){const m=this.c.get(t);if(!m||c.action.kind==="vote")return;const v=d.ChatAgentUserActionEvent.to(b,c,this.j.converter);v&&m.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(t,b,c){const m=this.c.get(t);return m?(await m.invokeCompletionProvider(b,c)).map(d.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,b){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(b)}async $provideSampleQuestions(t,b,c){const m=this.c.get(t);if(m)return(await m.provideSampleQuestions(d.ChatLocation.to(b),c)).map(v=>d.ChatFollowup.from(v,void 0))}}e.$dkc=i;class a{constructor(t,b,c,m,v){this.extension=t,this.id=b,this.u=c,this.w=m,this.x=v,this.n=new F.$be,this.o=new F.$be}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,b){return this.q?await this.q.provider.provideCompletionItems(t,b)??[]:[]}async provideFollowups(t,b,c){if(!this.b)return[];const m=await this.b.provideFollowups(t,b,c);return m?m.filter(v=>!(v&&"commandId"in v)).filter(v=>!(v&&"message"in v)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const b=await this.s.provideWelcomeMessage(t);return b?b.map(c=>typeof c=="string"?c:d.MarkdownString.from(c)):[]}async provideSampleQuestions(t,b){if(!this.s||!this.s.provideSampleQuestions)return[];const c=await this.s.provideSampleQuestions(t,b);return c||[]}get apiAgent(){let t=!1,b=!1;const c=()=>{t||b||(b=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof s.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:d.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),b=!1}))},m=this;return{get id(){return m.id},get fullName(){return(0,n.$yG)(m.extension,"defaultChatParticipant"),m.c??m.extension.displayName??m.extension.name},set fullName(v){(0,n.$yG)(m.extension,"defaultChatParticipant"),m.c=v,c()},get iconPath(){return m.d},set iconPath(v){m.d=v,c()},get requestHandler(){return m.x},set requestHandler(v){(0,D.$bg)(typeof v=="function","Invalid request handler"),m.x=v},get followupProvider(){return m.b},set followupProvider(v){m.b=v,c()},get isDefault(){return(0,n.$yG)(m.extension,"defaultChatParticipant"),m.g},set isDefault(v){(0,n.$yG)(m.extension,"defaultChatParticipant"),m.g=v,c()},get helpTextPrefix(){return(0,n.$yG)(m.extension,"defaultChatParticipant"),m.i},set helpTextPrefix(v){(0,n.$yG)(m.extension,"defaultChatParticipant"),m.i=v,c()},get helpTextVariablesPrefix(){return(0,n.$yG)(m.extension,"defaultChatParticipant"),m.j},set helpTextVariablesPrefix(v){(0,n.$yG)(m.extension,"defaultChatParticipant"),m.j=v,c()},get helpTextPostfix(){return(0,n.$yG)(m.extension,"defaultChatParticipant"),m.k},set helpTextPostfix(v){(0,n.$yG)(m.extension,"defaultChatParticipant"),m.k=v,c()},get isSecondary(){return(0,n.$yG)(m.extension,"defaultChatParticipant"),m.m},set isSecondary(v){(0,n.$yG)(m.extension,"defaultChatParticipant"),m.m=v,c()},get sampleRequest(){return m.l},set sampleRequest(v){m.l=v,c()},get supportIssueReporting(){return(0,n.$yG)(m.extension,"chatParticipantAdditions"),m.p},set supportIssueReporting(v){(0,n.$yG)(m.extension,"chatParticipantAdditions"),m.p=v,c()},get onDidReceiveFeedback(){return m.n.event},set participantVariableProvider(v){if((0,n.$yG)(m.extension,"chatParticipantAdditions"),m.q=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");m.u.$registerAgentCompletionsProvider(m.w,v.triggerCharacters)}else m.u.$unregisterAgentCompletionsProvider(m.w)},get participantVariableProvider(){return(0,n.$yG)(m.extension,"chatParticipantAdditions"),m.q},set welcomeMessageProvider(v){(0,n.$yG)(m.extension,"defaultChatParticipant"),m.s=v,c()},get welcomeMessageProvider(){return(0,n.$yG)(m.extension,"defaultChatParticipant"),m.s},onDidPerformAction:(0,n.$xG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(v){m.t=v,c()},get requester(){return m.t},dispose(){t=!0,m.b=void 0,m.n.dispose(),m.u.$unregisterAgent(m.w)}}}invoke(t,b,c,m){return this.x(t,b,c,m)}}}),define(Re[254],Ae([1,0,14,6,4,8,7,25]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class g{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(R.$PM.MainThreadChatVariables)}async $resolveVariable(k,u,w,d){const s=this.b.get(k);if(s)try{if(s.resolver.resolve2){(0,p.$yG)(s.extension,"chatParticipantAdditions");const o=new D(u,this.c),n=await s.resolver.resolve2(s.data.name,{prompt:w},o.apiObject,d);if(n)return n.map(F.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:w},d);if(o)return o.map(F.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(k,u,w,d){const s=g.a++;return this.b.set(s,{extension:k,data:{name:u,description:w},resolver:d}),this.c.$registerVariable(s,{name:u,description:w}),(0,N.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$ekc=g;class D{constructor(k,u){this.c=k,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(d){if(k.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,d),s}};const k=this,w=d=>{this.d.$handleProgressChunk(this.c,d)};this.b={progress(d){u(this.progress);const s=new M.$QO(d),o=F.ChatResponseProgressPart.from(s);return w(o),this},reference(d){u(this.reference);const s=new M.$SO(d),o=F.ChatResponseReferencePart.from(s);return w(o),this},push(d){return u(this.push),d instanceof M.$SO?w(F.ChatResponseReferencePart.from(d)):d instanceof M.$QO&&w(F.ChatResponseProgressPart.from(d)),this}}}return this.b}}}),define(Re[255],Ae([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=w;function w(d,s,o){const n=d.getProxy(k.$PM.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$Nm,s.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const E=this.b.get(h.handle);return E?E.value:h}else if(h&&h.$mid===7){const E=h,f=this.b.get(E.commentControlHandle);if(!f)return E;const S=f.getCommentThread(E.commentThreadHandle);return S?S.value:E}else if(h&&(h.$mid===9||h.$mid===8)){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const f=E.getCommentThread(h.thread.commentThreadHandle);return f?h.$mid===8?f.value:{thread:f.value,text:h.text}:h}else if(h&&h.$mid===10){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const f=E.getCommentThread(h.thread.commentThreadHandle);if(!f)return h;const S=h.commentUniqueId,y=f.getCommentByUniqueId(S);return y||h}else if(h&&h.$mid===11){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const f=E.getCommentThread(h.thread.commentThreadHandle);if(!f)return h;const S=h.text,y=h.commentUniqueId,C=f.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=S:C.body=new T.$gN(S),C):h}return h}})}createCommentController(h,E,f){const S=r.a++,y=new a(h,S,E,f);this.b.set(y.handle,y);const C=this.c.get(h.identifier)||[];return C.push(y),this.c.set(h.identifier,C),y.value}async $createCommentThreadTemplate(h,E,f){const S=this.b.get(h);S&&S.$createCommentThreadTemplate(E,f)}async $setActiveComment(h,E){const f=this.b.get(h);f&&f.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(h,E,f){const S=this.b.get(h);S&&S.$updateCommentThreadTemplate(E,f)}$deleteCommentThread(h,E){this.b.get(h)?.$deleteCommentThread(E)}async $provideCommentingRanges(h,E,f){const S=this.b.get(h);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(M.URI.revive(E));return(0,I.$ih)(async()=>{const C=await S.commentingRangeProvider.provideCommentingRanges(y.document,f);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(V=>D.Range.from(V)),fileComments:C.fileComments}),P})}$toggleReaction(h,E,f,S,y){const C=this.b.get(h);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$ih)(()=>{const P=C.getCommentThread(E);if(P){const V=P.getCommentByUniqueId(S.uniqueIdInThread);if(C!==void 0&&V&&C.reactionHandler)return C.reactionHandler(V,b(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,typeof h=="object"?((0,u.$yG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=h.resolved,this.b.applicability=h.applicability):this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,E,f,S,y,C,P,V){this.m=E,this.n=f,this.o=S,this.p=y,this.q=C,this.extensionDescription=P,this.r=V,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Vc,this.l.value=new F.$Tc,this.n===void 0&&(this.n=`${h}.${this.handle}`),n.$createCommentThread(E,this.handle,this.n,this.o,D.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{n.$deleteCommentThread(E,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(q){W.range=q},get comments(){return W.comments},set comments(q){W.comments=q},get collapsibleState(){return W.collapsibleState},set collapsibleState(q){W.collapsibleState=q},get canReply(){return W.canReply},set canReply(q){W.canReply=q},get contextValue(){return W.contextValue},set contextValue(q){W.contextValue=q},get label(){return W.label},set label(q){W.label=q},get state(){return W.state},set state(q){W.state=q},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Tc);const h=f=>Object.prototype.hasOwnProperty.call(this.b,f),E={};h("range")&&(E.range=D.Range.from(this.p)),h("label")&&(E.label=this.label),h("contextValue")&&(E.contextValue=this.contextValue??null),h("comments")&&(E.comments=this.q.map(f=>l(this,f,this.k,this.extensionDescription))),h("collapsibleState")&&(E.collapseState=c(this.g)),h("canReply")&&(E.canReply=this.canReply),h("state")&&(E.state=m(this.h)),h("applicability")&&(E.applicability=v(this.h)),h("isTemplate")&&(E.isTemplate=this.r),this.b={},n.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(h){for(const E of this.k){const f=E[0],S=E[1];if(h===S)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Je([(0,N.$Vh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,h?.resourceHints&&(0,u.$yG)(this.h,"commentingRangeHint"),n.$updateCommentingRanges(this.handle,h?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,n.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$yG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$yG)(this.h,"activeComment"),this.f}constructor(h,E,f,S){this.h=h,this.i=E,this.j=f,this.k=S,this.a=new Map,n.$registerCommentController(this.handle,f,S,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,P,V){return y.createCommentThread(C,P,V).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread(h,E,f){E===void 0&&(0,u.$yG)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,h,E,f,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(h){if(!h){this.e=void 0,this.f=void 0;return}const E=this.a.get(h.commentThreadHandle);E&&(this.e=h.uniqueIdInThread?E.getCommentByUniqueId(h.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(h,E){const f=new i(this.id,this.handle,void 0,M.URI.revive(h),D.Range.to(E),[],this.h,!0);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(h,E){const f=this.a.get(h);f&&(f.range=D.Range.to(E))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.g.forEach(h=>h.dispose())}}function l($,h,E,f){let S=E.get(h);return S||(S=++$.commentHandle,E.set(h,S)),h.state!==void 0&&(0,u.$yG)(f,"commentsDraftState"),h.reactions?.some(y=>y.reactors!==void 0)&&(0,u.$yG)(f,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:S,body:typeof h.body=="string"?h.body:D.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(y=>t(y)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t($){return{label:$.label,iconPath:$.iconPath?D.$_O($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted,reactors:$.reactors&&$.reactors.length>0&&typeof $.reactors[0]!="string"?$.reactors.map(h=>h.name):$.reactors}}function b($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?M.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1,reactors:$.reactors?.map(h=>({name:h}))}}function c($){if($!==void 0)switch($){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function m($){let h;if(typeof $=="object"?h=$.resolved:h=$,h!==void 0)switch(h){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function v($){let h;if(typeof $=="object"&&(h=$.applicability),h!==void 0)switch(h){case T.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new r}}),define(Re[256],Ae([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;class w{constructor(b,c){this.document=b,this.b=c,this.a=1,this.c=new T.$1jc("custom documents")}addEdit(b){return this.c.add([b])}async undo(b,c){await this.f(b).undo(),c||this.disposeBackup()}async redo(b,c){await this.f(b).redo(),c||this.disposeBackup()}disposeEdits(b){for(const c of b)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const b=l(this.document.uri)+this.a++;return(0,M.$4g)(this.b,b)}updateBackup(b){this.d?.delete(),this.d=b}disposeBackup(){this.d?.delete(),this.d=void 0}f(b){const c=this.c.get(b,0);if(!c)throw new Error("No edit found");return c}}class d{constructor(){this.a=new Map}get(b,c){return this.a.get(this.b(b,c))}add(b,c,m){const v=this.b(b,c.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${b} resource:${c.uri}`);const $=new w(c,m);return this.a.set(v,$),$}delete(b,c){const m=this.b(b,c.uri);this.a.delete(m)}b(b,c){return`${b}@@@${c}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(b,c,m){return this.b(0,b,c,m)}addCustomProvider(b,c,m){return this.b(1,b,c,m)}get(b){return this.a.get(b)}b(b,c,m,v){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:b,extension:m,provider:v}),new u.$RM(()=>this.a.delete(c))}}class n{constructor(b,c,m,v,$){this.d=c,this.f=m,this.g=v,this.h=$,this.b=new o,this.c=new d,this.a=b.getProxy(k.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(b,c,m,v){const $=new R.$Tc;return i(m)?($.add(this.b.addTextProvider(c,b,m)),this.a.$registerTextEditorProvider((0,D.$xkc)(b),c,v.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,D.$vkc)(b))):($.add(this.b.addCustomProvider(c,b,m)),r(m)&&$.add(m.onDidChangeCustomDocument(h=>{const E=this.i(c,h.document.uri);if(a(h)){const f=E.addEdit(h);this.a.$onDidEdit(h.document.uri,c,f,h.label)}else this.a.$onContentChange(h.document.uri,c)})),this.a.$registerCustomEditorProvider((0,D.$xkc)(b),c,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,D.$vkc)(b))),u.$RM.from($,new u.$RM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(b,c,m,v,$){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${c}'`);const E=p.URI.revive(b),f=await h.provider.openCustomDocument(E,{backupId:m,untitledDocumentData:v?.buffer},$);let S;return r(h.provider)&&this.f&&(S=this.f.workspaceValue(h.extension)??this.f.globalValue(h.extension)),this.c.add(c,f,S),{editable:r(h.provider)}}async $disposeCustomDocument(b,c){const m=this.b.get(c);if(!m)throw new Error(`No provider found for '${c}'`);if(m.type!==1)throw new Error(`Invalid provider type for '${c}'`);const v=p.URI.revive(b),{document:$}=this.i(c,v);this.c.delete(c,$),$.dispose()}async $resolveCustomEditor(b,c,m,v,$,h){const E=this.b.get(m);if(!E)throw new Error(`No provider found for '${m}'`);const f=g.ViewColumn.to($),S=this.g.createNewWebview(c,v.contentOptions,E.extension),y=this.h.createNewWebviewPanel(c,m,v.title,f,v.options,S,v.active),C=p.URI.revive(b);switch(E.type){case 1:{const{document:P}=this.i(m,C);return E.provider.resolveCustomEditor(P,y,h)}case 0:{const P=this.d.getDocument(C);return E.provider.resolveCustomTextEditor(P,y,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(b,c,m){this.i(c,b).disposeEdits(m)}async $onMoveCustomEditor(b,c,m){const v=this.b.get(m);if(!v)throw new Error(`No provider found for '${m}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const $=this.h.getWebviewPanel(b);if(!$)throw new Error("No webview found");const h=p.URI.revive(c),E=this.d.getDocument(h);await v.provider.moveCustomTextEditor(E,$,I.CancellationToken.None)}async $undo(b,c,m,v){return this.i(c,b).undo(m,v)}async $redo(b,c,m,v){return this.i(c,b).redo(m,v)}async $revert(b,c,m){const v=this.i(c,b);await this.j(c).revertCustomDocument(v.document,m),v.disposeBackup()}async $onSave(b,c,m){const v=this.i(c,b);await this.j(c).saveCustomDocument(v.document,m),v.disposeBackup()}async $onSaveAs(b,c,m,v){const $=this.i(c,b);return this.j(c).saveCustomDocumentAs($.document,p.URI.revive(m),v)}async $backup(b,c,m){const v=this.i(c,b),h=await this.j(c).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},m);return v.updateBackup(h),h.id}i(b,c){const m=this.c.get(b,p.URI.revive(c));if(!m)throw new Error("No custom document found");return m}j(b){const m=this.b.get(b)?.provider;if(!m||!r(m))throw new Error("Custom document is not editable");return m}}e.$Akc=n;function r(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const b=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,N.$ej)(b)+""}}),define(Re[257],Ae([1,0,164,100,2,4,7,8,5,13,28,44]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=e.$8jc=void 0;class w{#e;#t;#i;constructor(o,n,r,i,a,l,t,b){this.d=o,this.e=n,this.f=r,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,r),this.#i=new T.$Bc(c=>l.getComparisonKey(c)),this.#e=t,this.#t=b}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,n){if(!o){this.clear();return}this.j();let r=[];if(R.URI.isUri(o)){if(!n){this.delete(o);return}this.#i.set(o,n.slice()),r=[o]}else if(Array.isArray(o)){r=[];let l;o=[...o].sort(w.k);for(const t of o){const[b,c]=t;if((!l||b.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=b,r.push(b),this.#i.set(b,[])),c)this.#i.get(b)?.push(...c);else{const m=this.#i.get(b);m&&(m.length=0)}}}if(this.#t.fire(r),!this.#e)return;const i=[];let a=0;for(const l of r){let t=[];const b=this.#i.get(l);if(b)if(b.length>this.g){t=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const v of b)if(v.severity===c[m]&&t.push({...p.Diagnostic.from(v),modelVersionId:this.h(l)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,I.localize)(0,null,b.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=b.map(c=>({...p.Diagnostic.from(c),modelVersionId:this.h(l)}));if(i.push([l,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,n){this.j();for(const[r,i]of this)o.call(n,r,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const n=this.#i.get(o);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,n){return o[0].toString()<n[0].toString()?-1:o[0].toString()>n[0].toString()?1:0}}e.$8jc=w;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const n=new T.$Bc;for(const r of o)n.set(r,r);return{uris:Object.freeze(Array.from(n.values()))}}constructor(o,n,r,i){this.j=n,this.k=r,this.l=i,this.g=new Map,this.h=new g.$fe({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,u._mapper),this.f=o.getProxy(F.$PM.MainThreadDiagnostics)}createDiagnosticCollection(o,n){const{g:r,f:i,h:a,j:l,k:t,l:b}=this,c=new class{$changeMany($,h){i.$changeMany($,h),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,$,h.length===0?"CLEARING":h)}$clear($){i.$clear($),l.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,$)}dispose(){i.dispose()}};let m;if(!n)n="_generated_diagnostic_collection_name_#"+u.c++,m=n;else if(!r.has(n))m=n;else{this.j.warn(`DiagnosticCollection with name '${n}' does already exist.`);do m=n+u.c++;while(r.has(m))}return new class extends w{constructor(){super(n,m,u.e,u.d,$=>b.getDocument($)?.version,t.extUri,c,a),r.set(m,this)}dispose(){super.dispose(),r.delete(m)}}}getDiagnostics(o){if(o)return this.m(o);{const n=new Map,r=[];for(const i of this.g.values())i.forEach((a,l)=>{let t=n.get(a.toString());typeof t>"u"&&(t=r.length,n.set(a.toString(),t),r.push([a,[]])),r[t][1]=r[t][1].concat(...l)});return r}}m(o){let n=[];for(const r of this.g.values())r.has(o)&&(n=n.concat(r.get(o)));return n}$acceptMarkersChange(o){if(!this.n){const n="_generated_mirror",r=new w(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(n,r),this.n=r}for(const[n,r]of o)this.n.set(R.URI.revive(n),r.map(p.Diagnostic.to))}};e.$9jc=d,e.$9jc=d=u=Je([Ve(1,D.$Wj),Ve(2,k.$7jc)],d)}),define(Re[258],Ae([1,0,2,14,7,8,193,34]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class g{constructor(T,k,u,w={timeout:1500,errors:3}){this.c=T,this.d=k,this.f=u,this.g=w,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(k,u,w)=>{const s={dispose:this.a.push([k,u,T])};return Array.isArray(w)&&w.push(s),s}}async $participateInSave(T,k){const u=I.URI.revive(T);let w=!1;const d=setTimeout(()=>w=!0,this.g.timeout),s=[];try{for(const o of[...this.a]){if(w)break;const n=this.d.getDocument(u),r=await this.h(o,{document:n,reason:F.TextDocumentSaveReason.to(k)});s.push(r)}}finally{clearTimeout(d)}return s}h([T,k,u],w){const d=this.b.get(T);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,T,k,w).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,k,u,w){const d=[],s=Date.now(),{document:o,reason:n}=w,{version:r}=o,i=Object.freeze({document:o,reason:n,waitUntil(a){if(Object.isFrozen(d))throw(0,N.$8)("waitUntil can not be called async");d.push(Promise.resolve(a))}});try{k.apply(u,[i])}catch(a){return Promise.reject(a)}return Object.freeze(d),new Promise((a,l)=>{const t=setTimeout(()=>l(new Error("timeout")),this.g.timeout);return Promise.all(d).then(b=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(t),a(b)}).catch(b=>{clearTimeout(t),l(b)})}).then(a=>{const l={edits:[]};for(const t of a)if(Array.isArray(t)&&t.every(b=>b instanceof R.$YM))for(const{newText:b,newEol:c,range:m}of t)l.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:m&&F.Range.from(m),text:b,eol:c&&F.EndOfLine.from(c)}});if(l.edits.length!==0)return r===o.version?this.f.$tryApplyWorkspaceEdit(new p.$mw(l)):Promise.reject(new Error("concurrent_edits"))})}}e.$elc=g}),define(Re[259],Ae([1,0,5,6,2,4,111,8,17,26,7]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class k{constructor(w,d){this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=w.getProxy(F.$PM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const d=this.g.getDocument(w);if(d)return d}getDocument(w){const d=this.getDocumentData(w);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return d.document}ensureDocumentData(w){const d=this.g.getDocument(w);if(d)return Promise.resolve(d);let s=this.h.get(w.toString());return s||(s=this.f.$tryOpenDocument(w).then(o=>{this.h.delete(w.toString());const n=R.URI.revive(o);return(0,g.$cg)(this.g.getDocument(n))},o=>(this.h.delete(w.toString()),Promise.reject(o))),this.h.set(w.toString(),s)),s}createDocumentData(w){return this.f.$tryCreateDocument(w).then(d=>R.URI.revive(d))}$acceptModelLanguageChanged(w,d){const s=R.URI.revive(w),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(w){const d=R.URI.revive(w),s=this.g.getDocument(d);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(w,d){const s=R.URI.revive(w),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,d,s){const o=R.URI.revive(w),n=this.g.getDocument(o);if(!n)throw new Error("unknown document");n._acceptIsDirty(s),n.onEvents(d);let r;d.isUndoing?r=T.TextDocumentChangeReason.Undo:d.isRedoing&&(r=T.TextDocumentChangeReason.Redo),this.c.fire((0,D.$Xn)({document:n.document,contentChanges:d.changes.map(i=>({range:p.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:r}))}setWordDefinitionFor(w,d){(0,M.$cP)(w,d)}}e.$0jc=k}),define(Re[66],Ae([1,0,260,5,17,2,3,4,16,8,7]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=e.$Bkc=void 0,e.$Bkc=(0,M.$qi)("IExtHostEditorTabs");class k{constructor(o,n,r){this.e=r,this.d=n,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,n={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(n)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$BO(F.URI.revive(this.b.input.uri));case 2:return new T.$CO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new T.$DO(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new T.$EO(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$FO(this.b.input.viewType);case 4:return new T.$GO(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$HO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$IO;case 9:return new T.$JO(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$KO;case 11:return new T.$LO(this.b.input.diffEditors.map(o=>new T.$CO(F.URI.revive(o.original),F.URI.revive(o.modified))));default:return}}}class u{constructor(o,n){this.c=[],this.d="",this.b=o,this.e=n;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new k(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,n={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return D.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(n)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new k(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const n=this.c.find(r=>r.tabId===o.tabDto.id);if(!n)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),n.acceptDtoUpdate(o.tabDto),n}activeTabId(){return this.d}}let w=class{constructor(o){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=o.getProxy(p.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,n={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,R.$cg)(o.e.find(a=>a.groupId===r)?.apiObject)},close:async(r,i)=>{const a=Array.isArray(r)?r:[r];return a.length?d(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(n)}return this.f}$acceptEditorTabModel(o){const n=new Set(this.e.map(c=>c.groupId)),r=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(n,r),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),l=[],t=[];this.e=o.map(c=>{const m=new u(c,()=>this.d);return i.added.includes(m.groupId)?l.push(m.apiObject):t.push(m.apiObject),m});const b=(0,R.$cg)(o.find(c=>c.isActive===!0)?.groupId);b!==void 0&&this.d!==b&&(this.d=b),this.c.fire(Object.freeze({opened:l,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const n=this.e.find(r=>r.groupId===o.groupId);if(!n)throw new Error("Update Group IPC call received before group creation.");n.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[n.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const n=this.e.find(i=>i.groupId===o.groupId);if(!n)throw new Error("Update Tabs IPC call received before group creation.");const r=n.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const n of this.e)for(const r of n.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(n=>n.apiObject===o)}async i(o,n){const r=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");r.push(a.tabId)}return this.a.$closeTab(r,n)}async j(o,n){const r=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");r.push(a.groupId)}return this.a.$closeGroup(r,n)}};e.$Ckc=w,e.$Ckc=w=Je([Ve(0,g.$aP)],w);function d(s){return s.tabs!==void 0}}),define(Re[261],Ae([1,0,2,4,6,7,8,304,15,22,25,54]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class u{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let n,r,i=14,a=14;for(const l of s){let t=n?(0,g.$vf)(n,l):0;for(t===0?r=1:r=a;t<l.length;t++)t+1===l.length?(i=a,a=9):a+=1,o.push([r,l.toUpperCase().charCodeAt(t),a]),o.push([r,l.toLowerCase().charCodeAt(t),a]),r=a;n=l,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$12(o)}}provideDocumentLinks(s){this.c();const o=[],n=p.$22.computeLinks({getLineContent(r){return s.lineAt(r-1).text},getLineCount(){return s.lineCount}},this.b);for(const r of n){const i=M.DocumentLink.to(r);i.target&&o.push(i)}return o}}class w{constructor(s,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(N.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,n,r={}){if(w.j(n),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,n);let a=2;r.isCaseSensitive&&(a+=1024),r.isReadonly&&(a+=2048),typeof n.copy=="function"&&(a+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,T.$yG)(s,"fsChunks"),a+=4);let l;r.isReadonly&&(0,k.$Pk)(r.isReadonly)&&r.isReadonly.value!==""&&(l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,l).catch(b=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error(b)});const t=n.onDidChangeFile(b=>{const c=[];for(const m of b){const{uri:v,type:$}=m;if(v.scheme!==o)continue;let h;switch($){case F.FileChangeType.Changed:h=0;break;case F.FileChangeType.Created:h=1;break;case F.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:v,type:h})}this.a.$onFileSystemChange(i,c)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:n,mtime:r,size:i,permissions:a}=s;return{type:o,ctime:n,mtime:r,size:i,permissions:a}}$stat(s,o){return Promise.resolve(this.l(s).stat(I.URI.revive(o))).then(n=>w.k(n))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(I.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(I.URI.revive(o))).then(n=>D.$Ce.wrap(n))}$writeFile(s,o,n,r){return Promise.resolve(this.l(s).writeFile(I.URI.revive(o),n.buffer,r))}$delete(s,o,n){return Promise.resolve(this.l(s).delete(I.URI.revive(o),n))}$rename(s,o,n,r){return Promise.resolve(this.l(s).rename(I.URI.revive(o),I.URI.revive(n),r))}$copy(s,o,n,r){const i=this.l(s);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(n),r))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(I.URI.revive(o)))}$watch(s,o,n,r){const i=this.l(s).watch(I.URI.revive(n),r);this.f.set(o,i)}$unwatch(s,o){const n=this.f.get(o);n&&(n.dispose(),this.f.delete(o))}$open(s,o,n){const r=this.l(s);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(I.URI.revive(o),n))}$close(s,o){const n=this.l(s);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(o))}$read(s,o,n,r){const i=this.l(s);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=D.$Ce.alloc(r);return Promise.resolve(i.read(o,n,a.buffer,0,r)).then(l=>a.slice(0,l))}$write(s,o,n,r){const i=this.l(s);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,n,r.buffer,0,r.byteLength))}l(s){const o=this.c.get(s);if(!o){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return o}}e.$glc=w}),define(Re[262],Ae([1,0,5,36,2,4,8,7,40]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,d,s,o,n,r){this.a=Math.random(),this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$kk)(n),a=typeof n=="string",l=r?.correlate,t=o(b=>{if(!(typeof b.session=="number"&&b.session!==this.a)&&!(l&&typeof b.session>"u")){if(!r?.ignoreCreateEvents)for(const c of b.created){const m=R.URI.revive(c);i(m.fsPath)&&(!a||d.getWorkspaceFolder(m))&&this.b.fire(m)}if(!r?.ignoreChangeEvents)for(const c of b.changed){const m=R.URI.revive(c);i(m.fsPath)&&(!a||d.getWorkspaceFolder(m))&&this.c.fire(m)}if(!r?.ignoreDeleteEvents)for(const c of b.deleted){const m=R.URI.revive(c);i(m.fsPath)&&(!a||d.getWorkspaceFolder(m))&&this.d.fire(m)}}});this.g=p.$RM.from(this.i(w,s,n,r,r?.correlate),this.b,this.c,this.d,t)}i(w,d,s,o,n){const r=p.$RM.from();if(typeof s=="string")return r;const i=w.getProxy(F.$PM.MainThreadFileSystemEventService);let a=!1;return(s.pattern.includes(N.$gk)||s.pattern.includes(N.$hk))&&(a=!0),i.$watch(d.identifier.value,this.a,s.baseUri,{recursive:a,excludes:o?.excludes??[]},!!n),p.$RM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(w){this.a=w,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(R.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(w,d,s){this.j=w,this.k=d,this.l=s,this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.g=new I.$de,this.h=new I.$de,this.i=new I.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,d,s,o){return new D(this.j,w,d,this.a.event,M.GlobPattern.from(s),o)}$onFileEvent(w){this.a.fire(new T(w))}$onDidRunFileOperation(w,d){switch(w){case 2:this.b.fire(Object.freeze({files:d.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:d.map(s=>R.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:d.map(s=>R.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,d){return(s,o,n)=>{const r=function(a){s.call(o,a)};return r.extension=w,d.event(r,void 0,n)}}async $onWillRunFileOperation(w,d,s,o){switch(w){case 2:return await this.n(this.g,{files:d.map(n=>({oldUri:R.URI.revive(n.source),newUri:R.URI.revive(n.target)}))},s,o);case 1:return await this.n(this.i,{files:d.map(n=>R.URI.revive(n.target))},s,o);case 0:case 3:return await this.n(this.h,{files:d.map(n=>R.URI.revive(n.target))},s,o)}}async n(w,d,s,o){const n=new Set,r=[];if(await w.fireAsync(d,o,async(a,l)=>{const t=Date.now(),b=await Promise.resolve(a);b instanceof p.$2M&&(r.push([l.extension,b]),n.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",l.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,a]of r){const{edits:l}=M.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(l)}return{edit:i,extensionNames:Array.from(n)}}}e.$hlc=k}),define(Re[263],Ae([1,0,18,11,24,14,90,6,26,65,15,17,2,29,305,87,97,166,20,8,7,25,74,4]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class c{constructor(z,L){this.d=z,this.e=L}async provideDocumentSymbols(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(G,L);if(!(0,I.$Kb)(H))return H[0]instanceof a.$$M?H.map(i.DocumentSymbol.from):c.f(H)}static f(z){z=z.slice(0).sort((H,_)=>{let se=H.location.range.start.compareTo(_.location.range.start);return se===0&&(se=_.location.range.end.compareTo(H.location.range.end)),se});const L=[],G=[];for(const H of z){const _={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(_),L.push(_);break}const se=G[G.length-1];if(w.$kt.containsRange(se.range,_.range)&&!w.$kt.equalsRange(se.range,_.range)){se.children?.push(_),G.push(_);break}G.pop()}}return L}}class m{constructor(z,L,G,H,_,se){this.f=z,this.g=L,this.h=G,this.j=H,this.k=_,this.l=se,this.d=new t.$1jc("CodeLens"),this.e=new Map}async provideCodeLenses(z,L){const G=this.f.getDocument(z),H=await this.h.provideCodeLenses(G,L);if(!H||L.isCancellationRequested)return;const _=this.d.add(H),se=new p.$Tc;this.e.set(_,se);const Fe={cacheId:_,lenses:[]};for(let Be=0;Be<H.length;Be++)Fe.lenses.push({cacheId:[_,Be],range:i.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,se)});return Fe}async resolveCodeLens(z,L){const G=z.cacheId&&this.d.get(...z.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,L),H||(H=G),L.isCancellationRequested)return;const _=z.cacheId&&this.e.get(z.cacheId[0]);if(_){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return z.command=this.g.toInternal(H.command,_),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function v(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class ${constructor(z,L){this.d=z,this.e=L}async provideDefinition(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideDefinition(H,_,G);return v(se)}}class h{constructor(z,L){this.d=z,this.e=L}async provideDeclaration(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideDeclaration(H,_,G);return v(se)}}class E{constructor(z,L){this.d=z,this.e=L}async provideImplementation(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideImplementation(H,_,G);return v(se)}}class f{constructor(z,L){this.d=z,this.e=L}async provideTypeDefinition(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideTypeDefinition(H,_,G);return v(se)}}class S{constructor(z,L){this.d=z,this.e=L}async provideHover(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideHover(H,_,G);if(!(!se||(0,I.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(_)),se.range||(se.range=new a.$TM(_,_)),i.Hover.from(se)}}class y{constructor(z,L){this.d=z,this.e=L}async provideEvaluatableExpression(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideEvaluatableExpression(H,_,G);if(se)return i.EvaluatableExpression.from(se)}}class C{constructor(z,L){this.d=z,this.e=L}async provideInlineValues(z,L,G,H){const _=this.d.getDocument(z),se=await this.e.provideInlineValues(_,i.Range.to(L),i.InlineValueContext.to(G),H);if(Array.isArray(se))return se.map(Fe=>i.InlineValue.from(Fe))}}class P{constructor(z,L){this.d=z,this.e=L}async provideDocumentHighlights(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideDocumentHighlights(H,_,G);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class V{constructor(z,L){this.d=z,this.e=L}async provideMultiDocumentHighlights(z,L,G,H){const _=this.d.getDocument(z),se=G.map(Qe=>this.d.getDocument(Qe)),Fe=i.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(_,Fe,se,H);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class W{constructor(z,L){this.d=z,this.e=L}async provideLinkedEditingRanges(z,L,G){const H=this.d.getDocument(z),_=i.Position.to(L),se=await this.e.provideLinkedEditingRanges(H,_,G);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class q{constructor(z,L){this.d=z,this.e=L}async provideReferences(z,L,G,H){const _=this.d.getDocument(z),se=i.Position.to(L),Fe=await this.e.provideReferences(_,se,G,H);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class A{static{this.d=1e3}constructor(z,L,G,H,_,se,Fe){this.g=z,this.h=L,this.j=G,this.k=H,this.l=_,this.m=se,this.n=Fe,this.e=new t.$1jc("CodeAction"),this.f=new Map}async provideCodeActions(z,L,G,H){const _=this.g.getDocument(z),se=d.$mt.isISelection(L)?i.Selection.to(L):i.Range.to(L),Fe=[];for(const it of this.j.getDiagnostics(z))if(se.intersection(it.range)&&Fe.push(it)>A.d)break;const Be={diagnostics:Fe,only:G.only?new a.$aN(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(_,se,Be,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const _e=this.e.add(Qe),et=new p.$Tc;this.f.set(_e,et);const tt=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(A.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];tt.push({cacheId:[_e,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(i.Diagnostic.from),edit:nt.edit&&i.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,l.$xG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,l.$xG)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(i.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:tt}}async resolveCodeAction(z,L){const[G,H]=z,_=this.e.get(G,H);if(!_||A.o(_))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(_,L)??_;let Fe;se.edit&&(Fe=i.WorkspaceEdit.from(se.edit,void 0));let Be;if(se.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(se.command,Qe))}return{edit:Fe,command:Be}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class j{constructor(z,L,G,H,_){this.e=z,this.f=L,this.g=G,this.h=H,this.j=_,this.d=new t.$1jc("DocumentPasteEdit")}async prepareDocumentPaste(z,L,G,H){if(!this.g.prepareDocumentPaste)return;const _=this.f.getDocument(z),se=L.map(Qe=>i.Range.to(Qe)),Fe=i.DataTransfer.toDataTransfer(G,()=>{throw new F.$$});if(await this.g.prepareDocumentPaste(_,se,Fe,H),H.isCancellationRequested)return;const Be=Array.from(Fe).filter(([,Qe])=>!(Qe instanceof a.$GN));return i.DataTransfer.from(Be)}async providePasteEdits(z,L,G,H,_,se){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(L),Be=G.map(tt=>i.Range.to(tt)),Qe=i.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolvePasteFileData(this.h,z,tt)).buffer),_e=await this.g.provideDocumentPasteEdits(Fe,Be,Qe,{only:_.only?new a.$LN(_.only):void 0,triggerKind:_.triggerKind},se);if(!_e||se.isCancellationRequested)return[];const et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,n.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,L){const[G,H]=z,_=this.d.get(G,H);if(!_||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(_,L)??_;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class K{constructor(z,L){this.d=z,this.e=L}async provideDocumentFormattingEdits(z,L,G){const H=this.d.getDocument(z),_=await this.e.provideDocumentFormattingEdits(H,L,G);if(Array.isArray(_))return _.map(i.TextEdit.from)}}class ie{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeFormattingEdits(z,L,G,H){const _=this.d.getDocument(z),se=i.Range.to(L),Fe=await this.e.provideDocumentRangeFormattingEdits(_,se,G,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,L,G,H){(0,k.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(z),se=L.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(_,se,G,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class ce{constructor(z,L){this.d=z,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,L,G,H,_){const se=this.d.getDocument(z),Fe=i.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(se,Fe,G,H,_);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class ve{constructor(z,L){this.e=z,this.f=L,this.d=new t.$1jc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,L){const G=await this.e.provideWorkspaceSymbols(z,L);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),_={cacheId:H,symbols:[]};for(let se=0;se<G.length;se++){const Fe=G[se];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}_.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[H,se]})}return _}async resolveWorkspaceSymbol(z,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const G=this.d.get(...z.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,L);return H&&(0,g.$Zn)(z,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideRenameEdits(z,L,G,H){const _=this.d.getDocument(z),se=i.Position.to(L);try{const Fe=await this.e.provideRenameEdits(_,se,G,H);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Be=Ie.g(Fe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(z,L,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),_=i.Position.to(L);try{const se=await this.e.prepareRename(H,_,G);let Fe,Be;if(a.$TM.isRange(se)?(Fe=se,Be=H.getText(se)):(0,k.$6f)(se)&&(Fe=se.range,Be=se.placeholder),!Fe||!Be)return;if(Fe.start.line>_.line||Fe.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Be}}catch(se){const Fe=Ie.g(se);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(se)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideNewSymbolNames(z,L,G){const H=this.d.getDocument(z),_=i.Range.to(L);try{const se=await this.e.provideNewSymbolNames(H,_,G);return se?se.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(se){this.f.error(ue.g(se)??JSON.stringify(se,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class pe{constructor(z,L){this.resultId=z,this.tokens=L}}class re{constructor(z,L){this.f=z,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,L,G){const H=this.f.getDocument(z),_=L!==0?this.d.get(L):null;let se=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,_.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return _&&this.d.delete(L),se?(se=re.h(se),this.o(re.n(_,se),se)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return re.j(z)?re.k(z)?z:new a.$_N(new Uint32Array(z.data),z.resultId):re.l(z)?re.m(z)?z:new a.$bO(z.edits.map(L=>new a.$aO(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const L of z.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(z,L){if(!re.j(L)||!z||!z.tokens)return L;const G=z.tokens,H=G.length,_=L.data,se=_.length;let Fe=0;const Be=Math.min(H,se);for(;Fe<Be&&G[Fe]===_[Fe];)Fe++;if(Fe===H&&Fe===se)return new a.$bO([],L.resultId);let Qe=0;const _e=Be-Fe;for(;Qe<_e&&G[H-Qe-1]===_[se-Qe-1];)Qe++;return new a.$bO([{start:Fe,deleteCount:H-Fe-Qe,data:_.subarray(Fe,se-Qe)}],L.resultId)}o(z,L){if(re.j(z)){const G=this.e++;return this.d.set(G,new pe(z.resultId,z.data)),(0,o.$hbb)({id:G,type:"full",data:z.data})}if(re.l(z)){const G=this.e++;return re.j(L)?this.d.set(G,new pe(L.resultId,L.data)):this.d.set(G,new pe(z.resultId)),(0,o.$hbb)({id:G,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Se{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeSemanticTokens(z,L,G){const H=this.d.getDocument(z),_=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(L),G);return _?this.f(_):null}f(z){return(0,o.$hbb)({id:0,type:"full",data:z.data})}}class Le{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,L,G,H,_){this.f=z,this.g=L,this.h=G,this.j=H,this.k=_,this.d=new t.$1jc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,L,G,H){const _=this.f.getDocument(z),se=i.Position.to(L),Fe=_.getWordRangeAtPosition(se)||new a.$TM(se,se),Be=Fe.with({end:se}),Qe=new D.$0d,_e=await this.h.provideCompletionItems(_,se,H,i.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const et=Array.isArray(_e)?new a.$nN(_e):_e,tt=Le.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new p.$Tc;this.e.set(tt,it);const nt=[],ct={x:tt,b:nt,a:{replace:i.Range.from(Fe),insert:i.Range.from(Be)},c:et.isIncomplete||void 0,d:Qe.elapsed()};for(let ft=0;ft<et.items.length;ft++){const je=et.items[ft],st=this.l(je,[tt,ft],Be,Fe);nt.push(st)}return ct}async resolveCompletionItem(z,L){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...z);if(!G)return;const H=this.l(G,z),_=await this.h.resolveCompletionItem(G,L);if(!_)return;const se=this.l(_,z);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,g.$1n)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L,G,H){const _=this.e.get(L[0]);if(!_)throw Error("DisposableStore is missing...");const se=this.g.toInternal(z.command,_),Fe={x:L,a:z.label,b:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(i.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=z.textEdit.newText):typeof z.insertText=="string"?Fe.h=z.insertText:z.insertText instanceof a.$3M&&(Fe.h=z.insertText.value,Fe.i|=4);let Be;return z.textEdit?Be=z.textEdit.range:z.range&&(Be=z.range),a.$TM.isRange(Be)?Fe.j=i.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Fe.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Fe}}class ne{async provideInlineCompletions(z,L,G,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,L,G){}handlePartialAccept(z,L,G,H){}}class U extends ne{constructor(z,L,G,H){super(),this.f=z,this.g=L,this.h=G,this.j=H,this.d=new be,this.e=(0,l.$xG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,l.$xG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,L,G,H){const _=this.g.getDocument(z),se=i.Position.to(L),Fe=await this.h.provideInlineCompletionItems(_,se,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Fe||H.isCancellationRequested)return;const Be=Array.isArray(Fe)?Fe:Fe.items,Qe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],_e=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,nt)=>{let ct;it.command&&(et||(et=new p.$Tc),ct=this.j.toInternal(it.command,et));const ft=it.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(et||(et=new p.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,L,G){const H=this.d.get(z)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(z,L,G,H){const _=this.d.get(z)?.items[L];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(_,G),this.h.handleDidPartiallyAcceptCompletionItem(_,i.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(z,L,G){const H=this.f.getDocument(z),_=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},G);if(!_||G.isCancellationRequested)return;let se;const Fe=this.d.createReferenceId({dispose(){se?.dispose()},item:_});let Be;_.accepted&&(se||(se=new p.$Tc),Be=this.h.toInternal(_.accepted,se));let Qe;return _.rejected&&(se||(se=new p.$Tc),Qe=this.h.toInternal(_.rejected,se)),{pid:Fe,text:_.text,range:i.Range.from(_.range),accepted:Be,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,L,G,H){this.f=L,this.g=G,this.h=H,this.d=new be,this.e={[s.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const L=this.e++;return this.d.set(L,z),L}disposeReferenceId(z){const L=this.d.get(z);return this.d.delete(z),L}get(z){return this.d.get(z)}}class Te{constructor(z,L){this.e=z,this.f=L,this.d=new t.$1jc("SignatureHelp")}async provideSignatureHelp(z,L,G,H){const _=this.e.getDocument(z),se=i.Position.to(L),Fe=this.g(G),Be=await this.f.provideSignatureHelp(_,se,H,Fe);if(Be){const Qe=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:Qe}}}g(z){let L;if(z.activeSignatureHelp){const G=i.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=G.activeSignature,L.activeParameter=G.activeParameter):L=G}return{...z,activeSignatureHelp:L}}releaseSignatureHelp(z){this.d.delete(z)}}class Ee{constructor(z,L,G,H,_){this.f=z,this.g=L,this.h=G,this.j=H,this.k=_,this.d=new t.$1jc("InlayHints"),this.e=new Map}async provideInlayHints(z,L,G){const H=this.f.getDocument(z),_=i.Range.to(L),se=await this.h.provideInlayHints(H,_,G);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(G.isCancellationRequested)return;const Fe=this.d.add(se);this.e.set(Fe,new p.$Tc);const Be={hints:[],cacheId:Fe};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],_)&&Be.hints.push(this.m(se[Qe],[Fe,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(z,L){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.h.resolveInlayHint(G,L);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L){return z.label.length===0||Array.isArray(z.label)&&z.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(L&&!L.contains(z.position))}m(z,L){const G=this.e.get(L[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const _=[];H.label=_;for(const se of z.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.$4M.isLocation(se.location)&&(Fe.location=i.location.from(se.location)),se.command&&(Fe.command=this.g.toInternal(se.command,G)),_.push(Fe)}}return H}}class $e{constructor(z,L){this.e=z,this.f=L,this.d=new t.$1jc("DocumentLink")}async provideLinks(z,L){const G=this.e.getDocument(z),H=await this.f.provideDocumentLinks(G,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(i.DocumentLink.from)};{const _=this.d.add(H),se={links:[],cacheId:_};for(let Fe=0;Fe<H.length;Fe++){if(!$e.g(H[Fe]))continue;const Be=i.DocumentLink.from(H[Fe]);Be.cacheId=[_,Fe],se.links.push(Be)}return se}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,L){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.f.resolveDocumentLink(G,L);if(!(!H||!$e.g(H)))return i.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class fe{constructor(z,L){this.d=z,this.e=L}async provideColors(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentColors(G,L);return Array.isArray(H)?H.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(z,L,G){const H=this.d.getDocument(z),_=i.Range.to(L.range),se=i.Color.to(L.color),Fe=await this.e.provideColorPresentations(se,{document:H,range:_},G);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class Q{constructor(z,L){this.d=z,this.e=L}async provideFoldingRanges(z,L,G){const H=this.d.getDocument(z),_=await this.e.provideFoldingRanges(H,L,G);if(Array.isArray(_))return _.map(i.FoldingRange.from)}}class Y{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideSelectionRanges(z,L,G){const H=this.d.getDocument(z),_=L.map(i.Position.to),se=await this.e.provideSelectionRanges(H,_,G);if(!(0,I.$Lb)(se))return[];if(se.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Be=0;Be<_.length;Be++){const Qe=[];Fe.push(Qe);let _e=_[Be],et=se[Be];for(;;){if(!et.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(et)),!et.parent)break;_e=et.range,et=et.parent}}return Fe}}class he{constructor(z,L){this.f=z,this.g=L,this.d=new M.$fP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),_=i.Position.to(L),se=await this.g.prepareCallHierarchy(H,_,G);if(!se)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(se)?se.map(Be=>this.h(Fe,Be)):[this.h(Fe,se)]}async provideCallsTo(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(H,G);if(_)return _.map(se=>({from:this.h(z,se.from),fromRanges:se.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(_)return _.map(se=>({to:this.h(z,se.to),fromRanges:se.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=i.CallHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class le{constructor(z,L){this.f=z,this.g=L,this.d=new M.$fP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),_=i.Position.to(L),se=await this.g.prepareTypeHierarchy(H,_,G);if(!se)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(se)?se.map(Be=>this.h(Fe,Be)):[this.h(Fe,se)]}async provideSupertypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(H,G);if(_)return _.map(se=>this.h(z,se))}async provideSubtypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(H,G);if(_)return _.map(se=>this.h(z,se))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=i.TypeHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class Ne{constructor(z,L,G,H,_){this.e=z,this.f=L,this.g=G,this.h=H,this.j=_,this.d=new t.$1jc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,L,G,H,_){const se=this.f.getDocument(L),Fe=i.Position.to(G),Be=i.DataTransfer.toDataTransfer(H,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,tt)).buffer),Qe=await this.g.provideDocumentDropEdits(se,Fe,Be,_);if(!Qe)return;const _e=(0,I.$3b)(Qe),et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,n.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,L){const[G,H]=z,_=this.d.get(G,H);if(!_||!this.g.resolveDocumentDropEdit)return{};const se=await this.g.resolveDocumentDropEdit(_,L)??_;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class de{constructor(z,L){this.d=z,this.e=L}async provideMappedEdits(z,L,G,H){const _=u.URI.revive(z),se=this.d.getDocument(_),Fe=G.documents.map(_e=>_e.map(et=>({uri:u.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(tt=>i.Range.to(tt))}))),Be={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,L,Be,H);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ce{constructor(z,L){this.adapter=z,this.extension=L}}class Me{static{this.d=0}constructor(z,L,G,H,_,se,Fe,Be){this.g=L,this.h=G,this.j=H,this.k=_,this.l=se,this.m=Fe,this.n=Be,this.f=new Map,this.e=z.getProxy(b.$PM.MainThreadLanguageFeatures)}o(z,L){return i.DocumentSelector.from(z,this.g,L)}p(z){return new a.$RM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Me.d++}async s(z,L,G,H,_,se=!1){const Fe=this.f.get(z);if(!Fe||!(Fe.adapter instanceof L))return H;const Be=Date.now();se||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Fe.adapter,Fe.extension);return Promise.resolve(Qe).catch(_e=>{(0,F.$4)(_e)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Fe.extension.identifier,_e))}).finally(()=>{se||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(_)?(0,N.$fh)(Qe,_):Qe}t(z,L){const G=this.q();return this.f.set(G,new Ce(z,L)),G}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,L,G,H){const _=this.t(new c(this.h,G),z),se=H&&H.label||Me.u(z);return this.e.$registerDocumentSymbolProvider(_,this.o(L,z),se),this.p(_)}$provideDocumentSymbols(z,L,G){return this.s(z,c,H=>H.provideDocumentSymbols(u.URI.revive(L),G),void 0,G)}registerCodeLensProvider(z,L,G){const H=this.q(),_=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new m(this.h,this.j.converter,G,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(L,z),_);let se=this.p(H);if(_!==void 0){const Fe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(_));se=a.$RM.from(se,Fe)}return se}$provideCodeLenses(z,L,G){return this.s(z,m,H=>H.provideCodeLenses(u.URI.revive(L),G),void 0,G)}$resolveCodeLens(z,L,G){return this.s(z,m,H=>H.resolveCodeLens(L,G),void 0,void 0)}$releaseCodeLenses(z,L){this.s(z,m,G=>Promise.resolve(G.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(z,L,G){const H=this.t(new $(this.h,G),z);return this.e.$registerDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideDefinition(z,L,G,H){return this.s(z,$,_=>_.provideDefinition(u.URI.revive(L),G,H),[],H)}registerDeclarationProvider(z,L,G){const H=this.t(new h(this.h,G),z);return this.e.$registerDeclarationSupport(H,this.o(L,z)),this.p(H)}$provideDeclaration(z,L,G,H){return this.s(z,h,_=>_.provideDeclaration(u.URI.revive(L),G,H),[],H)}registerImplementationProvider(z,L,G){const H=this.t(new E(this.h,G),z);return this.e.$registerImplementationSupport(H,this.o(L,z)),this.p(H)}$provideImplementation(z,L,G,H){return this.s(z,E,_=>_.provideImplementation(u.URI.revive(L),G,H),[],H)}registerTypeDefinitionProvider(z,L,G){const H=this.t(new f(this.h,G),z);return this.e.$registerTypeDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideTypeDefinition(z,L,G,H){return this.s(z,f,_=>_.provideTypeDefinition(u.URI.revive(L),G,H),[],H)}registerHoverProvider(z,L,G,H){const _=this.t(new S(this.h,G),z);return this.e.$registerHoverProvider(_,this.o(L,z)),this.p(_)}$provideHover(z,L,G,H){return this.s(z,S,_=>_.provideHover(u.URI.revive(L),G,H),void 0,H)}registerEvaluatableExpressionProvider(z,L,G,H){const _=this.t(new y(this.h,G),z);return this.e.$registerEvaluatableExpressionProvider(_,this.o(L,z)),this.p(_)}$provideEvaluatableExpression(z,L,G,H){return this.s(z,y,_=>_.provideEvaluatableExpression(u.URI.revive(L),G,H),void 0,H)}registerInlineValuesProvider(z,L,G,H){const _=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new C(this.h,G),z);this.e.$registerInlineValuesProvider(se,this.o(L,z),_);let Fe=this.p(se);if(_!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(_));Fe=a.$RM.from(Fe,Be)}return Fe}$provideInlineValues(z,L,G,H,_){return this.s(z,C,se=>se.provideInlineValues(u.URI.revive(L),G,H,_),void 0,_)}registerDocumentHighlightProvider(z,L,G){const H=this.t(new P(this.h,G),z);return this.e.$registerDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,L,G){const H=this.t(new V(this.h,G),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}$provideDocumentHighlights(z,L,G,H){return this.s(z,P,_=>_.provideDocumentHighlights(u.URI.revive(L),G,H),void 0,H)}$provideMultiDocumentHighlights(z,L,G,H,_){return this.s(z,V,se=>se.provideMultiDocumentHighlights(u.URI.revive(L),G,H.map(Fe=>u.URI.revive(Fe)),_),void 0,_)}registerLinkedEditingRangeProvider(z,L,G){const H=this.t(new W(this.h,G),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,z)),this.p(H)}$provideLinkedEditingRanges(z,L,G,H){return this.s(z,W,async _=>{const se=await _.provideLinkedEditingRanges(u.URI.revive(L),G,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Me.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,L,G){const H=this.t(new q(this.h,G),z);return this.e.$registerReferenceSupport(H,this.o(L,z)),this.p(H)}$provideReferences(z,L,G,H,_){return this.s(z,q,se=>se.provideReferences(u.URI.revive(L),G,H,_),void 0,_)}registerCodeActionProvider(z,L,G,H){const _=new p.$Tc,se=this.t(new A(this.h,this.j.converter,this.k,G,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(se,this.o(L,z),{providedKinds:H?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:H?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,_)}))},Me.u(z),!!G.resolveCodeAction),_.add(this.p(se)),_}$provideCodeActions(z,L,G,H,_){return this.s(z,A,se=>se.provideCodeActions(u.URI.revive(L),G,H,_),void 0,_)}$resolveCodeAction(z,L,G){return this.s(z,A,H=>H.resolveCodeAction(L,G),{},void 0)}$releaseCodeActions(z,L){this.s(z,A,G=>Promise.resolve(G.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(z,L,G){const H=this.t(new K(this.h,G),z);return this.e.$registerDocumentFormattingSupport(H,this.o(L,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,L,G,H){return this.s(z,K,_=>_.provideDocumentFormattingEdits(u.URI.revive(L),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,L,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",_=this.t(new ie(this.h,G),z);return this.e.$registerRangeFormattingSupport(_,this.o(L,z),z.identifier,z.displayName||z.name,H),this.p(_)}$provideDocumentRangeFormattingEdits(z,L,G,H,_){return this.s(z,ie,se=>se.provideDocumentRangeFormattingEdits(u.URI.revive(L),G,H,_),void 0,_)}$provideDocumentRangesFormattingEdits(z,L,G,H,_){return this.s(z,ie,se=>se.provideDocumentRangesFormattingEdits(u.URI.revive(L),G,H,_),void 0,_)}registerOnTypeFormattingEditProvider(z,L,G,H){const _=this.t(new ce(this.h,G),z);return this.e.$registerOnTypeFormattingSupport(_,this.o(L,z),H,z.identifier),this.p(_)}$provideOnTypeFormattingEdits(z,L,G,H,_,se){return this.s(z,ce,Fe=>Fe.provideOnTypeFormattingEdits(u.URI.revive(L),G,H,_,se),void 0,se)}registerWorkspaceSymbolProvider(z,L){const G=this.t(new ve(L,this.l),z);return this.e.$registerNavigateTypeSupport(G,typeof L.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(z,L,G){return this.s(z,ve,H=>H.provideWorkspaceSymbols(L,G),{symbols:[]},G)}$resolveWorkspaceSymbol(z,L,G){return this.s(z,ve,H=>H.resolveWorkspaceSymbol(L,G),void 0,void 0)}$releaseWorkspaceSymbols(z,L){this.s(z,ve,G=>G.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(z,L,G){const H=this.t(new Ie(this.h,G,this.l),z);return this.e.$registerRenameSupport(H,this.o(L,z),Ie.supportsResolving(G)),this.p(H)}$provideRenameEdits(z,L,G,H,_){return this.s(z,Ie,se=>se.provideRenameEdits(u.URI.revive(L),G,H,_),void 0,_)}$resolveRenameLocation(z,L,G,H){return this.s(z,Ie,_=>_.resolveRenameLocation(u.URI.revive(L),G,H),void 0,H)}registerNewSymbolNamesProvider(z,L,G){const H=this.t(new ue(this.h,G,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,z)),this.p(H)}$provideNewSymbolNames(z,L,G,H){return this.s(z,ue,_=>_.provideNewSymbolNames(u.URI.revive(L),G,H),void 0,H)}registerDocumentSemanticTokensProvider(z,L,G,H){const _=this.t(new re(this.h,G),z),se=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(L,z),H,se);let Fe=this.p(_);if(se){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Fe=a.$RM.from(Fe,Be)}return Fe}$provideDocumentSemanticTokens(z,L,G,H){return this.s(z,re,_=>_.provideDocumentSemanticTokens(u.URI.revive(L),G,H),null,H)}$releaseDocumentSemanticTokens(z,L){this.s(z,re,G=>G.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,L,G,H){const _=this.t(new Se(this.h,G),z);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(L,z),H),this.p(_)}$provideDocumentRangeSemanticTokens(z,L,G,H){return this.s(z,Se,_=>_.provideDocumentRangeSemanticTokens(u.URI.revive(L),G,H),null,H)}registerCompletionItemProvider(z,L,G,H){const _=this.t(new Le(this.h,this.j.converter,G,this.m,z),z);return this.e.$registerCompletionsProvider(_,this.o(L,z),H,Le.supportsResolving(G),z.identifier),this.p(_)}$provideCompletionItems(z,L,G,H,_){return this.s(z,Le,se=>se.provideCompletionItems(u.URI.revive(L),G,H,_),void 0,_)}$resolveCompletionItem(z,L,G){return this.s(z,Le,H=>H.resolveCompletionItem(L,G),void 0,G)}$releaseCompletionItems(z,L){this.s(z,Le,G=>G.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(z,L,G,H){const _=new U(z,this.h,G,this.j.converter),se=this.t(_,z);return this.e.$registerInlineCompletionsSupport(se,this.o(L,z),_.supportsHandleEvents,r.$Lm.toKey(z.identifier.value),H?.yieldTo?.map(Fe=>r.$Lm.toKey(Fe))||[]),this.p(se)}$provideInlineCompletions(z,L,G,H,_){return this.s(z,ne,se=>se.provideInlineCompletions(u.URI.revive(L),G,H,_),void 0,_)}$handleInlineCompletionDidShow(z,L,G,H){this.s(z,ne,async _=>{_.handleDidShowCompletionItem(L,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,L,G,H,_){this.s(z,ne,async se=>{se.handlePartialAccept(L,G,H,_)},void 0,void 0)}$freeInlineCompletionsList(z,L){this.s(z,ne,async G=>{G.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(z,L,G){const H=new x(z,this.h,G,this.j.converter),_=this.t(H,z);return this.e.$registerInlineEditProvider(_,this.o(L,z),z.identifier),this.p(_)}$provideInlineEdit(z,L,G,H){return this.s(z,x,_=>_.provideInlineEdits(u.URI.revive(L),G,H),void 0,H)}$freeInlineEdit(z,L){this.s(z,x,async G=>{G.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(z,L,G,H){const _=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Te(this.h,G),z);return this.e.$registerSignatureHelpProvider(se,this.o(L,z),_),this.p(se)}$provideSignatureHelp(z,L,G,H,_){return this.s(z,Te,se=>se.provideSignatureHelp(u.URI.revive(L),G,H,_),void 0,_)}$releaseSignatureHelp(z,L){this.s(z,Te,G=>G.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(z,L,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new Ee(this.h,this.j.converter,G,this.l,z),z);this.e.$registerInlayHintsProvider(_,this.o(L,z),typeof G.resolveInlayHint=="function",H,Me.u(z));let se=this.p(_);if(H!==void 0){const Fe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));se=a.$RM.from(se,Fe)}return se}$provideInlayHints(z,L,G,H){return this.s(z,Ee,_=>_.provideInlayHints(u.URI.revive(L),G,H),void 0,H)}$resolveInlayHint(z,L,G){return this.s(z,Ee,H=>H.resolveInlayHint(L,G),void 0,G)}$releaseInlayHints(z,L){this.s(z,Ee,G=>G.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(z,L,G){const H=this.t(new $e(this.h,G),z);return this.e.$registerDocumentLinkProvider(H,this.o(L,z),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,L,G){return this.s(z,$e,H=>H.provideLinks(u.URI.revive(L),G),void 0,G,L.scheme==="output")}$resolveDocumentLink(z,L,G){return this.s(z,$e,H=>H.resolveLink(L,G),void 0,void 0,!0)}$releaseDocumentLinks(z,L){this.s(z,$e,G=>G.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(z,L,G){const H=this.t(new fe(this.h,G),z);return this.e.$registerDocumentColorProvider(H,this.o(L,z)),this.p(H)}$provideDocumentColors(z,L,G){return this.s(z,fe,H=>H.provideColors(u.URI.revive(L),G),[],G)}$provideColorPresentations(z,L,G,H){return this.s(z,fe,_=>_.provideColorPresentations(u.URI.revive(L),G,H),void 0,H)}registerFoldingRangeProvider(z,L,G){const H=this.q(),_=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new Q(this.h,G),z)),this.e.$registerFoldingRangeProvider(H,this.o(L,z),z.identifier,_);let se=this.p(H);if(_!==void 0){const Fe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));se=a.$RM.from(se,Fe)}return se}$provideFoldingRanges(z,L,G,H){return this.s(z,Q,_=>_.provideFoldingRanges(u.URI.revive(L),G,H),void 0,H)}registerSelectionRangeProvider(z,L,G){const H=this.t(new Y(this.h,G,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(L,z)),this.p(H)}$provideSelectionRanges(z,L,G,H){return this.s(z,Y,_=>_.provideSelectionRanges(u.URI.revive(L),G,H),[],H)}registerCallHierarchyProvider(z,L,G){const H=this.t(new he(this.h,G),z);return this.e.$registerCallHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareCallHierarchy(z,L,G,H){return this.s(z,he,_=>Promise.resolve(_.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,L,G,H){return this.s(z,he,_=>_.provideCallsTo(L,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,L,G,H){return this.s(z,he,_=>_.provideCallsFrom(L,G,H),void 0,H)}$releaseCallHierarchy(z,L){this.s(z,he,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(z,L,G){const H=this.t(new le(this.h,G),z);return this.e.$registerTypeHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareTypeHierarchy(z,L,G,H){return this.s(z,le,_=>Promise.resolve(_.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideTypeHierarchySupertypes(z,L,G,H){return this.s(z,le,_=>_.provideSupertypes(L,G,H),void 0,H)}$provideTypeHierarchySubtypes(z,L,G,H){return this.s(z,le,_=>_.provideSubtypes(L,G,H),void 0,H)}$releaseTypeHierarchy(z,L){this.s(z,le,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(z,L,G,H){const _=this.q();return this.f.set(_,new Ce(new Ne(this.e,this.h,G,_,z),z)),this.e.$registerDocumentOnDropEditProvider(_,this.o(L,z),(0,l.$xG)(z,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(_)}$provideDocumentOnDropEdits(z,L,G,H,_,se){return this.s(z,Ne,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(L,u.URI.revive(G),H,_,se)),void 0,void 0)}$resolveDropEdit(z,L,G){return this.s(z,Ne,H=>H.resolveDropEdit(L,G),{},void 0)}$releaseDropEdits(z,L){this.s(z,Ne,G=>Promise.resolve(G.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(z,L,G){const H=this.t(new de(this.h,G),z);return this.e.$registerMappedEditsProvider(H,this.o(L,z)),this.p(H)}$provideMappedEdits(z,L,G,H,_){return this.s(z,de,se=>Promise.resolve(se.provideMappedEdits(L,G,H,_)),null,_)}registerDocumentPasteEditProvider(z,L,G,H){const _=this.q();return this.f.set(_,new Ce(new j(this.e,this.h,G,_,z),z)),this.e.$registerPasteEditProvider(_,this.o(L,z),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(z,L,G,H,_){return this.s(z,j,se=>se.prepareDocumentPaste(u.URI.revive(L),G,H,_),void 0,_)}$providePasteEdits(z,L,G,H,_,se,Fe){return this.s(z,j,Be=>Be.providePasteEdits(L,u.URI.revive(G),H,_,se,Fe),void 0,Fe)}$resolvePasteEdit(z,L,G){return this.s(z,j,H=>H.resolvePasteEdit(L,G),{},void 0)}$releasePasteEdits(z,L){this.s(z,j,G=>Promise.resolve(G.releasePasteEdits(L)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Me.w(z.decreaseIndentPattern),increaseIndentPattern:Me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Me.w(z.beforeText),afterText:z.afterText?Me.w(z.afterText):void 0,previousLineText:z.previousLineText?Me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(L=>a.SyntaxTokenType.toString(L)):void 0}}static D(z){return z.map(Me.C)}setLanguageConfiguration(z,L,G){const{wordPattern:H}=G;if(H&&(0,T.$ff)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const _=this.q(),se={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,L,se),this.p(_)}$setWordDefinitions(z){for(const L of z)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$$jc=Me}),define(Re[88],Ae([1,0,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=e.$Rkc=void 0,e.$Rkc=(0,w.$qi)("IExtHostLanguageModels");class r{constructor(t,b){this.option=t,this.stream=new g.$Th,this.stream=b??new g.$Th}}class i{constructor(){this.a=new Map,this.b=new g.$Th,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let b=this.a.get(t.index);b||(this.a.size===0?b=new r(t.index,this.b):b=new r(t.index),this.a.set(t.index,b)),b.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const b of this.f())b.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{n=this}static{this.a=1}constructor(t,b,c){this.j=b,this.k=c,this.c=new D.$be,this.d=new D.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Nm,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,b,c,m){const v=n.a++;this.f.set(v,{extension:t.identifier,provider:c,languageModelId:b});let $;return m.auth&&($={providerLabel:t.displayName||t.name,accountLabel:typeof m.auth=="object"?m.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,b,{extension:t.identifier,identifier:b,model:m.name??"",auth:$}),(0,I.$Sc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(t,b,c,m,v,$){const h=this.f.get(t);if(!h)return;const E=new M.$Zv(async f=>{if($.isCancellationRequested){this.j.warn(`[CHAT](${h.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(b,{index:f.index,part:f.part})});return h.provider.provideLanguageModelResponse2(m.map(R.LanguageModelMessage.to),v,p.$Lm.toKey(c),E,$)}$updateLanguageModels(t){const b=[],c=[];if(t.added)for(const m of t.added)this.g.set(m.identifier,m),b.push(m.model);if(t.removed)for(const m of t.removed){this.g.delete(m),c.push(m);for(const[v,$]of this.i)$.languageModelId===m&&($.res.reject(new u.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(b),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const b=new Array;for(const{from:c,to:m,enabled:v}of t){const $=this.h.get(c)??new p.$Mm;if($.has(m)!==v){v?$.add(m):$.delete(m),this.h.set(c,$);const E={from:c,to:m};b.push(E),this.c.fire(E)}}}async sendChatRequest(t,b,c,m,v){const $=t.identifier,h=await this.b.$prepareChatAccess($,b,m.justification);if(!h||!this.g.has(b))throw F.$ZO.NotFound(`Language model '${b}' is unknown.`);if(this.m($,h)&&(!await this.l(t,{identifier:h.extension,displayName:h.auth.providerLabel},m.justification,m.silent)||!this.h.get($)?.has(h.extension)))throw F.$ZO.NoPermissions(`Language model '${b}' cannot be used by '${$.value}'.`);const E=Math.random()*1e6|0,f=this.b.$fetchResponse($,b,E,c.map(R.LanguageModelMessage.from),m.modelOptions??{},v),S=new g.$ph,y=new i;this.i.set(E,{languageModelId:b,res:y});let C;if(f.catch(P=>{S.isOpen()?y.reject(P):C=P}).finally(()=>{this.i.delete(E),y.resolve(),S.open()}),await S.wait(),C)throw new F.$ZO(`Language model '${b}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,b){const c=this.i.get(t);c&&c.res.handleFragment(b)}async l(t,b,c,m){const v=k.$RL+b.identifier.value;if(await this.k.getSession(t,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:b.identifier,enabled:!0}]),!0;if(m)return!1;try{const h=c?(0,T.localize)(0,null,b.displayName,c):(0,T.localize)(1,null,b.displayName);return await this.k.getSession(t,v,[],{forceNewSession:{detail:h}}),this.$updateModelAccesslist([{from:t.identifier,to:b.identifier,enabled:!0}]),!0}catch{return!1}}m(t,b){return!!b.auth&&!p.$Lm.equals(b.extension,t)}async n(t){for(const b of this.o)try{await this.l(b,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const b=this,c=D.Event.signal(D.Event.filter(this.c.event,v=>p.$Lm.equals(v.from,t.identifier))),m=D.Event.signal(this.d.event);return{get onDidChange(){return D.Event.any(c,m)},canSendRequest(v){const $=b.g.get(v);if(!$)return;if(!b.m(t.identifier,$))return!0;const h=b.h.get(t.identifier);if(h)return h.has($.extension)}}}};e.$Skc=a,e.$Skc=a=n=Je([Ve(0,d.$aP),Ve(1,o.$Wj),Ve(2,s.$akc)],a)}),define(Re[264],Ae([1,0,4,8,7,33,11,6,25]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class D{constructor(k,u,w,d){this.c=u,this.d=w,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(I.$PM.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,u){await this.a.$changeLanguage(k,u);const w=this.c.getDocumentData(k);if(!w)throw new Error(`document '${k.toString()}' NOT found`);return w.document}async tokenAtPosition(k,u){const w=k.version,d=N.Position.from(u),s=await this.a.$tokensAtPosition(k.uri,d),o={type:R.StandardTokenType.Other,range:k.getWordRangeAtPosition(u)??new R.$TM(u.line,u.character,u.line,u.character)};if(!s)return o;const n={range:N.Range.to(s.range),type:N.TokenType.to(s.type)};return!n.range.contains(u)||w!==k.version?o:n}createLanguageStatusItem(k,u,w){const d=this.f++,s=this.a,o=this.g,n=`${k.identifier.value}/${u}`;if(o.has(n))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(n);const r={selector:w,id:u,name:k.displayName??k.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new p.$Tc,l=()=>{if(i?.dispose(),!o.has(n)){console.warn(`LanguageStatusItem (${u}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$sh)(()=>{a.clear(),this.a.$setLanguageStatus(d,{id:n,name:r.name??k.displayName??k.name,source:k.displayName??k.name,selector:N.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===R.LanguageStatusSeverity.Error?F.default.Error:r.severity===R.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),s.$removeLanguageStatus(d),o.delete(n)},get id(){return r.id},get name(){return r.name},set name(b){r.name=b,l()},get selector(){return r.selector},set selector(b){r.selector=b,l()},get text(){return r.text},set text(b){r.text=b,l()},set text2(b){(0,g.$yG)(k,"languageStatusText"),r.text=b,l()},get text2(){return(0,g.$yG)(k,"languageStatusText"),r.text},get detail(){return r.detail},set detail(b){r.detail=b,l()},get severity(){return r.severity},set severity(b){r.severity=b,l()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(b){r.accessibilityInformation=b,l()},get command(){return r.command},set command(b){r.command=b,l()},get busy(){return r.busy},set busy(b){r.busy=b,l()}};return l(),t}}e.$xlc=D}),define(Re[265],Ae([1,0,12,2,8,7,83]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0;class p{constructor(k,u,w,d){this.start=k,this.deletedCount=u,this.deletedItems=w,this.items=d}asApiEvent(){return{range:new F.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k){return{EOL:k.eol,lines:k.source,languageId:k.language,uri:k.uri,isDirty:!1,versionId:1}}constructor(k,u,w){this.notebook=k,this.h=u,this.j=w,this.handle=w.handle,this.uri=N.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(R.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return k.g},set mime(d){k.g=d},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(w)}return this.f}setOutputs(k){this.a=k.map(R.NotebookCellOutput.to)}setOutputItems(k,u,w){const d=w.map(R.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===k);if(s&&(u||(s.items.length=0),s.items.push(...d),s.items.length>1&&s.items.every(o=>M.$MK(o.mime)))){const o=new Map,n=[];s.items.forEach(r=>{let i;o.has(r.mime)?i=o.get(r.mime):(i=[],o.set(r.mime,i),n.push(r.mime)),i.push(r.data)}),s.items.length=0,n.forEach(r=>{const i=M.$NK(o.get(r));s.items.push({mime:r,data:i.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$jlc=g;class D{static{this.a=0}constructor(k,u,w,d,s){this.k=k,this.l=u,this.m=w,this.uri=d,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,u={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===I.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(w){return w=k.n(w),k.b[w].apiCell},getCells(w){return(w?k.p(w):k.b).map(s=>s.apiCell)},save(){return k.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,u,w){this.g=k.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:w});const d={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},s=[];for(const n of k.rawEvents)n.kind===M.NotebookCellsChangeType.ModelChange?this.r(n.changes,!1,d.contentChanges):n.kind===M.NotebookCellsChangeType.Move?this.s(n.index,n.length,n.newIdx,d.contentChanges):n.kind===M.NotebookCellsChangeType.Output?(this.t(n.index,n.outputs),s.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===M.NotebookCellsChangeType.OutputItem?(this.u(n.index,n.outputId,n.append,n.outputItems),s.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(n.index,n.language),s.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document})):n.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document}):n.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(n.index,n.mime):n.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(n.index,n.metadata),s.push({cell:this.b[n.index].apiCell,metadata:this.b[n.index].apiCell.metadata})):n.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(n.index,n.internalMetadata),s.push({cell:this.b[n.index].apiCell,executionSummary:this.b[n.index].apiCell.executionSummary}));const o=new Map;for(let n=0;n<s.length;n++){const r=s[n],i=o.get(r.cell);if(i===void 0){const a=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,a-1)}else d.cellChanges[i]={...d.cellChanges[i],...r}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let u=k.start|0,w=k.end|0;return u<0&&(u=0),w>this.b.length&&(w=this.b.length),k.with({start:u,end:w})}p(k){k=this.o(k);const u=[];for(let w=k.start;w<k.end;w++)u.push(this.b[w]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,u,w){if(this.j)return;const d=[],s=[],o=[];if(k.reverse().forEach(n=>{const i=n[2].map(t=>{const b=new g(this,this.l,t);return u||s.push(g.asModelAddData(t)),b}),a=new p(n[0],n[1],[],i),l=this.b.splice(n[0],n[1],...i);for(const t of l)o.push(t.uri),a.deletedItems.push(t.apiCell);d.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),w)for(const n of d)w.push(n.asApiEvent())}s(k,u,w,d){const s=this.b.splice(k,u);this.b.splice(w,0,...s);const o=[new p(k,u,s.map(n=>n.apiCell),[]),new p(w,0,[],s)];for(const n of o)d.push(n.asApiEvent())}t(k,u){this.b[k].setOutputs(u)}u(k,u,w,d){this.b[k].setOutputItems(u,w,d)}v(k,u){const w=this.b[k];w.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(w.uri,u)}w(k,u){const w=this.b[k];w.apiCell.mime=u}x(k,u){this.b[k].setMetadata(u)}y(k,u){this.b[k].setInternalMetadata(u)}getCellFromApiCell(k){return this.b.find(u=>u.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(u=>u.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$klc=D}),define(Re[266],Ae([1,0,5,2,8,7,34]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class p{constructor(D,T,k,u={timeout:1500,errors:3}){this.b=D,this.c=T,this.d=k,this.f=u,this.a=new I.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(T,k,u)=>{const w=function(s){T.call(k,s)};return w.extension=D,this.a.event(w,void 0,u)}}async $participateInSave(D,T,k){const u=N.URI.revive(D),w=this.c.getNotebookDocument(u);if(!w)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:R.TextDocumentSaveReason.to(T)},k,async(o,n)=>{const r=Date.now(),i=await await Promise.resolve(o);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!k.isCancellationRequested&&i&&(i instanceof F.$2M?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data"))}),k.isCancellationRequested)return!1;if(d.length===0)return!0;const s={edits:[]};for(const o of d){const{edits:n}=R.WorkspaceEdit.from(o);s.edits=s.edits.concat(n)}return this.d.$tryApplyWorkspaceEdit(new M.$mw(s))}}e.$zlc=p}),define(Re[112],Ae([1,0,14,8,7]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,g,D,T,k,u){this.id=p,this.f=g,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=T,this.c=u}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(g){this.selections=[g]},get selections(){return p.a},set selections(g){if(!Array.isArray(g)||!g.every(R.$gO.isNotebookRange))throw(0,I.$7)("selections");p.a=g,p.g(g)},get visibleRanges(){return p.b},revealRange(g,D){p.f.$tryRevealRange(p.id,N.NotebookRange.from(g),D??R.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$llc=F}),define(Re[267],Ae([1,0,5,13,8]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0;let F=class{constructor(p,g){this.c=p,this.d=g,this.a=new I.$be,this.b=new I.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,g);const D=this.d.getEditorById(p);g.visibleRanges&&D._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&D._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const g in p)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(p[g]))}};e.$Blc=F,e.$Blc=F=Je([Ve(0,N.$Wj)],F)}),define(Re[268],Ae([1,0,5,4,112]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class F{constructor(p,g){this.c=g,this.a=new Map,this.b=p.getProxy(N.$PM.MainThreadNotebookRenderers)}$postRendererMessage(p,g,D){const T=this.c.getEditorById(p);this.a.get(g)?.fire({editor:T.apiEditor,message:D})}createRendererMessaging(p,g){if(!p.contributes?.notebookRenderer?.some(T=>T.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(T,k,u)=>this.d(g).event(T,k,u),postMessage:(T,k)=>{R.$llc.apiEditorsToExtHost.has(T)&&([T,k]=[k,T]);const u=k&&R.$llc.apiEditorsToExtHost.get(k);return this.b.$postMessage(u?.id,g,T)}}}d(p){let g=this.a.get(p);return g||(g=new I.$be({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(p)}}),this.a.set(p,g),g)}}e.$Elc=F}),define(Re[269],Ae([1,0,8,101,24,68,14]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class p{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,u,w){const d=this.b++,{title:s,location:o,cancellable:n}=u,r={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(d,{location:I.ProgressLocation.from(o),title:s,source:r,cancellable:n},k.isUnderDevelopment?void 0:k.identifier.value).catch(M.$2),this.d(d,w,!!n)}d(k,u,w){let d;w&&(d=new R.$me,this.c.set(k,d));const s=n=>{this.a.$progressEnd(n),this.c.delete(n),d?.dispose()};let o;try{o=u(new D(this.a,k),w&&d?d.token:R.CancellationToken.None)}catch(n){throw s(k),n}return o.then(n=>s(k),n=>s(k)),o}$acceptProgressCanceled(k){const u=this.c.get(k);u&&(u.cancel(),this.c.delete(k))}}e.$Ilc=p;function g(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class D extends N.$Zv{constructor(k,u){super(w=>this.throttledReport(w)),this.c=k,this.d=u}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,F.$Wh)(100,(T,k)=>g(T,k),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(Re[270],Ae([1,0,2,4,11,8]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class M{static{this.a=0}constructor(g,D){this.d=D,this.c=new Map,this.b=g.getProxy(N.$PM.MainThreadQuickDiff)}$provideOriginalResource(g,D,T){const k=I.URI.revive(D),u=this.c.get(g);return u?(0,R.$ih)(()=>u.provideOriginalResource(k,T)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(g,D,T,k){const u=M.a++;return this.c.set(u,D),this.b.$registerQuickDiffProvider(u,F.DocumentSelector.from(g,this.d),T,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Jlc=M}),define(Re[271],Ae([1,0,24,5,6,4,2,7,14,18,33,41,25,8]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=d;function d(s,o,n){const r=s.getProxy(F.$PM.MainThreadQuickOpen);class i{constructor(h,E){this.e=new Map,this.f=0,this.a=h,this.b=E}showQuickPick(h,E,f,S=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(E),C=++this.f,P=r.$show(C,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},S),V={},W=P.then(()=>V);return Promise.race([W,y]).then(q=>{if(q===V)return;const A=(0,u.$xG)(h,"quickPickItemTooltip");return y.then(j=>{const K=[];for(let ie=0;ie<j.length;ie++){const ce=j[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!A&&console.warn(`Extension '${h.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`);const ve=ce.iconPath?c(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:A?w.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=ie=>{f.onDidSelectItem(j[ie])}),r.$setItems(C,K),P.then(ie=>{if(typeof ie=="number")return j[ie];if(Array.isArray(ie))return ie.map(ce=>j[ce])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return r.$setError(C,q),Promise.reject(q)})}$onItemSelected(h){this.c?.(h)}showInput(h,E=I.CancellationToken.None){return this.d=h?.validateInput,r.$input(h,typeof this.d=="function",E).then(void 0,f=>{if(!(0,g.$4)(f))return Promise.reject(f)})}async $validateInput(h){if(!this.d)return;const E=await this.d(h);if(!E||typeof E=="string")return E;let f;switch(E.severity){case p.InputBoxValidationSeverity.Info:f=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:f=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:f=T.default.Error;break;default:f=E.message?T.default.Error:T.default.Ignore;break}return{content:E.message,severity:f}}async showWorkspaceFolderPick(h,E=I.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!f)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(y=>y.uri.toString()===f.uri.toString())}createQuickPick(h){const E=new m(h,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(h){const E=new v(h,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(h,E){this.e.get(h)?._fireDidChangeValue(E)}$onDidAccept(h){this.e.get(h)?._fireDidAccept()}$onDidChangeActive(h,E){const f=this.e.get(h);f instanceof m&&f._fireDidChangeActive(E)}$onDidChangeSelection(h,E){const f=this.e.get(h);f instanceof m&&f._fireDidChangeSelection(E)}$onDidTriggerButton(h,E){this.e.get(h)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(h,E,f){const S=this.e.get(h);S instanceof m&&S._fireDidTriggerItemButton(E,f)}$onDidHide(h){this.e.get(h)?._fireDidHide()}}class a{static{this.a=1}constructor(h,E){this.x=h,this.y=E,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(h){this.b=h,this.z({title:h})}get step(){return this.c}set step(h){this.c=h,this.z({step:h})}get totalSteps(){return this.d}set totalSteps(h){this.d=h,this.z({totalSteps:h})}get enabled(){return this.g}set enabled(h){this.g=h,this.z({enabled:h})}get busy(){return this.j}set busy(h){this.j=h,this.z({busy:h})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(h){this.k=h,this.z({ignoreFocusOut:h})}get value(){return this.l}set value(h){this.l=h,this.z({value:h})}get placeholder(){return this.m}set placeholder(h){this.m=h,this.z({placeholder:h})}get buttons(){return this.n}set buttons(h){this.n=h.slice(),this.o.clear(),h.forEach((E,f)=>{const S=E===p.$dO.Back?-1:f;this.o.set(S,E)}),this.z({buttons:h.map((E,f)=>({...c(E.iconPath),tooltip:E.tooltip,handle:E===p.$dO.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(h){this.l=h,this.q.fire(h)}_fireDidTriggerButton(h){const E=this.o.get(h);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(h){if(!this.v){for(const E of Object.keys(h)){const f=h[E];this.u[E]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function l($){if($ instanceof p.$NN)return{id:$.id};const h=b($),E=t($);return{dark:typeof h=="string"?M.URI.file(h):h,light:typeof E=="string"?M.URI.file(E):E}}function t($){return typeof $=="object"&&"light"in $?$.light:$}function b($){return typeof $=="object"&&"dark"in $?$.dark:$}function c($){const h=l($);let E,f;return"id"in h?f=k.ThemeIcon.asClassName(h):E=h,{iconPath:E,iconClass:f}}class m extends a{constructor(h,E){super(h.identifier,E),this.O=h,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(h){this.B=h.slice(),this.C.clear(),this.D.clear(),h.forEach((S,y)=>{this.C.set(y,S),this.D.set(S,y)});const E=(0,u.$xG)(this.O,"quickPickItemTooltip"),f=[];for(let S=0;S<h.length;S++){const y=h[S];if(y.kind===p.QuickPickItemKind.Separator)f.push({type:"separator",label:y.label});else{y.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;f.push({handle:S,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:E?w.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((P,V)=>({...c(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(h){this.E=h,this.z({canSelectMany:h})}get matchOnDescription(){return this.F}set matchOnDescription(h){this.F=h,this.z({matchOnDescription:h})}get matchOnDetail(){return this.G}set matchOnDetail(h){this.G=h,this.z({matchOnDetail:h})}get sortByLabel(){return this.H}set sortByLabel(h){this.H=h,this.z({sortByLabel:h})}get keepScrollPosition(){return this.I}set keepScrollPosition(h){this.I=h,this.z({keepScrollPosition:h})}get activeItems(){return this.J}set activeItems(h){this.J=h.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(h){this.L=h.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(h){const E=(0,D.$Hb)(h.map(f=>this.C.get(f)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(h){const E=(0,D.$Hb)(h.map(f=>this.C.get(f)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(h,E){const f=this.C.get(h);if(!f||!f.buttons||!f.buttons.length)return;const S=f.buttons[E];S&&this.N.fire({button:S,item:f})}}class v extends a{constructor(h,E){super(h.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(h){this.B=h,this.z({password:h})}get prompt(){return this.C}set prompt(h){this.C=h,this.z({prompt:h})}get valueSelection(){return this.D}set valueSelection(h){this.D=h,this.z({valueSelection:h})}get validationMessage(){return this.E}set validationMessage(h){this.E=h,h?typeof h=="string"?this.z({validationMessage:h,severity:T.default.Error}):this.z({validationMessage:h.message,severity:h.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new i(o,n)}}),define(Re[272],Ae([1,0,2,5,68,6,11,4,18,143,13,20,41,8,25,12,21]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0;function r(C){return C instanceof I.URI}function i(C,P){return C.scheme===s.Schemas.file&&P.scheme===s.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||u.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function l(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(u.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function t(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,D.$ir)(V,W)}function b(C,P){let V=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(V=t(C,P),V!==0)return V;if(C.light&&P.light)V=t(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(V!==0)return V;if(C.dark&&P.dark)V=t(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return V}function c(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<C.arguments.length;V++){const W=C.arguments[V],q=P.arguments[V];if(W!==q&&!(r(W)&&r(q)&&i(W,q)))return W<q?-1:1}return 0}function m(C,P){let V=(0,D.$ir)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(C.command&&P.command)V=c(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(V!==0)return V;if(C.decorations&&P.decorations)V=b(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,D.$ir)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,D.$ir)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function v(C,P){for(let V=0;V<C.length;V++)if(C[V]!==P[V])return!1;return!0}function $(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?v(C.arguments,P.arguments):C.arguments===P.arguments)}function h(C,P){return(0,g.$ub)(C,P,$)}class E{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,d.$yG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,d.$yG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,d.$yG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,A){this.k=P,this.l=q,this.m=A,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,d.$yG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Llc=E;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,A,j,K){this.q=P,this.s=V,this.t=W,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=j,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,M.$ih)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(m),W=(0,g.$Db)(this.o,P,m).map(j=>{const K=j.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ve=ie.resourceUri;let Ie;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const fe=new F.$Tc;Ie=this.s.converter.toInternal(ie.command,fe),this.j.set(ce,fe)}else this.h.set(ce,ie.command);const ue=(0,d.$xG)(this.w,"scmMultiDiffEditor"),pe=ue?ie.multiDiffEditorOriginalUri:void 0,re=ue?ie.multiFileDiffEditorModifiedUri:void 0,Se=a(ie.decorations),Le=ie.decorations&&a(ie.decorations.light)||Se,ne=ie.decorations&&a(ie.decorations.dark)||Se,U=[Le,ne],x=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Te=ie.decorations&&!!ie.decorations.faded,Ee=ie.contextValue||"";return{rawResource:[ce,ve,U,x,be,Te,Ee,Ie,pe,re],handle:ce}});return{start:j.start,deleteCount:j.deleteCount,toInsert:K}}),q=W.map(({start:j,deleteCount:K,toInsert:ie})=>[j,K,ie.map(ce=>ce.rawResource)]),A=W.reverse();for(const{start:j,deleteCount:K,toInsert:ie}of A){const ce=ie.map(Ie=>Ie.handle),ve=this.n.splice(j,K,...ce);for(const Ie of ve)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,d.$xG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,d.$yG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,d.$yG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new F.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new F.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,d.$yG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,d.$yG)(this.x,"scmActionButton"),this.p.value=new F.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&h(this.t,P))return;this.s.value=new F.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,A,j,K){this.x=P,this.y=q,this.z=A,this.A=j,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Vc,this.m=void 0,this.n=new F.$Vc,this.o=void 0,this.p=new F.$Vc,this.s=new F.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=W;const ie=I.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new E(P,V,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,A,j,K,ie)}createResourceGroup(P,V,W){const q=(0,d.$xG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,A=new f(this.#e,this.y,this.w,P,V,q,this.x),j=N.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,j),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const A=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});N.Event.once(W.onDidDispose)(()=>{this.D.delete(W),A.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const j=W._takeResourceStateSnapshot();j.length>0&&V.push([W.handle,j]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Vh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Vh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{n=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new k.$Nm,this.j=new N.$be,this.e=P.getProxy(p.$PM.MainThreadSCM),this.f=P.getProxy(p.$PM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const j=this.g.get(A.sourceControlHandle);if(!j)return A;const K=j.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const j=this.g.get(A.sourceControlHandle);return j?j.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const j=this.g.get(A.handle);return j||A}return A}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const A=n.d++,j=new S(P,this.m,this.e,this.l,V,W,q);this.g.set(A,j);const K=this.h.get(P.identifier)||[];return K.push(j),this.h.set(P.identifier,K),j}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=I.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const A=this.g.get(P);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>A.quickDiffProvider.provideOriginalResource(q,W)).then(j=>j||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const A=this.g.get(P);if(!A)return Promise.resolve(void 0);const j=A.getResourceGroup(V);return j?j.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>q.inputBox.validateInput(V,W)).then(A=>{if(!A)return Promise.resolve(void 0);const j=w.MarkdownString.fromStrict(A.message);return j?Promise.resolve([j,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(K=>({...K,icon:l(K)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const A=this.g.get(P)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const j=await A.provideHistoryItemSummary(V,W,q);return j?{...j,icon:l(j)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$Mlc=y,e.$Mlc=y=n=Je([Ve(3,T.$Wj)],y)}),define(Re[273],Ae([1,0,4,8,2]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class F{static{this.a=0}constructor(p,g){this.d=g,this.c=new Map,this.b=p.getProxy(I.$PM.MainThreadShare)}async $provideShare(p,g,D){return await this.c.get(p)?.provideShare({selection:N.Range.to(g.selection),resourceUri:R.URI.revive(g.resourceUri)},D)??void 0}registerShareProvider(p,g){const D=F.a++;return this.c.set(D,g),this.b.$registerShareProvider(D,N.DocumentSelector.from(p,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$Nlc=F}),define(Re[274],Ae([1,0,7,4,170,6,8,17]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor(u,w,d,s,o,n=I.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new F.$Tc,this.#e=u,this.#t=w,o&&s){this.c=(0,I.$qN)(s.identifier,o);const i=d.get(this.c);i&&(n=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,r=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(g.a++);this.e=s,this.f=o,this.g=n,this.h=this.u(r)}u(u){if((0,p.$8f)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!g.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new F.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let w;this.m?w=this.m:w=(0,R.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=g.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,w,this.k,s,this.r?.internal,d,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Plc=g;class D{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const w={message:u};return this.b.unshift(w),this.c(),new I.$RM(()=>{const d=this.b.indexOf(w);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(u,w){this.e=new Map,this.a=u.getProxy(N.$PM.MainThreadStatusBar),this.b=w,this.c=new D(this)}$acceptStaticEntries(u){for(const w of u)this.e.set(w.entryId,w)}createStatusBarEntry(u,w,d,s){return new g(this.a,this.b,this.e,u,w,d,s)}setStatusBarMessage(u,w){const d=this.c.setMessage(u);let s;return typeof w=="number"?s=setTimeout(()=>d.dispose(),w):typeof w<"u"&&w.then(()=>d.dispose(),()=>d.dispose()),new I.$RM(()=>{d.dispose(),clearTimeout(s)})}}e.$Qlc=T}),define(Re[113],Ae([1,0,29,105,50,75,61,8,2]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=e.$nP=e.$mP=void 0;const D=(i,a,l,t)=>{let b=a;return{enumerable:!0,configurable:!1,get(){return b},set(c){if(!l(b,c)){const m=b;b=c,i.listener?.(t(c,m))}}}},T=(i,a)=>i===a,k={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(i,a)=>!(i.length!==a.length||i.some(l=>!a.find(t=>l.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),w=(i,a)=>({range:(()=>{let l;const t=u(b=>({range:I.$kt.lift(p.Range.from(b))}));return{enumerable:!0,configurable:!1,get(){return l},set(b){i.listener?.({op:6}),k.range(l,b)||(l=b,i.listener?.(t(b)))}}})(),label:D(i,a,k.label,u(l=>({label:l}))),description:D(i,void 0,k.description,u(l=>({description:l}))),sortText:D(i,void 0,k.sortText,u(l=>({sortText:l}))),canResolveChildren:D(i,!1,k.canResolveChildren,l=>({op:2,state:l})),busy:D(i,!1,k.busy,u(l=>({busy:l}))),error:D(i,void 0,k.error,u(l=>({error:p.MarkdownString.fromStrict(l)||null}))),tags:D(i,[],k.tags,(l,t)=>({op:1,new:l.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),d=i=>{const a=R.$BL.fromString(i.extId),l=new o(a.controllerId,a.localId,i.label,g.URI.revive(i.uri)||void 0);return l.range=p.Range.to(i.range||void 0),l.description=i.description||void 0,l.sortText=i.sortText||void 0,l.tags=i.tags.map(t=>p.TestTag.to({id:(0,M.$HL)(t).tagId})),l},s=i=>{let a;for(const l of i.tests){const t=d(l.item);(0,N.$9O)(t).parent=a,a=t}return a};e.$mP=s;class o{constructor(a,l,t,b){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const c=(0,N.$8O)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof n?void 0:c.parent}},children:{value:(0,F.$7O)(c,N.$9O,o),enumerable:!0,writable:!1},...w(c,t)})}}e.$nP=o;class n extends o{constructor(a,l){super(a,a,l,void 0),this._isRoot=!0}}e.$oP=n;class r extends F.$3O{constructor(a,l,t){super({controllerId:a,getDocumentVersion:b=>b&&t.getDocument(b)?.version,getApiFor:N.$9O,getChildren:b=>b.children,root:new n(a,l),toITestItem:p.TestItem.from})}}e.$pP=r}),define(Re[32],Ae([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,22,34,42,65,59,62,35]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=void 0;let c=class{#e;#t;#i;constructor(f,S,y){this.b=new Map,this.c=new Map,this.#e=f.getProxy(M.$PM.MainThreadCommands),this.d=S,this.#i=y,this.#t=f.getProxy(M.$PM.MainThreadTelemetry),this.converter=new m(this,C=>{const P=this.c.get(C);return P?.result===$.Void?P:void 0},S),this.f=[{processArgument(C){return(0,D.$Zh)(C)}},{processArgument(C){return(0,F.$Yn)(C,function(P){if(T.$kt.isIRange(P))return R.Range.to(P);if(k.$jt.isIPosition(P))return R.Position.to(P);if(T.$kt.isIRange(P.range)&&u.URI.isUri(P.uri))return R.location.to(P);if(P instanceof n.$Ce)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const S=this.registerCommand(!1,f.id,async(...y)=>{const C=f.args.map((V,W)=>{if(!V.validate(y[W]))throw new Error(`Invalid argument '${V.name}' when running '${f.id}', received: ${typeof y[W]=="object"?JSON.stringify(y[W],null,"	"):y[W]} `);return V.convert(y[W])}),P=await this.executeCommand(f.internalId,...C);return f.result.convert(P,y,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new N.$RM(()=>{S.dispose(),this.c.delete(f.id)})}registerCommand(f,S,y,C,P,V){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:y,thisArg:C,metadata:P,extension:V}),f&&this.#e.$registerCommand(S),new N.$RM(()=>{this.b.delete(S)&&f&&this.#e.$unregisterCommand(S)})}executeCommand(f,...S){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,S,!0)}async g(f,S,y){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,S,!1);{let C=!1;const P=(0,F.$Yn)(S,function(V){if(V instanceof N.$SM)return R.Position.from(V);if(V instanceof N.$TM)return R.Range.from(V);if(V instanceof N.$4M)return R.location.from(V);if(N.$gO.isNotebookRange(V))return R.NotebookRange.from(V);if(V instanceof ArrayBuffer)return C=!0,n.$Ce.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return C=!0,n.$Ce.wrap(V);if(V instanceof n.$Ce)return C=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(f,C?new r.$mw(P):P,y);return(0,D.$Zh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(f,S,!1);throw V}}}async h(f,S,y){const C=this.b.get(f);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=C;if(W?.args)for(let A=0;A<W.args.length;A++)try{(0,I.$ig)(S[A],W.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${W.args[A].name}' - ${W.args[A].description}`)}const q=a.$0d.create();try{return await P.apply(V,S)}catch(A){if(f===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...S);j&&(f=j.command)}if(this.d.error(A,f,C.extension?.identifier),!y)throw A;if(C.extension?.identifier){const j=this.#i.onExtensionError(C.extension.identifier,A);this.d.trace("forwarded error to extension?",j,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$bj)(A)),this.id=f,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,f,q.elapsed())}}j(f,S,y){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new l.$_o(S),duration:y})}$executeContributedCommand(f,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const y=this.b.get(f);return y?(S=S.map(C=>this.f.reduce((P,V)=>V.processArgument(P,y.extension?.identifier),C)),this.h(f,S,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(S=>(f&&(S=S.filter(y=>y[0]!=="_")),S))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[S,y]of this.b){const{metadata:C}=y;C&&(f[S]=C)}return Promise.resolve(f)}};e.$vP=c,e.$vP=c=Je([Ve(0,s.$aP),Ve(1,g.$Wj),Ve(2,t.$uP)],c),e.$wP=(0,d.$qi)("IExtHostCommands");class m{constructor(f,S,y){this.d=f,this.f=S,this.g=y,this.delegatingCommandId=`__vsc${(0,b.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,S){if(!f)return;const y={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return y;const C=this.f(f.command);if(C)y.id=C.internalId,y.arguments=C.args.map((P,V)=>P.convert(f.arguments&&f.arguments[V]));else if((0,p.$Lb)(f.arguments)){const P=`${f.command} /${++this.c}`;this.b.set(P,f),S.add((0,w.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),y.$ident=P,y.id=this.delegatingCommandId,y.arguments=[P],this.g.trace("CommandsConverter#CREATE",f.command,P)}return y}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const S=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$xP=m;class v{static{this.Uri=new v("uri","Uri of a text document",f=>u.URI.isUri(f),f=>f)}static{this.Position=new v("position","A position in a text document",f=>N.$SM.isPosition(f),R.Position.from)}static{this.Range=new v("range","A range in a text document",f=>N.$TM.isRange(f),R.Range.from)}static{this.Selection=new v("selection","A selection in a text document",f=>N.$UM.isSelection(f),R.Selection.from)}static{this.Number=new v("number","",f=>typeof f=="number",f=>f)}static{this.String=new v("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=v.Arr(v.String)}static Arr(f){return new v(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,S=>Array.isArray(S)&&S.every(y=>f.validate(y)),S=>S.map(y=>f.convert(y)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",f=>f instanceof N.$cN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",f=>f instanceof N.$AO,R.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",f=>f instanceof o.$nP,R.TestItem.from)}constructor(f,S,y,C){this.name=f,this.description=S,this.validate=y,this.convert=C}optional(){return new v(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,S){return new v(f??this.name,S??this.description,this.validate,this.convert)}}e.$yP=v;class ${static{this.Void=new $("no result",f=>f)}constructor(f,S){this.description=f,this.convert=S}}e.$zP=$;class h{constructor(f,S,y,C,P){this.id=f,this.internalId=S,this.description=y,this.args=C,this.result=P}}e.$AP=h}),define(Re[275],Ae([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;const k=[new g.$AP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of DocumentHighlight-instances.",w(D.DocumentHighlight.to))),new g.$AP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$yP.Uri],new g.$zP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,I.$Kb)(s))return;class n extends T.$0M{static to(i){const a=new n(i.name,D.SymbolKind.to(i.kind),i.containerName||"",new T.$4M(o[0],D.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=D.Range.to(i.selectionRange),a.children=i.children?i.children.map(n.to):[],a}}return s.map(n.to)})),new g.$AP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$yP.Uri,new g.$yP("options","Formatting options",s=>!0,s=>s)],new g.$zP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new g.$AP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$yP.Uri,g.$yP.Range,new g.$yP("options","Formatting options",s=>!0,s=>s)],new g.$zP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new g.$AP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$yP.Uri,g.$yP.Position,new g.$yP("ch","Trigger character",s=>typeof s=="string",s=>s),new g.$yP("options","Formatting options",s=>!0,s=>s)],new g.$zP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new g.$AP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location-instances.",w(D.location.to))),new g.$AP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Hover-instances.",w(D.Hover.to))),new g.$AP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$yP.Uri,new g.$yP("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>T.$SM.isPosition(o)),s=>s.map(D.Position.from))],new g.$zP("A promise that resolves to an array of ranges.",s=>s.map(o=>{let n;for(const r of o.reverse())n=new T.$bN(D.Range.to(r),n);return n}))),new g.$AP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$yP.String.with("query","Search string")],new g.$zP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(D.WorkspaceSymbol.to))),new g.$AP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(D.CallHierarchyItem.to))),new g.$AP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$yP.CallHierarchyItem],new g.$zP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(D.CallHierarchyIncomingCall.to))),new g.$AP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$yP.CallHierarchyItem],new g.$zP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(D.CallHierarchyOutgoingCall.to))),new g.$AP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:D.Range.to(s.range),placeholder:s.text}})),new g.$AP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$yP.Uri,g.$yP.Position,g.$yP.String.with("newName","The new symbol name")],new g.$zP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return D.WorkspaceEdit.to(s)}})),new g.$AP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$yP.Uri,g.$yP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$zP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(D.DocumentLink.to))),new g.$AP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$yP.Uri],new g.$zP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$0N(s.tokenTypes,s.tokenModifiers)})),new g.$AP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$yP.Uri],new g.$zP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$ibb)(s);if(o.type==="full")return new T.$_N(o.data,void 0)})),new g.$AP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$yP.Uri,g.$yP.Range.optional()],new g.$zP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$0N(s.tokenTypes,s.tokenModifiers)})),new g.$AP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$yP.Uri,g.$yP.Range],new g.$zP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$ibb)(s);if(o.type==="full")return new T.$_N(o.data,void 0)})),new g.$AP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$yP.Uri,g.$yP.Position,g.$yP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$yP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$zP("A promise that resolves to a CompletionList-instance.",(s,o,n)=>{if(!s)return new T.$nN([]);const r=s.suggestions.map(i=>D.CompletionItem.to(i,n));return new T.$nN(r,s.incomplete)})),new g.$AP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$yP.Uri,g.$yP.Position,g.$yP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$zP("A promise that resolves to SignatureHelp.",s=>{if(s)return D.SignatureHelp.to(s)})),new g.$AP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$yP.Uri,g.$yP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$zP("A promise that resolves to an array of CodeLens-instances.",(s,o,n)=>w(r=>new T.$fN(D.Range.to(r.range),r.command&&n.fromInternal(r.command)))(s))),new g.$AP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$yP.Uri,new g.$yP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.$TM.isRange(s),s=>T.$UM.isSelection(s)?D.Selection.from(s):D.Range.from(s)),g.$yP.String.with("kind","Code action kind to return code actions for").optional(),g.$yP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$zP("A promise that resolves to an array of Command-instances.",(s,o,n)=>w(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(r.command)}else{const i=new T.$_M(r.title,r.kind?new T.$aN(r.kind):void 0);return r.edit&&(i.edit=D.WorkspaceEdit.to(r.edit)),r.command&&(i.command=n.fromInternal(r.command)),i.isPreferred=r.isPreferred,i}})(s))),new g.$AP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$yP.Uri],new g.$zP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new T.$tN(D.Range.to(o.range),D.Color.to(o.color))):[])),new g.$AP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$yP("color","The color to show and insert",s=>s instanceof T.$sN,D.Color.from),new g.$yP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:D.Range.from(s.range)}))],new g.$zP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(D.ColorPresentation.to):[])),new g.$AP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$yP.Uri,g.$yP.Range],new g.$zP("A promise that resolves to an array of Inlay objects",(s,o,n)=>s.map(D.InlayHint.to.bind(void 0,n)))),new g.$AP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$yP.Uri],new g.$zP("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(D.FoldingRange.to)})),new g.$AP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$zP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>D.NotebookExclusiveDocumentPattern.to(o))})))),new g.$AP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$yP.Uri,g.$yP.Range,new g.$yP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof T.$TM,s=>D.InlineValueContext.from(s))],new g.$zP("A promise that resolves to an array of InlineValue objects",s=>s.map(D.InlineValue.to))),new g.$AP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$yP("uriOrString","Uri-instance or string (only http/https)",s=>R.URI.isUri(s)||typeof s=="string"&&(0,N.$Ag)(s,N.Schemas.http,N.Schemas.https),s=>s),new g.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional(),g.$yP.String.with("label","").optional()],g.$zP.Void),new g.$AP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$yP.Uri.with("resource","Resource to open"),g.$yP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional()],g.$zP.Void),new g.$AP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$yP.Uri.with("left","Left-hand side resource of the diff editor"),g.$yP.Uri.with("right","Right-hand side resource of the diff editor"),g.$yP.String.with("title","Human readable title for the diff editor").optional(),new g.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)]).optional()],g.$zP.Void),new g.$AP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$yP.String.with("title","Human readable title for the changes editor"),new g.$yP("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[n,r,i]=o;if(!R.URI.isUri(n)||!R.URI.isUri(r)&&r!==void 0&&r!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},s=>s)],g.$zP.Void),new g.$AP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new g.$AP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$yP.TypeHierarchyItem],new g.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new g.$AP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$yP.TypeHierarchyItem],new g.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new g.$AP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$yP.TestItem],g.$zP.Void),new g.$AP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$yP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$zP.Void),new g.$AP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$yP.String.with("name","The context key name"),new g.$yP("value","The context key value",()=>!0,s=>s)],g.$zP.Void),new g.$AP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$yP.Uri,g.$yP.StringArray,new g.$yP("MappedEditsContext","Mapped Edits Context",s=>D.MappedEditsContext.is(s),s=>D.MappedEditsContext.from(s))],new g.$zP("A promise that resolves to a workspace edit or null",s=>s?D.WorkspaceEdit.to(s):null))];class u{static register(o){k.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$pj)}}e.$_jc=u;function w(s){return o=>{if(Array.isArray(o))return o.map(s)}}function d(s){if(!Array.isArray(s))return;const o=[];for(const n of s)F.$2t(n)?o.push(D.DefinitionLink.to(n)):o.push(D.location.to(n));return o}}),define(Re[276],Ae([1,0,11,6,2,4,32,8,7]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class D{static{this.a=0}constructor(w,d){this.extension=w,this.provider=d,this.handle=D.a++}}class T{constructor(w){this.session=w,this.responses=[]}}class k{static{this.a=0}constructor(w,d,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=w.getProxy(F.$PM.MainThreadInlineChat),d.registerApiCommand(new M.$AP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$yP("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?p.Range.from(n.initialRange):void 0,initialSelection:g.$UM.isSelection(n.initialSelection)?p.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?p.Position.from(n.position):void 0}})],M.$zP.Void))}registerProvider(w,d,s){const o=new D(w,d);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??w.displayName??w.name,w.identifier,typeof d.handleInteractiveEditorResponseFeedback=="function",typeof d.provideFollowups=="function",s?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(w,d,s,o){const n=this.b.get(w);if(!n){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(R.URI.revive(d)),i=p.Selection.to(s),a=await n.provider.prepareInteractiveEditorSession({document:r,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=k.a++;return this.d.set(l,new T(a)),{id:l,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(a.wholeRange),message:a.message}}async $provideResponse(w,d,s,o){const n=this.b.get(w);if(!n)return;const r=this.d.get(d.id);if(!r)return;const i={prompt:s.prompt,selection:p.Selection.to(s.selection),wholeRange:p.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(R.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let a=!1;const l={report:async E=>{if(!s.live&&E.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:E.message,edits:E.edits?.map(p.TextEdit.from),editsShouldBeInstant:E.editsShouldBeInstant,slashCommand:E.slashCommand?.command,markdownFragment:g.$gN.isMarkdownString(E.content)?E.content.value:E.content})}},t=Promise.resolve(n.provider.provideInteractiveEditorResponse(r.session,i,l,o));let b;try{b=await(0,I.$eh)(t,o)}finally{a=!0}if(!b)return;const c=r.responses.push(b)-1,m={wholeRange:p.Range.from(b.wholeRange),placeholder:b.placeholder};if(!k.h(b))return{...m,id:c,type:"editorEdit",message:p.MarkdownString.from(b.contents),edits:[]};const{edits:v,contents:$}=b,h=$!==void 0?p.MarkdownString.from($):void 0;return v instanceof g.$2M?{...m,id:c,type:"bulkEdit",edits:p.WorkspaceEdit.from(v),message:h}:{...m,id:c,type:"editorEdit",edits:v.map(p.TextEdit.from),message:h}}async $provideFollowups(w,d,s,o){const n=this.b.get(w),r=this.d.get(d),i=r?.responses[s];if(n&&i&&n.provider.provideFollowups){const a=Promise.resolve(n.provider.provideFollowups(r.session,i,o));return(await(0,I.$eh)(a,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(w,d,s,o){const n=this.b.get(w),r=this.d.get(d),i=r?.responses[s];if(n&&i){const a=p.InteractiveEditorResponseFeedbackKind.to(o);n.provider.handleInteractiveEditorResponseFeedback?.(r.session,i,a)}}$releaseSession(w,d){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$ilc=k}),define(Re[277],Ae([1,0,2,32]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class R{constructor(M,p,g,D,T){this.a=p,this.b=g,this.c=D;const k=new N.$AP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$yP("showOptions","Show Options",u=>!0,u=>u),new N.$yP("resource","Interactive resource Uri",u=>!0,u=>u),new N.$yP("controllerId","Notebook controller Id",u=>!0,u=>u),new N.$yP("title","Interactive editor title",u=>!0,u=>u)],new N.$zP("Notebook and input URI",u=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const w=this.a.getEditorById(u.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:w.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(M,p,g,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$vlc=R}),define(Re[278],Ae([1,0,18,11,24,5,6,28,2,20,13,4,32,8,7,76,219,25,34,220]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Clc=void 0,e.$Dlc=v;let a=class{constructor(h,E,f,S,y){this.m=E,this.n=f,this.o=S,this.q=y,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=h.getProxy(k.$PM.MainThreadNotebookKernels);const C=new u.$AP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$yP("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],u.$zP.Void),P=new u.$AP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$yP.Uri],new u.$zP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(h,E,f,S,y,C){for(const Se of this.j.values())if(Se.controller.id===E&&D.$Lm.equals(h.identifier,Se.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${h.identifier.value}, ${E}`);const W=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${h.identifier}'`);let q=!1;const A=new F.$be,j=new F.$be,K={id:v(h.identifier,E),notebookType:f,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:S||h.identifier.value,preloads:C?C.map(w.NotebookRendererScript.from):[]};let ie=y??W,ce,ve;this.a.$addKernel(P,K).catch(Se=>{console.log(Se),q=!0});let Ie=0;const ue=()=>{if(q)return;const Se=++Ie;Promise.resolve().then(()=>{Se===Ie&&this.a.$updateKernel(P,K)})},pe=new p.$Bc,re={get id(){return E},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(Se){K.label=Se??h.displayName??h.name,ue()},get detail(){return K.detail??""},set detail(Se){K.detail=Se,ue()},get description(){return K.description??""},set description(Se){K.description=Se,ue()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Se){K.supportedLanguages=Se,ue()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Se){K.supportsExecutionOrder=Se,ue()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Se){ie=Se??W},get interruptHandler(){return ce},set interruptHandler(Se){ce=Se,K.supportsInterrupt=!!Se,ue()},set variableProvider(Se){(0,n.$yG)(h,"notebookVariableProvider"),ve=Se,K.hasVariableProvider=!!Se,Se?.onDidChangeVariables(Le=>V.a.$variablesUpdated(Le.uri)),ue()},get variableProvider(){return ve},createNotebookCellExecution(Se){if(q)throw new Error("notebook controller is DISPOSED");if(!pe.has(Se.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.notebook.uri.toString()}`);return V._createNotebookCellExecution(Se,v(h.identifier,this.id))},createNotebookExecution(Se){if((0,n.$yG)(h,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!pe.has(Se.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.uri.toString()}`);return V._createNotebookExecution(Se,v(h.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),A.dispose(),j.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(Se,Le){Le===d.NotebookControllerAffinity2.Hidden&&(0,n.$yG)(h,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,Se.uri,Le)},onDidReceiveMessage:j.event,postMessage(Se,Le){return(0,n.$yG)(h,"notebookMessaging"),V.a.$postMessage(P,Le&&V.n.getIdByEditor(Le),Se)},asWebviewUri(Se){return(0,n.$yG)(h,"notebookMessaging"),(0,s.$Gxb)(Se,V.m.remote)}};return this.j.set(P,{extensionId:h.identifier,controller:re,onDidReceiveMessage:j,onDidChangeSelection:A,associatedNotebooks:pe}),re}getIdByController(h){for(const[E,f]of this.j)if(f.controller===h)return v(f.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,E){const f=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(f,E);const y={dispose:()=>{this.f.delete(f),S.a.$removeKernelDetectionTask(f)}};return this.f.set(f,y),y}registerKernelSourceActionProvider(h,E,f){const S=this.i++,y=typeof f.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,C=this;this.h.set(S,f),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,E);let P;return y!==void 0&&(P=f.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(S),C.a.$removeKernelSourceActionProvider(S,S),P?.dispose()}}}async $provideKernelSourceActions(h,E){const f=this.h.get(h);if(f){const S=new M.$Tc;return(await f.provideNotebookKernelSourceActions(E)??[]).map(C=>w.NotebookKernelSourceAction.from(C,this.o.converter,S))}return[]}$acceptNotebookAssociation(h,E,f){const S=this.j.get(h);if(S){const y=this.n.getNotebookDocument(g.URI.revive(E));f?S.associatedNotebooks.set(y.uri,!0):S.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,y.uri.toString(),f),S.onDidChangeSelection.fire({selected:f,notebook:y.apiNotebook})}}async $executeCells(h,E,f){const S=this.j.get(h);if(!S)return;const y=this.n.getNotebookDocument(g.URI.revive(E)),C=[];for(const P of f){const V=y.getCell(P);V&&C.push(V.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,y.uri.toString(),C.length),await S.controller.executeHandler.call(S.controller,C,y.apiNotebook,S.controller)}catch(P){this.q.error(`NotebookController[${h}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(h,E,f){const S=this.j.get(h);if(!S)return;const y=this.n.getNotebookDocument(g.URI.revive(E));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,y.apiNotebook);else for(const C of f){const P=y.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(S.controller.interruptHandler){const C=this.c.get(y.uri);f.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(h,E,f,S,y,C,P){const V=this.j.get(h);if(!V)return;const W=this.n.getNotebookDocument(g.URI.revive(f)),q=V.controller.variableProvider;if(!q)return;let A;if(S!==void 0){if(A=this.s[S],!A)return}else this.s={};const j=y==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(W.apiNotebook,A,j,C,P);let ie=0;for await(const ce of K){if(P.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(E,ve),ie++>=i.$kib)return}}$acceptKernelMessageFromRenderer(h,E,f){const S=this.j.get(h);if(!S)return;const y=this.n.getEditorById(E);S.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:f}))}$cellExecutionChanged(h,E,f){const y=this.n.getNotebookDocument(g.URI.revive(h)).getCell(E);if(y){const C=f?w.NotebookCellExecutionState.to(f):d.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(h,E){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const y=new t(E,S,this.a);this.b.set(S.uri,y);const C=y.onDidChangeState(()=>{y.state===l.Resolved&&(y.dispose(),C.dispose(),this.b.delete(S.uri))});return y.asApiObject()}_createNotebookExecution(h,E){const f=this.n.getNotebookDocument(h.uri),S=h.getCells().find(P=>{const V=f.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const y=new c(E,f,this.a),C=y.onDidChangeState(()=>{y.state===b.Resolved&&(y.dispose(),C.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[y,C]),y.asApiObject()}};e.$Clc=a,e.$Clc=a=Je([Ve(4,T.$Wj)],a);var l;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(l||(l={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(h,E,f){super(),this.m=E,this.n=f,this.b=t.a++,this.c=new F.$be,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new R.$me),this.h=new m(10,S=>this.s(S)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const E=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new r.$mw(E))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let E=this.m;if(h&&(E=this.m.notebook.getCellFromApiCell(h)),!E)throw new Error("INVALID cell");return E.handle}y(h){return h.map(E=>{const f=d.$kO.ensureUniqueMimeTypes(E.items,!0);return f===E.items?w.NotebookCellOutput.from(E):w.NotebookCellOutput.from({items:f,id:E.id,metadata:E.metadata})})}async z(h,E,f){const S=this.w(E),y=this.y((0,I.$3b)(h));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:f,outputs:y})}async C(h,E,f){return h=d.$kO.ensureUniqueMimeTypes((0,I.$3b)(h),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:h.map(w.NotebookCellOutputItem.from),outputId:E.id,append:f})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(f){h.j=f,h.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(f){if(h.f===l.Resolved||h.f===l.Started)throw new Error("Cannot call start again");h.f=l.Started,h.c.fire(),h.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,S,y){if(h.f===l.Resolved)throw new Error("Cannot call resolve twice");h.f=l.Resolved,h.c.fire(),h.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;h.n.$completeExecution(h.b,new r.$mw({runEndTime:S,lastRunSuccess:f,error:C}))},clearOutput(f){return h.t(),h.z([],f,!1)},appendOutput(f,S){return h.t(),h.z(f,S,!0)},replaceOutput(f,S){return h.t(),h.z(f,S,!1)},appendOutputItems(f,S){return h.t(),h.C(f,S,!0)},replaceOutputItems(f,S){return h.t(),h.C(f,S,!1)}})}}var b;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(b||(b={}));class c extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(h,E,f){super(),this.h=E,this.j=f,this.b=c.a++,this.c=new F.$be,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new R.$me),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===b.Resolved||this.f===b.Started)throw new Error("Cannot call start again");this.f=b.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===b.Resolved)throw new Error("Cannot call resolve twice");this.f=b.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(h,E){this.f=h,this.g=E,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new N.$Nh,this.b=Date.now(),(0,N.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>h.complete())}}function v($,h){return`${$.value}/${h}`}}),define(Re[51],Ae([1,0,5,4,3,2,16,6,7,172,14,201,24,35,202,41,11,8,32]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=e.$Pkc=e.$Okc=e.$Nkc=void 0,e.$Nkc=(0,R.$qi)("IExtHostTerminalService");class i extends p.$Uc{constructor(f,S,y,C){super(),this.u=f,this._id=S,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??S?.cwd??void 0,env:f.env??void 0,icon:v(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.z(f.location,S?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,S,y,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:s.ThemeColor.isThemeColor(P)?P.id:void 0,location:S?.location||this.z(f,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,S){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in f?{viewColumn:n.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,S){this.j=Object.freeze({code:f,reason:S})}setDimensions(f,S){return f===this.f&&S===this.h||f===0||S===0?!1:(this.f=f,this.h=S,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(S=>{S!==f&&(this.b=Promise.resolve(f))})}}e.$Okc=i;class a{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new I.$be,this.onProcessData=this.a.event,this.b=new I.$be,this.d=new I.$be,this.onDidChangeProperty=this.d.event,this.f=new I.$be,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,S){this.g.setDimensions?.({columns:f,rows:S})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,S,y){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$be,this.onDidCloseTerminal=this.H.event,this.I=new I.$be,this.onDidOpenTerminal=this.I.event,this.J=new I.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$be,this.onDidChangeTerminalState=this.M.event,this.N=new I.$be,this.onDidChangeShell=this.N.event,this.O=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$PM.MainThreadTerminalService),this.y=new d.$Fsb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:C=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let V=0;V<C.length&&C[V].$mid===15;V++)C[V]=P(C[V]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,S){const y=new i(this.a,(0,w.$Mg)(),f,f.name),C=new a(f.pty);return y.createExtensionTerminal(f.location,S,this.R(f,S).resolvedExtHostIdentifier,v(f.iconPath),$(f.color)).then(P=>{const V=this.S(P,C);this.h[P]=V}),this.f.push(y),y.value}R(f,S){if(S=S||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const y=f.location.parentTerminal;if(y){const C=this.f.find(P=>P.value===y);C&&(S.resolvedExtHostIdentifier=C._id)}}else f.location&&typeof f.location!="object"?S.location=f.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(f,S){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const C=new a(S),P=this.S(f,C);this.h[f]=P}async $acceptActiveTerminalChanged(f){const S=this.b;if(f===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(f);y&&(this.b=y,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,S){const y=this.getTerminalById(f);y&&this.O.fire({terminal:y.value,data:S})}async $acceptTerminalDimensions(f,S,y){const C=this.getTerminalById(f);C&&C.setDimensions(S,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(f,S){const y=this.getTerminalById(f);y&&this.P.fire({terminal:y.value,...S})}async $acceptTerminalMaximumDimensions(f,S,y){this.g.get(f)?.resize(S,y)}async $acceptTerminalTitleChange(f,S){const y=this.getTerminalById(f);y&&(y.name=S)}async $acceptTerminalClosed(f,S,y){const C=this.X(this.f,f);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(S,y),this.H.fire(P.value)}}$acceptTerminalOpened(f,S,y,C){if(S){const W=this.X(this.f,S);if(W!==null){this.f[W]._id=f,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:F.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},V=new i(this.a,f,P,y);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(f,S){this.getTerminalById(f)?._setProcessId(S)}async $startExtensionTerminal(f,S){const y=this.getTerminalById(f);if(!y)return{message:(0,D.localize)(0,null,f)};y.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===y.value&&(V.dispose(),P())})});const C=this.g.get(f);C?C.startSendingEvents(S):this.j[f]={initialDimensions:S}}S(f,S){const y=new p.$Tc;y.add(S.onProcessReady(P=>this.a.$sendProcessReady(f,P.pid,P.cwd,P.windowsPty))),y.add(S.onDidChangeProperty(P=>this.a.$sendProcessProperty(f,P))),this.y.startBuffering(f,S.onProcessData),y.add(S.onProcessExit(P=>this.U(f,P))),this.g.set(f,S);const C=this.j[f];return C&&S instanceof a&&(S.startSendingEvents(C.initialDimensions),delete this.j[f]),y}$acceptProcessAckDataEvent(f,S){this.g.get(f)?.acknowledgeDataEvent(S)}$acceptProcessInput(f,S){this.g.get(f)?.input(S)}$acceptTerminalInteraction(f){const S=this.getTerminalById(f);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(f,S){this.getTerminalById(f)?.setSelection(S)}$acceptProcessResize(f,S,y){try{this.g.get(f)?.resize(S,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(f,S){this.g.get(f)?.shutdown(S)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(S=>this.a.$sendProcessProperty(f,{type:"cwd",value:S}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new g.$RM(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,S,y){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,y),this.a.$registerProfileProvider(S,f.identifier.value),new g.$RM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(f,S,y){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,y),this.a.$registerQuickFixProvider(f,S),new g.$RM(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,S){const y=new u.$me().token;if(y.isCancellationRequested)return;const C=this.D.get(f);if(!C)return;const P=await C.provideTerminalQuickFixes(S,y);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new p.$Tc;if(this.w.value=V,!Array.isArray(P))return P?n.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const A=n.TerminalQuickFix.from(q,this.Q.converter,V);A&&W.push(A)}return W}async $createContributedProfileTerminal(f,S){const y=new u.$me().token;let C=await this.C.get(f)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(f,S){const y=this.getTerminalById(f);if(!y)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const P=new u.$me;this.G.set(f,P);const V=[],W={terminal:y.value,line:S},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||ie({provider:K,links:ce})}));const A=await Promise.all(q);if(P.token.isCancellationRequested)return[];const j=new Map;for(const K of A)K&&K.links.length>0&&V.push(...K.links.map(ie=>{const ce={id:l++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return j.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(f,j),V}$activateLink(f,S){const y=this.F.get(f)?.get(S);y&&y.provider.handleTerminalLink(y.link)}U(f,S){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const y=this.h[f];y&&(y.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,S)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const S=this.f.findIndex(y=>y.value===f);return S>=0?S:null}W(f,S){const y=this.X(f,S);return y!==null?f[y]:null}X(f,S){const y=f.findIndex(C=>C._id===S);return y>=0?y:null}getEnvironmentVariableCollection(f){let S=this.n.get(f.identifier.value);return S||(S=new b,this.Z(f.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Y(f,S){const y=(0,k.$cs)(S.map),C=(0,k.$ds)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(f,S.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(f){f.forEach(S=>{const y=S[0],C=new b(S[1]);this.Z(y,C)})}$acceptDefaultProfile(f,S){const y=this.s;this.s=f,this.u=S,y?.path!==f.path&&this.N.fire(f.path)}Z(f,S){this.n.set(f,S),S.onDidChangeCollection(()=>{this.Y(f,S)})}};e.$Pkc=t,e.$Pkc=t=Je([Ve(1,r.$wP),Ve(2,M.$aP)],t);class b{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$be,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const S=this.h(f);let y=this.a.get(S);return y||(y=new c(this,f),this.a.set(S,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(f,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(f,S.scope),C=this.map.get(y),P=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const V=this.g(f,S.scope),W={variable:f,...S,options:P};this.map.set(V,W),this.d.fire()}}get(f,S){const y=this.g(f,S),C=this.map.get(y);return C?h(C):void 0}g(f,S){const y=this.h(S);return y.length?`${f}:::${y}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const S=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(f)&&S.set(C.variable,h(C));return S}delete(f,S){const y=this.g(f,S);this.map.delete(y),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[S,y]of this.map)y.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(S);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,S){const y=this.h(S),C=this.descriptionMap.get(y);if(!C||C.description!==f){let P;typeof f=="string"?P=f:P=f?.value.split(`

`)[0];const V={description:P,scope:S};this.descriptionMap.set(y,V),this.d.fire()}}getDescription(f){const S=this.h(f);return this.descriptionMap.get(S)?.description}k(f){const S=this.h(f);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,S){this.b=f,this.d=S,this.a=new I.$be}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,S,y){this.b.replace(f,S,y,this.d)}append(f,S,y){this.b.append(f,S,y,this.d)}prepend(f,S,y){this.b.prepend(f,S,y,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,S){this.b.getVariableMap(this.d).forEach((y,C)=>f.call(S,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let m=class extends t{constructor(f,S){super(!1,f,S)}createTerminal(f,S,y){throw new T.$_}createTerminalFromOptions(f,S){throw new T.$_}};e.$Qkc=m,e.$Qkc=m=Je([Ve(0,r.$wP),Ve(1,M.$aP)],m);function v(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function $(E){return s.ThemeColor.isThemeColor(E)?E:void 0}function h(E){const f={...E};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Re[114],Ae([1,0,7,6,3,4,16,51,5,2,11]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=void 0,e.$Ulc=(0,R.$qi)("IExtHostTerminalShellIntegration");let k=class extends N.$Uc{constructor(o,n){super(),this.h=n,this.b=new Map,this.c=new g.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new g.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new g.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(F.$PM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[r,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const n=this.h.getTerminalById(o);if(!n)return;const r=n.value;let i=this.b.get(o);i||(i=new u(n.value,this.f),this.b.set(o,i),i.store.add(n.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(a=>this.a.$executeCommand(o,a))),i.store.add(i.onDidRequestEndExecution(a=>this.g.fire(a))),i.store.add(i.onDidRequestChangeShellIntegration(a=>this.c.fire(a))),n.shellIntegration=i.value),this.c.fire({terminal:r,shellIntegration:i.value})}$shellExecutionStart(o,n,r,i,a){this.b.has(o)||this.$shellIntegrationChange(o);const l={value:n,confidence:r,isTrusted:i};this.b.get(o)?.startShellExecution(l,a)}$shellExecutionEnd(o,n,r,i,a){const l={value:n,confidence:r,isTrusted:i};this.b.get(o)?.endShellExecution(l,a)}$shellExecutionData(o,n){this.b.get(o)?.emitData(n)}$cwdChange(o,n){this.b.get(o)?.setCwd(n)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$Vlc=k,e.$Vlc=k=Je([Ve(0,M.$aP),Ve(1,p.$Nkc)],k);class u extends N.$Uc{get currentExecution(){return this.a}constructor(o,n){super(),this.j=o,this.m=n,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new g.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new g.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new g.$be),this.onDidRequestEndExecution=this.h.event;const r=this;this.value={get cwd(){return r.c},executeCommand(i,a){let l=i;a&&(l+=` "${a.map(c=>`${c.replaceAll('"','\\"')}`).join('" "')}"`),r.g.fire(l);const t={value:l,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},b=r.startShellExecution(t,r.c,!0).value;return r.b=!0,b}}}startShellExecution(o,n,r){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new w(o,n);r?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,n){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:n}),this.a=void 0)}setCwd(o){let n=!1;D.URI.isUri(this.c)?n=!D.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(n=!0),n&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class w{constructor(o,n){this.c=o,this.cwd=n,this.b=!1;const r=this;this.value={get commandLine(){return r.c},get cwd(){return r.cwd},read(){return r.d()}}}d(){if(!this.a){if(this.b)return T.$Qh.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const o=this.a=new T.$ph;return new T.$Qh(async r=>{this.b.push(r),await o.wait()})}emitData(o){for(const n of this.b)n.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[279],Ae([1,0,11,22,24,5,251,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=e.$Xlc=e.$Wlc=void 0;let a=class extends g.$Uc{constructor(P,V,W,q){super(),this.w=q,this.f=this.B(new F.$be),this.g=new Map,this.s=this.B(new F.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(u.$PM.MainThreadTesting),this.m=new E(this.h),this.j=new c(this.h,V),W.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const j=A,K=j.tests[j.tests.length-1].item.extId;return this.g.get(n.$BL.root(K))?.collection.tree.get(K)?.actual??(0,d.$mP)(A)}case 18:{const{test:j,message:K}=A,ie=j.item.extId;return{test:this.g.get(n.$BL.root(ie))?.collection.tree.get(ie)?.actual??(0,d.$mP)({$mid:16,tests:[j]}),message:s.TestMessage.to(K)}}default:return A}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await W.executeCommand("_testing.getExplorerSelection"),j=K=>{const ie=this.g.get(n.$BL.root(K));if(ie)return n.$BL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:A?.include.map(j).filter(D.$_f)||[],exclude:A?.exclude.map(j).filter(D.$_f)||[]}})}createTestController(P,V,W,q){if(this.g.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const A=new g.$Tc,j=A.add(new d.$pP(V,W,this.w));j.root.label=W;const K=new Map,ie=new Set,ce=this.h,ve={items:j.root.children,get label(){return W},set label(ue){W=ue,j.root.label=ue,ce.$updateController(V,{label:W})},get refreshHandler(){return q},set refreshHandler(ue){q=ue,ce.$updateController(V,{canRefresh:!!ue})},get id(){return V},createRunProfile:(ue,pe,re,Se,Le,ne)=>{let U=(0,p.$ej)(ue);for(;K.has(U);)U++;return new S(this.h,K,ie,this.s.event,V,U,ue,pe,re,Se,Le,ne)},createTestItem(ue,pe,re){return new d.$nP(V,ue,pe,re)},createTestRun:(ue,pe,re=!0)=>this.j.createTestRun(V,j,ue,pe,re),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const pe=ue instanceof Array?ue:[ue];this.h.$markTestRetired(pe.map(re=>n.$BL.fromExtHostTestItem(re,V).toString()))}},set resolveHandler(ue){j.resolveHandler=ue},get resolveHandler(){return j.resolveHandler},dispose:()=>{A.dispose()}};ce.$registerTestController(V,W,!!q),A.add((0,g.$Sc)(()=>ce.$unregisterTestController(V)));const Ie={controller:ve,collection:j,profiles:K,extension:P,activeProfiles:ie};return this.g.set(V,Ie),A.add((0,g.$Sc)(()=>this.g.delete(V))),A.add(j.onDidGenerateDiff(ue=>ce.$publishDiff(V,ue.map(i.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(P,V=R.CancellationToken.None){const W=m(P);if(!W)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(W.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(A=>n.$BL.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:y[W.kind],profileId:W.profileId,controllerId:W.controllerId}],exclude:P.exclude?.map(A=>A.id)},V)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,V){return(await this.j.getCoverageDetails(P,V))?.map(s.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,V){this.g.get(P)?.profiles.get(V)?.configureHandler?.()}$setDefaultRunProfiles(P){const V=new Map;for(const[W,q]of Object.entries(P)){const A=this.g.get(W);if(!A)continue;const j=new Map,K=q.filter(ce=>!A.activeProfiles.has(ce)),ie=[...A.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)j.set(ce,!0),A.activeProfiles.add(ce);for(const ce of ie)j.set(ce,!1),A.activeProfiles.delete(ce);j.size&&V.set(W,j)}this.s.fire(V)}async $refreshTests(P,V){await this.g.get(P)?.controller.refreshHandler?.(V)}$publishTestResults(P){this.results=Object.freeze(P.map(s.TestResults.to).concat(this.results).sort((V,W)=>W.completedAt-V.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,V){const W=this.g.get(n.$BL.fromString(P).controllerId)?.collection;W&&(await W.expand(P,V<0?1/0:V),W.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(V=>i.TestsDiffOp.deserialize({asCanonicalUri:W=>W},V)))}async $runControllerTests(P,V){return Promise.all(P.map(W=>this.y(W,!1,V)))}async $startContinuousRun(P,V){const W=new R.$me(V),q=await Promise.all(P.map(A=>this.y(A,!0,W.token)));return!V.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>V.onCancellationRequested(A)),W.dispose(!0),q}async y(P,V,W){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:A,profiles:j}=q,K=j.get(P.profileId);if(!K)return{};const ie=P.testIds.map(ue=>A.tree.get(ue)).filter(D.$_f),ce=P.excludeExtIds.map(ue=>q.collection.tree.get(ue)).filter(D.$_f).filter(ue=>ie.some(pe=>pe.fullId.compare(ue.fullId)===2));if(!ie.length)return{};const ve=new o.$rO(ie.some(ue=>ue.actual instanceof d.$oP)?void 0:ie.map(ue=>ue.actual),ce.map(ue=>ue.actual),K,V),Ie=(0,i.$EL)(P)&&this.j.prepareForMainThreadTestRun(ve,v.fromInternal(P,q.collection),K,W);try{return await K.runHandler(ve,W),{}}catch(ue){return{error:String(ue)}}finally{Ie&&Ie.hasRunningTasks&&!W.isCancellationRequested&&await F.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$Wlc=a,e.$Wlc=a=Je([Ve(0,w.$aP),Ve(1,k.$Wj)],a);const l=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class b extends g.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,V,W,q,A){super(),this.y=P,this.z=V,this.C=W,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new F.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$me(A));const j=this.B(new I.$Ch(()=>this.F(),l));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const K=new F.$be;this.s=K.event,this.B((0,g.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,V){const[,W,q]=n.$BL.fromString(P).path,A=this.w.get(q);if(!A)return[];const j=this.g.get(W);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,A,V)??[]}createRun(P){const V=this.y.id,W=this.y.controllerId,q=(0,T.$Mg)(),A=ce=>(ve,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ce(ve,...Ie))},j=(ce,ve)=>{const Ie=ve instanceof Array?ve.map(s.TestMessage.from):[s.TestMessage.from(ve)];if(ce.uri&&ce.range){const ue={range:s.Range.from(ce.range),uri:ce.uri};for(const pe of Ie)pe.location=pe.location||ue}this.z.$appendTestMessagesInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),Ie)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ce=>{const ve=ce.uri.toString(),Ie=new n.$BL([V,q,ve]).toString();this.w.set(ve,ce),this.z.$appendCoverage(V,q,s.TestCoverage.fromFile(Ie,ce))},enqueued:A(ce=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),1)}),skipped:A(ce=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),5)}),started:A(ce=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),2)}),errored:A((ce,ve,Ie)=>{j(ce,ve),this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),6,Ie)}),failed:A((ce,ve,Ie)=>{j(ce,ve),this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,W).toString(),4,Ie)}),passed:A((ce,ve)=>{this.z.$updateTestStateInRun(V,q,n.$BL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ve)}),appendOutput:(ce,ve,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(V,q,N.$Ce.fromString(ce),ve&&s.location.from(ve),Ie&&n.$BL.fromExtHostTestItem(Ie,W).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(V,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(V,{id:q,name:P,running:!0}),ie}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof d.$nP))throw new r.$5O(P.id);if(this.h.has(n.$BL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const V=[],W=this.y.colllection.root;for(;;){const q=s.TestItem.from(P);if(V.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===W))break;P=P.parent||W}this.z.$addTestsToRun(this.y.controllerId,this.y.id,V)}dispose(){this.G(),super.dispose()}}class c{get trackers(){return this.c.values()}constructor(P,V){this.g=P,this.h=V,this.c=new Map,this.f=new Map}getCoverageDetails(P,V){const W=n.$BL.root(P);return this.f.get(W)?.getCoverageDetails(P,V)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[V,{id:W}]of this.c)W===P&&this.c.delete(V)}prepareForMainThreadTestRun(P,V,W,q){return this.j(P,V,W,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,V,W,q,A){const j=this.c.get(W);if(j)return j.createRun(q);const K=v.fromPublic(P,V,W,A),ie=m(W);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!W.continuous,profile:ie&&{group:y[ie.kind],id:ie.profileId},exclude:W.exclude?.map(ve=>n.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[],id:K.id,include:W.include?.map(ve=>n.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[V.root.id],persist:A});const ce=this.j(W,K,W.profile);return F.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(P,V,W,q){const A=new b(V,this.g,this.h,W,q);return this.c.set(P,A),this.f.set(A.id,A),A}}e.$Xlc=c;const m=C=>{if(C.profile){if(!(C.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class v{static fromPublic(P,V,W,q){return new v(P,(0,T.$Mg)(),W.include?.map(A=>n.$BL.fromExtHostTestItem(A,P).toString())??[P],W.exclude?.map(A=>n.$BL.fromExtHostTestItem(A,P).toString())??[],q,V)}static fromInternal(P,V){return new v(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,V)}constructor(P,V,W,q,A,j){this.controllerId=P,this.id=V,this.isPersisted=A,this.colllection=j,this.c=W.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const V=n.$BL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const W of this.f)if(V===W||V.startsWith(W))return!1;for(const W of this.c)if(V===W||V.startsWith(W))return!0;return!1}}e.$Ylc=v;class ${get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,s.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const V=n.$BL.parentId(P.item.extId);if(V&&this.h.has(V.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:V,g:W}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...V].map(q=>q.revived)},get removed(){return[...W].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class h extends i.$KL{constructor(){super(...arguments),this.s=new F.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,V){return{...P,revived:s.TestItem.toPlain(P.item),depth:V?V.depth+1:0,children:new Set}}v(){return new $(this.s)}}class E{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(V=>V.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new h({asCanonicalUri:V=>V});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const f=(C,P,V,W)=>{V?Object.assign(V,W):P.$updateTestRunConfig(C.controllerId,C.profileId,W)};class S{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,f(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,f(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,f(this,this.#e,this.#n,{tag:P?s.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,f(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return F.Event.chain(this.#i,P=>P.map(V=>V.get(this.controllerId)?.get(this.profileId)).filter(D.$_f))}constructor(P,V,W,q,A,j,K,ie,ce,ve=!1,Ie=void 0,ue=!1){this.controllerId=A,this.profileId=j,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=Ie,this.g=ue,this.#e=P,this.#s=V,this.#t=W,this.#i=q,V.set(j,this);const pe=y[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);ve&&W.add(j),this.#n={profileId:j,controllerId:A,tag:Ie?s.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:pe,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Zlc=S;const y={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Re[115],Ae([1,0,56,14,90,8,7]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=e.$hP=void 0;class p{static{this.c=new R.$fP("TextEditorDecorationType")}constructor(u,w,d){const s=p.c.nextId();u.$registerTextEditorDecorationType(w.identifier,s,F.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:s,dispose(){u.$removeTextEditorDecorationType(s)}})}}e.$hP=p;class g{constructor(u,w){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,w){this.k();let d=null;if(u instanceof M.$SM)d=new M.$TM(u,u);else if(u instanceof M.$TM)d=u;else throw new Error("Unrecognized location");this.l(d,w,!1)}insert(u,w){this.k(),this.l(new M.$TM(u,u),w,!0)}delete(u){this.k();let w=null;if(u instanceof M.$TM)w=u;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(u,w,d){const s=this.c.validateRange(u);this.g.push({range:s,text:w,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==M.EndOfLine.LF&&u!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=u}}class D{constructor(u,w,d,s){this.c=u,this.d=w,this._accept(d),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(n){o.n(n)},get indentSize(){return o.g},set indentSize(n){o.p(n)},get insertSpaces(){return o.j},set insertSpaces(n){o.s(n)},get cursorStyle(){return o.k},set cursorStyle(n){o.t(n)},get lineNumbers(){return o.l},set lineNumbers(n){o.u(n)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}n(u){const w=this.m(u);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}p(u){const w=this.o(u);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const w=this.q(u);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(u)})))}assign(u){const w={};let d=!1;if(typeof u.tabSize<"u"){const s=this.m(u.tabSize);s==="auto"?(d=!0,w.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,d=!0,w.tabSize=s)}if(typeof u.indentSize<"u"){const s=this.o(u.indentSize);s==="tabSize"?(d=!0,w.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,d=!0,w.indentSize=s)}if(typeof u.insertSpaces<"u"){const s=this.q(u.insertSpaces);s==="auto"?(d=!0,w.insertSpaces=s):this.j!==s&&(this.j=s,d=!0,w.insertSpaces=s)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,w.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,w.lineNumbers=F.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(u,w){w.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$iP=D;class T{constructor(u,w,d,s,o,n,r,i){this.id=u,this.j=w,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new D(this.j,this.id,n,d),this.e=r,this.f=i;const a=this;this.value=Object.freeze({get document(){return s.value},set document(l){throw new N.$9("document")},get selection(){return a.c&&a.c[0]},set selection(l){if(!(l instanceof M.$UM))throw(0,N.$7)("selection");a.c=[l],a.l()},get selections(){return a.c},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof M.$UM)))throw(0,N.$7)("selections");a.c=l,a.l()},get visibleRanges(){return a.e},set visibleRanges(l){throw new N.$9("visibleRanges")},get options(){return a.d.value},set options(l){a.g||a.d.assign(l)},get viewColumn(){return a.f},set viewColumn(l){throw new N.$9("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new g(s.value,t);return l(b),a.m(b)},insertSnippet(l,t,b={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map(m=>F.Range.from(m));else if(t instanceof M.$SM){const{lineNumber:m,column:v}=F.Position.from(t);c=[{startLineNumber:m,startColumn:v,endLineNumber:m,endColumn:v}]}else if(t instanceof M.$TM)c=[F.Range.from(t)];else{c=[];for(const m of t)if(m instanceof M.$TM)c.push(F.Range.from(m));else{const{lineNumber:v,column:$}=F.Position.from(m);c.push({startLineNumber:v,startColumn:$,endLineNumber:v,endColumn:$})}}return w.$tryInsertSnippet(u,s.value.version,l.value,c,b)},setDecorations(l,t){const b=t.length===0;b&&!a.h.has(l.key)||(b?a.h.delete(l.key):a.h.add(l.key),a.n(()=>{if(F.$0O(t))return w.$trySetDecorations(u,l.key,F.$$O(t));{const c=new Array(4*t.length);for(let m=0,v=t.length;m<v;m++){const $=t[m];c[4*m]=$.start.line+1,c[4*m+1]=$.start.character+1,c[4*m+2]=$.end.line+1,c[4*m+3]=$.end.character+1}return w.$trySetDecorationsFast(u,l.key,c)}}))},revealRange(l,t){a.n(()=>w.$tryRevealRange(u,F.Range.from(l),t||M.TextEditorRevealType.Default))},show(l){w.$tryShowEditor(u,F.ViewColumn.from(l))},hide(){w.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const w=u.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const d=w.edits.map(o=>o.range);d.sort((o,n)=>o.end.line===n.end.line?o.end.character===n.end.character?o.start.line===n.start.line?o.start.character-n.start.character:o.start.line-n.start.line:o.end.character-n.end.character:o.end.line-n.end.line);for(let o=0,n=d.length-1;o<n;o++){const r=d[o].end;if(d[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=w.edits.map(o=>({range:F.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,s,{setEndOfLine:typeof w.setEndOfLine=="number"?F.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$jP=T}),define(Re[67],Ae([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,46,40]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0;class n{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(a,l){this.h=a,this.i=l,this.a=null,this.b=new Map,this.c=new w.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const l=[],t=[],b=[];if(a.removedDocuments)for(const c of a.removedDocuments){const m=F.URI.revive(c),v=this.c.get(m);v?.unref()&&(this.c.delete(m),l.push(v.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const m=F.URI.revive(c.uri);let v=this.c.get(m);if(v&&m.scheme!==d.Schemas.vscodeNotebookCell&&m.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);v||(v=new n(new g.$dP(this.h.getProxy(p.$PM.MainThreadDocuments),m,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set(m,v),t.push(v.value)),v.ref()}if(a.removedEditors)for(const c of a.removedEditors){const m=this.b.get(c);this.b.delete(c),m&&b.push(m)}if(a.addedEditors)for(const c of a.addedEditors){const m=F.URI.revive(c.documentUri);I.ok(this.c.has(m),`document '${m}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const v=this.c.get(m).value,$=new T.$jP(c.id,this.h.getProxy(p.$PM.MainThreadTextEditors),this.i,new o.$V(()=>v.document),c.selections.map(k.Selection.to),c.options,c.visibleRanges.map(h=>k.Range.to(h)),typeof c.editorPosition=="number"?k.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,$)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,R.$Pc)(l),(0,R.$Pc)(b),a.removedDocuments&&this.e.fire(l),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return s.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const l=this.b.get(this.a);return a?l:l?.value}allEditors(){return[...this.b.values()]}};e.$kP=r,e.$kP=r=Je([Ve(0,D.$aP),Ve(1,u.$Wj)],r),e.$lP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(Re[280],Ae([1,0,18,5,4,115,8,7]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class g{constructor(T,k){this.i=k,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const k=this.i.allEditors();return T?k:k.map(u=>u.value)}async showTextDocument(T,k,u){let w;typeof k=="number"?w={position:M.ViewColumn.from(k),preserveFocus:u}:typeof k=="object"?w={position:M.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?M.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:w={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(T.uri,w),s=d&&this.i.getEditor(d);if(s)return s.value;throw d?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,k){return new F.$hP(this.h,T,k).value}$acceptEditorPropertiesChanged(T,k){const u=this.i.getEditor(T);if(!u)throw new Error("unknown text editor");if(k.options&&u._acceptOptions(k.options),k.selections){const w=k.selections.selections.map(M.Selection.to);u._acceptSelections(w)}if(k.visibleRanges){const w=I.$Hb(k.visibleRanges.map(M.Range.to));u._acceptVisibleRanges(w)}if(k.options&&this.b.fire({textEditor:u.value,options:{...k.options,lineNumbers:M.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const w=p.TextEditorSelectionChangeKind.fromValue(k.selections.source),d=k.selections.selections.map(M.Selection.to);this.a.fire({textEditor:u.value,selections:d,kind:w})}if(k.visibleRanges){const w=I.$Hb(k.visibleRanges.map(M.Range.to));this.c.fire({textEditor:u.value,visibleRanges:w})}}$acceptEditorPositionData(T){for(const k in T){const u=this.i.getEditor(k);if(!u)throw new Error("Unknown text editor");const w=M.ViewColumn.to(T[k]);u.value.viewColumn!==w&&(u._acceptViewColumn(w),this.d.fire({textEditor:u.value,viewColumn:w}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$gkc=g}),define(Re[281],Ae([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=e.$2lc=void 0,e.$2lc=(0,N.$qi)("IExtHostTimeline");class T{constructor(w,d){this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$PM.MainThreadTimeline),d.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&g.$Lm.equals(o,this.b.get(s.source)?.extension)){const n=s.uri===void 0?void 0:I.URI.revive(s.uri);return this.c.get(s.source)?.get(k(n))?.get(s.handle)}else return;return s}})}async $getTimeline(w,d,s,o){return this.b.get(w)?.provider.provideTimeline(I.URI.revive(d),s,o)}registerTimelineProvider(w,d,s,o){const n=new F.$Tc,r=this.d(d.id,o,n).bind(this);let i;d.onDidChange&&(i=d.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:d.id}),this));const a=this.c;return this.f({...d,scheme:w,onDidChange:void 0,async provideTimeline(l,t,b){t?.resetCache&&(n.clear(),a.get(d.id)?.clear());const c=await d.provideTimeline(l,t,b);if(c==null)return;const m=r(l,t);return{...c,source:d.id,items:c.items.map(m)}},dispose(){for(const l of a.values())l.get(d.id)?.clear();i?.dispose(),n.dispose()}},s)}d(w,d,s){return(o,n)=>{let r;if(n?.cacheResults){let i=this.c.get(w);i===void 0&&(i=new Map,this.c.set(w,i));const a=k(o);r=i.get(a),r===void 0&&(r=new Map,i.set(a,r))}return i=>{const{iconPath:a,...l}=i,t=`${w}|${i.id??i.timestamp}`;r?.set(t,i);let b,c,m;i.iconPath&&(a instanceof M.$NN?m={id:a.id,color:a.color}:I.URI.isUri(a)?(b=a,c=a):{light:b,dark:c}=a);let v;return M.$gN.isMarkdownString(l.tooltip)?v=p.MarkdownString.from(l.tooltip):(0,D.$4f)(l.tooltip)?v=l.tooltip:M.$gN.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=p.MarkdownString.from(l.detail)):(0,D.$4f)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=l.detail),{...l,id:l.id??void 0,handle:t,source:w,command:i.command?d.toInternal(i.command,s):void 0,icon:b,iconDark:c,themeIcon:m,tooltip:v,accessibilityInformation:i.accessibilityInformation}}}}f(w,d){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:d}),(0,F.$Sc)(()=>{for(const o of this.c.values())o.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$3lc=T;function k(u){return u?.toString()}}),define(Re[282],Ae([1,0,173,23,2,5,6,212,11,7,17,18,8,54,24,137,25]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;function n(a,l){if((0,T.$4f)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(b=>b.length===2&&typeof b[0]=="number"&&typeof b[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class r extends M.$Uc{constructor(l,t,b){super(),this.f=l,this.g=t,this.h=b,this.a=new Map,this.b=new s.$M0;function c(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:m=>c(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map(v=>c(v)?this.r(v):v):m})}registerTreeDataProvider(l,t,b){const c=this.createTreeView(l,{treeDataProvider:t},b);return{dispose:()=>c.dispose()}}createTreeView(l,t,b){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],m=t.dragAndDropController?.dragMimeTypes??[],v=!!t.dragAndDropController?.handleDrag,$=!!t.dragAndDropController?.handleDrop,h=this.m(l,t,b),E={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:m,hasHandleDrag:v,hasHandleDrop:$,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(l,E),S={get onDidCollapseElement(){return h.onDidCollapseElement},get onDidExpandElement(){return h.onDidExpandElement},get selection(){return h.selectedElements},get onDidChangeSelection(){return h.onDidChangeSelection},get activeItem(){return(0,o.$yG)(b,"treeViewActiveItem"),h.focusedElement},get onDidChangeActiveItem(){return(0,o.$yG)(b,"treeViewActiveItem"),h.onDidChangeActiveItem},get visible(){return h.visible},get onDidChangeVisibility(){return h.onDidChangeVisibility},get onDidChangeCheckboxState(){return h.onDidChangeCheckboxState},get message(){return h.message},set message(y){(0,w.$Pk)(y)&&(0,o.$yG)(b,"treeViewMarkdownMessage"),h.message=y},get title(){return h.title},set title(y){h.title=y},get description(){return h.description},set description(y){h.description=y},get badge(){return h.badge},set badge(y){y!==void 0&&D.ViewBadge.isViewBadge(y)?h.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(h.badge=void 0)},reveal:(y,C)=>h.reveal(y,C),dispose:async()=>{await f,this.a.delete(l),h.dispose()}};return this.B(S),S}$getChildren(l,t){const b=this.a.get(l);return b?b.getChildren(t):Promise.reject(new p.$NF(l))}async $handleDrop(l,t,b,c,m,v,$,h){const E=this.a.get(l);if(!E)return Promise.reject(new p.$NF(l));const f=u.DataTransfer.toDataTransfer(b,async S=>(await this.f.$resolveDropFileData(l,t,S)).buffer);return $===l&&h&&await this.j(f,E,h,m,v),E.onDrop(f,c,m)}async j(l,t,b,c,m){const v=this.b.removeDragOperationTransfer(m);if(v)(await v)?.forEach(($,h)=>{$&&l.set(h,$)});else if(m&&t.handleDrag){const $=t.handleDrag(b,l,c);this.b.addDragOperationTransfer(m,$),await $}return l}async $handleDrag(l,t,b,c){const m=this.a.get(l);if(!m)return Promise.reject(new p.$NF(l));const v=await this.j(new D.$JN,m,t,c,b);if(!(!v||c.isCancellationRequested))return u.DataTransfer.from(v)}async $hasResolve(l){const t=this.a.get(l);if(!t)throw new p.$NF(l);return t.hasResolve}$resolve(l,t,b){const c=this.a.get(l);if(!c)throw new p.$NF(l);return c.resolveTreeItem(t,b)}$setExpanded(l,t,b){const c=this.a.get(l);if(!c)throw new p.$NF(l);c.setExpanded(t,b)}$setSelectionAndFocus(l,t,b){const c=this.a.get(l);if(!c)throw new p.$NF(l);c.setSelectionAndFocus(t,b)}$setVisible(l,t){const b=this.a.get(l);if(!b){if(!t)return;throw new p.$NF(l)}b.setVisible(t)}$changeCheckboxState(l,t){const b=this.a.get(l);if(!b)throw new p.$NF(l);b.setCheckboxState(t)}m(l,t,b){const c=this.B(new i(l,t,this.f,this.g.converter,this.h,b));return this.a.set(l,c),c}r(l){const t=this.a.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.$4lc=r;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,T.$ag)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,t,b,c,m,v){if(super(),this.I=l,this.J=b,this.L=c,this.M=m,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$me,v.contributes&&v.contributes.views)for(const f in v.contributes.views)for(const S of v.contributes.views[f])S.id===l&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let $,h;const E=F.Event.debounce(this.F.event,(f,S)=>(f||(f={message:!1,elements:[]}),S.element!==!1&&($||($=new Promise(y=>h=y),this.G=this.G.then(()=>$)),Array.isArray(S.element)?f.elements.push(...S.element):f.elements.push(S.element)),S.message&&(f.message=!0),f),200,!0);this.B(E(({message:f,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const y=h;return $=null,this.$(S).then(()=>y())})),f&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let b=this.X(l);return b||(b=await this.Y(t)),b?b.map(c=>c.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const b=(0,T.$ag)(t.select)?!0:t.select,c=(0,T.$ag)(t.focus)?!1:t.focus,m=(0,T.$ag)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(v=>this.W(l,v[v.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:v.map(h=>h.item)},{select:b,focus:c,expand:m})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:b,focus:c,expand:m})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=u.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,t){const b=this.getExtensionElement(l);b&&(t?this.u.fire(Object.freeze({element:b})):this.w.fire(Object.freeze({element:b})))}setSelectionAndFocus(l,t){const b=!(0,k.$ub)(this.s,l);this.s=l;const c=this.t!==t;this.t=t,b&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async b=>{const c=this.getExtensionElement(b.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:b.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(b=>b!==void 0);t.forEach(b=>{b.treeItem.checkboxState=b.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(b=>[b.extensionItem,b.newState])})}async handleDrag(l,t,b){const c=[];for(const m of l){const v=this.getExtensionElement(m);v&&c.push(v)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,b),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,t,b){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,g.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(c,l,b):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,t){if(!this.f.resolveTreeItem)return;const b=this.j.get(l);if(b){const c=this.m.get(b);if(c){const m=await this.f.resolveTreeItem(c.extensionItem,b,t)??c.extensionItem;return this.hb(m),c.item.tooltip=this.eb(m.tooltip),c.item.command=this.fb(c.disposableStore,m.command),c.item}}}S(l){return this.U(l).then(t=>t?this.S(t).then(b=>this.W(t,b[b.length-1]).then(c=>(b.push(c),b))):Promise.resolve([]))}U(l){const t=this.m.get(l);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,g.$ih)(()=>this.f.getParent(l))}W(l,t){const b=this.m.get(l);return b?Promise.resolve(b):(0,g.$ih)(()=>this.f.getTreeItem(l)).then(c=>this.kb(l,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const m=this.getExtensionElement(c);if(m){const v=this.m.get(m);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let t;if(typeof l=="string"){const b=this.getExtensionElement(l);t=b?this.m.get(b):void 0}else t=l;return t&&t.children||void 0}return this.h}async Y(l){this.rb(l);const t=new d.$me(this.Z.token);try{const b=l?this.m.get(l):void 0,c=await this.f.getChildren(l);if(t.token.isCancellationRequested)return;const m=(0,k.$Hb)(c||[]),v=await Promise.all((0,k.$Hb)(m).map(h=>this.f.getTreeItem(h)));if(t.token.isCancellationRequested)return;const $=v.map((h,E)=>h?this.db(m[E],h,b):null);return(0,k.$Hb)($)}finally{t.dispose()}}$(l){if(l.some(b=>!b))return this.Z.dispose(!0),this.Z=new d.$me,this.tb(),this.J.$refresh(this.I);{const b=this.ab(l);if(b.length)return this.bb(b)}return Promise.resolve(void 0)}ab(l){const t=new Set,b=l.map(m=>this.m.get(m));for(const m of b)if(m&&!t.has(m.item.handle)){let v=m;for(;v&&v.parent&&b.findIndex($=>v&&v.parent&&$&&$.item.handle===v.parent.item.handle)===-1;){const $=this.j.get(v.parent.item.handle);v=$?this.m.get($):void 0}v&&!v.parent&&t.add(m.item.handle)}const c=[];return t.forEach(m=>{const v=this.j.get(m);if(v){const $=this.m.get(v);$&&(!$.parent||!t.has($.parent.item.handle))&&c.push(m)}}),c}bb(l){const t={};return Promise.all(l.map(b=>this.cb(b).then(c=>{c&&(t[b]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(l){const t=this.getExtensionElement(l);if(t){const b=this.m.get(t);if(b)return this.rb(t),(0,g.$ih)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const m=this.ib(t,c,b.parent);return this.pb(t,m,b,b.parent),b.dispose(),m}return null})}return Promise.resolve(null)}db(l,t,b){const c=this.ib(l,t,b);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(l,c),this.qb(c,b),c}eb(l){return D.$gN.isMarkdownString(l)?u.MarkdownString.from(l):l}fb(l,t){return t?{...this.L.toInternal(t,l),originalId:t.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let t,b,c;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,b=l.checkboxState.tooltip,c=l.checkboxState.accessibilityInformation),{isChecked:t===D.TreeItemCheckboxState.Checked,tooltip:b,accessibilityInformation:c}}hb(l){if(!D.$EN.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,t,b){this.hb(t);const c=this.B(new M.$Tc),m=this.kb(l,t,b),v=this.lb(t);return{item:{handle:m,parentHandle:b?b.item.handle:void 0,label:n(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:v,iconDark:this.mb(t)||v,themeIcon:this.jb(t),collapsibleState:(0,T.$ag)(t.collapsibleState)?D.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:b,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(l){return l.iconPath instanceof D.$NN?l.iconPath:void 0}kb(l,{id:t,label:b,resourceUri:c},m,v){if(t)return`${i.b}/${t}`;const $=n(b,this.N),h=m?m.item.handle:i.a;let E=$?$.label:c?(0,N.$1g)(c):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const f=this.m.has(l)?this.m.get(l).item.handle:void 0,S=this.X(m)||[];let y,C=0;do{if(y=`${h}/${C}:${E}`,v||!this.j.has(y)||f===y)break;C++}while(C<=S.length);return y}lb(l){if(l.iconPath&&!(l.iconPath instanceof D.$NN))return typeof l.iconPath=="string"||R.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof D.$NN)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return R.URI.isUri(l)?l:R.URI.file(l)}ob(l,t){this.j.set(t.item.handle,l),this.m.set(l,t)}pb(l,t,b,c){this.j.delete(t.item.handle),this.m.delete(l),t.item.handle!==b.item.handle&&this.j.delete(b.item.handle),this.ob(l,t);const m=this.X(c)||[],v=m.filter($=>$.item.handle===b.item.handle)[0];v&&m.splice(m.indexOf(v),1,t)}qb(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const t=this.m.get(l);if(t){if(t.children)for(const b of t.children){const c=this.j.get(b.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(l){const t=this.m.get(l);if(t){if(t.children)for(const b of t.children){const c=this.j.get(b.item.handle);c&&this.sb(c)}this.m.delete(l),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[283],Ae([1,0,5,6,2,35,8,63,4,7]),function(ge,e,I,N,R,F,M,p,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class T extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,s,o,n){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$be),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=s,this.#n=o,this.#i=n.viewType,this.#s=n.panelOptions,this.#o=n.viewColumn,this.#r=n.title,this.#u=n.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,R.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:M.ViewColumn.from(d),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends N.$Uc{static c(){return(0,F.$Mg)()}constructor(d,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy(g.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,s,o,n,r={}){const i=typeof n=="object"?n.viewColumn:n,a={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof n=="object"&&!!n.preserveFocus},l=(0,p.$vkc)(d),t=k.c();this.f.$createWebviewPanel((0,p.$xkc)(d),t,s,{title:o,panelOptions:u(r),webviewOptions:(0,p.$ykc)(d,this.m,r),serializeBuffersForPostMessage:l},a);const b=this.j.createNewWebview(t,r,d);return this.createNewWebviewPanel(t,s,o,i,r,b,!0)}$onDidChangeWebviewPanelViewStates(d){const s=Object.keys(d);s.sort((o,n)=>{const r=d[o],i=d[n];return r.active?1:i.active?-1:+r.visible-+i.visible});for(const o of s){const n=this.getWebviewPanel(o);if(!n)continue;const r=d[o];n._updateViewState({active:r.active,visible:r.visible,viewColumn:M.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:d}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$vkc)(d)}),new D.$RM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(d,s,o,n){const r=this.h.get(s);if(!r)throw new Error(`No serializer found for '${s}'`);const{serializer:i,extension:a}=r,l=this.j.createNewWebview(d,o.webviewOptions,a),t=this.createNewWebviewPanel(d,s,o.title,n,o.panelOptions,l,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(d,s,o,n,r,i,a){const l=new T(d,this.f,i,{viewType:s,title:o,viewColumn:n,panelOptions:r,active:a});return this.g.set(d,l),l}getWebviewPanel(d){return this.g.get(d)}}e.$zkc=k;function u(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Re[284],Ae([1,0,5,6,63,8,4,7]),function(ge,e,I,N,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class g extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,u,w,d,s,o){super(),this.#s=!1,this.#u=this.B(new I.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$be),this.onDidDispose=this.#l.event,this.#i=w,this.#a=d,this.#e=k,this.#t=u,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(k,u){this.d=u,this.b=new Map,this.c=new Map,this.a=k.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(k,u,w,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:w,extension:k}),this.a.$registerWebviewViewProvider((0,R.$xkc)(k),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$vkc)(k)}),new p.$RM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(k,u,w,d,s){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:n,extension:r}=o,i=this.d.createNewWebview(k,{},r),a=new g(k,this.a,u,w,i,!0);this.c.set(k,a),await n.resolveWebviewView(a,{state:d},s)}async $onDidChangeWebviewViewVisibility(k,u){this.e(k)._setVisible(u)}async $disposeWebviewView(k){const u=this.e(k);this.c.delete(k),u.dispose(),this.d.deleteWebview(k)}e(k){const u=this.c.get(k);if(!u)throw new Error("No webview found");return u}}e.$7lc=D}),define(Re[285],Ae([1,0,5,30,31,3]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new R.$Hj("inOutput",!1),e.$5L=new R.$Hj("activeLogOutput",!1),e.$6L=new R.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new R.$Hj("activeLogOutput.level",""),e.$8L=new R.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new R.$Hj("outputView.scrollLock",!1),e.$0L=(0,F.$qi)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$be,this.onDidRegisterChannel=this.b.event,this.c=new I.$be,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(T=>D.push(T)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}N.$9n.add(e.$$L.OutputChannels,new p),e.$_L=new R.$Hj("activeOutputChannel","")}),define(Re[116],Ae([1,0,4,3,16,20,13,285,64,27,44,141,22,17,43,5,6]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Flc=void 0;class n extends M.$3j{get disposed(){return this.n}constructor(l,t,b,c,m){super(),this.id=l,this.name=t,this.r=b,this.s=c,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(b.getLevel()),this.B(b.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.m;this.info(l),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(l,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.s.$close(this.id)}g(l,t){this.m+=u.$Ce.fromString(t).byteLength,(0,M.log)(this.r,l,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends n{appendLine(l){this.append(l)}}let i=class{constructor(l,t,b,c,m,v){this.i=t,this.j=b,this.k=c,this.l=m,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(I.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[t,b]of this.g)b.visible=t===this.h}createOutputChannel(l,t,b){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,m=(0,w.$4f)(t)?t:void 0;if((0,w.$4f)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const $=this.i.environment.extensionLogLevel?.find(([E])=>F.$Lm.equals(b.identifier,E))?.[1];$&&(v=(0,M.$bk)($));const h=c?this.o(l,v,b):this.n(l,m,b);return h.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),c?this.r(l,v??this.m.getLevel(),h):this.q(l,h)}async n(l,t,b){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,m=this.k.extUri.joinPath(c,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(l,m,t,b.identifier.value);return new n($,l,v,this.a,b)}async o(l,t,b){const c=await this.p(b),m=l.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(c,`${m}.log`),$=`${b.identifier.value}.${m}`,h=this.l.createLogger(v,{id:$,name:l,logLevel:t,extensionId:b.identifier.value});return new r($,l,h,this.a,b)}p(l){let t=this.d.get(l.identifier.value);if(!t){const b=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(b)}catch(c){if((0,d.$al)(c)!==d.FileSystemProviderErrorCode.FileExists)throw c}return b})())}return t}q(l,t){let b=!1;const c=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return l},append(m){c(),t.then(v=>v.append(m))},appendLine(m){c(),t.then(v=>v.appendLine(m))},clear(){c(),t.then(m=>m.clear())},replace(m){c(),t.then(v=>v.replace(m))},show(m,v){c(),t.then($=>$.show(m,v))},hide(){c(),t.then(m=>m.hide())},dispose(){b=!0,t.then(m=>m.dispose())}}}r(l,t,b){const c=new o.$Tc,m=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},v=c.add(new s.$be);function $(h){t=h,v.fire(h)}return b.then(h=>{c.add(h),h.logLevel!==t&&$(h.logLevel),c.add(h.onDidChangeLogLevel(E=>$(E)))}),{...this.q(l,b),get logLevel(){return t},onDidChangeLogLevel:v.event,trace(h,...E){m(),b.then(f=>f.trace(h,...E))},debug(h,...E){m(),b.then(f=>f.debug(h,...E))},info(h,...E){m(),b.then(f=>f.info(h,...E))},warn(h,...E){m(),b.then(f=>f.warn(h,...E))},error(h,...E){m(),b.then(f=>f.error(h,...E))},dispose(){c.dispose()}}}};e.$Flc=i,e.$Flc=i=Je([Ve(0,R.$aP),Ve(1,D.$qP),Ve(2,g.$rkc),Ve(3,T.$7jc),Ve(4,M.$Xj),Ve(5,M.$Wj)],i),e.$Glc=(0,N.$qi)("IExtHostOutputService")}),define(Re[117],Ae([1,0,3,11]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,I.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let F=1/0;for(let p=0;p<this.maxSampleCount;p++){const g=await R.getRoundTripTime();if(g===void 0)return;F=Math.min(F,g/2),await(0,N.$rh)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(F):M=this.initial.reduce((p,g)=>p+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:F,average:this.average.reduce((p,g)=>p+g,0)/this.average.length,high:typeof M>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[286],Ae([1,0,176,57,30,49,48,6,5,117,21,26,11]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new g.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const d=new w;R.$9n.add(e.$uJ.ConfigurationMigration,d);let s=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,i){super(),this.a=r,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const l of a.added)await this.f(l,d.migrations)})),this.c(d.migrations),this.B(d.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(r){await this.f(void 0,r);for(const i of this.b.getWorkspace().folders)await this.f(i,r)}async f(r,i){await Promise.all([i.map(a=>this.g(a,r?.uri))])}async g(r,i){const a=this.a.inspect(r.key,{resource:i}),l=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,b]of l){const c=a[t];if(!c)continue;const m=[];if(c.value!==void 0){const v=await this.h(r,t,c.value,i,void 0);for(const $ of v??[])m.push([$,[]])}for(const{identifiers:v,value:$}of c.overrides??[])if($!==void 0){const h=await this.h(r,t,$,i,v);for(const E of h??[])m.push([E,v])}m.length&&await Promise.allSettled(m.map(async([[v,$],h])=>this.a.updateValue(v,$.value,{resource:i,overrideIdentifiers:h},b)))}}async h(r,i,a,l,t){const b=m=>{const $=this.a.inspect(m,{resource:l})[i];if($)return t?$.overrides?.find(({identifiers:h})=>(0,k.$1n)(h,t))?.value:$.value},c=await r.migrateFn(a,b);return Array.isArray(c)?c:[[r.key,c]]}};e.$vJ=s,e.$vJ=s=Je([Ve(0,M.$Wi),Ve(1,F.$zi)],s);let o=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$9n.as(N.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$wJ=o,e.$wJ=o=Je([Ve(0,D.$an)],o)}),define(Re[287],Ae([1,0,36,12,19,23,185,286,57,3,30]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kgb=e.$jgb=void 0,e.$lgb=s,e.$mgb=o,e.$jgb=(0,D.$qi)("editorResolverService"),e.$kgb="workbench.editorAssociations";const k=T.$9n.as(g.$bo.Configuration),u={...p.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(u);var w;(function(n){n.builtin="builtin",n.option="option",n.exclusive="exclusive",n.default="default"})(w||(e.RegisteredEditorPriority=w={}));var d;(function(n){n[n.ABORT=1]="ABORT",n[n.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function s(n){switch(n){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(n,r){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(r.scheme))return!1;const l=typeof n=="string"&&n.indexOf(R.$hc.sep)>=0?`${r.scheme}:${r.path}`:(0,F.$1g)(r);return I.$jk(typeof n=="string"?n.toLowerCase():n,l.toLowerCase())}}),define(Re[288],Ae([1,0,47,12,19,21,23,2,3,206,49,226,117]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,g.$qi)("pathService");let d=w=class{constructor(o,n,r,i){this.d=o,this.e=n,this.f=r,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,n,r){return typeof n=="string"||typeof n>"u"?this.a.then(i=>this.h(o,i,n)):this.h(o,n,r)}h(o,n,r){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,I.$og)(r??(0,M.$1g)(o),n===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,n){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const r=(0,D.$oM)(n.getWorkspace());if(r)return r;const i=n.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=n.getWorkspace().configuration;return a?a.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let n="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(n=o.substring(2),o="/"):(n=o.substring(2,i),o=o.substring(i)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:n,path:o,query:"",fragment:""})}};e.$sM=d,e.$sM=d=w=Je([Ve(1,u.$an),Ve(2,k.$aM),Ve(3,T.$zi)],d)}),define(Re[118],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class I{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new I(0,0)}with(M){return new I(0,0)}}e.$WK=I;class N{constructor(M,p,g,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,p),this.end=new I(g,D)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$XK=N;var R;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Re[45],Ae([1,0,18,36,26,47,15,3,19,14,118,11]),function(ge,e,I,N,R,F,M,p,g,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=n,e.$6K=r,e.$7K=i,e.$_K=h,e.$aL=E,e.$cL=y,e.$dL=C,e.$eL=P,e.$fL=V,e.$gL=W,e.$hL=q,e.$jL=j,e.$lL=ce,e.$mL=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const u="\u27EA ",w=" characters skipped \u27EB",d=(u.length+w.length+5)*2;e.$4K=(0,p.$qi)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(o||(e.QueryType=o={}));function n(ue){return!!ue.preview}function r(ue){return!!ue.resource}function i(ue){return!!ue.message}var a;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class l{constructor(pe){this.resource=pe,this.results=[]}}e.$8K=l;class t{constructor(pe,re,Se,Le){this.ranges=re,this.webviewIndex=Le;const ne=Array.isArray(re)?re:[re];if(Se&&Se.matchLines===1&&b(ne)){pe=(0,M.$Wf)(pe,Se.matchLines);let U="",x=0,be=0;const Te=Math.floor(Se.charsPerLine/5),Ee=[];for(const $e of ne){const fe=Math.max($e.startColumn-Te,0),Q=$e.startColumn+Se.charsPerLine;if(fe>be+Te+d){const Y=u+(fe-be)+w;U+=Y+pe.slice(fe,Q),x+=fe-(be+Y.length)}else U+=pe.slice(be,Q);Ee.push(new m(0,$e.startColumn-x,$e.endColumn-x)),be=Q}this.preview={text:U,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const U=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:pe,matches:(0,I.$2b)(re,x=>new c(x.startLineNumber-U,x.startColumn,x.endLineNumber-U,x.endColumn))}}}}e.$9K=t;function b(ue){const pe=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==pe||re.endLineNumber!==pe)return!1;return!0}class c{constructor(pe,re,Se,Le){this.startLineNumber=pe,this.startColumn=re,this.endLineNumber=Se,this.endColumn=Le}}e.$0K=c;class m extends c{constructor(pe,re,Se){super(pe,re,pe,Se)}}e.$$K=m;var v;(function(ue){ue.List="list",ue.Tree="tree"})(v||(e.ViewMode=v={}));var $;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function h(ue,pe=!0){const re=ue&&ue.files&&ue.files.exclude,Se=pe&&ue&&ue.search&&ue.search.exclude;if(!re&&!Se)return;if(!re||!Se)return re||Se;let Le=Object.create(null);return Le=R.$Zn(Le,R.$Wn(re)),Le=R.$Zn(Le,R.$Wn(Se),!0),Le}function E(ue,pe){return ue.excludePattern&&N.$jk(ue.excludePattern,pe)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&N.$jk(ue.includePattern,pe)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const Se=re.folder.fsPath;if(F.$qg(pe,Se)){const Le=g.$mc(Se,pe);return!re.includePattern||!!N.$jk(re.includePattern,Le)}else return!1}):!1:!0}var f;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class S extends Error{constructor(pe,re){super(pe),this.code=re}}e.$bL=S;function y(ue){const pe=ue.message;if((0,D.$4)(ue))return new S(pe,f.canceled);try{const re=JSON.parse(pe);return new S(re.message,re.code)}catch{return new S(pe,f.other)}}function C(ue){const pe={message:ue.message,code:ue.code};return new Error(JSON.stringify(pe))}function P(ue){return ue.type==="error"?!0:ue.type==="success"}function V(ue){return ue.type==="success"}function W(ue){return!!ue.path}function q(ue,pe,re=!0){const Se=ue.searchPath?ue.searchPath:ue.relativePath;return re?(0,M.$Tf)(Se,pe):N.$jk(pe,Se)}class A{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=A;function j(ue,pe){const re={...ue||{},...pe||{}};return Object.keys(re).filter(Se=>{const Le=re[Se];return typeof Le=="boolean"&&Le})}class K{constructor(pe,re){this.c=null,this.a={...pe.excludePattern||{},...re.excludePattern||{}},this.b=N.$kk(this.a);let Se=pe.includePattern;re.includePattern&&(Se?Se={...Se,...re.includePattern}:Se=re.includePattern),Se&&(this.c=N.$kk(Se))}matchesExcludesSync(pe,re,Se){return!!(this.b&&this.b(pe,re,Se))}includedInQuerySync(pe,re,Se){return!(this.b&&this.b(pe,re,Se)||this.c&&!this.c(pe,re,Se))}includedInQuery(pe,re,Se){const Le=this.b(pe,re,Se),ne=()=>this.c?!!this.c(pe,re,Se):!0;return(0,k.$ch)(Le)?Le.then(U=>U?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$kL=K;function ie(ue){for(const pe in ue)if(typeof ue[pe]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let pe;return re=>(pe||(pe=(ue()||Promise.resolve([])).then(Se=>Se?Ie(Se):{})),pe.then(Se=>!!Se[re]))}function ve(ue){if(!ue)return;let pe;return re=>{if(!pe){const Se=ue();pe=Se?Ie(Se):{}}return!!pe[re]}}function Ie(ue){const pe={};for(const re of ue)pe[re]=!0;return pe}}),define(Re[37],Ae([1,0,18,11,24,5,6,52,12,126,23,15,2,175,3,13,195,49,44,27,16,8,7,60,45,4,53]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b,c,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=e.$lkc=void 0;function $(V,W,q){return new T.$Sg(A=>S(A,q)).isEqual(V,W)}function h(V,W,q){return $(V.uri,W.uri,q)?0:(0,k.$mf)(V.uri.toString(),W.uri.toString())}function E(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:$(V.uri,W.uri,q)?(0,k.$mf)(V.name,W.name):(0,k.$mf)(V.uri.toString(),W.uri.toString())}function f(V,W,q,A){const j=V.slice(0).sort((ie,ce)=>q(ie,ce,A)),K=W.slice(0).sort((ie,ce)=>q(ie,ce,A));return(0,I.$Eb)(j,K,(ie,ce)=>q(ie,ce,A))}function S(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class y extends n.$Ji{static toExtHostWorkspace(W,q,A,j){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ve,transient:Ie,isUntitled:ue}=W,pe=[],re=q;q?ce.forEach((U,x)=>{const be=u.URI.revive(U.uri),Te=y.o(A||q,be,j);Te?(Te.name=U.name,Te.index=U.index,pe.push(Te)):pe.push({uri:be,name:U.name,index:x})}):pe.push(...ce.map(({uri:U,name:x,index:be})=>({uri:u.URI.revive(U),name:x,index:be}))),pe.sort((U,x)=>U.index<x.index?-1:1);const Se=new y(K,ie,pe,!!Ie,ve?u.URI.revive(ve):null,!!ue,U=>S(U,j)),{added:Le,removed:ne}=f(re?re.workspaceFolders:[],Se.workspaceFolders,h,j);return{workspace:Se,added:Le,removed:ne}}static o(W,q,A){for(let j=0;j<W.folders.length;j++){const K=W.workspaceFolders[j];if($(K.uri,q,A))return K}}constructor(W,q,A,j,K,ie,ce){super(W,A.map(ve=>new n.$Ki(ve)),j,K,ce),this.t=q,this.u=ie,this.q=[],this.s=p.$wi.forUris(ce),A.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,T.$3g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let C=class{constructor(W,q,A,j,K){this.c=new F.$be,this.onDidChangeWorkspace=this.c.event,this.g=new F.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new F.$de,this.C=new Map,this.h=j,this.s=A,this.t=K,this.j=new D.$xm,this.k=new N.$ph,this.o=W.getProxy(m.$PM.MainThreadWorkspace),this.q=W.getProxy(m.$PM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new y(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>S(ce,A)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:g.Schemas.untitled,path:(0,T.$1g)((0,T.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,A,...j){const K=[];if(Array.isArray(j)&&j.forEach(ue=>{u.URI.isUri(ue.uri)&&!K.some(pe=>$(pe.uri,ue.uri,this.s))&&K.push({uri:ue.uri,name:ue.name||(0,T.$Zg)(ue.uri)})}),this.n||[q,A].some(ue=>typeof ue!="number"||ue<0)||A===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+A>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,A,...K.map(ue=>({uri:ue.uri,name:ue.name||(0,T.$Zg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const pe=ce[ue];if(ce.some((re,Se)=>Se!==ue&&$(pe.uri,re.uri,this.s)))return!1}ce.forEach((ue,pe)=>ue.index=pe);const{added:ve,removed:Ie}=f(ie,ce,E,this.s);if(ve.length===0&&Ie.length===0)return!1;if(this.o){const ue=W.displayName||W.name;this.o.$updateWorkspaceFolders(ue,q,A,K).then(void 0,pe=>{this.n=void 0;const re={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,w.localize)(0,null,ue,pe.toString()),re,[])})}return this.y(ce),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let A,j="";if(typeof W=="string"?(A=u.URI.file(W),j=W):typeof W<"u"&&(A=W,j=W.fsPath),!A)return j;const K=this.getWorkspaceFolder(A,!0);if(!K)return j;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$6g)(K.uri,A);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(W){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:A,removed:j}=y.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:j}))}findFiles(W,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(W,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,q={},A,j=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,W,q,j)}async z(W,q,A,j=R.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ve,folder:Ie}=P(l.GlobPattern.from(W));ce=Ie,ie.includePattern=ve}else{const{includePattern:ve,folder:Ie}=P(l.GlobPattern.from(q));ce=Ie,ie.filePattern=ve}return this.o.$startFileSearch(ce??null,ie,j).then(ve=>Array.isArray(ve)?ve.map(Ie=>u.URI.revive(Ie)):[])}async findTextInFiles(W,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Ie}=P(l.GlobPattern.from(q.include)),ue=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,pe={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:ue},re=!1;if(this.u[ie]=Se=>{if(re)return;const Le=u.URI.revive(Se.resource);Se.results.forEach(ne=>{const U=(0,v.$Zh)(ne);(0,c.$5K)(U)?A({uri:Le,preview:{text:U.preview.text,matches:(0,I.$2b)(U.preview.matches,x=>new t.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(U.ranges,x=>new t.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Le,text:U.text,lineNumber:U.lineNumber})})},K.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(W,Ie??null,pe,ie,K);return delete this.u[ie],Se||{}}catch(Se){throw delete this.u[ie],Se}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return u.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return u.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const A=this.t.transformOutgoingScheme(W),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,A),(0,M.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const A=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const j=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!j),!j)return;const K=await j.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,q,A,j){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,A,j);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(q,A,j)=>{const K=function(ce){q.call(A,ce)};return K.extension=W,this.B.event(K,void 0,j)}}async $onWillCreateEditSessionIdentity(W,q,A){const j=await this.resolveWorkspaceFolder(u.URI.revive(W));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>A&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const A=this.t.transformOutgoingScheme(W),j=this.A++;return this.o.$registerCanonicalUriProvider(j,A),(0,M.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(W,q,A){const j=this.C.get(W.scheme);if(!j)return;const K=await j.provideCanonicalUri?.(u.URI.revive(W),q,A);if(K)return K}async $provideCanonicalUri(W,q,A){return this.provideCanonicalUri(u.URI.revive(W),{targetScheme:q},A)}};e.$lkc=C,e.$lkc=C=Je([Ve(0,a.$aP),Ve(1,i.$qP),Ve(2,r.$7jc),Ve(3,s.$Wj),Ve(4,b.$jkc)],C),e.$mkc=(0,d.$qi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=u.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Re[38],Ae([1,0,26,5,37,4,7,197,57,17,11,3,16,13,2]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=e.$okc=e.$nkc=void 0;function s(b,c){if(c){const m=c.split(".");let v=b;for(let $=0;v&&$<m.length;$++)v=v[m[$]];return v}}function o(b){return b instanceof d.URI}function n(b){return b&&b.uri instanceof d.URI&&b.languageId&&typeof b.languageId=="string"}function r(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function i(b){return b&&b.uri instanceof d.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function a(b){if(o(b))return{resource:b};if(n(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(r(b))return{overrideIdentifier:b.languageId};if(i(b))return{resource:b.uri};if(b===null)return{resource:null}}let l=class{constructor(c,m,v){this.a=c.getProxy(F.$PM.MainThreadConfiguration),this.c=m,this.b=v,this.d=new T.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,m){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(c,m))}};e.$nkc=l,e.$nkc=l=Je([Ve(0,u.$aP),Ve(1,R.$mkc),Ve(2,w.$Wj)],l);class t{constructor(c,m,v,$){this.a=new N.$be,this.b=c,this.f=$,this.c=m,this.e=p.$uo.parse(v,$),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,m){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$uo.parse(c,this.f),this.d=this.k(c.configurationScopes),this.a.fire(this.j(m,v))}getConfiguration(c,m,v){const $=a(m)||{},h=this.g(c?s(this.e.getValue(void 0,$,this.c.workspace),c):this.e.getValue(void 0,$,this.c.workspace));c&&this.h(c,$,v?.identifier);function E(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(S){return typeof s(h,S)<"u"},get:(S,y)=>{this.h(c?`${c}.${S}`:S,$,v?.identifier);let C=s(h,S);if(typeof C>"u")C=y;else{let P;const V=(W,q)=>{if((0,D.$6f)(W)){let A;const j=()=>{P=P||(0,I.$Wn)(h),A=A||s(P,q)};return new Proxy(W,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return j(),()=>A;if(P)return A=A||s(P,q),A[ie];const ce=K[ie];return typeof ie=="string"?V(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(j(),A&&(A[ie]=ce),!0),deleteProperty:(K,ie)=>(j(),A&&delete A[ie],!0),defineProperty:(K,ie,ce)=>(j(),A&&Object.defineProperty(A,ie,ce),!0)})}return Array.isArray(W)?(0,I.$Wn)(W):W};C=V(C,S)}return C},update:(S,y,C,P)=>{S=c?`${c}.${S}`:S;const V=E(C);return y!==void 0?this.b.$updateConfigurationOption(V,S,y,$,P):this.b.$removeConfigurationOption(V,S,$,P)},inspect:S=>{S=c?`${c}.${S}`:S;const y=this.e.inspect(S,$,this.c.workspace);if(y)return{key:S,defaultValue:(0,I.$Wn)(y.policy?.value??y.default?.value),globalValue:(0,I.$Wn)(y.user?.value??y.application?.value),workspaceValue:(0,I.$Wn)(y.workspace?.value),workspaceFolderValue:(0,I.$Wn)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$Wn)(y.default?.override),globalLanguageValue:(0,I.$Wn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$Wn)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$Wn)(y.workspaceFolder?.override),languageIds:(0,I.$Wn)(y.overrideIdentifiers)}}};return typeof h=="object"&&(0,I.$Zn)(f,h,!1),Object.freeze(f)}g(c){const m=v=>(0,D.$6f)(v)?new Proxy(v,{get:($,h)=>m($[h]),set:($,h,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:($,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:($,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return m(c)}h(c,m,v){const $=g.$lo.test(c)?4:this.d.get(c),h=v?`[${v.value}] `:"";if($===4){typeof m?.resource>"u"&&this.f.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){m?.resource&&this.f.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,m){const v=new p.$wo(c,m,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:($,h)=>v.affectsConfiguration($,a(h))})}k(c){return c.reduce((m,v)=>(m.set(v[0],v[1]),m),new Map)}}e.$okc=t,e.$pkc=(0,k.$qi)("IExtHostConfiguration")}),define(Re[119],Ae([1,0,2,11,5,4,7,37,67,38,24,51,16,27,3,12,21,13,78,231,14]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tlc=e.$Slc=e.$Rlc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(l||(l={}));var t;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(t||(t={}));var b;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(b||(b={}));var c;(function(V){function W(j){if(j){const K=j;return K&&!!K.process}else return!1}V.is=W;function q(j){if(j==null)return;const K={process:j.process,args:j.args};return j.options&&(K.options=b.from(j.options)),K}V.from=q;function A(j){if(j!=null)return new M.$AN(j.process,j.args,j.options)}V.to=A})(c||(c={}));var m;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(m||(m={}));var v;(function(V){function W(j){if(j){const K=j;return K&&(!!K.commandLine||!!K.command)}else return!1}V.is=W;function q(j){if(j==null)return;const K={};return j.commandLine!==void 0?K.commandLine=j.commandLine:(K.command=j.command,K.args=j.args),j.options&&(K.options=m.from(j.options)),K}V.from=q;function A(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new M.$BN(j.commandLine,j.options):new M.$BN(j.command,j.args?j.args:[],j.options)}V.to=A})(v||(v={}));var $;(function(V){function W(j){if(j){const K=j;return K&&K.customExecution==="customExecution"}else return!1}V.is=W;function q(j){return{customExecution:"customExecution"}}V.from=q;function A(j,K){return K.get(j)}V.to=A})($||(e.CustomExecutionDTO=$={}));var h;(function(V){function W(q,A){let j;return q.scope!==void 0&&typeof q.scope!="number"?j=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?j=A.workspaceFile:j=i.$VH),{id:q._id,workspaceFolder:j}}V.from=W})(h||(e.TaskHandleDTO=h={}));var E;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(E||(E={}));var f;(function(V){function W(j,K){if(j==null)return[];const ie=[];for(const ce of j){const ve=q(ce,K);ve&&ie.push(ve)}return ie}V.fromMany=W;function q(j,K){if(j==null)return;let ie;j.execution instanceof M.$AN?ie=c.from(j.execution):j.execution instanceof M.$BN?ie=v.from(j.execution):j.execution&&j.execution instanceof M.$CN&&(ie=$.from(j.execution));const ce=l.from(j.definition);let ve;return j.scope?typeof j.scope=="number"?ve=j.scope:ve=j.scope.uri:ve=M.TaskScope.Workspace,!ce||!ve?void 0:{_id:j._id,definition:ce,name:j.name,source:{extensionId:K.identifier.value,label:j.source,scope:ve},execution:ie,isBackground:j.isBackground,group:E.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}V.from=q;async function A(j,K,ie){if(j==null)return;let ce;c.is(j.execution)?ce=c.to(j.execution):v.is(j.execution)?ce=v.to(j.execution):$.is(j.execution)&&(ce=$.to(j._id,ie));const ve=l.to(j.definition);let Ie;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Ie=j.source.scope:Ie=await K.resolveWorkspaceFolder(I.URI.revive(j.source.scope)):Ie=M.TaskScope.Workspace),!ve||!Ie)return;const ue=new M.$DN(ve,Ie,j.name,j.source.label,ce,j.problemMatchers);return j.isBackground!==void 0&&(ue.isBackground=j.isBackground),j.group!==void 0&&(ue.group=M.$zN.from(j.group._id),ue.group&&j.group.isDefault&&(ue.group=new M.$zN(ue.group.id,ue.group.label),j.group.isDefault===!0&&(ue.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ue.presentationOptions=t.to(j.presentationOptions)),j._id&&(ue._id=j._id),j.detail&&(ue.detail=j.detail),ue}V.to=A})(f||(e.TaskDTO=f={}));var S;(function(V){function W(A){return A}V.from=W;function q(A){if(A)return Object.assign(Object.create(null),A)}V.to=q})(S||(S={}));class y{#e;constructor(W,q,A){this._id=q,this.a=A,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let C=class{constructor(W,q,A,j,K,ie,ce,ve){this.q=new R.$be,this.r=new R.$be,this.s=new R.$be,this.u=new R.$be,this.a=W.getProxy(F.$PM.MainThreadTask),this.b=A,this.c=j,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,A){if(!A)return new M.$RM(()=>{});const j=this.x();return this.j.set(j,{type:q,provider:A,extension:W}),this.a.$registerTaskProvider(j,q),new M.$RM(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(S.from(W)).then(async q=>{const A=[];for(const j of q){const K=await f.to(j,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,A){const j=this.m.get(W.id);j&&(this.o.set(W.id,j),this.e.attachPtyToTerminal(q,await j.callback(A))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));const j=[],K=(0,N.$ih)(()=>A.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,j,A,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(j).then(()=>{ie(ce)})})})}async $resolveTask(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const j=await f.to(q,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(j,T.CancellationToken.None);if(!K)return;this.A(K,A);const ie=f.from(K,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(W,q,A){const j=await this.a.$createTaskId(W);!A&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,q.execution)),this.m.set(j,q.execution)}async z(W,q){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new a.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(W.id);if(A)return A;let j;return q?j=Promise.resolve(new y(this,W.id,q)):j=f.to(W.task,this.b,this.m).then(K=>{if(!K)throw new a.$bb("Unexpected: Task does not exist.");return new y(this,W.id,K)}),this.l.set(W.id,j),j.then(K=>(this.k.set(W.id,K),K))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const A=this.n.values();let j=A.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=A.next()}};e.$Rlc=C,e.$Rlc=C=Je([Ve(0,u.$aP),Ve(1,w.$qP),Ve(2,p.$mkc),Ve(3,g.$lP),Ve(4,D.$pkc),Ve(5,k.$Nkc),Ve(6,n.$Wj),Ve(7,r.$3jc)],C);let P=class extends C{constructor(W,q,A,j,K,ie,ce,ve){super(W,q,A,j,K,ie,ce,ve),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=f.from(q,W);if(A===void 0)throw new Error("Task is not valid");if($.is(A.execution))await this.y(A,q,!1);else throw new a.$_;const j=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),j}v(W,q,A,j){const K=[];if(j)for(const ie of j){if(this.A(ie,A),!ie.definition||!W[ie.definition.type]){const ve=ie.source?ie.source:"No task source";this.f.warn(`The task [${ve}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=f.from(ie,A.extension);ce&&$.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(W){if($.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,A){}};e.$Slc=P,e.$Slc=P=Je([Ve(0,u.$aP),Ve(1,w.$qP),Ve(2,p.$mkc),Ve(3,g.$lP),Ve(4,D.$pkc),Ve(5,k.$Nkc),Ve(6,n.$Wj),Ve(7,r.$3jc)],P),e.$Tlc=(0,d.$qi)("IExtHostTask")}),define(Re[289],Ae([1,0,45,29]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=R,e.$uL=F;function R(M){return"cellResults"in M}e.$tL="rawCell#";function F(M,p){let g=-1;const D=[];let T=[];return M.forEach(u=>{u.range.startLineNumber!==g&&T.length>0&&(D.push([...T]),T=[]),T.push(u),g=u.range.endLineNumber}),T.length>0&&D.push([...T]),D.map(u=>{const w=[],d=u[0].range.startLineNumber,s=u[u.length-1].range.endLineNumber;for(let o=d;o<=s;o++)w.push(p.getLineContent(o));return new I.$9K(w.join(`
`)+`
`,u.map(o=>new N.$kt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Re[290],Ae([1,0,169,22,5,6,28,15,17,2,43,74,4,32,8,7,34,265,112,26,12,221,289,287]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(v=>v.apiEditor)}constructor(v,$,h,E,f,S){this.q=h,this.r=E,this.s=f,this.t=S,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$1jc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=v.getProxy(u.$PM.MainThreadNotebook),this.c=v.getProxy(u.$PM.MainThreadNotebookDocuments),this.d=v.getProxy(u.$PM.MainThreadNotebookEditors),this.i=$.converter,$.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,P=y.cell.handle,W=this.g.get(C)?.getCell(P);if(W)return W.apiCell}if(y&&y.$mid===14){const C=y.uri,P=this.g.get(C);if(P)return P.apiNotebook}return y}}),c.B($)}getEditorById(v){const $=this.h.get(v);if(!$)throw new Error(`unknown text editor: ${v}. known editors: ${[...this.h.keys()]} `);return $}getIdByEditor(v){for(const[$,h]of this.h)if(h.apiEditor===v)return $}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(v,$){const h=this.g.get(v);if(!h&&!$)throw new Error(`NO notebook document for '${v}'`);return h}static u(v,$){if(!$)return;const h=$.filenamePattern.map(E=>d.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if($.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${$.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:$.displayName,filenamePattern:h,exclusive:$.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,$,h){const E=c.a++,f=typeof h.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(E,h),this.b.$registerNotebookCellStatusBarItemProvider(E,f,$);let S;return f!==void 0&&(S=h.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(f))),new s.$RM(()=>{this.f.delete(E),this.b.$unregisterNotebookCellStatusBarItemProvider(E,f),S?.dispose()})}async createNotebookDocument(v){const $=await this.c.$tryCreateNotebook({viewType:v.viewType,content:v.content&&d.NotebookData.from(v.content)});return D.URI.revive($)}async openNotebookDocument(v){const $=this.g.get(v);if($)return $.apiNotebook;const h=await this.c.$tryOpenNotebook(v),E=this.g.get(D.URI.revive(h));return(0,g.$cg)(E?.apiNotebook)}async showNotebookDocument(v,$){D.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let h;typeof $=="object"?h={position:d.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selections:$.selections&&$.selections.map(d.NotebookRange.from),pinned:typeof $.preview=="boolean"?!$.preview:void 0}:h={preserveFocus:!1};const E=await this.d.$tryShowNotebookDocument(v.uri,v.notebookType,h),f=E&&this.h.get(E)?.apiEditor;if(f)return f;throw E?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,$,h,E){const f=this.f.get(v),S=D.URI.revive($),y=this.g.get(S);if(!y||!f)return;const C=y.getCellFromIndex(h);if(!C)return;const P=await f.provideCellStatusBarItems(C.apiCell,E);if(!P)return;const V=new F.$Tc,W=this.p.add([V]),A=(Array.isArray(P)?P:[P]).map(j=>d.NotebookStatusBarItem.from(j,this.i,V));return{cacheId:W,items:A}}$releaseNotebookCellStatusBarItems(v){this.p.delete(v)}registerNotebookSerializer(v,$,h,E,f){if((0,p.$3e)($))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:$,serializer:h,options:E}),this.b.$registerNotebookSerializer(S,{id:v.identifier,location:v.extensionLocation},$,d.NotebookDocumentContentOptions.from(E),c.u(v,f)),(0,F.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(v,$,h){const E=this.x.get(v);if(!E)throw new Error("NO serializer found");const f=await E.serializer.deserializeNotebook($.buffer,h);return new o.$mw(d.NotebookData.from(f))}async $notebookToData(v,$,h){const E=this.x.get(v);if(!E)throw new Error("NO serializer found");const f=await E.serializer.serializeNotebook(d.NotebookData.to($.value),h);return N.$Ce.wrap(f)}async $saveNotebook(v,$,h,E,f){const S=D.URI.revive($),y=this.x.get(v);if(!y)throw new Error("NO serializer found");const C=this.g.get(S);if(!C)throw new Error("Document NOT found");if(C.versionId!==h)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new T.$fl((0,I.localize)(0,null,this.z(S)),6);await this.y(S,E);const P={metadata:(0,i.$5n)(C.apiNotebook.metadata,j=>!(y.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of C.apiNotebook.getCells()){const K=new s.$hO(j.kind,j.document.getText(),j.document.languageId,j.mime,y.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);K.metadata=(0,i.$5n)(j.metadata,ie=>!(y.options?.transientCellMetadata??{})[ie]),P.cells.push(K)}const V=await y.serializer.serializeNotebook(P,f);await this.s.value.writeFile(S,V);const W=this.s.getFileSystemProviderExtUri(S.scheme),q=await this.s.value.stat(S);return{name:W.basename(S),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$ql({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(v,$,h,E,f){const S=this.x.get(v)?.serializer;if(!S)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(q,A,j)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,A,ve=>{ve.forEach(Ie=>{y.has(Ie)||E.some(pe=>K.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(re=>(0,b.$mgb)(re,Ie)))||y.add(Ie)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(h,f,$);const P=new M.$Bc;let V=!1;const W=Array.from(y).map(async q=>{const A=[];try{if(f.isCancellationRequested)return;if($.maxResults&&[...P.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>$.maxResults){V=!0;return}const j=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>j.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=N.$Ce.fromString(ce.toString()),Ie=await S.deserializeNotebook(ve.buffer,f);if(f.isCancellationRequested)return;d.NotebookData.from(Ie).cells.forEach(pe=>j.push({input:pe.source,outputs:pe.outputs.flatMap(re=>re.items.map(Se=>Se.valueBytes.toString()))}))}if(f.isCancellationRequested)return;j.forEach((ce,ve)=>{const Ie=$.contentPattern.pattern,ue=new l.$_Vb(ce.input,void 0,ce.outputs),pe=ue.findInInputs(Ie),re=ue.findInOutputs(Ie),Se=re.flatMap(Le=>(0,t.$uL)(Le.matches,Le.textBuffer)).map((Le,ne)=>(Le.webviewIndex=ne,Le));if(pe.length>0||re.length>0){const Le={index:ve,contentResults:(0,t.$uL)(pe,ue.inputTextBuffer),webviewResults:Se};A.push(Le)}});const ie={resource:q,cellResults:A};P.set(q,ie);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y(v,$){const h=await this.s.value.stat(v);if(typeof $?.mtime=="number"&&typeof $.etag=="string"&&$.etag!==T.$pl&&typeof h.mtime=="number"&&typeof h.size=="number"&&$.mtime<h.mtime&&$.etag!==T.$ql({mtime:$.mtime,size:h.size}))throw new T.$fl((0,I.localize)(1,null),3,$)}z(v){return v.scheme===a.Schemas.file?v.fsPath:v.toString()}A(v,$,h){if(this.h.has($))throw new Error(`editor with id ALREADY EXSIST: ${$}`);const E=new r.$llc($,this.d,v,h.visibleRanges.map(d.NotebookRange.to),h.selections.map(d.NotebookRange.to),typeof h.viewColumn=="number"?d.ViewColumn.to(h.viewColumn):void 0);this.h.set($,E)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const h of v.value.removedDocuments){const E=D.URI.revive(h),f=this.g.get(E);f&&(f.dispose(),this.g.delete(E),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(f.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===E.toString()&&this.h.delete(S.id)}if(v.value.addedDocuments){const h=[];for(const E of v.value.addedDocuments){const f=D.URI.revive(E.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const S=new n.$klc(this.c,this.q,this.r,f,E);h.push(...E.cells.map(y=>n.$jlc.asModelAddData(y))),this.g.get(f)?.dispose(),this.g.set(f,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this.m.fire(S.apiNotebook)}}if(v.value.addedEditors)for(const h of v.value.addedEditors){if(this.h.has(h.id))return;const E=D.URI.revive(h.documentUri),f=this.g.get(E);f&&this.A(f,h.id,h)}const $=[];if(v.value.removedEditors)for(const h of v.value.removedEditors){const E=this.h.get(h);E&&(this.h.delete(h),this.k?.id===E.id&&(this.k=void 0),$.push(E))}if(v.value.visibleEditors){this.l=v.value.visibleEditors.map(E=>this.h.get(E)).filter(E=>!!E);const h=new Set;this.l.forEach(E=>h.add(E.id));for(const E of this.h.values()){const f=h.has(E.id);E._acceptVisibility(f)}this.l=[...this.h.values()].map(E=>E).filter(E=>E.visible),this.o.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this.k=void 0:v.value.newActiveEditor&&(this.h.get(v.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${v.value.newActiveEditor}`),this.k=this.h.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(v){const $=w.$yP.String.with("notebookType","A notebook type"),h=new w.$AP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[$,new w.$yP("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>N.$Ce.wrap(f))],new w.$zP("Notebook Data",f=>d.NotebookData.to(f.value))),E=new w.$AP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[$,new w.$yP("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$mw(d.NotebookData.from(f)))],new w.$zP("Bytes",f=>f.buffer));v.registerApiCommand(h),v.registerApiCommand(E)}}e.$ulc=c}),define(Re[291],Ae([1,0,19,24,42,36,23,65,45]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;class D{constructor(u,w,d){this.k=u,this.l=w,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&F.$kk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&F.$kk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const w=this.k.folderQueries||[];return new Promise((d,s)=>{const o=n=>{this.f++,u(n)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(n=>{const r=n.toString(),i=I.$oc(r);this.j&&this.j(r,i)||this.v(o,{base:n,basename:i})}),Promise.all(w.map(n=>this.p(n,o))).then(n=>{d({limitHit:this.e,stats:n[0]||void 0})},n=>{s(new Error((0,R.$bj)(n)))})})}async p(u,w){const d=new N.$me,s=this.q(u),o=this.r(),n=new g.$kL(this.k,u),r=!n.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=p.$0d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,d.token),l=i.elapsed(),t=p.$0d.create();return this.g&&!this.e||(a&&a.forEach(b=>{const c=I.$hc.relative(u.folder.path,b.path);if(r){const m=I.$oc(b.path);this.v(w,{base:u.folder,relativePath:c,basename:m});return}this.s(o,u.folder,c,w)}),this.g&&!this.e)?null:(this.u(o,n,w),{providerTime:l,postProcessTime:t.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const w=(0,g.$jL)(this.k.includePattern,u.includePattern),d=(0,g.$jL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:w,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},w,d,s){if(d===this.a){const n=I.$oc(this.a);this.v(s,{base:w,relativePath:this.a,basename:n})}function o(n){const r=I.$oc(n),i=I.$nc(n);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:w,relativePath:n,basename:r})}o(d)}u({rootEntries:u,pathToEntries:w},d,s){const o=this,n=this.a;function r(i){const a=(0,g.$mL)(()=>i.map(l=>l.basename));for(let l=0,t=i.length;l<t;l++){const b=i[l],{relativePath:c,basename:m}=b;if(d.matchesExcludesSync(c,m,n!==m?a:void 0))continue;const v=w[c];if(v)r(v);else{if(c===n)continue;o.v(s,b)}if(o.e)break}}r(u)}v(u,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(w))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,w,d,s){const o=this.c(u.cacheKey),n=new D(u,w,o&&o.token);let r=0;const i=a=>{r+=a.length,d(a.map(l=>this.d(l)))};return this.e(n,T.a,i,s).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new N.$me),this.b.get(u)}d(u){return u.relativePath?{resource:M.$4g(u.base,u.relativePath)}:{resource:u.base}}e(u,w,d,s){const o=s.onCancellationRequested(()=>{u.cancel()}),n=i=>{i&&(r.push(i),w>0&&r.length>=w&&(d(r),r=[]))};let r=[];return u.search(n).then(i=>(r.length&&d(r),o.dispose(),i),i=>(r.length&&d(r),o.dispose(),Promise.reject(i)))}}e.$mlc=T}),define(Re[292],Ae([1,0,18,260,36,96,28,12,19,23,15,17,2,95,187,48,13,49,107,288,45]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=E;let l=class{constructor(S,y,C,P,V){this.a=S,this.b=y,this.c=C,this.d=P,this.e=V}text(S,y,C={}){S=this.f(S,C);const P=this.a.getValue(),V=y&&y.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(y?.map(n.$Li),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(S,y){const C=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const P={...S,wordSeparators:C.editor.wordSeparators};return this.j(S,y)&&(P.isCaseSensitive=!0),this.k(S)&&(P.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),P}file(S,y={}){return{...this.h(S,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(S,y){return S?(S=Array.isArray(S)?S.map(v):v(S),y?this.parseSearchPaths(S):{pattern:b(...Array.isArray(S)?S:[S])}):{}}h(S=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),P=this.g(y.excludePattern,y.expandPatterns),V=S.length>1,W=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(j=>this.q(j,y,P)):S.map(j=>this.r(j,y,P,V))).filter(j=>!!j),q={_reason:y._reason,folderQueries:W,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const j=I.$Hb(I.$Rb(this.c.groups.map(ce=>ce.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const K=j.filter(ce=>(0,a.$aL)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const A=y.extraFileResources&&y.extraFileResources.filter(j=>(0,a.$aL)(q,j.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(S){const y=[],C=new M.$Bc,P={};let V=!1;return S.forEach(W=>{if(W.scheme===p.Schemas.walkThrough)return;if((0,D.$8g)(W)){const A=this.b.getWorkspaceFolder(W)?.uri??W.with({path:g.$nc(W.fsPath)});let j=C.get(A);j||(V=!0,j={folder:A,includePattern:{}},y.push(j),C.set(A,j));const K=g.$mc(A.fsPath,W.fsPath);(0,k.$cg)(j.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:y,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(S,y){if(y.isSmartCase){if(S.isRegExp){if(T.$Uf(S.pattern,!0))return!0}else if(T.$Uf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,w.$BC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const y=ie=>g.$jc(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(S)?S:c(S)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,F.$rw)(ie,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):ie}),V=N.$K(P,ie=>y(ie)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(ie=>T.$bf(ie,"/")).map(ie=>T.$bf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),m(ie))),q={},A=this.m(V.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const j=I.$Rb(W),K=b(...j);return K&&(q.pattern=K),q}l(S,y){return y.disregardExcludeSettings?void 0:(0,a.$_K)(S,!y.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const y=S.flatMap(P=>{let{pathPortion:V,globPortion:W}=t(P);return W&&(W=$(W)),this.n(V).flatMap(A=>this.o(A,W))}),C=new Map;return y.forEach(P=>{const V=P.searchPath.toString(),W=C.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):C.set(V,{searchPath:P.searchPath,pattern:P.pattern?b(P.pattern):void 0})}),Array.from(C.values())}n(S){if(g.$jc(S)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==p.Schemas.file?[{searchPath:y[0].uri.with({path:S})}]:[{searchPath:u.URI.file(g.$ic(S))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(S=v(S),S.startsWith("../")||S===".."){const P=g.$hc.resolve(y.path,S);return[{searchPath:y.with({path:P})}]}const C=$(S);return[{searchPath:y,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const y=S.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=y.match(new RegExp(`^${T.$8e(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(k.$_f);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&$(W)}});{const V=S.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:S,q=d.localize(0,null,W);throw new Error(q)}}}}o(S,y){const C=S.pattern&&y?`${S.pattern}/${y}`:S.pattern||y,P=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:S.searchPath,pattern:C+"/**"}),P}q(S,y,C){const P=this.r((0,n.$Li)(S.searchPath),y,C,!1);return P?{...P,includePattern:S.pattern}:null}r(S,y,C,P){let V;const W=u.URI.isUri(S)?S:S.uri;if(C.searchPaths){const ie=C.searchPaths.filter(ce=>(0,D.$Wg)(ce.searchPath,W))[0];if(ie&&!ie.pattern)return null;ie&&(V=ie.pattern)}const q=this.a.getValue({resource:W}),j={...this.l(q,y)||{},...V||{}},K=u.URI.isUri(S)?(0,D.$1g)(S):S.name;return{folder:W,folderName:P?K:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!q.search.followSymlinks}}};e.$tM=l,e.$tM=l=Je([Ve(0,s.$Wi),Ve(1,n.$zi),Ve(2,r.$ID),Ve(3,o.$Wj),Ve(4,i.$rM)],l);function t(f){const S=f.match(/[\*\{\}\(\)\[\]\?]/);if(S){const y=S.index,C=f.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let P=f.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:f.substr((C.index||0)+1)}}}return{pathPortion:f}}function b(...f){return f.length?f.reduce((S,y)=>(S[y]=!0,S),Object.create(null)):void 0}function c(f){return R.$ik(f,",").map(S=>S.trim()).filter(S=>!!S.length)}function m(f){return[`**/${f}/**`,`**/${f}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function v(f){return f.replace(/\\/g,"/")}function $(f){return v(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(f){return f.replace(/([?*[\]])/g,"[$1]")}function E(f,S){f=I.$Mb(f,P=>P.toString());const y=[],C=S.getWorkspace();return f&&f.forEach(P=>{let V;if(S.getWorkbenchState()===2)V=(0,D.$6g)(C.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=S.getWorkspaceFolder(P);if(W){const q=W.name;if(C.folders.filter(j=>j.name===q).length===1){const j=(0,D.$6g)(W.uri,P);j===""?V=`./${W.name}`:V=`./${W.name}/${j}`}else V=P.fsPath}}V&&y.push(h(V))}),y}}),define(Re[293],Ae([1,0,23,2,24,14,3,292,45,49,11]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mtb=u,e.$ntb=s;const k=7e3;function u(o,n){const r=n.activationEvents;if(!r)return Promise.resolve(void 0);const i=[],a=[];for(const v of r)if(/^workspaceContains:/.test(v)){const $=v.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||o.forceUsingSearch?a.push($):i.push($)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:l,resolve:t}=(0,T.$jh)(),b=v=>t({activationEvent:v}),c=Promise.all(i.map(v=>w(o,v,b))).then(()=>{}),m=d(o,n.identifier,a,b);return Promise.all([c,m]).then(()=>{t(void 0)}),l}async function w(o,n,r){for(const i of o.folders)if(await o.exists(I.$4g(N.URI.revive(i),n))){r(`workspaceContains:${n}`);return}}async function d(o,n,r,i){if(r.length===0)return Promise.resolve(void 0);const a=new R.$me,l=o.checkExists(o.folders,r,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},k);let b=!1;try{b=await l}catch(c){F.$4(c)||F.$1(c)}a.dispose(),clearTimeout(t),b&&i(`workspaceContains:${r.join(",")}`)}function s(o,n,r,i){const a=o.get(M.$pi),l=o.get(g.$4K),b=a.createInstance(p.$tM).file(n.map(c=>(0,D.$Li)(N.URI.revive(c))),{_reason:"checkExists",includePattern:r,exists:!0});return l.fileSearch(b,i).then(c=>!!c.limitHit,c=>F.$4(c)?!1:Promise.reject(c))}}),define(Re[39],Ae([1,0,165,19,89,23,11,6,52,2,13,4,38,227,82,37,25,108,14,20,22,208,7,102,3,27,85,16,71,86,51,88,5,293,81,210,12,79,65,21,80]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b,c,m,v,$,h,E,f,S,y,C,P,V,W,q,A,j,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=e.$3kc=e.$2kc=e.$1kc=void 0,e.$1kc=(0,c.$qi)("IHostUtils");let ce=ie=class extends p.$Uc{constructor(U,x,be,Te,Ee,$e,fe,Q,Y,he,le,Ne,de){super(),this.Y=Ne,this.Z=de,this.a=this.B(new y.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=be,this.f=fe,this.j=Te,this.m=Ee,this.s=$e,this.t=Y,this.u=he,this.w=le,this.y=this.g.getProxy(k.$PM.MainThreadWorkspace),this.z=this.g.getProxy(k.$PM.MainThreadTelemetry),this.C=this.g.getProxy(k.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Le(this.f.extensions.activationEvents),this.L=new n.$C$b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Mm(this.f.extensions.myExtensions);this.J=new n.$C$b(this.I,re(this.L,Ce)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new d.$Jkc(this.g,this.s),this.N=new P.$Tkc(this.g),this.O=Q,this.h=U.createChild(new h.$oi([d.$Kkc,this.M],[P.$Ukc,this.N])),this.P=this.B(new w.$Ikc(this.J,this.L,{onExtensionActivationError:(Me,ze,z)=>{this.C.$onExtensionActivationError(Me,r.$3(ze),z)},actualActivateExtension:async(Me,ze)=>{if(n.$C$b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,ze),new w.$Hkc;const z=this.J.getExtensionDescription(Me);return this.fb(z,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){r.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.eb(Ee))}catch{}await Promise.all(U)}terminate(U,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$rh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const x=await this.C.$getExtension(U);return x&&{...x,identifier:new i.$Lm(x.identifier.value),extensionLocation:D.URI.revive(x.extensionLocation)}}ab(U,x){return this.P.activateByEvent(U,x)}bb(U,x){return this.P.activateById(U,x)}activateByIdWithErrors(U,x){return this.bb(U,x).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===W.Schemas.file&&this.c.fsRealpath){const x=U.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const be=await this.R.get(x);return D.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new Se(U))),this.Q}async db(U){const x=g.$wi.forUris(be=>F.$Ug.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const Te=await this.cb(be.extensionLocation);x.set(Te,be)}})),x}eb(U){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return x;const be=this.P.getActivatedExtension(U);if(!be)return x;try{typeof be.module.deactivate=="function"&&(x=Promise.resolve(be.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Te)}try{(0,p.$Pc)(be.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Te)}return x}async fb(U,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,x).then(be=>{const Te=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,x),this.gb(U,x,"success",Te),be},be=>{throw this.gb(U,x,"failure"),be})}gb(U,x,be,Te){const Ee=Ie(U,x);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Te||{},outcome:be})}hb(U,x){const be=Ie(U,x);this.z.$publicLog2("activatePlugin",be);const Te=this.wb(U);if(!Te)return Promise.resolve(new w.$Gkc(w.$Dkc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${U.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const Ee=new w.$Ekc(x.startup);return Promise.all([this.xb(U,(0,F.$4g)(U.extensionLocation,Te),Ee),this.ib(U)]).then($e=>(R.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ie.jb(this.s,U.identifier,$e[0],$e[1],Ee))).then($e=>(R.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),$e))}ib(U){const x=this.Z.createLanguageModelAccessInformation(U),be=new l.$Mkc(U,this.M),Te=new l.$Lkc(U.identifier.value,!1,this.M),Ee=new V.$Vkc(U,this.N),$e=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const le=(0,o.$xG)(U,"ipc")?this.f.messagePorts?.get(i.$Lm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Te,secrets:Ee,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ne){return N.$kc(U.extensionLocation.fsPath,Ne)},get storagePath(){return Q.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return Q.O.globalValue(U).fsPath},get logPath(){return N.$kc(Q.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return D.URI.joinPath(Q.f.logsLocation,U.identifier.value)},get storageUri(){return Q.O.workspaceValue(U)},get globalStorageUri(){return Q.O.globalValue(U)},get extensionMode(){return $e},get extension(){return Y===void 0&&(Y=new pe(Q,U.identifier,U,fe,!1)),Y},get extensionRuntime(){return(0,o.$yG)(U,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!he){if(!le)return;const Ne=y.Event.buffer(y.Event.fromDOMEventEmitter(le,"message",de=>de.data));le.start(),he={onDidReceiveMessage:Ne,postMessage:le.postMessage.bind(le)}}return he}})})}static jb(U,x,be,Te,Ee){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,x,be,Te,Ee).then($e=>new w.$Fkc(!1,null,Ee.build(),be,$e,Te.subscriptions))}static kb(U,x,be,Te,Ee){if(typeof be.activate=="function")try{Ee.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${x.value}`);const $e=typeof global=="object"?global:self,fe=be.activate.apply($e,[Te]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(fe).then(Q=>(Ee.activateResolveStop(),Q))}catch($e){return Promise.reject($e)}else return Promise.resolve(be)}lb(U,x){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:x}).then(void 0,be=>{this.s.error(be)})}mb(U,x=0){const Te=Date.now();(0,j.$B)(()=>{for(let Ee=x;Ee<U.length;Ee+=1){const $e=U[Ee];for(const fe of $e.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Te>50){this.mb(U,Ee);break}else this.lb($e,fe)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(U=>{const x=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(x)this.mb(be);else for(const Te of be)if(Te.activationEvents)for(const Ee of Te.activationEvents)Ee==="onStartupFinished"&&this.lb(Te,Ee)})}ob(){const U=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const x=this.j.workspace?this.j.workspace.folders:[],be=this.pb(x),Te=this.rb(),Ee=Promise.all([Te,U,be]).then(()=>{});return Promise.race([Ee,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),Ee}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(U,x))).then(()=>{})}async qb(U,x){if(this.isActivated(x.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:U.map($e=>$e.uri),forceUsingSearch:be||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,fe,Q)=>this.y.$checkExists($e,fe,Q)},Ee=await(0,C.$mtb)(Te,x);if(Ee)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:Ee.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:x}=this.f.environment;if(!U||!x)throw new Error(I.localize(0,null));const be=await this.xb(null,x,new w.$Ekc(!1));if(!be||typeof be.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Te,Ee)=>{const $e=(Y,he)=>{Y?(j.$t&&this.s.error("Test runner called back with error",Y),Ee(Y)):(j.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof he=="number"&&he>0?1:0))},fe=(0,F.$Rg)(x),Q=be.run(fe,$e);Q&&Q.then&&Q.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(Y=>{j.$t&&this.s.error("Test runner finished with error",Y),Ee(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,x){return this.S[U]=x,(0,p.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:x}=await this.ub(U);return x?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const x=U.indexOf("+");if(x===-1)throw new t.$XM("Not an authority that can be resolved!",b.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,x){const be=A.$0d.create(!1),Te=()=>`[resolveAuthority(${(0,b.$Fl)(U)},${x})][${be.elapsed()}ms] `,Ee=L=>this.s.info(`${Te()}${L}`),$e=L=>this.s.warn(`${Te()}${L}`),fe=(L,G=void 0)=>this.s.error(`${Te()}${L}`,G),Q=L=>{if(L instanceof t.$XM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{Ee(`activating resolver for ${L}...`);const{resolver:G,authorityPrefix:H}=await this.ub(L);if(!G)throw fe(`no resolver for ${H}`),new t.$XM(`No remote extension installed to resolve ${H}.`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:L}},he=U.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${he.join(" -> ")}`);let le;try{le=await Promise.all(he.map(Y)).catch(async L=>{if(!(L instanceof t.$XM)||L._code!==b.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return $e(`resolving nested authorities failed: ${L.message}`),[await Y(U)]})}catch(L){return Q(L)}const Ne=new M.$Bh;Ne.cancelAndSet(()=>Ee("waiting..."),1e3);let de,Ce;for(const[L,{authorityPrefix:G,resolver:H,remoteAuthority:_}]of le.entries())try{if(L===le.length-1)Ee("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(_,{resolveAttempt:x,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$WM.isManagedResolvedAuthority(de)?de:void 0));else{if(Ee(`invoking resolveExecServer() for ${_}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(_,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$XM(`Exec server was not available for ${_}`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(se){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),fe("returned an error",se),Ne.dispose(),Q(se)}Ne.dispose();const Me={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${t.$WM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let z;if(t.$WM.isManagedResolvedAuthority(de)){const L=x;this.Y.setFactory(L,de.makeConnection),z={authority:U,connectTo:new b.$Cl(L),connectionToken:de.connectionToken}}else z={authority:U,connectTo:new b.$Dl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:z,options:ze,tunnelInformation:Me}}}async $getCanonicalURI(U,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,b.$Fl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const Te=D.URI.revive(x);if(typeof be.getCanonicalURI>"u")return Te;const Ee=await(0,M.$ih)(()=>be.getCanonicalURI(Te));return Ee||Te}async $startExtensionHost(U){U.toAdd.forEach($e=>$e.extensionLocation=D.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,U),Te=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.tb()}$activateByEvent(U,x){return x===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,x){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,x),!0):!1}async $deltaExtensions(U){U.toAdd.forEach($e=>$e.extensionLocation=D.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,U),Te=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const x=a.$Ce.alloc(U),be=Math.random()%256;for(let Te=0;Te<U;Te++)x.writeUInt8(be,Te);return x}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$2kc=ce,e.$2kc=ce=ie=Je([Ve(0,c.$pi),Ve(1,e.$1kc),Ve(2,$.$aP),Ve(3,s.$mkc),Ve(4,u.$pkc),Ve(5,T.$Wj),Ve(6,m.$qP),Ve(7,v.$skc),Ve(8,E.$oCb),Ve(9,f.$Nkc),Ve(10,q.$Xkc),Ve(11,K.$Ykc),Ve(12,S.$Rkc)],ce);function ve(ne,U,x,be){ne.addActivationEvents(be.addActivationEvents);const Te=new n.$C$b(ne,U.getAllExtensionDescriptions());Te.deltaExtensions(be.toAdd,be.toRemove);const Ee=new i.$Mm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of be.myToRemove)Ee.delete(fe);for(const fe of be.myToAdd)Ee.add(fe);const $e=re(Te,Ee);return{globalRegistry:Te,myExtensions:$e}}function Ie(ne,U){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function ue(ne){return ne.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$3kc=(0,c.$qi)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(U,x,be,Te,Ee){this.#e=U,this.#t=x,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=N.$ic((0,F.$Rg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Te,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4kc=pe;function re(ne,U){return ne.getAllExtensionDescriptions().filter(x=>U.has(x.identifier))}class Se{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$5kc=Se;class Le{constructor(U){this.a=new i.$Nm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const x of Object.keys(U))this.a.set(x,U[x])}}}),define(Re[294],Ae([1,0,89,2,4,38,25,20,16,27,3,39,13,15]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=void 0;let s=class{constructor(a,l,t,b,c,m,v){this.c=a,this.d=l,this.e=t,this.f=b,this.g=c,this.h=m,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new n(this.c,l,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,l,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const l of a.nodeModuleName)this.a.set(l,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(l=>a.alternativeModuleName(l))}};e.$bmc=s,e.$bmc=s=Je([Ve(2,T.$pi),Ve(3,F.$pkc),Ve(4,k.$3kc),Ve(5,D.$qP),Ve(6,u.$Wj)],s);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&d.a.size){const l=(0,w.$8e)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",b=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${c}\\/)(${b})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const l=this.b.exec(this.c(a));if(!l)return;const[,t,b,c]=l,m=d.a.get(b);if(m!==void 0)return console.warn(`${b} as been renamed to ${m}, please update your imports`),t+m+c}c(a){return a.replace(/\\/g,"/")}};o=d=Je([Ve(0,D.$qP)],o);class n{constructor(a,l,t,b,c){this.c=a,this.d=l,this.e=t,this.f=b,this.g=c,this.nodeModuleName="vscode",this.a=new p.$Nm}load(a,l){const t=this.d.findSubstr(l);if(t){let b=this.a.get(t.identifier);return b||(b=this.c(t,this.e,this.f),this.a.set(t.identifier,b)),b}if(!this.b){let b="";this.d.forEach((c,m)=>b+=`	${m} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${b}`),this.b=this.c(M.$sG,this.e,this.f)}return this.b}}let r=class{constructor(a,l,t){this.e=a,this.f=l,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$PM.MainThreadTelemetry);const b=t.getProxy(R.$PM.MainThreadWindow);this.c=(c,m)=>{const v=N.URI.parse(c);return m?this.g(c,m):v.scheme==="http"||v.scheme==="https"?b.$openUri(v,c,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?b.$openUri(v,c,{}):this.g(c,m)}}load(a,l,t){const b=this.e.findSubstr(l);return b&&(this.a=b.identifier.value,this.h()),this.b=t(a),this.c}g(a,l){return this.i(),this.b(a,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Je([Ve(2,g.$aP)],r)}),define(Re[120],Ae([1,0,40,6,19,73,3,67,66,39,7,37,224,38]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=e.$6kc=void 0,e.$6kc=(0,M.$qi)("IExtHostVariableResolverProvider");class d extends u.$cQ{constructor(n,r,i,a,l,t,b){function c(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const v=a.tabGroups.all.find($=>$.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof T.$CO||v.input instanceof T.$HO)return v.input.modified;if(v.input instanceof T.$BO||v.input instanceof T.$GO||v.input instanceof T.$EO)return v.input.uri}}}super({getFolderUri:m=>{const v=t.folders.filter($=>$.name===m);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(m,v)=>l.getConfiguration(void 0,m).get(v),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=c();if(m)return R.$ic(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const m=c();if(m){const v=r.getWorkspaceFolder(m);if(v)return R.$ic(v.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>n.getExtension(m)},void 0,b?Promise.resolve(b):void 0,Promise.resolve(F.env))}}let s=class extends N.$Uc{constructor(n,r,i,a,l){super(),this.b=n,this.c=r,this.g=i,this.h=a,this.j=l,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$7kc=s,e.$7kc=s=Je([Ve(0,D.$3kc),Ve(1,k.$mkc),Ve(2,p.$lP),Ve(3,w.$pkc),Ve(4,g.$Bkc)],s)}),define(Re[121],Ae([1,0,11,5,2,20,3,4,66,39,16,7,37,216,218,38,120,6,41,32,8]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=e.$$kc=e.$0kc=e.$9kc=e.$8kc=void 0,e.$8kc=(0,M.$qi)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(h,E,f,S,y,C,P){this.N=E,this.O=f,this.P=S,this.Q=y,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=h.getProxy(p.$PM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new b(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(W=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(h,E){const f=this.W(E);if(!f)return;const S=await this.H.get(h)?.getTreeItem?.(f);return S?this.U(h,S):void 0}registerDebugVisualizationTree(h,E,f){const S=F.$Lm.toKey(h.identifier),y=this.jb(S,E);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.H.set(y,f),this.l.$registerDebugVisualizerTree(y,!!f.editItem),(0,n.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(E)})}async $getVisualizerTreeItemChildren(h,E){const f=this.J.get(E)?.item;return f?(await this.H.get(h)?.getChildren?.(f))?.map(y=>this.U(h,y))||[]:[]}async $editVisualizerTreeItem(h,E){const f=this.J.get(h);if(!f)return;const S=await this.H.get(f.provider)?.editItem?.(f.item,E);return this.U(f.provider,S||f.item)}$disposeVisualizedTree(h){const E=this.J.get(h);if(!E)return;const f=[E.children];for(const S of f)if(S)for(const y of S)f.push(this.J.get(y)?.children),this.J.delete(y)}U(h,E){let f=this.I.get(E);return f||(f=this.F++,this.I.set(E,f),this.J.set(f,{provider:h,item:E})),a.DebugTreeItem.from(E,f)}asDebugSourceUri(h,E){const f=h;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let S=`debug:${encodeURIComponent(f.path||"")}`,y="?";return E&&(S+=`${y}session=${encodeURIComponent(E.id)}`,y="&"),S+=`${y}ref=${f.sourceReference}`,R.URI.parse(S)}else{if(f.path)return R.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(h){const E=[];for(const f of h.getAllExtensionDescriptions())if(f.contributes){const S=f.contributes.debuggers;if(S&&S.length>0)for(const y of S)(0,d.$_G)(y)&&E.push(y.type)}this.l.$registerDebugTypes(E)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const h=[];return this.z.forEach(E=>h.push(E)),h}async $resolveDebugVisualizer(h,E){const f=this.L.get(h);if(!f)throw new Error(`No debug visualizer found with id '${h}'`);let{v:S,provider:y,extensionId:C}=f;if(S.visualization||(S=await y.resolveDebugVisualization?.(S,E)||S,f.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,S.visualization)}async $executeDebugVisualizerCommand(h){const E=this.L.get(h);if(!E)throw new Error(`No debug visualizer found with id '${h}'`);const f=E.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(h){const E=this.m.get(h.sessionId);return E&&{session:E.api,variable:h.variable,containerId:h.containerId,frameId:h.frameId,threadId:h.threadId}}async $provideDebugVisualizers(h,E,f,S){const y=this.W(f),C=this.jb(h,E),P=this.G.get(C);if(!y||!P)return[];const V=await P.provideDebugVisualization(y,S);return V?V.map(W=>{const q=++this.M;this.L.set(q,{v:W,provider:P,extensionId:h});const A=W.iconPath?this.lb(W.iconPath):void 0;return{id:q,name:W.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(h,W.visualization)}}):[]}$disposeDebugVisualizers(h){for(const E of h)this.L.delete(E)}registerDebugVisualizationProvider(h,E,f){if(!h.contributes?.debugVisualizers?.some(C=>C.id===E))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${E})`);const S=F.$Lm.toKey(h.identifier),y=this.jb(S,E);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${E}' is already registered`);return this.G.set(y,f),this.l.$registerDebugVisualizer(S,E),(0,n.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,E),this.G.delete(E)})}addBreakpoints(h){const E=h.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(E,[],[]);const f=[],S=new Map;for(const y of E)if(y instanceof k.$SN){let C=S.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},S.set(y.location.uri.toString(),C),f.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof k.$TN&&f.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(h){const E=h.filter(C=>this.z.delete(C.id));this.gb([],E,[]);const f=E.filter(C=>C instanceof k.$SN).map(C=>C.id),S=E.filter(C=>C instanceof k.$TN).map(C=>C.id),y=E.filter(C=>C instanceof k.$UN).map(C=>C.id);return this.l.$unregisterBreakpoints(f,S,y)}startDebugging(h,E,f){return this.l.$startDebugging(h?h.uri:void 0,E,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(h){return this.l.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,E,f){if(!E)return new k.$RM(()=>{});const S=this.d++;return this.f.push({type:h,handle:S,provider:E}),this.l.$registerDebugConfigurationProvider(h,f,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,S),new k.$RM(()=>{this.f=this.f.filter(y=>y.provider!==E),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(h,E,f){if(!f)return new k.$RM(()=>{});if(!this.cb(h,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.$(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:E,handle:S,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(E,S),new k.$RM(()=>{this.h=this.h.filter(y=>y.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(h,E){if(!E)return new k.$RM(()=>{});const f=this.j++;return this.k.push({type:h,handle:f,factory:E}),new k.$RM(()=>{this.k=this.k.filter(S=>S.factory!==E)})}async $runInTerminal(h,E){return Promise.resolve(void 0)}async $substituteVariables(h,E){let f;const S=await this.ib(h);return S&&(f={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,E)}X(h,E){if(h.type==="implementation")return new m(h.implementation)}Y(){}async $startDASession(h,E){const f=this,S=await this.hb(E);return this.eb(this.$(S.type),S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.Z(y),P=this.X(C,S);if(!P)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const V=P;return this.D.set(h,V),this.db(S).then(W=>(W&&this.E.set(h,W),V.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,j={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);j.body={signature:K},V.sendResponse(j)}else throw new Error("no signer")}catch(K){j.success=!1,j.message=K.message,V.sendResponse(j)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(q),q=(0,d.$eH)(q,!0),f.l.$acceptDAMessage(h,q)}),V.onError(q=>{W&&W.onError&&W.onError(q),this.l.$acceptDAError(h,q.name,q.message,q.stack)}),V.onExit(q=>{W&&W.onExit&&W.onExit(q??void 0,void 0),this.l.$acceptDAExit(h,q??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),V.startSession()))})}$sendDAMessage(h,E){E=(0,d.$dH)(E,!1);const f=this.E.get(h);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(E),this.D.get(h)?.sendMessage(E)}$stopDASession(h){const E=this.E.get(h);this.E.delete(h),E&&E.onWillStopSession&&E.onWillStopSession();const f=this.D.get(h);return this.D.delete(h),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const E=[],f=[],S=[];if(h.added)for(const y of h.added){const C=y.id;if(C&&!this.z.has(C)){let P;if(y.type==="function")P=new k.$TN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")P=new k.$UN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const V=R.URI.revive(y.uri);P=new k.$SN(new k.$4M(V,new k.$SM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,k.$QN)(P,C),this.z.set(C,P),E.push(P)}}if(h.removed)for(const y of h.removed){const C=this.z.get(y);C&&(this.z.delete(y),f.push(C))}if(h.changed){for(const y of h.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof k.$TN&&y.type==="function"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.functionName=y.functionName}else if(C instanceof k.$SN&&y.type==="source"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.location=new k.$4M(R.URI.revive(y.uri),new k.$SM(y.line,y.character))}S.push(C)}}}this.gb(E,f,S)}async $acceptStackFrameFocus(h){let E;if(h){const f=await this.hb(h.sessionId);h.kind==="thread"?E=new k.$1N(f.api,h.threadId):E=new k.$ZN(f.api,h.threadId,h.frameId)}this.B=E,this.C.fire(this.B)}$provideDebugConfigurations(h,E,f){return(0,I.$ih)(async()=>{const S=this.bb(h);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(E);return S.provideDebugConfigurations(y,f)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(h,E,f,S){return(0,I.$ih)(async()=>{const y=this.bb(h);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(E);return y.resolveDebugConfiguration(C,f,S)})}$resolveDebugConfigurationWithSubstitutedVariables(h,E,f,S){return(0,I.$ih)(async()=>{const y=this.bb(h);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(E);return y.resolveDebugConfigurationWithSubstitutedVariables(C,f,S)})}async $provideDebugAdapter(h,E){const f=this.ab(h);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(E);return this.eb(f,S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(h){const E=await this.hb(h);this.n.fire(E.api)}async $acceptDebugSessionTerminated(h){const E=await this.hb(h);E&&(this.o.fire(E.api),this.m.delete(E.id))}async $acceptDebugSessionActiveChanged(h){this.u=h?await this.hb(h):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(h,E){(await this.hb(h))?._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(h,E){const S={session:(await this.hb(h)).api,event:E.event,body:E.body};this.w.fire(S)}Z(h){if(h instanceof k.$VN)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof k.$WN)return{type:"server",port:h.port,host:h.host};if(h instanceof k.$XN)return{type:"pipeServer",path:h.path};if(h instanceof k.$YN)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}$(h){const E=this.h.filter(f=>f.type===h);if(E.length>0)return E[0].factory}ab(h){const E=this.h.filter(f=>f.handle===h);if(E.length>0)return E[0].factory}bb(h){const E=this.f.filter(f=>f.handle===h);if(E.length>0)return E[0].provider}cb(h,E){if(h.contributes){const f=h.contributes.debuggers;if(f&&f.length>0){for(const S of f)if(S.label&&S.type&&S.type===E)return!0}}return!1}db(h){const f=h.configuration.type,S=this.k.filter(y=>y.type===f||y.type==="*").map(y=>(0,I.$ih)(()=>y.factory.createDebugAdapterTracker(h.api)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(y=>{const C=y.filter(P=>!!P);if(C.length>0)return new c(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(h,E){const f=E.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.$WN(f));if(h){const y=await this.O.getExtensionRegistry();return(0,I.$ih)(()=>h.createDebugAdapterDescriptor(E.api,this.fb(E,y))).then(C=>{if(C)return C})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(E,S))}fb(h,E){}gb(h,E,f){(h.length>0||E.length>0||f.length>0)&&this.A.fire(Object.freeze({added:h,removed:E,changed:f}))}async hb(h){if(h)if(typeof h=="string"){const E=this.m.get(h);if(E)return E}else{let E=this.m.get(h.id);if(!E){const f=await this.ib(h.folderUri),S=h.parent?this.m.get(h.parent):void 0;E=new t(this.l,h.id,h.type,h.name,f,h.configuration,S?.api),this.m.set(E.id,E),this.l.$sessionCached(E.id)}return E}throw new Error("cannot find session")}ib(h){if(h){const E=R.URI.revive(h);return this.N.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}jb(h,E){return`${h}\0${E}`}kb(h,E){if(E){if("title"in E&&"command"in E)return{type:0};if("treeId"in E)return{type:1,id:`${h}\0${E.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(h){const E=this.mb(h);let f,S;return"id"in E?S=r.ThemeIcon.asClassName(E):f=E,{iconPath:f,iconClass:S}}mb(h){if(h instanceof k.$NN)return{id:h.id};const E=typeof h=="object"&&"dark"in h?h.dark:h,f=typeof h=="object"&&"light"in h?h.light:h;return{dark:typeof E=="string"?R.URI.file(E):E,light:typeof f=="string"?R.URI.file(f):f}}};e.$9kc=l,e.$9kc=l=Je([Ve(0,T.$aP),Ve(1,u.$mkc),Ve(2,D.$3kc),Ve(3,s.$pkc),Ve(4,g.$Bkc),Ve(5,o.$6kc),Ve(6,i.$wP)],l);class t{constructor(h,E,f,S,y,C,P){this.f=h,this.g=E,this.h=f,this.j=S,this.k=y,this.l=C,this.m=P}get api(){const h=this;return this.d??=Object.freeze({id:h.g,type:h.h,get name(){return h.j},set name(E){h.j=E,h.f.$setDebugSessionName(h.g,E)},parentSession:h.m,workspaceFolder:h.k,configuration:h.l,customRequest(E,f){return h.f.$customDebugAdapterRequest(h.g,E,f)},getDebugProtocolBreakpoint(E){return h.f.$getDebugProtocolBreakpoint(h.g,E.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(h){this.j=h}get configuration(){return this.l}}e.$0kc=t;class b{constructor(h){this.value=Object.freeze({append(E){h.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.$$kc=b;class c{constructor(h){this.d=h}onWillStartSession(){this.d.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.d.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.d.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(h):void 0)}onWillStopSession(){this.d.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.d.forEach(E=>E.onError?E.onError(h):void 0)}onExit(h,E){this.d.forEach(f=>f.onExit?f.onExit(h,E):void 0)}}class m extends w.$sob{constructor(h){super(),this.h=h,h.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.h.handleMessage(h)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends l{constructor(h,E,f,S,y,C,P){super(h,E,f,S,y,C,P)}};e.$_kc=v,e.$_kc=v=Je([Ve(0,T.$aP),Ve(1,u.$mkc),Ve(2,D.$3kc),Ve(3,s.$pkc),Ve(4,g.$Bkc),Ve(5,o.$6kc),Ve(6,i.$wP)],v)}),define(Re[295],Ae([1,0,14,89,2,4,244,13,55,71,27,192,16,60,39,62]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=e.$cmc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(p.$Wj),t=i.get(u.$aP).getProxy(F.$PM.MainThreadErrors);I.setUnexpectedErrorHandler(b=>{a.error(b);const c=I.$3(b);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(p.$Wj),l=i.get(u.$aP),t=i.get(d.$3kc),b=i.get(s.$uP),c=l.getProxy(F.$PM.MainThreadExtensionService),m=l.getProxy(F.$PM.MainThreadErrors),v=await t.getExtensionPathIndex(),$=new WeakMap;function h(S,y){if($.has(S))return $.get(S).stack;let C="",P,V;for(const q of y)C+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=v.findSubstr(R.URI.file(V)));const W=`${S.name||"Error"}: ${S.message||""}${C}`;return $.set(S,{extensionIdentifier:P?.identifier,stack:W}),W}const E=Symbol("prepareStackTrace wrapped");let f=h;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(S){if(S===h||!S||S[E]){f=S||h;return}f=function(y,C){return h(y,C),S.call(Error,y,C)},Object.assign(f,{[E]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const y=I.$3(S),C=$.get(S);if(!C?.extensionIdentifier){m.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const P=b.onExtensionError(C.extensionIdentifier,S);a.trace("forwarded error to extension?",P,C)})}}e.$cmc=o;class n{constructor(i,a,l,t,b){this.a=l,this.b=new M.$K$b(i,null,t),a=n.e(a,this.b);const c=new D.$oi(...(0,g.$ps)());c.set(T.$qP,{_serviceBrand:void 0,...a,messagePorts:b}),c.set(u.$aP,new u.$bP(this.b)),c.set(w.$jkc,new w.$kkc(t)),c.set(d.$1kc,l);const m=new k.$7q(c,!0);m.invokeFunction(o.installEarlyHandler),this.d=m.invokeFunction(v=>v.get(p.$Wj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=m.invokeFunction(v=>v.get(d.$3kc)),this.c.initialize(),m.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(F.$PM.MainThreadExtensionService);return R.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=R.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const l=i.environment.extensionDevelopmentLocationURI;return l&&(i.environment.extensionDevelopmentLocationURI=l.map(t=>R.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$dmc=n}),define(Re[296],Ae([1,0,18,11,24,42,12,19,23,2,45]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=e.$olc=e.$nlc=void 0,e.$plc=s;class k{constructor(r,i,a){this.d=r,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(r,i){const a=this.g.folderQueries||[],l=new R.$me(i);return new Promise((t,b)=>{this.a=new w(r);let c=!1;const m=(v,$)=>{if(!c&&!this.b){const h=this.h(v);s(v)&&typeof this.g.maxResults=="number"&&this.c+h>this.g.maxResults&&(this.b=!0,c=!0,l.cancel(),v=this.j(v,this.g.maxResults-this.c));const E=this.h(v);this.c+=E,(E>0||!s(v))&&this.a.add(v,$)}};Promise.all(a.map((v,$)=>this.k(v,h=>m(h,$),l.token))).then(v=>{l.dispose(),this.a.flush();const $=v.some(h=>!!h&&!!h.limitHit);t({limitHit:this.b||$,messages:(0,I.$Rb)(v.map(h=>h?.message?Array.isArray(h.message)?h.message:[h.message]:[])),stats:{type:this.f}})},v=>{l.dispose();const $=(0,F.$bj)(v);b(new Error($))})})}h(r){return s(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,i){const a=Array.isArray(r.ranges)?r.ranges:[r.ranges],l=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:a.slice(0,i),preview:{matches:l.slice(0,i),text:r.preview.text},uri:r.uri}}async k(r,i,a){const l=new T.$kL(this.g,r),t=[],b={report:v=>{if(!this.l(v))return;const $=r.folder.scheme===M.Schemas.file?(0,T.$lL)(()=>this.e.readdir(g.$3g(v.uri))):void 0,h=g.$6g(r.folder,v.uri);if(h){const E=l.includedInQuery(h,p.$oc(h),$);(0,N.$ch)(E)?t.push(E.then(f=>{f&&i(v)})):E&&i(v)}}},c=this.n(r);let m;return this.d.query.type===3?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,b,a):m=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,b,a),t.length&&await Promise.all(t),m}l(r){if(s(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const i=(0,T.$jL)(this.g.includePattern,r.includePattern),a=(0,T.$jL)(this.g.excludePattern,r.excludePattern),l={folder:D.URI.from(r.folder),excludes:a,includes:i,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.e.toCanonicalName(r.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(l.usePCRE2=this.g.usePCRE2),l}}e.$nlc=k;function u(n){return{isCaseSensitive:n.isCaseSensitive||!1,isRegExp:n.isRegExp||!1,isWordMatch:n.isWordMatch||!1,isMultiline:n.isMultiline||!1,pattern:n.pattern}}class w{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(r,i){this.d&&(this.b!==i||!g.$Wg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:r.uri,results:[]}),this.d.results.push(d(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$olc=w;function d(n){return s(n)?{preview:{matches:(0,I.$2b)(n.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:n.preview.text},ranges:(0,I.$2b)(n.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:n.text,lineNumber:n.lineNumber}}function s(n){return!!n.preview}class o{static{this.a=4e3}static{this.b=50}constructor(r,i){this.g=r,this.h=i,this.c=0,this.d=[],this.e=0}addItem(r,i){r&&this.j(r,i)}addItems(r,i){r&&this.k(r,i)}j(r,i){this.d.push(r),this.e+=i,this.l()}k(r,i){this.d=this.d.concat(r),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qlc=o}),define(Re[122],Ae([1,0,6,4,3,291,16,60,13,2,296]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=e.$rlc=void 0,e.$tlc=u,e.$rlc=(0,R.$qi)("IExtHostSearch");let k=class{constructor(s,o,n){this.n=s,this.o=o,this.q=n,this.c=this.n.getProxy(N.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new F.$mlc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const n=this.d++;return this.e.set(n,o),this.c.$registerTextSearchProvider(n,this.s(s)),(0,I.$Sc)(()=>{this.g.delete(s),this.e.delete(n),this.c.$unregisterProvider(n)})}registerAITextSearchProvider(s,o){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const n=this.d++;return this.h.set(n,o),this.c.$registerAITextSearchProvider(n,this.s(s)),(0,I.$Sc)(()=>{this.i.delete(s),this.h.delete(n),this.c.$unregisterProvider(n)})}registerFileSearchProvider(s,o){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const n=this.d++;return this.j.set(n,o),this.c.$registerFileSearchProvider(n,this.s(s)),(0,I.$Sc)(()=>{this.k.delete(s),this.j.delete(n),this.c.$unregisterProvider(n)})}$provideFileSearchResults(s,o,n,r){const i=u(n),a=this.j.get(s);if(a)return this.l.fileSearch(i,a,l=>{this.c.$handleFileMatch(s,o,l.map(t=>t.resource))},r);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,n){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,n,r){const i=this.e.get(s);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const a=u(n);return this.t(a,i).search(t=>this.c.$handleTextMatch(s,o,t),r)}$provideAITextSearchResults(s,o,n,r){const i=this.h.get(s);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const a=u(n);return this.v(a,i).search(t=>this.c.$handleTextMatch(s,o,t),r)}$enableExtensionHostSearch(){}t(s,o){return new T.$nlc({query:s,provider:o},{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"textSearchProvider")}v(s,o){return new T.$nlc({query:s,provider:o},{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"aiTextSearchProvider")}};e.$slc=k,e.$slc=k=Je([Ve(0,M.$aP),Ve(1,p.$jkc),Ve(2,g.$Wj)],k);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(w),extraFileResources:d.extraFileResources&&d.extraFileResources.map(s=>D.URI.revive(s))}}function w(d){return{...d,folder:D.URI.revive(d.folder)}}}),define(Re[297],Ae([1,0,24,14,5,6,12,33,2,151,147,135,94,20,43,13,58,59,205,4,247,275,78,84,252,253,254,233,222,32,255,38,256,121,110,257,235,248,258,259,67,66,249,39,261,64,262,44,27,276,277,236,263,88,264,79,80,238,290,266,209,267,278,268,116,239,269,270,271,16,272,122,81,273,240,274,82,85,119,62,51,114,279,280,250,281,282,86,8,7,241,60,242,63,283,284,109,37,217,77,25,118]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b,c,m,v,$,h,E,f,S,y,C,P,V,W,q,A,j,K,ie,ce,ve,Ie,ue,pe,re,Se,Le,ne,U,x,be,Te,Ee,$e,fe,Q,Y,he,le,Ne,de,Ce,Me,ze,z,L,G,H,_,se,Fe,Be,Qe,_e,et,tt,it,nt,ct,ft,je,st,X,Z,me,He,we,ot,dt,Ct,Ut,Yt,Jt,xt,Dt,Wt,Qt,Xe,ri){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=_t;function _t(ht){const $t=ht.get(Se.$qP),ei=ht.get(re.$7jc),Zt=ht.get(ue.$rkc),Lt=ht.get(ve.$3kc),gt=ht.get(Dt.$mkc),jt=ht.get(it.$uP),Xt=ht.get(S.$pkc),zt=ht.get(dt.$jkc),Ke=ht.get(G.$aP),oi=ht.get(_e.$Kkc),Vt=ht.get(et.$skc),qt=ht.get(s.$Xj),mt=ht.get(s.$Wj),Rt=ht.get(me.$oCb),Tt=ht.get(t.$3jc),Nt=ht.get(xt.$9lc),ti=ht.get(se.$Ukc),Ht=ht.get(ie.$Bkc),si=ht.get($e.$Ykc),At=ht.get(b.$akc),Ft=ht.get(be.$Rkc);Ke.set(i.$QM.ExtHostFileSystemInfo,ei),Ke.set(i.$QM.ExtHostLogLevelServiceShape,qt),Ke.set(i.$QM.ExtHostWorkspace,gt),Ke.set(i.$QM.ExtHostConfiguration,Xt),Ke.set(i.$QM.ExtHostExtensionService,Lt),Ke.set(i.$QM.ExtHostStorage,oi),Ke.set(i.$QM.ExtHostTunnelService,Rt),Ke.set(i.$QM.ExtHostWindow,Nt),Ke.set(i.$QM.ExtHostSecretState,ti),Ke.set(i.$QM.ExtHostTelemetry,jt),Ke.set(i.$QM.ExtHostEditorTabs,Ht),Ke.set(i.$QM.ExtHostManagedSockets,si),Ke.set(i.$QM.ExtHostAuthentication,At),Ke.set(i.$QM.ExtHostChatProvider,Ft);const It=Ke.set(i.$QM.ExtHostDecorations,ht.get(P.$blc)),Pt=Ke.set(i.$QM.ExtHostDocumentsAndEditors,ht.get(K.$lP)),pt=Ke.set(i.$QM.ExtHostCommands,ht.get(E.$wP)),St=Ke.set(i.$QM.ExtHostTerminalService,ht.get(nt.$Nkc)),li=Ke.set(i.$QM.ExtHostTerminalShellIntegration,ht.get(ct.$Ulc)),Et=Ke.set(i.$QM.ExtHostDebugService,ht.get(C.$8kc)),hi=Ke.set(i.$QM.ExtHostSearch,ht.get(_.$rlc)),Gt=Ke.set(i.$QM.ExtHostTask,ht.get(tt.$Tlc)),vi=Ke.set(i.$QM.ExtHostOutputService,ht.get(Ce.$Glc)),ii=Ke.set(i.$QM.ExtHostLocalization,ht.get(Ee.$Xkc)),wi=Ke.set(i.$QM.ExtHostUrls,new Ct.$6lc(Ke)),yt=Ke.set(i.$QM.ExtHostDocuments,new j.$0jc(Ke,Pt)),$i=Ke.set(i.$QM.ExtHostDocumentContentProviders,new q.$dlc(Ke,Pt,mt)),ye=Ke.set(i.$QM.ExtHostDocumentSaveParticipant,new A.$elc(mt,yt,Ke.getProxy(i.$PM.MainThreadBulkEdits))),Pe=Ke.set(i.$QM.ExtHostNotebook,new Q.$ulc(Ke,pt,Pt,yt,Zt,hi)),ae=Ke.set(i.$QM.ExtHostNotebookDocuments,new he.$Alc(Pe)),J=Ke.set(i.$QM.ExtHostNotebookEditors,new le.$Blc(mt,Pe)),ke=Ke.set(i.$QM.ExtHostNotebookKernels,new Ne.$Clc(Ke,$t,Pe,pt,mt)),We=Ke.set(i.$QM.ExtHostNotebookRenderers,new de.$Elc(Ke,Pe)),Ze=Ke.set(i.$QM.ExtHostNotebookDocumentSaveParticipant,new Y.$zlc(mt,Pe,Ke.getProxy(i.$PM.MainThreadBulkEdits))),qe=Ke.set(i.$QM.ExtHostEditors,new je.$gkc(Ke,Pt)),ut=Ke.set(i.$QM.ExtHostTreeViews,new Z.$4lc(Ke.getProxy(i.$PM.MainThreadTreeViews),pt,mt)),kt=Ke.set(i.$QM.ExtHostEditorInsets,new h.$hkc(Ke.getProxy(i.$PM.MainThreadEditorInsets),qe,$t.remote)),Ot=Ke.set(i.$QM.ExtHostDiagnostics,new V.$9jc(Ke,mt,ei,Pt)),Bt=Ke.set(i.$QM.ExtHostLanguages,new Te.$xlc(Ke,yt,pt.converter,zt)),at=Ke.set(i.$QM.ExtHostLanguageFeatures,new x.$$jc(Ke,zt,yt,pt,Ot,mt,Tt,jt)),ni=Ke.set(i.$QM.ExtHostFileSystem,new Ie.$glc(Ke,at)),di=Ke.set(i.$QM.ExtHostFileSystemEventService,new pe.$hlc(Ke,mt,Pt)),pi=Ke.set(i.$QM.ExtHostQuickOpen,(0,L.$Klc)(Ke,gt,pt)),Si=Ke.set(i.$QM.ExtHostSCM,new H.$Mlc(Ke,pt,yt,mt)),Ai=Ke.set(i.$QM.ExtHostQuickDiff,new z.$Jlc(Ke,zt)),Mi=Ke.set(i.$QM.ExtHostShare,new Fe.$Nlc(Ke,zt)),Ni=Ke.set(i.$QM.ExtHostComments,(0,f.$ikc)(Ke,pt,yt)),Ti=Ke.set(i.$QM.ExtHostProgress,new ze.$Ilc(Ke.getProxy(i.$PM.MainThreadProgress))),cn=Ke.set(i.$QM.ExtHostLabelService,new U.$wlc(Ke)),Fi=Ke.set(i.$QM.ExtHostTheming,new st.$1lc(Ke)),Oi=Ke.set(i.$QM.ExtHostTimeline,new X.$3lc(Ke,pt)),yi=Ke.set(i.$QM.ExtHostWebviews,new Ut.$wkc(Ke,$t.remote,gt,mt,Tt)),Ii=Ke.set(i.$QM.ExtHostWebviewPanels,new Yt.$zkc(Ke,yi,gt)),Gi=Ke.set(i.$QM.ExtHostCustomEditors,new y.$Akc(Ke,yt,Vt,yi,Ii)),Ki=Ke.set(i.$QM.ExtHostWebviewViews,new Jt.$7lc(Ke,yi)),bi=Ke.set(i.$QM.ExtHostTesting,new ft.$Wlc(Ke,mt,pt,Pt)),Ji=Ke.set(i.$QM.ExtHostUriOpeners,new ot.$5lc(Ke)),Qi=Ke.set(i.$QM.ExtHostProfileContentHandlers,new Me.$Hlc(Ke));Ke.set(i.$QM.ExtHostInteractive,new ne.$vlc(Ke,Pe,Pt,pt,mt));const un=Ke.set(i.$QM.ExtHostInlineChat,new Le.$ilc(Ke,pt,yt,mt)),Li=Ke.set(i.$QM.ExtHostChatAgents2,new m.$dkc(Ke,mt,pt)),zi=Ke.set(i.$QM.ExtHostChatVariables,new v.$ekc(Ke)),Pi=Ke.set(i.$QM.ExtHostAiRelatedInformation,new a.$2jc(Ke)),ln=Ke.set(i.$QM.ExtHostAiEmbeddingVector,new ce.$flc(Ke)),Zi=Ke.set(i.$QM.ExtHostStatusBar,new Qe.$Qlc(Ke,pt.converter)),Xi=Ke.set(i.$QM.ExtHostSpeech,new Be.$Olc(Ke)),hn=Object.values(i.$QM);Ke.assertRegistered(hn);const Ui=new c.$ckc(Ke,Pt),Yi=new $.$fkc(Ke),Ci=new fe.$ylc(Ke,mt),ji=new W.$clc(Ke);return l.$_jc.register(pt),function(Ue,ai,Bi){function xe(ee){return(oe,Oe,rt)=>{const wt=ee(Mt=>{try{oe.call(Oe,Mt)}catch(Di){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),jt.onExtensionError(Ue.identifier,Di)}});return rt?.push(wt),wt}}const vt=function(){let ee=!Ue.isUnderDevelopment;function oe(){ee||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")oe();else{const wt=rt;typeof wt.scheme>"u"&&oe(),typeof wt.exclusive=="boolean"&&(0,Xe.$yG)(Ue,"documentFiltersExclusive")}return rt}}(),dn={getSession(ee,oe,Oe){return typeof Oe?.forceNewSession=="object"&&Oe.forceNewSession.learnMore&&(0,Xe.$yG)(Ue,"authLearnMore"),At.getSession(Ue,ee,oe,Oe)},getSessions(ee,oe){return(0,Xe.$yG)(Ue,"authGetSessions"),At.getSessions(Ue,ee,oe)},async hasSession(ee,oe){return(0,Xe.$yG)(Ue,"authSession"),!!await At.getSession(Ue,ee,oe,{silent:!0})},get onDidChangeSessions(){return xe(At.onDidChangeSessions)},registerAuthenticationProvider(ee,oe,Oe,rt){return At.registerAuthenticationProvider(ee,oe,Oe,rt)}},ci={registerCommand(ee,oe,Oe){return pt.registerCommand(!0,ee,oe,Oe,void 0,Ue)},registerTextEditorCommand(ee,oe,Oe){return pt.registerCommand(!0,ee,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){mt.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(Mt=>{oe.apply(Oe,[wt,Mt,...rt])}).then(Mt=>{Mt||mt.warn("Edits from command "+ee+" were not applied.")},Mt=>{mt.warn("An error occurred while running command "+ee,Mt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ee,oe,Oe)=>((0,Xe.$yG)(Ue,"diffCommand"),pt.registerCommand(!0,ee,async(...rt)=>{const wt=Pt.activeEditor(!0);if(!wt){mt.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Mt=await qe.getDiffInformation(wt.id);oe.apply(Oe,[Mt,...rt])},void 0,void 0,Ue)),executeCommand(ee,...oe){return pt.executeCommand(ee,...oe)},getCommands(ee=!1){return pt.getCommands(ee)}},ki={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return xe(St.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return xe(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),xe(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$tP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,oe){return it.$sP.validateSender(ee),jt.instantiateLogger(Ue,ee,oe)},openExternal(ee,oe){return Nt.openUri(ee,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===$t.environment.appUriScheme)return wi.createAppUri(ee);try{return await Nt.asExternalUri(ee,{allowTunneling:!!$t.remote.authority})}catch(oe){if((0,M.$zg)(ee,M.Schemas.http)||(0,M.$zg)(ee,M.Schemas.https))return ee;throw oe}},get remoteName(){return(0,o.$Cm)($t.remote.authority)},get remoteAuthority(){return(0,Xe.$yG)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return xe(mt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$yG)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,Xe.$yG)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(ki);const xi={createTestController(ee,oe,Oe){return bi.createTestController(Ue,ee,oe,Oe)},createTestObserver(){return(0,Xe.$yG)(Ue,"testObserver"),bi.createTestObserver()},runTests(ee){return(0,Xe.$yG)(Ue,"testObserver"),bi.runTests(ee)},get onDidChangeTestResults(){return(0,Xe.$yG)(Ue,"testObserver"),xe(bi.onResultsChanged)},get testResults(){return(0,Xe.$yG)(Ue,"testObserver"),bi.results}},Ei=$t.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,_i={getExtension(ee,oe){(0,Xe.$xG)(Ue,"extensionsAny")||(oe=!1);const Oe=ai.mine.getExtensionDescription(ee);if(Oe)return new ve.$4kc(Lt,Ue.identifier,Oe,Ei,!1);if(oe){const rt=ai.all.getExtensionDescription(ee);if(rt)return new ve.$4kc(Lt,Ue.identifier,rt,Ei,!0)}},get all(){const ee=[];for(const oe of ai.mine.getAllExtensionDescriptions())ee.push(new ve.$4kc(Lt,Ue.identifier,oe,Ei,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.$yG)(Ue,"extensionsAny");const ee=new w.$Mm(ai.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),oe=[];for(const Oe of ai.all.getAllExtensionDescriptions()){const rt=!ee.has(Oe.identifier);oe.push(new ve.$4kc(Lt,Ue.identifier,Oe,Ei,rt))}return oe},get onDidChange(){return(0,Xe.$xG)(Ue,"extensionsAny")?xe(R.Event.any(ai.mine.onDidChange,ai.all.onDidChange)):xe(ai.mine.onDidChange)}},en={createDiagnosticCollection(ee){return Ot.createDiagnosticCollection(Ue.identifier,ee)},get onDidChangeDiagnostics(){return xe(Ot.onDidChangeDiagnostics)},getDiagnostics:ee=>Ot.getDiagnostics(ee),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(ee,oe){return Bt.changeLanguage(ee.uri,oe)},match(ee,oe){const Oe=He.LanguageSelector.from(ee);let rt;return(0,T.$Vt)(Oe)&&(rt=Pe.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Mt=>Mt.document===oe))?.apiNotebook),(0,T.$Ut)(Oe,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(ee,oe,Oe){return at.registerCodeActionProvider(Ue,vt(ee),oe,Oe)},registerDocumentPasteEditProvider(ee,oe,Oe){return(0,Xe.$yG)(Ue,"documentPaste"),at.registerDocumentPasteEditProvider(Ue,vt(ee),oe,Oe)},registerCodeLensProvider(ee,oe){return at.registerCodeLensProvider(Ue,vt(ee),oe)},registerDefinitionProvider(ee,oe){return at.registerDefinitionProvider(Ue,vt(ee),oe)},registerDeclarationProvider(ee,oe){return at.registerDeclarationProvider(Ue,vt(ee),oe)},registerImplementationProvider(ee,oe){return at.registerImplementationProvider(Ue,vt(ee),oe)},registerTypeDefinitionProvider(ee,oe){return at.registerTypeDefinitionProvider(Ue,vt(ee),oe)},registerHoverProvider(ee,oe){return at.registerHoverProvider(Ue,vt(ee),oe,Ue.identifier)},registerEvaluatableExpressionProvider(ee,oe){return at.registerEvaluatableExpressionProvider(Ue,vt(ee),oe,Ue.identifier)},registerInlineValuesProvider(ee,oe){return at.registerInlineValuesProvider(Ue,vt(ee),oe,Ue.identifier)},registerDocumentHighlightProvider(ee,oe){return at.registerDocumentHighlightProvider(Ue,vt(ee),oe)},registerMultiDocumentHighlightProvider(ee,oe){return at.registerMultiDocumentHighlightProvider(Ue,vt(ee),oe)},registerLinkedEditingRangeProvider(ee,oe){return at.registerLinkedEditingRangeProvider(Ue,vt(ee),oe)},registerReferenceProvider(ee,oe){return at.registerReferenceProvider(Ue,vt(ee),oe)},registerRenameProvider(ee,oe){return at.registerRenameProvider(Ue,vt(ee),oe)},registerNewSymbolNamesProvider(ee,oe){return(0,Xe.$yG)(Ue,"newSymbolNamesProvider"),at.registerNewSymbolNamesProvider(Ue,vt(ee),oe)},registerDocumentSymbolProvider(ee,oe,Oe){return at.registerDocumentSymbolProvider(Ue,vt(ee),oe,Oe)},registerWorkspaceSymbolProvider(ee){return at.registerWorkspaceSymbolProvider(Ue,ee)},registerDocumentFormattingEditProvider(ee,oe){return at.registerDocumentFormattingEditProvider(Ue,vt(ee),oe)},registerDocumentRangeFormattingEditProvider(ee,oe){return at.registerDocumentRangeFormattingEditProvider(Ue,vt(ee),oe)},registerOnTypeFormattingEditProvider(ee,oe,Oe,...rt){return at.registerOnTypeFormattingEditProvider(Ue,vt(ee),oe,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(ee,oe,Oe){return at.registerDocumentSemanticTokensProvider(Ue,vt(ee),oe,Oe)},registerDocumentRangeSemanticTokensProvider(ee,oe,Oe){return at.registerDocumentRangeSemanticTokensProvider(Ue,vt(ee),oe,Oe)},registerSignatureHelpProvider(ee,oe,Oe,...rt){return typeof Oe=="object"?at.registerSignatureHelpProvider(Ue,vt(ee),oe,Oe):at.registerSignatureHelpProvider(Ue,vt(ee),oe,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(ee,oe,...Oe){return at.registerCompletionItemProvider(Ue,vt(ee),oe,Oe)},registerInlineCompletionItemProvider(ee,oe,Oe){return oe.handleDidShowCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),Oe&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(Ue,vt(ee),oe,Oe)},registerInlineEditProvider(ee,oe){return(0,Xe.$yG)(Ue,"inlineEdit"),at.registerInlineEditProvider(Ue,vt(ee),oe)},registerDocumentLinkProvider(ee,oe){return at.registerDocumentLinkProvider(Ue,vt(ee),oe)},registerColorProvider(ee,oe){return at.registerColorProvider(Ue,vt(ee),oe)},registerFoldingRangeProvider(ee,oe){return at.registerFoldingRangeProvider(Ue,vt(ee),oe)},registerSelectionRangeProvider(ee,oe){return at.registerSelectionRangeProvider(Ue,ee,oe)},registerCallHierarchyProvider(ee,oe){return at.registerCallHierarchyProvider(Ue,ee,oe)},registerTypeHierarchyProvider(ee,oe){return at.registerTypeHierarchyProvider(Ue,ee,oe)},setLanguageConfiguration:(ee,oe)=>at.setLanguageConfiguration(Ue,ee,oe),getTokenInformationAtPosition(ee,oe){return(0,Xe.$yG)(Ue,"tokenInformation"),Bt.tokenAtPosition(ee,oe)},registerInlayHintsProvider(ee,oe){return at.registerInlayHintsProvider(Ue,ee,oe)},createLanguageStatusItem(ee,oe){return Bt.createLanguageStatusItem(Ue,ee,oe)},registerDocumentDropEditProvider(ee,oe,Oe){return at.registerDocumentOnDropEditProvider(Ue,ee,oe,(0,Xe.$xG)(Ue,"documentPaste")?Oe:void 0)}},fn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(ee,oe,Oe){g.URI.isUri(ee)&&ee.scheme===M.Schemas.vscodeRemote&&!ee.authority&&Tt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(g.URI.isUri(ee)?Promise.resolve(Wi.openTextDocument(ee)):Promise.resolve(ee));return qe.showTextDocument(rt,oe,Oe)},createTextEditorDecorationType(ee){return qe.createTextEditorDecorationType(Ue,ee)},onDidChangeActiveTextEditor(ee,oe,Oe){return xe(qe.onDidChangeActiveTextEditor)(ee,oe,Oe)},onDidChangeVisibleTextEditors(ee,oe,Oe){return xe(qe.onDidChangeVisibleTextEditors)(ee,oe,Oe)},onDidChangeTextEditorSelection(ee,oe,Oe){return xe(qe.onDidChangeTextEditorSelection)(ee,oe,Oe)},onDidChangeTextEditorOptions(ee,oe,Oe){return xe(qe.onDidChangeTextEditorOptions)(ee,oe,Oe)},onDidChangeTextEditorVisibleRanges(ee,oe,Oe){return xe(qe.onDidChangeTextEditorVisibleRanges)(ee,oe,Oe)},onDidChangeTextEditorViewColumn(ee,oe,Oe){return xe(qe.onDidChangeTextEditorViewColumn)(ee,oe,Oe)},onDidCloseTerminal(ee,oe,Oe){return xe(St.onDidCloseTerminal)(ee,oe,Oe)},onDidOpenTerminal(ee,oe,Oe){return xe(St.onDidOpenTerminal)(ee,oe,Oe)},onDidChangeActiveTerminal(ee,oe,Oe){return xe(St.onDidChangeActiveTerminal)(ee,oe,Oe)},onDidChangeTerminalDimensions(ee,oe,Oe){return(0,Xe.$yG)(Ue,"terminalDimensions"),xe(St.onDidChangeTerminalDimensions)(ee,oe,Oe)},onDidChangeTerminalState(ee,oe,Oe){return xe(St.onDidChangeTerminalState)(ee,oe,Oe)},onDidWriteTerminalData(ee,oe,Oe){return(0,Xe.$yG)(Ue,"terminalDataWriteEvent"),xe(St.onDidWriteTerminalData)(ee,oe,Oe)},onDidExecuteTerminalCommand(ee,oe,Oe){return(0,Xe.$yG)(Ue,"terminalExecuteCommandEvent"),xe(St.onDidExecuteTerminalCommand)(ee,oe,Oe)},onDidChangeTerminalShellIntegration(ee,oe,Oe){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidChangeTerminalShellIntegration)(ee,oe,Oe)},onDidStartTerminalShellExecution(ee,oe,Oe){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidStartTerminalShellExecution)(ee,oe,Oe)},onDidEndTerminalShellExecution(ee,oe,Oe){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),xe(li.onDidEndTerminalShellExecution)(ee,oe,Oe)},get state(){return Nt.getState(Ue)},onDidChangeWindowState(ee,oe,Oe){return xe(Nt.onDidChangeWindowState)(ee,oe,Oe)},showInformationMessage(ee,...oe){return Ci.showMessage(Ue,p.default.Info,ee,oe[0],oe.slice(1))},showWarningMessage(ee,...oe){return Ci.showMessage(Ue,p.default.Warning,ee,oe[0],oe.slice(1))},showErrorMessage(ee,...oe){return Ci.showMessage(Ue,p.default.Error,ee,oe[0],oe.slice(1))},showQuickPick(ee,oe,Oe){return pi.showQuickPick(Ue,ee,oe,Oe)},showWorkspaceFolderPick(ee){return pi.showWorkspaceFolderPick(ee)},showInputBox(ee,oe){return pi.showInput(ee,oe)},showOpenDialog(ee){return ji.showOpenDialog(Ue,ee)},showSaveDialog(ee){return ji.showSaveDialog(ee)},createStatusBarItem(ee,oe,Oe){let rt,wt,Mt;return typeof ee=="string"?(rt=ee,wt=oe,Mt=Oe):(wt=ee,Mt=oe),Zi.createStatusBarEntry(Ue,rt,wt,Mt)},setStatusBarMessage(ee,oe){return Zi.setStatusBarMessage(ee,oe)},withScmProgress(ee){return Tt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ti.withProgress(Ue,{location:we.ProgressLocation.SourceControl},(oe,Oe)=>ee({report(rt){}}))},withProgress(ee,oe){return Ti.withProgress(Ue,ee,oe)},createOutputChannel(ee,oe){return vi.createOutputChannel(ee,oe,Ue)},createWebviewPanel(ee,oe,Oe,rt){return Ii.createWebviewPanel(Ue,ee,oe,Oe,rt)},createWebviewTextEditorInset(ee,oe,Oe,rt){return(0,Xe.$yG)(Ue,"editorInsets"),kt.createWebviewEditorInset(ee,oe,Oe,rt,Ue)},createTerminal(ee,oe,Oe){return typeof ee=="object"?"pty"in ee?St.createExtensionTerminal(ee):St.createTerminalFromOptions(ee):St.createTerminal(ee,oe,Oe)},registerTerminalLinkProvider(ee){return St.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,oe){return St.registerProfileProvider(Ue,ee,oe)},registerTerminalQuickFixProvider(ee,oe){return(0,Xe.$yG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(ee,Ue.identifier.value,oe)},registerTreeDataProvider(ee,oe){return ut.registerTreeDataProvider(ee,oe,Ue)},createTreeView(ee,oe){return ut.createTreeView(ee,oe,Ue)},registerWebviewPanelSerializer:(ee,oe)=>Ii.registerWebviewPanelSerializer(Ue,ee,oe),registerCustomEditorProvider:(ee,oe,Oe={})=>Gi.registerCustomEditorProvider(Ue,ee,oe,Oe),registerFileDecorationProvider(ee){return It.registerFileDecorationProvider(ee,Ue)},registerUriHandler(ee){return wi.registerUriHandler(Ue,ee)},createQuickPick(){return pi.createQuickPick(Ue)},createInputBox(){return pi.createInputBox(Ue)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(ee,oe,Oe){return xe(Fi.onDidChangeActiveColorTheme)(ee,oe,Oe)},registerWebviewViewProvider(ee,oe,Oe){return Ki.registerWebviewViewProvider(Ue,ee,oe,Oe?.webviewOptions)},get activeNotebookEditor(){return Pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,oe,Oe){return xe(Pe.onDidChangeActiveNotebookEditor)(ee,oe,Oe)},get visibleNotebookEditors(){return Pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return xe(Pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,oe,Oe){return xe(J.onDidChangeNotebookEditorSelection)(ee,oe,Oe)},onDidChangeNotebookEditorVisibleRanges(ee,oe,Oe){return xe(J.onDidChangeNotebookEditorVisibleRanges)(ee,oe,Oe)},showNotebookDocument(ee,oe){return Pe.showNotebookDocument(ee,oe)},registerExternalUriOpener(ee,oe,Oe){return(0,Xe.$yG)(Ue,"externalUriOpener"),Ji.registerExternalUriOpener(Ue.identifier,ee,oe,Oe)},registerProfileContentHandler(ee,oe){return(0,Xe.$yG)(Ue,"profileContentHandlers"),Qi.registerProfileContentHandler(Ue,ee,oe)},registerQuickDiffProvider(ee,oe,Oe,rt){return(0,Xe.$yG)(Ue,"quickDiffProvider"),Ai.registerQuickDiffProvider(vt(ee),oe,Oe,rt)},get tabGroups(){return Ht.tabGroups},registerShareProvider(ee,oe){return(0,Xe.$yG)(Ue,"shareProvider"),Mi.registerShareProvider(vt(ee),oe)}},Wi={get rootPath(){return Tt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(ee){throw new N.$9("rootPath")},getWorkspaceFolder(ee){return gt.getWorkspaceFolder(ee)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(ee){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(ee){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(ee,oe,...Oe)=>gt.updateWorkspaceFolders(Ue,ee,oe||0,...Oe),onDidChangeWorkspaceFolders:function(ee,oe,Oe){return xe(gt.onDidChangeWorkspace)(ee,oe,Oe)},asRelativePath:(ee,oe)=>gt.getRelativePath(ee,oe),findFiles:(ee,oe,Oe,rt)=>gt.findFiles(ee,oe,Oe,Ue.identifier,rt),findFiles2:(ee,oe,Oe)=>((0,Xe.$yG)(Ue,"findFiles2"),gt.findFiles2(ee,oe,Ue.identifier,Oe)),findTextInFiles:(ee,oe,Oe,rt)=>{(0,Xe.$yG)(Ue,"findTextInFiles");let wt,Mt;return typeof oe=="object"?(wt=oe,Mt=Oe):(wt={},Mt=oe,rt=Oe),gt.findTextInFiles(ee,wt||{},Mt,Ue.identifier,rt)},save:ee=>gt.save(ee),saveAs:ee=>gt.saveAs(ee),saveAll:ee=>gt.saveAll(ee),applyEdit(ee,oe){return Ui.applyWorkspaceEdit(ee,Ue,oe)},createFileSystemWatcher:(ee,oe,Oe,rt)=>{let wt;return typeof oe=="boolean"?wt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Xe.$yG)(Ue,"createFileSystemWatcher"),wt={...oe,correlate:!0}),di.createFileSystemWatcher(gt,Ue,ee,wt)},get textDocuments(){return yt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new N.$9("textDocuments")},openTextDocument(ee){let oe;const Oe=ee;if(typeof ee=="string")oe=Promise.resolve(g.URI.file(ee));else if(g.URI.isUri(ee))oe=Promise.resolve(ee);else if(!Oe||typeof Oe=="object")oe=yt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&Tt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),yt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(ee,oe,Oe)=>xe(yt.onDidAddDocument)(ee,oe,Oe),onDidCloseTextDocument:(ee,oe,Oe)=>xe(yt.onDidRemoveDocument)(ee,oe,Oe),onDidChangeTextDocument:(ee,oe,Oe)=>xe(yt.onDidChangeDocument)(ee,oe,Oe),onDidSaveTextDocument:(ee,oe,Oe)=>xe(yt.onDidSaveDocument)(ee,oe,Oe),onWillSaveTextDocument:(ee,oe,Oe)=>xe(ye.getOnWillSaveTextDocumentEvent(Ue))(ee,oe,Oe),get notebookDocuments(){return Pe.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,oe){let Oe;if(g.URI.isUri(ee))Oe=ee,await Pe.openNotebookDocument(ee);else if(typeof ee=="string")Oe=g.URI.revive(await Pe.createNotebookDocument({viewType:ee,content:oe}));else throw new Error("Invalid arguments");return Pe.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ee,oe,Oe){return xe(ae.onDidSaveNotebookDocument)(ee,oe,Oe)},onDidChangeNotebookDocument(ee,oe,Oe){return xe(ae.onDidChangeNotebookDocument)(ee,oe,Oe)},onWillSaveNotebookDocument(ee,oe,Oe){return xe(Ze.getOnWillSaveNotebookDocumentEvent(Ue))(ee,oe,Oe)},get onDidOpenNotebookDocument(){return xe(Pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return xe(Pe.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,oe,Oe,rt){return Pe.registerNotebookSerializer(Ue,ee,oe,Oe,(0,Xe.$xG)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ee,oe,Oe)=>xe(Bi.onDidChangeConfiguration)(ee,oe,Oe),getConfiguration(ee,oe){return oe=arguments.length===1?void 0:oe,Bi.getConfiguration(ee,oe,Ue)},registerTextDocumentContentProvider(ee,oe){return $i.registerTextDocumentContentProvider(ee,oe)},registerTaskProvider:(ee,oe)=>(Tt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Ue,ee,oe)),registerFileSystemProvider(ee,oe,Oe){return(0,F.$Rc)(ni.registerFileSystemProvider(Ue,ee,oe,Oe),Zt.addFileSystemProvider(ee,oe,Oe))},get fs(){return Zt.value},registerFileSearchProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(ee,oe)),registerTextSearchProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(ee,oe)),registerAITextSearchProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"aiTextSearchProvider"),(0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(ee,oe)),registerRemoteAuthorityResolver:(ee,oe)=>((0,Xe.$yG)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(ee,oe)),registerResourceLabelFormatter:ee=>((0,Xe.$yG)(Ue,"resolvers"),cn.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.$yG)(Ue,"resolvers"),Lt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,oe,Oe)=>xe(di.onDidCreateFile)(ee,oe,Oe),onDidDeleteFiles:(ee,oe,Oe)=>xe(di.onDidDeleteFile)(ee,oe,Oe),onDidRenameFiles:(ee,oe,Oe)=>xe(di.onDidRenameFile)(ee,oe,Oe),onWillCreateFiles:(ee,oe,Oe)=>xe(di.getOnWillCreateFileEvent(Ue))(ee,oe,Oe),onWillDeleteFiles:(ee,oe,Oe)=>xe(di.getOnWillDeleteFileEvent(Ue))(ee,oe,Oe),onWillRenameFiles:(ee,oe,Oe)=>xe(di.getOnWillRenameFileEvent(Ue))(ee,oe,Oe),openTunnel:ee=>((0,Xe.$yG)(Ue,"tunnels"),Rt.openTunnel(Ue,ee).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$yG)(Ue,"tunnels"),Rt.getTunnels()},onDidChangeTunnels:(ee,oe,Oe)=>((0,Xe.$yG)(Ue,"tunnels"),xe(Rt.onDidChangeTunnels)(ee,oe,Oe)),registerPortAttributesProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"portsAttributes"),Rt.registerPortsAttributesProvider(ee,oe)),registerTunnelProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"tunnelFactory"),Rt.registerTunnelProvider(ee,oe)),registerTimelineProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"timeline"),Oi.registerTimelineProvider(ee,oe,Ue.identifier,pt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:ee=>((0,Xe.$yG)(Ue,"workspaceTrust"),gt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,oe,Oe)=>xe(gt.onDidGrantWorkspaceTrust)(ee,oe,Oe),registerEditSessionIdentityProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(ee,oe)),onWillCreateEditSessionIdentity:(ee,oe,Oe)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),xe(gt.getOnWillCreateEditSessionIdentityEvent(Ue))(ee,oe,Oe)),registerCanonicalUriProvider:(ee,oe)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),gt.registerCanonicalUriProvider(ee,oe)),getCanonicalUri:(ee,oe,Oe)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),gt.provideCanonicalUri(ee,oe,Oe))},tn={get inputBox(){return Tt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Ue)},createSourceControl(ee,oe,Oe){return Si.createSourceControl(Ue,ee,oe,Oe)}},gn={createCommentController(ee,oe){return Ni.createCommentController(Ue,ee,oe)}},mn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,Xe.$xG)(Ue,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(ee,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),Et.registerDebugVisualizationProvider(Ue,ee,oe)},registerDebugVisualizationTreeProvider(ee,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),Et.registerDebugVisualizationTree(Ue,ee,oe)},onDidStartDebugSession(ee,oe,Oe){return xe(Et.onDidStartDebugSession)(ee,oe,Oe)},onDidTerminateDebugSession(ee,oe,Oe){return xe(Et.onDidTerminateDebugSession)(ee,oe,Oe)},onDidChangeActiveDebugSession(ee,oe,Oe){return xe(Et.onDidChangeActiveDebugSession)(ee,oe,Oe)},onDidReceiveDebugSessionCustomEvent(ee,oe,Oe){return xe(Et.onDidReceiveDebugSessionCustomEvent)(ee,oe,Oe)},onDidChangeBreakpoints(ee,oe,Oe){return xe(Et.onDidChangeBreakpoints)(ee,oe,Oe)},onDidChangeActiveStackItem(ee,oe,Oe){return(0,Xe.$yG)(Ue,"debugFocus"),xe(Et.onDidChangeActiveStackItem)(ee,oe,Oe)},registerDebugConfigurationProvider(ee,oe,Oe){return Et.registerDebugConfigurationProvider(ee,oe,Oe||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,oe){return Et.registerDebugAdapterDescriptorFactory(Ue,ee,oe)},registerDebugAdapterTrackerFactory(ee,oe){return Et.registerDebugAdapterTrackerFactory(ee,oe)},startDebugging(ee,oe,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Et.startDebugging(ee,oe,{parentSession:Oe}):Et.startDebugging(ee,oe,Oe||{})},stopDebugging(ee){return Et.stopDebugging(ee)},addBreakpoints(ee){return Et.addBreakpoints(ee)},removeBreakpoints(ee){return Et.removeBreakpoints(ee)},asDebugSourceUri(ee,oe){return Et.asDebugSourceUri(ee,oe)}},nn={registerTaskProvider:(ee,oe)=>Gt.registerTaskProvider(Ue,ee,oe),fetchTasks:ee=>Gt.fetchTasks(ee),executeTask:ee=>Gt.executeTask(Ue,ee),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(ee,oe,Oe)=>xe(Gt.onDidStartTask)(ee,oe,Oe),onDidEndTask:(ee,oe,Oe)=>xe(Gt.onDidEndTask)(ee,oe,Oe),onDidStartTaskProcess:(ee,oe,Oe)=>xe(Gt.onDidStartTaskProcess)(ee,oe,Oe),onDidEndTaskProcess:(ee,oe,Oe)=>xe(Gt.onDidEndTaskProcess)(ee,oe,Oe)},Vi={createNotebookController(ee,oe,Oe,rt,wt){return ke.createNotebookController(Ue,ee,oe,Oe,rt,(0,Xe.$xG)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,oe)=>Pe.registerNotebookCellStatusBarItemProvider(Ue,ee,oe),createRendererMessaging(ee){return We.createRendererMessaging(Ue,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.$yG)(Ue,"notebookKernelSource"),ke.createNotebookControllerDetectionTask(Ue,ee)},registerKernelSourceActionProvider(ee,oe){return(0,Xe.$yG)(Ue,"notebookKernelSource"),ke.registerKernelSourceActionProvider(Ue,ee,oe)},onDidChangeNotebookCellExecutionState(ee,oe,Oe){return(0,Xe.$yG)(Ue,"notebookCellExecutionState"),xe(ke.onDidChangeNotebookCellExecutionState)(ee,oe,Oe)}},rn={t(...ee){if(typeof ee[0]=="string"){const oe=ee.shift(),Oe=!ee||typeof ee[0]!="object"?ee:ee[0];return ii.getMessage(Ue.identifier.value,{message:oe,args:Oe})}return ii.getMessage(Ue.identifier.value,ee[0])},get bundle(){return ii.getBundle(Ue.identifier.value)},get uri(){return ii.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(ee,oe){return(0,Xe.$yG)(Ue,"interactive"),un.registerProvider(Ue,ee,oe)},transferActiveChat(ee){return(0,Xe.$yG)(Ue,"interactive"),Li.transferActiveChat(ee)}},on={getRelatedInformation(ee,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Pi.getRelatedInformation(Ue,ee,oe)},registerRelatedInformationProvider(ee,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(Ue,ee,oe)},registerEmbeddingVectorProvider(ee,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(Ue,ee,oe)}},$n={registerChatResponseProvider(ee,oe,Oe){return(0,Xe.$yG)(Ue,"chatProvider"),Ft.registerLanguageModel(Ue,ee,oe,Oe)},registerChatVariableResolver(ee,oe,Oe){return(0,Xe.$yG)(Ue,"chatVariableResolver"),zi.registerVariableResolver(Ue,ee,oe,Oe)},registerMappedEditsProvider(ee,oe){return(0,Xe.$yG)(Ue,"mappedEditsProvider"),at.registerMappedEditsProvider(Ue,ee,oe)},createChatParticipant(ee,oe){return(0,Xe.$yG)(Ue,"chatParticipant"),Li.createChatAgent(Ue,ee,oe)},createDynamicChatParticipant(ee,oe,Oe,rt){return(0,Xe.$yG)(Ue,"chatParticipantAdditions"),Li.createDynamicChatAgent(Ue,ee,oe,Oe,rt)}},pn={get languageModels(){return(0,Xe.$yG)(Ue,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:(ee,oe,Oe)=>((0,Xe.$yG)(Ue,"languageModels"),Ft.onDidChangeProviders(ee,oe,Oe)),sendChatRequest(ee,oe,Oe,rt){return(0,Xe.$yG)(Ue,"languageModels"),Ft.sendChatRequest(Ue,ee,oe,Oe,rt)}},an={registerSpeechProvider(ee,oe){return(0,Xe.$yG)(Ue,"speech"),Xi.registerProvider(Ue.identifier,ee,oe)}};return{version:$t.version,ai:on,authentication:dn,commands:ci,comments:gn,chat:$n,debug:mn,env:ki,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Vi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Wi,Breakpoint:we.$RN,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$MO,CallHierarchyIncomingCall:we.$dN,CallHierarchyItem:we.$cN,CallHierarchyOutgoingCall:we.$eN,CancellationError:N.$5,CancellationTokenSource:I.$me,CandidatePortSource:i.CandidatePortSource,CodeAction:we.$_M,CodeActionKind:we.$aN,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$fN,Color:we.$sN,ColorInformation:we.$tN,ColorPresentation:we.$uN,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$mN,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$nN,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$CN,DebugAdapterExecutable:we.$VN,DebugAdapterInlineImplementation:we.$YN,DebugAdapterNamedPipeServer:we.$XN,DebugAdapterServer:we.$WN,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$cO,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$6M,DiagnosticRelatedInformation:we.$5M,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$RM,DocumentHighlight:we.$8M,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$9M,DocumentLink:we.$rN,DocumentSymbol:we.$$M,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$2N,InlineValueText:we.$3N,InlineValueVariableLookup:we.$4N,InlineValueEvaluatableExpression:we.$5N,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:R.$be,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$eO,FileDecoration2:we.$eO,FileSystemError:we.$8N,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:we.$9N,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$TN,InlineCompletionItem:we.$oN,InlineCompletionList:we.$pN,Hover:we.$7M,IndentAction:k.IndentAction,Location:we.$4M,MarkdownString:we.$gN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:we.$hN,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$SM,ProcessExecution:we.$AN,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$dO,Range:we.$TM,RelativePattern:we.$PN,Selection:we.$UM,SelectionRange:we.$bN,SemanticTokens:we.$_N,SemanticTokensBuilder:we.$$N,SemanticTokensEdit:we.$aO,SemanticTokensEdits:we.$bO,SemanticTokensLegend:we.$0N,ShellExecution:we.$BN,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$jN,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$iN,SnippetString:we.$3M,SourceBreakpoint:we.$SN,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$0M,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$DN,TaskGroup:we.$zN,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$vN,TerminalQuickFixTerminalCommand:we.$xN,TerminalQuickFixOpener:we.$wN,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$yN,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$YM,SnippetTextEdit:we.$1M,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$ON,ThemeIcon:we.$NN,TreeItem:we.$EN,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$AO,UIKind:Qt.UIKind,Uri:g.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$2M,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$KN,DocumentDropOrPasteEditKind:we.$LN,DocumentPasteEdit:we.$MN,InlayHint:we.$lN,InlayHintLabelPart:we.$kN,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$XM,ResolvedAuthority:we.$VM,ManagedResolvedAuthority:we.$WM,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$oO,NotebookRange:we.$gO,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$hO,NotebookData:we.$iO,NotebookRendererScript:we.$mO,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$kO,NotebookCellOutputItem:we.$jO,NotebookCellStatusBarItem:we.$lO,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$ZM,NotebookKernelSourceAction:we.$nO,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$qO,LinkedEditingRanges:we.$pO,TestResultState:we.TestResultState,TestRunRequest:we.$rO,TestMessage:we.$sO,TestTag:we.$tO,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:ri.TextSearchCompleteMessageType,DataTransfer:we.$JN,DataTransferItem:we.$FN,TestCoverageCount:we.$uO,FileCoverage:we.$wO,StatementCoverage:we.$xO,BranchCoverage:we.$yO,DeclarationCoverage:we.$zO,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$BO,TabInputTextDiff:we.$CO,TabInputTextMerge:we.$DO,TabInputCustom:we.$EO,TabInputNotebook:we.$GO,TabInputNotebookDiff:we.$HO,TabInputWebview:we.$FO,TabInputTerminal:we.$IO,TabInputInteractiveWindow:we.$JO,TabInputChat:we.$KO,TabInputTextMultiDiff:we.$LO,TelemetryTrustedValue:n.$_o,LogLevel:s.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,StackFrame:we.$ZN,Thread:we.$1N,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$NO,ChatResponseFileTreePart:we.$OO,ChatResponseAnchorPart:we.$PO,ChatResponseProgressPart:we.$QO,ChatResponseReferencePart:we.$SO,ChatResponseTextEditPart:we.$TO,ChatResponseCommandButtonPart:we.$RO,ChatRequestTurn:we.$UO,ChatResponseTurn:we.$VO,ChatLocation:we.ChatLocation,LanguageModelChatSystemMessage:we.$WO,LanguageModelChatUserMessage:we.$XO,LanguageModelChatAssistantMessage:we.$YO,LanguageModelSystemMessage:we.$WO,LanguageModelUserMessage:we.$XO,LanguageModelAssistantMessage:we.$YO,LanguageModelError:we.$ZO,NewSymbolName:we.$7N,NewSymbolNameTag:we.NewSymbolNameTag,InlineEdit:we.$1O,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Re[298],Ae([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,44,81,62,66,237,13,120,79,80,84,88,114]),function(ge,e,I,N,R,F,M,p,g,D,T,k,u,w,d,s,o,n,r,i,a,l,t,b,c,m,v,$,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$os)(m.$Xkc,m.$Wkc,1),(0,I.$os)(b.$Xj,t.$$lc,1),(0,I.$os)(s.$3jc,s.$4jc,1),(0,I.$os)(p.$wP,p.$vP,0),(0,I.$os)($.$akc,$.$bkc,0),(0,I.$os)(h.$Rkc,h.$Skc,0),(0,I.$os)(M.$pkc,M.$nkc,0),(0,I.$os)(n.$rkc,n.$qkc,0),(0,I.$os)(k.$8kc,k.$_kc,0),(0,I.$os)(F.$blc,F.$alc,0),(0,I.$os)(g.$lP,g.$kP,0),(0,I.$os)(v.$Ykc,v.$Zkc,0),(0,I.$os)(r.$7jc,r.$6jc,0),(0,I.$os)(N.$Glc,N.$Flc,1),(0,I.$os)(u.$rlc,u.$slc,0),(0,I.$os)(w.$Kkc,w.$Jkc,0),(0,I.$os)(T.$Tlc,T.$Slc,0),(0,I.$os)(D.$Nkc,D.$Qkc,0),(0,I.$os)(E.$Ulc,E.$Vlc,0),(0,I.$os)(d.$oCb,d.$pCb,0),(0,I.$os)(o.$9lc,o.$8lc,0),(0,I.$os)(R.$mkc,R.$lkc,0),(0,I.$os)(i.$Ukc,i.$Tkc,0),(0,I.$os)(a.$uP,a.$rP,0),(0,I.$os)(l.$Bkc,l.$Ckc,0),(0,I.$os)(c.$6kc,c.$7kc,0)}),define(Re[299],Ae([1,0,297,39,2,294,7,11,243]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class D extends F.$bmc{j(){}getModule(w,d){for(const s of this.b){const o=s(w);if(o){w=o;break}}if(this.a.has(w))return this.a.get(w).load(w,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends N.$2kc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(g.$hoc);const w=this.h.invokeFunction(I.$0lc);this.r=this.h.createInstance(D,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,d,s){d=d.with({path:k(d.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const n=R.URI.revive(await this.C.$asBrowserUri(d)),r=await fetch(n.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const i=await r.text(),a=`${d.toString(!0)}#vscode-extension`,l=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",l)}catch(v){throw console.error(o?`Loading code for extension ${o} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${d.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}w&&await this.w.initializeLocalizedMessages(w);const b={},c={exports:b},m=v=>{const $=this.r.getModule(v,d);if($===void 0)throw new Error(`Cannot load module '${v}'`);return $};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,b,m),c.exports!==b?c.exports:b}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+w;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,p.$rh)(10)}}e.$ioc=T;function k(u,w){return u.endsWith(w)?u:u+w}}),define(Re[300],Ae([1,0,70,55,13,39,207,85,299]),function(ge,e,I,N,R,F,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$os)(R.$Wj,new I.$ni(M.$amc,[!0],!0)),(0,N.$os)(F.$3kc,g.$ioc,0),(0,N.$os)(p.$skc,p.$tkc,0)}),define(Re[306],Ae([1,0,22,5,77,295,245,19,89,12,2,298,300]),function(ge,e,I,N,R,F,M,p,g,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=l;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const d=fetch.bind(self);function s(t){self.fetch=async function(b,c){return b instanceof Request||w(String(b))&&(b=(await t(T.URI.parse(String(b)))).toString(!0)),d(b,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,c,m,v,$){(async()=>(w(c.toString())&&(c=(await t(T.URI.parse(c.toString()))).toString(!0)),super.open(b,c,m??!0,v,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(b,c){if(/^file:/i.test(b.toString()))b=D.$Kg.uriToBrowserUri(T.URI.parse(b.toString())).toString(!0);else if(/^vscode-remote:/i.test(b.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(f){function S(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const y=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?y(P,V):y(S(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,A){return super.open(P,S(V),W??!0,q,A)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(S))},C(f)}.toString()}('${b}'))`;c=c||{},c.name=`${name} -> ${c.name||p.$oc(b.toString())}`;const $=new Blob([v],{type:"application/javascript"}),h=URL.createObjectURL($);return new t(h,c)}}else self.Worker=class extends M.$joc{constructor(t,b){super(u,t,{name:p.$oc(t.toString()),...b})}};const o=new class{constructor(){this.pid=void 0}exit(t){k()}};class n{constructor(){const b=new MessageChannel,c=new N.$be;let m=!1;u(b.port2,[b.port2]),b.port1.onmessage=v=>{const{data:$}=v;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const h=I.$Ce.wrap(new Uint8Array($,0,$.byteLength));if((0,R.$Um)(h,2)){m=!0,i("received terminate message from renderer");return}c.fire(h)},this.protocol={onMessage:c.event,send:v=>{if(!m){const $=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);b.port1.postMessage($,[$])}}}}}function r(t){return new Promise(b=>{const c=t.onMessage(m=>{c.dispose();const v=JSON.parse(m.toString());t.send((0,R.$Tm)(0)),b({protocol:t,initData:v})});t.send((0,R.$Tm)(1))})}let i=t=>k();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function l(){g.mark("code/extHost/willConnectToRenderer");const t=new n;return{onmessage(b){a(b)&&r(t.protocol).then(c=>{g.mark("code/extHost/didWaitForInitData");const m=new F.$dmc(c.protocol,c.initData,o,null,b.data);s(v=>m.asBrowserUri(v)),i=v=>m.terminate(v)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7eba2d200076e9ca04ef1d0874fb49aae426f895/core/vs/workbench/api/worker/extensionHostWorker.js.map
